within DCOL.Consumption.Psychrometrics.Functions.InProgress;
function Twb_3 "Return the wet-bulb temperature of moist air given the dry-bulb temperature and relative humidity
  from paper: Wet-Bulb Temperature from Relative Humidity and Air Temperature from Roland Stul"
  input Fluid.Types.Percentage RH "relative humidity";
  input Modelica.SIunits.Temp_C Tdb "dry-bulb temperature";
  output Modelica.SIunits.Temp_C Twb "wet-bulb temperature";

algorithm
  Twb := Tdb*atan(0.151977*sqrt(RH*100 + 8.313659)) + atan(Tdb + RH*100) - atan(
    RH*100 - 1.676331) + (0.00391838*(RH*100)^(3/2))*(atan(0.023101*RH*100)) -
    4.686035;

end Twb_3;
