within DCOL.Consumption.Psychrometrics.Functions;
function RHtoW
  "Return the humidity ratio of moist air given the relative humidity and the dry-bulb temperature"

  input Modelica.SIunits.Pressure p "total pressure";
  input Fluid.Types.Percentage RH "relative humidity";
  input Modelica.SIunits.Temp_C T "dry-bulb temperature";
  output Modelica.SIunits.MassFraction W "humidity ratio";

protected
  Modelica.SIunits.Pressure pws;
  //saturation pressure
  Modelica.SIunits.Pressure pw;
  //partial pressure

algorithm
  pws := p_ws(Tin=T);
  pw := pws*RH;
  W := W1(p=p, pw=pw);

end RHtoW;
