within DCOL.Consumption.Psychrometrics.Functions;
function Tdp
  "Return the dew point temperature of moist air given the partial pressure"
  input Modelica.SIunits.Pressure ps "partial pressure";
  output Modelica.SIunits.Temp_C T "dew point temperature";
algorithm
  T := (log(ps/610.78)*238.3)/(17.294 - log(ps/610.78));
end Tdp;
