within DCOL.Consumption.Psychrometrics.Functions;
function Twb
  "Return the wet-bulb temperature of moist air given the dry-bulb temperature, the humidity ratio and the humidity ratio at wet-bulb temperature "
  input Modelica.SIunits.Temp_C Tdb "dry-bulb temperature";
  input Modelica.SIunits.MassFraction WAs
    "humidity ratio at wet-bulb temperature";
  input Modelica.SIunits.MassFraction W "humidity ratio";
  output Modelica.SIunits.Temp_C Twb "wet-bulb temperature";

algorithm
  Twb := (2501*(WAs - W) - Tdb*(1.006 + 1.86*W))/(2.326*WAs - 4.186*W - 1.006);

end Twb;
