within DCOL.Consumption.Psychrometrics.Functions;
function W2
  "Return the humidity ratio of moist air given the dry-bulb temperature, the wet-bulb temperature and the humidity ratio at wet-bulb temperature"

  input Modelica.SIunits.Temp_C Tdb "dry-bulb temperature";
  input Modelica.SIunits.Temp_C Twb "wet-bulb temperature";
  input Modelica.SIunits.MassFraction WAs
    "humidity ratio at wet-bulb temperature";
  output Modelica.SIunits.MassFraction W "humidity ratio";

algorithm
  W := ((2501 - 2.326*Twb)*WAs - 1.006*(Tdb - Twb))/(2501 + 1.86*Tdb - 4.186*
    Twb);

end W2;
