within DCOL.Consumption.Psychrometrics.Functions;
function eff_CounterFlow
  "Return the effectiveness (eff-NTU method) given Z and NTU for a counter flow device"

  input Fluid.Types.CapacityRateRatio Z "Dimensionless capacity rate ratio";
  input Fluid.Types.NTU NTU "Number of exchanger heat transfer units";
  output Fluid.Types.Effectiveness eff "Effectiveness";

algorithm
  if (Z <> 1) then
    eff := (1 - exp(-NTU*(1 - Z)))/(1 - Z*exp(-NTU*(1 - Z)));
  else
    eff := NTU/(1 + NTU);
  end if;
end eff_CounterFlow;
