within DCOL.Consumption.Psychrometrics.Functions;
function eff_CrossFlow
  "Return the effectiveness (eff-NTU method) given Z and NTU for a cross-flow device"

  input Fluid.Types.CapacityRateRatio Z "Dimensionless capacity rate ratio";
  input Fluid.Types.NTU NTU "Number of exchanger heat transfer units";
  output Fluid.Types.Effectiveness eff "Effectiveness";

algorithm
  eff := 1 - exp((exp(-Z*(NTU^0.78)) - 1)*(NTU^(0.22))/Z);
end eff_CrossFlow;
