within DCOL.Consumption.Psychrometrics.Functions;
function eff_ParallelFlow
  "Return the effectiveness (eff-NTU method) given Z and NTU for a parallel flow device"

  input Fluid.Types.CapacityRateRatio Z "Dimensionless capacity rate ratio";
  input Fluid.Types.NTU NTU "Number of exchanger heat transfer units";
  output Fluid.Types.Effectiveness eff "Effectiveness";

algorithm
  eff := (1 - exp(-NTU*(1 + Z)))/(1 + Z);
end eff_ParallelFlow;
