within DCOL.Consumption.Psychrometrics.Functions;
function h
  "Return the enthalpy of moist air given the temperature and the humidity ratio"

  input Modelica.SIunits.Temp_C Tdb "dry-buld temperature";
  input Modelica.SIunits.MassFraction W "humidity ratio";
  output Modelica.SIunits.SpecificEnthalpy h "saturation pressure";

algorithm
  h := 1006*Tdb + W*(2501e3 + 1860*Tdb);

end h;
