within DCOL.Consumption.Psychrometrics.Functions;
function p_ws
  "Return the saturation pressure of moist air given the temperature"

  input Modelica.SIunits.Temp_C Tin "dry-buld temperature";
  output Modelica.SIunits.Pressure pws "saturation pressure";

protected
  Modelica.SIunits.Temp_K T;

algorithm
  T := Tin + 273.15;
  pws := exp((-5.8002206e+3)*T^(-1) + (1.3914993e+0)*T^(0) + (-4.8640239e-2)*T^
    (1) + (4.1764768e-5)*T^(2) + (-1.4452093e-8)*T^(3) + (6.5459673)*log(T));

end p_ws;
