within DCOL.Distribution.HeatExchanger.Testing;
model PlatesHeatTransfer_Both

  inner Modelica.Fluid.System system annotation (Placement(transformation(extent={{-126,
            -30},{-106,-10}})));

  Modelica.Fluid.Sources.FixedBoundary outlet_hot(
    redeclare package Medium =
        Modelica.Media.Water.ConstantPropertyLiquidWater,
      nPorts=1)
              annotation (Placement(transformation(extent={{-100,20},{-80,40}})));

  Modelica.Fluid.Sources.MassFlowSource_T inlet_hot(
    redeclare package Medium =
        Modelica.Media.Water.ConstantPropertyLiquidWater,
    use_m_flow_in=true,
    use_T_in=true,
    m_flow=50,
    T=323.15,
    nPorts=1) annotation (Placement(transformation(extent={{90,140},{70,160}})));

  Modelica.Fluid.Sources.FixedBoundary outlet_cold(
    redeclare package Medium =
        Modelica.Media.Water.ConstantPropertyLiquidWater,
      nPorts=1)
              annotation (Placement(transformation(extent={{120,44},{100,64}})));

  Modelica.Fluid.Sources.MassFlowSource_T inlet_cold(
    redeclare package Medium =
        Modelica.Media.Water.ConstantPropertyLiquidWater,
    use_m_flow_in=true,
    use_T_in=true,
    m_flow=100,
    T=283.15,
    nPorts=1) annotation (Placement(transformation(extent={{-72,120},{-52,140}})));

  Modelica.Blocks.Sources.Constant m_flowHot(k=50) annotation (Placement(transformation(extent={{130,170},
            {110,190}})));

  Modelica.Blocks.Sources.Constant THot(k=50 + 273.15) annotation (Placement(transformation(extent={{130,134},
            {110,154}})));

  Modelica.Blocks.Sources.Constant m_flowCold(k=60) annotation (Placement(transformation(extent={{-112,
            150},{-92,170}})));

  Modelica.Blocks.Sources.Constant TCold(k=10 + 273.15) annotation (Placement(transformation(extent={{-112,
            110},{-92,130}})));

  Modelica.Blocks.Sources.TimeTable timeTable(
    offset=273.15,
    table=[ 0,10; 20,10;
           20,30; 40,30]) annotation (Placement(transformation(extent={{-80,80},
            {-60,100}})));

  Modelica.Blocks.Sources.TimeTable timeTable1(
    offset=273.15,
    table=[ 0,50; 20,50;
           20,30; 40,30]) annotation (Placement(transformation(extent={{100,100},
            {80,120}})));

  Modelica.Fluid.Sensors.Temperature outletCold_T(
    redeclare package Medium =
        Modelica.Media.Water.ConstantPropertyLiquidWater)                        annotation (Placement(transformation(extent={{70,54},
            {90,74}})));

  Modelica.Fluid.Sensors.Temperature outletHot_T(
    redeclare package Medium =
        Modelica.Media.Water.ConstantPropertyLiquidWater)                        annotation (Placement(transformation(extent={{-82,46},
            {-62,66}})));

  Modelica.Fluid.Sensors.Temperature inletHot_T(
    redeclare package Medium =
        Modelica.Media.Water.ConstantPropertyLiquidWater)                        annotation (Placement(transformation(extent={{30,150},
            {50,170}})));

  Modelica.Fluid.Sensors.Temperature inletCold_T(
    redeclare package Medium =
        Modelica.Media.Water.ConstantPropertyLiquidWater)                        annotation (Placement(transformation(extent={{-30,140},
            {-10,160}})));

  PlatesHeatExchanger_parallel platesHeatExchanger1(
    redeclare package Medium =
        Modelica.Media.Water.ConstantPropertyLiquidWater,
    redeclare package Medium1 =
        Modelica.Media.Water.ConstantPropertyLiquidWater,
    length_hot=1.5,
    length_cold=1.5,
    redeclare package Material =
        Modelica_IK4_TEKNIKER.Thermal.Materials.Copper,
    diameter_hot=sqrt(0.01*4/Modelica.Constants.pi),
    diameter_cold=sqrt(0.01*4/Modelica.Constants.pi),
    nPlates=51,
    T_start_hot=313.15,
    T_start_cold=293.15,
    T_start=303.15)
    annotation (Placement(transformation(extent={{-28,-136},{52,-56}})));

  Modelica.Fluid.Sources.FixedBoundary outlet_hot1(
    redeclare package Medium =
        Modelica.Media.Water.ConstantPropertyLiquidWater,
    nPorts=1) annotation (Placement(transformation(extent={{94,-164},{74,-144}})));
  Modelica.Fluid.Sources.MassFlowSource_T inlet_hot1(
    redeclare package Medium =
        Modelica.Media.Water.ConstantPropertyLiquidWater,
    use_m_flow_in=true,
    use_T_in=true,
    nPorts=1,
    m_flow=50,
    T=323.15) annotation (Placement(transformation(extent={{92,-44},{72,-24}})));
  Modelica.Fluid.Sources.FixedBoundary outlet_cold1(
    redeclare package Medium =
        Modelica.Media.Water.ConstantPropertyLiquidWater,
    nPorts=1) annotation (Placement(transformation(extent={{-68,-44},{-48,-24}})));
  Modelica.Fluid.Sources.MassFlowSource_T inlet_cold1(
    redeclare package Medium =
        Modelica.Media.Water.ConstantPropertyLiquidWater,
    use_m_flow_in=true,
    use_T_in=true,
    nPorts=1,
    m_flow=100,
    T=283.15) annotation (Placement(transformation(extent={{-68,-164},{-48,-144}})));
  Modelica.Blocks.Sources.Constant m_flowHot1(
                                             k=50) annotation (Placement(transformation(extent={{132,-14},
            {112,6}})));
  Modelica.Blocks.Sources.Constant THot1(
                                        k=50 + 273.15) annotation (Placement(transformation(extent={{132,-50},
            {112,-30}})));
  Modelica.Blocks.Sources.Constant m_flowCold1(
                                              k=60) annotation (Placement(transformation(extent={{-120,
            -134},{-100,-114}})));
  Modelica.Blocks.Sources.Constant TCold1(
                                         k=10 + 273.15) annotation (Placement(transformation(extent={{-120,
            -174},{-100,-154}})));
  Modelica.Blocks.Sources.TimeTable timeTable2(
    offset=273.15,
    table=[ 0,10; 20,10;
           20,30; 40,30]) annotation (Placement(transformation(extent={{-78,
            -104},{-58,-84}})));
  Modelica.Blocks.Sources.TimeTable timeTable3(
    offset=273.15,
    table=[ 0,50; 20,50;
           20,30; 40,30]) annotation (Placement(transformation(extent={{82,-84},
            {102,-64}})));
  Modelica.Fluid.Sensors.Temperature outletCold_T1(
    redeclare package Medium =
        Modelica.Media.Water.ConstantPropertyLiquidWater)                        annotation (Placement(transformation(extent={{-28,-34},
            {-8,-14}})));
  Modelica.Fluid.Sensors.Temperature outletHot_T1(
    redeclare package Medium =
        Modelica.Media.Water.ConstantPropertyLiquidWater)                        annotation (Placement(transformation(extent={{32,-174},
            {52,-154}})));
  Modelica.Fluid.Sensors.Temperature inletHot_T1(
    redeclare package Medium =
        Modelica.Media.Water.ConstantPropertyLiquidWater)                        annotation (Placement(transformation(extent={{32,-34},
            {52,-14}})));
  Modelica.Fluid.Sensors.Temperature inletCold_T1(
    redeclare package Medium =
        Modelica.Media.Water.ConstantPropertyLiquidWater)                        annotation (Placement(transformation(extent={{-28,
            -174},{-8,-154}})));
  PlatesHeatExchanger_serie platesHeatExchanger_counterflow_pruebas_serie2_1
    annotation (Placement(transformation(extent={{-28,46},{52,128}})));
equation
  connect(m_flowHot.y,inlet_hot. m_flow_in) annotation (Line(points={{109,180},
          {100,180},{100,158},{90,158}},
                                   color={0,0,127}));
  connect(m_flowCold.y, inlet_cold.m_flow_in) annotation (Line(points={{-91,160},
          {-80,160},{-80,138},{-72,138}}, color={0,0,127}));
  connect(TCold.y, inlet_cold.T_in) annotation (Line(points={{-91,120},{-80,120},
          {-80,134},{-74,134}}, color={0,0,127}));
  connect(inlet_hot.T_in, THot.y) annotation (Line(points={{92,154},{100,154},{
          100,144},{109,144}},                           color={0,0,127}));
  connect(inlet_hot1.ports[1], platesHeatExchanger1.port_a_Hot)
    annotation (Line(points={{72,-34},{56,-34},{56,-64}}, color={0,127,255}));
  connect(platesHeatExchanger1.port_b_Hot, outlet_hot1.ports[1]) annotation (
      Line(points={{56,-124},{56,-124},{56,-154},{74,-154}}, color={0,127,255}));
  connect(inlet_cold1.ports[1], platesHeatExchanger1.port_a_Cold) annotation (
      Line(points={{-48,-154},{-32,-154},{-32,-128}}, color={0,127,255}));
  connect(outlet_cold1.ports[1], platesHeatExchanger1.port_b_Cold) annotation (
      Line(points={{-48,-34},{-32,-34},{-32,-68},{-32,-68}}, color={0,127,255}));
  connect(m_flowHot1.y, inlet_hot1.m_flow_in) annotation (Line(points={{111,-4},
          {100,-4},{100,-26},{92,-26}},
                                      color={0,0,127}));
  connect(m_flowCold1.y, inlet_cold1.m_flow_in) annotation (Line(points={{-99,
          -124},{-92,-124},{-92,-146},{-68,-146}}, color={0,0,127}));
  connect(TCold1.y, inlet_cold1.T_in) annotation (Line(points={{-99,-164},{-92,
          -164},{-92,-150},{-70,-150}}, color={0,0,127}));
  connect(inlet_hot1.T_in, THot1.y) annotation (Line(points={{94,-30},{100,-30},
          {100,-40},{111,-40}},color={0,0,127}));
  connect(platesHeatExchanger1.port_a_Cold, inletCold_T1.port) annotation (Line(
        points={{-32,-128},{-32,-128},{-32,-142},{-32,-174},{-18,-174}}, color=
          {0,127,255}));
  connect(platesHeatExchanger1.port_b_Hot, outletHot_T1.port) annotation (Line(
        points={{56,-124},{56,-124},{56,-174},{42,-174}}, color={0,127,255}));
  connect(inletHot_T1.port, platesHeatExchanger1.port_a_Hot)
    annotation (Line(points={{42,-34},{56,-34},{56,-64}}, color={0,127,255}));
  connect(outletCold_T1.port, platesHeatExchanger1.port_b_Cold) annotation (
      Line(points={{-18,-34},{-32,-34},{-32,-68},{-32,-68}}, color={0,127,255}));
  connect(inlet_hot.ports[1], platesHeatExchanger_counterflow_pruebas_serie2_1.port_a_Hot)
    annotation (Line(points={{70,150},{56,150},{56,119.8}}, color={0,127,255}));
  connect(inletHot_T.port, platesHeatExchanger_counterflow_pruebas_serie2_1.port_a_Hot)
    annotation (Line(points={{40,150},{56,150},{56,119.8},{56,119.8}}, color={0,
          127,255}));
  connect(platesHeatExchanger_counterflow_pruebas_serie2_1.port_b_Cold,
    outletCold_T.port) annotation (Line(points={{56,54.2},{56,54},{80,54}},
                           color={0,127,255}));
  connect(platesHeatExchanger_counterflow_pruebas_serie2_1.port_b_Cold,
    outlet_cold.ports[1]) annotation (Line(points={{56,54.2},{56,54},{100,54}},
                           color={0,127,255}));
  connect(inlet_cold.ports[1], platesHeatExchanger_counterflow_pruebas_serie2_1.port_a_Cold)
    annotation (Line(points={{-52,130},{-32,130},{-32,111.6}},       color={0,
          127,255}));
  connect(inletCold_T.port, platesHeatExchanger_counterflow_pruebas_serie2_1.port_a_Cold)
    annotation (Line(points={{-20,140},{-32,140},{-32,111.6}},
                                                            color={0,127,255}));
  connect(platesHeatExchanger_counterflow_pruebas_serie2_1.port_b_Hot,
    outlet_hot.ports[1]) annotation (Line(points={{-32,62.4},{-60,62.4},{-60,30},
          {-80,30}},       color={0,127,255}));
  connect(platesHeatExchanger_counterflow_pruebas_serie2_1.port_b_Hot,
    outletHot_T.port)
    annotation (Line(points={{-32,62.4},{-32,62},{-60,62},{-60,46},{-72,46}},
                                                         color={0,127,255}));
  annotation (Documentation(revisions="<html>
<p>2016-05-16 Eduardo Ubieta (IK4-TEKNIKER): First implementation</p>
<h4>Copyright &copy; IK4-TEKNIKER</h4>
</html>"),
    Diagram(coordinateSystem(extent={{-140,-180},{140,200}})),
    Icon(coordinateSystem(extent={{-140,-180},{140,200}})));
end PlatesHeatTransfer_Both;
