within DCOL.Distribution.HeatExchanger.Utilities.Functions.SweepParameters;
function SweepParameterColdMassflowShell_TubesHTX
  input String pathToModel="Modelica_IK4_TEKNIKER.DCOL.Generation.HeatExchanger.Testing.ShellAndTubesHeatTransfer";
  input String[:] parameterToSweep={"m_flowCold.k"};
  input Integer nbrSimulations=10;
  input Real[size(parameterToSweep,1)] startValue={10};
  input Real[size(parameterToSweep,1)] endValue={100};

protected
  Real[size(parameterToSweep,1)] parameterValues;
  Real step_m_flow;

algorithm
  translateModel(pathToModel);
  step_m_flow:=(endValue[1]-startValue[1])/(nbrSimulations-1);

  for j in 1:nbrSimulations loop
      parameterValues[1]:=startValue[1]+(j-1)*step_m_flow;

          simulateExtendedModel(pathToModel,
                                stopTime=10000,
                                method="dassl",
                                resultFile="ColdMassFlowVariation",
                                initialNames={parameterToSweep[1]},
                                initialValues={parameterValues[1]},
                                finalNames={parameterToSweep[1]});

  end for;

  annotation (Documentation(info="<html>
<p>This function simulates (nbrSimulations^nbrSimulation) times the AccelerationTest experiment made in Workshop10. During each simulationa diferent combination of the v_start, J_wheel and m_chassis parameters will be used, so that how each parameter affect to the cars behaviour is appreciated.</p>
</html>"));
end SweepParameterColdMassflowShell_TubesHTX;
