within DCOL.Distribution.Pipes.Testing.Distribution;
model Annex60_vs_MSL
  parameter Modelica.SIunits.Temperature T_amb=25 +273.15;
  parameter Modelica.SIunits.Temperature T_in=70 + 273.15;

  // parameter Modelica.SIunits.Temperature T_amb=40 +273.15;
  // parameter Modelica.SIunits.Temperature T_in=7 + 273.15;

  parameter Modelica.SIunits.MassFlowRate m_flow=5;

  MSL_pipe mSL_pipe(
    T_in=T_in,
    T_amb=T_amb,
    m_flow=m_flow)  annotation (Placement(transformation(extent={{-12,20},{8,40}})));
  Annex60_pipe annex60_pipe(
    T_amb=T_amb,
    T_in=T_in,
    m_flow=m_flow)          annotation (Placement(transformation(extent={{-12,-20},{8,0}})));
  inner Modelica.Fluid.System system(
    m_flow_start=m_flow,
    T_ambient=T_amb,
    allowFlowReversal=false)         annotation (Placement(transformation(extent={{-100,-100},{-80,-80}})));
  annotation (Icon(coordinateSystem(preserveAspectRatio=false)), Diagram(coordinateSystem(preserveAspectRatio=false)),
    experiment(StopTime=36000));
end Annex60_vs_MSL;
