within DCOL.Distribution.Pipes.Testing.Distribution;
model Annex60pipe

  Annex60.Experimental.Pipe.PipeHeatLoss pipeHeatLoss(
    m_flow_nominal=2,
    diameter=diameter,
    length=length,
    thicknessIns=thicknessIns,
    lambdaI=lambdaI,
    redeclare package Medium = Modelica.Media.Water.StandardWater)
    annotation (Placement(transformation(extent={{-24,22},{28,72}})));

  parameter Modelica.SIunits.Diameter diameter=0.2540 "Pipe diameter";
  parameter Modelica.SIunits.Length length=1000 "Pipe length";
  parameter Modelica.SIunits.Length thicknessIns=0.04
    "Thickness of pipe insulation";
  parameter Modelica.SIunits.ThermalConductivity lambdaI=0.026
    "Heat conductivity";
  Modelica.Fluid.Sources.FixedBoundary boundary(nPorts=1, redeclare package Medium =
               Modelica.Media.Water.StandardWater) annotation (Placement(
        transformation(
        extent={{-10,-10},{10,10}},
        rotation=180,
        origin={82,46})));
  Modelica.Fluid.Sources.MassFlowSource_T boundary1(
    nPorts=1,
    m_flow=2,
    T=280.15,
    redeclare package Medium = Modelica.Media.Water.StandardWater)
    annotation (Placement(transformation(extent={{-92,36},{-72,56}})));
  Modelica.Thermal.HeatTransfer.Sources.FixedTemperature fixedTemperature(T=313.15)
    annotation (Placement(transformation(extent={{-118,70},{-98,90}})));
equation
  connect(pipeHeatLoss.port_b, boundary.ports[1]) annotation (Line(points={{28,47},
          {49,47},{49,46},{72,46}}, color={0,127,255}));
  connect(boundary1.ports[1], pipeHeatLoss.port_a)
    annotation (Line(points={{-72,46},{-24,46},{-24,47}}, color={0,127,255}));
  connect(fixedTemperature.port, pipeHeatLoss.heatPort) annotation (Line(points=
         {{-98,80},{-60,80},{-60,84},{2,84},{2,72}}, color={191,0,0}));

  annotation (Icon(coordinateSystem(preserveAspectRatio=false)), Diagram(
        coordinateSystem(preserveAspectRatio=false)));
end Annex60pipe;
