within DCOL.Distribution.Pipes.Testing;
model Type31_test
  parameter Integer n = 500;
  parameter Real l = 100/Modelica.Constants.pi;
  parameter Real d = 1.0;
  parameter Real rho= 1.0;
  parameter Real initialPoints[n]=linspace(0,1,n);
  parameter Real initialValues[n]=fill(-1, n);
  Modelica.SIunits.MassFlowRate mflow;
  Real Tin_a;
  Real Tin_b;
  Real Tout_a;
  Real Tout_aa=sD_b.Tout_a;
  Real Tout_b;
  Real Tout_bb=sD_b.Tout_b;
  DCOL.Distribution.Pipes.BaseClasses.Type31 sD_b(
    length=l,
    diameter=d,
    rho=rho,
    cp=1,
    U=0,
    n=n,
    initialTs=initialValues,
    mflow=mflow,
    Tin_a=Tin_a,
    Tin_b=Tin_b,
    Text=fill(0, n));
  Real v;
  Real x;

// initial algorithm
//   mflow :=10;
// algorithm
//   when time>=5.0 then
//     mflow :=-10;
//   end when;

equation
  mflow = if time<5.0 then 10 else -10;
  Tin_a = if time<0.5 then 1 else 2;
  Tin_b = 1;
  v = sD_b.v;
  der(x) = v;
  (Tout_a, Tout_b) = spatialDistribution(Tin_a, Tin_b, x/l, v>0,  initialPoints, initialValues);

  annotation (Icon(coordinateSystem(preserveAspectRatio=false)), Diagram(coordinateSystem(preserveAspectRatio=false)),
    experiment(StopTime=10));
end Type31_test;
