within DCOL.Distribution.Thermal_temp.BaseClasses;
partial model DistributedThermalMaterial
  import SI = Modelica.SIunits;
  import Modelica.Fluid.Types.ModelStructure;
  extends BaseClasses.DistributedThermalVolume(
    dim_1=true,
    dim_2=true,
    dim_3=true,
    n_1=2,
    n_2=2,
    n_3=2);

  replaceable package Material =
    Modelica_IK4_TEKNIKER.Thermal.Materials.AISI321
    constrainedby Modelica_IK4_TEKNIKER.Thermal.Materials.BaseClases.PartialMaterial
    "Material of the component"
    annotation (choicesAllMatching = true,
                Dialog(tab="General", group="Material"));

  SI.SpecificHeatCapacity[n_3, n_2, n_1] cps
    "Specific heat capacity of material";

  SI.ThermalConductivity[n_3, n_2, nG_1] ks_1
    "Thermal conductance of element";
  SI.ThermalConductivity[n_3, nG_2, n_1] ks_2
    "Thermal conductance of element";
  SI.ThermalConductivity[nG_3, n_2, n_1] ks_3
    "Thermal conductance of element";

equation
  cps = Material.specificHeatCapacity_T(Ts);

  ks_1 = Material.thermalConductivity_T(Ts_1);
  ks_2 = Material.thermalConductivity_T(Ts_2);
  ks_3 = Material.thermalConductivity_T(Ts_3);

end DistributedThermalMaterial;
