within DCOL.Distribution.Thermal_temp.Testing;
model Test_HollowCylinder_vs_OLD
  parameter Integer n1 = 1;
  parameter Integer n2 = 1;
  parameter Integer n3 = 1;
  parameter Integer n11 = n1*2 - 1;
  parameter Integer n22 = n2*2 - 1;
  parameter Integer n33 = n3*2 - 1;

  Modelica.Thermal.HeatTransfer.Sources.FixedTemperature fixedTemperature[n33,n22](each T=308.15) annotation (Placement(transformation(extent={{100,-40},{80,-20}})));
  Modelica.Thermal.HeatTransfer.Sources.FixedTemperature fixedTemperature1[n33,n11](each T=308.15) annotation (Placement(transformation(extent={{100,20},{80,40}})));
  Modelica.Thermal.HeatTransfer.Sources.FixedTemperature fixedTemperature3[n33,n22](each T=303.15) annotation (Placement(transformation(extent={{-20,-40},{0,-20}})));
  Modelica.Thermal.HeatTransfer.Sources.FixedTemperature fixedTemperature4[n33,n11](each T=303.15) annotation (Placement(transformation(extent={{-20,-100},{0,-80}})));
  DCOL.Distribution.Thermal_temp.HollowCylinder hollowCylinder(
    use_longitudinalDim=true,
    alpha=2*Modelica.Constants.pi,
    modelStructure_radial=Modelica.Fluid.Types.ModelStructure.a_v_b,
    modelStructure_longitudinal=Modelica.Fluid.Types.ModelStructure.a_v_b,
    modelStructure_angular=Modelica.Fluid.Types.ModelStructure.a_v_b,
    nRadial=n11,
    nLongitudinal=n22,
    nAngular=n33,
    r_int=0.5,
    r_ext=1,
    length=10,
    nParallel=1,
    redeclare package Material = Modelica_IK4_TEKNIKER.Thermal.Materials.AISI316) annotation (Placement(transformation(extent={{30,-40},{50,-20}})));

  Modelica.Thermal.HeatTransfer.Sources.FixedTemperature fixedTemperature6[n2,n3](each T=308.15)
    annotation (Placement(transformation(extent={{20,20},{0,40}})));
  Modelica.Thermal.HeatTransfer.Sources.FixedTemperature fixedTemperature7[n3,n1](each T=308.15)
    annotation (Placement(transformation(extent={{20,80},{0,100}})));
  Modelica.Thermal.HeatTransfer.Sources.FixedTemperature fixedTemperature9[n2,n3](each T=303.15)
    annotation (Placement(transformation(extent={{-100,20},{-80,40}})));
  Modelica.Thermal.HeatTransfer.Sources.FixedTemperature fixedTemperature10[
                                                                           n3,n1](each T=303.15)
    annotation (Placement(transformation(extent={{-100,-40},{-80,-20}})));
  Modelica_IK4_TEKNIKER.Obsolete.Thermal.NewHeatTransfer.Components.Conduction.BaseGenericGeometries.Tubes3D.TubeMultilayerDiscretized hollowCylinder_OLD(
    n_layer=n1,
    n_sector=n3,
    n_section=n2,
    r_int=0.5,
    r_ext=1,
    length=10,
    redeclare model material = Modelica_IK4_TEKNIKER.Obsolete.Thermal.Materials.AISI316) annotation (Placement(transformation(extent={{-50,16},{-30,36}})));
  Modelica.Blocks.Sources.RealExpression hollowCylinder_middle(y=hollowCylinder.Ts[integer((n33 + 1)/2), integer((n22 + 1)/2), integer((n11 + 1)/2)])
                                                                                                                           annotation (Placement(transformation(extent={{80,-106},{100,-86}})));
  Modelica.Blocks.Sources.RealExpression hollowCylinderOLD_middle(y=hollowCylinder_OLD.ring_multilayer_disc[integer((n1 + 1)/2)].ring_disc[integer((n1 + 1)/2)].anular_nodes[integer((n1 + 1)/2)].inertiaNode.T)
                                                                                                                                                           annotation (Placement(transformation(extent={{-100,74},{-80,94}})));
equation
  connect(hollowCylinder.port_a_angular, hollowCylinder.port_b_angular) annotation (Line(points={{32,-38},{40,-38},{40,-22},{48,-22}}, color={191,0,0}));
  connect(fixedTemperature7.port, hollowCylinder_OLD.port_up) annotation (Line(points={{0,90},{-20,90},{-40.2,90},{-40.2,35.8}}, color={191,0,0}));
  connect(fixedTemperature10.port, hollowCylinder_OLD.port_down) annotation (Line(points={{-80,-30},{-60,-30},{-40,-30},{-40,16}}, color={191,0,0}));
  connect(fixedTemperature6.port, hollowCylinder_OLD.port_int) annotation (Line(points={{0,30},{-41,30},{-41,30.2}}, color={191,0,0}));
  connect(fixedTemperature9.port, hollowCylinder_OLD.port_ext) annotation (Line(points={{-80,30},{-48,30},{-48,30.2}}, color={191,0,0}));
  connect(fixedTemperature1.port, hollowCylinder.port_b_longitudinal) annotation (Line(points={{80,30},{60,30},{40,30},{40,-20}}, color={191,0,0}));
  connect(fixedTemperature.port, hollowCylinder.port_b_radial) annotation (Line(points={{80,-30},{65,-30},{50,-30}}, color={191,0,0}));
  connect(fixedTemperature4.port, hollowCylinder.port_a_longitudinal) annotation (Line(points={{0,-90},{20,-90},{40,-90},{40,-39.8}}, color={191,0,0}));
  connect(fixedTemperature3.port, hollowCylinder.port_a_radial) annotation (Line(points={{0,-30},{30,-30}}, color={191,0,0}));
  annotation (Icon(coordinateSystem(preserveAspectRatio=false)), Diagram(coordinateSystem(preserveAspectRatio=false)),
    experiment(StopTime=86400));
end Test_HollowCylinder_vs_OLD;
