within DCOL.Distribution.Thermal_temp.Testing;
model Test_Pipe_vs_OLD_nParallel

  Modelica.Fluid.Pipes.DynamicPipe pipe(
    redeclare package Medium = Modelica.Media.Water.ConstantPropertyLiquidWater,
    length=1,
    diameter=0.1,
    nNodes=10,
    modelStructure=Modelica.Fluid.Types.ModelStructure.a_v_b,
    use_HeatTransfer=true,
    redeclare model HeatTransfer =
        Modelica.Fluid.Pipes.BaseClasses.HeatTransfer.LocalPipeFlowHeatTransfer)                            annotation (Placement(transformation(extent={{-10,30},{10,50}})));
  Modelica.Fluid.Sources.MassFlowSource_T boundary(          redeclare package Medium =
        Modelica.Media.Water.ConstantPropertyLiquidWater,
    nPorts=1,
    m_flow=2)                                                                                                                             annotation (Placement(transformation(extent={{-40,30},{-20,50}})));
  Modelica.Fluid.Sources.FixedBoundary boundary1(          redeclare package Medium =
        Modelica.Media.Water.ConstantPropertyLiquidWater,                                                                               nPorts=1)
                                                                                                                                        annotation (Placement(transformation(extent={{40,30},{20,50}})));
  Modelica.Fluid.Pipes.DynamicPipe pipe1(
    redeclare package Medium = Modelica.Media.Water.ConstantPropertyLiquidWater,
    length=1,
    diameter=0.1,
    modelStructure=Modelica.Fluid.Types.ModelStructure.a_v_b,
    use_HeatTransfer=true,
    redeclare model HeatTransfer =
        Modelica.Fluid.Pipes.BaseClasses.HeatTransfer.LocalPipeFlowHeatTransfer,
    nParallel=5,
    nNodes=10) annotation (Placement(transformation(extent={{-10,-50},{10,-30}})));
  Modelica.Fluid.Sources.MassFlowSource_T boundary2(nPorts=1, redeclare package Medium =
        Modelica.Media.Water.ConstantPropertyLiquidWater,
    m_flow=10)                                                                                                                             annotation (Placement(transformation(extent={{-40,-50},{-20,-30}})));
  Modelica.Fluid.Sources.FixedBoundary boundary3(nPorts=1, redeclare package Medium =
        Modelica.Media.Water.ConstantPropertyLiquidWater)                                                                               annotation (Placement(transformation(extent={{40,-50},{20,-30}})));
  Modelica.Thermal.HeatTransfer.Sources.FixedTemperature fixedTemperature[10](T=303.15) annotation (Placement(transformation(extent={{-30,70},{-10,90}})));
  Modelica.Thermal.HeatTransfer.Sources.FixedTemperature fixedTemperature1[10](T=303.15) annotation (Placement(transformation(extent={{-30,-10},{-10,10}})));
  DCOL.Distribution.Thermal_temp.HollowCylinder hollowCylinder(
    alpha=2*Modelica.Constants.pi,
    redeclare package Material = Modelica_IK4_TEKNIKER.Thermal.Materials.AISI321,
    modelStructure_radial=Modelica.Fluid.Types.ModelStructure.a_v_b,
    modelStructure_longitudinal=Modelica.Fluid.Types.ModelStructure.a_v_b,
    modelStructure_angular=Modelica.Fluid.Types.ModelStructure.a_v_b,
    use_longitudinalDim=true,
    use_angularDim=true,
    nParallel=1,
    nRadial=1,
    nLongitudinal=10,
    nAngular=1,
    r_int=0.1,
    r_ext=0.5,
    length=1) annotation (Placement(transformation(
        extent={{-10,-10},{10,10}},
        rotation=-90,
        origin={0,60})));
  DCOL.Distribution.Thermal_temp.HollowCylinder hollowCylinder1(
    alpha=2*Modelica.Constants.pi,
    redeclare package Material = Modelica_IK4_TEKNIKER.Thermal.Materials.AISI321,
    modelStructure_radial=Modelica.Fluid.Types.ModelStructure.a_v_b,
    modelStructure_longitudinal=Modelica.Fluid.Types.ModelStructure.a_v_b,
    modelStructure_angular=Modelica.Fluid.Types.ModelStructure.a_v_b,
    use_longitudinalDim=true,
    use_angularDim=true,
    nRadial=1,
    nLongitudinal=10,
    nAngular=1,
    r_int=0.1,
    r_ext=0.5,
    length=1,
    nParallel=5) annotation (Placement(transformation(
        extent={{-10,-10},{10,10}},
        rotation=-90,
        origin={0,-20})));
equation

  connect(boundary2.ports[1], pipe1.port_a) annotation (Line(points={{-20,-40},{-20,-40},{-10,-40}}, color={0,127,255}));
  connect(pipe1.port_b, boundary3.ports[1]) annotation (Line(points={{10,-40},{16,-40},{20,-40}}, color={0,127,255}));

  connect(boundary.ports[1], pipe.port_a) annotation (Line(points={{-20,40},{-16,40},{-10,40}}, color={0,127,255}));
  connect(pipe.port_b, boundary1.ports[1]) annotation (Line(points={{10,40},{20,40}},         color={0,127,255}));
  connect(fixedTemperature.port, hollowCylinder.port_a_radial[1, :]) annotation (Line(points={{-10,80},{-6,80},{0,80},{0,70}}, color={191,0,0}));
  connect(hollowCylinder.port_b_radial[1, :], pipe.heatPorts) annotation (Line(points={{0,50},{0,44.4},{0.1,44.4}}, color={191,0,0}));
  connect(fixedTemperature1.port, hollowCylinder1.port_a_radial[1, :]) annotation (Line(points={{-10,0},{0,0},{0,-10}}, color={191,0,0}));
  connect(hollowCylinder1.port_b_radial[1, :], pipe1.heatPorts) annotation (Line(points={{0,-30},{0,-35.6},{0.1,-35.6}}, color={191,0,0}));
  annotation (experiment(StopTime=100000));
end Test_Pipe_vs_OLD_nParallel;
