within DCOL.Generation.AbsorptionChillers;
model AbsorptionChiller
  import SI = Modelica.SIunits;
  import Modelica.Fluid.Types.ModelStructure;
  extends Icons.AbsorptionCycle;

//Generator
  replaceable package Medium_gen = Modelica.Media.Water.WaterIF97_R1ph
    constrainedby Modelica.Media.Interfaces.PartialMedium
    "Generator medium" annotation (choicesAllMatching=true, Dialog(tab="Generator"));
  parameter SI.Height height_gen
    "Height of vessel" annotation (Dialog(tab="Generator"));
  parameter SI.Area crossArea_gen
    "Area of vessel" annotation (Dialog(tab="Generator"));
  parameter SI.ThermalConductance G_gen
    "Thermal conductance" annotation (Dialog(tab="Generator"));
  parameter SI.HeatCapacity C_gen
    "Heat capacity" annotation (Dialog(tab="Generator"));
  parameter ModelStructure modelStructure_gen=ModelStructure.av_vb
    "Determines whether flow or volume models are present at the ports" annotation (Dialog(tab="Generator"));
//Generator::Nominal
  parameter SI.AbsolutePressure p_gen_nominal
    "Pressure" annotation (Dialog(tab="Generator", group="Nominal"));
//Generator::Initialization
  parameter SI.Height level_gen_start
    "Liquid level" annotation (Dialog(tab="Generator", group="Initialization"));
  parameter SI.AbsolutePressure p_gen_start
    "Vessel pressure" annotation (Dialog(tab="Generator", group="Initialization"));
  parameter SI.Temperature T_genPipe_start
    "Pipe temperature" annotation (Dialog(tab="Generator", group="Initialization"));
  parameter SI.MassFlowRate m_flow_gen_start
    "Mass flow rate" annotation (Dialog(tab="Generator", group="Initialization"));
  parameter SI.AbsolutePressure p_genPipe_start
    "Pipe pressure" annotation (Dialog(tab="Generator", group="Initialization"));

//Absorber
  replaceable package Medium_abs = Modelica.Media.Water.WaterIF97_R1ph
    constrainedby Modelica.Media.Interfaces.PartialMedium
    "Absorber medium" annotation (choicesAllMatching=true, Dialog(tab="Absorber"));
  parameter SI.Height height_abs
    "Height of vessel" annotation (Dialog(tab="Absorber"));
  parameter SI.Area crossArea_abs
    "Area of vessel" annotation (Dialog(tab="Absorber"));
  parameter SI.ThermalConductance G_abs
    "Thermal conductance" annotation (Dialog(tab="Absorber"));
  parameter SI.HeatCapacity C_abs
    "Heat capacity" annotation (Dialog(tab="Absorber"));
  parameter ModelStructure modelStructure_abs=ModelStructure.av_vb
    "Determines whether flow or volume models are present at the ports" annotation (Dialog(tab="Absorber"));
//Absorber::Nominal
  parameter SI.AbsolutePressure p_abs_nominal
    "Pressure" annotation (Dialog(tab="Absorber", group="Nominal"));
//Absorber::Initialization
  parameter SI.Height level_abs_start
  "Liquid level" annotation (Dialog(tab="Absorber", group="Initialization"));
  parameter SI.AbsolutePressure p_abs_start
    "Vessel pressure" annotation (Dialog(tab="Absorber", group="Initialization"));
  parameter SI.Temperature T_absPipe_start
    "Pipe temperature" annotation (Dialog(tab="Absorber", group="Initialization"));
  parameter SI.MassFlowRate m_flow_abs_start
    "Mass flow rate" annotation (Dialog(tab="Absorber", group="Initialization"));
  parameter SI.AbsolutePressure p_absPipe_start
    "Pipe pressure" annotation (Dialog(tab="Absorber", group="Initialization"));

//Condenser
  replaceable package Medium_con = Modelica.Media.Water.WaterIF97_R1ph
    constrainedby Modelica.Media.Interfaces.PartialMedium
    "Condenser medium" annotation (choicesAllMatching=true, Dialog(tab="Condenser"));
  parameter SI.Height height_con
    "Height of vessel" annotation (Dialog(tab="Condenser"));
  parameter SI.Area crossArea_con
    "Area of vessel" annotation (Dialog(tab="Condenser"));
  parameter SI.ThermalConductance G_con
    "Thermal conductance" annotation (Dialog(tab="Condenser"));
  parameter SI.HeatCapacity C_con
    "Heat capacity" annotation (Dialog(tab="Condenser"));
  parameter ModelStructure modelStructure_con=ModelStructure.av_vb
    "Determines whether flow or volume models are present at the ports" annotation (Dialog(tab="Condenser"));
//Condenser::Initialization
  parameter SI.Height level_con_start
    "Liquid level" annotation (Dialog(tab="Condenser", group="Initialization"));
  parameter SI.Temperature T_conPipe_start
    "Pipe temperature" annotation (Dialog(tab="Condenser", group="Initialization"));
  parameter SI.MassFlowRate m_flow_con_start
    "Mass flow rate" annotation (Dialog(tab="Condenser", group="Initialization"));
  parameter SI.AbsolutePressure p_conPipe_start
    "Pipe pressure" annotation (Dialog(tab="Condenser", group="Initialization"));

//Evaporator
  replaceable package Medium_eva = Modelica.Media.Water.WaterIF97_R1ph
    constrainedby Modelica.Media.Interfaces.PartialMedium
    "Evaporator medium" annotation (choicesAllMatching=true, Dialog(tab="Evaporator"));
  parameter SI.Height height_eva
    "Height of vessel" annotation (Dialog(tab="Evaporator"));
  parameter SI.Area crossArea_eva
    "Area of vessel" annotation (Dialog(tab="Evaporator"));
  parameter SI.ThermalConductance G_eva
    "Thermal conductance" annotation (Dialog(tab="Evaporator"));
  parameter SI.HeatCapacity C_eva
    "Heat capacity" annotation (Dialog(tab="Evaporator"));
  parameter ModelStructure modelStructure_eva=ModelStructure.av_vb
    "Determines whether flow or volume models are present at the ports" annotation (Dialog(tab="Evaporator"));
//Evaporator::Initialization
  parameter SI.Height level_eva_start
    "Liquid level" annotation (Dialog(tab="Evaporator", group="Initialization"));
  parameter SI.Temperature T_evaPipe_start
    "Pipe temperature" annotation (Dialog(tab="Evaporator", group="Initialization"));
  parameter SI.MassFlowRate m_flow_eva_start
    "Mass flow rate" annotation (Dialog(tab="Evaporator", group="Initialization"));
  parameter SI.AbsolutePressure p_evaPipe_start
    "Pipe pressure" annotation (Dialog(tab="Evaporator", group="Initialization"));

//Solution
  parameter SI.ThermalConductance G_HXsol
    "Thermal conductance, heat exchanger" annotation (Dialog(tab="Solution"));
//Solution::Nominal
  parameter SI.MassFlowRate m_flow_str_nominal
    "Mass flow rate, strong solution" annotation (Dialog(tab="Solution", group="Nominal"));
  parameter Real opening_str_nominal(min=0, max=1)
    "Solution valve opening" annotation (Dialog(tab="Solution", group="Nominal"));
//Solution::Initialization
  parameter SI.MassFraction X_wea_start
    "Mass fraction, weak solution" annotation (Dialog(tab="Solution", group="Initialization"));
  parameter SI.MassFraction X_str_start
    "Mass fraction, strong solution" annotation (Dialog(tab="Solution", group="Initialization"));
  parameter SI.MassFlowRate m_flow_str_start = m_flow_str_nominal
    "Mass flow rate, strong solution" annotation (Dialog(tab="Solution", group="Initialization"));
  parameter Real opening_str_start(min=0, max=1) = opening_str_nominal
    "Solution valve opening" annotation (Dialog(tab="Solution", group="Initialization"));
  parameter SI.Temperature T_HX_start
    "Temperature, heat exchanger" annotation (Dialog(tab="Solution", group="Initialization"));

//Refrigerant::Nominal
  parameter SI.MassFlowRate m_flow_ref_nominal
    "Mass fraction" annotation (Dialog(tab="Refrigerant", group="Nominal"));
  parameter Real opening_ref_nominal(min=0, max=1)
    "Refrigerant valve opening" annotation (Dialog(tab="Refrigerant", group="Nominal"));
//Refrigerant::Initialization
  parameter SI.MassFlowRate m_flow_ref_start = m_flow_ref_nominal
    "Mass fraction" annotation (Dialog(tab="Refrigerant", group="Initialization"));
  parameter Real opening_ref_start(min=0, max=1) = opening_ref_nominal
    "Refrigerant valve opening" annotation (Dialog(tab="Refrigerant", group="Initialization"));

//Components
  BaseClasses.AbsorptionCycle absorptionCycle(
    X_wea_start=X_wea_start,
    X_str_start=X_str_start,
    m_flow_str_start=m_flow_str_start,
    m_flow_ref_start=m_flow_ref_start,
    level_abs_start=level_abs_start,
    p_abs_start=p_abs_start,
    level_gen_start=level_gen_start,
    p_gen_start=p_gen_start,
    level_eva_start=level_eva_start,
    level_con_start=level_con_start,
    G_HXsol=G_HXsol,
    T_HXw_start=T_HX_start,
    T_HXs_start=T_HX_start,
    opening_str_start=opening_str_start,
    opening_ref_start=opening_ref_start,
    p_gen_nominal=p_gen_nominal,
    p_abs_nominal=p_abs_nominal,
    m_flow_str_nominal=m_flow_str_nominal,
    opening_str_nominal=opening_str_nominal,
    m_flow_ref_nominal=m_flow_ref_nominal,
    opening_ref_nominal=opening_ref_nominal,
    height_gen=height_gen,
    crossArea_gen=crossArea_gen,
    height_abs=height_abs,
    crossArea_abs=crossArea_abs,
    height_con=height_con,
    crossArea_con=crossArea_con,
    height_eva=height_eva,
    crossArea_eva=crossArea_eva)             annotation (Placement(transformation(extent={{-80,-80},{80,80}})));

  Modelica.Thermal.HeatTransfer.Components.ThermalConductor thermalConductor_gen_ext[2](each G=G_gen)   annotation (Placement(transformation(
        extent={{-10,-10},{10,10}},
        rotation=-90,
        origin={170,110})));
  Modelica.Thermal.HeatTransfer.Components.ThermalConductor thermalConductor_abs_ext[2](each G=G_abs)   annotation (Placement(transformation(
        extent={{-10,-10},{10,10}},
        rotation=-90,
        origin={170,-110})));
  Modelica.Thermal.HeatTransfer.Components.ThermalConductor thermalConductor_con_ext[2](each G=G_con)   annotation (Placement(transformation(
        extent={{-10,-10},{10,10}},
        rotation=90,
        origin={-170,110})));
  Modelica.Thermal.HeatTransfer.Components.ThermalConductor thermalConductor_eva_ext[2](each G=G_eva)   annotation (Placement(transformation(
        extent={{-10,-10},{10,10}},
        rotation=90,
        origin={-170,-110})));
  Modelica.Thermal.HeatTransfer.Components.ThermalConductor thermalConductor_gen_int(G=G_gen*2) annotation (Placement(transformation(
        extent={{-10,-10},{10,10}},
        rotation=180,
        origin={110,40})));
  Modelica.Thermal.HeatTransfer.Components.ThermalConductor thermalConductor_abs_int(G=G_abs*2) annotation (Placement(transformation(
        extent={{-10,-10},{10,10}},
        rotation=0,
        origin={110,-72})));
  Modelica.Thermal.HeatTransfer.Components.ThermalConductor thermalConductor_con_int(G=G_con*2) annotation (Placement(transformation(
        extent={{-10,-10},{10,10}},
        rotation=180,
        origin={-110,40})));
  Modelica.Thermal.HeatTransfer.Components.ThermalConductor thermalConductor_eva_int(G=G_eva*2) annotation (Placement(transformation(
        extent={{-10,-10},{10,10}},
        rotation=0,
        origin={-110,-72})));
  Modelica.Thermal.HeatTransfer.Components.HeatCapacitor heatCapacitor_gen(C=C_gen, T(start=0.5*(absorptionCycle.generator.Tsat_start + T_genPipe_start), fixed=true))
                                                                                    annotation (Placement(transformation(extent={{150,40},{170,20}})));
  Modelica.Thermal.HeatTransfer.Components.HeatCapacitor heatCapacitor_abs(C=C_abs, T(start=0.5*(absorptionCycle.absorber.Tsat_start + T_absPipe_start), fixed=true))
                                                                                    annotation (Placement(transformation(extent={{150,-72},{170,-52}})));
  Modelica.Thermal.HeatTransfer.Components.HeatCapacitor heatCapacitor_con(C=C_con, T(start=0.5*(absorptionCycle.condenser.Tsat_start + T_conPipe_start), fixed=true))
                                                                                    annotation (Placement(transformation(extent={{-170,40},{-150,20}})));
  Modelica.Thermal.HeatTransfer.Components.HeatCapacitor heatCapacitor_eva(C=C_eva, T(start=0.5*(absorptionCycle.evaporator.Tsat_start + T_evaPipe_start), fixed=true))
                                                                                    annotation (Placement(transformation(extent={{-170,-72},{-150,-52}})));

  Modelica.Fluid.Pipes.DynamicPipe pipe_gen(allowFlowReversal=false, use_HeatTransfer=true,
    redeclare package Medium = Medium_gen,
    length=0.1,
    diameter=1,
    nParallel=1,
    isCircular=true,
    roughness=0,
    height_ab=0,
    nNodes=2,
    useLumpedPressure=false,
    useInnerPortProperties=false,
    redeclare model HeatTransfer =
      Modelica.Fluid.Pipes.BaseClasses.HeatTransfer.IdealFlowHeatTransfer,
    modelStructure=modelStructure_gen,
    m_flow_start=m_flow_gen_start,
    redeclare model FlowModel =
      Modelica.Fluid.Pipes.BaseClasses.FlowModels.NominalLaminarFlow (                          dp_nominal(displayUnit="Pa") = 0.001, m_flow_nominal=m_flow_gen_start),
    momentumDynamics=Modelica.Fluid.Types.Dynamics.SteadyState,
    p_a_start(displayUnit="MPa") = p_genPipe_start,
    use_T_start=true,
    T_start(displayUnit="K") = T_genPipe_start)
    annotation (Placement(transformation(extent={{180,150},{160,130}})));
  Modelica.Fluid.Pipes.DynamicPipe pipe_abs(allowFlowReversal=false, use_HeatTransfer=true,
    redeclare package Medium = Medium_abs,
    length=0.1,
    diameter=1,
    nParallel=1,
    isCircular=true,
    roughness=0,
    height_ab=0,
    nNodes=2,
    useLumpedPressure=false,
    useInnerPortProperties=false,
    redeclare model HeatTransfer =
      Modelica.Fluid.Pipes.BaseClasses.HeatTransfer.IdealFlowHeatTransfer,
    redeclare model FlowModel =
      Modelica.Fluid.Pipes.BaseClasses.FlowModels.NominalLaminarFlow (                          dp_nominal(displayUnit="Pa") = 0.001, m_flow_nominal=m_flow_abs_start),
    modelStructure=modelStructure_abs,
    m_flow_start=m_flow_abs_start,
    momentumDynamics=Modelica.Fluid.Types.Dynamics.SteadyState,
    p_a_start=p_absPipe_start,
    use_T_start=true,
    T_start(displayUnit="K") = T_absPipe_start)
    annotation (Placement(transformation(extent={{180,-150},{160,-130}})));
  Modelica.Fluid.Pipes.DynamicPipe pipe_con(allowFlowReversal=false, use_HeatTransfer=true,
    redeclare package Medium = Medium_con,
    length=0.1,
    diameter=1,
    nParallel=1,
    isCircular=true,
    roughness=0,
    height_ab=0,
    nNodes=2,
    useLumpedPressure=false,
    useInnerPortProperties=false,
    redeclare model HeatTransfer =
      Modelica.Fluid.Pipes.BaseClasses.HeatTransfer.IdealFlowHeatTransfer,
    redeclare model FlowModel =
      Modelica.Fluid.Pipes.BaseClasses.FlowModels.NominalLaminarFlow (                          dp_nominal(displayUnit="Pa") = 0.001, m_flow_nominal=m_flow_con_start),
    modelStructure=modelStructure_con,
    m_flow_start=m_flow_con_start,
    momentumDynamics=Modelica.Fluid.Types.Dynamics.SteadyState,
    p_a_start=p_conPipe_start,
    T_start(displayUnit="K") = T_conPipe_start,
    use_T_start=true)
    annotation (Placement(transformation(extent={{-180,150},{-160,130}})));
  Modelica.Fluid.Pipes.DynamicPipe pipe_eva(allowFlowReversal=false, use_HeatTransfer=true,
    redeclare package Medium = Medium_eva,
    length=0.1,
    diameter=1,
    nParallel=1,
    isCircular=true,
    roughness=0,
    height_ab=0,
    nNodes=2,
    useLumpedPressure=false,
    useInnerPortProperties=false,
    redeclare model HeatTransfer =
      Modelica.Fluid.Pipes.BaseClasses.HeatTransfer.IdealFlowHeatTransfer,
    modelStructure=modelStructure_eva,
    redeclare model FlowModel =
      Modelica.Fluid.Pipes.BaseClasses.FlowModels.NominalLaminarFlow (                          dp_nominal(displayUnit="Pa") = 0.001, m_flow_nominal=m_flow_eva_start),
    m_flow_start=m_flow_eva_start,
    momentumDynamics=Modelica.Fluid.Types.Dynamics.SteadyState,
    p_a_start=p_evaPipe_start,
    T_start(displayUnit="K") = T_evaPipe_start,
    use_T_start=true)
    annotation (Placement(transformation(extent={{-180,-150},{-160,-130}})));

//Inputs
  Modelica.Blocks.Interfaces.RealInput pump_sol
    "Control signal, solution pump" annotation (Placement(transformation(extent={{240,-80},{200,-40}})));
  Modelica.Blocks.Interfaces.RealInput opening_sol
    "Control signal, solution valve" annotation (Placement(transformation(extent={{240,0},{200,40}})));
  Modelica.Blocks.Interfaces.RealInput opening_ref
    "Control signal, refrigerant valve" annotation (Placement(transformation(extent={{-240,-20},{-200,20}})));

//FluidPorts
  Modelica.Fluid.Interfaces.FluidPort_a port_a_gen(redeclare package Medium = Medium_gen)
    annotation (Placement(transformation(extent={{190,130},{210,150}})));
  Modelica.Fluid.Interfaces.FluidPort_a port_a_abs(redeclare package Medium = Medium_abs)
    annotation (Placement(transformation(extent={{190,-150},{210,-130}})));
  Modelica.Fluid.Interfaces.FluidPort_a port_a_con(redeclare package Medium = Medium_con)
    annotation (Placement(transformation(extent={{-210,130},{-190,150}})));
  Modelica.Fluid.Interfaces.FluidPort_a port_a_eva(redeclare package Medium = Medium_eva)
    annotation (Placement(transformation(extent={{-210,-150},{-190,-130}})));
  Modelica.Fluid.Interfaces.FluidPort_b port_b_gen(redeclare package Medium = Medium_gen)
    annotation (Placement(transformation(extent={{130,190},{150,210}})));
  Modelica.Fluid.Interfaces.FluidPort_b port_b_abs(redeclare package Medium = Medium_abs)
    annotation (Placement(transformation(extent={{130,-210},{150,-190}})));
  Modelica.Fluid.Interfaces.FluidPort_b port_b_con(redeclare package Medium = Medium_con)
    annotation (Placement(transformation(extent={{-150,190},{-130,210}})));
  Modelica.Fluid.Interfaces.FluidPort_b port_b_eva(redeclare package Medium = Medium_eva)
    annotation (Placement(transformation(extent={{-150,-210},{-130,-190}})));

//InternalStates
  Types.VesselState state_g=absorptionCycle.state_g "State, generator";
  Types.VesselState state_a=absorptionCycle.state_a "State, absorber";
  Types.VesselState state_c=absorptionCycle.state_c "State, condenser";
  Types.VesselState state_e=absorptionCycle.state_e "State, evaporator";
  Real COP(min=0, nominal=1, unit="W/W") = absorptionCycle.COP "Absortion cycle COP";

equation
  connect(port_a_gen, pipe_gen.port_a) annotation (Line(points={{200,140},{180,140}}, color={0,127,255}));
  connect(pipe_gen.port_b, port_b_gen) annotation (Line(points={{160,140},{140,140},{140,200}}, color={0,127,255}));
  connect(port_a_abs, pipe_abs.port_a) annotation (Line(points={{200,-140},{180,-140}}, color={0,127,255}));
  connect(pipe_abs.port_b, port_b_abs) annotation (Line(points={{160,-140},{140,-140},{140,-200}}, color={0,127,255}));
  connect(port_a_con, pipe_con.port_a) annotation (Line(points={{-200,140},{-190,140},{-180,140}}, color={0,127,255}));
  connect(pipe_con.port_b, port_b_con) annotation (Line(points={{-160,140},{-140,140},{-140,200}}, color={0,127,255}));
  connect(port_a_eva, pipe_eva.port_a) annotation (Line(points={{-200,-140},{-190,-140},{-180,-140}}, color={0,127,255}));
  connect(pipe_eva.port_b, port_b_eva) annotation (Line(points={{-160,-140},{-150,-140},{-140,-140},{-140,-200}}, color={0,127,255}));
  connect(thermalConductor_con_ext.port_b, pipe_con.heatPorts) annotation (Line(points={{-170,120},{-170,135.6},{-169.9,135.6}}, color={191,0,0}));
  connect(opening_sol, absorptionCycle.opening_sol) annotation (Line(points={{220,20},{220,20},{180,20},{180,8},{88,8}},
                                                                                                                      color={0,0,127}));
  connect(pump_sol, absorptionCycle.pump_sol) annotation (Line(points={{220,-60},{200,-60},{180,-60},{180,-32},{88,-32}}, color={0,0,127}));
  connect(opening_ref, absorptionCycle.opening_ref) annotation (Line(points={{-220,0},{-88,0}},         color={0,0,127}));
  connect(absorptionCycle.port_g, thermalConductor_gen_int.port_b) annotation (Line(points={{80,40},{90,40},{100,40}}, color={191,0,0}));
  connect(thermalConductor_gen_int.port_a, heatCapacitor_gen.port) annotation (Line(points={{120,40},{140,40},{160,40}}, color={191,0,0}));
  connect(heatCapacitor_gen.port, thermalConductor_gen_ext[1].port_b) annotation (Line(points={{160,40},{166,40},{170,40},{170,100}}, color={191,0,0}));
  connect(heatCapacitor_gen.port, thermalConductor_gen_ext[2].port_b) annotation (Line(points={{160,40},{170,40},{170,100}}, color={191,0,0}));
  connect(thermalConductor_gen_ext.port_a, pipe_gen.heatPorts) annotation (Line(points={{170,120},{170,135.6},{169.9,135.6}}, color={191,0,0}));
  connect(absorptionCycle.port_a, thermalConductor_abs_int.port_a) annotation (Line(points={{80,-72},{90,-72},{100,-72}}, color={191,0,0}));
  connect(thermalConductor_abs_int.port_b, heatCapacitor_abs.port) annotation (Line(points={{120,-72},{160,-72}}, color={191,0,0}));
  connect(heatCapacitor_abs.port, thermalConductor_abs_ext[1].port_a) annotation (Line(points={{160,-72},{170,-72},{170,-100}}, color={191,0,0}));
  connect(heatCapacitor_abs.port, thermalConductor_abs_ext[2].port_a) annotation (Line(points={{160,-72},{170,-72},{170,-100}}, color={191,0,0}));
  connect(thermalConductor_abs_ext.port_b, pipe_abs.heatPorts) annotation (Line(points={{170,-120},{170,-135.6},{169.9,-135.6}}, color={191,0,0}));
  connect(absorptionCycle.port_c, thermalConductor_con_int.port_a) annotation (Line(points={{-80,40},{-90,40},{-100,40}}, color={191,0,0}));
  connect(thermalConductor_con_int.port_b, heatCapacitor_con.port) annotation (Line(points={{-120,40},{-140,40},{-160,40}}, color={191,0,0}));
  connect(heatCapacitor_con.port, thermalConductor_con_ext[1].port_a) annotation (Line(points={{-160,40},{-166,40},{-170,40},{-170,100}}, color={191,0,0}));
  connect(heatCapacitor_con.port, thermalConductor_con_ext[2].port_a) annotation (Line(points={{-160,40},{-170,40},{-170,100}}, color={191,0,0}));
  connect(absorptionCycle.port_e, thermalConductor_eva_int.port_b) annotation (Line(points={{-80,-72},{-90,-72},{-100,-72}}, color={191,0,0}));
  connect(thermalConductor_eva_int.port_a, heatCapacitor_eva.port) annotation (Line(points={{-120,-72},{-160,-72}}, color={191,0,0}));
  connect(heatCapacitor_eva.port, thermalConductor_eva_ext[1].port_b) annotation (Line(points={{-160,-72},{-170,-72},{-170,-100}}, color={191,0,0}));
  connect(heatCapacitor_eva.port, thermalConductor_eva_ext[2].port_b) annotation (Line(points={{-160,-72},{-164,-72},{-170,-72},{-170,-100}}, color={191,0,0}));
  connect(thermalConductor_eva_ext.port_a, pipe_eva.heatPorts) annotation (Line(points={{-170,-120},{-169.9,-120},{-169.9,-135.6}}, color={191,0,0}));
  annotation (Icon(coordinateSystem(preserveAspectRatio=false, extent={{-200,-200},{200,200}}), graphics={
        Polygon(
          points={{-110,-20},{-90,18},{-110,-20}},
          pattern=LinePattern.None,
          fillColor={170,255,255},
          fillPattern=FillPattern.Solid),
        Line(points={{100,20},{220,20}}, color={0,0,0}),
        Line(points={{-220,0},{-100,0}}, color={0,0,0}),
        Text(
          extent={{-100,260},{100,200}},
          lineColor={28,108,200},
          textString="%name"),
        Text(
          extent={{40,200},{160,80}},
          textString="G",
          pattern=LinePattern.None,
          lineColor={255,255,255}),
        Text(
          extent={{40,-80},{160,-200}},
          textString="A",
          pattern=LinePattern.None,
          lineColor={255,255,255}),
        Text(
          extent={{-160,200},{-40,80}},
          textString="C",
          pattern=LinePattern.None,
          lineColor={255,255,255}),
        Text(
          extent={{-160,-80},{-40,-200}},
          textString="E",
          pattern=LinePattern.None,
          lineColor={255,255,255})}),                      Diagram(coordinateSystem(preserveAspectRatio=false, extent={{-200,-200},{200,200}})),
    Documentation(info="<html>
<p><span style=\"font-family: MS Shell Dlg 2,sans-serif;\">Absorption chiller with LiBr+H2O as the refrigerant solution. Thermal conductance and capacity are assumed constant (model parameter) for all heat exchangers. <a href=\"Modelica.Fluid.Pipes.BaseClasses.FlowModels.NominalLaminarFlow\">Laminar flow</a> is assumed.</span></p>
</html>", revisions="<html>
<p>2016-05-31 <a href=\"mailto:jesus.febres@tekniker.es\">Jes&uacute;s Febres</a> (IK4-TEKNIKER): First implementation</p>
<p><b>Copyright &copy; <a href=\"http://www.tekniker.es/en\">IK4-TEKNIKER</a></b></p>
</html>"));
end AbsorptionChiller;
