within DCOL.Generation.AbsorptionChillers.BaseClasses.LiBrH2O;
function saturationPressure_TX "Vapour pressure of the H2O/LiBr solution as a function of T and X_LiBr"
  input Temperature T "Temperature [K] of the solution";
  input MassFraction X_LiBr "LiBr mass fraction in the solution";
  output AbsolutePressure p_v "vapour pressure of the solution in the vessel";
algorithm
  p_v := Modelica.Media.Water.WaterIF97_base.saturationPressure(dewPoint_TX(T, X_LiBr));
  annotation(inverse(T = temperature_psatX(p_v, X_LiBr)));
end saturationPressure_TX;
