﻿within DCOL.Generation.AbsorptionChillers.BaseClasses.LiBrH2O;
function specificHeatCapacity_TX
  "Specific enthalpy of the H2O/LiBr solution as a function of T and X_LiBr"
  //Kaita, Y. 2001. “Thermodynamic Properties of Lithium Bromide - Water Solutions at High Temperatures”
  input Temperature T "Temperature [K] of the solution";
  input MassFraction X_LiBr "LiBr mass fraction in the solution";
  output SpecificHeatCapacity cp "Specific heat capacity of the solution";
protected
  constant Real[2] A = {3.462023, -2.679895E-2};
  constant Real[2] B = {1.3499E-3, -6.55E-6};
  Real[2] X = {(X_LiBr*100)^i for i in 0:1} "Aux. array";
  Real[2] Tc = {(T-273.15)^i for i in 0:1} "Aux. array";
algorithm
  cp := {A*X, B*X}*Tc;
  annotation (derivative=specificHeatCapacity_TX_der);
end specificHeatCapacity_TX;
