within DCOL.Generation.AbsorptionChillers.BaseClasses.LiBrH2O;
function temperature_psatX "Vapour pressure of the H2O/LiBr solution as a function of T and X_LiBr"
  input AbsolutePressure p_v "vapour pressure of the solution in the vessel";
  input MassFraction X_LiBr "LiBr mass fraction in the solution";
  output Temperature T "Temperature [K] of the solution";
algorithm
  T :=temperature_dewPointX(Modelica.Media.Water.WaterIF97_base.saturationTemperature(p_v), X_LiBr)
  annotation(inverse(p_v = saturationPressure_TX(T, X_LiBr)));
end temperature_psatX;
