within DCOL.Generation.ConventionalChillers.BaseClasses.HeatTransfer;
model NominalConstantFlowHeatTransfer
  "ConstantHeatTransfer: Constant heat transfer coefficient given nominal condition"
  extends Modelica.Fluid.Pipes.BaseClasses.HeatTransfer.ConstantFlowHeatTransfer(
    final alpha0=Q_flow_nominal/((sum(surfaceAreas_par)/size(Ts_nominal,1))*sum(heatports_T_nominal - Ts_nominal)*nParallel));
  parameter Modelica.SIunits.Area[n] surfaceAreas_par "Heat transfer areas, parameter";
  parameter Modelica.SIunits.HeatFlowRate Q_flow_nominal "Total heat flow rate (nominal)";
  parameter Modelica.SIunits.Temperature[n] Ts_nominal "Temperatures defined by fluid states (nominal)";
  parameter Modelica.SIunits.Temperature[n] heatports_T_nominal "Temperatures at component boundary (Nominal)";

initial equation
  //ToDO: assert for negative alpha
//   sum(Q_flows_nominal) = Q_flow_nominal;
//   Q_flows_nominal = alpha0*sum(surfaceAreas/size(Ts_nominal,1)).*(heatports_T_nominal - Ts_nominal)*nParallel;
//Q_flow_nominal = alpha0*(sum(surfaceAreas)/size(Ts_nominal,1))*sum(heatports_T_nominal - Ts_nominal)*nParallel;
  annotation(Documentation(info="<html>
<p>Simple heat transfer correlation with constant heat transfer coefficient, used as default component in distributed pipe models. The heat transfer coefficient is calculated using temperatures and heat transfer rate nominal values.</p>
</html>"));
end NominalConstantFlowHeatTransfer;
