within DCOL.Generation.ConventionalChillers.ChillerSpecs;
record Data
  parameter Modelica.SIunits.HeatFlowRate Qflow_eva_ref "Reference capacity";
  parameter Real COP_ref;

  parameter Real PLRMax(min=0) "Maximum part load ratio";
  parameter Real PLRMinUnl(min=0) "Minimum part unload ratio";
  parameter Real PLRMin(min=0) "Minimum part load ratio";

  parameter Real etaMotor(min=0, max=1)
    "Fraction of compressor motor heat entering refrigerant";

  parameter Modelica.SIunits.Temperature T_out_eva_nominal
    "Temperature of fluid leaving evaporator at nominal condition"
    annotation (Dialog(group="Nominal condition"));
  parameter Modelica.SIunits.Temperature T_out_eva_min
    "Minimum value for leaving evaporator temperature"
    annotation (Dialog(group="Performance curves"));
  parameter Modelica.SIunits.Temperature T_out_eva_max
    "Maximum value for leaving evaporator temperature"
    annotation (Dialog(group="Performance curves"));
  parameter Modelica.SIunits.MassFlowRate mflow_eva_nominal
    "Nominal mass flow at evaporator"
    annotation (Dialog(group="Nominal condition"));
  parameter Modelica.SIunits.Pressure dp_eva_nominal
    "Nominal pressure drop at evaporator"
    annotation (Dialog(group="Nominal condition"));

  parameter Modelica.SIunits.Temperature T_in_con_nominal
    "Temperature of fluid entering condenser at nominal condition"
    annotation (Dialog(group="Nominal condition"));
  parameter Modelica.SIunits.Temperature T_in_con_min
    "Minimum value for entering condenser temperature"
    annotation (Dialog(group="Performance curves"));
  parameter Modelica.SIunits.Temperature T_in_con_max
    "Maximum value for entering condenser temperature"
    annotation (Dialog(group="Performance curves"));
  parameter Modelica.SIunits.MassFlowRate mflow_con_nominal
    "Nominal mass flow at condenser"
    annotation (Dialog(group="Nominal condition"));

end Data;
