within DCOL.Generation.ConventionalChillers.FMI;
model McQuay_fmu
// Model automatically generated by Dymola from FMI model description
public
  type Modelica_Blocks_Interfaces_BooleanInput = Boolean;
  type Modelica_Blocks_Interfaces_BooleanOutput = Boolean;
  type Modelica_Blocks_Interfaces_RealInput = Real;
  type Modelica_Blocks_Interfaces_RealOutput = Real;
  type Modelica_IK4_TEKNIKER_DCOL_Generation_ConventionalChillers_FMI_MassFlowRateInput = Real (unit = "kg/s", quantity = "MassFlowRate");
  type Modelica_IK4_TEKNIKER_DCOL_Generation_ConventionalChillers_FMI_PressureInput = Real (unit = "Pa", displayUnit = "bar", quantity = "Pressure");
  type Modelica_IK4_TEKNIKER_DCOL_Generation_ConventionalChillers_FMI_PressureOutput = Real (unit = "Pa", displayUnit = "bar", quantity = "Pressure");
  type Modelica_IK4_TEKNIKER_DCOL_Generation_ConventionalChillers_FMI_TemperatureInput = Real (unit = "K", displayUnit = "degC", nominal = 300.0, quantity = "ThermodynamicTemperature", min = 0.0);
  type Modelica_IK4_TEKNIKER_DCOL_Generation_ConventionalChillers_FMI_TemperatureOutput = Real (unit = "K", displayUnit = "degC", nominal = 300.0, quantity = "ThermodynamicTemperature", min = 0.0);
  parameter Modelica.SIunits.HeatCapacity C_con = 100
                                                     "Heat capacity of condenser (= cp*m)";
  parameter Modelica.SIunits.HeatCapacity C_eva = 50000000.0
                                                            "Heat capacity of evaporator (= cp*m)";
  Real pin_con_der(unit = "Pa/s");
protected
  record pressure_eva_rec
  protected
    record port_rec
      constant Modelica.Media.Interfaces.PartialMedium.MassFlowRate m_flow(quantity = "MassFlowRate.SimpleLiquidWater", min = 0.0) = 0
                                                                                                                                      "Mass flow rate from the connection point into the component";
      Modelica.Media.Interfaces.Types.AbsolutePressure p
                                                        "Thermodynamic pressure in the connection point";
      constant Modelica.Media.Interfaces.Types.SpecificEnthalpy h_outflow = 83680.0
                                                                                   "Specific thermodynamic enthalpy close to the connection point if m_flow < 0";
    end port_rec;
  public
    port_rec port;
    Modelica_Blocks_Interfaces_RealOutput p(unit = "Pa", displayUnit = "bar", quantity = "Pressure", min = 0.0)
                                                                                                               "Pressure at port";
  end pressure_eva_rec;
public
  pressure_eva_rec pressure_eva;
  parameter Real _Tin_con_start = 288.15
  annotation (Dialog(tab="Input Start Values", group="Input Start Value before call to fmiInitialize"));
  Modelica.Blocks.Interfaces.RealInput Tin_con(unit = "K", displayUnit = "degC", nominal = 300.0, quantity = "ThermodynamicTemperature", min = 273.15, max = 373.15, start = 288.15)
                                                                                                                                                                                    "Inlet temperature, condenser"
  annotation (Placement(transformation(extent={{-114,65},{-94,85}})));
  parameter Real _m_flow_con_start = 0.0
  annotation (Dialog(tab="Input Start Values", group="Input Start Value before call to fmiInitialize"));
  Modelica.Blocks.Interfaces.RealInput m_flow_con(unit = "kg/s", quantity = "MassFlowRate", min = 0.0, max = 100000.0, start = 0.0)
                                                                                                                                   "Mass flow rate, condenser"
  annotation (Placement(transformation(extent={{-114,40},{-94,60}})));
  parameter Real _pout_con_start = 100000.0
  annotation (Dialog(tab="Input Start Values", group="Input Start Value before call to fmiInitialize"));
  Modelica.Blocks.Interfaces.RealInput pout_con(unit = "Pa", displayUnit = "bar", nominal = 100000.0, quantity = "Pressure", min = 0.0, max = 100000000.0, start = 100000.0)
                                                                                                                                                                            "Outlet pressure, condenser"
  annotation (Placement(transformation(extent={{-114,15},{-94,35}})));
  parameter Real _Tin_eva_start = 288.15
  annotation (Dialog(tab="Input Start Values", group="Input Start Value before call to fmiInitialize"));
  Modelica.Blocks.Interfaces.RealInput Tin_eva(unit = "K", displayUnit = "degC", nominal = 300.0, quantity = "ThermodynamicTemperature", min = 1.0, max = 10000.0, start = 288.15)
                                                                                                                                                                                  "Inlet temperature, evaporator"
  annotation (Placement(transformation(extent={{-114,-10},{-94,10}})));
  parameter Real _m_flow_eva_start = 0.0
  annotation (Dialog(tab="Input Start Values", group="Input Start Value before call to fmiInitialize"));
  Modelica.Blocks.Interfaces.RealInput m_flow_eva(unit = "kg/s", quantity = "MassFlowRate", min = 0.0, max = 100000.0, start = 0.0)
                                                                                                                                   "Mass flow rate, evaporator"
  annotation (Placement(transformation(extent={{-114,-35},{-94,-15}})));
  parameter Real _pout_eva_start = 0.0
  annotation (Dialog(tab="Input Start Values", group="Input Start Value before call to fmiInitialize"));
  Modelica.Blocks.Interfaces.RealInput pout_eva(unit = "Pa", displayUnit = "bar", nominal = 100000.0, quantity = "Pressure", min = 0.0, max = 100000000.0, start = 0.0)
                                                                                                                                                                       "Outlet pressure, evaporator"
  annotation (Placement(transformation(extent={{-114,-60},{-94,-40}})));
  parameter Real _P_com_start = 0.0
  annotation (Dialog(tab="Input Start Values", group="Input Start Value before call to fmiInitialize"));
  Modelica.Blocks.Interfaces.RealInput P_com(start = 0.0)
                                                         "Compressor power"
  annotation (Placement(transformation(extent={{-114,-85},{-94,-65}})));
  Modelica.Blocks.Interfaces.RealOutput Tout_con(unit = "K", displayUnit = "degC", nominal = 300.0, quantity = "ThermodynamicTemperature", min = 0.0)
                                                                                                                                                     "Outlet temperature, condenser"
  annotation (Placement(transformation(extent={{100,40},{140,80}})));
  Modelica.Blocks.Interfaces.RealOutput Tout_eva(unit = "K", displayUnit = "degC", nominal = 300.0, quantity = "ThermodynamicTemperature", min = 0.0)
                                                                                                                                                     "Outlet temperature, evaporator"
  annotation (Placement(transformation(extent={{100,0},{140,40}})));
  Modelica.Blocks.Interfaces.RealOutput pin_con(unit = "Pa", displayUnit = "bar", nominal = 100000.0, quantity = "Pressure", min = 0.0, max = 100000000.0)
  annotation (Placement(transformation(extent={{100,-40},{140,0}})));
  Modelica.Blocks.Interfaces.RealOutput pin_eva(unit = "Pa", displayUnit = "bar", nominal = 100000.0, quantity = "Pressure", min = 0.0, max = 100000000.0)
  annotation (Placement(transformation(extent={{100,-80},{140,-40}})));
public
  parameter String fmi_instanceName="Modelica_0IK4_0TEKNIKER_DCOL_Generation_ConventionalChillers_FMI_McQuay_fmu"
  annotation (Dialog(tab="FMI", group="Instance name"));
  parameter Boolean fmi_loggingOn=false
  annotation (Dialog(tab="FMI", group="Enable logging"));
  parameter Boolean fmi_pullInputsForInitialization=true
  "Set to false when using the FMU in feedback connections"
  annotation (Dialog(tab="FMI", group="Inputs for initialization"));
  parameter Real fmi_StartTime = 0.0
  annotation (Dialog(tab="FMI", group="Step time"));
  parameter Real fmi_StopTime = 3600.0
  annotation (Dialog(tab="FMI", group="Step time"));
  parameter Real fmi_NumberOfSteps = 500
  annotation (Dialog(tab="FMI", group="Step time"));
  parameter Real fmi_CommunicationStepSize=(fmi_StopTime-fmi_StartTime)/fmi_NumberOfSteps
  annotation (Dialog(tab="FMI", group="Step time"));
  parameter Integer stepSizeScaleFactor = 1 "Number of doSteps called between two CommunicationStepSize"
  annotation (Dialog(tab="FMI", group="Step time"));
  parameter Boolean fmi_forceShutDownAtStopTime=false
  annotation (Dialog(tab="FMI", group="Step time"));
  parameter String fmi_fmuLocation="file:///"+ModelicaServices.ExternalReferences.loadResource("modelica://Modelica_IK4_TEKNIKER.DCOL.Generation.ConventionalChillers.FMI.McQuay_fmu")
  annotation (Dialog(tab="FMI", group="Instantiation"));
protected
fmi_Functions.fmiModel fmi;
Boolean fmi_StepOK;
parameter Real fmi_Initialized(fixed=false);
parameter Real fmi_AParamsAndStart(fixed=false);
parameter Real fmi_initInput0(start=0,fixed=false);
parameter Real fmi_initInput1(start=0,fixed=false);
parameter Real fmi_initInput2(start=0,fixed=false);
parameter Real fmi_initInput3(start=0,fixed=false);
parameter Real fmi_initInput4(start=0,fixed=false);
parameter Real fmi_initInput5(start=0,fixed=false);
parameter Real fmi_initInput6(start=0,fixed=false);
Real RealVariables[3];
package fmi_Functions
  class fmiModel
  extends ExternalObject;
    function constructor "Initialize FMI model"
      extends Modelica.Icons.Function;
      input String instanceName;
      input Boolean loggingOn;
        input String fmuLocation;
      output fmiModel fmi;
      external"C" fmi = Modelica_0IK4_0TEKNIKER_DCOL_Generation_ConventionalChillers_FMI_McQuay_fmiInstantiateModel2(instanceName, loggingOn, fmuLocation)
      annotation(Header="
#ifndef Modelica_0IK4_0TEKNIKER_DCOL_Generation_ConventionalChillers_FMI_McQuay_Instantiate_C
#define Modelica_0IK4_0TEKNIKER_DCOL_Generation_ConventionalChillers_FMI_McQuay_Instantiate_C 1
#include <stdlib.h>
#include \"FMI/fmiImport.h\"
#ifndef Modelica_0IK4_0TEKNIKER_DCOL_Generation_ConventionalChillers_FMI_McQuay_MYSTRCMP_C
#define Modelica_0IK4_0TEKNIKER_DCOL_Generation_ConventionalChillers_FMI_McQuay_MYSTRCMP_C 1
int Modelica_0IK4_0TEKNIKER_DCOL_Generation_ConventionalChillers_FMI_McQuaymystrcmp(const void *_a, const void *_b) {
  char *a = _a;
  char *const *b = _b;
  return strcmp(a, *b);
}
#endif
void Modelica_0IK4_0TEKNIKER_DCOL_Generation_ConventionalChillers_FMI_McQuayLogger(fmiComponent c, fmiString instanceName, fmiStatus status,
         fmiString category, fmiString message, ...) {
  const char *rVreafArray[17] = {"+"\"r100664749\","+"\"r100664750\"," + "\"r16777221\"," + "\"r16777222\"," + "\"r335544320\"," + "\"r335544321\"," + "\"r335544322\"," + "\"r335544323\"," + "\"r352321536\"," + "\"r352321537\"," + "\"r352321538\","
               + "\"r352321539\"," + "\"r352321540\"," + "\"r352321541\"," + "\"r352321542\"," + "\"r369100204\"," + "\"r905969688\"};
  const char *rNamesArray[17] = {" + "\"pressure_eva.port.m_flow\"," + "\"pressure_eva.port.h_outflow\"," + "\"C_con\"," + "\"C_eva\"," + "\"Tout_con\"," + "\"Tout_eva\"," + "\"pin_con\"," + "\"pin_eva\"," + "\"Tin_con\"," + "\"m_flow_con\","
               + "\"pout_con\"," + "\"Tin_eva\"," + "\"m_flow_eva\"," + "\"pout_eva\"," + "\"P_com\"," + "\"der(pin_con)\"," + "\"pressure_eva.port.p\"};
  size_t nr = 17;
  char msg[4096];
  char buf[4096];
  int len;
  va_list ap;
  char fmsg[4096];
  char sVref[16];
  char* hashPtr1;
  char* hashPtr2;
  char** vrefPos;
  ptrdiff_t cpylen;
  ptrdiff_t nameIndex;
  char* msgPtr;
  va_start(ap,message);
#if defined(_MSC_VER) && _MSC_VER>=1200
  len = _snprintf(msg, sizeof(msg)/sizeof(*msg), \"%s: %s\", instanceName, message);
  if (len < 0) goto fail;
  len = _vsnprintf(buf, sizeof(buf)/sizeof(*buf) - 2, msg, ap);
  if (len < 0) goto fail;
#else
  len = snprintf(msg, sizeof(msg)/sizeof(*msg), \"%s: %s\", instanceName, message);
  if (len < 0) goto fail;
  len = vsnprintf(buf, sizeof(buf)/sizeof(*buf) - 2, msg, ap);
  if (len < 0) goto fail;
#endif
  if( len>0 && len <4096 && buf[len - 1]!='\\n'){
    buf[len] = '\\n';
    buf[len + 1] = 0;
  }
  va_end(ap);
  msgPtr = buf;
  hashPtr1 = strchr(msgPtr,\'#\');
  fmsg[0]=\'\\0\';
  while(hashPtr1){
    hashPtr2 = strchr(hashPtr1+1,\'#\');
    if(!hashPtr2){
      ModelicaError(\"Found start # for value reference but no stop #\");
    }
    cpylen = hashPtr1-msgPtr-1;
    strncat(fmsg,msgPtr,cpylen);
    fmsg[cpylen]=\'\\0\';
    if(hashPtr2!=hashPtr1+1){
      cpylen = hashPtr2 - hashPtr1 -1;
      if(cpylen>15 || cpylen<0){
        ModelicaError(\"Value reference string to large\");
      }
      strncpy(sVref,hashPtr1+1,cpylen);
      sVref[cpylen]=\'\\0\';
      if(sVref[0]==\'r\'){
        vrefPos = (char**) bsearch(&sVref, rVreafArray, nr, sizeof(char*), Modelica_0IK4_0TEKNIKER_DCOL_Generation_ConventionalChillers_FMI_McQuaymystrcmp);
        nameIndex=vrefPos-rVreafArray;
        if(nameIndex < 0){
          ModelicaFormatError(\"Value reference %s does not exist in xml file\",sVref);
        }
        strcat(fmsg,rNamesArray[nameIndex]);
      }else {
        ModelicaFormatError(\"Value reference type %c is illegal or modeldescription.xml does not contain any variable with variable reference %s of that type\",sVref[0],&sVref[1]);
      }
    }else{
      strcat(fmsg,\"#\");
    }
    msgPtr=hashPtr2+1;
    hashPtr1 = strchr(msgPtr,\'#\');
  }
  strcat(fmsg,msgPtr);
  switch (status) {
    case fmiFatal:
      ModelicaError(fmsg);
      break;
    default:
     ModelicaMessage(fmsg);
     break;
  }
  return;
fail:
  ModelicaMessage(\"Logger failed, message too long?\");
}
void * Modelica_0IK4_0TEKNIKER_DCOL_Generation_ConventionalChillers_FMI_McQuay_fmiInstantiateModel2(const char*instanceName, fmiBoolean loggingOn, const char* fmuLocation) {
  static fmiCoSimCallbackFunctions funcs = {&Modelica_0IK4_0TEKNIKER_DCOL_Generation_ConventionalChillers_FMI_McQuayLogger, &calloc, &free, NULL};
  struct dy_Extended* res;

  res = calloc(1, sizeof(struct dy_Extended));
  if (res!=0) {
    if (!(res->hInst=LoadLibraryW(L\"Modelica_0IK4_0TEKNIKER_DCOL_Generation_ConventionalChillers_FMI_McQuay.dll\"))) {
      ModelicaError(\"Loading of FMU dynamic link library (Modelica_0IK4_0TEKNIKER_DCOL_Generation_ConventionalChillers_FMI_McQuay.dll) failed!\");
      return 0;
    }
    if(!(res->dyFmiInstantiateSlave=(fmiInstantiateSlaveFunc)GetProcAddress(res->hInst,\"Modelica_0IK4_0TEKNIKER_DCOL_Generation_ConventionalChillers_FMI_McQuay_fmiInstantiateSlave\"))){
      ModelicaError(\"GetProcAddress failed for fmiInstantiateSlave!\\n The model was imported as a Co-Simulation FMU but could not load the CS specific function fmiInstantiateSlave\\n Verify that the FMU supports Co-Simulation\");
      return 0;
    }
    if(!(res->dyFmiFreeSlaveInstance=(fmiFreeSlaveInstanceFunc)GetProcAddress(res->hInst,\"Modelica_0IK4_0TEKNIKER_DCOL_Generation_ConventionalChillers_FMI_McQuay_fmiFreeSlaveInstance\"))){
      ModelicaError(\"GetProcAddress failed for fmiFreeSlaveInstance!\\n The model was imported as a Co-Simulation FMU but could not load the CS specific function fmiFreeSlaveInstance\\n Verify that the FMU supports Co-Simulation\");
      return 0;
    }
    if(!(res->dyFmiInitializeSlave=(fmiInitializeSlaveFunc)GetProcAddress(res->hInst,\"Modelica_0IK4_0TEKNIKER_DCOL_Generation_ConventionalChillers_FMI_McQuay_fmiInitializeSlave\"))){
      ModelicaError(\"GetProcAddress failed for fmiInitializeSlave!\\n The model was imported as a Co-Simulation FMU but could not load the CS specific function fmiInitializeSlave\\n Verify that the FMU supports Co-Simulation\");
      return 0;
    }
    if(!(res->dyFmiResetSlave=(fmiResetSlaveFunc)GetProcAddress(res->hInst,\"Modelica_0IK4_0TEKNIKER_DCOL_Generation_ConventionalChillers_FMI_McQuay_fmiResetSlave\"))){
      ModelicaError(\"GetProcAddress failed for fmiResetSlave!\\n The model was imported as a Co-Simulation FMU but could not load the CS specific function fmiResetSlave\\n Verify that the FMU supports Co-Simulation\");
      return 0;
    }
    if(!(res->dyFmiDoStep=(fmiDoStepFunc)GetProcAddress(res->hInst,\"Modelica_0IK4_0TEKNIKER_DCOL_Generation_ConventionalChillers_FMI_McQuay_fmiDoStep\"))){
      ModelicaError(\"GetProcAddress failed for fmiDoStep!\\n The model was imported as a Co-Simulation FMU but could not load the CS specific function fmiDoStep\\n Verify that the FMU supports Co-Simulation\");
      return 0;
    }
    if(!(res->dyFmiTerminateSlave=(fmiTerminateSlaveFunc)GetProcAddress(res->hInst,\"Modelica_0IK4_0TEKNIKER_DCOL_Generation_ConventionalChillers_FMI_McQuay_fmiTerminateSlave\"))){
      ModelicaError(\"GetProcAddress failed for fmiTerminateSlave!\\n The model was imported as a Co-Simulation FMU but could not load the CS specific function fmiTerminateSlave\\n Verify that the FMU supports Co-Simulation\");
      return 0;
    }
    if (!(res->dyFmiSetReal=(fmiSetRealFunc)GetProcAddress(res->hInst,\"Modelica_0IK4_0TEKNIKER_DCOL_Generation_ConventionalChillers_FMI_McQuay_fmiSetReal\"))) {
      ModelicaError(\"GetProcAddress failed for fmiSetReal!\");
      return 0;
    }
    if (!(res->dyFmiGetReal=(fmiGetRealFunc)GetProcAddress(res->hInst,\"Modelica_0IK4_0TEKNIKER_DCOL_Generation_ConventionalChillers_FMI_McQuay_fmiGetReal\"))) {
      ModelicaError(\"GetProcAddress failed for fmiGetReal!\");
      return 0;
    }
    if (!(res->dyFmiSetInteger=(fmiSetIntegerFunc)GetProcAddress(res->hInst,\"Modelica_0IK4_0TEKNIKER_DCOL_Generation_ConventionalChillers_FMI_McQuay_fmiSetInteger\"))) {
      ModelicaError(\"GetProcAddress failed for fmiSetInteger!\");
      return 0;
    }
    if (!(res->dyFmiGetInteger=(fmiGetIntegerFunc)GetProcAddress(res->hInst,\"Modelica_0IK4_0TEKNIKER_DCOL_Generation_ConventionalChillers_FMI_McQuay_fmiGetInteger\"))) {
      ModelicaError(\"GetProcAddress failed for fmiGetInteger!\");
      return 0;
    }
    if (!(res->dyFmiSetBoolean=(fmiSetBooleanFunc)GetProcAddress(res->hInst,\"Modelica_0IK4_0TEKNIKER_DCOL_Generation_ConventionalChillers_FMI_McQuay_fmiSetBoolean\"))) {
      ModelicaError(\"GetProcAddress failed for fmiSetBoolean!\");
      return 0;
    }
    if (!(res->dyFmiGetBoolean=(fmiGetBooleanFunc)GetProcAddress(res->hInst,\"Modelica_0IK4_0TEKNIKER_DCOL_Generation_ConventionalChillers_FMI_McQuay_fmiGetBoolean\"))) {
      ModelicaError(\"GetProcAddress failed for fmiGetBoolean!\");
      return 0;
    }
    if (!(res->dyFmiSetString=(fmiSetStringFunc)GetProcAddress(res->hInst,\"Modelica_0IK4_0TEKNIKER_DCOL_Generation_ConventionalChillers_FMI_McQuay_fmiSetString\"))) {
      ModelicaError(\"GetProcAddress failed for fmiSetString!\");
      return 0;
    }
    if (!(res->dyFmiGetString=(fmiGetStringFunc)GetProcAddress(res->hInst,\"Modelica_0IK4_0TEKNIKER_DCOL_Generation_ConventionalChillers_FMI_McQuay_fmiGetString\"))) {
      ModelicaError(\"GetProcAddress failed for fmiGetString!\");
      return 0;
    }
    res->m=res->dyFmiInstantiateSlave(instanceName, \"{e5730ef5-4355-469d-a69a-98508414da43}\", fmuLocation, \"application/x-dymolakernel\", 0, fmiFalse, fmiFalse, funcs, loggingOn);
    if (0==res->m) {free(res);res=0;ModelicaError(\"InstantiateSlave failed\");}
    else {res->dyTriggered=0;res->dyTime=res->dyLastTime=-1e37;}
  }
  return res;
}
#endif",  Library="Modelica_0IK4_0TEKNIKER_DCOL_Generation_ConventionalChillers_FMI_McQuay",
          LibraryDirectory="modelica://DCOL/Resources/Library/FMU/Modelica_0IK4_0TEKNIKER_DCOL_Generation_ConventionalChillers_FMI_McQuay/binaries",
          __Dymola_CriticalRegion="Modelica_0IK4_0TEKNIKER_DCOL_Generation_ConventionalChillers_FMI_McQuay");
    end constructor;

    function destructor "Release storage of FMI model"
      extends Modelica.Icons.Function;
      input fmiModel fmi;
      external"C"
                 Modelica_0IK4_0TEKNIKER_DCOL_Generation_ConventionalChillers_FMI_McQuay_fmiFreeModelInstance2(fmi);
      annotation (Header="
#ifndef Modelica_0IK4_0TEKNIKER_DCOL_Generation_ConventionalChillers_FMI_McQuay_Free_C
#define Modelica_0IK4_0TEKNIKER_DCOL_Generation_ConventionalChillers_FMI_McQuay_Free_C 1
#include <stdlib.h>
#include \"FMI/fmiImport.h\"
void Modelica_0IK4_0TEKNIKER_DCOL_Generation_ConventionalChillers_FMI_McQuay_fmiFreeModelInstance2(void*m) {
  struct dy_Extended*a=m;
  if (a) {
    a->dyFmiTerminateSlave(a->m);
    a->dyFmiFreeSlaveInstance(a->m);
    FreeLibrary(a->hInst);
    free(a);
  }
}
#endif", Library="Modelica_0IK4_0TEKNIKER_DCOL_Generation_ConventionalChillers_FMI_McQuay", LibraryDirectory="modelica://DCOL/Resources/Library/FMU/Modelica_0IK4_0TEKNIKER_DCOL_Generation_ConventionalChillers_FMI_McQuay/binaries",                                                                        __Dymola_CriticalRegion="Modelica_0IK4_0TEKNIKER_DCOL_Generation_ConventionalChillers_FMI_McQuay");
    end destructor;
  end fmiModel;

    function fmiInitializeSlave
      input fmiModel fmi;
      input Real tStart;
      input Boolean forceShutDownAtTStop;
       input Real tStop;
      input Real preAvailable;
      output Real postAvailable=preAvailable;
      external"C" Modelica_0IK4_0TEKNIKER_DCOL_Generation_ConventionalChillers_FMI_McQuay_fmiInitializeSlave2(fmi, tStart, forceShutDownAtTStop, tStop);
      annotation (Header="
#ifndef Modelica_0IK4_0TEKNIKER_DCOL_Generation_ConventionalChillers_FMI_McQuay_InitializeSlave_C
#define Modelica_0IK4_0TEKNIKER_DCOL_Generation_ConventionalChillers_FMI_McQuay_InitializeSlave_C 1
#include <stdlib.h>
#include \"FMI/fmiImport.h\"
double Modelica_0IK4_0TEKNIKER_DCOL_Generation_ConventionalChillers_FMI_McQuay_fmiInitializeSlave2(void*m, fmiReal tStart, fmiBoolean forceShutDownAtTStop, fmiReal tStop) {
  struct dy_Extended*a=m;
  fmiStatus status=fmiFatal;
  if (a) {
    status=a->dyFmiInitializeSlave(a->m, tStart, forceShutDownAtTStop, tStop);
    a->dyTriggered=0;
    a->dyLastTime=a->dyTime;
  }
  if (status!=fmiOK && status!=fmiWarning) ModelicaError(\"InitializeSlave failed\");
  return 1e37;
}
#endif", Library="Modelica_0IK4_0TEKNIKER_DCOL_Generation_ConventionalChillers_FMI_McQuay", LibraryDirectory="modelica://DCOL/Resources/Library/FMU/Modelica_0IK4_0TEKNIKER_DCOL_Generation_ConventionalChillers_FMI_McQuay/binaries",                                                                        __Dymola_CriticalRegion="Modelica_0IK4_0TEKNIKER_DCOL_Generation_ConventionalChillers_FMI_McQuay");
    end fmiInitializeSlave;

   function fmiDoStep
     input fmiModel fmi;
     input Real currentTime;
     input Real stepSize;
     output Boolean stepOK;
     external"C" stepOK= Modelica_0IK4_0TEKNIKER_DCOL_Generation_ConventionalChillers_FMI_McQuay_fmiDoStep2(fmi, currentTime, stepSize);
     annotation (Header="
#ifndef Modelica_0IK4_0TEKNIKER_DCOL_Generation_ConventionalChillers_FMI_McQuay_DoStep_C
#define Modelica_0IK4_0TEKNIKER_DCOL_Generation_ConventionalChillers_FMI_McQuay_DoStep_C 1
#include <stdlib.h>
#include \"FMI/fmiImport.h\"
double Modelica_0IK4_0TEKNIKER_DCOL_Generation_ConventionalChillers_FMI_McQuay_fmiDoStep2(void*m, double currentTime, double stepSize) {
  struct dy_Extended*a=m;
  fmiStatus status=fmiFatal;
  if (a) {
    status=a->dyFmiDoStep(a->m, currentTime, stepSize, fmiTrue);
  }
  if (status!=fmiOK && status!=fmiWarning) ModelicaError(\"DoStep failed\");
  return 1.0;
}
#endif", Library="Modelica_0IK4_0TEKNIKER_DCOL_Generation_ConventionalChillers_FMI_McQuay", LibraryDirectory="modelica://DCOL/Resources/Library/FMU/Modelica_0IK4_0TEKNIKER_DCOL_Generation_ConventionalChillers_FMI_McQuay/binaries",                                                                        __Dymola_CriticalRegion="Modelica_0IK4_0TEKNIKER_DCOL_Generation_ConventionalChillers_FMI_McQuay");
   end fmiDoStep;

    function fmiResetSlave
      input fmiModel fmi;
      output Boolean resetOK;
      external"C" resetOK = Modelica_0IK4_0TEKNIKER_DCOL_Generation_ConventionalChillers_FMI_McQuay_fmiResetSlave2(fmi);
      annotation (Header="
#ifndef Modelica_0IK4_0TEKNIKER_DCOL_Generation_ConventionalChillers_FMI_McQuay_ResetSlave_C
#define Modelica_0IK4_0TEKNIKER_DCOL_Generation_ConventionalChillers_FMI_McQuay_ResetSlave_C 1
#include <stdlib.h>
#include \"FMI/fmiImport.h\"
double Modelica_0IK4_0TEKNIKER_DCOL_Generation_ConventionalChillers_FMI_McQuay_fmiResetSlave2(void*m) {
  struct dy_Extended*a=m;
  fmiStatus status=fmiFatal;
  if (a) {
    status=a->dyFmiResetSlave(a->m);
  }
  if (status!=fmiOK && status!=fmiWarning) ModelicaError(\"resetSlave failed\");
    return 1.0;
  }
#endif", Library="Modelica_0IK4_0TEKNIKER_DCOL_Generation_ConventionalChillers_FMI_McQuay", LibraryDirectory="modelica://DCOL/Resources/Library/FMU/Modelica_0IK4_0TEKNIKER_DCOL_Generation_ConventionalChillers_FMI_McQuay/binaries",                                                                        __Dymola_CriticalRegion="Modelica_0IK4_0TEKNIKER_DCOL_Generation_ConventionalChillers_FMI_McQuay");
    end fmiResetSlave;

    function fmiSetReal
      input fmiModel fmi;
      input Integer refs[:];
      input Real vals[size(refs, 1)];
      output Real dummy= 1;
      external"C"
                 Modelica_0IK4_0TEKNIKER_DCOL_Generation_ConventionalChillers_FMI_McQuay_fmiSetReal2(
        fmi,
        refs,
        size(refs, 1),
        vals);
        annotation (Header="
#ifndef Modelica_0IK4_0TEKNIKER_DCOL_Generation_ConventionalChillers_FMI_McQuay_SetReal_C
#define Modelica_0IK4_0TEKNIKER_DCOL_Generation_ConventionalChillers_FMI_McQuay_SetReal_C 1
#include <stdlib.h>
#include \"FMI/fmiImport.h\"
void Modelica_0IK4_0TEKNIKER_DCOL_Generation_ConventionalChillers_FMI_McQuay_fmiSetReal2(void*m, const int*refs, size_t nrefs, const double*vals) {
  struct dy_Extended*a=m;
  fmiStatus status=fmiFatal;
  if(!nrefs){return;}
  if (a) {
    status=a->dyFmiSetReal(a->m, refs, nrefs, vals);
  }
  if (status!=fmiOK && status!=fmiWarning) ModelicaError(\"SetReal failed\");
}
#endif", Library="Modelica_0IK4_0TEKNIKER_DCOL_Generation_ConventionalChillers_FMI_McQuay", LibraryDirectory="modelica://DCOL/Resources/Library/FMU/Modelica_0IK4_0TEKNIKER_DCOL_Generation_ConventionalChillers_FMI_McQuay/binaries",                                                                        __Dymola_CriticalRegion="Modelica_0IK4_0TEKNIKER_DCOL_Generation_ConventionalChillers_FMI_McQuay",__Dymola_IdemPotent=true, __Dymola_VectorizedExceptFirst=true);
    end fmiSetReal;

    function fmiSetRealParam
      input fmiModel fmi;
      input Integer refs[:];
      input Real vals[size(refs, 1)];
    protected
      Real oldVals[size(refs, 1)];
      external"C"
                 Modelica_0IK4_0TEKNIKER_DCOL_Generation_ConventionalChillers_FMI_McQuay_fmiSetRealParam2(
        fmi,
        refs,
        size(refs, 1),
        vals,
        oldVals);
        annotation (Header="
#ifndef Modelica_0IK4_0TEKNIKER_DCOL_Generation_ConventionalChillers_FMI_McQuay_SetRealParam_C
#define Modelica_0IK4_0TEKNIKER_DCOL_Generation_ConventionalChillers_FMI_McQuay_SetRealParam_C 1
#include <stdlib.h>
#include \"FMI/fmiImport.h\"
void Modelica_0IK4_0TEKNIKER_DCOL_Generation_ConventionalChillers_FMI_McQuay_fmiSetRealParam2(void*m, const int*refs, size_t nrefs, const double*vals, double*oldVals) {
  struct dy_Extended*a=m;
  fmiStatus status=fmiFatal;
  int i = 0;
  if(!nrefs){return;}
  if (a) {
    if(a->currentMode == dyInstantiationMode){
                status=a->dyFmiSetReal(a->m, refs, nrefs, vals);
    }else{
      status=a->dyFmiGetReal(a->m, refs, nrefs, oldVals);
      for(i=0; i<nrefs;++i){
        if( abs(vals[i]-oldVals[i])> 5e-16){
          ModelicaError(\"SetRealParameter: new parameters with diferent values are being set after initialization, this is not allowed\");
        }
      }
    }
  }
  if (status!=fmiOK && status!=fmiWarning) ModelicaError(\"SetReal failed\");
}
#endif", Library="Modelica_0IK4_0TEKNIKER_DCOL_Generation_ConventionalChillers_FMI_McQuay", LibraryDirectory="modelica://DCOL/Resources/Library/FMU/Modelica_0IK4_0TEKNIKER_DCOL_Generation_ConventionalChillers_FMI_McQuay/binaries",                                                                        __Dymola_CriticalRegion="Modelica_0IK4_0TEKNIKER_DCOL_Generation_ConventionalChillers_FMI_McQuay",__Dymola_IdemPotent=true, __Dymola_VectorizedExceptFirst=true);
    end fmiSetRealParam;

    function fmiGetRealScalar
      input fmiModel fmi;
      input Integer ref;
      input Real dummy;
      output Real val;
    algorithm
        val := scalar(fmiGetReal(fmi, {ref}, dummy));
    end fmiGetRealScalar;

    function fmiGetReal
      input fmiModel fmi;
      input Integer refs[:];
      output Real vals[size(refs, 1)];
      input Real preAvailable;
      external"C" Modelica_0IK4_0TEKNIKER_DCOL_Generation_ConventionalChillers_FMI_McQuay_fmiGetReal2(
        fmi,
        refs,
        size(refs, 1),
        vals);
      annotation (Header="
#ifndef Modelica_0IK4_0TEKNIKER_DCOL_Generation_ConventionalChillers_FMI_McQuay_GetReal_C
#define Modelica_0IK4_0TEKNIKER_DCOL_Generation_ConventionalChillers_FMI_McQuay_GetReal_C 1
#include <stdlib.h>
#include \"FMI/fmiImport.h\"
void Modelica_0IK4_0TEKNIKER_DCOL_Generation_ConventionalChillers_FMI_McQuay_fmiGetReal2(void*m, const int*refs, size_t nrefs, double*vals) {
  struct dy_Extended*a=m;
  fmiStatus status=fmiFatal;
  if (a) {
    status=a->dyFmiGetReal(a->m, refs, nrefs, vals);
  }
  if (status!=fmiOK && status!=fmiWarning) ModelicaError(\"GetReal failed\");
}
#endif", Library="Modelica_0IK4_0TEKNIKER_DCOL_Generation_ConventionalChillers_FMI_McQuay", LibraryDirectory="modelica://DCOL/Resources/Library/FMU/Modelica_0IK4_0TEKNIKER_DCOL_Generation_ConventionalChillers_FMI_McQuay/binaries",                                                                        __Dymola_CriticalRegion="Modelica_0IK4_0TEKNIKER_DCOL_Generation_ConventionalChillers_FMI_McQuay");
    end fmiGetReal;

    function fmiGetIntegerScalar
      input fmiModel fmi;
      input Integer ref;
      input Integer dummy;
      output Integer val;
    algorithm
        val := scalar(fmiGetInteger(fmi, {ref}, dummy));
    end fmiGetIntegerScalar;

    function fmiGetInteger
      input fmiModel fmi;
      input Integer refs[:];
      output Integer vals[size(refs, 1)];
      input Integer preAvailable;
      external"C" Modelica_0IK4_0TEKNIKER_DCOL_Generation_ConventionalChillers_FMI_McQuay_fmiGetInteger2(
        fmi,
        refs,
        size(refs, 1),
        vals);
      annotation (Header="
#ifndef Modelica_0IK4_0TEKNIKER_DCOL_Generation_ConventionalChillers_FMI_McQuay_GetInteger_C
#define Modelica_0IK4_0TEKNIKER_DCOL_Generation_ConventionalChillers_FMI_McQuay_GetInteger_C 1
#include <stdlib.h>
#include \"FMI/fmiImport.h\"
void Modelica_0IK4_0TEKNIKER_DCOL_Generation_ConventionalChillers_FMI_McQuay_fmiGetInteger2(void*m, const int*refs, size_t nrefs, int*vals) {
  struct dy_Extended*a=m;
  fmiStatus status=fmiFatal;
  if (a) {
    status=a->dyFmiGetInteger(a->m, refs, nrefs, vals);
  }
  if (status!=fmiOK && status!=fmiWarning) ModelicaError(\"GetInteger failed\");
}
#endif", Library="Modelica_0IK4_0TEKNIKER_DCOL_Generation_ConventionalChillers_FMI_McQuay", LibraryDirectory="modelica://DCOL/Resources/Library/FMU/Modelica_0IK4_0TEKNIKER_DCOL_Generation_ConventionalChillers_FMI_McQuay/binaries",                                                                        __Dymola_CriticalRegion="Modelica_0IK4_0TEKNIKER_DCOL_Generation_ConventionalChillers_FMI_McQuay");
    end fmiGetInteger;

    function fmiSetInteger
    input fmiModel fmi;
      input Integer refs[:];
      input Integer vals[size(refs, 1)];
      output Real dummy= 1;
      external"C" Modelica_0IK4_0TEKNIKER_DCOL_Generation_ConventionalChillers_FMI_McQuay_fmiSetInteger2(
        fmi,
        refs,
        size(refs, 1),
        vals);
        annotation (Header="
#ifndef Modelica_0IK4_0TEKNIKER_DCOL_Generation_ConventionalChillers_FMI_McQuay_SetInteger_C
#define Modelica_0IK4_0TEKNIKER_DCOL_Generation_ConventionalChillers_FMI_McQuay_SetInteger_C 1
#include <stdlib.h>
#include \"FMI/fmiImport.h\"
void Modelica_0IK4_0TEKNIKER_DCOL_Generation_ConventionalChillers_FMI_McQuay_fmiSetInteger2(void*m, const int*refs, size_t nrefs, int*vals) {
  struct dy_Extended*a=m;
  fmiStatus status=fmiFatal;
  if(!nrefs){return;}
  if (a) {
    status=a->dyFmiSetInteger(a->m, refs, nrefs, vals);
  }
  if (status!=fmiOK && status!=fmiWarning) ModelicaError(\"SetInteger failed\");
}
#endif", Library="Modelica_0IK4_0TEKNIKER_DCOL_Generation_ConventionalChillers_FMI_McQuay", LibraryDirectory="modelica://DCOL/Resources/Library/FMU/Modelica_0IK4_0TEKNIKER_DCOL_Generation_ConventionalChillers_FMI_McQuay/binaries",                                                                        __Dymola_CriticalRegion="Modelica_0IK4_0TEKNIKER_DCOL_Generation_ConventionalChillers_FMI_McQuay",__Dymola_IdemPotent=true, __Dymola_VectorizedExceptFirst=true);
    end fmiSetInteger;

    function fmiSetIntegerParam
    input fmiModel fmi;
      input Integer refs[:];
      input Integer vals[size(refs, 1)];
    protected
      Integer oldVals[size(refs, 1)];
      external"C" Modelica_0IK4_0TEKNIKER_DCOL_Generation_ConventionalChillers_FMI_McQuay_fmiSetIntegerParam2(
        fmi,
        refs,
        size(refs, 1),
        vals,
        oldVals);
        annotation (Header="
#ifndef Modelica_0IK4_0TEKNIKER_DCOL_Generation_ConventionalChillers_FMI_McQuay_SetIntegerParam_C
#define Modelica_0IK4_0TEKNIKER_DCOL_Generation_ConventionalChillers_FMI_McQuay_SetIntegerParam_C 1
#include <stdlib.h>
#include \"FMI/fmiImport.h\"
void Modelica_0IK4_0TEKNIKER_DCOL_Generation_ConventionalChillers_FMI_McQuay_fmiSetIntegerParam2(void*m, const int*refs, size_t nrefs, int*vals, int*oldVals) {
  struct dy_Extended*a=m;
  fmiStatus status=fmiFatal;
  int i=0;
  if(!nrefs){return;}
  if (a) {
    if(a->currentMode == dyInstantiationMode){
      status=a->dyFmiSetInteger(a->m, refs, nrefs, vals);
    }else{
      status=a->dyFmiGetInteger(a->m, refs, nrefs, oldVals);
      for(i = 0; i< nrefs; ++i){
        if(vals[i]!=oldVals[i]){
          ModelicaError(\"SetIntegerParameter: new parameters with diferent values are being set after initialization, this is not allowed\");
        }
      }
    }
  }
  if (status!=fmiOK && status!=fmiWarning) ModelicaError(\"SetInteger failed\");
}
#endif", Library="Modelica_0IK4_0TEKNIKER_DCOL_Generation_ConventionalChillers_FMI_McQuay", LibraryDirectory="modelica://DCOL/Resources/Library/FMU/Modelica_0IK4_0TEKNIKER_DCOL_Generation_ConventionalChillers_FMI_McQuay/binaries",                                                                        __Dymola_CriticalRegion="Modelica_0IK4_0TEKNIKER_DCOL_Generation_ConventionalChillers_FMI_McQuay",__Dymola_IdemPotent=true, __Dymola_VectorizedExceptFirst=true);
    end fmiSetIntegerParam;

    function fmiGetBooleanScalar
      input fmiModel fmi;
      input Integer ref;
      input Integer dummy;
      output Boolean val;
    algorithm
        val := scalar(fmiGetBoolean(fmi, {ref}, dummy));
    end fmiGetBooleanScalar;

    function fmiGetBoolean
      input fmiModel fmi;
      input Integer refs[:];
      output Boolean vals[size(refs, 1)];
      input Integer preAvailable;
      external"C" Modelica_0IK4_0TEKNIKER_DCOL_Generation_ConventionalChillers_FMI_McQuay_fmiGetBoolean2(
        fmi,
        refs,
        size(refs, 1),
        vals);
        annotation (Header="
#ifndef Modelica_0IK4_0TEKNIKER_DCOL_Generation_ConventionalChillers_FMI_McQuay_GetBoolean_C
#define Modelica_0IK4_0TEKNIKER_DCOL_Generation_ConventionalChillers_FMI_McQuay_GetBoolean_C 1
#include \"FMI/fmiImport.h\"
void Modelica_0IK4_0TEKNIKER_DCOL_Generation_ConventionalChillers_FMI_McQuay_fmiGetBoolean2(void*m, const int* refs, size_t nr, int* vals) {
  int i;
  struct dy_Extended*a=m;
  fmiStatus status=fmiFatal;
  if (a) {
    status=a->dyFmiGetBoolean(a->m, refs, nr, (fmiBoolean*)(vals));
  }
  if (status!=fmiOK && status!=fmiWarning) ModelicaError(\"GetBoolean failed\");
  for(i=nr-1;i>=0;i--) vals[i]=((fmiBoolean*)(vals))[i];
}
#endif", Library="Modelica_0IK4_0TEKNIKER_DCOL_Generation_ConventionalChillers_FMI_McQuay", LibraryDirectory="modelica://DCOL/Resources/Library/FMU/Modelica_0IK4_0TEKNIKER_DCOL_Generation_ConventionalChillers_FMI_McQuay/binaries",                                                                        __Dymola_CriticalRegion="Modelica_0IK4_0TEKNIKER_DCOL_Generation_ConventionalChillers_FMI_McQuay");
    end fmiGetBoolean;

    function fmiSetBoolean
      input fmiModel fmi;
      input Integer refs[:];
      input Boolean vals[size(refs, 1)];
      output Real dummy2= 1;
    protected
      Boolean dummy[size(refs, 1)];
      external"C" Modelica_0IK4_0TEKNIKER_DCOL_Generation_ConventionalChillers_FMI_McQuay_fmiSetBoolean2(
        fmi,
        refs,
        size(refs, 1),
        vals,
        dummy);
        annotation (Header="
#ifndef Modelica_0IK4_0TEKNIKER_DCOL_Generation_ConventionalChillers_FMI_McQuay_SetBoolean_C
#define Modelica_0IK4_0TEKNIKER_DCOL_Generation_ConventionalChillers_FMI_McQuay_SetBoolean_C 1
#include \"FMI/fmiImport.h\"
void Modelica_0IK4_0TEKNIKER_DCOL_Generation_ConventionalChillers_FMI_McQuay_fmiSetBoolean2(void*m, const int* refs, size_t nr, const int* vals,int*dummy) {
  int i;
  struct dy_Extended*a=m;
  fmiStatus status=fmiFatal;
  if(!nr){return;}
  for(i=0;i<nr;++i) ((fmiBoolean*)(dummy))[i]=vals[i];
  if (a) {
    status=a->dyFmiSetBoolean(a->m, refs, nr, (fmiBoolean*)(dummy));
  }
  if (status!=fmiOK && status!=fmiWarning) ModelicaError(\"SetBoolean failed\");
}
#endif", Library="Modelica_0IK4_0TEKNIKER_DCOL_Generation_ConventionalChillers_FMI_McQuay", LibraryDirectory="modelica://DCOL/Resources/Library/FMU/Modelica_0IK4_0TEKNIKER_DCOL_Generation_ConventionalChillers_FMI_McQuay/binaries",                                                                        __Dymola_CriticalRegion="Modelica_0IK4_0TEKNIKER_DCOL_Generation_ConventionalChillers_FMI_McQuay",__Dymola_IdemPotent=true, __Dymola_VectorizedExceptFirst=true);
    end fmiSetBoolean;

    function fmiSetBooleanParam
      input fmiModel fmi;
      input Integer refs[:];
      input Boolean vals[size(refs, 1)];
    protected
      Boolean dummy[size(refs, 1)];
      Boolean oldVals[size(refs, 1)];
      external"C" Modelica_0IK4_0TEKNIKER_DCOL_Generation_ConventionalChillers_FMI_McQuay_fmiSetBooleanParam2(
      fmi,
        refs,
        size(refs, 1),
        vals,
        dummy,
        oldVals);
        annotation (Header="
#ifndef Modelica_0IK4_0TEKNIKER_DCOL_Generation_ConventionalChillers_FMI_McQuay_SetBooleanParam_C
#define Modelica_0IK4_0TEKNIKER_DCOL_Generation_ConventionalChillers_FMI_McQuay_SetBooleanParam_C 1
#include \"FMI/fmiImport.h\"
void Modelica_0IK4_0TEKNIKER_DCOL_Generation_ConventionalChillers_FMI_McQuay_fmiSetBooleanParam2(void*m, const int* refs, size_t nr, const int* vals,int*dummy,int*oldVals) {
  int i;
  struct dy_Extended*a=m;
  fmiStatus status=fmiFatal;
  if(!nr){return;}
  for(i=0;i<nr;++i) ((fmiBoolean*)(dummy))[i]=vals[i];
  if (a) {
    if(a->currentMode == dyInstantiationMode){
      status=a->dyFmiSetBoolean(a->m, refs, nr, (fmiBoolean*)(dummy));
    }else{
      status=a->dyFmiGetBoolean(a->m, refs, nr, (fmiBoolean*)(oldVals));
      for(i=nr-1;i>=0;i--){
        oldVals[i]=((fmiBoolean*)(oldVals))[i];
        if(oldVals[i]!=dummy[i]){
          ModelicaError(\"SetIntegerParameter: new parameters with diferent values are being set after initialization, this is not allowed\");
        }
      }
    }
  }
  if (status!=fmiOK && status!=fmiWarning) ModelicaError(\"SetBoolean failed\");
}
#endif", Library="Modelica_0IK4_0TEKNIKER_DCOL_Generation_ConventionalChillers_FMI_McQuay", LibraryDirectory="modelica://DCOL/Resources/Library/FMU/Modelica_0IK4_0TEKNIKER_DCOL_Generation_ConventionalChillers_FMI_McQuay/binaries",                                                                        __Dymola_CriticalRegion="Modelica_0IK4_0TEKNIKER_DCOL_Generation_ConventionalChillers_FMI_McQuay",__Dymola_IdemPotent=true, __Dymola_VectorizedExceptFirst=true);
    end fmiSetBooleanParam;

    function fmiGetString
      input fmiModel fmi;
      input Integer refs[:];
      output String vals[size(refs, 1)];
      input Integer preAvailable;
      external"C" Modelica_0IK4_0TEKNIKER_DCOL_Generation_ConventionalChillers_FMI_McQuay_fmiGetString2(
        fmi,
        refs,
        size(refs, 1),
        vals);
      annotation (Header="
#ifndef Modelica_0IK4_0TEKNIKER_DCOL_Generation_ConventionalChillers_FMI_McQuay_GetString_C
#define Modelica_0IK4_0TEKNIKER_DCOL_Generation_ConventionalChillers_FMI_McQuay_GetString_C 1
#include <stdlib.h>
#include \"FMI/fmiImport.h\"
void Modelica_0IK4_0TEKNIKER_DCOL_Generation_ConventionalChillers_FMI_McQuay_fmiGetString2(void*m, const int*refs, size_t nrefs, fmiString* vals) {
  struct dy_Extended*a=m;
  fmiStatus status=fmiFatal;
  if (a) {
    status=a->dyFmiGetString(a->m, refs, nrefs, vals);
  }
  if (status!=fmiOK && status!=fmiWarning) ModelicaError(\"StringInteger failed\");
}
#endif", Library="Modelica_0IK4_0TEKNIKER_DCOL_Generation_ConventionalChillers_FMI_McQuay", LibraryDirectory="modelica://DCOL/Resources/Library/FMU/Modelica_0IK4_0TEKNIKER_DCOL_Generation_ConventionalChillers_FMI_McQuay/binaries",                                                                        __Dymola_CriticalRegion="Modelica_0IK4_0TEKNIKER_DCOL_Generation_ConventionalChillers_FMI_McQuay");
    end fmiGetString;

    function fmiSetString
    input fmiModel fmi;
      input Integer refs[:];
      input String vals[size(refs, 1)];
      external"C" Modelica_0IK4_0TEKNIKER_DCOL_Generation_ConventionalChillers_FMI_McQuay_fmiSetString2(
        fmi,
        refs,
        size(refs, 1),
        vals);
        annotation (Header="
#ifndef Modelica_0IK4_0TEKNIKER_DCOL_Generation_ConventionalChillers_FMI_McQuay_SetString_C
#define Modelica_0IK4_0TEKNIKER_DCOL_Generation_ConventionalChillers_FMI_McQuay_SetString_C 1
#include \"FMI/fmiImport.h\"
#include <stdlib.h>
void Modelica_0IK4_0TEKNIKER_DCOL_Generation_ConventionalChillers_FMI_McQuay_fmiSetString2(void*m, const int*refs, size_t nrefs, const fmiString vals[]) {
  struct dy_Extended*a=m;
  fmiStatus status=fmiFatal;
  if(!nrefs){return;}
  if (a) {
    status=a->dyFmiSetString(a->m, refs, nrefs, vals);
  }
  if (status!=fmiOK && status!=fmiWarning) ModelicaError(\"SetString failed\");
}
#endif", Library="Modelica_0IK4_0TEKNIKER_DCOL_Generation_ConventionalChillers_FMI_McQuay", LibraryDirectory="modelica://DCOL/Resources/Library/FMU/Modelica_0IK4_0TEKNIKER_DCOL_Generation_ConventionalChillers_FMI_McQuay/binaries",                                                                        __Dymola_CriticalRegion="Modelica_0IK4_0TEKNIKER_DCOL_Generation_ConventionalChillers_FMI_McQuay",__Dymola_IdemPotent=true, __Dymola_VectorizedExceptFirst=true);
    end fmiSetString;

    function fmiSetStringParam
    input fmiModel fmi;
      input Integer refs[:];
      input String vals[size(refs, 1)];
      external"C" Modelica_0IK4_0TEKNIKER_DCOL_Generation_ConventionalChillers_FMI_McQuay_fmiSetStringParam2(
        fmi,
        refs,
        size(refs, 1),
        vals);
        annotation (Header="
#ifndef Modelica_0IK4_0TEKNIKER_DCOL_Generation_ConventionalChillers_FMI_McQuay_SetStringParam_C
#define Modelica_0IK4_0TEKNIKER_DCOL_Generation_ConventionalChillers_FMI_McQuay_SetStringParam_C 1
#include \"FMI/fmiImport.h\"
#include <stdlib.h>
void Modelica_0IK4_0TEKNIKER_DCOL_Generation_ConventionalChillers_FMI_McQuay_fmiSetStringParam2(void*m, const int*refs, size_t nrefs, const fmiString vals[]) {
  struct dy_Extended*a=m;
  fmiStatus status=fmiFatal;
  if(!nrefs){return;}
  if (a) {
    if(a->currentMode == dyInstantiationMode){
                status=a->dyFmiSetString(a->m, refs, nrefs, vals);
    }else{
      status=fmiOK;
    }
  }
  if (status!=fmiOK && status!=fmiWarning) ModelicaError(\"SetString failed\");
}
#endif", Library="Modelica_0IK4_0TEKNIKER_DCOL_Generation_ConventionalChillers_FMI_McQuay", LibraryDirectory="modelica://DCOL/Resources/Library/FMU/Modelica_0IK4_0TEKNIKER_DCOL_Generation_ConventionalChillers_FMI_McQuay/binaries",                                                                        __Dymola_CriticalRegion="Modelica_0IK4_0TEKNIKER_DCOL_Generation_ConventionalChillers_FMI_McQuay",__Dymola_IdemPotent=true, __Dymola_VectorizedExceptFirst=true);
    end fmiSetStringParam;

    function noHysteresis
      input Real x;
      output Real y;
    algorithm
      y:=x+(if (x < 0) then -1 else 1);
    end noHysteresis;
end fmi_Functions;
equation
  when initial() then
    fmi = fmi_Functions.fmiModel(fmi_instanceName, fmi_loggingOn, fmi_fmuLocation);
  end when;
algorithm
  when {initial(), sample(fmi_StartTime, fmi_CommunicationStepSize)} then
    if time>=fmi_CommunicationStepSize +fmi_StartTime then
  fmi_Functions.fmiSetReal(fmi, {352321536}, {pre(Tin_con)});
  fmi_Functions.fmiSetReal(fmi, {352321537}, {pre(m_flow_con)});
  fmi_Functions.fmiSetReal(fmi, {352321538}, {pre(pout_con)});
  fmi_Functions.fmiSetReal(fmi, {352321539}, {pre(Tin_eva)});
  fmi_Functions.fmiSetReal(fmi, {352321540}, {pre(m_flow_eva)});
  fmi_Functions.fmiSetReal(fmi, {352321541}, {pre(pout_eva)});
  fmi_Functions.fmiSetReal(fmi, {352321542}, {pre(P_com)});
      for stepSizeIndex in 1:stepSizeScaleFactor loop
        fmi_StepOK :=fmi_Functions.fmiDoStep(
          fmi,
          time + (stepSizeIndex - 1 - stepSizeScaleFactor)*fmi_CommunicationStepSize/stepSizeScaleFactor,
          fmi_CommunicationStepSize/stepSizeScaleFactor);
      end for;
    end if;
  Tout_con :=fmi_Functions.fmiGetRealScalar(
      fmi,
      335544320,
      1);
  Tout_eva :=fmi_Functions.fmiGetRealScalar(
      fmi,
      335544321,
      1);
  pin_con :=fmi_Functions.fmiGetRealScalar(
      fmi,
      335544322,
      1);
  pin_eva :=fmi_Functions.fmiGetRealScalar(
      fmi,
      335544323,
      1);
RealVariables :=fmi_Functions.fmiGetReal(
      fmi,
      {369100204,905969688,905969688},
      1);
  end when;
initial algorithm
  fmi_AParamsAndStart:=1;
 // 2 Real parameters
  fmi_Functions.fmiSetRealParam(fmi, {16777221, 16777222}, {C_con, C_eva});
 // 0 Real start values
 // 0 Integer parameters
 // 0 Integer start values
 // 0 Boolean parameters
 // 0 Boolean start values
 // 0 Enumeration parameters
 // 0 Enumeration start values
 // 0 String parameters
initial equation
if fmi_pullInputsForInitialization then fmi_initInput0 = fmi_Functions.fmiSetReal(fmi, {352321536}, {pre(Tin_con)}); else fmi_initInput0 = fmi_Functions.fmiSetReal(fmi, {352321536}, {_Tin_con_start}); end if;
if fmi_pullInputsForInitialization then fmi_initInput1 = fmi_Functions.fmiSetReal(fmi, {352321537}, {pre(m_flow_con)}); else fmi_initInput1 = fmi_Functions.fmiSetReal(fmi, {352321537}, {_m_flow_con_start}); end if;
if fmi_pullInputsForInitialization then fmi_initInput2 = fmi_Functions.fmiSetReal(fmi, {352321538}, {pre(pout_con)}); else fmi_initInput2 = fmi_Functions.fmiSetReal(fmi, {352321538}, {_pout_con_start}); end if;
if fmi_pullInputsForInitialization then fmi_initInput3 = fmi_Functions.fmiSetReal(fmi, {352321539}, {pre(Tin_eva)}); else fmi_initInput3 = fmi_Functions.fmiSetReal(fmi, {352321539}, {_Tin_eva_start}); end if;
if fmi_pullInputsForInitialization then fmi_initInput4 = fmi_Functions.fmiSetReal(fmi, {352321540}, {pre(m_flow_eva)}); else fmi_initInput4 = fmi_Functions.fmiSetReal(fmi, {352321540}, {_m_flow_eva_start}); end if;
if fmi_pullInputsForInitialization then fmi_initInput5 = fmi_Functions.fmiSetReal(fmi, {352321541}, {pre(pout_eva)}); else fmi_initInput5 = fmi_Functions.fmiSetReal(fmi, {352321541}, {_pout_eva_start}); end if;
if fmi_pullInputsForInitialization then fmi_initInput6 = fmi_Functions.fmiSetReal(fmi, {352321542}, {pre(P_com)}); else fmi_initInput6 = fmi_Functions.fmiSetReal(fmi, {352321542}, {_P_com_start}); end if;
  fmi_Initialized = fmi_Functions.fmiInitializeSlave(fmi, fmi_StartTime, fmi_forceShutDownAtStopTime, fmi_StopTime,fmi_AParamsAndStart+ fmi_initInput0+ fmi_initInput1+ fmi_initInput2+ fmi_initInput3+ fmi_initInput4+ fmi_initInput5+ fmi_initInput6);
equation
  pin_con_der = RealVariables[1];
  pressure_eva.port.p = RealVariables[2];
  pressure_eva.p = RealVariables[3];
  annotation (__Dymola_FMUImportVersion="Dymola 2017", experiment(StartTime=0.0, StopTime=3600.0, Tolerance=0.0001),
    Icon(graphics={
      Rectangle(
        extent={{-100,100},{100,-100}},
        lineColor={95,95,95},
        fillColor={255,255,255},
        fillPattern=FillPattern.Solid,
        lineThickness=0.5),
      Text(
        extent={{-70,20},{70,-20}},
        lineColor={0,0,255},
        textString="%name"),
      Text(
        extent={{-70,-72},{70,-94}},
        lineColor={95,95,95},
        textString="FMI 1.0 CS Import")}),
Documentation(info="<html>
<h4>ModelDescription Attributes</h4>
<ul>
<li>fmiVersion = 1.0</li>
<li>modelName = Modelica_IK4_TEKNIKER.DCOL.Generation.ConventionalChillers.FMI.McQuay</li>
<li>generationTool = Dymola Version 2017 (64-bit), 2016-04-12</li>
<li>generationDateAndTime = 2017-03-23T10:49:10Z</li>
</ul>
<p><br><b>Co-Simulation Attributes</b></p>
<ul>
<li>canHandleVariableCommunicationStepSize = true</li>
<li>canHandleEvents = true</li>
<li>canRejectSteps = false</li>
<li>canInterpolateInputs = true</li>
<li>maxOutputDerivativeOrder = 1</li>
<li>canRunAsynchronuously = false</li>
<li>canSignalEvents = false</li>
<li>canBeInstantiatedOnlyOncePerProcess = false</li>
<li>canNotUseMemoryManagementFunctions = false</li>
</ul>
</html>"));
end McQuay_fmu;
