within DCOL.Generation.ConventionalChillers.Interfaces;
partial model PartialRefrigerantCircuit "Refrigerant circuit interface"
  extends Icons.RefrigerantCircuit;

  replaceable package Medium =
    Modelica.Media.R134a.R134a_ph
    constrainedby Modelica.Media.Interfaces.PartialTwoPhaseMedium "Refrigerant"
    annotation(choicesAllMatching=true);

  parameter Integer n=3 "Number of nodes (evaporator and condenser)";

  Modelica.Fluid.Interfaces.HeatPorts_a[n] heatPorts_a "Evaporator heat port"
    annotation (Placement(
      transformation(extent={{-10,-110},{10,-90}}),
      iconTransformation(extent={{-40,-108},{40,-88}})));
  Modelica.Fluid.Interfaces.HeatPorts_b[n] heatPorts_b "Condenser heat port"
    annotation (Placement(
      transformation(extent={{-10,90},{10,110}}),
      iconTransformation(extent={{-40,88},{40,108}})));
  Modelica.Blocks.Interfaces.RealInput control_in
                    "Compressor electrical power"
    annotation (Placement(transformation(
      extent={{-20,-20},{20,20}},
      rotation=180,
      origin={120,0}),   iconTransformation(
      extent={{-20,-20},{20,20}},
      rotation=180,
      origin={140,0})));
  annotation (Icon(coordinateSystem(preserveAspectRatio=false, extent={{-100,-100},{100,100}}),
        graphics={
        Text(
          extent={{-150,20},{150,-20}},
          textString="%name",
          lineColor={0,0,255},
          origin={0,121},
          rotation=360)}),                    Diagram(coordinateSystem(
          preserveAspectRatio=false, extent={{-100,-100},{100,100}})),
    Documentation(revisions="<html>
<p><span style=\"font-family: MS Shell Dlg 2;\">2016-05-16 <a href=\"mailto: jesus.febres@tekniker.es\">Jes&uacute;s Febres</a> (IK4-TEKNIKER): First implementation</span></p>
<p><span style=\"font-family: MS Shell Dlg 2;\"></p><p><b>Copyright &copy; IK4-TEKNIKER</span></b></p>
<p><span style=\"font-family: MS Shell Dlg 2;\"><img src=\"modelica://ModelicaTEK/Resources/Images/IK4-TEKNIKER_logo.jpg\"/></span></p>
</html>"));
end PartialRefrigerantCircuit;
