within DCOL.Generation.CoolingTowers.CalibrationComponents.BaseClasses;
model CalibrationComponentEquation

  Modelica.Blocks.Interfaces.RealInput NTU1 "Number of Transfer Units of the tower for the first operation point" annotation (Placement(transformation(extent={{-140,70},{-100,110}}),
        iconTransformation(extent={{-120,80},{-100,100}})));

  Modelica.Blocks.Interfaces.RealInput NTU2 "Number of Transfer Units of the tower for the second operation point" annotation (Placement(transformation(extent={{-140,-120},{-100,-80}}),
        iconTransformation(extent={{-120,-100},{-100,-80}})));

  Modelica.Blocks.Interfaces.RealOutput c annotation (Placement(transformation(extent={{100,20},{120,40}})));

  Modelica.Blocks.Interfaces.RealOutput n annotation (Placement(transformation(extent={{100,-40},{120,-20}})));

  Modelica.Blocks.Interfaces.RealInput mAir1 "Number of Transfer Units of the tower for the first operation point" annotation (Placement(transformation(extent={{-140,40},{-100,80}}),
        iconTransformation(extent={{-120,50},{-100,70}})));

  Modelica.Blocks.Interfaces.RealInput mWater1 "Number of Transfer Units of the tower for the first operation point" annotation (Placement(transformation(extent={{-140,0},{-100,40}}),
        iconTransformation(extent={{-120,20},{-100,40}})));

  Modelica.Blocks.Interfaces.RealInput mAir2 "Number of Transfer Units of the tower for the first operation point" annotation (Placement(transformation(extent={{-140,
            -80},{-100,-40}}),
        iconTransformation(extent={{-120,-70},{-100,-50}})));

  Modelica.Blocks.Interfaces.RealInput mWater2 "Number of Transfer Units of the tower for the first operation point" annotation (Placement(transformation(extent={{-140,
            -40},{-100,0}}),
        iconTransformation(extent={{-120,-40},{-100,-20}})));

equation
  NTU1=c*((mAir1/mWater1)^(-(1+n)));
  NTU2=c*((mAir2/mWater2)^(-(1+n)));
  annotation (Documentation(info="<html>
<p><span style=\"font-family: MS Shell Dlg 2;\">This component is used to obtain the values of the charactristic parameters of the cooling tower &QUOT;n&QUOT; and &QUOT;c&QUOT;. </span></p>
<p><br><b><span style=\"font-family: MS Shell Dlg 2;\">Copyright &copy; IK4-TEKNIKER</span></b></p>
</html>", revisions="<html>
<p>2016-05-16 <a href=\"mailto: eduardo.ubieta@tekniker.es\">Eduardo Ubieta</a> (IK4-TEKNIKER): First implementation</p>
<p><b>Copyright &copy; <a href=\"http://www.tekniker.es/en\">IK4-TEKNIKER</a></b></p>
</html>"), Diagram(coordinateSystem(preserveAspectRatio=false, extent={{-100,-100},
            {100,100}})),
    Icon(coordinateSystem(preserveAspectRatio=false, extent={{-100,-100},
            {100,100}})));
end CalibrationComponentEquation;
