within DCOL.Generation.CoolingTowers.FMI.Pruebas;
model CompleteCCT_FMI
  import Modelica_IK4_TEKNIKER;
  Modelica_IK4_TEKNIKER.DCOL.Generation.CoolingTowers.FMI.CompleteCCT_FMI
    completeCCT_Dym
    annotation (Placement(transformation(extent={{-20,-38},{60,34}})));
  Modelica.Blocks.Sources.Constant  m_CWater(k=13.440411)
                           annotation (Placement(transformation(extent={{-80,60},
            {-60,80}})));
  Modelica.Blocks.Sources.Constant T_CWater(k=40 + 273.15)
    annotation (Placement(transformation(extent={{-80,25},{-60,45}})));
  Modelica.Blocks.Sources.Constant m_Airin1(k=45.14)
    annotation (Placement(transformation(extent={{-80,-10},{-60,10}})));
  Modelica.Blocks.Sources.Constant inletAir_X(k=0.007713153)
    annotation (Placement(transformation(extent={{-80,-80},{-60,-60}})));
  Modelica.Blocks.Sources.Constant ambient_T(k=15.5234973 + 273.15)
    annotation (Placement(transformation(extent={{-80,-45},{-60,-25}})));
equation
  connect(m_CWater.y, completeCCT_Dym.inletCWater_m_flow) annotation (Line(
        points={{-59,70},{-40,70},{-40,22.12},{-21.6,22.12}},  color={0,0,127}));
  connect(T_CWater.y, completeCCT_Dym.inletCWater_T) annotation (Line(points={{-59,35},
          {-50,35},{-50,10.24},{-21.6,10.24}},          color={0,0,127}));
  connect(m_Airin1.y, completeCCT_Dym.inletAir_m_flow)
    annotation (Line(points={{-59,0},{-44,0},{-44,-2},{-21.6,-2}},
                                                    color={0,0,127}));
  connect(inletAir_X.y, completeCCT_Dym.inletAir_X) annotation (Line(points={{-59,-70},
          {-40,-70},{-40,-25.76},{-21.6,-25.76}},           color={0,0,127}));
  connect(ambient_T.y, completeCCT_Dym.ambient_T) annotation (Line(points={{-59,-35},
          {-50,-35},{-50,-13.88},{-21.6,-13.88}},       color={0,0,127}));
  annotation (Icon(coordinateSystem(preserveAspectRatio=false)), Diagram(
        coordinateSystem(preserveAspectRatio=false)),
    experiment(StopTime=25000, __Dymola_Algorithm="Cvode"),
    Documentation(revisions="<html>
<p>2016-05-16 <a href=\"mailto: eduardo.ubieta@tekniker.es\">Eduardo Ubieta</a></a> (IK4-TEKNIKER): First implementation</p>
<p><b>Copyright &copy; <a href=\"http://www.tekniker.es/en\">IK4-TEKNIKER</a></b></p>
</html>"));
end CompleteCCT_FMI;
