within DCOL.Generation.CoolingTowers.FMI.Pruebas;
model CompleteCCT_inertia_FMI
  import Modelica_IK4_TEKNIKER;
  Modelica_IK4_TEKNIKER.DCOL.Generation.CoolingTowers.FMI.CompleteCCT_inertia_FMI
    completeCCT_Dym
    annotation (Placement(transformation(extent={{-20,-36},{60,36}})));
  Modelica.Blocks.Sources.Constant  m_CWater(k=13.440411)
                           annotation (Placement(transformation(extent={{-80,50},
            {-60,70}})));
  Modelica.Blocks.Sources.Constant T_CWater(k=40 + 273.15)
    annotation (Placement(transformation(extent={{-80,20},{-60,40}})));
  Modelica.Blocks.Sources.Constant m_Airin1(k=45.14)
    annotation (Placement(transformation(extent={{-80,-10},{-60,10}})));
  Modelica.Blocks.Sources.Constant ambient_T(k=26.5 + 273.15)
    annotation (Placement(transformation(extent={{-80,-38},{-60,-18}})));
  Modelica.Blocks.Sources.Constant inletAir_X(k=0.017623194)
    annotation (Placement(transformation(extent={{-80,-70},{-60,-50}})));
equation
  connect(m_CWater.y, completeCCT_Dym.inletCWater_m_flow) annotation (Line(
        points={{-59,60},{-40,60},{-40,24.12},{-21.6,24.12}},  color={0,0,127}));
  connect(T_CWater.y, completeCCT_Dym.inletCWater_T) annotation (Line(points={{-59,30},
          {-50,30},{-50,12.24},{-21.6,12.24}},          color={0,0,127}));
  connect(m_Airin1.y, completeCCT_Dym.inletAir_m_flow)
    annotation (Line(points={{-59,0},{-21.6,0}},    color={0,0,127}));
  connect(ambient_T.y, completeCCT_Dym.ambient_T) annotation (Line(points={{-59,-28},
          {-50,-28},{-50,-11.88},{-21.6,-11.88}},       color={0,0,127}));
  connect(inletAir_X.y, completeCCT_Dym.inletAir_X) annotation (Line(points={{-59,-60},
          {-40,-60},{-40,-23.76},{-21.6,-23.76}},           color={0,0,127}));
  annotation (Icon(coordinateSystem(preserveAspectRatio=false)), Diagram(
        coordinateSystem(preserveAspectRatio=false)),
    experiment(StopTime=25000, __Dymola_Algorithm="Cvode"),
    Documentation(revisions="<html>
<p>2016-05-16 <a href=\"mailto: eduardo.ubieta@tekniker.es\">Eduardo Ubieta</a></a> (IK4-TEKNIKER): First implementation</p>
<p><b>Copyright &copy; <a href=\"http://www.tekniker.es/en\">IK4-TEKNIKER</a></b></p>
</html>"));
end CompleteCCT_inertia_FMI;
