within DCOL.Generation.CoolingTowers.FMI.Pruebas;
model CompleteOCT_inertia_Dym
  import Modelica_IK4_TEKNIKER;
  Modelica_IK4_TEKNIKER.DCOL.Generation.CoolingTowers.FMI.CompleteOCT_inertia_Dym
                                                                          completeOCT_Dym
    annotation (Placement(transformation(extent={{-12,-40},{68,40}})));
  Modelica.Blocks.Sources.Constant  inlet_m_flowW(k=97.259)
    annotation (Placement(transformation(extent={{-90,44},{-70,64}})));
  Modelica.Blocks.Sources.Constant  inlet_TW(k=35 + 273.15)
    annotation (Placement(transformation(extent={{-90,8},{-70,28}})));
  Modelica.Blocks.Sources.Constant  outlet_m_flowA(k=57.3619)
    annotation (Placement(transformation(extent={{-90,80},{-70,100}})));
  Modelica.Blocks.Sources.Constant  ambientT(k=26.5 + 273.15)
    annotation (Placement(transformation(extent={{-90,-28},{-70,-8}})));
  Modelica.Blocks.Sources.Constant inletAir_X(k=0.017623194)
    annotation (Placement(transformation(extent={{-90,-100},{-70,-80}})));
  Modelica.Blocks.Sources.Constant  outlet_m_flowW(
                                                  k=97.259)
    annotation (Placement(transformation(extent={{-90,-64},{-70,-44}})));
  Modelica.Blocks.Sources.TimeTable outlet_m_flowA1(
                                                   table=[0.0,20; 1000,20; 1000,
        60; 2000,60; 2000,100; 3000,100])
    annotation (Placement(transformation(extent={{-140,80},{-120,100}})));
  Modelica.Blocks.Sources.TimeTable inlet_m_flowW1(
                                                  table=[0.0,60; 1000,60; 1000,
        80; 2000,80; 2000,100; 3000,100])
    annotation (Placement(transformation(extent={{-140,44},{-120,64}})));
  Modelica.Blocks.Sources.TimeTable inlet_TW1(table=[0.0,30 + 273.15; 1000,30
         + 273.15; 1000,35 + 273.15; 2000,35 + 273.15; 2000,45 + 273.15; 3000,
        45 + 273.15])
    annotation (Placement(transformation(extent={{-140,8},{-120,28}})));
  Modelica.Blocks.Sources.TimeTable ambient_T1(table=[0.0,5 + 273.15; 1000,5 +
        273.15; 1000,15 + 273.15; 2000,15 + 273.15; 2000,25 + 273.15; 3000,25
         + 273.15])
    annotation (Placement(transformation(extent={{-140,-28},{-120,-8}})));
  Modelica.Blocks.Sources.TimeTable inletAir_X1(table=[0.0,0.012; 1000,0.012;
        1000,0.017623194; 2000,0.017623194; 2000,0.02; 3000,0.02])
    annotation (Placement(transformation(extent={{-140,-100},{-120,-80}})));
  Modelica.Blocks.Sources.TimeTable outlet_m_flowW1(table=[0.0,60; 1000,60;
        1000,80; 2000,80; 2000,100; 3000,100])
    annotation (Placement(transformation(extent={{-140,-64},{-120,-44}})));
equation
  connect(outlet_m_flowA.y, completeOCT_Dym.outletAir_m_flow) annotation (Line(
        points={{-69,90},{-40,90},{-40,36},{-20,36}}, color={0,0,127}));
  connect(inlet_m_flowW.y, completeOCT_Dym.inletWater_m_flow) annotation (Line(
        points={{-69,54},{-50,54},{-50,22},{-36,22},{-36,22},{-20,22}}, color={
          0,0,127}));
  connect(inlet_TW.y, completeOCT_Dym.inletWater_T) annotation (Line(points={{
          -69,18},{-60,18},{-60,8},{-20,8}}, color={0,0,127}));
  connect(ambientT.y, completeOCT_Dym.ambient_T) annotation (Line(points={{-69,
          -18},{-60,-18},{-60,-8},{-20,-8}}, color={0,0,127}));
  connect(outlet_m_flowW.y, completeOCT_Dym.outletWater_m_flow) annotation (
      Line(points={{-69,-54},{-50,-54},{-50,-22},{-20,-22}}, color={0,0,127}));
  connect(inletAir_X.y, completeOCT_Dym.inletAir_X) annotation (Line(points={{
          -69,-90},{-54,-90},{-40,-90},{-40,-36},{-20,-36}}, color={0,0,127}));
  annotation (Icon(coordinateSystem(preserveAspectRatio=false)), Diagram(
        coordinateSystem(preserveAspectRatio=false)),
    experiment(StopTime=3000, __Dymola_Algorithm="Cvode"),
    Documentation(revisions="<html>
<p>2016-05-16 <a href=\"mailto: eduardo.ubieta@tekniker.es\">Eduardo Ubieta</a></a> (IK4-TEKNIKER): First implementation</p>
<p><b>Copyright &copy; <a href=\"http://www.tekniker.es/en\">IK4-TEKNIKER</a></b></p>
</html>"));
end CompleteOCT_inertia_Dym;
