within DCOL.Generation.CoolingTowers.Interfaces;
partial model PartialLevelControl
  import DCOL;
  extends DCOL.Generation.CoolingTowers.Icons.LevelControl;

  parameter Modelica.SIunits.Height hmax=0.1651 "Maximum height of water that can the basin have" annotation(Dialog(group="Water basin data"));
  parameter Modelica.SIunits.Height hmin=0.092075 "Minimum height of water that can the basin have" annotation(Dialog(group="Water basin data"));

  parameter Modelica.SIunits.MassFlowRate m_In=2 "Inlet overflow" annotation(Dialog(group="Overflow data"));
  parameter Modelica.SIunits.MassFlowRate m_Out=1e-3 "Outlet overflow" annotation(Dialog(group="Overflow data"));

  Modelica.Blocks.Interfaces.RealInput  level(unit="m") annotation (Placement(transformation(extent={{-140,
            -20},{-100,20}}), iconTransformation(extent={{-140,-20},{-100,20}})));
  Modelica.Blocks.Interfaces.RealOutput  m_outflow(start=1e-2, unit="kg/s") annotation (Placement(transformation(extent={{100,-10},{120,10}})));

equation

  annotation (Icon(coordinateSystem(preserveAspectRatio=false)), Diagram(
        coordinateSystem(preserveAspectRatio=false)),
    Documentation(info="<html>
<p>This partial model is an interface with a RealInput port and a RealOutput port. Is used for the modeling of the LevelControl model.</p>
</html>"));
end PartialLevelControl;
