within DCOL.Generation.CoolingTowers.Testing.CompleteCoolingTowers;
model CompleteClosedCoolingTower_controlled
  import DCOL;
  Real t;

  DCOL.Generation.CoolingTowers.ClosedCoolingTower_inertia
    completeClosedCoolingTower(
    redeclare package Material = Modelica_IK4_TEKNIKER.Thermal.Materials.AISI321,
    redeclare package Material1 = Modelica_IK4_TEKNIKER.Thermal.Materials.AISI321,
    TWater2_start=20 + 273.15,
    d_a=0.02705,
    d_b=0.027,
    nSeg=2,
    nCoil=2,
    nParallel=2,
    C_iner=100000)
    annotation (Placement(transformation(extent={{-50,-40},{30,40}})));

  Modelica.Fluid.Sources.MassFlowSource_T airIn(
    redeclare package Medium = Modelica.Media.Air.MoistAir,
    use_T_in=true,
    m_flow=48,
    use_m_flow_in=true,
    nPorts=1,
    T=298.15,
    X={0.007,(1 - 0.007)}) annotation (Placement(transformation(extent={{64,-46},
            {44,-26}})));

  Modelica.Fluid.Sources.FixedBoundary airOut(
    redeclare package Medium = Modelica.Media.Air.MoistAir,
    p=101325,
    nPorts=1) annotation (Placement(transformation(extent={{80,60},{60,80}})));

  inner Modelica.Fluid.System system annotation (Placement(transformation(extent={{-80,60},
            {-60,80}})));

  Modelica.Fluid.Sources.MassFlowSource_T cWaterIn(
    redeclare package Medium =
        Modelica.Media.Water.ConstantPropertyLiquidWater,
    m_flow=13.440411,
    use_m_flow_in=true,
    use_T_in=true,
    T=313.15,
    nPorts=1) annotation (Placement(transformation(
        extent={{10,-10},{-10,10}},
        rotation=0,
        origin={76,20})));

  Modelica.Fluid.Sources.FixedBoundary cWaterOut(
    redeclare package Medium =
        Modelica.Media.Water.ConstantPropertyLiquidWater,
    p=101325,
    nPorts=1) annotation (Placement(transformation(extent={{10,-10},{-10,10}},
        rotation=0,
        origin={70,-12})));

  Modelica.Blocks.Sources.Constant const2(
    k=13.4404) annotation (Placement(transformation(extent={{116,18},{96,38}})));

  Modelica.Blocks.Sources.Constant const4(
    k=37 + 273.15) annotation (Placement(transformation(extent={{116,-12},{96,8}})));

  Modelica.Fluid.Sensors.Temperature temperature1(
    redeclare package Medium = Modelica.Media.Air.MoistAir) annotation (Placement(transformation(extent={{30,74},{50,94}})));

  Modelica.Fluid.Sensors.Temperature temperature2(
    redeclare package Medium =
        Modelica.Media.Water.ConstantPropertyLiquidWater)                         annotation (Placement(transformation(extent={{44,-6},
            {64,14}})));

  Modelica.Thermal.HeatTransfer.Sources.FixedTemperature T_floor(
    T=288.15) annotation (Placement(transformation(extent={{-50,-74},{-30,-54}})));

  Modelica.Thermal.HeatTransfer.Sources.PrescribedTemperature T_ambient annotation (Placement(transformation(extent={{-80,18},
            {-60,38}})));

  Modelica.Fluid.Sources.MassFlowSource_T
                                       waterOverFlow(
    redeclare package Medium =
        Modelica.Media.Water.ConstantPropertyLiquidWater,
    nPorts=1,
    m_flow=2,
    use_m_flow_in=true)
              annotation (Placement(transformation(extent={{-80,-34},{-60,-14}})));

  Modelica.Blocks.Sources.TimeTable T_outletRequired(
    table=[  0.0,32 + 273.15;
            5000,32 + 273.15;
            5000,32 + 273.15;
           10000,32 + 273.15]) annotation (Placement(transformation(extent={{110,-75},
            {100,-65}})));

  Modelica.Blocks.Continuous.LimPID PID(
    controllerType=Modelica.Blocks.Types.SimpleController.PI,
    k=5,
    wp=1,
    Ni=0.1,
    initType=Modelica.Blocks.Types.InitPID.InitialOutput,
    strict=true,
    xi_start=10,
    Ti=0.01,
    yMax=80,
    yMin=0,
    y_start=10) annotation (Placement(transformation(extent={{77,-75},{67,-65}})));

  Modelica.Blocks.Math.Gain gain(k=-1) annotation (Placement(transformation(extent={{93,-75},
            {83,-65}})));

  Modelica.Blocks.Math.Gain gain1(k=-1) annotation (Placement(transformation(extent={{97,-95},
            {87,-85}})));

  Modelica.Blocks.Sources.TimeTable T_ambient1(table=[0.0,15 + 273.15; 5000,15 +
        273.15; 5000,15 + 273.15; 10000,15 + 273.15])
                                annotation (Placement(transformation(extent={{50,-90},
            {30,-70}})));

  Modelica.Blocks.Sources.Constant const(
    k=45) annotation (Placement(transformation(extent={{108,-46},{88,-26}})));

  DCOL.Generation.CoolingTowers.BaseClasses.LevelControl levelControl(
    m_In=1,
    hmax=0.377825,
    hmin=0.092075) annotation (Placement(transformation(
        extent={{-10,-10},{10,10}},
        rotation=90,
        origin={-100,-30})));
  Modelica.Blocks.Sources.TimeTable T_ambient2(table=[0.0,1.88912; 5.14286,
        1.88924; 6,1.88926; 10.2857,1.88935; 12,1.88939; 13.9126,1.88943;
        15.4286,1.88947; 18,1.88952; 20.5714,1.88958; 24,1.88966; 25.7143,
        1.8897; 30,1.8898; 30.8571,1.88982; 36,1.88995; 41.1429,1.89007; 42,
        1.89009; 46.2857,1.89019; 48,1.89024; 51.4286,1.89032; 54,1.89039;
        56.5714,1.89045; 60,1.89054; 61.7143,1.89058; 66,1.89069; 66.8571,
        1.89071; 100,1.8916; 200,1.89458; 300,1.89804; 400,1.90177; 5001,
        1.90574; 600,1.90993; 700,1.91433; 800,1.91892; 900,1.92368; 1000,
        1.92857; 1100,1.93359; 1200,1.93871; 1300,1.94394; 1400,1.94926; 1500,
        1.95466; 1600,1.96012; 1700,1.96566; 1800,1.97125; 1900,1.97689; 2000,
        1.98259; 2100,1.98832; 2200,1.9941; 2300,1.99991; 2400,2.00575; 2500,
        2.01163; 2600,2.01753; 2700,2.02346; 2800,2.02941; 2900,2.03539; 3000,
        2.04138; 3100,2.0474; 3200,2.05343; 3300,2.05947; 3400,2.06553; 3500,
        2.07161; 3600,2.0777; 3700,2.0838; 3800,2.08991; 3900,2.09603; 4000,
        2.10216; 4100,2.1083; 4200,2.11445; 4300,2.1206; 4400,2.12677; 4500,
        2.13294; 4600,2.13911; 4700,2.14529; 4800,2.15148; 4900,2.15768; 5000,
        2.16387; 5100,2.17008; 5200,2.17628; 5300,2.18249; 5400,2.18871; 5500,
        2.19492; 5600,2.20114; 5700,2.20737; 5800,2.21359; 5900,2.21982; 6000,
        2.22605; 6100,2.23229; 6200,2.23853; 6300,2.24476; 6400,2.251; 6500,
        2.25725; 6600,2.26349; 6700,2.26974; 6800,2.27599; 6900,2.28223; 7000,
        2.28849; 7100,2.29474; 7200,2.30099; 7300,2.30725; 7400,2.3135; 7500,
        2.31976; 7600,2.32602; 7700,2.33228; 7800,2.33854; 7900,2.3448; 8000,
        2.35106; 8100,2.35732; 8200,2.36358; 8300,2.36985; 8400,2.37611; 8500,
        2.38238; 8600,2.38864; 8700,2.39491; 8800,2.40117; 8900,2.40744; 9000,
        2.41371; 9100,2.41997; 9200,2.42624; 9300,2.43251; 9400,2.43878; 9500,
        2.44505; 9600,2.45132; 9700,2.45759; 9800,2.46385; 9900,2.47012; 10000,
        2.47639])               annotation (Placement(transformation(extent={{-132,
            -80},{-112,-60}})));
  Modelica.Blocks.Discrete.Sampler sampler(samplePeriod=10)
    annotation (Placement(transformation(extent={{-60,-58},{-80,-38}})));
equation
  t=time;
  connect(waterOverFlow.ports[1], completeClosedCoolingTower.port_a_Owater)
    annotation (Line(points={{-60,-24},{-46,-24}}, color={0,127,255}));
  connect(airIn.ports[1], completeClosedCoolingTower.port_a_air) annotation (
      Line(points={{44,-36},{40,-36},{40,-13.6},{33.6,-13.6}}, color={0,127,255}));
  connect(airOut.ports[1], completeClosedCoolingTower.port_b_air) annotation (
      Line(points={{60,70},{20,70},{20,42},{10,42},{10,40.8}}, color={0,127,255}));
  connect(temperature1.port, completeClosedCoolingTower.port_b_air) annotation (
     Line(points={{40,74},{40,74},{40,70},{20,70},{20,42},{10,42},{10,40.8}},
        color={0,127,255}));
  connect(cWaterIn.ports[1], completeClosedCoolingTower.port_a_Cwater)
    annotation (Line(points={{66,20},{40,20},{40,16},{30,16}}, color={0,127,255}));
  connect(completeClosedCoolingTower.port_b_Cwater, cWaterOut.ports[1])
    annotation (Line(points={{30,0},{40,0},{40,-12},{60,-12}}, color={0,127,255}));
  connect(temperature2.port, completeClosedCoolingTower.port_b_Cwater)
    annotation (Line(points={{54,-6},{40,-6},{40,0},{30,0}}, color={0,127,255}));
  connect(const2.y, cWaterIn.m_flow_in) annotation (Line(points={{95,28},{86,28}},            color={0,0,127}));
  connect(const4.y, cWaterIn.T_in) annotation (Line(points={{95,-2},{92,-2},{92,
          24},{88,24}},       color={0,0,127}));
  connect(T_outletRequired.y, gain.u) annotation (Line(points={{99.5,-70},{
          96.75,-70},{94,-70}},   color={0,0,127}));
  connect(gain.y, PID.u_s) annotation (Line(points={{82.5,-70},{80.25,-70},{78,
          -70}},     color={0,0,127}));
  connect(gain1.y, PID.u_m) annotation (Line(points={{86.5,-90},{72,-90},{72,
          -76}},                                                                     color={0,0,127}));
  connect(temperature2.T, gain1.u) annotation (Line(points={{61,4},{61,4},{84,4},
          {84,-52},{114,-52},{114,-90},{98,-90}},      color={0,0,127}));
  connect(T_floor.port, completeClosedCoolingTower.port_a_floor) annotation (
      Line(points={{-30,-64},{-30,-64},{-10,-64},{-10,-40}}, color={191,0,0}));
  connect(T_ambient1.y, airIn.T_in) annotation (Line(points={{29,-80},{4,-80},{
          4,-60},{72,-60},{72,-32},{66,-32}},   color={0,0,127}));
  connect(T_ambient1.y, T_ambient.T) annotation (Line(points={{29,-80},{-90,-80},
          {-90,28},{-82,28}},       color={0,0,127}));
  connect(T_ambient.port, completeClosedCoolingTower.port_a_ambient)
    annotation (Line(points={{-60,28},{-48,28}}, color={191,0,0}));
  connect(const.y, airIn.m_flow_in) annotation (Line(points={{87,-36},{76,-36},
          {76,-28},{64,-28}}, color={0,0,127}));
  connect(levelControl.m_outflow, waterOverFlow.m_flow_in) annotation (Line(
        points={{-100,-19},{-100,-16},{-80,-16}}, color={0,0,127}));
  connect(sampler.y, levelControl.level) annotation (Line(points={{-81,-48},{
          -100,-48},{-100,-42}}, color={0,0,127}));
  connect(sampler.u, completeClosedCoolingTower.level) annotation (Line(points=
          {{-58,-48},{-58,-48},{34,-48},{34,-24}}, color={0,0,127}));
  annotation (Diagram(coordinateSystem(preserveAspectRatio=false, extent={{-120,
            -100},{140,100}})), Icon(coordinateSystem(extent={{-120,-100},{
            140,100}})),
    Documentation(revisions="<html>
<p>2016-05-16 <a href=\"mailto: eduardo.ubieta@tekniker.es\">Eduardo Ubieta</a></a> (IK4-TEKNIKER): First implementation</p>
<p><b>Copyright &copy; <a href=\"http://www.tekniker.es/en\">IK4-TEKNIKER</a></b></p>
</html>"));
end CompleteClosedCoolingTower_controlled;
