within DCOL.Generation.CoolingTowers.Utilities.Functions;
function AbsHumidity

  import Modelica.Media.IdealGases.Common.Functions;
  constant Integer Water=1
    "Index of water (in substanceNames, massFractions X, etc.)";
  constant Integer Air=2
    "Index of air (in substanceNames, massFractions X, etc.)";
  //     constant SI.Pressure psat_low=saturationPressureWithoutLimits(200.0);
  //     constant SI.Pressure psat_high=saturationPressureWithoutLimits(422.16);
  constant Real k_mair=0.018/0.029 "Ratio of molar weights";

  input Modelica.SIunits.Temperature T "Air temperature";
  input Modelica.SIunits.Pressure p "Air pressure";
  input Real phi "Relative humidity";
 output Modelica.SIunits.MassFraction X_water;

protected
  Modelica.SIunits.MassFraction X_air "Mass fraction of air";
 Modelica.SIunits.AbsolutePressure p_steam_sat "partial saturation pressure of steam";

algorithm
  p_steam_sat :=min(Modelica.Media.Air.MoistAir.saturationPressure(T), 0.999*p);
  X_water:=(k_mair*phi*p_steam_sat/p)/(1+(k_mair-1)*phi*p_steam_sat/p);
  X_air:=1-X_water;

end AbsHumidity;
