within DCOL.Generation.SolarThermal.BaseClasses;
model ConvectionCharacteristicLengthBlock

  parameter Modelica.SIunits.Length shortSide "Cover short side";
  parameter Modelica.SIunits.Length longSide "Cover long side";

  Modelica.Blocks.Interfaces.RealInput windDirection(unit="rad") annotation (
      Placement(transformation(extent={{-124,-20},{-84,20}}),
        iconTransformation(extent={{-140,-20},{-100,20}})));
  Modelica.Blocks.Interfaces.RealOutput L(unit="m") annotation (Placement(
        transformation(extent={{96,-10},{116,10}}), iconTransformation(extent={
            {100,-10},{120,10}})));
equation
  L = DCOL.Generation.SolarThermal.BaseClasses.ConvectionCharacteristicLength(
    windDirection,
    longSide,
    shortSide);

  annotation (
    Diagram(coordinateSystem(preserveAspectRatio=false, extent={{-100,-100},{
            100,100}}), graphics),
    Icon(coordinateSystem(preserveAspectRatio=false, extent={{-100,-100},{100,
            100}}), graphics={Text(
          extent={{-44,118},{46,108}},
          lineColor={0,0,255},
          fillPattern=FillPattern.HorizontalCylinder,
          fillColor={255,255,255},
          fontSize=40,
          textString="%name"),Rectangle(
          extent={{-100,100},{100,-100}},
          pattern=LinePattern.None,
          lineThickness=0.5)}),
    Documentation(info="<html>
<p>This block just calls <a href=\"Ambassador_WP4.ThermoFluidTek.ThermalSources.SolarThermal.BaseClasses.ConvectionCharacteristicLength\">ConvectionCharacteristicLength</a> function to calculate characteristic Convection length.</p>
</html>"));
end ConvectionCharacteristicLengthBlock;
