within DCOL.Generation.SolarThermal.BaseClasses;
function LeastSquaresGenericResistance
  "Least Squares calculation for determination of coeficients of generic resistance fluid library model"
  input Modelica.SIunits.VolumeFlowRate x[:] annotation (Dialog);
  input Modelica.SIunits.Pressure y[:] annotation (Dialog);
  output Real coeficients[2];

protected
  Real X1[size(x, 1)];
  Real X2[size(x, 1)];
  Real Y1[size(x, 1)];
  Real Y2[size(x, 1)];
  Real K1[size(x, 1)];
  Real K2[size(x, 1)];

algorithm
  X1[1] := x[1]^4;
  X2[1] := x[1]^3;

  Y2[1] := x[1]^2;
  K1[1] := y[1]*x[1]^2;
  K2[1] := y[1]*x[1];

  for i in 1:(size(x, 1) - 1) loop
    X1[i + 1] := X1[i] + x[i + 1]^4;
    X2[i + 1] := X2[i] + x[i + 1]^3;
    Y2[i + 1] := Y2[i] + x[i + 1]^2;
    K1[i + 1] := K1[i] + y[i + 1]*x[i + 1]^2;
    K2[i + 1] := K2[i] + y[i + 1]*x[i + 1];

  end for;

  for i in 1:size(x, 1) loop
    Y1[i] := X2[i];
  end for;

  coeficients[2] := (K1[size(x, 1)]*X2[size(x, 1)] - K2[size(x, 1)]*X1[size(x,
    1)])/(Y1[size(x, 1)]*X2[size(x, 1)] - Y2[size(x, 1)]*X1[size(x, 1)]);
  coeficients[1] := (K1[size(x, 1)]/X1[size(x, 1)]) - (Y1[size(x, 1)]/X1[size(x,
    1)])*coeficients[2];

end LeastSquaresGenericResistance;
