within DCOL.Generation.SolarThermal.BaseClasses;
partial model SolarCollectorBasicInterface
  "Interface for a solar collector model"

  Modelica.Fluid.Interfaces.FluidPort_a inlet(redeclare package Medium = Medium)
    annotation (Placement(transformation(extent={{-126,-90},{-94,-58}},
          rotation=0), iconTransformation(extent={{90,-90},{114,-66}})));
  Modelica.Fluid.Interfaces.FluidPort_b outlet(redeclare package Medium =
        Medium) annotation (Placement(transformation(extent={{78,-92},{106,-62}},
          rotation=0), iconTransformation(extent={{-128,70},{-102,94}})));

  replaceable package Medium = Modelica.Media.Interfaces.PartialMedium
    annotation (__Dymola_choicesAllMatching=true);

  Interfaces.SolarCollectorInput solarCollectorInput annotation (Placement(
        transformation(
        extent={{-17,-18},{17,18}},
        rotation=0,
        origin={-2,133}), iconTransformation(
        extent={{-24.5,-23},{24.5,23}},
        rotation=90,
        origin={-98.5,-9})));
  annotation (
    Diagram(coordinateSystem(preserveAspectRatio=false, extent={{-140,-120},{
            140,140}}), graphics),
    Icon(coordinateSystem(preserveAspectRatio=false,extent={{-140,-120},{140,
            140}}), graphics={
        Rectangle(
          extent={{-100,102},{100,-124}},
          lineThickness=1,
          pattern=LinePattern.None,
          lineColor={0,0,0},
          fillColor={170,213,255},
          fillPattern=FillPattern.Solid),
        Polygon(
          points={{-98,72},{-76,96},{88,-58},{66,-80},{-98,72}},
          lineColor={0,0,255},
          pattern=LinePattern.None,
          fillColor={95,95,95},
          fillPattern=FillPattern.Solid),
        Rectangle(
          extent={{-96,70},{-92,-76}},
          lineColor={0,0,255},
          pattern=LinePattern.None,
          fillColor={215,215,215},
          fillPattern=FillPattern.VerticalCylinder),
        Rectangle(
          extent={{-94,-76},{66,-80}},
          lineColor={0,0,255},
          pattern=LinePattern.None,
          fillColor={215,215,215},
          fillPattern=FillPattern.HorizontalCylinder),
        Ellipse(
          extent={{66,106},{106,64}},
          lineColor={0,0,255},
          pattern=LinePattern.None,
          fillColor={255,170,85},
          fillPattern=FillPattern.Solid),
        Line(
          points={{42,42},{68,68}},
          color={255,170,85},
          thickness=0.5),
        Line(
          points={{76,28},{82,60}},
          color={255,170,85},
          thickness=0.5),
        Line(
          points={{24,76},{64,86}},
          color={255,170,85},
          thickness=0.5),
        Line(
          points={{98,32},{98,64}},
          color={255,170,85},
          thickness=0.5),
        Line(
          points={{24,98},{62,98}},
          color={255,170,85},
          thickness=0.5),
        Rectangle(
          extent={{-3,16},{3,-16}},
          lineColor={0,0,0},
          lineThickness=1,
          fillPattern=FillPattern.VerticalCylinder,
          fillColor={255,0,0},
          origin={-104,81},
          rotation=90),
        Rectangle(
          extent={{70,-76},{98,-80}},
          lineColor={0,0,0},
          lineThickness=1,
          fillPattern=FillPattern.HorizontalCylinder,
          fillColor={0,0,255}),
        Rectangle(
          extent={{-6,2},{6,-2}},
          lineColor={0,0,0},
          lineThickness=1,
          fillPattern=FillPattern.HorizontalCylinder,
          fillColor={0,0,255},
          origin={72,-74},
          rotation=90),
        Polygon(
          points={{-86,82},{-76,94},{86,-58},{76,-68},{-86,82}},
          lineColor={0,0,0},
          pattern=LinePattern.None,
          fillColor={255,255,255},
          fillPattern=FillPattern.Solid),
        Text(
          extent={{-48,112},{42,102}},
          lineColor={0,0,255},
          fillPattern=FillPattern.HorizontalCylinder,
          fillColor={255,255,255},
          fontSize=40,
          textString="%name
")}),
    Commands(executeCall=simulateModel(
          "Modelos_propios.colector_sin_aislamiento_MARVEL_h_rever_PROBE",
          stopTime=20000,
          method="dassl",
          resultFile="colector_sin_aislamiento_MARVEL_h_rever_PROBE")),
    DymolaStoredErrors,
    Documentation(info="<html>
<p>Base class for Solar Collector models development. Includes:</p>
<p><ul>
<li>Expandable connector for necessary inputs routing</li>
<li>Input and output fluid ports</li>
<li>Replaceable medium definition</li>
</ul></p>
</html>"));

end SolarCollectorBasicInterface;
