within DCOL.Generation.SolarThermal.BaseClasses;
function WindDirectionQuadrantCorrection

  Modelica.Blocks.Interfaces.RealInput windDirection(unit="rad");

  Modelica.Blocks.Interfaces.RealOutput windDirectionFirstQuadrant(unit="rad");

algorithm
  if windDirection < (Modelica.Constants.pi/2) and windDirection >= 0 then
    windDirectionFirstQuadrant := windDirection;
  elseif windDirection < Modelica.Constants.pi then
    windDirectionFirstQuadrant := Modelica.Constants.pi - windDirection;
  elseif windDirection < (3*Modelica.Constants.pi/2) then
    windDirectionFirstQuadrant := windDirection - Modelica.Constants.pi;
  else
    windDirectionFirstQuadrant := (2*Modelica.Constants.pi) - windDirection;
  end if;

  annotation (Documentation(info="<html>
<p>This function includes a simple calculation to transform a general wind direction (0-2pi rad) to an angle between 0-pi/2 rad, in order to represent the net angle between the wind direction and a planar surface.</p>
</html>"));
end WindDirectionQuadrantCorrection;
