within DCOL.Generation.SolarThermal.BaseClasses;
model WindDirectionQuadrantCorrectionBlock

  Modelica.Blocks.Interfaces.RealInput windDirection(unit="rad") annotation (
      Placement(transformation(extent={{-136,-10},{-96,30}}),
        iconTransformation(extent={{-138,-18},{-100,20}})));
  Modelica.Blocks.Interfaces.RealOutput windDirectionFirstQuadrant(unit="rad")
    annotation (Placement(transformation(extent={{96,-2},{116,18}}),
        iconTransformation(extent={{100,-10},{120,10}})));

equation
  windDirectionFirstQuadrant = DCOL.Generation.SolarThermal.BaseClasses.WindDirectionQuadrantCorrection(windDirection);

  annotation (
    Icon(coordinateSystem(preserveAspectRatio=false, extent={{-100,-100},{100,
            100}}), graphics={
        Text(
          extent={{-48,116},{32,108}},
          pattern=LinePattern.None,
          lineThickness=0.5,
          fillColor={0,0,255},
          fillPattern=FillPattern.Solid,
          lineColor={0,0,255},
          textString="%name",
          fontSize=40),
        Rectangle(extent={{-100,60},{100,-60}}, lineColor={0,0,0}),
        Text(
          extent={{-86,26},{94,-8}},
          lineColor={0,0,255},
          textString="WindDirQuadrant")}),
    Diagram(coordinateSystem(preserveAspectRatio=false, extent={{-100,-100},{
            100,100}}), graphics),
    Documentation(info="<html>
<p>This block just calls <a href=\"Ambassador_WP4.ThermoFluidTek.ThermalSources.SolarThermal.BaseClasses.WindDirectionQuadrantCorrection\">WindDirectionQuadrantCorrection</a> to represent the net angle between the wind direction and a planar surface, in order to use it for a convection heat calculation.</p>
</html>"));
end WindDirectionQuadrantCorrectionBlock;
