within DCOL.Generation.SolarThermal.FMU.Test;
model Test_SolarSystemBasurtoRUG
  SolarSystemBasurtoRUG solarSystemBasurtoRUG(n=267, e=2)
    annotation (Placement(transformation(extent={{-20,-20},{40,20}})));
  Modelica.Blocks.Sources.CombiTimeTable combiTimeTable(
    tableOnFile=true,
    tableName="A",
    columns={2,3,4,5,6,7,8,9,10,11,12,13,14},
    fileName=
        "D:/Users/eubieta/Proyectos/INDIGO/TablasTiempo/2013_09_24_Data_DeltaI_Qcreciente_Ini5000s - copia.mat")
    annotation (Placement(transformation(extent={{-90,10},{-70,30}})));
  Modelica.Blocks.Sources.Constant m_flow(k=0.03*36)
    annotation (Placement(transformation(extent={{-90,-20},{-70,0}})));
  Modelica.Blocks.Sources.Constant const1(k=70 + 273.15)
    annotation (Placement(transformation(extent={{-90,-50},{-70,-30}})));
equation
  connect(combiTimeTable.y[9], solarSystemBasurtoRUG.ambientTemperature)
    annotation (Line(points={{-69,20},{-46,20},{-46,16.6667},{-20,16.6667}},
        color={0,0,127}));
  connect(combiTimeTable.y[4], solarSystemBasurtoRUG.gIhor) annotation (Line(
        points={{-69,20},{-46,20},{-46,10},{-20,10}}, color={0,0,127}));
  connect(combiTimeTable.y[13], solarSystemBasurtoRUG.localTime_h) annotation (
      Line(points={{-69,20},{-46,20},{-46,3.33333},{-20,3.33333}}, color={0,0,
          127}));
  connect(combiTimeTable.y[3], solarSystemBasurtoRUG.irradiance) annotation (
      Line(points={{-69,20},{-46,20},{-46,-3.33333},{-20,-3.33333}}, color={0,0,
          127}));
  connect(m_flow.y, solarSystemBasurtoRUG.inlet_massFlow)
    annotation (Line(points={{-69,-10},{-20,-10}}, color={0,0,127}));
  connect(const1.y, solarSystemBasurtoRUG.inlet_Temperature) annotation (Line(
        points={{-69,-40},{-46,-40},{-46,-16.6667},{-20,-16.6667}}, color={0,0,
          127}));
  annotation (
    Icon(coordinateSystem(preserveAspectRatio=false)),
    Diagram(coordinateSystem(preserveAspectRatio=false)),
    experiment(StopTime=13579.992));
end Test_SolarSystemBasurtoRUG;
