within DCOL.Generation.SolarThermal.FMU.Test;
model Test_SolarSystemBasurtoRUG_fmu
  Modelica.Blocks.Sources.CombiTimeTable combiTimeTable(
    tableOnFile=true,
    tableName="A",
    columns={2,3,4,5,6,7,8,9,10,11,12,13,14},
    fileName=
        "D:/Users/eubieta/Proyectos/INDIGO/TablasTiempo/2013_09_24_Data_DeltaI_Qcreciente_Ini5000s - copia.mat")
    annotation (Placement(transformation(extent={{-90,10},{-70,30}})));
  Modelica.Blocks.Sources.Constant m_flow(k=0.03*36)
    annotation (Placement(transformation(extent={{-90,-20},{-70,0}})));
  Modelica.Blocks.Sources.Constant const1(k=70 + 273.15)
    annotation (Placement(transformation(extent={{-90,-50},{-70,-30}})));
  Modelica.Blocks.Math.Gain gain(k=3600)
    annotation (Placement(transformation(extent={{-60,40},{-40,60}})));
equation
  connect(combiTimeTable.y[9], solarSystemBasurtoRUG_fmu.ambientTemperature)
    annotation (Line(points={{-69,20},{-46,20},{-46,14.4},{10.8,14.4}}, color={
          0,0,127}));
  connect(combiTimeTable.y[4], solarSystemBasurtoRUG_fmu.gIhor) annotation (
      Line(points={{-69,20},{-46,20},{-46,8.6},{10.8,8.6}}, color={0,0,127}));
  connect(combiTimeTable.y[3], solarSystemBasurtoRUG_fmu.irradiance)
    annotation (Line(points={{-69,20},{-46,20},{-46,-2.8},{10.8,-2.8}}, color={
          0,0,127}));
  connect(m_flow.y, solarSystemBasurtoRUG_fmu.inlet_massFlow) annotation (Line(
        points={{-69,-10},{-30,-10},{-30,-8.4},{10.8,-8.4}}, color={0,0,127}));
  connect(const1.y, solarSystemBasurtoRUG_fmu.inlet_Temperature) annotation (
      Line(points={{-69,-40},{-46,-40},{-46,-14.2},{10.8,-14.2}}, color={0,0,
          127}));
  connect(combiTimeTable.y[13], gain.u) annotation (Line(points={{-69,20},{-66,
          20},{-66,50},{-62,50}}, color={0,0,127}));
  connect(gain.y, solarSystemBasurtoRUG_fmu.localTime_h_inBaseUnit) annotation (
     Line(points={{-39,50},{-20,50},{-20,3},{10.8,3}}, color={0,0,127}));
  annotation (
    Icon(coordinateSystem(preserveAspectRatio=false)),
    Diagram(coordinateSystem(preserveAspectRatio=false)),
    experiment(StopTime=13579.992));
end Test_SolarSystemBasurtoRUG_fmu;
