within DCOL.Generation.SolarThermal.FMU.Test;
model Test_SolarSystemBasurtoSOLTOP2
  SolarSystemBasurtoSOLTOP solarSystemBasurtoSOLTOP(n=267, e=7200)
    annotation (Placement(transformation(extent={{0,-20},{60,20}})));
  Modelica.Blocks.Sources.Constant m_flow(k=0.03*35)
    annotation (Placement(transformation(extent={{-90,-52},{-70,-32}})));
  Modelica.Blocks.Sources.Constant const1(k=70 + 273.15)
    annotation (Placement(transformation(extent={{-90,-80},{-70,-60}})));
  Modelica.Blocks.Sources.Constant irradiance(k=1000)
    annotation (Placement(transformation(extent={{-90,-20},{-70,0}})));
  Modelica.Blocks.Sources.Constant gIhor(k=600)
    annotation (Placement(transformation(extent={{-90,40},{-70,60}})));
  Modelica.Blocks.Sources.Constant ambientT(k=25 + 273.15)
    annotation (Placement(transformation(extent={{-90,70},{-70,90}})));
  Modelica.Blocks.Sources.Ramp localTime(
    offset=8*3600,
    height=12*3600,
    duration=12*3600)
    annotation (Placement(transformation(extent={{-90,10},{-70,30}})));
equation
  connect(m_flow.y, solarSystemBasurtoSOLTOP.inlet_massFlow)
    annotation (Line(points={{-69,-42},{-60,-42},{-60,-10},{0,-10}},
                                                   color={0,0,127}));
  connect(const1.y, solarSystemBasurtoSOLTOP.inlet_Temperature) annotation (
      Line(points={{-69,-70},{-46,-70},{-46,-16.6667},{0,-16.6667}},   color={0,
          0,127}));
  connect(solarSystemBasurtoSOLTOP.irradiance, irradiance.y) annotation (Line(
        points={{0,-3.33333},{-64,-3.33333},{-64,-10},{-69,-10}}, color={0,0,
          127}));
  connect(localTime.y, solarSystemBasurtoSOLTOP.localTime) annotation (Line(
        points={{-69,20},{-30,20},{-30,3.33333},{0,3.33333}}, color={0,0,127}));
  connect(gIhor.y, solarSystemBasurtoSOLTOP.Ighor) annotation (Line(points={{
          -69,50},{-20,50},{-20,10},{0,10}}, color={0,0,127}));
  connect(ambientT.y, solarSystemBasurtoSOLTOP.ambientTemperature) annotation (
      Line(points={{-69,80},{-10,80},{-10,16.6667},{0,16.6667}}, color={0,0,127}));
  annotation (
    Icon(coordinateSystem(preserveAspectRatio=false)),
    Diagram(coordinateSystem(preserveAspectRatio=false)),
    experiment(
      StopTime=43200,
      Interval=10,
      __Dymola_Algorithm="Cvode"));
end Test_SolarSystemBasurtoSOLTOP2;
