within DCOL.Generation.SolarThermal.FMU.Test;
model Test_SolarSystemBasurtoSOLTOP_fmu
  Modelica.Blocks.Sources.CombiTimeTable combiTimeTable(
    tableOnFile=true,
    tableName="A",
    columns={2,3,4,5,6,7,8,9,10,11,12,13,14},
    fileName=
        "D:/Users/eubieta/Proyectos/INDIGO/TablasTiempo/2013_09_24_Data_DeltaI_Qcreciente_Ini5000s - copia.mat")
    annotation (Placement(transformation(extent={{-90,10},{-70,30}})));
  Modelica.Blocks.Sources.Constant m_flow(k=0.03*36)
    annotation (Placement(transformation(extent={{-90,-20},{-70,0}})));
  Modelica.Blocks.Sources.Constant const1(k=70 + 273.15)
    annotation (Placement(transformation(extent={{-90,-50},{-70,-30}})));
  Modelica.Blocks.Math.Gain gain(k=3600)
    annotation (Placement(transformation(extent={{-60,40},{-40,60}})));
  SolarSystemBasurtoSOLTOPTotal_fmu solarSystemBasurtoSOLTOPTotal_fmu
    annotation (Placement(transformation(extent={{14,-44},{94,36}})));
equation
  connect(combiTimeTable.y[13], gain.u) annotation (Line(points={{-69,20},{-66,
          20},{-66,50},{-62,50}}, color={0,0,127}));
  connect(solarSystemBasurtoSOLTOPTotal_fmu.ambientTemperature, combiTimeTable.y[9])
    annotation (Line(points={{12.4,24.8},{-4,24.8},{-4,14},{-26,14},{-26,20},{-69,
          20}},     color={0,0,127}));
  connect(solarSystemBasurtoSOLTOPTotal_fmu.Ighor, combiTimeTable.y[4]) annotation (
      Line(points={{12.4,13.2},{-2,13.2},{-2,8},{-26,8},{-26,20},{-69,20}},
                                                                          color=
         {0,0,127}));
  connect(solarSystemBasurtoSOLTOPTotal_fmu.localTime, gain.y)
    annotation (Line(points={{12.4,2},{-26,2},{-26,50},{-39,50}}, color={0,0,
          127}));
  connect(combiTimeTable.y[3], solarSystemBasurtoSOLTOPTotal_fmu.irradiance)
    annotation (Line(points={{-69,20},{-26,20},{-26,-9.6},{12.4,-9.6}}, color={
          0,0,127}));
  connect(m_flow.y, solarSystemBasurtoSOLTOPTotal_fmu.inlet_massFlow) annotation (
      Line(points={{-69,-10},{-34,-10},{-34,-20.8},{12.4,-20.8}},
                                                                color={0,0,127}));
  connect(const1.y, solarSystemBasurtoSOLTOPTotal_fmu.inlet_Temperature) annotation (
     Line(points={{-69,-40},{-36,-40},{-36,-32.4},{12.4,-32.4}}, color={0,0,127}));
  annotation (
    Icon(coordinateSystem(preserveAspectRatio=false)),
    Diagram(coordinateSystem(preserveAspectRatio=false)),
    experiment(StopTime=13579.992));
end Test_SolarSystemBasurtoSOLTOP_fmu;
