within DCOL.Generation.SolarThermal.Interfaces;
expandable connector SolarCollectorInput
  "Input real values for Simplified solar collector model, acquiring local time for calculation of incidence angle and clearness index"

  Modelica.SIunits.Angle IncidenceAngle;
  Modelica.SIunits.Irradiance Irradiance;
  Modelica.SIunits.Temperature AmbientTemperature;
  Modelica.SIunits.MassFlowRate MassFlowRate;
  Modelica.SIunits.Temperature InletTemperature;
  Real ClearnessIndex "[-]";
  Real RelativeHumidity "[%]";
  Modelica.SIunits.Velocity WindSpeed;
  Modelica.SIunits.Angle WindDirection;
  Modelica.SIunits.Temperature OutletTemperature;
  Real LocalHour(unit="h");
  Modelica.SIunits.Irradiance HorizontalIrradiance;
  annotation (Icon(coordinateSystem(preserveAspectRatio=false, extent={{-100,-100},
            {100,100}}), graphics={
        Polygon(
          points={{-80,60},{80,60},{100,40},{80,-30},{60,-40},{-60,-40},{-80,-30},
              {-100,40},{-80,60}},
          lineColor={0,0,0},
          fillColor={130,38,241},
          fillPattern=FillPattern.Solid),
        Ellipse(
          extent={{-55,35},{-45,25}},
          lineColor={0,0,0},
          fillColor={0,0,0},
          fillPattern=FillPattern.Solid),
        Ellipse(
          extent={{45,35},{55,25}},
          lineColor={0,0,0},
          fillColor={0,0,0},
          fillPattern=FillPattern.Solid),
        Ellipse(
          extent={{-5,-5},{5,-15}},
          lineColor={0,0,0},
          fillColor={0,0,0},
          fillPattern=FillPattern.Solid)}), Protection(access=Access.diagram), Documentation(info="<html>
<p>Expandable connector for routing all the necessary signals at solar collector models (both simplified and detailed)</p>
</html>"));
end SolarCollectorInput;
