within DCOL.Generation.SolarThermal.Testing;
model SolarSystemBasurtoRUG
  Interfaces.SolarCollectorInput solarCollectorInput1
    annotation (Placement(transformation(extent={{-40,-6},{-20,14}})));
  inner Modelica.Fluid.System system
    annotation (Placement(transformation(extent={{-100,80},{-80,100}})));
  Modelica_IK4_TEKNIKER.Fluid.Sources.FixedBoundary boundary(redeclare package Medium = Modelica.Media.Incompressible.Examples.Glycol47, nPorts=1) annotation (Placement(transformation(extent={{150,-78},{130,-58}})));
  Modelica_IK4_TEKNIKER.Fluid.Sources.MassFlowSource_T boundary1(
    redeclare package Medium = Modelica.Media.Incompressible.Examples.Glycol47,
    nPorts=1,
    m_flow=0.11584*36,
    T=343.15) annotation (Placement(transformation(extent={{156,50},{136,70}})));

  Modelica_IK4_TEKNIKER.Meteorological.ClearnessIndex_IncidenceAngle clearnessIndex_IncidenceAngle(
    latitude=0.013154389492649,
    longitude=0.00075240502687317,
    n=267,
    e=7200,
    cAzimuth=0.017453292519943,
    cInclination=0.013098556409877) annotation (Placement(transformation(extent={{-102,-2},{-82,18}})));
  Modelica.Blocks.Sources.CombiTimeTable combiTimeTable(
    tableOnFile=true,
    tableName="A",
    columns={2,3,4,5,6,7,8,9,10,11,12,13,14},
    fileName=
        "D:/Users/eubieta/Proyectos/INDIGO/TablasTiempo/2013_09_24_Data_DeltaI_Qcreciente_Ini5000s - copia.mat")
    annotation (Placement(transformation(extent={{-154,2},{-134,22}})));

  ParallelSimplifiedSolarCollector SolarCollectorRow1(
    redeclare package Medium =
        Modelica.Media.Incompressible.Examples.Glycol47,
    Nparallel=36,
    n_tubes=1,
    angleModifierData(displayUnit="rad") = 0.87266,
    collectorHarp(T_start=343.15),
    m_flow_max=0.1158411,
    D_tubes=0.0321,
    L_tubes=1.856,
    S_absorber=1.77,
    incidenceAngleModifierData=0.89,
    C=4100,
    F_tau_alfa=0.764,
    c1=4.33,
    c2=0.0069,
    x={2.778e-5,5.556e-5,8.33e-5,1.11e-4},
    y={250,550,900,1300})
    annotation (Placement(transformation(extent={{38,56},{66,82}})));
  ParallelSimplifiedSolarCollector SolarCollectorRow2(
    redeclare package Medium =
        Modelica.Media.Incompressible.Examples.Glycol47,
    Nparallel=36,
    n_tubes=1,
    angleModifierData(displayUnit="rad") = 0.87266,
    collectorHarp(T_start=343.15),
    m_flow_max=0.1158411,
    D_tubes=0.0321,
    L_tubes=1.856,
    S_absorber=1.77,
    incidenceAngleModifierData=0.89,
    C=4100,
    F_tau_alfa=0.764,
    c1=4.33,
    c2=0.0069,
    x={2.778e-5,5.556e-5,8.33e-5,1.11e-4},
    y={250,550,900,1300})
    annotation (Placement(transformation(extent={{44,0},{72,26}})));
  ParallelSimplifiedSolarCollector SolarCollectorRow3(
    redeclare package Medium =
        Modelica.Media.Incompressible.Examples.Glycol47,
    Nparallel=36,
    n_tubes=1,
    angleModifierData(displayUnit="rad") = 0.87266,
    collectorHarp(T_start=343.15),
    m_flow_max=0.1158411,
    D_tubes=0.0321,
    L_tubes=1.856,
    S_absorber=1.77,
    incidenceAngleModifierData=0.89,
    C=4100,
    F_tau_alfa=0.764,
    c1=4.33,
    c2=0.0069,
    x={2.778e-5,5.556e-5,8.33e-5,1.11e-4},
    y={250,550,900,1300})
    annotation (Placement(transformation(extent={{46,-54},{74,-28}})));
equation
  connect(clearnessIndex_IncidenceAngle.incidenceAngle, solarCollectorInput1.IncidenceAngle)
    annotation (Line(points={{-79.9,2.9},{-57.95,2.9},{-57.95,4.05},{-29.95,
          4.05}}, color={0,0,127}), Text(
      string="%second",
      index=1,
      extent={{6,3},{6,3}}));
  connect(combiTimeTable.y[4], clearnessIndex_IncidenceAngle.gIhor) annotation (
     Line(points={{-133,12},{-116,12},{-116,12.8},{-104,12.8}}, color={0,0,127}));
  connect(combiTimeTable.y[13], clearnessIndex_IncidenceAngle.localTime_h)
    annotation (Line(points={{-133,12},{-128,12},{-128,4},{-104,4}}, color={0,0,
          127}));
  connect(combiTimeTable.y[9], solarCollectorInput1.AmbientTemperature)
    annotation (Line(points={{-133,12},{-132,12},{-132,52},{-29.95,52},{-29.95,
          4.05}}, color={0,0,127}), Text(
      string="%second",
      index=1,
      extent={{6,3},{6,3}}));
  connect(combiTimeTable.y[3], solarCollectorInput1.Irradiance) annotation (
      Line(points={{-133,12},{-132,12},{-132,-26},{-29.95,-26},{-29.95,4.05}},
        color={0,0,127}), Text(
      string="%second",
      index=1,
      extent={{6,3},{6,3}}));
  connect(boundary1.ports[1], SolarCollectorRow1.inlet) annotation (Line(points=
         {{136,60},{100,60},{100,60.2},{62.2,60.2}}, color={0,127,255}));
  connect(solarCollectorInput1, SolarCollectorRow1.solarCollectorInput)
    annotation (Line(points={{-30,4},{-26,4},{-26,64},{42.15,64},{42.15,67.1}},
        color={0,0,0}), Text(
      string="%first",
      index=-1,
      extent={{-6,3},{-6,3}}));
  connect(solarCollectorInput1, SolarCollectorRow2.solarCollectorInput)
    annotation (Line(points={{-30,4},{-30,2},{48.15,2},{48.15,11.1}}, color={0,
          0,0}), Text(
      string="%first",
      index=-1,
      extent={{-6,3},{-6,3}}));
  connect(solarCollectorInput1, SolarCollectorRow3.solarCollectorInput)
    annotation (Line(points={{-30,4},{-30,-62},{50.15,-62},{50.15,-42.9}},
        color={0,0,0}), Text(
      string="%first",
      index=-1,
      extent={{-6,3},{-6,3}}));
  connect(SolarCollectorRow1.outlet, SolarCollectorRow2.inlet) annotation (Line(
        points={{40.5,76.2},{12,76.2},{12,40},{120,40},{120,4},{94,4},{94,4.2},
          {68.2,4.2}}, color={0,127,255}));
  connect(SolarCollectorRow2.outlet, SolarCollectorRow3.inlet) annotation (Line(
        points={{46.5,20.2},{12,20.2},{12,-12},{120,-12},{120,-49.8},{70.2,
          -49.8}}, color={0,127,255}));
  connect(SolarCollectorRow3.outlet, boundary.ports[1]) annotation (Line(points=
         {{48.5,-33.8},{14,-33.8},{14,-68},{130,-68}}, color={0,127,255}));
  annotation (Icon(coordinateSystem(preserveAspectRatio=false, extent={{-160,
            -100},{160,100}})),                                  Diagram(
        coordinateSystem(preserveAspectRatio=false, extent={{-160,-100},{160,
            100}})));
end SolarSystemBasurtoRUG;
