within DCOL.Generation.SolarThermal.Testing;
model SolarSystemBasurtoSOLTOP
  Interfaces.SolarCollectorInput solarCollectorInput1
    annotation (Placement(transformation(extent={{-40,-6},{-20,14}})));
  inner Modelica.Fluid.System system
    annotation (Placement(transformation(extent={{-100,80},{-80,100}})));
  Modelica_IK4_TEKNIKER.Fluid.Sources.FixedBoundary boundary(redeclare package Medium = Modelica.Media.Incompressible.Examples.Glycol47, nPorts=1) annotation (Placement(transformation(extent={{152,-94},{132,-74}})));
  Modelica_IK4_TEKNIKER.Fluid.Sources.MassFlowSource_T boundary1(
    redeclare package Medium = Modelica.Media.Incompressible.Examples.Glycol47,
    nPorts=1,
    m_flow=0.03*36,
    T=343.15) annotation (Placement(transformation(extent={{156,50},{136,70}})));

  Modelica_IK4_TEKNIKER.Meteorological.ClearnessIndex_IncidenceAngle clearnessIndex_IncidenceAngle(
    n=267,
    latitude=0.013154389492649,
    longitude=0.00075240502687317,
    e=7200,
    cAzimuth=0.017453292519943,
    cInclination=0.013098556409877) annotation (Placement(transformation(extent={{-84,-2},{-64,18}})));
  Modelica.Blocks.Sources.CombiTimeTable combiTimeTable(
    tableOnFile=true,
    tableName="A",
    columns={2,3,4,5,6,7,8,9,10,11,12,13,14},
    fileName=
        "D:/Users/eubieta/Proyectos/INDIGO/TablasTiempo/2013_09_24_Data_DeltaI_Qcreciente_Ini5000s - copia.mat")
    annotation (Placement(transformation(extent={{-154,2},{-134,22}})));

  ParallelSimplifiedSolarCollector SolarCollectorRow1(
    redeclare package Medium =
        Modelica.Media.Incompressible.Examples.Glycol47,
    m_flow_max=0.057921,
    n_tubes=1,
    D_tubes=0.0391,
    angleModifierData(displayUnit="rad") = 0.87266,
    L_tubes=1.897,
    S_absorber=1.926,
    incidenceAngleModifierData=0.94,
    C=5400,
    F_tau_alfa=0.854,
    c1=4.06,
    c2=0.009,
    x={1.389e-5,2.778e-5,4.167e-5,5.556e-5,6.944e-5,8.33e-5},
    collectorHarp(T_start=343.15),
    Nparallel=36,
    y={5000,14000,27000,45000,66000,92000})
    annotation (Placement(transformation(extent={{40,52},{68,78}})));
  ParallelSimplifiedSolarCollector SolarCollectorRow2(
    redeclare package Medium =
        Modelica.Media.Incompressible.Examples.Glycol47,
    m_flow_max=0.057921,
    n_tubes=1,
    D_tubes=0.0391,
    angleModifierData(displayUnit="rad") = 0.87266,
    L_tubes=1.897,
    S_absorber=1.926,
    incidenceAngleModifierData=0.94,
    C=5400,
    F_tau_alfa=0.854,
    c1=4.06,
    c2=0.009,
    x={1.389e-5,2.778e-5,4.167e-5,5.556e-5,6.944e-5,8.33e-5},
    collectorHarp(T_start=343.15),
    Nparallel=36,
    y={5000,14000,27000,45000,66000,92000})
    annotation (Placement(transformation(extent={{42,-6},{70,20}})));
  ParallelSimplifiedSolarCollector SolarCollectorRow3(
    redeclare package Medium =
        Modelica.Media.Incompressible.Examples.Glycol47,
    m_flow_max=0.057921,
    n_tubes=1,
    D_tubes=0.0391,
    angleModifierData(displayUnit="rad") = 0.87266,
    L_tubes=1.897,
    S_absorber=1.926,
    incidenceAngleModifierData=0.94,
    C=5400,
    F_tau_alfa=0.854,
    c1=4.06,
    c2=0.009,
    x={1.389e-5,2.778e-5,4.167e-5,5.556e-5,6.944e-5,8.33e-5},
    collectorHarp(T_start=343.15),
    Nparallel=36,
    y={5000,14000,27000,45000,66000,92000})
    annotation (Placement(transformation(extent={{44,-60},{72,-34}})));
  Modelica.Blocks.Math.Gain gain(k=3600)
    annotation (Placement(transformation(extent={{-116,0},{-106,10}})));
equation
  connect(clearnessIndex_IncidenceAngle.incidenceAngle, solarCollectorInput1.IncidenceAngle)
    annotation (Line(points={{-61.9,2.9},{-57.95,2.9},{-57.95,4.05},{-29.95,
          4.05}}, color={0,0,127}), Text(
      string="%second",
      index=1,
      extent={{6,3},{6,3}}));
  connect(combiTimeTable.y[4], clearnessIndex_IncidenceAngle.gIhor) annotation (
     Line(points={{-133,12},{-116,12},{-116,12.8},{-86,12.8}},  color={0,0,127}));
  connect(combiTimeTable.y[9], solarCollectorInput1.AmbientTemperature)
    annotation (Line(points={{-133,12},{-132,12},{-132,52},{-29.95,52},{-29.95,
          4.05}}, color={0,0,127}), Text(
      string="%second",
      index=1,
      extent={{6,3},{6,3}}));
  connect(combiTimeTable.y[3], solarCollectorInput1.Irradiance) annotation (
      Line(points={{-133,12},{-132,12},{-132,-26},{-29.95,-26},{-29.95,4.05}},
        color={0,0,127}), Text(
      string="%second",
      index=1,
      extent={{6,3},{6,3}}));
  connect(boundary1.ports[1], SolarCollectorRow1.inlet) annotation (Line(points=
         {{136,60},{100,60},{100,56.2},{64.2,56.2}}, color={0,127,255}));
  connect(SolarCollectorRow1.outlet, SolarCollectorRow2.inlet) annotation (Line(
        points={{42.5,72.2},{0,72.2},{0,36},{120,36},{120,-1.8},{66.2,-1.8}},
        color={0,127,255}));
  connect(SolarCollectorRow2.outlet, SolarCollectorRow3.inlet) annotation (Line(
        points={{44.5,14.2},{0,14.2},{0,-14},{120,-14},{120,-55.8},{68.2,-55.8}},
        color={0,127,255}));
  connect(SolarCollectorRow3.outlet, boundary.ports[1]) annotation (Line(points=
         {{46.5,-39.8},{0,-39.8},{0,-84},{132,-84}}, color={0,127,255}));
  connect(solarCollectorInput1, SolarCollectorRow1.solarCollectorInput)
    annotation (Line(points={{-30,4},{-26,4},{-26,64},{44.15,64},{44.15,63.1}},
        color={0,0,0}), Text(
      string="%first",
      index=-1,
      extent={{-6,3},{-6,3}}));
  connect(solarCollectorInput1, SolarCollectorRow2.solarCollectorInput)
    annotation (Line(points={{-30,4},{8,4},{8,5.1},{46.15,5.1}}, color={0,0,0}),
      Text(
      string="%first",
      index=-1,
      extent={{-6,3},{-6,3}}));
  connect(solarCollectorInput1, SolarCollectorRow3.solarCollectorInput)
    annotation (Line(points={{-30,4},{-28,4},{-28,-50},{48.15,-50},{48.15,-48.9}},
        color={0,0,0}), Text(
      string="%first",
      index=-1,
      extent={{-6,3},{-6,3}}));
  connect(combiTimeTable.y[13], gain.u) annotation (Line(points={{-133,12},{
          -126,12},{-126,5},{-117,5}}, color={0,0,127}));
  connect(gain.y, clearnessIndex_IncidenceAngle.localTime) annotation (Line(
        points={{-105.5,5},{-95.75,5},{-95.75,4},{-86,4}}, color={0,0,127}));
  annotation (Icon(coordinateSystem(preserveAspectRatio=false, extent={{-160,
            -100},{160,100}})),                                  Diagram(
        coordinateSystem(preserveAspectRatio=false, extent={{-160,-100},{160,
            100}})));
end SolarSystemBasurtoSOLTOP;
