within DCOL.ThermalStorage.LatentStorages.FMI.Pruebas;
model IceStorageExternalMelting_FMU_test

  Modelica.Blocks.Sources.TimeTable HTF_inlet_T(table=[0.0,-9 + 273.15; 100,-9
         + 273.15])
    annotation (Placement(transformation(extent={{-70,-90},{-50,-70}})));
  Modelica.Blocks.Sources.TimeTable water_inlet_T(table=[0.0,10 + 273.15; 40,10
         + 273.15; 40,20 + 273.15; 100,20 + 273.15])
    annotation (Placement(transformation(extent={{-70,-10},{-50,10}})));
  Modelica.Blocks.Sources.TimeTable HTF_in_m_flow(table=[0.0,300; 10,300; 10,0;
        100,0])
    annotation (Placement(transformation(extent={{-70,-50},{-50,-30}})));
  Modelica.Blocks.Sources.TimeTable water_in_m_flow(table=[0.0,100; 10,100; 10,
        0; 50,0; 50,100; 100,100])
    annotation (Placement(transformation(extent={{-70,30},{-50,50}})));
  IceStorageExtMelt_FMU_fmu iceStorageExternalMelting_Dym
    annotation (Placement(transformation(extent={{0,-40},{80,40}})));
  Modelica.Blocks.Sources.TimeTable ambient_T(table=[0.0,20 + 273.15; 100,20 +
        273.15])
    annotation (Placement(transformation(extent={{-70,70},{-50,90}})));
equation
  connect(ambient_T.y, iceStorageExternalMelting_Dym.ambient_T) annotation (
      Line(points={{-49,80},{-20,80},{-20,26.8},{-1.6,26.8}}, color={0,0,127}));
  connect(water_in_m_flow.y, iceStorageExternalMelting_Dym.water_in_m_flow)
    annotation (Line(points={{-49,40},{-30,40},{-30,13.6},{-1.6,13.6}}, color={
          0,0,127}));
  connect(water_inlet_T.y, iceStorageExternalMelting_Dym.water_inlet_T)
    annotation (Line(points={{-49,0},{-1.6,0}}, color={0,0,127}));
  connect(HTF_in_m_flow.y, iceStorageExternalMelting_Dym.HTF_m_flow)
    annotation (Line(points={{-49,-40},{-30,-40},{-30,-13.2},{-1.6,-13.2}},
        color={0,0,127}));
  connect(HTF_inlet_T.y, iceStorageExternalMelting_Dym.HTF_inlet_T) annotation (
     Line(points={{-49,-80},{-20,-80},{-20,-26.4},{-1.6,-26.4}}, color={0,0,127}));
  annotation (Icon(coordinateSystem(preserveAspectRatio=false, extent={{-100,
            -120},{100,100}})),                                  Diagram(
        coordinateSystem(preserveAspectRatio=false, extent={{-100,-100},{100,
            100}})));
end IceStorageExternalMelting_FMU_test;
