within DCOL.ThermalStorage.LatentStorages.FMI.Pruebas;
model IceStorage_FMI_test

  IceStorage_FMU iceStorage_Dym
    annotation (Placement(transformation(extent={{-8,-30},{52,30}})));
  Modelica.Blocks.Sources.TimeTable HTF_T(table=[0,-10 + 273.15; 100000,-10 +
        273.15; 100000,-10 + 273.15; 200000,-10 + 273.15; 200000,10 + 273.15;
        300000,10 + 273.15])
    annotation (Placement(transformation(extent={{-80,-30},{-60,-10}})));
  Modelica.Blocks.Sources.TimeTable HTF_m_flow(table=[0,10; 100000,10; 100000,
        20; 200000,20])
    annotation (Placement(transformation(extent={{-80,10},{-60,30}})));
  Modelica.Blocks.Sources.TimeTable floorT(table=[0,-10 + 273.15; 100000,-10 +
        273.15; 100000,-10 + 273.15; 200000,-10 + 273.15; 200000,10 + 273.15;
        300000,10 + 273.15])
    annotation (Placement(transformation(extent={{-80,-70},{-60,-50}})));
  Modelica.Blocks.Sources.TimeTable ambient_T(table=[0,-10 + 273.15; 100000,-10
         + 273.15; 100000,-10 + 273.15; 200000,-10 + 273.15; 200000,10 + 273.15;
        300000,10 + 273.15])
    annotation (Placement(transformation(extent={{-80,50},{-60,70}})));
equation
  connect(ambient_T.y, iceStorage_Dym.ambient_T) annotation (Line(points={{-59,60},
          {-40,60},{-40,18},{-9.2,18},{-9.2,18}},   color={0,0,127}));
  connect(HTF_m_flow.y, iceStorage_Dym.HTF_m_flow) annotation (Line(points={{-59,20},
          {-50,20},{-50,6},{-9.2,6}},        color={0,0,127}));
  connect(HTF_T.y, iceStorage_Dym.HTF_T) annotation (Line(points={{-59,-20},{
          -50,-20},{-50,-6},{-9.2,-6}},color={0,0,127}));
  connect(floorT.y, iceStorage_Dym.floor_T) annotation (Line(points={{-59,-60},
          {-40,-60},{-40,-18},{-9.2,-18}},color={0,0,127}));
  annotation (Icon(coordinateSystem(preserveAspectRatio=false)), Diagram(
        coordinateSystem(preserveAspectRatio=false)),
    Documentation(revisions="<html>
<p>2016-05-16 <a href=\"mailto: eduardo.ubieta@tekniker.es\">Eduardo Ubieta</a></a> (IK4-TEKNIKER): First implementation</p>
<p><b>Copyright &copy; <a href=\"http://www.tekniker.es/en\">IK4-TEKNIKER</a></b></p>
</html>"));
end IceStorage_FMI_test;
