within DCOL.ThermalStorage.LatentStorages.Interfaces;
model MidTemperature_external "Calculates the mid temperature of m ports"

  parameter Integer m(min=1)=3 "Number of collected heat flows";
  parameter Integer n(min=1)=3 "Number of collected heat flows";
  parameter Integer o(min=1)=3 "Number of collected heat flows";

  Modelica.Thermal.HeatTransfer.Interfaces.HeatPort_b port_a[m,n,o] annotation (Placement(transformation(extent={{-10,88},
            {10,108}}), iconTransformation(extent={{-10,88},{10,108}})));
  Modelica.Thermal.HeatTransfer.Interfaces.HeatPort_a port_b annotation (Placement(transformation(extent={{-10,
            -108},{10,-88}}), iconTransformation(extent={{-10,-108},{10,-88}})));

equation
  port_b.T=sum(port_a.T)/(m*n*o);
  port_a.Q_flow = fill((port_b.Q_flow)/(n*m*o), m, n, o);

  annotation (Icon(coordinateSystem(preserveAspectRatio=false), graphics={
        Text(
          extent={{-150,-30},{150,-70}},
          textString="%name",
          lineColor={0,0,255}),
        Text(
          extent={{-152,80},{148,50}},
          lineColor={0,0,0},
          textString="m=%m, n=%n"),
        Line(
          points={{0,90},{0,40}},
          color={181,0,0}),
        Rectangle(
          extent={{-60,40},{60,30}},
          lineColor={181,0,0},
          fillColor={181,0,0},
          fillPattern=FillPattern.Solid),
        Line(
          points={{-60,30},{0,-30},{0,-90}},
          color={181,0,0}),
        Line(
          points={{0,-30},{-20,30}},
          color={181,0,0}),
        Line(
          points={{0,-30},{20,30}},
          color={181,0,0}),
        Line(
          points={{0,-30},{60,30}},
          color={181,0,0})}),                                    Diagram(
        coordinateSystem(preserveAspectRatio=false)));
end MidTemperature_external;
