within DCOL.ThermalStorage.LatentStorages.Interfaces;
partial model PartialIce_WaterRing

  import Modelica.Constants;
  outer Modelica.Fluid.System system "System wide properties";

  Modelica.Thermal.HeatTransfer.Interfaces.HeatPort_a port_a_heatToAmbient
    "Heat exchanged with the ambient" annotation (Placement(transformation(
          extent={{10,70},{30,90}}), iconTransformation(extent={{-20,70},{0,90}})));
  Modelica.Thermal.HeatTransfer.Interfaces.HeatPort_a port_a_heatToHTF
    "Heat exchanged between the HTF and the PCM" annotation (Placement(
        transformation(extent={{30,-10},{50,10}}), iconTransformation(extent={{
            30,-10},{50,10}})));
  annotation (Icon(coordinateSystem(preserveAspectRatio=false)), Diagram(
        coordinateSystem(preserveAspectRatio=false)),
    Documentation(info="<html>
<p>This partial model contain two HeatPort_a ports to allow the heat exchange between the Heat Transfer Fluid (HTF) and the Phase Change Material (PCM)</p>
</html>",
      revisions="<html>
<p>2016-05-16 <a href=\"mailto: eduardo.ubieta@tekniker.es\">Eduardo Ubieta</a></a> (IK4-TEKNIKER): First implementation</p>
<p><b>Copyright &copy; <a href=\"http://www.tekniker.es/en\">IK4-TEKNIKER</a></b></p>
</html>"));
end PartialIce_WaterRing;
