within DCOL.ThermalStorage.LatentStorages.Interfaces;
partial model PartialIce_WaterRingOM

  import Modelica.Constants;
  outer Modelica.Fluid.System system "System wide properties";

  replaceable package Medium =
      Modelica.Media.Water.ConstantPropertyLiquidWater
    constrainedby Modelica.Media.Interfaces.PartialMedium
    "Water PCM medium in the component" annotation (choicesAllMatching = true);

  //Properties of the PCM
  replaceable package PCM_Prop =
     DCOL.ThermalStorage.LatentStorages.PCMs.Ice_Water constrainedby DCOL.ThermalStorage.LatentStorages.PCMs.BaseClasses.PCM_Properties
     "PCM Medium in the component" annotation (choicesAllMatching = true);

  parameter Integer nSeg=10 "Number of segments dividing the coil";
  parameter Integer nCoilp=10 "number of horizontally parallel coils";

  //Material of the tube
//  replaceable package Material =
//    Modelica_IK4_TEKNIKER.Thermal.Materials.BaseClases.PartialMaterial  "Material of the coils" annotation (choicesAllMatching = true,Dialog(group="Properties of the coils"));

   Modelica.Thermal.HeatTransfer.Interfaces.HeatPort_a port_a_heatToAmbient[nSeg]
    "Heat exchanged with the ambient" annotation (Placement(transformation(
           extent={{120,80},{140,100}}),iconTransformation(extent={{140,70},{
            160,90}})));

   Modelica.Thermal.HeatTransfer.Interfaces.HeatPort_a port_a_heatToHTF[nSeg]
    "Heat exchanged between the HTF and the PCM" annotation (Placement(
        transformation(extent={{20,21},{40,41}}), iconTransformation(extent={{-110,30},
            {-90,50}})));

   Modelica.Fluid.Interfaces.FluidPort_a port_a_water(
     redeclare package Medium = Medium) "Entrace port of the water PCM" annotation (Placement(
        transformation(extent={{-10,90},{10,110}}), iconTransformation(extent={{-10,90},
            {10,110}})));

   Modelica.Fluid.Interfaces.FluidPort_b port_b_water(
     redeclare package Medium = Medium) "Exit port of the water PCM" annotation (Placement(transformation(extent={{-10,
            -110},{10,-90}}),
         iconTransformation(extent={{-10,-110},{10,-90}})));

   annotation (Icon(coordinateSystem(preserveAspectRatio=false,
               extent={{-200,-100},{200,100}})),
               Diagram(coordinateSystem(preserveAspectRatio=false,
               extent={{-200,-100},{200,100}})));
end PartialIce_WaterRingOM;
