within DCOL.ThermalStorage.LatentStorages.PCMs.BaseClasses;
package PCM_Properties
   constant Modelica.SIunits.Temperature T_fus "Fusion temperature";
   constant Modelica.SIunits.Density rho_solid "Density in soid state";
   constant Modelica.SIunits.Density rho_liquid "Density in liquid state";
   constant Modelica.SIunits.SpecificHeatCapacity Cp_PCMs "Specific heat capacity of the solid PCM";
   constant Modelica.SIunits.SpecificHeatCapacity Cp_PCMl "Specific heat capacity of the solid PCM";
   constant Modelica.SIunits.SpecificEnthalpy hfus "Enthalpy of fusion of the PCM at ambient presure";

  annotation (
    Window(
      x=0.21,
      y=0.32,
      width=0.6,
      height=0.6),
    Icon(coordinateSystem(
        preserveAspectRatio=false,
        extent={{-100,-100},{100,100}},
        grid={2,2}), graphics={
        Rectangle(
          extent={{-100,50},{100,-100}},
          lineColor={0,0,255},
          fillColor={255,255,127},
          fillPattern=FillPattern.Solid),
        Text(extent={{-127,115},{127,55}}, textString=
                                               "%name"),
        Line(points={{-100,-50},{100,-50}}, color={0,0,0}),
        Line(points={{-100,0},{100,0}}, color={0,0,0}),
        Line(points={{0,50},{0,-100}}, color={0,0,0})}),
    Documentation(info="<html>
<p>Record containing the needed properties of the PCMs</p>
</html>"));
end PCM_Properties;
