within DCOL.ThermalStorage.LatentStorages.Testing;
model ISEM_TOTAL
    Real t;
  IceStorageExternalMelt_TOTAL iceStorageExternalMelt(
    L_coil=0.66673757545215,
    redeclare package Medium = Modelica.Media.Water.ConstantPropertyLiquidWater,
    redeclare package Medium1 = Modelica_IK4_TEKNIKER.Media.Incompressible.Examples.EthyleneGlycol,
    T_Tube_start=-10 + 273.15,
    nSeg=2,
    nCoilp=5,
    nCoilv=10) annotation (Placement(transformation(extent={{-40,-30},{40,30}})));

  inner Modelica.Fluid.System system
    annotation (Placement(transformation(extent={{16,80},{36,100}})));
  Modelica.Fluid.Sources.FixedBoundary outlet_water(redeclare package Medium =
        Modelica.Media.Water.ConstantPropertyLiquidWater, nPorts=1)
    annotation (Placement(transformation(extent={{-40,-70},{-20,-50}})));
  Modelica.Fluid.Sources.MassFlowSource_T inlet_HTF(
    nPorts=1,
    m_flow=30,
    use_T_in=true,
    use_m_flow_in=true,
    T=263.15,
    redeclare package Medium = Modelica_IK4_TEKNIKER.Media.Incompressible.Examples.EthyleneGlycol)
    annotation (Placement(transformation(extent={{-80,-10},{-60,10}})));
  Modelica.Fluid.Sources.MassFlowSource_T inlet_water(
    redeclare package Medium = Modelica.Media.Water.ConstantPropertyLiquidWater,
    m_flow=10,
    use_T_in=true,
    use_m_flow_in=true,
    T=283.15,
    nPorts=1) annotation (Placement(transformation(extent={{-40,50},{-20,70}})));

  Modelica.Fluid.Sources.FixedBoundary outlet_HTF(
                                     nPorts=1, redeclare package Medium =
        Modelica_IK4_TEKNIKER.Media.Incompressible.Examples.EthyleneGlycol)
    annotation (Placement(transformation(extent={{80,-10},{60,10}})));
  Modelica.Thermal.HeatTransfer.Sources.FixedTemperature fixedTemperature(T=
        293.15) annotation (Placement(transformation(extent={{60,50},{40,70}})));
  Modelica.Fluid.Sensors.Temperature inlet_HTF_temperature(redeclare package Medium =
               Modelica_IK4_TEKNIKER.Media.Incompressible.Examples.EthyleneGlycol)
    annotation (Placement(transformation(extent={{-60,20},{-40,40}})));
  Modelica.Fluid.Sensors.Temperature outlet_HTF_temperature(redeclare package Medium =
               Modelica_IK4_TEKNIKER.Media.Incompressible.Examples.EthyleneGlycol)
    annotation (Placement(transformation(extent={{40,20},{60,40}})));
  Modelica.Blocks.Sources.TimeTable timeTable(table=[0.0,-9 + 273.15; 100000,-9
         + 273.15])
    annotation (Placement(transformation(extent={{-120,-28},{-100,-8}})));
  Modelica.Blocks.Sources.TimeTable timeTable2(table=[0.0,10 + 273.15; 40000,10
         + 273.15; 40000,10 + 273.15; 100000,10 + 273.15])
    annotation (Placement(transformation(extent={{-80,48},{-60,68}})));
  Modelica.Blocks.Sources.TimeTable timeTable1(table=[0.0,3000; 50000,3000; 50000,
        0; 100000,0])
    annotation (Placement(transformation(extent={{-120,22},{-100,42}})));
  Modelica.Blocks.Sources.TimeTable timeTable3(table=[0.0,10; 40000,10; 40000,
        10; 100000,10])
    annotation (Placement(transformation(extent={{-80,80},{-60,100}})));
  Modelica.Fluid.Fittings.GenericResistances.VolumeFlowRate volumeFlowRate(
    a=100,
    b=10,
    redeclare package Medium = Modelica.Media.Water.ConstantPropertyLiquidWater)
          annotation (Placement(transformation(extent={{-12,70},{8,90}})));
equation
    t=time;
  connect(inlet_HTF.ports[1], iceStorageExternalMelt.port_a_HTF)
    annotation (Line(points={{-60,0},{-37.5,0}}, color={0,127,255}));
  connect(iceStorageExternalMelt.por_b_HTF, outlet_HTF.ports[1])
    annotation (Line(points={{37.5,0},{60,0}}, color={0,127,255}));
  connect(iceStorageExternalMelt.port_b_water, outlet_water.ports[1])
    annotation (Line(points={{0,-27.5},{0,-60},{-20,-60}}, color={0,127,255}));
  connect(fixedTemperature.port, iceStorageExternalMelt.port_b_Tambient)
    annotation (Line(points={{40,60},{27.5,60},{27.5,27.5}}, color={191,0,0}));
  connect(inlet_HTF_temperature.port, iceStorageExternalMelt.port_a_HTF)
    annotation (Line(points={{-50,20},{-50,0},{-37.5,0}}, color={0,127,255}));
  connect(outlet_HTF_temperature.port, iceStorageExternalMelt.por_b_HTF)
    annotation (Line(points={{50,20},{50,0},{37.5,0}}, color={0,127,255}));
  connect(timeTable2.y, inlet_water.T_in)
    annotation (Line(points={{-59,58},{-50,58},{-50,64},{-42,64}},
                                                 color={0,0,127}));
  connect(timeTable.y, inlet_HTF.T_in) annotation (Line(points={{-99,-18},{-90,
          -18},{-90,4},{-82,4}},color={0,0,127}));
  connect(timeTable1.y, inlet_HTF.m_flow_in) annotation (Line(points={{-99,32},
          {-90,32},{-90,8},{-80,8}}, color={0,0,127}));
  connect(timeTable3.y, inlet_water.m_flow_in) annotation (Line(points={{-59,90},
          {-48,90},{-48,68},{-40,68}}, color={0,0,127}));
  connect(inlet_water.ports[1], volumeFlowRate.port_a) annotation (Line(points=
          {{-20,60},{-16,60},{-16,80},{-12,80}}, color={0,127,255}));
  connect(volumeFlowRate.port_b, iceStorageExternalMelt.port_a_water)
    annotation (Line(points={{8,80},{14,80},{14,48},{0,48},{0,27.5}}, color={0,
          127,255}));
  annotation (Icon(coordinateSystem(preserveAspectRatio=false)), Diagram(
        coordinateSystem(preserveAspectRatio=false)));
end ISEM_TOTAL;
