within DCOL.ThermalStorage.LatentStorages.Testing;
model IceStorageExternalMelting_nSeg
  IceStorageExternalMelt_nSeg iceStorageExternalMelt_nSeg(
    L_coil=0.66673757545215,
    nSeg=10,
    T_Tube_start=-5 + 273.15,
    redeclare package Medium1 = Modelica_IK4_TEKNIKER.Media.Incompressible.Examples.EthyleneGlycol,
    redeclare package Material = Modelica_IK4_TEKNIKER.Thermal.Materials.Copper)
             annotation (Placement(transformation(extent={{-38,-24},{42,24}})));

  inner Modelica.Fluid.System system
    annotation (Placement(transformation(extent={{16,80},{36,100}})));
  Modelica.Fluid.Sources.FixedBoundary outlet_water(redeclare package Medium =
        Modelica.Media.Water.ConstantPropertyLiquidWater, nPorts=1) annotation (Placement(transformation(extent={{-40,-70},{-20,-50}})));
  Modelica.Fluid.Sources.MassFlowSource_T inlet_HTF(
    nPorts=1,
    m_flow=30,
    use_T_in=true,
    use_m_flow_in=true,
    T=263.15,
    redeclare package Medium = Modelica_IK4_TEKNIKER.Media.Incompressible.Examples.EthyleneGlycol)
    annotation (Placement(transformation(extent={{-80,-10},{-60,10}})));
  Modelica.Fluid.Sources.MassFlowSource_T inlet_water(
    redeclare package Medium = Modelica.Media.Water.ConstantPropertyLiquidWater,
    nPorts=1,
    m_flow=10,
    use_T_in=true,
    use_m_flow_in=true,
    T=283.15) annotation (Placement(transformation(extent={{-40,50},{-20,70}})));

  Modelica.Fluid.Sources.FixedBoundary outlet_HTF(
                                     nPorts=1, redeclare package Medium =
        Modelica_IK4_TEKNIKER.Media.Incompressible.Examples.EthyleneGlycol)
    annotation (Placement(transformation(extent={{80,-10},{60,10}})));
  Modelica.Thermal.HeatTransfer.Sources.FixedTemperature fixedTemperature(T=
        293.15) annotation (Placement(transformation(extent={{60,50},{40,70}})));
  Modelica.Fluid.Sensors.Temperature inlet_HTF_temperature(redeclare package Medium =
               Modelica_IK4_TEKNIKER.Media.Incompressible.Examples.EthyleneGlycol)
    annotation (Placement(transformation(extent={{-60,20},{-40,40}})));
  Modelica.Fluid.Sensors.Temperature outlet_HTF_temperature(redeclare package Medium =
               Modelica_IK4_TEKNIKER.Media.Incompressible.Examples.EthyleneGlycol)
    annotation (Placement(transformation(extent={{40,20},{60,40}})));
  Modelica.Blocks.Sources.TimeTable timeTable(table=[0.0,-9 + 273.15; 100,-9 +
        273.15])
    annotation (Placement(transformation(extent={{-120,-18},{-100,2}})));
  Modelica.Blocks.Sources.TimeTable timeTable1(table=[0.0,300; 10,300; 10,0;
        100,0])
    annotation (Placement(transformation(extent={{-120,10},{-100,30}})));
  Modelica.Blocks.Sources.TimeTable timeTable2(table=[0.0,10 + 273.15; 40,10 +
        273.15; 40,20 + 273.15; 100,20 + 273.15])
    annotation (Placement(transformation(extent={{-80,50},{-60,70}})));
  Modelica.Blocks.Sources.TimeTable timeTable3(table=[0.0,100; 10,100; 10,0; 50,
        0; 50,100; 100,100])
    annotation (Placement(transformation(extent={{-80,80},{-60,100}})));
equation
  connect(inlet_HTF.ports[1], iceStorageExternalMelt_nSeg.port_a_HTF)
    annotation (Line(points={{-60,0},{-28,0}}, color={0,127,255}));
  connect(iceStorageExternalMelt_nSeg.por_b_HTF, outlet_HTF.ports[1])
    annotation (Line(points={{32,0},{60,0}}, color={0,127,255}));
  connect(inlet_water.ports[1], iceStorageExternalMelt_nSeg.port_a_water)
    annotation (Line(points={{-20,60},{2,60},{2,22}}, color={0,127,255}));
  connect(iceStorageExternalMelt_nSeg.port_b_water, outlet_water.ports[1])
    annotation (Line(points={{2,-22},{2,-60},{-20,-60}}, color={0,127,255}));
  connect(fixedTemperature.port, iceStorageExternalMelt_nSeg.port_b_Tambient)
    annotation (Line(points={{40,60},{24,60},{24,22}}, color={191,0,0}));
  connect(inlet_HTF_temperature.port, iceStorageExternalMelt_nSeg.port_a_HTF)
    annotation (Line(points={{-50,20},{-50,0},{-28,0}}, color={0,127,255}));
  connect(outlet_HTF_temperature.port, iceStorageExternalMelt_nSeg.por_b_HTF)
    annotation (Line(points={{50,20},{50,0},{32,0}}, color={0,127,255}));
  connect(timeTable3.y, inlet_water.m_flow_in) annotation (Line(points={{-59,90},
          {-50,90},{-50,68},{-40,68}}, color={0,0,127}));
  connect(timeTable2.y, inlet_water.T_in) annotation (Line(points={{-59,60},{
          -50,60},{-50,64},{-42,64}}, color={0,0,127}));
  connect(timeTable1.y, inlet_HTF.m_flow_in) annotation (Line(points={{-99,20},
          {-90,20},{-90,8},{-80,8}}, color={0,0,127}));
  connect(timeTable.y, inlet_HTF.T_in) annotation (Line(points={{-99,-8},{-90,
          -8},{-90,4},{-82,4}}, color={0,0,127}));
  annotation (Icon(coordinateSystem(preserveAspectRatio=false)), Diagram(
        coordinateSystem(preserveAspectRatio=false)));
end IceStorageExternalMelting_nSeg;
