within DCOL.ThermalStorage.LatentStorages.Testing;
model IceStorageExternalMelting_nSegnCoilp

  inner Modelica.Fluid.System system
    annotation (Placement(transformation(extent={{16,80},{36,100}})));
  Modelica.Fluid.Sources.FixedBoundary outlet_water(redeclare package Medium =
        Modelica.Media.Water.ConstantPropertyLiquidWater, nPorts=1)
    annotation (Placement(transformation(extent={{-40,-70},{-20,-50}})));
  IceStorageExternalMelt_nSegnCoilp iceStorageExternalMelt(
    T_Tube_start=-10 + 273.15,
    redeclare package Medium1 = Modelica_IK4_TEKNIKER.Media.Incompressible.Examples.EthyleneGlycol,
    L_coil=0.66673757545215,
    redeclare package Material = Modelica_IK4_TEKNIKER.Thermal.Materials.Copper,
    nSeg=10,
    nCoilp=100)
    annotation (Placement(transformation(extent={{-50,-30},{50,30}})));
  Modelica.Fluid.Sources.MassFlowSource_T inlet_HTF(
    nPorts=1,
    m_flow=30,
    use_T_in=true,
    use_m_flow_in=true,
    T=263.15,
    redeclare package Medium = Modelica_IK4_TEKNIKER.Media.Incompressible.Examples.EthyleneGlycol)
    annotation (Placement(transformation(extent={{-80,-10},{-60,10}})));
  Modelica.Fluid.Sources.MassFlowSource_T inlet_water(
    redeclare package Medium = Modelica.Media.Water.ConstantPropertyLiquidWater,
    m_flow=10,
    use_T_in=true,
    use_m_flow_in=true,
    T=283.15,
    nPorts=1) annotation (Placement(transformation(extent={{-40,50},{-20,70}})));

  Modelica.Fluid.Sources.FixedBoundary outlet_HTF(
                                     nPorts=1, redeclare package Medium =
        Modelica_IK4_TEKNIKER.Media.Incompressible.Examples.EthyleneGlycol)
    annotation (Placement(transformation(extent={{80,-10},{60,10}})));
  Modelica.Thermal.HeatTransfer.Sources.FixedTemperature fixedTemperature(T=
        293.15) annotation (Placement(transformation(extent={{60,50},{40,70}})));
  Modelica.Fluid.Sensors.Temperature inlet_HTF_temperature(redeclare package Medium =
               Modelica_IK4_TEKNIKER.Media.Incompressible.Examples.EthyleneGlycol)
    annotation (Placement(transformation(extent={{-60,20},{-40,40}})));
  Modelica.Fluid.Sensors.Temperature outlet_HTF_temperature(redeclare package Medium =
               Modelica_IK4_TEKNIKER.Media.Incompressible.Examples.EthyleneGlycol)
    annotation (Placement(transformation(extent={{40,20},{60,40}})));
  Modelica.Blocks.Sources.TimeTable timeTable(table=[0.0,-9 + 273.15; 28000,-9
         + 273.15])
    annotation (Placement(transformation(extent={{-120,-20},{-100,0}})));
  Modelica.Blocks.Sources.TimeTable timeTable2(table=[0.0,10 + 273.15; 4000,10
         + 273.15; 4000,10 + 273.15; 28000,10 + 273.15])
    annotation (Placement(transformation(extent={{-80,50},{-60,70}})));
  Modelica.Blocks.Sources.TimeTable timeTable1(table=[0.0,3000; 20000,3000;
        20000,0.0; 28000,0.0])
    annotation (Placement(transformation(extent={{-120,10},{-100,30}})));
  Modelica.Blocks.Sources.TimeTable timeTable3(table=[0.0,0; 5000,0; 5000,0;
        20000,0; 20000,5; 28000,5])
    annotation (Placement(transformation(extent={{-78,80},{-58,100}})));
equation
  connect(inlet_HTF.ports[1], iceStorageExternalMelt.port_a_HTF)
    annotation (Line(points={{-60,0},{-37.5,0}}, color={0,127,255}));
  connect(iceStorageExternalMelt.por_b_HTF, outlet_HTF.ports[1])
    annotation (Line(points={{37.5,0},{60,0}}, color={0,127,255}));
  connect(fixedTemperature.port, iceStorageExternalMelt.port_b_Tambient)
    annotation (Line(points={{40,60},{27.5,60},{27.5,27.5}}, color={191,0,0}));
  connect(inlet_HTF_temperature.port, iceStorageExternalMelt.port_a_HTF)
    annotation (Line(points={{-50,20},{-50,0},{-37.5,0}}, color={0,127,255}));
  connect(outlet_HTF_temperature.port, iceStorageExternalMelt.por_b_HTF)
    annotation (Line(points={{50,20},{50,0},{37.5,0}}, color={0,127,255}));
  connect(timeTable2.y, inlet_water.T_in)
    annotation (Line(points={{-59,60},{-50,60},{-50,64},{-42,64}},
                                                 color={0,0,127}));
  connect(timeTable.y, inlet_HTF.T_in) annotation (Line(points={{-99,-10},{-90,
          -10},{-90,4},{-82,4}},color={0,0,127}));
  connect(timeTable1.y, inlet_HTF.m_flow_in) annotation (Line(points={{-99,20},
          {-90,20},{-90,8},{-80,8}}, color={0,0,127}));
  connect(timeTable3.y, inlet_water.m_flow_in) annotation (Line(points={{-57,90},
          {-48,90},{-48,68},{-40,68}}, color={0,0,127}));
  connect(inlet_water.ports[1], iceStorageExternalMelt.port_a_water)
    annotation (Line(points={{-20,60},{0,60},{0,27.5}}, color={0,127,255}));
  connect(iceStorageExternalMelt.port_b_water, outlet_water.ports[1])
    annotation (Line(points={{0,-27.5},{0,-60},{-20,-60}}, color={0,127,255}));
  annotation (Icon(coordinateSystem(preserveAspectRatio=false)), Diagram(
        coordinateSystem(preserveAspectRatio=false)));
end IceStorageExternalMelting_nSegnCoilp;
