within DCOL.ThermalStorage.LatentStorages.Testing;
model IceStorageInternalMeltingnSegnCoilRecordTest

  Modelica.Thermal.HeatTransfer.Sources.FixedTemperature fixedTemperature(T=293.15) annotation (Placement(transformation(extent={{-40,60},
            {-20,80}})));

  inner Modelica.Fluid.System system annotation (Placement(transformation(extent={{60,72},{80,92}})));

  IceStorageInternalMeltnSegnCoilsRecord iceStorageInternalMelt(
    T_start_pipe=-15 + 273.15,
    redeclare package Material = Modelica_IK4_TEKNIKER.Thermal.Materials.AISI321,
    redeclare package Medium = Modelica.Media.Air.DryAirNasa,
    redeclare package Material1 =
        Modelica_IK4_TEKNIKER.Thermal.Materials.Etortek2013_TankInsolation,
    Charge_Percentage=80)
    annotation (Placement(transformation(extent={{-60,-40},{60,40}})));

  Modelica.Fluid.Sources.FixedBoundary boundary(
    nPorts=1, redeclare package Medium = Modelica.Media.Air.DryAirNasa)
                                                         annotation (Placement(transformation(extent={{100,-10},{80,10}})));

  Modelica.Fluid.Sources.MassFlowSource_T boundary1(
    m_flow=10,
    nPorts=1,
    redeclare package Medium = Modelica.Media.Air.DryAirNasa,
    use_T_in=true,
    use_m_flow_in=true,
    T=263.15) annotation (Placement(transformation(extent={{-98,-10},{-78,10}})));

  Modelica.Blocks.Sources.TimeTable HTF_Inlet_T(table=[0,-10 + 273.15; 100000,-10
         + 273.15; 100000,-10 + 273.15; 200000,-10 + 273.15; 200000,10 + 273.15;
        300000,10 + 273.15])
    annotation (Placement(transformation(extent={{-140,-6},{-120,14}})));

  Modelica.Fluid.Sensors.Temperature m_inlet_HTF_T(redeclare package Medium =
        Modelica.Media.Air.DryAirNasa)
    annotation (Placement(transformation(extent={{-80,20},{-60,40}})));

  Modelica.Fluid.Sensors.Temperature m_outlet_HTF_T(redeclare package Medium =
        Modelica.Media.Air.DryAirNasa)
    annotation (Placement(transformation(extent={{60,20},{80,40}})));

  Modelica.Blocks.Sources.TimeTable HTF_m_flow(table=[0,10; 100000,10; 100000,0;
        200000,0; 200000,10; 300000,10])
                        annotation (Placement(transformation(extent={{-130,24},
            {-110,44}})));
  Modelica.Thermal.HeatTransfer.Sources.FixedTemperature fixedTemperature1(T=283.15)
                                                                                    annotation (Placement(transformation(extent={{-72,-80},
            {-52,-60}})));
equation
  connect(fixedTemperature.port, iceStorageInternalMelt.port_b_Tambient)
    annotation (Line(points={{-20,70},{-20,70},{0,70},{0,36}}, color={191,0,0}));
  connect(boundary1.ports[1], iceStorageInternalMelt.port_a_HTF)
    annotation (Line(points={{-78,0},{-56.25,0}}, color={0,127,255}));
  connect(m_inlet_HTF_T.port, iceStorageInternalMelt.port_a_HTF) annotation (
      Line(points={{-70,20},{-70,20},{-70,0},{-56.25,0}}, color={0,127,255}));
  connect(iceStorageInternalMelt.port_b_HTF, boundary.ports[1]) annotation (Line(points={{56.25,0},{80,0}},         color={0,127,255}));
  connect(m_outlet_HTF_T.port,iceStorageInternalMelt.port_b_HTF)  annotation (
      Line(points={{70,20},{70,20},{70,0},{56.25,0}}, color={0,127,255}));

  connect(iceStorageInternalMelt.port_b_Tfloor, fixedTemperature1.port)
    annotation (Line(points={{-41.25,-36},{-41.25,-70},{-52,-70}}, color={191,0,
          0}));
  connect(HTF_Inlet_T.y, boundary1.T_in)
    annotation (Line(points={{-119,4},{-100,4}}, color={0,0,127}));
  connect(HTF_m_flow.y, boundary1.m_flow_in) annotation (Line(points={{-109,34},
          {-106,34},{-106,8},{-98,8}},  color={0,0,127}));
  annotation (Documentation(revisions="<html>
<p>2016-05-16 <a href=\"mailto: eduardo.ubieta@tekniker.es\">Eduardo Ubieta</a></a> (IK4-TEKNIKER): First implementation</p>
<p><b>Copyright &copy; <a href=\"http://www.tekniker.es/en\">IK4-TEKNIKER</a></b></p>
</html>"));
end IceStorageInternalMeltingnSegnCoilRecordTest;
