within DCOL.ThermalStorage.LatentStorages.Testing;
model IceStorageInternalMeltingnSegnCoilTest

  Modelica.Thermal.HeatTransfer.Sources.FixedTemperature fixedTemperature(T=293.15) annotation (Placement(transformation(extent={{-30,50},
            {-10,70}})));

  inner Modelica.Fluid.System system annotation (Placement(transformation(extent={{60,72},{80,92}})));

  IceStorageInternalMeltnSegnCoils iceStorageInternalMelt(
    redeclare package Medium = Modelica.Media.Air.DryAirNasa,
    redeclare package Material = Modelica_IK4_TEKNIKER.Thermal.Materials.AISI321,
    T_start_pipe=-15 + 273.15,
    redeclare package Material1 =
        Modelica_IK4_TEKNIKER.Thermal.Materials.Etortek2013_TankInsolation,
    Charge_Percentage=80)
    annotation (Placement(transformation(extent={{-60,-40},{60,40}})));

  Modelica.Fluid.Sources.FixedBoundary boundary(
    redeclare package Medium = Modelica.Media.Air.DryAirNasa,
    nPorts=1) annotation (Placement(transformation(extent={{100,-10},{80,10}})));

  Modelica.Fluid.Sources.MassFlowSource_T boundary1(
    redeclare package Medium = Modelica.Media.Air.DryAirNasa,
    use_T_in=true,
    nPorts=1,
    m_flow=10,
    use_m_flow_in=true,
    T=258.15) annotation (Placement(transformation(extent={{-100,-10},{-80,10}})));

  Modelica.Blocks.Sources.TimeTable timeTable(table=[0,263.15; 20000,263.15;
        20000,293.15; 200000,293.15])
                            annotation (Placement(transformation(extent={{-140,-6},{-120,14}})));

  Modelica.Fluid.Sensors.Temperature temperature(
    redeclare package Medium = Modelica.Media.Air.DryAirNasa) annotation (Placement(transformation(extent={{-80,20},
            {-60,40}})));

  Modelica.Fluid.Sensors.Temperature temperature1(
    redeclare package Medium =  Modelica.Media.Air.DryAirNasa) annotation (Placement(transformation(extent={{60,20},
            {80,40}})));

  Modelica.Thermal.HeatTransfer.Sources.FixedTemperature fixedTemperature1(T=283.15)
              annotation (Placement(transformation(extent={{-70,-70},{-50,-50}})));

  Modelica.Blocks.Sources.TimeTable timeTable1(table=[0,10; 100000,10; 100000,
        10; 200000,10]) annotation (Placement(transformation(extent={{-140,26},{-120,46}})));
equation
  connect(fixedTemperature.port, iceStorageInternalMelt.port_b_Tambient)
    annotation (Line(points={{-10,60},{-10,60},{0,60},{0,36}}, color={191,0,0}));
  connect(boundary1.ports[1], iceStorageInternalMelt.port_a_HTF)
    annotation (Line(points={{-80,0},{-56.25,0}}, color={0,127,255}));
  connect(boundary.ports[1], iceStorageInternalMelt.por_b_HTF)
    annotation (Line(points={{80,0},{80,0},{56.25,0}}, color={0,127,255}));
  connect(timeTable.y, boundary1.T_in) annotation (Line(points={{-119,4},{-102,4}}, color={0,0,127}));
  connect(temperature.port, iceStorageInternalMelt.port_a_HTF) annotation (Line(
        points={{-70,20},{-70,20},{-70,0},{-56.25,0}}, color={0,127,255}));
  connect(temperature1.port, iceStorageInternalMelt.por_b_HTF) annotation (Line(
        points={{70,20},{70,20},{70,0},{56.25,0}}, color={0,127,255}));

  connect(fixedTemperature1.port, iceStorageInternalMelt.port_b_Tfloor)
    annotation (Line(points={{-50,-60},{-50,-60},{-33.75,-60},{-33.75,-36}},
        color={191,0,0}));
  connect(timeTable1.y, boundary1.m_flow_in)
    annotation (Line(points={{-119,36},{-110,36},{-110,8},{-100,8}}, color={0,0,127}));
  annotation (Documentation(revisions="<html>
<p>2016-05-16 <a href=\"mailto: eduardo.ubieta@tekniker.es\">Eduardo Ubieta</a></a> (IK4-TEKNIKER): First implementation</p>
<p><b>Copyright &copy; <a href=\"http://www.tekniker.es/en\">IK4-TEKNIKER</a></b></p>
</html>"));
end IceStorageInternalMeltingnSegnCoilTest;
