within DCOL.ThermalStorage.LatentStorages.Testing;
model OneDimSemiInfComplet

  LatentStoragesNEW.IceVessel                                                            iceLiquidVessel(n_seg=
        n_seg,
    redeclare package Medium1 = Modelica_IK4_TEKNIKER.Media.Incompressible.Examples.EthyleneGlycol,
    redeclare package Material = Modelica_IK4_TEKNIKER.Thermal.Materials.Copper)                         annotation (Placement(transformation(extent={{-31,-14},
            {31,16}})));
  Modelica.Blocks.Sources.Trapezoid Qb_flow_trap[n_seg](
    each rising(displayUnit="min") = 300,
    each width(displayUnit="min") = 4200,
    each falling(displayUnit="min") = 300,
    each period(displayUnit="min") = 14400,
    each amplitude=-50e3/n_seg)
    annotation (Placement(transformation(extent={{-100,-76},{-80,-56}})));
  Modelica.Fluid.Sources.MassFlowSource_T boundary(
    nPorts=1,
    use_m_flow_in=true,
    redeclare package Medium = Modelica.Media.Water.ConstantPropertyLiquidWater,
    T=283.15) annotation (Placement(transformation(extent={{-40,40},{-20,60}})));
  Modelica.Blocks.Sources.Trapezoid m_flow_trap(
    period(displayUnit="min") = 14400,
    rising(displayUnit="min") = 300,
    width(displayUnit="min") = 4200,
    falling(displayUnit="min") = 300,
    startTime(displayUnit="min") = 6000,
    amplitude=10) annotation (Placement(transformation(extent={{-100,48},{-80,68}})));
  Modelica.Fluid.Sources.MassFlowSource_T boundary2(
    redeclare package Medium =
      Modelica.Media.Water.ConstantPropertyLiquidWater,
    use_m_flow_in=true,
    T=283.15,
    nPorts=1) annotation (Placement(transformation(extent={{38,-54},{18,-34}})));
  Modelica.Blocks.Sources.Trapezoid m_flow_trap_b(
    amplitude=-m_flow_trap.amplitude,
    rising(displayUnit="min") = m_flow_trap.rising,
    width(displayUnit="min") = m_flow_trap.width,
    falling(displayUnit="min") = m_flow_trap.falling,
    period(displayUnit="min") = m_flow_trap.period,
    startTime(displayUnit="min") = m_flow_trap.startTime) annotation (Placement(transformation(extent={{84,-46},
            {64,-26}})));
  Modelica.Thermal.HeatTransfer.Sources.FixedTemperature fixedTemperature(T=293.15)
    annotation (Placement(transformation(extent={{82,64},{62,84}})));
  parameter Integer n_seg=10 "Number of segments forming each coil";
  Modelica.Fluid.Sources.MassFlowSource_T inlet_HTF(
    nPorts=1,
    m_flow=30,
    use_T_in=true,
    use_m_flow_in=true,
    redeclare package Medium = Modelica_IK4_TEKNIKER.Media.Incompressible.Examples.EthyleneGlycol,
    T=263.15)
    annotation (Placement(transformation(extent={{-80,-10},{-60,10}})));
  Modelica.Blocks.Sources.TimeTable timeTable(table=[0.0,-9 + 273.15; 100000,-9
         + 273.15])
    annotation (Placement(transformation(extent={{-120,-28},{-100,-8}})));
  Modelica.Blocks.Sources.TimeTable timeTable1(table=[0.0,3000; 50000,3000; 50000,
        0; 100000,0])
    annotation (Placement(transformation(extent={{-124,12},{-104,32}})));
  Modelica.Fluid.Sensors.Temperature inlet_HTF_temperature(redeclare package Medium =
               Modelica_IK4_TEKNIKER.Media.Incompressible.Examples.EthyleneGlycol)
    annotation (Placement(transformation(extent={{-60,20},{-40,40}})));
  Modelica.Fluid.Sensors.Temperature outlet_HTF_temperature(redeclare package Medium =
               Modelica_IK4_TEKNIKER.Media.Incompressible.Examples.EthyleneGlycol)
    annotation (Placement(transformation(extent={{40,20},{60,40}})));
  Modelica.Fluid.Sources.FixedBoundary outlet_HTF(
                                     nPorts=1, redeclare package Medium =
        Modelica_IK4_TEKNIKER.Media.Incompressible.Examples.EthyleneGlycol)
    annotation (Placement(transformation(extent={{80,-10},{60,10}})));
equation

  for i in 1:iceLiquidVessel.n_seg loop
  end for;

  connect(boundary.ports[1], iceLiquidVessel.port_l_a) annotation (Line(points={{-20,50},
          {0,50},{0,9.75}},                                                                             color={0,127,255}));
  connect(m_flow_trap.y, boundary.m_flow_in) annotation (Line(points={{-79,58},{-40,58}}, color={0,0,127}));
  connect(iceLiquidVessel.port_l_b, boundary2.ports[1]) annotation (Line(points={{0,
          -10.25},{0,-44},{18,-44}},                                                                        color={0,127,255}));
  connect(m_flow_trap_b.y, boundary2.m_flow_in) annotation (Line(points={{63,-36},
          {38,-36}},                                                                         color={0,0,127}));

  connect(iceLiquidVessel.port_b_Tambient, fixedTemperature.port) annotation (
      Line(points={{21.3125,9.75},{21.3125,74},{62,74}}, color={191,0,0}));
  connect(timeTable.y,inlet_HTF. T_in) annotation (Line(points={{-99,-18},{-90,
          -18},{-90,4},{-82,4}},color={0,0,127}));
  connect(timeTable1.y,inlet_HTF. m_flow_in) annotation (Line(points={{-103,22},
          {-90,22},{-90,8},{-80,8}}, color={0,0,127}));
  connect(iceLiquidVessel.por_HTF_b, outlet_HTF_temperature.port) annotation (
      Line(points={{29.0625,-0.25},{37.125,-0.25},{37.125,20},{50,20}}, color={
          0,127,255}));
  connect(iceLiquidVessel.por_HTF_b, outlet_HTF.ports[1]) annotation (Line(
        points={{29.0625,-0.25},{41.125,-0.25},{41.125,0},{60,0}}, color={0,127,
          255}));
  connect(inlet_HTF.ports[1], iceLiquidVessel.port_HTF_a) annotation (Line(
        points={{-60,0},{-42,0},{-42,-0.25},{-29.0625,-0.25}}, color={0,127,255}));
  connect(iceLiquidVessel.port_HTF_a, inlet_HTF_temperature.port) annotation (
      Line(points={{-29.0625,-0.25},{-36.125,-0.25},{-36.125,20},{-50,20}},
        color={0,127,255}));
end OneDimSemiInfComplet;
