within DCOL.ThermalStorage.LatentStorages.Testing;
model Test_externalMeltnSeg
  import Modelica_IK4_TEKNIKER;

  parameter Integer nSeg=1 "Number of segments dividing the coil";
  Real t;

  Modelica_IK4_TEKNIKER.DCOL.ThermalStorage.LatentStorages.BaseClasses.ExternalMelt_nSegNCoilp
    pruebas_externalMelt(
    redeclare package Medium = Modelica.Media.Water.ConstantPropertyLiquidWater,
    Charge_Percentage=90,
    nSeg=nSeg,
    nCoilp=10,
    L_coil=0.72769643949)
    annotation (Placement(transformation(extent={{-40,-22},{40,18}})));

  Modelica.Thermal.HeatTransfer.Components.ThermalConductor thermalConductor[nSeg](G=10000)
    annotation (Placement(transformation(extent={{-40,-4},{-60,16}})));
  Modelica.Thermal.HeatTransfer.Sources.PrescribedTemperature fixedTemperature[nSeg]
    annotation (Placement(transformation(extent={{-100,-4},{-80,16}})));
  inner Modelica.Fluid.System system
    annotation (Placement(transformation(extent={{64,74},{84,94}})));
  Modelica.Fluid.Sources.FixedBoundary outlet_water_PCM(redeclare package Medium =
               Modelica.Media.Water.ConstantPropertyLiquidWater, nPorts=1)
    annotation (Placement(transformation(extent={{-40,-60},{-20,-40}})));
  Modelica.Fluid.Sources.MassFlowSource_T inlet_Water_PCM(
    m_flow=10,
    redeclare package Medium = Modelica.Media.Water.ConstantPropertyLiquidWater,
    use_T_in=true,
    nPorts=1,
    use_m_flow_in=true,
    T=283.15) annotation (Placement(transformation(extent={{-40,40},{-20,60}})));

  Modelica.Fluid.Sensors.Temperature outlet_temperature(redeclare package Medium =
               Modelica.Media.Water.ConstantPropertyLiquidWater)
    annotation (Placement(transformation(extent={{20,-50},{40,-30}})));
  Modelica.Fluid.Sensors.Temperature inlet_temperature(redeclare package Medium =
        Modelica.Media.Water.ConstantPropertyLiquidWater)
    annotation (Placement(transformation(extent={{20,50},{40,70}})));
  Modelica.Thermal.HeatTransfer.Components.ThermalConductor thermalConductor1[nSeg](G=2)
    annotation (Placement(transformation(extent={{70,4},{50,24}})));
  Modelica.Thermal.HeatTransfer.Sources.FixedTemperature fixedTemperature1[nSeg](T=293.15)
    annotation (Placement(transformation(extent={{100,4},{80,24}})));
  Modelica.Blocks.Sources.TimeTable timeTable(table=[0.0,-10 + 273.15; 200,-10
         + 273.15; 200,0 + 273.15; 400,0 + 273.15])
    annotation (Placement(transformation(extent={{-140,-4},{-120,16}})));
  Modelica.Blocks.Sources.TimeTable timeTable2(table=[0.0,10 + 273.15; 200,10
         + 273.15; 200,20 + 273.15; 400,20 + 273.15])
    annotation (Placement(transformation(extent={{-84,42},{-64,62}})));
  Modelica.Blocks.Sources.TimeTable timeTable1(table=[0.0,0; 200,0; 200,10; 400,
        10])
    annotation (Placement(transformation(extent={{-84,74},{-64,94}})));
equation
  t=time;
  if time<200 then
    pruebas_externalMelt.Charging = true;
  else
    pruebas_externalMelt.Charging = false;
  end if;

  connect(timeTable2.y, inlet_Water_PCM.T_in)
    annotation (Line(points={{-63,52},{-52,52},{-52,54},{-42,54}},
                                                 color={0,0,127}));
  for i in 1:nSeg loop
    connect(timeTable.y, fixedTemperature[i].T) annotation (Line(points={{-119,6},
            {-102,6}},                                                                       color={0,0,127}));
  end for;

  connect(inlet_Water_PCM.ports[1], pruebas_externalMelt.port_a_water)
    annotation (Line(points={{-20,50},{0,50},{0,18}}, color={0,127,255}));
  connect(inlet_temperature.port, pruebas_externalMelt.port_a_water)
    annotation (Line(points={{30,50},{0,50},{0,18},{0,18}}, color={0,127,255}));
  connect(outlet_water_PCM.ports[1], pruebas_externalMelt.port_b_water)
    annotation (Line(points={{-20,-50},{0,-50},{0,-22}}, color={0,127,255}));
  connect(outlet_temperature.port, pruebas_externalMelt.port_b_water)
    annotation (Line(points={{30,-50},{0,-50},{0,-22}}, color={0,127,255}));

  connect(fixedTemperature.port, thermalConductor.port_b)
    annotation (Line(points={{-80,6},{-60,6}}, color={191,0,0}));
  connect(thermalConductor.port_a, pruebas_externalMelt.port_a_heatToHTF)
    annotation (Line(points={{-40,6},{-20,6}}, color={191,0,0}));
  connect(thermalConductor1.port_b, pruebas_externalMelt.port_a_heatToAmbient)
    annotation (Line(points={{50,14},{30,14}}, color={191,0,0}));
  connect(fixedTemperature1.port, thermalConductor1.port_a)
    annotation (Line(points={{80,14},{70,14}}, color={191,0,0}));
  connect(timeTable1.y, inlet_Water_PCM.m_flow_in)
    annotation (Line(points={{-63,84},{-52,84},{-52,58},{-40,58}}, color={0,0,127}));
  annotation (Icon(coordinateSystem(preserveAspectRatio=false)), Diagram(
        coordinateSystem(preserveAspectRatio=false)));
end Test_externalMeltnSeg;
