within DCOL.ThermalStorage.LatentStorages.Testing;
model Test_externalMeltnSeg2
  import Modelica_IK4_TEKNIKER;

  parameter Integer nSeg=10 "Number of segments dividing the coil";
  Real t;

  Modelica_IK4_TEKNIKER.Obsolete.DCOL.Generation.LatentStorages.BaseClasses.IceLiquidVessel1
    l(nSeg=nSeg, T_start=283.15)
    annotation (Placement(transformation(extent={{-40,-22},{40,18}})));

  Modelica.Thermal.HeatTransfer.Components.ThermalConductor thermalConductor[nSeg](G=100)
    annotation (Placement(transformation(extent={{-40,-2},{-60,18}})));
  Modelica.Thermal.HeatTransfer.Sources.PrescribedTemperature fixedTemperature[nSeg]
    annotation (Placement(transformation(extent={{-100,-2},{-80,18}})));
  inner Modelica.Fluid.System system
    annotation (Placement(transformation(extent={{64,74},{84,94}})));
  Modelica.Fluid.Sources.FixedBoundary outlet_water_PCM(redeclare package Medium =
               Modelica.Media.Water.ConstantPropertyLiquidWater, nPorts=1)
    annotation (Placement(transformation(extent={{-40,-60},{-20,-40}})));
  Modelica.Fluid.Sources.MassFlowSource_T inlet_Water_PCM(
    m_flow=10,
    redeclare package Medium = Modelica.Media.Water.ConstantPropertyLiquidWater,
    use_T_in=true,
    nPorts=1,
    use_m_flow_in=true,
    T=283.15) annotation (Placement(transformation(extent={{-40,40},{-20,60}})));

  Modelica.Fluid.Sensors.Temperature outlet_temperature(redeclare package Medium =
               Modelica.Media.Water.ConstantPropertyLiquidWater)
    annotation (Placement(transformation(extent={{20,-50},{40,-30}})));
  Modelica.Fluid.Sensors.Temperature inlet_temperature(redeclare package Medium =
        Modelica.Media.Water.ConstantPropertyLiquidWater)
    annotation (Placement(transformation(extent={{20,50},{40,70}})));
  Modelica.Blocks.Sources.TimeTable timeTable(table=[0.0,-10 + 273.15; 40000,-10 + 273.15; 40000,
        0 + 273.15; 80000,0 + 273.15])
    annotation (Placement(transformation(extent={{-140,-2},{-120,18}})));
  Modelica.Blocks.Sources.TimeTable timeTable2(table=[0.0,20 + 273.15; 40000,20 + 273.15; 40000,
        20 + 273.15; 80000,20 + 273.15])
    annotation (Placement(transformation(extent={{-84,42},{-64,62}})));
  Modelica.Blocks.Sources.TimeTable timeTable1(table=[0.0,0; 40000,0; 40000,10; 80000,10])
    annotation (Placement(transformation(extent={{-84,74},{-64,94}})));
equation
  t=time;
  if time<400 then
    l.Charging = true;
  else
    l.Charging = false;
  end if;

  connect(timeTable2.y, inlet_Water_PCM.T_in)  annotation (Line(points={{-63,52},{-52,52},{-52,54},{-42,54}},
                                                 color={0,0,127}));
  for i in 1:nSeg loop
    connect(timeTable.y, fixedTemperature[i].T) annotation (Line(points={{-119,8},{-102,8}}, color={0,0,127}));
  end for;

  connect(timeTable1.y, inlet_Water_PCM.m_flow_in) annotation (Line(points={{-63,84},{-52,84},{-52,58},{-40,58}}, color={0,0,127}));
  connect(inlet_Water_PCM.ports[1], l.port_l_a) annotation (Line(points={{-20,50},{0,50},{0,16}}, color={0,127,255}));
  connect(l.port_l_b, outlet_water_PCM.ports[1]) annotation (Line(points={{0.4,-20},{0.4,-50},{-20,-50}}, color={0,127,255}));
  connect(inlet_temperature.port, l.port_l_a) annotation (Line(points={{30,50},{0,50},{0,16},{0,16}}, color={0,127,255}));
  connect(outlet_temperature.port, l.port_l_b) annotation (Line(points={{30,-50},{16,-50},{16,-20},
          {0.4,-20}}, color={0,127,255}));
  connect(fixedTemperature.port, thermalConductor.port_b) annotation (Line(points={{-80,8},{-60,8}}, color={191,0,0}));
  connect(thermalConductor.port_a, l.heatPort) annotation (Line(points={{-40,8},{-30,8},{-30,8},{-18,8}}, color={191,0,0}));
  annotation (Icon(coordinateSystem(preserveAspectRatio=false)), Diagram(
        coordinateSystem(preserveAspectRatio=false)));
end Test_externalMeltnSeg2;
