within DCOL.ThermalStorage.LatentStorages.Testing;
model Test_externalMeltnSeg_edu2
  import Modelica_IK4_TEKNIKER;

  parameter Integer nSeg=1 "Number of segments dividing the coil";

  Modelica_IK4_TEKNIKER.DCOL.ThermalStorage.LatentStorages.BaseClasses.IceWaterVessel_edu2 externalMelt(
    nSeg=nSeg,
    h_l=15000,
    port_a(h_outflow(start=85000)),
    L_coil=0.66)
    annotation (Placement(transformation(extent={{-40,-20},{40,20}})));

  Modelica_IK4_TEKNIKER.Obsolete.DCOL.Generation.LatentStorages.BaseClasses.ThermalConductorInputthermalConduction
                                                            thermalConductor[nSeg]
    annotation (Placement(transformation(extent={{10,-10},{-10,10}},
        rotation=90,
        origin={-46,-2})));
  Modelica.Thermal.HeatTransfer.Sources.PrescribedTemperature fixedTemperature[nSeg] annotation (Placement(transformation(extent={{-70,-40},{-50,-20}})));

  inner Modelica.Fluid.System system annotation (Placement(transformation(extent={{-100,-100},{-80,
            -80}})));

  Modelica.Fluid.Sources.FixedBoundary outlet_water_PCM(
    redeclare package Medium = Modelica.Media.Water.ConstantPropertyLiquidWater,
    nPorts=1,
    T=274.15) annotation (Placement(transformation(extent={{-60,-80},{-40,-60}})));

  Modelica.Fluid.Sources.MassFlowSource_T inlet_Water_PCM(
    m_flow=10,
    use_T_in=true,
    nPorts=1,
    use_m_flow_in=true,
    redeclare package Medium = Modelica.Media.Water.ConstantPropertyLiquidWater,
    T=283.15) annotation (Placement(transformation(extent={{-40,20},{-20,40}})));

  Modelica.Fluid.Sensors.Temperature outlet_temperature(
    redeclare package Medium = Modelica.Media.Water.ConstantPropertyLiquidWater) annotation (Placement(transformation(extent={{20,-50},{40,-30}})));

  Modelica.Fluid.Sensors.Temperature inlet_temperature(
    redeclare package Medium = Modelica.Media.Water.ConstantPropertyLiquidWater) annotation (Placement(transformation(extent={{20,30},{40,50}})));

  Modelica.Blocks.Sources.TimeTable timeTable(table=[0.0,-10 + 273.15; 495,-10
         + 273.15; 495,-10 + 273.15; 1000,-10 + 273.15])                              annotation (Placement(transformation(extent={{-100,-40},{-80,-20}})));

  Modelica.Blocks.Sources.TimeTable timeTable2(table=[0.0,20 + 273.15; 400,20
         + 273.15; 400,20 + 273.15; 1000,20 + 273.15])                             annotation (Placement(transformation(extent={{-100,20},
            {-80,40}})));

  Modelica.Blocks.Sources.TimeTable timeTable1(table=[0.0,0; 500,0; 500,1; 1000,
        1])                                           annotation (Placement(transformation(extent={{-90,60},
            {-70,80}})));
equation

  for i in 1:nSeg loop
    if time<495 then
      thermalConductor[i].G=1000;
    else
      thermalConductor[i].G=0;
    end if;
  end for;

  for i in 1:nSeg loop
      connect(timeTable.y, fixedTemperature[i].T) annotation (Line(points={{-79,-30},{-72,-30}},
                                                                                             color={0,0,127}));
  end for;

  connect(fixedTemperature.port, thermalConductor.port_b) annotation (Line(points={{-50,-30},{-46,-30},{-46,-12}},
                                                                                                     color={191,0,0}));
  connect(thermalConductor.port_a, externalMelt.heatPort)
    annotation (Line(points={{-46,8},{-46,10},{-18,10}},         color={191,0,0}));
  connect(inlet_Water_PCM.ports[1], externalMelt.port_a)
    annotation (Line(points={{-20,30},{0,30},{0,18}},            color={0,127,255}));
  connect(inlet_temperature.port, externalMelt.port_a)
    annotation (Line(points={{30,30},{0,30},{0,18}},          color={0,127,255}));
  connect(outlet_water_PCM.ports[1], externalMelt.port_b) annotation (Line(points={{-40,-70},{0,
          -70},{0,-18}},           color={0,127,255}));
  connect(outlet_temperature.port, externalMelt.port_b)
    annotation (Line(points={{30,-50},{0,-50},{0,-18}},           color={0,127,255}));
  connect(timeTable2.y, inlet_Water_PCM.T_in)  annotation (Line(points={{-79,30},{-50,30},{-50,34},
          {-42,34}},                             color={0,0,127}));
  connect(timeTable1.y, inlet_Water_PCM.m_flow_in) annotation (Line(points={{-69,70},{-50,70},{-50,
          38},{-40,38}},                                                                                          color={0,0,127}));

  annotation (Icon(coordinateSystem(preserveAspectRatio=false)), Diagram(
        coordinateSystem(preserveAspectRatio=false)));
end Test_externalMeltnSeg_edu2;
