within DCOL.ThermalStorage.LatentStorages.Testing;
model Test_externalMeltnSeg_tato
  import Modelica_IK4_TEKNIKER;

  parameter Integer nSeg=10 "Number of segments dividing the coil";

  Modelica_IK4_TEKNIKER.DCOL.ThermalStorage.LatentStorages.BaseClasses.IceWaterVessel
    externalMelt(
    nSeg=nSeg,
    m=externalMelt.m_l_start,
    T_l_start=293.15,
    T_s_start=273.15)
    annotation (Placement(transformation(extent={{-38,-22},{42,18}})));

  Modelica.Thermal.HeatTransfer.Components.ThermalConductor thermalConductor[nSeg](each G=
        100)
    annotation (Placement(transformation(extent={{10,-10},{-10,10}},
        rotation=90,
        origin={-46,-2})));
  Modelica.Thermal.HeatTransfer.Sources.PrescribedTemperature fixedTemperature[nSeg]
    annotation (Placement(transformation(extent={{-70,-40},{-50,-20}})));
  inner Modelica.Fluid.System system
    annotation (Placement(transformation(extent={{-100,-100},{-80,-80}})));
  Modelica.Fluid.Sources.FixedBoundary outlet_water_PCM(redeclare package Medium =
               Modelica.Media.Water.ConstantPropertyLiquidWater, nPorts=1)
    annotation (Placement(transformation(extent={{-40,-60},{-20,-40}})));
  Modelica.Fluid.Sources.MassFlowSource_T inlet_Water_PCM(
    m_flow=10,
    redeclare package Medium = Modelica.Media.Water.ConstantPropertyLiquidWater,
    use_T_in=true,
    nPorts=1,
    use_m_flow_in=true,
    T=283.15) annotation (Placement(transformation(extent={{-40,20},{-20,40}})));

  Modelica.Fluid.Sensors.Temperature outlet_temperature(redeclare package Medium =
               Modelica.Media.Water.ConstantPropertyLiquidWater)
    annotation (Placement(transformation(extent={{20,-50},{40,-30}})));
  Modelica.Fluid.Sensors.Temperature inlet_temperature(redeclare package Medium =
        Modelica.Media.Water.ConstantPropertyLiquidWater)
    annotation (Placement(transformation(extent={{20,20},{40,40}})));
  Modelica.Blocks.Sources.TimeTable timeTable(table=[0.0,-10 + 273.15; 40000,-10 + 273.15; 40000,
        0 + 273.15; 80000,0 + 273.15])
    annotation (Placement(transformation(extent={{-100,-40},{-80,-20}})));
  Modelica.Blocks.Sources.TimeTable timeTable2(table=[0.0,20 + 273.15; 40000,20 + 273.15; 40000,
        20 + 273.15; 80000,20 + 273.15])
    annotation (Placement(transformation(extent={{-80,20},{-60,40}})));
  Modelica.Blocks.Sources.TimeTable timeTable1(table=[0.0,0; 40000,0; 40000,10; 80000,10])
    annotation (Placement(transformation(extent={{-80,60},{-60,80}})));
equation

  connect(timeTable2.y, inlet_Water_PCM.T_in)  annotation (Line(points={{-59,30},{-52,30},{-52,34},{-42,34}},
                                                 color={0,0,127}));
  for i in 1:nSeg loop
    connect(timeTable.y, fixedTemperature[i].T) annotation (Line(points={{-79,-30},{-72,-30}},
                                                                                             color={0,0,127}));
  end for;

  connect(timeTable1.y, inlet_Water_PCM.m_flow_in) annotation (Line(points={{-59,70},{-52,70},{-52,38},{-40,38}}, color={0,0,127}));
  connect(fixedTemperature.port, thermalConductor.port_b) annotation (Line(points={{-50,-30},{-46,-30},{-46,-12}},
                                                                                                     color={191,0,0}));
  connect(thermalConductor.port_a, externalMelt.heatPort)
    annotation (Line(points={{-46,8},{-16,8}}, color={191,0,0}));
  connect(inlet_Water_PCM.ports[1], externalMelt.port_a) annotation (Line(
        points={{-20,30},{-10,30},{-10,16},{2,16}}, color={0,127,255}));
  connect(inlet_temperature.port, externalMelt.port_a) annotation (Line(points=
          {{30,20},{16,20},{16,16},{2,16}}, color={0,127,255}));
  connect(outlet_water_PCM.ports[1], externalMelt.port_b) annotation (Line(
        points={{-20,-50},{-10,-50},{-10,-20},{2.4,-20}}, color={0,127,255}));
  connect(outlet_temperature.port, externalMelt.port_b) annotation (Line(points=
         {{30,-50},{16,-50},{16,-20},{2.4,-20}}, color={0,127,255}));
  annotation (Icon(coordinateSystem(preserveAspectRatio=false)), Diagram(
        coordinateSystem(preserveAspectRatio=false)));
end Test_externalMeltnSeg_tato;
