within DCOL.ThermalStorage.LatentStoragesNEW.FMI;
model ExternalLS_fmu
// Model automatically generated by Dymola from FMI model description
public
  type Modelica_IK4_TEKNIKER_DCOL_ThermalStorage_LatentStoragesNEW_FMI_RealConectors_RealInternalEnergy = Real (unit = "J", quantity = "Energy");
  type Modelica_IK4_TEKNIKER_DCOL_ThermalStorage_LatentStoragesNEW_FMI_RealConectors_RealMassFlowInput = Real (unit = "kg/s", quantity = "MassFlowRate");
  type Modelica_IK4_TEKNIKER_DCOL_ThermalStorage_LatentStoragesNEW_FMI_RealConectors_RealMassFractionOutput = Real (quantity = "MassFraction", min = 0.0, max = 1.0);
  type Modelica_IK4_TEKNIKER_DCOL_ThermalStorage_LatentStoragesNEW_FMI_RealConectors_RealTemperatureInput = Real (unit = "K", displayUnit = "degC", nominal = 300.0, quantity = "ThermodynamicTemperature", min = 0.0);
  type Modelica_IK4_TEKNIKER_DCOL_ThermalStorage_LatentStoragesNEW_FMI_RealConectors_RealTemperatureOutput = Real (unit = "K", displayUnit = "degC", nominal = 300.0, quantity = "ThermodynamicTemperature", min = 0.0);
protected
  record 'system_rec'
    parameter Modelica.SIunits.AbsolutePressure p_ambient = 101325
                                                                  "Default ambient pressure";
    parameter Modelica.SIunits.Temperature T_ambient = 293.15
                                                             "Default ambient temperature";
    parameter Modelica.SIunits.Acceleration g = 9.80665
                                                       "Constant gravity acceleration";
    parameter Real eps_m_flow(min = 0.0) = 0.0001
                                                 "Regularization of zero flow for |m_flow| < eps_m_flow*m_flow_nominal";
    parameter Modelica.SIunits.AbsolutePressure dp_small = 1
                                                            "Default small pressure drop for regularization of laminar and zero flow";
    parameter Modelica.SIunits.MassFlowRate m_flow_small(min = 0.0) = 0.01
                                                                          "Default small mass flow rate for regularization of laminar and zero flow";
  end 'system_rec';
public
  'system_rec' 'system' annotation(Dialog);
  parameter Modelica.SIunits.ThermalConductivity k_s = 2.16
                                                           "Thermal conductivity of the solid water";
  parameter Modelica.SIunits.ThermalConductivity k_l = 0.556
                                                            "Thermal conductivity of the liquid water";
  parameter Modelica.SIunits.Density d_s = 916.7
                                                "Density of the solid water";
  parameter Modelica.SIunits.Density d_l = 999.8
                                                "Density of the liquid water";
  parameter Modelica.SIunits.SpecificHeatCapacity cp_s = 2110
                                                             "Specific heat capacity of the solid water";
  parameter Modelica.SIunits.SpecificHeatCapacity cp_l = 4184
                                                             "Specific heat capacity of the liquid water";
  parameter Modelica.SIunits.DynamicViscosity mu = 0.00179
                                                          "Dynamic viscosity of the solid water";
  parameter Modelica.SIunits.Temperature T0 = 273.15
                                                    "Reference temperature";
  parameter Modelica.SIunits.SpecificEnthalpy hfus = 333550.0
                                                             "Phase change enthalpy";
  parameter Modelica.SIunits.CoefficientOfHeatTransfer h_l = 568.4
                                                                  "Convection heat transfer coefficient of liquid water when static";
  parameter Modelica.SIunits.Radius r_int = 0.018
                                                 "Inner radius of cylinder";
  parameter Modelica.SIunits.Length S_L = 0.15
                                              "Horizontal separation between coils";
  parameter Integer n_T = 15
                            "Vertical number of coils";
  parameter Integer n_L = 10
                            "Horizontal number of coils";
  parameter Modelica.SIunits.MassFlowRate m_flow_start = 5
                                                          "Initial mass flow";
protected
  record iceLiquidVessel_rec
  protected
    record pipe_rec
      parameter Modelica.SIunits.Height roughness = 2.5E-005
                                                            "Average height of surface asperities (default: smooth steel pipe)";
      parameter Real 'X_start[1]'(nominal = 0.1, quantity = "MassFraction", min = 0.0, max = 1.0) = 1.0
                                                                                                       "Start value of mass fractions m_i/m";
    protected
      record flowModel_rec
        parameter Modelica.SIunits.ReynoldsNumber Re_turbulent = 4000
                                                                     "Start of turbulent regime, depending on type of flow device";
        parameter Modelica.SIunits.AbsolutePressure dp_nominal = 100000
                                                                       "Nominal pressure loss";
        parameter Modelica.SIunits.MassFlowRate m_flow_nominal = 3000
                                                                     "Mass flow rate for dp_nominal";
      end flowModel_rec;
    public
      flowModel_rec flowModel annotation(Dialog);
    protected
      record heatTransfer_rec
        parameter Modelica.SIunits.CoefficientOfHeatTransfer alpha0 = 100
                                                                         "guess value for heat transfer coefficients";
      end heatTransfer_rec;
    public
      heatTransfer_rec heatTransfer annotation(Dialog);
    protected
      record 'mediums[1]_rec'
        parameter Real _T_start = 273.15;
        Real T(unit = "K", displayUnit = "degC", nominal = 300.0, quantity = "ThermodynamicTemperature", min = 243.14999999999998, max = 373.15,start = _T_start)
                                                                                                                                                                 "Temperature of medium";
        parameter Real _T_der_start = 0.0;
        Real T_der(unit = "K/s",start = _T_der_start, fixed=false)
                                                                  "der(Temperature of medium)";
        parameter Modelica.SIunits.Temperature T_start = 298.15
                                                               "Initial temperature";
      end 'mediums[1]_rec';
    public
      'mediums[1]_rec' 'mediums[1]' annotation(Dialog);
    protected
      record 'mediums[2]_rec'
        parameter Real _T_start = 273.15;
        Real T(unit = "K", displayUnit = "degC", nominal = 300.0, quantity = "ThermodynamicTemperature", min = 243.14999999999998, max = 373.15,start = _T_start)
                                                                                                                                                                 "Temperature of medium";
        parameter Real _T_der_start = 0.0;
        Real T_der(unit = "K/s",start = _T_der_start, fixed=false)
                                                                  "der(Temperature of medium)";
        parameter Modelica.SIunits.Temperature T_start = 298.15
                                                               "Initial temperature";
      end 'mediums[2]_rec';
    public
      'mediums[2]_rec' 'mediums[2]' annotation(Dialog);
    protected
      record 'mediums[3]_rec'
        parameter Real _T_start = 273.15;
        Real T(unit = "K", displayUnit = "degC", nominal = 300.0, quantity = "ThermodynamicTemperature", min = 243.14999999999998, max = 373.15,start = _T_start)
                                                                                                                                                                 "Temperature of medium";
        parameter Real _T_der_start = 0.0;
        Real T_der(unit = "K/s",start = _T_der_start, fixed=false)
                                                                  "der(Temperature of medium)";
        parameter Modelica.SIunits.Temperature T_start = 298.15
                                                               "Initial temperature";
      end 'mediums[3]_rec';
    public
      'mediums[3]_rec' 'mediums[3]' annotation(Dialog);
    protected
      record 'mediums[4]_rec'
        parameter Real _T_start = 273.15;
        Real T(unit = "K", displayUnit = "degC", nominal = 300.0, quantity = "ThermodynamicTemperature", min = 243.14999999999998, max = 373.15,start = _T_start)
                                                                                                                                                                 "Temperature of medium";
        parameter Real _T_der_start = 0.0;
        Real T_der(unit = "K/s",start = _T_der_start, fixed=false)
                                                                  "der(Temperature of medium)";
        parameter Modelica.SIunits.Temperature T_start = 298.15
                                                               "Initial temperature";
      end 'mediums[4]_rec';
    public
      'mediums[4]_rec' 'mediums[4]' annotation(Dialog);
    protected
      record 'mediums[5]_rec'
        parameter Real _T_start = 273.15;
        Real T(unit = "K", displayUnit = "degC", nominal = 300.0, quantity = "ThermodynamicTemperature", min = 243.14999999999998, max = 373.15,start = _T_start)
                                                                                                                                                                 "Temperature of medium";
        parameter Real _T_der_start = 0.0;
        Real T_der(unit = "K/s",start = _T_der_start, fixed=false)
                                                                  "der(Temperature of medium)";
        parameter Modelica.SIunits.Temperature T_start = 298.15
                                                               "Initial temperature";
      end 'mediums[5]_rec';
    public
      'mediums[5]_rec' 'mediums[5]' annotation(Dialog);
    protected
      record 'mediums[6]_rec'
        parameter Real _T_start = 273.15;
        Real T(unit = "K", displayUnit = "degC", nominal = 300.0, quantity = "ThermodynamicTemperature", min = 243.14999999999998, max = 373.15,start = _T_start)
                                                                                                                                                                 "Temperature of medium";
        parameter Real _T_der_start = 0.0;
        Real T_der(unit = "K/s",start = _T_der_start, fixed=false)
                                                                  "der(Temperature of medium)";
        parameter Modelica.SIunits.Temperature T_start = 298.15
                                                               "Initial temperature";
      end 'mediums[6]_rec';
    public
      'mediums[6]_rec' 'mediums[6]' annotation(Dialog);
    protected
      record 'mediums[7]_rec'
        parameter Real _T_start = 273.15;
        Real T(unit = "K", displayUnit = "degC", nominal = 300.0, quantity = "ThermodynamicTemperature", min = 243.14999999999998, max = 373.15,start = _T_start)
                                                                                                                                                                 "Temperature of medium";
        parameter Real _T_der_start = 0.0;
        Real T_der(unit = "K/s",start = _T_der_start, fixed=false)
                                                                  "der(Temperature of medium)";
        parameter Modelica.SIunits.Temperature T_start = 298.15
                                                               "Initial temperature";
      end 'mediums[7]_rec';
    public
      'mediums[7]_rec' 'mediums[7]' annotation(Dialog);
    protected
      record 'mediums[8]_rec'
        parameter Real _T_start = 273.15;
        Real T(unit = "K", displayUnit = "degC", nominal = 300.0, quantity = "ThermodynamicTemperature", min = 243.14999999999998, max = 373.15,start = _T_start)
                                                                                                                                                                 "Temperature of medium";
        parameter Real _T_der_start = 0.0;
        Real T_der(unit = "K/s",start = _T_der_start, fixed=false)
                                                                  "der(Temperature of medium)";
        parameter Modelica.SIunits.Temperature T_start = 298.15
                                                               "Initial temperature";
      end 'mediums[8]_rec';
    public
      'mediums[8]_rec' 'mediums[8]' annotation(Dialog);
    protected
      record 'mediums[9]_rec'
        parameter Real _T_start = 273.15;
        Real T(unit = "K", displayUnit = "degC", nominal = 300.0, quantity = "ThermodynamicTemperature", min = 243.14999999999998, max = 373.15,start = _T_start)
                                                                                                                                                                 "Temperature of medium";
        parameter Real _T_der_start = 0.0;
        Real T_der(unit = "K/s",start = _T_der_start, fixed=false)
                                                                  "der(Temperature of medium)";
        parameter Modelica.SIunits.Temperature T_start = 298.15
                                                               "Initial temperature";
      end 'mediums[9]_rec';
    public
      'mediums[9]_rec' 'mediums[9]' annotation(Dialog);
    protected
      record 'mediums[10]_rec'
        parameter Real _T_start = 273.15;
        Real T(unit = "K", displayUnit = "degC", nominal = 300.0, quantity = "ThermodynamicTemperature", min = 243.14999999999998, max = 373.15,start = _T_start)
                                                                                                                                                                 "Temperature of medium";
        parameter Real _T_der_start = 0.0;
        Real T_der(unit = "K/s",start = _T_der_start, fixed=false)
                                                                  "der(Temperature of medium)";
        parameter Modelica.SIunits.Temperature T_start = 298.15
                                                               "Initial temperature";
      end 'mediums[10]_rec';
    public
      'mediums[10]_rec' 'mediums[10]' annotation(Dialog);
    end pipe_rec;
  public
    pipe_rec pipe annotation(Dialog);
  protected
    record iceLiquidVessel_rec
      Modelica.SIunits.Mass m_l;
      Real m_l_der(unit = "kg/s");
      Modelica.SIunits.Mass m_s;
      Real m_s_der(unit = "kg/s");
      parameter Modelica.SIunits.Temperature _T_l_start = 273.15;
      Modelica.SIunits.Temperature T_l(min = 1.0, max = 10000.0,start = _T_l_start)
                                                                                   "Liquid temperature in the vessel";
      Real T_l_der(unit = "K/s")
                                "der(Liquid temperature in the vessel)";
    end iceLiquidVessel_rec;
  public
    iceLiquidVessel_rec iceLiquidVessel annotation(Dialog);
  protected
    record hollowCylinder_rec
      parameter Modelica.SIunits.TemperatureSlope der_T_start = 0
                                                                 "Derivative of temperature (= der(T))";
      parameter Modelica.SIunits.Angle alpha = 6.283185307179586
                                                                "Swept angle";
    protected
      record 'heatCapacitors[1, 1, 1]_rec'
        parameter Modelica.SIunits.Temperature _T_start = 273.15;
        Modelica.SIunits.Temperature T(start = _T_start)
                                                        "Temperature of element";
        Real T_der(unit = "K/s")
                                "der(Temperature of element)";
      end 'heatCapacitors[1, 1, 1]_rec';
    public
      'heatCapacitors[1, 1, 1]_rec' 'heatCapacitors[1, 1, 1]' annotation(Dialog);
    protected
      record 'heatCapacitors[1, 1, 2]_rec'
        parameter Modelica.SIunits.Temperature _T_start = 273.15;
        Modelica.SIunits.Temperature T(start = _T_start)
                                                        "Temperature of element";
        Real T_der(unit = "K/s")
                                "der(Temperature of element)";
      end 'heatCapacitors[1, 1, 2]_rec';
    public
      'heatCapacitors[1, 1, 2]_rec' 'heatCapacitors[1, 1, 2]' annotation(Dialog);
    protected
      record 'heatCapacitors[1, 2, 2]_rec'
        parameter Modelica.SIunits.Temperature _T_start = 273.15;
        Modelica.SIunits.Temperature T(start = _T_start)
                                                        "Temperature of element";
        Real T_der(unit = "K/s")
                                "der(Temperature of element)";
      end 'heatCapacitors[1, 2, 2]_rec';
    public
      'heatCapacitors[1, 2, 2]_rec' 'heatCapacitors[1, 2, 2]' annotation(Dialog);
    protected
      record 'heatCapacitors[1, 3, 2]_rec'
        parameter Modelica.SIunits.Temperature _T_start = 273.15;
        Modelica.SIunits.Temperature T(start = _T_start)
                                                        "Temperature of element";
        Real T_der(unit = "K/s")
                                "der(Temperature of element)";
      end 'heatCapacitors[1, 3, 2]_rec';
    public
      'heatCapacitors[1, 3, 2]_rec' 'heatCapacitors[1, 3, 2]' annotation(Dialog);
    protected
      record 'heatCapacitors[1, 4, 2]_rec'
        parameter Modelica.SIunits.Temperature _T_start = 273.15;
        Modelica.SIunits.Temperature T(start = _T_start)
                                                        "Temperature of element";
        Real T_der(unit = "K/s")
                                "der(Temperature of element)";
      end 'heatCapacitors[1, 4, 2]_rec';
    public
      'heatCapacitors[1, 4, 2]_rec' 'heatCapacitors[1, 4, 2]' annotation(Dialog);
    protected
      record 'heatCapacitors[1, 5, 2]_rec'
        parameter Modelica.SIunits.Temperature _T_start = 273.15;
        Modelica.SIunits.Temperature T(start = _T_start)
                                                        "Temperature of element";
        Real T_der(unit = "K/s")
                                "der(Temperature of element)";
      end 'heatCapacitors[1, 5, 2]_rec';
    public
      'heatCapacitors[1, 5, 2]_rec' 'heatCapacitors[1, 5, 2]' annotation(Dialog);
    protected
      record 'heatCapacitors[1, 6, 2]_rec'
        parameter Modelica.SIunits.Temperature _T_start = 273.15;
        Modelica.SIunits.Temperature T(start = _T_start)
                                                        "Temperature of element";
        Real T_der(unit = "K/s")
                                "der(Temperature of element)";
      end 'heatCapacitors[1, 6, 2]_rec';
    public
      'heatCapacitors[1, 6, 2]_rec' 'heatCapacitors[1, 6, 2]' annotation(Dialog);
    protected
      record 'heatCapacitors[1, 7, 2]_rec'
        parameter Modelica.SIunits.Temperature _T_start = 273.15;
        Modelica.SIunits.Temperature T(start = _T_start)
                                                        "Temperature of element";
        Real T_der(unit = "K/s")
                                "der(Temperature of element)";
      end 'heatCapacitors[1, 7, 2]_rec';
    public
      'heatCapacitors[1, 7, 2]_rec' 'heatCapacitors[1, 7, 2]' annotation(Dialog);
    protected
      record 'heatCapacitors[1, 8, 2]_rec'
        parameter Modelica.SIunits.Temperature _T_start = 273.15;
        Modelica.SIunits.Temperature T(start = _T_start)
                                                        "Temperature of element";
        Real T_der(unit = "K/s")
                                "der(Temperature of element)";
      end 'heatCapacitors[1, 8, 2]_rec';
    public
      'heatCapacitors[1, 8, 2]_rec' 'heatCapacitors[1, 8, 2]' annotation(Dialog);
    protected
      record 'heatCapacitors[1, 9, 2]_rec'
        parameter Modelica.SIunits.Temperature _T_start = 273.15;
        Modelica.SIunits.Temperature T(start = _T_start)
                                                        "Temperature of element";
        Real T_der(unit = "K/s")
                                "der(Temperature of element)";
      end 'heatCapacitors[1, 9, 2]_rec';
    public
      'heatCapacitors[1, 9, 2]_rec' 'heatCapacitors[1, 9, 2]' annotation(Dialog);
    protected
      record 'heatCapacitors[1, 10, 2]_rec'
        parameter Modelica.SIunits.Temperature _T_start = 273.15;
        Modelica.SIunits.Temperature T(start = _T_start)
                                                        "Temperature of element";
        Real T_der(unit = "K/s")
                                "der(Temperature of element)";
      end 'heatCapacitors[1, 10, 2]_rec';
    public
      'heatCapacitors[1, 10, 2]_rec' 'heatCapacitors[1, 10, 2]' annotation(Dialog);
    end hollowCylinder_rec;
  public
    hollowCylinder_rec hollowCylinder annotation(Dialog);
  protected
    record thermalConductor_rec
      parameter Modelica.SIunits.ThermalConductance G = 100
                                                           "Constant thermal conductance of material";
    end thermalConductor_rec;
  public
    thermalConductor_rec thermalConductor annotation(Dialog);
  end iceLiquidVessel_rec;
public
  iceLiquidVessel_rec iceLiquidVessel annotation(Dialog);
protected
  record outlet_HTF_rec
  protected
    record medium_rec
      parameter Modelica.SIunits.Temperature T_start = 298.15
                                                             "Initial temperature";
    end medium_rec;
  public
    medium_rec medium annotation(Dialog);
    parameter Real p(unit = "Pa", displayUnit = "bar", nominal = 100000.0, quantity = "Pressure", min = 0.0, max = 100000000.0) = 101325
                                                                                                                                        "Boundary pressure";
    parameter Real T(unit = "K", displayUnit = "degC", nominal = 300.0, quantity = "ThermodynamicTemperature", min = 243.14999999999998, max = 373.15) = 293.15
                                                                                                                                                               "Boundary temperature";
    parameter Real 'X[1]'(nominal = 0.1, quantity = "Glycol-Water 47%", min = 0.0, max = 1.0) = 1.0
                                                                                                   "Boundary mass fractions m_i/m";
  end outlet_HTF_rec;
public
  outlet_HTF_rec outlet_HTF;
  parameter Real _water_m_flow_a_start = 0.0
  annotation (Dialog( group="Start values for inputs "));
protected
  Real _water_m_flow_a_old;
public
  Modelica.Blocks.Interfaces.RealInput water_m_flow_a(unit = "kg/s", quantity = "MassFlowRate", min = -100000.0, max = 100000.0, start = _water_m_flow_a_start)
  annotation (Placement(transformation(extent={{-114,62},{-94,82}})));
  parameter Real _water_T_start = 288.15
  annotation (Dialog( group="Start values for inputs "));
protected
  Real _water_T_old;
public
  Modelica.Blocks.Interfaces.RealInput water_T(unit = "K", displayUnit = "degC", nominal = 300.0, quantity = "ThermodynamicTemperature", min = 1.0, max = 10000.0, start = _water_T_start)
  annotation (Placement(transformation(extent={{-114,33},{-94,53}})));
  parameter Real _HTF_m_flow_a_start = 0.0
  annotation (Dialog( group="Start values for inputs "));
protected
  Real _HTF_m_flow_a_old;
public
  Modelica.Blocks.Interfaces.RealInput HTF_m_flow_a(unit = "kg/s", quantity = "MassFlowRate", min = -1E+060, max = 100000.0, start = _HTF_m_flow_a_start)
  annotation (Placement(transformation(extent={{-114,5},{-94,25}})));
  parameter Real _HTF_T_start = 298.15
  annotation (Dialog( group="Start values for inputs "));
protected
  Real _HTF_T_old;
public
  Modelica.Blocks.Interfaces.RealInput HTF_T(unit = "K", displayUnit = "degC", nominal = 300.0, quantity = "ThermodynamicTemperature", min = 243.14999999999998, max = 373.15, start = _HTF_T_start)
  annotation (Placement(transformation(extent={{-114,-24},{-94,-4}})));
  parameter Real _water_m_flow_b_start = 0.0
  annotation (Dialog( group="Start values for inputs "));
protected
  Real _water_m_flow_b_old;
public
  Modelica.Blocks.Interfaces.RealInput water_m_flow_b(unit = "kg/s", quantity = "MassFlowRate", min = -100000.0, max = 100000.0, start = _water_m_flow_b_start)
  annotation (Placement(transformation(extent={{-114,-52},{-94,-32}})));
  parameter Real _Ambient_T_start = 288.15
  annotation (Dialog( group="Start values for inputs "));
protected
  Real _Ambient_T_old;
public
  Modelica.Blocks.Interfaces.RealInput Ambient_T(unit = "K", displayUnit = "degC", nominal = 300.0, quantity = "ThermodynamicTemperature", min = 0.0, start = _Ambient_T_start)
  annotation (Placement(transformation(extent={{-114,-81},{-94,-61}})));
  Modelica.Blocks.Interfaces.RealOutput HTF_outlet_T(unit = "K", displayUnit = "degC", nominal = 300.0, quantity = "ThermodynamicTemperature", min = 0.0)
  annotation (Placement(transformation(extent={{100,47},{140,87}})));
  Modelica.Blocks.Interfaces.RealOutput water_outlet_T(unit = "K", displayUnit = "degC", nominal = 300.0, quantity = "ThermodynamicTemperature", min = 0.0)
  annotation (Placement(transformation(extent={{100,14},{140,54}})));
  Modelica.Blocks.Interfaces.RealOutput charge_percentage(quantity = "MassFraction", min = 0.0, max = 1.0)
  annotation (Placement(transformation(extent={{100,-20},{140,20}})));
  Modelica.Blocks.Interfaces.RealOutput storaged_energy(unit = "J", quantity = "Energy")
  annotation (Placement(transformation(extent={{100,-53},{140,-13}})));
  Modelica.Blocks.Interfaces.RealOutput energy_percentage(quantity = "MassFraction", min = 0.0, max = 1.0)
  annotation (Placement(transformation(extent={{100,-86},{140,-46}})));
public
  parameter String fmi_instanceName="ExternalLS_fmu"
  annotation (Dialog(tab="FMI", group="Instance name"));
  parameter Boolean fmi_loggingOn=false
  annotation (Dialog(tab="FMI", group="Enable logging"));
  parameter Boolean fmi_InputTime=false
  "Time point of input used when calling doStep."
  annotation (Evaluate=true,Dialog(tab="FMI", group="Input Handling"),choices(choice= false "StepEnd", choice= true "StepStart"));
  parameter Boolean fmi_UsePreOnInputSignals=true
  annotation (Evaluate=true,Dialog(tab="FMI", group="Input Handling"));
  parameter Real fmi_StartTime = 0.0
  annotation (Dialog(tab="FMI", group="Step time"));
  parameter Real fmi_StopTime = 17000.0
  annotation (Dialog(tab="FMI", group="Step time"));
  parameter Real fmi_NumberOfSteps = 500
  annotation (Dialog(tab="FMI", group="Step time"));
  parameter Real fmi_CommunicationStepSize=(fmi_StopTime-fmi_StartTime)/fmi_NumberOfSteps
  annotation (Dialog(tab="FMI", group="Step time"));
  parameter Integer stepSizeScaleFactor = 1 "Number of doSteps called between two CommunicationStepSize"
  annotation (Dialog(tab="FMI", group="Step time"));
  parameter Boolean fmi_forceShutDownAtStopTime=false
  annotation (Dialog(tab="FMI", group="Step time"));
  parameter Real fmi_rTol=1e-6 "relative tolerance for the internal solver of the fmu"
  annotation (Dialog(tab="FMI", group="Step time"));
  parameter String fmi_resourceLocation="file:///"+ModelicaServices.ExternalReferences.loadResource("modelica://ExternalLS_fmu/Resources/Library/FMU/ExternalLS/resources")
  annotation (Dialog(tab="FMI", group="Instantiation"));
protected
  fmi_Functions.fmiModel fmi;
  Boolean fmi_exitInit(start=false,fixed=true);
  Boolean fmi_flip(start=false,fixed=true);
  parameter Real fmi_rdum(start=0,fixed=false);
  parameter Integer fmi_idum(start=0,fixed=false);
  Boolean fmi_StepOK;
Real RealVariables[48];
package fmi_Functions
    class fmiModel
      extends ExternalObject;
      function constructor "Initialize FMI model"
        extends Modelica.Icons.Function;
        input String instanceName;
        input Boolean loggingOn;
        input String resourceLocation;
        output fmiModel fmi;
        external"C" fmi = Modelica_0IK4_0TEKNIKER_0DCOL_0ThermalStorage_0LatentStoragesNEW_0FMI_0ExternalLS_0Dym_fmiInstantiateModel2(instanceName, loggingOn, resourceLocation)
        annotation(Header="
#ifndef Modelica_0IK4_0TEKNIKER_0DCOL_0ThermalStorage_0LatentStoragesNEW_0FMI_0ExternalLS_0Dym_Instantiate_C
#define Modelica_0IK4_0TEKNIKER_0DCOL_0ThermalStorage_0LatentStoragesNEW_0FMI_0ExternalLS_0Dym_Instantiate_C 1
#include \"FMI/fmi2Import.h\"
#include <stdlib.h>
void Modelica_0IK4_0TEKNIKER_0DCOL_0ThermalStorage_0LatentStoragesNEW_0FMI_0ExternalLS_0DymLogger(fmi2ComponentEnvironment componentEnvironment, fmi2String instanceName, fmi2Status status,
  fmi2String category, fmi2String message, ...) {
  char msg[4096];
  char buf[4096];
  va_list ap;
  int len;
  va_start(ap,message);
#if defined(_MSC_VER) && _MSC_VER>=1200
  len = _snprintf(msg, sizeof(msg)/sizeof(*msg), \"%s: %s\", instanceName, message);
  if (len < 0) goto fail;
  len = _vsnprintf(buf, sizeof(buf)/sizeof(*buf) - 2, msg, ap);
  if (len < 0) goto fail;
#else
  len = snprintf(msg, sizeof(msg)/sizeof(*msg), \"%s: %s\", instanceName, message);
  if (len < 0) goto fail;
  len = vsnprintf(buf, sizeof(buf)/sizeof(*buf) - 2, msg, ap);
  if (len < 0) goto fail;
#endif
  if( len>0 && len < 4096 && buf[len - 1]!='\\n'){
    buf[len] = '\\n';
    buf[len + 1] = 0;
  }
  va_end(ap);
  switch (status) {
    case fmi2Fatal:
      ModelicaMessage(\"[fmi2Fatal]: \");
      break;
    case fmi2Error:
      ModelicaMessage(\"[fmi2Error]: \");
      break;
    case fmi2Discard:
      ModelicaMessage(\"[fmi2Discard]: \");
      break;
    case fmi2Warning:
      ModelicaMessage(\"[fmi2Warning]: \");
      break;
    case fmi2OK:
      ModelicaMessage(\"[fmi2OK]: \");
      break;
  }
  ModelicaMessage(buf);
  return;
fail:
  ModelicaMessage(\"Logger failed, message too long?\");
}
void * Modelica_0IK4_0TEKNIKER_0DCOL_0ThermalStorage_0LatentStoragesNEW_0FMI_0ExternalLS_0Dym_fmiInstantiateModel2(const char*instanceName, fmi2Boolean loggingOn, fmi2String resourceLocation) {
  static fmi2CallbackFunctions funcs = {&Modelica_0IK4_0TEKNIKER_0DCOL_0ThermalStorage_0LatentStoragesNEW_0FMI_0ExternalLS_0DymLogger, &calloc, &free, NULL, NULL};
  struct dy_fmi2Extended* res;
  res = calloc(1, sizeof(struct dy_fmi2Extended));
  if (res!=0) {
    if (!(res->hInst=LoadLibraryW(L\"Modelica_0IK4_0TEKNIKER_0DCOL_0ThermalStorage_0LatentStoragesNEW_0FMI_0ExternalLS_0Dym.dll\"))) {
      ModelicaError(\"Loading of FMU dynamic link library (Modelica_0IK4_0TEKNIKER_0DCOL_0ThermalStorage_0LatentStoragesNEW_0FMI_0ExternalLS_0Dym.dll) failed!\");
      return 0;
    }
    if (!(res->dyFmiInstantiate=(fmi2InstantiateFunc)GetProcAddress(res->hInst,\"fmi2Instantiate\"))) {
      ModelicaError(\"GetProcAddress failed for fmi2Instantiate!\");
      return 0;
    }
    if (!(res->dyFmiFreeInstance=(fmi2FreeInstanceFunc)GetProcAddress(res->hInst,\"fmi2FreeInstance\"))) {
      ModelicaError(\"GetProcAddress failed for fmi2FreeInstance!\");
      return 0;
    }
    if (!(res->dyFmiSetupExperiment=(fmi2SetupExperimentFunc)GetProcAddress(res->hInst,\"fmi2SetupExperiment\"))) {
      ModelicaError(\"GetProcAddress failed for fmi2SetupExperiment!\");
      return 0;
    }
    if (!(res->dyFmiEnterInitializationMode=(fmi2EnterInitializationModeFunc)GetProcAddress(res->hInst,\"fmi2EnterInitializationMode\"))) {
      ModelicaError(\"GetProcAddress failed for fmi2EnterInitializationMode!\");
      return 0;
    }
    if (!(res->dyFmiExitInitializationMode=(fmi2ExitInitializationModeFunc)GetProcAddress(res->hInst,\"fmi2ExitInitializationMode\"))) {
      ModelicaError(\"GetProcAddress failed for fmi2ExitInitializationMode!\");
      return 0;
    }
    if (!(res->dyFmiTerminate=(fmi2TerminateFunc)GetProcAddress(res->hInst,\"fmi2Terminate\"))) {
      ModelicaError(\"GetProcAddress failed for fmi2Terminate!\");
      return 0;
    }
    if (!(res->dyFmiReset=(fmi2ResetFunc)GetProcAddress(res->hInst,\"fmi2Reset\"))) {
      ModelicaError(\"GetProcAddress failed for fmi2Reset!\");
      return 0;
    }
    if (!(res->dyFmiSetReal=(fmi2SetRealFunc)GetProcAddress(res->hInst,\"fmi2SetReal\"))) {
      ModelicaError(\"GetProcAddress failed for fmi2SetReal!\");
      return 0;
    }
    if (!(res->dyFmiGetReal=(fmi2GetRealFunc)GetProcAddress(res->hInst,\"fmi2GetReal\"))) {
      ModelicaError(\"GetProcAddress failed for fmi2GetReal!\");
      return 0;
    }
    if (!(res->dyFmiSetInteger=(fmi2SetIntegerFunc)GetProcAddress(res->hInst,\"fmi2SetInteger\"))) {
      ModelicaError(\"GetProcAddress failed for fmi2SetInteger!\");
      return 0;
    }
    if (!(res->dyFmiGetInteger=(fmi2GetIntegerFunc)GetProcAddress(res->hInst,\"fmi2GetInteger\"))) {
      ModelicaError(\"GetProcAddress failed for fmi2GetInteger!\");
      return 0;
    }
    if (!(res->dyFmiSetBoolean=(fmi2SetBooleanFunc)GetProcAddress(res->hInst,\"fmi2SetBoolean\"))) {
      ModelicaError(\"GetProcAddress failed for fmi2SetBoolean!\");
      return 0;
    }
    if (!(res->dyFmiGetBoolean=(fmi2GetBooleanFunc)GetProcAddress(res->hInst,\"fmi2GetBoolean\"))) {
      ModelicaError(\"GetProcAddress failed for fmi2GetBoolean!\");
      return 0;
    }
    if (!(res->dyFmiSetString=(fmi2SetStringFunc)GetProcAddress(res->hInst,\"fmi2SetString\"))) {
      ModelicaError(\"GetProcAddress failed for fmi2SetString!\");
      return 0;
    }
    if (!(res->dyFmiGetString=(fmi2GetStringFunc)GetProcAddress(res->hInst,\"fmi2GetString\"))) {
      ModelicaError(\"GetProcAddress failed for fmi2GetString!\");
      return 0;
    }
    if(!(res->dyFmiDoStep=(fmi2DoStepFunc)GetProcAddress(res->hInst,\"fmi2DoStep\"))){
      ModelicaError(\"GetProcAddress failed for fmi2DoStep!\\n The model was imported as a Co-Simulation FMU but could not load the CS specific function fmiDoStep\\n Verify that the FMU supports Co-Simulation\");
      return 0;
    }
    if(!(res->dyFmiGetBooleanStatus=(fmi2GetBooleanStatusFunc)GetProcAddress(res->hInst,\"fmi2GetBooleanStatus\"))){
      ModelicaError(\"GetProcAddress failed for fmi2GetBooleanStatus!\\n The model was imported as a Co-Simulation FMU but could not load the CS specific function fmiGetBooleanStatus\\n Verify that the FMU supports Co-Simulation\");
      return 0;
    }
    if (!(res->dyFmiGetDirectionalDerivative=(fmi2GetDirectionalDerivativeFunc)GetProcAddress(res->hInst,\"fmi2GetDirectionalDerivative\"))) {
      ModelicaError(\"GetProcAddress failed for fmi2GetDirectionalDerivative!\");
      return 0;
    }
    if (!(res->dyFmiGetFMUstate=(fmi2GetFMUstateFunc)GetProcAddress(res->hInst,\"fmi2GetFMUstate\"))) {
      ModelicaError(\"GetProcAddress failed for fmi2GetFMUstate!\");
      return 0;
    }
    if (!(res->dyFmiSetFMUstate=(fmi2SetFMUstateFunc)GetProcAddress(res->hInst,\"fmi2SetFMUstate\"))) {
      ModelicaError(\"GetProcAddress failed for fmi2SetFMUstate!\");
      return 0;
    }
    if (!(res->dyFmiFreeFMUstate=(fmi2FreeFMUstateFunc)GetProcAddress(res->hInst,\"fmi2FreeFMUstate\"))) {
      ModelicaError(\"GetProcAddress failed for fmi2FreeFMUstate!\");
      return 0;
    }
    res->m=res->dyFmiInstantiate(instanceName, fmi2CoSimulation, \"{acef19b6-9c3f-4bd4-a352-1606f60cbde8}\",resourceLocation, &funcs, fmi2False, loggingOn);
    if (0==res->m) {free(res);res=0;ModelicaError(\"InstantiateModel failed\");}
    else {res->dyTriggered=0;res->dyTime=res->dyLastTime=-1e37;res->discreteInputChanged=1;res->currentMode=dyfmi2InstantiationMode;res->dyLastStepTime=0;res->dyFMUstate=NULL;}
  }
  return res;
}
#endif", Library="Modelica_0IK4_0TEKNIKER_0DCOL_0ThermalStorage_0LatentStoragesNEW_0FMI_0ExternalLS_0Dym", LibraryDirectory="modelica://DCOL/Resources/Library/FMU/ExternalLS/binaries",           __Dymola_CriticalRegion="Modelica_0IK4_0TEKNIKER_0DCOL_0ThermalStorage_0LatentStoragesNEW_0FMI_0ExternalLS_0Dym");
      end constructor;

      function destructor "Release storage of FMI model"
        extends Modelica.Icons.Function;
        input fmiModel fmi;
        external"C"
                   Modelica_0IK4_0TEKNIKER_0DCOL_0ThermalStorage_0LatentStoragesNEW_0FMI_0ExternalLS_0Dym_fmiFreeModelInstance2(fmi);
        annotation (Header="
#ifndef Modelica_0IK4_0TEKNIKER_0DCOL_0ThermalStorage_0LatentStoragesNEW_0FMI_0ExternalLS_0Dym_Free_C
#define Modelica_0IK4_0TEKNIKER_0DCOL_0ThermalStorage_0LatentStoragesNEW_0FMI_0ExternalLS_0Dym_Free_C 1
#include \"FMI/fmi2Import.h\"
#include <stdlib.h>
void Modelica_0IK4_0TEKNIKER_0DCOL_0ThermalStorage_0LatentStoragesNEW_0FMI_0ExternalLS_0Dym_fmiFreeModelInstance2(void*m) {
  struct dy_fmi2Extended*a=m;
  if (a) {
    if(a->dyFMUstate)
    a->dyFmiFreeFMUstate(a->m, &a->dyFMUstate);
    a->dyFmiTerminate(a->m);
    a->dyFmiFreeInstance(a->m);
    FreeLibrary(a->hInst);
    free(a);
  }
}
#endif", Library="Modelica_0IK4_0TEKNIKER_0DCOL_0ThermalStorage_0LatentStoragesNEW_0FMI_0ExternalLS_0Dym", LibraryDirectory="modelica://DCOL/Resources/Library/FMU/ExternalLS/binaries",           __Dymola_CriticalRegion="Modelica_0IK4_0TEKNIKER_0DCOL_0ThermalStorage_0LatentStoragesNEW_0FMI_0ExternalLS_0Dym");
      end destructor;
    end fmiModel;

    function fmiDoStep
    input fmiModel fmi;
    input Real currentTime;
    input Real stepSize;
    input Real preAvailable;
    output Boolean stepOK;
    output Real postAvailable=preAvailable;
    external"C" stepOK= Modelica_0IK4_0TEKNIKER_0DCOL_0ThermalStorage_0LatentStoragesNEW_0FMI_0ExternalLS_0Dym_fmiDoStep2(fmi, currentTime, stepSize);
      annotation (Header="
#ifndef Modelica_0IK4_0TEKNIKER_0DCOL_0ThermalStorage_0LatentStoragesNEW_0FMI_0ExternalLS_0Dym_DoStep_C
#define Modelica_0IK4_0TEKNIKER_0DCOL_0ThermalStorage_0LatentStoragesNEW_0FMI_0ExternalLS_0Dym_DoStep_C 1
#include <stdlib.h>
#include \"FMI/fmi2Import.h\"
double Modelica_0IK4_0TEKNIKER_0DCOL_0ThermalStorage_0LatentStoragesNEW_0FMI_0ExternalLS_0Dym_fmiDoStep2(void*m, double currentTime, double stepSize) {
  struct dy_fmi2Extended*a=m;
  fmi2Status status=fmi2Fatal;
  fmi2Boolean value=fmi2False;
  if (a) {
    status=a->dyFmiDoStep(a->m, currentTime, stepSize, fmi2True);
    if(status==fmi2Discard){
      status = a->dyFmiGetBooleanStatus(a->m, fmi2Terminated, &value);
      if(value==fmi2True){
        terminate(\"Terminate signaled by the FMU\");
      }
    }
  }
  if (status!=fmi2OK && status!=fmi2Warning) ModelicaError(\"DoStep failed\");
  return 1.0;
}
#endif", Library="Modelica_0IK4_0TEKNIKER_0DCOL_0ThermalStorage_0LatentStoragesNEW_0FMI_0ExternalLS_0Dym", LibraryDirectory="modelica://DCOL/Resources/Library/FMU/ExternalLS/binaries",           __Dymola_CriticalRegion="Modelica_0IK4_0TEKNIKER_0DCOL_0ThermalStorage_0LatentStoragesNEW_0FMI_0ExternalLS_0Dym");
    end fmiDoStep;

    function fmiReset
      input fmiModel fmi;
      output Boolean resetOK;
      external"C" resetOK = Modelica_0IK4_0TEKNIKER_0DCOL_0ThermalStorage_0LatentStoragesNEW_0FMI_0ExternalLS_0Dym_fmiReset2(fmi);
      annotation (Header="
#ifndef Modelica_0IK4_0TEKNIKER_0DCOL_0ThermalStorage_0LatentStoragesNEW_0FMI_0ExternalLS_0Dym_Reset_C
#define Modelica_0IK4_0TEKNIKER_0DCOL_0ThermalStorage_0LatentStoragesNEW_0FMI_0ExternalLS_0Dym_Reset_C 1
#include <stdlib.h>
#include \"FMI/fmi2Import.h\"
double Modelica_0IK4_0TEKNIKER_0DCOL_0ThermalStorage_0LatentStoragesNEW_0FMI_0ExternalLS_0Dym_fmiReset2(void*m) {
  struct dy_fmi2Extended*a=m;
  fmi2Status status=fmi2Fatal;
  if (a) {
    status=a->dyFmiReset(a->m);
    a->currentMode=dyfmi2InstantiationMode;
  }
  if (status!=fmi2OK && status!=fmi2Warning) ModelicaError(\"fmiReset failed\");
    return 1.0;
  }
#endif", Library="Modelica_0IK4_0TEKNIKER_0DCOL_0ThermalStorage_0LatentStoragesNEW_0FMI_0ExternalLS_0Dym", LibraryDirectory="modelica://DCOL/Resources/Library/FMU/ExternalLS/binaries",           __Dymola_CriticalRegion="Modelica_0IK4_0TEKNIKER_0DCOL_0ThermalStorage_0LatentStoragesNEW_0FMI_0ExternalLS_0Dym");
    end fmiReset;

    function fmiGetRealScalar
      input fmiModel fmi;
      input Integer ref;
      output Real val;
    algorithm
        val := scalar(fmiGetReal(fmi, {ref}));
    end fmiGetRealScalar;

    function fmiGetReal
      input fmiModel fmi;
      input Integer refs[:];
      output Real vals[size(refs, 1)];
      external"C" Modelica_0IK4_0TEKNIKER_0DCOL_0ThermalStorage_0LatentStoragesNEW_0FMI_0ExternalLS_0Dym_fmiGetReal2(
        fmi,
        refs,
        size(refs, 1),
        vals);
      annotation (Header="
#ifndef Modelica_0IK4_0TEKNIKER_0DCOL_0ThermalStorage_0LatentStoragesNEW_0FMI_0ExternalLS_0Dym_GetReal_C
#define Modelica_0IK4_0TEKNIKER_0DCOL_0ThermalStorage_0LatentStoragesNEW_0FMI_0ExternalLS_0Dym_GetReal_C 1
#include <stdlib.h>
#include \"FMI/fmi2Import.h\"
void Modelica_0IK4_0TEKNIKER_0DCOL_0ThermalStorage_0LatentStoragesNEW_0FMI_0ExternalLS_0Dym_fmiGetReal2(void*m, const int*refs, size_t nrefs, double*vals) {
  struct dy_fmi2Extended*a=m;
  fmi2Status status=fmi2Fatal;
  if (a) {
    status=a->dyFmiGetReal(a->m, refs, nrefs, vals);
  }
  if (status!=fmi2OK && status!=fmi2Warning) ModelicaError(\"GetReal failed\");
}
#endif", Library="Modelica_0IK4_0TEKNIKER_0DCOL_0ThermalStorage_0LatentStoragesNEW_0FMI_0ExternalLS_0Dym", LibraryDirectory="modelica://DCOL/Resources/Library/FMU/ExternalLS/binaries",           __Dymola_CriticalRegion="Modelica_0IK4_0TEKNIKER_0DCOL_0ThermalStorage_0LatentStoragesNEW_0FMI_0ExternalLS_0Dym");
    end fmiGetReal;

    function fmiGetRealwf
      input fmiModel fmi;
      input Integer refs[:];
      input Real preAvailable;
      output Real vals[size(refs, 1)];
      external"C" Modelica_0IK4_0TEKNIKER_0DCOL_0ThermalStorage_0LatentStoragesNEW_0FMI_0ExternalLS_0Dym_fmiGetReal2(
        fmi,
        refs,
        size(refs, 1),
        vals);
      annotation (Header="
#ifndef Modelica_0IK4_0TEKNIKER_0DCOL_0ThermalStorage_0LatentStoragesNEW_0FMI_0ExternalLS_0Dym_GetReal_C
#define Modelica_0IK4_0TEKNIKER_0DCOL_0ThermalStorage_0LatentStoragesNEW_0FMI_0ExternalLS_0Dym_GetReal_C 1
#include <stdlib.h>
#include \"FMI/fmi2Import.h\"
void Modelica_0IK4_0TEKNIKER_0DCOL_0ThermalStorage_0LatentStoragesNEW_0FMI_0ExternalLS_0Dym_fmiGetReal2(void*m, const int*refs, size_t nrefs, double*vals) {
  struct dy_fmi2Extended*a=m;
  fmi2Status status=fmi2Fatal;
  if (a) {
    status=a->dyFmiGetReal(a->m, refs, nrefs, vals);
  }
  if (status!=fmi2OK && status!=fmi2Warning) ModelicaError(\"GetReal failed\");
}
#endif", Library="Modelica_0IK4_0TEKNIKER_0DCOL_0ThermalStorage_0LatentStoragesNEW_0FMI_0ExternalLS_0Dym", LibraryDirectory="modelica://DCOL/Resources/Library/FMU/ExternalLS/binaries",           __Dymola_CriticalRegion="Modelica_0IK4_0TEKNIKER_0DCOL_0ThermalStorage_0LatentStoragesNEW_0FMI_0ExternalLS_0Dym");
    end fmiGetRealwf;

    function fmiSetReal
      input fmiModel fmi;
      input Integer refs[:];
      input Real vals[size(refs, 1)];
      external"C"
                 Modelica_0IK4_0TEKNIKER_0DCOL_0ThermalStorage_0LatentStoragesNEW_0FMI_0ExternalLS_0Dym_fmiSetReal2(
        fmi,
        refs,
        size(refs, 1),
        vals);
        annotation (Header="
#ifndef Modelica_0IK4_0TEKNIKER_0DCOL_0ThermalStorage_0LatentStoragesNEW_0FMI_0ExternalLS_0Dym_SetReal_C
#define Modelica_0IK4_0TEKNIKER_0DCOL_0ThermalStorage_0LatentStoragesNEW_0FMI_0ExternalLS_0Dym_SetReal_C 1
#include <stdlib.h>
#include \"FMI/fmi2Import.h\"
void Modelica_0IK4_0TEKNIKER_0DCOL_0ThermalStorage_0LatentStoragesNEW_0FMI_0ExternalLS_0Dym_fmiSetReal2(void*m, const int*refs, size_t nrefs, const double*vals) {
  struct dy_fmi2Extended*a=m;
  fmi2Status status=fmi2Fatal;
  if(!nrefs){return;}
  if (a) {
    status=a->dyFmiSetReal(a->m, refs, nrefs, vals);
  }
  if (status!=fmi2OK && status!=fmi2Warning) ModelicaError(\"SetReal failed\");
}
#endif", Library="Modelica_0IK4_0TEKNIKER_0DCOL_0ThermalStorage_0LatentStoragesNEW_0FMI_0ExternalLS_0Dym", LibraryDirectory="modelica://DCOL/Resources/Library/FMU/ExternalLS/binaries",           __Dymola_CriticalRegion="Modelica_0IK4_0TEKNIKER_0DCOL_0ThermalStorage_0LatentStoragesNEW_0FMI_0ExternalLS_0Dym",__Dymola_IdemPotent=true, __Dymola_VectorizedExceptFirst=true);
    end fmiSetReal;

    function fmiSetRealwf
      input fmiModel fmi;
      input Integer refs[:];
      input Real vals[size(refs, 1)];
      input Real preAvailable;
      output Real postAvailable=preAvailable;
      external"C"
                 Modelica_0IK4_0TEKNIKER_0DCOL_0ThermalStorage_0LatentStoragesNEW_0FMI_0ExternalLS_0Dym_fmiSetReal2(
        fmi,
        refs,
        size(refs, 1),
        vals);
        annotation (Header="
#ifndef Modelica_0IK4_0TEKNIKER_0DCOL_0ThermalStorage_0LatentStoragesNEW_0FMI_0ExternalLS_0Dym_SetReal_C
#define Modelica_0IK4_0TEKNIKER_0DCOL_0ThermalStorage_0LatentStoragesNEW_0FMI_0ExternalLS_0Dym_SetReal_C 1
#include <stdlib.h>
#include \"FMI/fmi2Import.h\"
void Modelica_0IK4_0TEKNIKER_0DCOL_0ThermalStorage_0LatentStoragesNEW_0FMI_0ExternalLS_0Dym_fmiSetReal2(void*m, const int*refs, size_t nrefs, const double*vals) {
  struct dy_fmi2Extended*a=m;
  fmi2Status status=fmi2Fatal;
  if(!nrefs){return;}
  if (a) {
    status=a->dyFmiSetReal(a->m, refs, nrefs, vals);
  }
  if (status!=fmi2OK && status!=fmi2Warning) ModelicaError(\"SetReal failed\");
}
#endif", Library="Modelica_0IK4_0TEKNIKER_0DCOL_0ThermalStorage_0LatentStoragesNEW_0FMI_0ExternalLS_0Dym", LibraryDirectory="modelica://DCOL/Resources/Library/FMU/ExternalLS/binaries",           __Dymola_CriticalRegion="Modelica_0IK4_0TEKNIKER_0DCOL_0ThermalStorage_0LatentStoragesNEW_0FMI_0ExternalLS_0Dym",__Dymola_IdemPotent=true, __Dymola_VectorizedExceptFirst=true);
    end fmiSetRealwf;

    function fmiGetIntegerScalar
      input fmiModel fmi;
      input Integer ref;
      output Integer val;
    algorithm
        val := scalar(fmiGetInteger(fmi, {ref}));
    end fmiGetIntegerScalar;

    function fmiGetInteger
      input fmiModel fmi;
      input Integer refs[:];
      output Integer vals[size(refs, 1)];
      external"C" Modelica_0IK4_0TEKNIKER_0DCOL_0ThermalStorage_0LatentStoragesNEW_0FMI_0ExternalLS_0Dym_fmiGetInteger2(
        fmi,
        refs,
        size(refs, 1),
        vals);
      annotation (Header="
#ifndef Modelica_0IK4_0TEKNIKER_0DCOL_0ThermalStorage_0LatentStoragesNEW_0FMI_0ExternalLS_0Dym_GetInteger_C
#define Modelica_0IK4_0TEKNIKER_0DCOL_0ThermalStorage_0LatentStoragesNEW_0FMI_0ExternalLS_0Dym_GetInteger_C 1
#include <stdlib.h>
#include \"FMI/fmi2Import.h\"
void Modelica_0IK4_0TEKNIKER_0DCOL_0ThermalStorage_0LatentStoragesNEW_0FMI_0ExternalLS_0Dym_fmiGetInteger2(void*m, const int*refs, size_t nrefs, int*vals) {
  struct dy_fmi2Extended*a=m;
  fmi2Status status=fmi2Fatal;
  if (a) {
    status=a->dyFmiGetInteger(a->m, refs, nrefs, vals);
  }
  if (status!=fmi2OK && status!=fmi2Warning) ModelicaError(\"GetInteger failed\");
}
#endif", Library="Modelica_0IK4_0TEKNIKER_0DCOL_0ThermalStorage_0LatentStoragesNEW_0FMI_0ExternalLS_0Dym", LibraryDirectory="modelica://DCOL/Resources/Library/FMU/ExternalLS/binaries",           __Dymola_CriticalRegion="Modelica_0IK4_0TEKNIKER_0DCOL_0ThermalStorage_0LatentStoragesNEW_0FMI_0ExternalLS_0Dym");
    end fmiGetInteger;

    function fmiGetIntegerwf
      input fmiModel fmi;
      input Integer refs[:];
      input Integer preAvailable;
      output Integer vals[size(refs, 1)];
      external"C" Modelica_0IK4_0TEKNIKER_0DCOL_0ThermalStorage_0LatentStoragesNEW_0FMI_0ExternalLS_0Dym_fmiGetInteger2(
        fmi,
        refs,
        size(refs, 1),
        vals);
      annotation (Header="
#ifndef Modelica_0IK4_0TEKNIKER_0DCOL_0ThermalStorage_0LatentStoragesNEW_0FMI_0ExternalLS_0Dym_GetInteger_C
#define Modelica_0IK4_0TEKNIKER_0DCOL_0ThermalStorage_0LatentStoragesNEW_0FMI_0ExternalLS_0Dym_GetInteger_C 1
#include \"FMI/fmi2Import.h\"
#include <stdlib.h>
void Modelica_0IK4_0TEKNIKER_0DCOL_0ThermalStorage_0LatentStoragesNEW_0FMI_0ExternalLS_0Dym_fmiGetInteger2(void*m, const int*refs, size_t nrefs, int*vals) {
  struct dy_fmi2Extended*a=m;
  fmi2Status status=fmi2Fatal;
  if (a) {
    status=a->dyFmiGetInteger(a->m, refs, nrefs, vals);
  }
  if (status!=fmi2OK && status!=fmi2Warning) ModelicaError(\"GetInteger failed\");
}
#endif", Library="Modelica_0IK4_0TEKNIKER_0DCOL_0ThermalStorage_0LatentStoragesNEW_0FMI_0ExternalLS_0Dym", LibraryDirectory="modelica://DCOL/Resources/Library/FMU/ExternalLS/binaries",           __Dymola_CriticalRegion="Modelica_0IK4_0TEKNIKER_0DCOL_0ThermalStorage_0LatentStoragesNEW_0FMI_0ExternalLS_0Dym");
    end fmiGetIntegerwf;

    function fmiSetInteger
      input fmiModel fmi;
      input Integer refs[:];
      input Integer vals[size(refs, 1)];
    protected
      Integer oldVals[size(refs, 1)];
      external"C" Modelica_0IK4_0TEKNIKER_0DCOL_0ThermalStorage_0LatentStoragesNEW_0FMI_0ExternalLS_0Dym_fmiSetInteger2(
        fmi,
        refs,
        size(refs, 1),
        vals,
        oldVals);
      annotation (Header="
#ifndef Modelica_0IK4_0TEKNIKER_0DCOL_0ThermalStorage_0LatentStoragesNEW_0FMI_0ExternalLS_0Dym_SetInteger_C
#define Modelica_0IK4_0TEKNIKER_0DCOL_0ThermalStorage_0LatentStoragesNEW_0FMI_0ExternalLS_0Dym_SetInteger_C 1
#include <stdlib.h>
#include \"FMI/fmi2Import.h\"
void Modelica_0IK4_0TEKNIKER_0DCOL_0ThermalStorage_0LatentStoragesNEW_0FMI_0ExternalLS_0Dym_fmiSetInteger2(void*m, const int*refs, size_t nrefs, int*vals, int*oldVals) {
  struct dy_fmi2Extended*a=m;
  fmi2Status status=fmi2Fatal;
  size_t i = 0;
  if(!nrefs){return;}
  if (a) {
    if(!a->discreteInputChanged){
      status=a->dyFmiGetInteger(a->m, refs, nrefs, oldVals);
      if (status!=fmi2OK && status!=fmi2Warning) ModelicaError(\"GetInteger failed in SetInteger\");
      for( i = 0; i < nrefs; ++i){
        if(oldVals[i] != vals[i]){
          a->discreteInputChanged = 1;
          break;
        }
      }
    }
    if(a->discreteInputChanged){
      if(a->currentMode == dyfmi2ContinuousTimeMode){
        status = a->dyFmiEnterEventMode(a->m);
        if (status!=fmi2OK && status!=fmi2Warning) ModelicaError(\"fmiEnterEventModeFailed\");
        a->currentMode = dyfmi2EventMode;
      }
      status=a->dyFmiSetInteger(a->m, refs, nrefs, vals);
    }
  }
  if (status!=fmi2OK && status!=fmi2Warning) ModelicaError(\"SetInteger failed\");
}
#endif", Library="Modelica_0IK4_0TEKNIKER_0DCOL_0ThermalStorage_0LatentStoragesNEW_0FMI_0ExternalLS_0Dym", LibraryDirectory="modelica://DCOL/Resources/Library/FMU/ExternalLS/binaries",           __Dymola_CriticalRegion="Modelica_0IK4_0TEKNIKER_0DCOL_0ThermalStorage_0LatentStoragesNEW_0FMI_0ExternalLS_0Dym",__Dymola_IdemPotent=true, __Dymola_VectorizedExceptFirst=true);
    end fmiSetInteger;

    function fmiSetIntegerwf
      input fmiModel fmi;
      input Integer refs[:];
      input Integer vals[size(refs, 1)];
      input Integer preAvailable;
      output Integer postAvailable=preAvailable;
      external"C" Modelica_0IK4_0TEKNIKER_0DCOL_0ThermalStorage_0LatentStoragesNEW_0FMI_0ExternalLS_0Dym_fmiSetInteger2wf(
        fmi,
        refs,
        size(refs, 1),
        vals);
      annotation (Header="
#ifndef Modelica_0IK4_0TEKNIKER_0DCOL_0ThermalStorage_0LatentStoragesNEW_0FMI_0ExternalLS_0Dym_SetIntegerwf_C
#define Modelica_0IK4_0TEKNIKER_0DCOL_0ThermalStorage_0LatentStoragesNEW_0FMI_0ExternalLS_0Dym_SetIntegerwf_C 1
#include <stdlib.h>
#include \"FMI/fmi2Import.h\"
void Modelica_0IK4_0TEKNIKER_0DCOL_0ThermalStorage_0LatentStoragesNEW_0FMI_0ExternalLS_0Dym_fmiSetInteger2wf(void*m, const int*refs, size_t nrefs, int*vals) {
  struct dy_fmi2Extended*a=m;
  fmi2Status status=fmi2Fatal;
  size_t i = 0;
  if(!nrefs){return;}
  if (a) {
    status=a->dyFmiSetInteger(a->m, refs, nrefs, vals);
  }
  if (status!=fmi2OK && status!=fmi2Warning) ModelicaError(\"SetInteger failed\");
}
#endif", Library="Modelica_0IK4_0TEKNIKER_0DCOL_0ThermalStorage_0LatentStoragesNEW_0FMI_0ExternalLS_0Dym", LibraryDirectory="modelica://DCOL/Resources/Library/FMU/ExternalLS/binaries",           __Dymola_CriticalRegion="Modelica_0IK4_0TEKNIKER_0DCOL_0ThermalStorage_0LatentStoragesNEW_0FMI_0ExternalLS_0Dym",__Dymola_IdemPotent=true, __Dymola_VectorizedExceptFirst=true);
    end fmiSetIntegerwf;

    function fmiGetBooleanScalar
      input fmiModel fmi;
      input Integer ref;
      output Boolean val;
    algorithm
        val := scalar(fmiGetBoolean(fmi, {ref}));
    end fmiGetBooleanScalar;

    function fmiGetBoolean
      input fmiModel fmi;
      input Integer refs[:];
      output Boolean vals[size(refs, 1)];
      external"C" Modelica_0IK4_0TEKNIKER_0DCOL_0ThermalStorage_0LatentStoragesNEW_0FMI_0ExternalLS_0Dym_fmiGetBoolean2(
        fmi,
        refs,
        size(refs, 1),
        vals);
        annotation (Header="
#ifndef Modelica_0IK4_0TEKNIKER_0DCOL_0ThermalStorage_0LatentStoragesNEW_0FMI_0ExternalLS_0Dym_GetBoolean_C
#define Modelica_0IK4_0TEKNIKER_0DCOL_0ThermalStorage_0LatentStoragesNEW_0FMI_0ExternalLS_0Dym_GetBoolean_C 1
#include \"FMI/fmi2Import.h\"
void Modelica_0IK4_0TEKNIKER_0DCOL_0ThermalStorage_0LatentStoragesNEW_0FMI_0ExternalLS_0Dym_fmiGetBoolean2(void*m, const int* refs, size_t nr, int* vals) {
  int i;
  struct dy_fmi2Extended*a=m;
  fmi2Status status=fmi2Fatal;
  if (a) {
    status=a->dyFmiGetBoolean(a->m, refs, nr, (fmi2Boolean*)(vals));
  }
  if (status!=fmi2OK && status!=fmi2Warning) ModelicaError(\"GetBoolean failed\");
    for(i=nr-1;i>=0;i--) vals[i]=((fmi2Boolean*)(vals))[i];
  }
#endif", Library="Modelica_0IK4_0TEKNIKER_0DCOL_0ThermalStorage_0LatentStoragesNEW_0FMI_0ExternalLS_0Dym", LibraryDirectory="modelica://DCOL/Resources/Library/FMU/ExternalLS/binaries",           __Dymola_CriticalRegion="Modelica_0IK4_0TEKNIKER_0DCOL_0ThermalStorage_0LatentStoragesNEW_0FMI_0ExternalLS_0Dym");
    end fmiGetBoolean;

    function fmiGetBooleanwf
      input fmiModel fmi;
      input Integer refs[:];
      input Integer preAvailable;
      output Boolean vals[size(refs, 1)];
      external"C" Modelica_0IK4_0TEKNIKER_0DCOL_0ThermalStorage_0LatentStoragesNEW_0FMI_0ExternalLS_0Dym_fmiGetBoolean2(
        fmi,
        refs,
        size(refs, 1),
        vals);
        annotation (Header="
#ifndef Modelica_0IK4_0TEKNIKER_0DCOL_0ThermalStorage_0LatentStoragesNEW_0FMI_0ExternalLS_0Dym_GetBoolean_C
#define Modelica_0IK4_0TEKNIKER_0DCOL_0ThermalStorage_0LatentStoragesNEW_0FMI_0ExternalLS_0Dym_GetBoolean_C 1
#include \"FMI/fmi2Import.h\"
void Modelica_0IK4_0TEKNIKER_0DCOL_0ThermalStorage_0LatentStoragesNEW_0FMI_0ExternalLS_0Dym_fmiGetBoolean2(void*m, const int* refs, size_t nr, int* vals) {
  int i;
  struct dy_fmi2Extended*a=m;
  fmi2Status status=fmi2Fatal;
  if (a) {
    status=a->dyFmiGetBoolean(a->m, refs, nr, (fmi2Boolean*)(vals));
  }
  if (status!=fmi2OK && status!=fmi2Warning) ModelicaError(\"GetBoolean failed\");
    for(i=nr-1;i>=0;i--) vals[i]=((fmi2Boolean*)(vals))[i];
  }
#endif", Library="Modelica_0IK4_0TEKNIKER_0DCOL_0ThermalStorage_0LatentStoragesNEW_0FMI_0ExternalLS_0Dym", LibraryDirectory="modelica://DCOL/Resources/Library/FMU/ExternalLS/binaries",           __Dymola_CriticalRegion="Modelica_0IK4_0TEKNIKER_0DCOL_0ThermalStorage_0LatentStoragesNEW_0FMI_0ExternalLS_0Dym");
    end fmiGetBooleanwf;

    function fmiSetBoolean
      input fmiModel fmi;
      input Integer refs[:];
      input Boolean vals[size(refs, 1)];
    protected
      Boolean dummy[size(refs, 1)];
      Boolean oldVals[size(refs, 1)];
      external"C" Modelica_0IK4_0TEKNIKER_0DCOL_0ThermalStorage_0LatentStoragesNEW_0FMI_0ExternalLS_0Dym_fmiSetBoolean2(
        fmi,
        refs,
        size(refs, 1),
        vals,
        dummy,
        oldVals);
        annotation (Header="
#ifndef Modelica_0IK4_0TEKNIKER_0DCOL_0ThermalStorage_0LatentStoragesNEW_0FMI_0ExternalLS_0Dym_SetBoolean_C
#define Modelica_0IK4_0TEKNIKER_0DCOL_0ThermalStorage_0LatentStoragesNEW_0FMI_0ExternalLS_0Dym_SetBoolean_C 1
#include \"FMI/fmi2Import.h\"
void Modelica_0IK4_0TEKNIKER_0DCOL_0ThermalStorage_0LatentStoragesNEW_0FMI_0ExternalLS_0Dym_fmiSetBoolean2(void*m, const int* refs, size_t nr, const int* vals, int* dummy, int* oldVals) {
  size_t i;
  int j;
  struct dy_fmi2Extended*a=m;
  fmi2Status status=fmi2Fatal;
  if(!nr){return;}
  for(i=0;i<nr;++i) ((fmi2Boolean*)(dummy))[i]=vals[i];
  if (a) {
    if(!a->discreteInputChanged){
      status=a->dyFmiGetBoolean(a->m, refs, nr, (fmi2Boolean*)(oldVals));
      if (status!=fmi2OK && status!=fmi2Warning) ModelicaError(\"GetBoolean failed in SetBoolean\");
      for(j=nr-1;j>=0;j--){
        oldVals[j]=((fmi2Boolean*)(oldVals))[j];
        if(oldVals[j] != dummy[j]){
          a->discreteInputChanged = 1;
          break;
        }
      }
    }
    if(a->discreteInputChanged){
      if(a->currentMode == dyfmi2ContinuousTimeMode){
        status = a->dyFmiEnterEventMode(a->m);
        if (status!=fmi2OK && status!=fmi2Warning) ModelicaError(\"fmiEnterEventModeFailed\");
        a->currentMode = dyfmi2EventMode;
      }
      status=a->dyFmiSetBoolean(a->m, refs, nr, (fmi2Boolean*)(dummy));
    }
  }
  if (status!=fmi2OK && status!=fmi2Warning) ModelicaError(\"SetBoolean failed\");
}
#endif", Library="Modelica_0IK4_0TEKNIKER_0DCOL_0ThermalStorage_0LatentStoragesNEW_0FMI_0ExternalLS_0Dym", LibraryDirectory="modelica://DCOL/Resources/Library/FMU/ExternalLS/binaries",           __Dymola_CriticalRegion="Modelica_0IK4_0TEKNIKER_0DCOL_0ThermalStorage_0LatentStoragesNEW_0FMI_0ExternalLS_0Dym",__Dymola_IdemPotent=true, __Dymola_VectorizedExceptFirst=true);
    end fmiSetBoolean;

    function fmiSetString
      input fmiModel fmi;
      input Integer refs[:];
      input String vals[size(refs, 1)];
      external"C" Modelica_0IK4_0TEKNIKER_0DCOL_0ThermalStorage_0LatentStoragesNEW_0FMI_0ExternalLS_0Dym_fmiSetString2(
        fmi,
        refs,
        size(refs, 1),
        vals);
      annotation (Header="
#ifndef Modelica_0IK4_0TEKNIKER_0DCOL_0ThermalStorage_0LatentStoragesNEW_0FMI_0ExternalLS_0Dym_SetString_C
#define Modelica_0IK4_0TEKNIKER_0DCOL_0ThermalStorage_0LatentStoragesNEW_0FMI_0ExternalLS_0Dym_SetString_C 1
#include <stdlib.h>
#include \"FMI/fmi2Import.h\"
void Modelica_0IK4_0TEKNIKER_0DCOL_0ThermalStorage_0LatentStoragesNEW_0FMI_0ExternalLS_0Dym_fmiSetString2(void*m, const int*refs, size_t nrefs,const fmi2String vals[]) {
  struct dy_fmi2Extended*a=m;
  fmi2Status status=fmi2Fatal;
  size_t i = 0;
  if(!nrefs){return;}
  if (a) {
    if(a->currentMode == dyfmi2ContinuousTimeMode){
      status = a->dyFmiEnterEventMode(a->m);
      if (status!=fmi2OK && status!=fmi2Warning) ModelicaError(\"fmiEnterEventModeFailed\");
      a->currentMode = dyfmi2EventMode;
    }
    status=a->dyFmiSetString(a->m, refs, nrefs, vals);
    a->discreteInputChanged = fmi2True;
  }
  if (status!=fmi2OK && status!=fmi2Warning) ModelicaError(\"SetString failed\");
}
#endif", Library="Modelica_0IK4_0TEKNIKER_0DCOL_0ThermalStorage_0LatentStoragesNEW_0FMI_0ExternalLS_0Dym", LibraryDirectory="modelica://DCOL/Resources/Library/FMU/ExternalLS/binaries",           __Dymola_CriticalRegion="Modelica_0IK4_0TEKNIKER_0DCOL_0ThermalStorage_0LatentStoragesNEW_0FMI_0ExternalLS_0Dym",__Dymola_IdemPotent=true, __Dymola_VectorizedExceptFirst=true);
    end fmiSetString;

    function fmiSetBooleanwf
      input fmiModel fmi;
      input Integer refs[:];
      input Boolean vals[size(refs, 1)];
      input Integer preAvailable;
      output Integer postAvailable=preAvailable;
    protected
      Boolean dummy[size(refs, 1)];
      external"C" Modelica_0IK4_0TEKNIKER_0DCOL_0ThermalStorage_0LatentStoragesNEW_0FMI_0ExternalLS_0Dym_fmiSetBoolean2wf(
        fmi,
        refs,
        size(refs, 1),
        vals,
        dummy);
        annotation (Header="
#ifndef Modelica_0IK4_0TEKNIKER_0DCOL_0ThermalStorage_0LatentStoragesNEW_0FMI_0ExternalLS_0Dym_SetBooleanwf_C
#define Modelica_0IK4_0TEKNIKER_0DCOL_0ThermalStorage_0LatentStoragesNEW_0FMI_0ExternalLS_0Dym_SetBooleanwf_C 1
#include \"FMI/fmi2Import.h\"
void Modelica_0IK4_0TEKNIKER_0DCOL_0ThermalStorage_0LatentStoragesNEW_0FMI_0ExternalLS_0Dym_fmiSetBoolean2wf(void*m, const int* refs, size_t nr, const int* vals, int* dummy) {
  size_t i;
  int j;
  struct dy_fmi2Extended*a=m;
  fmi2Status status=fmi2Fatal;
  if(!nr){return;}
  for(i=0;i<nr;++i) ((fmi2Boolean*)(dummy))[i]=vals[i];
  if (a) {
    status=a->dyFmiSetBoolean(a->m, refs, nr, (fmi2Boolean*)(dummy));
  }
  if (status!=fmi2OK && status!=fmi2Warning) ModelicaError(\"SetBoolean failed\");
}
#endif", Library="Modelica_0IK4_0TEKNIKER_0DCOL_0ThermalStorage_0LatentStoragesNEW_0FMI_0ExternalLS_0Dym", LibraryDirectory="modelica://DCOL/Resources/Library/FMU/ExternalLS/binaries",           __Dymola_CriticalRegion="Modelica_0IK4_0TEKNIKER_0DCOL_0ThermalStorage_0LatentStoragesNEW_0FMI_0ExternalLS_0Dym",__Dymola_IdemPotent=true, __Dymola_VectorizedExceptFirst=true);
    end fmiSetBooleanwf;

    function fmiGetDirectionalDerivative
      input fmiModel fmi;
      input Integer z_refs[:];
      input Integer v_refs[:];
      input Real dv[size(v_refs, 1)];
      output Real dz[size(z_refs, 1)];
      external"C" Modelica_0IK4_0TEKNIKER_0DCOL_0ThermalStorage_0LatentStoragesNEW_0FMI_0ExternalLS_0Dym_GetDirectionalDerivative2(
        fmi,
        z_refs,
        size(z_refs, 1),
        v_refs,
        size(v_refs, 1),
        dv,
        dz);
      annotation (Header="
#ifndef Modelica_0IK4_0TEKNIKER_0DCOL_0ThermalStorage_0LatentStoragesNEW_0FMI_0ExternalLS_0Dym_GetDirectionalDerivative2_C
#define Modelica_0IK4_0TEKNIKER_0DCOL_0ThermalStorage_0LatentStoragesNEW_0FMI_0ExternalLS_0Dym_GetDirectionalDerivative2_C 1
#include \"FMI/fmi2Import.h\"
void Modelica_0IK4_0TEKNIKER_0DCOL_0ThermalStorage_0LatentStoragesNEW_0FMI_0ExternalLS_0Dym_GetDirectionalDerivative2(void*m, const int* zref, size_t nzr, const int* vrefs, size_t nvr, const double *dv, double *dz) {
  struct dy_fmi2Extended*a=m;
  fmi2Status status=fmi2Fatal;
  if (a) {
    status=a->dyFmiGetDirectionalDerivative(a->m, zref, nzr, vrefs, nvr, dv, dz);
  }
  if (status!=fmi2OK && status!=fmi2Warning) ModelicaError(\"fmiGetDirectionalDerivative failed\");
}
#endif", Library="Modelica_0IK4_0TEKNIKER_0DCOL_0ThermalStorage_0LatentStoragesNEW_0FMI_0ExternalLS_0Dym", LibraryDirectory="modelica://DCOL/Resources/Library/FMU/ExternalLS/binaries",           __Dymola_CriticalRegion="Modelica_0IK4_0TEKNIKER_0DCOL_0ThermalStorage_0LatentStoragesNEW_0FMI_0ExternalLS_0Dym");
    end fmiGetDirectionalDerivative;

    function fmiSaveFMUState
      input fmiModel fmi;
      external"C" Modelica_0IK4_0TEKNIKER_0DCOL_0ThermalStorage_0LatentStoragesNEW_0FMI_0ExternalLS_0Dym_fmiSaveFMUState2(fmi);
        annotation (Header="
#ifndef Modelica_0IK4_0TEKNIKER_0DCOL_0ThermalStorage_0LatentStoragesNEW_0FMI_0ExternalLS_0Dym_fmiSaveFMUState_C
#define Modelica_0IK4_0TEKNIKER_0DCOL_0ThermalStorage_0LatentStoragesNEW_0FMI_0ExternalLS_0Dym_fmiSaveFMUState_C 1
#include \"FMI/fmi2Import.h\"
void Modelica_0IK4_0TEKNIKER_0DCOL_0ThermalStorage_0LatentStoragesNEW_0FMI_0ExternalLS_0Dym_fmiSaveFMUState2(void*m) {
  struct dy_fmi2Extended*a=m;
  fmi2Status status=fmi2Fatal;
  if (a) {
    status = a->dyFmiGetFMUstate(a->m, &a->dyFMUstate);
  }
  if (status!=fmi2OK && status!=fmi2Warning) ModelicaError(\"fmiGetFMUstate failed\");
}
#endif", Library="Modelica_0IK4_0TEKNIKER_0DCOL_0ThermalStorage_0LatentStoragesNEW_0FMI_0ExternalLS_0Dym", LibraryDirectory="modelica://DCOL/Resources/Library/FMU/ExternalLS/binaries",           __Dymola_CriticalRegion="Modelica_0IK4_0TEKNIKER_0DCOL_0ThermalStorage_0LatentStoragesNEW_0FMI_0ExternalLS_0Dym");
    end fmiSaveFMUState;

    function fmiRestoreFMUState
      input fmiModel fmi;
      external"C" Modelica_0IK4_0TEKNIKER_0DCOL_0ThermalStorage_0LatentStoragesNEW_0FMI_0ExternalLS_0Dym_fmiRestoreFMUState2(fmi);
        annotation (Header="
#ifndef Modelica_0IK4_0TEKNIKER_0DCOL_0ThermalStorage_0LatentStoragesNEW_0FMI_0ExternalLS_0Dym_fmiRestoreFMUState_C
#define Modelica_0IK4_0TEKNIKER_0DCOL_0ThermalStorage_0LatentStoragesNEW_0FMI_0ExternalLS_0Dym_fmiRestoreFMUState_C 1
#include \"FMI/fmi2Import.h\"
void Modelica_0IK4_0TEKNIKER_0DCOL_0ThermalStorage_0LatentStoragesNEW_0FMI_0ExternalLS_0Dym_fmiRestoreFMUState2(void*m) {
  struct dy_fmi2Extended*a=m;
  fmi2Status status=fmi2Fatal;
  if (a) {
    status = a->dyFmiSetFMUstate(a->m, a->dyFMUstate);
  }
  if (status!=fmi2OK && status!=fmi2Warning) ModelicaError(\"fmiSetFMUstate failed\");
}
#endif", Library="Modelica_0IK4_0TEKNIKER_0DCOL_0ThermalStorage_0LatentStoragesNEW_0FMI_0ExternalLS_0Dym", LibraryDirectory="modelica://DCOL/Resources/Library/FMU/ExternalLS/binaries",           __Dymola_CriticalRegion="Modelica_0IK4_0TEKNIKER_0DCOL_0ThermalStorage_0LatentStoragesNEW_0FMI_0ExternalLS_0Dym");
    end fmiRestoreFMUState;

    function fmiEnterSlaveInitializationMode
      input fmiModel fmi;
      input Real relativeTolerance;
      input Real tStart;
      input Boolean forceShutDownAtTStop;
      input Real tStop;
      input Real preAvailable;
      output Real postAvailable = preAvailable;
      external"C" Modelica_0IK4_0TEKNIKER_0DCOL_0ThermalStorage_0LatentStoragesNEW_0FMI_0ExternalLS_0Dym_fmiEnterSlaveInitializationMode2(fmi, relativeTolerance, tStart, forceShutDownAtTStop, tStop);
      annotation (Header="
#ifndef Modelica_0IK4_0TEKNIKER_0DCOL_0ThermalStorage_0LatentStoragesNEW_0FMI_0ExternalLS_0Dym_fmiEnterSlaveInitializationMode_C
#define Modelica_0IK4_0TEKNIKER_0DCOL_0ThermalStorage_0LatentStoragesNEW_0FMI_0ExternalLS_0Dym_fmiEnterSlaveInitializationMode_C 1
#include <stdlib.h>
#include \"FMI/fmi2Import.h\"
void Modelica_0IK4_0TEKNIKER_0DCOL_0ThermalStorage_0LatentStoragesNEW_0FMI_0ExternalLS_0Dym_fmiEnterSlaveInitializationMode2(void*m, double relativeTolerance, double tStart, int forceShutDownAtTStop, double tStop) {
  struct dy_fmi2Extended*a=m;
  fmi2Status status=fmi2Fatal;
  if (a) {
    if(a->currentMode==dyfmi2InstantiationMode){
      status=a->dyFmiSetupExperiment(a->m, fmi2True, relativeTolerance, tStart, forceShutDownAtTStop, tStop);
      status=a->dyFmiEnterInitializationMode(a->m);
      a->dyTriggered=0;
      a->dyLastTime=a->dyTime;
      a->currentMode=dyfmi2InitializationMode;
    }else{
      status=fmi2OK;
    }
  }
  if (status!=fmi2OK && status!=fmi2Warning) ModelicaError(\"InitializeSlave failed\");
}
#endif", Library="Modelica_0IK4_0TEKNIKER_0DCOL_0ThermalStorage_0LatentStoragesNEW_0FMI_0ExternalLS_0Dym", LibraryDirectory="modelica://DCOL/Resources/Library/FMU/ExternalLS/binaries",           __Dymola_CriticalRegion="Modelica_0IK4_0TEKNIKER_0DCOL_0ThermalStorage_0LatentStoragesNEW_0FMI_0ExternalLS_0Dym");
    end fmiEnterSlaveInitializationMode;

    function fmiExitSlaveInitializationMode
      input fmiModel fmi;
      input Real preAvailable;
      output Real postAvailable = preAvailable;
      external"C" Modelica_0IK4_0TEKNIKER_0DCOL_0ThermalStorage_0LatentStoragesNEW_0FMI_0ExternalLS_0Dym_fmiExitSlaveInitializationMode2(fmi);
      annotation (Header="
#ifndef Modelica_0IK4_0TEKNIKER_0DCOL_0ThermalStorage_0LatentStoragesNEW_0FMI_0ExternalLS_0Dym_fmiExitSlaveInitializationMode_C
#define Modelica_0IK4_0TEKNIKER_0DCOL_0ThermalStorage_0LatentStoragesNEW_0FMI_0ExternalLS_0Dym_fmiExitSlaveInitializationMode_C 1
#include <stdlib.h>
#include \"FMI/fmi2Import.h\"
void Modelica_0IK4_0TEKNIKER_0DCOL_0ThermalStorage_0LatentStoragesNEW_0FMI_0ExternalLS_0Dym_fmiExitSlaveInitializationMode2(void*m) {
  struct dy_fmi2Extended*a=m;
  fmi2Status status=fmi2Fatal;
  if (a) {
    status=a->dyFmiExitInitializationMode(a->m);
    a->dyTriggered=0;
    a->dyLastTime=a->dyTime;
    a->currentMode = dyfmi2EventMode;
  }
  if (status!=fmi2OK && status!=fmi2Warning) ModelicaError(\"fmiExitModelInitialization failed!\");
  return;
}
#endif", Library="Modelica_0IK4_0TEKNIKER_0DCOL_0ThermalStorage_0LatentStoragesNEW_0FMI_0ExternalLS_0Dym", LibraryDirectory="modelica://DCOL/Resources/Library/FMU/ExternalLS/binaries",           __Dymola_CriticalRegion="Modelica_0IK4_0TEKNIKER_0DCOL_0ThermalStorage_0LatentStoragesNEW_0FMI_0ExternalLS_0Dym");
    end fmiExitSlaveInitializationMode;
end fmi_Functions;
initial equation
    _water_m_flow_a_old = water_m_flow_a;
    _water_T_old = water_T;
    _HTF_m_flow_a_old = HTF_m_flow_a;
    _HTF_T_old = HTF_T;
    _water_m_flow_b_old = water_m_flow_b;
    _Ambient_T_old = Ambient_T;
equation
  when initial() then
    fmi = fmi_Functions.fmiModel(fmi_instanceName, fmi_loggingOn, fmi_resourceLocation);
  end when;
initial algorithm
  fmi_Functions.fmiSetReal(fmi, {16777216, 16777217, 16777218, 16777219, 16777220, 16777221, 16777222, 16777223, 16777224, 16777225, 16777226, 16777227, 16777228, 16777229, 16777230, 16777231, 16777232, 16777233, 16777236, 16777238, 16777239, 16777241, 16777242, 16777243, 16777244, 16777245, 16777246, 16777247, 16777248, 16777249, 16777250, 16777251, 16777252, 16777253, 16777254, 16777255, 16777256, 16777257, 16777258, 16777259, 16777260, 16777261}, {'system'.p_ambient, 'system'.T_ambient, 'system'.g, 'system'.eps_m_flow, 'system'.dp_small, 'system'.m_flow_small, k_s, k_l, d_s, d_l, cp_s, cp_l, mu, T0, hfus, h_l, r_int, S_L, m_flow_start, iceLiquidVessel.pipe.roughness, iceLiquidVessel.pipe.'X_start[1]', iceLiquidVessel.pipe.flowModel.Re_turbulent, iceLiquidVessel.pipe.flowModel.dp_nominal, iceLiquidVessel.pipe.flowModel.m_flow_nominal, iceLiquidVessel.pipe.heatTransfer.alpha0, iceLiquidVessel.pipe.'mediums[1]'.T_start, iceLiquidVessel.pipe.'mediums[2]'.T_start, iceLiquidVessel.pipe.'mediums[3]'.T_start, iceLiquidVessel.pipe.'mediums[4]'.T_start, iceLiquidVessel.pipe.'mediums[5]'.T_start, iceLiquidVessel.pipe.'mediums[6]'.T_start, iceLiquidVessel.pipe.'mediums[7]'.T_start, iceLiquidVessel.pipe.'mediums[8]'.T_start, iceLiquidVessel.pipe.'mediums[9]'.T_start, iceLiquidVessel.pipe.'mediums[10]'.T_start, iceLiquidVessel.hollowCylinder.der_T_start, iceLiquidVessel.hollowCylinder.alpha, iceLiquidVessel.thermalConductor.G, outlet_HTF.medium.T_start, outlet_HTF.p, outlet_HTF.T, outlet_HTF.'X[1]'});
  fmi_Functions.fmiSetInteger(fmi, {16777234, 16777235}, {n_T, n_L});
  fmi_Functions.fmiSetReal(fmi, {33554432, 318767104, 33554433, 318767105, 33554434, 318767106, 33554435, 318767107, 33554436, 318767108, 33554437, 318767109, 33554438, 318767110, 33554439, 318767111, 33554440, 318767112, 33554441, 318767113, 33554444, 33554445, 33554446, 33554447, 33554448, 33554449, 33554450, 33554451, 33554452, 33554453, 33554454, 33554455}, {iceLiquidVessel.pipe.'mediums[1]'._T_start, iceLiquidVessel.pipe.'mediums[1]'._T_der_start, iceLiquidVessel.pipe.'mediums[2]'._T_start, iceLiquidVessel.pipe.'mediums[2]'._T_der_start, iceLiquidVessel.pipe.'mediums[3]'._T_start, iceLiquidVessel.pipe.'mediums[3]'._T_der_start, iceLiquidVessel.pipe.'mediums[4]'._T_start, iceLiquidVessel.pipe.'mediums[4]'._T_der_start, iceLiquidVessel.pipe.'mediums[5]'._T_start, iceLiquidVessel.pipe.'mediums[5]'._T_der_start, iceLiquidVessel.pipe.'mediums[6]'._T_start, iceLiquidVessel.pipe.'mediums[6]'._T_der_start, iceLiquidVessel.pipe.'mediums[7]'._T_start, iceLiquidVessel.pipe.'mediums[7]'._T_der_start, iceLiquidVessel.pipe.'mediums[8]'._T_start, iceLiquidVessel.pipe.'mediums[8]'._T_der_start, iceLiquidVessel.pipe.'mediums[9]'._T_start, iceLiquidVessel.pipe.'mediums[9]'._T_der_start, iceLiquidVessel.pipe.'mediums[10]'._T_start, iceLiquidVessel.pipe.'mediums[10]'._T_der_start, iceLiquidVessel.iceLiquidVessel._T_l_start, iceLiquidVessel.hollowCylinder.'heatCapacitors[1, 1, 1]'._T_start, iceLiquidVessel.hollowCylinder.'heatCapacitors[1, 1, 2]'._T_start, iceLiquidVessel.hollowCylinder.'heatCapacitors[1, 2, 2]'._T_start, iceLiquidVessel.hollowCylinder.'heatCapacitors[1, 3, 2]'._T_start, iceLiquidVessel.hollowCylinder.'heatCapacitors[1, 4, 2]'._T_start, iceLiquidVessel.hollowCylinder.'heatCapacitors[1, 5, 2]'._T_start, iceLiquidVessel.hollowCylinder.'heatCapacitors[1, 6, 2]'._T_start, iceLiquidVessel.hollowCylinder.'heatCapacitors[1, 7, 2]'._T_start, iceLiquidVessel.hollowCylinder.'heatCapacitors[1, 8, 2]'._T_start, iceLiquidVessel.hollowCylinder.'heatCapacitors[1, 9, 2]'._T_start, iceLiquidVessel.hollowCylinder.'heatCapacitors[1, 10, 2]'._T_start});
    fmi_Functions.fmiSetReal(fmi, {352321536}, {_water_m_flow_a_start});
    fmi_Functions.fmiSetReal(fmi, {352321537}, {_water_T_start});
    fmi_Functions.fmiSetReal(fmi, {352321538}, {_HTF_m_flow_a_start});
    fmi_Functions.fmiSetReal(fmi, {352321539}, {_HTF_T_start});
    fmi_Functions.fmiSetReal(fmi, {352321540}, {_water_m_flow_b_start});
    fmi_Functions.fmiSetReal(fmi, {352321541}, {_Ambient_T_start});
    fmi_Functions.fmiEnterSlaveInitializationMode(fmi, fmi_rTol, fmi_StartTime, fmi_forceShutDownAtStopTime, fmi_StopTime, 1);
  fmi_rdum := 1;
  fmi_idum := 1;
algorithm
  when {initial(), sample(fmi_StartTime, fmi_CommunicationStepSize)} then
    if fmi_InputTime then
      fmi_Functions.fmiSetReal(fmi, {352321536}, {_water_m_flow_a_old});
    else
      if fmi_UsePreOnInputSignals then
        fmi_Functions.fmiSetReal(fmi, {352321536}, {pre(water_m_flow_a)});
      else
        fmi_Functions.fmiSetReal(fmi, {352321536}, {water_m_flow_a});
      end if;
    end if;
    if fmi_InputTime then
      fmi_Functions.fmiSetReal(fmi, {352321537}, {_water_T_old});
    else
      if fmi_UsePreOnInputSignals then
        fmi_Functions.fmiSetReal(fmi, {352321537}, {pre(water_T)});
      else
        fmi_Functions.fmiSetReal(fmi, {352321537}, {water_T});
      end if;
    end if;
    if fmi_InputTime then
      fmi_Functions.fmiSetReal(fmi, {352321538}, {_HTF_m_flow_a_old});
    else
      if fmi_UsePreOnInputSignals then
        fmi_Functions.fmiSetReal(fmi, {352321538}, {pre(HTF_m_flow_a)});
      else
        fmi_Functions.fmiSetReal(fmi, {352321538}, {HTF_m_flow_a});
      end if;
    end if;
    if fmi_InputTime then
      fmi_Functions.fmiSetReal(fmi, {352321539}, {_HTF_T_old});
    else
      if fmi_UsePreOnInputSignals then
        fmi_Functions.fmiSetReal(fmi, {352321539}, {pre(HTF_T)});
      else
        fmi_Functions.fmiSetReal(fmi, {352321539}, {HTF_T});
      end if;
    end if;
    if fmi_InputTime then
      fmi_Functions.fmiSetReal(fmi, {352321540}, {_water_m_flow_b_old});
    else
      if fmi_UsePreOnInputSignals then
        fmi_Functions.fmiSetReal(fmi, {352321540}, {pre(water_m_flow_b)});
      else
        fmi_Functions.fmiSetReal(fmi, {352321540}, {water_m_flow_b});
      end if;
    end if;
    if fmi_InputTime then
      fmi_Functions.fmiSetReal(fmi, {352321541}, {_Ambient_T_old});
    else
      if fmi_UsePreOnInputSignals then
        fmi_Functions.fmiSetReal(fmi, {352321541}, {pre(Ambient_T)});
      else
        fmi_Functions.fmiSetReal(fmi, {352321541}, {Ambient_T});
      end if;
    end if;
      if fmi_rdum >= 0  and fmi_idum >= 0 and not fmi_exitInit and not initial() then
        fmi_Functions.fmiExitSlaveInitializationMode(fmi, 1);
        fmi_exitInit:=true;
      end if;
    if time>=fmi_CommunicationStepSize +fmi_StartTime then
      for stepSizeIndex in 1:stepSizeScaleFactor loop
        fmi_StepOK :=fmi_Functions.fmiDoStep(
          fmi,
          time + (stepSizeIndex - 1 - stepSizeScaleFactor)*
            fmi_CommunicationStepSize/stepSizeScaleFactor,
          fmi_CommunicationStepSize/stepSizeScaleFactor,
          1);
      end for;
      fmi_flip :=not pre(fmi_flip);
    end if;
  HTF_outlet_T :=fmi_Functions.fmiGetRealScalar(fmi, 335544320);
  water_outlet_T :=fmi_Functions.fmiGetRealScalar(fmi, 335544321);
  charge_percentage :=fmi_Functions.fmiGetRealScalar(fmi, 335544322);
  storaged_energy :=fmi_Functions.fmiGetRealScalar(fmi, 335544323);
  energy_percentage :=fmi_Functions.fmiGetRealScalar(fmi, 335544324);
RealVariables :=fmi_Functions.fmiGetReal(fmi, {33554432,318767104,33554433,
      318767105,33554434,318767106,33554435,318767107,33554436,318767108,
      33554437,318767109,33554438,318767110,33554439,318767111,33554440,
      318767112,33554441,318767113,33554442,587202570,33554443,587202571,
      33554444,587202572,33554445,587202573,33554446,587202574,33554447,
      587202575,33554448,587202576,33554449,587202577,33554450,587202578,
      33554451,587202579,33554452,587202580,33554453,587202581,33554454,
      587202582,33554455,587202583});
  end when;
  when {pre(fmi_flip), not pre(fmi_flip)} then
    _water_m_flow_a_old := pre(water_m_flow_a);
    _water_T_old := pre(water_T);
    _HTF_m_flow_a_old := pre(HTF_m_flow_a);
    _HTF_T_old := pre(HTF_T);
    _water_m_flow_b_old := pre(water_m_flow_b);
    _Ambient_T_old := pre(Ambient_T);
  end when;
equation
  iceLiquidVessel.pipe.'mediums[1]'.T = RealVariables[1];
  iceLiquidVessel.pipe.'mediums[1]'.T_der = RealVariables[2];
  iceLiquidVessel.pipe.'mediums[2]'.T = RealVariables[3];
  iceLiquidVessel.pipe.'mediums[2]'.T_der = RealVariables[4];
  iceLiquidVessel.pipe.'mediums[3]'.T = RealVariables[5];
  iceLiquidVessel.pipe.'mediums[3]'.T_der = RealVariables[6];
  iceLiquidVessel.pipe.'mediums[4]'.T = RealVariables[7];
  iceLiquidVessel.pipe.'mediums[4]'.T_der = RealVariables[8];
  iceLiquidVessel.pipe.'mediums[5]'.T = RealVariables[9];
  iceLiquidVessel.pipe.'mediums[5]'.T_der = RealVariables[10];
  iceLiquidVessel.pipe.'mediums[6]'.T = RealVariables[11];
  iceLiquidVessel.pipe.'mediums[6]'.T_der = RealVariables[12];
  iceLiquidVessel.pipe.'mediums[7]'.T = RealVariables[13];
  iceLiquidVessel.pipe.'mediums[7]'.T_der = RealVariables[14];
  iceLiquidVessel.pipe.'mediums[8]'.T = RealVariables[15];
  iceLiquidVessel.pipe.'mediums[8]'.T_der = RealVariables[16];
  iceLiquidVessel.pipe.'mediums[9]'.T = RealVariables[17];
  iceLiquidVessel.pipe.'mediums[9]'.T_der = RealVariables[18];
  iceLiquidVessel.pipe.'mediums[10]'.T = RealVariables[19];
  iceLiquidVessel.pipe.'mediums[10]'.T_der = RealVariables[20];
  iceLiquidVessel.iceLiquidVessel.m_l = RealVariables[21];
  iceLiquidVessel.iceLiquidVessel.m_l_der = RealVariables[22];
  iceLiquidVessel.iceLiquidVessel.m_s = RealVariables[23];
  iceLiquidVessel.iceLiquidVessel.m_s_der = RealVariables[24];
  iceLiquidVessel.iceLiquidVessel.T_l = RealVariables[25];
  iceLiquidVessel.iceLiquidVessel.T_l_der = RealVariables[26];
  iceLiquidVessel.hollowCylinder.'heatCapacitors[1, 1, 1]'.T = RealVariables[27];
  iceLiquidVessel.hollowCylinder.'heatCapacitors[1, 1, 1]'.T_der = RealVariables[28];
  iceLiquidVessel.hollowCylinder.'heatCapacitors[1, 1, 2]'.T = RealVariables[29];
  iceLiquidVessel.hollowCylinder.'heatCapacitors[1, 1, 2]'.T_der = RealVariables[30];
  iceLiquidVessel.hollowCylinder.'heatCapacitors[1, 2, 2]'.T = RealVariables[31];
  iceLiquidVessel.hollowCylinder.'heatCapacitors[1, 2, 2]'.T_der = RealVariables[32];
  iceLiquidVessel.hollowCylinder.'heatCapacitors[1, 3, 2]'.T = RealVariables[33];
  iceLiquidVessel.hollowCylinder.'heatCapacitors[1, 3, 2]'.T_der = RealVariables[34];
  iceLiquidVessel.hollowCylinder.'heatCapacitors[1, 4, 2]'.T = RealVariables[35];
  iceLiquidVessel.hollowCylinder.'heatCapacitors[1, 4, 2]'.T_der = RealVariables[36];
  iceLiquidVessel.hollowCylinder.'heatCapacitors[1, 5, 2]'.T = RealVariables[37];
  iceLiquidVessel.hollowCylinder.'heatCapacitors[1, 5, 2]'.T_der = RealVariables[38];
  iceLiquidVessel.hollowCylinder.'heatCapacitors[1, 6, 2]'.T = RealVariables[39];
  iceLiquidVessel.hollowCylinder.'heatCapacitors[1, 6, 2]'.T_der = RealVariables[40];
  iceLiquidVessel.hollowCylinder.'heatCapacitors[1, 7, 2]'.T = RealVariables[41];
  iceLiquidVessel.hollowCylinder.'heatCapacitors[1, 7, 2]'.T_der = RealVariables[42];
  iceLiquidVessel.hollowCylinder.'heatCapacitors[1, 8, 2]'.T = RealVariables[43];
  iceLiquidVessel.hollowCylinder.'heatCapacitors[1, 8, 2]'.T_der = RealVariables[44];
  iceLiquidVessel.hollowCylinder.'heatCapacitors[1, 9, 2]'.T = RealVariables[45];
  iceLiquidVessel.hollowCylinder.'heatCapacitors[1, 9, 2]'.T_der = RealVariables[46];
  iceLiquidVessel.hollowCylinder.'heatCapacitors[1, 10, 2]'.T = RealVariables[47];
  iceLiquidVessel.hollowCylinder.'heatCapacitors[1, 10, 2]'.T_der = RealVariables[48];
  annotation (__Dymola_FMUImportVersion="Dymola 2018 FD01", experiment(StartTime=0.0, StopTime=17000.0, Tolerance=1E-006),
    Icon(graphics={
      Rectangle(
        extent={{-100,100},{100,-100}},
        lineColor={95,95,95},
        fillColor={255,255,255},
        fillPattern=FillPattern.Solid,
        lineThickness=0.5),
      Text(extent={{-150,150},{150,110}},
        lineColor={0,0,255},
        textString="%name"),
      Text(extent={{-150,-110},{150,-150}},
        lineColor={95,95,95},
        textString="FMI 2.0 CS")}),
Documentation(info="<html>
<h4>ModelDescription Attributes</h4>
<ul>
<li>fmiVersion = 2.0</li>
<li>modelName = Modelica_IK4_TEKNIKER_DCOL_ThermalStorage_LatentStoragesNEW_FMI_ExternalLS_Dym</li>
<li>generationTool = Dymola Version 2018 (64-bit), 2017-04-10</li>
<li>generationDateAndTime = 2018-01-18T08:19:13Z</li>
</ul>
<p><br><b>Co-Simulation Attributes</b></p>
<ul>
<li>needsExecutionTool = false</li>
<li>canHandleVariableCommunicationStepSize = true</li>
<li>canInterpolateInputs = true</li>
<li>maxOutputDerivativeOrder = 1</li>
<li>canRunAsynchronuously = false</li>
<li>canBeInstantiatedOnlyOncePerProcess = false</li>
<li>canNotUseMemoryManagementFunctions = false</li>
<li>canGetAndSetFMUstate = true</li>
<li>canSerializeFMUstate = false</li>
<li>providesDirectionalDerivative = true</li>
</ul>
</html>"));
end ExternalLS_fmu;
