within DCOL.ThermalStorage.LatentStoragesNEW.FMI.Pruebas;
model Test_ExternalLS
  import Modelica_IK4_TEKNIKER;

  Modelica.Blocks.Sources.Trapezoid water_m_flow_a(
    falling(displayUnit="min") = 300,
    amplitude=0.5,
    rising(displayUnit="min") = 300,
    width(displayUnit="h") = 28800,
    period(displayUnit="h") = 57600,
    startTime(displayUnit="h") = 32400)
    annotation (Placement(transformation(extent={{-80,70},{-60,90}})));
  Modelica.Blocks.Sources.Trapezoid water_m_flow_b(
    amplitude=-water_m_flow_a.amplitude,
    rising(displayUnit="min") = water_m_flow_a.rising,
    width(displayUnit="min") = water_m_flow_a.width,
    falling(displayUnit="min") = water_m_flow_a.falling,
    period(displayUnit="min") = water_m_flow_a.period,
    startTime(displayUnit="min") = water_m_flow_a.startTime)
    annotation (Placement(transformation(extent={{-80,-60},{-60,-40}})));
  Modelica.Blocks.Sources.TimeTable HTF_T(table=[0.0,-3 + 273.15; 100000,-3 + 273.15])
    annotation (Placement(transformation(extent={{-80,-30},{-60,-10}})));
  Modelica.Blocks.Sources.Trapezoid HTF_m_flow_a(
    each rising(displayUnit="min") = 300,
    each falling(displayUnit="min") = 300,
    each width(displayUnit="h") = 28800,
    each period(displayUnit="h") = 64800,
    each amplitude=1)   annotation (Placement(transformation(extent={{-80,10},{
            -60,30}})));
  Modelica.Blocks.Sources.TimeTable water_T(table=[0.0,10 + 273.15; 100000,10 + 273.15])
    annotation (Placement(transformation(extent={{-80,40},{-60,60}})));
  Modelica.Blocks.Sources.TimeTable Ambient_T(table=[0.0,0 + 273.15; 100000,0
         + 273.15])
    annotation (Placement(transformation(extent={{-80,-90},{-60,-70}})));
  Modelica_IK4_TEKNIKER.DCOL.ThermalStorage.LatentStoragesNEW.FMI.ExternalLS_Dym
    test_ExternalLS(S_T=0.021, S_L=0.03)
    annotation (Placement(transformation(extent={{-6,-40},{74,40}})));
  Modelica_IK4_TEKNIKER.DCOL.ThermalStorage.LatentStoragesNEW.FMI.RealConectors.RealTemperatureOutput
                                      HTF_outlet_T
    annotation (Placement(transformation(extent={{100,70},{120,90}})));
  Modelica_IK4_TEKNIKER.DCOL.ThermalStorage.LatentStoragesNEW.FMI.RealConectors.RealTemperatureOutput
                                      water_outlet_T
    annotation (Placement(transformation(extent={{100,30},{120,50}})));
  Modelica_IK4_TEKNIKER.DCOL.ThermalStorage.LatentStoragesNEW.FMI.RealConectors.RealMassFractionOutput
                                       charge_percentage
    annotation (Placement(transformation(extent={{100,-10},{120,10}})));
  Modelica_IK4_TEKNIKER.DCOL.ThermalStorage.LatentStoragesNEW.FMI.RealConectors.RealInternalEnergy
                                                                             storaged_energy
    annotation (Placement(transformation(extent={{100,-50},{120,-30}})));
  Modelica_IK4_TEKNIKER.DCOL.ThermalStorage.LatentStoragesNEW.FMI.RealConectors.RealMassFractionOutput
                                                                                 energy_percentage
    annotation (Placement(transformation(extent={{100,-90},{120,-70}})));
equation

  connect(water_m_flow_a.y, test_ExternalLS.water_m_flow_a)
    annotation (Line(points={{-59,80},{-20,80},{-20,32},{-6,32}},  color={0,0,127}));
  connect(water_T.y, test_ExternalLS.water_T)
    annotation (Line(points={{-59,50},{-30,50},{-30,16},{-6,16}},  color={0,0,127}));
  connect(HTF_m_flow_a.y, test_ExternalLS.HTF_m_flow_a)
    annotation (Line(points={{-59,20},{-40,20},{-40,0},{-6,0}},  color={0,0,127}));
  connect(HTF_T.y, test_ExternalLS.HTF_T)
    annotation (Line(points={{-59,-20},{-40,-20},{-40,-16},{-6,-16}},color={0,0,127}));
  connect(Ambient_T.y, test_ExternalLS.Ambient_T)
    annotation (Line(points={{-59,-80},{-20,-80},{-20,-32},{-6,-32}},  color={0,0,127}));
  connect(test_ExternalLS.HTF_outlet_T, HTF_outlet_T) annotation (Line(points={{78,32},
          {80,32},{80,80},{110,80}},         color={0,0,127}));
  connect(test_ExternalLS.water_outlet_T, water_outlet_T) annotation (Line(
        points={{78,16},{90,16},{90,40},{110,40}}, color={0,0,127}));
  connect(test_ExternalLS.charge_percentage, charge_percentage)
    annotation (Line(points={{78,0},{110,0}}, color={0,0,127}));
  connect(test_ExternalLS.storaged_energy, storaged_energy) annotation (Line(
        points={{78,-16},{90,-16},{90,-40},{110,-40}}, color={0,0,127}));
  connect(test_ExternalLS.energy_percentage, energy_percentage) annotation (
      Line(points={{78,-32},{80,-32},{80,-80},{110,-80}}, color={0,0,127}));
  annotation (experiment(
      StopTime=72000,
      Interval=10,
      Tolerance=1e-06,
      __Dymola_Algorithm="Cvode"));
end Test_ExternalLS;
