within DCOL.ThermalStorage.LatentStoragesNEW.FMI.Pruebas;
model Test_ExternalLS_FMU
  import Modelica_IK4_TEKNIKER;

  Modelica.Blocks.Sources.Trapezoid water_m_flow_a(
    period(displayUnit="min") = 14400,
    rising(displayUnit="min") = 300,
    width(displayUnit="min") = 4200,
    falling(displayUnit="min") = 300,
    amplitude=10,
    startTime(displayUnit="min") = 7800)
    annotation (Placement(transformation(extent={{-80,70},{-60,90}})));
  Modelica.Blocks.Sources.Trapezoid water_m_flow_b(
    amplitude=-water_m_flow_a.amplitude,
    rising(displayUnit="min") = water_m_flow_a.rising,
    width(displayUnit="min") = water_m_flow_a.width,
    falling(displayUnit="min") = water_m_flow_a.falling,
    period(displayUnit="min") = water_m_flow_a.period,
    startTime(displayUnit="min") = water_m_flow_a.startTime)
    annotation (Placement(transformation(extent={{-80,-60},{-60,-40}})));
  Modelica.Blocks.Sources.TimeTable HTF_T(table=[0.0,-3 + 273.15; 100000,-3 + 273.15])
    annotation (Placement(transformation(extent={{-80,-30},{-60,-10}})));
  Modelica.Blocks.Sources.Trapezoid HTF_m_flow_a(
    each rising(displayUnit="min") = 300,
    each falling(displayUnit="min") = 300,
    each period(displayUnit="min") = 14400,
    each width(displayUnit="min") = 6000,
    each amplitude=300) annotation (Placement(transformation(extent={{-80,10},{
            -60,30}})));
  Modelica.Blocks.Sources.TimeTable water_T(table=[0.0,10 + 273.15; 100000,10 + 273.15])
    annotation (Placement(transformation(extent={{-80,40},{-60,60}})));
  Modelica.Blocks.Sources.TimeTable Ambient_T(table=[0.0,20 + 273.15; 100000,20 + 273.15])
    annotation (Placement(transformation(extent={{-80,-90},{-60,-70}})));
  Modelica_IK4_TEKNIKER.DCOL.ThermalStorage.LatentStoragesNEW.FMI.ExternalLS_fmu
    externalLS_fmu
    annotation (Placement(transformation(extent={{26,-8},{46,12}})));
equation

  connect(water_m_flow_a.y, externalLS_fmu.water_m_flow_a) annotation (Line(
        points={{-59,80},{-30,80},{-30,9.2},{25.6,9.2}}, color={0,0,127}));
  connect(water_T.y, externalLS_fmu.water_T) annotation (Line(points={{-59,50},
          {-40,50},{-40,6.3},{25.6,6.3}}, color={0,0,127}));
  connect(HTF_m_flow_a.y, externalLS_fmu.HTF_m_flow_a) annotation (Line(points=
          {{-59,20},{-50,20},{-50,3.5},{25.6,3.5}}, color={0,0,127}));
  connect(externalLS_fmu.HTF_T, HTF_T.y) annotation (Line(points={{25.6,0.6},{
          -49.6,0.6},{-49.6,-20},{-59,-20}}, color={0,0,127}));
  connect(externalLS_fmu.Ambient_T, Ambient_T.y) annotation (Line(points={{25.6,
          -5.1},{25.6,-10},{-20,-10},{-20,-80},{-59,-80}}, color={0,0,127}));
  connect(water_m_flow_b.y, externalLS_fmu.water_m_flow_b) annotation (Line(
        points={{-59,-50},{-16,-50},{-16,-2.2},{25.6,-2.2}}, color={0,0,127}));
  annotation (experiment(
      StopTime=17000,
      Tolerance=1e-006,
      __Dymola_Algorithm="Cvode"));
end Test_ExternalLS_FMU;
