within DCOL.ThermalStorage.SensibleStorages;
model ClosedCylindricalTank
  import DCOL;
  extends DCOL.ThermalStorage.SensibleStorages.Interfaces.PartialClosedCylindricalTank;

equation

  h_seg=h/nSeg;

  //Calculation of the volume entering each Volume
  for i in 1:nSeg loop
    Vinstant[i]=(initialV/nSeg)+VIn[i]-VOut[i];
  end for;

    //Calculation of the volume entering the Top volume, depending on which are the inlet and outlet ports
  if volumeTop.ports[1].m_flow>0 then
    VIn[nSeg]=volumeTop.ports[1].m_flow/rhoIn[nSeg];
    sta_defaultIn[nSeg]=Medium.setState_phX(h=volumeTop.ports[1].h_outflow,
                                            p=volumeTop.ports[1].p,
                                            X=volumeTop.ports[1].Xi_outflow);
    rhoIn[nSeg]=Medium.density(sta_defaultIn[nSeg]);
    if volumeTop.ports[2].m_flow<0 then
      VOut[nSeg]=volumeTop.ports[2].m_flow/rhoOut[nSeg];
      sta_defaultOut[nSeg] = Medium.setState_phX(h=volumeTop.ports[2].h_outflow,
                                                 p=volumeTop.ports[2].p,
                                                 X=volumeTop.ports[2].Xi_outflow);
      rhoOut[nSeg]=Medium.density(sta_defaultOut[nSeg]);
    else
      VOut[nSeg]=volumeTop.ports[3].m_flow/rhoOut[nSeg];
      sta_defaultOut[nSeg] = Medium.setState_phX(h=volumeTop.ports[3].h_outflow,
                                                 p=volumeTop.ports[3].p,
                                                 X=volumeTop.ports[3].Xi_outflow);
      rhoOut[nSeg]=Medium.density(sta_defaultOut[nSeg]);
    end if;

  elseif volumeTop.ports[2].m_flow>0 then
    VIn[nSeg]=volumeTop.ports[2].m_flow/rhoIn[nSeg];
    sta_defaultIn[nSeg]=Medium.setState_phX(h=volumeTop.ports[2].h_outflow,
                                            p=volumeTop.ports[2].p,
                                            X=volumeTop.ports[2].Xi_outflow);
    rhoIn[nSeg]=Medium.density(sta_defaultIn[nSeg]);
    if volumeTop.ports[1].m_flow<0 then
      VOut[nSeg]=volumeTop.ports[1].m_flow/rhoOut[nSeg];
      sta_defaultOut[nSeg] = Medium.setState_phX(h=volumeTop.ports[1].h_outflow,
                                                 p=volumeTop.ports[1].p,
                                                 X=volumeTop.ports[1].Xi_outflow);
      rhoOut[nSeg]=Medium.density(sta_defaultOut[nSeg]);
    else
      VOut[nSeg]=volumeTop.ports[3].m_flow/rhoOut[nSeg];
      sta_defaultOut[nSeg] = Medium.setState_phX(h=volumeTop.ports[3].h_outflow,
                                                 p=volumeTop.ports[3].p,
                                                 X=volumeTop.ports[3].Xi_outflow);
      rhoOut[nSeg]=Medium.density(sta_defaultOut[nSeg]);
    end if;

  elseif volumeTop.ports[3].m_flow>0 then
    VIn[nSeg]=volumeTop.ports[3].m_flow/rhoIn[nSeg];
    sta_defaultIn[nSeg]=Medium.setState_phX(h=volumeTop.ports[3].h_outflow,
                                            p=volumeTop.ports[3].p,
                                            X=volumeTop.ports[3].Xi_outflow);
    rhoIn[nSeg]=Medium.density(sta_defaultIn[nSeg]);
    if volumeTop.ports[1].m_flow<0 then
      VOut[nSeg]=volumeTop.ports[1].m_flow/rhoOut[nSeg];
      sta_defaultOut[nSeg] = Medium.setState_phX(h=volumeTop.ports[1].h_outflow,
                                                 p=volumeTop.ports[1].p,
                                                 X=volumeTop.ports[1].Xi_outflow);
      rhoOut[nSeg]=Medium.density(sta_defaultOut[nSeg]);
    else
      VOut[nSeg]=volumeTop.ports[2].m_flow/rhoOut[nSeg];
      sta_defaultOut[nSeg] = Medium.setState_phX(h=volumeTop.ports[2].h_outflow,
                                                 p=volumeTop.ports[2].p,
                                                 X=volumeTop.ports[2].Xi_outflow);
      rhoOut[nSeg]=Medium.density(sta_defaultOut[nSeg]);
    end if;

  else
    VIn[nSeg]=volumeTop.ports[1].m_flow/rhoIn[nSeg];
    sta_defaultIn[nSeg]=Medium.setState_phX(h=volumeTop.ports[1].h_outflow,
                                            p=volumeTop.ports[1].p,
                                            X=volumeTop.ports[1].Xi_outflow);
    rhoIn[nSeg]=Medium.density(sta_defaultIn[nSeg]);
    VOut[nSeg]=volumeTop.ports[2].m_flow/rhoOut[nSeg];
    sta_defaultOut[nSeg] = Medium.setState_phX(h=volumeTop.ports[2].h_outflow,
                                               p=volumeTop.ports[2].p,
                                               X=volumeTop.ports[2].Xi_outflow);
    rhoOut[nSeg]=Medium.density(sta_defaultOut[nSeg]);
  end if;

    //Calculation of the volume entering the Middle volume, depending on which are the inlet and outlet ports
  for i in 2:nSeg-1 loop
    if volumeMiddle[i-1].ports[1].m_flow>0 then
      VIn[i]=volumeMiddle[i-1].ports[1].m_flow/rhoIn[1];
      sta_defaultIn[i]=Medium.setState_phX(h=volumeMiddle[i-1].ports[1].h_outflow,
                                           p=volumeMiddle[i-1].ports[1].p,
                                           X=volumeMiddle[i-1].ports[1].Xi_outflow);
      rhoIn[i]=Medium.density(sta_defaultIn[i]);
      if volumeMiddle[i-1].ports[2].m_flow<0 then
        VOut[i]=volumeMiddle[i-1].ports[2].m_flow/rhoOut[1];
        sta_defaultOut[i] =Medium.setState_phX(h=volumeMiddle[i-1].ports[2].h_outflow,
                                               p=volumeMiddle[i-1].ports[2].p,
                                               X=volumeMiddle[i-1].ports[2].Xi_outflow);
        rhoOut[i]=Medium.density(sta_defaultOut[i]);
      elseif volumeMiddle[i-1].ports[3].m_flow<0 then
        VOut[i]=volumeMiddle[i-1].ports[3].m_flow/rhoOut[1];
        sta_defaultOut[i] =Medium.setState_phX(h=volumeMiddle[i-1].ports[3].h_outflow,
                                               p=volumeMiddle[i-1].ports[3].p,
                                               X=volumeMiddle[i-1].ports[3].Xi_outflow);
        rhoOut[i]=Medium.density(sta_defaultOut[i]);
      else
        VOut[i]=volumeMiddle[i-1].ports[4].m_flow/rhoOut[1];
        sta_defaultOut[i] =Medium.setState_phX(h=volumeMiddle[i-1].ports[4].h_outflow,
                                               p=volumeMiddle[i-1].ports[4].p,
                                               X=volumeMiddle[i-1].ports[4].Xi_outflow);
        rhoOut[i]=Medium.density(sta_defaultOut[i]);
      end if;

    elseif volumeMiddle[i-1].ports[2].m_flow>0 then
      VIn[i]=volumeMiddle[i-1].ports[2].m_flow/rhoIn[1];
      sta_defaultIn[i]=Medium.setState_phX(h=volumeMiddle[i-1].ports[2].h_outflow,
                                           p=volumeMiddle[i-1].ports[2].p,
                                           X=volumeMiddle[i-1].ports[2].Xi_outflow);
      rhoIn[i]=Medium.density(sta_defaultIn[i]);
      if volumeMiddle[i-1].ports[1].m_flow<0 then
        VOut[i]=volumeMiddle[i-1].ports[1].m_flow/rhoOut[1];
        sta_defaultOut[i] =Medium.setState_phX(h=volumeMiddle[i-1].ports[1].h_outflow,
                                               p=volumeMiddle[i-1].ports[1].p,
                                               X=volumeMiddle[i-1].ports[1].Xi_outflow);
        rhoOut[i]=Medium.density(sta_defaultOut[i]);
      elseif volumeMiddle[i-1].ports[3].m_flow<0 then
        VOut[i]=volumeMiddle[i-1].ports[3].m_flow/rhoOut[1];
        sta_defaultOut[i] =Medium.setState_phX(h=volumeMiddle[i-1].ports[3].h_outflow,
                                               p=volumeMiddle[i-1].ports[3].p,
                                               X=volumeMiddle[i-1].ports[3].Xi_outflow);
        rhoOut[i]=Medium.density(sta_defaultOut[i]);
      else
        VOut[i]=volumeMiddle[i-1].ports[4].m_flow/rhoOut[1];
        sta_defaultOut[i] =Medium.setState_phX(h=volumeMiddle[i-1].ports[4].h_outflow,
                                               p=volumeMiddle[i-1].ports[4].p,
                                               X=volumeMiddle[i-1].ports[4].Xi_outflow);
        rhoOut[i]=Medium.density(sta_defaultOut[i]);
      end if;

    elseif volumeMiddle[i-1].ports[3].m_flow>0 then
      VIn[i]=volumeMiddle[i-1].ports[3].m_flow/rhoIn[1];
      sta_defaultIn[i]=Medium.setState_phX(h=volumeMiddle[i-1].ports[3].h_outflow,
                                           p=volumeMiddle[i-1].ports[3].p,
                                           X=volumeMiddle[i-1].ports[3].Xi_outflow);
      rhoIn[i]=Medium.density(sta_defaultIn[i]);
      if volumeMiddle[i-1].ports[1].m_flow<0 then
        VOut[i]=volumeMiddle[i-1].ports[1].m_flow/rhoOut[1];
        sta_defaultOut[i] =Medium.setState_phX(h=volumeMiddle[i-1].ports[1].h_outflow,
                                               p=volumeMiddle[i-1].ports[1].p,
                                               X=volumeMiddle[i-1].ports[1].Xi_outflow);
        rhoOut[i]=Medium.density(sta_defaultOut[i]);
      elseif volumeMiddle[i-1].ports[2].m_flow<0 then
        VOut[i]=volumeMiddle[i-1].ports[2].m_flow/rhoOut[1];
        sta_defaultOut[i] =Medium.setState_phX(h=volumeMiddle[i-1].ports[2].h_outflow,
                                               p=volumeMiddle[i-1].ports[2].p,
                                               X=volumeMiddle[i-1].ports[2].Xi_outflow);
        rhoOut[i]=Medium.density(sta_defaultOut[i]);
      else
        VOut[i]=volumeMiddle[i-1].ports[4].m_flow/rhoOut[1];
        sta_defaultOut[i] =Medium.setState_phX(h=volumeMiddle[i-1].ports[4].h_outflow,
                                               p=volumeMiddle[i-1].ports[4].p,
                                               X=volumeMiddle[i-1].ports[4].Xi_outflow);
        rhoOut[i]=Medium.density(sta_defaultOut[i]);
      end if;
    elseif volumeMiddle[i-1].ports[4].m_flow>0 then
      VIn[i]=volumeMiddle[i-1].ports[4].m_flow/rhoIn[1];
      sta_defaultIn[i]=Medium.setState_phX(h=volumeMiddle[i-1].ports[4].h_outflow,
                                           p=volumeMiddle[i-1].ports[4].p,
                                           X=volumeMiddle[i-1].ports[4].Xi_outflow);
      rhoIn[i]=Medium.density(sta_defaultIn[i]);
      if volumeMiddle[i-1].ports[1].m_flow<0 then
        VOut[i]=volumeMiddle[i-1].ports[1].m_flow/rhoOut[1];
        sta_defaultOut[i] =Medium.setState_phX(h=volumeMiddle[i-1].ports[1].h_outflow,
                                               p=volumeMiddle[i-1].ports[1].p,
                                               X=volumeMiddle[i-1].ports[1].Xi_outflow);
        rhoOut[i]=Medium.density(sta_defaultOut[i]);
      elseif volumeMiddle[i-1].ports[2].m_flow<0 then
        VOut[i]=volumeMiddle[i-1].ports[2].m_flow/rhoOut[1];
        sta_defaultOut[i] =Medium.setState_phX(h=volumeMiddle[i-1].ports[2].h_outflow,
                                               p=volumeMiddle[i-1].ports[2].p,
                                               X=volumeMiddle[i-1].ports[2].Xi_outflow);
        rhoOut[i]=Medium.density(sta_defaultOut[i]);
      else
        VOut[i]=volumeMiddle[i-1].ports[3].m_flow/rhoOut[1];
        sta_defaultOut[i] =Medium.setState_phX(h=volumeMiddle[i-1].ports[3].h_outflow,
                                               p=volumeMiddle[i-1].ports[3].p,
                                               X=volumeMiddle[i-1].ports[3].Xi_outflow);
        rhoOut[i]=Medium.density(sta_defaultOut[i]);
      end if;
    else
      VIn[i]=volumeMiddle[i-1].ports[1].m_flow/rhoIn[1];
      sta_defaultIn[i]=Medium.setState_phX(h=volumeMiddle[i-1].ports[1].h_outflow,
                                           p=volumeMiddle[i-1].ports[1].p,
                                           X=volumeMiddle[i-1].ports[1].Xi_outflow);
      rhoIn[i]=Medium.density(sta_defaultIn[i]);
      VOut[i]=volumeMiddle[i-1].ports[2].m_flow/rhoOut[1];
      sta_defaultOut[i] =Medium.setState_phX(h=volumeMiddle[i-1].ports[2].h_outflow,
                                             p=volumeMiddle[i-1].ports[2].p,
                                             X=volumeMiddle[i-1].ports[2].Xi_outflow);
      rhoOut[i]=Medium.density(sta_defaultOut[i]);
    end if;
  end for;

    //Calculation of the volume entering the Bottom volume, depending on which are the inlet and outlet ports
  if volumeBottom.ports[1].m_flow>0 then
    VIn[1]=volumeBottom.ports[1].m_flow/rhoIn[1];
    sta_defaultIn[1]=Medium.setState_phX(h=volumeBottom.ports[1].h_outflow,
                                         p=volumeBottom.ports[1].p,
                                         X=volumeBottom.ports[1].Xi_outflow);
    rhoIn[1]=Medium.density(sta_defaultIn[1]);
    if volumeBottom.ports[2].m_flow<0 then
      VOut[1]=volumeBottom.ports[2].m_flow/rhoOut[1];
      sta_defaultOut[1] = Medium.setState_phX(h=volumeBottom.ports[2].h_outflow,
                                              p=volumeBottom.ports[2].p,
                                              X=volumeBottom.ports[2].Xi_outflow);
      rhoOut[1]=Medium.density(sta_defaultOut[1]);
    else
      VOut[1]=volumeBottom.ports[3].m_flow/rhoOut[1];
      sta_defaultOut[1] = Medium.setState_phX(h=volumeBottom.ports[3].h_outflow,
                                                 p=volumeBottom.ports[3].p,
                                                 X=volumeBottom.ports[3].Xi_outflow);
      rhoOut[1]=Medium.density(sta_defaultOut[1]);
    end if;

  elseif volumeBottom.ports[2].m_flow>0 then
    VIn[1]=volumeBottom.ports[2].m_flow/rhoIn[1];
    sta_defaultIn[1]=Medium.setState_phX(h=volumeBottom.ports[2].h_outflow,
                                         p=volumeBottom.ports[2].p,
                                         X=volumeBottom.ports[2].Xi_outflow);
    rhoIn[1]=Medium.density(sta_defaultIn[1]);
    if volumeBottom.ports[1].m_flow<0 then
      VOut[1]=volumeBottom.ports[1].m_flow/rhoOut[1];
      sta_defaultOut[1] = Medium.setState_phX(h=volumeBottom.ports[1].h_outflow,
                                              p=volumeBottom.ports[1].p,
                                              X=volumeBottom.ports[1].Xi_outflow);
      rhoOut[1]=Medium.density(sta_defaultOut[1]);
    else
      VOut[1]=volumeBottom.ports[3].m_flow/rhoOut[1];
      sta_defaultOut[1] = Medium.setState_phX(h=volumeBottom.ports[3].h_outflow,
                                              p=volumeBottom.ports[3].p,
                                              X=volumeBottom.ports[3].Xi_outflow);
      rhoOut[1]=Medium.density(sta_defaultOut[1]);
    end if;

  elseif volumeBottom.ports[3].m_flow>0 then
    VIn[1]=volumeBottom.ports[3].m_flow/rhoIn[1];
    sta_defaultIn[1]=Medium.setState_phX(h=volumeBottom.ports[3].h_outflow,
                                         p=volumeBottom.ports[3].p,
                                         X=volumeBottom.ports[3].Xi_outflow);
    rhoIn[1]=Medium.density(sta_defaultIn[1]);
    if volumeBottom.ports[1].m_flow<0 then
      VOut[1]=volumeBottom.ports[1].m_flow/rhoOut[1];
      sta_defaultOut[1] = Medium.setState_phX(h=volumeBottom.ports[1].h_outflow,
                                              p=volumeBottom.ports[1].p,
                                              X=volumeBottom.ports[1].Xi_outflow);
      rhoOut[1]=Medium.density(sta_defaultOut[1]);
    else
      VOut[1]=volumeBottom.ports[2].m_flow/rhoOut[1];
      sta_defaultOut[1] = Medium.setState_phX(h=volumeBottom.ports[2].h_outflow,
                                              p=volumeBottom.ports[2].p,
                                              X=volumeBottom.ports[2].Xi_outflow);
      rhoOut[1]=Medium.density(sta_defaultOut[1]);
    end if;

  else
    VIn[1]=volumeBottom.ports[1].m_flow/rhoIn[1];
    sta_defaultIn[1]=Medium.setState_phX(h=volumeBottom.ports[1].h_outflow,
                                         p=volumeBottom.ports[1].p,
                                         X=volumeBottom.ports[1].Xi_outflow);
    rhoIn[1]=Medium.density(sta_defaultIn[1]);
    VOut[1]=volumeBottom.ports[2].m_flow/rhoOut[1];
    sta_defaultOut[1] = Medium.setState_phX(h=volumeBottom.ports[2].h_outflow,
                                            p=volumeBottom.ports[2].p,
                                            X=volumeBottom.ports[2].Xi_outflow);
    rhoOut[1]=Medium.density(sta_defaultOut[1]);
  end if;

  //Calculation of the constant thermal conductance of material
  for i in 1:nSeg-1 loop
    GFluid[i]=(Modelica.Constants.pi*(d/2)^2)*Medium.thermalConductivity(sta_defaultIn[i+1])/(h/nSeg);
  end for;

    annotation (Diagram(coordinateSystem(preserveAspectRatio=false, extent={{-100,
            -100},{100,100}})), Documentation(info="<html>
<p>This model represents a closed tank with cylindrical shape for the accumulation of water. The model takes into account the heat losses produced throught the walls of the tank. </p>
<p>The bouyancy of the water in the tank due to the different densities (because of the different temperatures) of the water along the height of the tank, is also taken into account.</p>
<p>This model considers that the same amount of water enters and exits the tank, so the total volume of the tank is considered constant.</p>
<p>The storage is divided in one topVolume, <code>nSeg-2 </code>middleVolume and one bottomVolume, as each volume has different heat transfer area</p>
<p>The convection component used is <a href=\"modelica://Modelica.Thermal.HeatTransfer.Components.Convection\">Convection</a> from the Modelica Standard Library. In these component parameter <code>kConv</code> (coeficient of heat transfer) cuantifies the amount of heat transferred by convection to the ambient.</p>
<h4>Assumptions</h4>
<ul>
<li>The volume in the closed tank stays constant, so the same amount of water enters and leaves the tank;</li>
<li>The tank has a cylindrical shape;</li>
<li>The bouyancy of the water in the tank due to the different densities (because of the different temperatures) of the water along the height of the tank is taken into account;</li>
<li>It is also taken into acount the heat losses through the walls of the tank.</li>
</ul>
<h4>References</h4>
<ul>
<li>Nash, A. and Jain, N., &QUOT;Dynamic Modeling and Performance Analysys of Sensible Thermal Energy Storag System&QUOT; (2016). 4th International High Performance Buildings, Conference at Purdue.</li>
<li>Wetter, M (2017) <a href=\"modelica://Buildings.Fluid.Storage.Stratified\">Buildings.Fluid.Storage.Stratified</a>, Buildings library.</li>
</ul>
</html>", revisions="<html>
<p>2016-05-16 <a href=\"mailto: eduardo.ubieta@tekniker.es\"><a href=\"mailto: eduardo.ubieta@tekniker.es\">Eduardo Ubieta</a></a> (IK4-TEKNIKER): First implementation</p>
<p><b>Copyright &copy; <a href=\"http://www.tekniker.es/en\">IK4-TEKNIKER</a></b></p>
</html>"));
end ClosedCylindricalTank;
