within DCOL.ThermalStorage.SensibleStorages.FMI.Pruebas;
model Buffer_Dym_mFlow
  import Modelica_IK4_TEKNIKER;
  Modelica.Blocks.Sources.TimeTable m_flow1(table=[0.0,10; 20000,10; 20000,0;
        40000,0; 40000,-10; 60000,-10])
    annotation (Placement(transformation(extent={{-70,60},{-50,80}})));
  Modelica.Blocks.Sources.Constant temperature_Impulsion(k=7 + 273.15)
    annotation (Placement(transformation(extent={{-70,20},{-50,40}})));
  Modelica.Blocks.Sources.Constant temperature_Retorno(k=10 + 273.15)
    annotation (Placement(transformation(extent={{-70,-40},{-50,-20}})));
  Modelica.Blocks.Sources.Constant temperature_ambient(k=15.5234973 + 273.15)
    annotation (Placement(transformation(extent={{-70,-80},{-50,-60}})));
  Modelica_IK4_TEKNIKER.DCOL.ThermalStorage.SensibleStorages.FMI.Buffer_Dym buffer_Dym annotation (Placement(transformation(extent={{0,-30},{60,30}})));
equation
  connect(m_flow1.y, buffer_Dym.massFlow) annotation (Line(points={{-49,70},{
          -20,70},{-20,24},{-6,24}}, color={0,0,127}));
  connect(temperature_Impulsion.y, buffer_Dym.impulsion_T) annotation (Line(
        points={{-49,30},{-24,30},{-24,9},{-6,9}}, color={0,0,127}));
  connect(temperature_Retorno.y, buffer_Dym.return_T) annotation (Line(points={
          {-49,-30},{-24,-30},{-24,-9},{-6,-9}}, color={0,0,127}));
  connect(temperature_ambient.y, buffer_Dym.ambient_T) annotation (Line(points=
          {{-49,-70},{-20,-70},{-20,-24},{-6,-24}}, color={0,0,127}));
  annotation (Icon(coordinateSystem(preserveAspectRatio=false)), Diagram(
        coordinateSystem(preserveAspectRatio=false)),
    Documentation(revisions="<html>
<p>2016-05-16 <a href=\"mailto: eduardo.ubieta@tekniker.es\">Eduardo Ubieta</a></a> (IK4-TEKNIKER): First implementation</p>
<p><b>Copyright &copy; <a href=\"http://www.tekniker.es/en\">IK4-TEKNIKER</a></b></p>
</html>"));
end Buffer_Dym_mFlow;
