within DCOL.ThermalStorage.SensibleStorages.FMI.Pruebas;
model Buffer_FMU_ambientT
  import Modelica_IK4_TEKNIKER;
  Modelica_IK4_TEKNIKER.DCOL.ThermalStorage.SensibleStorages.FMI.Buffer_FMI_temperature buffer_Dym annotation (Placement(transformation(extent={{0,-30},{60,30}})));
  Modelica.Blocks.Sources.Constant  m_flow(k=10)
    annotation (Placement(transformation(extent={{-70,60},{-50,80}})));
  Modelica.Blocks.Sources.Constant temperature_Impulsion1(
                                                         k=7 + 273.15)
    annotation (Placement(transformation(extent={{-70,20},{-50,40}})));
  Modelica.Blocks.Sources.TimeTable temperature_Ambient(table=[0.0,5 + 273.15;
        20000,5 + 273.15; 20000,20 + 273.15; 40000,20 + 273.15; 40000,35 +
        273.15; 60000,35 + 273.15])
    annotation (Placement(transformation(extent={{-70,-80},{-50,-60}})));
equation
  connect(m_flow.y, buffer_Dym.massFlow) annotation (Line(points={{-49,70},{-20,
          70},{-20,15},{-1.2,15}},
                                 color={0,0,127}));
  connect(temperature_Impulsion1.y, buffer_Dym.impulsion_T) annotation (Line(
        points={{-49,30},{-24,30},{-24,0},{-1.2,0}},
                                                   color={0,0,127}));
  connect(temperature_Ambient.y, buffer_Dym.ambient_T) annotation (Line(points={{-49,-70},
          {-34,-70},{-22,-70},{-22,-15},{-1.2,-15}},          color={0,0,127}));
  annotation (Icon(coordinateSystem(preserveAspectRatio=false)), Diagram(
        coordinateSystem(preserveAspectRatio=false)),
    Documentation(revisions="<html>
<p>2016-05-16 <a href=\"mailto: eduardo.ubieta@tekniker.es\">Eduardo Ubieta</a></a> (IK4-TEKNIKER): First implementation</p>
<p><b>Copyright &copy; <a href=\"http://www.tekniker.es/en\">IK4-TEKNIKER</a></b></p>
</html>"));
end Buffer_FMU_ambientT;
