within DCOL.ThermalStorage.SensibleStorages.Testing.TestControl;
model Buffer_m_flow

  ClosedCylindricalTank_NatConv closedCylindricalTank(redeclare package Medium =
        Modelica.Media.Water.ConstantPropertyLiquidWater, redeclare package Material =
                 Modelica_IK4_TEKNIKER.Thermal.Materials.AISI321)
    annotation (Placement(transformation(extent={{-20,-30},{40,30}})));

  inner Modelica.Fluid.System system annotation (Placement(transformation(extent={{50,50},{70,70}})));

  Modelica.Thermal.HeatTransfer.Sources.PrescribedTemperature ambientTemperature
    annotation (Placement(transformation(extent={{80,-10},{60,10}})));
  Modelica.Fluid.Sources.Boundary_pT Retorno(
    redeclare package Medium =
        Modelica.Media.Water.ConstantPropertyLiquidWater,
    nPorts=1,
    use_p_in=false,
    use_T_in=true)
    annotation (Placement(transformation(extent={{-80,-40},{-60,-20}})));

  Modelica.Fluid.Sources.MassFlowSource_T Impulsion(
    nPorts=1,
    use_m_flow_in=true,
    use_T_in=true,
    redeclare package Medium =
        Modelica.Media.Water.ConstantPropertyLiquidWater)
    annotation (Placement(transformation(extent={{-60,20},{-40,40}})));
  Modelica.Blocks.Sources.TimeTable m_flow(table=[0.0,10; 10000,10; 10000,0; 20000,
        0; 20000,-10; 30000,-10; 30000,0; 40000,0; 40000,10; 50000,10])
    annotation (Placement(transformation(extent={{-100,56},{-80,76}})));
  Modelica.Blocks.Sources.Constant temperature_Impulsion(k=7 + 273.15)
    annotation (Placement(transformation(extent={{-156,2},{-136,22}})));
  Modelica.Fluid.Sensors.Temperature T_Impulsion(redeclare package Medium =
        Modelica.Media.Water.ConstantPropertyLiquidWater)
    annotation (Placement(transformation(extent={{-40,46},{-20,66}})));
  Modelica.Fluid.Sensors.Temperature T_Retorno(redeclare package Medium =
        Modelica.Media.Water.ConstantPropertyLiquidWater)
    annotation (Placement(transformation(extent={{-30,-60},{-10,-40}})));
  Modelica.Blocks.Sources.Constant temperature_ambient(k=15.5234973 + 273.15)
    annotation (Placement(transformation(extent={{120,-10},{100,10}})));
  Modelica.Fluid.Sensors.MassFlowRate massFlowRate(redeclare package Medium =
        Modelica.Media.Water.ConstantPropertyLiquidWater)
    annotation (Placement(transformation(extent={{-35,-35},{-45,-25}})));
  Modelica.Blocks.Discrete.TriggeredSampler triggeredSampler(y_start=7 + 273.15)
    annotation (Placement(transformation(extent={{-114,7},{-104,17}})));
  Modelica.Blocks.Sources.Constant temperature_Retorno(k=10 + 273.15)
    annotation (Placement(transformation(extent={{-156,-32},{-136,-12}})));
  Modelica.Blocks.Discrete.TriggeredSampler triggeredSampler1(y_start=7 + 273.15)
    annotation (Placement(transformation(extent={{-114,-17},{-104,-27}})));
  Modelica.Blocks.Logical.Not not1
    annotation (Placement(transformation(extent={{-90,-18},{-100,-8}})));
  Modelica.Blocks.Sources.BooleanExpression booleanExpression(y=if m_flow.y < 0
         then false else true)
    annotation (Placement(transformation(extent={{-60,-14},{-80,6}})));
  Modelica.Blocks.Sources.TimeTable m_flow1(table=[0.0,10; 20000,10; 20000,0;
        40000,0; 40000,-10; 60000,-10])
    annotation (Placement(transformation(extent={{-120,28},{-100,48}})));
equation

  connect(closedCylindricalTank.port_a_Tambient, ambientTemperature.port)
    annotation (Line(points={{31.9231,0},{60,0}}, color={191,0,0}));
  connect(Impulsion.ports[1],closedCylindricalTank.port_a)  annotation (Line(
        points={{-40,30},{-30,30},{-30,21},{-15.3846,21}},
                                                      color={0,127,255}));
  connect(T_Retorno.port, closedCylindricalTank.port_b) annotation (Line(points={{-20,-60},
          {-30,-60},{-30,-21},{-15.3846,-21}},           color={0,127,255}));
  connect(T_Impulsion.port,closedCylindricalTank.port_a)  annotation (Line(
        points={{-30,46},{-30,46},{-30,21},{-15.3846,21}},
                                                      color={0,127,255}));
  connect(temperature_ambient.y, ambientTemperature.T)
    annotation (Line(points={{99,0},{90.5,0},{82,0}}, color={0,0,127}));
  connect(closedCylindricalTank.port_b, massFlowRate.port_a) annotation (Line(
        points={{-15.3846,-21},{-15.3846,-21},{-34,-21},{-34,-30},{-35,-30}},
        color={0,127,255}));
  connect(massFlowRate.port_b, Retorno.ports[1]) annotation (Line(points={{-45,-30},
          {-45,-30},{-60,-30}}, color={0,127,255}));
  connect(temperature_Impulsion.y, triggeredSampler.u)
    annotation (Line(points={{-135,12},{-115,12}}, color={0,0,127}));
  connect(triggeredSampler.y, Impulsion.T_in) annotation (Line(points={{-103.5,12},
          {-74,12},{-74,34},{-62,34}}, color={0,0,127}));
  connect(temperature_Retorno.y, triggeredSampler1.u) annotation (Line(points={{-135,
          -22},{-115,-22}},                 color={0,0,127}));
  connect(booleanExpression.y, triggeredSampler.trigger) annotation (Line(
        points={{-81,-4},{-109,-4},{-109,6.1}}, color={255,0,255}));
  connect(booleanExpression.y, not1.u) annotation (Line(points={{-81,-4},{-84,-4},
          {-84,-13},{-89,-13}}, color={255,0,255}));
  connect(not1.y, triggeredSampler1.trigger) annotation (Line(points={{-100.5,-13},
          {-109,-13},{-109,-16.1}}, color={255,0,255}));
  connect(triggeredSampler1.y, Retorno.T_in) annotation (Line(points={{-103.5,-22},
          {-94,-22},{-94,-26},{-82,-26}}, color={0,0,127}));
  connect(m_flow1.y, Impulsion.m_flow_in)
    annotation (Line(points={{-99,38},{-60,38}}, color={0,0,127}));
   annotation (Icon(coordinateSystem(preserveAspectRatio=false)), Diagram(
        coordinateSystem(preserveAspectRatio=false)),
    experiment(StopTime=60000, __Dymola_Algorithm="Cvode"),
    Documentation(revisions="<html>
<p>2016-05-16 <a href=\"mailto: eduardo.ubieta@tekniker.es\">Eduardo Ubieta</a></a> (IK4-TEKNIKER): First implementation</p>
<p><b>Copyright &copy; <a href=\"http://www.tekniker.es/en\">IK4-TEKNIKER</a></b></p>
</html>"));
end Buffer_m_flow;
