within DCOL.ThermalStorage.SensibleStorages.Testing.TestControl;
model Buffer_temperature

  ClosedCylindricalTank_NatConv closedCylindricalTank
    annotation (Placement(transformation(extent={{-20,-30},{40,30}})));
  inner Modelica.Fluid.System system
    annotation (Placement(transformation(extent={{50,50},{70,70}})));
  Modelica.Thermal.HeatTransfer.Sources.PrescribedTemperature ambientTemperature
    annotation (Placement(transformation(extent={{80,-10},{60,10}})));
  Modelica.Fluid.Sources.FixedBoundary
                                     Retorno(
    redeclare package Medium =
        Modelica.Media.Water.ConstantPropertyLiquidWater, nPorts=1)
    annotation (Placement(transformation(extent={{-100,-40},{-80,-20}})));

  Modelica.Fluid.Sources.MassFlowSource_T Impulsion(
    nPorts=1,
    use_m_flow_in=true,
    use_T_in=true,
    redeclare package Medium =
        Modelica.Media.Water.ConstantPropertyLiquidWater)
    annotation (Placement(transformation(extent={{-60,20},{-40,40}})));
  Modelica.Blocks.Sources.Constant  m_flow(k=10)
    annotation (Placement(transformation(extent={{-100,40},{-80,60}})));
  Modelica.Fluid.Sensors.Temperature T_Impulsion(redeclare package Medium =
        Modelica.Media.Water.ConstantPropertyLiquidWater)
    annotation (Placement(transformation(extent={{-40,46},{-20,66}})));
  Modelica.Fluid.Sensors.Temperature T_Retorno(redeclare package Medium =
        Modelica.Media.Water.ConstantPropertyLiquidWater)
    annotation (Placement(transformation(extent={{-30,-60},{-10,-40}})));
  Modelica.Blocks.Sources.TimeTable temperature_Impulsion(table=[0.0,4 + 273.15;
        20000,4 + 273.15; 20000,7 + 273.15; 40000,7 + 273.15; 40000,10 + 273.15;
        60000,10 + 273.15])
    annotation (Placement(transformation(extent={{-100,0},{-80,20}})));
  Modelica.Blocks.Sources.Constant temperature_Ambient(k=15.5234973 + 273.15)
    annotation (Placement(transformation(extent={{120,-10},{100,10}})));
  Modelica.Fluid.Sensors.MassFlowRate massFlowRate(redeclare package Medium =
        Modelica.Media.Water.ConstantPropertyLiquidWater)
    annotation (Placement(transformation(extent={{-55,-35},{-65,-25}})));
equation
  connect(closedCylindricalTank.port_a_Tambient, ambientTemperature.port)
    annotation (Line(points={{31.9231,0},{60,0}}, color={191,0,0}));
  connect(Impulsion.ports[1],closedCylindricalTank.port_a)  annotation (Line(
        points={{-40,30},{-30,30},{-30,21},{-15.3846,21}},
                                                      color={0,127,255}));
  connect(m_flow.y, Impulsion.m_flow_in) annotation (Line(points={{-79,50},{-70,
          50},{-70,38},{-60,38}}, color={0,0,127}));
  connect(T_Retorno.port, closedCylindricalTank.port_b) annotation (Line(points={{-20,-60},
          {-30,-60},{-30,-21},{-15.3846,-21}},           color={0,127,255}));
  connect(T_Impulsion.port,closedCylindricalTank.port_a)  annotation (Line(
        points={{-30,46},{-30,46},{-30,21},{-15.3846,21}},
                                                      color={0,127,255}));
  connect(temperature_Impulsion.y, Impulsion.T_in) annotation (Line(points={{
          -79,10},{-70,10},{-70,34},{-62,34}}, color={0,0,127}));
  connect(temperature_Ambient.y, ambientTemperature.T)
    annotation (Line(points={{99,0},{82,0}}, color={0,0,127}));
  connect(massFlowRate.port_b, Retorno.ports[1]) annotation (Line(points={{
          -65,-30},{-72.5,-30},{-80,-30}}, color={0,127,255}));
  connect(closedCylindricalTank.port_b, massFlowRate.port_a) annotation (Line(
        points={{-15.3846,-21},{-40,-21},{-40,-30},{-55,-30}}, color={0,127,255}));
  annotation (Icon(coordinateSystem(preserveAspectRatio=false)), Diagram(
        coordinateSystem(preserveAspectRatio=false)),
    experiment(StopTime=60000),
    Documentation(revisions="<html>
<p>2016-05-16 <a href=\"mailto: eduardo.ubieta@tekniker.es\">Eduardo Ubieta</a></a> (IK4-TEKNIKER): First implementation</p>
<p><b>Copyright &copy; <a href=\"http://www.tekniker.es/en\">IK4-TEKNIKER</a></b></p>
</html>"));
end Buffer_temperature;
