within DCOL.Generation.CoolingTowers.FMI;
model CompleteCCT_inertia_FMI
// Model automatically generated by Dymola from FMI model description
public
  type Modelica_Blocks_Interfaces_BooleanInput = Boolean;
  type Modelica_Blocks_Interfaces_RealInput = Real;
  type Modelica_Blocks_Interfaces_RealOutput = Real;
  type Modelica_IK4_TEKNIKER_DCOL_Generation_CoolingTowers_FMI_RealConnectors_RealMassFlowInput = Real (unit = "kg/s", quantity = "MassFlowRate");
  type Modelica_IK4_TEKNIKER_DCOL_Generation_CoolingTowers_FMI_RealConnectors_RealMassFractionInput = Real (unit = "1", quantity = "MassFraction", min = 0.0, max = 1.0);
  type Modelica_IK4_TEKNIKER_DCOL_Generation_CoolingTowers_FMI_RealConnectors_RealTemperatureInput = Real (unit = "K", displayUnit = "degC", nominal = 300.0, quantity = "ThermodynamicTemperature", min = 0.0);
  type Modelica_IK4_TEKNIKER_DCOL_Generation_CoolingTowers_FMI_RealConnectors_RealTemperatureOutput = Real (unit = "K", displayUnit = "degC", nominal = 300.0, quantity = "ThermodynamicTemperature", min = 0.0);
protected
  record 'system_rec'
    parameter Modelica.SIunits.AbsolutePressure p_ambient = 101325
                                                                  "Default ambient pressure";
    parameter Modelica.SIunits.Temperature T_ambient = 293.15
                                                             "Default ambient temperature";
    parameter Modelica.SIunits.Acceleration g = 9.80665
                                                       "Constant gravity acceleration";
    constant Boolean allowFlowReversal = true
                                             "= false to restrict to design flow direction (port_a -> port_b)";
    constant Modelica.Fluid.Types.Dynamics energyDynamics = Modelica.Fluid.Types.Dynamics.DynamicFreeInitial
                                                                                                            "Default formulation of energy balances";
    constant Modelica.Fluid.Types.Dynamics massDynamics = Modelica.Fluid.Types.Dynamics.DynamicFreeInitial
                                                                                                          "Default formulation of mass balances";
    constant Modelica.Fluid.Types.Dynamics substanceDynamics = Modelica.Fluid.Types.Dynamics.DynamicFreeInitial
                                                                                                               "Default formulation of substance balances";
    constant Modelica.Fluid.Types.Dynamics traceDynamics = Modelica.Fluid.Types.Dynamics.DynamicFreeInitial
                                                                                                           "Default formulation of trace substance balances";
    constant Modelica.Fluid.Types.Dynamics momentumDynamics = Modelica.Fluid.Types.Dynamics.SteadyState
                                                                                                       "Default formulation of momentum balances, if options available";
    constant Modelica.SIunits.MassFlowRate m_flow_start = 0
                                                           "Default start value for mass flow rates";
    parameter Modelica.SIunits.AbsolutePressure p_start(fixed=false)
                                                                    "Default start value for pressures";
    parameter Modelica.SIunits.Temperature T_start(fixed=false)
                                                               "Default start value for temperatures";
    constant Boolean use_eps_Re = false
                                       "= true to determine turbulent region automatically using Reynolds number";
    parameter Modelica.SIunits.MassFlowRate m_flow_nominal(fixed=false)
                                                                       "Default nominal mass flow rate";
    parameter Real eps_m_flow(min = 0.0) = 0.0001
                                                 "Regularization of zero flow for |m_flow| < eps_m_flow*m_flow_nominal";
    parameter Modelica.SIunits.AbsolutePressure dp_small = 1
                                                            "Default small pressure drop for regularization of laminar and zero flow";
    parameter Modelica.SIunits.MassFlowRate m_flow_small(min = 0.0) = 0.01
                                                                          "Default small mass flow rate for regularization of laminar and zero flow";
  end 'system_rec';
public
  'system_rec' 'system' annotation(Dialog);
  parameter Modelica.SIunits.Height hmax = 0.377825
                                                   "Maximum height of water that can the basin have";
  parameter Modelica.SIunits.Height hmin = 0.092075
                                                   "Minimum height of water that can the basin have";
  parameter Modelica.SIunits.Length L_basin = 5.486
                                                   "Length of the basin";
  parameter Modelica.SIunits.Length w = 2.388
                                             "Width of the basin";
  parameter Modelica.SIunits.Length e = 0.2
                                           "Thicknes of the storages wall";
  constant Integer nSeg = 10
                            "Number of section in which is divided de fill";
  constant Integer nCoil = 2
                            "Number of steps of each coil";
  parameter Integer nParallel = 2
                                 "Number of parallel coils in the fill";
  constant Modelica.SIunits.Length L = 5
                                        "Length of the tube";
  parameter Modelica.SIunits.Radius R_ext = 0.03
                                                "Extermal radious of the tube";
  parameter Modelica.SIunits.Radius R_int = 0.025
                                                 "Intermal radious of the tube";
  parameter Modelica.SIunits.Pressure pPumpedWater = 135496.772
                                                               "Pressure of the sprayed water";
  parameter Modelica.SIunits.Pressure pCWater2(fixed=false)
                                                           "Pressure of the sprayed water";
  parameter Real c = 2.3
                        "Empirical constant specific to a particular tower design";
  parameter Real n = -0.72
                          "Empirical constant specific to a particular tower design";
  parameter Modelica.SIunits.Height roughness = 2.5E-005
                                                        "Average height of surface asperities (default: smooth steel pipe)";
  parameter Real a = 1000
                         "Coefficient for quadratic term of the pressure drop";
  parameter Real b = 1000
                         "Coefficient for linear term of the pressure drop";
  parameter Modelica.SIunits.Diameter d_a = 0.02505
                                                   "Diameter at the entrace of the sprayer";
  parameter Modelica.SIunits.Diameter d_b = 0.025
                                                 "Diameter at the exit of the sprayer";
  parameter Real Kfi = 3.5
                          "Loss coefficient in the fill";
  parameter Modelica.SIunits.Length hfi = 3
                                           "Height of the filter";
  parameter Modelica.SIunits.Length wfi = 2.388
                                               "Width of the filter";
  parameter Modelica.SIunits.Length lfi = 5.486
                                               "Length of the filter";
  parameter Real C_iner = 10
                            "Constant defining the thermal inertia of the filter";
  constant Modelica.SIunits.Temperature ToverflowWater = 298.15
                                                               "Start value for the outlet water";
  parameter Modelica.SIunits.MassFlowRate moverflowWater = 2
                                                            "Inlet air mass flow";
  parameter Modelica.SIunits.Temperature TWater2_start = 293.15
                                                               "Start value for the outlet water";
  parameter Modelica.SIunits.Temperature TAir2_start = 307.15
                                                             "Start value for the outlet water";
  parameter Modelica.SIunits.MassFraction H2_start = 0.15
                                                         "Outlet Air absolute humidity";
  constant Modelica.SIunits.Temperature T_start_coil = 293.15
                                                             "Start temperature for the average temperature of cylinder";
  parameter Modelica.SIunits.Temperature TMaterial_start = 293.15
                                                                 "start temperature of the material of the coil";
protected
  record closedCTPressureDrop_rec
    constant Boolean allowFlowReversal = false
                                              "true for allowing the reversal flow";
    constant Boolean homotopyInitialization = true
                                                  "true for allowing the reversal flow";
    parameter Modelica.SIunits.Height hmax(fixed=false)
                                                       "Maximum height of water that can the basin have";
    parameter Modelica.SIunits.Height hmin(fixed=false)
                                                       "Minimum height of water that can the basin have";
    parameter Modelica.SIunits.Length L_basin(fixed=false)
                                                          "Length of the basin";
    parameter Modelica.SIunits.Length L_char(fixed=false)
                                                         "Characteristic length, length of the plate";
    parameter Modelica.SIunits.Length w(fixed=false)
                                                    "Width of the basin";
    parameter Modelica.SIunits.Length e(fixed=false)
                                                    "Thicknes of the storages wall";
    constant Integer nSeg = 10
                              "Number of section in which is divided each coil";
    constant Integer nCoil = 2
                              "Number of steps of each coil";
    parameter Integer nParallel(fixed=false)
                                            "Number of parallel coils in the fill";
    constant Modelica.SIunits.Length L = 5.0
                                            "Length of the tube";
    parameter Modelica.SIunits.Radius R_ext(fixed=false)
                                                        "Extermal radious of the tube";
    parameter Modelica.SIunits.Radius R_int(fixed=false)
                                                        "Intermal radious of the tube";
    parameter Modelica_Blocks_Interfaces_RealOutput mWaterIn(min = 0.0, max = 100000.0, fixed=false)
                                                                                                    "Value for pumped water";
    parameter Modelica.SIunits.Pressure pPumpedWater(fixed=false)
                                                                 "Pressure of the sprayed water";
    parameter Real c(fixed=false)
                                 "Empirical constant specific to a particular tower design";
    parameter Real n(fixed=false)
                                 "Empirical constant specific to a particular tower design";
    parameter Modelica.SIunits.Height roughness(fixed=false)
                                                            "Average height of surface asperities (default: smooth steel pipe)";
    parameter Real a(fixed=false)
                                 "Coefficient for quadratic term of the pressure drop";
    parameter Real b(fixed=false)
                                 "Coefficient for linear term of the pressure drop";
    parameter Modelica.SIunits.Diameter d_a(fixed=false)
                                                        "Diameter at the entrace of the sprayer";
    parameter Modelica.SIunits.Diameter d_b(fixed=false)
                                                        "Diameter at the exit of the sprayer";
    parameter Real C_iner(fixed=false)
                                      "Constant defining the thermal inertia of the filter";
    parameter Real Kfi(fixed=false)
                                   "Loss coefficient in the fill";
    parameter Modelica.SIunits.Length hfi(fixed=false)
                                                      "Height of the filter";
    parameter Modelica.SIunits.Length wfi(fixed=false)
                                                      "Width of the filter";
    parameter Modelica.SIunits.Length lfi(fixed=false)
                                                      "Length of the filter";
    parameter Modelica.SIunits.Area Afr(fixed=false)
                                                    "cross-sectional packing area";
    parameter Modelica.SIunits.Temperature TWater2_start(fixed=false)
                                                                     "Start value for the outlet water";
    parameter Modelica.SIunits.Temperature TAir2_start(fixed=false)
                                                                   "Start value for the outlet water";
    parameter Modelica.SIunits.MassFraction H2_start(fixed=false)
                                                                 "Outlet Air absolute humidity";
    constant Modelica.SIunits.Temperature T_start_coil = 293.15
                                                               "Start temperature for the average temperature of cylinder";
    parameter Modelica.SIunits.Temperature TMaterial_start(fixed=false)
                                                                       "start temperature of the material";
  protected
    record heatExchangerThroughReal_rec
      constant Boolean allowFlowReversal = false
                                                "true for allowing the reversal flow";
      constant Boolean homotopyInitialization = true
                                                    "true for allowing the reversal flow";
      constant Integer nSeg = 10
                                "Number of sections in which is divided each coil";
      constant Integer nCoil = 2
                                "Number of coil steps in the fill";
      parameter Integer nParallel(fixed=false)
                                              "Number of parallel coils in the fill";
      constant Modelica.SIunits.Length L = 5.0
                                              "Length of the tube";
      parameter Modelica.SIunits.Radius R_ext(fixed=false)
                                                          "Extermal radious of the tube";
      parameter Modelica.SIunits.Radius R_int(fixed=false)
                                                          "Intermal radious of the tube";
      parameter Real c(fixed=false);
      parameter Real n(fixed=false);
      parameter Modelica.SIunits.Height roughness(fixed=false)
                                                              "Average height of surface asperities (default: smooth steel pipe)";
      parameter Real a(fixed=false)
                                   "Coefficient for quadratic term of the pressure drop";
      parameter Real b(fixed=false)
                                   "Coefficient for linear term of the pressure drop";
      parameter Real Kfi(fixed=false)
                                     "Loss coefficient in the fill";
      parameter Modelica.SIunits.Length hfi(fixed=false)
                                                        "Height of the filter";
      parameter Modelica.SIunits.Length wfi(fixed=false)
                                                        "Width of the filter";
      parameter Modelica.SIunits.Length lfi(fixed=false)
                                                        "Length of the filter";
      parameter Modelica.SIunits.Area Afr(fixed=false)
                                                      "cross-sectional packing area";
      parameter Real C_iner(fixed=false)
                                        "Constant defining the thermal inertia of the filter";
      Real efficiency
                     "Efficiency of the tower";
      Modelica.SIunits.Temperature TCWater1
                                           "Inlet water temperature in K";
      Modelica.SIunits.Temperature TCWater2
                                           "Inlet water temperature in K";
      parameter Modelica.SIunits.Temperature TWater2_start(fixed=false)
                                                                       "Start value for the outlet water";
      parameter Modelica.SIunits.Temperature TAir2_start(fixed=false)
                                                                     "Start value for the outlet water";
      parameter Modelica.SIunits.MassFraction H2_start(fixed=false)
                                                                   "Outlet Air absolute humidity";
      constant Modelica.SIunits.Temperature T_start_coil = 293.15
                                                                 "Start temperature for the average temperature of cylinder";
      parameter Modelica.SIunits.Temperature TMaterial_start(fixed=false)
                                                                         "start temperature of the material";
    protected
      record port_a_water_rec
        parameter Modelica.Media.Interfaces.PartialMedium.MassFlowRate m_flow(quantity = "MassFlowRate.SimpleLiquidWater", min = 0.0, fixed=false)
                                                                                                                                                  "Mass flow rate from the connection point into the component";
        Modelica.Media.Interfaces.Types.AbsolutePressure p
                                                          "Thermodynamic pressure in the connection point";
        Modelica.Media.Interfaces.Types.SpecificEnthalpy h_outflow
                                                                  "Specific thermodynamic enthalpy close to the connection point if m_flow < 0";
      end port_a_water_rec;
    public
      port_a_water_rec port_a_water;
    protected
      record port_b_water_rec
        Modelica.Media.Interfaces.PartialMedium.MassFlowRate m_flow(quantity = "MassFlowRate.SimpleLiquidWater", max = 0.0)
                                                                                                                           "Mass flow rate from the connection point into the component";
        Modelica.Media.Interfaces.Types.AbsolutePressure p
                                                          "Thermodynamic pressure in the connection point";
        Modelica.Media.Interfaces.Types.SpecificEnthalpy h_outflow
                                                                  "Specific thermodynamic enthalpy close to the connection point if m_flow < 0";
      end port_b_water_rec;
    public
      port_b_water_rec port_b_water;
    protected
      record port_a_air_rec
        Modelica.Media.Interfaces.PartialMedium.MassFlowRate m_flow(quantity = "MassFlowRate.Moist air", min = 0.0)
                                                                                                                   "Mass flow rate from the connection point into the component";
        Modelica.Media.Interfaces.Types.AbsolutePressure p
                                                          "Thermodynamic pressure in the connection point";
        Modelica.Media.Interfaces.Types.SpecificEnthalpy h_outflow
                                                                  "Specific thermodynamic enthalpy close to the connection point if m_flow < 0";
        Modelica.Media.Interfaces.Types.MassFraction 'Xi_outflow[1]'
                                                                    "Independent mixture mass fractions m_i/m close to the connection point if m_flow < 0";
      end port_a_air_rec;
    public
      port_a_air_rec port_a_air;
    protected
      record port_b_air_rec
        Modelica.Media.Interfaces.PartialMedium.MassFlowRate m_flow(quantity = "MassFlowRate.Moist air", max = 0.0)
                                                                                                                   "Mass flow rate from the connection point into the component";
        Modelica.Media.Interfaces.Types.AbsolutePressure p
                                                          "Thermodynamic pressure in the connection point";
        Modelica.Media.Interfaces.Types.SpecificEnthalpy h_outflow
                                                                  "Specific thermodynamic enthalpy close to the connection point if m_flow < 0";
        Modelica.Media.Interfaces.Types.MassFraction 'Xi_outflow[1]'
                                                                    "Independent mixture mass fractions m_i/m close to the connection point if m_flow < 0";
      end port_b_air_rec;
    public
      port_b_air_rec port_b_air;
    protected
      record port_a_Cwater_rec
        Modelica.Media.Interfaces.PartialMedium.MassFlowRate m_flow(quantity = "MassFlowRate.SimpleLiquidWater", min = 0.0)
                                                                                                                           "Mass flow rate from the connection point into the component";
        Modelica.Media.Interfaces.Types.AbsolutePressure p
                                                          "Thermodynamic pressure in the connection point";
        Modelica.Media.Interfaces.Types.SpecificEnthalpy h_outflow
                                                                  "Specific thermodynamic enthalpy close to the connection point if m_flow < 0";
      end port_a_Cwater_rec;
    public
      port_a_Cwater_rec port_a_Cwater;
    protected
      record port_b_Cwater_rec
        Modelica.Media.Interfaces.Types.AbsolutePressure p
                                                          "Thermodynamic pressure in the connection point";
        Modelica.Media.Interfaces.Types.SpecificEnthalpy h_outflow
                                                                  "Specific thermodynamic enthalpy close to the connection point if m_flow < 0";
      end port_b_Cwater_rec;
    public
      port_b_Cwater_rec port_b_Cwater;
    protected
      record closedHeatToAirPressureDrop_rec
        constant Boolean allowFlowReversal = false
                                                  "= true to allow flow reversal, false restricts to design direction (port_a -> port_b)";
        constant Integer nCoil = 2
                                  "Number of parallel coils";
      protected
        record port_a_water_rec
          Modelica.Media.Interfaces.PartialMedium.MassFlowRate m_flow(quantity = "MassFlowRate.SimpleLiquidWater", min = 0.0)
                                                                                                                             "Mass flow rate from the connection point into the component";
          Modelica.Media.Interfaces.Types.AbsolutePressure p
                                                            "Thermodynamic pressure in the connection point";
          Modelica.Media.Interfaces.Types.SpecificEnthalpy h_outflow
                                                                    "Specific thermodynamic enthalpy close to the connection point if m_flow < 0";
        end port_a_water_rec;
      public
        port_a_water_rec port_a_water;
      protected
        record port_b_water_rec
          Modelica.Media.Interfaces.PartialMedium.MassFlowRate m_flow(quantity = "MassFlowRate.SimpleLiquidWater", max = 0.0)
                                                                                                                             "Mass flow rate from the connection point into the component";
          Modelica.Media.Interfaces.Types.AbsolutePressure p
                                                            "Thermodynamic pressure in the connection point";
          Modelica.Media.Interfaces.Types.SpecificEnthalpy h_outflow
                                                                    "Specific thermodynamic enthalpy close to the connection point if m_flow < 0";
        end port_b_water_rec;
      public
        port_b_water_rec port_b_water;
      protected
        record port_a_air_rec
          Modelica.Media.Interfaces.PartialMedium.MassFlowRate m_flow(quantity = "MassFlowRate.Moist air", min = 0.0)
                                                                                                                     "Mass flow rate from the connection point into the component";
          Modelica.Media.Interfaces.Types.AbsolutePressure p
                                                            "Thermodynamic pressure in the connection point";
          Modelica.Media.Interfaces.Types.SpecificEnthalpy h_outflow
                                                                    "Specific thermodynamic enthalpy close to the connection point if m_flow < 0";
          Modelica.Media.Interfaces.Types.MassFraction 'Xi_outflow[1]'
                                                                      "Independent mixture mass fractions m_i/m close to the connection point if m_flow < 0";
        end port_a_air_rec;
      public
        port_a_air_rec port_a_air;
      protected
        record port_b_air_rec
          Modelica.Media.Interfaces.PartialMedium.MassFlowRate m_flow(quantity = "MassFlowRate.Moist air", max = 0.0)
                                                                                                                     "Mass flow rate from the connection point into the component";
          Modelica.Media.Interfaces.Types.AbsolutePressure p
                                                            "Thermodynamic pressure in the connection point";
          Modelica.Media.Interfaces.Types.SpecificEnthalpy h_outflow
                                                                    "Specific thermodynamic enthalpy close to the connection point if m_flow < 0";
          parameter Modelica.Media.Interfaces.Types.MassFraction '_Xi_outflow[1]_start' = 0.0;
          Modelica.Media.Interfaces.Types.MassFraction 'Xi_outflow[1]'(start = '_Xi_outflow[1]_start', fixed=false)
                                                                                                                   "Independent mixture mass fractions m_i/m close to the connection point if m_flow < 0";
        end port_b_air_rec;
      public
        port_b_air_rec port_b_air annotation(Dialog);
      protected
        record 'port_a[1]_rec'
          Modelica.SIunits.Temperature T
                                        "Port temperature";
          Modelica.SIunits.HeatFlowRate Q_flow
                                              "Heat flow rate (positive if flowing from outside into the component)";
        end 'port_a[1]_rec';
      public
        'port_a[1]_rec' 'port_a[1]';
      protected
        record 'port_a[2]_rec'
          Modelica.SIunits.Temperature T
                                        "Port temperature";
          Modelica.SIunits.HeatFlowRate Q_flow
                                              "Heat flow rate (positive if flowing from outside into the component)";
        end 'port_a[2]_rec';
      public
        'port_a[2]_rec' 'port_a[2]';
        Modelica.SIunits.Temperature TWater1
                                            "Inlet water temperature in K";
        Modelica.SIunits.SpecificEnthalpy hWater1
                                                 "Specific enthalpy of the inlet water";
        parameter Modelica.SIunits.MassFlowRate mWater1(fixed=false)
                                                                    "Inlet water mass flow";
        Modelica.SIunits.Temp_C TWater1C
                                        "Inlet water temperature in C";
        Modelica.SIunits.Temperature TWater2
                                            "Outlet water temperature in K";
        Modelica.SIunits.SpecificEnthalpy hWater2
                                                 "Specific enthalpy of the outlet water";
        Modelica.SIunits.MassFlowRate mWater2
                                             "Outlet water mass flow";
        Modelica.SIunits.Temp_C TWater2C
                                        "Outlet water temperature in C";
        Modelica.SIunits.Temperature TAir1
                                          "Inlet air temperature in K";
        Modelica.SIunits.SpecificEnthalpy hAir1
                                               "Specific enthalpy of the inlet Air";
        Modelica.SIunits.MassFlowRate mAir1
                                           "Inlet air mass flow";
        Modelica.SIunits.MassFraction X1
                                        "Vapour mass fraction in the inlet air [kg_vapour/kg_moist_air]";
        Modelica.SIunits.Temp_C TAir1C
                                      "Inlet air temperature in C";
        Modelica.SIunits.MassFraction H1
                                        "Inlet air absolute humidity=0.0184560958649";
        Modelica.SIunits.MassFlowRate mDAir1
                                            "Inlet dry air mass flow";
        Modelica.SIunits.MassFlowRate mVap1
                                           "Inlet vapour mass flow";
        Modelica.SIunits.SpecificEnthalpy hsw1
                                              "Air saturation enthalpy at inlet water temperature";
        Modelica.SIunits.MassFraction Hsat1
                                           "Inlet air saturation absolute humidity";
        Modelica.SIunits.Pressure pSat1
                                       "Air saturation pressure at TWater1";
        Modelica.SIunits.Density rho1
                                     "Density of air-water vapor mixture at the entrace";
        Modelica.SIunits.MolarMass N1
                                     "Inlet air molar mass";
        Modelica.SIunits.Temperature TAir2
                                          "Inlet air temperature in K";
        Modelica.SIunits.SpecificEnthalpy hAir2
                                               "specific enthalpy of the outlet Air";
        Modelica.SIunits.MassFlowRate mAir2
                                           "Outlet air mass flow";
        Modelica.SIunits.MassFraction X2
                                        "Vapour mass fraction in the outlet air [kg_vapour/kg_moist_air]";
        Modelica.SIunits.MassFlowRate mDAir2
                                            "Outlet dry air mass flow";
        Modelica.SIunits.MassFlowRate mVap2
                                           "Outlet vapour mass flow";
        Modelica.SIunits.MassFraction H2
                                        "Outlet Air absolute humidity";
        Modelica.SIunits.Temp_C TAir2C
                                      "Inlet air temperature in C";
        Modelica.SIunits.SpecificEnthalpy hsw2
                                              "Air saturation enthalpy at outlet water temperature";
        Modelica.SIunits.MassFraction Hsat2
                                           "Outlet air saturation absolute humidity";
        Modelica.SIunits.Pressure pSat2
                                       "Air saturation pressure at TAir2";
        Modelica.SIunits.Density rho2
                                     "Density of air-water vapor mixture at the exit";
        Modelica.SIunits.MolarMass N2
                                     "Outlet air molar mass";
        Real phi2
                 "Realitive humidity at the exit of the tower";
        Modelica.SIunits.MassFlowRate mEvap
                                           "Evaported mass flow";
        Modelica.SIunits.SpecificEnthalpy hvap
                                              "Vapour specific enthalpy";
        Modelica.SIunits.Temperature Tvap
                                         "Vapour temperature in K";
        Modelica.SIunits.Temp_C TvapC
                                     "Vapour temperature in C";
        Modelica.SIunits.HeatFlowRate Qsen
                                          "Sensible heat transferred to the water";
        Modelica.SIunits.HeatFlowRate Qlat
                                          "Latent heat transferred to the water";
        Modelica.SIunits.HeatFlowRate Qtot
                                          "Total heat transferred to the water";
        Modelica.SIunits.HeatFlowRate Qcol
                                          "Total heat transferred to the cooling water";
        Modelica.SIunits.HeatFlowRate Qfi
                                         "Total heat absorbed by the filter";
        parameter Real Kfi(unit = "1/m", fixed=false)
                                                     "Loss coefficient in the fill";
        parameter Modelica.SIunits.Length hfi(fixed=false)
                                                          "Height of the filter";
        parameter Modelica.SIunits.Length wfi(fixed=false)
                                                          "Width of the filter";
        parameter Modelica.SIunits.Length lfi(fixed=false)
                                                          "Length of the filter";
        Modelica.SIunits.MassFlowRate mMed
                                          "Mean air-vapor flow rate";
        Modelica.SIunits.Density rhoMed
                                       "harmonic mean density of air-water vapor mixtures";
        parameter Modelica.SIunits.Area Afr(fixed=false)
                                                        "cross-sectional packing area";
        Modelica.SIunits.Pressure IncP
                                      "Air pressure change between the entrace and the exit";
        Real e_a
                "Efficiency of the tower";
        parameter Real c(fixed=false)
                                     "Empirical constant specific to a particular tower design";
        parameter Real n(fixed=false)
                                     "Empirical constant specific to a particular tower design";
        Real NTU
                "Number of Transfer Units of the tower";
        Real C_s
                "Derivative of saturated ha with respect to Tw";
        Real m_ratio
                    "Ratio of air to water effective capacitance rate";
        parameter Modelica.SIunits.Pressure pAmbient(fixed=false)
                                                                 "Ambient pressure";
        parameter Modelica.SIunits.Temperature TWater2_start(fixed=false)
                                                                         "Start value for the outlet water";
        parameter Modelica.SIunits.Temperature TAir2_start(fixed=false)
                                                                       "Start value for the outlet water";
        parameter Modelica.SIunits.MassFraction H2_start(fixed=false)
                                                                     "Outlet Air absolute humidity";
        parameter Modelica.SIunits.MassFlowRate mMed_start = 40
                                                               "Start value for the outlet water";
        Modelica.SIunits.Temperature Tfi;
        Real Tfi_der(unit = "K/s");
        parameter Real C_iner(fixed=false)
                                          "Constant defining the thermal inertia of the filter";
      end closedHeatToAirPressureDrop_rec;
    public
      closedHeatToAirPressureDrop_rec closedHeatToAirPressureDrop annotation(Dialog);
    protected
      record 'coilWall[1]_rec'
        parameter Real nParallel(min = 1.0, fixed=false)
                                                        "Number of identical parallel elements";
        constant Boolean use_portDim1 = true
                                            "Heat tranfer in 1st dimention";
        constant Boolean use_portDim2 = true
                                            "Heat tranfer in 2nd dimention";
        constant Boolean use_portDim3 = false
                                             "Heat tranfer in 3rd dimention";
        constant Integer nDim1(min = 1) = 1;
        constant Integer nDim2(min = 1) = 10;
        constant Integer nDim3(min = 1) = 1;
        constant Boolean use_dim1 = true
                                        "Heat tranfer in 1st dimention";
        constant Boolean use_dim2 = true
                                        "Heat tranfer in 2nd dimention";
        constant Boolean use_dim3 = false
                                         "Heat tranfer in 3rd dimention";
        parameter Modelica.SIunits.Temperature T_start(fixed=false)
                                                                   "Start temperature for the average temperature of cylinder";
        parameter Modelica.SIunits.TemperatureSlope der_T_start = 0
                                                                   "Start value ofime derivative of temperature (= der(T))";
        parameter Modelica.SIunits.Volume V(fixed=false)
                                                        "Volume of material";
        constant Boolean use_radialDim = true
                                             "Use heat transfer in radial direction";
        constant Boolean use_longitudinalDim = true
                                                   "Use heat transfer in longitudinal direction";
        constant Boolean use_angularDim = false
                                               "Use heat transfer in angular direction";
        constant Integer nRadial = 1;
        constant Integer nLongitudinal = 10;
        constant Integer nAngular = 1;
        parameter Modelica.SIunits.Length r_int(fixed=false)
                                                            "Inner radius of cylinder";
        parameter Modelica.SIunits.Length r_ext(fixed=false)
                                                            "Outer radius of cylinder";
        constant Modelica.SIunits.Length length = 5.0
                                                     "Length of cylinder";
        parameter Modelica.SIunits.Angle alpha = 6.283185307179586
                                                                  "Swept angle";
        parameter Modelica.SIunits.Area A_annulus(fixed=false)
                                                              "Annulus section area";
        constant Modelica.SIunits.Length length_node = 0.5;
        parameter Modelica.SIunits.Angle alpha_node(fixed=false);
        parameter Modelica.SIunits.Length 'rs[1]'(fixed=false);
        parameter Modelica.SIunits.Length 'rs[2]'(fixed=false);
        parameter Modelica.SIunits.Length 'rs_int[1,1,1]'(fixed=false);
        parameter Modelica.SIunits.Length 'rs_int[1,2,1]'(fixed=false);
        parameter Modelica.SIunits.Length 'rs_int[1,3,1]'(fixed=false);
        parameter Modelica.SIunits.Length 'rs_int[1,4,1]'(fixed=false);
        parameter Modelica.SIunits.Length 'rs_int[1,5,1]'(fixed=false);
        parameter Modelica.SIunits.Length 'rs_int[1,6,1]'(fixed=false);
        parameter Modelica.SIunits.Length 'rs_int[1,7,1]'(fixed=false);
        parameter Modelica.SIunits.Length 'rs_int[1,8,1]'(fixed=false);
        parameter Modelica.SIunits.Length 'rs_int[1,9,1]'(fixed=false);
        parameter Modelica.SIunits.Length 'rs_int[1,10,1]'(fixed=false);
        parameter Modelica.SIunits.Length 'rs_ext[1,1,1]'(fixed=false);
        parameter Modelica.SIunits.Length 'rs_ext[1,2,1]'(fixed=false);
        parameter Modelica.SIunits.Length 'rs_ext[1,3,1]'(fixed=false);
        parameter Modelica.SIunits.Length 'rs_ext[1,4,1]'(fixed=false);
        parameter Modelica.SIunits.Length 'rs_ext[1,5,1]'(fixed=false);
        parameter Modelica.SIunits.Length 'rs_ext[1,6,1]'(fixed=false);
        parameter Modelica.SIunits.Length 'rs_ext[1,7,1]'(fixed=false);
        parameter Modelica.SIunits.Length 'rs_ext[1,8,1]'(fixed=false);
        parameter Modelica.SIunits.Length 'rs_ext[1,9,1]'(fixed=false);
        parameter Modelica.SIunits.Length 'rs_ext[1,10,1]'(fixed=false);
        parameter Modelica.SIunits.Length 'rs_avg[1,1,1]'(fixed=false);
        parameter Modelica.SIunits.Length 'rs_avg[1,2,1]'(fixed=false);
        parameter Modelica.SIunits.Length 'rs_avg[1,3,1]'(fixed=false);
        parameter Modelica.SIunits.Length 'rs_avg[1,4,1]'(fixed=false);
        parameter Modelica.SIunits.Length 'rs_avg[1,5,1]'(fixed=false);
        parameter Modelica.SIunits.Length 'rs_avg[1,6,1]'(fixed=false);
        parameter Modelica.SIunits.Length 'rs_avg[1,7,1]'(fixed=false);
        parameter Modelica.SIunits.Length 'rs_avg[1,8,1]'(fixed=false);
        parameter Modelica.SIunits.Length 'rs_avg[1,9,1]'(fixed=false);
        parameter Modelica.SIunits.Length 'rs_avg[1,10,1]'(fixed=false);
        parameter Modelica.SIunits.Length 'arcs[1,1,1]'(fixed=false);
        parameter Modelica.SIunits.Length 'arcs[1,2,1]'(fixed=false);
        parameter Modelica.SIunits.Length 'arcs[1,3,1]'(fixed=false);
        parameter Modelica.SIunits.Length 'arcs[1,4,1]'(fixed=false);
        parameter Modelica.SIunits.Length 'arcs[1,5,1]'(fixed=false);
        parameter Modelica.SIunits.Length 'arcs[1,6,1]'(fixed=false);
        parameter Modelica.SIunits.Length 'arcs[1,7,1]'(fixed=false);
        parameter Modelica.SIunits.Length 'arcs[1,8,1]'(fixed=false);
        parameter Modelica.SIunits.Length 'arcs[1,9,1]'(fixed=false);
        parameter Modelica.SIunits.Length 'arcs[1,10,1]'(fixed=false);
        parameter Modelica.SIunits.Area 'As_annulus[1,1,1]'(fixed=false)
                                                                        "Annulus section area";
        parameter Modelica.SIunits.Area 'As_annulus[1,2,1]'(fixed=false)
                                                                        "Annulus section area";
        parameter Modelica.SIunits.Area 'As_annulus[1,3,1]'(fixed=false)
                                                                        "Annulus section area";
        parameter Modelica.SIunits.Area 'As_annulus[1,4,1]'(fixed=false)
                                                                        "Annulus section area";
        parameter Modelica.SIunits.Area 'As_annulus[1,5,1]'(fixed=false)
                                                                        "Annulus section area";
        parameter Modelica.SIunits.Area 'As_annulus[1,6,1]'(fixed=false)
                                                                        "Annulus section area";
        parameter Modelica.SIunits.Area 'As_annulus[1,7,1]'(fixed=false)
                                                                        "Annulus section area";
        parameter Modelica.SIunits.Area 'As_annulus[1,8,1]'(fixed=false)
                                                                        "Annulus section area";
        parameter Modelica.SIunits.Area 'As_annulus[1,9,1]'(fixed=false)
                                                                        "Annulus section area";
        parameter Modelica.SIunits.Area 'As_annulus[1,10,1]'(fixed=false)
                                                                         "Annulus section area";
      protected
        record 'port_a_1[1, 1]_rec'
          Modelica.SIunits.Temperature T
                                        "Port temperature";
          Modelica.SIunits.HeatFlowRate Q_flow
                                              "Heat flow rate (positive if flowing from outside into the component)";
        end 'port_a_1[1, 1]_rec';
      public
        'port_a_1[1, 1]_rec' 'port_a_1[1, 1]';
      protected
        record 'port_a_1[1, 2]_rec'
          Modelica.SIunits.Temperature T
                                        "Port temperature";
          Modelica.SIunits.HeatFlowRate Q_flow
                                              "Heat flow rate (positive if flowing from outside into the component)";
        end 'port_a_1[1, 2]_rec';
      public
        'port_a_1[1, 2]_rec' 'port_a_1[1, 2]';
      protected
        record 'port_a_1[1, 3]_rec'
          Modelica.SIunits.Temperature T
                                        "Port temperature";
          Modelica.SIunits.HeatFlowRate Q_flow
                                              "Heat flow rate (positive if flowing from outside into the component)";
        end 'port_a_1[1, 3]_rec';
      public
        'port_a_1[1, 3]_rec' 'port_a_1[1, 3]';
      protected
        record 'port_a_1[1, 4]_rec'
          Modelica.SIunits.Temperature T
                                        "Port temperature";
          Modelica.SIunits.HeatFlowRate Q_flow
                                              "Heat flow rate (positive if flowing from outside into the component)";
        end 'port_a_1[1, 4]_rec';
      public
        'port_a_1[1, 4]_rec' 'port_a_1[1, 4]';
      protected
        record 'port_a_1[1, 5]_rec'
          Modelica.SIunits.Temperature T
                                        "Port temperature";
          Modelica.SIunits.HeatFlowRate Q_flow
                                              "Heat flow rate (positive if flowing from outside into the component)";
        end 'port_a_1[1, 5]_rec';
      public
        'port_a_1[1, 5]_rec' 'port_a_1[1, 5]';
      protected
        record 'port_a_1[1, 6]_rec'
          Modelica.SIunits.Temperature T
                                        "Port temperature";
          Modelica.SIunits.HeatFlowRate Q_flow
                                              "Heat flow rate (positive if flowing from outside into the component)";
        end 'port_a_1[1, 6]_rec';
      public
        'port_a_1[1, 6]_rec' 'port_a_1[1, 6]';
      protected
        record 'port_a_1[1, 7]_rec'
          Modelica.SIunits.Temperature T
                                        "Port temperature";
          Modelica.SIunits.HeatFlowRate Q_flow
                                              "Heat flow rate (positive if flowing from outside into the component)";
        end 'port_a_1[1, 7]_rec';
      public
        'port_a_1[1, 7]_rec' 'port_a_1[1, 7]';
      protected
        record 'port_a_1[1, 8]_rec'
          Modelica.SIunits.Temperature T
                                        "Port temperature";
          Modelica.SIunits.HeatFlowRate Q_flow
                                              "Heat flow rate (positive if flowing from outside into the component)";
        end 'port_a_1[1, 8]_rec';
      public
        'port_a_1[1, 8]_rec' 'port_a_1[1, 8]';
      protected
        record 'port_a_1[1, 9]_rec'
          Modelica.SIunits.Temperature T
                                        "Port temperature";
          Modelica.SIunits.HeatFlowRate Q_flow
                                              "Heat flow rate (positive if flowing from outside into the component)";
        end 'port_a_1[1, 9]_rec';
      public
        'port_a_1[1, 9]_rec' 'port_a_1[1, 9]';
      protected
        record 'port_a_1[1, 10]_rec'
          Modelica.SIunits.Temperature T
                                        "Port temperature";
          Modelica.SIunits.HeatFlowRate Q_flow
                                              "Heat flow rate (positive if flowing from outside into the component)";
        end 'port_a_1[1, 10]_rec';
      public
        'port_a_1[1, 10]_rec' 'port_a_1[1, 10]';
      protected
        record 'port_b_1[1, 1]_rec'
          Modelica.SIunits.Temperature T
                                        "Port temperature";
          Modelica.SIunits.HeatFlowRate Q_flow
                                              "Heat flow rate (positive if flowing from outside into the component)";
        end 'port_b_1[1, 1]_rec';
      public
        'port_b_1[1, 1]_rec' 'port_b_1[1, 1]';
      protected
        record 'port_b_1[1, 2]_rec'
          Modelica.SIunits.Temperature T
                                        "Port temperature";
          Modelica.SIunits.HeatFlowRate Q_flow
                                              "Heat flow rate (positive if flowing from outside into the component)";
        end 'port_b_1[1, 2]_rec';
      public
        'port_b_1[1, 2]_rec' 'port_b_1[1, 2]';
      protected
        record 'port_b_1[1, 3]_rec'
          Modelica.SIunits.Temperature T
                                        "Port temperature";
          Modelica.SIunits.HeatFlowRate Q_flow
                                              "Heat flow rate (positive if flowing from outside into the component)";
        end 'port_b_1[1, 3]_rec';
      public
        'port_b_1[1, 3]_rec' 'port_b_1[1, 3]';
      protected
        record 'port_b_1[1, 4]_rec'
          Modelica.SIunits.Temperature T
                                        "Port temperature";
          Modelica.SIunits.HeatFlowRate Q_flow
                                              "Heat flow rate (positive if flowing from outside into the component)";
        end 'port_b_1[1, 4]_rec';
      public
        'port_b_1[1, 4]_rec' 'port_b_1[1, 4]';
      protected
        record 'port_b_1[1, 5]_rec'
          Modelica.SIunits.Temperature T
                                        "Port temperature";
          Modelica.SIunits.HeatFlowRate Q_flow
                                              "Heat flow rate (positive if flowing from outside into the component)";
        end 'port_b_1[1, 5]_rec';
      public
        'port_b_1[1, 5]_rec' 'port_b_1[1, 5]';
      protected
        record 'port_b_1[1, 6]_rec'
          Modelica.SIunits.Temperature T
                                        "Port temperature";
          Modelica.SIunits.HeatFlowRate Q_flow
                                              "Heat flow rate (positive if flowing from outside into the component)";
        end 'port_b_1[1, 6]_rec';
      public
        'port_b_1[1, 6]_rec' 'port_b_1[1, 6]';
      protected
        record 'port_b_1[1, 7]_rec'
          Modelica.SIunits.Temperature T
                                        "Port temperature";
          Modelica.SIunits.HeatFlowRate Q_flow
                                              "Heat flow rate (positive if flowing from outside into the component)";
        end 'port_b_1[1, 7]_rec';
      public
        'port_b_1[1, 7]_rec' 'port_b_1[1, 7]';
      protected
        record 'port_b_1[1, 8]_rec'
          Modelica.SIunits.Temperature T
                                        "Port temperature";
          Modelica.SIunits.HeatFlowRate Q_flow
                                              "Heat flow rate (positive if flowing from outside into the component)";
        end 'port_b_1[1, 8]_rec';
      public
        'port_b_1[1, 8]_rec' 'port_b_1[1, 8]';
      protected
        record 'port_b_1[1, 9]_rec'
          Modelica.SIunits.Temperature T
                                        "Port temperature";
          Modelica.SIunits.HeatFlowRate Q_flow
                                              "Heat flow rate (positive if flowing from outside into the component)";
        end 'port_b_1[1, 9]_rec';
      public
        'port_b_1[1, 9]_rec' 'port_b_1[1, 9]';
      protected
        record 'port_b_1[1, 10]_rec'
          Modelica.SIunits.Temperature T
                                        "Port temperature";
          Modelica.SIunits.HeatFlowRate Q_flow
                                              "Heat flow rate (positive if flowing from outside into the component)";
        end 'port_b_1[1, 10]_rec';
      public
        'port_b_1[1, 10]_rec' 'port_b_1[1, 10]';
      protected
        record 'port_a_2[1, 1]_rec'
          Modelica.SIunits.Temperature T
                                        "Port temperature";
          constant Modelica.SIunits.HeatFlowRate Q_flow = 0.0
                                                             "Heat flow rate (positive if flowing from outside into the component)";
        end 'port_a_2[1, 1]_rec';
      public
        'port_a_2[1, 1]_rec' 'port_a_2[1, 1]';
      protected
        record 'port_b_2[1, 1]_rec'
          Modelica.SIunits.Temperature T
                                        "Port temperature";
          constant Modelica.SIunits.HeatFlowRate Q_flow = 0.0
                                                             "Heat flow rate (positive if flowing from outside into the component)";
        end 'port_b_2[1, 1]_rec';
      public
        'port_b_2[1, 1]_rec' 'port_b_2[1, 1]';
      protected
        record 'thermalNode[1, 1, 1]_rec'
          parameter Real nParallel(min = 1.0) = 1
                                                 "Number of identical parallel elements";
          constant Boolean use_portDim1 = true
                                              "Heat tranfer in 1st dimention";
          constant Boolean use_portDim2 = true
                                              "Heat tranfer in 2nd dimention";
          constant Boolean use_portDim3 = false
                                               "Heat tranfer in 3rd dimention";
        protected
          record port_a_1_rec
            Modelica.SIunits.Temperature T
                                          "Port temperature";
            Modelica.SIunits.HeatFlowRate Q_flow
                                                "Heat flow rate (positive if flowing from outside into the component)";
          end port_a_1_rec;
        public
          port_a_1_rec port_a_1;
        protected
          record port_b_1_rec
            Modelica.SIunits.Temperature T
                                          "Port temperature";
            Modelica.SIunits.HeatFlowRate Q_flow
                                                "Heat flow rate (positive if flowing from outside into the component)";
          end port_b_1_rec;
        public
          port_b_1_rec port_b_1;
        protected
          record port_a_2_rec
            Modelica.SIunits.Temperature T
                                          "Port temperature";
            constant Modelica.SIunits.HeatFlowRate Q_flow = 0.0
                                                               "Heat flow rate (positive if flowing from outside into the component)";
          end port_a_2_rec;
        public
          port_a_2_rec port_a_2;
        protected
          record port_b_2_rec
            Modelica.SIunits.Temperature T
                                          "Port temperature";
            Modelica.SIunits.HeatFlowRate Q_flow
                                                "Heat flow rate (positive if flowing from outside into the component)";
          end port_b_2_rec;
        public
          port_b_2_rec port_b_2;
          parameter Modelica.SIunits.Volume V(fixed=false)
                                                          "Volume of material";
        protected
          record thermalConductor_a_1_rec
            Modelica.SIunits.HeatFlowRate Q_flow
                                                "Heat flow rate from port_a -> port_b";
            Modelica.SIunits.TemperatureDifference dT
                                                     "port_a.T - port_b.T";
          protected
            record port_a_rec
              Modelica.SIunits.Temperature T
                                            "Port temperature";
              Modelica.SIunits.HeatFlowRate Q_flow
                                                  "Heat flow rate (positive if flowing from outside into the component)";
            end port_a_rec;
          public
            port_a_rec port_a;
          protected
            record port_b_rec
              Modelica.SIunits.Temperature T
                                            "Port temperature";
              Modelica.SIunits.HeatFlowRate Q_flow
                                                  "Heat flow rate (positive if flowing from outside into the component)";
            end port_b_rec;
          public
            port_b_rec port_b;
            Modelica.SIunits.Temperature T
                                          "Average temperature of element";
            parameter Modelica.SIunits.Temperature T_start(fixed=false)
                                                                       "Start temperature for the average temperature of element";
            Modelica.SIunits.ThermalConductance G
                                                 "Thermal conductance of material";
            Modelica.SIunits.ThermalConductivity k
                                                  "Thermal conductivity";
            parameter Modelica.SIunits.Length r_internal(fixed=false)
                                                                     "Inner radius of cylinder";
            parameter Modelica.SIunits.Length r_external(fixed=false)
                                                                     "Outer radius of cylinder";
            parameter Modelica.SIunits.Length L(fixed=false)
                                                            "Length of cylinder";
            parameter Modelica.SIunits.Angle alpha(fixed=false)
                                                               "Swept angle";
          end thermalConductor_a_1_rec;
        public
          thermalConductor_a_1_rec thermalConductor_a_1;
        protected
          record thermalConductor_b_1_rec
            Modelica.SIunits.HeatFlowRate Q_flow
                                                "Heat flow rate from port_a -> port_b";
            Modelica.SIunits.TemperatureDifference dT
                                                     "port_a.T - port_b.T";
          protected
            record port_a_rec
              Modelica.SIunits.Temperature T
                                            "Port temperature";
              Modelica.SIunits.HeatFlowRate Q_flow
                                                  "Heat flow rate (positive if flowing from outside into the component)";
            end port_a_rec;
          public
            port_a_rec port_a;
          protected
            record port_b_rec
              Modelica.SIunits.Temperature T
                                            "Port temperature";
              Modelica.SIunits.HeatFlowRate Q_flow
                                                  "Heat flow rate (positive if flowing from outside into the component)";
            end port_b_rec;
          public
            port_b_rec port_b;
            Modelica.SIunits.Temperature T
                                          "Average temperature of element";
            parameter Modelica.SIunits.Temperature T_start(fixed=false)
                                                                       "Start temperature for the average temperature of element";
            Modelica.SIunits.ThermalConductance G
                                                 "Thermal conductance of material";
            Modelica.SIunits.ThermalConductivity k
                                                  "Thermal conductivity";
            parameter Modelica.SIunits.Length r_internal(fixed=false)
                                                                     "Inner radius of cylinder";
            parameter Modelica.SIunits.Length r_external(fixed=false)
                                                                     "Outer radius of cylinder";
            parameter Modelica.SIunits.Length L(fixed=false)
                                                            "Length of cylinder";
            parameter Modelica.SIunits.Angle alpha(fixed=false)
                                                               "Swept angle";
          end thermalConductor_b_1_rec;
        public
          thermalConductor_b_1_rec thermalConductor_b_1;
        protected
          record thermalConductor_a_2_rec
            constant Modelica.SIunits.HeatFlowRate Q_flow = 0.0
                                                               "Heat flow rate from port_a -> port_b";
            Modelica.SIunits.TemperatureDifference dT
                                                     "port_a.T - port_b.T";
          protected
            record port_a_rec
              Modelica.SIunits.Temperature T
                                            "Port temperature";
              constant Modelica.SIunits.HeatFlowRate Q_flow = 0.0
                                                                 "Heat flow rate (positive if flowing from outside into the component)";
            end port_a_rec;
          public
            port_a_rec port_a;
          protected
            record port_b_rec
              Modelica.SIunits.Temperature T
                                            "Port temperature";
              constant Modelica.SIunits.HeatFlowRate Q_flow = 0.0
                                                                 "Heat flow rate (positive if flowing from outside into the component)";
            end port_b_rec;
          public
            port_b_rec port_b;
            Modelica.SIunits.Temperature T
                                          "Average temperature of element";
            parameter Modelica.SIunits.Temperature T_start(fixed=false)
                                                                       "Start temperature for the average temperature of element";
            Modelica.SIunits.ThermalConductance G
                                                 "Thermal conductance of material";
            Modelica.SIunits.ThermalConductivity k
                                                  "Thermal conductivity";
            parameter Modelica.SIunits.Length L(fixed=false)
                                                            "length of conduction";
            parameter Modelica.SIunits.Area A(fixed=false)
                                                          "Heat transfer area";
          end thermalConductor_a_2_rec;
        public
          thermalConductor_a_2_rec thermalConductor_a_2;
        protected
          record thermalConductor_b_2_rec
            Modelica.SIunits.HeatFlowRate Q_flow
                                                "Heat flow rate from port_a -> port_b";
            Modelica.SIunits.TemperatureDifference dT
                                                     "port_a.T - port_b.T";
          protected
            record port_a_rec
              Modelica.SIunits.Temperature T
                                            "Port temperature";
              Modelica.SIunits.HeatFlowRate Q_flow
                                                  "Heat flow rate (positive if flowing from outside into the component)";
            end port_a_rec;
          public
            port_a_rec port_a;
          protected
            record port_b_rec
              Modelica.SIunits.Temperature T
                                            "Port temperature";
              Modelica.SIunits.HeatFlowRate Q_flow
                                                  "Heat flow rate (positive if flowing from outside into the component)";
            end port_b_rec;
          public
            port_b_rec port_b;
            Modelica.SIunits.Temperature T
                                          "Average temperature of element";
            parameter Modelica.SIunits.Temperature T_start(fixed=false)
                                                                       "Start temperature for the average temperature of element";
            Modelica.SIunits.ThermalConductance G
                                                 "Thermal conductance of material";
            Modelica.SIunits.ThermalConductivity k
                                                  "Thermal conductivity";
            parameter Modelica.SIunits.Length L(fixed=false)
                                                            "length of conduction";
            parameter Modelica.SIunits.Area A(fixed=false)
                                                          "Heat transfer area";
          end thermalConductor_b_2_rec;
        public
          thermalConductor_b_2_rec thermalConductor_b_2;
        protected
          record thermalConductor_a_3_rec
            constant Modelica.SIunits.HeatFlowRate Q_flow = 0.0
                                                               "Heat flow rate from port_a -> port_b";
            Modelica.SIunits.TemperatureDifference dT
                                                     "port_a.T - port_b.T";
          protected
            record port_a_rec
              Modelica.SIunits.Temperature T
                                            "Port temperature";
              constant Modelica.SIunits.HeatFlowRate Q_flow = 0.0
                                                                 "Heat flow rate (positive if flowing from outside into the component)";
            end port_a_rec;
          public
            port_a_rec port_a;
          protected
            record port_b_rec
              Modelica.SIunits.Temperature T
                                            "Port temperature";
              constant Modelica.SIunits.HeatFlowRate Q_flow = 0.0
                                                                 "Heat flow rate (positive if flowing from outside into the component)";
            end port_b_rec;
          public
            port_b_rec port_b;
            Modelica.SIunits.Temperature T
                                          "Average temperature of element";
            parameter Modelica.SIunits.Temperature T_start(fixed=false)
                                                                       "Start temperature for the average temperature of element";
            Modelica.SIunits.ThermalConductance G
                                                 "Thermal conductance of material";
            Modelica.SIunits.ThermalConductivity k
                                                  "Thermal conductivity";
            parameter Modelica.SIunits.Length L(fixed=false)
                                                            "length of conduction";
            parameter Modelica.SIunits.Area A(fixed=false)
                                                          "Heat transfer area";
          end thermalConductor_a_3_rec;
        public
          thermalConductor_a_3_rec thermalConductor_a_3;
        protected
          record thermalConductor_b_3_rec
            constant Modelica.SIunits.HeatFlowRate Q_flow = 0.0
                                                               "Heat flow rate from port_a -> port_b";
            Modelica.SIunits.TemperatureDifference dT
                                                     "port_a.T - port_b.T";
          protected
            record port_a_rec
              Modelica.SIunits.Temperature T
                                            "Port temperature";
              constant Modelica.SIunits.HeatFlowRate Q_flow = 0.0
                                                                 "Heat flow rate (positive if flowing from outside into the component)";
            end port_a_rec;
          public
            port_a_rec port_a;
          protected
            record port_b_rec
              Modelica.SIunits.Temperature T
                                            "Port temperature";
              constant Modelica.SIunits.HeatFlowRate Q_flow = 0.0
                                                                 "Heat flow rate (positive if flowing from outside into the component)";
            end port_b_rec;
          public
            port_b_rec port_b;
            Modelica.SIunits.Temperature T
                                          "Average temperature of element";
            parameter Modelica.SIunits.Temperature T_start(fixed=false)
                                                                       "Start temperature for the average temperature of element";
            Modelica.SIunits.ThermalConductance G
                                                 "Thermal conductance of material";
            Modelica.SIunits.ThermalConductivity k
                                                  "Thermal conductivity";
            parameter Modelica.SIunits.Length L(fixed=false)
                                                            "length of conduction";
            parameter Modelica.SIunits.Area A(fixed=false)
                                                          "Heat transfer area";
          end thermalConductor_b_3_rec;
        public
          thermalConductor_b_3_rec thermalConductor_b_3;
        protected
          record heatCapacitor_rec
            Modelica.SIunits.Temperature T
                                          "Temperature of element";
            Real T_der(unit = "K/s")
                                    "der(Temperature of element)";
            Modelica.SIunits.HeatFlowRate Q_flow;
            parameter Modelica.SIunits.Temperature T_start(fixed=false)
                                                                       "Start temperature for the average temperature of ellement";
          protected
            record port_rec
              Modelica.SIunits.Temperature T
                                            "Port temperature";
              Modelica.SIunits.HeatFlowRate Q_flow
                                                  "Heat flow rate (positive if flowing from outside into the component)";
            end port_rec;
          public
            port_rec port;
            parameter Modelica.SIunits.Volume V(fixed=false)
                                                            "Volume of element";
            parameter Modelica.SIunits.Mass m(fixed=false)
                                                          "Mass of element";
            Modelica.SIunits.TemperatureSlope der_T
                                                   "Time derivative of temperature (= der(T))";
            Modelica.SIunits.HeatCapacity C
                                           "Heat capacity of element (= cp*m)";
            parameter Modelica.SIunits.TemperatureSlope der_T_start(fixed=false)
                                                                                "Start value ofime derivative of temperature (= der(T))";
          end heatCapacitor_rec;
        public
          heatCapacitor_rec heatCapacitor;
        protected
          record port_int_rec
            Modelica.SIunits.Temperature T
                                          "Port temperature";
            constant Modelica.SIunits.HeatFlowRate Q_flow = 0.0
                                                               "Heat flow rate (positive if flowing from outside into the component)";
          end port_int_rec;
        public
          port_int_rec port_int;
        end 'thermalNode[1, 1, 1]_rec';
      public
        'thermalNode[1, 1, 1]_rec' 'thermalNode[1, 1, 1]' annotation(Dialog);
      protected
        record 'thermalNode[1, 2, 1]_rec'
          parameter Real nParallel(min = 1.0) = 1
                                                 "Number of identical parallel elements";
          constant Boolean use_portDim1 = true
                                              "Heat tranfer in 1st dimention";
          constant Boolean use_portDim2 = true
                                              "Heat tranfer in 2nd dimention";
          constant Boolean use_portDim3 = false
                                               "Heat tranfer in 3rd dimention";
        protected
          record port_a_1_rec
            Modelica.SIunits.Temperature T
                                          "Port temperature";
            Modelica.SIunits.HeatFlowRate Q_flow
                                                "Heat flow rate (positive if flowing from outside into the component)";
          end port_a_1_rec;
        public
          port_a_1_rec port_a_1;
        protected
          record port_b_1_rec
            Modelica.SIunits.Temperature T
                                          "Port temperature";
            Modelica.SIunits.HeatFlowRate Q_flow
                                                "Heat flow rate (positive if flowing from outside into the component)";
          end port_b_1_rec;
        public
          port_b_1_rec port_b_1;
        protected
          record port_a_2_rec
            Modelica.SIunits.Temperature T
                                          "Port temperature";
            Modelica.SIunits.HeatFlowRate Q_flow
                                                "Heat flow rate (positive if flowing from outside into the component)";
          end port_a_2_rec;
        public
          port_a_2_rec port_a_2;
        protected
          record port_b_2_rec
            Modelica.SIunits.Temperature T
                                          "Port temperature";
            Modelica.SIunits.HeatFlowRate Q_flow
                                                "Heat flow rate (positive if flowing from outside into the component)";
          end port_b_2_rec;
        public
          port_b_2_rec port_b_2;
          parameter Modelica.SIunits.Volume V(fixed=false)
                                                          "Volume of material";
        protected
          record thermalConductor_a_1_rec
            Modelica.SIunits.HeatFlowRate Q_flow
                                                "Heat flow rate from port_a -> port_b";
            Modelica.SIunits.TemperatureDifference dT
                                                     "port_a.T - port_b.T";
          protected
            record port_a_rec
              Modelica.SIunits.Temperature T
                                            "Port temperature";
              Modelica.SIunits.HeatFlowRate Q_flow
                                                  "Heat flow rate (positive if flowing from outside into the component)";
            end port_a_rec;
          public
            port_a_rec port_a;
          protected
            record port_b_rec
              Modelica.SIunits.Temperature T
                                            "Port temperature";
              Modelica.SIunits.HeatFlowRate Q_flow
                                                  "Heat flow rate (positive if flowing from outside into the component)";
            end port_b_rec;
          public
            port_b_rec port_b;
            Modelica.SIunits.Temperature T
                                          "Average temperature of element";
            parameter Modelica.SIunits.Temperature T_start(fixed=false)
                                                                       "Start temperature for the average temperature of element";
            Modelica.SIunits.ThermalConductance G
                                                 "Thermal conductance of material";
            Modelica.SIunits.ThermalConductivity k
                                                  "Thermal conductivity";
            parameter Modelica.SIunits.Length r_internal(fixed=false)
                                                                     "Inner radius of cylinder";
            parameter Modelica.SIunits.Length r_external(fixed=false)
                                                                     "Outer radius of cylinder";
            parameter Modelica.SIunits.Length L(fixed=false)
                                                            "Length of cylinder";
            parameter Modelica.SIunits.Angle alpha(fixed=false)
                                                               "Swept angle";
          end thermalConductor_a_1_rec;
        public
          thermalConductor_a_1_rec thermalConductor_a_1;
        protected
          record thermalConductor_b_1_rec
            Modelica.SIunits.HeatFlowRate Q_flow
                                                "Heat flow rate from port_a -> port_b";
            Modelica.SIunits.TemperatureDifference dT
                                                     "port_a.T - port_b.T";
          protected
            record port_a_rec
              Modelica.SIunits.Temperature T
                                            "Port temperature";
              Modelica.SIunits.HeatFlowRate Q_flow
                                                  "Heat flow rate (positive if flowing from outside into the component)";
            end port_a_rec;
          public
            port_a_rec port_a;
          protected
            record port_b_rec
              Modelica.SIunits.Temperature T
                                            "Port temperature";
              Modelica.SIunits.HeatFlowRate Q_flow
                                                  "Heat flow rate (positive if flowing from outside into the component)";
            end port_b_rec;
          public
            port_b_rec port_b;
            Modelica.SIunits.Temperature T
                                          "Average temperature of element";
            parameter Modelica.SIunits.Temperature T_start(fixed=false)
                                                                       "Start temperature for the average temperature of element";
            Modelica.SIunits.ThermalConductance G
                                                 "Thermal conductance of material";
            Modelica.SIunits.ThermalConductivity k
                                                  "Thermal conductivity";
            parameter Modelica.SIunits.Length r_internal(fixed=false)
                                                                     "Inner radius of cylinder";
            parameter Modelica.SIunits.Length r_external(fixed=false)
                                                                     "Outer radius of cylinder";
            parameter Modelica.SIunits.Length L(fixed=false)
                                                            "Length of cylinder";
            parameter Modelica.SIunits.Angle alpha(fixed=false)
                                                               "Swept angle";
          end thermalConductor_b_1_rec;
        public
          thermalConductor_b_1_rec thermalConductor_b_1;
        protected
          record thermalConductor_a_2_rec
            Modelica.SIunits.HeatFlowRate Q_flow
                                                "Heat flow rate from port_a -> port_b";
            Modelica.SIunits.TemperatureDifference dT
                                                     "port_a.T - port_b.T";
          protected
            record port_a_rec
              Modelica.SIunits.Temperature T
                                            "Port temperature";
              Modelica.SIunits.HeatFlowRate Q_flow
                                                  "Heat flow rate (positive if flowing from outside into the component)";
            end port_a_rec;
          public
            port_a_rec port_a;
          protected
            record port_b_rec
              Modelica.SIunits.Temperature T
                                            "Port temperature";
              Modelica.SIunits.HeatFlowRate Q_flow
                                                  "Heat flow rate (positive if flowing from outside into the component)";
            end port_b_rec;
          public
            port_b_rec port_b;
            Modelica.SIunits.Temperature T
                                          "Average temperature of element";
            parameter Modelica.SIunits.Temperature T_start(fixed=false)
                                                                       "Start temperature for the average temperature of element";
            Modelica.SIunits.ThermalConductance G
                                                 "Thermal conductance of material";
            Modelica.SIunits.ThermalConductivity k
                                                  "Thermal conductivity";
            parameter Modelica.SIunits.Length L(fixed=false)
                                                            "length of conduction";
            parameter Modelica.SIunits.Area A(fixed=false)
                                                          "Heat transfer area";
          end thermalConductor_a_2_rec;
        public
          thermalConductor_a_2_rec thermalConductor_a_2;
        protected
          record thermalConductor_b_2_rec
            Modelica.SIunits.HeatFlowRate Q_flow
                                                "Heat flow rate from port_a -> port_b";
            Modelica.SIunits.TemperatureDifference dT
                                                     "port_a.T - port_b.T";
          protected
            record port_a_rec
              Modelica.SIunits.Temperature T
                                            "Port temperature";
              Modelica.SIunits.HeatFlowRate Q_flow
                                                  "Heat flow rate (positive if flowing from outside into the component)";
            end port_a_rec;
          public
            port_a_rec port_a;
          protected
            record port_b_rec
              Modelica.SIunits.Temperature T
                                            "Port temperature";
              Modelica.SIunits.HeatFlowRate Q_flow
                                                  "Heat flow rate (positive if flowing from outside into the component)";
            end port_b_rec;
          public
            port_b_rec port_b;
            Modelica.SIunits.Temperature T
                                          "Average temperature of element";
            parameter Modelica.SIunits.Temperature T_start(fixed=false)
                                                                       "Start temperature for the average temperature of element";
            Modelica.SIunits.ThermalConductance G
                                                 "Thermal conductance of material";
            Modelica.SIunits.ThermalConductivity k
                                                  "Thermal conductivity";
            parameter Modelica.SIunits.Length L(fixed=false)
                                                            "length of conduction";
            parameter Modelica.SIunits.Area A(fixed=false)
                                                          "Heat transfer area";
          end thermalConductor_b_2_rec;
        public
          thermalConductor_b_2_rec thermalConductor_b_2;
        protected
          record thermalConductor_a_3_rec
            constant Modelica.SIunits.HeatFlowRate Q_flow = 0.0
                                                               "Heat flow rate from port_a -> port_b";
            Modelica.SIunits.TemperatureDifference dT
                                                     "port_a.T - port_b.T";
          protected
            record port_a_rec
              Modelica.SIunits.Temperature T
                                            "Port temperature";
              constant Modelica.SIunits.HeatFlowRate Q_flow = 0.0
                                                                 "Heat flow rate (positive if flowing from outside into the component)";
            end port_a_rec;
          public
            port_a_rec port_a;
          protected
            record port_b_rec
              Modelica.SIunits.Temperature T
                                            "Port temperature";
              constant Modelica.SIunits.HeatFlowRate Q_flow = 0.0
                                                                 "Heat flow rate (positive if flowing from outside into the component)";
            end port_b_rec;
          public
            port_b_rec port_b;
            Modelica.SIunits.Temperature T
                                          "Average temperature of element";
            parameter Modelica.SIunits.Temperature T_start(fixed=false)
                                                                       "Start temperature for the average temperature of element";
            Modelica.SIunits.ThermalConductance G
                                                 "Thermal conductance of material";
            Modelica.SIunits.ThermalConductivity k
                                                  "Thermal conductivity";
            parameter Modelica.SIunits.Length L(fixed=false)
                                                            "length of conduction";
            parameter Modelica.SIunits.Area A(fixed=false)
                                                          "Heat transfer area";
          end thermalConductor_a_3_rec;
        public
          thermalConductor_a_3_rec thermalConductor_a_3;
        protected
          record thermalConductor_b_3_rec
            constant Modelica.SIunits.HeatFlowRate Q_flow = 0.0
                                                               "Heat flow rate from port_a -> port_b";
            Modelica.SIunits.TemperatureDifference dT
                                                     "port_a.T - port_b.T";
          protected
            record port_a_rec
              Modelica.SIunits.Temperature T
                                            "Port temperature";
              constant Modelica.SIunits.HeatFlowRate Q_flow = 0.0
                                                                 "Heat flow rate (positive if flowing from outside into the component)";
            end port_a_rec;
          public
            port_a_rec port_a;
          protected
            record port_b_rec
              Modelica.SIunits.Temperature T
                                            "Port temperature";
              constant Modelica.SIunits.HeatFlowRate Q_flow = 0.0
                                                                 "Heat flow rate (positive if flowing from outside into the component)";
            end port_b_rec;
          public
            port_b_rec port_b;
            Modelica.SIunits.Temperature T
                                          "Average temperature of element";
            parameter Modelica.SIunits.Temperature T_start(fixed=false)
                                                                       "Start temperature for the average temperature of element";
            Modelica.SIunits.ThermalConductance G
                                                 "Thermal conductance of material";
            Modelica.SIunits.ThermalConductivity k
                                                  "Thermal conductivity";
            parameter Modelica.SIunits.Length L(fixed=false)
                                                            "length of conduction";
            parameter Modelica.SIunits.Area A(fixed=false)
                                                          "Heat transfer area";
          end thermalConductor_b_3_rec;
        public
          thermalConductor_b_3_rec thermalConductor_b_3;
        protected
          record heatCapacitor_rec
            Modelica.SIunits.Temperature T
                                          "Temperature of element";
            Real T_der(unit = "K/s")
                                    "der(Temperature of element)";
            Modelica.SIunits.HeatFlowRate Q_flow;
            parameter Modelica.SIunits.Temperature T_start(fixed=false)
                                                                       "Start temperature for the average temperature of ellement";
          protected
            record port_rec
              Modelica.SIunits.Temperature T
                                            "Port temperature";
              Modelica.SIunits.HeatFlowRate Q_flow
                                                  "Heat flow rate (positive if flowing from outside into the component)";
            end port_rec;
          public
            port_rec port;
            parameter Modelica.SIunits.Volume V(fixed=false)
                                                            "Volume of element";
            parameter Modelica.SIunits.Mass m(fixed=false)
                                                          "Mass of element";
            Modelica.SIunits.TemperatureSlope der_T
                                                   "Time derivative of temperature (= der(T))";
            Modelica.SIunits.HeatCapacity C
                                           "Heat capacity of element (= cp*m)";
            parameter Modelica.SIunits.TemperatureSlope der_T_start(fixed=false)
                                                                                "Start value ofime derivative of temperature (= der(T))";
          end heatCapacitor_rec;
        public
          heatCapacitor_rec heatCapacitor;
        protected
          record port_int_rec
            Modelica.SIunits.Temperature T
                                          "Port temperature";
            constant Modelica.SIunits.HeatFlowRate Q_flow = 0.0
                                                               "Heat flow rate (positive if flowing from outside into the component)";
          end port_int_rec;
        public
          port_int_rec port_int;
        end 'thermalNode[1, 2, 1]_rec';
      public
        'thermalNode[1, 2, 1]_rec' 'thermalNode[1, 2, 1]' annotation(Dialog);
      protected
        record 'thermalNode[1, 3, 1]_rec'
          parameter Real nParallel(min = 1.0) = 1
                                                 "Number of identical parallel elements";
          constant Boolean use_portDim1 = true
                                              "Heat tranfer in 1st dimention";
          constant Boolean use_portDim2 = true
                                              "Heat tranfer in 2nd dimention";
          constant Boolean use_portDim3 = false
                                               "Heat tranfer in 3rd dimention";
        protected
          record port_a_1_rec
            Modelica.SIunits.Temperature T
                                          "Port temperature";
            Modelica.SIunits.HeatFlowRate Q_flow
                                                "Heat flow rate (positive if flowing from outside into the component)";
          end port_a_1_rec;
        public
          port_a_1_rec port_a_1;
        protected
          record port_b_1_rec
            Modelica.SIunits.Temperature T
                                          "Port temperature";
            Modelica.SIunits.HeatFlowRate Q_flow
                                                "Heat flow rate (positive if flowing from outside into the component)";
          end port_b_1_rec;
        public
          port_b_1_rec port_b_1;
        protected
          record port_a_2_rec
            Modelica.SIunits.Temperature T
                                          "Port temperature";
            Modelica.SIunits.HeatFlowRate Q_flow
                                                "Heat flow rate (positive if flowing from outside into the component)";
          end port_a_2_rec;
        public
          port_a_2_rec port_a_2;
        protected
          record port_b_2_rec
            Modelica.SIunits.Temperature T
                                          "Port temperature";
            Modelica.SIunits.HeatFlowRate Q_flow
                                                "Heat flow rate (positive if flowing from outside into the component)";
          end port_b_2_rec;
        public
          port_b_2_rec port_b_2;
          parameter Modelica.SIunits.Volume V(fixed=false)
                                                          "Volume of material";
        protected
          record thermalConductor_a_1_rec
            Modelica.SIunits.HeatFlowRate Q_flow
                                                "Heat flow rate from port_a -> port_b";
            Modelica.SIunits.TemperatureDifference dT
                                                     "port_a.T - port_b.T";
          protected
            record port_a_rec
              Modelica.SIunits.Temperature T
                                            "Port temperature";
              Modelica.SIunits.HeatFlowRate Q_flow
                                                  "Heat flow rate (positive if flowing from outside into the component)";
            end port_a_rec;
          public
            port_a_rec port_a;
          protected
            record port_b_rec
              Modelica.SIunits.Temperature T
                                            "Port temperature";
              Modelica.SIunits.HeatFlowRate Q_flow
                                                  "Heat flow rate (positive if flowing from outside into the component)";
            end port_b_rec;
          public
            port_b_rec port_b;
            Modelica.SIunits.Temperature T
                                          "Average temperature of element";
            parameter Modelica.SIunits.Temperature T_start(fixed=false)
                                                                       "Start temperature for the average temperature of element";
            Modelica.SIunits.ThermalConductance G
                                                 "Thermal conductance of material";
            Modelica.SIunits.ThermalConductivity k
                                                  "Thermal conductivity";
            parameter Modelica.SIunits.Length r_internal(fixed=false)
                                                                     "Inner radius of cylinder";
            parameter Modelica.SIunits.Length r_external(fixed=false)
                                                                     "Outer radius of cylinder";
            parameter Modelica.SIunits.Length L(fixed=false)
                                                            "Length of cylinder";
            parameter Modelica.SIunits.Angle alpha(fixed=false)
                                                               "Swept angle";
          end thermalConductor_a_1_rec;
        public
          thermalConductor_a_1_rec thermalConductor_a_1;
        protected
          record thermalConductor_b_1_rec
            Modelica.SIunits.HeatFlowRate Q_flow
                                                "Heat flow rate from port_a -> port_b";
            Modelica.SIunits.TemperatureDifference dT
                                                     "port_a.T - port_b.T";
          protected
            record port_a_rec
              Modelica.SIunits.Temperature T
                                            "Port temperature";
              Modelica.SIunits.HeatFlowRate Q_flow
                                                  "Heat flow rate (positive if flowing from outside into the component)";
            end port_a_rec;
          public
            port_a_rec port_a;
          protected
            record port_b_rec
              Modelica.SIunits.Temperature T
                                            "Port temperature";
              Modelica.SIunits.HeatFlowRate Q_flow
                                                  "Heat flow rate (positive if flowing from outside into the component)";
            end port_b_rec;
          public
            port_b_rec port_b;
            Modelica.SIunits.Temperature T
                                          "Average temperature of element";
            parameter Modelica.SIunits.Temperature T_start(fixed=false)
                                                                       "Start temperature for the average temperature of element";
            Modelica.SIunits.ThermalConductance G
                                                 "Thermal conductance of material";
            Modelica.SIunits.ThermalConductivity k
                                                  "Thermal conductivity";
            parameter Modelica.SIunits.Length r_internal(fixed=false)
                                                                     "Inner radius of cylinder";
            parameter Modelica.SIunits.Length r_external(fixed=false)
                                                                     "Outer radius of cylinder";
            parameter Modelica.SIunits.Length L(fixed=false)
                                                            "Length of cylinder";
            parameter Modelica.SIunits.Angle alpha(fixed=false)
                                                               "Swept angle";
          end thermalConductor_b_1_rec;
        public
          thermalConductor_b_1_rec thermalConductor_b_1;
        protected
          record thermalConductor_a_2_rec
            Modelica.SIunits.HeatFlowRate Q_flow
                                                "Heat flow rate from port_a -> port_b";
            Modelica.SIunits.TemperatureDifference dT
                                                     "port_a.T - port_b.T";
          protected
            record port_a_rec
              Modelica.SIunits.Temperature T
                                            "Port temperature";
              Modelica.SIunits.HeatFlowRate Q_flow
                                                  "Heat flow rate (positive if flowing from outside into the component)";
            end port_a_rec;
          public
            port_a_rec port_a;
          protected
            record port_b_rec
              Modelica.SIunits.Temperature T
                                            "Port temperature";
              Modelica.SIunits.HeatFlowRate Q_flow
                                                  "Heat flow rate (positive if flowing from outside into the component)";
            end port_b_rec;
          public
            port_b_rec port_b;
            Modelica.SIunits.Temperature T
                                          "Average temperature of element";
            parameter Modelica.SIunits.Temperature T_start(fixed=false)
                                                                       "Start temperature for the average temperature of element";
            Modelica.SIunits.ThermalConductance G
                                                 "Thermal conductance of material";
            Modelica.SIunits.ThermalConductivity k
                                                  "Thermal conductivity";
            parameter Modelica.SIunits.Length L(fixed=false)
                                                            "length of conduction";
            parameter Modelica.SIunits.Area A(fixed=false)
                                                          "Heat transfer area";
          end thermalConductor_a_2_rec;
        public
          thermalConductor_a_2_rec thermalConductor_a_2;
        protected
          record thermalConductor_b_2_rec
            Modelica.SIunits.HeatFlowRate Q_flow
                                                "Heat flow rate from port_a -> port_b";
            Modelica.SIunits.TemperatureDifference dT
                                                     "port_a.T - port_b.T";
          protected
            record port_a_rec
              Modelica.SIunits.Temperature T
                                            "Port temperature";
              Modelica.SIunits.HeatFlowRate Q_flow
                                                  "Heat flow rate (positive if flowing from outside into the component)";
            end port_a_rec;
          public
            port_a_rec port_a;
          protected
            record port_b_rec
              Modelica.SIunits.Temperature T
                                            "Port temperature";
              Modelica.SIunits.HeatFlowRate Q_flow
                                                  "Heat flow rate (positive if flowing from outside into the component)";
            end port_b_rec;
          public
            port_b_rec port_b;
            Modelica.SIunits.Temperature T
                                          "Average temperature of element";
            parameter Modelica.SIunits.Temperature T_start(fixed=false)
                                                                       "Start temperature for the average temperature of element";
            Modelica.SIunits.ThermalConductance G
                                                 "Thermal conductance of material";
            Modelica.SIunits.ThermalConductivity k
                                                  "Thermal conductivity";
            parameter Modelica.SIunits.Length L(fixed=false)
                                                            "length of conduction";
            parameter Modelica.SIunits.Area A(fixed=false)
                                                          "Heat transfer area";
          end thermalConductor_b_2_rec;
        public
          thermalConductor_b_2_rec thermalConductor_b_2;
        protected
          record thermalConductor_a_3_rec
            constant Modelica.SIunits.HeatFlowRate Q_flow = 0.0
                                                               "Heat flow rate from port_a -> port_b";
            Modelica.SIunits.TemperatureDifference dT
                                                     "port_a.T - port_b.T";
          protected
            record port_a_rec
              Modelica.SIunits.Temperature T
                                            "Port temperature";
              constant Modelica.SIunits.HeatFlowRate Q_flow = 0.0
                                                                 "Heat flow rate (positive if flowing from outside into the component)";
            end port_a_rec;
          public
            port_a_rec port_a;
          protected
            record port_b_rec
              Modelica.SIunits.Temperature T
                                            "Port temperature";
              constant Modelica.SIunits.HeatFlowRate Q_flow = 0.0
                                                                 "Heat flow rate (positive if flowing from outside into the component)";
            end port_b_rec;
          public
            port_b_rec port_b;
            Modelica.SIunits.Temperature T
                                          "Average temperature of element";
            parameter Modelica.SIunits.Temperature T_start(fixed=false)
                                                                       "Start temperature for the average temperature of element";
            Modelica.SIunits.ThermalConductance G
                                                 "Thermal conductance of material";
            Modelica.SIunits.ThermalConductivity k
                                                  "Thermal conductivity";
            parameter Modelica.SIunits.Length L(fixed=false)
                                                            "length of conduction";
            parameter Modelica.SIunits.Area A(fixed=false)
                                                          "Heat transfer area";
          end thermalConductor_a_3_rec;
        public
          thermalConductor_a_3_rec thermalConductor_a_3;
        protected
          record thermalConductor_b_3_rec
            constant Modelica.SIunits.HeatFlowRate Q_flow = 0.0
                                                               "Heat flow rate from port_a -> port_b";
            Modelica.SIunits.TemperatureDifference dT
                                                     "port_a.T - port_b.T";
          protected
            record port_a_rec
              Modelica.SIunits.Temperature T
                                            "Port temperature";
              constant Modelica.SIunits.HeatFlowRate Q_flow = 0.0
                                                                 "Heat flow rate (positive if flowing from outside into the component)";
            end port_a_rec;
          public
            port_a_rec port_a;
          protected
            record port_b_rec
              Modelica.SIunits.Temperature T
                                            "Port temperature";
              constant Modelica.SIunits.HeatFlowRate Q_flow = 0.0
                                                                 "Heat flow rate (positive if flowing from outside into the component)";
            end port_b_rec;
          public
            port_b_rec port_b;
            Modelica.SIunits.Temperature T
                                          "Average temperature of element";
            parameter Modelica.SIunits.Temperature T_start(fixed=false)
                                                                       "Start temperature for the average temperature of element";
            Modelica.SIunits.ThermalConductance G
                                                 "Thermal conductance of material";
            Modelica.SIunits.ThermalConductivity k
                                                  "Thermal conductivity";
            parameter Modelica.SIunits.Length L(fixed=false)
                                                            "length of conduction";
            parameter Modelica.SIunits.Area A(fixed=false)
                                                          "Heat transfer area";
          end thermalConductor_b_3_rec;
        public
          thermalConductor_b_3_rec thermalConductor_b_3;
        protected
          record heatCapacitor_rec
            Modelica.SIunits.Temperature T
                                          "Temperature of element";
            Real T_der(unit = "K/s")
                                    "der(Temperature of element)";
            Modelica.SIunits.HeatFlowRate Q_flow;
            parameter Modelica.SIunits.Temperature T_start(fixed=false)
                                                                       "Start temperature for the average temperature of ellement";
          protected
            record port_rec
              Modelica.SIunits.Temperature T
                                            "Port temperature";
              Modelica.SIunits.HeatFlowRate Q_flow
                                                  "Heat flow rate (positive if flowing from outside into the component)";
            end port_rec;
          public
            port_rec port;
            parameter Modelica.SIunits.Volume V(fixed=false)
                                                            "Volume of element";
            parameter Modelica.SIunits.Mass m(fixed=false)
                                                          "Mass of element";
            Modelica.SIunits.TemperatureSlope der_T
                                                   "Time derivative of temperature (= der(T))";
            Modelica.SIunits.HeatCapacity C
                                           "Heat capacity of element (= cp*m)";
            parameter Modelica.SIunits.TemperatureSlope der_T_start(fixed=false)
                                                                                "Start value ofime derivative of temperature (= der(T))";
          end heatCapacitor_rec;
        public
          heatCapacitor_rec heatCapacitor;
        protected
          record port_int_rec
            Modelica.SIunits.Temperature T
                                          "Port temperature";
            constant Modelica.SIunits.HeatFlowRate Q_flow = 0.0
                                                               "Heat flow rate (positive if flowing from outside into the component)";
          end port_int_rec;
        public
          port_int_rec port_int;
        end 'thermalNode[1, 3, 1]_rec';
      public
        'thermalNode[1, 3, 1]_rec' 'thermalNode[1, 3, 1]' annotation(Dialog);
      protected
        record 'thermalNode[1, 4, 1]_rec'
          parameter Real nParallel(min = 1.0) = 1
                                                 "Number of identical parallel elements";
          constant Boolean use_portDim1 = true
                                              "Heat tranfer in 1st dimention";
          constant Boolean use_portDim2 = true
                                              "Heat tranfer in 2nd dimention";
          constant Boolean use_portDim3 = false
                                               "Heat tranfer in 3rd dimention";
        protected
          record port_a_1_rec
            Modelica.SIunits.Temperature T
                                          "Port temperature";
            Modelica.SIunits.HeatFlowRate Q_flow
                                                "Heat flow rate (positive if flowing from outside into the component)";
          end port_a_1_rec;
        public
          port_a_1_rec port_a_1;
        protected
          record port_b_1_rec
            Modelica.SIunits.Temperature T
                                          "Port temperature";
            Modelica.SIunits.HeatFlowRate Q_flow
                                                "Heat flow rate (positive if flowing from outside into the component)";
          end port_b_1_rec;
        public
          port_b_1_rec port_b_1;
        protected
          record port_a_2_rec
            Modelica.SIunits.Temperature T
                                          "Port temperature";
            Modelica.SIunits.HeatFlowRate Q_flow
                                                "Heat flow rate (positive if flowing from outside into the component)";
          end port_a_2_rec;
        public
          port_a_2_rec port_a_2;
        protected
          record port_b_2_rec
            Modelica.SIunits.Temperature T
                                          "Port temperature";
            Modelica.SIunits.HeatFlowRate Q_flow
                                                "Heat flow rate (positive if flowing from outside into the component)";
          end port_b_2_rec;
        public
          port_b_2_rec port_b_2;
          parameter Modelica.SIunits.Volume V(fixed=false)
                                                          "Volume of material";
        protected
          record thermalConductor_a_1_rec
            Modelica.SIunits.HeatFlowRate Q_flow
                                                "Heat flow rate from port_a -> port_b";
            Modelica.SIunits.TemperatureDifference dT
                                                     "port_a.T - port_b.T";
          protected
            record port_a_rec
              Modelica.SIunits.Temperature T
                                            "Port temperature";
              Modelica.SIunits.HeatFlowRate Q_flow
                                                  "Heat flow rate (positive if flowing from outside into the component)";
            end port_a_rec;
          public
            port_a_rec port_a;
          protected
            record port_b_rec
              Modelica.SIunits.Temperature T
                                            "Port temperature";
              Modelica.SIunits.HeatFlowRate Q_flow
                                                  "Heat flow rate (positive if flowing from outside into the component)";
            end port_b_rec;
          public
            port_b_rec port_b;
            Modelica.SIunits.Temperature T
                                          "Average temperature of element";
            parameter Modelica.SIunits.Temperature T_start(fixed=false)
                                                                       "Start temperature for the average temperature of element";
            Modelica.SIunits.ThermalConductance G
                                                 "Thermal conductance of material";
            Modelica.SIunits.ThermalConductivity k
                                                  "Thermal conductivity";
            parameter Modelica.SIunits.Length r_internal(fixed=false)
                                                                     "Inner radius of cylinder";
            parameter Modelica.SIunits.Length r_external(fixed=false)
                                                                     "Outer radius of cylinder";
            parameter Modelica.SIunits.Length L(fixed=false)
                                                            "Length of cylinder";
            parameter Modelica.SIunits.Angle alpha(fixed=false)
                                                               "Swept angle";
          end thermalConductor_a_1_rec;
        public
          thermalConductor_a_1_rec thermalConductor_a_1;
        protected
          record thermalConductor_b_1_rec
            Modelica.SIunits.HeatFlowRate Q_flow
                                                "Heat flow rate from port_a -> port_b";
            Modelica.SIunits.TemperatureDifference dT
                                                     "port_a.T - port_b.T";
          protected
            record port_a_rec
              Modelica.SIunits.Temperature T
                                            "Port temperature";
              Modelica.SIunits.HeatFlowRate Q_flow
                                                  "Heat flow rate (positive if flowing from outside into the component)";
            end port_a_rec;
          public
            port_a_rec port_a;
          protected
            record port_b_rec
              Modelica.SIunits.Temperature T
                                            "Port temperature";
              Modelica.SIunits.HeatFlowRate Q_flow
                                                  "Heat flow rate (positive if flowing from outside into the component)";
            end port_b_rec;
          public
            port_b_rec port_b;
            Modelica.SIunits.Temperature T
                                          "Average temperature of element";
            parameter Modelica.SIunits.Temperature T_start(fixed=false)
                                                                       "Start temperature for the average temperature of element";
            Modelica.SIunits.ThermalConductance G
                                                 "Thermal conductance of material";
            Modelica.SIunits.ThermalConductivity k
                                                  "Thermal conductivity";
            parameter Modelica.SIunits.Length r_internal(fixed=false)
                                                                     "Inner radius of cylinder";
            parameter Modelica.SIunits.Length r_external(fixed=false)
                                                                     "Outer radius of cylinder";
            parameter Modelica.SIunits.Length L(fixed=false)
                                                            "Length of cylinder";
            parameter Modelica.SIunits.Angle alpha(fixed=false)
                                                               "Swept angle";
          end thermalConductor_b_1_rec;
        public
          thermalConductor_b_1_rec thermalConductor_b_1;
        protected
          record thermalConductor_a_2_rec
            Modelica.SIunits.HeatFlowRate Q_flow
                                                "Heat flow rate from port_a -> port_b";
            Modelica.SIunits.TemperatureDifference dT
                                                     "port_a.T - port_b.T";
          protected
            record port_a_rec
              Modelica.SIunits.Temperature T
                                            "Port temperature";
              Modelica.SIunits.HeatFlowRate Q_flow
                                                  "Heat flow rate (positive if flowing from outside into the component)";
            end port_a_rec;
          public
            port_a_rec port_a;
          protected
            record port_b_rec
              Modelica.SIunits.Temperature T
                                            "Port temperature";
              Modelica.SIunits.HeatFlowRate Q_flow
                                                  "Heat flow rate (positive if flowing from outside into the component)";
            end port_b_rec;
          public
            port_b_rec port_b;
            Modelica.SIunits.Temperature T
                                          "Average temperature of element";
            parameter Modelica.SIunits.Temperature T_start(fixed=false)
                                                                       "Start temperature for the average temperature of element";
            Modelica.SIunits.ThermalConductance G
                                                 "Thermal conductance of material";
            Modelica.SIunits.ThermalConductivity k
                                                  "Thermal conductivity";
            parameter Modelica.SIunits.Length L(fixed=false)
                                                            "length of conduction";
            parameter Modelica.SIunits.Area A(fixed=false)
                                                          "Heat transfer area";
          end thermalConductor_a_2_rec;
        public
          thermalConductor_a_2_rec thermalConductor_a_2;
        protected
          record thermalConductor_b_2_rec
            Modelica.SIunits.HeatFlowRate Q_flow
                                                "Heat flow rate from port_a -> port_b";
            Modelica.SIunits.TemperatureDifference dT
                                                     "port_a.T - port_b.T";
          protected
            record port_a_rec
              Modelica.SIunits.Temperature T
                                            "Port temperature";
              Modelica.SIunits.HeatFlowRate Q_flow
                                                  "Heat flow rate (positive if flowing from outside into the component)";
            end port_a_rec;
          public
            port_a_rec port_a;
          protected
            record port_b_rec
              Modelica.SIunits.Temperature T
                                            "Port temperature";
              Modelica.SIunits.HeatFlowRate Q_flow
                                                  "Heat flow rate (positive if flowing from outside into the component)";
            end port_b_rec;
          public
            port_b_rec port_b;
            Modelica.SIunits.Temperature T
                                          "Average temperature of element";
            parameter Modelica.SIunits.Temperature T_start(fixed=false)
                                                                       "Start temperature for the average temperature of element";
            Modelica.SIunits.ThermalConductance G
                                                 "Thermal conductance of material";
            Modelica.SIunits.ThermalConductivity k
                                                  "Thermal conductivity";
            parameter Modelica.SIunits.Length L(fixed=false)
                                                            "length of conduction";
            parameter Modelica.SIunits.Area A(fixed=false)
                                                          "Heat transfer area";
          end thermalConductor_b_2_rec;
        public
          thermalConductor_b_2_rec thermalConductor_b_2;
        protected
          record thermalConductor_a_3_rec
            constant Modelica.SIunits.HeatFlowRate Q_flow = 0.0
                                                               "Heat flow rate from port_a -> port_b";
            Modelica.SIunits.TemperatureDifference dT
                                                     "port_a.T - port_b.T";
          protected
            record port_a_rec
              Modelica.SIunits.Temperature T
                                            "Port temperature";
              constant Modelica.SIunits.HeatFlowRate Q_flow = 0.0
                                                                 "Heat flow rate (positive if flowing from outside into the component)";
            end port_a_rec;
          public
            port_a_rec port_a;
          protected
            record port_b_rec
              Modelica.SIunits.Temperature T
                                            "Port temperature";
              constant Modelica.SIunits.HeatFlowRate Q_flow = 0.0
                                                                 "Heat flow rate (positive if flowing from outside into the component)";
            end port_b_rec;
          public
            port_b_rec port_b;
            Modelica.SIunits.Temperature T
                                          "Average temperature of element";
            parameter Modelica.SIunits.Temperature T_start(fixed=false)
                                                                       "Start temperature for the average temperature of element";
            Modelica.SIunits.ThermalConductance G
                                                 "Thermal conductance of material";
            Modelica.SIunits.ThermalConductivity k
                                                  "Thermal conductivity";
            parameter Modelica.SIunits.Length L(fixed=false)
                                                            "length of conduction";
            parameter Modelica.SIunits.Area A(fixed=false)
                                                          "Heat transfer area";
          end thermalConductor_a_3_rec;
        public
          thermalConductor_a_3_rec thermalConductor_a_3;
        protected
          record thermalConductor_b_3_rec
            constant Modelica.SIunits.HeatFlowRate Q_flow = 0.0
                                                               "Heat flow rate from port_a -> port_b";
            Modelica.SIunits.TemperatureDifference dT
                                                     "port_a.T - port_b.T";
          protected
            record port_a_rec
              Modelica.SIunits.Temperature T
                                            "Port temperature";
              constant Modelica.SIunits.HeatFlowRate Q_flow = 0.0
                                                                 "Heat flow rate (positive if flowing from outside into the component)";
            end port_a_rec;
          public
            port_a_rec port_a;
          protected
            record port_b_rec
              Modelica.SIunits.Temperature T
                                            "Port temperature";
              constant Modelica.SIunits.HeatFlowRate Q_flow = 0.0
                                                                 "Heat flow rate (positive if flowing from outside into the component)";
            end port_b_rec;
          public
            port_b_rec port_b;
            Modelica.SIunits.Temperature T
                                          "Average temperature of element";
            parameter Modelica.SIunits.Temperature T_start(fixed=false)
                                                                       "Start temperature for the average temperature of element";
            Modelica.SIunits.ThermalConductance G
                                                 "Thermal conductance of material";
            Modelica.SIunits.ThermalConductivity k
                                                  "Thermal conductivity";
            parameter Modelica.SIunits.Length L(fixed=false)
                                                            "length of conduction";
            parameter Modelica.SIunits.Area A(fixed=false)
                                                          "Heat transfer area";
          end thermalConductor_b_3_rec;
        public
          thermalConductor_b_3_rec thermalConductor_b_3;
        protected
          record heatCapacitor_rec
            Modelica.SIunits.Temperature T
                                          "Temperature of element";
            Real T_der(unit = "K/s")
                                    "der(Temperature of element)";
            Modelica.SIunits.HeatFlowRate Q_flow;
            parameter Modelica.SIunits.Temperature T_start(fixed=false)
                                                                       "Start temperature for the average temperature of ellement";
          protected
            record port_rec
              Modelica.SIunits.Temperature T
                                            "Port temperature";
              Modelica.SIunits.HeatFlowRate Q_flow
                                                  "Heat flow rate (positive if flowing from outside into the component)";
            end port_rec;
          public
            port_rec port;
            parameter Modelica.SIunits.Volume V(fixed=false)
                                                            "Volume of element";
            parameter Modelica.SIunits.Mass m(fixed=false)
                                                          "Mass of element";
            Modelica.SIunits.TemperatureSlope der_T
                                                   "Time derivative of temperature (= der(T))";
            Modelica.SIunits.HeatCapacity C
                                           "Heat capacity of element (= cp*m)";
            parameter Modelica.SIunits.TemperatureSlope der_T_start(fixed=false)
                                                                                "Start value ofime derivative of temperature (= der(T))";
          end heatCapacitor_rec;
        public
          heatCapacitor_rec heatCapacitor;
        protected
          record port_int_rec
            Modelica.SIunits.Temperature T
                                          "Port temperature";
            constant Modelica.SIunits.HeatFlowRate Q_flow = 0.0
                                                               "Heat flow rate (positive if flowing from outside into the component)";
          end port_int_rec;
        public
          port_int_rec port_int;
        end 'thermalNode[1, 4, 1]_rec';
      public
        'thermalNode[1, 4, 1]_rec' 'thermalNode[1, 4, 1]' annotation(Dialog);
      protected
        record 'thermalNode[1, 5, 1]_rec'
          parameter Real nParallel(min = 1.0) = 1
                                                 "Number of identical parallel elements";
          constant Boolean use_portDim1 = true
                                              "Heat tranfer in 1st dimention";
          constant Boolean use_portDim2 = true
                                              "Heat tranfer in 2nd dimention";
          constant Boolean use_portDim3 = false
                                               "Heat tranfer in 3rd dimention";
        protected
          record port_a_1_rec
            Modelica.SIunits.Temperature T
                                          "Port temperature";
            Modelica.SIunits.HeatFlowRate Q_flow
                                                "Heat flow rate (positive if flowing from outside into the component)";
          end port_a_1_rec;
        public
          port_a_1_rec port_a_1;
        protected
          record port_b_1_rec
            Modelica.SIunits.Temperature T
                                          "Port temperature";
            Modelica.SIunits.HeatFlowRate Q_flow
                                                "Heat flow rate (positive if flowing from outside into the component)";
          end port_b_1_rec;
        public
          port_b_1_rec port_b_1;
        protected
          record port_a_2_rec
            Modelica.SIunits.Temperature T
                                          "Port temperature";
            Modelica.SIunits.HeatFlowRate Q_flow
                                                "Heat flow rate (positive if flowing from outside into the component)";
          end port_a_2_rec;
        public
          port_a_2_rec port_a_2;
        protected
          record port_b_2_rec
            Modelica.SIunits.Temperature T
                                          "Port temperature";
            Modelica.SIunits.HeatFlowRate Q_flow
                                                "Heat flow rate (positive if flowing from outside into the component)";
          end port_b_2_rec;
        public
          port_b_2_rec port_b_2;
          parameter Modelica.SIunits.Volume V(fixed=false)
                                                          "Volume of material";
        protected
          record thermalConductor_a_1_rec
            Modelica.SIunits.HeatFlowRate Q_flow
                                                "Heat flow rate from port_a -> port_b";
            Modelica.SIunits.TemperatureDifference dT
                                                     "port_a.T - port_b.T";
          protected
            record port_a_rec
              Modelica.SIunits.Temperature T
                                            "Port temperature";
              Modelica.SIunits.HeatFlowRate Q_flow
                                                  "Heat flow rate (positive if flowing from outside into the component)";
            end port_a_rec;
          public
            port_a_rec port_a;
          protected
            record port_b_rec
              Modelica.SIunits.Temperature T
                                            "Port temperature";
              Modelica.SIunits.HeatFlowRate Q_flow
                                                  "Heat flow rate (positive if flowing from outside into the component)";
            end port_b_rec;
          public
            port_b_rec port_b;
            Modelica.SIunits.Temperature T
                                          "Average temperature of element";
            parameter Modelica.SIunits.Temperature T_start(fixed=false)
                                                                       "Start temperature for the average temperature of element";
            Modelica.SIunits.ThermalConductance G
                                                 "Thermal conductance of material";
            Modelica.SIunits.ThermalConductivity k
                                                  "Thermal conductivity";
            parameter Modelica.SIunits.Length r_internal(fixed=false)
                                                                     "Inner radius of cylinder";
            parameter Modelica.SIunits.Length r_external(fixed=false)
                                                                     "Outer radius of cylinder";
            parameter Modelica.SIunits.Length L(fixed=false)
                                                            "Length of cylinder";
            parameter Modelica.SIunits.Angle alpha(fixed=false)
                                                               "Swept angle";
          end thermalConductor_a_1_rec;
        public
          thermalConductor_a_1_rec thermalConductor_a_1;
        protected
          record thermalConductor_b_1_rec
            Modelica.SIunits.HeatFlowRate Q_flow
                                                "Heat flow rate from port_a -> port_b";
            Modelica.SIunits.TemperatureDifference dT
                                                     "port_a.T - port_b.T";
          protected
            record port_a_rec
              Modelica.SIunits.Temperature T
                                            "Port temperature";
              Modelica.SIunits.HeatFlowRate Q_flow
                                                  "Heat flow rate (positive if flowing from outside into the component)";
            end port_a_rec;
          public
            port_a_rec port_a;
          protected
            record port_b_rec
              Modelica.SIunits.Temperature T
                                            "Port temperature";
              Modelica.SIunits.HeatFlowRate Q_flow
                                                  "Heat flow rate (positive if flowing from outside into the component)";
            end port_b_rec;
          public
            port_b_rec port_b;
            Modelica.SIunits.Temperature T
                                          "Average temperature of element";
            parameter Modelica.SIunits.Temperature T_start(fixed=false)
                                                                       "Start temperature for the average temperature of element";
            Modelica.SIunits.ThermalConductance G
                                                 "Thermal conductance of material";
            Modelica.SIunits.ThermalConductivity k
                                                  "Thermal conductivity";
            parameter Modelica.SIunits.Length r_internal(fixed=false)
                                                                     "Inner radius of cylinder";
            parameter Modelica.SIunits.Length r_external(fixed=false)
                                                                     "Outer radius of cylinder";
            parameter Modelica.SIunits.Length L(fixed=false)
                                                            "Length of cylinder";
            parameter Modelica.SIunits.Angle alpha(fixed=false)
                                                               "Swept angle";
          end thermalConductor_b_1_rec;
        public
          thermalConductor_b_1_rec thermalConductor_b_1;
        protected
          record thermalConductor_a_2_rec
            Modelica.SIunits.HeatFlowRate Q_flow
                                                "Heat flow rate from port_a -> port_b";
            Modelica.SIunits.TemperatureDifference dT
                                                     "port_a.T - port_b.T";
          protected
            record port_a_rec
              Modelica.SIunits.Temperature T
                                            "Port temperature";
              Modelica.SIunits.HeatFlowRate Q_flow
                                                  "Heat flow rate (positive if flowing from outside into the component)";
            end port_a_rec;
          public
            port_a_rec port_a;
          protected
            record port_b_rec
              Modelica.SIunits.Temperature T
                                            "Port temperature";
              Modelica.SIunits.HeatFlowRate Q_flow
                                                  "Heat flow rate (positive if flowing from outside into the component)";
            end port_b_rec;
          public
            port_b_rec port_b;
            Modelica.SIunits.Temperature T
                                          "Average temperature of element";
            parameter Modelica.SIunits.Temperature T_start(fixed=false)
                                                                       "Start temperature for the average temperature of element";
            Modelica.SIunits.ThermalConductance G
                                                 "Thermal conductance of material";
            Modelica.SIunits.ThermalConductivity k
                                                  "Thermal conductivity";
            parameter Modelica.SIunits.Length L(fixed=false)
                                                            "length of conduction";
            parameter Modelica.SIunits.Area A(fixed=false)
                                                          "Heat transfer area";
          end thermalConductor_a_2_rec;
        public
          thermalConductor_a_2_rec thermalConductor_a_2;
        protected
          record thermalConductor_b_2_rec
            Modelica.SIunits.HeatFlowRate Q_flow
                                                "Heat flow rate from port_a -> port_b";
            Modelica.SIunits.TemperatureDifference dT
                                                     "port_a.T - port_b.T";
          protected
            record port_a_rec
              Modelica.SIunits.Temperature T
                                            "Port temperature";
              Modelica.SIunits.HeatFlowRate Q_flow
                                                  "Heat flow rate (positive if flowing from outside into the component)";
            end port_a_rec;
          public
            port_a_rec port_a;
          protected
            record port_b_rec
              Modelica.SIunits.Temperature T
                                            "Port temperature";
              Modelica.SIunits.HeatFlowRate Q_flow
                                                  "Heat flow rate (positive if flowing from outside into the component)";
            end port_b_rec;
          public
            port_b_rec port_b;
            Modelica.SIunits.Temperature T
                                          "Average temperature of element";
            parameter Modelica.SIunits.Temperature T_start(fixed=false)
                                                                       "Start temperature for the average temperature of element";
            Modelica.SIunits.ThermalConductance G
                                                 "Thermal conductance of material";
            Modelica.SIunits.ThermalConductivity k
                                                  "Thermal conductivity";
            parameter Modelica.SIunits.Length L(fixed=false)
                                                            "length of conduction";
            parameter Modelica.SIunits.Area A(fixed=false)
                                                          "Heat transfer area";
          end thermalConductor_b_2_rec;
        public
          thermalConductor_b_2_rec thermalConductor_b_2;
        protected
          record thermalConductor_a_3_rec
            constant Modelica.SIunits.HeatFlowRate Q_flow = 0.0
                                                               "Heat flow rate from port_a -> port_b";
            Modelica.SIunits.TemperatureDifference dT
                                                     "port_a.T - port_b.T";
          protected
            record port_a_rec
              Modelica.SIunits.Temperature T
                                            "Port temperature";
              constant Modelica.SIunits.HeatFlowRate Q_flow = 0.0
                                                                 "Heat flow rate (positive if flowing from outside into the component)";
            end port_a_rec;
          public
            port_a_rec port_a;
          protected
            record port_b_rec
              Modelica.SIunits.Temperature T
                                            "Port temperature";
              constant Modelica.SIunits.HeatFlowRate Q_flow = 0.0
                                                                 "Heat flow rate (positive if flowing from outside into the component)";
            end port_b_rec;
          public
            port_b_rec port_b;
            Modelica.SIunits.Temperature T
                                          "Average temperature of element";
            parameter Modelica.SIunits.Temperature T_start(fixed=false)
                                                                       "Start temperature for the average temperature of element";
            Modelica.SIunits.ThermalConductance G
                                                 "Thermal conductance of material";
            Modelica.SIunits.ThermalConductivity k
                                                  "Thermal conductivity";
            parameter Modelica.SIunits.Length L(fixed=false)
                                                            "length of conduction";
            parameter Modelica.SIunits.Area A(fixed=false)
                                                          "Heat transfer area";
          end thermalConductor_a_3_rec;
        public
          thermalConductor_a_3_rec thermalConductor_a_3;
        protected
          record thermalConductor_b_3_rec
            constant Modelica.SIunits.HeatFlowRate Q_flow = 0.0
                                                               "Heat flow rate from port_a -> port_b";
            Modelica.SIunits.TemperatureDifference dT
                                                     "port_a.T - port_b.T";
          protected
            record port_a_rec
              Modelica.SIunits.Temperature T
                                            "Port temperature";
              constant Modelica.SIunits.HeatFlowRate Q_flow = 0.0
                                                                 "Heat flow rate (positive if flowing from outside into the component)";
            end port_a_rec;
          public
            port_a_rec port_a;
          protected
            record port_b_rec
              Modelica.SIunits.Temperature T
                                            "Port temperature";
              constant Modelica.SIunits.HeatFlowRate Q_flow = 0.0
                                                                 "Heat flow rate (positive if flowing from outside into the component)";
            end port_b_rec;
          public
            port_b_rec port_b;
            Modelica.SIunits.Temperature T
                                          "Average temperature of element";
            parameter Modelica.SIunits.Temperature T_start(fixed=false)
                                                                       "Start temperature for the average temperature of element";
            Modelica.SIunits.ThermalConductance G
                                                 "Thermal conductance of material";
            Modelica.SIunits.ThermalConductivity k
                                                  "Thermal conductivity";
            parameter Modelica.SIunits.Length L(fixed=false)
                                                            "length of conduction";
            parameter Modelica.SIunits.Area A(fixed=false)
                                                          "Heat transfer area";
          end thermalConductor_b_3_rec;
        public
          thermalConductor_b_3_rec thermalConductor_b_3;
        protected
          record heatCapacitor_rec
            Modelica.SIunits.Temperature T
                                          "Temperature of element";
            Real T_der(unit = "K/s")
                                    "der(Temperature of element)";
            Modelica.SIunits.HeatFlowRate Q_flow;
            parameter Modelica.SIunits.Temperature T_start(fixed=false)
                                                                       "Start temperature for the average temperature of ellement";
          protected
            record port_rec
              Modelica.SIunits.Temperature T
                                            "Port temperature";
              Modelica.SIunits.HeatFlowRate Q_flow
                                                  "Heat flow rate (positive if flowing from outside into the component)";
            end port_rec;
          public
            port_rec port;
            parameter Modelica.SIunits.Volume V(fixed=false)
                                                            "Volume of element";
            parameter Modelica.SIunits.Mass m(fixed=false)
                                                          "Mass of element";
            Modelica.SIunits.TemperatureSlope der_T
                                                   "Time derivative of temperature (= der(T))";
            Modelica.SIunits.HeatCapacity C
                                           "Heat capacity of element (= cp*m)";
            parameter Modelica.SIunits.TemperatureSlope der_T_start(fixed=false)
                                                                                "Start value ofime derivative of temperature (= der(T))";
          end heatCapacitor_rec;
        public
          heatCapacitor_rec heatCapacitor;
        protected
          record port_int_rec
            Modelica.SIunits.Temperature T
                                          "Port temperature";
            constant Modelica.SIunits.HeatFlowRate Q_flow = 0.0
                                                               "Heat flow rate (positive if flowing from outside into the component)";
          end port_int_rec;
        public
          port_int_rec port_int;
        end 'thermalNode[1, 5, 1]_rec';
      public
        'thermalNode[1, 5, 1]_rec' 'thermalNode[1, 5, 1]' annotation(Dialog);
      protected
        record 'thermalNode[1, 6, 1]_rec'
          parameter Real nParallel(min = 1.0) = 1
                                                 "Number of identical parallel elements";
          constant Boolean use_portDim1 = true
                                              "Heat tranfer in 1st dimention";
          constant Boolean use_portDim2 = true
                                              "Heat tranfer in 2nd dimention";
          constant Boolean use_portDim3 = false
                                               "Heat tranfer in 3rd dimention";
        protected
          record port_a_1_rec
            Modelica.SIunits.Temperature T
                                          "Port temperature";
            Modelica.SIunits.HeatFlowRate Q_flow
                                                "Heat flow rate (positive if flowing from outside into the component)";
          end port_a_1_rec;
        public
          port_a_1_rec port_a_1;
        protected
          record port_b_1_rec
            Modelica.SIunits.Temperature T
                                          "Port temperature";
            Modelica.SIunits.HeatFlowRate Q_flow
                                                "Heat flow rate (positive if flowing from outside into the component)";
          end port_b_1_rec;
        public
          port_b_1_rec port_b_1;
        protected
          record port_a_2_rec
            Modelica.SIunits.Temperature T
                                          "Port temperature";
            Modelica.SIunits.HeatFlowRate Q_flow
                                                "Heat flow rate (positive if flowing from outside into the component)";
          end port_a_2_rec;
        public
          port_a_2_rec port_a_2;
        protected
          record port_b_2_rec
            Modelica.SIunits.Temperature T
                                          "Port temperature";
            Modelica.SIunits.HeatFlowRate Q_flow
                                                "Heat flow rate (positive if flowing from outside into the component)";
          end port_b_2_rec;
        public
          port_b_2_rec port_b_2;
          parameter Modelica.SIunits.Volume V(fixed=false)
                                                          "Volume of material";
        protected
          record thermalConductor_a_1_rec
            Modelica.SIunits.HeatFlowRate Q_flow
                                                "Heat flow rate from port_a -> port_b";
            Modelica.SIunits.TemperatureDifference dT
                                                     "port_a.T - port_b.T";
          protected
            record port_a_rec
              Modelica.SIunits.Temperature T
                                            "Port temperature";
              Modelica.SIunits.HeatFlowRate Q_flow
                                                  "Heat flow rate (positive if flowing from outside into the component)";
            end port_a_rec;
          public
            port_a_rec port_a;
          protected
            record port_b_rec
              Modelica.SIunits.Temperature T
                                            "Port temperature";
              Modelica.SIunits.HeatFlowRate Q_flow
                                                  "Heat flow rate (positive if flowing from outside into the component)";
            end port_b_rec;
          public
            port_b_rec port_b;
            Modelica.SIunits.Temperature T
                                          "Average temperature of element";
            parameter Modelica.SIunits.Temperature T_start(fixed=false)
                                                                       "Start temperature for the average temperature of element";
            Modelica.SIunits.ThermalConductance G
                                                 "Thermal conductance of material";
            Modelica.SIunits.ThermalConductivity k
                                                  "Thermal conductivity";
            parameter Modelica.SIunits.Length r_internal(fixed=false)
                                                                     "Inner radius of cylinder";
            parameter Modelica.SIunits.Length r_external(fixed=false)
                                                                     "Outer radius of cylinder";
            parameter Modelica.SIunits.Length L(fixed=false)
                                                            "Length of cylinder";
            parameter Modelica.SIunits.Angle alpha(fixed=false)
                                                               "Swept angle";
          end thermalConductor_a_1_rec;
        public
          thermalConductor_a_1_rec thermalConductor_a_1;
        protected
          record thermalConductor_b_1_rec
            Modelica.SIunits.HeatFlowRate Q_flow
                                                "Heat flow rate from port_a -> port_b";
            Modelica.SIunits.TemperatureDifference dT
                                                     "port_a.T - port_b.T";
          protected
            record port_a_rec
              Modelica.SIunits.Temperature T
                                            "Port temperature";
              Modelica.SIunits.HeatFlowRate Q_flow
                                                  "Heat flow rate (positive if flowing from outside into the component)";
            end port_a_rec;
          public
            port_a_rec port_a;
          protected
            record port_b_rec
              Modelica.SIunits.Temperature T
                                            "Port temperature";
              Modelica.SIunits.HeatFlowRate Q_flow
                                                  "Heat flow rate (positive if flowing from outside into the component)";
            end port_b_rec;
          public
            port_b_rec port_b;
            Modelica.SIunits.Temperature T
                                          "Average temperature of element";
            parameter Modelica.SIunits.Temperature T_start(fixed=false)
                                                                       "Start temperature for the average temperature of element";
            Modelica.SIunits.ThermalConductance G
                                                 "Thermal conductance of material";
            Modelica.SIunits.ThermalConductivity k
                                                  "Thermal conductivity";
            parameter Modelica.SIunits.Length r_internal(fixed=false)
                                                                     "Inner radius of cylinder";
            parameter Modelica.SIunits.Length r_external(fixed=false)
                                                                     "Outer radius of cylinder";
            parameter Modelica.SIunits.Length L(fixed=false)
                                                            "Length of cylinder";
            parameter Modelica.SIunits.Angle alpha(fixed=false)
                                                               "Swept angle";
          end thermalConductor_b_1_rec;
        public
          thermalConductor_b_1_rec thermalConductor_b_1;
        protected
          record thermalConductor_a_2_rec
            Modelica.SIunits.HeatFlowRate Q_flow
                                                "Heat flow rate from port_a -> port_b";
            Modelica.SIunits.TemperatureDifference dT
                                                     "port_a.T - port_b.T";
          protected
            record port_a_rec
              Modelica.SIunits.Temperature T
                                            "Port temperature";
              Modelica.SIunits.HeatFlowRate Q_flow
                                                  "Heat flow rate (positive if flowing from outside into the component)";
            end port_a_rec;
          public
            port_a_rec port_a;
          protected
            record port_b_rec
              Modelica.SIunits.Temperature T
                                            "Port temperature";
              Modelica.SIunits.HeatFlowRate Q_flow
                                                  "Heat flow rate (positive if flowing from outside into the component)";
            end port_b_rec;
          public
            port_b_rec port_b;
            Modelica.SIunits.Temperature T
                                          "Average temperature of element";
            parameter Modelica.SIunits.Temperature T_start(fixed=false)
                                                                       "Start temperature for the average temperature of element";
            Modelica.SIunits.ThermalConductance G
                                                 "Thermal conductance of material";
            Modelica.SIunits.ThermalConductivity k
                                                  "Thermal conductivity";
            parameter Modelica.SIunits.Length L(fixed=false)
                                                            "length of conduction";
            parameter Modelica.SIunits.Area A(fixed=false)
                                                          "Heat transfer area";
          end thermalConductor_a_2_rec;
        public
          thermalConductor_a_2_rec thermalConductor_a_2;
        protected
          record thermalConductor_b_2_rec
            Modelica.SIunits.HeatFlowRate Q_flow
                                                "Heat flow rate from port_a -> port_b";
            Modelica.SIunits.TemperatureDifference dT
                                                     "port_a.T - port_b.T";
          protected
            record port_a_rec
              Modelica.SIunits.Temperature T
                                            "Port temperature";
              Modelica.SIunits.HeatFlowRate Q_flow
                                                  "Heat flow rate (positive if flowing from outside into the component)";
            end port_a_rec;
          public
            port_a_rec port_a;
          protected
            record port_b_rec
              Modelica.SIunits.Temperature T
                                            "Port temperature";
              Modelica.SIunits.HeatFlowRate Q_flow
                                                  "Heat flow rate (positive if flowing from outside into the component)";
            end port_b_rec;
          public
            port_b_rec port_b;
            Modelica.SIunits.Temperature T
                                          "Average temperature of element";
            parameter Modelica.SIunits.Temperature T_start(fixed=false)
                                                                       "Start temperature for the average temperature of element";
            Modelica.SIunits.ThermalConductance G
                                                 "Thermal conductance of material";
            Modelica.SIunits.ThermalConductivity k
                                                  "Thermal conductivity";
            parameter Modelica.SIunits.Length L(fixed=false)
                                                            "length of conduction";
            parameter Modelica.SIunits.Area A(fixed=false)
                                                          "Heat transfer area";
          end thermalConductor_b_2_rec;
        public
          thermalConductor_b_2_rec thermalConductor_b_2;
        protected
          record thermalConductor_a_3_rec
            constant Modelica.SIunits.HeatFlowRate Q_flow = 0.0
                                                               "Heat flow rate from port_a -> port_b";
            Modelica.SIunits.TemperatureDifference dT
                                                     "port_a.T - port_b.T";
          protected
            record port_a_rec
              Modelica.SIunits.Temperature T
                                            "Port temperature";
              constant Modelica.SIunits.HeatFlowRate Q_flow = 0.0
                                                                 "Heat flow rate (positive if flowing from outside into the component)";
            end port_a_rec;
          public
            port_a_rec port_a;
          protected
            record port_b_rec
              Modelica.SIunits.Temperature T
                                            "Port temperature";
              constant Modelica.SIunits.HeatFlowRate Q_flow = 0.0
                                                                 "Heat flow rate (positive if flowing from outside into the component)";
            end port_b_rec;
          public
            port_b_rec port_b;
            Modelica.SIunits.Temperature T
                                          "Average temperature of element";
            parameter Modelica.SIunits.Temperature T_start(fixed=false)
                                                                       "Start temperature for the average temperature of element";
            Modelica.SIunits.ThermalConductance G
                                                 "Thermal conductance of material";
            Modelica.SIunits.ThermalConductivity k
                                                  "Thermal conductivity";
            parameter Modelica.SIunits.Length L(fixed=false)
                                                            "length of conduction";
            parameter Modelica.SIunits.Area A(fixed=false)
                                                          "Heat transfer area";
          end thermalConductor_a_3_rec;
        public
          thermalConductor_a_3_rec thermalConductor_a_3;
        protected
          record thermalConductor_b_3_rec
            constant Modelica.SIunits.HeatFlowRate Q_flow = 0.0
                                                               "Heat flow rate from port_a -> port_b";
            Modelica.SIunits.TemperatureDifference dT
                                                     "port_a.T - port_b.T";
          protected
            record port_a_rec
              Modelica.SIunits.Temperature T
                                            "Port temperature";
              constant Modelica.SIunits.HeatFlowRate Q_flow = 0.0
                                                                 "Heat flow rate (positive if flowing from outside into the component)";
            end port_a_rec;
          public
            port_a_rec port_a;
          protected
            record port_b_rec
              Modelica.SIunits.Temperature T
                                            "Port temperature";
              constant Modelica.SIunits.HeatFlowRate Q_flow = 0.0
                                                                 "Heat flow rate (positive if flowing from outside into the component)";
            end port_b_rec;
          public
            port_b_rec port_b;
            Modelica.SIunits.Temperature T
                                          "Average temperature of element";
            parameter Modelica.SIunits.Temperature T_start(fixed=false)
                                                                       "Start temperature for the average temperature of element";
            Modelica.SIunits.ThermalConductance G
                                                 "Thermal conductance of material";
            Modelica.SIunits.ThermalConductivity k
                                                  "Thermal conductivity";
            parameter Modelica.SIunits.Length L(fixed=false)
                                                            "length of conduction";
            parameter Modelica.SIunits.Area A(fixed=false)
                                                          "Heat transfer area";
          end thermalConductor_b_3_rec;
        public
          thermalConductor_b_3_rec thermalConductor_b_3;
        protected
          record heatCapacitor_rec
            Modelica.SIunits.Temperature T
                                          "Temperature of element";
            Real T_der(unit = "K/s")
                                    "der(Temperature of element)";
            Modelica.SIunits.HeatFlowRate Q_flow;
            parameter Modelica.SIunits.Temperature T_start(fixed=false)
                                                                       "Start temperature for the average temperature of ellement";
          protected
            record port_rec
              Modelica.SIunits.Temperature T
                                            "Port temperature";
              Modelica.SIunits.HeatFlowRate Q_flow
                                                  "Heat flow rate (positive if flowing from outside into the component)";
            end port_rec;
          public
            port_rec port;
            parameter Modelica.SIunits.Volume V(fixed=false)
                                                            "Volume of element";
            parameter Modelica.SIunits.Mass m(fixed=false)
                                                          "Mass of element";
            Modelica.SIunits.TemperatureSlope der_T
                                                   "Time derivative of temperature (= der(T))";
            Modelica.SIunits.HeatCapacity C
                                           "Heat capacity of element (= cp*m)";
            parameter Modelica.SIunits.TemperatureSlope der_T_start(fixed=false)
                                                                                "Start value ofime derivative of temperature (= der(T))";
          end heatCapacitor_rec;
        public
          heatCapacitor_rec heatCapacitor;
        protected
          record port_int_rec
            Modelica.SIunits.Temperature T
                                          "Port temperature";
            constant Modelica.SIunits.HeatFlowRate Q_flow = 0.0
                                                               "Heat flow rate (positive if flowing from outside into the component)";
          end port_int_rec;
        public
          port_int_rec port_int;
        end 'thermalNode[1, 6, 1]_rec';
      public
        'thermalNode[1, 6, 1]_rec' 'thermalNode[1, 6, 1]' annotation(Dialog);
      protected
        record 'thermalNode[1, 7, 1]_rec'
          parameter Real nParallel(min = 1.0) = 1
                                                 "Number of identical parallel elements";
          constant Boolean use_portDim1 = true
                                              "Heat tranfer in 1st dimention";
          constant Boolean use_portDim2 = true
                                              "Heat tranfer in 2nd dimention";
          constant Boolean use_portDim3 = false
                                               "Heat tranfer in 3rd dimention";
        protected
          record port_a_1_rec
            Modelica.SIunits.Temperature T
                                          "Port temperature";
            Modelica.SIunits.HeatFlowRate Q_flow
                                                "Heat flow rate (positive if flowing from outside into the component)";
          end port_a_1_rec;
        public
          port_a_1_rec port_a_1;
        protected
          record port_b_1_rec
            Modelica.SIunits.Temperature T
                                          "Port temperature";
            Modelica.SIunits.HeatFlowRate Q_flow
                                                "Heat flow rate (positive if flowing from outside into the component)";
          end port_b_1_rec;
        public
          port_b_1_rec port_b_1;
        protected
          record port_a_2_rec
            Modelica.SIunits.Temperature T
                                          "Port temperature";
            Modelica.SIunits.HeatFlowRate Q_flow
                                                "Heat flow rate (positive if flowing from outside into the component)";
          end port_a_2_rec;
        public
          port_a_2_rec port_a_2;
        protected
          record port_b_2_rec
            Modelica.SIunits.Temperature T
                                          "Port temperature";
            Modelica.SIunits.HeatFlowRate Q_flow
                                                "Heat flow rate (positive if flowing from outside into the component)";
          end port_b_2_rec;
        public
          port_b_2_rec port_b_2;
          parameter Modelica.SIunits.Volume V(fixed=false)
                                                          "Volume of material";
        protected
          record thermalConductor_a_1_rec
            Modelica.SIunits.HeatFlowRate Q_flow
                                                "Heat flow rate from port_a -> port_b";
            Modelica.SIunits.TemperatureDifference dT
                                                     "port_a.T - port_b.T";
          protected
            record port_a_rec
              Modelica.SIunits.Temperature T
                                            "Port temperature";
              Modelica.SIunits.HeatFlowRate Q_flow
                                                  "Heat flow rate (positive if flowing from outside into the component)";
            end port_a_rec;
          public
            port_a_rec port_a;
          protected
            record port_b_rec
              Modelica.SIunits.Temperature T
                                            "Port temperature";
              Modelica.SIunits.HeatFlowRate Q_flow
                                                  "Heat flow rate (positive if flowing from outside into the component)";
            end port_b_rec;
          public
            port_b_rec port_b;
            Modelica.SIunits.Temperature T
                                          "Average temperature of element";
            parameter Modelica.SIunits.Temperature T_start(fixed=false)
                                                                       "Start temperature for the average temperature of element";
            Modelica.SIunits.ThermalConductance G
                                                 "Thermal conductance of material";
            Modelica.SIunits.ThermalConductivity k
                                                  "Thermal conductivity";
            parameter Modelica.SIunits.Length r_internal(fixed=false)
                                                                     "Inner radius of cylinder";
            parameter Modelica.SIunits.Length r_external(fixed=false)
                                                                     "Outer radius of cylinder";
            parameter Modelica.SIunits.Length L(fixed=false)
                                                            "Length of cylinder";
            parameter Modelica.SIunits.Angle alpha(fixed=false)
                                                               "Swept angle";
          end thermalConductor_a_1_rec;
        public
          thermalConductor_a_1_rec thermalConductor_a_1;
        protected
          record thermalConductor_b_1_rec
            Modelica.SIunits.HeatFlowRate Q_flow
                                                "Heat flow rate from port_a -> port_b";
            Modelica.SIunits.TemperatureDifference dT
                                                     "port_a.T - port_b.T";
          protected
            record port_a_rec
              Modelica.SIunits.Temperature T
                                            "Port temperature";
              Modelica.SIunits.HeatFlowRate Q_flow
                                                  "Heat flow rate (positive if flowing from outside into the component)";
            end port_a_rec;
          public
            port_a_rec port_a;
          protected
            record port_b_rec
              Modelica.SIunits.Temperature T
                                            "Port temperature";
              Modelica.SIunits.HeatFlowRate Q_flow
                                                  "Heat flow rate (positive if flowing from outside into the component)";
            end port_b_rec;
          public
            port_b_rec port_b;
            Modelica.SIunits.Temperature T
                                          "Average temperature of element";
            parameter Modelica.SIunits.Temperature T_start(fixed=false)
                                                                       "Start temperature for the average temperature of element";
            Modelica.SIunits.ThermalConductance G
                                                 "Thermal conductance of material";
            Modelica.SIunits.ThermalConductivity k
                                                  "Thermal conductivity";
            parameter Modelica.SIunits.Length r_internal(fixed=false)
                                                                     "Inner radius of cylinder";
            parameter Modelica.SIunits.Length r_external(fixed=false)
                                                                     "Outer radius of cylinder";
            parameter Modelica.SIunits.Length L(fixed=false)
                                                            "Length of cylinder";
            parameter Modelica.SIunits.Angle alpha(fixed=false)
                                                               "Swept angle";
          end thermalConductor_b_1_rec;
        public
          thermalConductor_b_1_rec thermalConductor_b_1;
        protected
          record thermalConductor_a_2_rec
            Modelica.SIunits.HeatFlowRate Q_flow
                                                "Heat flow rate from port_a -> port_b";
            Modelica.SIunits.TemperatureDifference dT
                                                     "port_a.T - port_b.T";
          protected
            record port_a_rec
              Modelica.SIunits.Temperature T
                                            "Port temperature";
              Modelica.SIunits.HeatFlowRate Q_flow
                                                  "Heat flow rate (positive if flowing from outside into the component)";
            end port_a_rec;
          public
            port_a_rec port_a;
          protected
            record port_b_rec
              Modelica.SIunits.Temperature T
                                            "Port temperature";
              Modelica.SIunits.HeatFlowRate Q_flow
                                                  "Heat flow rate (positive if flowing from outside into the component)";
            end port_b_rec;
          public
            port_b_rec port_b;
            Modelica.SIunits.Temperature T
                                          "Average temperature of element";
            parameter Modelica.SIunits.Temperature T_start(fixed=false)
                                                                       "Start temperature for the average temperature of element";
            Modelica.SIunits.ThermalConductance G
                                                 "Thermal conductance of material";
            Modelica.SIunits.ThermalConductivity k
                                                  "Thermal conductivity";
            parameter Modelica.SIunits.Length L(fixed=false)
                                                            "length of conduction";
            parameter Modelica.SIunits.Area A(fixed=false)
                                                          "Heat transfer area";
          end thermalConductor_a_2_rec;
        public
          thermalConductor_a_2_rec thermalConductor_a_2;
        protected
          record thermalConductor_b_2_rec
            Modelica.SIunits.HeatFlowRate Q_flow
                                                "Heat flow rate from port_a -> port_b";
            Modelica.SIunits.TemperatureDifference dT
                                                     "port_a.T - port_b.T";
          protected
            record port_a_rec
              Modelica.SIunits.Temperature T
                                            "Port temperature";
              Modelica.SIunits.HeatFlowRate Q_flow
                                                  "Heat flow rate (positive if flowing from outside into the component)";
            end port_a_rec;
          public
            port_a_rec port_a;
          protected
            record port_b_rec
              Modelica.SIunits.Temperature T
                                            "Port temperature";
              Modelica.SIunits.HeatFlowRate Q_flow
                                                  "Heat flow rate (positive if flowing from outside into the component)";
            end port_b_rec;
          public
            port_b_rec port_b;
            Modelica.SIunits.Temperature T
                                          "Average temperature of element";
            parameter Modelica.SIunits.Temperature T_start(fixed=false)
                                                                       "Start temperature for the average temperature of element";
            Modelica.SIunits.ThermalConductance G
                                                 "Thermal conductance of material";
            Modelica.SIunits.ThermalConductivity k
                                                  "Thermal conductivity";
            parameter Modelica.SIunits.Length L(fixed=false)
                                                            "length of conduction";
            parameter Modelica.SIunits.Area A(fixed=false)
                                                          "Heat transfer area";
          end thermalConductor_b_2_rec;
        public
          thermalConductor_b_2_rec thermalConductor_b_2;
        protected
          record thermalConductor_a_3_rec
            constant Modelica.SIunits.HeatFlowRate Q_flow = 0.0
                                                               "Heat flow rate from port_a -> port_b";
            Modelica.SIunits.TemperatureDifference dT
                                                     "port_a.T - port_b.T";
          protected
            record port_a_rec
              Modelica.SIunits.Temperature T
                                            "Port temperature";
              constant Modelica.SIunits.HeatFlowRate Q_flow = 0.0
                                                                 "Heat flow rate (positive if flowing from outside into the component)";
            end port_a_rec;
          public
            port_a_rec port_a;
          protected
            record port_b_rec
              Modelica.SIunits.Temperature T
                                            "Port temperature";
              constant Modelica.SIunits.HeatFlowRate Q_flow = 0.0
                                                                 "Heat flow rate (positive if flowing from outside into the component)";
            end port_b_rec;
          public
            port_b_rec port_b;
            Modelica.SIunits.Temperature T
                                          "Average temperature of element";
            parameter Modelica.SIunits.Temperature T_start(fixed=false)
                                                                       "Start temperature for the average temperature of element";
            Modelica.SIunits.ThermalConductance G
                                                 "Thermal conductance of material";
            Modelica.SIunits.ThermalConductivity k
                                                  "Thermal conductivity";
            parameter Modelica.SIunits.Length L(fixed=false)
                                                            "length of conduction";
            parameter Modelica.SIunits.Area A(fixed=false)
                                                          "Heat transfer area";
          end thermalConductor_a_3_rec;
        public
          thermalConductor_a_3_rec thermalConductor_a_3;
        protected
          record thermalConductor_b_3_rec
            constant Modelica.SIunits.HeatFlowRate Q_flow = 0.0
                                                               "Heat flow rate from port_a -> port_b";
            Modelica.SIunits.TemperatureDifference dT
                                                     "port_a.T - port_b.T";
          protected
            record port_a_rec
              Modelica.SIunits.Temperature T
                                            "Port temperature";
              constant Modelica.SIunits.HeatFlowRate Q_flow = 0.0
                                                                 "Heat flow rate (positive if flowing from outside into the component)";
            end port_a_rec;
          public
            port_a_rec port_a;
          protected
            record port_b_rec
              Modelica.SIunits.Temperature T
                                            "Port temperature";
              constant Modelica.SIunits.HeatFlowRate Q_flow = 0.0
                                                                 "Heat flow rate (positive if flowing from outside into the component)";
            end port_b_rec;
          public
            port_b_rec port_b;
            Modelica.SIunits.Temperature T
                                          "Average temperature of element";
            parameter Modelica.SIunits.Temperature T_start(fixed=false)
                                                                       "Start temperature for the average temperature of element";
            Modelica.SIunits.ThermalConductance G
                                                 "Thermal conductance of material";
            Modelica.SIunits.ThermalConductivity k
                                                  "Thermal conductivity";
            parameter Modelica.SIunits.Length L(fixed=false)
                                                            "length of conduction";
            parameter Modelica.SIunits.Area A(fixed=false)
                                                          "Heat transfer area";
          end thermalConductor_b_3_rec;
        public
          thermalConductor_b_3_rec thermalConductor_b_3;
        protected
          record heatCapacitor_rec
            Modelica.SIunits.Temperature T
                                          "Temperature of element";
            Real T_der(unit = "K/s")
                                    "der(Temperature of element)";
            Modelica.SIunits.HeatFlowRate Q_flow;
            parameter Modelica.SIunits.Temperature T_start(fixed=false)
                                                                       "Start temperature for the average temperature of ellement";
          protected
            record port_rec
              Modelica.SIunits.Temperature T
                                            "Port temperature";
              Modelica.SIunits.HeatFlowRate Q_flow
                                                  "Heat flow rate (positive if flowing from outside into the component)";
            end port_rec;
          public
            port_rec port;
            parameter Modelica.SIunits.Volume V(fixed=false)
                                                            "Volume of element";
            parameter Modelica.SIunits.Mass m(fixed=false)
                                                          "Mass of element";
            Modelica.SIunits.TemperatureSlope der_T
                                                   "Time derivative of temperature (= der(T))";
            Modelica.SIunits.HeatCapacity C
                                           "Heat capacity of element (= cp*m)";
            parameter Modelica.SIunits.TemperatureSlope der_T_start(fixed=false)
                                                                                "Start value ofime derivative of temperature (= der(T))";
          end heatCapacitor_rec;
        public
          heatCapacitor_rec heatCapacitor;
        protected
          record port_int_rec
            Modelica.SIunits.Temperature T
                                          "Port temperature";
            constant Modelica.SIunits.HeatFlowRate Q_flow = 0.0
                                                               "Heat flow rate (positive if flowing from outside into the component)";
          end port_int_rec;
        public
          port_int_rec port_int;
        end 'thermalNode[1, 7, 1]_rec';
      public
        'thermalNode[1, 7, 1]_rec' 'thermalNode[1, 7, 1]' annotation(Dialog);
      protected
        record 'thermalNode[1, 8, 1]_rec'
          parameter Real nParallel(min = 1.0) = 1
                                                 "Number of identical parallel elements";
          constant Boolean use_portDim1 = true
                                              "Heat tranfer in 1st dimention";
          constant Boolean use_portDim2 = true
                                              "Heat tranfer in 2nd dimention";
          constant Boolean use_portDim3 = false
                                               "Heat tranfer in 3rd dimention";
        protected
          record port_a_1_rec
            Modelica.SIunits.Temperature T
                                          "Port temperature";
            Modelica.SIunits.HeatFlowRate Q_flow
                                                "Heat flow rate (positive if flowing from outside into the component)";
          end port_a_1_rec;
        public
          port_a_1_rec port_a_1;
        protected
          record port_b_1_rec
            Modelica.SIunits.Temperature T
                                          "Port temperature";
            Modelica.SIunits.HeatFlowRate Q_flow
                                                "Heat flow rate (positive if flowing from outside into the component)";
          end port_b_1_rec;
        public
          port_b_1_rec port_b_1;
        protected
          record port_a_2_rec
            Modelica.SIunits.Temperature T
                                          "Port temperature";
            Modelica.SIunits.HeatFlowRate Q_flow
                                                "Heat flow rate (positive if flowing from outside into the component)";
          end port_a_2_rec;
        public
          port_a_2_rec port_a_2;
        protected
          record port_b_2_rec
            Modelica.SIunits.Temperature T
                                          "Port temperature";
            Modelica.SIunits.HeatFlowRate Q_flow
                                                "Heat flow rate (positive if flowing from outside into the component)";
          end port_b_2_rec;
        public
          port_b_2_rec port_b_2;
          parameter Modelica.SIunits.Volume V(fixed=false)
                                                          "Volume of material";
        protected
          record thermalConductor_a_1_rec
            Modelica.SIunits.HeatFlowRate Q_flow
                                                "Heat flow rate from port_a -> port_b";
            Modelica.SIunits.TemperatureDifference dT
                                                     "port_a.T - port_b.T";
          protected
            record port_a_rec
              Modelica.SIunits.Temperature T
                                            "Port temperature";
              Modelica.SIunits.HeatFlowRate Q_flow
                                                  "Heat flow rate (positive if flowing from outside into the component)";
            end port_a_rec;
          public
            port_a_rec port_a;
          protected
            record port_b_rec
              Modelica.SIunits.Temperature T
                                            "Port temperature";
              Modelica.SIunits.HeatFlowRate Q_flow
                                                  "Heat flow rate (positive if flowing from outside into the component)";
            end port_b_rec;
          public
            port_b_rec port_b;
            Modelica.SIunits.Temperature T
                                          "Average temperature of element";
            parameter Modelica.SIunits.Temperature T_start(fixed=false)
                                                                       "Start temperature for the average temperature of element";
            Modelica.SIunits.ThermalConductance G
                                                 "Thermal conductance of material";
            Modelica.SIunits.ThermalConductivity k
                                                  "Thermal conductivity";
            parameter Modelica.SIunits.Length r_internal(fixed=false)
                                                                     "Inner radius of cylinder";
            parameter Modelica.SIunits.Length r_external(fixed=false)
                                                                     "Outer radius of cylinder";
            parameter Modelica.SIunits.Length L(fixed=false)
                                                            "Length of cylinder";
            parameter Modelica.SIunits.Angle alpha(fixed=false)
                                                               "Swept angle";
          end thermalConductor_a_1_rec;
        public
          thermalConductor_a_1_rec thermalConductor_a_1;
        protected
          record thermalConductor_b_1_rec
            Modelica.SIunits.HeatFlowRate Q_flow
                                                "Heat flow rate from port_a -> port_b";
            Modelica.SIunits.TemperatureDifference dT
                                                     "port_a.T - port_b.T";
          protected
            record port_a_rec
              Modelica.SIunits.Temperature T
                                            "Port temperature";
              Modelica.SIunits.HeatFlowRate Q_flow
                                                  "Heat flow rate (positive if flowing from outside into the component)";
            end port_a_rec;
          public
            port_a_rec port_a;
          protected
            record port_b_rec
              Modelica.SIunits.Temperature T
                                            "Port temperature";
              Modelica.SIunits.HeatFlowRate Q_flow
                                                  "Heat flow rate (positive if flowing from outside into the component)";
            end port_b_rec;
          public
            port_b_rec port_b;
            Modelica.SIunits.Temperature T
                                          "Average temperature of element";
            parameter Modelica.SIunits.Temperature T_start(fixed=false)
                                                                       "Start temperature for the average temperature of element";
            Modelica.SIunits.ThermalConductance G
                                                 "Thermal conductance of material";
            Modelica.SIunits.ThermalConductivity k
                                                  "Thermal conductivity";
            parameter Modelica.SIunits.Length r_internal(fixed=false)
                                                                     "Inner radius of cylinder";
            parameter Modelica.SIunits.Length r_external(fixed=false)
                                                                     "Outer radius of cylinder";
            parameter Modelica.SIunits.Length L(fixed=false)
                                                            "Length of cylinder";
            parameter Modelica.SIunits.Angle alpha(fixed=false)
                                                               "Swept angle";
          end thermalConductor_b_1_rec;
        public
          thermalConductor_b_1_rec thermalConductor_b_1;
        protected
          record thermalConductor_a_2_rec
            Modelica.SIunits.HeatFlowRate Q_flow
                                                "Heat flow rate from port_a -> port_b";
            Modelica.SIunits.TemperatureDifference dT
                                                     "port_a.T - port_b.T";
          protected
            record port_a_rec
              Modelica.SIunits.Temperature T
                                            "Port temperature";
              Modelica.SIunits.HeatFlowRate Q_flow
                                                  "Heat flow rate (positive if flowing from outside into the component)";
            end port_a_rec;
          public
            port_a_rec port_a;
          protected
            record port_b_rec
              Modelica.SIunits.Temperature T
                                            "Port temperature";
              Modelica.SIunits.HeatFlowRate Q_flow
                                                  "Heat flow rate (positive if flowing from outside into the component)";
            end port_b_rec;
          public
            port_b_rec port_b;
            Modelica.SIunits.Temperature T
                                          "Average temperature of element";
            parameter Modelica.SIunits.Temperature T_start(fixed=false)
                                                                       "Start temperature for the average temperature of element";
            Modelica.SIunits.ThermalConductance G
                                                 "Thermal conductance of material";
            Modelica.SIunits.ThermalConductivity k
                                                  "Thermal conductivity";
            parameter Modelica.SIunits.Length L(fixed=false)
                                                            "length of conduction";
            parameter Modelica.SIunits.Area A(fixed=false)
                                                          "Heat transfer area";
          end thermalConductor_a_2_rec;
        public
          thermalConductor_a_2_rec thermalConductor_a_2;
        protected
          record thermalConductor_b_2_rec
            Modelica.SIunits.HeatFlowRate Q_flow
                                                "Heat flow rate from port_a -> port_b";
            Modelica.SIunits.TemperatureDifference dT
                                                     "port_a.T - port_b.T";
          protected
            record port_a_rec
              Modelica.SIunits.Temperature T
                                            "Port temperature";
              Modelica.SIunits.HeatFlowRate Q_flow
                                                  "Heat flow rate (positive if flowing from outside into the component)";
            end port_a_rec;
          public
            port_a_rec port_a;
          protected
            record port_b_rec
              Modelica.SIunits.Temperature T
                                            "Port temperature";
              Modelica.SIunits.HeatFlowRate Q_flow
                                                  "Heat flow rate (positive if flowing from outside into the component)";
            end port_b_rec;
          public
            port_b_rec port_b;
            Modelica.SIunits.Temperature T
                                          "Average temperature of element";
            parameter Modelica.SIunits.Temperature T_start(fixed=false)
                                                                       "Start temperature for the average temperature of element";
            Modelica.SIunits.ThermalConductance G
                                                 "Thermal conductance of material";
            Modelica.SIunits.ThermalConductivity k
                                                  "Thermal conductivity";
            parameter Modelica.SIunits.Length L(fixed=false)
                                                            "length of conduction";
            parameter Modelica.SIunits.Area A(fixed=false)
                                                          "Heat transfer area";
          end thermalConductor_b_2_rec;
        public
          thermalConductor_b_2_rec thermalConductor_b_2;
        protected
          record thermalConductor_a_3_rec
            constant Modelica.SIunits.HeatFlowRate Q_flow = 0.0
                                                               "Heat flow rate from port_a -> port_b";
            Modelica.SIunits.TemperatureDifference dT
                                                     "port_a.T - port_b.T";
          protected
            record port_a_rec
              Modelica.SIunits.Temperature T
                                            "Port temperature";
              constant Modelica.SIunits.HeatFlowRate Q_flow = 0.0
                                                                 "Heat flow rate (positive if flowing from outside into the component)";
            end port_a_rec;
          public
            port_a_rec port_a;
          protected
            record port_b_rec
              Modelica.SIunits.Temperature T
                                            "Port temperature";
              constant Modelica.SIunits.HeatFlowRate Q_flow = 0.0
                                                                 "Heat flow rate (positive if flowing from outside into the component)";
            end port_b_rec;
          public
            port_b_rec port_b;
            Modelica.SIunits.Temperature T
                                          "Average temperature of element";
            parameter Modelica.SIunits.Temperature T_start(fixed=false)
                                                                       "Start temperature for the average temperature of element";
            Modelica.SIunits.ThermalConductance G
                                                 "Thermal conductance of material";
            Modelica.SIunits.ThermalConductivity k
                                                  "Thermal conductivity";
            parameter Modelica.SIunits.Length L(fixed=false)
                                                            "length of conduction";
            parameter Modelica.SIunits.Area A(fixed=false)
                                                          "Heat transfer area";
          end thermalConductor_a_3_rec;
        public
          thermalConductor_a_3_rec thermalConductor_a_3;
        protected
          record thermalConductor_b_3_rec
            constant Modelica.SIunits.HeatFlowRate Q_flow = 0.0
                                                               "Heat flow rate from port_a -> port_b";
            Modelica.SIunits.TemperatureDifference dT
                                                     "port_a.T - port_b.T";
          protected
            record port_a_rec
              Modelica.SIunits.Temperature T
                                            "Port temperature";
              constant Modelica.SIunits.HeatFlowRate Q_flow = 0.0
                                                                 "Heat flow rate (positive if flowing from outside into the component)";
            end port_a_rec;
          public
            port_a_rec port_a;
          protected
            record port_b_rec
              Modelica.SIunits.Temperature T
                                            "Port temperature";
              constant Modelica.SIunits.HeatFlowRate Q_flow = 0.0
                                                                 "Heat flow rate (positive if flowing from outside into the component)";
            end port_b_rec;
          public
            port_b_rec port_b;
            Modelica.SIunits.Temperature T
                                          "Average temperature of element";
            parameter Modelica.SIunits.Temperature T_start(fixed=false)
                                                                       "Start temperature for the average temperature of element";
            Modelica.SIunits.ThermalConductance G
                                                 "Thermal conductance of material";
            Modelica.SIunits.ThermalConductivity k
                                                  "Thermal conductivity";
            parameter Modelica.SIunits.Length L(fixed=false)
                                                            "length of conduction";
            parameter Modelica.SIunits.Area A(fixed=false)
                                                          "Heat transfer area";
          end thermalConductor_b_3_rec;
        public
          thermalConductor_b_3_rec thermalConductor_b_3;
        protected
          record heatCapacitor_rec
            Modelica.SIunits.Temperature T
                                          "Temperature of element";
            Real T_der(unit = "K/s")
                                    "der(Temperature of element)";
            Modelica.SIunits.HeatFlowRate Q_flow;
            parameter Modelica.SIunits.Temperature T_start(fixed=false)
                                                                       "Start temperature for the average temperature of ellement";
          protected
            record port_rec
              Modelica.SIunits.Temperature T
                                            "Port temperature";
              Modelica.SIunits.HeatFlowRate Q_flow
                                                  "Heat flow rate (positive if flowing from outside into the component)";
            end port_rec;
          public
            port_rec port;
            parameter Modelica.SIunits.Volume V(fixed=false)
                                                            "Volume of element";
            parameter Modelica.SIunits.Mass m(fixed=false)
                                                          "Mass of element";
            Modelica.SIunits.TemperatureSlope der_T
                                                   "Time derivative of temperature (= der(T))";
            Modelica.SIunits.HeatCapacity C
                                           "Heat capacity of element (= cp*m)";
            parameter Modelica.SIunits.TemperatureSlope der_T_start(fixed=false)
                                                                                "Start value ofime derivative of temperature (= der(T))";
          end heatCapacitor_rec;
        public
          heatCapacitor_rec heatCapacitor;
        protected
          record port_int_rec
            Modelica.SIunits.Temperature T
                                          "Port temperature";
            constant Modelica.SIunits.HeatFlowRate Q_flow = 0.0
                                                               "Heat flow rate (positive if flowing from outside into the component)";
          end port_int_rec;
        public
          port_int_rec port_int;
        end 'thermalNode[1, 8, 1]_rec';
      public
        'thermalNode[1, 8, 1]_rec' 'thermalNode[1, 8, 1]' annotation(Dialog);
      protected
        record 'thermalNode[1, 9, 1]_rec'
          parameter Real nParallel(min = 1.0) = 1
                                                 "Number of identical parallel elements";
          constant Boolean use_portDim1 = true
                                              "Heat tranfer in 1st dimention";
          constant Boolean use_portDim2 = true
                                              "Heat tranfer in 2nd dimention";
          constant Boolean use_portDim3 = false
                                               "Heat tranfer in 3rd dimention";
        protected
          record port_a_1_rec
            Modelica.SIunits.Temperature T
                                          "Port temperature";
            Modelica.SIunits.HeatFlowRate Q_flow
                                                "Heat flow rate (positive if flowing from outside into the component)";
          end port_a_1_rec;
        public
          port_a_1_rec port_a_1;
        protected
          record port_b_1_rec
            Modelica.SIunits.Temperature T
                                          "Port temperature";
            Modelica.SIunits.HeatFlowRate Q_flow
                                                "Heat flow rate (positive if flowing from outside into the component)";
          end port_b_1_rec;
        public
          port_b_1_rec port_b_1;
        protected
          record port_a_2_rec
            Modelica.SIunits.Temperature T
                                          "Port temperature";
            Modelica.SIunits.HeatFlowRate Q_flow
                                                "Heat flow rate (positive if flowing from outside into the component)";
          end port_a_2_rec;
        public
          port_a_2_rec port_a_2;
        protected
          record port_b_2_rec
            Modelica.SIunits.Temperature T
                                          "Port temperature";
            Modelica.SIunits.HeatFlowRate Q_flow
                                                "Heat flow rate (positive if flowing from outside into the component)";
          end port_b_2_rec;
        public
          port_b_2_rec port_b_2;
          parameter Modelica.SIunits.Volume V(fixed=false)
                                                          "Volume of material";
        protected
          record thermalConductor_a_1_rec
            Modelica.SIunits.HeatFlowRate Q_flow
                                                "Heat flow rate from port_a -> port_b";
            Modelica.SIunits.TemperatureDifference dT
                                                     "port_a.T - port_b.T";
          protected
            record port_a_rec
              Modelica.SIunits.Temperature T
                                            "Port temperature";
              Modelica.SIunits.HeatFlowRate Q_flow
                                                  "Heat flow rate (positive if flowing from outside into the component)";
            end port_a_rec;
          public
            port_a_rec port_a;
          protected
            record port_b_rec
              Modelica.SIunits.Temperature T
                                            "Port temperature";
              Modelica.SIunits.HeatFlowRate Q_flow
                                                  "Heat flow rate (positive if flowing from outside into the component)";
            end port_b_rec;
          public
            port_b_rec port_b;
            Modelica.SIunits.Temperature T
                                          "Average temperature of element";
            parameter Modelica.SIunits.Temperature T_start(fixed=false)
                                                                       "Start temperature for the average temperature of element";
            Modelica.SIunits.ThermalConductance G
                                                 "Thermal conductance of material";
            Modelica.SIunits.ThermalConductivity k
                                                  "Thermal conductivity";
            parameter Modelica.SIunits.Length r_internal(fixed=false)
                                                                     "Inner radius of cylinder";
            parameter Modelica.SIunits.Length r_external(fixed=false)
                                                                     "Outer radius of cylinder";
            parameter Modelica.SIunits.Length L(fixed=false)
                                                            "Length of cylinder";
            parameter Modelica.SIunits.Angle alpha(fixed=false)
                                                               "Swept angle";
          end thermalConductor_a_1_rec;
        public
          thermalConductor_a_1_rec thermalConductor_a_1;
        protected
          record thermalConductor_b_1_rec
            Modelica.SIunits.HeatFlowRate Q_flow
                                                "Heat flow rate from port_a -> port_b";
            Modelica.SIunits.TemperatureDifference dT
                                                     "port_a.T - port_b.T";
          protected
            record port_a_rec
              Modelica.SIunits.Temperature T
                                            "Port temperature";
              Modelica.SIunits.HeatFlowRate Q_flow
                                                  "Heat flow rate (positive if flowing from outside into the component)";
            end port_a_rec;
          public
            port_a_rec port_a;
          protected
            record port_b_rec
              Modelica.SIunits.Temperature T
                                            "Port temperature";
              Modelica.SIunits.HeatFlowRate Q_flow
                                                  "Heat flow rate (positive if flowing from outside into the component)";
            end port_b_rec;
          public
            port_b_rec port_b;
            Modelica.SIunits.Temperature T
                                          "Average temperature of element";
            parameter Modelica.SIunits.Temperature T_start(fixed=false)
                                                                       "Start temperature for the average temperature of element";
            Modelica.SIunits.ThermalConductance G
                                                 "Thermal conductance of material";
            Modelica.SIunits.ThermalConductivity k
                                                  "Thermal conductivity";
            parameter Modelica.SIunits.Length r_internal(fixed=false)
                                                                     "Inner radius of cylinder";
            parameter Modelica.SIunits.Length r_external(fixed=false)
                                                                     "Outer radius of cylinder";
            parameter Modelica.SIunits.Length L(fixed=false)
                                                            "Length of cylinder";
            parameter Modelica.SIunits.Angle alpha(fixed=false)
                                                               "Swept angle";
          end thermalConductor_b_1_rec;
        public
          thermalConductor_b_1_rec thermalConductor_b_1;
        protected
          record thermalConductor_a_2_rec
            Modelica.SIunits.HeatFlowRate Q_flow
                                                "Heat flow rate from port_a -> port_b";
            Modelica.SIunits.TemperatureDifference dT
                                                     "port_a.T - port_b.T";
          protected
            record port_a_rec
              Modelica.SIunits.Temperature T
                                            "Port temperature";
              Modelica.SIunits.HeatFlowRate Q_flow
                                                  "Heat flow rate (positive if flowing from outside into the component)";
            end port_a_rec;
          public
            port_a_rec port_a;
          protected
            record port_b_rec
              Modelica.SIunits.Temperature T
                                            "Port temperature";
              Modelica.SIunits.HeatFlowRate Q_flow
                                                  "Heat flow rate (positive if flowing from outside into the component)";
            end port_b_rec;
          public
            port_b_rec port_b;
            Modelica.SIunits.Temperature T
                                          "Average temperature of element";
            parameter Modelica.SIunits.Temperature T_start(fixed=false)
                                                                       "Start temperature for the average temperature of element";
            Modelica.SIunits.ThermalConductance G
                                                 "Thermal conductance of material";
            Modelica.SIunits.ThermalConductivity k
                                                  "Thermal conductivity";
            parameter Modelica.SIunits.Length L(fixed=false)
                                                            "length of conduction";
            parameter Modelica.SIunits.Area A(fixed=false)
                                                          "Heat transfer area";
          end thermalConductor_a_2_rec;
        public
          thermalConductor_a_2_rec thermalConductor_a_2;
        protected
          record thermalConductor_b_2_rec
            Modelica.SIunits.HeatFlowRate Q_flow
                                                "Heat flow rate from port_a -> port_b";
            Modelica.SIunits.TemperatureDifference dT
                                                     "port_a.T - port_b.T";
          protected
            record port_a_rec
              Modelica.SIunits.Temperature T
                                            "Port temperature";
              Modelica.SIunits.HeatFlowRate Q_flow
                                                  "Heat flow rate (positive if flowing from outside into the component)";
            end port_a_rec;
          public
            port_a_rec port_a;
          protected
            record port_b_rec
              Modelica.SIunits.Temperature T
                                            "Port temperature";
              Modelica.SIunits.HeatFlowRate Q_flow
                                                  "Heat flow rate (positive if flowing from outside into the component)";
            end port_b_rec;
          public
            port_b_rec port_b;
            Modelica.SIunits.Temperature T
                                          "Average temperature of element";
            parameter Modelica.SIunits.Temperature T_start(fixed=false)
                                                                       "Start temperature for the average temperature of element";
            Modelica.SIunits.ThermalConductance G
                                                 "Thermal conductance of material";
            Modelica.SIunits.ThermalConductivity k
                                                  "Thermal conductivity";
            parameter Modelica.SIunits.Length L(fixed=false)
                                                            "length of conduction";
            parameter Modelica.SIunits.Area A(fixed=false)
                                                          "Heat transfer area";
          end thermalConductor_b_2_rec;
        public
          thermalConductor_b_2_rec thermalConductor_b_2;
        protected
          record thermalConductor_a_3_rec
            constant Modelica.SIunits.HeatFlowRate Q_flow = 0.0
                                                               "Heat flow rate from port_a -> port_b";
            Modelica.SIunits.TemperatureDifference dT
                                                     "port_a.T - port_b.T";
          protected
            record port_a_rec
              Modelica.SIunits.Temperature T
                                            "Port temperature";
              constant Modelica.SIunits.HeatFlowRate Q_flow = 0.0
                                                                 "Heat flow rate (positive if flowing from outside into the component)";
            end port_a_rec;
          public
            port_a_rec port_a;
          protected
            record port_b_rec
              Modelica.SIunits.Temperature T
                                            "Port temperature";
              constant Modelica.SIunits.HeatFlowRate Q_flow = 0.0
                                                                 "Heat flow rate (positive if flowing from outside into the component)";
            end port_b_rec;
          public
            port_b_rec port_b;
            Modelica.SIunits.Temperature T
                                          "Average temperature of element";
            parameter Modelica.SIunits.Temperature T_start(fixed=false)
                                                                       "Start temperature for the average temperature of element";
            Modelica.SIunits.ThermalConductance G
                                                 "Thermal conductance of material";
            Modelica.SIunits.ThermalConductivity k
                                                  "Thermal conductivity";
            parameter Modelica.SIunits.Length L(fixed=false)
                                                            "length of conduction";
            parameter Modelica.SIunits.Area A(fixed=false)
                                                          "Heat transfer area";
          end thermalConductor_a_3_rec;
        public
          thermalConductor_a_3_rec thermalConductor_a_3;
        protected
          record thermalConductor_b_3_rec
            constant Modelica.SIunits.HeatFlowRate Q_flow = 0.0
                                                               "Heat flow rate from port_a -> port_b";
            Modelica.SIunits.TemperatureDifference dT
                                                     "port_a.T - port_b.T";
          protected
            record port_a_rec
              Modelica.SIunits.Temperature T
                                            "Port temperature";
              constant Modelica.SIunits.HeatFlowRate Q_flow = 0.0
                                                                 "Heat flow rate (positive if flowing from outside into the component)";
            end port_a_rec;
          public
            port_a_rec port_a;
          protected
            record port_b_rec
              Modelica.SIunits.Temperature T
                                            "Port temperature";
              constant Modelica.SIunits.HeatFlowRate Q_flow = 0.0
                                                                 "Heat flow rate (positive if flowing from outside into the component)";
            end port_b_rec;
          public
            port_b_rec port_b;
            Modelica.SIunits.Temperature T
                                          "Average temperature of element";
            parameter Modelica.SIunits.Temperature T_start(fixed=false)
                                                                       "Start temperature for the average temperature of element";
            Modelica.SIunits.ThermalConductance G
                                                 "Thermal conductance of material";
            Modelica.SIunits.ThermalConductivity k
                                                  "Thermal conductivity";
            parameter Modelica.SIunits.Length L(fixed=false)
                                                            "length of conduction";
            parameter Modelica.SIunits.Area A(fixed=false)
                                                          "Heat transfer area";
          end thermalConductor_b_3_rec;
        public
          thermalConductor_b_3_rec thermalConductor_b_3;
        protected
          record heatCapacitor_rec
            Modelica.SIunits.Temperature T
                                          "Temperature of element";
            Real T_der(unit = "K/s")
                                    "der(Temperature of element)";
            Modelica.SIunits.HeatFlowRate Q_flow;
            parameter Modelica.SIunits.Temperature T_start(fixed=false)
                                                                       "Start temperature for the average temperature of ellement";
          protected
            record port_rec
              Modelica.SIunits.Temperature T
                                            "Port temperature";
              Modelica.SIunits.HeatFlowRate Q_flow
                                                  "Heat flow rate (positive if flowing from outside into the component)";
            end port_rec;
          public
            port_rec port;
            parameter Modelica.SIunits.Volume V(fixed=false)
                                                            "Volume of element";
            parameter Modelica.SIunits.Mass m(fixed=false)
                                                          "Mass of element";
            Modelica.SIunits.TemperatureSlope der_T
                                                   "Time derivative of temperature (= der(T))";
            Modelica.SIunits.HeatCapacity C
                                           "Heat capacity of element (= cp*m)";
            parameter Modelica.SIunits.TemperatureSlope der_T_start(fixed=false)
                                                                                "Start value ofime derivative of temperature (= der(T))";
          end heatCapacitor_rec;
        public
          heatCapacitor_rec heatCapacitor;
        protected
          record port_int_rec
            Modelica.SIunits.Temperature T
                                          "Port temperature";
            constant Modelica.SIunits.HeatFlowRate Q_flow = 0.0
                                                               "Heat flow rate (positive if flowing from outside into the component)";
          end port_int_rec;
        public
          port_int_rec port_int;
        end 'thermalNode[1, 9, 1]_rec';
      public
        'thermalNode[1, 9, 1]_rec' 'thermalNode[1, 9, 1]' annotation(Dialog);
      protected
        record 'thermalNode[1, 10, 1]_rec'
          parameter Real nParallel(min = 1.0) = 1
                                                 "Number of identical parallel elements";
          constant Boolean use_portDim1 = true
                                              "Heat tranfer in 1st dimention";
          constant Boolean use_portDim2 = true
                                              "Heat tranfer in 2nd dimention";
          constant Boolean use_portDim3 = false
                                               "Heat tranfer in 3rd dimention";
        protected
          record port_a_1_rec
            Modelica.SIunits.Temperature T
                                          "Port temperature";
            Modelica.SIunits.HeatFlowRate Q_flow
                                                "Heat flow rate (positive if flowing from outside into the component)";
          end port_a_1_rec;
        public
          port_a_1_rec port_a_1;
        protected
          record port_b_1_rec
            Modelica.SIunits.Temperature T
                                          "Port temperature";
            Modelica.SIunits.HeatFlowRate Q_flow
                                                "Heat flow rate (positive if flowing from outside into the component)";
          end port_b_1_rec;
        public
          port_b_1_rec port_b_1;
        protected
          record port_a_2_rec
            Modelica.SIunits.Temperature T
                                          "Port temperature";
            Modelica.SIunits.HeatFlowRate Q_flow
                                                "Heat flow rate (positive if flowing from outside into the component)";
          end port_a_2_rec;
        public
          port_a_2_rec port_a_2;
        protected
          record port_b_2_rec
            Modelica.SIunits.Temperature T
                                          "Port temperature";
            constant Modelica.SIunits.HeatFlowRate Q_flow = 0.0
                                                               "Heat flow rate (positive if flowing from outside into the component)";
          end port_b_2_rec;
        public
          port_b_2_rec port_b_2;
          parameter Modelica.SIunits.Volume V(fixed=false)
                                                          "Volume of material";
        protected
          record thermalConductor_a_1_rec
            Modelica.SIunits.HeatFlowRate Q_flow
                                                "Heat flow rate from port_a -> port_b";
            Modelica.SIunits.TemperatureDifference dT
                                                     "port_a.T - port_b.T";
          protected
            record port_a_rec
              Modelica.SIunits.Temperature T
                                            "Port temperature";
              Modelica.SIunits.HeatFlowRate Q_flow
                                                  "Heat flow rate (positive if flowing from outside into the component)";
            end port_a_rec;
          public
            port_a_rec port_a;
          protected
            record port_b_rec
              Modelica.SIunits.Temperature T
                                            "Port temperature";
              Modelica.SIunits.HeatFlowRate Q_flow
                                                  "Heat flow rate (positive if flowing from outside into the component)";
            end port_b_rec;
          public
            port_b_rec port_b;
            Modelica.SIunits.Temperature T
                                          "Average temperature of element";
            parameter Modelica.SIunits.Temperature T_start(fixed=false)
                                                                       "Start temperature for the average temperature of element";
            Modelica.SIunits.ThermalConductance G
                                                 "Thermal conductance of material";
            Modelica.SIunits.ThermalConductivity k
                                                  "Thermal conductivity";
            parameter Modelica.SIunits.Length r_internal(fixed=false)
                                                                     "Inner radius of cylinder";
            parameter Modelica.SIunits.Length r_external(fixed=false)
                                                                     "Outer radius of cylinder";
            parameter Modelica.SIunits.Length L(fixed=false)
                                                            "Length of cylinder";
            parameter Modelica.SIunits.Angle alpha(fixed=false)
                                                               "Swept angle";
          end thermalConductor_a_1_rec;
        public
          thermalConductor_a_1_rec thermalConductor_a_1;
        protected
          record thermalConductor_b_1_rec
            Modelica.SIunits.HeatFlowRate Q_flow
                                                "Heat flow rate from port_a -> port_b";
            Modelica.SIunits.TemperatureDifference dT
                                                     "port_a.T - port_b.T";
          protected
            record port_a_rec
              Modelica.SIunits.Temperature T
                                            "Port temperature";
              Modelica.SIunits.HeatFlowRate Q_flow
                                                  "Heat flow rate (positive if flowing from outside into the component)";
            end port_a_rec;
          public
            port_a_rec port_a;
          protected
            record port_b_rec
              Modelica.SIunits.Temperature T
                                            "Port temperature";
              Modelica.SIunits.HeatFlowRate Q_flow
                                                  "Heat flow rate (positive if flowing from outside into the component)";
            end port_b_rec;
          public
            port_b_rec port_b;
            Modelica.SIunits.Temperature T
                                          "Average temperature of element";
            parameter Modelica.SIunits.Temperature T_start(fixed=false)
                                                                       "Start temperature for the average temperature of element";
            Modelica.SIunits.ThermalConductance G
                                                 "Thermal conductance of material";
            Modelica.SIunits.ThermalConductivity k
                                                  "Thermal conductivity";
            parameter Modelica.SIunits.Length r_internal(fixed=false)
                                                                     "Inner radius of cylinder";
            parameter Modelica.SIunits.Length r_external(fixed=false)
                                                                     "Outer radius of cylinder";
            parameter Modelica.SIunits.Length L(fixed=false)
                                                            "Length of cylinder";
            parameter Modelica.SIunits.Angle alpha(fixed=false)
                                                               "Swept angle";
          end thermalConductor_b_1_rec;
        public
          thermalConductor_b_1_rec thermalConductor_b_1;
        protected
          record thermalConductor_a_2_rec
            Modelica.SIunits.HeatFlowRate Q_flow
                                                "Heat flow rate from port_a -> port_b";
            Modelica.SIunits.TemperatureDifference dT
                                                     "port_a.T - port_b.T";
          protected
            record port_a_rec
              Modelica.SIunits.Temperature T
                                            "Port temperature";
              Modelica.SIunits.HeatFlowRate Q_flow
                                                  "Heat flow rate (positive if flowing from outside into the component)";
            end port_a_rec;
          public
            port_a_rec port_a;
          protected
            record port_b_rec
              Modelica.SIunits.Temperature T
                                            "Port temperature";
              Modelica.SIunits.HeatFlowRate Q_flow
                                                  "Heat flow rate (positive if flowing from outside into the component)";
            end port_b_rec;
          public
            port_b_rec port_b;
            Modelica.SIunits.Temperature T
                                          "Average temperature of element";
            parameter Modelica.SIunits.Temperature T_start(fixed=false)
                                                                       "Start temperature for the average temperature of element";
            Modelica.SIunits.ThermalConductance G
                                                 "Thermal conductance of material";
            Modelica.SIunits.ThermalConductivity k
                                                  "Thermal conductivity";
            parameter Modelica.SIunits.Length L(fixed=false)
                                                            "length of conduction";
            parameter Modelica.SIunits.Area A(fixed=false)
                                                          "Heat transfer area";
          end thermalConductor_a_2_rec;
        public
          thermalConductor_a_2_rec thermalConductor_a_2;
        protected
          record thermalConductor_b_2_rec
            constant Modelica.SIunits.HeatFlowRate Q_flow = 0.0
                                                               "Heat flow rate from port_a -> port_b";
            Modelica.SIunits.TemperatureDifference dT
                                                     "port_a.T - port_b.T";
          protected
            record port_a_rec
              Modelica.SIunits.Temperature T
                                            "Port temperature";
              constant Modelica.SIunits.HeatFlowRate Q_flow = 0.0
                                                                 "Heat flow rate (positive if flowing from outside into the component)";
            end port_a_rec;
          public
            port_a_rec port_a;
          protected
            record port_b_rec
              Modelica.SIunits.Temperature T
                                            "Port temperature";
              constant Modelica.SIunits.HeatFlowRate Q_flow = 0.0
                                                                 "Heat flow rate (positive if flowing from outside into the component)";
            end port_b_rec;
          public
            port_b_rec port_b;
            Modelica.SIunits.Temperature T
                                          "Average temperature of element";
            parameter Modelica.SIunits.Temperature T_start(fixed=false)
                                                                       "Start temperature for the average temperature of element";
            Modelica.SIunits.ThermalConductance G
                                                 "Thermal conductance of material";
            Modelica.SIunits.ThermalConductivity k
                                                  "Thermal conductivity";
            parameter Modelica.SIunits.Length L(fixed=false)
                                                            "length of conduction";
            parameter Modelica.SIunits.Area A(fixed=false)
                                                          "Heat transfer area";
          end thermalConductor_b_2_rec;
        public
          thermalConductor_b_2_rec thermalConductor_b_2;
        protected
          record thermalConductor_a_3_rec
            constant Modelica.SIunits.HeatFlowRate Q_flow = 0.0
                                                               "Heat flow rate from port_a -> port_b";
            Modelica.SIunits.TemperatureDifference dT
                                                     "port_a.T - port_b.T";
          protected
            record port_a_rec
              Modelica.SIunits.Temperature T
                                            "Port temperature";
              constant Modelica.SIunits.HeatFlowRate Q_flow = 0.0
                                                                 "Heat flow rate (positive if flowing from outside into the component)";
            end port_a_rec;
          public
            port_a_rec port_a;
          protected
            record port_b_rec
              Modelica.SIunits.Temperature T
                                            "Port temperature";
              constant Modelica.SIunits.HeatFlowRate Q_flow = 0.0
                                                                 "Heat flow rate (positive if flowing from outside into the component)";
            end port_b_rec;
          public
            port_b_rec port_b;
            Modelica.SIunits.Temperature T
                                          "Average temperature of element";
            parameter Modelica.SIunits.Temperature T_start(fixed=false)
                                                                       "Start temperature for the average temperature of element";
            Modelica.SIunits.ThermalConductance G
                                                 "Thermal conductance of material";
            Modelica.SIunits.ThermalConductivity k
                                                  "Thermal conductivity";
            parameter Modelica.SIunits.Length L(fixed=false)
                                                            "length of conduction";
            parameter Modelica.SIunits.Area A(fixed=false)
                                                          "Heat transfer area";
          end thermalConductor_a_3_rec;
        public
          thermalConductor_a_3_rec thermalConductor_a_3;
        protected
          record thermalConductor_b_3_rec
            constant Modelica.SIunits.HeatFlowRate Q_flow = 0.0
                                                               "Heat flow rate from port_a -> port_b";
            Modelica.SIunits.TemperatureDifference dT
                                                     "port_a.T - port_b.T";
          protected
            record port_a_rec
              Modelica.SIunits.Temperature T
                                            "Port temperature";
              constant Modelica.SIunits.HeatFlowRate Q_flow = 0.0
                                                                 "Heat flow rate (positive if flowing from outside into the component)";
            end port_a_rec;
          public
            port_a_rec port_a;
          protected
            record port_b_rec
              Modelica.SIunits.Temperature T
                                            "Port temperature";
              constant Modelica.SIunits.HeatFlowRate Q_flow = 0.0
                                                                 "Heat flow rate (positive if flowing from outside into the component)";
            end port_b_rec;
          public
            port_b_rec port_b;
            Modelica.SIunits.Temperature T
                                          "Average temperature of element";
            parameter Modelica.SIunits.Temperature T_start(fixed=false)
                                                                       "Start temperature for the average temperature of element";
            Modelica.SIunits.ThermalConductance G
                                                 "Thermal conductance of material";
            Modelica.SIunits.ThermalConductivity k
                                                  "Thermal conductivity";
            parameter Modelica.SIunits.Length L(fixed=false)
                                                            "length of conduction";
            parameter Modelica.SIunits.Area A(fixed=false)
                                                          "Heat transfer area";
          end thermalConductor_b_3_rec;
        public
          thermalConductor_b_3_rec thermalConductor_b_3;
        protected
          record heatCapacitor_rec
            Modelica.SIunits.Temperature T
                                          "Temperature of element";
            Real T_der(unit = "K/s")
                                    "der(Temperature of element)";
            Modelica.SIunits.HeatFlowRate Q_flow;
            parameter Modelica.SIunits.Temperature T_start(fixed=false)
                                                                       "Start temperature for the average temperature of ellement";
          protected
            record port_rec
              Modelica.SIunits.Temperature T
                                            "Port temperature";
              Modelica.SIunits.HeatFlowRate Q_flow
                                                  "Heat flow rate (positive if flowing from outside into the component)";
            end port_rec;
          public
            port_rec port;
            parameter Modelica.SIunits.Volume V(fixed=false)
                                                            "Volume of element";
            parameter Modelica.SIunits.Mass m(fixed=false)
                                                          "Mass of element";
            Modelica.SIunits.TemperatureSlope der_T
                                                   "Time derivative of temperature (= der(T))";
            Modelica.SIunits.HeatCapacity C
                                           "Heat capacity of element (= cp*m)";
            parameter Modelica.SIunits.TemperatureSlope der_T_start(fixed=false)
                                                                                "Start value ofime derivative of temperature (= der(T))";
          end heatCapacitor_rec;
        public
          heatCapacitor_rec heatCapacitor;
        protected
          record port_int_rec
            Modelica.SIunits.Temperature T
                                          "Port temperature";
            constant Modelica.SIunits.HeatFlowRate Q_flow = 0.0
                                                               "Heat flow rate (positive if flowing from outside into the component)";
          end port_int_rec;
        public
          port_int_rec port_int;
        end 'thermalNode[1, 10, 1]_rec';
      public
        'thermalNode[1, 10, 1]_rec' 'thermalNode[1, 10, 1]' annotation(Dialog);
      protected
        record 'port_int[1, 1, 1]_rec'
          Modelica.SIunits.Temperature T
                                        "Port temperature";
          constant Modelica.SIunits.HeatFlowRate Q_flow = 0.0
                                                             "Heat flow rate (positive if flowing from outside into the component)";
        end 'port_int[1, 1, 1]_rec';
      public
        'port_int[1, 1, 1]_rec' 'port_int[1, 1, 1]';
      protected
        record 'port_int[1, 2, 1]_rec'
          Modelica.SIunits.Temperature T
                                        "Port temperature";
          constant Modelica.SIunits.HeatFlowRate Q_flow = 0.0
                                                             "Heat flow rate (positive if flowing from outside into the component)";
        end 'port_int[1, 2, 1]_rec';
      public
        'port_int[1, 2, 1]_rec' 'port_int[1, 2, 1]';
      protected
        record 'port_int[1, 3, 1]_rec'
          Modelica.SIunits.Temperature T
                                        "Port temperature";
          constant Modelica.SIunits.HeatFlowRate Q_flow = 0.0
                                                             "Heat flow rate (positive if flowing from outside into the component)";
        end 'port_int[1, 3, 1]_rec';
      public
        'port_int[1, 3, 1]_rec' 'port_int[1, 3, 1]';
      protected
        record 'port_int[1, 4, 1]_rec'
          Modelica.SIunits.Temperature T
                                        "Port temperature";
          constant Modelica.SIunits.HeatFlowRate Q_flow = 0.0
                                                             "Heat flow rate (positive if flowing from outside into the component)";
        end 'port_int[1, 4, 1]_rec';
      public
        'port_int[1, 4, 1]_rec' 'port_int[1, 4, 1]';
      protected
        record 'port_int[1, 5, 1]_rec'
          Modelica.SIunits.Temperature T
                                        "Port temperature";
          constant Modelica.SIunits.HeatFlowRate Q_flow = 0.0
                                                             "Heat flow rate (positive if flowing from outside into the component)";
        end 'port_int[1, 5, 1]_rec';
      public
        'port_int[1, 5, 1]_rec' 'port_int[1, 5, 1]';
      protected
        record 'port_int[1, 6, 1]_rec'
          Modelica.SIunits.Temperature T
                                        "Port temperature";
          constant Modelica.SIunits.HeatFlowRate Q_flow = 0.0
                                                             "Heat flow rate (positive if flowing from outside into the component)";
        end 'port_int[1, 6, 1]_rec';
      public
        'port_int[1, 6, 1]_rec' 'port_int[1, 6, 1]';
      protected
        record 'port_int[1, 7, 1]_rec'
          Modelica.SIunits.Temperature T
                                        "Port temperature";
          constant Modelica.SIunits.HeatFlowRate Q_flow = 0.0
                                                             "Heat flow rate (positive if flowing from outside into the component)";
        end 'port_int[1, 7, 1]_rec';
      public
        'port_int[1, 7, 1]_rec' 'port_int[1, 7, 1]';
      protected
        record 'port_int[1, 8, 1]_rec'
          Modelica.SIunits.Temperature T
                                        "Port temperature";
          constant Modelica.SIunits.HeatFlowRate Q_flow = 0.0
                                                             "Heat flow rate (positive if flowing from outside into the component)";
        end 'port_int[1, 8, 1]_rec';
      public
        'port_int[1, 8, 1]_rec' 'port_int[1, 8, 1]';
      protected
        record 'port_int[1, 9, 1]_rec'
          Modelica.SIunits.Temperature T
                                        "Port temperature";
          constant Modelica.SIunits.HeatFlowRate Q_flow = 0.0
                                                             "Heat flow rate (positive if flowing from outside into the component)";
        end 'port_int[1, 9, 1]_rec';
      public
        'port_int[1, 9, 1]_rec' 'port_int[1, 9, 1]';
      protected
        record 'port_int[1, 10, 1]_rec'
          Modelica.SIunits.Temperature T
                                        "Port temperature";
          constant Modelica.SIunits.HeatFlowRate Q_flow = 0.0
                                                             "Heat flow rate (positive if flowing from outside into the component)";
        end 'port_int[1, 10, 1]_rec';
      public
        'port_int[1, 10, 1]_rec' 'port_int[1, 10, 1]';
      end 'coilWall[1]_rec';
    public
      'coilWall[1]_rec' 'coilWall[1]' annotation(Dialog);
    protected
      record 'coilWall[2]_rec'
        parameter Real nParallel(min = 1.0, fixed=false)
                                                        "Number of identical parallel elements";
        constant Boolean use_portDim1 = true
                                            "Heat tranfer in 1st dimention";
        constant Boolean use_portDim2 = true
                                            "Heat tranfer in 2nd dimention";
        constant Boolean use_portDim3 = false
                                             "Heat tranfer in 3rd dimention";
        constant Integer nDim1(min = 1) = 1;
        constant Integer nDim2(min = 1) = 10;
        constant Integer nDim3(min = 1) = 1;
        constant Boolean use_dim1 = true
                                        "Heat tranfer in 1st dimention";
        constant Boolean use_dim2 = true
                                        "Heat tranfer in 2nd dimention";
        constant Boolean use_dim3 = false
                                         "Heat tranfer in 3rd dimention";
        parameter Modelica.SIunits.Temperature T_start(fixed=false)
                                                                   "Start temperature for the average temperature of cylinder";
        parameter Modelica.SIunits.TemperatureSlope der_T_start = 0
                                                                   "Start value ofime derivative of temperature (= der(T))";
        parameter Modelica.SIunits.Volume V(fixed=false)
                                                        "Volume of material";
        constant Boolean use_radialDim = true
                                             "Use heat transfer in radial direction";
        constant Boolean use_longitudinalDim = true
                                                   "Use heat transfer in longitudinal direction";
        constant Boolean use_angularDim = false
                                               "Use heat transfer in angular direction";
        constant Integer nRadial = 1;
        constant Integer nLongitudinal = 10;
        constant Integer nAngular = 1;
        parameter Modelica.SIunits.Length r_int(fixed=false)
                                                            "Inner radius of cylinder";
        parameter Modelica.SIunits.Length r_ext(fixed=false)
                                                            "Outer radius of cylinder";
        constant Modelica.SIunits.Length length = 5.0
                                                     "Length of cylinder";
        parameter Modelica.SIunits.Angle alpha = 6.283185307179586
                                                                  "Swept angle";
        parameter Modelica.SIunits.Area A_annulus(fixed=false)
                                                              "Annulus section area";
        constant Modelica.SIunits.Length length_node = 0.5;
        parameter Modelica.SIunits.Angle alpha_node(fixed=false);
        parameter Modelica.SIunits.Length 'rs[1]'(fixed=false);
        parameter Modelica.SIunits.Length 'rs[2]'(fixed=false);
        parameter Modelica.SIunits.Length 'rs_int[1,1,1]'(fixed=false);
        parameter Modelica.SIunits.Length 'rs_int[1,2,1]'(fixed=false);
        parameter Modelica.SIunits.Length 'rs_int[1,3,1]'(fixed=false);
        parameter Modelica.SIunits.Length 'rs_int[1,4,1]'(fixed=false);
        parameter Modelica.SIunits.Length 'rs_int[1,5,1]'(fixed=false);
        parameter Modelica.SIunits.Length 'rs_int[1,6,1]'(fixed=false);
        parameter Modelica.SIunits.Length 'rs_int[1,7,1]'(fixed=false);
        parameter Modelica.SIunits.Length 'rs_int[1,8,1]'(fixed=false);
        parameter Modelica.SIunits.Length 'rs_int[1,9,1]'(fixed=false);
        parameter Modelica.SIunits.Length 'rs_int[1,10,1]'(fixed=false);
        parameter Modelica.SIunits.Length 'rs_ext[1,1,1]'(fixed=false);
        parameter Modelica.SIunits.Length 'rs_ext[1,2,1]'(fixed=false);
        parameter Modelica.SIunits.Length 'rs_ext[1,3,1]'(fixed=false);
        parameter Modelica.SIunits.Length 'rs_ext[1,4,1]'(fixed=false);
        parameter Modelica.SIunits.Length 'rs_ext[1,5,1]'(fixed=false);
        parameter Modelica.SIunits.Length 'rs_ext[1,6,1]'(fixed=false);
        parameter Modelica.SIunits.Length 'rs_ext[1,7,1]'(fixed=false);
        parameter Modelica.SIunits.Length 'rs_ext[1,8,1]'(fixed=false);
        parameter Modelica.SIunits.Length 'rs_ext[1,9,1]'(fixed=false);
        parameter Modelica.SIunits.Length 'rs_ext[1,10,1]'(fixed=false);
        parameter Modelica.SIunits.Length 'rs_avg[1,1,1]'(fixed=false);
        parameter Modelica.SIunits.Length 'rs_avg[1,2,1]'(fixed=false);
        parameter Modelica.SIunits.Length 'rs_avg[1,3,1]'(fixed=false);
        parameter Modelica.SIunits.Length 'rs_avg[1,4,1]'(fixed=false);
        parameter Modelica.SIunits.Length 'rs_avg[1,5,1]'(fixed=false);
        parameter Modelica.SIunits.Length 'rs_avg[1,6,1]'(fixed=false);
        parameter Modelica.SIunits.Length 'rs_avg[1,7,1]'(fixed=false);
        parameter Modelica.SIunits.Length 'rs_avg[1,8,1]'(fixed=false);
        parameter Modelica.SIunits.Length 'rs_avg[1,9,1]'(fixed=false);
        parameter Modelica.SIunits.Length 'rs_avg[1,10,1]'(fixed=false);
        parameter Modelica.SIunits.Length 'arcs[1,1,1]'(fixed=false);
        parameter Modelica.SIunits.Length 'arcs[1,2,1]'(fixed=false);
        parameter Modelica.SIunits.Length 'arcs[1,3,1]'(fixed=false);
        parameter Modelica.SIunits.Length 'arcs[1,4,1]'(fixed=false);
        parameter Modelica.SIunits.Length 'arcs[1,5,1]'(fixed=false);
        parameter Modelica.SIunits.Length 'arcs[1,6,1]'(fixed=false);
        parameter Modelica.SIunits.Length 'arcs[1,7,1]'(fixed=false);
        parameter Modelica.SIunits.Length 'arcs[1,8,1]'(fixed=false);
        parameter Modelica.SIunits.Length 'arcs[1,9,1]'(fixed=false);
        parameter Modelica.SIunits.Length 'arcs[1,10,1]'(fixed=false);
        parameter Modelica.SIunits.Area 'As_annulus[1,1,1]'(fixed=false)
                                                                        "Annulus section area";
        parameter Modelica.SIunits.Area 'As_annulus[1,2,1]'(fixed=false)
                                                                        "Annulus section area";
        parameter Modelica.SIunits.Area 'As_annulus[1,3,1]'(fixed=false)
                                                                        "Annulus section area";
        parameter Modelica.SIunits.Area 'As_annulus[1,4,1]'(fixed=false)
                                                                        "Annulus section area";
        parameter Modelica.SIunits.Area 'As_annulus[1,5,1]'(fixed=false)
                                                                        "Annulus section area";
        parameter Modelica.SIunits.Area 'As_annulus[1,6,1]'(fixed=false)
                                                                        "Annulus section area";
        parameter Modelica.SIunits.Area 'As_annulus[1,7,1]'(fixed=false)
                                                                        "Annulus section area";
        parameter Modelica.SIunits.Area 'As_annulus[1,8,1]'(fixed=false)
                                                                        "Annulus section area";
        parameter Modelica.SIunits.Area 'As_annulus[1,9,1]'(fixed=false)
                                                                        "Annulus section area";
        parameter Modelica.SIunits.Area 'As_annulus[1,10,1]'(fixed=false)
                                                                         "Annulus section area";
      protected
        record 'port_a_1[1, 1]_rec'
          Modelica.SIunits.Temperature T
                                        "Port temperature";
          Modelica.SIunits.HeatFlowRate Q_flow
                                              "Heat flow rate (positive if flowing from outside into the component)";
        end 'port_a_1[1, 1]_rec';
      public
        'port_a_1[1, 1]_rec' 'port_a_1[1, 1]';
      protected
        record 'port_a_1[1, 2]_rec'
          Modelica.SIunits.Temperature T
                                        "Port temperature";
          Modelica.SIunits.HeatFlowRate Q_flow
                                              "Heat flow rate (positive if flowing from outside into the component)";
        end 'port_a_1[1, 2]_rec';
      public
        'port_a_1[1, 2]_rec' 'port_a_1[1, 2]';
      protected
        record 'port_a_1[1, 3]_rec'
          Modelica.SIunits.Temperature T
                                        "Port temperature";
          Modelica.SIunits.HeatFlowRate Q_flow
                                              "Heat flow rate (positive if flowing from outside into the component)";
        end 'port_a_1[1, 3]_rec';
      public
        'port_a_1[1, 3]_rec' 'port_a_1[1, 3]';
      protected
        record 'port_a_1[1, 4]_rec'
          Modelica.SIunits.Temperature T
                                        "Port temperature";
          Modelica.SIunits.HeatFlowRate Q_flow
                                              "Heat flow rate (positive if flowing from outside into the component)";
        end 'port_a_1[1, 4]_rec';
      public
        'port_a_1[1, 4]_rec' 'port_a_1[1, 4]';
      protected
        record 'port_a_1[1, 5]_rec'
          Modelica.SIunits.Temperature T
                                        "Port temperature";
          Modelica.SIunits.HeatFlowRate Q_flow
                                              "Heat flow rate (positive if flowing from outside into the component)";
        end 'port_a_1[1, 5]_rec';
      public
        'port_a_1[1, 5]_rec' 'port_a_1[1, 5]';
      protected
        record 'port_a_1[1, 6]_rec'
          Modelica.SIunits.Temperature T
                                        "Port temperature";
          Modelica.SIunits.HeatFlowRate Q_flow
                                              "Heat flow rate (positive if flowing from outside into the component)";
        end 'port_a_1[1, 6]_rec';
      public
        'port_a_1[1, 6]_rec' 'port_a_1[1, 6]';
      protected
        record 'port_a_1[1, 7]_rec'
          Modelica.SIunits.Temperature T
                                        "Port temperature";
          Modelica.SIunits.HeatFlowRate Q_flow
                                              "Heat flow rate (positive if flowing from outside into the component)";
        end 'port_a_1[1, 7]_rec';
      public
        'port_a_1[1, 7]_rec' 'port_a_1[1, 7]';
      protected
        record 'port_a_1[1, 8]_rec'
          Modelica.SIunits.Temperature T
                                        "Port temperature";
          Modelica.SIunits.HeatFlowRate Q_flow
                                              "Heat flow rate (positive if flowing from outside into the component)";
        end 'port_a_1[1, 8]_rec';
      public
        'port_a_1[1, 8]_rec' 'port_a_1[1, 8]';
      protected
        record 'port_a_1[1, 9]_rec'
          Modelica.SIunits.Temperature T
                                        "Port temperature";
          Modelica.SIunits.HeatFlowRate Q_flow
                                              "Heat flow rate (positive if flowing from outside into the component)";
        end 'port_a_1[1, 9]_rec';
      public
        'port_a_1[1, 9]_rec' 'port_a_1[1, 9]';
      protected
        record 'port_a_1[1, 10]_rec'
          Modelica.SIunits.Temperature T
                                        "Port temperature";
          Modelica.SIunits.HeatFlowRate Q_flow
                                              "Heat flow rate (positive if flowing from outside into the component)";
        end 'port_a_1[1, 10]_rec';
      public
        'port_a_1[1, 10]_rec' 'port_a_1[1, 10]';
      protected
        record 'port_b_1[1, 1]_rec'
          Modelica.SIunits.Temperature T
                                        "Port temperature";
          Modelica.SIunits.HeatFlowRate Q_flow
                                              "Heat flow rate (positive if flowing from outside into the component)";
        end 'port_b_1[1, 1]_rec';
      public
        'port_b_1[1, 1]_rec' 'port_b_1[1, 1]';
      protected
        record 'port_b_1[1, 2]_rec'
          Modelica.SIunits.Temperature T
                                        "Port temperature";
          Modelica.SIunits.HeatFlowRate Q_flow
                                              "Heat flow rate (positive if flowing from outside into the component)";
        end 'port_b_1[1, 2]_rec';
      public
        'port_b_1[1, 2]_rec' 'port_b_1[1, 2]';
      protected
        record 'port_b_1[1, 3]_rec'
          Modelica.SIunits.Temperature T
                                        "Port temperature";
          Modelica.SIunits.HeatFlowRate Q_flow
                                              "Heat flow rate (positive if flowing from outside into the component)";
        end 'port_b_1[1, 3]_rec';
      public
        'port_b_1[1, 3]_rec' 'port_b_1[1, 3]';
      protected
        record 'port_b_1[1, 4]_rec'
          Modelica.SIunits.Temperature T
                                        "Port temperature";
          Modelica.SIunits.HeatFlowRate Q_flow
                                              "Heat flow rate (positive if flowing from outside into the component)";
        end 'port_b_1[1, 4]_rec';
      public
        'port_b_1[1, 4]_rec' 'port_b_1[1, 4]';
      protected
        record 'port_b_1[1, 5]_rec'
          Modelica.SIunits.Temperature T
                                        "Port temperature";
          Modelica.SIunits.HeatFlowRate Q_flow
                                              "Heat flow rate (positive if flowing from outside into the component)";
        end 'port_b_1[1, 5]_rec';
      public
        'port_b_1[1, 5]_rec' 'port_b_1[1, 5]';
      protected
        record 'port_b_1[1, 6]_rec'
          Modelica.SIunits.Temperature T
                                        "Port temperature";
          Modelica.SIunits.HeatFlowRate Q_flow
                                              "Heat flow rate (positive if flowing from outside into the component)";
        end 'port_b_1[1, 6]_rec';
      public
        'port_b_1[1, 6]_rec' 'port_b_1[1, 6]';
      protected
        record 'port_b_1[1, 7]_rec'
          Modelica.SIunits.Temperature T
                                        "Port temperature";
          Modelica.SIunits.HeatFlowRate Q_flow
                                              "Heat flow rate (positive if flowing from outside into the component)";
        end 'port_b_1[1, 7]_rec';
      public
        'port_b_1[1, 7]_rec' 'port_b_1[1, 7]';
      protected
        record 'port_b_1[1, 8]_rec'
          Modelica.SIunits.Temperature T
                                        "Port temperature";
          Modelica.SIunits.HeatFlowRate Q_flow
                                              "Heat flow rate (positive if flowing from outside into the component)";
        end 'port_b_1[1, 8]_rec';
      public
        'port_b_1[1, 8]_rec' 'port_b_1[1, 8]';
      protected
        record 'port_b_1[1, 9]_rec'
          Modelica.SIunits.Temperature T
                                        "Port temperature";
          Modelica.SIunits.HeatFlowRate Q_flow
                                              "Heat flow rate (positive if flowing from outside into the component)";
        end 'port_b_1[1, 9]_rec';
      public
        'port_b_1[1, 9]_rec' 'port_b_1[1, 9]';
      protected
        record 'port_b_1[1, 10]_rec'
          Modelica.SIunits.Temperature T
                                        "Port temperature";
          Modelica.SIunits.HeatFlowRate Q_flow
                                              "Heat flow rate (positive if flowing from outside into the component)";
        end 'port_b_1[1, 10]_rec';
      public
        'port_b_1[1, 10]_rec' 'port_b_1[1, 10]';
      protected
        record 'port_a_2[1, 1]_rec'
          Modelica.SIunits.Temperature T
                                        "Port temperature";
          constant Modelica.SIunits.HeatFlowRate Q_flow = 0.0
                                                             "Heat flow rate (positive if flowing from outside into the component)";
        end 'port_a_2[1, 1]_rec';
      public
        'port_a_2[1, 1]_rec' 'port_a_2[1, 1]';
      protected
        record 'port_b_2[1, 1]_rec'
          Modelica.SIunits.Temperature T
                                        "Port temperature";
          constant Modelica.SIunits.HeatFlowRate Q_flow = 0.0
                                                             "Heat flow rate (positive if flowing from outside into the component)";
        end 'port_b_2[1, 1]_rec';
      public
        'port_b_2[1, 1]_rec' 'port_b_2[1, 1]';
      protected
        record 'thermalNode[1, 1, 1]_rec'
          parameter Real nParallel(min = 1.0) = 1
                                                 "Number of identical parallel elements";
          constant Boolean use_portDim1 = true
                                              "Heat tranfer in 1st dimention";
          constant Boolean use_portDim2 = true
                                              "Heat tranfer in 2nd dimention";
          constant Boolean use_portDim3 = false
                                               "Heat tranfer in 3rd dimention";
        protected
          record port_a_1_rec
            Modelica.SIunits.Temperature T
                                          "Port temperature";
            Modelica.SIunits.HeatFlowRate Q_flow
                                                "Heat flow rate (positive if flowing from outside into the component)";
          end port_a_1_rec;
        public
          port_a_1_rec port_a_1;
        protected
          record port_b_1_rec
            Modelica.SIunits.Temperature T
                                          "Port temperature";
            Modelica.SIunits.HeatFlowRate Q_flow
                                                "Heat flow rate (positive if flowing from outside into the component)";
          end port_b_1_rec;
        public
          port_b_1_rec port_b_1;
        protected
          record port_a_2_rec
            Modelica.SIunits.Temperature T
                                          "Port temperature";
            constant Modelica.SIunits.HeatFlowRate Q_flow = 0.0
                                                               "Heat flow rate (positive if flowing from outside into the component)";
          end port_a_2_rec;
        public
          port_a_2_rec port_a_2;
        protected
          record port_b_2_rec
            Modelica.SIunits.Temperature T
                                          "Port temperature";
            Modelica.SIunits.HeatFlowRate Q_flow
                                                "Heat flow rate (positive if flowing from outside into the component)";
          end port_b_2_rec;
        public
          port_b_2_rec port_b_2;
          parameter Modelica.SIunits.Volume V(fixed=false)
                                                          "Volume of material";
        protected
          record thermalConductor_a_1_rec
            Modelica.SIunits.HeatFlowRate Q_flow
                                                "Heat flow rate from port_a -> port_b";
            Modelica.SIunits.TemperatureDifference dT
                                                     "port_a.T - port_b.T";
          protected
            record port_a_rec
              Modelica.SIunits.Temperature T
                                            "Port temperature";
              Modelica.SIunits.HeatFlowRate Q_flow
                                                  "Heat flow rate (positive if flowing from outside into the component)";
            end port_a_rec;
          public
            port_a_rec port_a;
          protected
            record port_b_rec
              Modelica.SIunits.Temperature T
                                            "Port temperature";
              Modelica.SIunits.HeatFlowRate Q_flow
                                                  "Heat flow rate (positive if flowing from outside into the component)";
            end port_b_rec;
          public
            port_b_rec port_b;
            Modelica.SIunits.Temperature T
                                          "Average temperature of element";
            parameter Modelica.SIunits.Temperature T_start(fixed=false)
                                                                       "Start temperature for the average temperature of element";
            Modelica.SIunits.ThermalConductance G
                                                 "Thermal conductance of material";
            Modelica.SIunits.ThermalConductivity k
                                                  "Thermal conductivity";
            parameter Modelica.SIunits.Length r_internal(fixed=false)
                                                                     "Inner radius of cylinder";
            parameter Modelica.SIunits.Length r_external(fixed=false)
                                                                     "Outer radius of cylinder";
            parameter Modelica.SIunits.Length L(fixed=false)
                                                            "Length of cylinder";
            parameter Modelica.SIunits.Angle alpha(fixed=false)
                                                               "Swept angle";
          end thermalConductor_a_1_rec;
        public
          thermalConductor_a_1_rec thermalConductor_a_1;
        protected
          record thermalConductor_b_1_rec
            Modelica.SIunits.HeatFlowRate Q_flow
                                                "Heat flow rate from port_a -> port_b";
            Modelica.SIunits.TemperatureDifference dT
                                                     "port_a.T - port_b.T";
          protected
            record port_a_rec
              Modelica.SIunits.Temperature T
                                            "Port temperature";
              Modelica.SIunits.HeatFlowRate Q_flow
                                                  "Heat flow rate (positive if flowing from outside into the component)";
            end port_a_rec;
          public
            port_a_rec port_a;
          protected
            record port_b_rec
              Modelica.SIunits.Temperature T
                                            "Port temperature";
              Modelica.SIunits.HeatFlowRate Q_flow
                                                  "Heat flow rate (positive if flowing from outside into the component)";
            end port_b_rec;
          public
            port_b_rec port_b;
            Modelica.SIunits.Temperature T
                                          "Average temperature of element";
            parameter Modelica.SIunits.Temperature T_start(fixed=false)
                                                                       "Start temperature for the average temperature of element";
            Modelica.SIunits.ThermalConductance G
                                                 "Thermal conductance of material";
            Modelica.SIunits.ThermalConductivity k
                                                  "Thermal conductivity";
            parameter Modelica.SIunits.Length r_internal(fixed=false)
                                                                     "Inner radius of cylinder";
            parameter Modelica.SIunits.Length r_external(fixed=false)
                                                                     "Outer radius of cylinder";
            parameter Modelica.SIunits.Length L(fixed=false)
                                                            "Length of cylinder";
            parameter Modelica.SIunits.Angle alpha(fixed=false)
                                                               "Swept angle";
          end thermalConductor_b_1_rec;
        public
          thermalConductor_b_1_rec thermalConductor_b_1;
        protected
          record thermalConductor_a_2_rec
            constant Modelica.SIunits.HeatFlowRate Q_flow = 0.0
                                                               "Heat flow rate from port_a -> port_b";
            Modelica.SIunits.TemperatureDifference dT
                                                     "port_a.T - port_b.T";
          protected
            record port_a_rec
              Modelica.SIunits.Temperature T
                                            "Port temperature";
              constant Modelica.SIunits.HeatFlowRate Q_flow = 0.0
                                                                 "Heat flow rate (positive if flowing from outside into the component)";
            end port_a_rec;
          public
            port_a_rec port_a;
          protected
            record port_b_rec
              Modelica.SIunits.Temperature T
                                            "Port temperature";
              constant Modelica.SIunits.HeatFlowRate Q_flow = 0.0
                                                                 "Heat flow rate (positive if flowing from outside into the component)";
            end port_b_rec;
          public
            port_b_rec port_b;
            Modelica.SIunits.Temperature T
                                          "Average temperature of element";
            parameter Modelica.SIunits.Temperature T_start(fixed=false)
                                                                       "Start temperature for the average temperature of element";
            Modelica.SIunits.ThermalConductance G
                                                 "Thermal conductance of material";
            Modelica.SIunits.ThermalConductivity k
                                                  "Thermal conductivity";
            parameter Modelica.SIunits.Length L(fixed=false)
                                                            "length of conduction";
            parameter Modelica.SIunits.Area A(fixed=false)
                                                          "Heat transfer area";
          end thermalConductor_a_2_rec;
        public
          thermalConductor_a_2_rec thermalConductor_a_2;
        protected
          record thermalConductor_b_2_rec
            Modelica.SIunits.HeatFlowRate Q_flow
                                                "Heat flow rate from port_a -> port_b";
            Modelica.SIunits.TemperatureDifference dT
                                                     "port_a.T - port_b.T";
          protected
            record port_a_rec
              Modelica.SIunits.Temperature T
                                            "Port temperature";
              Modelica.SIunits.HeatFlowRate Q_flow
                                                  "Heat flow rate (positive if flowing from outside into the component)";
            end port_a_rec;
          public
            port_a_rec port_a;
          protected
            record port_b_rec
              Modelica.SIunits.Temperature T
                                            "Port temperature";
              Modelica.SIunits.HeatFlowRate Q_flow
                                                  "Heat flow rate (positive if flowing from outside into the component)";
            end port_b_rec;
          public
            port_b_rec port_b;
            Modelica.SIunits.Temperature T
                                          "Average temperature of element";
            parameter Modelica.SIunits.Temperature T_start(fixed=false)
                                                                       "Start temperature for the average temperature of element";
            Modelica.SIunits.ThermalConductance G
                                                 "Thermal conductance of material";
            Modelica.SIunits.ThermalConductivity k
                                                  "Thermal conductivity";
            parameter Modelica.SIunits.Length L(fixed=false)
                                                            "length of conduction";
            parameter Modelica.SIunits.Area A(fixed=false)
                                                          "Heat transfer area";
          end thermalConductor_b_2_rec;
        public
          thermalConductor_b_2_rec thermalConductor_b_2;
        protected
          record thermalConductor_a_3_rec
            constant Modelica.SIunits.HeatFlowRate Q_flow = 0.0
                                                               "Heat flow rate from port_a -> port_b";
            Modelica.SIunits.TemperatureDifference dT
                                                     "port_a.T - port_b.T";
          protected
            record port_a_rec
              Modelica.SIunits.Temperature T
                                            "Port temperature";
              constant Modelica.SIunits.HeatFlowRate Q_flow = 0.0
                                                                 "Heat flow rate (positive if flowing from outside into the component)";
            end port_a_rec;
          public
            port_a_rec port_a;
          protected
            record port_b_rec
              Modelica.SIunits.Temperature T
                                            "Port temperature";
              constant Modelica.SIunits.HeatFlowRate Q_flow = 0.0
                                                                 "Heat flow rate (positive if flowing from outside into the component)";
            end port_b_rec;
          public
            port_b_rec port_b;
            Modelica.SIunits.Temperature T
                                          "Average temperature of element";
            parameter Modelica.SIunits.Temperature T_start(fixed=false)
                                                                       "Start temperature for the average temperature of element";
            Modelica.SIunits.ThermalConductance G
                                                 "Thermal conductance of material";
            Modelica.SIunits.ThermalConductivity k
                                                  "Thermal conductivity";
            parameter Modelica.SIunits.Length L(fixed=false)
                                                            "length of conduction";
            parameter Modelica.SIunits.Area A(fixed=false)
                                                          "Heat transfer area";
          end thermalConductor_a_3_rec;
        public
          thermalConductor_a_3_rec thermalConductor_a_3;
        protected
          record thermalConductor_b_3_rec
            constant Modelica.SIunits.HeatFlowRate Q_flow = 0.0
                                                               "Heat flow rate from port_a -> port_b";
            Modelica.SIunits.TemperatureDifference dT
                                                     "port_a.T - port_b.T";
          protected
            record port_a_rec
              Modelica.SIunits.Temperature T
                                            "Port temperature";
              constant Modelica.SIunits.HeatFlowRate Q_flow = 0.0
                                                                 "Heat flow rate (positive if flowing from outside into the component)";
            end port_a_rec;
          public
            port_a_rec port_a;
          protected
            record port_b_rec
              Modelica.SIunits.Temperature T
                                            "Port temperature";
              constant Modelica.SIunits.HeatFlowRate Q_flow = 0.0
                                                                 "Heat flow rate (positive if flowing from outside into the component)";
            end port_b_rec;
          public
            port_b_rec port_b;
            Modelica.SIunits.Temperature T
                                          "Average temperature of element";
            parameter Modelica.SIunits.Temperature T_start(fixed=false)
                                                                       "Start temperature for the average temperature of element";
            Modelica.SIunits.ThermalConductance G
                                                 "Thermal conductance of material";
            Modelica.SIunits.ThermalConductivity k
                                                  "Thermal conductivity";
            parameter Modelica.SIunits.Length L(fixed=false)
                                                            "length of conduction";
            parameter Modelica.SIunits.Area A(fixed=false)
                                                          "Heat transfer area";
          end thermalConductor_b_3_rec;
        public
          thermalConductor_b_3_rec thermalConductor_b_3;
        protected
          record heatCapacitor_rec
            Modelica.SIunits.Temperature T
                                          "Temperature of element";
            Real T_der(unit = "K/s")
                                    "der(Temperature of element)";
            Modelica.SIunits.HeatFlowRate Q_flow;
            parameter Modelica.SIunits.Temperature T_start(fixed=false)
                                                                       "Start temperature for the average temperature of ellement";
          protected
            record port_rec
              Modelica.SIunits.Temperature T
                                            "Port temperature";
              Modelica.SIunits.HeatFlowRate Q_flow
                                                  "Heat flow rate (positive if flowing from outside into the component)";
            end port_rec;
          public
            port_rec port;
            parameter Modelica.SIunits.Volume V(fixed=false)
                                                            "Volume of element";
            parameter Modelica.SIunits.Mass m(fixed=false)
                                                          "Mass of element";
            Modelica.SIunits.TemperatureSlope der_T
                                                   "Time derivative of temperature (= der(T))";
            Modelica.SIunits.HeatCapacity C
                                           "Heat capacity of element (= cp*m)";
            parameter Modelica.SIunits.TemperatureSlope der_T_start(fixed=false)
                                                                                "Start value ofime derivative of temperature (= der(T))";
          end heatCapacitor_rec;
        public
          heatCapacitor_rec heatCapacitor;
        protected
          record port_int_rec
            Modelica.SIunits.Temperature T
                                          "Port temperature";
            constant Modelica.SIunits.HeatFlowRate Q_flow = 0.0
                                                               "Heat flow rate (positive if flowing from outside into the component)";
          end port_int_rec;
        public
          port_int_rec port_int;
        end 'thermalNode[1, 1, 1]_rec';
      public
        'thermalNode[1, 1, 1]_rec' 'thermalNode[1, 1, 1]' annotation(Dialog);
      protected
        record 'thermalNode[1, 2, 1]_rec'
          parameter Real nParallel(min = 1.0) = 1
                                                 "Number of identical parallel elements";
          constant Boolean use_portDim1 = true
                                              "Heat tranfer in 1st dimention";
          constant Boolean use_portDim2 = true
                                              "Heat tranfer in 2nd dimention";
          constant Boolean use_portDim3 = false
                                               "Heat tranfer in 3rd dimention";
        protected
          record port_a_1_rec
            Modelica.SIunits.Temperature T
                                          "Port temperature";
            Modelica.SIunits.HeatFlowRate Q_flow
                                                "Heat flow rate (positive if flowing from outside into the component)";
          end port_a_1_rec;
        public
          port_a_1_rec port_a_1;
        protected
          record port_b_1_rec
            Modelica.SIunits.Temperature T
                                          "Port temperature";
            Modelica.SIunits.HeatFlowRate Q_flow
                                                "Heat flow rate (positive if flowing from outside into the component)";
          end port_b_1_rec;
        public
          port_b_1_rec port_b_1;
        protected
          record port_a_2_rec
            Modelica.SIunits.Temperature T
                                          "Port temperature";
            Modelica.SIunits.HeatFlowRate Q_flow
                                                "Heat flow rate (positive if flowing from outside into the component)";
          end port_a_2_rec;
        public
          port_a_2_rec port_a_2;
        protected
          record port_b_2_rec
            Modelica.SIunits.Temperature T
                                          "Port temperature";
            Modelica.SIunits.HeatFlowRate Q_flow
                                                "Heat flow rate (positive if flowing from outside into the component)";
          end port_b_2_rec;
        public
          port_b_2_rec port_b_2;
          parameter Modelica.SIunits.Volume V(fixed=false)
                                                          "Volume of material";
        protected
          record thermalConductor_a_1_rec
            Modelica.SIunits.HeatFlowRate Q_flow
                                                "Heat flow rate from port_a -> port_b";
            Modelica.SIunits.TemperatureDifference dT
                                                     "port_a.T - port_b.T";
          protected
            record port_a_rec
              Modelica.SIunits.Temperature T
                                            "Port temperature";
              Modelica.SIunits.HeatFlowRate Q_flow
                                                  "Heat flow rate (positive if flowing from outside into the component)";
            end port_a_rec;
          public
            port_a_rec port_a;
          protected
            record port_b_rec
              Modelica.SIunits.Temperature T
                                            "Port temperature";
              Modelica.SIunits.HeatFlowRate Q_flow
                                                  "Heat flow rate (positive if flowing from outside into the component)";
            end port_b_rec;
          public
            port_b_rec port_b;
            Modelica.SIunits.Temperature T
                                          "Average temperature of element";
            parameter Modelica.SIunits.Temperature T_start(fixed=false)
                                                                       "Start temperature for the average temperature of element";
            Modelica.SIunits.ThermalConductance G
                                                 "Thermal conductance of material";
            Modelica.SIunits.ThermalConductivity k
                                                  "Thermal conductivity";
            parameter Modelica.SIunits.Length r_internal(fixed=false)
                                                                     "Inner radius of cylinder";
            parameter Modelica.SIunits.Length r_external(fixed=false)
                                                                     "Outer radius of cylinder";
            parameter Modelica.SIunits.Length L(fixed=false)
                                                            "Length of cylinder";
            parameter Modelica.SIunits.Angle alpha(fixed=false)
                                                               "Swept angle";
          end thermalConductor_a_1_rec;
        public
          thermalConductor_a_1_rec thermalConductor_a_1;
        protected
          record thermalConductor_b_1_rec
            Modelica.SIunits.HeatFlowRate Q_flow
                                                "Heat flow rate from port_a -> port_b";
            Modelica.SIunits.TemperatureDifference dT
                                                     "port_a.T - port_b.T";
          protected
            record port_a_rec
              Modelica.SIunits.Temperature T
                                            "Port temperature";
              Modelica.SIunits.HeatFlowRate Q_flow
                                                  "Heat flow rate (positive if flowing from outside into the component)";
            end port_a_rec;
          public
            port_a_rec port_a;
          protected
            record port_b_rec
              Modelica.SIunits.Temperature T
                                            "Port temperature";
              Modelica.SIunits.HeatFlowRate Q_flow
                                                  "Heat flow rate (positive if flowing from outside into the component)";
            end port_b_rec;
          public
            port_b_rec port_b;
            Modelica.SIunits.Temperature T
                                          "Average temperature of element";
            parameter Modelica.SIunits.Temperature T_start(fixed=false)
                                                                       "Start temperature for the average temperature of element";
            Modelica.SIunits.ThermalConductance G
                                                 "Thermal conductance of material";
            Modelica.SIunits.ThermalConductivity k
                                                  "Thermal conductivity";
            parameter Modelica.SIunits.Length r_internal(fixed=false)
                                                                     "Inner radius of cylinder";
            parameter Modelica.SIunits.Length r_external(fixed=false)
                                                                     "Outer radius of cylinder";
            parameter Modelica.SIunits.Length L(fixed=false)
                                                            "Length of cylinder";
            parameter Modelica.SIunits.Angle alpha(fixed=false)
                                                               "Swept angle";
          end thermalConductor_b_1_rec;
        public
          thermalConductor_b_1_rec thermalConductor_b_1;
        protected
          record thermalConductor_a_2_rec
            Modelica.SIunits.HeatFlowRate Q_flow
                                                "Heat flow rate from port_a -> port_b";
            Modelica.SIunits.TemperatureDifference dT
                                                     "port_a.T - port_b.T";
          protected
            record port_a_rec
              Modelica.SIunits.Temperature T
                                            "Port temperature";
              Modelica.SIunits.HeatFlowRate Q_flow
                                                  "Heat flow rate (positive if flowing from outside into the component)";
            end port_a_rec;
          public
            port_a_rec port_a;
          protected
            record port_b_rec
              Modelica.SIunits.Temperature T
                                            "Port temperature";
              Modelica.SIunits.HeatFlowRate Q_flow
                                                  "Heat flow rate (positive if flowing from outside into the component)";
            end port_b_rec;
          public
            port_b_rec port_b;
            Modelica.SIunits.Temperature T
                                          "Average temperature of element";
            parameter Modelica.SIunits.Temperature T_start(fixed=false)
                                                                       "Start temperature for the average temperature of element";
            Modelica.SIunits.ThermalConductance G
                                                 "Thermal conductance of material";
            Modelica.SIunits.ThermalConductivity k
                                                  "Thermal conductivity";
            parameter Modelica.SIunits.Length L(fixed=false)
                                                            "length of conduction";
            parameter Modelica.SIunits.Area A(fixed=false)
                                                          "Heat transfer area";
          end thermalConductor_a_2_rec;
        public
          thermalConductor_a_2_rec thermalConductor_a_2;
        protected
          record thermalConductor_b_2_rec
            Modelica.SIunits.HeatFlowRate Q_flow
                                                "Heat flow rate from port_a -> port_b";
            Modelica.SIunits.TemperatureDifference dT
                                                     "port_a.T - port_b.T";
          protected
            record port_a_rec
              Modelica.SIunits.Temperature T
                                            "Port temperature";
              Modelica.SIunits.HeatFlowRate Q_flow
                                                  "Heat flow rate (positive if flowing from outside into the component)";
            end port_a_rec;
          public
            port_a_rec port_a;
          protected
            record port_b_rec
              Modelica.SIunits.Temperature T
                                            "Port temperature";
              Modelica.SIunits.HeatFlowRate Q_flow
                                                  "Heat flow rate (positive if flowing from outside into the component)";
            end port_b_rec;
          public
            port_b_rec port_b;
            Modelica.SIunits.Temperature T
                                          "Average temperature of element";
            parameter Modelica.SIunits.Temperature T_start(fixed=false)
                                                                       "Start temperature for the average temperature of element";
            Modelica.SIunits.ThermalConductance G
                                                 "Thermal conductance of material";
            Modelica.SIunits.ThermalConductivity k
                                                  "Thermal conductivity";
            parameter Modelica.SIunits.Length L(fixed=false)
                                                            "length of conduction";
            parameter Modelica.SIunits.Area A(fixed=false)
                                                          "Heat transfer area";
          end thermalConductor_b_2_rec;
        public
          thermalConductor_b_2_rec thermalConductor_b_2;
        protected
          record thermalConductor_a_3_rec
            constant Modelica.SIunits.HeatFlowRate Q_flow = 0.0
                                                               "Heat flow rate from port_a -> port_b";
            Modelica.SIunits.TemperatureDifference dT
                                                     "port_a.T - port_b.T";
          protected
            record port_a_rec
              Modelica.SIunits.Temperature T
                                            "Port temperature";
              constant Modelica.SIunits.HeatFlowRate Q_flow = 0.0
                                                                 "Heat flow rate (positive if flowing from outside into the component)";
            end port_a_rec;
          public
            port_a_rec port_a;
          protected
            record port_b_rec
              Modelica.SIunits.Temperature T
                                            "Port temperature";
              constant Modelica.SIunits.HeatFlowRate Q_flow = 0.0
                                                                 "Heat flow rate (positive if flowing from outside into the component)";
            end port_b_rec;
          public
            port_b_rec port_b;
            Modelica.SIunits.Temperature T
                                          "Average temperature of element";
            parameter Modelica.SIunits.Temperature T_start(fixed=false)
                                                                       "Start temperature for the average temperature of element";
            Modelica.SIunits.ThermalConductance G
                                                 "Thermal conductance of material";
            Modelica.SIunits.ThermalConductivity k
                                                  "Thermal conductivity";
            parameter Modelica.SIunits.Length L(fixed=false)
                                                            "length of conduction";
            parameter Modelica.SIunits.Area A(fixed=false)
                                                          "Heat transfer area";
          end thermalConductor_a_3_rec;
        public
          thermalConductor_a_3_rec thermalConductor_a_3;
        protected
          record thermalConductor_b_3_rec
            constant Modelica.SIunits.HeatFlowRate Q_flow = 0.0
                                                               "Heat flow rate from port_a -> port_b";
            Modelica.SIunits.TemperatureDifference dT
                                                     "port_a.T - port_b.T";
          protected
            record port_a_rec
              Modelica.SIunits.Temperature T
                                            "Port temperature";
              constant Modelica.SIunits.HeatFlowRate Q_flow = 0.0
                                                                 "Heat flow rate (positive if flowing from outside into the component)";
            end port_a_rec;
          public
            port_a_rec port_a;
          protected
            record port_b_rec
              Modelica.SIunits.Temperature T
                                            "Port temperature";
              constant Modelica.SIunits.HeatFlowRate Q_flow = 0.0
                                                                 "Heat flow rate (positive if flowing from outside into the component)";
            end port_b_rec;
          public
            port_b_rec port_b;
            Modelica.SIunits.Temperature T
                                          "Average temperature of element";
            parameter Modelica.SIunits.Temperature T_start(fixed=false)
                                                                       "Start temperature for the average temperature of element";
            Modelica.SIunits.ThermalConductance G
                                                 "Thermal conductance of material";
            Modelica.SIunits.ThermalConductivity k
                                                  "Thermal conductivity";
            parameter Modelica.SIunits.Length L(fixed=false)
                                                            "length of conduction";
            parameter Modelica.SIunits.Area A(fixed=false)
                                                          "Heat transfer area";
          end thermalConductor_b_3_rec;
        public
          thermalConductor_b_3_rec thermalConductor_b_3;
        protected
          record heatCapacitor_rec
            Modelica.SIunits.Temperature T
                                          "Temperature of element";
            Real T_der(unit = "K/s")
                                    "der(Temperature of element)";
            Modelica.SIunits.HeatFlowRate Q_flow;
            parameter Modelica.SIunits.Temperature T_start(fixed=false)
                                                                       "Start temperature for the average temperature of ellement";
          protected
            record port_rec
              Modelica.SIunits.Temperature T
                                            "Port temperature";
              Modelica.SIunits.HeatFlowRate Q_flow
                                                  "Heat flow rate (positive if flowing from outside into the component)";
            end port_rec;
          public
            port_rec port;
            parameter Modelica.SIunits.Volume V(fixed=false)
                                                            "Volume of element";
            parameter Modelica.SIunits.Mass m(fixed=false)
                                                          "Mass of element";
            Modelica.SIunits.TemperatureSlope der_T
                                                   "Time derivative of temperature (= der(T))";
            Modelica.SIunits.HeatCapacity C
                                           "Heat capacity of element (= cp*m)";
            parameter Modelica.SIunits.TemperatureSlope der_T_start(fixed=false)
                                                                                "Start value ofime derivative of temperature (= der(T))";
          end heatCapacitor_rec;
        public
          heatCapacitor_rec heatCapacitor;
        protected
          record port_int_rec
            Modelica.SIunits.Temperature T
                                          "Port temperature";
            constant Modelica.SIunits.HeatFlowRate Q_flow = 0.0
                                                               "Heat flow rate (positive if flowing from outside into the component)";
          end port_int_rec;
        public
          port_int_rec port_int;
        end 'thermalNode[1, 2, 1]_rec';
      public
        'thermalNode[1, 2, 1]_rec' 'thermalNode[1, 2, 1]' annotation(Dialog);
      protected
        record 'thermalNode[1, 3, 1]_rec'
          parameter Real nParallel(min = 1.0) = 1
                                                 "Number of identical parallel elements";
          constant Boolean use_portDim1 = true
                                              "Heat tranfer in 1st dimention";
          constant Boolean use_portDim2 = true
                                              "Heat tranfer in 2nd dimention";
          constant Boolean use_portDim3 = false
                                               "Heat tranfer in 3rd dimention";
        protected
          record port_a_1_rec
            Modelica.SIunits.Temperature T
                                          "Port temperature";
            Modelica.SIunits.HeatFlowRate Q_flow
                                                "Heat flow rate (positive if flowing from outside into the component)";
          end port_a_1_rec;
        public
          port_a_1_rec port_a_1;
        protected
          record port_b_1_rec
            Modelica.SIunits.Temperature T
                                          "Port temperature";
            Modelica.SIunits.HeatFlowRate Q_flow
                                                "Heat flow rate (positive if flowing from outside into the component)";
          end port_b_1_rec;
        public
          port_b_1_rec port_b_1;
        protected
          record port_a_2_rec
            Modelica.SIunits.Temperature T
                                          "Port temperature";
            Modelica.SIunits.HeatFlowRate Q_flow
                                                "Heat flow rate (positive if flowing from outside into the component)";
          end port_a_2_rec;
        public
          port_a_2_rec port_a_2;
        protected
          record port_b_2_rec
            Modelica.SIunits.Temperature T
                                          "Port temperature";
            Modelica.SIunits.HeatFlowRate Q_flow
                                                "Heat flow rate (positive if flowing from outside into the component)";
          end port_b_2_rec;
        public
          port_b_2_rec port_b_2;
          parameter Modelica.SIunits.Volume V(fixed=false)
                                                          "Volume of material";
        protected
          record thermalConductor_a_1_rec
            Modelica.SIunits.HeatFlowRate Q_flow
                                                "Heat flow rate from port_a -> port_b";
            Modelica.SIunits.TemperatureDifference dT
                                                     "port_a.T - port_b.T";
          protected
            record port_a_rec
              Modelica.SIunits.Temperature T
                                            "Port temperature";
              Modelica.SIunits.HeatFlowRate Q_flow
                                                  "Heat flow rate (positive if flowing from outside into the component)";
            end port_a_rec;
          public
            port_a_rec port_a;
          protected
            record port_b_rec
              Modelica.SIunits.Temperature T
                                            "Port temperature";
              Modelica.SIunits.HeatFlowRate Q_flow
                                                  "Heat flow rate (positive if flowing from outside into the component)";
            end port_b_rec;
          public
            port_b_rec port_b;
            Modelica.SIunits.Temperature T
                                          "Average temperature of element";
            parameter Modelica.SIunits.Temperature T_start(fixed=false)
                                                                       "Start temperature for the average temperature of element";
            Modelica.SIunits.ThermalConductance G
                                                 "Thermal conductance of material";
            Modelica.SIunits.ThermalConductivity k
                                                  "Thermal conductivity";
            parameter Modelica.SIunits.Length r_internal(fixed=false)
                                                                     "Inner radius of cylinder";
            parameter Modelica.SIunits.Length r_external(fixed=false)
                                                                     "Outer radius of cylinder";
            parameter Modelica.SIunits.Length L(fixed=false)
                                                            "Length of cylinder";
            parameter Modelica.SIunits.Angle alpha(fixed=false)
                                                               "Swept angle";
          end thermalConductor_a_1_rec;
        public
          thermalConductor_a_1_rec thermalConductor_a_1;
        protected
          record thermalConductor_b_1_rec
            Modelica.SIunits.HeatFlowRate Q_flow
                                                "Heat flow rate from port_a -> port_b";
            Modelica.SIunits.TemperatureDifference dT
                                                     "port_a.T - port_b.T";
          protected
            record port_a_rec
              Modelica.SIunits.Temperature T
                                            "Port temperature";
              Modelica.SIunits.HeatFlowRate Q_flow
                                                  "Heat flow rate (positive if flowing from outside into the component)";
            end port_a_rec;
          public
            port_a_rec port_a;
          protected
            record port_b_rec
              Modelica.SIunits.Temperature T
                                            "Port temperature";
              Modelica.SIunits.HeatFlowRate Q_flow
                                                  "Heat flow rate (positive if flowing from outside into the component)";
            end port_b_rec;
          public
            port_b_rec port_b;
            Modelica.SIunits.Temperature T
                                          "Average temperature of element";
            parameter Modelica.SIunits.Temperature T_start(fixed=false)
                                                                       "Start temperature for the average temperature of element";
            Modelica.SIunits.ThermalConductance G
                                                 "Thermal conductance of material";
            Modelica.SIunits.ThermalConductivity k
                                                  "Thermal conductivity";
            parameter Modelica.SIunits.Length r_internal(fixed=false)
                                                                     "Inner radius of cylinder";
            parameter Modelica.SIunits.Length r_external(fixed=false)
                                                                     "Outer radius of cylinder";
            parameter Modelica.SIunits.Length L(fixed=false)
                                                            "Length of cylinder";
            parameter Modelica.SIunits.Angle alpha(fixed=false)
                                                               "Swept angle";
          end thermalConductor_b_1_rec;
        public
          thermalConductor_b_1_rec thermalConductor_b_1;
        protected
          record thermalConductor_a_2_rec
            Modelica.SIunits.HeatFlowRate Q_flow
                                                "Heat flow rate from port_a -> port_b";
            Modelica.SIunits.TemperatureDifference dT
                                                     "port_a.T - port_b.T";
          protected
            record port_a_rec
              Modelica.SIunits.Temperature T
                                            "Port temperature";
              Modelica.SIunits.HeatFlowRate Q_flow
                                                  "Heat flow rate (positive if flowing from outside into the component)";
            end port_a_rec;
          public
            port_a_rec port_a;
          protected
            record port_b_rec
              Modelica.SIunits.Temperature T
                                            "Port temperature";
              Modelica.SIunits.HeatFlowRate Q_flow
                                                  "Heat flow rate (positive if flowing from outside into the component)";
            end port_b_rec;
          public
            port_b_rec port_b;
            Modelica.SIunits.Temperature T
                                          "Average temperature of element";
            parameter Modelica.SIunits.Temperature T_start(fixed=false)
                                                                       "Start temperature for the average temperature of element";
            Modelica.SIunits.ThermalConductance G
                                                 "Thermal conductance of material";
            Modelica.SIunits.ThermalConductivity k
                                                  "Thermal conductivity";
            parameter Modelica.SIunits.Length L(fixed=false)
                                                            "length of conduction";
            parameter Modelica.SIunits.Area A(fixed=false)
                                                          "Heat transfer area";
          end thermalConductor_a_2_rec;
        public
          thermalConductor_a_2_rec thermalConductor_a_2;
        protected
          record thermalConductor_b_2_rec
            Modelica.SIunits.HeatFlowRate Q_flow
                                                "Heat flow rate from port_a -> port_b";
            Modelica.SIunits.TemperatureDifference dT
                                                     "port_a.T - port_b.T";
          protected
            record port_a_rec
              Modelica.SIunits.Temperature T
                                            "Port temperature";
              Modelica.SIunits.HeatFlowRate Q_flow
                                                  "Heat flow rate (positive if flowing from outside into the component)";
            end port_a_rec;
          public
            port_a_rec port_a;
          protected
            record port_b_rec
              Modelica.SIunits.Temperature T
                                            "Port temperature";
              Modelica.SIunits.HeatFlowRate Q_flow
                                                  "Heat flow rate (positive if flowing from outside into the component)";
            end port_b_rec;
          public
            port_b_rec port_b;
            Modelica.SIunits.Temperature T
                                          "Average temperature of element";
            parameter Modelica.SIunits.Temperature T_start(fixed=false)
                                                                       "Start temperature for the average temperature of element";
            Modelica.SIunits.ThermalConductance G
                                                 "Thermal conductance of material";
            Modelica.SIunits.ThermalConductivity k
                                                  "Thermal conductivity";
            parameter Modelica.SIunits.Length L(fixed=false)
                                                            "length of conduction";
            parameter Modelica.SIunits.Area A(fixed=false)
                                                          "Heat transfer area";
          end thermalConductor_b_2_rec;
        public
          thermalConductor_b_2_rec thermalConductor_b_2;
        protected
          record thermalConductor_a_3_rec
            constant Modelica.SIunits.HeatFlowRate Q_flow = 0.0
                                                               "Heat flow rate from port_a -> port_b";
            Modelica.SIunits.TemperatureDifference dT
                                                     "port_a.T - port_b.T";
          protected
            record port_a_rec
              Modelica.SIunits.Temperature T
                                            "Port temperature";
              constant Modelica.SIunits.HeatFlowRate Q_flow = 0.0
                                                                 "Heat flow rate (positive if flowing from outside into the component)";
            end port_a_rec;
          public
            port_a_rec port_a;
          protected
            record port_b_rec
              Modelica.SIunits.Temperature T
                                            "Port temperature";
              constant Modelica.SIunits.HeatFlowRate Q_flow = 0.0
                                                                 "Heat flow rate (positive if flowing from outside into the component)";
            end port_b_rec;
          public
            port_b_rec port_b;
            Modelica.SIunits.Temperature T
                                          "Average temperature of element";
            parameter Modelica.SIunits.Temperature T_start(fixed=false)
                                                                       "Start temperature for the average temperature of element";
            Modelica.SIunits.ThermalConductance G
                                                 "Thermal conductance of material";
            Modelica.SIunits.ThermalConductivity k
                                                  "Thermal conductivity";
            parameter Modelica.SIunits.Length L(fixed=false)
                                                            "length of conduction";
            parameter Modelica.SIunits.Area A(fixed=false)
                                                          "Heat transfer area";
          end thermalConductor_a_3_rec;
        public
          thermalConductor_a_3_rec thermalConductor_a_3;
        protected
          record thermalConductor_b_3_rec
            constant Modelica.SIunits.HeatFlowRate Q_flow = 0.0
                                                               "Heat flow rate from port_a -> port_b";
            Modelica.SIunits.TemperatureDifference dT
                                                     "port_a.T - port_b.T";
          protected
            record port_a_rec
              Modelica.SIunits.Temperature T
                                            "Port temperature";
              constant Modelica.SIunits.HeatFlowRate Q_flow = 0.0
                                                                 "Heat flow rate (positive if flowing from outside into the component)";
            end port_a_rec;
          public
            port_a_rec port_a;
          protected
            record port_b_rec
              Modelica.SIunits.Temperature T
                                            "Port temperature";
              constant Modelica.SIunits.HeatFlowRate Q_flow = 0.0
                                                                 "Heat flow rate (positive if flowing from outside into the component)";
            end port_b_rec;
          public
            port_b_rec port_b;
            Modelica.SIunits.Temperature T
                                          "Average temperature of element";
            parameter Modelica.SIunits.Temperature T_start(fixed=false)
                                                                       "Start temperature for the average temperature of element";
            Modelica.SIunits.ThermalConductance G
                                                 "Thermal conductance of material";
            Modelica.SIunits.ThermalConductivity k
                                                  "Thermal conductivity";
            parameter Modelica.SIunits.Length L(fixed=false)
                                                            "length of conduction";
            parameter Modelica.SIunits.Area A(fixed=false)
                                                          "Heat transfer area";
          end thermalConductor_b_3_rec;
        public
          thermalConductor_b_3_rec thermalConductor_b_3;
        protected
          record heatCapacitor_rec
            Modelica.SIunits.Temperature T
                                          "Temperature of element";
            Real T_der(unit = "K/s")
                                    "der(Temperature of element)";
            Modelica.SIunits.HeatFlowRate Q_flow;
            parameter Modelica.SIunits.Temperature T_start(fixed=false)
                                                                       "Start temperature for the average temperature of ellement";
          protected
            record port_rec
              Modelica.SIunits.Temperature T
                                            "Port temperature";
              Modelica.SIunits.HeatFlowRate Q_flow
                                                  "Heat flow rate (positive if flowing from outside into the component)";
            end port_rec;
          public
            port_rec port;
            parameter Modelica.SIunits.Volume V(fixed=false)
                                                            "Volume of element";
            parameter Modelica.SIunits.Mass m(fixed=false)
                                                          "Mass of element";
            Modelica.SIunits.TemperatureSlope der_T
                                                   "Time derivative of temperature (= der(T))";
            Modelica.SIunits.HeatCapacity C
                                           "Heat capacity of element (= cp*m)";
            parameter Modelica.SIunits.TemperatureSlope der_T_start(fixed=false)
                                                                                "Start value ofime derivative of temperature (= der(T))";
          end heatCapacitor_rec;
        public
          heatCapacitor_rec heatCapacitor;
        protected
          record port_int_rec
            Modelica.SIunits.Temperature T
                                          "Port temperature";
            constant Modelica.SIunits.HeatFlowRate Q_flow = 0.0
                                                               "Heat flow rate (positive if flowing from outside into the component)";
          end port_int_rec;
        public
          port_int_rec port_int;
        end 'thermalNode[1, 3, 1]_rec';
      public
        'thermalNode[1, 3, 1]_rec' 'thermalNode[1, 3, 1]' annotation(Dialog);
      protected
        record 'thermalNode[1, 4, 1]_rec'
          parameter Real nParallel(min = 1.0) = 1
                                                 "Number of identical parallel elements";
          constant Boolean use_portDim1 = true
                                              "Heat tranfer in 1st dimention";
          constant Boolean use_portDim2 = true
                                              "Heat tranfer in 2nd dimention";
          constant Boolean use_portDim3 = false
                                               "Heat tranfer in 3rd dimention";
        protected
          record port_a_1_rec
            Modelica.SIunits.Temperature T
                                          "Port temperature";
            Modelica.SIunits.HeatFlowRate Q_flow
                                                "Heat flow rate (positive if flowing from outside into the component)";
          end port_a_1_rec;
        public
          port_a_1_rec port_a_1;
        protected
          record port_b_1_rec
            Modelica.SIunits.Temperature T
                                          "Port temperature";
            Modelica.SIunits.HeatFlowRate Q_flow
                                                "Heat flow rate (positive if flowing from outside into the component)";
          end port_b_1_rec;
        public
          port_b_1_rec port_b_1;
        protected
          record port_a_2_rec
            Modelica.SIunits.Temperature T
                                          "Port temperature";
            Modelica.SIunits.HeatFlowRate Q_flow
                                                "Heat flow rate (positive if flowing from outside into the component)";
          end port_a_2_rec;
        public
          port_a_2_rec port_a_2;
        protected
          record port_b_2_rec
            Modelica.SIunits.Temperature T
                                          "Port temperature";
            Modelica.SIunits.HeatFlowRate Q_flow
                                                "Heat flow rate (positive if flowing from outside into the component)";
          end port_b_2_rec;
        public
          port_b_2_rec port_b_2;
          parameter Modelica.SIunits.Volume V(fixed=false)
                                                          "Volume of material";
        protected
          record thermalConductor_a_1_rec
            Modelica.SIunits.HeatFlowRate Q_flow
                                                "Heat flow rate from port_a -> port_b";
            Modelica.SIunits.TemperatureDifference dT
                                                     "port_a.T - port_b.T";
          protected
            record port_a_rec
              Modelica.SIunits.Temperature T
                                            "Port temperature";
              Modelica.SIunits.HeatFlowRate Q_flow
                                                  "Heat flow rate (positive if flowing from outside into the component)";
            end port_a_rec;
          public
            port_a_rec port_a;
          protected
            record port_b_rec
              Modelica.SIunits.Temperature T
                                            "Port temperature";
              Modelica.SIunits.HeatFlowRate Q_flow
                                                  "Heat flow rate (positive if flowing from outside into the component)";
            end port_b_rec;
          public
            port_b_rec port_b;
            Modelica.SIunits.Temperature T
                                          "Average temperature of element";
            parameter Modelica.SIunits.Temperature T_start(fixed=false)
                                                                       "Start temperature for the average temperature of element";
            Modelica.SIunits.ThermalConductance G
                                                 "Thermal conductance of material";
            Modelica.SIunits.ThermalConductivity k
                                                  "Thermal conductivity";
            parameter Modelica.SIunits.Length r_internal(fixed=false)
                                                                     "Inner radius of cylinder";
            parameter Modelica.SIunits.Length r_external(fixed=false)
                                                                     "Outer radius of cylinder";
            parameter Modelica.SIunits.Length L(fixed=false)
                                                            "Length of cylinder";
            parameter Modelica.SIunits.Angle alpha(fixed=false)
                                                               "Swept angle";
          end thermalConductor_a_1_rec;
        public
          thermalConductor_a_1_rec thermalConductor_a_1;
        protected
          record thermalConductor_b_1_rec
            Modelica.SIunits.HeatFlowRate Q_flow
                                                "Heat flow rate from port_a -> port_b";
            Modelica.SIunits.TemperatureDifference dT
                                                     "port_a.T - port_b.T";
          protected
            record port_a_rec
              Modelica.SIunits.Temperature T
                                            "Port temperature";
              Modelica.SIunits.HeatFlowRate Q_flow
                                                  "Heat flow rate (positive if flowing from outside into the component)";
            end port_a_rec;
          public
            port_a_rec port_a;
          protected
            record port_b_rec
              Modelica.SIunits.Temperature T
                                            "Port temperature";
              Modelica.SIunits.HeatFlowRate Q_flow
                                                  "Heat flow rate (positive if flowing from outside into the component)";
            end port_b_rec;
          public
            port_b_rec port_b;
            Modelica.SIunits.Temperature T
                                          "Average temperature of element";
            parameter Modelica.SIunits.Temperature T_start(fixed=false)
                                                                       "Start temperature for the average temperature of element";
            Modelica.SIunits.ThermalConductance G
                                                 "Thermal conductance of material";
            Modelica.SIunits.ThermalConductivity k
                                                  "Thermal conductivity";
            parameter Modelica.SIunits.Length r_internal(fixed=false)
                                                                     "Inner radius of cylinder";
            parameter Modelica.SIunits.Length r_external(fixed=false)
                                                                     "Outer radius of cylinder";
            parameter Modelica.SIunits.Length L(fixed=false)
                                                            "Length of cylinder";
            parameter Modelica.SIunits.Angle alpha(fixed=false)
                                                               "Swept angle";
          end thermalConductor_b_1_rec;
        public
          thermalConductor_b_1_rec thermalConductor_b_1;
        protected
          record thermalConductor_a_2_rec
            Modelica.SIunits.HeatFlowRate Q_flow
                                                "Heat flow rate from port_a -> port_b";
            Modelica.SIunits.TemperatureDifference dT
                                                     "port_a.T - port_b.T";
          protected
            record port_a_rec
              Modelica.SIunits.Temperature T
                                            "Port temperature";
              Modelica.SIunits.HeatFlowRate Q_flow
                                                  "Heat flow rate (positive if flowing from outside into the component)";
            end port_a_rec;
          public
            port_a_rec port_a;
          protected
            record port_b_rec
              Modelica.SIunits.Temperature T
                                            "Port temperature";
              Modelica.SIunits.HeatFlowRate Q_flow
                                                  "Heat flow rate (positive if flowing from outside into the component)";
            end port_b_rec;
          public
            port_b_rec port_b;
            Modelica.SIunits.Temperature T
                                          "Average temperature of element";
            parameter Modelica.SIunits.Temperature T_start(fixed=false)
                                                                       "Start temperature for the average temperature of element";
            Modelica.SIunits.ThermalConductance G
                                                 "Thermal conductance of material";
            Modelica.SIunits.ThermalConductivity k
                                                  "Thermal conductivity";
            parameter Modelica.SIunits.Length L(fixed=false)
                                                            "length of conduction";
            parameter Modelica.SIunits.Area A(fixed=false)
                                                          "Heat transfer area";
          end thermalConductor_a_2_rec;
        public
          thermalConductor_a_2_rec thermalConductor_a_2;
        protected
          record thermalConductor_b_2_rec
            Modelica.SIunits.HeatFlowRate Q_flow
                                                "Heat flow rate from port_a -> port_b";
            Modelica.SIunits.TemperatureDifference dT
                                                     "port_a.T - port_b.T";
          protected
            record port_a_rec
              Modelica.SIunits.Temperature T
                                            "Port temperature";
              Modelica.SIunits.HeatFlowRate Q_flow
                                                  "Heat flow rate (positive if flowing from outside into the component)";
            end port_a_rec;
          public
            port_a_rec port_a;
          protected
            record port_b_rec
              Modelica.SIunits.Temperature T
                                            "Port temperature";
              Modelica.SIunits.HeatFlowRate Q_flow
                                                  "Heat flow rate (positive if flowing from outside into the component)";
            end port_b_rec;
          public
            port_b_rec port_b;
            Modelica.SIunits.Temperature T
                                          "Average temperature of element";
            parameter Modelica.SIunits.Temperature T_start(fixed=false)
                                                                       "Start temperature for the average temperature of element";
            Modelica.SIunits.ThermalConductance G
                                                 "Thermal conductance of material";
            Modelica.SIunits.ThermalConductivity k
                                                  "Thermal conductivity";
            parameter Modelica.SIunits.Length L(fixed=false)
                                                            "length of conduction";
            parameter Modelica.SIunits.Area A(fixed=false)
                                                          "Heat transfer area";
          end thermalConductor_b_2_rec;
        public
          thermalConductor_b_2_rec thermalConductor_b_2;
        protected
          record thermalConductor_a_3_rec
            constant Modelica.SIunits.HeatFlowRate Q_flow = 0.0
                                                               "Heat flow rate from port_a -> port_b";
            Modelica.SIunits.TemperatureDifference dT
                                                     "port_a.T - port_b.T";
          protected
            record port_a_rec
              Modelica.SIunits.Temperature T
                                            "Port temperature";
              constant Modelica.SIunits.HeatFlowRate Q_flow = 0.0
                                                                 "Heat flow rate (positive if flowing from outside into the component)";
            end port_a_rec;
          public
            port_a_rec port_a;
          protected
            record port_b_rec
              Modelica.SIunits.Temperature T
                                            "Port temperature";
              constant Modelica.SIunits.HeatFlowRate Q_flow = 0.0
                                                                 "Heat flow rate (positive if flowing from outside into the component)";
            end port_b_rec;
          public
            port_b_rec port_b;
            Modelica.SIunits.Temperature T
                                          "Average temperature of element";
            parameter Modelica.SIunits.Temperature T_start(fixed=false)
                                                                       "Start temperature for the average temperature of element";
            Modelica.SIunits.ThermalConductance G
                                                 "Thermal conductance of material";
            Modelica.SIunits.ThermalConductivity k
                                                  "Thermal conductivity";
            parameter Modelica.SIunits.Length L(fixed=false)
                                                            "length of conduction";
            parameter Modelica.SIunits.Area A(fixed=false)
                                                          "Heat transfer area";
          end thermalConductor_a_3_rec;
        public
          thermalConductor_a_3_rec thermalConductor_a_3;
        protected
          record thermalConductor_b_3_rec
            constant Modelica.SIunits.HeatFlowRate Q_flow = 0.0
                                                               "Heat flow rate from port_a -> port_b";
            Modelica.SIunits.TemperatureDifference dT
                                                     "port_a.T - port_b.T";
          protected
            record port_a_rec
              Modelica.SIunits.Temperature T
                                            "Port temperature";
              constant Modelica.SIunits.HeatFlowRate Q_flow = 0.0
                                                                 "Heat flow rate (positive if flowing from outside into the component)";
            end port_a_rec;
          public
            port_a_rec port_a;
          protected
            record port_b_rec
              Modelica.SIunits.Temperature T
                                            "Port temperature";
              constant Modelica.SIunits.HeatFlowRate Q_flow = 0.0
                                                                 "Heat flow rate (positive if flowing from outside into the component)";
            end port_b_rec;
          public
            port_b_rec port_b;
            Modelica.SIunits.Temperature T
                                          "Average temperature of element";
            parameter Modelica.SIunits.Temperature T_start(fixed=false)
                                                                       "Start temperature for the average temperature of element";
            Modelica.SIunits.ThermalConductance G
                                                 "Thermal conductance of material";
            Modelica.SIunits.ThermalConductivity k
                                                  "Thermal conductivity";
            parameter Modelica.SIunits.Length L(fixed=false)
                                                            "length of conduction";
            parameter Modelica.SIunits.Area A(fixed=false)
                                                          "Heat transfer area";
          end thermalConductor_b_3_rec;
        public
          thermalConductor_b_3_rec thermalConductor_b_3;
        protected
          record heatCapacitor_rec
            Modelica.SIunits.Temperature T
                                          "Temperature of element";
            Real T_der(unit = "K/s")
                                    "der(Temperature of element)";
            Modelica.SIunits.HeatFlowRate Q_flow;
            parameter Modelica.SIunits.Temperature T_start(fixed=false)
                                                                       "Start temperature for the average temperature of ellement";
          protected
            record port_rec
              Modelica.SIunits.Temperature T
                                            "Port temperature";
              Modelica.SIunits.HeatFlowRate Q_flow
                                                  "Heat flow rate (positive if flowing from outside into the component)";
            end port_rec;
          public
            port_rec port;
            parameter Modelica.SIunits.Volume V(fixed=false)
                                                            "Volume of element";
            parameter Modelica.SIunits.Mass m(fixed=false)
                                                          "Mass of element";
            Modelica.SIunits.TemperatureSlope der_T
                                                   "Time derivative of temperature (= der(T))";
            Modelica.SIunits.HeatCapacity C
                                           "Heat capacity of element (= cp*m)";
            parameter Modelica.SIunits.TemperatureSlope der_T_start(fixed=false)
                                                                                "Start value ofime derivative of temperature (= der(T))";
          end heatCapacitor_rec;
        public
          heatCapacitor_rec heatCapacitor;
        protected
          record port_int_rec
            Modelica.SIunits.Temperature T
                                          "Port temperature";
            constant Modelica.SIunits.HeatFlowRate Q_flow = 0.0
                                                               "Heat flow rate (positive if flowing from outside into the component)";
          end port_int_rec;
        public
          port_int_rec port_int;
        end 'thermalNode[1, 4, 1]_rec';
      public
        'thermalNode[1, 4, 1]_rec' 'thermalNode[1, 4, 1]' annotation(Dialog);
      protected
        record 'thermalNode[1, 5, 1]_rec'
          parameter Real nParallel(min = 1.0) = 1
                                                 "Number of identical parallel elements";
          constant Boolean use_portDim1 = true
                                              "Heat tranfer in 1st dimention";
          constant Boolean use_portDim2 = true
                                              "Heat tranfer in 2nd dimention";
          constant Boolean use_portDim3 = false
                                               "Heat tranfer in 3rd dimention";
        protected
          record port_a_1_rec
            Modelica.SIunits.Temperature T
                                          "Port temperature";
            Modelica.SIunits.HeatFlowRate Q_flow
                                                "Heat flow rate (positive if flowing from outside into the component)";
          end port_a_1_rec;
        public
          port_a_1_rec port_a_1;
        protected
          record port_b_1_rec
            Modelica.SIunits.Temperature T
                                          "Port temperature";
            Modelica.SIunits.HeatFlowRate Q_flow
                                                "Heat flow rate (positive if flowing from outside into the component)";
          end port_b_1_rec;
        public
          port_b_1_rec port_b_1;
        protected
          record port_a_2_rec
            Modelica.SIunits.Temperature T
                                          "Port temperature";
            Modelica.SIunits.HeatFlowRate Q_flow
                                                "Heat flow rate (positive if flowing from outside into the component)";
          end port_a_2_rec;
        public
          port_a_2_rec port_a_2;
        protected
          record port_b_2_rec
            Modelica.SIunits.Temperature T
                                          "Port temperature";
            Modelica.SIunits.HeatFlowRate Q_flow
                                                "Heat flow rate (positive if flowing from outside into the component)";
          end port_b_2_rec;
        public
          port_b_2_rec port_b_2;
          parameter Modelica.SIunits.Volume V(fixed=false)
                                                          "Volume of material";
        protected
          record thermalConductor_a_1_rec
            Modelica.SIunits.HeatFlowRate Q_flow
                                                "Heat flow rate from port_a -> port_b";
            Modelica.SIunits.TemperatureDifference dT
                                                     "port_a.T - port_b.T";
          protected
            record port_a_rec
              Modelica.SIunits.Temperature T
                                            "Port temperature";
              Modelica.SIunits.HeatFlowRate Q_flow
                                                  "Heat flow rate (positive if flowing from outside into the component)";
            end port_a_rec;
          public
            port_a_rec port_a;
          protected
            record port_b_rec
              Modelica.SIunits.Temperature T
                                            "Port temperature";
              Modelica.SIunits.HeatFlowRate Q_flow
                                                  "Heat flow rate (positive if flowing from outside into the component)";
            end port_b_rec;
          public
            port_b_rec port_b;
            Modelica.SIunits.Temperature T
                                          "Average temperature of element";
            parameter Modelica.SIunits.Temperature T_start(fixed=false)
                                                                       "Start temperature for the average temperature of element";
            Modelica.SIunits.ThermalConductance G
                                                 "Thermal conductance of material";
            Modelica.SIunits.ThermalConductivity k
                                                  "Thermal conductivity";
            parameter Modelica.SIunits.Length r_internal(fixed=false)
                                                                     "Inner radius of cylinder";
            parameter Modelica.SIunits.Length r_external(fixed=false)
                                                                     "Outer radius of cylinder";
            parameter Modelica.SIunits.Length L(fixed=false)
                                                            "Length of cylinder";
            parameter Modelica.SIunits.Angle alpha(fixed=false)
                                                               "Swept angle";
          end thermalConductor_a_1_rec;
        public
          thermalConductor_a_1_rec thermalConductor_a_1;
        protected
          record thermalConductor_b_1_rec
            Modelica.SIunits.HeatFlowRate Q_flow
                                                "Heat flow rate from port_a -> port_b";
            Modelica.SIunits.TemperatureDifference dT
                                                     "port_a.T - port_b.T";
          protected
            record port_a_rec
              Modelica.SIunits.Temperature T
                                            "Port temperature";
              Modelica.SIunits.HeatFlowRate Q_flow
                                                  "Heat flow rate (positive if flowing from outside into the component)";
            end port_a_rec;
          public
            port_a_rec port_a;
          protected
            record port_b_rec
              Modelica.SIunits.Temperature T
                                            "Port temperature";
              Modelica.SIunits.HeatFlowRate Q_flow
                                                  "Heat flow rate (positive if flowing from outside into the component)";
            end port_b_rec;
          public
            port_b_rec port_b;
            Modelica.SIunits.Temperature T
                                          "Average temperature of element";
            parameter Modelica.SIunits.Temperature T_start(fixed=false)
                                                                       "Start temperature for the average temperature of element";
            Modelica.SIunits.ThermalConductance G
                                                 "Thermal conductance of material";
            Modelica.SIunits.ThermalConductivity k
                                                  "Thermal conductivity";
            parameter Modelica.SIunits.Length r_internal(fixed=false)
                                                                     "Inner radius of cylinder";
            parameter Modelica.SIunits.Length r_external(fixed=false)
                                                                     "Outer radius of cylinder";
            parameter Modelica.SIunits.Length L(fixed=false)
                                                            "Length of cylinder";
            parameter Modelica.SIunits.Angle alpha(fixed=false)
                                                               "Swept angle";
          end thermalConductor_b_1_rec;
        public
          thermalConductor_b_1_rec thermalConductor_b_1;
        protected
          record thermalConductor_a_2_rec
            Modelica.SIunits.HeatFlowRate Q_flow
                                                "Heat flow rate from port_a -> port_b";
            Modelica.SIunits.TemperatureDifference dT
                                                     "port_a.T - port_b.T";
          protected
            record port_a_rec
              Modelica.SIunits.Temperature T
                                            "Port temperature";
              Modelica.SIunits.HeatFlowRate Q_flow
                                                  "Heat flow rate (positive if flowing from outside into the component)";
            end port_a_rec;
          public
            port_a_rec port_a;
          protected
            record port_b_rec
              Modelica.SIunits.Temperature T
                                            "Port temperature";
              Modelica.SIunits.HeatFlowRate Q_flow
                                                  "Heat flow rate (positive if flowing from outside into the component)";
            end port_b_rec;
          public
            port_b_rec port_b;
            Modelica.SIunits.Temperature T
                                          "Average temperature of element";
            parameter Modelica.SIunits.Temperature T_start(fixed=false)
                                                                       "Start temperature for the average temperature of element";
            Modelica.SIunits.ThermalConductance G
                                                 "Thermal conductance of material";
            Modelica.SIunits.ThermalConductivity k
                                                  "Thermal conductivity";
            parameter Modelica.SIunits.Length L(fixed=false)
                                                            "length of conduction";
            parameter Modelica.SIunits.Area A(fixed=false)
                                                          "Heat transfer area";
          end thermalConductor_a_2_rec;
        public
          thermalConductor_a_2_rec thermalConductor_a_2;
        protected
          record thermalConductor_b_2_rec
            Modelica.SIunits.HeatFlowRate Q_flow
                                                "Heat flow rate from port_a -> port_b";
            Modelica.SIunits.TemperatureDifference dT
                                                     "port_a.T - port_b.T";
          protected
            record port_a_rec
              Modelica.SIunits.Temperature T
                                            "Port temperature";
              Modelica.SIunits.HeatFlowRate Q_flow
                                                  "Heat flow rate (positive if flowing from outside into the component)";
            end port_a_rec;
          public
            port_a_rec port_a;
          protected
            record port_b_rec
              Modelica.SIunits.Temperature T
                                            "Port temperature";
              Modelica.SIunits.HeatFlowRate Q_flow
                                                  "Heat flow rate (positive if flowing from outside into the component)";
            end port_b_rec;
          public
            port_b_rec port_b;
            Modelica.SIunits.Temperature T
                                          "Average temperature of element";
            parameter Modelica.SIunits.Temperature T_start(fixed=false)
                                                                       "Start temperature for the average temperature of element";
            Modelica.SIunits.ThermalConductance G
                                                 "Thermal conductance of material";
            Modelica.SIunits.ThermalConductivity k
                                                  "Thermal conductivity";
            parameter Modelica.SIunits.Length L(fixed=false)
                                                            "length of conduction";
            parameter Modelica.SIunits.Area A(fixed=false)
                                                          "Heat transfer area";
          end thermalConductor_b_2_rec;
        public
          thermalConductor_b_2_rec thermalConductor_b_2;
        protected
          record thermalConductor_a_3_rec
            constant Modelica.SIunits.HeatFlowRate Q_flow = 0.0
                                                               "Heat flow rate from port_a -> port_b";
            Modelica.SIunits.TemperatureDifference dT
                                                     "port_a.T - port_b.T";
          protected
            record port_a_rec
              Modelica.SIunits.Temperature T
                                            "Port temperature";
              constant Modelica.SIunits.HeatFlowRate Q_flow = 0.0
                                                                 "Heat flow rate (positive if flowing from outside into the component)";
            end port_a_rec;
          public
            port_a_rec port_a;
          protected
            record port_b_rec
              Modelica.SIunits.Temperature T
                                            "Port temperature";
              constant Modelica.SIunits.HeatFlowRate Q_flow = 0.0
                                                                 "Heat flow rate (positive if flowing from outside into the component)";
            end port_b_rec;
          public
            port_b_rec port_b;
            Modelica.SIunits.Temperature T
                                          "Average temperature of element";
            parameter Modelica.SIunits.Temperature T_start(fixed=false)
                                                                       "Start temperature for the average temperature of element";
            Modelica.SIunits.ThermalConductance G
                                                 "Thermal conductance of material";
            Modelica.SIunits.ThermalConductivity k
                                                  "Thermal conductivity";
            parameter Modelica.SIunits.Length L(fixed=false)
                                                            "length of conduction";
            parameter Modelica.SIunits.Area A(fixed=false)
                                                          "Heat transfer area";
          end thermalConductor_a_3_rec;
        public
          thermalConductor_a_3_rec thermalConductor_a_3;
        protected
          record thermalConductor_b_3_rec
            constant Modelica.SIunits.HeatFlowRate Q_flow = 0.0
                                                               "Heat flow rate from port_a -> port_b";
            Modelica.SIunits.TemperatureDifference dT
                                                     "port_a.T - port_b.T";
          protected
            record port_a_rec
              Modelica.SIunits.Temperature T
                                            "Port temperature";
              constant Modelica.SIunits.HeatFlowRate Q_flow = 0.0
                                                                 "Heat flow rate (positive if flowing from outside into the component)";
            end port_a_rec;
          public
            port_a_rec port_a;
          protected
            record port_b_rec
              Modelica.SIunits.Temperature T
                                            "Port temperature";
              constant Modelica.SIunits.HeatFlowRate Q_flow = 0.0
                                                                 "Heat flow rate (positive if flowing from outside into the component)";
            end port_b_rec;
          public
            port_b_rec port_b;
            Modelica.SIunits.Temperature T
                                          "Average temperature of element";
            parameter Modelica.SIunits.Temperature T_start(fixed=false)
                                                                       "Start temperature for the average temperature of element";
            Modelica.SIunits.ThermalConductance G
                                                 "Thermal conductance of material";
            Modelica.SIunits.ThermalConductivity k
                                                  "Thermal conductivity";
            parameter Modelica.SIunits.Length L(fixed=false)
                                                            "length of conduction";
            parameter Modelica.SIunits.Area A(fixed=false)
                                                          "Heat transfer area";
          end thermalConductor_b_3_rec;
        public
          thermalConductor_b_3_rec thermalConductor_b_3;
        protected
          record heatCapacitor_rec
            Modelica.SIunits.Temperature T
                                          "Temperature of element";
            Real T_der(unit = "K/s")
                                    "der(Temperature of element)";
            Modelica.SIunits.HeatFlowRate Q_flow;
            parameter Modelica.SIunits.Temperature T_start(fixed=false)
                                                                       "Start temperature for the average temperature of ellement";
          protected
            record port_rec
              Modelica.SIunits.Temperature T
                                            "Port temperature";
              Modelica.SIunits.HeatFlowRate Q_flow
                                                  "Heat flow rate (positive if flowing from outside into the component)";
            end port_rec;
          public
            port_rec port;
            parameter Modelica.SIunits.Volume V(fixed=false)
                                                            "Volume of element";
            parameter Modelica.SIunits.Mass m(fixed=false)
                                                          "Mass of element";
            Modelica.SIunits.TemperatureSlope der_T
                                                   "Time derivative of temperature (= der(T))";
            Modelica.SIunits.HeatCapacity C
                                           "Heat capacity of element (= cp*m)";
            parameter Modelica.SIunits.TemperatureSlope der_T_start(fixed=false)
                                                                                "Start value ofime derivative of temperature (= der(T))";
          end heatCapacitor_rec;
        public
          heatCapacitor_rec heatCapacitor;
        protected
          record port_int_rec
            Modelica.SIunits.Temperature T
                                          "Port temperature";
            constant Modelica.SIunits.HeatFlowRate Q_flow = 0.0
                                                               "Heat flow rate (positive if flowing from outside into the component)";
          end port_int_rec;
        public
          port_int_rec port_int;
        end 'thermalNode[1, 5, 1]_rec';
      public
        'thermalNode[1, 5, 1]_rec' 'thermalNode[1, 5, 1]' annotation(Dialog);
      protected
        record 'thermalNode[1, 6, 1]_rec'
          parameter Real nParallel(min = 1.0) = 1
                                                 "Number of identical parallel elements";
          constant Boolean use_portDim1 = true
                                              "Heat tranfer in 1st dimention";
          constant Boolean use_portDim2 = true
                                              "Heat tranfer in 2nd dimention";
          constant Boolean use_portDim3 = false
                                               "Heat tranfer in 3rd dimention";
        protected
          record port_a_1_rec
            Modelica.SIunits.Temperature T
                                          "Port temperature";
            Modelica.SIunits.HeatFlowRate Q_flow
                                                "Heat flow rate (positive if flowing from outside into the component)";
          end port_a_1_rec;
        public
          port_a_1_rec port_a_1;
        protected
          record port_b_1_rec
            Modelica.SIunits.Temperature T
                                          "Port temperature";
            Modelica.SIunits.HeatFlowRate Q_flow
                                                "Heat flow rate (positive if flowing from outside into the component)";
          end port_b_1_rec;
        public
          port_b_1_rec port_b_1;
        protected
          record port_a_2_rec
            Modelica.SIunits.Temperature T
                                          "Port temperature";
            Modelica.SIunits.HeatFlowRate Q_flow
                                                "Heat flow rate (positive if flowing from outside into the component)";
          end port_a_2_rec;
        public
          port_a_2_rec port_a_2;
        protected
          record port_b_2_rec
            Modelica.SIunits.Temperature T
                                          "Port temperature";
            Modelica.SIunits.HeatFlowRate Q_flow
                                                "Heat flow rate (positive if flowing from outside into the component)";
          end port_b_2_rec;
        public
          port_b_2_rec port_b_2;
          parameter Modelica.SIunits.Volume V(fixed=false)
                                                          "Volume of material";
        protected
          record thermalConductor_a_1_rec
            Modelica.SIunits.HeatFlowRate Q_flow
                                                "Heat flow rate from port_a -> port_b";
            Modelica.SIunits.TemperatureDifference dT
                                                     "port_a.T - port_b.T";
          protected
            record port_a_rec
              Modelica.SIunits.Temperature T
                                            "Port temperature";
              Modelica.SIunits.HeatFlowRate Q_flow
                                                  "Heat flow rate (positive if flowing from outside into the component)";
            end port_a_rec;
          public
            port_a_rec port_a;
          protected
            record port_b_rec
              Modelica.SIunits.Temperature T
                                            "Port temperature";
              Modelica.SIunits.HeatFlowRate Q_flow
                                                  "Heat flow rate (positive if flowing from outside into the component)";
            end port_b_rec;
          public
            port_b_rec port_b;
            Modelica.SIunits.Temperature T
                                          "Average temperature of element";
            parameter Modelica.SIunits.Temperature T_start(fixed=false)
                                                                       "Start temperature for the average temperature of element";
            Modelica.SIunits.ThermalConductance G
                                                 "Thermal conductance of material";
            Modelica.SIunits.ThermalConductivity k
                                                  "Thermal conductivity";
            parameter Modelica.SIunits.Length r_internal(fixed=false)
                                                                     "Inner radius of cylinder";
            parameter Modelica.SIunits.Length r_external(fixed=false)
                                                                     "Outer radius of cylinder";
            parameter Modelica.SIunits.Length L(fixed=false)
                                                            "Length of cylinder";
            parameter Modelica.SIunits.Angle alpha(fixed=false)
                                                               "Swept angle";
          end thermalConductor_a_1_rec;
        public
          thermalConductor_a_1_rec thermalConductor_a_1;
        protected
          record thermalConductor_b_1_rec
            Modelica.SIunits.HeatFlowRate Q_flow
                                                "Heat flow rate from port_a -> port_b";
            Modelica.SIunits.TemperatureDifference dT
                                                     "port_a.T - port_b.T";
          protected
            record port_a_rec
              Modelica.SIunits.Temperature T
                                            "Port temperature";
              Modelica.SIunits.HeatFlowRate Q_flow
                                                  "Heat flow rate (positive if flowing from outside into the component)";
            end port_a_rec;
          public
            port_a_rec port_a;
          protected
            record port_b_rec
              Modelica.SIunits.Temperature T
                                            "Port temperature";
              Modelica.SIunits.HeatFlowRate Q_flow
                                                  "Heat flow rate (positive if flowing from outside into the component)";
            end port_b_rec;
          public
            port_b_rec port_b;
            Modelica.SIunits.Temperature T
                                          "Average temperature of element";
            parameter Modelica.SIunits.Temperature T_start(fixed=false)
                                                                       "Start temperature for the average temperature of element";
            Modelica.SIunits.ThermalConductance G
                                                 "Thermal conductance of material";
            Modelica.SIunits.ThermalConductivity k
                                                  "Thermal conductivity";
            parameter Modelica.SIunits.Length r_internal(fixed=false)
                                                                     "Inner radius of cylinder";
            parameter Modelica.SIunits.Length r_external(fixed=false)
                                                                     "Outer radius of cylinder";
            parameter Modelica.SIunits.Length L(fixed=false)
                                                            "Length of cylinder";
            parameter Modelica.SIunits.Angle alpha(fixed=false)
                                                               "Swept angle";
          end thermalConductor_b_1_rec;
        public
          thermalConductor_b_1_rec thermalConductor_b_1;
        protected
          record thermalConductor_a_2_rec
            Modelica.SIunits.HeatFlowRate Q_flow
                                                "Heat flow rate from port_a -> port_b";
            Modelica.SIunits.TemperatureDifference dT
                                                     "port_a.T - port_b.T";
          protected
            record port_a_rec
              Modelica.SIunits.Temperature T
                                            "Port temperature";
              Modelica.SIunits.HeatFlowRate Q_flow
                                                  "Heat flow rate (positive if flowing from outside into the component)";
            end port_a_rec;
          public
            port_a_rec port_a;
          protected
            record port_b_rec
              Modelica.SIunits.Temperature T
                                            "Port temperature";
              Modelica.SIunits.HeatFlowRate Q_flow
                                                  "Heat flow rate (positive if flowing from outside into the component)";
            end port_b_rec;
          public
            port_b_rec port_b;
            Modelica.SIunits.Temperature T
                                          "Average temperature of element";
            parameter Modelica.SIunits.Temperature T_start(fixed=false)
                                                                       "Start temperature for the average temperature of element";
            Modelica.SIunits.ThermalConductance G
                                                 "Thermal conductance of material";
            Modelica.SIunits.ThermalConductivity k
                                                  "Thermal conductivity";
            parameter Modelica.SIunits.Length L(fixed=false)
                                                            "length of conduction";
            parameter Modelica.SIunits.Area A(fixed=false)
                                                          "Heat transfer area";
          end thermalConductor_a_2_rec;
        public
          thermalConductor_a_2_rec thermalConductor_a_2;
        protected
          record thermalConductor_b_2_rec
            Modelica.SIunits.HeatFlowRate Q_flow
                                                "Heat flow rate from port_a -> port_b";
            Modelica.SIunits.TemperatureDifference dT
                                                     "port_a.T - port_b.T";
          protected
            record port_a_rec
              Modelica.SIunits.Temperature T
                                            "Port temperature";
              Modelica.SIunits.HeatFlowRate Q_flow
                                                  "Heat flow rate (positive if flowing from outside into the component)";
            end port_a_rec;
          public
            port_a_rec port_a;
          protected
            record port_b_rec
              Modelica.SIunits.Temperature T
                                            "Port temperature";
              Modelica.SIunits.HeatFlowRate Q_flow
                                                  "Heat flow rate (positive if flowing from outside into the component)";
            end port_b_rec;
          public
            port_b_rec port_b;
            Modelica.SIunits.Temperature T
                                          "Average temperature of element";
            parameter Modelica.SIunits.Temperature T_start(fixed=false)
                                                                       "Start temperature for the average temperature of element";
            Modelica.SIunits.ThermalConductance G
                                                 "Thermal conductance of material";
            Modelica.SIunits.ThermalConductivity k
                                                  "Thermal conductivity";
            parameter Modelica.SIunits.Length L(fixed=false)
                                                            "length of conduction";
            parameter Modelica.SIunits.Area A(fixed=false)
                                                          "Heat transfer area";
          end thermalConductor_b_2_rec;
        public
          thermalConductor_b_2_rec thermalConductor_b_2;
        protected
          record thermalConductor_a_3_rec
            constant Modelica.SIunits.HeatFlowRate Q_flow = 0.0
                                                               "Heat flow rate from port_a -> port_b";
            Modelica.SIunits.TemperatureDifference dT
                                                     "port_a.T - port_b.T";
          protected
            record port_a_rec
              Modelica.SIunits.Temperature T
                                            "Port temperature";
              constant Modelica.SIunits.HeatFlowRate Q_flow = 0.0
                                                                 "Heat flow rate (positive if flowing from outside into the component)";
            end port_a_rec;
          public
            port_a_rec port_a;
          protected
            record port_b_rec
              Modelica.SIunits.Temperature T
                                            "Port temperature";
              constant Modelica.SIunits.HeatFlowRate Q_flow = 0.0
                                                                 "Heat flow rate (positive if flowing from outside into the component)";
            end port_b_rec;
          public
            port_b_rec port_b;
            Modelica.SIunits.Temperature T
                                          "Average temperature of element";
            parameter Modelica.SIunits.Temperature T_start(fixed=false)
                                                                       "Start temperature for the average temperature of element";
            Modelica.SIunits.ThermalConductance G
                                                 "Thermal conductance of material";
            Modelica.SIunits.ThermalConductivity k
                                                  "Thermal conductivity";
            parameter Modelica.SIunits.Length L(fixed=false)
                                                            "length of conduction";
            parameter Modelica.SIunits.Area A(fixed=false)
                                                          "Heat transfer area";
          end thermalConductor_a_3_rec;
        public
          thermalConductor_a_3_rec thermalConductor_a_3;
        protected
          record thermalConductor_b_3_rec
            constant Modelica.SIunits.HeatFlowRate Q_flow = 0.0
                                                               "Heat flow rate from port_a -> port_b";
            Modelica.SIunits.TemperatureDifference dT
                                                     "port_a.T - port_b.T";
          protected
            record port_a_rec
              Modelica.SIunits.Temperature T
                                            "Port temperature";
              constant Modelica.SIunits.HeatFlowRate Q_flow = 0.0
                                                                 "Heat flow rate (positive if flowing from outside into the component)";
            end port_a_rec;
          public
            port_a_rec port_a;
          protected
            record port_b_rec
              Modelica.SIunits.Temperature T
                                            "Port temperature";
              constant Modelica.SIunits.HeatFlowRate Q_flow = 0.0
                                                                 "Heat flow rate (positive if flowing from outside into the component)";
            end port_b_rec;
          public
            port_b_rec port_b;
            Modelica.SIunits.Temperature T
                                          "Average temperature of element";
            parameter Modelica.SIunits.Temperature T_start(fixed=false)
                                                                       "Start temperature for the average temperature of element";
            Modelica.SIunits.ThermalConductance G
                                                 "Thermal conductance of material";
            Modelica.SIunits.ThermalConductivity k
                                                  "Thermal conductivity";
            parameter Modelica.SIunits.Length L(fixed=false)
                                                            "length of conduction";
            parameter Modelica.SIunits.Area A(fixed=false)
                                                          "Heat transfer area";
          end thermalConductor_b_3_rec;
        public
          thermalConductor_b_3_rec thermalConductor_b_3;
        protected
          record heatCapacitor_rec
            Modelica.SIunits.Temperature T
                                          "Temperature of element";
            Real T_der(unit = "K/s")
                                    "der(Temperature of element)";
            Modelica.SIunits.HeatFlowRate Q_flow;
            parameter Modelica.SIunits.Temperature T_start(fixed=false)
                                                                       "Start temperature for the average temperature of ellement";
          protected
            record port_rec
              Modelica.SIunits.Temperature T
                                            "Port temperature";
              Modelica.SIunits.HeatFlowRate Q_flow
                                                  "Heat flow rate (positive if flowing from outside into the component)";
            end port_rec;
          public
            port_rec port;
            parameter Modelica.SIunits.Volume V(fixed=false)
                                                            "Volume of element";
            parameter Modelica.SIunits.Mass m(fixed=false)
                                                          "Mass of element";
            Modelica.SIunits.TemperatureSlope der_T
                                                   "Time derivative of temperature (= der(T))";
            Modelica.SIunits.HeatCapacity C
                                           "Heat capacity of element (= cp*m)";
            parameter Modelica.SIunits.TemperatureSlope der_T_start(fixed=false)
                                                                                "Start value ofime derivative of temperature (= der(T))";
          end heatCapacitor_rec;
        public
          heatCapacitor_rec heatCapacitor;
        protected
          record port_int_rec
            Modelica.SIunits.Temperature T
                                          "Port temperature";
            constant Modelica.SIunits.HeatFlowRate Q_flow = 0.0
                                                               "Heat flow rate (positive if flowing from outside into the component)";
          end port_int_rec;
        public
          port_int_rec port_int;
        end 'thermalNode[1, 6, 1]_rec';
      public
        'thermalNode[1, 6, 1]_rec' 'thermalNode[1, 6, 1]' annotation(Dialog);
      protected
        record 'thermalNode[1, 7, 1]_rec'
          parameter Real nParallel(min = 1.0) = 1
                                                 "Number of identical parallel elements";
          constant Boolean use_portDim1 = true
                                              "Heat tranfer in 1st dimention";
          constant Boolean use_portDim2 = true
                                              "Heat tranfer in 2nd dimention";
          constant Boolean use_portDim3 = false
                                               "Heat tranfer in 3rd dimention";
        protected
          record port_a_1_rec
            Modelica.SIunits.Temperature T
                                          "Port temperature";
            Modelica.SIunits.HeatFlowRate Q_flow
                                                "Heat flow rate (positive if flowing from outside into the component)";
          end port_a_1_rec;
        public
          port_a_1_rec port_a_1;
        protected
          record port_b_1_rec
            Modelica.SIunits.Temperature T
                                          "Port temperature";
            Modelica.SIunits.HeatFlowRate Q_flow
                                                "Heat flow rate (positive if flowing from outside into the component)";
          end port_b_1_rec;
        public
          port_b_1_rec port_b_1;
        protected
          record port_a_2_rec
            Modelica.SIunits.Temperature T
                                          "Port temperature";
            Modelica.SIunits.HeatFlowRate Q_flow
                                                "Heat flow rate (positive if flowing from outside into the component)";
          end port_a_2_rec;
        public
          port_a_2_rec port_a_2;
        protected
          record port_b_2_rec
            Modelica.SIunits.Temperature T
                                          "Port temperature";
            Modelica.SIunits.HeatFlowRate Q_flow
                                                "Heat flow rate (positive if flowing from outside into the component)";
          end port_b_2_rec;
        public
          port_b_2_rec port_b_2;
          parameter Modelica.SIunits.Volume V(fixed=false)
                                                          "Volume of material";
        protected
          record thermalConductor_a_1_rec
            Modelica.SIunits.HeatFlowRate Q_flow
                                                "Heat flow rate from port_a -> port_b";
            Modelica.SIunits.TemperatureDifference dT
                                                     "port_a.T - port_b.T";
          protected
            record port_a_rec
              Modelica.SIunits.Temperature T
                                            "Port temperature";
              Modelica.SIunits.HeatFlowRate Q_flow
                                                  "Heat flow rate (positive if flowing from outside into the component)";
            end port_a_rec;
          public
            port_a_rec port_a;
          protected
            record port_b_rec
              Modelica.SIunits.Temperature T
                                            "Port temperature";
              Modelica.SIunits.HeatFlowRate Q_flow
                                                  "Heat flow rate (positive if flowing from outside into the component)";
            end port_b_rec;
          public
            port_b_rec port_b;
            Modelica.SIunits.Temperature T
                                          "Average temperature of element";
            parameter Modelica.SIunits.Temperature T_start(fixed=false)
                                                                       "Start temperature for the average temperature of element";
            Modelica.SIunits.ThermalConductance G
                                                 "Thermal conductance of material";
            Modelica.SIunits.ThermalConductivity k
                                                  "Thermal conductivity";
            parameter Modelica.SIunits.Length r_internal(fixed=false)
                                                                     "Inner radius of cylinder";
            parameter Modelica.SIunits.Length r_external(fixed=false)
                                                                     "Outer radius of cylinder";
            parameter Modelica.SIunits.Length L(fixed=false)
                                                            "Length of cylinder";
            parameter Modelica.SIunits.Angle alpha(fixed=false)
                                                               "Swept angle";
          end thermalConductor_a_1_rec;
        public
          thermalConductor_a_1_rec thermalConductor_a_1;
        protected
          record thermalConductor_b_1_rec
            Modelica.SIunits.HeatFlowRate Q_flow
                                                "Heat flow rate from port_a -> port_b";
            Modelica.SIunits.TemperatureDifference dT
                                                     "port_a.T - port_b.T";
          protected
            record port_a_rec
              Modelica.SIunits.Temperature T
                                            "Port temperature";
              Modelica.SIunits.HeatFlowRate Q_flow
                                                  "Heat flow rate (positive if flowing from outside into the component)";
            end port_a_rec;
          public
            port_a_rec port_a;
          protected
            record port_b_rec
              Modelica.SIunits.Temperature T
                                            "Port temperature";
              Modelica.SIunits.HeatFlowRate Q_flow
                                                  "Heat flow rate (positive if flowing from outside into the component)";
            end port_b_rec;
          public
            port_b_rec port_b;
            Modelica.SIunits.Temperature T
                                          "Average temperature of element";
            parameter Modelica.SIunits.Temperature T_start(fixed=false)
                                                                       "Start temperature for the average temperature of element";
            Modelica.SIunits.ThermalConductance G
                                                 "Thermal conductance of material";
            Modelica.SIunits.ThermalConductivity k
                                                  "Thermal conductivity";
            parameter Modelica.SIunits.Length r_internal(fixed=false)
                                                                     "Inner radius of cylinder";
            parameter Modelica.SIunits.Length r_external(fixed=false)
                                                                     "Outer radius of cylinder";
            parameter Modelica.SIunits.Length L(fixed=false)
                                                            "Length of cylinder";
            parameter Modelica.SIunits.Angle alpha(fixed=false)
                                                               "Swept angle";
          end thermalConductor_b_1_rec;
        public
          thermalConductor_b_1_rec thermalConductor_b_1;
        protected
          record thermalConductor_a_2_rec
            Modelica.SIunits.HeatFlowRate Q_flow
                                                "Heat flow rate from port_a -> port_b";
            Modelica.SIunits.TemperatureDifference dT
                                                     "port_a.T - port_b.T";
          protected
            record port_a_rec
              Modelica.SIunits.Temperature T
                                            "Port temperature";
              Modelica.SIunits.HeatFlowRate Q_flow
                                                  "Heat flow rate (positive if flowing from outside into the component)";
            end port_a_rec;
          public
            port_a_rec port_a;
          protected
            record port_b_rec
              Modelica.SIunits.Temperature T
                                            "Port temperature";
              Modelica.SIunits.HeatFlowRate Q_flow
                                                  "Heat flow rate (positive if flowing from outside into the component)";
            end port_b_rec;
          public
            port_b_rec port_b;
            Modelica.SIunits.Temperature T
                                          "Average temperature of element";
            parameter Modelica.SIunits.Temperature T_start(fixed=false)
                                                                       "Start temperature for the average temperature of element";
            Modelica.SIunits.ThermalConductance G
                                                 "Thermal conductance of material";
            Modelica.SIunits.ThermalConductivity k
                                                  "Thermal conductivity";
            parameter Modelica.SIunits.Length L(fixed=false)
                                                            "length of conduction";
            parameter Modelica.SIunits.Area A(fixed=false)
                                                          "Heat transfer area";
          end thermalConductor_a_2_rec;
        public
          thermalConductor_a_2_rec thermalConductor_a_2;
        protected
          record thermalConductor_b_2_rec
            Modelica.SIunits.HeatFlowRate Q_flow
                                                "Heat flow rate from port_a -> port_b";
            Modelica.SIunits.TemperatureDifference dT
                                                     "port_a.T - port_b.T";
          protected
            record port_a_rec
              Modelica.SIunits.Temperature T
                                            "Port temperature";
              Modelica.SIunits.HeatFlowRate Q_flow
                                                  "Heat flow rate (positive if flowing from outside into the component)";
            end port_a_rec;
          public
            port_a_rec port_a;
          protected
            record port_b_rec
              Modelica.SIunits.Temperature T
                                            "Port temperature";
              Modelica.SIunits.HeatFlowRate Q_flow
                                                  "Heat flow rate (positive if flowing from outside into the component)";
            end port_b_rec;
          public
            port_b_rec port_b;
            Modelica.SIunits.Temperature T
                                          "Average temperature of element";
            parameter Modelica.SIunits.Temperature T_start(fixed=false)
                                                                       "Start temperature for the average temperature of element";
            Modelica.SIunits.ThermalConductance G
                                                 "Thermal conductance of material";
            Modelica.SIunits.ThermalConductivity k
                                                  "Thermal conductivity";
            parameter Modelica.SIunits.Length L(fixed=false)
                                                            "length of conduction";
            parameter Modelica.SIunits.Area A(fixed=false)
                                                          "Heat transfer area";
          end thermalConductor_b_2_rec;
        public
          thermalConductor_b_2_rec thermalConductor_b_2;
        protected
          record thermalConductor_a_3_rec
            constant Modelica.SIunits.HeatFlowRate Q_flow = 0.0
                                                               "Heat flow rate from port_a -> port_b";
            Modelica.SIunits.TemperatureDifference dT
                                                     "port_a.T - port_b.T";
          protected
            record port_a_rec
              Modelica.SIunits.Temperature T
                                            "Port temperature";
              constant Modelica.SIunits.HeatFlowRate Q_flow = 0.0
                                                                 "Heat flow rate (positive if flowing from outside into the component)";
            end port_a_rec;
          public
            port_a_rec port_a;
          protected
            record port_b_rec
              Modelica.SIunits.Temperature T
                                            "Port temperature";
              constant Modelica.SIunits.HeatFlowRate Q_flow = 0.0
                                                                 "Heat flow rate (positive if flowing from outside into the component)";
            end port_b_rec;
          public
            port_b_rec port_b;
            Modelica.SIunits.Temperature T
                                          "Average temperature of element";
            parameter Modelica.SIunits.Temperature T_start(fixed=false)
                                                                       "Start temperature for the average temperature of element";
            Modelica.SIunits.ThermalConductance G
                                                 "Thermal conductance of material";
            Modelica.SIunits.ThermalConductivity k
                                                  "Thermal conductivity";
            parameter Modelica.SIunits.Length L(fixed=false)
                                                            "length of conduction";
            parameter Modelica.SIunits.Area A(fixed=false)
                                                          "Heat transfer area";
          end thermalConductor_a_3_rec;
        public
          thermalConductor_a_3_rec thermalConductor_a_3;
        protected
          record thermalConductor_b_3_rec
            constant Modelica.SIunits.HeatFlowRate Q_flow = 0.0
                                                               "Heat flow rate from port_a -> port_b";
            Modelica.SIunits.TemperatureDifference dT
                                                     "port_a.T - port_b.T";
          protected
            record port_a_rec
              Modelica.SIunits.Temperature T
                                            "Port temperature";
              constant Modelica.SIunits.HeatFlowRate Q_flow = 0.0
                                                                 "Heat flow rate (positive if flowing from outside into the component)";
            end port_a_rec;
          public
            port_a_rec port_a;
          protected
            record port_b_rec
              Modelica.SIunits.Temperature T
                                            "Port temperature";
              constant Modelica.SIunits.HeatFlowRate Q_flow = 0.0
                                                                 "Heat flow rate (positive if flowing from outside into the component)";
            end port_b_rec;
          public
            port_b_rec port_b;
            Modelica.SIunits.Temperature T
                                          "Average temperature of element";
            parameter Modelica.SIunits.Temperature T_start(fixed=false)
                                                                       "Start temperature for the average temperature of element";
            Modelica.SIunits.ThermalConductance G
                                                 "Thermal conductance of material";
            Modelica.SIunits.ThermalConductivity k
                                                  "Thermal conductivity";
            parameter Modelica.SIunits.Length L(fixed=false)
                                                            "length of conduction";
            parameter Modelica.SIunits.Area A(fixed=false)
                                                          "Heat transfer area";
          end thermalConductor_b_3_rec;
        public
          thermalConductor_b_3_rec thermalConductor_b_3;
        protected
          record heatCapacitor_rec
            Modelica.SIunits.Temperature T
                                          "Temperature of element";
            Real T_der(unit = "K/s")
                                    "der(Temperature of element)";
            Modelica.SIunits.HeatFlowRate Q_flow;
            parameter Modelica.SIunits.Temperature T_start(fixed=false)
                                                                       "Start temperature for the average temperature of ellement";
          protected
            record port_rec
              Modelica.SIunits.Temperature T
                                            "Port temperature";
              Modelica.SIunits.HeatFlowRate Q_flow
                                                  "Heat flow rate (positive if flowing from outside into the component)";
            end port_rec;
          public
            port_rec port;
            parameter Modelica.SIunits.Volume V(fixed=false)
                                                            "Volume of element";
            parameter Modelica.SIunits.Mass m(fixed=false)
                                                          "Mass of element";
            Modelica.SIunits.TemperatureSlope der_T
                                                   "Time derivative of temperature (= der(T))";
            Modelica.SIunits.HeatCapacity C
                                           "Heat capacity of element (= cp*m)";
            parameter Modelica.SIunits.TemperatureSlope der_T_start(fixed=false)
                                                                                "Start value ofime derivative of temperature (= der(T))";
          end heatCapacitor_rec;
        public
          heatCapacitor_rec heatCapacitor;
        protected
          record port_int_rec
            Modelica.SIunits.Temperature T
                                          "Port temperature";
            constant Modelica.SIunits.HeatFlowRate Q_flow = 0.0
                                                               "Heat flow rate (positive if flowing from outside into the component)";
          end port_int_rec;
        public
          port_int_rec port_int;
        end 'thermalNode[1, 7, 1]_rec';
      public
        'thermalNode[1, 7, 1]_rec' 'thermalNode[1, 7, 1]' annotation(Dialog);
      protected
        record 'thermalNode[1, 8, 1]_rec'
          parameter Real nParallel(min = 1.0) = 1
                                                 "Number of identical parallel elements";
          constant Boolean use_portDim1 = true
                                              "Heat tranfer in 1st dimention";
          constant Boolean use_portDim2 = true
                                              "Heat tranfer in 2nd dimention";
          constant Boolean use_portDim3 = false
                                               "Heat tranfer in 3rd dimention";
        protected
          record port_a_1_rec
            Modelica.SIunits.Temperature T
                                          "Port temperature";
            Modelica.SIunits.HeatFlowRate Q_flow
                                                "Heat flow rate (positive if flowing from outside into the component)";
          end port_a_1_rec;
        public
          port_a_1_rec port_a_1;
        protected
          record port_b_1_rec
            Modelica.SIunits.Temperature T
                                          "Port temperature";
            Modelica.SIunits.HeatFlowRate Q_flow
                                                "Heat flow rate (positive if flowing from outside into the component)";
          end port_b_1_rec;
        public
          port_b_1_rec port_b_1;
        protected
          record port_a_2_rec
            Modelica.SIunits.Temperature T
                                          "Port temperature";
            Modelica.SIunits.HeatFlowRate Q_flow
                                                "Heat flow rate (positive if flowing from outside into the component)";
          end port_a_2_rec;
        public
          port_a_2_rec port_a_2;
        protected
          record port_b_2_rec
            Modelica.SIunits.Temperature T
                                          "Port temperature";
            Modelica.SIunits.HeatFlowRate Q_flow
                                                "Heat flow rate (positive if flowing from outside into the component)";
          end port_b_2_rec;
        public
          port_b_2_rec port_b_2;
          parameter Modelica.SIunits.Volume V(fixed=false)
                                                          "Volume of material";
        protected
          record thermalConductor_a_1_rec
            Modelica.SIunits.HeatFlowRate Q_flow
                                                "Heat flow rate from port_a -> port_b";
            Modelica.SIunits.TemperatureDifference dT
                                                     "port_a.T - port_b.T";
          protected
            record port_a_rec
              Modelica.SIunits.Temperature T
                                            "Port temperature";
              Modelica.SIunits.HeatFlowRate Q_flow
                                                  "Heat flow rate (positive if flowing from outside into the component)";
            end port_a_rec;
          public
            port_a_rec port_a;
          protected
            record port_b_rec
              Modelica.SIunits.Temperature T
                                            "Port temperature";
              Modelica.SIunits.HeatFlowRate Q_flow
                                                  "Heat flow rate (positive if flowing from outside into the component)";
            end port_b_rec;
          public
            port_b_rec port_b;
            Modelica.SIunits.Temperature T
                                          "Average temperature of element";
            parameter Modelica.SIunits.Temperature T_start(fixed=false)
                                                                       "Start temperature for the average temperature of element";
            Modelica.SIunits.ThermalConductance G
                                                 "Thermal conductance of material";
            Modelica.SIunits.ThermalConductivity k
                                                  "Thermal conductivity";
            parameter Modelica.SIunits.Length r_internal(fixed=false)
                                                                     "Inner radius of cylinder";
            parameter Modelica.SIunits.Length r_external(fixed=false)
                                                                     "Outer radius of cylinder";
            parameter Modelica.SIunits.Length L(fixed=false)
                                                            "Length of cylinder";
            parameter Modelica.SIunits.Angle alpha(fixed=false)
                                                               "Swept angle";
          end thermalConductor_a_1_rec;
        public
          thermalConductor_a_1_rec thermalConductor_a_1;
        protected
          record thermalConductor_b_1_rec
            Modelica.SIunits.HeatFlowRate Q_flow
                                                "Heat flow rate from port_a -> port_b";
            Modelica.SIunits.TemperatureDifference dT
                                                     "port_a.T - port_b.T";
          protected
            record port_a_rec
              Modelica.SIunits.Temperature T
                                            "Port temperature";
              Modelica.SIunits.HeatFlowRate Q_flow
                                                  "Heat flow rate (positive if flowing from outside into the component)";
            end port_a_rec;
          public
            port_a_rec port_a;
          protected
            record port_b_rec
              Modelica.SIunits.Temperature T
                                            "Port temperature";
              Modelica.SIunits.HeatFlowRate Q_flow
                                                  "Heat flow rate (positive if flowing from outside into the component)";
            end port_b_rec;
          public
            port_b_rec port_b;
            Modelica.SIunits.Temperature T
                                          "Average temperature of element";
            parameter Modelica.SIunits.Temperature T_start(fixed=false)
                                                                       "Start temperature for the average temperature of element";
            Modelica.SIunits.ThermalConductance G
                                                 "Thermal conductance of material";
            Modelica.SIunits.ThermalConductivity k
                                                  "Thermal conductivity";
            parameter Modelica.SIunits.Length r_internal(fixed=false)
                                                                     "Inner radius of cylinder";
            parameter Modelica.SIunits.Length r_external(fixed=false)
                                                                     "Outer radius of cylinder";
            parameter Modelica.SIunits.Length L(fixed=false)
                                                            "Length of cylinder";
            parameter Modelica.SIunits.Angle alpha(fixed=false)
                                                               "Swept angle";
          end thermalConductor_b_1_rec;
        public
          thermalConductor_b_1_rec thermalConductor_b_1;
        protected
          record thermalConductor_a_2_rec
            Modelica.SIunits.HeatFlowRate Q_flow
                                                "Heat flow rate from port_a -> port_b";
            Modelica.SIunits.TemperatureDifference dT
                                                     "port_a.T - port_b.T";
          protected
            record port_a_rec
              Modelica.SIunits.Temperature T
                                            "Port temperature";
              Modelica.SIunits.HeatFlowRate Q_flow
                                                  "Heat flow rate (positive if flowing from outside into the component)";
            end port_a_rec;
          public
            port_a_rec port_a;
          protected
            record port_b_rec
              Modelica.SIunits.Temperature T
                                            "Port temperature";
              Modelica.SIunits.HeatFlowRate Q_flow
                                                  "Heat flow rate (positive if flowing from outside into the component)";
            end port_b_rec;
          public
            port_b_rec port_b;
            Modelica.SIunits.Temperature T
                                          "Average temperature of element";
            parameter Modelica.SIunits.Temperature T_start(fixed=false)
                                                                       "Start temperature for the average temperature of element";
            Modelica.SIunits.ThermalConductance G
                                                 "Thermal conductance of material";
            Modelica.SIunits.ThermalConductivity k
                                                  "Thermal conductivity";
            parameter Modelica.SIunits.Length L(fixed=false)
                                                            "length of conduction";
            parameter Modelica.SIunits.Area A(fixed=false)
                                                          "Heat transfer area";
          end thermalConductor_a_2_rec;
        public
          thermalConductor_a_2_rec thermalConductor_a_2;
        protected
          record thermalConductor_b_2_rec
            Modelica.SIunits.HeatFlowRate Q_flow
                                                "Heat flow rate from port_a -> port_b";
            Modelica.SIunits.TemperatureDifference dT
                                                     "port_a.T - port_b.T";
          protected
            record port_a_rec
              Modelica.SIunits.Temperature T
                                            "Port temperature";
              Modelica.SIunits.HeatFlowRate Q_flow
                                                  "Heat flow rate (positive if flowing from outside into the component)";
            end port_a_rec;
          public
            port_a_rec port_a;
          protected
            record port_b_rec
              Modelica.SIunits.Temperature T
                                            "Port temperature";
              Modelica.SIunits.HeatFlowRate Q_flow
                                                  "Heat flow rate (positive if flowing from outside into the component)";
            end port_b_rec;
          public
            port_b_rec port_b;
            Modelica.SIunits.Temperature T
                                          "Average temperature of element";
            parameter Modelica.SIunits.Temperature T_start(fixed=false)
                                                                       "Start temperature for the average temperature of element";
            Modelica.SIunits.ThermalConductance G
                                                 "Thermal conductance of material";
            Modelica.SIunits.ThermalConductivity k
                                                  "Thermal conductivity";
            parameter Modelica.SIunits.Length L(fixed=false)
                                                            "length of conduction";
            parameter Modelica.SIunits.Area A(fixed=false)
                                                          "Heat transfer area";
          end thermalConductor_b_2_rec;
        public
          thermalConductor_b_2_rec thermalConductor_b_2;
        protected
          record thermalConductor_a_3_rec
            constant Modelica.SIunits.HeatFlowRate Q_flow = 0.0
                                                               "Heat flow rate from port_a -> port_b";
            Modelica.SIunits.TemperatureDifference dT
                                                     "port_a.T - port_b.T";
          protected
            record port_a_rec
              Modelica.SIunits.Temperature T
                                            "Port temperature";
              constant Modelica.SIunits.HeatFlowRate Q_flow = 0.0
                                                                 "Heat flow rate (positive if flowing from outside into the component)";
            end port_a_rec;
          public
            port_a_rec port_a;
          protected
            record port_b_rec
              Modelica.SIunits.Temperature T
                                            "Port temperature";
              constant Modelica.SIunits.HeatFlowRate Q_flow = 0.0
                                                                 "Heat flow rate (positive if flowing from outside into the component)";
            end port_b_rec;
          public
            port_b_rec port_b;
            Modelica.SIunits.Temperature T
                                          "Average temperature of element";
            parameter Modelica.SIunits.Temperature T_start(fixed=false)
                                                                       "Start temperature for the average temperature of element";
            Modelica.SIunits.ThermalConductance G
                                                 "Thermal conductance of material";
            Modelica.SIunits.ThermalConductivity k
                                                  "Thermal conductivity";
            parameter Modelica.SIunits.Length L(fixed=false)
                                                            "length of conduction";
            parameter Modelica.SIunits.Area A(fixed=false)
                                                          "Heat transfer area";
          end thermalConductor_a_3_rec;
        public
          thermalConductor_a_3_rec thermalConductor_a_3;
        protected
          record thermalConductor_b_3_rec
            constant Modelica.SIunits.HeatFlowRate Q_flow = 0.0
                                                               "Heat flow rate from port_a -> port_b";
            Modelica.SIunits.TemperatureDifference dT
                                                     "port_a.T - port_b.T";
          protected
            record port_a_rec
              Modelica.SIunits.Temperature T
                                            "Port temperature";
              constant Modelica.SIunits.HeatFlowRate Q_flow = 0.0
                                                                 "Heat flow rate (positive if flowing from outside into the component)";
            end port_a_rec;
          public
            port_a_rec port_a;
          protected
            record port_b_rec
              Modelica.SIunits.Temperature T
                                            "Port temperature";
              constant Modelica.SIunits.HeatFlowRate Q_flow = 0.0
                                                                 "Heat flow rate (positive if flowing from outside into the component)";
            end port_b_rec;
          public
            port_b_rec port_b;
            Modelica.SIunits.Temperature T
                                          "Average temperature of element";
            parameter Modelica.SIunits.Temperature T_start(fixed=false)
                                                                       "Start temperature for the average temperature of element";
            Modelica.SIunits.ThermalConductance G
                                                 "Thermal conductance of material";
            Modelica.SIunits.ThermalConductivity k
                                                  "Thermal conductivity";
            parameter Modelica.SIunits.Length L(fixed=false)
                                                            "length of conduction";
            parameter Modelica.SIunits.Area A(fixed=false)
                                                          "Heat transfer area";
          end thermalConductor_b_3_rec;
        public
          thermalConductor_b_3_rec thermalConductor_b_3;
        protected
          record heatCapacitor_rec
            Modelica.SIunits.Temperature T
                                          "Temperature of element";
            Real T_der(unit = "K/s")
                                    "der(Temperature of element)";
            Modelica.SIunits.HeatFlowRate Q_flow;
            parameter Modelica.SIunits.Temperature T_start(fixed=false)
                                                                       "Start temperature for the average temperature of ellement";
          protected
            record port_rec
              Modelica.SIunits.Temperature T
                                            "Port temperature";
              Modelica.SIunits.HeatFlowRate Q_flow
                                                  "Heat flow rate (positive if flowing from outside into the component)";
            end port_rec;
          public
            port_rec port;
            parameter Modelica.SIunits.Volume V(fixed=false)
                                                            "Volume of element";
            parameter Modelica.SIunits.Mass m(fixed=false)
                                                          "Mass of element";
            Modelica.SIunits.TemperatureSlope der_T
                                                   "Time derivative of temperature (= der(T))";
            Modelica.SIunits.HeatCapacity C
                                           "Heat capacity of element (= cp*m)";
            parameter Modelica.SIunits.TemperatureSlope der_T_start(fixed=false)
                                                                                "Start value ofime derivative of temperature (= der(T))";
          end heatCapacitor_rec;
        public
          heatCapacitor_rec heatCapacitor;
        protected
          record port_int_rec
            Modelica.SIunits.Temperature T
                                          "Port temperature";
            constant Modelica.SIunits.HeatFlowRate Q_flow = 0.0
                                                               "Heat flow rate (positive if flowing from outside into the component)";
          end port_int_rec;
        public
          port_int_rec port_int;
        end 'thermalNode[1, 8, 1]_rec';
      public
        'thermalNode[1, 8, 1]_rec' 'thermalNode[1, 8, 1]' annotation(Dialog);
      protected
        record 'thermalNode[1, 9, 1]_rec'
          parameter Real nParallel(min = 1.0) = 1
                                                 "Number of identical parallel elements";
          constant Boolean use_portDim1 = true
                                              "Heat tranfer in 1st dimention";
          constant Boolean use_portDim2 = true
                                              "Heat tranfer in 2nd dimention";
          constant Boolean use_portDim3 = false
                                               "Heat tranfer in 3rd dimention";
        protected
          record port_a_1_rec
            Modelica.SIunits.Temperature T
                                          "Port temperature";
            Modelica.SIunits.HeatFlowRate Q_flow
                                                "Heat flow rate (positive if flowing from outside into the component)";
          end port_a_1_rec;
        public
          port_a_1_rec port_a_1;
        protected
          record port_b_1_rec
            Modelica.SIunits.Temperature T
                                          "Port temperature";
            Modelica.SIunits.HeatFlowRate Q_flow
                                                "Heat flow rate (positive if flowing from outside into the component)";
          end port_b_1_rec;
        public
          port_b_1_rec port_b_1;
        protected
          record port_a_2_rec
            Modelica.SIunits.Temperature T
                                          "Port temperature";
            Modelica.SIunits.HeatFlowRate Q_flow
                                                "Heat flow rate (positive if flowing from outside into the component)";
          end port_a_2_rec;
        public
          port_a_2_rec port_a_2;
        protected
          record port_b_2_rec
            Modelica.SIunits.Temperature T
                                          "Port temperature";
            Modelica.SIunits.HeatFlowRate Q_flow
                                                "Heat flow rate (positive if flowing from outside into the component)";
          end port_b_2_rec;
        public
          port_b_2_rec port_b_2;
          parameter Modelica.SIunits.Volume V(fixed=false)
                                                          "Volume of material";
        protected
          record thermalConductor_a_1_rec
            Modelica.SIunits.HeatFlowRate Q_flow
                                                "Heat flow rate from port_a -> port_b";
            Modelica.SIunits.TemperatureDifference dT
                                                     "port_a.T - port_b.T";
          protected
            record port_a_rec
              Modelica.SIunits.Temperature T
                                            "Port temperature";
              Modelica.SIunits.HeatFlowRate Q_flow
                                                  "Heat flow rate (positive if flowing from outside into the component)";
            end port_a_rec;
          public
            port_a_rec port_a;
          protected
            record port_b_rec
              Modelica.SIunits.Temperature T
                                            "Port temperature";
              Modelica.SIunits.HeatFlowRate Q_flow
                                                  "Heat flow rate (positive if flowing from outside into the component)";
            end port_b_rec;
          public
            port_b_rec port_b;
            Modelica.SIunits.Temperature T
                                          "Average temperature of element";
            parameter Modelica.SIunits.Temperature T_start(fixed=false)
                                                                       "Start temperature for the average temperature of element";
            Modelica.SIunits.ThermalConductance G
                                                 "Thermal conductance of material";
            Modelica.SIunits.ThermalConductivity k
                                                  "Thermal conductivity";
            parameter Modelica.SIunits.Length r_internal(fixed=false)
                                                                     "Inner radius of cylinder";
            parameter Modelica.SIunits.Length r_external(fixed=false)
                                                                     "Outer radius of cylinder";
            parameter Modelica.SIunits.Length L(fixed=false)
                                                            "Length of cylinder";
            parameter Modelica.SIunits.Angle alpha(fixed=false)
                                                               "Swept angle";
          end thermalConductor_a_1_rec;
        public
          thermalConductor_a_1_rec thermalConductor_a_1;
        protected
          record thermalConductor_b_1_rec
            Modelica.SIunits.HeatFlowRate Q_flow
                                                "Heat flow rate from port_a -> port_b";
            Modelica.SIunits.TemperatureDifference dT
                                                     "port_a.T - port_b.T";
          protected
            record port_a_rec
              Modelica.SIunits.Temperature T
                                            "Port temperature";
              Modelica.SIunits.HeatFlowRate Q_flow
                                                  "Heat flow rate (positive if flowing from outside into the component)";
            end port_a_rec;
          public
            port_a_rec port_a;
          protected
            record port_b_rec
              Modelica.SIunits.Temperature T
                                            "Port temperature";
              Modelica.SIunits.HeatFlowRate Q_flow
                                                  "Heat flow rate (positive if flowing from outside into the component)";
            end port_b_rec;
          public
            port_b_rec port_b;
            Modelica.SIunits.Temperature T
                                          "Average temperature of element";
            parameter Modelica.SIunits.Temperature T_start(fixed=false)
                                                                       "Start temperature for the average temperature of element";
            Modelica.SIunits.ThermalConductance G
                                                 "Thermal conductance of material";
            Modelica.SIunits.ThermalConductivity k
                                                  "Thermal conductivity";
            parameter Modelica.SIunits.Length r_internal(fixed=false)
                                                                     "Inner radius of cylinder";
            parameter Modelica.SIunits.Length r_external(fixed=false)
                                                                     "Outer radius of cylinder";
            parameter Modelica.SIunits.Length L(fixed=false)
                                                            "Length of cylinder";
            parameter Modelica.SIunits.Angle alpha(fixed=false)
                                                               "Swept angle";
          end thermalConductor_b_1_rec;
        public
          thermalConductor_b_1_rec thermalConductor_b_1;
        protected
          record thermalConductor_a_2_rec
            Modelica.SIunits.HeatFlowRate Q_flow
                                                "Heat flow rate from port_a -> port_b";
            Modelica.SIunits.TemperatureDifference dT
                                                     "port_a.T - port_b.T";
          protected
            record port_a_rec
              Modelica.SIunits.Temperature T
                                            "Port temperature";
              Modelica.SIunits.HeatFlowRate Q_flow
                                                  "Heat flow rate (positive if flowing from outside into the component)";
            end port_a_rec;
          public
            port_a_rec port_a;
          protected
            record port_b_rec
              Modelica.SIunits.Temperature T
                                            "Port temperature";
              Modelica.SIunits.HeatFlowRate Q_flow
                                                  "Heat flow rate (positive if flowing from outside into the component)";
            end port_b_rec;
          public
            port_b_rec port_b;
            Modelica.SIunits.Temperature T
                                          "Average temperature of element";
            parameter Modelica.SIunits.Temperature T_start(fixed=false)
                                                                       "Start temperature for the average temperature of element";
            Modelica.SIunits.ThermalConductance G
                                                 "Thermal conductance of material";
            Modelica.SIunits.ThermalConductivity k
                                                  "Thermal conductivity";
            parameter Modelica.SIunits.Length L(fixed=false)
                                                            "length of conduction";
            parameter Modelica.SIunits.Area A(fixed=false)
                                                          "Heat transfer area";
          end thermalConductor_a_2_rec;
        public
          thermalConductor_a_2_rec thermalConductor_a_2;
        protected
          record thermalConductor_b_2_rec
            Modelica.SIunits.HeatFlowRate Q_flow
                                                "Heat flow rate from port_a -> port_b";
            Modelica.SIunits.TemperatureDifference dT
                                                     "port_a.T - port_b.T";
          protected
            record port_a_rec
              Modelica.SIunits.Temperature T
                                            "Port temperature";
              Modelica.SIunits.HeatFlowRate Q_flow
                                                  "Heat flow rate (positive if flowing from outside into the component)";
            end port_a_rec;
          public
            port_a_rec port_a;
          protected
            record port_b_rec
              Modelica.SIunits.Temperature T
                                            "Port temperature";
              Modelica.SIunits.HeatFlowRate Q_flow
                                                  "Heat flow rate (positive if flowing from outside into the component)";
            end port_b_rec;
          public
            port_b_rec port_b;
            Modelica.SIunits.Temperature T
                                          "Average temperature of element";
            parameter Modelica.SIunits.Temperature T_start(fixed=false)
                                                                       "Start temperature for the average temperature of element";
            Modelica.SIunits.ThermalConductance G
                                                 "Thermal conductance of material";
            Modelica.SIunits.ThermalConductivity k
                                                  "Thermal conductivity";
            parameter Modelica.SIunits.Length L(fixed=false)
                                                            "length of conduction";
            parameter Modelica.SIunits.Area A(fixed=false)
                                                          "Heat transfer area";
          end thermalConductor_b_2_rec;
        public
          thermalConductor_b_2_rec thermalConductor_b_2;
        protected
          record thermalConductor_a_3_rec
            constant Modelica.SIunits.HeatFlowRate Q_flow = 0.0
                                                               "Heat flow rate from port_a -> port_b";
            Modelica.SIunits.TemperatureDifference dT
                                                     "port_a.T - port_b.T";
          protected
            record port_a_rec
              Modelica.SIunits.Temperature T
                                            "Port temperature";
              constant Modelica.SIunits.HeatFlowRate Q_flow = 0.0
                                                                 "Heat flow rate (positive if flowing from outside into the component)";
            end port_a_rec;
          public
            port_a_rec port_a;
          protected
            record port_b_rec
              Modelica.SIunits.Temperature T
                                            "Port temperature";
              constant Modelica.SIunits.HeatFlowRate Q_flow = 0.0
                                                                 "Heat flow rate (positive if flowing from outside into the component)";
            end port_b_rec;
          public
            port_b_rec port_b;
            Modelica.SIunits.Temperature T
                                          "Average temperature of element";
            parameter Modelica.SIunits.Temperature T_start(fixed=false)
                                                                       "Start temperature for the average temperature of element";
            Modelica.SIunits.ThermalConductance G
                                                 "Thermal conductance of material";
            Modelica.SIunits.ThermalConductivity k
                                                  "Thermal conductivity";
            parameter Modelica.SIunits.Length L(fixed=false)
                                                            "length of conduction";
            parameter Modelica.SIunits.Area A(fixed=false)
                                                          "Heat transfer area";
          end thermalConductor_a_3_rec;
        public
          thermalConductor_a_3_rec thermalConductor_a_3;
        protected
          record thermalConductor_b_3_rec
            constant Modelica.SIunits.HeatFlowRate Q_flow = 0.0
                                                               "Heat flow rate from port_a -> port_b";
            Modelica.SIunits.TemperatureDifference dT
                                                     "port_a.T - port_b.T";
          protected
            record port_a_rec
              Modelica.SIunits.Temperature T
                                            "Port temperature";
              constant Modelica.SIunits.HeatFlowRate Q_flow = 0.0
                                                                 "Heat flow rate (positive if flowing from outside into the component)";
            end port_a_rec;
          public
            port_a_rec port_a;
          protected
            record port_b_rec
              Modelica.SIunits.Temperature T
                                            "Port temperature";
              constant Modelica.SIunits.HeatFlowRate Q_flow = 0.0
                                                                 "Heat flow rate (positive if flowing from outside into the component)";
            end port_b_rec;
          public
            port_b_rec port_b;
            Modelica.SIunits.Temperature T
                                          "Average temperature of element";
            parameter Modelica.SIunits.Temperature T_start(fixed=false)
                                                                       "Start temperature for the average temperature of element";
            Modelica.SIunits.ThermalConductance G
                                                 "Thermal conductance of material";
            Modelica.SIunits.ThermalConductivity k
                                                  "Thermal conductivity";
            parameter Modelica.SIunits.Length L(fixed=false)
                                                            "length of conduction";
            parameter Modelica.SIunits.Area A(fixed=false)
                                                          "Heat transfer area";
          end thermalConductor_b_3_rec;
        public
          thermalConductor_b_3_rec thermalConductor_b_3;
        protected
          record heatCapacitor_rec
            Modelica.SIunits.Temperature T
                                          "Temperature of element";
            Real T_der(unit = "K/s")
                                    "der(Temperature of element)";
            Modelica.SIunits.HeatFlowRate Q_flow;
            parameter Modelica.SIunits.Temperature T_start(fixed=false)
                                                                       "Start temperature for the average temperature of ellement";
          protected
            record port_rec
              Modelica.SIunits.Temperature T
                                            "Port temperature";
              Modelica.SIunits.HeatFlowRate Q_flow
                                                  "Heat flow rate (positive if flowing from outside into the component)";
            end port_rec;
          public
            port_rec port;
            parameter Modelica.SIunits.Volume V(fixed=false)
                                                            "Volume of element";
            parameter Modelica.SIunits.Mass m(fixed=false)
                                                          "Mass of element";
            Modelica.SIunits.TemperatureSlope der_T
                                                   "Time derivative of temperature (= der(T))";
            Modelica.SIunits.HeatCapacity C
                                           "Heat capacity of element (= cp*m)";
            parameter Modelica.SIunits.TemperatureSlope der_T_start(fixed=false)
                                                                                "Start value ofime derivative of temperature (= der(T))";
          end heatCapacitor_rec;
        public
          heatCapacitor_rec heatCapacitor;
        protected
          record port_int_rec
            Modelica.SIunits.Temperature T
                                          "Port temperature";
            constant Modelica.SIunits.HeatFlowRate Q_flow = 0.0
                                                               "Heat flow rate (positive if flowing from outside into the component)";
          end port_int_rec;
        public
          port_int_rec port_int;
        end 'thermalNode[1, 9, 1]_rec';
      public
        'thermalNode[1, 9, 1]_rec' 'thermalNode[1, 9, 1]' annotation(Dialog);
      protected
        record 'thermalNode[1, 10, 1]_rec'
          parameter Real nParallel(min = 1.0) = 1
                                                 "Number of identical parallel elements";
          constant Boolean use_portDim1 = true
                                              "Heat tranfer in 1st dimention";
          constant Boolean use_portDim2 = true
                                              "Heat tranfer in 2nd dimention";
          constant Boolean use_portDim3 = false
                                               "Heat tranfer in 3rd dimention";
        protected
          record port_a_1_rec
            Modelica.SIunits.Temperature T
                                          "Port temperature";
            Modelica.SIunits.HeatFlowRate Q_flow
                                                "Heat flow rate (positive if flowing from outside into the component)";
          end port_a_1_rec;
        public
          port_a_1_rec port_a_1;
        protected
          record port_b_1_rec
            Modelica.SIunits.Temperature T
                                          "Port temperature";
            Modelica.SIunits.HeatFlowRate Q_flow
                                                "Heat flow rate (positive if flowing from outside into the component)";
          end port_b_1_rec;
        public
          port_b_1_rec port_b_1;
        protected
          record port_a_2_rec
            Modelica.SIunits.Temperature T
                                          "Port temperature";
            Modelica.SIunits.HeatFlowRate Q_flow
                                                "Heat flow rate (positive if flowing from outside into the component)";
          end port_a_2_rec;
        public
          port_a_2_rec port_a_2;
        protected
          record port_b_2_rec
            Modelica.SIunits.Temperature T
                                          "Port temperature";
            constant Modelica.SIunits.HeatFlowRate Q_flow = 0.0
                                                               "Heat flow rate (positive if flowing from outside into the component)";
          end port_b_2_rec;
        public
          port_b_2_rec port_b_2;
          parameter Modelica.SIunits.Volume V(fixed=false)
                                                          "Volume of material";
        protected
          record thermalConductor_a_1_rec
            Modelica.SIunits.HeatFlowRate Q_flow
                                                "Heat flow rate from port_a -> port_b";
            Modelica.SIunits.TemperatureDifference dT
                                                     "port_a.T - port_b.T";
          protected
            record port_a_rec
              Modelica.SIunits.Temperature T
                                            "Port temperature";
              Modelica.SIunits.HeatFlowRate Q_flow
                                                  "Heat flow rate (positive if flowing from outside into the component)";
            end port_a_rec;
          public
            port_a_rec port_a;
          protected
            record port_b_rec
              Modelica.SIunits.Temperature T
                                            "Port temperature";
              Modelica.SIunits.HeatFlowRate Q_flow
                                                  "Heat flow rate (positive if flowing from outside into the component)";
            end port_b_rec;
          public
            port_b_rec port_b;
            Modelica.SIunits.Temperature T
                                          "Average temperature of element";
            parameter Modelica.SIunits.Temperature T_start(fixed=false)
                                                                       "Start temperature for the average temperature of element";
            Modelica.SIunits.ThermalConductance G
                                                 "Thermal conductance of material";
            Modelica.SIunits.ThermalConductivity k
                                                  "Thermal conductivity";
            parameter Modelica.SIunits.Length r_internal(fixed=false)
                                                                     "Inner radius of cylinder";
            parameter Modelica.SIunits.Length r_external(fixed=false)
                                                                     "Outer radius of cylinder";
            parameter Modelica.SIunits.Length L(fixed=false)
                                                            "Length of cylinder";
            parameter Modelica.SIunits.Angle alpha(fixed=false)
                                                               "Swept angle";
          end thermalConductor_a_1_rec;
        public
          thermalConductor_a_1_rec thermalConductor_a_1;
        protected
          record thermalConductor_b_1_rec
            Modelica.SIunits.HeatFlowRate Q_flow
                                                "Heat flow rate from port_a -> port_b";
            Modelica.SIunits.TemperatureDifference dT
                                                     "port_a.T - port_b.T";
          protected
            record port_a_rec
              Modelica.SIunits.Temperature T
                                            "Port temperature";
              Modelica.SIunits.HeatFlowRate Q_flow
                                                  "Heat flow rate (positive if flowing from outside into the component)";
            end port_a_rec;
          public
            port_a_rec port_a;
          protected
            record port_b_rec
              Modelica.SIunits.Temperature T
                                            "Port temperature";
              Modelica.SIunits.HeatFlowRate Q_flow
                                                  "Heat flow rate (positive if flowing from outside into the component)";
            end port_b_rec;
          public
            port_b_rec port_b;
            Modelica.SIunits.Temperature T
                                          "Average temperature of element";
            parameter Modelica.SIunits.Temperature T_start(fixed=false)
                                                                       "Start temperature for the average temperature of element";
            Modelica.SIunits.ThermalConductance G
                                                 "Thermal conductance of material";
            Modelica.SIunits.ThermalConductivity k
                                                  "Thermal conductivity";
            parameter Modelica.SIunits.Length r_internal(fixed=false)
                                                                     "Inner radius of cylinder";
            parameter Modelica.SIunits.Length r_external(fixed=false)
                                                                     "Outer radius of cylinder";
            parameter Modelica.SIunits.Length L(fixed=false)
                                                            "Length of cylinder";
            parameter Modelica.SIunits.Angle alpha(fixed=false)
                                                               "Swept angle";
          end thermalConductor_b_1_rec;
        public
          thermalConductor_b_1_rec thermalConductor_b_1;
        protected
          record thermalConductor_a_2_rec
            Modelica.SIunits.HeatFlowRate Q_flow
                                                "Heat flow rate from port_a -> port_b";
            Modelica.SIunits.TemperatureDifference dT
                                                     "port_a.T - port_b.T";
          protected
            record port_a_rec
              Modelica.SIunits.Temperature T
                                            "Port temperature";
              Modelica.SIunits.HeatFlowRate Q_flow
                                                  "Heat flow rate (positive if flowing from outside into the component)";
            end port_a_rec;
          public
            port_a_rec port_a;
          protected
            record port_b_rec
              Modelica.SIunits.Temperature T
                                            "Port temperature";
              Modelica.SIunits.HeatFlowRate Q_flow
                                                  "Heat flow rate (positive if flowing from outside into the component)";
            end port_b_rec;
          public
            port_b_rec port_b;
            Modelica.SIunits.Temperature T
                                          "Average temperature of element";
            parameter Modelica.SIunits.Temperature T_start(fixed=false)
                                                                       "Start temperature for the average temperature of element";
            Modelica.SIunits.ThermalConductance G
                                                 "Thermal conductance of material";
            Modelica.SIunits.ThermalConductivity k
                                                  "Thermal conductivity";
            parameter Modelica.SIunits.Length L(fixed=false)
                                                            "length of conduction";
            parameter Modelica.SIunits.Area A(fixed=false)
                                                          "Heat transfer area";
          end thermalConductor_a_2_rec;
        public
          thermalConductor_a_2_rec thermalConductor_a_2;
        protected
          record thermalConductor_b_2_rec
            constant Modelica.SIunits.HeatFlowRate Q_flow = 0.0
                                                               "Heat flow rate from port_a -> port_b";
            Modelica.SIunits.TemperatureDifference dT
                                                     "port_a.T - port_b.T";
          protected
            record port_a_rec
              Modelica.SIunits.Temperature T
                                            "Port temperature";
              constant Modelica.SIunits.HeatFlowRate Q_flow = 0.0
                                                                 "Heat flow rate (positive if flowing from outside into the component)";
            end port_a_rec;
          public
            port_a_rec port_a;
          protected
            record port_b_rec
              Modelica.SIunits.Temperature T
                                            "Port temperature";
              constant Modelica.SIunits.HeatFlowRate Q_flow = 0.0
                                                                 "Heat flow rate (positive if flowing from outside into the component)";
            end port_b_rec;
          public
            port_b_rec port_b;
            Modelica.SIunits.Temperature T
                                          "Average temperature of element";
            parameter Modelica.SIunits.Temperature T_start(fixed=false)
                                                                       "Start temperature for the average temperature of element";
            Modelica.SIunits.ThermalConductance G
                                                 "Thermal conductance of material";
            Modelica.SIunits.ThermalConductivity k
                                                  "Thermal conductivity";
            parameter Modelica.SIunits.Length L(fixed=false)
                                                            "length of conduction";
            parameter Modelica.SIunits.Area A(fixed=false)
                                                          "Heat transfer area";
          end thermalConductor_b_2_rec;
        public
          thermalConductor_b_2_rec thermalConductor_b_2;
        protected
          record thermalConductor_a_3_rec
            constant Modelica.SIunits.HeatFlowRate Q_flow = 0.0
                                                               "Heat flow rate from port_a -> port_b";
            Modelica.SIunits.TemperatureDifference dT
                                                     "port_a.T - port_b.T";
          protected
            record port_a_rec
              Modelica.SIunits.Temperature T
                                            "Port temperature";
              constant Modelica.SIunits.HeatFlowRate Q_flow = 0.0
                                                                 "Heat flow rate (positive if flowing from outside into the component)";
            end port_a_rec;
          public
            port_a_rec port_a;
          protected
            record port_b_rec
              Modelica.SIunits.Temperature T
                                            "Port temperature";
              constant Modelica.SIunits.HeatFlowRate Q_flow = 0.0
                                                                 "Heat flow rate (positive if flowing from outside into the component)";
            end port_b_rec;
          public
            port_b_rec port_b;
            Modelica.SIunits.Temperature T
                                          "Average temperature of element";
            parameter Modelica.SIunits.Temperature T_start(fixed=false)
                                                                       "Start temperature for the average temperature of element";
            Modelica.SIunits.ThermalConductance G
                                                 "Thermal conductance of material";
            Modelica.SIunits.ThermalConductivity k
                                                  "Thermal conductivity";
            parameter Modelica.SIunits.Length L(fixed=false)
                                                            "length of conduction";
            parameter Modelica.SIunits.Area A(fixed=false)
                                                          "Heat transfer area";
          end thermalConductor_a_3_rec;
        public
          thermalConductor_a_3_rec thermalConductor_a_3;
        protected
          record thermalConductor_b_3_rec
            constant Modelica.SIunits.HeatFlowRate Q_flow = 0.0
                                                               "Heat flow rate from port_a -> port_b";
            Modelica.SIunits.TemperatureDifference dT
                                                     "port_a.T - port_b.T";
          protected
            record port_a_rec
              Modelica.SIunits.Temperature T
                                            "Port temperature";
              constant Modelica.SIunits.HeatFlowRate Q_flow = 0.0
                                                                 "Heat flow rate (positive if flowing from outside into the component)";
            end port_a_rec;
          public
            port_a_rec port_a;
          protected
            record port_b_rec
              Modelica.SIunits.Temperature T
                                            "Port temperature";
              constant Modelica.SIunits.HeatFlowRate Q_flow = 0.0
                                                                 "Heat flow rate (positive if flowing from outside into the component)";
            end port_b_rec;
          public
            port_b_rec port_b;
            Modelica.SIunits.Temperature T
                                          "Average temperature of element";
            parameter Modelica.SIunits.Temperature T_start(fixed=false)
                                                                       "Start temperature for the average temperature of element";
            Modelica.SIunits.ThermalConductance G
                                                 "Thermal conductance of material";
            Modelica.SIunits.ThermalConductivity k
                                                  "Thermal conductivity";
            parameter Modelica.SIunits.Length L(fixed=false)
                                                            "length of conduction";
            parameter Modelica.SIunits.Area A(fixed=false)
                                                          "Heat transfer area";
          end thermalConductor_b_3_rec;
        public
          thermalConductor_b_3_rec thermalConductor_b_3;
        protected
          record heatCapacitor_rec
            Modelica.SIunits.Temperature T
                                          "Temperature of element";
            Real T_der(unit = "K/s")
                                    "der(Temperature of element)";
            Modelica.SIunits.HeatFlowRate Q_flow;
            parameter Modelica.SIunits.Temperature T_start(fixed=false)
                                                                       "Start temperature for the average temperature of ellement";
          protected
            record port_rec
              Modelica.SIunits.Temperature T
                                            "Port temperature";
              Modelica.SIunits.HeatFlowRate Q_flow
                                                  "Heat flow rate (positive if flowing from outside into the component)";
            end port_rec;
          public
            port_rec port;
            parameter Modelica.SIunits.Volume V(fixed=false)
                                                            "Volume of element";
            parameter Modelica.SIunits.Mass m(fixed=false)
                                                          "Mass of element";
            Modelica.SIunits.TemperatureSlope der_T
                                                   "Time derivative of temperature (= der(T))";
            Modelica.SIunits.HeatCapacity C
                                           "Heat capacity of element (= cp*m)";
            parameter Modelica.SIunits.TemperatureSlope der_T_start(fixed=false)
                                                                                "Start value ofime derivative of temperature (= der(T))";
          end heatCapacitor_rec;
        public
          heatCapacitor_rec heatCapacitor;
        protected
          record port_int_rec
            Modelica.SIunits.Temperature T
                                          "Port temperature";
            constant Modelica.SIunits.HeatFlowRate Q_flow = 0.0
                                                               "Heat flow rate (positive if flowing from outside into the component)";
          end port_int_rec;
        public
          port_int_rec port_int;
        end 'thermalNode[1, 10, 1]_rec';
      public
        'thermalNode[1, 10, 1]_rec' 'thermalNode[1, 10, 1]' annotation(Dialog);
      protected
        record 'port_int[1, 1, 1]_rec'
          Modelica.SIunits.Temperature T
                                        "Port temperature";
          constant Modelica.SIunits.HeatFlowRate Q_flow = 0.0
                                                             "Heat flow rate (positive if flowing from outside into the component)";
        end 'port_int[1, 1, 1]_rec';
      public
        'port_int[1, 1, 1]_rec' 'port_int[1, 1, 1]';
      protected
        record 'port_int[1, 2, 1]_rec'
          Modelica.SIunits.Temperature T
                                        "Port temperature";
          constant Modelica.SIunits.HeatFlowRate Q_flow = 0.0
                                                             "Heat flow rate (positive if flowing from outside into the component)";
        end 'port_int[1, 2, 1]_rec';
      public
        'port_int[1, 2, 1]_rec' 'port_int[1, 2, 1]';
      protected
        record 'port_int[1, 3, 1]_rec'
          Modelica.SIunits.Temperature T
                                        "Port temperature";
          constant Modelica.SIunits.HeatFlowRate Q_flow = 0.0
                                                             "Heat flow rate (positive if flowing from outside into the component)";
        end 'port_int[1, 3, 1]_rec';
      public
        'port_int[1, 3, 1]_rec' 'port_int[1, 3, 1]';
      protected
        record 'port_int[1, 4, 1]_rec'
          Modelica.SIunits.Temperature T
                                        "Port temperature";
          constant Modelica.SIunits.HeatFlowRate Q_flow = 0.0
                                                             "Heat flow rate (positive if flowing from outside into the component)";
        end 'port_int[1, 4, 1]_rec';
      public
        'port_int[1, 4, 1]_rec' 'port_int[1, 4, 1]';
      protected
        record 'port_int[1, 5, 1]_rec'
          Modelica.SIunits.Temperature T
                                        "Port temperature";
          constant Modelica.SIunits.HeatFlowRate Q_flow = 0.0
                                                             "Heat flow rate (positive if flowing from outside into the component)";
        end 'port_int[1, 5, 1]_rec';
      public
        'port_int[1, 5, 1]_rec' 'port_int[1, 5, 1]';
      protected
        record 'port_int[1, 6, 1]_rec'
          Modelica.SIunits.Temperature T
                                        "Port temperature";
          constant Modelica.SIunits.HeatFlowRate Q_flow = 0.0
                                                             "Heat flow rate (positive if flowing from outside into the component)";
        end 'port_int[1, 6, 1]_rec';
      public
        'port_int[1, 6, 1]_rec' 'port_int[1, 6, 1]';
      protected
        record 'port_int[1, 7, 1]_rec'
          Modelica.SIunits.Temperature T
                                        "Port temperature";
          constant Modelica.SIunits.HeatFlowRate Q_flow = 0.0
                                                             "Heat flow rate (positive if flowing from outside into the component)";
        end 'port_int[1, 7, 1]_rec';
      public
        'port_int[1, 7, 1]_rec' 'port_int[1, 7, 1]';
      protected
        record 'port_int[1, 8, 1]_rec'
          Modelica.SIunits.Temperature T
                                        "Port temperature";
          constant Modelica.SIunits.HeatFlowRate Q_flow = 0.0
                                                             "Heat flow rate (positive if flowing from outside into the component)";
        end 'port_int[1, 8, 1]_rec';
      public
        'port_int[1, 8, 1]_rec' 'port_int[1, 8, 1]';
      protected
        record 'port_int[1, 9, 1]_rec'
          Modelica.SIunits.Temperature T
                                        "Port temperature";
          constant Modelica.SIunits.HeatFlowRate Q_flow = 0.0
                                                             "Heat flow rate (positive if flowing from outside into the component)";
        end 'port_int[1, 9, 1]_rec';
      public
        'port_int[1, 9, 1]_rec' 'port_int[1, 9, 1]';
      protected
        record 'port_int[1, 10, 1]_rec'
          Modelica.SIunits.Temperature T
                                        "Port temperature";
          constant Modelica.SIunits.HeatFlowRate Q_flow = 0.0
                                                             "Heat flow rate (positive if flowing from outside into the component)";
        end 'port_int[1, 10, 1]_rec';
      public
        'port_int[1, 10, 1]_rec' 'port_int[1, 10, 1]';
      end 'coilWall[2]_rec';
    public
      'coilWall[2]_rec' 'coilWall[2]' annotation(Dialog);
    protected
      record 'pipe[1]_rec'
        constant Boolean allowFlowReversal = false
                                                  "= true to allow flow reversal, false restricts to design direction (port_a -> port_b)";
      protected
        record port_a_rec
          Modelica.Media.Interfaces.PartialMedium.MassFlowRate m_flow(quantity = "MassFlowRate.SimpleLiquidWater", min = 0.0)
                                                                                                                             "Mass flow rate from the connection point into the component";
          Modelica.Media.Interfaces.Types.AbsolutePressure p
                                                            "Thermodynamic pressure in the connection point";
          Modelica.Media.Interfaces.Types.SpecificEnthalpy h_outflow
                                                                    "Specific thermodynamic enthalpy close to the connection point if m_flow < 0";
        end port_a_rec;
      public
        port_a_rec port_a;
      protected
        record port_b_rec
          Modelica.Media.Interfaces.Types.AbsolutePressure p
                                                            "Thermodynamic pressure in the connection point";
          Modelica.Media.Interfaces.Types.SpecificEnthalpy h_outflow
                                                                    "Specific thermodynamic enthalpy close to the connection point if m_flow < 0";
        end port_b_rec;
      public
        port_b_rec port_b;
        parameter Real nParallel(min = 1.0, fixed=false)
                                                        "Number of identical parallel pipes";
        constant Modelica.SIunits.Length length = 5.0
                                                     "Length";
        constant Boolean isCircular = true
                                          "= true if cross sectional area is circular";
        parameter Modelica.SIunits.Diameter diameter(fixed=false)
                                                                 "Diameter of circular pipe";
        parameter Modelica.SIunits.Area crossArea(fixed=false)
                                                              "Inner cross section area";
        parameter Modelica.SIunits.Length perimeter(fixed=false)
                                                                "Inner perimeter";
        parameter Modelica.SIunits.Height roughness(fixed=false)
                                                                "Average height of surface asperities (default: smooth steel pipe)";
        parameter Modelica.SIunits.Volume V(fixed=false)
                                                        "volume size";
        constant Modelica.SIunits.Length height_ab = 0
                                                      "Height(port_b) - Height(port_a)";
        constant Integer n = 10
                               "Number of discrete volumes";
        parameter Modelica.SIunits.Volume 'fluidVolumes[1]'(fixed=false)
                                                                        "Discretized volume, determine in inheriting class";
        parameter Modelica.SIunits.Volume 'fluidVolumes[2]'(fixed=false)
                                                                        "Discretized volume, determine in inheriting class";
        parameter Modelica.SIunits.Volume 'fluidVolumes[3]'(fixed=false)
                                                                        "Discretized volume, determine in inheriting class";
        parameter Modelica.SIunits.Volume 'fluidVolumes[4]'(fixed=false)
                                                                        "Discretized volume, determine in inheriting class";
        parameter Modelica.SIunits.Volume 'fluidVolumes[5]'(fixed=false)
                                                                        "Discretized volume, determine in inheriting class";
        parameter Modelica.SIunits.Volume 'fluidVolumes[6]'(fixed=false)
                                                                        "Discretized volume, determine in inheriting class";
        parameter Modelica.SIunits.Volume 'fluidVolumes[7]'(fixed=false)
                                                                        "Discretized volume, determine in inheriting class";
        parameter Modelica.SIunits.Volume 'fluidVolumes[8]'(fixed=false)
                                                                        "Discretized volume, determine in inheriting class";
        parameter Modelica.SIunits.Volume 'fluidVolumes[9]'(fixed=false)
                                                                        "Discretized volume, determine in inheriting class";
        parameter Modelica.SIunits.Volume 'fluidVolumes[10]'(fixed=false)
                                                                         "Discretized volume, determine in inheriting class";
        constant Modelica.Fluid.Types.Dynamics energyDynamics = Modelica.Fluid.Types.Dynamics.DynamicFreeInitial
                                                                                                                "Formulation of energy balances";
        constant Modelica.Fluid.Types.Dynamics massDynamics = Modelica.Fluid.Types.Dynamics.DynamicFreeInitial
                                                                                                              "Formulation of mass balances";
        constant Modelica.Fluid.Types.Dynamics substanceDynamics = Modelica.Fluid.Types.Dynamics.DynamicFreeInitial
                                                                                                                   "Formulation of substance balances";
        constant Modelica.Fluid.Types.Dynamics traceDynamics = Modelica.Fluid.Types.Dynamics.DynamicFreeInitial
                                                                                                               "Formulation of trace substance balances";
        parameter Modelica.Media.Interfaces.Types.AbsolutePressure p_a_start(fixed=false)
                                                                                         "Start value of pressure at port a";
        parameter Modelica.Media.Interfaces.Types.AbsolutePressure p_b_start(fixed=false)
                                                                                         "Start value of pressure at port b";
        parameter Modelica.Media.Interfaces.Types.AbsolutePressure 'ps_start[1]'(fixed=false)
                                                                                             "Start value of pressure";
        parameter Modelica.Media.Interfaces.Types.AbsolutePressure 'ps_start[2]'(fixed=false)
                                                                                             "Start value of pressure";
        parameter Modelica.Media.Interfaces.Types.AbsolutePressure 'ps_start[3]'(fixed=false)
                                                                                             "Start value of pressure";
        parameter Modelica.Media.Interfaces.Types.AbsolutePressure 'ps_start[4]'(fixed=false)
                                                                                             "Start value of pressure";
        parameter Modelica.Media.Interfaces.Types.AbsolutePressure 'ps_start[5]'(fixed=false)
                                                                                             "Start value of pressure";
        parameter Modelica.Media.Interfaces.Types.AbsolutePressure 'ps_start[6]'(fixed=false)
                                                                                             "Start value of pressure";
        parameter Modelica.Media.Interfaces.Types.AbsolutePressure 'ps_start[7]'(fixed=false)
                                                                                             "Start value of pressure";
        parameter Modelica.Media.Interfaces.Types.AbsolutePressure 'ps_start[8]'(fixed=false)
                                                                                             "Start value of pressure";
        parameter Modelica.Media.Interfaces.Types.AbsolutePressure 'ps_start[9]'(fixed=false)
                                                                                             "Start value of pressure";
        parameter Modelica.Media.Interfaces.Types.AbsolutePressure 'ps_start[10]'(fixed=false)
                                                                                              "Start value of pressure";
        constant Boolean use_T_start = true
                                           "Use T_start if true, otherwise h_start";
        constant Modelica.Media.Interfaces.Types.Temperature T_start = 293.15
                                                                             "Start value of temperature";
        constant Modelica.Media.Interfaces.Types.SpecificEnthalpy h_start = 83680.0
                                                                                   "Start value of specific enthalpy";
        parameter Modelica.Media.Interfaces.Types.MassFraction 'X_start[1]' = 1.0
                                                                                 "Start value of mass fractions m_i/m";
        Modelica.SIunits.Energy 'Us[1]'
                                       "Internal energy of fluid";
        Real 'Us[1]_der'(unit = "W")
                                    "der(Internal energy of fluid)";
        Modelica.SIunits.Energy 'Us[2]'
                                       "Internal energy of fluid";
        Real 'Us[2]_der'(unit = "W")
                                    "der(Internal energy of fluid)";
        Modelica.SIunits.Energy 'Us[3]'
                                       "Internal energy of fluid";
        Real 'Us[3]_der'(unit = "W")
                                    "der(Internal energy of fluid)";
        Modelica.SIunits.Energy 'Us[4]'
                                       "Internal energy of fluid";
        Real 'Us[4]_der'(unit = "W")
                                    "der(Internal energy of fluid)";
        Modelica.SIunits.Energy 'Us[5]'
                                       "Internal energy of fluid";
        Real 'Us[5]_der'(unit = "W")
                                    "der(Internal energy of fluid)";
        Modelica.SIunits.Energy 'Us[6]'
                                       "Internal energy of fluid";
        Real 'Us[6]_der'(unit = "W")
                                    "der(Internal energy of fluid)";
        Modelica.SIunits.Energy 'Us[7]'
                                       "Internal energy of fluid";
        Real 'Us[7]_der'(unit = "W")
                                    "der(Internal energy of fluid)";
        Modelica.SIunits.Energy 'Us[8]'
                                       "Internal energy of fluid";
        Real 'Us[8]_der'(unit = "W")
                                    "der(Internal energy of fluid)";
        Modelica.SIunits.Energy 'Us[9]'
                                       "Internal energy of fluid";
        Real 'Us[9]_der'(unit = "W")
                                    "der(Internal energy of fluid)";
        Modelica.SIunits.Energy 'Us[10]'
                                        "Internal energy of fluid";
        Real 'Us[10]_der'(unit = "W")
                                     "der(Internal energy of fluid)";
        parameter Modelica.SIunits.Mass 'ms[1]'(fixed=false)
                                                            "Fluid mass";
        constant Real 'ms[1]_der'(unit = "kg/s") = 0.0
                                                      "der(Fluid mass)";
        parameter Modelica.SIunits.Mass 'ms[2]'(fixed=false)
                                                            "Fluid mass";
        constant Real 'ms[2]_der'(unit = "kg/s") = 0.0
                                                      "der(Fluid mass)";
        parameter Modelica.SIunits.Mass 'ms[3]'(fixed=false)
                                                            "Fluid mass";
        constant Real 'ms[3]_der'(unit = "kg/s") = 0.0
                                                      "der(Fluid mass)";
        parameter Modelica.SIunits.Mass 'ms[4]'(fixed=false)
                                                            "Fluid mass";
        constant Real 'ms[4]_der'(unit = "kg/s") = 0.0
                                                      "der(Fluid mass)";
        parameter Modelica.SIunits.Mass 'ms[5]'(fixed=false)
                                                            "Fluid mass";
        constant Real 'ms[5]_der'(unit = "kg/s") = 0.0
                                                      "der(Fluid mass)";
        parameter Modelica.SIunits.Mass 'ms[6]'(fixed=false)
                                                            "Fluid mass";
        constant Real 'ms[6]_der'(unit = "kg/s") = 0.0
                                                      "der(Fluid mass)";
        parameter Modelica.SIunits.Mass 'ms[7]'(fixed=false)
                                                            "Fluid mass";
        constant Real 'ms[7]_der'(unit = "kg/s") = 0.0
                                                      "der(Fluid mass)";
        parameter Modelica.SIunits.Mass 'ms[8]'(fixed=false)
                                                            "Fluid mass";
        constant Real 'ms[8]_der'(unit = "kg/s") = 0.0
                                                      "der(Fluid mass)";
        parameter Modelica.SIunits.Mass 'ms[9]'(fixed=false)
                                                            "Fluid mass";
        constant Real 'ms[9]_der'(unit = "kg/s") = 0.0
                                                      "der(Fluid mass)";
        parameter Modelica.SIunits.Mass 'ms[10]'(fixed=false)
                                                             "Fluid mass";
        constant Real 'ms[10]_der'(unit = "kg/s") = 0.0
                                                       "der(Fluid mass)";
        constant Modelica.Media.Interfaces.PartialMedium.MassFlowRate 'mb_flows[1]'(quantity = "MassFlowRate.SimpleLiquidWater") = 0.0
                                                                                                                                      "Mass flow rate, source or sink";
        constant Modelica.Media.Interfaces.PartialMedium.MassFlowRate 'mb_flows[2]'(quantity = "MassFlowRate.SimpleLiquidWater") = 0.0
                                                                                                                                      "Mass flow rate, source or sink";
        constant Modelica.Media.Interfaces.PartialMedium.MassFlowRate 'mb_flows[3]'(quantity = "MassFlowRate.SimpleLiquidWater") = 0.0
                                                                                                                                      "Mass flow rate, source or sink";
        constant Modelica.Media.Interfaces.PartialMedium.MassFlowRate 'mb_flows[4]'(quantity = "MassFlowRate.SimpleLiquidWater") = 0.0
                                                                                                                                      "Mass flow rate, source or sink";
        constant Modelica.Media.Interfaces.PartialMedium.MassFlowRate 'mb_flows[5]'(quantity = "MassFlowRate.SimpleLiquidWater") = 0.0
                                                                                                                                      "Mass flow rate, source or sink";
        constant Modelica.Media.Interfaces.PartialMedium.MassFlowRate 'mb_flows[6]'(quantity = "MassFlowRate.SimpleLiquidWater") = 0.0
                                                                                                                                      "Mass flow rate, source or sink";
        constant Modelica.Media.Interfaces.PartialMedium.MassFlowRate 'mb_flows[7]'(quantity = "MassFlowRate.SimpleLiquidWater") = 0.0
                                                                                                                                      "Mass flow rate, source or sink";
        constant Modelica.Media.Interfaces.PartialMedium.MassFlowRate 'mb_flows[8]'(quantity = "MassFlowRate.SimpleLiquidWater") = 0.0
                                                                                                                                      "Mass flow rate, source or sink";
        constant Modelica.Media.Interfaces.PartialMedium.MassFlowRate 'mb_flows[9]'(quantity = "MassFlowRate.SimpleLiquidWater") = 0.0
                                                                                                                                      "Mass flow rate, source or sink";
        constant Modelica.Media.Interfaces.PartialMedium.MassFlowRate 'mb_flows[10]'(quantity = "MassFlowRate.SimpleLiquidWater") = 0.0
                                                                                                                                       "Mass flow rate, source or sink";
        Modelica.SIunits.EnthalpyFlowRate 'Hb_flows[1]'
                                                       "Enthalpy flow rate, source or sink";
        Modelica.SIunits.EnthalpyFlowRate 'Hb_flows[2]'
                                                       "Enthalpy flow rate, source or sink";
        Modelica.SIunits.EnthalpyFlowRate 'Hb_flows[3]'
                                                       "Enthalpy flow rate, source or sink";
        Modelica.SIunits.EnthalpyFlowRate 'Hb_flows[4]'
                                                       "Enthalpy flow rate, source or sink";
        Modelica.SIunits.EnthalpyFlowRate 'Hb_flows[5]'
                                                       "Enthalpy flow rate, source or sink";
        Modelica.SIunits.EnthalpyFlowRate 'Hb_flows[6]'
                                                       "Enthalpy flow rate, source or sink";
        Modelica.SIunits.EnthalpyFlowRate 'Hb_flows[7]'
                                                       "Enthalpy flow rate, source or sink";
        Modelica.SIunits.EnthalpyFlowRate 'Hb_flows[8]'
                                                       "Enthalpy flow rate, source or sink";
        Modelica.SIunits.EnthalpyFlowRate 'Hb_flows[9]'
                                                       "Enthalpy flow rate, source or sink";
        Modelica.SIunits.EnthalpyFlowRate 'Hb_flows[10]'
                                                        "Enthalpy flow rate, source or sink";
        Modelica.SIunits.HeatFlowRate 'Qb_flows[1]'
                                                   "Heat flow rate, source or sink";
        Modelica.SIunits.HeatFlowRate 'Qb_flows[2]'
                                                   "Heat flow rate, source or sink";
        Modelica.SIunits.HeatFlowRate 'Qb_flows[3]'
                                                   "Heat flow rate, source or sink";
        Modelica.SIunits.HeatFlowRate 'Qb_flows[4]'
                                                   "Heat flow rate, source or sink";
        Modelica.SIunits.HeatFlowRate 'Qb_flows[5]'
                                                   "Heat flow rate, source or sink";
        Modelica.SIunits.HeatFlowRate 'Qb_flows[6]'
                                                   "Heat flow rate, source or sink";
        Modelica.SIunits.HeatFlowRate 'Qb_flows[7]'
                                                   "Heat flow rate, source or sink";
        Modelica.SIunits.HeatFlowRate 'Qb_flows[8]'
                                                   "Heat flow rate, source or sink";
        Modelica.SIunits.HeatFlowRate 'Qb_flows[9]'
                                                   "Heat flow rate, source or sink";
        Modelica.SIunits.HeatFlowRate 'Qb_flows[10]'
                                                    "Heat flow rate, source or sink";
        Modelica.SIunits.Power 'Wb_flows[1]'
                                            "Mechanical power, p*der(V) etc.";
        Modelica.SIunits.Power 'Wb_flows[2]'
                                            "Mechanical power, p*der(V) etc.";
        Modelica.SIunits.Power 'Wb_flows[3]'
                                            "Mechanical power, p*der(V) etc.";
        Modelica.SIunits.Power 'Wb_flows[4]'
                                            "Mechanical power, p*der(V) etc.";
        Modelica.SIunits.Power 'Wb_flows[5]'
                                            "Mechanical power, p*der(V) etc.";
        Modelica.SIunits.Power 'Wb_flows[6]'
                                            "Mechanical power, p*der(V) etc.";
        Modelica.SIunits.Power 'Wb_flows[7]'
                                            "Mechanical power, p*der(V) etc.";
        Modelica.SIunits.Power 'Wb_flows[8]'
                                            "Mechanical power, p*der(V) etc.";
        Modelica.SIunits.Power 'Wb_flows[9]'
                                            "Mechanical power, p*der(V) etc.";
        Modelica.SIunits.Power 'Wb_flows[10]'
                                             "Mechanical power, p*der(V) etc.";
        constant Modelica.SIunits.Length 'lengths[1]' = 0.5
                                                           "lengths of flow segments";
        constant Modelica.SIunits.Length 'lengths[2]' = 0.5
                                                           "lengths of flow segments";
        constant Modelica.SIunits.Length 'lengths[3]' = 0.5
                                                           "lengths of flow segments";
        constant Modelica.SIunits.Length 'lengths[4]' = 0.5
                                                           "lengths of flow segments";
        constant Modelica.SIunits.Length 'lengths[5]' = 0.5
                                                           "lengths of flow segments";
        constant Modelica.SIunits.Length 'lengths[6]' = 0.5
                                                           "lengths of flow segments";
        constant Modelica.SIunits.Length 'lengths[7]' = 0.5
                                                           "lengths of flow segments";
        constant Modelica.SIunits.Length 'lengths[8]' = 0.5
                                                           "lengths of flow segments";
        constant Modelica.SIunits.Length 'lengths[9]' = 0.5
                                                           "lengths of flow segments";
        constant Modelica.SIunits.Length 'lengths[10]' = 0.5
                                                            "lengths of flow segments";
        parameter Modelica.SIunits.Area 'crossAreas[1]'(fixed=false)
                                                                    "cross flow areas of flow segments";
        parameter Modelica.SIunits.Area 'crossAreas[2]'(fixed=false)
                                                                    "cross flow areas of flow segments";
        parameter Modelica.SIunits.Area 'crossAreas[3]'(fixed=false)
                                                                    "cross flow areas of flow segments";
        parameter Modelica.SIunits.Area 'crossAreas[4]'(fixed=false)
                                                                    "cross flow areas of flow segments";
        parameter Modelica.SIunits.Area 'crossAreas[5]'(fixed=false)
                                                                    "cross flow areas of flow segments";
        parameter Modelica.SIunits.Area 'crossAreas[6]'(fixed=false)
                                                                    "cross flow areas of flow segments";
        parameter Modelica.SIunits.Area 'crossAreas[7]'(fixed=false)
                                                                    "cross flow areas of flow segments";
        parameter Modelica.SIunits.Area 'crossAreas[8]'(fixed=false)
                                                                    "cross flow areas of flow segments";
        parameter Modelica.SIunits.Area 'crossAreas[9]'(fixed=false)
                                                                    "cross flow areas of flow segments";
        parameter Modelica.SIunits.Area 'crossAreas[10]'(fixed=false)
                                                                     "cross flow areas of flow segments";
        parameter Modelica.SIunits.Length 'dimensions[1]'(fixed=false)
                                                                      "hydraulic diameters of flow segments";
        parameter Modelica.SIunits.Length 'dimensions[2]'(fixed=false)
                                                                      "hydraulic diameters of flow segments";
        parameter Modelica.SIunits.Length 'dimensions[3]'(fixed=false)
                                                                      "hydraulic diameters of flow segments";
        parameter Modelica.SIunits.Length 'dimensions[4]'(fixed=false)
                                                                      "hydraulic diameters of flow segments";
        parameter Modelica.SIunits.Length 'dimensions[5]'(fixed=false)
                                                                      "hydraulic diameters of flow segments";
        parameter Modelica.SIunits.Length 'dimensions[6]'(fixed=false)
                                                                      "hydraulic diameters of flow segments";
        parameter Modelica.SIunits.Length 'dimensions[7]'(fixed=false)
                                                                      "hydraulic diameters of flow segments";
        parameter Modelica.SIunits.Length 'dimensions[8]'(fixed=false)
                                                                      "hydraulic diameters of flow segments";
        parameter Modelica.SIunits.Length 'dimensions[9]'(fixed=false)
                                                                      "hydraulic diameters of flow segments";
        parameter Modelica.SIunits.Length 'dimensions[10]'(fixed=false)
                                                                       "hydraulic diameters of flow segments";
        parameter Modelica.SIunits.Height 'roughnesses[1]'(fixed=false)
                                                                       "Average heights of surface asperities";
        parameter Modelica.SIunits.Height 'roughnesses[2]'(fixed=false)
                                                                       "Average heights of surface asperities";
        parameter Modelica.SIunits.Height 'roughnesses[3]'(fixed=false)
                                                                       "Average heights of surface asperities";
        parameter Modelica.SIunits.Height 'roughnesses[4]'(fixed=false)
                                                                       "Average heights of surface asperities";
        parameter Modelica.SIunits.Height 'roughnesses[5]'(fixed=false)
                                                                       "Average heights of surface asperities";
        parameter Modelica.SIunits.Height 'roughnesses[6]'(fixed=false)
                                                                       "Average heights of surface asperities";
        parameter Modelica.SIunits.Height 'roughnesses[7]'(fixed=false)
                                                                       "Average heights of surface asperities";
        parameter Modelica.SIunits.Height 'roughnesses[8]'(fixed=false)
                                                                       "Average heights of surface asperities";
        parameter Modelica.SIunits.Height 'roughnesses[9]'(fixed=false)
                                                                       "Average heights of surface asperities";
        parameter Modelica.SIunits.Height 'roughnesses[10]'(fixed=false)
                                                                        "Average heights of surface asperities";
        constant Modelica.SIunits.Length 'dheights[1]' = 0.0
                                                            "Differences in heights of flow segments";
        constant Modelica.SIunits.Length 'dheights[2]' = 0.0
                                                            "Differences in heights of flow segments";
        constant Modelica.SIunits.Length 'dheights[3]' = 0.0
                                                            "Differences in heights of flow segments";
        constant Modelica.SIunits.Length 'dheights[4]' = 0.0
                                                            "Differences in heights of flow segments";
        constant Modelica.SIunits.Length 'dheights[5]' = 0.0
                                                            "Differences in heights of flow segments";
        constant Modelica.SIunits.Length 'dheights[6]' = 0.0
                                                            "Differences in heights of flow segments";
        constant Modelica.SIunits.Length 'dheights[7]' = 0.0
                                                            "Differences in heights of flow segments";
        constant Modelica.SIunits.Length 'dheights[8]' = 0.0
                                                            "Differences in heights of flow segments";
        constant Modelica.SIunits.Length 'dheights[9]' = 0.0
                                                            "Differences in heights of flow segments";
        constant Modelica.SIunits.Length 'dheights[10]' = 0.0
                                                             "Differences in heights of flow segments";
        constant Modelica.Fluid.Types.Dynamics momentumDynamics = Modelica.Fluid.Types.Dynamics.SteadyState
                                                                                                           "Formulation of momentum balances";
        constant Modelica.Media.Interfaces.PartialMedium.MassFlowRate m_flow_start(quantity = "MassFlowRate.SimpleLiquidWater") = 0.0
                                                                                                                                     "Start value for mass flow rate";
        constant Integer nNodes(min = 1) = 10
                                             "Number of discrete flow volumes";
        constant Modelica.Fluid.Types.ModelStructure modelStructure = Modelica.Fluid.Types.ModelStructure.av_vb
                                                                                                               "Determines whether flow or volume models are present at the ports";
        constant Boolean useLumpedPressure = false
                                                  "=true to lump pressure states together";
        constant Integer nFM = 9
                                "number of flow models in flowModel";
        constant Integer nFMDistributed = 9;
        constant Integer nFMLumped = 1;
        constant Integer iLumped = 6
                                    "Index of control volume with representative state if useLumpedPressure";
        constant Boolean useInnerPortProperties = false
                                                       "=true to take port properties for flow models from internal control volumes";
      protected
        record state_a_rec
          Modelica.Media.Interfaces.Types.AbsolutePressure p
                                                            "Absolute pressure of medium";
          Modelica.Media.Interfaces.Types.Temperature T
                                                       "Temperature of medium";
        end state_a_rec;
      public
        state_a_rec state_a;
      protected
        record state_b_rec
          Modelica.Media.Interfaces.Types.AbsolutePressure p
                                                            "Absolute pressure of medium";
          Modelica.Media.Interfaces.Types.Temperature T
                                                       "Temperature of medium";
        end state_b_rec;
      public
        state_b_rec state_b;
      protected
        record 'statesFM[1]_rec'
          Modelica.Media.Interfaces.Types.AbsolutePressure p
                                                            "Absolute pressure of medium";
          Modelica.Media.Interfaces.Types.Temperature T
                                                       "Temperature of medium";
        end 'statesFM[1]_rec';
      public
        'statesFM[1]_rec' 'statesFM[1]';
      protected
        record 'statesFM[2]_rec'
          Modelica.Media.Interfaces.Types.AbsolutePressure p
                                                            "Absolute pressure of medium";
          Modelica.Media.Interfaces.Types.Temperature T
                                                       "Temperature of medium";
        end 'statesFM[2]_rec';
      public
        'statesFM[2]_rec' 'statesFM[2]';
      protected
        record 'statesFM[3]_rec'
          Modelica.Media.Interfaces.Types.AbsolutePressure p
                                                            "Absolute pressure of medium";
          Modelica.Media.Interfaces.Types.Temperature T
                                                       "Temperature of medium";
        end 'statesFM[3]_rec';
      public
        'statesFM[3]_rec' 'statesFM[3]';
      protected
        record 'statesFM[4]_rec'
          Modelica.Media.Interfaces.Types.AbsolutePressure p
                                                            "Absolute pressure of medium";
          Modelica.Media.Interfaces.Types.Temperature T
                                                       "Temperature of medium";
        end 'statesFM[4]_rec';
      public
        'statesFM[4]_rec' 'statesFM[4]';
      protected
        record 'statesFM[5]_rec'
          Modelica.Media.Interfaces.Types.AbsolutePressure p
                                                            "Absolute pressure of medium";
          Modelica.Media.Interfaces.Types.Temperature T
                                                       "Temperature of medium";
        end 'statesFM[5]_rec';
      public
        'statesFM[5]_rec' 'statesFM[5]';
      protected
        record 'statesFM[6]_rec'
          Modelica.Media.Interfaces.Types.AbsolutePressure p
                                                            "Absolute pressure of medium";
          Modelica.Media.Interfaces.Types.Temperature T
                                                       "Temperature of medium";
        end 'statesFM[6]_rec';
      public
        'statesFM[6]_rec' 'statesFM[6]';
      protected
        record 'statesFM[7]_rec'
          Modelica.Media.Interfaces.Types.AbsolutePressure p
                                                            "Absolute pressure of medium";
          Modelica.Media.Interfaces.Types.Temperature T
                                                       "Temperature of medium";
        end 'statesFM[7]_rec';
      public
        'statesFM[7]_rec' 'statesFM[7]';
      protected
        record 'statesFM[8]_rec'
          Modelica.Media.Interfaces.Types.AbsolutePressure p
                                                            "Absolute pressure of medium";
          Modelica.Media.Interfaces.Types.Temperature T
                                                       "Temperature of medium";
        end 'statesFM[8]_rec';
      public
        'statesFM[8]_rec' 'statesFM[8]';
      protected
        record 'statesFM[9]_rec'
          Modelica.Media.Interfaces.Types.AbsolutePressure p
                                                            "Absolute pressure of medium";
          Modelica.Media.Interfaces.Types.Temperature T
                                                       "Temperature of medium";
        end 'statesFM[9]_rec';
      public
        'statesFM[9]_rec' 'statesFM[9]';
      protected
        record 'statesFM[10]_rec'
          Modelica.Media.Interfaces.Types.AbsolutePressure p
                                                            "Absolute pressure of medium";
          Modelica.Media.Interfaces.Types.Temperature T
                                                       "Temperature of medium";
        end 'statesFM[10]_rec';
      public
        'statesFM[10]_rec' 'statesFM[10]';
      protected
        record flowModel_rec
          constant Boolean from_dp = true
                                         "= true, use m_flow = f(dp), otherwise dp = f(m_flow)";
          constant Integer n = 10
                                 "Number of discrete flow volumes";
        protected
          record 'states[1]_rec'
            Modelica.Media.Interfaces.Types.AbsolutePressure p
                                                              "Absolute pressure of medium";
            Modelica.Media.Interfaces.Types.Temperature T
                                                         "Temperature of medium";
          end 'states[1]_rec';
        public
          'states[1]_rec' 'states[1]';
        protected
          record 'states[2]_rec'
            Modelica.Media.Interfaces.Types.AbsolutePressure p
                                                              "Absolute pressure of medium";
            Modelica.Media.Interfaces.Types.Temperature T
                                                         "Temperature of medium";
          end 'states[2]_rec';
        public
          'states[2]_rec' 'states[2]';
        protected
          record 'states[3]_rec'
            Modelica.Media.Interfaces.Types.AbsolutePressure p
                                                              "Absolute pressure of medium";
            Modelica.Media.Interfaces.Types.Temperature T
                                                         "Temperature of medium";
          end 'states[3]_rec';
        public
          'states[3]_rec' 'states[3]';
        protected
          record 'states[4]_rec'
            Modelica.Media.Interfaces.Types.AbsolutePressure p
                                                              "Absolute pressure of medium";
            Modelica.Media.Interfaces.Types.Temperature T
                                                         "Temperature of medium";
          end 'states[4]_rec';
        public
          'states[4]_rec' 'states[4]';
        protected
          record 'states[5]_rec'
            Modelica.Media.Interfaces.Types.AbsolutePressure p
                                                              "Absolute pressure of medium";
            Modelica.Media.Interfaces.Types.Temperature T
                                                         "Temperature of medium";
          end 'states[5]_rec';
        public
          'states[5]_rec' 'states[5]';
        protected
          record 'states[6]_rec'
            Modelica.Media.Interfaces.Types.AbsolutePressure p
                                                              "Absolute pressure of medium";
            Modelica.Media.Interfaces.Types.Temperature T
                                                         "Temperature of medium";
          end 'states[6]_rec';
        public
          'states[6]_rec' 'states[6]';
        protected
          record 'states[7]_rec'
            Modelica.Media.Interfaces.Types.AbsolutePressure p
                                                              "Absolute pressure of medium";
            Modelica.Media.Interfaces.Types.Temperature T
                                                         "Temperature of medium";
          end 'states[7]_rec';
        public
          'states[7]_rec' 'states[7]';
        protected
          record 'states[8]_rec'
            Modelica.Media.Interfaces.Types.AbsolutePressure p
                                                              "Absolute pressure of medium";
            Modelica.Media.Interfaces.Types.Temperature T
                                                         "Temperature of medium";
          end 'states[8]_rec';
        public
          'states[8]_rec' 'states[8]';
        protected
          record 'states[9]_rec'
            Modelica.Media.Interfaces.Types.AbsolutePressure p
                                                              "Absolute pressure of medium";
            Modelica.Media.Interfaces.Types.Temperature T
                                                         "Temperature of medium";
          end 'states[9]_rec';
        public
          'states[9]_rec' 'states[9]';
        protected
          record 'states[10]_rec'
            Modelica.Media.Interfaces.Types.AbsolutePressure p
                                                              "Absolute pressure of medium";
            Modelica.Media.Interfaces.Types.Temperature T
                                                         "Temperature of medium";
          end 'states[10]_rec';
        public
          'states[10]_rec' 'states[10]';
          Modelica.SIunits.Velocity 'vs[1]'
                                           "Mean velocities of fluid flow";
          Modelica.SIunits.Velocity 'vs[2]'
                                           "Mean velocities of fluid flow";
          Modelica.SIunits.Velocity 'vs[3]'
                                           "Mean velocities of fluid flow";
          Modelica.SIunits.Velocity 'vs[4]'
                                           "Mean velocities of fluid flow";
          Modelica.SIunits.Velocity 'vs[5]'
                                           "Mean velocities of fluid flow";
          Modelica.SIunits.Velocity 'vs[6]'
                                           "Mean velocities of fluid flow";
          Modelica.SIunits.Velocity 'vs[7]'
                                           "Mean velocities of fluid flow";
          Modelica.SIunits.Velocity 'vs[8]'
                                           "Mean velocities of fluid flow";
          Modelica.SIunits.Velocity 'vs[9]'
                                           "Mean velocities of fluid flow";
          Modelica.SIunits.Velocity 'vs[10]'
                                            "Mean velocities of fluid flow";
          parameter Real nParallel(fixed=false)
                                               "number of identical parallel flow devices";
          Modelica.SIunits.Area 'crossAreas[1]'
                                               "Cross flow areas at segment boundaries";
          Modelica.SIunits.Area 'crossAreas[2]'
                                               "Cross flow areas at segment boundaries";
          Modelica.SIunits.Area 'crossAreas[3]'
                                               "Cross flow areas at segment boundaries";
          Modelica.SIunits.Area 'crossAreas[4]'
                                               "Cross flow areas at segment boundaries";
          Modelica.SIunits.Area 'crossAreas[5]'
                                               "Cross flow areas at segment boundaries";
          Modelica.SIunits.Area 'crossAreas[6]'
                                               "Cross flow areas at segment boundaries";
          Modelica.SIunits.Area 'crossAreas[7]'
                                               "Cross flow areas at segment boundaries";
          Modelica.SIunits.Area 'crossAreas[8]'
                                               "Cross flow areas at segment boundaries";
          Modelica.SIunits.Area 'crossAreas[9]'
                                               "Cross flow areas at segment boundaries";
          Modelica.SIunits.Area 'crossAreas[10]'
                                                "Cross flow areas at segment boundaries";
          Modelica.SIunits.Length 'dimensions[1]'
                                                 "Characteristic dimensions for fluid flow (diameters for pipe flow)";
          Modelica.SIunits.Length 'dimensions[2]'
                                                 "Characteristic dimensions for fluid flow (diameters for pipe flow)";
          Modelica.SIunits.Length 'dimensions[3]'
                                                 "Characteristic dimensions for fluid flow (diameters for pipe flow)";
          Modelica.SIunits.Length 'dimensions[4]'
                                                 "Characteristic dimensions for fluid flow (diameters for pipe flow)";
          Modelica.SIunits.Length 'dimensions[5]'
                                                 "Characteristic dimensions for fluid flow (diameters for pipe flow)";
          Modelica.SIunits.Length 'dimensions[6]'
                                                 "Characteristic dimensions for fluid flow (diameters for pipe flow)";
          Modelica.SIunits.Length 'dimensions[7]'
                                                 "Characteristic dimensions for fluid flow (diameters for pipe flow)";
          Modelica.SIunits.Length 'dimensions[8]'
                                                 "Characteristic dimensions for fluid flow (diameters for pipe flow)";
          Modelica.SIunits.Length 'dimensions[9]'
                                                 "Characteristic dimensions for fluid flow (diameters for pipe flow)";
          Modelica.SIunits.Length 'dimensions[10]'
                                                  "Characteristic dimensions for fluid flow (diameters for pipe flow)";
          Modelica.SIunits.Height 'roughnesses[1]'
                                                  "Average height of surface asperities";
          Modelica.SIunits.Height 'roughnesses[2]'
                                                  "Average height of surface asperities";
          Modelica.SIunits.Height 'roughnesses[3]'
                                                  "Average height of surface asperities";
          Modelica.SIunits.Height 'roughnesses[4]'
                                                  "Average height of surface asperities";
          Modelica.SIunits.Height 'roughnesses[5]'
                                                  "Average height of surface asperities";
          Modelica.SIunits.Height 'roughnesses[6]'
                                                  "Average height of surface asperities";
          Modelica.SIunits.Height 'roughnesses[7]'
                                                  "Average height of surface asperities";
          Modelica.SIunits.Height 'roughnesses[8]'
                                                  "Average height of surface asperities";
          Modelica.SIunits.Height 'roughnesses[9]'
                                                  "Average height of surface asperities";
          Modelica.SIunits.Height 'roughnesses[10]'
                                                   "Average height of surface asperities";
          constant Modelica.SIunits.Length 'dheights[1]' = 0.0
                                                              "Height(states[2:n]) - Height(states[1:n-1])";
          constant Modelica.SIunits.Length 'dheights[2]' = 0.0
                                                              "Height(states[2:n]) - Height(states[1:n-1])";
          constant Modelica.SIunits.Length 'dheights[3]' = 0.0
                                                              "Height(states[2:n]) - Height(states[1:n-1])";
          constant Modelica.SIunits.Length 'dheights[4]' = 0.0
                                                              "Height(states[2:n]) - Height(states[1:n-1])";
          constant Modelica.SIunits.Length 'dheights[5]' = 0.0
                                                              "Height(states[2:n]) - Height(states[1:n-1])";
          constant Modelica.SIunits.Length 'dheights[6]' = 0.0
                                                              "Height(states[2:n]) - Height(states[1:n-1])";
          constant Modelica.SIunits.Length 'dheights[7]' = 0.0
                                                              "Height(states[2:n]) - Height(states[1:n-1])";
          constant Modelica.SIunits.Length 'dheights[8]' = 0.0
                                                              "Height(states[2:n]) - Height(states[1:n-1])";
          constant Modelica.SIunits.Length 'dheights[9]' = 0.0
                                                              "Height(states[2:n]) - Height(states[1:n-1])";
          parameter Modelica.SIunits.Acceleration g(fixed=false)
                                                                "Constant gravity acceleration";
          constant Boolean allowFlowReversal = false
                                                    "= true to allow flow reversal, false restricts to design direction (states[1] -> states[n+1])";
          constant Modelica.Fluid.Types.Dynamics momentumDynamics = Modelica.Fluid.Types.Dynamics.SteadyState
                                                                                                             "Formulation of momentum balance";
          constant Modelica.Media.Interfaces.PartialMedium.MassFlowRate m_flow_start(quantity = "MassFlowRate.SimpleLiquidWater") = 0.0
                                                                                                                                       "Start value of mass flow rates";
          parameter Modelica.Media.Interfaces.Types.AbsolutePressure p_a_start(fixed=false)
                                                                                           "Start value for p[1] at design inflow";
          parameter Modelica.Media.Interfaces.Types.AbsolutePressure p_b_start(fixed=false)
                                                                                           "Start value for p[n+1] at design outflow";
          constant Integer m = 9
                                "Number of flow segments";
          constant Modelica.SIunits.Length 'pathLengths[1]' = 0.75
                                                                  "Lengths along flow path";
          constant Modelica.SIunits.Length 'pathLengths[2]' = 0.5
                                                                 "Lengths along flow path";
          constant Modelica.SIunits.Length 'pathLengths[3]' = 0.5
                                                                 "Lengths along flow path";
          constant Modelica.SIunits.Length 'pathLengths[4]' = 0.5
                                                                 "Lengths along flow path";
          constant Modelica.SIunits.Length 'pathLengths[5]' = 0.5
                                                                 "Lengths along flow path";
          constant Modelica.SIunits.Length 'pathLengths[6]' = 0.5
                                                                 "Lengths along flow path";
          constant Modelica.SIunits.Length 'pathLengths[7]' = 0.5
                                                                 "Lengths along flow path";
          constant Modelica.SIunits.Length 'pathLengths[8]' = 0.5
                                                                 "Lengths along flow path";
          constant Modelica.SIunits.Length 'pathLengths[9]' = 0.75
                                                                  "Lengths along flow path";
          Modelica.Media.Interfaces.PartialMedium.MassFlowRate 'm_flows[1]'(quantity = "MassFlowRate.SimpleLiquidWater", min = 0.0)
                                                                                                                                   "mass flow rates between states";
          Modelica.Media.Interfaces.PartialMedium.MassFlowRate 'm_flows[2]'(quantity = "MassFlowRate.SimpleLiquidWater", min = 0.0)
                                                                                                                                   "mass flow rates between states";
          Modelica.Media.Interfaces.PartialMedium.MassFlowRate 'm_flows[3]'(quantity = "MassFlowRate.SimpleLiquidWater", min = 0.0)
                                                                                                                                   "mass flow rates between states";
          Modelica.Media.Interfaces.PartialMedium.MassFlowRate 'm_flows[4]'(quantity = "MassFlowRate.SimpleLiquidWater", min = 0.0)
                                                                                                                                   "mass flow rates between states";
          Modelica.Media.Interfaces.PartialMedium.MassFlowRate 'm_flows[5]'(quantity = "MassFlowRate.SimpleLiquidWater", min = 0.0)
                                                                                                                                   "mass flow rates between states";
          Modelica.Media.Interfaces.PartialMedium.MassFlowRate 'm_flows[6]'(quantity = "MassFlowRate.SimpleLiquidWater", min = 0.0)
                                                                                                                                   "mass flow rates between states";
          Modelica.Media.Interfaces.PartialMedium.MassFlowRate 'm_flows[7]'(quantity = "MassFlowRate.SimpleLiquidWater", min = 0.0)
                                                                                                                                   "mass flow rates between states";
          Modelica.Media.Interfaces.PartialMedium.MassFlowRate 'm_flows[8]'(quantity = "MassFlowRate.SimpleLiquidWater", min = 0.0)
                                                                                                                                   "mass flow rates between states";
          Modelica.Media.Interfaces.PartialMedium.MassFlowRate 'm_flows[9]'(quantity = "MassFlowRate.SimpleLiquidWater", min = 0.0)
                                                                                                                                   "mass flow rates between states";
          Modelica.SIunits.Momentum 'Is[1]'
                                           "Momenta of flow segments";
          Modelica.SIunits.Momentum 'Is[2]'
                                           "Momenta of flow segments";
          Modelica.SIunits.Momentum 'Is[3]'
                                           "Momenta of flow segments";
          Modelica.SIunits.Momentum 'Is[4]'
                                           "Momenta of flow segments";
          Modelica.SIunits.Momentum 'Is[5]'
                                           "Momenta of flow segments";
          Modelica.SIunits.Momentum 'Is[6]'
                                           "Momenta of flow segments";
          Modelica.SIunits.Momentum 'Is[7]'
                                           "Momenta of flow segments";
          Modelica.SIunits.Momentum 'Is[8]'
                                           "Momenta of flow segments";
          Modelica.SIunits.Momentum 'Is[9]'
                                           "Momenta of flow segments";
          constant Modelica.SIunits.Force 'Ib_flows[1]' = 0.0
                                                             "Flow of momentum across boundaries";
          constant Modelica.SIunits.Force 'Ib_flows[2]' = 0.0
                                                             "Flow of momentum across boundaries";
          constant Modelica.SIunits.Force 'Ib_flows[3]' = 0.0
                                                             "Flow of momentum across boundaries";
          constant Modelica.SIunits.Force 'Ib_flows[4]' = 0.0
                                                             "Flow of momentum across boundaries";
          constant Modelica.SIunits.Force 'Ib_flows[5]' = 0.0
                                                             "Flow of momentum across boundaries";
          constant Modelica.SIunits.Force 'Ib_flows[6]' = 0.0
                                                             "Flow of momentum across boundaries";
          constant Modelica.SIunits.Force 'Ib_flows[7]' = 0.0
                                                             "Flow of momentum across boundaries";
          constant Modelica.SIunits.Force 'Ib_flows[8]' = 0.0
                                                             "Flow of momentum across boundaries";
          constant Modelica.SIunits.Force 'Ib_flows[9]' = 0.0
                                                             "Flow of momentum across boundaries";
          Modelica.SIunits.Force 'Fs_p[1]'
                                          "Pressure forces";
          Modelica.SIunits.Force 'Fs_p[2]'
                                          "Pressure forces";
          Modelica.SIunits.Force 'Fs_p[3]'
                                          "Pressure forces";
          Modelica.SIunits.Force 'Fs_p[4]'
                                          "Pressure forces";
          Modelica.SIunits.Force 'Fs_p[5]'
                                          "Pressure forces";
          Modelica.SIunits.Force 'Fs_p[6]'
                                          "Pressure forces";
          Modelica.SIunits.Force 'Fs_p[7]'
                                          "Pressure forces";
          Modelica.SIunits.Force 'Fs_p[8]'
                                          "Pressure forces";
          Modelica.SIunits.Force 'Fs_p[9]'
                                          "Pressure forces";
          Modelica.SIunits.Force 'Fs_fg[1]'
                                           "Friction and gravity forces";
          Modelica.SIunits.Force 'Fs_fg[2]'
                                           "Friction and gravity forces";
          Modelica.SIunits.Force 'Fs_fg[3]'
                                           "Friction and gravity forces";
          Modelica.SIunits.Force 'Fs_fg[4]'
                                           "Friction and gravity forces";
          Modelica.SIunits.Force 'Fs_fg[5]'
                                           "Friction and gravity forces";
          Modelica.SIunits.Force 'Fs_fg[6]'
                                           "Friction and gravity forces";
          Modelica.SIunits.Force 'Fs_fg[7]'
                                           "Friction and gravity forces";
          Modelica.SIunits.Force 'Fs_fg[8]'
                                           "Friction and gravity forces";
          Modelica.SIunits.Force 'Fs_fg[9]'
                                           "Friction and gravity forces";
          constant Boolean useUpstreamScheme = true
                                                   "= false to average upstream and downstream properties across flow segments";
          constant Boolean use_Ib_flows = false
                                               "= true to consider differences in flow of momentum through boundaries";
          constant Modelica.Media.Interfaces.Types.Density 'rhos[1]' = 995.586;
          constant Modelica.Media.Interfaces.Types.Density 'rhos[2]' = 995.586;
          constant Modelica.Media.Interfaces.Types.Density 'rhos[3]' = 995.586;
          constant Modelica.Media.Interfaces.Types.Density 'rhos[4]' = 995.586;
          constant Modelica.Media.Interfaces.Types.Density 'rhos[5]' = 995.586;
          constant Modelica.Media.Interfaces.Types.Density 'rhos[6]' = 995.586;
          constant Modelica.Media.Interfaces.Types.Density 'rhos[7]' = 995.586;
          constant Modelica.Media.Interfaces.Types.Density 'rhos[8]' = 995.586;
          constant Modelica.Media.Interfaces.Types.Density 'rhos[9]' = 995.586;
          constant Modelica.Media.Interfaces.Types.Density 'rhos[10]' = 995.586;
          constant Modelica.Media.Interfaces.Types.Density 'rhos_act[1]' = 995.586
                                                                                  "Actual density per segment";
          constant Modelica.Media.Interfaces.Types.Density 'rhos_act[2]' = 995.586
                                                                                  "Actual density per segment";
          constant Modelica.Media.Interfaces.Types.Density 'rhos_act[3]' = 995.586
                                                                                  "Actual density per segment";
          constant Modelica.Media.Interfaces.Types.Density 'rhos_act[4]' = 995.586
                                                                                  "Actual density per segment";
          constant Modelica.Media.Interfaces.Types.Density 'rhos_act[5]' = 995.586
                                                                                  "Actual density per segment";
          constant Modelica.Media.Interfaces.Types.Density 'rhos_act[6]' = 995.586
                                                                                  "Actual density per segment";
          constant Modelica.Media.Interfaces.Types.Density 'rhos_act[7]' = 995.586
                                                                                  "Actual density per segment";
          constant Modelica.Media.Interfaces.Types.Density 'rhos_act[8]' = 995.586
                                                                                  "Actual density per segment";
          constant Modelica.Media.Interfaces.Types.Density 'rhos_act[9]' = 995.586
                                                                                  "Actual density per segment";
          constant Modelica.Media.Interfaces.Types.DynamicViscosity 'mus[1]' = 0.001;
          constant Modelica.Media.Interfaces.Types.DynamicViscosity 'mus[2]' = 0.001;
          constant Modelica.Media.Interfaces.Types.DynamicViscosity 'mus[3]' = 0.001;
          constant Modelica.Media.Interfaces.Types.DynamicViscosity 'mus[4]' = 0.001;
          constant Modelica.Media.Interfaces.Types.DynamicViscosity 'mus[5]' = 0.001;
          constant Modelica.Media.Interfaces.Types.DynamicViscosity 'mus[6]' = 0.001;
          constant Modelica.Media.Interfaces.Types.DynamicViscosity 'mus[7]' = 0.001;
          constant Modelica.Media.Interfaces.Types.DynamicViscosity 'mus[8]' = 0.001;
          constant Modelica.Media.Interfaces.Types.DynamicViscosity 'mus[9]' = 0.001;
          constant Modelica.Media.Interfaces.Types.DynamicViscosity 'mus[10]' = 0.001;
          constant Modelica.Media.Interfaces.Types.DynamicViscosity 'mus_act[1]' = 0.001
                                                                                        "Actual viscosity per segment";
          constant Modelica.Media.Interfaces.Types.DynamicViscosity 'mus_act[2]' = 0.001
                                                                                        "Actual viscosity per segment";
          constant Modelica.Media.Interfaces.Types.DynamicViscosity 'mus_act[3]' = 0.001
                                                                                        "Actual viscosity per segment";
          constant Modelica.Media.Interfaces.Types.DynamicViscosity 'mus_act[4]' = 0.001
                                                                                        "Actual viscosity per segment";
          constant Modelica.Media.Interfaces.Types.DynamicViscosity 'mus_act[5]' = 0.001
                                                                                        "Actual viscosity per segment";
          constant Modelica.Media.Interfaces.Types.DynamicViscosity 'mus_act[6]' = 0.001
                                                                                        "Actual viscosity per segment";
          constant Modelica.Media.Interfaces.Types.DynamicViscosity 'mus_act[7]' = 0.001
                                                                                        "Actual viscosity per segment";
          constant Modelica.Media.Interfaces.Types.DynamicViscosity 'mus_act[8]' = 0.001
                                                                                        "Actual viscosity per segment";
          constant Modelica.Media.Interfaces.Types.DynamicViscosity 'mus_act[9]' = 0.001
                                                                                        "Actual viscosity per segment";
          Modelica.SIunits.Pressure 'dps_fg[1]'
                                               "pressure drop between states";
          Modelica.SIunits.Pressure 'dps_fg[2]'
                                               "pressure drop between states";
          Modelica.SIunits.Pressure 'dps_fg[3]'
                                               "pressure drop between states";
          Modelica.SIunits.Pressure 'dps_fg[4]'
                                               "pressure drop between states";
          Modelica.SIunits.Pressure 'dps_fg[5]'
                                               "pressure drop between states";
          Modelica.SIunits.Pressure 'dps_fg[6]'
                                               "pressure drop between states";
          Modelica.SIunits.Pressure 'dps_fg[7]'
                                               "pressure drop between states";
          Modelica.SIunits.Pressure 'dps_fg[8]'
                                               "pressure drop between states";
          Modelica.SIunits.Pressure 'dps_fg[9]'
                                               "pressure drop between states";
          constant Modelica.SIunits.ReynoldsNumber Re_turbulent = 4000
                                                                      "Start of turbulent regime, depending on type of flow device";
          constant Boolean show_Res = false
                                           "= true, if Reynolds numbers are included for plotting";
          constant Modelica.SIunits.Length 'pathLengths_internal[1]' = 0.75
                                                                           "pathLengths used internally; to be defined by extending class";
          constant Modelica.SIunits.Length 'pathLengths_internal[2]' = 0.5
                                                                          "pathLengths used internally; to be defined by extending class";
          constant Modelica.SIunits.Length 'pathLengths_internal[3]' = 0.5
                                                                          "pathLengths used internally; to be defined by extending class";
          constant Modelica.SIunits.Length 'pathLengths_internal[4]' = 0.5
                                                                          "pathLengths used internally; to be defined by extending class";
          constant Modelica.SIunits.Length 'pathLengths_internal[5]' = 0.5
                                                                          "pathLengths used internally; to be defined by extending class";
          constant Modelica.SIunits.Length 'pathLengths_internal[6]' = 0.5
                                                                          "pathLengths used internally; to be defined by extending class";
          constant Modelica.SIunits.Length 'pathLengths_internal[7]' = 0.5
                                                                          "pathLengths used internally; to be defined by extending class";
          constant Modelica.SIunits.Length 'pathLengths_internal[8]' = 0.5
                                                                          "pathLengths used internally; to be defined by extending class";
          constant Modelica.SIunits.Length 'pathLengths_internal[9]' = 0.75
                                                                           "pathLengths used internally; to be defined by extending class";
          constant Modelica.SIunits.ReynoldsNumber 'Res_turbulent_internal[1]' = 4000
                                                                                     "Re_turbulent used internally; to be defined by extending class";
          constant Modelica.SIunits.ReynoldsNumber 'Res_turbulent_internal[2]' = 4000
                                                                                     "Re_turbulent used internally; to be defined by extending class";
          constant Modelica.SIunits.ReynoldsNumber 'Res_turbulent_internal[3]' = 4000
                                                                                     "Re_turbulent used internally; to be defined by extending class";
          constant Modelica.SIunits.ReynoldsNumber 'Res_turbulent_internal[4]' = 4000
                                                                                     "Re_turbulent used internally; to be defined by extending class";
          constant Modelica.SIunits.ReynoldsNumber 'Res_turbulent_internal[5]' = 4000
                                                                                     "Re_turbulent used internally; to be defined by extending class";
          constant Modelica.SIunits.ReynoldsNumber 'Res_turbulent_internal[6]' = 4000
                                                                                     "Re_turbulent used internally; to be defined by extending class";
          constant Modelica.SIunits.ReynoldsNumber 'Res_turbulent_internal[7]' = 4000
                                                                                     "Re_turbulent used internally; to be defined by extending class";
          constant Modelica.SIunits.ReynoldsNumber 'Res_turbulent_internal[8]' = 4000
                                                                                     "Re_turbulent used internally; to be defined by extending class";
          constant Modelica.SIunits.ReynoldsNumber 'Res_turbulent_internal[9]' = 4000
                                                                                     "Re_turbulent used internally; to be defined by extending class";
          parameter Modelica.SIunits.AbsolutePressure dp_nominal(fixed=false)
                                                                             "Nominal pressure loss (only for nominal models)";
          parameter Modelica.SIunits.MassFlowRate m_flow_nominal(fixed=false)
                                                                             "Nominal mass flow rate";
          parameter Modelica.SIunits.MassFlowRate m_flow_small(fixed=false)
                                                                           "Within regularization if |m_flows| < m_flow_small (may be wider for large discontinuities in static head)";
        end flowModel_rec;
      public
        flowModel_rec flowModel;
        Modelica.Media.Interfaces.PartialMedium.MassFlowRate 'm_flows[1]'(quantity = "MassFlowRate.SimpleLiquidWater", min = 0.0)
                                                                                                                                 "Mass flow rates of fluid across segment boundaries";
        Modelica.Media.Interfaces.PartialMedium.MassFlowRate 'm_flows[2]'(quantity = "MassFlowRate.SimpleLiquidWater", min = 0.0)
                                                                                                                                 "Mass flow rates of fluid across segment boundaries";
        Modelica.Media.Interfaces.PartialMedium.MassFlowRate 'm_flows[3]'(quantity = "MassFlowRate.SimpleLiquidWater", min = 0.0)
                                                                                                                                 "Mass flow rates of fluid across segment boundaries";
        Modelica.Media.Interfaces.PartialMedium.MassFlowRate 'm_flows[4]'(quantity = "MassFlowRate.SimpleLiquidWater", min = 0.0)
                                                                                                                                 "Mass flow rates of fluid across segment boundaries";
        Modelica.Media.Interfaces.PartialMedium.MassFlowRate 'm_flows[5]'(quantity = "MassFlowRate.SimpleLiquidWater", min = 0.0)
                                                                                                                                 "Mass flow rates of fluid across segment boundaries";
        Modelica.Media.Interfaces.PartialMedium.MassFlowRate 'm_flows[6]'(quantity = "MassFlowRate.SimpleLiquidWater", min = 0.0)
                                                                                                                                 "Mass flow rates of fluid across segment boundaries";
        Modelica.Media.Interfaces.PartialMedium.MassFlowRate 'm_flows[7]'(quantity = "MassFlowRate.SimpleLiquidWater", min = 0.0)
                                                                                                                                 "Mass flow rates of fluid across segment boundaries";
        Modelica.Media.Interfaces.PartialMedium.MassFlowRate 'm_flows[8]'(quantity = "MassFlowRate.SimpleLiquidWater", min = 0.0)
                                                                                                                                 "Mass flow rates of fluid across segment boundaries";
        Modelica.Media.Interfaces.PartialMedium.MassFlowRate 'm_flows[9]'(quantity = "MassFlowRate.SimpleLiquidWater", min = 0.0)
                                                                                                                                 "Mass flow rates of fluid across segment boundaries";
        Modelica.Media.Interfaces.PartialMedium.MassFlowRate 'm_flows[10]'(quantity = "MassFlowRate.SimpleLiquidWater", min = 0.0)
                                                                                                                                  "Mass flow rates of fluid across segment boundaries";
        Modelica.Media.Interfaces.PartialMedium.MassFlowRate 'm_flows[11]'(quantity = "MassFlowRate.SimpleLiquidWater", min = 0.0)
                                                                                                                                  "Mass flow rates of fluid across segment boundaries";
        Modelica.Media.Interfaces.Types.EnthalpyFlowRate 'H_flows[1]'
                                                                     "Enthalpy flow rates of fluid across segment boundaries";
        Modelica.Media.Interfaces.Types.EnthalpyFlowRate 'H_flows[2]'
                                                                     "Enthalpy flow rates of fluid across segment boundaries";
        Modelica.Media.Interfaces.Types.EnthalpyFlowRate 'H_flows[3]'
                                                                     "Enthalpy flow rates of fluid across segment boundaries";
        Modelica.Media.Interfaces.Types.EnthalpyFlowRate 'H_flows[4]'
                                                                     "Enthalpy flow rates of fluid across segment boundaries";
        Modelica.Media.Interfaces.Types.EnthalpyFlowRate 'H_flows[5]'
                                                                     "Enthalpy flow rates of fluid across segment boundaries";
        Modelica.Media.Interfaces.Types.EnthalpyFlowRate 'H_flows[6]'
                                                                     "Enthalpy flow rates of fluid across segment boundaries";
        Modelica.Media.Interfaces.Types.EnthalpyFlowRate 'H_flows[7]'
                                                                     "Enthalpy flow rates of fluid across segment boundaries";
        Modelica.Media.Interfaces.Types.EnthalpyFlowRate 'H_flows[8]'
                                                                     "Enthalpy flow rates of fluid across segment boundaries";
        Modelica.Media.Interfaces.Types.EnthalpyFlowRate 'H_flows[9]'
                                                                     "Enthalpy flow rates of fluid across segment boundaries";
        Modelica.Media.Interfaces.Types.EnthalpyFlowRate 'H_flows[10]'
                                                                      "Enthalpy flow rates of fluid across segment boundaries";
        Modelica.Media.Interfaces.Types.EnthalpyFlowRate 'H_flows[11]'
                                                                      "Enthalpy flow rates of fluid across segment boundaries";
        Modelica.SIunits.Velocity 'vs[1]'
                                         "mean velocities in flow segments";
        Modelica.SIunits.Velocity 'vs[2]'
                                         "mean velocities in flow segments";
        Modelica.SIunits.Velocity 'vs[3]'
                                         "mean velocities in flow segments";
        Modelica.SIunits.Velocity 'vs[4]'
                                         "mean velocities in flow segments";
        Modelica.SIunits.Velocity 'vs[5]'
                                         "mean velocities in flow segments";
        Modelica.SIunits.Velocity 'vs[6]'
                                         "mean velocities in flow segments";
        Modelica.SIunits.Velocity 'vs[7]'
                                         "mean velocities in flow segments";
        Modelica.SIunits.Velocity 'vs[8]'
                                         "mean velocities in flow segments";
        Modelica.SIunits.Velocity 'vs[9]'
                                         "mean velocities in flow segments";
        Modelica.SIunits.Velocity 'vs[10]'
                                          "mean velocities in flow segments";
        constant Boolean use_HeatTransfer = true
                                                "= true to use the HeatTransfer model";
      protected
        record 'heatPorts[1]_rec'
          Modelica.SIunits.Temperature T
                                        "Port temperature";
          Modelica.SIunits.HeatFlowRate Q_flow
                                              "Heat flow rate (positive if flowing from outside into the component)";
        end 'heatPorts[1]_rec';
      public
        'heatPorts[1]_rec' 'heatPorts[1]';
      protected
        record 'heatPorts[2]_rec'
          Modelica.SIunits.Temperature T
                                        "Port temperature";
          Modelica.SIunits.HeatFlowRate Q_flow
                                              "Heat flow rate (positive if flowing from outside into the component)";
        end 'heatPorts[2]_rec';
      public
        'heatPorts[2]_rec' 'heatPorts[2]';
      protected
        record 'heatPorts[3]_rec'
          Modelica.SIunits.Temperature T
                                        "Port temperature";
          Modelica.SIunits.HeatFlowRate Q_flow
                                              "Heat flow rate (positive if flowing from outside into the component)";
        end 'heatPorts[3]_rec';
      public
        'heatPorts[3]_rec' 'heatPorts[3]';
      protected
        record 'heatPorts[4]_rec'
          Modelica.SIunits.Temperature T
                                        "Port temperature";
          Modelica.SIunits.HeatFlowRate Q_flow
                                              "Heat flow rate (positive if flowing from outside into the component)";
        end 'heatPorts[4]_rec';
      public
        'heatPorts[4]_rec' 'heatPorts[4]';
      protected
        record 'heatPorts[5]_rec'
          Modelica.SIunits.Temperature T
                                        "Port temperature";
          Modelica.SIunits.HeatFlowRate Q_flow
                                              "Heat flow rate (positive if flowing from outside into the component)";
        end 'heatPorts[5]_rec';
      public
        'heatPorts[5]_rec' 'heatPorts[5]';
      protected
        record 'heatPorts[6]_rec'
          Modelica.SIunits.Temperature T
                                        "Port temperature";
          Modelica.SIunits.HeatFlowRate Q_flow
                                              "Heat flow rate (positive if flowing from outside into the component)";
        end 'heatPorts[6]_rec';
      public
        'heatPorts[6]_rec' 'heatPorts[6]';
      protected
        record 'heatPorts[7]_rec'
          Modelica.SIunits.Temperature T
                                        "Port temperature";
          Modelica.SIunits.HeatFlowRate Q_flow
                                              "Heat flow rate (positive if flowing from outside into the component)";
        end 'heatPorts[7]_rec';
      public
        'heatPorts[7]_rec' 'heatPorts[7]';
      protected
        record 'heatPorts[8]_rec'
          Modelica.SIunits.Temperature T
                                        "Port temperature";
          Modelica.SIunits.HeatFlowRate Q_flow
                                              "Heat flow rate (positive if flowing from outside into the component)";
        end 'heatPorts[8]_rec';
      public
        'heatPorts[8]_rec' 'heatPorts[8]';
      protected
        record 'heatPorts[9]_rec'
          Modelica.SIunits.Temperature T
                                        "Port temperature";
          Modelica.SIunits.HeatFlowRate Q_flow
                                              "Heat flow rate (positive if flowing from outside into the component)";
        end 'heatPorts[9]_rec';
      public
        'heatPorts[9]_rec' 'heatPorts[9]';
      protected
        record 'heatPorts[10]_rec'
          Modelica.SIunits.Temperature T
                                        "Port temperature";
          Modelica.SIunits.HeatFlowRate Q_flow
                                              "Heat flow rate (positive if flowing from outside into the component)";
        end 'heatPorts[10]_rec';
      public
        'heatPorts[10]_rec' 'heatPorts[10]';
      protected
        record heatTransfer_rec
          constant Integer n = 10
                                 "Number of heat transfer segments";
        protected
          record 'states[1]_rec'
            Modelica.Media.Interfaces.Types.AbsolutePressure p
                                                              "Absolute pressure of medium";
            Modelica.Media.Interfaces.Types.Temperature T
                                                         "Temperature of medium";
          end 'states[1]_rec';
        public
          'states[1]_rec' 'states[1]';
        protected
          record 'states[2]_rec'
            Modelica.Media.Interfaces.Types.AbsolutePressure p
                                                              "Absolute pressure of medium";
            Modelica.Media.Interfaces.Types.Temperature T
                                                         "Temperature of medium";
          end 'states[2]_rec';
        public
          'states[2]_rec' 'states[2]';
        protected
          record 'states[3]_rec'
            Modelica.Media.Interfaces.Types.AbsolutePressure p
                                                              "Absolute pressure of medium";
            Modelica.Media.Interfaces.Types.Temperature T
                                                         "Temperature of medium";
          end 'states[3]_rec';
        public
          'states[3]_rec' 'states[3]';
        protected
          record 'states[4]_rec'
            Modelica.Media.Interfaces.Types.AbsolutePressure p
                                                              "Absolute pressure of medium";
            Modelica.Media.Interfaces.Types.Temperature T
                                                         "Temperature of medium";
          end 'states[4]_rec';
        public
          'states[4]_rec' 'states[4]';
        protected
          record 'states[5]_rec'
            Modelica.Media.Interfaces.Types.AbsolutePressure p
                                                              "Absolute pressure of medium";
            Modelica.Media.Interfaces.Types.Temperature T
                                                         "Temperature of medium";
          end 'states[5]_rec';
        public
          'states[5]_rec' 'states[5]';
        protected
          record 'states[6]_rec'
            Modelica.Media.Interfaces.Types.AbsolutePressure p
                                                              "Absolute pressure of medium";
            Modelica.Media.Interfaces.Types.Temperature T
                                                         "Temperature of medium";
          end 'states[6]_rec';
        public
          'states[6]_rec' 'states[6]';
        protected
          record 'states[7]_rec'
            Modelica.Media.Interfaces.Types.AbsolutePressure p
                                                              "Absolute pressure of medium";
            Modelica.Media.Interfaces.Types.Temperature T
                                                         "Temperature of medium";
          end 'states[7]_rec';
        public
          'states[7]_rec' 'states[7]';
        protected
          record 'states[8]_rec'
            Modelica.Media.Interfaces.Types.AbsolutePressure p
                                                              "Absolute pressure of medium";
            Modelica.Media.Interfaces.Types.Temperature T
                                                         "Temperature of medium";
          end 'states[8]_rec';
        public
          'states[8]_rec' 'states[8]';
        protected
          record 'states[9]_rec'
            Modelica.Media.Interfaces.Types.AbsolutePressure p
                                                              "Absolute pressure of medium";
            Modelica.Media.Interfaces.Types.Temperature T
                                                         "Temperature of medium";
          end 'states[9]_rec';
        public
          'states[9]_rec' 'states[9]';
        protected
          record 'states[10]_rec'
            Modelica.Media.Interfaces.Types.AbsolutePressure p
                                                              "Absolute pressure of medium";
            Modelica.Media.Interfaces.Types.Temperature T
                                                         "Temperature of medium";
          end 'states[10]_rec';
        public
          'states[10]_rec' 'states[10]';
          parameter Modelica.SIunits.Area 'surfaceAreas[1]'(fixed=false)
                                                                        "Heat transfer areas";
          parameter Modelica.SIunits.Area 'surfaceAreas[2]'(fixed=false)
                                                                        "Heat transfer areas";
          parameter Modelica.SIunits.Area 'surfaceAreas[3]'(fixed=false)
                                                                        "Heat transfer areas";
          parameter Modelica.SIunits.Area 'surfaceAreas[4]'(fixed=false)
                                                                        "Heat transfer areas";
          parameter Modelica.SIunits.Area 'surfaceAreas[5]'(fixed=false)
                                                                        "Heat transfer areas";
          parameter Modelica.SIunits.Area 'surfaceAreas[6]'(fixed=false)
                                                                        "Heat transfer areas";
          parameter Modelica.SIunits.Area 'surfaceAreas[7]'(fixed=false)
                                                                        "Heat transfer areas";
          parameter Modelica.SIunits.Area 'surfaceAreas[8]'(fixed=false)
                                                                        "Heat transfer areas";
          parameter Modelica.SIunits.Area 'surfaceAreas[9]'(fixed=false)
                                                                        "Heat transfer areas";
          parameter Modelica.SIunits.Area 'surfaceAreas[10]'(fixed=false)
                                                                         "Heat transfer areas";
          Modelica.SIunits.HeatFlowRate 'Q_flows[1]'
                                                    "Heat flow rates";
          Modelica.SIunits.HeatFlowRate 'Q_flows[2]'
                                                    "Heat flow rates";
          Modelica.SIunits.HeatFlowRate 'Q_flows[3]'
                                                    "Heat flow rates";
          Modelica.SIunits.HeatFlowRate 'Q_flows[4]'
                                                    "Heat flow rates";
          Modelica.SIunits.HeatFlowRate 'Q_flows[5]'
                                                    "Heat flow rates";
          Modelica.SIunits.HeatFlowRate 'Q_flows[6]'
                                                    "Heat flow rates";
          Modelica.SIunits.HeatFlowRate 'Q_flows[7]'
                                                    "Heat flow rates";
          Modelica.SIunits.HeatFlowRate 'Q_flows[8]'
                                                    "Heat flow rates";
          Modelica.SIunits.HeatFlowRate 'Q_flows[9]'
                                                    "Heat flow rates";
          Modelica.SIunits.HeatFlowRate 'Q_flows[10]'
                                                     "Heat flow rates";
          constant Boolean use_k = true
                                       "= true to use k value for thermal isolation";
          constant Modelica.SIunits.CoefficientOfHeatTransfer k = 0
                                                                   "Heat transfer coefficient to ambient";
          parameter Modelica.SIunits.Temperature T_ambient(fixed=false)
                                                                       "Ambient temperature";
        protected
          record 'heatPorts[1]_rec'
            Modelica.SIunits.Temperature T
                                          "Port temperature";
            Modelica.SIunits.HeatFlowRate Q_flow
                                                "Heat flow rate (positive if flowing from outside into the component)";
          end 'heatPorts[1]_rec';
        public
          'heatPorts[1]_rec' 'heatPorts[1]';
        protected
          record 'heatPorts[2]_rec'
            Modelica.SIunits.Temperature T
                                          "Port temperature";
            Modelica.SIunits.HeatFlowRate Q_flow
                                                "Heat flow rate (positive if flowing from outside into the component)";
          end 'heatPorts[2]_rec';
        public
          'heatPorts[2]_rec' 'heatPorts[2]';
        protected
          record 'heatPorts[3]_rec'
            Modelica.SIunits.Temperature T
                                          "Port temperature";
            Modelica.SIunits.HeatFlowRate Q_flow
                                                "Heat flow rate (positive if flowing from outside into the component)";
          end 'heatPorts[3]_rec';
        public
          'heatPorts[3]_rec' 'heatPorts[3]';
        protected
          record 'heatPorts[4]_rec'
            Modelica.SIunits.Temperature T
                                          "Port temperature";
            Modelica.SIunits.HeatFlowRate Q_flow
                                                "Heat flow rate (positive if flowing from outside into the component)";
          end 'heatPorts[4]_rec';
        public
          'heatPorts[4]_rec' 'heatPorts[4]';
        protected
          record 'heatPorts[5]_rec'
            Modelica.SIunits.Temperature T
                                          "Port temperature";
            Modelica.SIunits.HeatFlowRate Q_flow
                                                "Heat flow rate (positive if flowing from outside into the component)";
          end 'heatPorts[5]_rec';
        public
          'heatPorts[5]_rec' 'heatPorts[5]';
        protected
          record 'heatPorts[6]_rec'
            Modelica.SIunits.Temperature T
                                          "Port temperature";
            Modelica.SIunits.HeatFlowRate Q_flow
                                                "Heat flow rate (positive if flowing from outside into the component)";
          end 'heatPorts[6]_rec';
        public
          'heatPorts[6]_rec' 'heatPorts[6]';
        protected
          record 'heatPorts[7]_rec'
            Modelica.SIunits.Temperature T
                                          "Port temperature";
            Modelica.SIunits.HeatFlowRate Q_flow
                                                "Heat flow rate (positive if flowing from outside into the component)";
          end 'heatPorts[7]_rec';
        public
          'heatPorts[7]_rec' 'heatPorts[7]';
        protected
          record 'heatPorts[8]_rec'
            Modelica.SIunits.Temperature T
                                          "Port temperature";
            Modelica.SIunits.HeatFlowRate Q_flow
                                                "Heat flow rate (positive if flowing from outside into the component)";
          end 'heatPorts[8]_rec';
        public
          'heatPorts[8]_rec' 'heatPorts[8]';
        protected
          record 'heatPorts[9]_rec'
            Modelica.SIunits.Temperature T
                                          "Port temperature";
            Modelica.SIunits.HeatFlowRate Q_flow
                                                "Heat flow rate (positive if flowing from outside into the component)";
          end 'heatPorts[9]_rec';
        public
          'heatPorts[9]_rec' 'heatPorts[9]';
        protected
          record 'heatPorts[10]_rec'
            Modelica.SIunits.Temperature T
                                          "Port temperature";
            Modelica.SIunits.HeatFlowRate Q_flow
                                                "Heat flow rate (positive if flowing from outside into the component)";
          end 'heatPorts[10]_rec';
        public
          'heatPorts[10]_rec' 'heatPorts[10]';
          Modelica.SIunits.Temperature 'Ts[1]'
                                              "Temperatures defined by fluid states";
          Modelica.SIunits.Temperature 'Ts[2]'
                                              "Temperatures defined by fluid states";
          Modelica.SIunits.Temperature 'Ts[3]'
                                              "Temperatures defined by fluid states";
          Modelica.SIunits.Temperature 'Ts[4]'
                                              "Temperatures defined by fluid states";
          Modelica.SIunits.Temperature 'Ts[5]'
                                              "Temperatures defined by fluid states";
          Modelica.SIunits.Temperature 'Ts[6]'
                                              "Temperatures defined by fluid states";
          Modelica.SIunits.Temperature 'Ts[7]'
                                              "Temperatures defined by fluid states";
          Modelica.SIunits.Temperature 'Ts[8]'
                                              "Temperatures defined by fluid states";
          Modelica.SIunits.Temperature 'Ts[9]'
                                              "Temperatures defined by fluid states";
          Modelica.SIunits.Temperature 'Ts[10]'
                                               "Temperatures defined by fluid states";
          Modelica.SIunits.Velocity 'vs[1]'
                                           "Mean velocities of fluid flow in segments";
          Modelica.SIunits.Velocity 'vs[2]'
                                           "Mean velocities of fluid flow in segments";
          Modelica.SIunits.Velocity 'vs[3]'
                                           "Mean velocities of fluid flow in segments";
          Modelica.SIunits.Velocity 'vs[4]'
                                           "Mean velocities of fluid flow in segments";
          Modelica.SIunits.Velocity 'vs[5]'
                                           "Mean velocities of fluid flow in segments";
          Modelica.SIunits.Velocity 'vs[6]'
                                           "Mean velocities of fluid flow in segments";
          Modelica.SIunits.Velocity 'vs[7]'
                                           "Mean velocities of fluid flow in segments";
          Modelica.SIunits.Velocity 'vs[8]'
                                           "Mean velocities of fluid flow in segments";
          Modelica.SIunits.Velocity 'vs[9]'
                                           "Mean velocities of fluid flow in segments";
          Modelica.SIunits.Velocity 'vs[10]'
                                            "Mean velocities of fluid flow in segments";
          parameter Real nParallel(fixed=false)
                                               "number of identical parallel flow devices";
          constant Modelica.SIunits.Length 'lengths[1]' = 0.5
                                                             "Lengths along flow path";
          constant Modelica.SIunits.Length 'lengths[2]' = 0.5
                                                             "Lengths along flow path";
          constant Modelica.SIunits.Length 'lengths[3]' = 0.5
                                                             "Lengths along flow path";
          constant Modelica.SIunits.Length 'lengths[4]' = 0.5
                                                             "Lengths along flow path";
          constant Modelica.SIunits.Length 'lengths[5]' = 0.5
                                                             "Lengths along flow path";
          constant Modelica.SIunits.Length 'lengths[6]' = 0.5
                                                             "Lengths along flow path";
          constant Modelica.SIunits.Length 'lengths[7]' = 0.5
                                                             "Lengths along flow path";
          constant Modelica.SIunits.Length 'lengths[8]' = 0.5
                                                             "Lengths along flow path";
          constant Modelica.SIunits.Length 'lengths[9]' = 0.5
                                                             "Lengths along flow path";
          constant Modelica.SIunits.Length 'lengths[10]' = 0.5
                                                              "Lengths along flow path";
          Modelica.SIunits.Length 'dimensions[1]'
                                                 "Characteristic dimensions for fluid flow (diameter for pipe flow)";
          Modelica.SIunits.Length 'dimensions[2]'
                                                 "Characteristic dimensions for fluid flow (diameter for pipe flow)";
          Modelica.SIunits.Length 'dimensions[3]'
                                                 "Characteristic dimensions for fluid flow (diameter for pipe flow)";
          Modelica.SIunits.Length 'dimensions[4]'
                                                 "Characteristic dimensions for fluid flow (diameter for pipe flow)";
          Modelica.SIunits.Length 'dimensions[5]'
                                                 "Characteristic dimensions for fluid flow (diameter for pipe flow)";
          Modelica.SIunits.Length 'dimensions[6]'
                                                 "Characteristic dimensions for fluid flow (diameter for pipe flow)";
          Modelica.SIunits.Length 'dimensions[7]'
                                                 "Characteristic dimensions for fluid flow (diameter for pipe flow)";
          Modelica.SIunits.Length 'dimensions[8]'
                                                 "Characteristic dimensions for fluid flow (diameter for pipe flow)";
          Modelica.SIunits.Length 'dimensions[9]'
                                                 "Characteristic dimensions for fluid flow (diameter for pipe flow)";
          Modelica.SIunits.Length 'dimensions[10]'
                                                  "Characteristic dimensions for fluid flow (diameter for pipe flow)";
          Modelica.SIunits.Height 'roughnesses[1]'
                                                  "Average heights of surface asperities";
          Modelica.SIunits.Height 'roughnesses[2]'
                                                  "Average heights of surface asperities";
          Modelica.SIunits.Height 'roughnesses[3]'
                                                  "Average heights of surface asperities";
          Modelica.SIunits.Height 'roughnesses[4]'
                                                  "Average heights of surface asperities";
          Modelica.SIunits.Height 'roughnesses[5]'
                                                  "Average heights of surface asperities";
          Modelica.SIunits.Height 'roughnesses[6]'
                                                  "Average heights of surface asperities";
          Modelica.SIunits.Height 'roughnesses[7]'
                                                  "Average heights of surface asperities";
          Modelica.SIunits.Height 'roughnesses[8]'
                                                  "Average heights of surface asperities";
          Modelica.SIunits.Height 'roughnesses[9]'
                                                  "Average heights of surface asperities";
          Modelica.SIunits.Height 'roughnesses[10]'
                                                   "Average heights of surface asperities";
        end heatTransfer_rec;
      public
        heatTransfer_rec heatTransfer;
        constant Real 'dxs[1]' = 0.1;
        constant Real 'dxs[2]' = 0.1;
        constant Real 'dxs[3]' = 0.1;
        constant Real 'dxs[4]' = 0.1;
        constant Real 'dxs[5]' = 0.1;
        constant Real 'dxs[6]' = 0.1;
        constant Real 'dxs[7]' = 0.1;
        constant Real 'dxs[8]' = 0.1;
        constant Real 'dxs[9]' = 0.1;
        constant Real 'dxs[10]' = 0.1;
      protected
        record 'mediums[1]_rec'
          Real p(unit = "Pa", displayUnit = "bar", nominal = 100000.0, quantity = "Pressure", min = 0.0)
                                                                                                        "Absolute pressure of medium";
          Real h(unit = "J/kg", quantity = "SpecificEnergy")
                                                            "Specific enthalpy of medium";
          constant Modelica.Media.Interfaces.Types.Density d = 995.586
                                                                      "Density of medium";
          Modelica.Media.Interfaces.Types.Temperature T
                                                       "Temperature of medium";
          Real T_der(unit = "K/s")
                                  "der(Temperature of medium)";
          constant Modelica.Media.Interfaces.Types.MassFraction 'X[1]' = 1.0
                                                                            "Mass fractions (= (component mass)/total mass  m_i/m)";
          Modelica.Media.Interfaces.Types.SpecificInternalEnergy u
                                                                  "Specific internal energy of medium";
          Real u_der(unit = "m2/s3")
                                    "der(Specific internal energy of medium)";
          constant Modelica.Media.Interfaces.Types.SpecificHeatCapacity R = 0
                                                                             "Gas constant (of mixture if applicable)";
          constant Modelica.Media.Interfaces.Types.MolarMass MM = 0.018015268
                                                                             "Molar mass (of mixture or single fluid)";
        protected
          record state_rec
            Modelica.Media.Interfaces.Types.AbsolutePressure p
                                                              "Absolute pressure of medium";
            Modelica.Media.Interfaces.Types.Temperature T
                                                         "Temperature of medium";
          end state_rec;
        public
          state_rec state;
          constant Boolean preferredMediumStates = true
                                                       "= true if StateSelect.prefer shall be used for the independent property variables of the medium";
          constant Boolean standardOrderComponents = true
                                                         "If true, and reducedX = true, the last element of X will be computed from the other ones";
          Modelica.SIunits.Conversions.NonSIunits.Temperature_degC T_degC
                                                                         "Temperature of medium in [degC]";
          Modelica.SIunits.Conversions.NonSIunits.Pressure_bar p_bar
                                                                    "Absolute pressure of medium in [bar]";
        end 'mediums[1]_rec';
      public
        'mediums[1]_rec' 'mediums[1]';
      protected
        record 'mediums[2]_rec'
          Real p(unit = "Pa", displayUnit = "bar", nominal = 100000.0, quantity = "Pressure", min = 0.0, max = 100000000.0)
                                                                                                                           "Absolute pressure of medium";
          Real h(unit = "J/kg", quantity = "SpecificEnergy")
                                                            "Specific enthalpy of medium";
          constant Modelica.Media.Interfaces.Types.Density d = 995.586
                                                                      "Density of medium";
          Modelica.Media.Interfaces.Types.Temperature T
                                                       "Temperature of medium";
          Real T_der(unit = "K/s")
                                  "der(Temperature of medium)";
          constant Modelica.Media.Interfaces.Types.MassFraction 'X[1]' = 1.0
                                                                            "Mass fractions (= (component mass)/total mass  m_i/m)";
          Modelica.Media.Interfaces.Types.SpecificInternalEnergy u
                                                                  "Specific internal energy of medium";
          Real u_der(unit = "m2/s3")
                                    "der(Specific internal energy of medium)";
          constant Modelica.Media.Interfaces.Types.SpecificHeatCapacity R = 0
                                                                             "Gas constant (of mixture if applicable)";
          constant Modelica.Media.Interfaces.Types.MolarMass MM = 0.018015268
                                                                             "Molar mass (of mixture or single fluid)";
        protected
          record state_rec
            Modelica.Media.Interfaces.Types.AbsolutePressure p
                                                              "Absolute pressure of medium";
            Modelica.Media.Interfaces.Types.Temperature T
                                                         "Temperature of medium";
          end state_rec;
        public
          state_rec state;
          constant Boolean preferredMediumStates = true
                                                       "= true if StateSelect.prefer shall be used for the independent property variables of the medium";
          constant Boolean standardOrderComponents = true
                                                         "If true, and reducedX = true, the last element of X will be computed from the other ones";
          Modelica.SIunits.Conversions.NonSIunits.Temperature_degC T_degC
                                                                         "Temperature of medium in [degC]";
          Modelica.SIunits.Conversions.NonSIunits.Pressure_bar p_bar
                                                                    "Absolute pressure of medium in [bar]";
        end 'mediums[2]_rec';
      public
        'mediums[2]_rec' 'mediums[2]';
      protected
        record 'mediums[3]_rec'
          Real p(unit = "Pa", displayUnit = "bar", nominal = 100000.0, quantity = "Pressure", min = 0.0, max = 100000000.0)
                                                                                                                           "Absolute pressure of medium";
          Real h(unit = "J/kg", quantity = "SpecificEnergy")
                                                            "Specific enthalpy of medium";
          constant Modelica.Media.Interfaces.Types.Density d = 995.586
                                                                      "Density of medium";
          parameter Modelica.Media.Interfaces.Types.Temperature _T_start = 293.15;
          Modelica.Media.Interfaces.Types.Temperature T(start = _T_start)
                                                                         "Temperature of medium";
          Real T_der(unit = "K/s")
                                  "der(Temperature of medium)";
          constant Modelica.Media.Interfaces.Types.MassFraction 'X[1]' = 1.0
                                                                            "Mass fractions (= (component mass)/total mass  m_i/m)";
          Modelica.Media.Interfaces.Types.SpecificInternalEnergy u
                                                                  "Specific internal energy of medium";
          Real u_der(unit = "m2/s3")
                                    "der(Specific internal energy of medium)";
          constant Modelica.Media.Interfaces.Types.SpecificHeatCapacity R = 0
                                                                             "Gas constant (of mixture if applicable)";
          constant Modelica.Media.Interfaces.Types.MolarMass MM = 0.018015268
                                                                             "Molar mass (of mixture or single fluid)";
        protected
          record state_rec
            Modelica.Media.Interfaces.Types.AbsolutePressure p
                                                              "Absolute pressure of medium";
            Modelica.Media.Interfaces.Types.Temperature T
                                                         "Temperature of medium";
          end state_rec;
        public
          state_rec state;
          constant Boolean preferredMediumStates = true
                                                       "= true if StateSelect.prefer shall be used for the independent property variables of the medium";
          constant Boolean standardOrderComponents = true
                                                         "If true, and reducedX = true, the last element of X will be computed from the other ones";
          Modelica.SIunits.Conversions.NonSIunits.Temperature_degC T_degC
                                                                         "Temperature of medium in [degC]";
          Modelica.SIunits.Conversions.NonSIunits.Pressure_bar p_bar
                                                                    "Absolute pressure of medium in [bar]";
        end 'mediums[3]_rec';
      public
        'mediums[3]_rec' 'mediums[3]' annotation(Dialog);
      protected
        record 'mediums[4]_rec'
          Real p(unit = "Pa", displayUnit = "bar", nominal = 100000.0, quantity = "Pressure", min = 0.0, max = 100000000.0)
                                                                                                                           "Absolute pressure of medium";
          Real h(unit = "J/kg", quantity = "SpecificEnergy")
                                                            "Specific enthalpy of medium";
          constant Modelica.Media.Interfaces.Types.Density d = 995.586
                                                                      "Density of medium";
          parameter Modelica.Media.Interfaces.Types.Temperature _T_start = 293.15;
          Modelica.Media.Interfaces.Types.Temperature T(start = _T_start)
                                                                         "Temperature of medium";
          Real T_der(unit = "K/s")
                                  "der(Temperature of medium)";
          constant Modelica.Media.Interfaces.Types.MassFraction 'X[1]' = 1.0
                                                                            "Mass fractions (= (component mass)/total mass  m_i/m)";
          Modelica.Media.Interfaces.Types.SpecificInternalEnergy u
                                                                  "Specific internal energy of medium";
          Real u_der(unit = "m2/s3")
                                    "der(Specific internal energy of medium)";
          constant Modelica.Media.Interfaces.Types.SpecificHeatCapacity R = 0
                                                                             "Gas constant (of mixture if applicable)";
          constant Modelica.Media.Interfaces.Types.MolarMass MM = 0.018015268
                                                                             "Molar mass (of mixture or single fluid)";
        protected
          record state_rec
            Modelica.Media.Interfaces.Types.AbsolutePressure p
                                                              "Absolute pressure of medium";
            Modelica.Media.Interfaces.Types.Temperature T
                                                         "Temperature of medium";
          end state_rec;
        public
          state_rec state;
          constant Boolean preferredMediumStates = true
                                                       "= true if StateSelect.prefer shall be used for the independent property variables of the medium";
          constant Boolean standardOrderComponents = true
                                                         "If true, and reducedX = true, the last element of X will be computed from the other ones";
          Modelica.SIunits.Conversions.NonSIunits.Temperature_degC T_degC
                                                                         "Temperature of medium in [degC]";
          Modelica.SIunits.Conversions.NonSIunits.Pressure_bar p_bar
                                                                    "Absolute pressure of medium in [bar]";
        end 'mediums[4]_rec';
      public
        'mediums[4]_rec' 'mediums[4]' annotation(Dialog);
      protected
        record 'mediums[5]_rec'
          Real p(unit = "Pa", displayUnit = "bar", nominal = 100000.0, quantity = "Pressure", min = 0.0, max = 100000000.0)
                                                                                                                           "Absolute pressure of medium";
          Real h(unit = "J/kg", quantity = "SpecificEnergy")
                                                            "Specific enthalpy of medium";
          constant Modelica.Media.Interfaces.Types.Density d = 995.586
                                                                      "Density of medium";
          parameter Modelica.Media.Interfaces.Types.Temperature _T_start = 293.15;
          Modelica.Media.Interfaces.Types.Temperature T(start = _T_start)
                                                                         "Temperature of medium";
          Real T_der(unit = "K/s")
                                  "der(Temperature of medium)";
          constant Modelica.Media.Interfaces.Types.MassFraction 'X[1]' = 1.0
                                                                            "Mass fractions (= (component mass)/total mass  m_i/m)";
          Modelica.Media.Interfaces.Types.SpecificInternalEnergy u
                                                                  "Specific internal energy of medium";
          Real u_der(unit = "m2/s3")
                                    "der(Specific internal energy of medium)";
          constant Modelica.Media.Interfaces.Types.SpecificHeatCapacity R = 0
                                                                             "Gas constant (of mixture if applicable)";
          constant Modelica.Media.Interfaces.Types.MolarMass MM = 0.018015268
                                                                             "Molar mass (of mixture or single fluid)";
        protected
          record state_rec
            Modelica.Media.Interfaces.Types.AbsolutePressure p
                                                              "Absolute pressure of medium";
            Modelica.Media.Interfaces.Types.Temperature T
                                                         "Temperature of medium";
          end state_rec;
        public
          state_rec state;
          constant Boolean preferredMediumStates = true
                                                       "= true if StateSelect.prefer shall be used for the independent property variables of the medium";
          constant Boolean standardOrderComponents = true
                                                         "If true, and reducedX = true, the last element of X will be computed from the other ones";
          Modelica.SIunits.Conversions.NonSIunits.Temperature_degC T_degC
                                                                         "Temperature of medium in [degC]";
          Modelica.SIunits.Conversions.NonSIunits.Pressure_bar p_bar
                                                                    "Absolute pressure of medium in [bar]";
        end 'mediums[5]_rec';
      public
        'mediums[5]_rec' 'mediums[5]' annotation(Dialog);
      protected
        record 'mediums[6]_rec'
          Real p(unit = "Pa", displayUnit = "bar", nominal = 100000.0, quantity = "Pressure", min = 0.0, max = 100000000.0)
                                                                                                                           "Absolute pressure of medium";
          Real h(unit = "J/kg", quantity = "SpecificEnergy")
                                                            "Specific enthalpy of medium";
          constant Modelica.Media.Interfaces.Types.Density d = 995.586
                                                                      "Density of medium";
          parameter Modelica.Media.Interfaces.Types.Temperature _T_start = 293.15;
          Modelica.Media.Interfaces.Types.Temperature T(start = _T_start)
                                                                         "Temperature of medium";
          Real T_der(unit = "K/s")
                                  "der(Temperature of medium)";
          constant Modelica.Media.Interfaces.Types.MassFraction 'X[1]' = 1.0
                                                                            "Mass fractions (= (component mass)/total mass  m_i/m)";
          Modelica.Media.Interfaces.Types.SpecificInternalEnergy u
                                                                  "Specific internal energy of medium";
          Real u_der(unit = "m2/s3")
                                    "der(Specific internal energy of medium)";
          constant Modelica.Media.Interfaces.Types.SpecificHeatCapacity R = 0
                                                                             "Gas constant (of mixture if applicable)";
          constant Modelica.Media.Interfaces.Types.MolarMass MM = 0.018015268
                                                                             "Molar mass (of mixture or single fluid)";
        protected
          record state_rec
            Modelica.Media.Interfaces.Types.AbsolutePressure p
                                                              "Absolute pressure of medium";
            Modelica.Media.Interfaces.Types.Temperature T
                                                         "Temperature of medium";
          end state_rec;
        public
          state_rec state;
          constant Boolean preferredMediumStates = true
                                                       "= true if StateSelect.prefer shall be used for the independent property variables of the medium";
          constant Boolean standardOrderComponents = true
                                                         "If true, and reducedX = true, the last element of X will be computed from the other ones";
          Modelica.SIunits.Conversions.NonSIunits.Temperature_degC T_degC
                                                                         "Temperature of medium in [degC]";
          Modelica.SIunits.Conversions.NonSIunits.Pressure_bar p_bar
                                                                    "Absolute pressure of medium in [bar]";
        end 'mediums[6]_rec';
      public
        'mediums[6]_rec' 'mediums[6]' annotation(Dialog);
      protected
        record 'mediums[7]_rec'
          Real p(unit = "Pa", displayUnit = "bar", nominal = 100000.0, quantity = "Pressure", min = 0.0, max = 100000000.0)
                                                                                                                           "Absolute pressure of medium";
          Real h(unit = "J/kg", quantity = "SpecificEnergy")
                                                            "Specific enthalpy of medium";
          constant Modelica.Media.Interfaces.Types.Density d = 995.586
                                                                      "Density of medium";
          parameter Modelica.Media.Interfaces.Types.Temperature _T_start = 293.15;
          Modelica.Media.Interfaces.Types.Temperature T(start = _T_start)
                                                                         "Temperature of medium";
          Real T_der(unit = "K/s")
                                  "der(Temperature of medium)";
          constant Modelica.Media.Interfaces.Types.MassFraction 'X[1]' = 1.0
                                                                            "Mass fractions (= (component mass)/total mass  m_i/m)";
          Modelica.Media.Interfaces.Types.SpecificInternalEnergy u
                                                                  "Specific internal energy of medium";
          Real u_der(unit = "m2/s3")
                                    "der(Specific internal energy of medium)";
          constant Modelica.Media.Interfaces.Types.SpecificHeatCapacity R = 0
                                                                             "Gas constant (of mixture if applicable)";
          constant Modelica.Media.Interfaces.Types.MolarMass MM = 0.018015268
                                                                             "Molar mass (of mixture or single fluid)";
        protected
          record state_rec
            Modelica.Media.Interfaces.Types.AbsolutePressure p
                                                              "Absolute pressure of medium";
            Modelica.Media.Interfaces.Types.Temperature T
                                                         "Temperature of medium";
          end state_rec;
        public
          state_rec state;
          constant Boolean preferredMediumStates = true
                                                       "= true if StateSelect.prefer shall be used for the independent property variables of the medium";
          constant Boolean standardOrderComponents = true
                                                         "If true, and reducedX = true, the last element of X will be computed from the other ones";
          Modelica.SIunits.Conversions.NonSIunits.Temperature_degC T_degC
                                                                         "Temperature of medium in [degC]";
          Modelica.SIunits.Conversions.NonSIunits.Pressure_bar p_bar
                                                                    "Absolute pressure of medium in [bar]";
        end 'mediums[7]_rec';
      public
        'mediums[7]_rec' 'mediums[7]' annotation(Dialog);
      protected
        record 'mediums[8]_rec'
          Real p(unit = "Pa", displayUnit = "bar", nominal = 100000.0, quantity = "Pressure", min = 0.0, max = 100000000.0)
                                                                                                                           "Absolute pressure of medium";
          Real h(unit = "J/kg", quantity = "SpecificEnergy")
                                                            "Specific enthalpy of medium";
          constant Modelica.Media.Interfaces.Types.Density d = 995.586
                                                                      "Density of medium";
          parameter Modelica.Media.Interfaces.Types.Temperature _T_start = 293.15;
          Modelica.Media.Interfaces.Types.Temperature T(start = _T_start)
                                                                         "Temperature of medium";
          Real T_der(unit = "K/s")
                                  "der(Temperature of medium)";
          constant Modelica.Media.Interfaces.Types.MassFraction 'X[1]' = 1.0
                                                                            "Mass fractions (= (component mass)/total mass  m_i/m)";
          Modelica.Media.Interfaces.Types.SpecificInternalEnergy u
                                                                  "Specific internal energy of medium";
          Real u_der(unit = "m2/s3")
                                    "der(Specific internal energy of medium)";
          constant Modelica.Media.Interfaces.Types.SpecificHeatCapacity R = 0
                                                                             "Gas constant (of mixture if applicable)";
          constant Modelica.Media.Interfaces.Types.MolarMass MM = 0.018015268
                                                                             "Molar mass (of mixture or single fluid)";
        protected
          record state_rec
            Modelica.Media.Interfaces.Types.AbsolutePressure p
                                                              "Absolute pressure of medium";
            Modelica.Media.Interfaces.Types.Temperature T
                                                         "Temperature of medium";
          end state_rec;
        public
          state_rec state;
          constant Boolean preferredMediumStates = true
                                                       "= true if StateSelect.prefer shall be used for the independent property variables of the medium";
          constant Boolean standardOrderComponents = true
                                                         "If true, and reducedX = true, the last element of X will be computed from the other ones";
          Modelica.SIunits.Conversions.NonSIunits.Temperature_degC T_degC
                                                                         "Temperature of medium in [degC]";
          Modelica.SIunits.Conversions.NonSIunits.Pressure_bar p_bar
                                                                    "Absolute pressure of medium in [bar]";
        end 'mediums[8]_rec';
      public
        'mediums[8]_rec' 'mediums[8]' annotation(Dialog);
      protected
        record 'mediums[9]_rec'
          Real p(unit = "Pa", displayUnit = "bar", nominal = 100000.0, quantity = "Pressure", min = 0.0, max = 100000000.0)
                                                                                                                           "Absolute pressure of medium";
          Real h(unit = "J/kg", quantity = "SpecificEnergy")
                                                            "Specific enthalpy of medium";
          constant Modelica.Media.Interfaces.Types.Density d = 995.586
                                                                      "Density of medium";
          parameter Modelica.Media.Interfaces.Types.Temperature _T_start = 293.15;
          Modelica.Media.Interfaces.Types.Temperature T(start = _T_start)
                                                                         "Temperature of medium";
          Real T_der(unit = "K/s")
                                  "der(Temperature of medium)";
          constant Modelica.Media.Interfaces.Types.MassFraction 'X[1]' = 1.0
                                                                            "Mass fractions (= (component mass)/total mass  m_i/m)";
          Modelica.Media.Interfaces.Types.SpecificInternalEnergy u
                                                                  "Specific internal energy of medium";
          Real u_der(unit = "m2/s3")
                                    "der(Specific internal energy of medium)";
          constant Modelica.Media.Interfaces.Types.SpecificHeatCapacity R = 0
                                                                             "Gas constant (of mixture if applicable)";
          constant Modelica.Media.Interfaces.Types.MolarMass MM = 0.018015268
                                                                             "Molar mass (of mixture or single fluid)";
        protected
          record state_rec
            Modelica.Media.Interfaces.Types.AbsolutePressure p
                                                              "Absolute pressure of medium";
            Modelica.Media.Interfaces.Types.Temperature T
                                                         "Temperature of medium";
          end state_rec;
        public
          state_rec state;
          constant Boolean preferredMediumStates = true
                                                       "= true if StateSelect.prefer shall be used for the independent property variables of the medium";
          constant Boolean standardOrderComponents = true
                                                         "If true, and reducedX = true, the last element of X will be computed from the other ones";
          Modelica.SIunits.Conversions.NonSIunits.Temperature_degC T_degC
                                                                         "Temperature of medium in [degC]";
          Modelica.SIunits.Conversions.NonSIunits.Pressure_bar p_bar
                                                                    "Absolute pressure of medium in [bar]";
        end 'mediums[9]_rec';
      public
        'mediums[9]_rec' 'mediums[9]' annotation(Dialog);
      protected
        record 'mediums[10]_rec'
          Real p(unit = "Pa", displayUnit = "bar", nominal = 100000.0, quantity = "Pressure", min = 0.0, max = 100000000.0)
                                                                                                                           "Absolute pressure of medium";
          Real h(unit = "J/kg", quantity = "SpecificEnergy")
                                                            "Specific enthalpy of medium";
          constant Modelica.Media.Interfaces.Types.Density d = 995.586
                                                                      "Density of medium";
          parameter Modelica.Media.Interfaces.Types.Temperature _T_start = 293.15;
          Modelica.Media.Interfaces.Types.Temperature T(start = _T_start)
                                                                         "Temperature of medium";
          Real T_der(unit = "K/s")
                                  "der(Temperature of medium)";
          constant Modelica.Media.Interfaces.Types.MassFraction 'X[1]' = 1.0
                                                                            "Mass fractions (= (component mass)/total mass  m_i/m)";
          Modelica.Media.Interfaces.Types.SpecificInternalEnergy u
                                                                  "Specific internal energy of medium";
          Real u_der(unit = "m2/s3")
                                    "der(Specific internal energy of medium)";
          constant Modelica.Media.Interfaces.Types.SpecificHeatCapacity R = 0
                                                                             "Gas constant (of mixture if applicable)";
          constant Modelica.Media.Interfaces.Types.MolarMass MM = 0.018015268
                                                                             "Molar mass (of mixture or single fluid)";
        protected
          record state_rec
            Modelica.Media.Interfaces.Types.AbsolutePressure p
                                                              "Absolute pressure of medium";
            Modelica.Media.Interfaces.Types.Temperature T
                                                         "Temperature of medium";
          end state_rec;
        public
          state_rec state;
          constant Boolean preferredMediumStates = true
                                                       "= true if StateSelect.prefer shall be used for the independent property variables of the medium";
          constant Boolean standardOrderComponents = true
                                                         "If true, and reducedX = true, the last element of X will be computed from the other ones";
          Modelica.SIunits.Conversions.NonSIunits.Temperature_degC T_degC
                                                                         "Temperature of medium in [degC]";
          Modelica.SIunits.Conversions.NonSIunits.Pressure_bar p_bar
                                                                    "Absolute pressure of medium in [bar]";
        end 'mediums[10]_rec';
      public
        'mediums[10]_rec' 'mediums[10]' annotation(Dialog);
      end 'pipe[1]_rec';
    public
      'pipe[1]_rec' 'pipe[1]' annotation(Dialog);
    protected
      record 'pipe[2]_rec'
        constant Boolean allowFlowReversal = false
                                                  "= true to allow flow reversal, false restricts to design direction (port_a -> port_b)";
      protected
        record port_a_rec
          Modelica.Media.Interfaces.PartialMedium.MassFlowRate m_flow(quantity = "MassFlowRate.SimpleLiquidWater", min = 0.0)
                                                                                                                             "Mass flow rate from the connection point into the component";
          Modelica.Media.Interfaces.Types.AbsolutePressure p
                                                            "Thermodynamic pressure in the connection point";
          Modelica.Media.Interfaces.Types.SpecificEnthalpy h_outflow
                                                                    "Specific thermodynamic enthalpy close to the connection point if m_flow < 0";
        end port_a_rec;
      public
        port_a_rec port_a;
      protected
        record port_b_rec
          Modelica.Media.Interfaces.Types.AbsolutePressure p
                                                            "Thermodynamic pressure in the connection point";
          Modelica.Media.Interfaces.Types.SpecificEnthalpy h_outflow
                                                                    "Specific thermodynamic enthalpy close to the connection point if m_flow < 0";
        end port_b_rec;
      public
        port_b_rec port_b;
        parameter Real nParallel(min = 1.0, fixed=false)
                                                        "Number of identical parallel pipes";
        constant Modelica.SIunits.Length length = 5.0
                                                     "Length";
        constant Boolean isCircular = true
                                          "= true if cross sectional area is circular";
        parameter Modelica.SIunits.Diameter diameter(fixed=false)
                                                                 "Diameter of circular pipe";
        parameter Modelica.SIunits.Area crossArea(fixed=false)
                                                              "Inner cross section area";
        parameter Modelica.SIunits.Length perimeter(fixed=false)
                                                                "Inner perimeter";
        parameter Modelica.SIunits.Height roughness(fixed=false)
                                                                "Average height of surface asperities (default: smooth steel pipe)";
        parameter Modelica.SIunits.Volume V(fixed=false)
                                                        "volume size";
        constant Modelica.SIunits.Length height_ab = 0
                                                      "Height(port_b) - Height(port_a)";
        constant Integer n = 10
                               "Number of discrete volumes";
        parameter Modelica.SIunits.Volume 'fluidVolumes[1]'(fixed=false)
                                                                        "Discretized volume, determine in inheriting class";
        parameter Modelica.SIunits.Volume 'fluidVolumes[2]'(fixed=false)
                                                                        "Discretized volume, determine in inheriting class";
        parameter Modelica.SIunits.Volume 'fluidVolumes[3]'(fixed=false)
                                                                        "Discretized volume, determine in inheriting class";
        parameter Modelica.SIunits.Volume 'fluidVolumes[4]'(fixed=false)
                                                                        "Discretized volume, determine in inheriting class";
        parameter Modelica.SIunits.Volume 'fluidVolumes[5]'(fixed=false)
                                                                        "Discretized volume, determine in inheriting class";
        parameter Modelica.SIunits.Volume 'fluidVolumes[6]'(fixed=false)
                                                                        "Discretized volume, determine in inheriting class";
        parameter Modelica.SIunits.Volume 'fluidVolumes[7]'(fixed=false)
                                                                        "Discretized volume, determine in inheriting class";
        parameter Modelica.SIunits.Volume 'fluidVolumes[8]'(fixed=false)
                                                                        "Discretized volume, determine in inheriting class";
        parameter Modelica.SIunits.Volume 'fluidVolumes[9]'(fixed=false)
                                                                        "Discretized volume, determine in inheriting class";
        parameter Modelica.SIunits.Volume 'fluidVolumes[10]'(fixed=false)
                                                                         "Discretized volume, determine in inheriting class";
        constant Modelica.Fluid.Types.Dynamics energyDynamics = Modelica.Fluid.Types.Dynamics.DynamicFreeInitial
                                                                                                                "Formulation of energy balances";
        constant Modelica.Fluid.Types.Dynamics massDynamics = Modelica.Fluid.Types.Dynamics.DynamicFreeInitial
                                                                                                              "Formulation of mass balances";
        constant Modelica.Fluid.Types.Dynamics substanceDynamics = Modelica.Fluid.Types.Dynamics.DynamicFreeInitial
                                                                                                                   "Formulation of substance balances";
        constant Modelica.Fluid.Types.Dynamics traceDynamics = Modelica.Fluid.Types.Dynamics.DynamicFreeInitial
                                                                                                               "Formulation of trace substance balances";
        parameter Modelica.Media.Interfaces.Types.AbsolutePressure p_a_start(fixed=false)
                                                                                         "Start value of pressure at port a";
        parameter Modelica.Media.Interfaces.Types.AbsolutePressure p_b_start(fixed=false)
                                                                                         "Start value of pressure at port b";
        parameter Modelica.Media.Interfaces.Types.AbsolutePressure 'ps_start[1]'(fixed=false)
                                                                                             "Start value of pressure";
        parameter Modelica.Media.Interfaces.Types.AbsolutePressure 'ps_start[2]'(fixed=false)
                                                                                             "Start value of pressure";
        parameter Modelica.Media.Interfaces.Types.AbsolutePressure 'ps_start[3]'(fixed=false)
                                                                                             "Start value of pressure";
        parameter Modelica.Media.Interfaces.Types.AbsolutePressure 'ps_start[4]'(fixed=false)
                                                                                             "Start value of pressure";
        parameter Modelica.Media.Interfaces.Types.AbsolutePressure 'ps_start[5]'(fixed=false)
                                                                                             "Start value of pressure";
        parameter Modelica.Media.Interfaces.Types.AbsolutePressure 'ps_start[6]'(fixed=false)
                                                                                             "Start value of pressure";
        parameter Modelica.Media.Interfaces.Types.AbsolutePressure 'ps_start[7]'(fixed=false)
                                                                                             "Start value of pressure";
        parameter Modelica.Media.Interfaces.Types.AbsolutePressure 'ps_start[8]'(fixed=false)
                                                                                             "Start value of pressure";
        parameter Modelica.Media.Interfaces.Types.AbsolutePressure 'ps_start[9]'(fixed=false)
                                                                                             "Start value of pressure";
        parameter Modelica.Media.Interfaces.Types.AbsolutePressure 'ps_start[10]'(fixed=false)
                                                                                              "Start value of pressure";
        constant Boolean use_T_start = true
                                           "Use T_start if true, otherwise h_start";
        constant Modelica.Media.Interfaces.Types.Temperature T_start = 293.15
                                                                             "Start value of temperature";
        constant Modelica.Media.Interfaces.Types.SpecificEnthalpy h_start = 83680.0
                                                                                   "Start value of specific enthalpy";
        parameter Modelica.Media.Interfaces.Types.MassFraction 'X_start[1]' = 1.0
                                                                                 "Start value of mass fractions m_i/m";
        Modelica.SIunits.Energy 'Us[1]'
                                       "Internal energy of fluid";
        Real 'Us[1]_der'(unit = "W")
                                    "der(Internal energy of fluid)";
        Modelica.SIunits.Energy 'Us[2]'
                                       "Internal energy of fluid";
        Real 'Us[2]_der'(unit = "W")
                                    "der(Internal energy of fluid)";
        Modelica.SIunits.Energy 'Us[3]'
                                       "Internal energy of fluid";
        Real 'Us[3]_der'(unit = "W")
                                    "der(Internal energy of fluid)";
        Modelica.SIunits.Energy 'Us[4]'
                                       "Internal energy of fluid";
        Real 'Us[4]_der'(unit = "W")
                                    "der(Internal energy of fluid)";
        Modelica.SIunits.Energy 'Us[5]'
                                       "Internal energy of fluid";
        Real 'Us[5]_der'(unit = "W")
                                    "der(Internal energy of fluid)";
        Modelica.SIunits.Energy 'Us[6]'
                                       "Internal energy of fluid";
        Real 'Us[6]_der'(unit = "W")
                                    "der(Internal energy of fluid)";
        Modelica.SIunits.Energy 'Us[7]'
                                       "Internal energy of fluid";
        Real 'Us[7]_der'(unit = "W")
                                    "der(Internal energy of fluid)";
        Modelica.SIunits.Energy 'Us[8]'
                                       "Internal energy of fluid";
        Real 'Us[8]_der'(unit = "W")
                                    "der(Internal energy of fluid)";
        Modelica.SIunits.Energy 'Us[9]'
                                       "Internal energy of fluid";
        Real 'Us[9]_der'(unit = "W")
                                    "der(Internal energy of fluid)";
        Modelica.SIunits.Energy 'Us[10]'
                                        "Internal energy of fluid";
        Real 'Us[10]_der'(unit = "W")
                                     "der(Internal energy of fluid)";
        parameter Modelica.SIunits.Mass 'ms[1]'(fixed=false)
                                                            "Fluid mass";
        constant Real 'ms[1]_der'(unit = "kg/s") = 0.0
                                                      "der(Fluid mass)";
        parameter Modelica.SIunits.Mass 'ms[2]'(fixed=false)
                                                            "Fluid mass";
        constant Real 'ms[2]_der'(unit = "kg/s") = 0.0
                                                      "der(Fluid mass)";
        parameter Modelica.SIunits.Mass 'ms[3]'(fixed=false)
                                                            "Fluid mass";
        constant Real 'ms[3]_der'(unit = "kg/s") = 0.0
                                                      "der(Fluid mass)";
        parameter Modelica.SIunits.Mass 'ms[4]'(fixed=false)
                                                            "Fluid mass";
        constant Real 'ms[4]_der'(unit = "kg/s") = 0.0
                                                      "der(Fluid mass)";
        parameter Modelica.SIunits.Mass 'ms[5]'(fixed=false)
                                                            "Fluid mass";
        constant Real 'ms[5]_der'(unit = "kg/s") = 0.0
                                                      "der(Fluid mass)";
        parameter Modelica.SIunits.Mass 'ms[6]'(fixed=false)
                                                            "Fluid mass";
        constant Real 'ms[6]_der'(unit = "kg/s") = 0.0
                                                      "der(Fluid mass)";
        parameter Modelica.SIunits.Mass 'ms[7]'(fixed=false)
                                                            "Fluid mass";
        constant Real 'ms[7]_der'(unit = "kg/s") = 0.0
                                                      "der(Fluid mass)";
        parameter Modelica.SIunits.Mass 'ms[8]'(fixed=false)
                                                            "Fluid mass";
        constant Real 'ms[8]_der'(unit = "kg/s") = 0.0
                                                      "der(Fluid mass)";
        parameter Modelica.SIunits.Mass 'ms[9]'(fixed=false)
                                                            "Fluid mass";
        constant Real 'ms[9]_der'(unit = "kg/s") = 0.0
                                                      "der(Fluid mass)";
        parameter Modelica.SIunits.Mass 'ms[10]'(fixed=false)
                                                             "Fluid mass";
        constant Real 'ms[10]_der'(unit = "kg/s") = 0.0
                                                       "der(Fluid mass)";
        constant Modelica.Media.Interfaces.PartialMedium.MassFlowRate 'mb_flows[1]'(quantity = "MassFlowRate.SimpleLiquidWater") = 0.0
                                                                                                                                      "Mass flow rate, source or sink";
        constant Modelica.Media.Interfaces.PartialMedium.MassFlowRate 'mb_flows[2]'(quantity = "MassFlowRate.SimpleLiquidWater") = 0.0
                                                                                                                                      "Mass flow rate, source or sink";
        constant Modelica.Media.Interfaces.PartialMedium.MassFlowRate 'mb_flows[3]'(quantity = "MassFlowRate.SimpleLiquidWater") = 0.0
                                                                                                                                      "Mass flow rate, source or sink";
        constant Modelica.Media.Interfaces.PartialMedium.MassFlowRate 'mb_flows[4]'(quantity = "MassFlowRate.SimpleLiquidWater") = 0.0
                                                                                                                                      "Mass flow rate, source or sink";
        constant Modelica.Media.Interfaces.PartialMedium.MassFlowRate 'mb_flows[5]'(quantity = "MassFlowRate.SimpleLiquidWater") = 0.0
                                                                                                                                      "Mass flow rate, source or sink";
        constant Modelica.Media.Interfaces.PartialMedium.MassFlowRate 'mb_flows[6]'(quantity = "MassFlowRate.SimpleLiquidWater") = 0.0
                                                                                                                                      "Mass flow rate, source or sink";
        constant Modelica.Media.Interfaces.PartialMedium.MassFlowRate 'mb_flows[7]'(quantity = "MassFlowRate.SimpleLiquidWater") = 0.0
                                                                                                                                      "Mass flow rate, source or sink";
        constant Modelica.Media.Interfaces.PartialMedium.MassFlowRate 'mb_flows[8]'(quantity = "MassFlowRate.SimpleLiquidWater") = 0.0
                                                                                                                                      "Mass flow rate, source or sink";
        constant Modelica.Media.Interfaces.PartialMedium.MassFlowRate 'mb_flows[9]'(quantity = "MassFlowRate.SimpleLiquidWater") = 0.0
                                                                                                                                      "Mass flow rate, source or sink";
        constant Modelica.Media.Interfaces.PartialMedium.MassFlowRate 'mb_flows[10]'(quantity = "MassFlowRate.SimpleLiquidWater") = 0.0
                                                                                                                                       "Mass flow rate, source or sink";
        Modelica.SIunits.EnthalpyFlowRate 'Hb_flows[1]'
                                                       "Enthalpy flow rate, source or sink";
        Modelica.SIunits.EnthalpyFlowRate 'Hb_flows[2]'
                                                       "Enthalpy flow rate, source or sink";
        Modelica.SIunits.EnthalpyFlowRate 'Hb_flows[3]'
                                                       "Enthalpy flow rate, source or sink";
        Modelica.SIunits.EnthalpyFlowRate 'Hb_flows[4]'
                                                       "Enthalpy flow rate, source or sink";
        Modelica.SIunits.EnthalpyFlowRate 'Hb_flows[5]'
                                                       "Enthalpy flow rate, source or sink";
        Modelica.SIunits.EnthalpyFlowRate 'Hb_flows[6]'
                                                       "Enthalpy flow rate, source or sink";
        Modelica.SIunits.EnthalpyFlowRate 'Hb_flows[7]'
                                                       "Enthalpy flow rate, source or sink";
        Modelica.SIunits.EnthalpyFlowRate 'Hb_flows[8]'
                                                       "Enthalpy flow rate, source or sink";
        Modelica.SIunits.EnthalpyFlowRate 'Hb_flows[9]'
                                                       "Enthalpy flow rate, source or sink";
        Modelica.SIunits.EnthalpyFlowRate 'Hb_flows[10]'
                                                        "Enthalpy flow rate, source or sink";
        Modelica.SIunits.HeatFlowRate 'Qb_flows[1]'
                                                   "Heat flow rate, source or sink";
        Modelica.SIunits.HeatFlowRate 'Qb_flows[2]'
                                                   "Heat flow rate, source or sink";
        Modelica.SIunits.HeatFlowRate 'Qb_flows[3]'
                                                   "Heat flow rate, source or sink";
        Modelica.SIunits.HeatFlowRate 'Qb_flows[4]'
                                                   "Heat flow rate, source or sink";
        Modelica.SIunits.HeatFlowRate 'Qb_flows[5]'
                                                   "Heat flow rate, source or sink";
        Modelica.SIunits.HeatFlowRate 'Qb_flows[6]'
                                                   "Heat flow rate, source or sink";
        Modelica.SIunits.HeatFlowRate 'Qb_flows[7]'
                                                   "Heat flow rate, source or sink";
        Modelica.SIunits.HeatFlowRate 'Qb_flows[8]'
                                                   "Heat flow rate, source or sink";
        Modelica.SIunits.HeatFlowRate 'Qb_flows[9]'
                                                   "Heat flow rate, source or sink";
        Modelica.SIunits.HeatFlowRate 'Qb_flows[10]'
                                                    "Heat flow rate, source or sink";
        Modelica.SIunits.Power 'Wb_flows[1]'
                                            "Mechanical power, p*der(V) etc.";
        Modelica.SIunits.Power 'Wb_flows[2]'
                                            "Mechanical power, p*der(V) etc.";
        Modelica.SIunits.Power 'Wb_flows[3]'
                                            "Mechanical power, p*der(V) etc.";
        Modelica.SIunits.Power 'Wb_flows[4]'
                                            "Mechanical power, p*der(V) etc.";
        Modelica.SIunits.Power 'Wb_flows[5]'
                                            "Mechanical power, p*der(V) etc.";
        Modelica.SIunits.Power 'Wb_flows[6]'
                                            "Mechanical power, p*der(V) etc.";
        Modelica.SIunits.Power 'Wb_flows[7]'
                                            "Mechanical power, p*der(V) etc.";
        Modelica.SIunits.Power 'Wb_flows[8]'
                                            "Mechanical power, p*der(V) etc.";
        Modelica.SIunits.Power 'Wb_flows[9]'
                                            "Mechanical power, p*der(V) etc.";
        Modelica.SIunits.Power 'Wb_flows[10]'
                                             "Mechanical power, p*der(V) etc.";
        constant Modelica.SIunits.Length 'lengths[1]' = 0.5
                                                           "lengths of flow segments";
        constant Modelica.SIunits.Length 'lengths[2]' = 0.5
                                                           "lengths of flow segments";
        constant Modelica.SIunits.Length 'lengths[3]' = 0.5
                                                           "lengths of flow segments";
        constant Modelica.SIunits.Length 'lengths[4]' = 0.5
                                                           "lengths of flow segments";
        constant Modelica.SIunits.Length 'lengths[5]' = 0.5
                                                           "lengths of flow segments";
        constant Modelica.SIunits.Length 'lengths[6]' = 0.5
                                                           "lengths of flow segments";
        constant Modelica.SIunits.Length 'lengths[7]' = 0.5
                                                           "lengths of flow segments";
        constant Modelica.SIunits.Length 'lengths[8]' = 0.5
                                                           "lengths of flow segments";
        constant Modelica.SIunits.Length 'lengths[9]' = 0.5
                                                           "lengths of flow segments";
        constant Modelica.SIunits.Length 'lengths[10]' = 0.5
                                                            "lengths of flow segments";
        parameter Modelica.SIunits.Area 'crossAreas[1]'(fixed=false)
                                                                    "cross flow areas of flow segments";
        parameter Modelica.SIunits.Area 'crossAreas[2]'(fixed=false)
                                                                    "cross flow areas of flow segments";
        parameter Modelica.SIunits.Area 'crossAreas[3]'(fixed=false)
                                                                    "cross flow areas of flow segments";
        parameter Modelica.SIunits.Area 'crossAreas[4]'(fixed=false)
                                                                    "cross flow areas of flow segments";
        parameter Modelica.SIunits.Area 'crossAreas[5]'(fixed=false)
                                                                    "cross flow areas of flow segments";
        parameter Modelica.SIunits.Area 'crossAreas[6]'(fixed=false)
                                                                    "cross flow areas of flow segments";
        parameter Modelica.SIunits.Area 'crossAreas[7]'(fixed=false)
                                                                    "cross flow areas of flow segments";
        parameter Modelica.SIunits.Area 'crossAreas[8]'(fixed=false)
                                                                    "cross flow areas of flow segments";
        parameter Modelica.SIunits.Area 'crossAreas[9]'(fixed=false)
                                                                    "cross flow areas of flow segments";
        parameter Modelica.SIunits.Area 'crossAreas[10]'(fixed=false)
                                                                     "cross flow areas of flow segments";
        parameter Modelica.SIunits.Length 'dimensions[1]'(fixed=false)
                                                                      "hydraulic diameters of flow segments";
        parameter Modelica.SIunits.Length 'dimensions[2]'(fixed=false)
                                                                      "hydraulic diameters of flow segments";
        parameter Modelica.SIunits.Length 'dimensions[3]'(fixed=false)
                                                                      "hydraulic diameters of flow segments";
        parameter Modelica.SIunits.Length 'dimensions[4]'(fixed=false)
                                                                      "hydraulic diameters of flow segments";
        parameter Modelica.SIunits.Length 'dimensions[5]'(fixed=false)
                                                                      "hydraulic diameters of flow segments";
        parameter Modelica.SIunits.Length 'dimensions[6]'(fixed=false)
                                                                      "hydraulic diameters of flow segments";
        parameter Modelica.SIunits.Length 'dimensions[7]'(fixed=false)
                                                                      "hydraulic diameters of flow segments";
        parameter Modelica.SIunits.Length 'dimensions[8]'(fixed=false)
                                                                      "hydraulic diameters of flow segments";
        parameter Modelica.SIunits.Length 'dimensions[9]'(fixed=false)
                                                                      "hydraulic diameters of flow segments";
        parameter Modelica.SIunits.Length 'dimensions[10]'(fixed=false)
                                                                       "hydraulic diameters of flow segments";
        parameter Modelica.SIunits.Height 'roughnesses[1]'(fixed=false)
                                                                       "Average heights of surface asperities";
        parameter Modelica.SIunits.Height 'roughnesses[2]'(fixed=false)
                                                                       "Average heights of surface asperities";
        parameter Modelica.SIunits.Height 'roughnesses[3]'(fixed=false)
                                                                       "Average heights of surface asperities";
        parameter Modelica.SIunits.Height 'roughnesses[4]'(fixed=false)
                                                                       "Average heights of surface asperities";
        parameter Modelica.SIunits.Height 'roughnesses[5]'(fixed=false)
                                                                       "Average heights of surface asperities";
        parameter Modelica.SIunits.Height 'roughnesses[6]'(fixed=false)
                                                                       "Average heights of surface asperities";
        parameter Modelica.SIunits.Height 'roughnesses[7]'(fixed=false)
                                                                       "Average heights of surface asperities";
        parameter Modelica.SIunits.Height 'roughnesses[8]'(fixed=false)
                                                                       "Average heights of surface asperities";
        parameter Modelica.SIunits.Height 'roughnesses[9]'(fixed=false)
                                                                       "Average heights of surface asperities";
        parameter Modelica.SIunits.Height 'roughnesses[10]'(fixed=false)
                                                                        "Average heights of surface asperities";
        constant Modelica.SIunits.Length 'dheights[1]' = 0.0
                                                            "Differences in heights of flow segments";
        constant Modelica.SIunits.Length 'dheights[2]' = 0.0
                                                            "Differences in heights of flow segments";
        constant Modelica.SIunits.Length 'dheights[3]' = 0.0
                                                            "Differences in heights of flow segments";
        constant Modelica.SIunits.Length 'dheights[4]' = 0.0
                                                            "Differences in heights of flow segments";
        constant Modelica.SIunits.Length 'dheights[5]' = 0.0
                                                            "Differences in heights of flow segments";
        constant Modelica.SIunits.Length 'dheights[6]' = 0.0
                                                            "Differences in heights of flow segments";
        constant Modelica.SIunits.Length 'dheights[7]' = 0.0
                                                            "Differences in heights of flow segments";
        constant Modelica.SIunits.Length 'dheights[8]' = 0.0
                                                            "Differences in heights of flow segments";
        constant Modelica.SIunits.Length 'dheights[9]' = 0.0
                                                            "Differences in heights of flow segments";
        constant Modelica.SIunits.Length 'dheights[10]' = 0.0
                                                             "Differences in heights of flow segments";
        constant Modelica.Fluid.Types.Dynamics momentumDynamics = Modelica.Fluid.Types.Dynamics.SteadyState
                                                                                                           "Formulation of momentum balances";
        constant Modelica.Media.Interfaces.PartialMedium.MassFlowRate m_flow_start(quantity = "MassFlowRate.SimpleLiquidWater") = 0.0
                                                                                                                                     "Start value for mass flow rate";
        constant Integer nNodes(min = 1) = 10
                                             "Number of discrete flow volumes";
        constant Modelica.Fluid.Types.ModelStructure modelStructure = Modelica.Fluid.Types.ModelStructure.av_vb
                                                                                                               "Determines whether flow or volume models are present at the ports";
        constant Boolean useLumpedPressure = false
                                                  "=true to lump pressure states together";
        constant Integer nFM = 9
                                "number of flow models in flowModel";
        constant Integer nFMDistributed = 9;
        constant Integer nFMLumped = 1;
        constant Integer iLumped = 6
                                    "Index of control volume with representative state if useLumpedPressure";
        constant Boolean useInnerPortProperties = false
                                                       "=true to take port properties for flow models from internal control volumes";
      protected
        record state_a_rec
          Modelica.Media.Interfaces.Types.AbsolutePressure p
                                                            "Absolute pressure of medium";
          Modelica.Media.Interfaces.Types.Temperature T
                                                       "Temperature of medium";
        end state_a_rec;
      public
        state_a_rec state_a;
      protected
        record state_b_rec
          Modelica.Media.Interfaces.Types.AbsolutePressure p
                                                            "Absolute pressure of medium";
          parameter Modelica.Media.Interfaces.Types.Temperature T(fixed=false)
                                                                              "Temperature of medium";
        end state_b_rec;
      public
        state_b_rec state_b;
      protected
        record 'statesFM[1]_rec'
          Modelica.Media.Interfaces.Types.AbsolutePressure p
                                                            "Absolute pressure of medium";
          Modelica.Media.Interfaces.Types.Temperature T
                                                       "Temperature of medium";
        end 'statesFM[1]_rec';
      public
        'statesFM[1]_rec' 'statesFM[1]';
      protected
        record 'statesFM[2]_rec'
          Modelica.Media.Interfaces.Types.AbsolutePressure p
                                                            "Absolute pressure of medium";
          Modelica.Media.Interfaces.Types.Temperature T
                                                       "Temperature of medium";
        end 'statesFM[2]_rec';
      public
        'statesFM[2]_rec' 'statesFM[2]';
      protected
        record 'statesFM[3]_rec'
          Modelica.Media.Interfaces.Types.AbsolutePressure p
                                                            "Absolute pressure of medium";
          Modelica.Media.Interfaces.Types.Temperature T
                                                       "Temperature of medium";
        end 'statesFM[3]_rec';
      public
        'statesFM[3]_rec' 'statesFM[3]';
      protected
        record 'statesFM[4]_rec'
          Modelica.Media.Interfaces.Types.AbsolutePressure p
                                                            "Absolute pressure of medium";
          Modelica.Media.Interfaces.Types.Temperature T
                                                       "Temperature of medium";
        end 'statesFM[4]_rec';
      public
        'statesFM[4]_rec' 'statesFM[4]';
      protected
        record 'statesFM[5]_rec'
          Modelica.Media.Interfaces.Types.AbsolutePressure p
                                                            "Absolute pressure of medium";
          Modelica.Media.Interfaces.Types.Temperature T
                                                       "Temperature of medium";
        end 'statesFM[5]_rec';
      public
        'statesFM[5]_rec' 'statesFM[5]';
      protected
        record 'statesFM[6]_rec'
          Modelica.Media.Interfaces.Types.AbsolutePressure p
                                                            "Absolute pressure of medium";
          Modelica.Media.Interfaces.Types.Temperature T
                                                       "Temperature of medium";
        end 'statesFM[6]_rec';
      public
        'statesFM[6]_rec' 'statesFM[6]';
      protected
        record 'statesFM[7]_rec'
          Modelica.Media.Interfaces.Types.AbsolutePressure p
                                                            "Absolute pressure of medium";
          Modelica.Media.Interfaces.Types.Temperature T
                                                       "Temperature of medium";
        end 'statesFM[7]_rec';
      public
        'statesFM[7]_rec' 'statesFM[7]';
      protected
        record 'statesFM[8]_rec'
          Modelica.Media.Interfaces.Types.AbsolutePressure p
                                                            "Absolute pressure of medium";
          Modelica.Media.Interfaces.Types.Temperature T
                                                       "Temperature of medium";
        end 'statesFM[8]_rec';
      public
        'statesFM[8]_rec' 'statesFM[8]';
      protected
        record 'statesFM[9]_rec'
          Modelica.Media.Interfaces.Types.AbsolutePressure p
                                                            "Absolute pressure of medium";
          Modelica.Media.Interfaces.Types.Temperature T
                                                       "Temperature of medium";
        end 'statesFM[9]_rec';
      public
        'statesFM[9]_rec' 'statesFM[9]';
      protected
        record 'statesFM[10]_rec'
          Modelica.Media.Interfaces.Types.AbsolutePressure p
                                                            "Absolute pressure of medium";
          Modelica.Media.Interfaces.Types.Temperature T
                                                       "Temperature of medium";
        end 'statesFM[10]_rec';
      public
        'statesFM[10]_rec' 'statesFM[10]';
      protected
        record flowModel_rec
          constant Boolean from_dp = true
                                         "= true, use m_flow = f(dp), otherwise dp = f(m_flow)";
          constant Integer n = 10
                                 "Number of discrete flow volumes";
        protected
          record 'states[1]_rec'
            Modelica.Media.Interfaces.Types.AbsolutePressure p
                                                              "Absolute pressure of medium";
            Modelica.Media.Interfaces.Types.Temperature T
                                                         "Temperature of medium";
          end 'states[1]_rec';
        public
          'states[1]_rec' 'states[1]';
        protected
          record 'states[2]_rec'
            Modelica.Media.Interfaces.Types.AbsolutePressure p
                                                              "Absolute pressure of medium";
            Modelica.Media.Interfaces.Types.Temperature T
                                                         "Temperature of medium";
          end 'states[2]_rec';
        public
          'states[2]_rec' 'states[2]';
        protected
          record 'states[3]_rec'
            Modelica.Media.Interfaces.Types.AbsolutePressure p
                                                              "Absolute pressure of medium";
            Modelica.Media.Interfaces.Types.Temperature T
                                                         "Temperature of medium";
          end 'states[3]_rec';
        public
          'states[3]_rec' 'states[3]';
        protected
          record 'states[4]_rec'
            Modelica.Media.Interfaces.Types.AbsolutePressure p
                                                              "Absolute pressure of medium";
            Modelica.Media.Interfaces.Types.Temperature T
                                                         "Temperature of medium";
          end 'states[4]_rec';
        public
          'states[4]_rec' 'states[4]';
        protected
          record 'states[5]_rec'
            Modelica.Media.Interfaces.Types.AbsolutePressure p
                                                              "Absolute pressure of medium";
            Modelica.Media.Interfaces.Types.Temperature T
                                                         "Temperature of medium";
          end 'states[5]_rec';
        public
          'states[5]_rec' 'states[5]';
        protected
          record 'states[6]_rec'
            Modelica.Media.Interfaces.Types.AbsolutePressure p
                                                              "Absolute pressure of medium";
            Modelica.Media.Interfaces.Types.Temperature T
                                                         "Temperature of medium";
          end 'states[6]_rec';
        public
          'states[6]_rec' 'states[6]';
        protected
          record 'states[7]_rec'
            Modelica.Media.Interfaces.Types.AbsolutePressure p
                                                              "Absolute pressure of medium";
            Modelica.Media.Interfaces.Types.Temperature T
                                                         "Temperature of medium";
          end 'states[7]_rec';
        public
          'states[7]_rec' 'states[7]';
        protected
          record 'states[8]_rec'
            Modelica.Media.Interfaces.Types.AbsolutePressure p
                                                              "Absolute pressure of medium";
            Modelica.Media.Interfaces.Types.Temperature T
                                                         "Temperature of medium";
          end 'states[8]_rec';
        public
          'states[8]_rec' 'states[8]';
        protected
          record 'states[9]_rec'
            Modelica.Media.Interfaces.Types.AbsolutePressure p
                                                              "Absolute pressure of medium";
            Modelica.Media.Interfaces.Types.Temperature T
                                                         "Temperature of medium";
          end 'states[9]_rec';
        public
          'states[9]_rec' 'states[9]';
        protected
          record 'states[10]_rec'
            Modelica.Media.Interfaces.Types.AbsolutePressure p
                                                              "Absolute pressure of medium";
            Modelica.Media.Interfaces.Types.Temperature T
                                                         "Temperature of medium";
          end 'states[10]_rec';
        public
          'states[10]_rec' 'states[10]';
          Modelica.SIunits.Velocity 'vs[1]'
                                           "Mean velocities of fluid flow";
          Modelica.SIunits.Velocity 'vs[2]'
                                           "Mean velocities of fluid flow";
          Modelica.SIunits.Velocity 'vs[3]'
                                           "Mean velocities of fluid flow";
          Modelica.SIunits.Velocity 'vs[4]'
                                           "Mean velocities of fluid flow";
          Modelica.SIunits.Velocity 'vs[5]'
                                           "Mean velocities of fluid flow";
          Modelica.SIunits.Velocity 'vs[6]'
                                           "Mean velocities of fluid flow";
          Modelica.SIunits.Velocity 'vs[7]'
                                           "Mean velocities of fluid flow";
          Modelica.SIunits.Velocity 'vs[8]'
                                           "Mean velocities of fluid flow";
          Modelica.SIunits.Velocity 'vs[9]'
                                           "Mean velocities of fluid flow";
          Modelica.SIunits.Velocity 'vs[10]'
                                            "Mean velocities of fluid flow";
          parameter Real nParallel(fixed=false)
                                               "number of identical parallel flow devices";
          Modelica.SIunits.Area 'crossAreas[1]'
                                               "Cross flow areas at segment boundaries";
          Modelica.SIunits.Area 'crossAreas[2]'
                                               "Cross flow areas at segment boundaries";
          Modelica.SIunits.Area 'crossAreas[3]'
                                               "Cross flow areas at segment boundaries";
          Modelica.SIunits.Area 'crossAreas[4]'
                                               "Cross flow areas at segment boundaries";
          Modelica.SIunits.Area 'crossAreas[5]'
                                               "Cross flow areas at segment boundaries";
          Modelica.SIunits.Area 'crossAreas[6]'
                                               "Cross flow areas at segment boundaries";
          Modelica.SIunits.Area 'crossAreas[7]'
                                               "Cross flow areas at segment boundaries";
          Modelica.SIunits.Area 'crossAreas[8]'
                                               "Cross flow areas at segment boundaries";
          Modelica.SIunits.Area 'crossAreas[9]'
                                               "Cross flow areas at segment boundaries";
          Modelica.SIunits.Area 'crossAreas[10]'
                                                "Cross flow areas at segment boundaries";
          Modelica.SIunits.Length 'dimensions[1]'
                                                 "Characteristic dimensions for fluid flow (diameters for pipe flow)";
          Modelica.SIunits.Length 'dimensions[2]'
                                                 "Characteristic dimensions for fluid flow (diameters for pipe flow)";
          Modelica.SIunits.Length 'dimensions[3]'
                                                 "Characteristic dimensions for fluid flow (diameters for pipe flow)";
          Modelica.SIunits.Length 'dimensions[4]'
                                                 "Characteristic dimensions for fluid flow (diameters for pipe flow)";
          Modelica.SIunits.Length 'dimensions[5]'
                                                 "Characteristic dimensions for fluid flow (diameters for pipe flow)";
          Modelica.SIunits.Length 'dimensions[6]'
                                                 "Characteristic dimensions for fluid flow (diameters for pipe flow)";
          Modelica.SIunits.Length 'dimensions[7]'
                                                 "Characteristic dimensions for fluid flow (diameters for pipe flow)";
          Modelica.SIunits.Length 'dimensions[8]'
                                                 "Characteristic dimensions for fluid flow (diameters for pipe flow)";
          Modelica.SIunits.Length 'dimensions[9]'
                                                 "Characteristic dimensions for fluid flow (diameters for pipe flow)";
          Modelica.SIunits.Length 'dimensions[10]'
                                                  "Characteristic dimensions for fluid flow (diameters for pipe flow)";
          Modelica.SIunits.Height 'roughnesses[1]'
                                                  "Average height of surface asperities";
          Modelica.SIunits.Height 'roughnesses[2]'
                                                  "Average height of surface asperities";
          Modelica.SIunits.Height 'roughnesses[3]'
                                                  "Average height of surface asperities";
          Modelica.SIunits.Height 'roughnesses[4]'
                                                  "Average height of surface asperities";
          Modelica.SIunits.Height 'roughnesses[5]'
                                                  "Average height of surface asperities";
          Modelica.SIunits.Height 'roughnesses[6]'
                                                  "Average height of surface asperities";
          Modelica.SIunits.Height 'roughnesses[7]'
                                                  "Average height of surface asperities";
          Modelica.SIunits.Height 'roughnesses[8]'
                                                  "Average height of surface asperities";
          Modelica.SIunits.Height 'roughnesses[9]'
                                                  "Average height of surface asperities";
          Modelica.SIunits.Height 'roughnesses[10]'
                                                   "Average height of surface asperities";
          constant Modelica.SIunits.Length 'dheights[1]' = 0.0
                                                              "Height(states[2:n]) - Height(states[1:n-1])";
          constant Modelica.SIunits.Length 'dheights[2]' = 0.0
                                                              "Height(states[2:n]) - Height(states[1:n-1])";
          constant Modelica.SIunits.Length 'dheights[3]' = 0.0
                                                              "Height(states[2:n]) - Height(states[1:n-1])";
          constant Modelica.SIunits.Length 'dheights[4]' = 0.0
                                                              "Height(states[2:n]) - Height(states[1:n-1])";
          constant Modelica.SIunits.Length 'dheights[5]' = 0.0
                                                              "Height(states[2:n]) - Height(states[1:n-1])";
          constant Modelica.SIunits.Length 'dheights[6]' = 0.0
                                                              "Height(states[2:n]) - Height(states[1:n-1])";
          constant Modelica.SIunits.Length 'dheights[7]' = 0.0
                                                              "Height(states[2:n]) - Height(states[1:n-1])";
          constant Modelica.SIunits.Length 'dheights[8]' = 0.0
                                                              "Height(states[2:n]) - Height(states[1:n-1])";
          constant Modelica.SIunits.Length 'dheights[9]' = 0.0
                                                              "Height(states[2:n]) - Height(states[1:n-1])";
          parameter Modelica.SIunits.Acceleration g(fixed=false)
                                                                "Constant gravity acceleration";
          constant Boolean allowFlowReversal = false
                                                    "= true to allow flow reversal, false restricts to design direction (states[1] -> states[n+1])";
          constant Modelica.Fluid.Types.Dynamics momentumDynamics = Modelica.Fluid.Types.Dynamics.SteadyState
                                                                                                             "Formulation of momentum balance";
          constant Modelica.Media.Interfaces.PartialMedium.MassFlowRate m_flow_start(quantity = "MassFlowRate.SimpleLiquidWater") = 0.0
                                                                                                                                       "Start value of mass flow rates";
          parameter Modelica.Media.Interfaces.Types.AbsolutePressure p_a_start(fixed=false)
                                                                                           "Start value for p[1] at design inflow";
          parameter Modelica.Media.Interfaces.Types.AbsolutePressure p_b_start(fixed=false)
                                                                                           "Start value for p[n+1] at design outflow";
          constant Integer m = 9
                                "Number of flow segments";
          constant Modelica.SIunits.Length 'pathLengths[1]' = 0.75
                                                                  "Lengths along flow path";
          constant Modelica.SIunits.Length 'pathLengths[2]' = 0.5
                                                                 "Lengths along flow path";
          constant Modelica.SIunits.Length 'pathLengths[3]' = 0.5
                                                                 "Lengths along flow path";
          constant Modelica.SIunits.Length 'pathLengths[4]' = 0.5
                                                                 "Lengths along flow path";
          constant Modelica.SIunits.Length 'pathLengths[5]' = 0.5
                                                                 "Lengths along flow path";
          constant Modelica.SIunits.Length 'pathLengths[6]' = 0.5
                                                                 "Lengths along flow path";
          constant Modelica.SIunits.Length 'pathLengths[7]' = 0.5
                                                                 "Lengths along flow path";
          constant Modelica.SIunits.Length 'pathLengths[8]' = 0.5
                                                                 "Lengths along flow path";
          constant Modelica.SIunits.Length 'pathLengths[9]' = 0.75
                                                                  "Lengths along flow path";
          Modelica.Media.Interfaces.PartialMedium.MassFlowRate 'm_flows[1]'(quantity = "MassFlowRate.SimpleLiquidWater", min = 0.0)
                                                                                                                                   "mass flow rates between states";
          Modelica.Media.Interfaces.PartialMedium.MassFlowRate 'm_flows[2]'(quantity = "MassFlowRate.SimpleLiquidWater", min = 0.0)
                                                                                                                                   "mass flow rates between states";
          Modelica.Media.Interfaces.PartialMedium.MassFlowRate 'm_flows[3]'(quantity = "MassFlowRate.SimpleLiquidWater", min = 0.0)
                                                                                                                                   "mass flow rates between states";
          Modelica.Media.Interfaces.PartialMedium.MassFlowRate 'm_flows[4]'(quantity = "MassFlowRate.SimpleLiquidWater", min = 0.0)
                                                                                                                                   "mass flow rates between states";
          Modelica.Media.Interfaces.PartialMedium.MassFlowRate 'm_flows[5]'(quantity = "MassFlowRate.SimpleLiquidWater", min = 0.0)
                                                                                                                                   "mass flow rates between states";
          Modelica.Media.Interfaces.PartialMedium.MassFlowRate 'm_flows[6]'(quantity = "MassFlowRate.SimpleLiquidWater", min = 0.0)
                                                                                                                                   "mass flow rates between states";
          Modelica.Media.Interfaces.PartialMedium.MassFlowRate 'm_flows[7]'(quantity = "MassFlowRate.SimpleLiquidWater", min = 0.0)
                                                                                                                                   "mass flow rates between states";
          Modelica.Media.Interfaces.PartialMedium.MassFlowRate 'm_flows[8]'(quantity = "MassFlowRate.SimpleLiquidWater", min = 0.0)
                                                                                                                                   "mass flow rates between states";
          Modelica.Media.Interfaces.PartialMedium.MassFlowRate 'm_flows[9]'(quantity = "MassFlowRate.SimpleLiquidWater", min = 0.0)
                                                                                                                                   "mass flow rates between states";
          Modelica.SIunits.Momentum 'Is[1]'
                                           "Momenta of flow segments";
          Modelica.SIunits.Momentum 'Is[2]'
                                           "Momenta of flow segments";
          Modelica.SIunits.Momentum 'Is[3]'
                                           "Momenta of flow segments";
          Modelica.SIunits.Momentum 'Is[4]'
                                           "Momenta of flow segments";
          Modelica.SIunits.Momentum 'Is[5]'
                                           "Momenta of flow segments";
          Modelica.SIunits.Momentum 'Is[6]'
                                           "Momenta of flow segments";
          Modelica.SIunits.Momentum 'Is[7]'
                                           "Momenta of flow segments";
          Modelica.SIunits.Momentum 'Is[8]'
                                           "Momenta of flow segments";
          Modelica.SIunits.Momentum 'Is[9]'
                                           "Momenta of flow segments";
          constant Modelica.SIunits.Force 'Ib_flows[1]' = 0.0
                                                             "Flow of momentum across boundaries";
          constant Modelica.SIunits.Force 'Ib_flows[2]' = 0.0
                                                             "Flow of momentum across boundaries";
          constant Modelica.SIunits.Force 'Ib_flows[3]' = 0.0
                                                             "Flow of momentum across boundaries";
          constant Modelica.SIunits.Force 'Ib_flows[4]' = 0.0
                                                             "Flow of momentum across boundaries";
          constant Modelica.SIunits.Force 'Ib_flows[5]' = 0.0
                                                             "Flow of momentum across boundaries";
          constant Modelica.SIunits.Force 'Ib_flows[6]' = 0.0
                                                             "Flow of momentum across boundaries";
          constant Modelica.SIunits.Force 'Ib_flows[7]' = 0.0
                                                             "Flow of momentum across boundaries";
          constant Modelica.SIunits.Force 'Ib_flows[8]' = 0.0
                                                             "Flow of momentum across boundaries";
          constant Modelica.SIunits.Force 'Ib_flows[9]' = 0.0
                                                             "Flow of momentum across boundaries";
          Modelica.SIunits.Force 'Fs_p[1]'
                                          "Pressure forces";
          Modelica.SIunits.Force 'Fs_p[2]'
                                          "Pressure forces";
          Modelica.SIunits.Force 'Fs_p[3]'
                                          "Pressure forces";
          Modelica.SIunits.Force 'Fs_p[4]'
                                          "Pressure forces";
          Modelica.SIunits.Force 'Fs_p[5]'
                                          "Pressure forces";
          Modelica.SIunits.Force 'Fs_p[6]'
                                          "Pressure forces";
          Modelica.SIunits.Force 'Fs_p[7]'
                                          "Pressure forces";
          Modelica.SIunits.Force 'Fs_p[8]'
                                          "Pressure forces";
          Modelica.SIunits.Force 'Fs_p[9]'
                                          "Pressure forces";
          Modelica.SIunits.Force 'Fs_fg[1]'
                                           "Friction and gravity forces";
          Modelica.SIunits.Force 'Fs_fg[2]'
                                           "Friction and gravity forces";
          Modelica.SIunits.Force 'Fs_fg[3]'
                                           "Friction and gravity forces";
          Modelica.SIunits.Force 'Fs_fg[4]'
                                           "Friction and gravity forces";
          Modelica.SIunits.Force 'Fs_fg[5]'
                                           "Friction and gravity forces";
          Modelica.SIunits.Force 'Fs_fg[6]'
                                           "Friction and gravity forces";
          Modelica.SIunits.Force 'Fs_fg[7]'
                                           "Friction and gravity forces";
          Modelica.SIunits.Force 'Fs_fg[8]'
                                           "Friction and gravity forces";
          Modelica.SIunits.Force 'Fs_fg[9]'
                                           "Friction and gravity forces";
          constant Boolean useUpstreamScheme = true
                                                   "= false to average upstream and downstream properties across flow segments";
          constant Boolean use_Ib_flows = false
                                               "= true to consider differences in flow of momentum through boundaries";
          constant Modelica.Media.Interfaces.Types.Density 'rhos[1]' = 995.586;
          constant Modelica.Media.Interfaces.Types.Density 'rhos[2]' = 995.586;
          constant Modelica.Media.Interfaces.Types.Density 'rhos[3]' = 995.586;
          constant Modelica.Media.Interfaces.Types.Density 'rhos[4]' = 995.586;
          constant Modelica.Media.Interfaces.Types.Density 'rhos[5]' = 995.586;
          constant Modelica.Media.Interfaces.Types.Density 'rhos[6]' = 995.586;
          constant Modelica.Media.Interfaces.Types.Density 'rhos[7]' = 995.586;
          constant Modelica.Media.Interfaces.Types.Density 'rhos[8]' = 995.586;
          constant Modelica.Media.Interfaces.Types.Density 'rhos[9]' = 995.586;
          constant Modelica.Media.Interfaces.Types.Density 'rhos[10]' = 995.586;
          constant Modelica.Media.Interfaces.Types.Density 'rhos_act[1]' = 995.586
                                                                                  "Actual density per segment";
          constant Modelica.Media.Interfaces.Types.Density 'rhos_act[2]' = 995.586
                                                                                  "Actual density per segment";
          constant Modelica.Media.Interfaces.Types.Density 'rhos_act[3]' = 995.586
                                                                                  "Actual density per segment";
          constant Modelica.Media.Interfaces.Types.Density 'rhos_act[4]' = 995.586
                                                                                  "Actual density per segment";
          constant Modelica.Media.Interfaces.Types.Density 'rhos_act[5]' = 995.586
                                                                                  "Actual density per segment";
          constant Modelica.Media.Interfaces.Types.Density 'rhos_act[6]' = 995.586
                                                                                  "Actual density per segment";
          constant Modelica.Media.Interfaces.Types.Density 'rhos_act[7]' = 995.586
                                                                                  "Actual density per segment";
          constant Modelica.Media.Interfaces.Types.Density 'rhos_act[8]' = 995.586
                                                                                  "Actual density per segment";
          constant Modelica.Media.Interfaces.Types.Density 'rhos_act[9]' = 995.586
                                                                                  "Actual density per segment";
          constant Modelica.Media.Interfaces.Types.DynamicViscosity 'mus[1]' = 0.001;
          constant Modelica.Media.Interfaces.Types.DynamicViscosity 'mus[2]' = 0.001;
          constant Modelica.Media.Interfaces.Types.DynamicViscosity 'mus[3]' = 0.001;
          constant Modelica.Media.Interfaces.Types.DynamicViscosity 'mus[4]' = 0.001;
          constant Modelica.Media.Interfaces.Types.DynamicViscosity 'mus[5]' = 0.001;
          constant Modelica.Media.Interfaces.Types.DynamicViscosity 'mus[6]' = 0.001;
          constant Modelica.Media.Interfaces.Types.DynamicViscosity 'mus[7]' = 0.001;
          constant Modelica.Media.Interfaces.Types.DynamicViscosity 'mus[8]' = 0.001;
          constant Modelica.Media.Interfaces.Types.DynamicViscosity 'mus[9]' = 0.001;
          constant Modelica.Media.Interfaces.Types.DynamicViscosity 'mus[10]' = 0.001;
          constant Modelica.Media.Interfaces.Types.DynamicViscosity 'mus_act[1]' = 0.001
                                                                                        "Actual viscosity per segment";
          constant Modelica.Media.Interfaces.Types.DynamicViscosity 'mus_act[2]' = 0.001
                                                                                        "Actual viscosity per segment";
          constant Modelica.Media.Interfaces.Types.DynamicViscosity 'mus_act[3]' = 0.001
                                                                                        "Actual viscosity per segment";
          constant Modelica.Media.Interfaces.Types.DynamicViscosity 'mus_act[4]' = 0.001
                                                                                        "Actual viscosity per segment";
          constant Modelica.Media.Interfaces.Types.DynamicViscosity 'mus_act[5]' = 0.001
                                                                                        "Actual viscosity per segment";
          constant Modelica.Media.Interfaces.Types.DynamicViscosity 'mus_act[6]' = 0.001
                                                                                        "Actual viscosity per segment";
          constant Modelica.Media.Interfaces.Types.DynamicViscosity 'mus_act[7]' = 0.001
                                                                                        "Actual viscosity per segment";
          constant Modelica.Media.Interfaces.Types.DynamicViscosity 'mus_act[8]' = 0.001
                                                                                        "Actual viscosity per segment";
          constant Modelica.Media.Interfaces.Types.DynamicViscosity 'mus_act[9]' = 0.001
                                                                                        "Actual viscosity per segment";
          Modelica.SIunits.Pressure 'dps_fg[1]'
                                               "pressure drop between states";
          Modelica.SIunits.Pressure 'dps_fg[2]'
                                               "pressure drop between states";
          Modelica.SIunits.Pressure 'dps_fg[3]'
                                               "pressure drop between states";
          Modelica.SIunits.Pressure 'dps_fg[4]'
                                               "pressure drop between states";
          Modelica.SIunits.Pressure 'dps_fg[5]'
                                               "pressure drop between states";
          Modelica.SIunits.Pressure 'dps_fg[6]'
                                               "pressure drop between states";
          Modelica.SIunits.Pressure 'dps_fg[7]'
                                               "pressure drop between states";
          Modelica.SIunits.Pressure 'dps_fg[8]'
                                               "pressure drop between states";
          Modelica.SIunits.Pressure 'dps_fg[9]'
                                               "pressure drop between states";
          constant Modelica.SIunits.ReynoldsNumber Re_turbulent = 4000
                                                                      "Start of turbulent regime, depending on type of flow device";
          constant Boolean show_Res = false
                                           "= true, if Reynolds numbers are included for plotting";
          constant Modelica.SIunits.Length 'pathLengths_internal[1]' = 0.75
                                                                           "pathLengths used internally; to be defined by extending class";
          constant Modelica.SIunits.Length 'pathLengths_internal[2]' = 0.5
                                                                          "pathLengths used internally; to be defined by extending class";
          constant Modelica.SIunits.Length 'pathLengths_internal[3]' = 0.5
                                                                          "pathLengths used internally; to be defined by extending class";
          constant Modelica.SIunits.Length 'pathLengths_internal[4]' = 0.5
                                                                          "pathLengths used internally; to be defined by extending class";
          constant Modelica.SIunits.Length 'pathLengths_internal[5]' = 0.5
                                                                          "pathLengths used internally; to be defined by extending class";
          constant Modelica.SIunits.Length 'pathLengths_internal[6]' = 0.5
                                                                          "pathLengths used internally; to be defined by extending class";
          constant Modelica.SIunits.Length 'pathLengths_internal[7]' = 0.5
                                                                          "pathLengths used internally; to be defined by extending class";
          constant Modelica.SIunits.Length 'pathLengths_internal[8]' = 0.5
                                                                          "pathLengths used internally; to be defined by extending class";
          constant Modelica.SIunits.Length 'pathLengths_internal[9]' = 0.75
                                                                           "pathLengths used internally; to be defined by extending class";
          constant Modelica.SIunits.ReynoldsNumber 'Res_turbulent_internal[1]' = 4000
                                                                                     "Re_turbulent used internally; to be defined by extending class";
          constant Modelica.SIunits.ReynoldsNumber 'Res_turbulent_internal[2]' = 4000
                                                                                     "Re_turbulent used internally; to be defined by extending class";
          constant Modelica.SIunits.ReynoldsNumber 'Res_turbulent_internal[3]' = 4000
                                                                                     "Re_turbulent used internally; to be defined by extending class";
          constant Modelica.SIunits.ReynoldsNumber 'Res_turbulent_internal[4]' = 4000
                                                                                     "Re_turbulent used internally; to be defined by extending class";
          constant Modelica.SIunits.ReynoldsNumber 'Res_turbulent_internal[5]' = 4000
                                                                                     "Re_turbulent used internally; to be defined by extending class";
          constant Modelica.SIunits.ReynoldsNumber 'Res_turbulent_internal[6]' = 4000
                                                                                     "Re_turbulent used internally; to be defined by extending class";
          constant Modelica.SIunits.ReynoldsNumber 'Res_turbulent_internal[7]' = 4000
                                                                                     "Re_turbulent used internally; to be defined by extending class";
          constant Modelica.SIunits.ReynoldsNumber 'Res_turbulent_internal[8]' = 4000
                                                                                     "Re_turbulent used internally; to be defined by extending class";
          constant Modelica.SIunits.ReynoldsNumber 'Res_turbulent_internal[9]' = 4000
                                                                                     "Re_turbulent used internally; to be defined by extending class";
          parameter Modelica.SIunits.AbsolutePressure dp_nominal(fixed=false)
                                                                             "Nominal pressure loss (only for nominal models)";
          parameter Modelica.SIunits.MassFlowRate m_flow_nominal(fixed=false)
                                                                             "Nominal mass flow rate";
          parameter Modelica.SIunits.MassFlowRate m_flow_small(fixed=false)
                                                                           "Within regularization if |m_flows| < m_flow_small (may be wider for large discontinuities in static head)";
        end flowModel_rec;
      public
        flowModel_rec flowModel;
        Modelica.Media.Interfaces.PartialMedium.MassFlowRate 'm_flows[1]'(quantity = "MassFlowRate.SimpleLiquidWater", min = 0.0)
                                                                                                                                 "Mass flow rates of fluid across segment boundaries";
        Modelica.Media.Interfaces.PartialMedium.MassFlowRate 'm_flows[2]'(quantity = "MassFlowRate.SimpleLiquidWater", min = 0.0)
                                                                                                                                 "Mass flow rates of fluid across segment boundaries";
        Modelica.Media.Interfaces.PartialMedium.MassFlowRate 'm_flows[3]'(quantity = "MassFlowRate.SimpleLiquidWater", min = 0.0)
                                                                                                                                 "Mass flow rates of fluid across segment boundaries";
        Modelica.Media.Interfaces.PartialMedium.MassFlowRate 'm_flows[4]'(quantity = "MassFlowRate.SimpleLiquidWater", min = 0.0)
                                                                                                                                 "Mass flow rates of fluid across segment boundaries";
        Modelica.Media.Interfaces.PartialMedium.MassFlowRate 'm_flows[5]'(quantity = "MassFlowRate.SimpleLiquidWater", min = 0.0)
                                                                                                                                 "Mass flow rates of fluid across segment boundaries";
        Modelica.Media.Interfaces.PartialMedium.MassFlowRate 'm_flows[6]'(quantity = "MassFlowRate.SimpleLiquidWater", min = 0.0)
                                                                                                                                 "Mass flow rates of fluid across segment boundaries";
        Modelica.Media.Interfaces.PartialMedium.MassFlowRate 'm_flows[7]'(quantity = "MassFlowRate.SimpleLiquidWater", min = 0.0)
                                                                                                                                 "Mass flow rates of fluid across segment boundaries";
        Modelica.Media.Interfaces.PartialMedium.MassFlowRate 'm_flows[8]'(quantity = "MassFlowRate.SimpleLiquidWater", min = 0.0)
                                                                                                                                 "Mass flow rates of fluid across segment boundaries";
        Modelica.Media.Interfaces.PartialMedium.MassFlowRate 'm_flows[9]'(quantity = "MassFlowRate.SimpleLiquidWater", min = 0.0)
                                                                                                                                 "Mass flow rates of fluid across segment boundaries";
        Modelica.Media.Interfaces.PartialMedium.MassFlowRate 'm_flows[10]'(quantity = "MassFlowRate.SimpleLiquidWater", min = 0.0)
                                                                                                                                  "Mass flow rates of fluid across segment boundaries";
        Modelica.Media.Interfaces.PartialMedium.MassFlowRate 'm_flows[11]'(quantity = "MassFlowRate.SimpleLiquidWater", min = 0.0)
                                                                                                                                  "Mass flow rates of fluid across segment boundaries";
        Modelica.Media.Interfaces.Types.EnthalpyFlowRate 'H_flows[1]'
                                                                     "Enthalpy flow rates of fluid across segment boundaries";
        Modelica.Media.Interfaces.Types.EnthalpyFlowRate 'H_flows[2]'
                                                                     "Enthalpy flow rates of fluid across segment boundaries";
        Modelica.Media.Interfaces.Types.EnthalpyFlowRate 'H_flows[3]'
                                                                     "Enthalpy flow rates of fluid across segment boundaries";
        Modelica.Media.Interfaces.Types.EnthalpyFlowRate 'H_flows[4]'
                                                                     "Enthalpy flow rates of fluid across segment boundaries";
        Modelica.Media.Interfaces.Types.EnthalpyFlowRate 'H_flows[5]'
                                                                     "Enthalpy flow rates of fluid across segment boundaries";
        Modelica.Media.Interfaces.Types.EnthalpyFlowRate 'H_flows[6]'
                                                                     "Enthalpy flow rates of fluid across segment boundaries";
        Modelica.Media.Interfaces.Types.EnthalpyFlowRate 'H_flows[7]'
                                                                     "Enthalpy flow rates of fluid across segment boundaries";
        Modelica.Media.Interfaces.Types.EnthalpyFlowRate 'H_flows[8]'
                                                                     "Enthalpy flow rates of fluid across segment boundaries";
        Modelica.Media.Interfaces.Types.EnthalpyFlowRate 'H_flows[9]'
                                                                     "Enthalpy flow rates of fluid across segment boundaries";
        Modelica.Media.Interfaces.Types.EnthalpyFlowRate 'H_flows[10]'
                                                                      "Enthalpy flow rates of fluid across segment boundaries";
        Modelica.Media.Interfaces.Types.EnthalpyFlowRate 'H_flows[11]'
                                                                      "Enthalpy flow rates of fluid across segment boundaries";
        Modelica.SIunits.Velocity 'vs[1]'
                                         "mean velocities in flow segments";
        Modelica.SIunits.Velocity 'vs[2]'
                                         "mean velocities in flow segments";
        Modelica.SIunits.Velocity 'vs[3]'
                                         "mean velocities in flow segments";
        Modelica.SIunits.Velocity 'vs[4]'
                                         "mean velocities in flow segments";
        Modelica.SIunits.Velocity 'vs[5]'
                                         "mean velocities in flow segments";
        Modelica.SIunits.Velocity 'vs[6]'
                                         "mean velocities in flow segments";
        Modelica.SIunits.Velocity 'vs[7]'
                                         "mean velocities in flow segments";
        Modelica.SIunits.Velocity 'vs[8]'
                                         "mean velocities in flow segments";
        Modelica.SIunits.Velocity 'vs[9]'
                                         "mean velocities in flow segments";
        Modelica.SIunits.Velocity 'vs[10]'
                                          "mean velocities in flow segments";
        constant Boolean use_HeatTransfer = true
                                                "= true to use the HeatTransfer model";
      protected
        record 'heatPorts[1]_rec'
          Modelica.SIunits.Temperature T
                                        "Port temperature";
          Modelica.SIunits.HeatFlowRate Q_flow
                                              "Heat flow rate (positive if flowing from outside into the component)";
        end 'heatPorts[1]_rec';
      public
        'heatPorts[1]_rec' 'heatPorts[1]';
      protected
        record 'heatPorts[2]_rec'
          Modelica.SIunits.Temperature T
                                        "Port temperature";
          Modelica.SIunits.HeatFlowRate Q_flow
                                              "Heat flow rate (positive if flowing from outside into the component)";
        end 'heatPorts[2]_rec';
      public
        'heatPorts[2]_rec' 'heatPorts[2]';
      protected
        record 'heatPorts[3]_rec'
          Modelica.SIunits.Temperature T
                                        "Port temperature";
          Modelica.SIunits.HeatFlowRate Q_flow
                                              "Heat flow rate (positive if flowing from outside into the component)";
        end 'heatPorts[3]_rec';
      public
        'heatPorts[3]_rec' 'heatPorts[3]';
      protected
        record 'heatPorts[4]_rec'
          Modelica.SIunits.Temperature T
                                        "Port temperature";
          Modelica.SIunits.HeatFlowRate Q_flow
                                              "Heat flow rate (positive if flowing from outside into the component)";
        end 'heatPorts[4]_rec';
      public
        'heatPorts[4]_rec' 'heatPorts[4]';
      protected
        record 'heatPorts[5]_rec'
          Modelica.SIunits.Temperature T
                                        "Port temperature";
          Modelica.SIunits.HeatFlowRate Q_flow
                                              "Heat flow rate (positive if flowing from outside into the component)";
        end 'heatPorts[5]_rec';
      public
        'heatPorts[5]_rec' 'heatPorts[5]';
      protected
        record 'heatPorts[6]_rec'
          Modelica.SIunits.Temperature T
                                        "Port temperature";
          Modelica.SIunits.HeatFlowRate Q_flow
                                              "Heat flow rate (positive if flowing from outside into the component)";
        end 'heatPorts[6]_rec';
      public
        'heatPorts[6]_rec' 'heatPorts[6]';
      protected
        record 'heatPorts[7]_rec'
          Modelica.SIunits.Temperature T
                                        "Port temperature";
          Modelica.SIunits.HeatFlowRate Q_flow
                                              "Heat flow rate (positive if flowing from outside into the component)";
        end 'heatPorts[7]_rec';
      public
        'heatPorts[7]_rec' 'heatPorts[7]';
      protected
        record 'heatPorts[8]_rec'
          Modelica.SIunits.Temperature T
                                        "Port temperature";
          Modelica.SIunits.HeatFlowRate Q_flow
                                              "Heat flow rate (positive if flowing from outside into the component)";
        end 'heatPorts[8]_rec';
      public
        'heatPorts[8]_rec' 'heatPorts[8]';
      protected
        record 'heatPorts[9]_rec'
          Modelica.SIunits.Temperature T
                                        "Port temperature";
          Modelica.SIunits.HeatFlowRate Q_flow
                                              "Heat flow rate (positive if flowing from outside into the component)";
        end 'heatPorts[9]_rec';
      public
        'heatPorts[9]_rec' 'heatPorts[9]';
      protected
        record 'heatPorts[10]_rec'
          Modelica.SIunits.Temperature T
                                        "Port temperature";
          Modelica.SIunits.HeatFlowRate Q_flow
                                              "Heat flow rate (positive if flowing from outside into the component)";
        end 'heatPorts[10]_rec';
      public
        'heatPorts[10]_rec' 'heatPorts[10]';
      protected
        record heatTransfer_rec
          constant Integer n = 10
                                 "Number of heat transfer segments";
        protected
          record 'states[1]_rec'
            Modelica.Media.Interfaces.Types.AbsolutePressure p
                                                              "Absolute pressure of medium";
            Modelica.Media.Interfaces.Types.Temperature T
                                                         "Temperature of medium";
          end 'states[1]_rec';
        public
          'states[1]_rec' 'states[1]';
        protected
          record 'states[2]_rec'
            Modelica.Media.Interfaces.Types.AbsolutePressure p
                                                              "Absolute pressure of medium";
            Modelica.Media.Interfaces.Types.Temperature T
                                                         "Temperature of medium";
          end 'states[2]_rec';
        public
          'states[2]_rec' 'states[2]';
        protected
          record 'states[3]_rec'
            Modelica.Media.Interfaces.Types.AbsolutePressure p
                                                              "Absolute pressure of medium";
            Modelica.Media.Interfaces.Types.Temperature T
                                                         "Temperature of medium";
          end 'states[3]_rec';
        public
          'states[3]_rec' 'states[3]';
        protected
          record 'states[4]_rec'
            Modelica.Media.Interfaces.Types.AbsolutePressure p
                                                              "Absolute pressure of medium";
            Modelica.Media.Interfaces.Types.Temperature T
                                                         "Temperature of medium";
          end 'states[4]_rec';
        public
          'states[4]_rec' 'states[4]';
        protected
          record 'states[5]_rec'
            Modelica.Media.Interfaces.Types.AbsolutePressure p
                                                              "Absolute pressure of medium";
            Modelica.Media.Interfaces.Types.Temperature T
                                                         "Temperature of medium";
          end 'states[5]_rec';
        public
          'states[5]_rec' 'states[5]';
        protected
          record 'states[6]_rec'
            Modelica.Media.Interfaces.Types.AbsolutePressure p
                                                              "Absolute pressure of medium";
            Modelica.Media.Interfaces.Types.Temperature T
                                                         "Temperature of medium";
          end 'states[6]_rec';
        public
          'states[6]_rec' 'states[6]';
        protected
          record 'states[7]_rec'
            Modelica.Media.Interfaces.Types.AbsolutePressure p
                                                              "Absolute pressure of medium";
            Modelica.Media.Interfaces.Types.Temperature T
                                                         "Temperature of medium";
          end 'states[7]_rec';
        public
          'states[7]_rec' 'states[7]';
        protected
          record 'states[8]_rec'
            Modelica.Media.Interfaces.Types.AbsolutePressure p
                                                              "Absolute pressure of medium";
            Modelica.Media.Interfaces.Types.Temperature T
                                                         "Temperature of medium";
          end 'states[8]_rec';
        public
          'states[8]_rec' 'states[8]';
        protected
          record 'states[9]_rec'
            Modelica.Media.Interfaces.Types.AbsolutePressure p
                                                              "Absolute pressure of medium";
            Modelica.Media.Interfaces.Types.Temperature T
                                                         "Temperature of medium";
          end 'states[9]_rec';
        public
          'states[9]_rec' 'states[9]';
        protected
          record 'states[10]_rec'
            Modelica.Media.Interfaces.Types.AbsolutePressure p
                                                              "Absolute pressure of medium";
            Modelica.Media.Interfaces.Types.Temperature T
                                                         "Temperature of medium";
          end 'states[10]_rec';
        public
          'states[10]_rec' 'states[10]';
          parameter Modelica.SIunits.Area 'surfaceAreas[1]'(fixed=false)
                                                                        "Heat transfer areas";
          parameter Modelica.SIunits.Area 'surfaceAreas[2]'(fixed=false)
                                                                        "Heat transfer areas";
          parameter Modelica.SIunits.Area 'surfaceAreas[3]'(fixed=false)
                                                                        "Heat transfer areas";
          parameter Modelica.SIunits.Area 'surfaceAreas[4]'(fixed=false)
                                                                        "Heat transfer areas";
          parameter Modelica.SIunits.Area 'surfaceAreas[5]'(fixed=false)
                                                                        "Heat transfer areas";
          parameter Modelica.SIunits.Area 'surfaceAreas[6]'(fixed=false)
                                                                        "Heat transfer areas";
          parameter Modelica.SIunits.Area 'surfaceAreas[7]'(fixed=false)
                                                                        "Heat transfer areas";
          parameter Modelica.SIunits.Area 'surfaceAreas[8]'(fixed=false)
                                                                        "Heat transfer areas";
          parameter Modelica.SIunits.Area 'surfaceAreas[9]'(fixed=false)
                                                                        "Heat transfer areas";
          parameter Modelica.SIunits.Area 'surfaceAreas[10]'(fixed=false)
                                                                         "Heat transfer areas";
          Modelica.SIunits.HeatFlowRate 'Q_flows[1]'
                                                    "Heat flow rates";
          Modelica.SIunits.HeatFlowRate 'Q_flows[2]'
                                                    "Heat flow rates";
          Modelica.SIunits.HeatFlowRate 'Q_flows[3]'
                                                    "Heat flow rates";
          Modelica.SIunits.HeatFlowRate 'Q_flows[4]'
                                                    "Heat flow rates";
          Modelica.SIunits.HeatFlowRate 'Q_flows[5]'
                                                    "Heat flow rates";
          Modelica.SIunits.HeatFlowRate 'Q_flows[6]'
                                                    "Heat flow rates";
          Modelica.SIunits.HeatFlowRate 'Q_flows[7]'
                                                    "Heat flow rates";
          Modelica.SIunits.HeatFlowRate 'Q_flows[8]'
                                                    "Heat flow rates";
          Modelica.SIunits.HeatFlowRate 'Q_flows[9]'
                                                    "Heat flow rates";
          Modelica.SIunits.HeatFlowRate 'Q_flows[10]'
                                                     "Heat flow rates";
          constant Boolean use_k = true
                                       "= true to use k value for thermal isolation";
          constant Modelica.SIunits.CoefficientOfHeatTransfer k = 0
                                                                   "Heat transfer coefficient to ambient";
          parameter Modelica.SIunits.Temperature T_ambient(fixed=false)
                                                                       "Ambient temperature";
        protected
          record 'heatPorts[1]_rec'
            Modelica.SIunits.Temperature T
                                          "Port temperature";
            Modelica.SIunits.HeatFlowRate Q_flow
                                                "Heat flow rate (positive if flowing from outside into the component)";
          end 'heatPorts[1]_rec';
        public
          'heatPorts[1]_rec' 'heatPorts[1]';
        protected
          record 'heatPorts[2]_rec'
            Modelica.SIunits.Temperature T
                                          "Port temperature";
            Modelica.SIunits.HeatFlowRate Q_flow
                                                "Heat flow rate (positive if flowing from outside into the component)";
          end 'heatPorts[2]_rec';
        public
          'heatPorts[2]_rec' 'heatPorts[2]';
        protected
          record 'heatPorts[3]_rec'
            Modelica.SIunits.Temperature T
                                          "Port temperature";
            Modelica.SIunits.HeatFlowRate Q_flow
                                                "Heat flow rate (positive if flowing from outside into the component)";
          end 'heatPorts[3]_rec';
        public
          'heatPorts[3]_rec' 'heatPorts[3]';
        protected
          record 'heatPorts[4]_rec'
            Modelica.SIunits.Temperature T
                                          "Port temperature";
            Modelica.SIunits.HeatFlowRate Q_flow
                                                "Heat flow rate (positive if flowing from outside into the component)";
          end 'heatPorts[4]_rec';
        public
          'heatPorts[4]_rec' 'heatPorts[4]';
        protected
          record 'heatPorts[5]_rec'
            Modelica.SIunits.Temperature T
                                          "Port temperature";
            Modelica.SIunits.HeatFlowRate Q_flow
                                                "Heat flow rate (positive if flowing from outside into the component)";
          end 'heatPorts[5]_rec';
        public
          'heatPorts[5]_rec' 'heatPorts[5]';
        protected
          record 'heatPorts[6]_rec'
            Modelica.SIunits.Temperature T
                                          "Port temperature";
            Modelica.SIunits.HeatFlowRate Q_flow
                                                "Heat flow rate (positive if flowing from outside into the component)";
          end 'heatPorts[6]_rec';
        public
          'heatPorts[6]_rec' 'heatPorts[6]';
        protected
          record 'heatPorts[7]_rec'
            Modelica.SIunits.Temperature T
                                          "Port temperature";
            Modelica.SIunits.HeatFlowRate Q_flow
                                                "Heat flow rate (positive if flowing from outside into the component)";
          end 'heatPorts[7]_rec';
        public
          'heatPorts[7]_rec' 'heatPorts[7]';
        protected
          record 'heatPorts[8]_rec'
            Modelica.SIunits.Temperature T
                                          "Port temperature";
            Modelica.SIunits.HeatFlowRate Q_flow
                                                "Heat flow rate (positive if flowing from outside into the component)";
          end 'heatPorts[8]_rec';
        public
          'heatPorts[8]_rec' 'heatPorts[8]';
        protected
          record 'heatPorts[9]_rec'
            Modelica.SIunits.Temperature T
                                          "Port temperature";
            Modelica.SIunits.HeatFlowRate Q_flow
                                                "Heat flow rate (positive if flowing from outside into the component)";
          end 'heatPorts[9]_rec';
        public
          'heatPorts[9]_rec' 'heatPorts[9]';
        protected
          record 'heatPorts[10]_rec'
            Modelica.SIunits.Temperature T
                                          "Port temperature";
            Modelica.SIunits.HeatFlowRate Q_flow
                                                "Heat flow rate (positive if flowing from outside into the component)";
          end 'heatPorts[10]_rec';
        public
          'heatPorts[10]_rec' 'heatPorts[10]';
          Modelica.SIunits.Temperature 'Ts[1]'
                                              "Temperatures defined by fluid states";
          Modelica.SIunits.Temperature 'Ts[2]'
                                              "Temperatures defined by fluid states";
          Modelica.SIunits.Temperature 'Ts[3]'
                                              "Temperatures defined by fluid states";
          Modelica.SIunits.Temperature 'Ts[4]'
                                              "Temperatures defined by fluid states";
          Modelica.SIunits.Temperature 'Ts[5]'
                                              "Temperatures defined by fluid states";
          Modelica.SIunits.Temperature 'Ts[6]'
                                              "Temperatures defined by fluid states";
          Modelica.SIunits.Temperature 'Ts[7]'
                                              "Temperatures defined by fluid states";
          Modelica.SIunits.Temperature 'Ts[8]'
                                              "Temperatures defined by fluid states";
          Modelica.SIunits.Temperature 'Ts[9]'
                                              "Temperatures defined by fluid states";
          Modelica.SIunits.Temperature 'Ts[10]'
                                               "Temperatures defined by fluid states";
          Modelica.SIunits.Velocity 'vs[1]'
                                           "Mean velocities of fluid flow in segments";
          Modelica.SIunits.Velocity 'vs[2]'
                                           "Mean velocities of fluid flow in segments";
          Modelica.SIunits.Velocity 'vs[3]'
                                           "Mean velocities of fluid flow in segments";
          Modelica.SIunits.Velocity 'vs[4]'
                                           "Mean velocities of fluid flow in segments";
          Modelica.SIunits.Velocity 'vs[5]'
                                           "Mean velocities of fluid flow in segments";
          Modelica.SIunits.Velocity 'vs[6]'
                                           "Mean velocities of fluid flow in segments";
          Modelica.SIunits.Velocity 'vs[7]'
                                           "Mean velocities of fluid flow in segments";
          Modelica.SIunits.Velocity 'vs[8]'
                                           "Mean velocities of fluid flow in segments";
          Modelica.SIunits.Velocity 'vs[9]'
                                           "Mean velocities of fluid flow in segments";
          Modelica.SIunits.Velocity 'vs[10]'
                                            "Mean velocities of fluid flow in segments";
          parameter Real nParallel(fixed=false)
                                               "number of identical parallel flow devices";
          constant Modelica.SIunits.Length 'lengths[1]' = 0.5
                                                             "Lengths along flow path";
          constant Modelica.SIunits.Length 'lengths[2]' = 0.5
                                                             "Lengths along flow path";
          constant Modelica.SIunits.Length 'lengths[3]' = 0.5
                                                             "Lengths along flow path";
          constant Modelica.SIunits.Length 'lengths[4]' = 0.5
                                                             "Lengths along flow path";
          constant Modelica.SIunits.Length 'lengths[5]' = 0.5
                                                             "Lengths along flow path";
          constant Modelica.SIunits.Length 'lengths[6]' = 0.5
                                                             "Lengths along flow path";
          constant Modelica.SIunits.Length 'lengths[7]' = 0.5
                                                             "Lengths along flow path";
          constant Modelica.SIunits.Length 'lengths[8]' = 0.5
                                                             "Lengths along flow path";
          constant Modelica.SIunits.Length 'lengths[9]' = 0.5
                                                             "Lengths along flow path";
          constant Modelica.SIunits.Length 'lengths[10]' = 0.5
                                                              "Lengths along flow path";
          Modelica.SIunits.Length 'dimensions[1]'
                                                 "Characteristic dimensions for fluid flow (diameter for pipe flow)";
          Modelica.SIunits.Length 'dimensions[2]'
                                                 "Characteristic dimensions for fluid flow (diameter for pipe flow)";
          Modelica.SIunits.Length 'dimensions[3]'
                                                 "Characteristic dimensions for fluid flow (diameter for pipe flow)";
          Modelica.SIunits.Length 'dimensions[4]'
                                                 "Characteristic dimensions for fluid flow (diameter for pipe flow)";
          Modelica.SIunits.Length 'dimensions[5]'
                                                 "Characteristic dimensions for fluid flow (diameter for pipe flow)";
          Modelica.SIunits.Length 'dimensions[6]'
                                                 "Characteristic dimensions for fluid flow (diameter for pipe flow)";
          Modelica.SIunits.Length 'dimensions[7]'
                                                 "Characteristic dimensions for fluid flow (diameter for pipe flow)";
          Modelica.SIunits.Length 'dimensions[8]'
                                                 "Characteristic dimensions for fluid flow (diameter for pipe flow)";
          Modelica.SIunits.Length 'dimensions[9]'
                                                 "Characteristic dimensions for fluid flow (diameter for pipe flow)";
          Modelica.SIunits.Length 'dimensions[10]'
                                                  "Characteristic dimensions for fluid flow (diameter for pipe flow)";
          Modelica.SIunits.Height 'roughnesses[1]'
                                                  "Average heights of surface asperities";
          Modelica.SIunits.Height 'roughnesses[2]'
                                                  "Average heights of surface asperities";
          Modelica.SIunits.Height 'roughnesses[3]'
                                                  "Average heights of surface asperities";
          Modelica.SIunits.Height 'roughnesses[4]'
                                                  "Average heights of surface asperities";
          Modelica.SIunits.Height 'roughnesses[5]'
                                                  "Average heights of surface asperities";
          Modelica.SIunits.Height 'roughnesses[6]'
                                                  "Average heights of surface asperities";
          Modelica.SIunits.Height 'roughnesses[7]'
                                                  "Average heights of surface asperities";
          Modelica.SIunits.Height 'roughnesses[8]'
                                                  "Average heights of surface asperities";
          Modelica.SIunits.Height 'roughnesses[9]'
                                                  "Average heights of surface asperities";
          Modelica.SIunits.Height 'roughnesses[10]'
                                                   "Average heights of surface asperities";
        end heatTransfer_rec;
      public
        heatTransfer_rec heatTransfer;
        constant Real 'dxs[1]' = 0.1;
        constant Real 'dxs[2]' = 0.1;
        constant Real 'dxs[3]' = 0.1;
        constant Real 'dxs[4]' = 0.1;
        constant Real 'dxs[5]' = 0.1;
        constant Real 'dxs[6]' = 0.1;
        constant Real 'dxs[7]' = 0.1;
        constant Real 'dxs[8]' = 0.1;
        constant Real 'dxs[9]' = 0.1;
        constant Real 'dxs[10]' = 0.1;
      protected
        record 'mediums[1]_rec'
          Real p(unit = "Pa", displayUnit = "bar", nominal = 100000.0, quantity = "Pressure", min = 0.0)
                                                                                                        "Absolute pressure of medium";
          Real h(unit = "J/kg", quantity = "SpecificEnergy")
                                                            "Specific enthalpy of medium";
          constant Modelica.Media.Interfaces.Types.Density d = 995.586
                                                                      "Density of medium";
          Modelica.Media.Interfaces.Types.Temperature T
                                                       "Temperature of medium";
          Real T_der(unit = "K/s")
                                  "der(Temperature of medium)";
          constant Modelica.Media.Interfaces.Types.MassFraction 'X[1]' = 1.0
                                                                            "Mass fractions (= (component mass)/total mass  m_i/m)";
          Modelica.Media.Interfaces.Types.SpecificInternalEnergy u
                                                                  "Specific internal energy of medium";
          Real u_der(unit = "m2/s3")
                                    "der(Specific internal energy of medium)";
          constant Modelica.Media.Interfaces.Types.SpecificHeatCapacity R = 0
                                                                             "Gas constant (of mixture if applicable)";
          constant Modelica.Media.Interfaces.Types.MolarMass MM = 0.018015268
                                                                             "Molar mass (of mixture or single fluid)";
        protected
          record state_rec
            Modelica.Media.Interfaces.Types.AbsolutePressure p
                                                              "Absolute pressure of medium";
            Modelica.Media.Interfaces.Types.Temperature T
                                                         "Temperature of medium";
          end state_rec;
        public
          state_rec state;
          constant Boolean preferredMediumStates = true
                                                       "= true if StateSelect.prefer shall be used for the independent property variables of the medium";
          constant Boolean standardOrderComponents = true
                                                         "If true, and reducedX = true, the last element of X will be computed from the other ones";
          Modelica.SIunits.Conversions.NonSIunits.Temperature_degC T_degC
                                                                         "Temperature of medium in [degC]";
          Modelica.SIunits.Conversions.NonSIunits.Pressure_bar p_bar
                                                                    "Absolute pressure of medium in [bar]";
        end 'mediums[1]_rec';
      public
        'mediums[1]_rec' 'mediums[1]';
      protected
        record 'mediums[2]_rec'
          Real p(unit = "Pa", displayUnit = "bar", nominal = 100000.0, quantity = "Pressure", min = 0.0, max = 100000000.0)
                                                                                                                           "Absolute pressure of medium";
          Real h(unit = "J/kg", quantity = "SpecificEnergy")
                                                            "Specific enthalpy of medium";
          constant Modelica.Media.Interfaces.Types.Density d = 995.586
                                                                      "Density of medium";
          Modelica.Media.Interfaces.Types.Temperature T
                                                       "Temperature of medium";
          Real T_der(unit = "K/s")
                                  "der(Temperature of medium)";
          constant Modelica.Media.Interfaces.Types.MassFraction 'X[1]' = 1.0
                                                                            "Mass fractions (= (component mass)/total mass  m_i/m)";
          Modelica.Media.Interfaces.Types.SpecificInternalEnergy u
                                                                  "Specific internal energy of medium";
          Real u_der(unit = "m2/s3")
                                    "der(Specific internal energy of medium)";
          constant Modelica.Media.Interfaces.Types.SpecificHeatCapacity R = 0
                                                                             "Gas constant (of mixture if applicable)";
          constant Modelica.Media.Interfaces.Types.MolarMass MM = 0.018015268
                                                                             "Molar mass (of mixture or single fluid)";
        protected
          record state_rec
            Modelica.Media.Interfaces.Types.AbsolutePressure p
                                                              "Absolute pressure of medium";
            Modelica.Media.Interfaces.Types.Temperature T
                                                         "Temperature of medium";
          end state_rec;
        public
          state_rec state;
          constant Boolean preferredMediumStates = true
                                                       "= true if StateSelect.prefer shall be used for the independent property variables of the medium";
          constant Boolean standardOrderComponents = true
                                                         "If true, and reducedX = true, the last element of X will be computed from the other ones";
          Modelica.SIunits.Conversions.NonSIunits.Temperature_degC T_degC
                                                                         "Temperature of medium in [degC]";
          Modelica.SIunits.Conversions.NonSIunits.Pressure_bar p_bar
                                                                    "Absolute pressure of medium in [bar]";
        end 'mediums[2]_rec';
      public
        'mediums[2]_rec' 'mediums[2]';
      protected
        record 'mediums[3]_rec'
          Real p(unit = "Pa", displayUnit = "bar", nominal = 100000.0, quantity = "Pressure", min = 0.0, max = 100000000.0)
                                                                                                                           "Absolute pressure of medium";
          Real h(unit = "J/kg", quantity = "SpecificEnergy")
                                                            "Specific enthalpy of medium";
          constant Modelica.Media.Interfaces.Types.Density d = 995.586
                                                                      "Density of medium";
          parameter Modelica.Media.Interfaces.Types.Temperature _T_start = 293.15;
          Modelica.Media.Interfaces.Types.Temperature T(start = _T_start)
                                                                         "Temperature of medium";
          Real T_der(unit = "K/s")
                                  "der(Temperature of medium)";
          constant Modelica.Media.Interfaces.Types.MassFraction 'X[1]' = 1.0
                                                                            "Mass fractions (= (component mass)/total mass  m_i/m)";
          Modelica.Media.Interfaces.Types.SpecificInternalEnergy u
                                                                  "Specific internal energy of medium";
          Real u_der(unit = "m2/s3")
                                    "der(Specific internal energy of medium)";
          constant Modelica.Media.Interfaces.Types.SpecificHeatCapacity R = 0
                                                                             "Gas constant (of mixture if applicable)";
          constant Modelica.Media.Interfaces.Types.MolarMass MM = 0.018015268
                                                                             "Molar mass (of mixture or single fluid)";
        protected
          record state_rec
            Modelica.Media.Interfaces.Types.AbsolutePressure p
                                                              "Absolute pressure of medium";
            Modelica.Media.Interfaces.Types.Temperature T
                                                         "Temperature of medium";
          end state_rec;
        public
          state_rec state;
          constant Boolean preferredMediumStates = true
                                                       "= true if StateSelect.prefer shall be used for the independent property variables of the medium";
          constant Boolean standardOrderComponents = true
                                                         "If true, and reducedX = true, the last element of X will be computed from the other ones";
          Modelica.SIunits.Conversions.NonSIunits.Temperature_degC T_degC
                                                                         "Temperature of medium in [degC]";
          Modelica.SIunits.Conversions.NonSIunits.Pressure_bar p_bar
                                                                    "Absolute pressure of medium in [bar]";
        end 'mediums[3]_rec';
      public
        'mediums[3]_rec' 'mediums[3]' annotation(Dialog);
      protected
        record 'mediums[4]_rec'
          Real p(unit = "Pa", displayUnit = "bar", nominal = 100000.0, quantity = "Pressure", min = 0.0, max = 100000000.0)
                                                                                                                           "Absolute pressure of medium";
          Real h(unit = "J/kg", quantity = "SpecificEnergy")
                                                            "Specific enthalpy of medium";
          constant Modelica.Media.Interfaces.Types.Density d = 995.586
                                                                      "Density of medium";
          parameter Modelica.Media.Interfaces.Types.Temperature _T_start = 293.15;
          Modelica.Media.Interfaces.Types.Temperature T(start = _T_start)
                                                                         "Temperature of medium";
          Real T_der(unit = "K/s")
                                  "der(Temperature of medium)";
          constant Modelica.Media.Interfaces.Types.MassFraction 'X[1]' = 1.0
                                                                            "Mass fractions (= (component mass)/total mass  m_i/m)";
          Modelica.Media.Interfaces.Types.SpecificInternalEnergy u
                                                                  "Specific internal energy of medium";
          Real u_der(unit = "m2/s3")
                                    "der(Specific internal energy of medium)";
          constant Modelica.Media.Interfaces.Types.SpecificHeatCapacity R = 0
                                                                             "Gas constant (of mixture if applicable)";
          constant Modelica.Media.Interfaces.Types.MolarMass MM = 0.018015268
                                                                             "Molar mass (of mixture or single fluid)";
        protected
          record state_rec
            Modelica.Media.Interfaces.Types.AbsolutePressure p
                                                              "Absolute pressure of medium";
            Modelica.Media.Interfaces.Types.Temperature T
                                                         "Temperature of medium";
          end state_rec;
        public
          state_rec state;
          constant Boolean preferredMediumStates = true
                                                       "= true if StateSelect.prefer shall be used for the independent property variables of the medium";
          constant Boolean standardOrderComponents = true
                                                         "If true, and reducedX = true, the last element of X will be computed from the other ones";
          Modelica.SIunits.Conversions.NonSIunits.Temperature_degC T_degC
                                                                         "Temperature of medium in [degC]";
          Modelica.SIunits.Conversions.NonSIunits.Pressure_bar p_bar
                                                                    "Absolute pressure of medium in [bar]";
        end 'mediums[4]_rec';
      public
        'mediums[4]_rec' 'mediums[4]' annotation(Dialog);
      protected
        record 'mediums[5]_rec'
          Real p(unit = "Pa", displayUnit = "bar", nominal = 100000.0, quantity = "Pressure", min = 0.0, max = 100000000.0)
                                                                                                                           "Absolute pressure of medium";
          Real h(unit = "J/kg", quantity = "SpecificEnergy")
                                                            "Specific enthalpy of medium";
          constant Modelica.Media.Interfaces.Types.Density d = 995.586
                                                                      "Density of medium";
          parameter Modelica.Media.Interfaces.Types.Temperature _T_start = 293.15;
          Modelica.Media.Interfaces.Types.Temperature T(start = _T_start)
                                                                         "Temperature of medium";
          Real T_der(unit = "K/s")
                                  "der(Temperature of medium)";
          constant Modelica.Media.Interfaces.Types.MassFraction 'X[1]' = 1.0
                                                                            "Mass fractions (= (component mass)/total mass  m_i/m)";
          Modelica.Media.Interfaces.Types.SpecificInternalEnergy u
                                                                  "Specific internal energy of medium";
          Real u_der(unit = "m2/s3")
                                    "der(Specific internal energy of medium)";
          constant Modelica.Media.Interfaces.Types.SpecificHeatCapacity R = 0
                                                                             "Gas constant (of mixture if applicable)";
          constant Modelica.Media.Interfaces.Types.MolarMass MM = 0.018015268
                                                                             "Molar mass (of mixture or single fluid)";
        protected
          record state_rec
            Modelica.Media.Interfaces.Types.AbsolutePressure p
                                                              "Absolute pressure of medium";
            Modelica.Media.Interfaces.Types.Temperature T
                                                         "Temperature of medium";
          end state_rec;
        public
          state_rec state;
          constant Boolean preferredMediumStates = true
                                                       "= true if StateSelect.prefer shall be used for the independent property variables of the medium";
          constant Boolean standardOrderComponents = true
                                                         "If true, and reducedX = true, the last element of X will be computed from the other ones";
          Modelica.SIunits.Conversions.NonSIunits.Temperature_degC T_degC
                                                                         "Temperature of medium in [degC]";
          Modelica.SIunits.Conversions.NonSIunits.Pressure_bar p_bar
                                                                    "Absolute pressure of medium in [bar]";
        end 'mediums[5]_rec';
      public
        'mediums[5]_rec' 'mediums[5]' annotation(Dialog);
      protected
        record 'mediums[6]_rec'
          Real p(unit = "Pa", displayUnit = "bar", nominal = 100000.0, quantity = "Pressure", min = 0.0, max = 100000000.0)
                                                                                                                           "Absolute pressure of medium";
          Real h(unit = "J/kg", quantity = "SpecificEnergy")
                                                            "Specific enthalpy of medium";
          constant Modelica.Media.Interfaces.Types.Density d = 995.586
                                                                      "Density of medium";
          parameter Modelica.Media.Interfaces.Types.Temperature _T_start = 293.15;
          Modelica.Media.Interfaces.Types.Temperature T(start = _T_start)
                                                                         "Temperature of medium";
          Real T_der(unit = "K/s")
                                  "der(Temperature of medium)";
          constant Modelica.Media.Interfaces.Types.MassFraction 'X[1]' = 1.0
                                                                            "Mass fractions (= (component mass)/total mass  m_i/m)";
          Modelica.Media.Interfaces.Types.SpecificInternalEnergy u
                                                                  "Specific internal energy of medium";
          Real u_der(unit = "m2/s3")
                                    "der(Specific internal energy of medium)";
          constant Modelica.Media.Interfaces.Types.SpecificHeatCapacity R = 0
                                                                             "Gas constant (of mixture if applicable)";
          constant Modelica.Media.Interfaces.Types.MolarMass MM = 0.018015268
                                                                             "Molar mass (of mixture or single fluid)";
        protected
          record state_rec
            Modelica.Media.Interfaces.Types.AbsolutePressure p
                                                              "Absolute pressure of medium";
            Modelica.Media.Interfaces.Types.Temperature T
                                                         "Temperature of medium";
          end state_rec;
        public
          state_rec state;
          constant Boolean preferredMediumStates = true
                                                       "= true if StateSelect.prefer shall be used for the independent property variables of the medium";
          constant Boolean standardOrderComponents = true
                                                         "If true, and reducedX = true, the last element of X will be computed from the other ones";
          Modelica.SIunits.Conversions.NonSIunits.Temperature_degC T_degC
                                                                         "Temperature of medium in [degC]";
          Modelica.SIunits.Conversions.NonSIunits.Pressure_bar p_bar
                                                                    "Absolute pressure of medium in [bar]";
        end 'mediums[6]_rec';
      public
        'mediums[6]_rec' 'mediums[6]' annotation(Dialog);
      protected
        record 'mediums[7]_rec'
          Real p(unit = "Pa", displayUnit = "bar", nominal = 100000.0, quantity = "Pressure", min = 0.0, max = 100000000.0)
                                                                                                                           "Absolute pressure of medium";
          Real h(unit = "J/kg", quantity = "SpecificEnergy")
                                                            "Specific enthalpy of medium";
          constant Modelica.Media.Interfaces.Types.Density d = 995.586
                                                                      "Density of medium";
          parameter Modelica.Media.Interfaces.Types.Temperature _T_start = 293.15;
          Modelica.Media.Interfaces.Types.Temperature T(start = _T_start)
                                                                         "Temperature of medium";
          Real T_der(unit = "K/s")
                                  "der(Temperature of medium)";
          constant Modelica.Media.Interfaces.Types.MassFraction 'X[1]' = 1.0
                                                                            "Mass fractions (= (component mass)/total mass  m_i/m)";
          Modelica.Media.Interfaces.Types.SpecificInternalEnergy u
                                                                  "Specific internal energy of medium";
          Real u_der(unit = "m2/s3")
                                    "der(Specific internal energy of medium)";
          constant Modelica.Media.Interfaces.Types.SpecificHeatCapacity R = 0
                                                                             "Gas constant (of mixture if applicable)";
          constant Modelica.Media.Interfaces.Types.MolarMass MM = 0.018015268
                                                                             "Molar mass (of mixture or single fluid)";
        protected
          record state_rec
            Modelica.Media.Interfaces.Types.AbsolutePressure p
                                                              "Absolute pressure of medium";
            Modelica.Media.Interfaces.Types.Temperature T
                                                         "Temperature of medium";
          end state_rec;
        public
          state_rec state;
          constant Boolean preferredMediumStates = true
                                                       "= true if StateSelect.prefer shall be used for the independent property variables of the medium";
          constant Boolean standardOrderComponents = true
                                                         "If true, and reducedX = true, the last element of X will be computed from the other ones";
          Modelica.SIunits.Conversions.NonSIunits.Temperature_degC T_degC
                                                                         "Temperature of medium in [degC]";
          Modelica.SIunits.Conversions.NonSIunits.Pressure_bar p_bar
                                                                    "Absolute pressure of medium in [bar]";
        end 'mediums[7]_rec';
      public
        'mediums[7]_rec' 'mediums[7]' annotation(Dialog);
      protected
        record 'mediums[8]_rec'
          Real p(unit = "Pa", displayUnit = "bar", nominal = 100000.0, quantity = "Pressure", min = 0.0, max = 100000000.0)
                                                                                                                           "Absolute pressure of medium";
          Real h(unit = "J/kg", quantity = "SpecificEnergy")
                                                            "Specific enthalpy of medium";
          constant Modelica.Media.Interfaces.Types.Density d = 995.586
                                                                      "Density of medium";
          parameter Modelica.Media.Interfaces.Types.Temperature _T_start = 293.15;
          Modelica.Media.Interfaces.Types.Temperature T(start = _T_start)
                                                                         "Temperature of medium";
          Real T_der(unit = "K/s")
                                  "der(Temperature of medium)";
          constant Modelica.Media.Interfaces.Types.MassFraction 'X[1]' = 1.0
                                                                            "Mass fractions (= (component mass)/total mass  m_i/m)";
          Modelica.Media.Interfaces.Types.SpecificInternalEnergy u
                                                                  "Specific internal energy of medium";
          Real u_der(unit = "m2/s3")
                                    "der(Specific internal energy of medium)";
          constant Modelica.Media.Interfaces.Types.SpecificHeatCapacity R = 0
                                                                             "Gas constant (of mixture if applicable)";
          constant Modelica.Media.Interfaces.Types.MolarMass MM = 0.018015268
                                                                             "Molar mass (of mixture or single fluid)";
        protected
          record state_rec
            Modelica.Media.Interfaces.Types.AbsolutePressure p
                                                              "Absolute pressure of medium";
            Modelica.Media.Interfaces.Types.Temperature T
                                                         "Temperature of medium";
          end state_rec;
        public
          state_rec state;
          constant Boolean preferredMediumStates = true
                                                       "= true if StateSelect.prefer shall be used for the independent property variables of the medium";
          constant Boolean standardOrderComponents = true
                                                         "If true, and reducedX = true, the last element of X will be computed from the other ones";
          Modelica.SIunits.Conversions.NonSIunits.Temperature_degC T_degC
                                                                         "Temperature of medium in [degC]";
          Modelica.SIunits.Conversions.NonSIunits.Pressure_bar p_bar
                                                                    "Absolute pressure of medium in [bar]";
        end 'mediums[8]_rec';
      public
        'mediums[8]_rec' 'mediums[8]' annotation(Dialog);
      protected
        record 'mediums[9]_rec'
          Real p(unit = "Pa", displayUnit = "bar", nominal = 100000.0, quantity = "Pressure", min = 0.0, max = 100000000.0)
                                                                                                                           "Absolute pressure of medium";
          Real h(unit = "J/kg", quantity = "SpecificEnergy")
                                                            "Specific enthalpy of medium";
          constant Modelica.Media.Interfaces.Types.Density d = 995.586
                                                                      "Density of medium";
          parameter Modelica.Media.Interfaces.Types.Temperature _T_start = 293.15;
          Modelica.Media.Interfaces.Types.Temperature T(start = _T_start)
                                                                         "Temperature of medium";
          Real T_der(unit = "K/s")
                                  "der(Temperature of medium)";
          constant Modelica.Media.Interfaces.Types.MassFraction 'X[1]' = 1.0
                                                                            "Mass fractions (= (component mass)/total mass  m_i/m)";
          Modelica.Media.Interfaces.Types.SpecificInternalEnergy u
                                                                  "Specific internal energy of medium";
          Real u_der(unit = "m2/s3")
                                    "der(Specific internal energy of medium)";
          constant Modelica.Media.Interfaces.Types.SpecificHeatCapacity R = 0
                                                                             "Gas constant (of mixture if applicable)";
          constant Modelica.Media.Interfaces.Types.MolarMass MM = 0.018015268
                                                                             "Molar mass (of mixture or single fluid)";
        protected
          record state_rec
            Modelica.Media.Interfaces.Types.AbsolutePressure p
                                                              "Absolute pressure of medium";
            Modelica.Media.Interfaces.Types.Temperature T
                                                         "Temperature of medium";
          end state_rec;
        public
          state_rec state;
          constant Boolean preferredMediumStates = true
                                                       "= true if StateSelect.prefer shall be used for the independent property variables of the medium";
          constant Boolean standardOrderComponents = true
                                                         "If true, and reducedX = true, the last element of X will be computed from the other ones";
          Modelica.SIunits.Conversions.NonSIunits.Temperature_degC T_degC
                                                                         "Temperature of medium in [degC]";
          Modelica.SIunits.Conversions.NonSIunits.Pressure_bar p_bar
                                                                    "Absolute pressure of medium in [bar]";
        end 'mediums[9]_rec';
      public
        'mediums[9]_rec' 'mediums[9]' annotation(Dialog);
      protected
        record 'mediums[10]_rec'
          Real p(unit = "Pa", displayUnit = "bar", nominal = 100000.0, quantity = "Pressure", min = 0.0, max = 100000000.0)
                                                                                                                           "Absolute pressure of medium";
          Real h(unit = "J/kg", quantity = "SpecificEnergy")
                                                            "Specific enthalpy of medium";
          constant Modelica.Media.Interfaces.Types.Density d = 995.586
                                                                      "Density of medium";
          parameter Modelica.Media.Interfaces.Types.Temperature _T_start = 293.15;
          Modelica.Media.Interfaces.Types.Temperature T(start = _T_start)
                                                                         "Temperature of medium";
          Real T_der(unit = "K/s")
                                  "der(Temperature of medium)";
          constant Modelica.Media.Interfaces.Types.MassFraction 'X[1]' = 1.0
                                                                            "Mass fractions (= (component mass)/total mass  m_i/m)";
          Modelica.Media.Interfaces.Types.SpecificInternalEnergy u
                                                                  "Specific internal energy of medium";
          Real u_der(unit = "m2/s3")
                                    "der(Specific internal energy of medium)";
          constant Modelica.Media.Interfaces.Types.SpecificHeatCapacity R = 0
                                                                             "Gas constant (of mixture if applicable)";
          constant Modelica.Media.Interfaces.Types.MolarMass MM = 0.018015268
                                                                             "Molar mass (of mixture or single fluid)";
        protected
          record state_rec
            Modelica.Media.Interfaces.Types.AbsolutePressure p
                                                              "Absolute pressure of medium";
            Modelica.Media.Interfaces.Types.Temperature T
                                                         "Temperature of medium";
          end state_rec;
        public
          state_rec state;
          constant Boolean preferredMediumStates = true
                                                       "= true if StateSelect.prefer shall be used for the independent property variables of the medium";
          constant Boolean standardOrderComponents = true
                                                         "If true, and reducedX = true, the last element of X will be computed from the other ones";
          Modelica.SIunits.Conversions.NonSIunits.Temperature_degC T_degC
                                                                         "Temperature of medium in [degC]";
          Modelica.SIunits.Conversions.NonSIunits.Pressure_bar p_bar
                                                                    "Absolute pressure of medium in [bar]";
        end 'mediums[10]_rec';
      public
        'mediums[10]_rec' 'mediums[10]' annotation(Dialog);
      end 'pipe[2]_rec';
    public
      'pipe[2]_rec' 'pipe[2]' annotation(Dialog);
    protected
      record volumeFlowRate_rec
        constant Boolean allowFlowReversal = false
                                                  "= true to allow flow reversal, false restricts to design direction (port_a -> port_b)";
      protected
        record port_a_rec
          Modelica.Media.Interfaces.PartialMedium.MassFlowRate m_flow(quantity = "MassFlowRate.SimpleLiquidWater", min = 0.0)
                                                                                                                             "Mass flow rate from the connection point into the component";
          Modelica.Media.Interfaces.Types.AbsolutePressure p
                                                            "Thermodynamic pressure in the connection point";
          Modelica.Media.Interfaces.Types.SpecificEnthalpy h_outflow
                                                                    "Specific thermodynamic enthalpy close to the connection point if m_flow < 0";
        end port_a_rec;
      public
        port_a_rec port_a;
      protected
        record port_b_rec
          Modelica.Media.Interfaces.Types.AbsolutePressure p
                                                            "Thermodynamic pressure in the connection point";
          Modelica.Media.Interfaces.Types.SpecificEnthalpy h_outflow
                                                                    "Specific thermodynamic enthalpy close to the connection point if m_flow < 0";
        end port_b_rec;
      public
        port_b_rec port_b;
        parameter Modelica.Media.Interfaces.Types.AbsolutePressure dp_start(min = -1E+060, fixed=false)
                                                                                                       "Guess value of dp = port_a.p - port_b.p";
        constant Modelica.Media.Interfaces.PartialMedium.MassFlowRate m_flow_start(quantity = "MassFlowRate.SimpleLiquidWater") = 0.0
                                                                                                                                     "Guess value of m_flow = port_a.m_flow";
        parameter Modelica.Media.Interfaces.PartialMedium.MassFlowRate m_flow_small(quantity = "MassFlowRate.SimpleLiquidWater", fixed=false)
                                                                                                                                             "Small mass flow rate for regularization of zero flow";
        constant Boolean show_T = true
                                      "= true, if temperatures at port_a and port_b are computed";
        constant Boolean show_V_flow = true
                                           "= true, if volume flow rate at inflowing port is computed";
        Modelica.Media.Interfaces.PartialMedium.MassFlowRate m_flow(quantity = "MassFlowRate.SimpleLiquidWater", min = 0.0)
                                                                                                                           "Mass flow rate in design flow direction";
        Modelica.SIunits.Pressure dp
                                    "Pressure difference between port_a and port_b (= port_a.p - port_b.p)";
        Modelica.SIunits.VolumeFlowRate V_flow
                                              "Volume flow rate at inflowing port (positive when flow from port_a to port_b)";
        Modelica.Media.Interfaces.Types.Temperature port_a_T
                                                            "Temperature close to port_a, if show_T = true";
        Modelica.Media.Interfaces.Types.Temperature port_b_T
                                                            "Temperature close to port_b, if show_T = true";
        parameter Real a(unit = "(Pa.s2)/m6", fixed=false)
                                                          "Coefficient for quadratic term";
        parameter Real b(unit = "(Pa.s)/m3", fixed=false)
                                                         "Coefficient for linear term";
      end volumeFlowRate_rec;
    public
      volumeFlowRate_rec volumeFlowRate;
    end heatExchangerThroughReal_rec;
  public
    heatExchangerThroughReal_rec heatExchangerThroughReal annotation(Dialog);
  protected
    record port_a_air_rec
      Modelica.Media.Interfaces.PartialMedium.MassFlowRate m_flow(quantity = "MassFlowRate.Moist air", min = 0.0)
                                                                                                                 "Mass flow rate from the connection point into the component";
      Modelica.Media.Interfaces.Types.AbsolutePressure p
                                                        "Thermodynamic pressure in the connection point";
      Modelica.Media.Interfaces.Types.SpecificEnthalpy h_outflow
                                                                "Specific thermodynamic enthalpy close to the connection point if m_flow < 0";
      Modelica.Media.Interfaces.Types.MassFraction 'Xi_outflow[1]'
                                                                  "Independent mixture mass fractions m_i/m close to the connection point if m_flow < 0";
    end port_a_air_rec;
  public
    port_a_air_rec port_a_air;
  protected
    record port_b_air_rec
      Modelica.Media.Interfaces.PartialMedium.MassFlowRate m_flow(quantity = "MassFlowRate.Moist air", max = 0.0)
                                                                                                                 "Mass flow rate from the connection point into the component";
      Modelica.Media.Interfaces.Types.AbsolutePressure p
                                                        "Thermodynamic pressure in the connection point";
      Modelica.Media.Interfaces.Types.SpecificEnthalpy h_outflow
                                                                "Specific thermodynamic enthalpy close to the connection point if m_flow < 0";
      Modelica.Media.Interfaces.Types.MassFraction 'Xi_outflow[1]'
                                                                  "Independent mixture mass fractions m_i/m close to the connection point if m_flow < 0";
    end port_b_air_rec;
  public
    port_b_air_rec port_b_air;
  protected
    record waterBasin_rec
      Modelica.SIunits.Height level
                                   "Level height of tank";
      Real level_der(unit = "m/s")
                                  "der(Level height of tank)";
      Modelica.SIunits.Volume V
                               "Actual tank volume";
      Real V_der(unit = "m3/s")
                               "der(Actual tank volume)";
      parameter Modelica.SIunits.Height height(fixed=false)
                                                           "Height of tank";
      parameter Modelica.SIunits.Area crossArea(fixed=false)
                                                            "Area of tank";
      parameter Modelica.Media.Interfaces.Types.AbsolutePressure p_ambient(fixed=false)
                                                                                       "Tank surface pressure";
      parameter Modelica.Media.Interfaces.Types.Temperature T_ambient(fixed=false)
                                                                                  "Tank surface Temperature";
      parameter Modelica.SIunits.Height level_start(fixed=false)
                                                                "Start value of tank level";
      Modelica.SIunits.Volume fluidVolume
                                         "Volume";
      constant Modelica.Fluid.Types.Dynamics energyDynamics = Modelica.Fluid.Types.Dynamics.DynamicFreeInitial
                                                                                                              "Formulation of energy balance";
      constant Modelica.Fluid.Types.Dynamics massDynamics = Modelica.Fluid.Types.Dynamics.DynamicFreeInitial
                                                                                                            "Formulation of mass balance";
      constant Modelica.Fluid.Types.Dynamics substanceDynamics = Modelica.Fluid.Types.Dynamics.DynamicFreeInitial
                                                                                                                 "Formulation of substance balance";
      constant Modelica.Fluid.Types.Dynamics traceDynamics = Modelica.Fluid.Types.Dynamics.DynamicFreeInitial
                                                                                                             "Formulation of trace substance balance";
      parameter Modelica.Media.Interfaces.Types.AbsolutePressure p_start(fixed=false)
                                                                                     "Start value of pressure";
      constant Boolean use_T_start = true
                                         "= true, use T_start, otherwise h_start";
      parameter Modelica.Media.Interfaces.Types.Temperature T_start(fixed=false)
                                                                                "Start value of temperature";
      parameter Modelica.Media.Interfaces.Types.SpecificEnthalpy h_start(fixed=false)
                                                                                     "Start value of specific enthalpy";
      parameter Modelica.Media.Interfaces.Types.MassFraction 'X_start[1]' = 1.0
                                                                               "Start value of mass fractions m_i/m";
    protected
      record medium_rec
        parameter Real p(unit = "Pa", displayUnit = "bar", nominal = 100000.0, quantity = "Pressure", min = 0.0, fixed=false)
                                                                                                                             "Absolute pressure of medium";
        Real h(unit = "J/kg", quantity = "SpecificEnergy")
                                                          "Specific enthalpy of medium";
        constant Modelica.Media.Interfaces.Types.Density d = 995.586
                                                                    "Density of medium";
        Modelica.Media.Interfaces.Types.Temperature T
                                                     "Temperature of medium";
        Real T_der(unit = "K/s")
                                "der(Temperature of medium)";
        constant Modelica.Media.Interfaces.Types.MassFraction 'X[1]' = 1.0
                                                                          "Mass fractions (= (component mass)/total mass  m_i/m)";
        Modelica.Media.Interfaces.Types.SpecificInternalEnergy u
                                                                "Specific internal energy of medium";
        Real u_der(unit = "m2/s3")
                                  "der(Specific internal energy of medium)";
        constant Modelica.Media.Interfaces.Types.SpecificHeatCapacity R = 0
                                                                           "Gas constant (of mixture if applicable)";
        constant Modelica.Media.Interfaces.Types.MolarMass MM = 0.018015268
                                                                           "Molar mass (of mixture or single fluid)";
      protected
        record state_rec
          Modelica.Media.Interfaces.Types.AbsolutePressure p
                                                            "Absolute pressure of medium";
          Modelica.Media.Interfaces.Types.Temperature T
                                                       "Temperature of medium";
        end state_rec;
      public
        state_rec state;
        constant Boolean preferredMediumStates = true
                                                     "= true if StateSelect.prefer shall be used for the independent property variables of the medium";
        constant Boolean standardOrderComponents = true
                                                       "If true, and reducedX = true, the last element of X will be computed from the other ones";
        Modelica.SIunits.Conversions.NonSIunits.Temperature_degC T_degC
                                                                       "Temperature of medium in [degC]";
        parameter Modelica.SIunits.Conversions.NonSIunits.Pressure_bar p_bar(fixed=false)
                                                                                         "Absolute pressure of medium in [bar]";
      end medium_rec;
    public
      medium_rec medium;
      Modelica.SIunits.Energy U
                               "Internal energy of fluid";
      Real U_der(unit = "W")
                            "der(Internal energy of fluid)";
      Modelica.SIunits.Mass m
                             "Mass of fluid";
      Real m_der(unit = "kg/s")
                               "der(Mass of fluid)";
      Modelica.SIunits.MassFlowRate mb_flow
                                           "Mass flows across boundaries";
      Modelica.SIunits.EnthalpyFlowRate Hb_flow
                                               "Enthalpy flow across boundaries or energy source/sink";
      Modelica.SIunits.HeatFlowRate Qb_flow
                                           "Heat flow across boundaries or energy source/sink";
      constant Modelica.SIunits.Power Wb_flow = 0
                                                 "Work flow across boundaries or source term";
      constant Integer nPorts = 3
                                 "Number of ports";
    protected
      record 'ports[1]_rec'
        Modelica.Media.Interfaces.PartialMedium.MassFlowRate m_flow(quantity = "MassFlowRate.SimpleLiquidWater")
                                                                                                                "Mass flow rate from the connection point into the component";
        Modelica.Media.Interfaces.Types.AbsolutePressure p
                                                          "Thermodynamic pressure in the connection point";
        Modelica.Media.Interfaces.Types.SpecificEnthalpy h_outflow
                                                                  "Specific thermodynamic enthalpy close to the connection point if m_flow < 0";
      end 'ports[1]_rec';
    public
      'ports[1]_rec' 'ports[1]';
    protected
      record 'ports[2]_rec'
        Modelica.Media.Interfaces.PartialMedium.MassFlowRate m_flow(quantity = "MassFlowRate.SimpleLiquidWater")
                                                                                                                "Mass flow rate from the connection point into the component";
        Modelica.Media.Interfaces.Types.AbsolutePressure p
                                                          "Thermodynamic pressure in the connection point";
        Modelica.Media.Interfaces.Types.SpecificEnthalpy h_outflow
                                                                  "Specific thermodynamic enthalpy close to the connection point if m_flow < 0";
      end 'ports[2]_rec';
    public
      'ports[2]_rec' 'ports[2]';
    protected
      record 'ports[3]_rec'
        Modelica.Media.Interfaces.PartialMedium.MassFlowRate m_flow(quantity = "MassFlowRate.SimpleLiquidWater")
                                                                                                                "Mass flow rate from the connection point into the component";
        Modelica.Media.Interfaces.Types.AbsolutePressure p
                                                          "Thermodynamic pressure in the connection point";
        Modelica.Media.Interfaces.Types.SpecificEnthalpy h_outflow
                                                                  "Specific thermodynamic enthalpy close to the connection point if m_flow < 0";
      end 'ports[3]_rec';
    public
      'ports[3]_rec' 'ports[3]';
      constant Boolean use_portsData = true
                                           "= false to neglect pressure loss and kinetic energy";
    protected
      record 'portsData[1]_rec'
        parameter Modelica.SIunits.Diameter diameter = 0.5
                                                          "Inner (hydraulic) diameter of inlet/outlet port";
        parameter Modelica.SIunits.Height height = 0.0
                                                      "Height over the bottom of the vessel";
        parameter Real zeta_out(min = 0.0) = 0.5
                                                "Hydraulic resistance out of vessel, default 0.5 for small diameter mounted flush with the wall";
        parameter Real zeta_in(min = 0.0) = 1.04
                                                "Hydraulic resistance into vessel, default 1.04 for small diameter mounted flush with the wall";
      end 'portsData[1]_rec';
    public
      'portsData[1]_rec' 'portsData[1]' annotation(Dialog);
    protected
      record 'portsData[2]_rec'
        parameter Modelica.SIunits.Diameter diameter = 0.5
                                                          "Inner (hydraulic) diameter of inlet/outlet port";
        parameter Modelica.SIunits.Height height = 0.0
                                                      "Height over the bottom of the vessel";
        parameter Real zeta_out(min = 0.0) = 0.5
                                                "Hydraulic resistance out of vessel, default 0.5 for small diameter mounted flush with the wall";
        parameter Real zeta_in(min = 0.0) = 1.04
                                                "Hydraulic resistance into vessel, default 1.04 for small diameter mounted flush with the wall";
      end 'portsData[2]_rec';
    public
      'portsData[2]_rec' 'portsData[2]' annotation(Dialog);
    protected
      record 'portsData[3]_rec'
        parameter Modelica.SIunits.Diameter diameter(fixed=false)
                                                                 "Inner (hydraulic) diameter of inlet/outlet port";
        parameter Modelica.SIunits.Height height(fixed=false)
                                                             "Height over the bottom of the vessel";
        parameter Real zeta_out(min = 0.0) = 0.5
                                                "Hydraulic resistance out of vessel, default 0.5 for small diameter mounted flush with the wall";
        parameter Real zeta_in(min = 0.0) = 1.04
                                                "Hydraulic resistance into vessel, default 1.04 for small diameter mounted flush with the wall";
      end 'portsData[3]_rec';
    public
      'portsData[3]_rec' 'portsData[3]' annotation(Dialog);
      parameter Modelica.Media.Interfaces.PartialMedium.MassFlowRate m_flow_nominal(quantity = "MassFlowRate.SimpleLiquidWater", fixed=false)
                                                                                                                                             "Nominal value for mass flow rates in ports";
      parameter Modelica.SIunits.MassFlowRate m_flow_small(min = 0.0, fixed=false)
                                                                                  "Regularization range at zero mass flow rate";
      constant Boolean use_Re = false
                                     "= true, if turbulent region is defined by Re, otherwise by m_flow_small";
      Modelica.Media.Interfaces.Types.EnthalpyFlowRate 'ports_H_flow[1]';
      Modelica.Media.Interfaces.Types.EnthalpyFlowRate 'ports_H_flow[2]';
      Modelica.Media.Interfaces.Types.EnthalpyFlowRate 'ports_H_flow[3]';
      constant Boolean use_HeatTransfer = true
                                              "= true to use the HeatTransfer model";
    protected
      record heatTransfer_rec
        constant Integer n = 1
                              "Number of heat transfer segments";
      protected
        record 'states[1]_rec'
          Modelica.Media.Interfaces.Types.AbsolutePressure p
                                                            "Absolute pressure of medium";
          Modelica.Media.Interfaces.Types.Temperature T
                                                       "Temperature of medium";
        end 'states[1]_rec';
      public
        'states[1]_rec' 'states[1]';
        Modelica.SIunits.Area 'surfaceAreas[1]'
                                               "Heat transfer areas";
        Modelica.SIunits.HeatFlowRate 'Q_flows[1]'
                                                  "Heat flow rates";
        constant Boolean use_k = true
                                     "= true to use k value for thermal isolation";
        constant Modelica.SIunits.CoefficientOfHeatTransfer k = 0
                                                                 "Heat transfer coefficient to ambient";
        parameter Modelica.SIunits.Temperature T_ambient(fixed=false)
                                                                     "Ambient temperature";
      protected
        record 'heatPorts[1]_rec'
          Modelica.SIunits.Temperature T
                                        "Port temperature";
          Modelica.SIunits.HeatFlowRate Q_flow
                                              "Heat flow rate (positive if flowing from outside into the component)";
        end 'heatPorts[1]_rec';
      public
        'heatPorts[1]_rec' 'heatPorts[1]';
        Modelica.SIunits.Temperature 'Ts[1]'
                                            "Temperatures defined by fluid states";
      end heatTransfer_rec;
    public
      heatTransfer_rec heatTransfer;
    protected
      record heatPort_rec
        Modelica.SIunits.Temperature T
                                      "Port temperature";
        Modelica.SIunits.HeatFlowRate Q_flow
                                            "Heat flow rate (positive if flowing from outside into the component)";
      end heatPort_rec;
    public
      heatPort_rec heatPort;
      constant Modelica.Media.Interfaces.Types.Density 'portInDensities[1]' = 995.586
                                                                                     "densities of the fluid at the device boundary";
      constant Modelica.Media.Interfaces.Types.Density 'portInDensities[2]' = 995.586
                                                                                     "densities of the fluid at the device boundary";
      constant Modelica.Media.Interfaces.Types.Density 'portInDensities[3]' = 995.586
                                                                                     "densities of the fluid at the device boundary";
      parameter Modelica.SIunits.Velocity 'portVelocities[1]'(fixed=false)
                                                                          "velocities of fluid flow at device boundary";
      Modelica.SIunits.Velocity 'portVelocities[2]'
                                                   "velocities of fluid flow at device boundary";
      Modelica.SIunits.Velocity 'portVelocities[3]'
                                                   "velocities of fluid flow at device boundary";
      parameter Modelica.SIunits.EnergyFlowRate 'ports_E_flow[1]'(fixed=false)
                                                                              "flow of kinetic and potential energy at device boundary";
      Modelica.SIunits.EnergyFlowRate 'ports_E_flow[2]'
                                                       "flow of kinetic and potential energy at device boundary";
      Modelica.SIunits.EnergyFlowRate 'ports_E_flow[3]'
                                                       "flow of kinetic and potential energy at device boundary";
      Real 's[1]'
                 "curve parameters for port flows vs. port pressures; for further details see, Modelica Tutorial: Ideal switching devices";
      Real 's[2]'
                 "curve parameters for port flows vs. port pressures; for further details see, Modelica Tutorial: Ideal switching devices";
      Real 's[3]'
                 "curve parameters for port flows vs. port pressures; for further details see, Modelica Tutorial: Ideal switching devices";
      Real 'ports_penetration[1]'
                                 "penetration of port with fluid, depending on fluid level and port diameter";
      Real 'ports_penetration[2]'
                                 "penetration of port with fluid, depending on fluid level and port diameter";
      Real 'ports_penetration[3]'
                                 "penetration of port with fluid, depending on fluid level and port diameter";
      parameter Modelica.SIunits.Area 'portAreas[1]'(fixed=false);
      parameter Modelica.SIunits.Area 'portAreas[2]'(fixed=false);
      parameter Modelica.SIunits.Area 'portAreas[3]'(fixed=false);
      Modelica.Media.Interfaces.Types.AbsolutePressure 'vessel_ps_static[1]'
                                                                            "static pressures inside the vessel at the height of the corresponding ports, zero flow velocity";
      Modelica.Media.Interfaces.Types.AbsolutePressure 'vessel_ps_static[2]'
                                                                            "static pressures inside the vessel at the height of the corresponding ports, zero flow velocity";
      Modelica.Media.Interfaces.Types.AbsolutePressure 'vessel_ps_static[3]'
                                                                            "static pressures inside the vessel at the height of the corresponding ports, zero flow velocity";
      constant Modelica.SIunits.ReynoldsNumber Re_turbulent = 100
                                                                 "cf. suddenExpansion";
      Modelica.SIunits.MassFlowRate 'm_flow_turbulent[1]';
      Modelica.SIunits.MassFlowRate 'm_flow_turbulent[2]';
      Modelica.SIunits.MassFlowRate 'm_flow_turbulent[3]';
    end waterBasin_rec;
  public
    waterBasin_rec waterBasin annotation(Dialog);
  protected
    record naturalConvectionVerticalPlate_rec
      Modelica.SIunits.HeatFlowRate Q_flow
                                          "Heat flow rate from solid -> fluid";
      Modelica.SIunits.TemperatureDifference dT
                                               "= solid.T - fluid.T";
    protected
      record solid_rec
        Modelica.SIunits.Temperature T
                                      "Port temperature";
        Modelica.SIunits.HeatFlowRate Q_flow
                                            "Heat flow rate (positive if flowing from outside into the component)";
      end solid_rec;
    public
      solid_rec solid;
    protected
      record fluid_rec
        Modelica.SIunits.Temperature T
                                      "Port temperature";
        Modelica.SIunits.HeatFlowRate Q_flow
                                            "Heat flow rate (positive if flowing from outside into the component)";
      end fluid_rec;
    public
      fluid_rec fluid;
      Real Gc
             "Convective thermal conductance in [W/K]";
      Modelica.SIunits.CoefficientOfHeatTransfer h
                                                  "Convection heat transfer coefficient";
      Modelica_Blocks_Interfaces_RealInput A;
      Modelica.SIunits.CubicExpansionCoefficient beta;
      Modelica.SIunits.GrashofNumber Gr;
      Modelica.SIunits.RayleighNumber Ra;
      Modelica.SIunits.NusseltNumber NuL;
      Modelica.SIunits.NusseltNumber NuL1;
      Modelica.SIunits.NusseltNumber NuL2;
      Modelica.SIunits.PrandtlNumber Pr;
      Modelica.SIunits.KinematicViscosity visco;
      Modelica.SIunits.ThermalConductivity K;
      Modelica.SIunits.Temp_K Tc
                                "Average temperature solid-fluid, characteristic temperature for correlation";
      parameter Modelica.SIunits.Length L(fixed=false)
                                                      "Characteristic length, length of the plate";
    end naturalConvectionVerticalPlate_rec;
  public
    naturalConvectionVerticalPlate_rec naturalConvectionVerticalPlate;
  protected
    record port_a_floor_rec
      Modelica.SIunits.Temperature T
                                    "Port temperature";
      Modelica.SIunits.HeatFlowRate Q_flow
                                          "Heat flow rate (positive if flowing from outside into the component)";
    end port_a_floor_rec;
  public
    port_a_floor_rec port_a_floor;
  protected
    record port_a_Cwater_rec
      Modelica.Media.Interfaces.PartialMedium.MassFlowRate m_flow(quantity = "MassFlowRate.SimpleLiquidWater", min = 0.0)
                                                                                                                         "Mass flow rate from the connection point into the component";
      Modelica.Media.Interfaces.Types.AbsolutePressure p
                                                        "Thermodynamic pressure in the connection point";
      Modelica.Media.Interfaces.Types.SpecificEnthalpy h_outflow
                                                                "Specific thermodynamic enthalpy close to the connection point if m_flow < 0";
    end port_a_Cwater_rec;
  public
    port_a_Cwater_rec port_a_Cwater;
  protected
    record port_b_Cwater_rec
      Modelica.Media.Interfaces.Types.AbsolutePressure p
                                                        "Thermodynamic pressure in the connection point";
      Modelica.Media.Interfaces.Types.SpecificEnthalpy h_outflow
                                                                "Specific thermodynamic enthalpy close to the connection point if m_flow < 0";
    end port_b_Cwater_rec;
  public
    port_b_Cwater_rec port_b_Cwater;
  protected
    record port_a_Owater_rec
      Modelica.Media.Interfaces.PartialMedium.MassFlowRate m_flow(quantity = "MassFlowRate.SimpleLiquidWater", min = 0.0)
                                                                                                                         "Mass flow rate from the connection point into the component";
      Modelica.Media.Interfaces.Types.AbsolutePressure p
                                                        "Thermodynamic pressure in the connection point";
      Modelica.Media.Interfaces.Types.SpecificEnthalpy h_outflow
                                                                "Specific thermodynamic enthalpy close to the connection point if m_flow < 0";
    end port_a_Owater_rec;
  public
    port_a_Owater_rec port_a_Owater;
  protected
    record waterSpray_rec
      constant Boolean allowFlowReversal = false
                                                "= true to allow flow reversal, false restricts to design direction (port_a -> port_b)";
    protected
      record port_a_rec
        Modelica.Media.Interfaces.PartialMedium.MassFlowRate m_flow(quantity = "MassFlowRate.SimpleLiquidWater", min = 0.0)
                                                                                                                           "Mass flow rate from the connection point into the component";
        Modelica.Media.Interfaces.Types.AbsolutePressure p
                                                          "Thermodynamic pressure in the connection point";
        Modelica.Media.Interfaces.Types.SpecificEnthalpy h_outflow
                                                                  "Specific thermodynamic enthalpy close to the connection point if m_flow < 0";
      end port_a_rec;
    public
      port_a_rec port_a;
    protected
      record port_b_rec
        Modelica.Media.Interfaces.PartialMedium.MassFlowRate m_flow(quantity = "MassFlowRate.SimpleLiquidWater", max = 0.0)
                                                                                                                           "Mass flow rate from the connection point into the component";
        Modelica.Media.Interfaces.Types.AbsolutePressure p
                                                          "Thermodynamic pressure in the connection point";
        Modelica.Media.Interfaces.Types.SpecificEnthalpy h_outflow
                                                                  "Specific thermodynamic enthalpy close to the connection point if m_flow < 0";
      end port_b_rec;
    public
      port_b_rec port_b;
      parameter Modelica.Media.Interfaces.Types.AbsolutePressure dp_start(min = -1E+060, fixed=false)
                                                                                                     "Guess value of dp = port_a.p - port_b.p";
      constant Modelica.Media.Interfaces.PartialMedium.MassFlowRate m_flow_start(quantity = "MassFlowRate.SimpleLiquidWater") = 0.0
                                                                                                                                   "Guess value of m_flow = port_a.m_flow";
      parameter Modelica.Media.Interfaces.PartialMedium.MassFlowRate m_flow_small(quantity = "MassFlowRate.SimpleLiquidWater", fixed=false)
                                                                                                                                           "Small mass flow rate for regularization of zero flow";
      constant Boolean show_T = true
                                    "= true, if temperatures at port_a and port_b are computed";
      constant Boolean show_V_flow = true
                                         "= true, if volume flow rate at inflowing port is computed";
      Modelica.Media.Interfaces.PartialMedium.MassFlowRate m_flow(quantity = "MassFlowRate.SimpleLiquidWater", min = 0.0)
                                                                                                                         "Mass flow rate in design flow direction";
      parameter Modelica.SIunits.Pressure dp(fixed=false)
                                                         "Pressure difference between port_a and port_b (= port_a.p - port_b.p)";
      parameter Modelica.SIunits.VolumeFlowRate V_flow(fixed=false)
                                                                   "Volume flow rate at inflowing port (positive when flow from port_a to port_b)";
      Modelica.Media.Interfaces.Types.Temperature port_a_T
                                                          "Temperature close to port_a, if show_T = true";
      Modelica.Media.Interfaces.Types.Temperature port_b_T
                                                          "Temperature close to port_b, if show_T = true";
      parameter Modelica.SIunits.AbsolutePressure p_ambient(fixed=false);
      parameter Modelica.SIunits.Diameter d_a(fixed=false);
      parameter Modelica.SIunits.Diameter d_b(fixed=false);
      parameter Modelica.SIunits.Area A_a(fixed=false);
      parameter Modelica.SIunits.Area A_b(fixed=false);
      parameter Modelica.SIunits.Velocity V_a(fixed=false);
      parameter Modelica.SIunits.Velocity V_b(fixed=false);
      constant Modelica.SIunits.Density rho_a = 995.586;
      constant Modelica.SIunits.Density rho_b = 995.586;
    end waterSpray_rec;
  public
    waterSpray_rec waterSpray;
  protected
    record pump_rec
      constant Boolean allowFlowReversal = false
                                                "= true to allow flow reversal, false restricts to design direction (port_a -> port_b)";
    protected
      record port_a_rec
        Modelica.Media.Interfaces.PartialMedium.MassFlowRate m_flow(quantity = "MassFlowRate.SimpleLiquidWater", min = 0.0)
                                                                                                                           "Mass flow rate from the connection point into the component";
        Modelica.Media.Interfaces.Types.AbsolutePressure p
                                                          "Thermodynamic pressure in the connection point";
        Modelica.Media.Interfaces.Types.SpecificEnthalpy h_outflow
                                                                  "Specific thermodynamic enthalpy close to the connection point if m_flow < 0";
      end port_a_rec;
    public
      port_a_rec port_a;
    protected
      record port_b_rec
        Modelica.Media.Interfaces.PartialMedium.MassFlowRate m_flow(quantity = "MassFlowRate.SimpleLiquidWater", max = 0.0)
                                                                                                                           "Mass flow rate from the connection point into the component";
        Modelica.Media.Interfaces.Types.AbsolutePressure p
                                                          "Thermodynamic pressure in the connection point";
        Modelica.Media.Interfaces.Types.SpecificEnthalpy h_outflow
                                                                  "Specific thermodynamic enthalpy close to the connection point if m_flow < 0";
      end port_b_rec;
    public
      port_b_rec port_b;
      parameter Modelica.Media.Interfaces.Types.AbsolutePressure p_a_start(fixed=false)
                                                                                       "Guess value for inlet pressure";
      parameter Modelica.Media.Interfaces.Types.AbsolutePressure p_b_start(fixed=false)
                                                                                       "Guess value for outlet pressure";
      constant Modelica.Media.Interfaces.PartialMedium.MassFlowRate m_flow_start(quantity = "MassFlowRate.SimpleLiquidWater") = 0.0
                                                                                                                                   "Guess value of m_flow = port_a.m_flow";
      constant Modelica.SIunits.VolumeFlowRate V_flow_single_init = 0.0
                                                                       "Used for simplified initialization model";
      constant Modelica.SIunits.Height delta_head_init = 0.0
                                                            "Used for simplified initialization model";
      parameter Integer nParallel(min = 1) = 1
                                              "Number of pumps in parallel";
      parameter Modelica.SIunits.Conversions.NonSIunits.AngularVelocity_rpm N_nominal = 1500
                                                                                            "Nominal rotational speed for flow characteristic";
      parameter Modelica.Media.Interfaces.Types.Density rho_nominal = 995.586
                                                                             "Nominal fluid density for characteristic";
      constant Boolean use_powerCharacteristic = false
                                                      "Use powerCharacteristic (vs. efficiencyCharacteristic)";
      constant Boolean checkValve = false
                                         "= true to prevent reverse flow";
      constant Modelica.SIunits.Volume V = 0.01
                                               "Volume inside the pump";
      constant Modelica.SIunits.Volume fluidVolume = 0.01
                                                         "Volume";
      constant Modelica.Fluid.Types.Dynamics energyDynamics = Modelica.Fluid.Types.Dynamics.SteadyState
                                                                                                       "Formulation of energy balance";
      constant Modelica.Fluid.Types.Dynamics massDynamics = Modelica.Fluid.Types.Dynamics.DynamicFreeInitial
                                                                                                            "Formulation of mass balance";
      constant Modelica.Fluid.Types.Dynamics substanceDynamics = Modelica.Fluid.Types.Dynamics.DynamicFreeInitial
                                                                                                                 "Formulation of substance balance";
      constant Modelica.Fluid.Types.Dynamics traceDynamics = Modelica.Fluid.Types.Dynamics.DynamicFreeInitial
                                                                                                             "Formulation of trace substance balance";
      parameter Modelica.Media.Interfaces.Types.AbsolutePressure p_start(fixed=false)
                                                                                     "Start value of pressure";
      constant Boolean use_T_start = true
                                         "= true, use T_start, otherwise h_start";
      parameter Modelica.Media.Interfaces.Types.Temperature T_start(fixed=false)
                                                                                "Start value of temperature";
      parameter Modelica.Media.Interfaces.Types.SpecificEnthalpy h_start(fixed=false)
                                                                                     "Start value of specific enthalpy";
      parameter Modelica.Media.Interfaces.Types.MassFraction 'X_start[1]' = 1.0
                                                                               "Start value of mass fractions m_i/m";
    protected
      record medium_rec
        Real p(unit = "Pa", displayUnit = "bar", nominal = 100000.0, quantity = "Pressure", min = 0.0, max = 100000000.0)
                                                                                                                         "Absolute pressure of medium";
        Real h(unit = "J/kg", quantity = "SpecificEnergy")
                                                          "Specific enthalpy of medium";
        constant Modelica.Media.Interfaces.Types.Density d = 995.586
                                                                    "Density of medium";
        Modelica.Media.Interfaces.Types.Temperature T
                                                     "Temperature of medium";
        constant Modelica.Media.Interfaces.Types.MassFraction 'X[1]' = 1.0
                                                                          "Mass fractions (= (component mass)/total mass  m_i/m)";
        Modelica.Media.Interfaces.Types.SpecificInternalEnergy u
                                                                "Specific internal energy of medium";
        constant Modelica.Media.Interfaces.Types.SpecificHeatCapacity R = 0
                                                                           "Gas constant (of mixture if applicable)";
        constant Modelica.Media.Interfaces.Types.MolarMass MM = 0.018015268
                                                                           "Molar mass (of mixture or single fluid)";
      protected
        record state_rec
          Modelica.Media.Interfaces.Types.AbsolutePressure p
                                                            "Absolute pressure of medium";
          Modelica.Media.Interfaces.Types.Temperature T
                                                       "Temperature of medium";
        end state_rec;
      public
        state_rec state;
        constant Boolean preferredMediumStates = true
                                                     "= true if StateSelect.prefer shall be used for the independent property variables of the medium";
        constant Boolean standardOrderComponents = true
                                                       "If true, and reducedX = true, the last element of X will be computed from the other ones";
        Modelica.SIunits.Conversions.NonSIunits.Temperature_degC T_degC
                                                                       "Temperature of medium in [degC]";
        Modelica.SIunits.Conversions.NonSIunits.Pressure_bar p_bar
                                                                  "Absolute pressure of medium in [bar]";
      end medium_rec;
    public
      medium_rec medium;
      Modelica.SIunits.Energy U
                               "Internal energy of fluid";
      constant Modelica.SIunits.Mass m = 9.95586
                                                "Mass of fluid";
      constant Real m_der(unit = "kg/s") = 0.0
                                              "der(Mass of fluid)";
      constant Modelica.SIunits.MassFlowRate mb_flow = 0.0
                                                          "Mass flows across boundaries";
      Modelica.SIunits.EnthalpyFlowRate Hb_flow
                                               "Enthalpy flow across boundaries or energy source/sink";
      constant Modelica.SIunits.HeatFlowRate Qb_flow = 0.0
                                                          "Heat flow across boundaries or energy source/sink";
      Modelica.SIunits.Power Wb_flow
                                    "Work flow across boundaries or source term";
      constant Boolean use_HeatTransfer = false
                                               "= true to use a HeatTransfer model, e.g., for a housing";
    protected
      record heatTransfer_rec
        constant Integer n = 1
                              "Number of heat transfer segments";
      protected
        record 'states[1]_rec'
          Modelica.Media.Interfaces.Types.AbsolutePressure p
                                                            "Absolute pressure of medium";
          Modelica.Media.Interfaces.Types.Temperature T
                                                       "Temperature of medium";
        end 'states[1]_rec';
      public
        'states[1]_rec' 'states[1]';
        constant Modelica.SIunits.Area 'surfaceAreas[1]' = 0.22446611560909474
                                                                              "Heat transfer areas";
        constant Modelica.SIunits.HeatFlowRate 'Q_flows[1]' = 0.0
                                                                 "Heat flow rates";
        constant Boolean use_k = false
                                      "= true to use k value for thermal isolation";
        constant Modelica.SIunits.CoefficientOfHeatTransfer k = 0
                                                                 "Heat transfer coefficient to ambient";
        parameter Modelica.SIunits.Temperature T_ambient(fixed=false)
                                                                     "Ambient temperature";
      protected
        record 'heatPorts[1]_rec'
          Modelica.SIunits.Temperature T
                                        "Port temperature";
          constant Modelica.SIunits.HeatFlowRate Q_flow = 0.0
                                                             "Heat flow rate (positive if flowing from outside into the component)";
        end 'heatPorts[1]_rec';
      public
        'heatPorts[1]_rec' 'heatPorts[1]';
        Modelica.SIunits.Temperature 'Ts[1]'
                                            "Temperatures defined by fluid states";
      end heatTransfer_rec;
    public
      heatTransfer_rec heatTransfer;
      parameter Modelica.SIunits.Acceleration g(fixed=false);
      constant Modelica.Media.Interfaces.Types.Density rho = 995.586;
      Modelica.SIunits.Pressure dp_pump
                                       "Pressure increase";
      Modelica.SIunits.Height head
                                  "Pump head";
      Modelica.SIunits.MassFlowRate m_flow
                                          "Mass flow rate (total)";
      parameter Modelica.SIunits.MassFlowRate m_flow_single(fixed=false)
                                                                        "Mass flow rate (single pump)";
      parameter Modelica.SIunits.VolumeFlowRate V_flow(fixed=false)
                                                                   "Volume flow rate (total)";
      parameter Modelica.SIunits.VolumeFlowRate V_flow_single(fixed=false)
                                                                          "Volume flow rate (single pump)";
      Modelica.SIunits.Conversions.NonSIunits.AngularVelocity_rpm N
                                                                   "Shaft rotational speed";
      Modelica.SIunits.Power W_single
                                     "Power Consumption (single pump)";
      Modelica.SIunits.Power W_total
                                    "Power Consumption (total)";
      constant Real eta = 0.8
                             "Global Efficiency";
      constant Real s = 0
                         "Curvilinear abscissa for the flow curve in parametric form (either mass flow rate or head)";
      constant Boolean show_NPSHa = false
                                         "obsolete -- remove modifier and specify Monitoring for NPSH instead";
    protected
      record monitoring_rec
      protected
        record state_in_rec
          Modelica.Media.Interfaces.Types.AbsolutePressure p
                                                            "Absolute pressure of medium";
          Modelica.Media.Interfaces.Types.Temperature T
                                                       "Temperature of medium";
        end state_in_rec;
      public
        state_in_rec state_in;
      protected
        record state_rec
          Modelica.Media.Interfaces.Types.AbsolutePressure p
                                                            "Absolute pressure of medium";
          Modelica.Media.Interfaces.Types.Temperature T
                                                       "Temperature of medium";
        end state_rec;
      public
        state_rec state;
      end monitoring_rec;
    public
      monitoring_rec monitoring;
      parameter Modelica.Media.Interfaces.Types.AbsolutePressure p_a_nominal(fixed=false)
                                                                                         "Nominal inlet pressure for predefined pump characteristics";
      parameter Modelica.Media.Interfaces.Types.AbsolutePressure p_b_nominal(fixed=false)
                                                                                         "Nominal outlet pressure, fixed if not control_m_flow and not use_p_set";
      parameter Modelica.Media.Interfaces.PartialMedium.MassFlowRate m_flow_nominal(quantity = "MassFlowRate.SimpleLiquidWater", fixed=false)
                                                                                                                                             "Nominal mass flow rate, fixed if control_m_flow and not use_m_flow_set";
      constant Boolean control_m_flow = true
                                            "= false to control outlet pressure port_b.p instead of m_flow";
      constant Boolean use_m_flow_set = true
                                            "= true to use input signal m_flow_set instead of m_flow_nominal";
      constant Boolean use_p_set = false
                                        "= true to use input signal p_set instead of p_b_nominal";
      parameter Modelica.SIunits.VolumeFlowRate V_flow_op(fixed=false)
                                                                      "operational volume flow rate according to nominal values";
      parameter Modelica.SIunits.Height head_op(fixed=false)
                                                            "operational pump head according to nominal values";
      Modelica_Blocks_Interfaces_RealInput m_flow_set
                                                     "Prescribed mass flow rate";
    end pump_rec;
  public
    pump_rec pump annotation(Dialog);
  protected
    record realExpression_rec
      Modelica_Blocks_Interfaces_RealOutput y
                                             "Value of Real output";
    end realExpression_rec;
  public
    realExpression_rec realExpression;
  protected
    record A_rec
      Modelica_Blocks_Interfaces_RealOutput y
                                             "Value of Real output";
    end A_rec;
  public
    A_rec A;
  protected
    record storageWall_rec
      parameter Modelica.SIunits.Temperature T_Wall_start = 293.15
                                                                  "Start temperature of the storage walls";
      parameter Modelica.SIunits.Length h(fixed=false)
                                                      "Height of the storage";
      parameter Modelica.SIunits.Length w(fixed=false)
                                                      "Width of the storage";
      parameter Modelica.SIunits.Length l(fixed=false)
                                                      "Length of the storage";
      parameter Modelica.SIunits.Length e(fixed=false)
                                                      "Thicknes of the storages wall";
    protected
      record 'sideInertia[1]_rec'
        Modelica.SIunits.Temperature T
                                      "Temperature of element";
        Real T_der(unit = "K/s")
                                "der(Temperature of element)";
        Modelica.SIunits.HeatFlowRate Q_flow;
        parameter Modelica.SIunits.Temperature T_start = 293.15
                                                               "Start temperature for the average temperature of ellement";
      protected
        record port_rec
          Modelica.SIunits.Temperature T
                                        "Port temperature";
          Modelica.SIunits.HeatFlowRate Q_flow
                                              "Heat flow rate (positive if flowing from outside into the component)";
        end port_rec;
      public
        port_rec port;
        parameter Modelica.SIunits.Volume V(fixed=false)
                                                        "Volume of element";
        parameter Modelica.SIunits.Mass m(fixed=false)
                                                      "Mass of element";
        Modelica.SIunits.TemperatureSlope der_T
                                               "Time derivative of temperature (= der(T))";
        parameter Modelica.SIunits.HeatCapacity C(fixed=false)
                                                              "Heat capacity of element (= cp*m)";
        parameter Modelica.SIunits.TemperatureSlope der_T_start = 0
                                                                   "Start value ofime derivative of temperature (= der(T))";
      end 'sideInertia[1]_rec';
    public
      'sideInertia[1]_rec' 'sideInertia[1]' annotation(Dialog);
    protected
      record 'sideInertia[2]_rec'
        Modelica.SIunits.Temperature T
                                      "Temperature of element";
        Real T_der(unit = "K/s")
                                "der(Temperature of element)";
        Modelica.SIunits.HeatFlowRate Q_flow;
        parameter Modelica.SIunits.Temperature T_start = 293.15
                                                               "Start temperature for the average temperature of ellement";
      protected
        record port_rec
          Modelica.SIunits.Temperature T
                                        "Port temperature";
          Modelica.SIunits.HeatFlowRate Q_flow
                                              "Heat flow rate (positive if flowing from outside into the component)";
        end port_rec;
      public
        port_rec port;
        parameter Modelica.SIunits.Volume V(fixed=false)
                                                        "Volume of element";
        parameter Modelica.SIunits.Mass m(fixed=false)
                                                      "Mass of element";
        Modelica.SIunits.TemperatureSlope der_T
                                               "Time derivative of temperature (= der(T))";
        parameter Modelica.SIunits.HeatCapacity C(fixed=false)
                                                              "Heat capacity of element (= cp*m)";
        parameter Modelica.SIunits.TemperatureSlope der_T_start = 0
                                                                   "Start value ofime derivative of temperature (= der(T))";
      end 'sideInertia[2]_rec';
    public
      'sideInertia[2]_rec' 'sideInertia[2]' annotation(Dialog);
    protected
      record topInertia_rec
        Modelica.SIunits.Temperature T
                                      "Temperature of element";
        Real T_der(unit = "K/s")
                                "der(Temperature of element)";
        Modelica.SIunits.HeatFlowRate Q_flow;
        parameter Modelica.SIunits.Temperature T_start = 293.15
                                                               "Start temperature for the average temperature of ellement";
      protected
        record port_rec
          Modelica.SIunits.Temperature T
                                        "Port temperature";
          Modelica.SIunits.HeatFlowRate Q_flow
                                              "Heat flow rate (positive if flowing from outside into the component)";
        end port_rec;
      public
        port_rec port;
        parameter Modelica.SIunits.Volume V(fixed=false)
                                                        "Volume of element";
        parameter Modelica.SIunits.Mass m(fixed=false)
                                                      "Mass of element";
        Modelica.SIunits.TemperatureSlope der_T
                                               "Time derivative of temperature (= der(T))";
        parameter Modelica.SIunits.HeatCapacity C(fixed=false)
                                                              "Heat capacity of element (= cp*m)";
        parameter Modelica.SIunits.TemperatureSlope der_T_start = 0
                                                                   "Start value ofime derivative of temperature (= der(T))";
      end topInertia_rec;
    public
      topInertia_rec topInertia annotation(Dialog);
    protected
      record 'sideCond2[1]_rec'
        Modelica.SIunits.HeatFlowRate Q_flow
                                            "Heat flow rate from port_a -> port_b";
        Modelica.SIunits.TemperatureDifference dT
                                                 "port_a.T - port_b.T";
      protected
        record port_a_rec
          Modelica.SIunits.Temperature T
                                        "Port temperature";
          Modelica.SIunits.HeatFlowRate Q_flow
                                              "Heat flow rate (positive if flowing from outside into the component)";
        end port_a_rec;
      public
        port_a_rec port_a;
      protected
        record port_b_rec
          Modelica.SIunits.Temperature T
                                        "Port temperature";
          Modelica.SIunits.HeatFlowRate Q_flow
                                              "Heat flow rate (positive if flowing from outside into the component)";
        end port_b_rec;
      public
        port_b_rec port_b;
        Modelica.SIunits.Temperature T
                                      "Average temperature of element";
        parameter Modelica.SIunits.Temperature T_start = 293.15
                                                               "Start temperature for the average temperature of element";
        parameter Modelica.SIunits.ThermalConductance G(fixed=false)
                                                                    "Thermal conductance of material";
        constant Modelica.SIunits.ThermalConductivity k = 17
                                                            "Thermal conductivity";
        parameter Modelica.SIunits.Length L(fixed=false)
                                                        "length of conduction";
        parameter Modelica.SIunits.Area A(fixed=false)
                                                      "Heat transfer area";
      end 'sideCond2[1]_rec';
    public
      'sideCond2[1]_rec' 'sideCond2[1]' annotation(Dialog);
    protected
      record 'sideCond2[2]_rec'
        Modelica.SIunits.HeatFlowRate Q_flow
                                            "Heat flow rate from port_a -> port_b";
        Modelica.SIunits.TemperatureDifference dT
                                                 "port_a.T - port_b.T";
      protected
        record port_a_rec
          Modelica.SIunits.Temperature T
                                        "Port temperature";
          Modelica.SIunits.HeatFlowRate Q_flow
                                              "Heat flow rate (positive if flowing from outside into the component)";
        end port_a_rec;
      public
        port_a_rec port_a;
      protected
        record port_b_rec
          Modelica.SIunits.Temperature T
                                        "Port temperature";
          Modelica.SIunits.HeatFlowRate Q_flow
                                              "Heat flow rate (positive if flowing from outside into the component)";
        end port_b_rec;
      public
        port_b_rec port_b;
        Modelica.SIunits.Temperature T
                                      "Average temperature of element";
        parameter Modelica.SIunits.Temperature T_start = 293.15
                                                               "Start temperature for the average temperature of element";
        parameter Modelica.SIunits.ThermalConductance G(fixed=false)
                                                                    "Thermal conductance of material";
        constant Modelica.SIunits.ThermalConductivity k = 17
                                                            "Thermal conductivity";
        parameter Modelica.SIunits.Length L(fixed=false)
                                                        "length of conduction";
        parameter Modelica.SIunits.Area A(fixed=false)
                                                      "Heat transfer area";
      end 'sideCond2[2]_rec';
    public
      'sideCond2[2]_rec' 'sideCond2[2]' annotation(Dialog);
    protected
      record 'sideCond1[1]_rec'
        Modelica.SIunits.HeatFlowRate Q_flow
                                            "Heat flow rate from port_a -> port_b";
        Modelica.SIunits.TemperatureDifference dT
                                                 "port_a.T - port_b.T";
      protected
        record port_a_rec
          Modelica.SIunits.Temperature T
                                        "Port temperature";
          Modelica.SIunits.HeatFlowRate Q_flow
                                              "Heat flow rate (positive if flowing from outside into the component)";
        end port_a_rec;
      public
        port_a_rec port_a;
      protected
        record port_b_rec
          Modelica.SIunits.Temperature T
                                        "Port temperature";
          Modelica.SIunits.HeatFlowRate Q_flow
                                              "Heat flow rate (positive if flowing from outside into the component)";
        end port_b_rec;
      public
        port_b_rec port_b;
        Modelica.SIunits.Temperature T
                                      "Average temperature of element";
        parameter Modelica.SIunits.Temperature T_start = 293.15
                                                               "Start temperature for the average temperature of element";
        parameter Modelica.SIunits.ThermalConductance G(fixed=false)
                                                                    "Thermal conductance of material";
        constant Modelica.SIunits.ThermalConductivity k = 17
                                                            "Thermal conductivity";
        parameter Modelica.SIunits.Length L(fixed=false)
                                                        "length of conduction";
        parameter Modelica.SIunits.Area A(fixed=false)
                                                      "Heat transfer area";
      end 'sideCond1[1]_rec';
    public
      'sideCond1[1]_rec' 'sideCond1[1]' annotation(Dialog);
    protected
      record 'sideCond1[2]_rec'
        Modelica.SIunits.HeatFlowRate Q_flow
                                            "Heat flow rate from port_a -> port_b";
        Modelica.SIunits.TemperatureDifference dT
                                                 "port_a.T - port_b.T";
      protected
        record port_a_rec
          Modelica.SIunits.Temperature T
                                        "Port temperature";
          Modelica.SIunits.HeatFlowRate Q_flow
                                              "Heat flow rate (positive if flowing from outside into the component)";
        end port_a_rec;
      public
        port_a_rec port_a;
      protected
        record port_b_rec
          Modelica.SIunits.Temperature T
                                        "Port temperature";
          Modelica.SIunits.HeatFlowRate Q_flow
                                              "Heat flow rate (positive if flowing from outside into the component)";
        end port_b_rec;
      public
        port_b_rec port_b;
        Modelica.SIunits.Temperature T
                                      "Average temperature of element";
        parameter Modelica.SIunits.Temperature T_start = 293.15
                                                               "Start temperature for the average temperature of element";
        parameter Modelica.SIunits.ThermalConductance G(fixed=false)
                                                                    "Thermal conductance of material";
        constant Modelica.SIunits.ThermalConductivity k = 17
                                                            "Thermal conductivity";
        parameter Modelica.SIunits.Length L(fixed=false)
                                                        "length of conduction";
        parameter Modelica.SIunits.Area A(fixed=false)
                                                      "Heat transfer area";
      end 'sideCond1[2]_rec';
    public
      'sideCond1[2]_rec' 'sideCond1[2]' annotation(Dialog);
    protected
      record topCond1_rec
        Modelica.SIunits.HeatFlowRate Q_flow
                                            "Heat flow rate from port_a -> port_b";
        Modelica.SIunits.TemperatureDifference dT
                                                 "port_a.T - port_b.T";
      protected
        record port_a_rec
          Modelica.SIunits.Temperature T
                                        "Port temperature";
          Modelica.SIunits.HeatFlowRate Q_flow
                                              "Heat flow rate (positive if flowing from outside into the component)";
        end port_a_rec;
      public
        port_a_rec port_a;
      protected
        record port_b_rec
          Modelica.SIunits.Temperature T
                                        "Port temperature";
          Modelica.SIunits.HeatFlowRate Q_flow
                                              "Heat flow rate (positive if flowing from outside into the component)";
        end port_b_rec;
      public
        port_b_rec port_b;
        Modelica.SIunits.Temperature T
                                      "Average temperature of element";
        parameter Modelica.SIunits.Temperature T_start = 293.15
                                                               "Start temperature for the average temperature of element";
        parameter Modelica.SIunits.ThermalConductance G(fixed=false)
                                                                    "Thermal conductance of material";
        constant Modelica.SIunits.ThermalConductivity k = 17
                                                            "Thermal conductivity";
        parameter Modelica.SIunits.Length L(fixed=false)
                                                        "length of conduction";
        parameter Modelica.SIunits.Area A(fixed=false)
                                                      "Heat transfer area";
      end topCond1_rec;
    public
      topCond1_rec topCond1 annotation(Dialog);
    protected
      record topCond2_rec
        Modelica.SIunits.HeatFlowRate Q_flow
                                            "Heat flow rate from port_a -> port_b";
        Modelica.SIunits.TemperatureDifference dT
                                                 "port_a.T - port_b.T";
      protected
        record port_a_rec
          Modelica.SIunits.Temperature T
                                        "Port temperature";
          Modelica.SIunits.HeatFlowRate Q_flow
                                              "Heat flow rate (positive if flowing from outside into the component)";
        end port_a_rec;
      public
        port_a_rec port_a;
      protected
        record port_b_rec
          Modelica.SIunits.Temperature T
                                        "Port temperature";
          Modelica.SIunits.HeatFlowRate Q_flow
                                              "Heat flow rate (positive if flowing from outside into the component)";
        end port_b_rec;
      public
        port_b_rec port_b;
        Modelica.SIunits.Temperature T
                                      "Average temperature of element";
        parameter Modelica.SIunits.Temperature T_start = 293.15
                                                               "Start temperature for the average temperature of element";
        parameter Modelica.SIunits.ThermalConductance G(fixed=false)
                                                                    "Thermal conductance of material";
        constant Modelica.SIunits.ThermalConductivity k = 17
                                                            "Thermal conductivity";
        parameter Modelica.SIunits.Length L(fixed=false)
                                                        "length of conduction";
        parameter Modelica.SIunits.Area A(fixed=false)
                                                      "Heat transfer area";
      end topCond2_rec;
    public
      topCond2_rec topCond2 annotation(Dialog);
    protected
      record T_water_rec
        Modelica.SIunits.Temperature T
                                      "Port temperature";
        Modelica.SIunits.HeatFlowRate Q_flow
                                            "Heat flow rate (positive if flowing from outside into the component)";
      end T_water_rec;
    public
      T_water_rec T_water;
    protected
      record ambient_rec
        Modelica.SIunits.Temperature T
                                      "Port temperature";
        Modelica.SIunits.HeatFlowRate Q_flow
                                            "Heat flow rate (positive if flowing from outside into the component)";
      end ambient_rec;
    public
      ambient_rec ambient;
    protected
      record 'frontInertia[1]_rec'
        Modelica.SIunits.Temperature T
                                      "Temperature of element";
        Real T_der(unit = "K/s")
                                "der(Temperature of element)";
        Modelica.SIunits.HeatFlowRate Q_flow;
        parameter Modelica.SIunits.Temperature T_start = 293.15
                                                               "Start temperature for the average temperature of ellement";
      protected
        record port_rec
          Modelica.SIunits.Temperature T
                                        "Port temperature";
          Modelica.SIunits.HeatFlowRate Q_flow
                                              "Heat flow rate (positive if flowing from outside into the component)";
        end port_rec;
      public
        port_rec port;
        parameter Modelica.SIunits.Volume V(fixed=false)
                                                        "Volume of element";
        parameter Modelica.SIunits.Mass m(fixed=false)
                                                      "Mass of element";
        Modelica.SIunits.TemperatureSlope der_T
                                               "Time derivative of temperature (= der(T))";
        parameter Modelica.SIunits.HeatCapacity C(fixed=false)
                                                              "Heat capacity of element (= cp*m)";
        parameter Modelica.SIunits.TemperatureSlope der_T_start = 0
                                                                   "Start value ofime derivative of temperature (= der(T))";
      end 'frontInertia[1]_rec';
    public
      'frontInertia[1]_rec' 'frontInertia[1]' annotation(Dialog);
    protected
      record 'frontInertia[2]_rec'
        Modelica.SIunits.Temperature T
                                      "Temperature of element";
        Real T_der(unit = "K/s")
                                "der(Temperature of element)";
        Modelica.SIunits.HeatFlowRate Q_flow;
        parameter Modelica.SIunits.Temperature T_start = 293.15
                                                               "Start temperature for the average temperature of ellement";
      protected
        record port_rec
          Modelica.SIunits.Temperature T
                                        "Port temperature";
          Modelica.SIunits.HeatFlowRate Q_flow
                                              "Heat flow rate (positive if flowing from outside into the component)";
        end port_rec;
      public
        port_rec port;
        parameter Modelica.SIunits.Volume V(fixed=false)
                                                        "Volume of element";
        parameter Modelica.SIunits.Mass m(fixed=false)
                                                      "Mass of element";
        Modelica.SIunits.TemperatureSlope der_T
                                               "Time derivative of temperature (= der(T))";
        parameter Modelica.SIunits.HeatCapacity C(fixed=false)
                                                              "Heat capacity of element (= cp*m)";
        parameter Modelica.SIunits.TemperatureSlope der_T_start = 0
                                                                   "Start value ofime derivative of temperature (= der(T))";
      end 'frontInertia[2]_rec';
    public
      'frontInertia[2]_rec' 'frontInertia[2]' annotation(Dialog);
    protected
      record 'frontCond1[1]_rec'
        Modelica.SIunits.HeatFlowRate Q_flow
                                            "Heat flow rate from port_a -> port_b";
        Modelica.SIunits.TemperatureDifference dT
                                                 "port_a.T - port_b.T";
      protected
        record port_a_rec
          Modelica.SIunits.Temperature T
                                        "Port temperature";
          Modelica.SIunits.HeatFlowRate Q_flow
                                              "Heat flow rate (positive if flowing from outside into the component)";
        end port_a_rec;
      public
        port_a_rec port_a;
      protected
        record port_b_rec
          Modelica.SIunits.Temperature T
                                        "Port temperature";
          Modelica.SIunits.HeatFlowRate Q_flow
                                              "Heat flow rate (positive if flowing from outside into the component)";
        end port_b_rec;
      public
        port_b_rec port_b;
        Modelica.SIunits.Temperature T
                                      "Average temperature of element";
        parameter Modelica.SIunits.Temperature T_start = 293.15
                                                               "Start temperature for the average temperature of element";
        parameter Modelica.SIunits.ThermalConductance G(fixed=false)
                                                                    "Thermal conductance of material";
        constant Modelica.SIunits.ThermalConductivity k = 17
                                                            "Thermal conductivity";
        parameter Modelica.SIunits.Length L(fixed=false)
                                                        "length of conduction";
        parameter Modelica.SIunits.Area A(fixed=false)
                                                      "Heat transfer area";
      end 'frontCond1[1]_rec';
    public
      'frontCond1[1]_rec' 'frontCond1[1]' annotation(Dialog);
    protected
      record 'frontCond1[2]_rec'
        constant Modelica.SIunits.HeatFlowRate Q_flow = 0.0
                                                           "Heat flow rate from port_a -> port_b";
        parameter Modelica.SIunits.TemperatureDifference dT(fixed=false)
                                                                        "port_a.T - port_b.T";
      protected
        record port_a_rec
          Modelica.SIunits.Temperature T
                                        "Port temperature";
          constant Modelica.SIunits.HeatFlowRate Q_flow = 0.0
                                                             "Heat flow rate (positive if flowing from outside into the component)";
        end port_a_rec;
      public
        port_a_rec port_a;
      protected
        record port_b_rec
          Modelica.SIunits.Temperature T
                                        "Port temperature";
          constant Modelica.SIunits.HeatFlowRate Q_flow = 0.0
                                                             "Heat flow rate (positive if flowing from outside into the component)";
        end port_b_rec;
      public
        port_b_rec port_b;
        Modelica.SIunits.Temperature T
                                      "Average temperature of element";
        parameter Modelica.SIunits.Temperature T_start = 293.15
                                                               "Start temperature for the average temperature of element";
        parameter Modelica.SIunits.ThermalConductance G(fixed=false)
                                                                    "Thermal conductance of material";
        constant Modelica.SIunits.ThermalConductivity k = 17
                                                            "Thermal conductivity";
        parameter Modelica.SIunits.Length L(fixed=false)
                                                        "length of conduction";
        parameter Modelica.SIunits.Area A(fixed=false)
                                                      "Heat transfer area";
      end 'frontCond1[2]_rec';
    public
      'frontCond1[2]_rec' 'frontCond1[2]' annotation(Dialog);
    protected
      record 'frontCond2[1]_rec'
        Modelica.SIunits.HeatFlowRate Q_flow
                                            "Heat flow rate from port_a -> port_b";
        Modelica.SIunits.TemperatureDifference dT
                                                 "port_a.T - port_b.T";
      protected
        record port_a_rec
          Modelica.SIunits.Temperature T
                                        "Port temperature";
          Modelica.SIunits.HeatFlowRate Q_flow
                                              "Heat flow rate (positive if flowing from outside into the component)";
        end port_a_rec;
      public
        port_a_rec port_a;
      protected
        record port_b_rec
          Modelica.SIunits.Temperature T
                                        "Port temperature";
          Modelica.SIunits.HeatFlowRate Q_flow
                                              "Heat flow rate (positive if flowing from outside into the component)";
        end port_b_rec;
      public
        port_b_rec port_b;
        Modelica.SIunits.Temperature T
                                      "Average temperature of element";
        parameter Modelica.SIunits.Temperature T_start = 293.15
                                                               "Start temperature for the average temperature of element";
        parameter Modelica.SIunits.ThermalConductance G(fixed=false)
                                                                    "Thermal conductance of material";
        constant Modelica.SIunits.ThermalConductivity k = 17
                                                            "Thermal conductivity";
        parameter Modelica.SIunits.Length L(fixed=false)
                                                        "length of conduction";
        parameter Modelica.SIunits.Area A(fixed=false)
                                                      "Heat transfer area";
      end 'frontCond2[1]_rec';
    public
      'frontCond2[1]_rec' 'frontCond2[1]' annotation(Dialog);
    protected
      record 'frontCond2[2]_rec'
        Modelica.SIunits.HeatFlowRate Q_flow
                                            "Heat flow rate from port_a -> port_b";
        Modelica.SIunits.TemperatureDifference dT
                                                 "port_a.T - port_b.T";
      protected
        record port_a_rec
          Modelica.SIunits.Temperature T
                                        "Port temperature";
          Modelica.SIunits.HeatFlowRate Q_flow
                                              "Heat flow rate (positive if flowing from outside into the component)";
        end port_a_rec;
      public
        port_a_rec port_a;
      protected
        record port_b_rec
          Modelica.SIunits.Temperature T
                                        "Port temperature";
          Modelica.SIunits.HeatFlowRate Q_flow
                                              "Heat flow rate (positive if flowing from outside into the component)";
        end port_b_rec;
      public
        port_b_rec port_b;
        Modelica.SIunits.Temperature T
                                      "Average temperature of element";
        parameter Modelica.SIunits.Temperature T_start = 293.15
                                                               "Start temperature for the average temperature of element";
        parameter Modelica.SIunits.ThermalConductance G(fixed=false)
                                                                    "Thermal conductance of material";
        constant Modelica.SIunits.ThermalConductivity k = 17
                                                            "Thermal conductivity";
        parameter Modelica.SIunits.Length L(fixed=false)
                                                        "length of conduction";
        parameter Modelica.SIunits.Area A(fixed=false)
                                                      "Heat transfer area";
      end 'frontCond2[2]_rec';
    public
      'frontCond2[2]_rec' 'frontCond2[2]' annotation(Dialog);
    protected
      record 'floor_rec'
        Modelica.SIunits.Temperature T
                                      "Port temperature";
        Modelica.SIunits.HeatFlowRate Q_flow
                                            "Heat flow rate (positive if flowing from outside into the component)";
      end 'floor_rec';
    public
      'floor_rec' 'floor';
    end storageWall_rec;
  public
    storageWall_rec storageWall annotation(Dialog);
  protected
    record port_a_ambient_rec
      Modelica.SIunits.Temperature T
                                    "Port temperature";
      Modelica.SIunits.HeatFlowRate Q_flow
                                          "Heat flow rate (positive if flowing from outside into the component)";
    end port_a_ambient_rec;
  public
    port_a_ambient_rec port_a_ambient;
    Modelica_Blocks_Interfaces_RealOutput level
                                               "Level of the water in the waterBasin";
  end closedCTPressureDrop_rec;
public
  closedCTPressureDrop_rec closedCTPressureDrop annotation(Dialog);
protected
  record airIn_rec
    constant Integer nPorts = 1
                               "Number of ports";
  protected
    record medium_rec
      Real p(unit = "Pa", displayUnit = "bar", nominal = 100000.0, quantity = "Pressure", min = 0.0)
                                                                                                    "Absolute pressure of medium";
      Real 'Xi[1]'(unit = "1", quantity = "MassFraction", min = 0.0, max = 1.0)
                                                                               "Structurally independent mass fractions";
      Real h(unit = "J/kg", quantity = "SpecificEnergy")
                                                        "Specific enthalpy of medium";
      Modelica.Media.Interfaces.Types.Density d
                                               "Density of medium";
      Modelica.Media.Interfaces.Types.Temperature T(min = 190.0, max = 647.0)
                                                                             "Temperature of medium";
      Modelica.Media.Interfaces.Types.MassFraction 'X[1]'
                                                         "Mass fractions (= (component mass)/total mass  m_i/m)";
      Modelica.Media.Interfaces.Types.MassFraction 'X[2]'
                                                         "Mass fractions (= (component mass)/total mass  m_i/m)";
      Modelica.Media.Interfaces.Types.SpecificInternalEnergy u
                                                              "Specific internal energy of medium";
      Modelica.Media.Interfaces.Types.SpecificHeatCapacity R
                                                            "Gas constant (of mixture if applicable)";
      Modelica.Media.Interfaces.Types.MolarMass MM
                                                  "Molar mass (of mixture or single fluid)";
    protected
      record state_rec
        Modelica.Media.Interfaces.Types.AbsolutePressure p
                                                          "Absolute pressure of medium";
        Modelica.Media.Interfaces.Types.Temperature T(min = 190.0, max = 647.0)
                                                                               "Temperature of medium";
        Modelica.Media.Interfaces.Types.MassFraction 'X[1]'
                                                           "Mass fractions (= (component mass)/total mass  m_i/m)";
        Modelica.Media.Interfaces.Types.MassFraction 'X[2]'
                                                           "Mass fractions (= (component mass)/total mass  m_i/m)";
      end state_rec;
    public
      state_rec state;
      constant Boolean preferredMediumStates = false
                                                    "= true if StateSelect.prefer shall be used for the independent property variables of the medium";
      constant Boolean standardOrderComponents = true
                                                     "If true, and reducedX = true, the last element of X will be computed from the other ones";
      Modelica.SIunits.Conversions.NonSIunits.Temperature_degC T_degC
                                                                     "Temperature of medium in [degC]";
      Modelica.SIunits.Conversions.NonSIunits.Pressure_bar p_bar
                                                                "Absolute pressure of medium in [bar]";
      Modelica.Media.Interfaces.Types.MassFraction x_water
                                                          "Mass of total water/mass of dry air";
      Real phi
              "Relative humidity";
    end medium_rec;
  public
    medium_rec medium;
  protected
    record 'ports[1]_rec'
      Modelica.Media.Interfaces.PartialMedium.MassFlowRate m_flow(quantity = "MassFlowRate.Moist air", min = -1E+060, max = 1E+060)
                                                                                                                                   "Mass flow rate from the connection point into the component";
      parameter Modelica.Media.Interfaces.Types.AbsolutePressure _p_start = 100000.0;
      Modelica.Media.Interfaces.Types.AbsolutePressure p(start = _p_start, fixed=false)
                                                                                       "Thermodynamic pressure in the connection point";
      Modelica.Media.Interfaces.Types.SpecificEnthalpy h_outflow
                                                                "Specific thermodynamic enthalpy close to the connection point if m_flow < 0";
      Modelica.Media.Interfaces.Types.MassFraction 'Xi_outflow[1]'
                                                                  "Independent mixture mass fractions m_i/m close to the connection point if m_flow < 0";
    end 'ports[1]_rec';
  public
    'ports[1]_rec' 'ports[1]' annotation(Dialog);
    constant Modelica.Media.Interfaces.PartialMedium.MassFlowRate m_flow(quantity = "MassFlowRate.Moist air") = 48
                                                                                                                  "Fixed mass flow rate going out of the fluid port";
    constant Modelica.Media.Interfaces.Types.Temperature T(min = 190.0, max = 647.0) = 298.15
                                                                                             "Fixed value of temperature";
    constant Modelica.Media.Interfaces.Types.MassFraction 'X[1]' = 0.007713153
                                                                              "Fixed value of composition";
    constant Modelica.Media.Interfaces.Types.MassFraction 'X[2]' = 0.992286847
                                                                              "Fixed value of composition";
    Modelica_Blocks_Interfaces_RealInput m_flow_in
                                                  "Prescribed mass flow rate";
    Modelica_Blocks_Interfaces_RealInput T_in
                                             "Prescribed fluid temperature";
    Modelica_Blocks_Interfaces_RealInput 'X_in[1]'
                                                  "Prescribed fluid composition";
    Modelica_Blocks_Interfaces_RealInput 'X_in[2]'
                                                  "Prescribed fluid composition";
  end airIn_rec;
public
  airIn_rec airIn annotation(Dialog);
protected
  record airOut_rec
    constant Integer nPorts = 1
                               "Number of ports";
  protected
    record medium_rec
      Real p(unit = "Pa", displayUnit = "bar", nominal = 100000.0, quantity = "Pressure", min = 0.0)
                                                                                                    "Absolute pressure of medium";
      Real 'Xi[1]'(unit = "1", quantity = "MassFraction", min = 0.0, max = 1.0)
                                                                               "Structurally independent mass fractions";
      Real h(unit = "J/kg", quantity = "SpecificEnergy")
                                                        "Specific enthalpy of medium";
      parameter Modelica.Media.Interfaces.Types.Density d(fixed=false)
                                                                      "Density of medium";
      Modelica.Media.Interfaces.Types.Temperature T(min = 190.0, max = 647.0)
                                                                             "Temperature of medium";
      Modelica.Media.Interfaces.Types.MassFraction 'X[1]'
                                                         "Mass fractions (= (component mass)/total mass  m_i/m)";
      parameter Modelica.Media.Interfaces.Types.MassFraction 'X[2]'(fixed=false)
                                                                                "Mass fractions (= (component mass)/total mass  m_i/m)";
      parameter Modelica.Media.Interfaces.Types.SpecificInternalEnergy u(fixed=false)
                                                                                     "Specific internal energy of medium";
      parameter Modelica.Media.Interfaces.Types.SpecificHeatCapacity R(fixed=false)
                                                                                   "Gas constant (of mixture if applicable)";
      parameter Modelica.Media.Interfaces.Types.MolarMass MM(fixed=false)
                                                                         "Molar mass (of mixture or single fluid)";
    protected
      record state_rec
        Modelica.Media.Interfaces.Types.AbsolutePressure p
                                                          "Absolute pressure of medium";
        Modelica.Media.Interfaces.Types.Temperature T(min = 190.0, max = 647.0)
                                                                               "Temperature of medium";
        Modelica.Media.Interfaces.Types.MassFraction 'X[1]'
                                                           "Mass fractions (= (component mass)/total mass  m_i/m)";
        Modelica.Media.Interfaces.Types.MassFraction 'X[2]'
                                                           "Mass fractions (= (component mass)/total mass  m_i/m)";
      end state_rec;
    public
      state_rec state;
      constant Boolean preferredMediumStates = false
                                                    "= true if StateSelect.prefer shall be used for the independent property variables of the medium";
      constant Boolean standardOrderComponents = true
                                                     "If true, and reducedX = true, the last element of X will be computed from the other ones";
      parameter Modelica.SIunits.Conversions.NonSIunits.Temperature_degC T_degC(fixed=false)
                                                                                            "Temperature of medium in [degC]";
      parameter Modelica.SIunits.Conversions.NonSIunits.Pressure_bar p_bar(fixed=false)
                                                                                       "Absolute pressure of medium in [bar]";
      parameter Modelica.Media.Interfaces.Types.MassFraction x_water(fixed=false)
                                                                                 "Mass of total water/mass of dry air";
      parameter Real phi(fixed=false)
                                     "Relative humidity";
    end medium_rec;
  public
    medium_rec medium;
  protected
    record 'ports[1]_rec'
      Modelica.Media.Interfaces.PartialMedium.MassFlowRate m_flow(quantity = "MassFlowRate.Moist air", min = -1E+060, max = 1E+060)
                                                                                                                                   "Mass flow rate from the connection point into the component";
      Modelica.Media.Interfaces.Types.AbsolutePressure p
                                                        "Thermodynamic pressure in the connection point";
      parameter Modelica.Media.Interfaces.Types.SpecificEnthalpy h_outflow(fixed=false)
                                                                                       "Specific thermodynamic enthalpy close to the connection point if m_flow < 0";
      Modelica.Media.Interfaces.Types.MassFraction 'Xi_outflow[1]'
                                                                  "Independent mixture mass fractions m_i/m close to the connection point if m_flow < 0";
    end 'ports[1]_rec';
  public
    'ports[1]_rec' 'ports[1]';
    constant Boolean use_p = true
                                 "select p or d";
    parameter Modelica.Media.Interfaces.Types.AbsolutePressure p(fixed=false)
                                                                             "Boundary pressure";
    constant Modelica.Media.Interfaces.Types.Density d = 1.1968386935810924
                                                                           "Boundary density";
    constant Boolean use_T = true
                                 "select T or h";
    parameter Modelica.Media.Interfaces.Types.Temperature T(min = 190.0, max = 647.0) = 293.15
                                                                                              "Boundary temperature";
    parameter Modelica.Media.Interfaces.Types.SpecificEnthalpy h = 45263.238744693415
                                                                                     "Boundary specific enthalpy";
    parameter Modelica.Media.Interfaces.Types.MassFraction 'X[1]'(quantity = "water") = 0.01
                                                                                            "Boundary mass fractions m_i/m";
    parameter Modelica.Media.Interfaces.Types.MassFraction 'X[2]'(quantity = "air") = 0.99
                                                                                          "Boundary mass fractions m_i/m";
  end airOut_rec;
public
  airOut_rec airOut annotation(Dialog);
protected
  record cWaterIn_rec
    constant Integer nPorts = 1
                               "Number of ports";
  protected
    record medium_rec
      Real p(unit = "Pa", displayUnit = "bar", nominal = 100000.0, quantity = "Pressure", min = 0.0)
                                                                                                    "Absolute pressure of medium";
      Real h(unit = "J/kg", quantity = "SpecificEnergy")
                                                        "Specific enthalpy of medium";
      constant Modelica.Media.Interfaces.Types.Density d = 995.586
                                                                  "Density of medium";
      Modelica.Media.Interfaces.Types.Temperature T
                                                   "Temperature of medium";
      constant Modelica.Media.Interfaces.Types.MassFraction 'X[1]' = 1.0
                                                                        "Mass fractions (= (component mass)/total mass  m_i/m)";
      Modelica.Media.Interfaces.Types.SpecificInternalEnergy u
                                                              "Specific internal energy of medium";
      constant Modelica.Media.Interfaces.Types.SpecificHeatCapacity R = 0
                                                                         "Gas constant (of mixture if applicable)";
      constant Modelica.Media.Interfaces.Types.MolarMass MM = 0.018015268
                                                                         "Molar mass (of mixture or single fluid)";
    protected
      record state_rec
        Modelica.Media.Interfaces.Types.AbsolutePressure p
                                                          "Absolute pressure of medium";
        Modelica.Media.Interfaces.Types.Temperature T
                                                     "Temperature of medium";
      end state_rec;
    public
      state_rec state;
      constant Boolean preferredMediumStates = false
                                                    "= true if StateSelect.prefer shall be used for the independent property variables of the medium";
      constant Boolean standardOrderComponents = true
                                                     "If true, and reducedX = true, the last element of X will be computed from the other ones";
      Modelica.SIunits.Conversions.NonSIunits.Temperature_degC T_degC
                                                                     "Temperature of medium in [degC]";
      Modelica.SIunits.Conversions.NonSIunits.Pressure_bar p_bar
                                                                "Absolute pressure of medium in [bar]";
    end medium_rec;
  public
    medium_rec medium;
  protected
    record 'ports[1]_rec'
      Modelica.Media.Interfaces.PartialMedium.MassFlowRate m_flow(quantity = "MassFlowRate.SimpleLiquidWater", min = -1E+060, max = 1E+060)
                                                                                                                                           "Mass flow rate from the connection point into the component";
      Modelica.Media.Interfaces.Types.AbsolutePressure p
                                                        "Thermodynamic pressure in the connection point";
      Modelica.Media.Interfaces.Types.SpecificEnthalpy h_outflow
                                                                "Specific thermodynamic enthalpy close to the connection point if m_flow < 0";
    end 'ports[1]_rec';
  public
    'ports[1]_rec' 'ports[1]';
    constant Modelica.Media.Interfaces.PartialMedium.MassFlowRate m_flow(quantity = "MassFlowRate.SimpleLiquidWater") = 13.440411
                                                                                                                                 "Fixed mass flow rate going out of the fluid port";
    constant Modelica.Media.Interfaces.Types.Temperature T = 313.15
                                                                   "Fixed value of temperature";
    constant Modelica.Media.Interfaces.Types.MassFraction 'X[1]' = 1.0
                                                                      "Fixed value of composition";
    Modelica_Blocks_Interfaces_RealInput m_flow_in
                                                  "Prescribed mass flow rate";
    Modelica_Blocks_Interfaces_RealInput T_in
                                             "Prescribed fluid temperature";
  end cWaterIn_rec;
public
  cWaterIn_rec cWaterIn;
protected
  record cWaterOut_rec
    constant Integer nPorts = 1
                               "Number of ports";
  protected
    record medium_rec
      Real p(unit = "Pa", displayUnit = "bar", nominal = 100000.0, quantity = "Pressure", min = 0.0)
                                                                                                    "Absolute pressure of medium";
      Real h(unit = "J/kg", quantity = "SpecificEnergy")
                                                        "Specific enthalpy of medium";
      constant Modelica.Media.Interfaces.Types.Density d = 995.586
                                                                  "Density of medium";
      Modelica.Media.Interfaces.Types.Temperature T
                                                   "Temperature of medium";
      constant Modelica.Media.Interfaces.Types.MassFraction 'X[1]' = 1.0
                                                                        "Mass fractions (= (component mass)/total mass  m_i/m)";
      parameter Modelica.Media.Interfaces.Types.SpecificInternalEnergy u(fixed=false)
                                                                                     "Specific internal energy of medium";
      constant Modelica.Media.Interfaces.Types.SpecificHeatCapacity R = 0
                                                                         "Gas constant (of mixture if applicable)";
      constant Modelica.Media.Interfaces.Types.MolarMass MM = 0.018015268
                                                                         "Molar mass (of mixture or single fluid)";
    protected
      record state_rec
        Modelica.Media.Interfaces.Types.AbsolutePressure p
                                                          "Absolute pressure of medium";
        Modelica.Media.Interfaces.Types.Temperature T
                                                     "Temperature of medium";
      end state_rec;
    public
      state_rec state;
      constant Boolean preferredMediumStates = false
                                                    "= true if StateSelect.prefer shall be used for the independent property variables of the medium";
      constant Boolean standardOrderComponents = true
                                                     "If true, and reducedX = true, the last element of X will be computed from the other ones";
      parameter Modelica.SIunits.Conversions.NonSIunits.Temperature_degC T_degC(fixed=false)
                                                                                            "Temperature of medium in [degC]";
      parameter Modelica.SIunits.Conversions.NonSIunits.Pressure_bar p_bar(fixed=false)
                                                                                       "Absolute pressure of medium in [bar]";
    end medium_rec;
  public
    medium_rec medium;
  protected
    record 'ports[1]_rec'
      Modelica.Media.Interfaces.PartialMedium.MassFlowRate m_flow(quantity = "MassFlowRate.SimpleLiquidWater", min = -1E+060, max = 1E+060)
                                                                                                                                           "Mass flow rate from the connection point into the component";
      Modelica.Media.Interfaces.Types.AbsolutePressure p
                                                        "Thermodynamic pressure in the connection point";
      parameter Modelica.Media.Interfaces.Types.SpecificEnthalpy h_outflow(fixed=false)
                                                                                       "Specific thermodynamic enthalpy close to the connection point if m_flow < 0";
    end 'ports[1]_rec';
  public
    'ports[1]_rec' 'ports[1]';
    constant Boolean use_p = true
                                 "select p or d";
    parameter Modelica.Media.Interfaces.Types.AbsolutePressure p(fixed=false)
                                                                             "Boundary pressure";
    constant Modelica.Media.Interfaces.Types.Density d = 995.586
                                                                "Boundary density";
    constant Boolean use_T = true
                                 "select T or h";
    parameter Modelica.Media.Interfaces.Types.Temperature T = 293.15
                                                                    "Boundary temperature";
    parameter Modelica.Media.Interfaces.Types.SpecificEnthalpy h = 83680.0
                                                                          "Boundary specific enthalpy";
    parameter Modelica.Media.Interfaces.Types.MassFraction 'X[1]'(quantity = "SimpleLiquidWater") = 1.0
                                                                                                       "Boundary mass fractions m_i/m";
  end cWaterOut_rec;
public
  cWaterOut_rec cWaterOut annotation(Dialog);
protected
  record T_airout_rec
  protected
    record port_rec
      constant Modelica.Media.Interfaces.PartialMedium.MassFlowRate m_flow(quantity = "MassFlowRate.Moist air", min = 0.0) = 0
                                                                                                                              "Mass flow rate from the connection point into the component";
      Modelica.Media.Interfaces.Types.AbsolutePressure p
                                                        "Thermodynamic pressure in the connection point";
      constant Modelica.Media.Interfaces.Types.SpecificEnthalpy h_outflow = 45263.238744693415
                                                                                              "Specific thermodynamic enthalpy close to the connection point if m_flow < 0";
      constant Modelica.Media.Interfaces.Types.MassFraction 'Xi_outflow[1]' = 0.01
                                                                                  "Independent mixture mass fractions m_i/m close to the connection point if m_flow < 0";
    end port_rec;
  public
    port_rec port;
    Modelica_Blocks_Interfaces_RealOutput T(unit = "K", displayUnit = "degC", nominal = 300.0, quantity = "ThermodynamicTemperature", min = 0.0)
                                                                                                                                                "Temperature in port medium";
  end T_airout_rec;
public
  T_airout_rec T_airout;
protected
  record T_CWaterout_rec
  protected
    record port_rec
      constant Modelica.Media.Interfaces.PartialMedium.MassFlowRate m_flow(quantity = "MassFlowRate.SimpleLiquidWater", min = 0.0) = 0
                                                                                                                                      "Mass flow rate from the connection point into the component";
      Modelica.Media.Interfaces.Types.AbsolutePressure p
                                                        "Thermodynamic pressure in the connection point";
      constant Modelica.Media.Interfaces.Types.SpecificEnthalpy h_outflow = 83680.0
                                                                                   "Specific thermodynamic enthalpy close to the connection point if m_flow < 0";
    end port_rec;
  public
    port_rec port;
    Modelica_Blocks_Interfaces_RealOutput T(unit = "K", displayUnit = "degC", nominal = 300.0, quantity = "ThermodynamicTemperature", min = 0.0)
                                                                                                                                                "Temperature in port medium";
  end T_CWaterout_rec;
public
  T_CWaterout_rec T_CWaterout;
protected
  record T_floor_rec
    parameter Modelica.SIunits.Temperature T = 288.15
                                                     "Fixed temperature at port";
  protected
    record port_rec
      Modelica.SIunits.Temperature T
                                    "Port temperature";
      Modelica.SIunits.HeatFlowRate Q_flow
                                          "Heat flow rate (positive if flowing from outside into the component)";
    end port_rec;
  public
    port_rec port;
  end T_floor_rec;
public
  T_floor_rec T_floor annotation(Dialog);
protected
  record T_ambient_rec
  protected
    record port_rec
      Modelica.SIunits.Temperature T
                                    "Port temperature";
      Modelica.SIunits.HeatFlowRate Q_flow
                                          "Heat flow rate (positive if flowing from outside into the component)";
    end port_rec;
  public
    port_rec port;
    Modelica_Blocks_Interfaces_RealInput T(unit = "K");
  end T_ambient_rec;
public
  T_ambient_rec T_ambient;
protected
  record levelControl_rec
    parameter Modelica.SIunits.Height hmax(fixed=false)
                                                       "Maximum height of water that can the basin have";
    parameter Modelica.SIunits.Height hmin(fixed=false)
                                                       "Minimum height of water that can the basin have";
    parameter Modelica.SIunits.MassFlowRate m_In(fixed=false)
                                                             "Inlet overflow";
    parameter Modelica.SIunits.MassFlowRate m_Out = 0.001
                                                         "Outlet overflow";
    Modelica_Blocks_Interfaces_RealInput level;
    parameter Modelica_Blocks_Interfaces_RealOutput _m_outflow_start = 0.01;
    Modelica_Blocks_Interfaces_RealOutput m_outflow(min = 0.0, max = 100000.0,start = _m_outflow_start);
  end levelControl_rec;
public
  levelControl_rec levelControl annotation(Dialog);
protected
  record waterOverFlow1_rec
    constant Integer nPorts = 1
                               "Number of ports";
  protected
    record medium_rec
      Real p(unit = "Pa", displayUnit = "bar", nominal = 100000.0, quantity = "Pressure", min = 0.0)
                                                                                                    "Absolute pressure of medium";
      constant Real h(unit = "J/kg", quantity = "SpecificEnergy") = 104600.0
                                                                            "Specific enthalpy of medium";
      constant Modelica.Media.Interfaces.Types.Density d = 995.586
                                                                  "Density of medium";
      constant Modelica.Media.Interfaces.Types.Temperature T = 298.15
                                                                     "Temperature of medium";
      constant Modelica.Media.Interfaces.Types.MassFraction 'X[1]' = 1.0
                                                                        "Mass fractions (= (component mass)/total mass  m_i/m)";
      constant Modelica.Media.Interfaces.Types.SpecificInternalEnergy u = 104600.0
                                                                                  "Specific internal energy of medium";
      constant Modelica.Media.Interfaces.Types.SpecificHeatCapacity R = 0
                                                                         "Gas constant (of mixture if applicable)";
      constant Modelica.Media.Interfaces.Types.MolarMass MM = 0.018015268
                                                                         "Molar mass (of mixture or single fluid)";
    protected
      record state_rec
        Modelica.Media.Interfaces.Types.AbsolutePressure p
                                                          "Absolute pressure of medium";
        constant Modelica.Media.Interfaces.Types.Temperature T = 298.15
                                                                       "Temperature of medium";
      end state_rec;
    public
      state_rec state;
      constant Boolean preferredMediumStates = false
                                                    "= true if StateSelect.prefer shall be used for the independent property variables of the medium";
      constant Boolean standardOrderComponents = true
                                                     "If true, and reducedX = true, the last element of X will be computed from the other ones";
      constant Modelica.SIunits.Conversions.NonSIunits.Temperature_degC T_degC = 25.0
                                                                                     "Temperature of medium in [degC]";
      Modelica.SIunits.Conversions.NonSIunits.Pressure_bar p_bar
                                                                "Absolute pressure of medium in [bar]";
    end medium_rec;
  public
    medium_rec medium;
  protected
    record 'ports[1]_rec'
      Modelica.Media.Interfaces.PartialMedium.MassFlowRate m_flow(quantity = "MassFlowRate.SimpleLiquidWater", min = -1E+060, max = 1E+060)
                                                                                                                                           "Mass flow rate from the connection point into the component";
      Modelica.Media.Interfaces.Types.AbsolutePressure p
                                                        "Thermodynamic pressure in the connection point";
      constant Modelica.Media.Interfaces.Types.SpecificEnthalpy h_outflow = 104600.0
                                                                                    "Specific thermodynamic enthalpy close to the connection point if m_flow < 0";
    end 'ports[1]_rec';
  public
    'ports[1]_rec' 'ports[1]';
    constant Modelica.Media.Interfaces.PartialMedium.MassFlowRate m_flow(quantity = "MassFlowRate.SimpleLiquidWater") = 2
                                                                                                                         "Fixed mass flow rate going out of the fluid port";
    constant Modelica.Media.Interfaces.Types.Temperature T = 298.15
                                                                   "Fixed value of temperature";
    constant Modelica.Media.Interfaces.Types.MassFraction 'X[1]' = 1.0
                                                                      "Fixed value of composition";
    Modelica_Blocks_Interfaces_RealInput m_flow_in
                                                  "Prescribed mass flow rate";
  end waterOverFlow1_rec;
public
  waterOverFlow1_rec waterOverFlow1;
protected
  record sampler_rec
    parameter Modelica.SIunits.Time samplePeriod(min = 1E-013) = 10
                                                                   "Sample period of component";
    parameter Modelica.SIunits.Time startTime = 0
                                                 "First sample time instant";
    Modelica_Blocks_Interfaces_RealInput u
                                          "Continuous input signal";
    Modelica_Blocks_Interfaces_RealOutput y
                                           "Continuous output signal";
  end sampler_rec;
public
  sampler_rec sampler;
  parameter Real _inletCWater_m_flow_start = 0.0
  annotation (Dialog(tab="Input Start Values", group="Input Start Value before call to fmiInitialize"));
protected
  Real _inletCWater_m_flow_old;
public
  Modelica.Blocks.Interfaces.RealInput inletCWater_m_flow(unit = "kg/s", quantity = "MassFlowRate", min = 0.0, max = 100000.0, start = 0.0)
                                                                                                                                           "Inlet cooling water mass flow"
  annotation (Placement(transformation(extent={{-124,47},{-84,87}})));
  parameter Real _inletCWater_T_start = 288.15
  annotation (Dialog(tab="Input Start Values", group="Input Start Value before call to fmiInitialize"));
protected
  Real _inletCWater_T_old;
public
  Modelica.Blocks.Interfaces.RealInput inletCWater_T(unit = "K", displayUnit = "degC", nominal = 300.0, quantity = "ThermodynamicTemperature", min = 1.0, max = 10000.0, start = 288.15)
                                                                                                                                                                                        "INlet cooling water temperature"
  annotation (Placement(transformation(extent={{-124,14},{-84,54}})));
  parameter Real _inletAir_m_flow_start = 0.0
  annotation (Dialog(tab="Input Start Values", group="Input Start Value before call to fmiInitialize"));
protected
  Real _inletAir_m_flow_old;
public
  Modelica.Blocks.Interfaces.RealInput inletAir_m_flow(unit = "kg/s", quantity = "MassFlowRate", min = 0.0, max = 100000.0, start = 0.0)
                                                                                                                                        "Inlet air mass flow"
  annotation (Placement(transformation(extent={{-124,-20},{-84,20}})));
  parameter Real _ambient_T_start = 288.15
  annotation (Dialog(tab="Input Start Values", group="Input Start Value before call to fmiInitialize"));
protected
  Real _ambient_T_old;
public
  Modelica.Blocks.Interfaces.RealInput ambient_T(unit = "K", displayUnit = "degC", nominal = 300.0, quantity = "ThermodynamicTemperature", min = 190.0, max = 647.0, start = 288.15)
                                                                                                                                                                                    "Ambient temperature"
  annotation (Placement(transformation(extent={{-124,-53},{-84,-13}})));
  parameter Real _inletAir_X_start = 0.01
  annotation (Dialog(tab="Input Start Values", group="Input Start Value before call to fmiInitialize"));
protected
  Real _inletAir_X_old;
public
  Modelica.Blocks.Interfaces.RealInput inletAir_X(unit = "1", nominal = 0.1, quantity = "MassFraction", min = 0.0, max = 1.0, start = 0.01)
                                                                                                                                           "Vapour fraction in the air at the entrace (m_vapour/m_air)"
  annotation (Placement(transformation(extent={{-124,-86},{-84,-46}})));
  Modelica.Blocks.Interfaces.RealOutput mWaterIn
                                                "Value for pumped water"
  annotation (Placement(transformation(extent={{100,30},{140,70}})));
  Modelica.Blocks.Interfaces.RealOutput outletAir_T(unit = "K", displayUnit = "degC", nominal = 300.0, quantity = "ThermodynamicTemperature", min = 0.0)
                                                                                                                                                        "Outlet cooling water temperature"
  annotation (Placement(transformation(extent={{100,-20},{140,20}})));
  Modelica.Blocks.Interfaces.RealOutput outletCWater_T(unit = "K", displayUnit = "degC", nominal = 300.0, quantity = "ThermodynamicTemperature", min = 0.0)
                                                                                                                                                           "Outle air temperature"
  annotation (Placement(transformation(extent={{100,-70},{140,-30}})));
public
  parameter String fmi_instanceName="CompleteCCT_inertia_FMU_fmu"
  annotation (Dialog(tab="FMI", group="Instance name"));
  parameter Boolean fmi_loggingOn=false
  annotation (Dialog(tab="FMI", group="Enable logging"));
  parameter Boolean fmi_pullInputsForInitialization=true
  "Set to false when using the FMU in feedback connections"
  annotation (Dialog(tab="FMI", group="Inputs for initialization"));
  parameter Boolean fmi_InputTime=false
  "Time point of input used when calling doStep."
  annotation (Evaluate=true,Dialog(tab="FMI", group="Input Handling"),choices(choice= false "StepEnd", choice= true "StepStart"));
  parameter Boolean fmi_UsePreOnInputSignals=true
  annotation (Evaluate=true,Dialog(tab="FMI", group="Input Handling"));
  parameter Real fmi_StartTime = 0.0
  annotation (Dialog(tab="FMI", group="Step time"));
  parameter Real fmi_StopTime = 15000.0
  annotation (Dialog(tab="FMI", group="Step time"));
  parameter Real fmi_NumberOfSteps = 500
  annotation (Dialog(tab="FMI", group="Step time"));
  parameter Real fmi_CommunicationStepSize=(fmi_StopTime-fmi_StartTime)/fmi_NumberOfSteps
  annotation (Dialog(tab="FMI", group="Step time"));
  parameter Integer stepSizeScaleFactor = 1 "Number of doSteps called between two CommunicationStepSize"
  annotation (Dialog(tab="FMI", group="Step time"));
  parameter Boolean fmi_forceShutDownAtStopTime=false
  annotation (Dialog(tab="FMI", group="Step time"));
  parameter String fmi_fmuLocation="file:///"+ModelicaServices.ExternalReferences.loadResource("modelica://CompleteCCT_inertia_FMU_fmu/Resources/Library/FMU/CompleteCCT_inertia_FMU")
  annotation (Dialog(tab="FMI", group="Instantiation"));
protected
fmi_Functions.fmiModel fmi;
Boolean fmi_StepOK;
parameter Real fmi_Initialized(fixed=false);
parameter Real fmi_AParamsAndStart(fixed=false);
parameter Real fmi_initInput0(start=0,fixed=false);
parameter Real fmi_initInput1(start=0,fixed=false);
parameter Real fmi_initInput2(start=0,fixed=false);
parameter Real fmi_initInput3(start=0,fixed=false);
parameter Real fmi_initInput4(start=0,fixed=false);
Real RealVariables1[100];
Real RealVariables2[100];
Real RealVariables3[100];
Real RealVariables4[100];
Real RealVariables5[100];
Real RealVariables6[100];
Real RealVariables7[100];
Real RealVariables8[100];
Real RealVariables9[100];
Real RealVariables10[100];
Real RealVariables11[100];
Real RealVariables12[100];
Real RealVariables13[100];
Real RealVariables14[100];
Real RealVariables15[100];
Real RealVariables16[100];
Real RealVariables17[100];
Real RealVariables18[100];
Real RealVariables19[100];
Real RealVariables20[100];
Real RealVariables21[100];
Real RealVariables22[100];
Real RealVariables23[100];
Real RealVariables24[100];
Real RealVariables25[100];
Real RealVariables26[100];
Real RealVariables27[39];
Real RealDependentParameters1[100];
Real RealDependentParameters2[100];
Real RealDependentParameters3[100];
Real RealDependentParameters4[100];
Real RealDependentParameters5[100];
Real RealDependentParameters6[100];
Real RealDependentParameters7[100];
Real RealDependentParameters8[100];
Real RealDependentParameters9[100];
Real RealDependentParameters10[100];
Real RealDependentParameters11[15];
Integer IntegerDependentParameters[2];
package fmi_Functions
  class fmiModel
  extends ExternalObject;
    function constructor "Initialize FMI model"
      extends Modelica.Icons.Function;
      input String instanceName;
      input Boolean loggingOn;
        input String fmuLocation;
      output fmiModel fmi;
      external"C" fmi = Modelica_0IK4_0TEKNIKER_DCOL_Generation_CoolingTowers_FMI_CompleteCCT_0inertia_0Dym_fmiInstantiateModel2(instanceName, loggingOn, fmuLocation)
      annotation(Header="
#ifndef Modelica_0IK4_0TEKNIKER_DCOL_Generation_CoolingTowers_FMI_CompleteCCT_0inertia_0Dym_Instantiate_C
#define Modelica_0IK4_0TEKNIKER_DCOL_Generation_CoolingTowers_FMI_CompleteCCT_0inertia_0Dym_Instantiate_C 1
#include <stdlib.h>
#include \"FMI/fmiImport.h\"
#ifndef Modelica_0IK4_0TEKNIKER_DCOL_Generation_CoolingTowers_FMI_CompleteCCT_0inertia_0Dym_MYSTRCMP_C
#define Modelica_0IK4_0TEKNIKER_DCOL_Generation_CoolingTowers_FMI_CompleteCCT_0inertia_0Dym_MYSTRCMP_C 1
int Modelica_0IK4_0TEKNIKER_DCOL_Generation_CoolingTowers_FMI_CompleteCCT_0inertia_0Dymmystrcmp(const void *_a, const void *_b) {
  char *a = _a;
  char *const *b = _b;
  return strcmp(a, *b);
}
#endif
void Modelica_0IK4_0TEKNIKER_DCOL_Generation_CoolingTowers_FMI_CompleteCCT_0inertia_0DymLogger(fmiComponent c, fmiString instanceName, fmiStatus status,
         fmiString category, fmiString message, ...) {
  char msg[4096];
  char buf[4096];
  int len;
  va_list ap;
  va_start(ap,message);
#if defined(_MSC_VER) && _MSC_VER>=1200
  len = _snprintf(msg, sizeof(msg)/sizeof(*msg), \"%s: %s\", instanceName, message);
  if (len < 0) goto fail;
  len = _vsnprintf(buf, sizeof(buf)/sizeof(*buf) - 2, msg, ap);
  if (len < 0) goto fail;
#else
  len = snprintf(msg, sizeof(msg)/sizeof(*msg), \"%s: %s\", instanceName, message);
  if (len < 0) goto fail;
  len = vsnprintf(buf, sizeof(buf)/sizeof(*buf) - 2, msg, ap);
  if (len < 0) goto fail;
#endif
  if( len>0 && len <4096 && buf[len - 1]!='\\n'){
    buf[len] = '\\n';
    buf[len + 1] = 0;
  }
  va_end(ap);
  switch (status) {
    case fmiFatal:
      ModelicaMessage(\"[fmiFatal]: \");
      break;
    case fmiError:
      ModelicaMessage(\"[fmiError]: \");
      break;
    case fmiDiscard:
      ModelicaMessage(\"[fmiDiscard]: \");
      break;
    case fmiWarning:
      ModelicaMessage(\"[fmiWarning]: \");
      break;
    case fmiOK:
      ModelicaMessage(\"[fmiOK]: \");
      break;
  }
  ModelicaMessage(buf);
  return;
fail:
  ModelicaMessage(\"Logger failed, message too long?\");
}
void * Modelica_0IK4_0TEKNIKER_DCOL_Generation_CoolingTowers_FMI_CompleteCCT_0inertia_0Dym_fmiInstantiateModel2(const char*instanceName, fmiBoolean loggingOn, const char* fmuLocation) {
  static fmiCoSimCallbackFunctions funcs = {&Modelica_0IK4_0TEKNIKER_DCOL_Generation_CoolingTowers_FMI_CompleteCCT_0inertia_0DymLogger, &calloc, &free, NULL};
  struct dy_Extended* res;

  res = calloc(1, sizeof(struct dy_Extended));
  if (res!=0) {
    if (!(res->hInst=LoadLibraryW(L\"Modelica_0IK4_0TEKNIKER_DCOL_Generation_CoolingTowers_FMI_CompleteCCT_0inertia_0Dym.dll\"))) {
      ModelicaError(\"Loading of FMU dynamic link library (Modelica_0IK4_0TEKNIKER_DCOL_Generation_CoolingTowers_FMI_CompleteCCT_0inertia_0Dym.dll) failed!\");
      return 0;
    }
    if(!(res->dyFmiInstantiateSlave=(fmiInstantiateSlaveFunc)GetProcAddress(res->hInst,\"Modelica_0IK4_0TEKNIKER_DCOL_Generation_CoolingTowers_FMI_CompleteCCT_0inertia_0Dym_fmiInstantiateSlave\"))){
      ModelicaError(\"GetProcAddress failed for fmiInstantiateSlave!\\n The model was imported as a Co-Simulation FMU but could not load the CS specific function fmiInstantiateSlave\\n Verify that the FMU supports Co-Simulation\");
      return 0;
    }
    if(!(res->dyFmiFreeSlaveInstance=(fmiFreeSlaveInstanceFunc)GetProcAddress(res->hInst,\"Modelica_0IK4_0TEKNIKER_DCOL_Generation_CoolingTowers_FMI_CompleteCCT_0inertia_0Dym_fmiFreeSlaveInstance\"))){
      ModelicaError(\"GetProcAddress failed for fmiFreeSlaveInstance!\\n The model was imported as a Co-Simulation FMU but could not load the CS specific function fmiFreeSlaveInstance\\n Verify that the FMU supports Co-Simulation\");
      return 0;
    }
    if(!(res->dyFmiInitializeSlave=(fmiInitializeSlaveFunc)GetProcAddress(res->hInst,\"Modelica_0IK4_0TEKNIKER_DCOL_Generation_CoolingTowers_FMI_CompleteCCT_0inertia_0Dym_fmiInitializeSlave\"))){
      ModelicaError(\"GetProcAddress failed for fmiInitializeSlave!\\n The model was imported as a Co-Simulation FMU but could not load the CS specific function fmiInitializeSlave\\n Verify that the FMU supports Co-Simulation\");
      return 0;
    }
    if(!(res->dyFmiResetSlave=(fmiResetSlaveFunc)GetProcAddress(res->hInst,\"Modelica_0IK4_0TEKNIKER_DCOL_Generation_CoolingTowers_FMI_CompleteCCT_0inertia_0Dym_fmiResetSlave\"))){
      ModelicaError(\"GetProcAddress failed for fmiResetSlave!\\n The model was imported as a Co-Simulation FMU but could not load the CS specific function fmiResetSlave\\n Verify that the FMU supports Co-Simulation\");
      return 0;
    }
    if(!(res->dyFmiDoStep=(fmiDoStepFunc)GetProcAddress(res->hInst,\"Modelica_0IK4_0TEKNIKER_DCOL_Generation_CoolingTowers_FMI_CompleteCCT_0inertia_0Dym_fmiDoStep\"))){
      ModelicaError(\"GetProcAddress failed for fmiDoStep!\\n The model was imported as a Co-Simulation FMU but could not load the CS specific function fmiDoStep\\n Verify that the FMU supports Co-Simulation\");
      return 0;
    }
    if(!(res->dyFmiTerminateSlave=(fmiTerminateSlaveFunc)GetProcAddress(res->hInst,\"Modelica_0IK4_0TEKNIKER_DCOL_Generation_CoolingTowers_FMI_CompleteCCT_0inertia_0Dym_fmiTerminateSlave\"))){
      ModelicaError(\"GetProcAddress failed for fmiTerminateSlave!\\n The model was imported as a Co-Simulation FMU but could not load the CS specific function fmiTerminateSlave\\n Verify that the FMU supports Co-Simulation\");
      return 0;
    }
    if (!(res->dyFmiSetReal=(fmiSetRealFunc)GetProcAddress(res->hInst,\"Modelica_0IK4_0TEKNIKER_DCOL_Generation_CoolingTowers_FMI_CompleteCCT_0inertia_0Dym_fmiSetReal\"))) {
      ModelicaError(\"GetProcAddress failed for fmiSetReal!\");
      return 0;
    }
    if (!(res->dyFmiGetReal=(fmiGetRealFunc)GetProcAddress(res->hInst,\"Modelica_0IK4_0TEKNIKER_DCOL_Generation_CoolingTowers_FMI_CompleteCCT_0inertia_0Dym_fmiGetReal\"))) {
      ModelicaError(\"GetProcAddress failed for fmiGetReal!\");
      return 0;
    }
    if (!(res->dyFmiSetInteger=(fmiSetIntegerFunc)GetProcAddress(res->hInst,\"Modelica_0IK4_0TEKNIKER_DCOL_Generation_CoolingTowers_FMI_CompleteCCT_0inertia_0Dym_fmiSetInteger\"))) {
      ModelicaError(\"GetProcAddress failed for fmiSetInteger!\");
      return 0;
    }
    if (!(res->dyFmiGetInteger=(fmiGetIntegerFunc)GetProcAddress(res->hInst,\"Modelica_0IK4_0TEKNIKER_DCOL_Generation_CoolingTowers_FMI_CompleteCCT_0inertia_0Dym_fmiGetInteger\"))) {
      ModelicaError(\"GetProcAddress failed for fmiGetInteger!\");
      return 0;
    }
    if (!(res->dyFmiSetBoolean=(fmiSetBooleanFunc)GetProcAddress(res->hInst,\"Modelica_0IK4_0TEKNIKER_DCOL_Generation_CoolingTowers_FMI_CompleteCCT_0inertia_0Dym_fmiSetBoolean\"))) {
      ModelicaError(\"GetProcAddress failed for fmiSetBoolean!\");
      return 0;
    }
    if (!(res->dyFmiGetBoolean=(fmiGetBooleanFunc)GetProcAddress(res->hInst,\"Modelica_0IK4_0TEKNIKER_DCOL_Generation_CoolingTowers_FMI_CompleteCCT_0inertia_0Dym_fmiGetBoolean\"))) {
      ModelicaError(\"GetProcAddress failed for fmiGetBoolean!\");
      return 0;
    }
    if (!(res->dyFmiSetString=(fmiSetStringFunc)GetProcAddress(res->hInst,\"Modelica_0IK4_0TEKNIKER_DCOL_Generation_CoolingTowers_FMI_CompleteCCT_0inertia_0Dym_fmiSetString\"))) {
      ModelicaError(\"GetProcAddress failed for fmiSetString!\");
      return 0;
    }
    if (!(res->dyFmiGetString=(fmiGetStringFunc)GetProcAddress(res->hInst,\"Modelica_0IK4_0TEKNIKER_DCOL_Generation_CoolingTowers_FMI_CompleteCCT_0inertia_0Dym_fmiGetString\"))) {
      ModelicaError(\"GetProcAddress failed for fmiGetString!\");
      return 0;
    }
    res->m=res->dyFmiInstantiateSlave(instanceName, \"{f7ab27ff-1f4f-4a87-bea9-ccc1c687cbba}\", fmuLocation, \"application/x-dymolakernel\", 0, fmiFalse, fmiFalse, funcs, loggingOn);
    if (0==res->m) {free(res);res=0;ModelicaError(\"InstantiateSlave failed\");}
    else {res->dyTriggered=0;res->dyTime=res->dyLastTime=-1e37;}
  }
  return res;
}
#endif", Library="Modelica_0IK4_0TEKNIKER_DCOL_Generation_CoolingTowers_FMI_CompleteCCT_0inertia_0Dym", LibraryDirectory="modelica://DCOL/Resources/Library/FMU/CompleteCCT_inertia_FMU/binaries",                        __Dymola_CriticalRegion="Modelica_0IK4_0TEKNIKER_DCOL_Generation_CoolingTowers_FMI_CompleteCCT_0inertia_0Dym");
    end constructor;

    function destructor "Release storage of FMI model"
      extends Modelica.Icons.Function;
      input fmiModel fmi;
      external"C"
                 Modelica_0IK4_0TEKNIKER_DCOL_Generation_CoolingTowers_FMI_CompleteCCT_0inertia_0Dym_fmiFreeModelInstance2(fmi);
      annotation (Header="
#ifndef Modelica_0IK4_0TEKNIKER_DCOL_Generation_CoolingTowers_FMI_CompleteCCT_0inertia_0Dym_Free_C
#define Modelica_0IK4_0TEKNIKER_DCOL_Generation_CoolingTowers_FMI_CompleteCCT_0inertia_0Dym_Free_C 1
#include <stdlib.h>
#include \"FMI/fmiImport.h\"
void Modelica_0IK4_0TEKNIKER_DCOL_Generation_CoolingTowers_FMI_CompleteCCT_0inertia_0Dym_fmiFreeModelInstance2(void*m) {
  struct dy_Extended*a=m;
  if (a) {
    a->dyFmiTerminateSlave(a->m);
    a->dyFmiFreeSlaveInstance(a->m);
    FreeLibrary(a->hInst);
    free(a);
  }
}
#endif", Library="Modelica_0IK4_0TEKNIKER_DCOL_Generation_CoolingTowers_FMI_CompleteCCT_0inertia_0Dym", LibraryDirectory="modelica://DCOL/Resources/Library/FMU/CompleteCCT_inertia_FMU/binaries",                        __Dymola_CriticalRegion="Modelica_0IK4_0TEKNIKER_DCOL_Generation_CoolingTowers_FMI_CompleteCCT_0inertia_0Dym");
    end destructor;
  end fmiModel;

    function fmiInitializeSlave
      input fmiModel fmi;
      input Real tStart;
      input Boolean forceShutDownAtTStop;
       input Real tStop;
      input Real preAvailable;
      output Real postAvailable=preAvailable;
      external"C" Modelica_0IK4_0TEKNIKER_DCOL_Generation_CoolingTowers_FMI_CompleteCCT_0inertia_0Dym_fmiInitializeSlave2(fmi, tStart, forceShutDownAtTStop, tStop);
      annotation (Header="
#ifndef Modelica_0IK4_0TEKNIKER_DCOL_Generation_CoolingTowers_FMI_CompleteCCT_0inertia_0Dym_InitializeSlave_C
#define Modelica_0IK4_0TEKNIKER_DCOL_Generation_CoolingTowers_FMI_CompleteCCT_0inertia_0Dym_InitializeSlave_C 1
#include <stdlib.h>
#include \"FMI/fmiImport.h\"
double Modelica_0IK4_0TEKNIKER_DCOL_Generation_CoolingTowers_FMI_CompleteCCT_0inertia_0Dym_fmiInitializeSlave2(void*m, fmiReal tStart, fmiBoolean forceShutDownAtTStop, fmiReal tStop) {
  struct dy_Extended*a=m;
  fmiStatus status=fmiFatal;
  if (a) {
    status=a->dyFmiInitializeSlave(a->m, tStart, forceShutDownAtTStop, tStop);
    a->dyTriggered=0;
    a->dyLastTime=a->dyTime;
  }
  if (status!=fmiOK && status!=fmiWarning) ModelicaError(\"InitializeSlave failed\");
  return 1e37;
}
#endif", Library="Modelica_0IK4_0TEKNIKER_DCOL_Generation_CoolingTowers_FMI_CompleteCCT_0inertia_0Dym", LibraryDirectory="modelica://DCOL/Resources/Library/FMU/CompleteCCT_inertia_FMU/binaries",                        __Dymola_CriticalRegion="Modelica_0IK4_0TEKNIKER_DCOL_Generation_CoolingTowers_FMI_CompleteCCT_0inertia_0Dym");
    end fmiInitializeSlave;

    function fmiDoStep
     input fmiModel fmi;
     input Real currentTime;
     input Real stepSize;
     output Boolean stepOK;
     external"C" stepOK= Modelica_0IK4_0TEKNIKER_DCOL_Generation_CoolingTowers_FMI_CompleteCCT_0inertia_0Dym_fmiDoStep2(fmi, currentTime, stepSize);
     annotation (Header="
#ifndef Modelica_0IK4_0TEKNIKER_DCOL_Generation_CoolingTowers_FMI_CompleteCCT_0inertia_0Dym_DoStep_C
#define Modelica_0IK4_0TEKNIKER_DCOL_Generation_CoolingTowers_FMI_CompleteCCT_0inertia_0Dym_DoStep_C 1
#include <stdlib.h>
#include \"FMI/fmiImport.h\"
double Modelica_0IK4_0TEKNIKER_DCOL_Generation_CoolingTowers_FMI_CompleteCCT_0inertia_0Dym_fmiDoStep2(void*m, double currentTime, double stepSize) {
  struct dy_Extended*a=m;
  fmiStatus status=fmiFatal;
  if (a) {
    status=a->dyFmiDoStep(a->m, currentTime, stepSize, fmiTrue);
  }
  if (status!=fmiOK && status!=fmiWarning) ModelicaError(\"DoStep failed\");
  return 1.0;
}
#endif", Library="Modelica_0IK4_0TEKNIKER_DCOL_Generation_CoolingTowers_FMI_CompleteCCT_0inertia_0Dym", LibraryDirectory="modelica://DCOL/Resources/Library/FMU/CompleteCCT_inertia_FMU/binaries",                        __Dymola_CriticalRegion="Modelica_0IK4_0TEKNIKER_DCOL_Generation_CoolingTowers_FMI_CompleteCCT_0inertia_0Dym");
    end fmiDoStep;

    function fmiResetSlave
      input fmiModel fmi;
      output Boolean resetOK;
      external"C" resetOK = Modelica_0IK4_0TEKNIKER_DCOL_Generation_CoolingTowers_FMI_CompleteCCT_0inertia_0Dym_fmiResetSlave2(fmi);
      annotation (Header="
#ifndef Modelica_0IK4_0TEKNIKER_DCOL_Generation_CoolingTowers_FMI_CompleteCCT_0inertia_0Dym_ResetSlave_C
#define Modelica_0IK4_0TEKNIKER_DCOL_Generation_CoolingTowers_FMI_CompleteCCT_0inertia_0Dym_ResetSlave_C 1
#include <stdlib.h>
#include \"FMI/fmiImport.h\"
double Modelica_0IK4_0TEKNIKER_DCOL_Generation_CoolingTowers_FMI_CompleteCCT_0inertia_0Dym_fmiResetSlave2(void*m) {
  struct dy_Extended*a=m;
  fmiStatus status=fmiFatal;
  if (a) {
    status=a->dyFmiResetSlave(a->m);
  }
  if (status!=fmiOK && status!=fmiWarning) ModelicaError(\"resetSlave failed\");
    return 1.0;
  }
#endif", Library="Modelica_0IK4_0TEKNIKER_DCOL_Generation_CoolingTowers_FMI_CompleteCCT_0inertia_0Dym", LibraryDirectory="modelica://DCOL/Resources/Library/FMU/CompleteCCT_inertia_FMU/binaries",                        __Dymola_CriticalRegion="Modelica_0IK4_0TEKNIKER_DCOL_Generation_CoolingTowers_FMI_CompleteCCT_0inertia_0Dym");
    end fmiResetSlave;

    function fmiSetReal
      input fmiModel fmi;
      input Integer refs[:];
      input Real vals[size(refs, 1)];
      output Real dummy= 1;
      external"C"
                 Modelica_0IK4_0TEKNIKER_DCOL_Generation_CoolingTowers_FMI_CompleteCCT_0inertia_0Dym_fmiSetReal2(
        fmi,
        refs,
        size(refs, 1),
        vals);
        annotation (Header="
#ifndef Modelica_0IK4_0TEKNIKER_DCOL_Generation_CoolingTowers_FMI_CompleteCCT_0inertia_0Dym_SetReal_C
#define Modelica_0IK4_0TEKNIKER_DCOL_Generation_CoolingTowers_FMI_CompleteCCT_0inertia_0Dym_SetReal_C 1
#include <stdlib.h>
#include \"FMI/fmiImport.h\"
void Modelica_0IK4_0TEKNIKER_DCOL_Generation_CoolingTowers_FMI_CompleteCCT_0inertia_0Dym_fmiSetReal2(void*m, const int*refs, size_t nrefs, const double*vals) {
  struct dy_Extended*a=m;
  fmiStatus status=fmiFatal;
  if(!nrefs){return;}
  if (a) {
    status=a->dyFmiSetReal(a->m, refs, nrefs, vals);
  }
  if (status!=fmiOK && status!=fmiWarning) ModelicaError(\"SetReal failed\");
}
#endif", Library="Modelica_0IK4_0TEKNIKER_DCOL_Generation_CoolingTowers_FMI_CompleteCCT_0inertia_0Dym", LibraryDirectory="modelica://DCOL/Resources/Library/FMU/CompleteCCT_inertia_FMU/binaries",                        __Dymola_CriticalRegion="Modelica_0IK4_0TEKNIKER_DCOL_Generation_CoolingTowers_FMI_CompleteCCT_0inertia_0Dym",__Dymola_IdemPotent=true, __Dymola_VectorizedExceptFirst=true);
    end fmiSetReal;

    function fmiSetRealParam
      input fmiModel fmi;
      input Integer refs[:];
      input Real vals[size(refs, 1)];
    protected
      Real oldVals[size(refs, 1)];
      external"C"
                 Modelica_0IK4_0TEKNIKER_DCOL_Generation_CoolingTowers_FMI_CompleteCCT_0inertia_0Dym_fmiSetRealParam2(
        fmi,
        refs,
        size(refs, 1),
        vals,
        oldVals);
        annotation (Header="
#ifndef Modelica_0IK4_0TEKNIKER_DCOL_Generation_CoolingTowers_FMI_CompleteCCT_0inertia_0Dym_SetRealParam_C
#define Modelica_0IK4_0TEKNIKER_DCOL_Generation_CoolingTowers_FMI_CompleteCCT_0inertia_0Dym_SetRealParam_C 1
#include <stdlib.h>
#include \"FMI/fmiImport.h\"
void Modelica_0IK4_0TEKNIKER_DCOL_Generation_CoolingTowers_FMI_CompleteCCT_0inertia_0Dym_fmiSetRealParam2(void*m, const int*refs, size_t nrefs, const double*vals, double*oldVals) {
  struct dy_Extended*a=m;
  fmiStatus status=fmiFatal;
  int i = 0;
  if(!nrefs){return;}
  if (a) {
    if(a->currentMode == dyInstantiationMode){
                status=a->dyFmiSetReal(a->m, refs, nrefs, vals);
    }else{
      status=a->dyFmiGetReal(a->m, refs, nrefs, oldVals);
      for(i=0; i<nrefs;++i){
        if( abs(vals[i]-oldVals[i])> 5e-16){
          ModelicaError(\"SetRealParameter: new parameters with diferent values are being set after initialization, this is not allowed\");
        }
      }
    }
  }
  if (status!=fmiOK && status!=fmiWarning) ModelicaError(\"SetReal failed\");
}
#endif", Library="Modelica_0IK4_0TEKNIKER_DCOL_Generation_CoolingTowers_FMI_CompleteCCT_0inertia_0Dym", LibraryDirectory="modelica://DCOL/Resources/Library/FMU/CompleteCCT_inertia_FMU/binaries",                        __Dymola_CriticalRegion="Modelica_0IK4_0TEKNIKER_DCOL_Generation_CoolingTowers_FMI_CompleteCCT_0inertia_0Dym",__Dymola_IdemPotent=true, __Dymola_VectorizedExceptFirst=true);
    end fmiSetRealParam;

    function fmiGetRealScalar
      input fmiModel fmi;
      input Integer ref;
      input Real dummy;
      output Real val;
    algorithm
        val := scalar(fmiGetReal(fmi, {ref}, dummy));
    end fmiGetRealScalar;

    function fmiGetReal
      input fmiModel fmi;
      input Integer refs[:];
      output Real vals[size(refs, 1)];
      input Real preAvailable;
      external"C" Modelica_0IK4_0TEKNIKER_DCOL_Generation_CoolingTowers_FMI_CompleteCCT_0inertia_0Dym_fmiGetReal2(
        fmi,
        refs,
        size(refs, 1),
        vals);
      annotation (Header="
#ifndef Modelica_0IK4_0TEKNIKER_DCOL_Generation_CoolingTowers_FMI_CompleteCCT_0inertia_0Dym_GetReal_C
#define Modelica_0IK4_0TEKNIKER_DCOL_Generation_CoolingTowers_FMI_CompleteCCT_0inertia_0Dym_GetReal_C 1
#include <stdlib.h>
#include \"FMI/fmiImport.h\"
void Modelica_0IK4_0TEKNIKER_DCOL_Generation_CoolingTowers_FMI_CompleteCCT_0inertia_0Dym_fmiGetReal2(void*m, const int*refs, size_t nrefs, double*vals) {
  struct dy_Extended*a=m;
  fmiStatus status=fmiFatal;
  if (a) {
    status=a->dyFmiGetReal(a->m, refs, nrefs, vals);
  }
  if (status!=fmiOK && status!=fmiWarning) ModelicaError(\"GetReal failed\");
}
#endif", Library="Modelica_0IK4_0TEKNIKER_DCOL_Generation_CoolingTowers_FMI_CompleteCCT_0inertia_0Dym", LibraryDirectory="modelica://DCOL/Resources/Library/FMU/CompleteCCT_inertia_FMU/binaries",                        __Dymola_CriticalRegion="Modelica_0IK4_0TEKNIKER_DCOL_Generation_CoolingTowers_FMI_CompleteCCT_0inertia_0Dym");
    end fmiGetReal;

    function fmiGetIntegerScalar
      input fmiModel fmi;
      input Integer ref;
      input Integer dummy;
      output Integer val;
    algorithm
        val := scalar(fmiGetInteger(fmi, {ref}, dummy));
    end fmiGetIntegerScalar;

    function fmiGetInteger
      input fmiModel fmi;
      input Integer refs[:];
      output Integer vals[size(refs, 1)];
      input Integer preAvailable;
      external"C" Modelica_0IK4_0TEKNIKER_DCOL_Generation_CoolingTowers_FMI_CompleteCCT_0inertia_0Dym_fmiGetInteger2(
        fmi,
        refs,
        size(refs, 1),
        vals);
      annotation (Header="
#ifndef Modelica_0IK4_0TEKNIKER_DCOL_Generation_CoolingTowers_FMI_CompleteCCT_0inertia_0Dym_GetInteger_C
#define Modelica_0IK4_0TEKNIKER_DCOL_Generation_CoolingTowers_FMI_CompleteCCT_0inertia_0Dym_GetInteger_C 1
#include <stdlib.h>
#include \"FMI/fmiImport.h\"
void Modelica_0IK4_0TEKNIKER_DCOL_Generation_CoolingTowers_FMI_CompleteCCT_0inertia_0Dym_fmiGetInteger2(void*m, const int*refs, size_t nrefs, int*vals) {
  struct dy_Extended*a=m;
  fmiStatus status=fmiFatal;
  if (a) {
    status=a->dyFmiGetInteger(a->m, refs, nrefs, vals);
  }
  if (status!=fmiOK && status!=fmiWarning) ModelicaError(\"GetInteger failed\");
}
#endif", Library="Modelica_0IK4_0TEKNIKER_DCOL_Generation_CoolingTowers_FMI_CompleteCCT_0inertia_0Dym", LibraryDirectory="modelica://DCOL/Resources/Library/FMU/CompleteCCT_inertia_FMU/binaries",                        __Dymola_CriticalRegion="Modelica_0IK4_0TEKNIKER_DCOL_Generation_CoolingTowers_FMI_CompleteCCT_0inertia_0Dym");
    end fmiGetInteger;

    function fmiSetInteger
    input fmiModel fmi;
      input Integer refs[:];
      input Integer vals[size(refs, 1)];
      output Real dummy= 1;
      external"C" Modelica_0IK4_0TEKNIKER_DCOL_Generation_CoolingTowers_FMI_CompleteCCT_0inertia_0Dym_fmiSetInteger2(
        fmi,
        refs,
        size(refs, 1),
        vals);
        annotation (Header="
#ifndef Modelica_0IK4_0TEKNIKER_DCOL_Generation_CoolingTowers_FMI_CompleteCCT_0inertia_0Dym_SetInteger_C
#define Modelica_0IK4_0TEKNIKER_DCOL_Generation_CoolingTowers_FMI_CompleteCCT_0inertia_0Dym_SetInteger_C 1
#include <stdlib.h>
#include \"FMI/fmiImport.h\"
void Modelica_0IK4_0TEKNIKER_DCOL_Generation_CoolingTowers_FMI_CompleteCCT_0inertia_0Dym_fmiSetInteger2(void*m, const int*refs, size_t nrefs, int*vals) {
  struct dy_Extended*a=m;
  fmiStatus status=fmiFatal;
  if(!nrefs){return;}
  if (a) {
    status=a->dyFmiSetInteger(a->m, refs, nrefs, vals);
  }
  if (status!=fmiOK && status!=fmiWarning) ModelicaError(\"SetInteger failed\");
}
#endif", Library="Modelica_0IK4_0TEKNIKER_DCOL_Generation_CoolingTowers_FMI_CompleteCCT_0inertia_0Dym", LibraryDirectory="modelica://DCOL/Resources/Library/FMU/CompleteCCT_inertia_FMU/binaries",                        __Dymola_CriticalRegion="Modelica_0IK4_0TEKNIKER_DCOL_Generation_CoolingTowers_FMI_CompleteCCT_0inertia_0Dym",__Dymola_IdemPotent=true, __Dymola_VectorizedExceptFirst=true);
    end fmiSetInteger;

    function fmiSetIntegerParam
    input fmiModel fmi;
      input Integer refs[:];
      input Integer vals[size(refs, 1)];
    protected
      Integer oldVals[size(refs, 1)];
      external"C" Modelica_0IK4_0TEKNIKER_DCOL_Generation_CoolingTowers_FMI_CompleteCCT_0inertia_0Dym_fmiSetIntegerParam2(
        fmi,
        refs,
        size(refs, 1),
        vals,
        oldVals);
        annotation (Header="
#ifndef Modelica_0IK4_0TEKNIKER_DCOL_Generation_CoolingTowers_FMI_CompleteCCT_0inertia_0Dym_SetIntegerParam_C
#define Modelica_0IK4_0TEKNIKER_DCOL_Generation_CoolingTowers_FMI_CompleteCCT_0inertia_0Dym_SetIntegerParam_C 1
#include <stdlib.h>
#include \"FMI/fmiImport.h\"
void Modelica_0IK4_0TEKNIKER_DCOL_Generation_CoolingTowers_FMI_CompleteCCT_0inertia_0Dym_fmiSetIntegerParam2(void*m, const int*refs, size_t nrefs, int*vals, int*oldVals) {
  struct dy_Extended*a=m;
  fmiStatus status=fmiFatal;
  int i=0;
  if(!nrefs){return;}
  if (a) {
    if(a->currentMode == dyInstantiationMode){
      status=a->dyFmiSetInteger(a->m, refs, nrefs, vals);
    }else{
      status=a->dyFmiGetInteger(a->m, refs, nrefs, oldVals);
      for(i = 0; i< nrefs; ++i){
        if(vals[i]!=oldVals[i]){
          ModelicaError(\"SetIntegerParameter: new parameters with diferent values are being set after initialization, this is not allowed\");
        }
      }
    }
  }
  if (status!=fmiOK && status!=fmiWarning) ModelicaError(\"SetInteger failed\");
}
#endif", Library="Modelica_0IK4_0TEKNIKER_DCOL_Generation_CoolingTowers_FMI_CompleteCCT_0inertia_0Dym", LibraryDirectory="modelica://DCOL/Resources/Library/FMU/CompleteCCT_inertia_FMU/binaries",                        __Dymola_CriticalRegion="Modelica_0IK4_0TEKNIKER_DCOL_Generation_CoolingTowers_FMI_CompleteCCT_0inertia_0Dym",__Dymola_IdemPotent=true, __Dymola_VectorizedExceptFirst=true);
    end fmiSetIntegerParam;

    function fmiGetBooleanScalar
      input fmiModel fmi;
      input Integer ref;
      input Integer dummy;
      output Boolean val;
    algorithm
        val := scalar(fmiGetBoolean(fmi, {ref}, dummy));
    end fmiGetBooleanScalar;

    function fmiGetBoolean
      input fmiModel fmi;
      input Integer refs[:];
      output Boolean vals[size(refs, 1)];
      input Integer preAvailable;
      external"C" Modelica_0IK4_0TEKNIKER_DCOL_Generation_CoolingTowers_FMI_CompleteCCT_0inertia_0Dym_fmiGetBoolean2(
        fmi,
        refs,
        size(refs, 1),
        vals);
        annotation (Header="
#ifndef Modelica_0IK4_0TEKNIKER_DCOL_Generation_CoolingTowers_FMI_CompleteCCT_0inertia_0Dym_GetBoolean_C
#define Modelica_0IK4_0TEKNIKER_DCOL_Generation_CoolingTowers_FMI_CompleteCCT_0inertia_0Dym_GetBoolean_C 1
#include \"FMI/fmiImport.h\"
void Modelica_0IK4_0TEKNIKER_DCOL_Generation_CoolingTowers_FMI_CompleteCCT_0inertia_0Dym_fmiGetBoolean2(void*m, const int* refs, size_t nr, int* vals) {
  int i;
  struct dy_Extended*a=m;
  fmiStatus status=fmiFatal;
  if (a) {
    status=a->dyFmiGetBoolean(a->m, refs, nr, (fmiBoolean*)(vals));
  }
  if (status!=fmiOK && status!=fmiWarning) ModelicaError(\"GetBoolean failed\");
  for(i=nr-1;i>=0;i--) vals[i]=((fmiBoolean*)(vals))[i];
}
#endif", Library="Modelica_0IK4_0TEKNIKER_DCOL_Generation_CoolingTowers_FMI_CompleteCCT_0inertia_0Dym", LibraryDirectory="modelica://DCOL/Resources/Library/FMU/CompleteCCT_inertia_FMU/binaries",                        __Dymola_CriticalRegion="Modelica_0IK4_0TEKNIKER_DCOL_Generation_CoolingTowers_FMI_CompleteCCT_0inertia_0Dym");
    end fmiGetBoolean;

    function fmiSetBoolean
      input fmiModel fmi;
      input Integer refs[:];
      input Boolean vals[size(refs, 1)];
      output Real dummy2= 1;
    protected
      Boolean dummy[size(refs, 1)];
      external"C" Modelica_0IK4_0TEKNIKER_DCOL_Generation_CoolingTowers_FMI_CompleteCCT_0inertia_0Dym_fmiSetBoolean2(
        fmi,
        refs,
        size(refs, 1),
        vals,
        dummy);
        annotation (Header="
#ifndef Modelica_0IK4_0TEKNIKER_DCOL_Generation_CoolingTowers_FMI_CompleteCCT_0inertia_0Dym_SetBoolean_C
#define Modelica_0IK4_0TEKNIKER_DCOL_Generation_CoolingTowers_FMI_CompleteCCT_0inertia_0Dym_SetBoolean_C 1
#include \"FMI/fmiImport.h\"
void Modelica_0IK4_0TEKNIKER_DCOL_Generation_CoolingTowers_FMI_CompleteCCT_0inertia_0Dym_fmiSetBoolean2(void*m, const int* refs, size_t nr, const int* vals,int*dummy) {
  int i;
  struct dy_Extended*a=m;
  fmiStatus status=fmiFatal;
  if(!nr){return;}
  for(i=0;i<nr;++i) ((fmiBoolean*)(dummy))[i]=vals[i];
  if (a) {
    status=a->dyFmiSetBoolean(a->m, refs, nr, (fmiBoolean*)(dummy));
  }
  if (status!=fmiOK && status!=fmiWarning) ModelicaError(\"SetBoolean failed\");
}
#endif", Library="Modelica_0IK4_0TEKNIKER_DCOL_Generation_CoolingTowers_FMI_CompleteCCT_0inertia_0Dym", LibraryDirectory="modelica://DCOL/Resources/Library/FMU/CompleteCCT_inertia_FMU/binaries",                        __Dymola_CriticalRegion="Modelica_0IK4_0TEKNIKER_DCOL_Generation_CoolingTowers_FMI_CompleteCCT_0inertia_0Dym",__Dymola_IdemPotent=true, __Dymola_VectorizedExceptFirst=true);
    end fmiSetBoolean;

    function fmiSetBooleanParam
      input fmiModel fmi;
      input Integer refs[:];
      input Boolean vals[size(refs, 1)];
    protected
      Boolean dummy[size(refs, 1)];
      Boolean oldVals[size(refs, 1)];
      external"C" Modelica_0IK4_0TEKNIKER_DCOL_Generation_CoolingTowers_FMI_CompleteCCT_0inertia_0Dym_fmiSetBooleanParam2(
      fmi,
        refs,
        size(refs, 1),
        vals,
        dummy,
        oldVals);
        annotation (Header="
#ifndef Modelica_0IK4_0TEKNIKER_DCOL_Generation_CoolingTowers_FMI_CompleteCCT_0inertia_0Dym_SetBooleanParam_C
#define Modelica_0IK4_0TEKNIKER_DCOL_Generation_CoolingTowers_FMI_CompleteCCT_0inertia_0Dym_SetBooleanParam_C 1
#include \"FMI/fmiImport.h\"
void Modelica_0IK4_0TEKNIKER_DCOL_Generation_CoolingTowers_FMI_CompleteCCT_0inertia_0Dym_fmiSetBooleanParam2(void*m, const int* refs, size_t nr, const int* vals,int*dummy,int*oldVals) {
  int i;
  struct dy_Extended*a=m;
  fmiStatus status=fmiFatal;
  if(!nr){return;}
  for(i=0;i<nr;++i) ((fmiBoolean*)(dummy))[i]=vals[i];
  if (a) {
    if(a->currentMode == dyInstantiationMode){
      status=a->dyFmiSetBoolean(a->m, refs, nr, (fmiBoolean*)(dummy));
    }else{
      status=a->dyFmiGetBoolean(a->m, refs, nr, (fmiBoolean*)(oldVals));
      for(i=nr-1;i>=0;i--){
        oldVals[i]=((fmiBoolean*)(oldVals))[i];
        if(oldVals[i]!=dummy[i]){
          ModelicaError(\"SetIntegerParameter: new parameters with diferent values are being set after initialization, this is not allowed\");
        }
      }
    }
  }
  if (status!=fmiOK && status!=fmiWarning) ModelicaError(\"SetBoolean failed\");
}
#endif", Library="Modelica_0IK4_0TEKNIKER_DCOL_Generation_CoolingTowers_FMI_CompleteCCT_0inertia_0Dym", LibraryDirectory="modelica://DCOL/Resources/Library/FMU/CompleteCCT_inertia_FMU/binaries",                        __Dymola_CriticalRegion="Modelica_0IK4_0TEKNIKER_DCOL_Generation_CoolingTowers_FMI_CompleteCCT_0inertia_0Dym",__Dymola_IdemPotent=true, __Dymola_VectorizedExceptFirst=true);
    end fmiSetBooleanParam;

    function fmiGetString
      input fmiModel fmi;
      input Integer refs[:];
      output String vals[size(refs, 1)];
      input Integer preAvailable;
      external"C" Modelica_0IK4_0TEKNIKER_DCOL_Generation_CoolingTowers_FMI_CompleteCCT_0inertia_0Dym_fmiGetString2(
        fmi,
        refs,
        size(refs, 1),
        vals);
      annotation (Header="
#ifndef Modelica_0IK4_0TEKNIKER_DCOL_Generation_CoolingTowers_FMI_CompleteCCT_0inertia_0Dym_GetString_C
#define Modelica_0IK4_0TEKNIKER_DCOL_Generation_CoolingTowers_FMI_CompleteCCT_0inertia_0Dym_GetString_C 1
#include <stdlib.h>
#include \"FMI/fmiImport.h\"
void Modelica_0IK4_0TEKNIKER_DCOL_Generation_CoolingTowers_FMI_CompleteCCT_0inertia_0Dym_fmiGetString2(void*m, const int*refs, size_t nrefs, fmiString* vals) {
  struct dy_Extended*a=m;
  fmiStatus status=fmiFatal;
  if (a) {
    status=a->dyFmiGetString(a->m, refs, nrefs, vals);
  }
  if (status!=fmiOK && status!=fmiWarning) ModelicaError(\"StringInteger failed\");
}
#endif", Library="Modelica_0IK4_0TEKNIKER_DCOL_Generation_CoolingTowers_FMI_CompleteCCT_0inertia_0Dym", LibraryDirectory="modelica://DCOL/Resources/Library/FMU/CompleteCCT_inertia_FMU/binaries",                        __Dymola_CriticalRegion="Modelica_0IK4_0TEKNIKER_DCOL_Generation_CoolingTowers_FMI_CompleteCCT_0inertia_0Dym");
    end fmiGetString;

    function fmiSetString
    input fmiModel fmi;
      input Integer refs[:];
      input String vals[size(refs, 1)];
      external"C" Modelica_0IK4_0TEKNIKER_DCOL_Generation_CoolingTowers_FMI_CompleteCCT_0inertia_0Dym_fmiSetString2(
        fmi,
        refs,
        size(refs, 1),
        vals);
        annotation (Header="
#ifndef Modelica_0IK4_0TEKNIKER_DCOL_Generation_CoolingTowers_FMI_CompleteCCT_0inertia_0Dym_SetString_C
#define Modelica_0IK4_0TEKNIKER_DCOL_Generation_CoolingTowers_FMI_CompleteCCT_0inertia_0Dym_SetString_C 1
#include \"FMI/fmiImport.h\"
#include <stdlib.h>
void Modelica_0IK4_0TEKNIKER_DCOL_Generation_CoolingTowers_FMI_CompleteCCT_0inertia_0Dym_fmiSetString2(void*m, const int*refs, size_t nrefs, const fmiString vals[]) {
  struct dy_Extended*a=m;
  fmiStatus status=fmiFatal;
  if(!nrefs){return;}
  if (a) {
    status=a->dyFmiSetString(a->m, refs, nrefs, vals);
  }
  if (status!=fmiOK && status!=fmiWarning) ModelicaError(\"SetString failed\");
}
#endif", Library="Modelica_0IK4_0TEKNIKER_DCOL_Generation_CoolingTowers_FMI_CompleteCCT_0inertia_0Dym", LibraryDirectory="modelica://DCOL/Resources/Library/FMU/CompleteCCT_inertia_FMU/binaries",                        __Dymola_CriticalRegion="Modelica_0IK4_0TEKNIKER_DCOL_Generation_CoolingTowers_FMI_CompleteCCT_0inertia_0Dym",__Dymola_IdemPotent=true, __Dymola_VectorizedExceptFirst=true);
    end fmiSetString;

    function fmiSetStringParam
    input fmiModel fmi;
      input Integer refs[:];
      input String vals[size(refs, 1)];
      external"C" Modelica_0IK4_0TEKNIKER_DCOL_Generation_CoolingTowers_FMI_CompleteCCT_0inertia_0Dym_fmiSetStringParam2(
        fmi,
        refs,
        size(refs, 1),
        vals);
        annotation (Header="
#ifndef Modelica_0IK4_0TEKNIKER_DCOL_Generation_CoolingTowers_FMI_CompleteCCT_0inertia_0Dym_SetStringParam_C
#define Modelica_0IK4_0TEKNIKER_DCOL_Generation_CoolingTowers_FMI_CompleteCCT_0inertia_0Dym_SetStringParam_C 1
#include \"FMI/fmiImport.h\"
#include <stdlib.h>
void Modelica_0IK4_0TEKNIKER_DCOL_Generation_CoolingTowers_FMI_CompleteCCT_0inertia_0Dym_fmiSetStringParam2(void*m, const int*refs, size_t nrefs, const fmiString vals[]) {
  struct dy_Extended*a=m;
  fmiStatus status=fmiFatal;
  if(!nrefs){return;}
  if (a) {
    if(a->currentMode == dyInstantiationMode){
                status=a->dyFmiSetString(a->m, refs, nrefs, vals);
    }else{
      status=fmiOK;
    }
  }
  if (status!=fmiOK && status!=fmiWarning) ModelicaError(\"SetString failed\");
}
#endif", Library="Modelica_0IK4_0TEKNIKER_DCOL_Generation_CoolingTowers_FMI_CompleteCCT_0inertia_0Dym", LibraryDirectory="modelica://DCOL/Resources/Library/FMU/CompleteCCT_inertia_FMU/binaries",                        __Dymola_CriticalRegion="Modelica_0IK4_0TEKNIKER_DCOL_Generation_CoolingTowers_FMI_CompleteCCT_0inertia_0Dym",__Dymola_IdemPotent=true, __Dymola_VectorizedExceptFirst=true);
    end fmiSetStringParam;

    function noHysteresis
      input Real x;
      output Real y;
    algorithm
      y:=x+(if (x < 0) then -1 else 1);
    end noHysteresis;
end fmi_Functions;
equation
  when initial() then
    fmi = fmi_Functions.fmiModel(fmi_instanceName, fmi_loggingOn, fmi_fmuLocation);
  end when;
algorithm
  when {initial(), sample(fmi_StartTime, fmi_CommunicationStepSize)} then
    if time>=fmi_CommunicationStepSize +fmi_StartTime then
    if fmi_InputTime then
      fmi_Functions.fmiSetReal(fmi, {352321536}, {_inletCWater_m_flow_old});
    else
      if fmi_UsePreOnInputSignals then
        fmi_Functions.fmiSetReal(fmi, {352321536}, {pre(inletCWater_m_flow)});
      else
        fmi_Functions.fmiSetReal(fmi, {352321536}, {inletCWater_m_flow});
      end if;
    end if;
    if fmi_InputTime then
      fmi_Functions.fmiSetReal(fmi, {352321537}, {_inletCWater_T_old});
    else
      if fmi_UsePreOnInputSignals then
        fmi_Functions.fmiSetReal(fmi, {352321537}, {pre(inletCWater_T)});
      else
        fmi_Functions.fmiSetReal(fmi, {352321537}, {inletCWater_T});
      end if;
    end if;
    if fmi_InputTime then
      fmi_Functions.fmiSetReal(fmi, {352321538}, {_inletAir_m_flow_old});
    else
      if fmi_UsePreOnInputSignals then
        fmi_Functions.fmiSetReal(fmi, {352321538}, {pre(inletAir_m_flow)});
      else
        fmi_Functions.fmiSetReal(fmi, {352321538}, {inletAir_m_flow});
      end if;
    end if;
    if fmi_InputTime then
      fmi_Functions.fmiSetReal(fmi, {352321539}, {_ambient_T_old});
    else
      if fmi_UsePreOnInputSignals then
        fmi_Functions.fmiSetReal(fmi, {352321539}, {pre(ambient_T)});
      else
        fmi_Functions.fmiSetReal(fmi, {352321539}, {ambient_T});
      end if;
    end if;
    if fmi_InputTime then
      fmi_Functions.fmiSetReal(fmi, {352321540}, {_inletAir_X_old});
    else
      if fmi_UsePreOnInputSignals then
        fmi_Functions.fmiSetReal(fmi, {352321540}, {pre(inletAir_X)});
      else
        fmi_Functions.fmiSetReal(fmi, {352321540}, {inletAir_X});
      end if;
    end if;
      for stepSizeIndex in 1:stepSizeScaleFactor loop
        fmi_StepOK :=fmi_Functions.fmiDoStep(
          fmi,
          time + (stepSizeIndex - 1 - stepSizeScaleFactor)*
            fmi_CommunicationStepSize/stepSizeScaleFactor,
          fmi_CommunicationStepSize/stepSizeScaleFactor);
      end for;
    end if;
    _inletCWater_m_flow_old := inletCWater_m_flow;
    _inletCWater_T_old := inletCWater_T;
    _inletAir_m_flow_old := inletAir_m_flow;
    _ambient_T_old := ambient_T;
    _inletAir_X_old := inletAir_X;
  mWaterIn :=fmi_Functions.fmiGetRealScalar(
      fmi,
      16777230,
      1);
  outletAir_T :=fmi_Functions.fmiGetRealScalar(
      fmi,
      335544320,
      1);
  outletCWater_T :=fmi_Functions.fmiGetRealScalar(
      fmi,
      335544321,
      1);
RealVariables1 :=fmi_Functions.fmiGetReal(
      fmi,
      {905969734,905969735,905969736,369098830,369098831,369098832,369098830,
        637534289,352321538,369100314,369100315,352321540,369099892,100664894,
        369099893,905970806,352321536,637535820,637535450,100664932,369099995,
        100663327,369098830,369098831,369098832,369098830,637534289,352321538,
        369100314,369100315,352321540,369099892,100664894,369099893,369098836,
        637534293,637534294,637534295,637534296,369098841,369098831,369098843,
        369098845,637534289,369098846,369098847,369098848,369100315,369098849,
        352321540,369098850,369098851,369098852,369098853,369098854,369098855,
        905969768,369098857,905969770,369098860,369099893,369100346,905970806,
        369098852,369098861,905969774,369098863,369098864,369098865,905969778,
        369098867,905969780,905969781,369098870,369098871,369098860,369098872,
        369098875,369098876,369098877,637534334,637534335,369098884,369098885,
        369098887,369098888,369098891,369098892,369098893,33554432,587202560,
        637534293,637535909,637534293,637535986,637534293,637536059,637534293,
        637536132,637534293},
      1);
RealVariables2 :=fmi_Functions.fmiGetReal(
      fmi,
      {637536205,637534293,637536278,637534293,637536351,637534293,637536424,
        637534293,637536496,637534293,637536569,33554460,637535891,33554461,
        637535892,33554462,637535893,33554463,637535894,33554464,637535895,
        33554465,637535896,33554466,637535897,33554467,637535898,33554468,
        637535899,33554469,637535900,905971389,905972058,637534293,637535909,
        33554460,637535891,905971389,637535944,637535907,637535909,637535910,
        637534293,637535909,33554440,637535911,637535912,637535914,637535915,
        637534610,637535921,33554440,637534610,33554460,637535891,637535922,
        637535924,637535925,905971388,905971389,33554440,905971392,905971394,
        905971395,637535942,637535943,33554440,637535942,637535944,637535907,
        637535945,637535947,637535948,905971408,905971409,33554440,905971412,
        905971414,905971415,905971419,33554440,905971421,905971423,905971425,
        905971426,33554440,587202568,637535973,33554440,637535973,587202568,
        637535977,33554440,637534293,637535986,33554461,637535892,637535944,
        637535942,637536017},
      1);
RealVariables3 :=fmi_Functions.fmiGetReal(
      fmi,
      {637535984,637535986,637535987,637534293,637535986,33554441,637535988,
        637535989,637535991,637535992,637534611,637535998,33554441,637534611,
        33554461,637535892,637535999,637536001,637536002,637535942,637536008,
        637535944,637535942,33554441,637535907,637536009,637536011,637536012,
        637536015,637536016,33554441,637536015,637536017,637535984,637536018,
        637536020,637536021,905971481,905971482,33554441,905971485,905971487,
        905971488,905971492,33554441,905971494,905971496,905971498,905971499,
        33554441,587202569,637536046,33554441,637536046,587202569,637536050,
        33554441,637534293,637536059,33554462,637535893,637536017,637536015,
        637536090,637536057,637536059,637536060,637534293,637536059,33554442,
        637536061,637536062,637536064,637536065,637534612,637536071,33554442,
        637534612,33554462,637535893,637536072,637536074,637536075,637536015,
        637536081,637536017,637536015,33554442,637535984,637536082,637536084,
        637536085,637536088,637536089,33554442,637536088,637536090,637536057,
        637536091,637536093},
      1);
RealVariables4 :=fmi_Functions.fmiGetReal(
      fmi,
      {637536094,905971554,905971555,33554442,905971558,905971560,905971561,
        905971565,33554442,905971567,905971569,905971571,905971572,33554442,
        587202570,637536119,33554442,637536119,587202570,637536123,33554442,
        637534293,637536132,33554463,637535894,637536090,637536088,637536163,
        637536130,637536132,637536133,637534293,637536132,33554443,637536134,
        637536135,637536137,637536138,637534613,637536144,33554443,637534613,
        33554463,637535894,637536145,637536147,637536148,637536088,637536154,
        637536090,637536088,33554443,637536057,637536155,637536157,637536158,
        637536161,637536162,33554443,637536161,637536163,637536130,637536164,
        637536166,637536167,905971627,905971628,33554443,905971631,905971633,
        905971634,905971638,33554443,905971640,905971642,905971644,905971645,
        33554443,587202571,637536192,33554443,637536192,587202571,637536196,
        33554443,637534293,637536205,33554464,637535895,637536163,637536161,
        637536236,637536203,637536205,637536206,637534293,637536205,33554444,
        637536207,637536208},
      1);
RealVariables5 :=fmi_Functions.fmiGetReal(
      fmi,
      {637536210,637536211,637534614,637536217,33554444,637534614,33554464,
        637535895,637536218,637536220,637536221,637536161,637536227,637536163,
        637536161,33554444,637536130,637536228,637536230,637536231,637536234,
        637536235,33554444,637536234,637536236,637536203,637536237,637536239,
        637536240,905971700,905971701,33554444,905971704,905971706,905971707,
        905971711,33554444,905971713,905971715,905971717,905971718,33554444,
        587202572,637536265,33554444,637536265,587202572,637536269,33554444,
        637534293,637536278,33554465,637535896,637536236,637536234,637536309,
        637536276,637536278,637536279,637534293,637536278,33554445,637536280,
        637536281,637536283,637536284,637534615,637536290,33554445,637534615,
        33554465,637535896,637536291,637536293,637536294,637536234,637536300,
        637536236,637536234,33554445,637536203,637536301,637536303,637536304,
        637536307,637536308,33554445,637536307,637536309,637536276,637536310,
        637536312,637536313,905971773,905971774,33554445,905971777,905971779,
        905971780,905971784},
      1);
RealVariables6 :=fmi_Functions.fmiGetReal(
      fmi,
      {33554445,905971786,905971788,905971790,905971791,33554445,587202573,
        637536338,33554445,637536338,587202573,637536342,33554445,637534293,
        637536351,33554466,637535897,637536309,637536307,637536382,637536349,
        637536351,637536352,637534293,637536351,33554446,637536353,637536354,
        637536356,637536357,637534616,637536363,33554446,637534616,33554466,
        637535897,637536364,637536366,637536367,637536307,637536373,637536309,
        637536307,33554446,637536276,637536374,637536376,637536377,637536380,
        637536381,33554446,637536380,637536382,637536349,637536383,637536385,
        637536386,905971846,905971847,33554446,905971850,905971852,905971853,
        905971857,33554446,905971859,905971861,905971863,905971864,33554446,
        587202574,637536411,33554446,637536411,587202574,637536415,33554446,
        637534293,637536424,33554467,637535898,637536382,637536380,637536455,
        637536422,637536424,637536425,637534293,637536424,33554447,637536426,
        637536427,637536429,637536430,637534617,637536436,33554447,637534617,
        33554467,637535898},
      1);
RealVariables7 :=fmi_Functions.fmiGetReal(
      fmi,
      {637536437,637536439,637536440,637536380,637536446,637536382,637536380,
        33554447,637536349,637536447,637536449,637536450,637536453,637536454,
        33554447,637536453,637536455,637536422,637536456,637536458,637536459,
        905971919,905971920,33554447,905971923,905971925,905971926,905971930,
        33554447,905971932,905971934,905971936,905971937,33554447,587202575,
        637536484,33554447,637536484,587202575,637536488,33554447,637534293,
        637536496,33554468,637535899,637536455,637536453,637536527,637536592,
        637536496,637536497,637534293,637536496,33554448,637536498,637536499,
        637536501,637536502,637534618,637536508,33554448,637534618,33554468,
        637535899,637536509,637536511,637536512,637536453,637536518,637536455,
        637536453,33554448,637536422,637536519,637536521,637536522,637536525,
        637536526,33554448,637536525,637536527,637536592,637536528,637536530,
        637536531,905971991,905971992,33554448,905971995,905971997,905971998,
        905972002,33554448,905972004,905972006,905972008,905972009,33554448,
        587202576,637536556},
      1);
RealVariables8 :=fmi_Functions.fmiGetReal(
      fmi,
      {33554448,637536556,587202576,637536560,33554448,637534293,637536569,
        33554469,637535900,637536527,637536525,905972058,637536569,637536570,
        637534293,637536569,33554449,637536571,637536572,637536574,637536575,
        637534619,637536581,33554449,637534619,33554469,637535900,637536582,
        637536584,637536585,637536525,637536591,637536527,637536525,33554449,
        637536592,637536593,637536595,637536596,905972056,33554449,905972058,
        905972060,905972062,905972063,905972067,905972068,33554449,905972071,
        905972073,905972074,905972078,33554449,905972080,905972082,905972084,
        905972085,33554449,587202577,637536632,33554449,637536632,587202577,
        637536636,33554449,33554440,33554441,33554442,33554443,33554444,
        33554445,33554446,33554447,33554448,33554449,637534295,637536668,
        637534295,637536745,637534295,637536818,637534295,637536891,637534295,
        637536964,637534295,637537037,637534295,637537110,637534295,637537183,
        637534295,637537255,637534295,637537328,33554470,637536650,33554471,
        637536651,33554472},
      1);
RealVariables9 :=fmi_Functions.fmiGetReal(
      fmi,
      {637536652,33554473,637536653,33554474,637536654,33554475,637536655,
        33554476,637536656,33554477,637536657,33554478,637536658,33554479,
        637536659,905972148,905972817,637534295,637536668,33554470,637536650,
        905972148,637536703,637536666,637536668,637536669,637534295,637536668,
        33554450,637536670,637536671,637536673,637536674,637535021,637536680,
        33554450,637535021,33554470,637536650,637536681,637536683,637536684,
        905972147,905972148,33554450,905972151,905972153,905972154,637536701,
        637536702,33554450,637536701,637536703,637536666,637536704,637536706,
        637536707,905972167,905972168,33554450,905972171,905972173,905972174,
        905972178,33554450,905972180,905972182,905972184,905972185,33554450,
        587202578,637536732,33554450,637536732,587202578,637536736,33554450,
        637534295,637536745,33554471,637536651,637536703,637536701,637536776,
        637536743,637536745,637536746,637534295,637536745,33554451,637536747,
        637536748,637536750,637536751,637535022,637536757,33554451,637535022,
        33554471,637536651},
      1);
RealVariables10 :=fmi_Functions.fmiGetReal(
      fmi,
      {637536758,637536760,637536761,637536701,637536767,637536703,637536701,
        33554451,637536666,637536768,637536770,637536771,637536774,637536775,
        33554451,637536774,637536776,637536743,637536777,637536779,637536780,
        905972240,905972241,33554451,905972244,905972246,905972247,905972251,
        33554451,905972253,905972255,905972257,905972258,33554451,587202579,
        637536805,33554451,637536805,587202579,637536809,33554451,637534295,
        637536818,33554472,637536652,637536776,637536774,637536849,637536816,
        637536818,637536819,637534295,637536818,33554452,637536820,637536821,
        637536823,637536824,637535023,637536830,33554452,637535023,33554472,
        637536652,637536831,637536833,637536834,637536774,637536840,637536776,
        637536774,33554452,637536743,637536841,637536843,637536844,637536847,
        637536848,33554452,637536847,637536849,637536816,637536850,637536852,
        637536853,905972313,905972314,33554452,905972317,905972319,905972320,
        905972324,33554452,905972326,905972328,905972330,905972331,33554452,
        587202580,637536878},
      1);
RealVariables11 :=fmi_Functions.fmiGetReal(
      fmi,
      {33554452,637536878,587202580,637536882,33554452,637534295,637536891,
        33554473,637536653,637536849,637536847,637536922,637536889,637536891,
        637536892,637534295,637536891,33554453,637536893,637536894,637536896,
        637536897,637535024,637536903,33554453,637535024,33554473,637536653,
        637536904,637536906,637536907,637536847,637536913,637536849,637536847,
        33554453,637536816,637536914,637536916,637536917,637536920,637536921,
        33554453,637536920,637536922,637536889,637536923,637536925,637536926,
        905972386,905972387,33554453,905972390,905972392,905972393,905972397,
        33554453,905972399,905972401,905972403,905972404,33554453,587202581,
        637536951,33554453,637536951,587202581,637536955,33554453,637534295,
        637536964,33554474,637536654,637536922,637536920,637536995,637536962,
        637536964,637536965,637534295,637536964,33554454,637536966,637536967,
        637536969,637536970,637535025,637536976,33554454,637535025,33554474,
        637536654,637536977,637536979,637536980,637536920,637536986,637536922,
        637536920,33554454},
      1);
RealVariables12 :=fmi_Functions.fmiGetReal(
      fmi,
      {637536889,637536987,637536989,637536990,637536993,637536994,33554454,
        637536993,637536995,637536962,637536996,637536998,637536999,905972459,
        905972460,33554454,905972463,905972465,905972466,905972470,33554454,
        905972472,905972474,905972476,905972477,33554454,587202582,637537024,
        33554454,637537024,587202582,637537028,33554454,637534295,637537037,
        33554475,637536655,637536995,637536993,637537068,637537035,637537037,
        637537038,637534295,637537037,33554455,637537039,637537040,637537042,
        637537043,637535026,637537049,33554455,637535026,33554475,637536655,
        637537050,637537052,637537053,637536993,637537059,637536995,637536993,
        33554455,637536962,637537060,637537062,637537063,637537066,637537067,
        33554455,637537066,637537068,637537035,637537069,637537071,637537072,
        905972532,905972533,33554455,905972536,905972538,905972539,905972543,
        33554455,905972545,905972547,905972549,905972550,33554455,587202583,
        637537097,33554455,637537097,587202583,637537101,33554455,637534295,
        637537110,33554476},
      1);
RealVariables13 :=fmi_Functions.fmiGetReal(
      fmi,
      {637536656,637537068,637537066,637537141,637537108,637537110,637537111,
        637534295,637537110,33554456,637537112,637537113,637537115,637537116,
        637535027,637537122,33554456,637535027,33554476,637536656,637537123,
        637537125,637537126,637537066,637537132,637537068,637537066,33554456,
        637537035,637537133,637537135,637537136,637537139,637537140,33554456,
        637537139,637537141,637537108,637537142,637537144,637537145,905972605,
        905972606,33554456,905972609,905972611,905972612,905972616,33554456,
        905972618,905972620,905972622,905972623,33554456,587202584,637537170,
        33554456,637537170,587202584,637537174,33554456,637534295,637537183,
        33554477,637536657,637537141,637537139,637537214,637537181,637537183,
        637537184,637534295,637537183,33554457,637537185,637537186,637537188,
        637537189,637535028,637537195,33554457,637535028,33554477,637536657,
        637537196,637537198,637537199,637537139,637537205,637537141,637537139,
        33554457,637537108,637537206,637537208,637537209,637537212,637537213,
        33554457,637537212},
      1);
RealVariables14 :=fmi_Functions.fmiGetReal(
      fmi,
      {637537214,637537181,637537215,637537217,637537218,905972678,905972679,
        33554457,905972682,905972684,905972685,905972689,33554457,905972691,
        905972693,905972695,905972696,33554457,587202585,637537243,33554457,
        637537243,587202585,637537247,33554457,637534295,637537255,33554478,
        637536658,637537214,637537212,637537286,637537351,637537255,637537256,
        637534295,637537255,33554458,637537257,637537258,637537260,637537261,
        637535029,637537267,33554458,637535029,33554478,637536658,637537268,
        637537270,637537271,637537212,637537277,637537214,637537212,33554458,
        637537181,637537278,637537280,637537281,637537284,637537285,33554458,
        637537284,637537286,637537351,637537287,637537289,637537290,905972750,
        905972751,33554458,905972754,905972756,905972757,905972761,33554458,
        905972763,905972765,905972767,905972768,33554458,587202586,637537315,
        33554458,637537315,587202586,637537319,33554458,637534295,637537328,
        33554479,637536659,637537286,637537284,905972817,637537328,637537329,
        637534295,637537328},
      1);
RealVariables15 :=fmi_Functions.fmiGetReal(
      fmi,
      {33554459,637537330,637537331,637537333,637537334,637535030,637537340,
        33554459,637535030,33554479,637536659,637537341,637537343,637537344,
        637537284,637537350,637537286,637537284,33554459,637537351,637537352,
        637537354,637537355,905972815,33554459,905972817,905972819,905972821,
        905972822,905972826,905972827,33554459,905972830,905972832,905972833,
        905972837,33554459,905972839,905972841,905972843,905972844,33554459,
        587202587,637537391,33554459,637537391,587202587,637537395,33554459,
        33554450,33554451,33554452,33554453,33554454,33554455,33554456,33554457,
        33554458,33554459,352321536,637535820,637535450,637537515,637534508,
        905970006,637534560,905970007,637534561,905970008,637534562,905970009,
        637534563,905970010,637534564,905970011,637534565,905970012,637534566,
        905970013,637534567,905970014,637534568,905970015,637534569,637534600,
        637534601,637534602,637534603,637534604,637534605,637534606,637534607,
        637534608,637534609,637534610,637534611,637534612,637534613,637534614,
        637534615},
      1);
RealVariables16 :=fmi_Functions.fmiGetReal(
      fmi,
      {637534616,637534617,637534618,637534619,637534620,637534621,637534622,
        637534623,637534624,637534625,637534626,637534627,637534628,637534629,
        637535820,905970146,637537515,905970147,637535820,33554460,637537419,
        33554461,637537431,33554462,637537443,33554463,637537455,33554464,
        637537467,33554465,637537479,33554466,637537491,33554467,637537503,
        33554468,637537515,33554469,637535820,33554460,637537419,33554461,
        637537431,33554462,637537443,33554463,637537455,33554464,637537467,
        33554465,637537479,33554466,637537491,33554467,637537503,33554468,
        637537515,33554469,637534854,637534855,637534856,637534857,637534858,
        637534859,637534860,637534861,637534862,637534863,100663728,100663729,
        100663730,100663731,100663732,100663733,100663734,100663735,100663736,
        100663737,100663738,100663739,100663740,100663741,100663742,100663743,
        100663744,100663745,100663746,100663747,100663748,100663749,100663750,
        100663751,100663752,100663753,100663754,100663755,100663756,100663757,
        352321536,352321536},
      1);
RealVariables17 :=fmi_Functions.fmiGetReal(
      fmi,
      {352321536,352321536,352321536,352321536,352321536,352321536,352321536,
        905970176,905970177,905970178,905970179,905970180,905970181,905970182,
        905970183,905970184,637534738,637534739,637534740,637534741,637534742,
        637534743,637534744,637534745,637534746,637534747,637534748,637534749,
        637534750,637534751,637534752,637534753,637534754,637534755,637534796,
        637534797,637534798,637534799,637534800,637534801,637534802,637534803,
        637534804,352321536,352321536,352321536,352321536,352321536,352321536,
        352321536,352321536,352321536,352321536,352321536,637534843,637534844,
        637534845,637534846,637534847,637534848,637534849,637534850,637534851,
        637534852,637534853,637534854,637534855,637534856,637534857,637534858,
        637534859,637534860,637534861,637534862,637534863,33554460,637534610,
        33554461,637534611,33554462,637534612,33554463,637534613,33554464,
        637534614,33554465,637534615,33554466,637534616,33554467,637534617,
        33554468,637534618,33554469,637534619,637535820,33554460,637537419,
        33554461,637537431},
      1);
RealVariables18 :=fmi_Functions.fmiGetReal(
      fmi,
      {33554462,637537443,33554463,637537455,33554464,637537467,33554465,
        637537479,33554466,637537491,33554467,637537503,33554468,637537515,
        33554469,637534610,637534611,637534612,637534613,637534614,637534615,
        637534616,637534617,637534618,637534619,33554460,637534610,33554461,
        637534611,33554462,637534612,33554463,637534613,33554464,637534614,
        33554465,637534615,33554466,637534616,33554467,637534617,33554468,
        637534618,33554469,637534619,33554460,33554461,33554462,33554463,
        33554464,33554465,33554466,33554467,33554468,33554469,637534854,
        637534855,637534856,637534857,637534858,637534859,637534860,637534861,
        637534862,637534863,100663738,100663739,100663740,100663741,100663742,
        100663743,100663744,100663745,100663746,100663747,100663748,100663749,
        100663750,100663751,100663752,100663753,100663754,100663755,100663756,
        100663757,637535820,637535450,33554460,587202588,905972867,637537412,
        637535820,33554460,905972873,905972874,637537419,637537420,33554461,
        587202589,905972879},
      1);
RealVariables19 :=fmi_Functions.fmiGetReal(
      fmi,
      {637537424,637537419,33554461,905972885,905972886,637537431,637537432,
        33554462,587202590,905972891,637537436,637537431,33554462,905972897,
        905972898,637537443,637537444,33554463,587202591,905972903,637537448,
        637537443,33554463,905972909,905972910,637537455,637537456,33554464,
        587202592,905972915,637537460,637537455,33554464,905972921,905972922,
        637537467,637537468,33554465,587202593,905972927,637537472,637537467,
        33554465,905972933,905972934,637537479,637537480,33554466,587202594,
        905972939,637537484,637537479,33554466,905972945,905972946,637537491,
        637537492,33554467,587202595,905972951,637537496,637537491,33554467,
        905972957,905972958,637537503,637537504,33554468,587202596,905972963,
        637537508,637537503,33554468,905972969,905972970,637537515,637534508,
        33554469,587202597,905972974,637537519,637537515,33554469,905972980,
        905972981,352321536,637537515,637534919,637537632,369099995,905970417,
        637534971,905970418,637534972,905970419,637534973,905970420,637534974,
        905970421,637534975},
      1);
RealVariables20 :=fmi_Functions.fmiGetReal(
      fmi,
      {905970422,637534976,905970423,637534977,905970424,637534978,905970425,
        637534979,905970426,637534980,637535011,637535012,637535013,637535014,
        637535015,637535016,637535017,637535018,637535019,637535020,637535021,
        637535022,637535023,637535024,637535025,637535026,637535027,637535028,
        637535029,637535030,637535031,637535032,637535033,637535034,637535035,
        637535036,637535037,637535038,637535039,637535040,637537515,905970557,
        637537632,637537515,33554470,637537536,33554471,637537548,33554472,
        637537560,33554473,637537572,33554474,637537584,33554475,637537596,
        33554476,637537608,33554477,637537620,33554478,637537632,33554479,
        637537515,33554470,637537536,33554471,637537548,33554472,637537560,
        33554473,637537572,33554474,637537584,33554475,637537596,33554476,
        637537608,33554477,637537620,33554478,637537632,33554479,637535265,
        637535266,637535267,637535268,637535269,637535270,637535271,637535272,
        637535273,637535274,100664139,100664140,100664141,100664142,100664143,
        100664144,100664145},
      1);
RealVariables21 :=fmi_Functions.fmiGetReal(
      fmi,
      {100664146,100664147,100664148,100664149,100664150,100664151,100664152,
        100664153,100664154,100664155,100664156,100664157,100664158,100664159,
        100664160,100664161,100664162,100664163,100664164,100664165,100664166,
        100664167,100664168,352321536,352321536,352321536,352321536,352321536,
        352321536,352321536,352321536,352321536,905970587,905970588,905970589,
        905970590,905970591,905970592,905970593,905970594,905970595,637535149,
        637535150,637535151,637535152,637535153,637535154,637535155,637535156,
        637535157,637535158,637535159,637535160,637535161,637535162,637535163,
        637535164,637535165,637535166,637535207,637535208,637535209,637535210,
        637535211,637535212,637535213,637535214,637535215,352321536,352321536,
        352321536,352321536,352321536,352321536,352321536,352321536,352321536,
        352321536,352321536,637535254,637535255,637535256,637535257,637535258,
        637535259,637535260,637535261,637535262,637535263,637535264,637535265,
        637535266,637535267,637535268,637535269,637535270,637535271,637535272,
        637535273,637535274},
      1);
RealVariables22 :=fmi_Functions.fmiGetReal(
      fmi,
      {33554470,637535021,33554471,637535022,33554472,637535023,33554473,
        637535024,33554474,637535025,33554475,637535026,33554476,637535027,
        33554477,637535028,33554478,637535029,33554479,637535030,637537515,
        33554470,637537536,33554471,637537548,33554472,637537560,33554473,
        637537572,33554474,637537584,33554475,637537596,33554476,637537608,
        33554477,637537620,33554478,637537632,33554479,637535021,637535022,
        637535023,637535024,637535025,637535026,637535027,637535028,637535029,
        637535030,33554470,637535021,33554471,637535022,33554472,637535023,
        33554473,637535024,33554474,637535025,33554475,637535026,33554476,
        637535027,33554477,637535028,33554478,637535029,33554479,637535030,
        33554470,33554471,33554472,33554473,33554474,33554475,33554476,33554477,
        33554478,33554479,637535265,637535266,637535267,637535268,637535269,
        637535270,637535271,637535272,637535273,637535274,100664149,100664150,
        100664151,100664152,100664153,100664154,100664155,100664156,100664157,
        100664158},
      1);
RealVariables23 :=fmi_Functions.fmiGetReal(
      fmi,
      {100664159,100664160,100664161,100664162,100664163,100664164,100664165,
        100664166,100664167,100664168,637537515,637534919,33554470,587202598,
        905972984,637537529,637537515,33554470,905972990,905972991,637537536,
        637537537,33554471,587202599,905972996,637537541,637537536,33554471,
        905973002,905973003,637537548,637537549,33554472,587202600,905973008,
        637537553,637537548,33554472,905973014,905973015,637537560,637537561,
        33554473,587202601,905973020,637537565,637537560,33554473,905973026,
        905973027,637537572,637537573,33554474,587202602,905973032,637537577,
        637537572,33554474,905973038,905973039,637537584,637537585,33554475,
        587202603,905973044,637537589,637537584,33554475,905973050,905973051,
        637537596,637537597,33554476,587202604,905973056,637537601,637537596,
        33554476,905973062,905973063,637537608,637537609,33554477,587202605,
        905973068,637537613,637537608,33554477,905973074,905973075,637537620,
        637537621,33554478,587202606,905973080,637537625,637537620,33554478,
        905973086,905973087},
      1);
RealVariables24 :=fmi_Functions.fmiGetReal(
      fmi,
      {637537632,369099995,33554479,587202607,905973091,637537636,637537632,
        33554479,905973097,905973098,352321536,637537632,100664929,100664932,
        369099995,352321536,637535337,905970794,905970795,905970796,352321538,
        369100314,369100315,352321540,369099892,100664894,369099893,905970806,
        33554433,587202561,637535351,637535352,637535351,369099996,33554434,
        587202562,637535369,637535370,100664443,33554434,905970831,905970833,
        637535378,637535379,637535380,637535380,637535381,637535382,100664565,
        369099930,369099996,637535861,905971332,369099996,369098846,369098830,
        369099996,637535393,637535394,637535395,100664443,33554434,905970854,
        637535382,33554434,637535382,33554434,33554434,637535382,637535406,
        637535407,637535409,637535410,369099955,905970868,369099957,369099958,
        905970871,369099960,369099964,905970877,369099966,100664479,100664479,
        100664479,637535856,637535433,637535434,637535856,352321539,637535658,
        637535435,637535436,637535437,637535438,637535439,637535440,637535441,
        637535442,637535443},
      1);
RealVariables25 :=fmi_Functions.fmiGetReal(
      fmi,
      {637535444,637535445,637535446,637535447,16777321,637535449,352321536,
        637535820,637535450,100664932,369099995,637535861,905971332,369099996,
        100663327,369100040,369098831,100664565,369098830,369098831,100663327,
        905970919,905970920,100663327,369099930,369098831,100664565,369100040,
        369098831,369100040,369098831,905970954,905970956,369100040,905970954,
        905970961,905970962,905970963,369100055,369100074,369100040,905970954,
        905970954,905970954,369100067,905970980,100663327,905970984,369100073,
        369100074,369099930,905970991,369100040,905970954,100663327,100663327,
        637535437,33554435,587202563,637535553,33554435,637535553,587202563,
        33554436,587202564,637535558,33554436,637535558,587202564,33554437,
        587202565,637535563,33554437,637535563,587202565,637535568,637535569,
        637535434,637535568,33554435,637535570,905971027,637535576,637535577,
        637535434,637535576,33554436,637535578,905971035,637535584,637535585,
        33554435,637535584,33554434,637535586,905971043,637535592,637535593,
        33554436,637535592},
      1);
RealVariables26 :=fmi_Functions.fmiGetReal(
      fmi,
      {33554434,637535594,905971051,637535600,637535601,33554437,637535600,
        33554434,637535602,905971059,637535449,637535608,16777321,637535449,
        33554437,637535855,905971065,33554434,637535614,637535434,637535658,
        33554438,587202566,637535615,33554438,637535615,587202566,33554439,
        587202567,637535620,33554439,637535620,587202567,637535625,637535626,
        33554438,637535625,33554434,637535627,905971084,33554439,905971092,
        905971094,637535643,637535644,637535434,637535643,33554438,637535645,
        905971102,637535620,637535651,637535434,637535620,33554439,637535652,
        905971109,16777321,637535449,352321539,637535658,33554433,369100314,
        352321540,369100315,905971116,352321539,352321540,905971117,905971118,
        905971119,905971120,369100314,352321539,352321540,905971117,905971123,
        905971124,905971125,905971126,905971225,369100314,369100315,905971228,
        352321538,352321539,352321540,905971239,100664894,16777316,100664891,
        16777314,16777316,100664894,16777314,16777316,100664874,369100346,
        100664894,16777316},
      1);
RealVariables27 :=fmi_Functions.fmiGetReal(
      fmi,
      {637535820,637535821,352321537,905971268,637535820,352321537,905971273,
        905971274,905971275,637535820,637535821,352321536,352321537,100664932,
        100664929,16777318,100664932,16777318,352321536,100664932,100664894,
        335544320,100664932,335544321,16777321,637535855,352321539,637535856,
        352321539,637535860,637535861,905971332,905971332,905971330,905971331,
        905971332,637535861,33554433,637535890},
      1);
  end when;
initial algorithm
  fmi_AParamsAndStart:=1;
 // 104 Real parameters
  fmi_Functions.fmiSetRealParam(fmi, {16777216, 16777217, 16777218, 16777219, 16777220, 16777221, 16777222, 16777223, 16777224, 16777225, 16777226, 16777228, 16777229, 16777231, 16777232, 16777233, 16777234, 16777235, 16777236, 16777237, 16777238, 16777239, 16777240, 16777241, 16777242, 16777243, 16777244, 16777245, 16777246, 16777247, 16777248, 16777256, 16777257, 16777258, 16777325, 16777326, 16777327, 16777328, 16777329, 16777330, 16777331, 16777332, 16777333, 16777334, 16777259, 16777260, 16777335, 16777336, 16777337, 16777338, 16777339, 16777340, 16777341, 16777342, 16777343, 16777344, 16777262, 16777267, 16777274, 16777275, 16777276, 16777277, 16777278, 16777279, 16777280, 16777281, 16777282, 16777283, 16777284, 16777289, 16777290, 16777291, 16777293, 16777294, 16777295, 16777296, 16777297, 16777298, 16777299, 16777300, 16777301, 16777302, 16777303, 16777304, 16777305, 16777306, 16777307, 16777308, 16777309, 16777310, 16777311, 16777312, 16777313, 16777314, 16777315, 16777316, 16777317, 16777318, 16777319, 16777320}, {'system'.p_ambient, 'system'.T_ambient, 'system'.g, 'system'.eps_m_flow, 'system'.dp_small, 'system'.m_flow_small, hmax, hmin, L_basin, w, e, R_ext, R_int, pPumpedWater, c, n, roughness, a, b, d_a, d_b, Kfi, hfi, wfi, lfi, C_iner, moverflowWater, TWater2_start, TAir2_start, H2_start, TMaterial_start, closedCTPressureDrop.heatExchangerThroughReal.closedHeatToAirPressureDrop.mMed_start, closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.der_T_start, closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.alpha, closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 1, 1]'.nParallel, closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 2, 1]'.nParallel, closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 3, 1]'.nParallel, closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 4, 1]'.nParallel, closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 5, 1]'.nParallel, closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 6, 1]'.nParallel, closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 7, 1]'.nParallel, closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 8, 1]'.nParallel, closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 9, 1]'.nParallel, closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 10, 1]'.nParallel, closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.der_T_start, closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.alpha, closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 1, 1]'.nParallel, closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 2, 1]'.nParallel, closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 3, 1]'.nParallel, closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 4, 1]'.nParallel, closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 5, 1]'.nParallel, closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 6, 1]'.nParallel, closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 7, 1]'.nParallel, closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 8, 1]'.nParallel, closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 9, 1]'.nParallel, closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 10, 1]'.nParallel, closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.'X_start[1]', closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.'X_start[1]', closedCTPressureDrop.waterBasin.'X_start[1]', closedCTPressureDrop.waterBasin.'portsData[1]'.diameter, closedCTPressureDrop.waterBasin.'portsData[1]'.height, closedCTPressureDrop.waterBasin.'portsData[1]'.zeta_out, closedCTPressureDrop.waterBasin.'portsData[1]'.zeta_in, closedCTPressureDrop.waterBasin.'portsData[2]'.diameter, closedCTPressureDrop.waterBasin.'portsData[2]'.height, closedCTPressureDrop.waterBasin.'portsData[2]'.zeta_out, closedCTPressureDrop.waterBasin.'portsData[2]'.zeta_in, closedCTPressureDrop.waterBasin.'portsData[3]'.zeta_out, closedCTPressureDrop.waterBasin.'portsData[3]'.zeta_in, closedCTPressureDrop.pump.N_nominal, closedCTPressureDrop.pump.rho_nominal, closedCTPressureDrop.pump.'X_start[1]', closedCTPressureDrop.storageWall.T_Wall_start, closedCTPressureDrop.storageWall.'sideInertia[1]'.T_start, closedCTPressureDrop.storageWall.'sideInertia[1]'.der_T_start, closedCTPressureDrop.storageWall.'sideInertia[2]'.T_start, closedCTPressureDrop.storageWall.'sideInertia[2]'.der_T_start, closedCTPressureDrop.storageWall.topInertia.T_start, closedCTPressureDrop.storageWall.topInertia.der_T_start, closedCTPressureDrop.storageWall.'sideCond2[1]'.T_start, closedCTPressureDrop.storageWall.'sideCond2[2]'.T_start, closedCTPressureDrop.storageWall.'sideCond1[1]'.T_start, closedCTPressureDrop.storageWall.'sideCond1[2]'.T_start, closedCTPressureDrop.storageWall.topCond1.T_start, closedCTPressureDrop.storageWall.topCond2.T_start, closedCTPressureDrop.storageWall.'frontInertia[1]'.T_start, closedCTPressureDrop.storageWall.'frontInertia[1]'.der_T_start, closedCTPressureDrop.storageWall.'frontInertia[2]'.T_start, closedCTPressureDrop.storageWall.'frontInertia[2]'.der_T_start, closedCTPressureDrop.storageWall.'frontCond1[1]'.T_start, closedCTPressureDrop.storageWall.'frontCond1[2]'.T_start, closedCTPressureDrop.storageWall.'frontCond2[1]'.T_start, closedCTPressureDrop.storageWall.'frontCond2[2]'.T_start, airOut.T, airOut.h, airOut.'X[1]', airOut.'X[2]', cWaterOut.T, cWaterOut.h, cWaterOut.'X[1]'});
  fmi_Functions.fmiSetRealParam(fmi, {16777321, 16777322, 16777323, 16777324}, {T_floor.T, levelControl.m_Out, sampler.samplePeriod, sampler.startTime});
 // 17 Real start values
  fmi_Functions.fmiSetRealParam(fmi, {33554462, 33554463, 33554464, 33554465, 33554466, 33554467, 33554468, 33554469, 33554472, 33554473, 33554474, 33554475, 33554476, 33554477, 33554478, 33554479, 637535861}, {closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.'mediums[3]'._T_start, closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.'mediums[4]'._T_start, closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.'mediums[5]'._T_start, closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.'mediums[6]'._T_start, closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.'mediums[7]'._T_start, closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.'mediums[8]'._T_start, closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.'mediums[9]'._T_start, closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.'mediums[10]'._T_start, closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.'mediums[3]'._T_start, closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.'mediums[4]'._T_start, closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.'mediums[5]'._T_start, closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.'mediums[6]'._T_start, closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.'mediums[7]'._T_start, closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.'mediums[8]'._T_start, closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.'mediums[9]'._T_start, closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.'mediums[10]'._T_start, levelControl._m_outflow_start});
 // 2 Integer parameters
  fmi_Functions.fmiSetIntegerParam(fmi, {16777227, 16777288}, {nParallel, closedCTPressureDrop.pump.nParallel});
 // 0 Integer start values
 // 0 Boolean parameters
 // 0 Boolean start values
 // 0 Enumeration parameters
 // 0 Enumeration start values
 // 0 String parameters
initial equation
if fmi_pullInputsForInitialization then fmi_initInput0 = fmi_Functions.fmiSetReal(fmi, {352321536}, {pre(inletCWater_m_flow)}); else fmi_initInput0 = fmi_Functions.fmiSetReal(fmi, {352321536}, {_inletCWater_m_flow_start}); end if;
if fmi_pullInputsForInitialization then fmi_initInput1 = fmi_Functions.fmiSetReal(fmi, {352321537}, {pre(inletCWater_T)}); else fmi_initInput1 = fmi_Functions.fmiSetReal(fmi, {352321537}, {_inletCWater_T_start}); end if;
if fmi_pullInputsForInitialization then fmi_initInput2 = fmi_Functions.fmiSetReal(fmi, {352321538}, {pre(inletAir_m_flow)}); else fmi_initInput2 = fmi_Functions.fmiSetReal(fmi, {352321538}, {_inletAir_m_flow_start}); end if;
if fmi_pullInputsForInitialization then fmi_initInput3 = fmi_Functions.fmiSetReal(fmi, {352321539}, {pre(ambient_T)}); else fmi_initInput3 = fmi_Functions.fmiSetReal(fmi, {352321539}, {_ambient_T_start}); end if;
if fmi_pullInputsForInitialization then fmi_initInput4 = fmi_Functions.fmiSetReal(fmi, {352321540}, {pre(inletAir_X)}); else fmi_initInput4 = fmi_Functions.fmiSetReal(fmi, {352321540}, {_inletAir_X_start}); end if;
  fmi_Initialized = fmi_Functions.fmiInitializeSlave(fmi, fmi_StartTime, fmi_forceShutDownAtStopTime, fmi_StopTime,fmi_AParamsAndStart+ fmi_initInput0+ fmi_initInput1+ fmi_initInput2+ fmi_initInput3+ fmi_initInput4);
RealDependentParameters1 = fmi_Functions.fmiGetReal(fmi, {100663303, 100663304, 100663306, 100663310, 100663315, 100663316, 100663317, 100663318, 100663319, 100663320, 100663325, 100663326, 100663327, 100663328, 100663329, 100663330, 100663331, 100663332, 100663333, 100663334, 100663335, 100663336, 100663337, 100663338, 100663339, 100663340, 100663341, 100663342, 100663343, 100663344, 100663346, 100663353, 100663354, 100663355, 100663356, 100663357, 100663358, 100663359, 100663360, 100663361, 100663362, 100663363, 100663364, 100663365, 100663369, 100663370, 100663371, 100663373, 100663327, 100663386, 100663424, 100663425, 100663426, 100663427, 100663430, 100663433, 100663434, 100663438, 100663439, 100663440, 100663441, 100663442, 100663443, 100663453, 100663454, 100663461, 100663462, 100663464, 100663466, 100663467, 100663468, 100663469, 100663470, 100663471, 100663472, 100663473, 100663474, 100663475, 100663476, 100663477, 100663478, 100663479, 100663480, 100663481, 100663482, 100663483, 100663484, 100663485, 100663486, 100663487, 100663488, 100663489, 100663490, 100663491, 100663492, 100663493, 100663494, 100663495, 100663496, 100663497},fmi_Initialized);
RealDependentParameters2 = fmi_Functions.fmiGetReal(fmi, {100663498, 100663499, 100663500, 100663501, 100663502, 100663503, 100663504, 100663505, 100663506, 100663507, 100663508, 100663509, 100663510, 100663511, 100663512, 100663513, 100663514, 100663515, 100663516, 100663517, 100663518, 100664996, 100665001, 100665004, 100665005, 100665006, 100665007, 100665011, 100665014, 100665015, 100665016, 100665017, 100665025, 100665028, 100665029, 100665034, 100665037, 100665038, 100665045, 100665048, 100665049, 100665056, 100665059, 100665060, 100665062, 100665063, 100665064, 100665066, 100665073, 100665078, 100665081, 100665082, 100665083, 100665084, 100665088, 100665091, 100665092, 100665093, 100665094, 100665098, 100665101, 100665102, 100665107, 100665110, 100665111, 100665118, 100665121, 100665122, 100665129, 100665132, 100665133, 100665135, 100665136, 100665137, 100665139, 100665146, 100665151, 100665154, 100665155, 100665156, 100665157, 100665161, 100665164, 100665165, 100665166, 100665167, 100665171, 100665174, 100665175, 100665180, 100665183, 100665184, 100665191, 100665194, 100665195, 100665202, 100665205, 100665206, 100665208, 100665209},fmi_Initialized);
RealDependentParameters3 = fmi_Functions.fmiGetReal(fmi, {100665210, 100665212, 100665219, 100665224, 100665227, 100665228, 100665229, 100665230, 100665234, 100665237, 100665238, 100665239, 100665240, 100665244, 100665247, 100665248, 100665253, 100665256, 100665257, 100665264, 100665267, 100665268, 100665275, 100665278, 100665279, 100665281, 100665282, 100665283, 100665285, 100665292, 100665297, 100665300, 100665301, 100665302, 100665303, 100665307, 100665310, 100665311, 100665312, 100665313, 100665317, 100665320, 100665321, 100665326, 100665329, 100665330, 100665337, 100665340, 100665341, 100665348, 100665351, 100665352, 100665354, 100665355, 100665356, 100665358, 100665365, 100665370, 100665373, 100665374, 100665375, 100665376, 100665380, 100665383, 100665384, 100665385, 100665386, 100665390, 100665393, 100665394, 100665399, 100665402, 100665403, 100665410, 100665413, 100665414, 100665421, 100665424, 100665425, 100665427, 100665428, 100665429, 100665431, 100665438, 100665443, 100665446, 100665447, 100665448, 100665449, 100665453, 100665456, 100665457, 100665458, 100665459, 100665463, 100665466, 100665467, 100665472, 100665475, 100665476},fmi_Initialized);
RealDependentParameters4 = fmi_Functions.fmiGetReal(fmi, {100665483, 100665486, 100665487, 100665494, 100665497, 100665498, 100665500, 100665501, 100665502, 100665504, 100665511, 100665516, 100665519, 100665520, 100665521, 100665522, 100665526, 100665529, 100665530, 100665531, 100665532, 100665536, 100665539, 100665540, 100665545, 100665548, 100665549, 100665556, 100665559, 100665560, 100665567, 100665570, 100665571, 100665573, 100665574, 100665575, 100665577, 100665583, 100665588, 100665591, 100665592, 100665593, 100665594, 100665598, 100665601, 100665602, 100665603, 100665604, 100665608, 100665611, 100665612, 100665617, 100665620, 100665621, 100665628, 100665631, 100665632, 100665639, 100665642, 100665643, 100665645, 100665646, 100665647, 100665649, 100665656, 100665661, 100665664, 100665665, 100665666, 100665667, 100665671, 100665674, 100665675, 100665676, 100665677, 100665682, 100665685, 100665686, 100665693, 100665696, 100665697, 100665704, 100665707, 100665708, 100665715, 100665718, 100665719, 100665721, 100665722, 100665723, 100665725, 100663519, 100663529, 100663530, 100663537, 100663538, 100663540, 100663542, 100663543, 100663544},fmi_Initialized);
RealDependentParameters5 = fmi_Functions.fmiGetReal(fmi, {100663545, 100663546, 100663547, 100663548, 100663549, 100663550, 100663551, 100663552, 100663553, 100663554, 100663555, 100663556, 100663557, 100663558, 100663559, 100663560, 100663561, 100663562, 100663563, 100663564, 100663565, 100663566, 100663567, 100663568, 100663569, 100663570, 100663571, 100663572, 100663573, 100663574, 100663575, 100663576, 100663577, 100663578, 100663579, 100663580, 100663581, 100663582, 100663583, 100663584, 100663585, 100663586, 100663587, 100663588, 100663589, 100663590, 100663591, 100663592, 100663593, 100663594, 100665755, 100665760, 100665763, 100665764, 100665765, 100665766, 100665770, 100665773, 100665774, 100665775, 100665776, 100665784, 100665787, 100665788, 100665793, 100665796, 100665797, 100665804, 100665807, 100665808, 100665815, 100665818, 100665819, 100665821, 100665822, 100665823, 100665825, 100665832, 100665837, 100665840, 100665841, 100665842, 100665843, 100665847, 100665850, 100665851, 100665852, 100665853, 100665857, 100665860, 100665861, 100665866, 100665869, 100665870, 100665877, 100665880, 100665881, 100665888, 100665891, 100665892},fmi_Initialized);
RealDependentParameters6 = fmi_Functions.fmiGetReal(fmi, {100665894, 100665895, 100665896, 100665898, 100665905, 100665910, 100665913, 100665914, 100665915, 100665916, 100665920, 100665923, 100665924, 100665925, 100665926, 100665930, 100665933, 100665934, 100665939, 100665942, 100665943, 100665950, 100665953, 100665954, 100665961, 100665964, 100665965, 100665967, 100665968, 100665969, 100665971, 100665978, 100665983, 100665986, 100665987, 100665988, 100665989, 100665993, 100665996, 100665997, 100665998, 100665999, 100666003, 100666006, 100666007, 100666012, 100666015, 100666016, 100666023, 100666026, 100666027, 100666034, 100666037, 100666038, 100666040, 100666041, 100666042, 100666044, 100666051, 100666056, 100666059, 100666060, 100666061, 100666062, 100666066, 100666069, 100666070, 100666071, 100666072, 100666076, 100666079, 100666080, 100666085, 100666088, 100666089, 100666096, 100666099, 100666100, 100666107, 100666110, 100666111, 100666113, 100666114, 100666115, 100666117, 100666124, 100666129, 100666132, 100666133, 100666134, 100666135, 100666139, 100666142, 100666143, 100666144, 100666145, 100666149, 100666152, 100666153, 100666158},fmi_Initialized);
RealDependentParameters7 = fmi_Functions.fmiGetReal(fmi, {100666161, 100666162, 100666169, 100666172, 100666173, 100666180, 100666183, 100666184, 100666186, 100666187, 100666188, 100666190, 100666197, 100666202, 100666205, 100666206, 100666207, 100666208, 100666212, 100666215, 100666216, 100666217, 100666218, 100666222, 100666225, 100666226, 100666231, 100666234, 100666235, 100666242, 100666245, 100666246, 100666253, 100666256, 100666257, 100666259, 100666260, 100666261, 100666263, 100666270, 100666275, 100666278, 100666279, 100666280, 100666281, 100666285, 100666288, 100666289, 100666290, 100666291, 100666295, 100666298, 100666299, 100666304, 100666307, 100666308, 100666315, 100666318, 100666319, 100666326, 100666329, 100666330, 100666332, 100666333, 100666334, 100666336, 100666342, 100666347, 100666350, 100666351, 100666352, 100666353, 100666357, 100666360, 100666361, 100666362, 100666363, 100666367, 100666370, 100666371, 100666376, 100666379, 100666380, 100666387, 100666390, 100666391, 100666398, 100666401, 100666402, 100666404, 100666405, 100666406, 100666408, 100666415, 100666420, 100666423, 100666424, 100666425, 100666426, 100666430},fmi_Initialized);
RealDependentParameters8 = fmi_Functions.fmiGetReal(fmi, {100666433, 100666434, 100666435, 100666436, 100666441, 100666444, 100666445, 100666452, 100666455, 100666456, 100666463, 100666466, 100666467, 100666474, 100666477, 100666478, 100666480, 100666481, 100666482, 100666484, 100663599, 100663602, 100663603, 100663604, 100663605, 100663606, 100663609, 100663610, 100663611, 100663612, 100663613, 100663614, 100663615, 100663616, 100663617, 100663618, 100663623, 100663624, 100663625, 100663626, 100663627, 100663628, 100663629, 100663630, 100663631, 100663632, 100663633, 100663634, 100663658, 100663659, 100663660, 100663661, 100663662, 100663663, 100663664, 100663665, 100663666, 100663667, 100663728, 100663729, 100663730, 100663731, 100663732, 100663733, 100663734, 100663735, 100663736, 100663737, 100663738, 100663739, 100663740, 100663741, 100663742, 100663743, 100663744, 100663745, 100663746, 100663747, 100663748, 100663749, 100663750, 100663751, 100663752, 100663753, 100663754, 100663755, 100663756, 100663757, 100663782, 100663792, 100663796, 100663797, 100663915, 100663916, 100663917, 100663972, 100663973, 100663974, 100663975, 100663976},fmi_Initialized);
RealDependentParameters9 = fmi_Functions.fmiGetReal(fmi, {100663977, 100663978, 100663979, 100663980, 100663981, 100663984, 100663985, 100664010, 100664013, 100664014, 100664015, 100664016, 100664017, 100664020, 100664021, 100664022, 100664023, 100664024, 100664025, 100664026, 100664027, 100664028, 100664029, 100664034, 100664035, 100664036, 100664037, 100664038, 100664039, 100664040, 100664041, 100664042, 100664043, 100664044, 100664045, 100664069, 100664070, 100664071, 100664072, 100664073, 100664074, 100664075, 100664076, 100664077, 100664078, 100664139, 100664140, 100664141, 100664142, 100664143, 100664144, 100664145, 100664146, 100664147, 100664148, 100664149, 100664150, 100664151, 100664152, 100664153, 100664154, 100664155, 100664156, 100664157, 100664158, 100664159, 100664160, 100664161, 100664162, 100664163, 100664164, 100664165, 100664166, 100664167, 100664168, 100664190, 100664193, 100664203, 100664207, 100664208, 100664326, 100664327, 100664328, 100664383, 100664384, 100664385, 100664386, 100664387, 100664388, 100664389, 100664390, 100664391, 100664392, 100664395, 100664396, 100664420, 100664422, 100664431, 100664432, 100664441},fmi_Initialized);
RealDependentParameters10 = fmi_Functions.fmiGetReal(fmi, {100664442, 100664443, 100664444, 100664445, 100664450, 100664452, 100664453, 100664454, 100664464, 100664476, 100664477, 100664478, 100664479, 100664489, 100664493, 100664496, 100664505, 100664506, 100664507, 100664536, 100664544, 100664546, 100664549, 100664550, 100664555, 100664556, 100664557, 100664558, 100664559, 100664560, 100664561, 100664567, 100664568, 100664580, 100664582, 100664583, 100664607, 100664609, 100664613, 100664614, 100664615, 100664626, 100664627, 100664628, 100664632, 100664633, 100664634, 100664635, 100664636, 100664637, 100664642, 100664643, 100664644, 100664647, 100664648, 100664649, 100664652, 100664653, 100664654, 100664660, 100664662, 100664663, 100664668, 100664670, 100664671, 100664676, 100664678, 100664679, 100664684, 100664686, 100664687, 100664692, 100664694, 100664695, 100664698, 100664700, 100664701, 100664704, 100664705, 100664706, 100664709, 100664710, 100664711, 100664717, 100664719, 100664720, 100664722, 100664727, 100664729, 100664730, 100664735, 100664737, 100664738, 100664742, 100664744, 100664745, 100664873, 100664874, 100664875, 100664876},fmi_Initialized);
RealDependentParameters11 = fmi_Functions.fmiGetReal(fmi, {100664877, 100664880, 100664881, 100664882, 100664883, 100664891, 100664894, 100664922, 100664927, 100664928, 100664929, 100664932, 100664945, 100664946, 100664947},fmi_Initialized);
IntegerDependentParameters = fmi_Functions.fmiGetInteger(fmi, {100663323, 100663351},integer(fmi_Initialized));
equation
  closedCTPressureDrop.heatExchangerThroughReal.efficiency = RealVariables1[1];
  closedCTPressureDrop.heatExchangerThroughReal.TCWater1 = RealVariables1[2];
  closedCTPressureDrop.heatExchangerThroughReal.TCWater2 = RealVariables1[3];
  closedCTPressureDrop.heatExchangerThroughReal.port_a_water.p = RealVariables1[4];
  closedCTPressureDrop.heatExchangerThroughReal.port_a_water.h_outflow = RealVariables1[5];
  closedCTPressureDrop.heatExchangerThroughReal.port_b_water.m_flow = RealVariables1[6];
  closedCTPressureDrop.heatExchangerThroughReal.port_b_water.p = RealVariables1[7];
  closedCTPressureDrop.heatExchangerThroughReal.port_b_water.h_outflow = RealVariables1[8];
  closedCTPressureDrop.heatExchangerThroughReal.port_a_air.m_flow = RealVariables1[9];
  closedCTPressureDrop.heatExchangerThroughReal.port_a_air.p = RealVariables1[10];
  closedCTPressureDrop.heatExchangerThroughReal.port_a_air.h_outflow = RealVariables1[11];
  closedCTPressureDrop.heatExchangerThroughReal.port_a_air.'Xi_outflow[1]' = RealVariables1[12];
  closedCTPressureDrop.heatExchangerThroughReal.port_b_air.m_flow = RealVariables1[13];
  closedCTPressureDrop.heatExchangerThroughReal.port_b_air.p = RealVariables1[14];
  closedCTPressureDrop.heatExchangerThroughReal.port_b_air.h_outflow = RealVariables1[15];
  closedCTPressureDrop.heatExchangerThroughReal.port_b_air.'Xi_outflow[1]' = RealVariables1[16];
  closedCTPressureDrop.heatExchangerThroughReal.port_a_Cwater.m_flow = RealVariables1[17];
  closedCTPressureDrop.heatExchangerThroughReal.port_a_Cwater.p = RealVariables1[18];
  closedCTPressureDrop.heatExchangerThroughReal.port_a_Cwater.h_outflow = RealVariables1[19];
  closedCTPressureDrop.heatExchangerThroughReal.port_b_Cwater.p = RealVariables1[20];
  closedCTPressureDrop.heatExchangerThroughReal.port_b_Cwater.h_outflow = RealVariables1[21];
  closedCTPressureDrop.heatExchangerThroughReal.closedHeatToAirPressureDrop.port_a_water.m_flow = RealVariables1[22];
  closedCTPressureDrop.heatExchangerThroughReal.closedHeatToAirPressureDrop.port_a_water.p = RealVariables1[23];
  closedCTPressureDrop.heatExchangerThroughReal.closedHeatToAirPressureDrop.port_a_water.h_outflow = RealVariables1[24];
  closedCTPressureDrop.heatExchangerThroughReal.closedHeatToAirPressureDrop.port_b_water.m_flow = RealVariables1[25];
  closedCTPressureDrop.heatExchangerThroughReal.closedHeatToAirPressureDrop.port_b_water.p = RealVariables1[26];
  closedCTPressureDrop.heatExchangerThroughReal.closedHeatToAirPressureDrop.port_b_water.h_outflow = RealVariables1[27];
  closedCTPressureDrop.heatExchangerThroughReal.closedHeatToAirPressureDrop.port_a_air.m_flow = RealVariables1[28];
  closedCTPressureDrop.heatExchangerThroughReal.closedHeatToAirPressureDrop.port_a_air.p = RealVariables1[29];
  closedCTPressureDrop.heatExchangerThroughReal.closedHeatToAirPressureDrop.port_a_air.h_outflow = RealVariables1[30];
  closedCTPressureDrop.heatExchangerThroughReal.closedHeatToAirPressureDrop.port_a_air.'Xi_outflow[1]' = RealVariables1[31];
  closedCTPressureDrop.heatExchangerThroughReal.closedHeatToAirPressureDrop.port_b_air.m_flow = RealVariables1[32];
  closedCTPressureDrop.heatExchangerThroughReal.closedHeatToAirPressureDrop.port_b_air.p = RealVariables1[33];
  closedCTPressureDrop.heatExchangerThroughReal.closedHeatToAirPressureDrop.port_b_air.h_outflow = RealVariables1[34];
  closedCTPressureDrop.heatExchangerThroughReal.closedHeatToAirPressureDrop.port_b_air.'Xi_outflow[1]' = RealVariables1[35];
  closedCTPressureDrop.heatExchangerThroughReal.closedHeatToAirPressureDrop.'port_a[1]'.T = RealVariables1[36];
  closedCTPressureDrop.heatExchangerThroughReal.closedHeatToAirPressureDrop.'port_a[1]'.Q_flow = RealVariables1[37];
  closedCTPressureDrop.heatExchangerThroughReal.closedHeatToAirPressureDrop.'port_a[2]'.T = RealVariables1[38];
  closedCTPressureDrop.heatExchangerThroughReal.closedHeatToAirPressureDrop.'port_a[2]'.Q_flow = RealVariables1[39];
  closedCTPressureDrop.heatExchangerThroughReal.closedHeatToAirPressureDrop.TWater1 = RealVariables1[40];
  closedCTPressureDrop.heatExchangerThroughReal.closedHeatToAirPressureDrop.hWater1 = RealVariables1[41];
  closedCTPressureDrop.heatExchangerThroughReal.closedHeatToAirPressureDrop.TWater1C = RealVariables1[42];
  closedCTPressureDrop.heatExchangerThroughReal.closedHeatToAirPressureDrop.TWater2 = RealVariables1[43];
  closedCTPressureDrop.heatExchangerThroughReal.closedHeatToAirPressureDrop.hWater2 = RealVariables1[44];
  closedCTPressureDrop.heatExchangerThroughReal.closedHeatToAirPressureDrop.mWater2 = RealVariables1[45];
  closedCTPressureDrop.heatExchangerThroughReal.closedHeatToAirPressureDrop.TWater2C = RealVariables1[46];
  closedCTPressureDrop.heatExchangerThroughReal.closedHeatToAirPressureDrop.TAir1 = RealVariables1[47];
  closedCTPressureDrop.heatExchangerThroughReal.closedHeatToAirPressureDrop.hAir1 = RealVariables1[48];
  closedCTPressureDrop.heatExchangerThroughReal.closedHeatToAirPressureDrop.mAir1 = RealVariables1[49];
  closedCTPressureDrop.heatExchangerThroughReal.closedHeatToAirPressureDrop.X1 = RealVariables1[50];
  closedCTPressureDrop.heatExchangerThroughReal.closedHeatToAirPressureDrop.TAir1C = RealVariables1[51];
  closedCTPressureDrop.heatExchangerThroughReal.closedHeatToAirPressureDrop.H1 = RealVariables1[52];
  closedCTPressureDrop.heatExchangerThroughReal.closedHeatToAirPressureDrop.mDAir1 = RealVariables1[53];
  closedCTPressureDrop.heatExchangerThroughReal.closedHeatToAirPressureDrop.mVap1 = RealVariables1[54];
  closedCTPressureDrop.heatExchangerThroughReal.closedHeatToAirPressureDrop.hsw1 = RealVariables1[55];
  closedCTPressureDrop.heatExchangerThroughReal.closedHeatToAirPressureDrop.Hsat1 = RealVariables1[56];
  closedCTPressureDrop.heatExchangerThroughReal.closedHeatToAirPressureDrop.pSat1 = RealVariables1[57];
  closedCTPressureDrop.heatExchangerThroughReal.closedHeatToAirPressureDrop.rho1 = RealVariables1[58];
  closedCTPressureDrop.heatExchangerThroughReal.closedHeatToAirPressureDrop.N1 = RealVariables1[59];
  closedCTPressureDrop.heatExchangerThroughReal.closedHeatToAirPressureDrop.TAir2 = RealVariables1[60];
  closedCTPressureDrop.heatExchangerThroughReal.closedHeatToAirPressureDrop.hAir2 = RealVariables1[61];
  closedCTPressureDrop.heatExchangerThroughReal.closedHeatToAirPressureDrop.mAir2 = RealVariables1[62];
  closedCTPressureDrop.heatExchangerThroughReal.closedHeatToAirPressureDrop.X2 = RealVariables1[63];
  closedCTPressureDrop.heatExchangerThroughReal.closedHeatToAirPressureDrop.mDAir2 = RealVariables1[64];
  closedCTPressureDrop.heatExchangerThroughReal.closedHeatToAirPressureDrop.mVap2 = RealVariables1[65];
  closedCTPressureDrop.heatExchangerThroughReal.closedHeatToAirPressureDrop.H2 = RealVariables1[66];
  closedCTPressureDrop.heatExchangerThroughReal.closedHeatToAirPressureDrop.TAir2C = RealVariables1[67];
  closedCTPressureDrop.heatExchangerThroughReal.closedHeatToAirPressureDrop.hsw2 = RealVariables1[68];
  closedCTPressureDrop.heatExchangerThroughReal.closedHeatToAirPressureDrop.Hsat2 = RealVariables1[69];
  closedCTPressureDrop.heatExchangerThroughReal.closedHeatToAirPressureDrop.pSat2 = RealVariables1[70];
  closedCTPressureDrop.heatExchangerThroughReal.closedHeatToAirPressureDrop.rho2 = RealVariables1[71];
  closedCTPressureDrop.heatExchangerThroughReal.closedHeatToAirPressureDrop.N2 = RealVariables1[72];
  closedCTPressureDrop.heatExchangerThroughReal.closedHeatToAirPressureDrop.phi2 = RealVariables1[73];
  closedCTPressureDrop.heatExchangerThroughReal.closedHeatToAirPressureDrop.mEvap = RealVariables1[74];
  closedCTPressureDrop.heatExchangerThroughReal.closedHeatToAirPressureDrop.hvap = RealVariables1[75];
  closedCTPressureDrop.heatExchangerThroughReal.closedHeatToAirPressureDrop.Tvap = RealVariables1[76];
  closedCTPressureDrop.heatExchangerThroughReal.closedHeatToAirPressureDrop.TvapC = RealVariables1[77];
  closedCTPressureDrop.heatExchangerThroughReal.closedHeatToAirPressureDrop.Qsen = RealVariables1[78];
  closedCTPressureDrop.heatExchangerThroughReal.closedHeatToAirPressureDrop.Qlat = RealVariables1[79];
  closedCTPressureDrop.heatExchangerThroughReal.closedHeatToAirPressureDrop.Qtot = RealVariables1[80];
  closedCTPressureDrop.heatExchangerThroughReal.closedHeatToAirPressureDrop.Qcol = RealVariables1[81];
  closedCTPressureDrop.heatExchangerThroughReal.closedHeatToAirPressureDrop.Qfi = RealVariables1[82];
  closedCTPressureDrop.heatExchangerThroughReal.closedHeatToAirPressureDrop.mMed = RealVariables1[83];
  closedCTPressureDrop.heatExchangerThroughReal.closedHeatToAirPressureDrop.rhoMed = RealVariables1[84];
  closedCTPressureDrop.heatExchangerThroughReal.closedHeatToAirPressureDrop.IncP = RealVariables1[85];
  closedCTPressureDrop.heatExchangerThroughReal.closedHeatToAirPressureDrop.e_a = RealVariables1[86];
  closedCTPressureDrop.heatExchangerThroughReal.closedHeatToAirPressureDrop.NTU = RealVariables1[87];
  closedCTPressureDrop.heatExchangerThroughReal.closedHeatToAirPressureDrop.C_s = RealVariables1[88];
  closedCTPressureDrop.heatExchangerThroughReal.closedHeatToAirPressureDrop.m_ratio = RealVariables1[89];
  closedCTPressureDrop.heatExchangerThroughReal.closedHeatToAirPressureDrop.Tfi = RealVariables1[90];
  closedCTPressureDrop.heatExchangerThroughReal.closedHeatToAirPressureDrop.Tfi_der = RealVariables1[91];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'port_a_1[1, 1]'.T = RealVariables1[92];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'port_a_1[1, 1]'.Q_flow = RealVariables1[93];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'port_a_1[1, 2]'.T = RealVariables1[94];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'port_a_1[1, 2]'.Q_flow = RealVariables1[95];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'port_a_1[1, 3]'.T = RealVariables1[96];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'port_a_1[1, 3]'.Q_flow = RealVariables1[97];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'port_a_1[1, 4]'.T = RealVariables1[98];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'port_a_1[1, 4]'.Q_flow = RealVariables1[99];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'port_a_1[1, 5]'.T = RealVariables1[100];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'port_a_1[1, 5]'.Q_flow = RealVariables2[1];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'port_a_1[1, 6]'.T = RealVariables2[2];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'port_a_1[1, 6]'.Q_flow = RealVariables2[3];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'port_a_1[1, 7]'.T = RealVariables2[4];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'port_a_1[1, 7]'.Q_flow = RealVariables2[5];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'port_a_1[1, 8]'.T = RealVariables2[6];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'port_a_1[1, 8]'.Q_flow = RealVariables2[7];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'port_a_1[1, 9]'.T = RealVariables2[8];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'port_a_1[1, 9]'.Q_flow = RealVariables2[9];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'port_a_1[1, 10]'.T = RealVariables2[10];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'port_a_1[1, 10]'.Q_flow = RealVariables2[11];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'port_b_1[1, 1]'.T = RealVariables2[12];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'port_b_1[1, 1]'.Q_flow = RealVariables2[13];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'port_b_1[1, 2]'.T = RealVariables2[14];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'port_b_1[1, 2]'.Q_flow = RealVariables2[15];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'port_b_1[1, 3]'.T = RealVariables2[16];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'port_b_1[1, 3]'.Q_flow = RealVariables2[17];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'port_b_1[1, 4]'.T = RealVariables2[18];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'port_b_1[1, 4]'.Q_flow = RealVariables2[19];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'port_b_1[1, 5]'.T = RealVariables2[20];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'port_b_1[1, 5]'.Q_flow = RealVariables2[21];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'port_b_1[1, 6]'.T = RealVariables2[22];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'port_b_1[1, 6]'.Q_flow = RealVariables2[23];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'port_b_1[1, 7]'.T = RealVariables2[24];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'port_b_1[1, 7]'.Q_flow = RealVariables2[25];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'port_b_1[1, 8]'.T = RealVariables2[26];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'port_b_1[1, 8]'.Q_flow = RealVariables2[27];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'port_b_1[1, 9]'.T = RealVariables2[28];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'port_b_1[1, 9]'.Q_flow = RealVariables2[29];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'port_b_1[1, 10]'.T = RealVariables2[30];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'port_b_1[1, 10]'.Q_flow = RealVariables2[31];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'port_a_2[1, 1]'.T = RealVariables2[32];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'port_b_2[1, 1]'.T = RealVariables2[33];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 1, 1]'.port_a_1.T = RealVariables2[34];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 1, 1]'.port_a_1.Q_flow = RealVariables2[35];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 1, 1]'.port_b_1.T = RealVariables2[36];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 1, 1]'.port_b_1.Q_flow = RealVariables2[37];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 1, 1]'.port_a_2.T = RealVariables2[38];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 1, 1]'.port_b_2.T = RealVariables2[39];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 1, 1]'.port_b_2.Q_flow = RealVariables2[40];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 1, 1]'.thermalConductor_a_1.Q_flow = RealVariables2[41];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 1, 1]'.thermalConductor_a_1.dT = RealVariables2[42];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 1, 1]'.thermalConductor_a_1.port_a.T = RealVariables2[43];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 1, 1]'.thermalConductor_a_1.port_a.Q_flow = RealVariables2[44];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 1, 1]'.thermalConductor_a_1.port_b.T = RealVariables2[45];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 1, 1]'.thermalConductor_a_1.port_b.Q_flow = RealVariables2[46];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 1, 1]'.thermalConductor_a_1.T = RealVariables2[47];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 1, 1]'.thermalConductor_a_1.G = RealVariables2[48];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 1, 1]'.thermalConductor_a_1.k = RealVariables2[49];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 1, 1]'.thermalConductor_b_1.Q_flow = RealVariables2[50];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 1, 1]'.thermalConductor_b_1.dT = RealVariables2[51];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 1, 1]'.thermalConductor_b_1.port_a.T = RealVariables2[52];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 1, 1]'.thermalConductor_b_1.port_a.Q_flow = RealVariables2[53];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 1, 1]'.thermalConductor_b_1.port_b.T = RealVariables2[54];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 1, 1]'.thermalConductor_b_1.port_b.Q_flow = RealVariables2[55];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 1, 1]'.thermalConductor_b_1.T = RealVariables2[56];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 1, 1]'.thermalConductor_b_1.G = RealVariables2[57];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 1, 1]'.thermalConductor_b_1.k = RealVariables2[58];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 1, 1]'.thermalConductor_a_2.dT = RealVariables2[59];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 1, 1]'.thermalConductor_a_2.port_a.T = RealVariables2[60];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 1, 1]'.thermalConductor_a_2.port_b.T = RealVariables2[61];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 1, 1]'.thermalConductor_a_2.T = RealVariables2[62];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 1, 1]'.thermalConductor_a_2.G = RealVariables2[63];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 1, 1]'.thermalConductor_a_2.k = RealVariables2[64];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 1, 1]'.thermalConductor_b_2.Q_flow = RealVariables2[65];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 1, 1]'.thermalConductor_b_2.dT = RealVariables2[66];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 1, 1]'.thermalConductor_b_2.port_a.T = RealVariables2[67];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 1, 1]'.thermalConductor_b_2.port_a.Q_flow = RealVariables2[68];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 1, 1]'.thermalConductor_b_2.port_b.T = RealVariables2[69];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 1, 1]'.thermalConductor_b_2.port_b.Q_flow = RealVariables2[70];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 1, 1]'.thermalConductor_b_2.T = RealVariables2[71];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 1, 1]'.thermalConductor_b_2.G = RealVariables2[72];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 1, 1]'.thermalConductor_b_2.k = RealVariables2[73];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 1, 1]'.thermalConductor_a_3.dT = RealVariables2[74];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 1, 1]'.thermalConductor_a_3.port_a.T = RealVariables2[75];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 1, 1]'.thermalConductor_a_3.port_b.T = RealVariables2[76];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 1, 1]'.thermalConductor_a_3.T = RealVariables2[77];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 1, 1]'.thermalConductor_a_3.G = RealVariables2[78];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 1, 1]'.thermalConductor_a_3.k = RealVariables2[79];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 1, 1]'.thermalConductor_b_3.dT = RealVariables2[80];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 1, 1]'.thermalConductor_b_3.port_a.T = RealVariables2[81];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 1, 1]'.thermalConductor_b_3.port_b.T = RealVariables2[82];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 1, 1]'.thermalConductor_b_3.T = RealVariables2[83];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 1, 1]'.thermalConductor_b_3.G = RealVariables2[84];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 1, 1]'.thermalConductor_b_3.k = RealVariables2[85];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 1, 1]'.heatCapacitor.T = RealVariables2[86];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 1, 1]'.heatCapacitor.T_der = RealVariables2[87];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 1, 1]'.heatCapacitor.Q_flow = RealVariables2[88];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 1, 1]'.heatCapacitor.port.T = RealVariables2[89];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 1, 1]'.heatCapacitor.port.Q_flow = RealVariables2[90];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 1, 1]'.heatCapacitor.der_T = RealVariables2[91];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 1, 1]'.heatCapacitor.C = RealVariables2[92];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 1, 1]'.port_int.T = RealVariables2[93];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 2, 1]'.port_a_1.T = RealVariables2[94];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 2, 1]'.port_a_1.Q_flow = RealVariables2[95];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 2, 1]'.port_b_1.T = RealVariables2[96];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 2, 1]'.port_b_1.Q_flow = RealVariables2[97];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 2, 1]'.port_a_2.T = RealVariables2[98];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 2, 1]'.port_a_2.Q_flow = RealVariables2[99];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 2, 1]'.port_b_2.T = RealVariables2[100];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 2, 1]'.port_b_2.Q_flow = RealVariables3[1];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 2, 1]'.thermalConductor_a_1.Q_flow = RealVariables3[2];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 2, 1]'.thermalConductor_a_1.dT = RealVariables3[3];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 2, 1]'.thermalConductor_a_1.port_a.T = RealVariables3[4];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 2, 1]'.thermalConductor_a_1.port_a.Q_flow = RealVariables3[5];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 2, 1]'.thermalConductor_a_1.port_b.T = RealVariables3[6];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 2, 1]'.thermalConductor_a_1.port_b.Q_flow = RealVariables3[7];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 2, 1]'.thermalConductor_a_1.T = RealVariables3[8];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 2, 1]'.thermalConductor_a_1.G = RealVariables3[9];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 2, 1]'.thermalConductor_a_1.k = RealVariables3[10];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 2, 1]'.thermalConductor_b_1.Q_flow = RealVariables3[11];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 2, 1]'.thermalConductor_b_1.dT = RealVariables3[12];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 2, 1]'.thermalConductor_b_1.port_a.T = RealVariables3[13];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 2, 1]'.thermalConductor_b_1.port_a.Q_flow = RealVariables3[14];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 2, 1]'.thermalConductor_b_1.port_b.T = RealVariables3[15];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 2, 1]'.thermalConductor_b_1.port_b.Q_flow = RealVariables3[16];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 2, 1]'.thermalConductor_b_1.T = RealVariables3[17];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 2, 1]'.thermalConductor_b_1.G = RealVariables3[18];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 2, 1]'.thermalConductor_b_1.k = RealVariables3[19];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 2, 1]'.thermalConductor_a_2.Q_flow = RealVariables3[20];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 2, 1]'.thermalConductor_a_2.dT = RealVariables3[21];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 2, 1]'.thermalConductor_a_2.port_a.T = RealVariables3[22];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 2, 1]'.thermalConductor_a_2.port_a.Q_flow = RealVariables3[23];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 2, 1]'.thermalConductor_a_2.port_b.T = RealVariables3[24];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 2, 1]'.thermalConductor_a_2.port_b.Q_flow = RealVariables3[25];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 2, 1]'.thermalConductor_a_2.T = RealVariables3[26];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 2, 1]'.thermalConductor_a_2.G = RealVariables3[27];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 2, 1]'.thermalConductor_a_2.k = RealVariables3[28];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 2, 1]'.thermalConductor_b_2.Q_flow = RealVariables3[29];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 2, 1]'.thermalConductor_b_2.dT = RealVariables3[30];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 2, 1]'.thermalConductor_b_2.port_a.T = RealVariables3[31];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 2, 1]'.thermalConductor_b_2.port_a.Q_flow = RealVariables3[32];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 2, 1]'.thermalConductor_b_2.port_b.T = RealVariables3[33];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 2, 1]'.thermalConductor_b_2.port_b.Q_flow = RealVariables3[34];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 2, 1]'.thermalConductor_b_2.T = RealVariables3[35];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 2, 1]'.thermalConductor_b_2.G = RealVariables3[36];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 2, 1]'.thermalConductor_b_2.k = RealVariables3[37];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 2, 1]'.thermalConductor_a_3.dT = RealVariables3[38];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 2, 1]'.thermalConductor_a_3.port_a.T = RealVariables3[39];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 2, 1]'.thermalConductor_a_3.port_b.T = RealVariables3[40];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 2, 1]'.thermalConductor_a_3.T = RealVariables3[41];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 2, 1]'.thermalConductor_a_3.G = RealVariables3[42];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 2, 1]'.thermalConductor_a_3.k = RealVariables3[43];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 2, 1]'.thermalConductor_b_3.dT = RealVariables3[44];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 2, 1]'.thermalConductor_b_3.port_a.T = RealVariables3[45];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 2, 1]'.thermalConductor_b_3.port_b.T = RealVariables3[46];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 2, 1]'.thermalConductor_b_3.T = RealVariables3[47];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 2, 1]'.thermalConductor_b_3.G = RealVariables3[48];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 2, 1]'.thermalConductor_b_3.k = RealVariables3[49];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 2, 1]'.heatCapacitor.T = RealVariables3[50];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 2, 1]'.heatCapacitor.T_der = RealVariables3[51];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 2, 1]'.heatCapacitor.Q_flow = RealVariables3[52];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 2, 1]'.heatCapacitor.port.T = RealVariables3[53];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 2, 1]'.heatCapacitor.port.Q_flow = RealVariables3[54];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 2, 1]'.heatCapacitor.der_T = RealVariables3[55];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 2, 1]'.heatCapacitor.C = RealVariables3[56];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 2, 1]'.port_int.T = RealVariables3[57];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 3, 1]'.port_a_1.T = RealVariables3[58];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 3, 1]'.port_a_1.Q_flow = RealVariables3[59];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 3, 1]'.port_b_1.T = RealVariables3[60];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 3, 1]'.port_b_1.Q_flow = RealVariables3[61];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 3, 1]'.port_a_2.T = RealVariables3[62];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 3, 1]'.port_a_2.Q_flow = RealVariables3[63];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 3, 1]'.port_b_2.T = RealVariables3[64];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 3, 1]'.port_b_2.Q_flow = RealVariables3[65];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 3, 1]'.thermalConductor_a_1.Q_flow = RealVariables3[66];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 3, 1]'.thermalConductor_a_1.dT = RealVariables3[67];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 3, 1]'.thermalConductor_a_1.port_a.T = RealVariables3[68];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 3, 1]'.thermalConductor_a_1.port_a.Q_flow = RealVariables3[69];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 3, 1]'.thermalConductor_a_1.port_b.T = RealVariables3[70];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 3, 1]'.thermalConductor_a_1.port_b.Q_flow = RealVariables3[71];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 3, 1]'.thermalConductor_a_1.T = RealVariables3[72];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 3, 1]'.thermalConductor_a_1.G = RealVariables3[73];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 3, 1]'.thermalConductor_a_1.k = RealVariables3[74];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 3, 1]'.thermalConductor_b_1.Q_flow = RealVariables3[75];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 3, 1]'.thermalConductor_b_1.dT = RealVariables3[76];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 3, 1]'.thermalConductor_b_1.port_a.T = RealVariables3[77];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 3, 1]'.thermalConductor_b_1.port_a.Q_flow = RealVariables3[78];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 3, 1]'.thermalConductor_b_1.port_b.T = RealVariables3[79];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 3, 1]'.thermalConductor_b_1.port_b.Q_flow = RealVariables3[80];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 3, 1]'.thermalConductor_b_1.T = RealVariables3[81];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 3, 1]'.thermalConductor_b_1.G = RealVariables3[82];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 3, 1]'.thermalConductor_b_1.k = RealVariables3[83];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 3, 1]'.thermalConductor_a_2.Q_flow = RealVariables3[84];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 3, 1]'.thermalConductor_a_2.dT = RealVariables3[85];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 3, 1]'.thermalConductor_a_2.port_a.T = RealVariables3[86];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 3, 1]'.thermalConductor_a_2.port_a.Q_flow = RealVariables3[87];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 3, 1]'.thermalConductor_a_2.port_b.T = RealVariables3[88];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 3, 1]'.thermalConductor_a_2.port_b.Q_flow = RealVariables3[89];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 3, 1]'.thermalConductor_a_2.T = RealVariables3[90];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 3, 1]'.thermalConductor_a_2.G = RealVariables3[91];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 3, 1]'.thermalConductor_a_2.k = RealVariables3[92];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 3, 1]'.thermalConductor_b_2.Q_flow = RealVariables3[93];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 3, 1]'.thermalConductor_b_2.dT = RealVariables3[94];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 3, 1]'.thermalConductor_b_2.port_a.T = RealVariables3[95];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 3, 1]'.thermalConductor_b_2.port_a.Q_flow = RealVariables3[96];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 3, 1]'.thermalConductor_b_2.port_b.T = RealVariables3[97];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 3, 1]'.thermalConductor_b_2.port_b.Q_flow = RealVariables3[98];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 3, 1]'.thermalConductor_b_2.T = RealVariables3[99];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 3, 1]'.thermalConductor_b_2.G = RealVariables3[100];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 3, 1]'.thermalConductor_b_2.k = RealVariables4[1];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 3, 1]'.thermalConductor_a_3.dT = RealVariables4[2];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 3, 1]'.thermalConductor_a_3.port_a.T = RealVariables4[3];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 3, 1]'.thermalConductor_a_3.port_b.T = RealVariables4[4];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 3, 1]'.thermalConductor_a_3.T = RealVariables4[5];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 3, 1]'.thermalConductor_a_3.G = RealVariables4[6];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 3, 1]'.thermalConductor_a_3.k = RealVariables4[7];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 3, 1]'.thermalConductor_b_3.dT = RealVariables4[8];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 3, 1]'.thermalConductor_b_3.port_a.T = RealVariables4[9];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 3, 1]'.thermalConductor_b_3.port_b.T = RealVariables4[10];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 3, 1]'.thermalConductor_b_3.T = RealVariables4[11];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 3, 1]'.thermalConductor_b_3.G = RealVariables4[12];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 3, 1]'.thermalConductor_b_3.k = RealVariables4[13];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 3, 1]'.heatCapacitor.T = RealVariables4[14];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 3, 1]'.heatCapacitor.T_der = RealVariables4[15];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 3, 1]'.heatCapacitor.Q_flow = RealVariables4[16];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 3, 1]'.heatCapacitor.port.T = RealVariables4[17];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 3, 1]'.heatCapacitor.port.Q_flow = RealVariables4[18];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 3, 1]'.heatCapacitor.der_T = RealVariables4[19];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 3, 1]'.heatCapacitor.C = RealVariables4[20];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 3, 1]'.port_int.T = RealVariables4[21];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 4, 1]'.port_a_1.T = RealVariables4[22];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 4, 1]'.port_a_1.Q_flow = RealVariables4[23];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 4, 1]'.port_b_1.T = RealVariables4[24];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 4, 1]'.port_b_1.Q_flow = RealVariables4[25];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 4, 1]'.port_a_2.T = RealVariables4[26];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 4, 1]'.port_a_2.Q_flow = RealVariables4[27];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 4, 1]'.port_b_2.T = RealVariables4[28];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 4, 1]'.port_b_2.Q_flow = RealVariables4[29];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 4, 1]'.thermalConductor_a_1.Q_flow = RealVariables4[30];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 4, 1]'.thermalConductor_a_1.dT = RealVariables4[31];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 4, 1]'.thermalConductor_a_1.port_a.T = RealVariables4[32];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 4, 1]'.thermalConductor_a_1.port_a.Q_flow = RealVariables4[33];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 4, 1]'.thermalConductor_a_1.port_b.T = RealVariables4[34];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 4, 1]'.thermalConductor_a_1.port_b.Q_flow = RealVariables4[35];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 4, 1]'.thermalConductor_a_1.T = RealVariables4[36];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 4, 1]'.thermalConductor_a_1.G = RealVariables4[37];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 4, 1]'.thermalConductor_a_1.k = RealVariables4[38];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 4, 1]'.thermalConductor_b_1.Q_flow = RealVariables4[39];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 4, 1]'.thermalConductor_b_1.dT = RealVariables4[40];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 4, 1]'.thermalConductor_b_1.port_a.T = RealVariables4[41];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 4, 1]'.thermalConductor_b_1.port_a.Q_flow = RealVariables4[42];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 4, 1]'.thermalConductor_b_1.port_b.T = RealVariables4[43];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 4, 1]'.thermalConductor_b_1.port_b.Q_flow = RealVariables4[44];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 4, 1]'.thermalConductor_b_1.T = RealVariables4[45];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 4, 1]'.thermalConductor_b_1.G = RealVariables4[46];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 4, 1]'.thermalConductor_b_1.k = RealVariables4[47];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 4, 1]'.thermalConductor_a_2.Q_flow = RealVariables4[48];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 4, 1]'.thermalConductor_a_2.dT = RealVariables4[49];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 4, 1]'.thermalConductor_a_2.port_a.T = RealVariables4[50];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 4, 1]'.thermalConductor_a_2.port_a.Q_flow = RealVariables4[51];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 4, 1]'.thermalConductor_a_2.port_b.T = RealVariables4[52];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 4, 1]'.thermalConductor_a_2.port_b.Q_flow = RealVariables4[53];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 4, 1]'.thermalConductor_a_2.T = RealVariables4[54];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 4, 1]'.thermalConductor_a_2.G = RealVariables4[55];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 4, 1]'.thermalConductor_a_2.k = RealVariables4[56];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 4, 1]'.thermalConductor_b_2.Q_flow = RealVariables4[57];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 4, 1]'.thermalConductor_b_2.dT = RealVariables4[58];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 4, 1]'.thermalConductor_b_2.port_a.T = RealVariables4[59];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 4, 1]'.thermalConductor_b_2.port_a.Q_flow = RealVariables4[60];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 4, 1]'.thermalConductor_b_2.port_b.T = RealVariables4[61];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 4, 1]'.thermalConductor_b_2.port_b.Q_flow = RealVariables4[62];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 4, 1]'.thermalConductor_b_2.T = RealVariables4[63];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 4, 1]'.thermalConductor_b_2.G = RealVariables4[64];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 4, 1]'.thermalConductor_b_2.k = RealVariables4[65];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 4, 1]'.thermalConductor_a_3.dT = RealVariables4[66];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 4, 1]'.thermalConductor_a_3.port_a.T = RealVariables4[67];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 4, 1]'.thermalConductor_a_3.port_b.T = RealVariables4[68];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 4, 1]'.thermalConductor_a_3.T = RealVariables4[69];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 4, 1]'.thermalConductor_a_3.G = RealVariables4[70];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 4, 1]'.thermalConductor_a_3.k = RealVariables4[71];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 4, 1]'.thermalConductor_b_3.dT = RealVariables4[72];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 4, 1]'.thermalConductor_b_3.port_a.T = RealVariables4[73];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 4, 1]'.thermalConductor_b_3.port_b.T = RealVariables4[74];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 4, 1]'.thermalConductor_b_3.T = RealVariables4[75];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 4, 1]'.thermalConductor_b_3.G = RealVariables4[76];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 4, 1]'.thermalConductor_b_3.k = RealVariables4[77];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 4, 1]'.heatCapacitor.T = RealVariables4[78];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 4, 1]'.heatCapacitor.T_der = RealVariables4[79];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 4, 1]'.heatCapacitor.Q_flow = RealVariables4[80];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 4, 1]'.heatCapacitor.port.T = RealVariables4[81];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 4, 1]'.heatCapacitor.port.Q_flow = RealVariables4[82];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 4, 1]'.heatCapacitor.der_T = RealVariables4[83];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 4, 1]'.heatCapacitor.C = RealVariables4[84];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 4, 1]'.port_int.T = RealVariables4[85];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 5, 1]'.port_a_1.T = RealVariables4[86];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 5, 1]'.port_a_1.Q_flow = RealVariables4[87];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 5, 1]'.port_b_1.T = RealVariables4[88];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 5, 1]'.port_b_1.Q_flow = RealVariables4[89];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 5, 1]'.port_a_2.T = RealVariables4[90];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 5, 1]'.port_a_2.Q_flow = RealVariables4[91];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 5, 1]'.port_b_2.T = RealVariables4[92];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 5, 1]'.port_b_2.Q_flow = RealVariables4[93];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 5, 1]'.thermalConductor_a_1.Q_flow = RealVariables4[94];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 5, 1]'.thermalConductor_a_1.dT = RealVariables4[95];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 5, 1]'.thermalConductor_a_1.port_a.T = RealVariables4[96];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 5, 1]'.thermalConductor_a_1.port_a.Q_flow = RealVariables4[97];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 5, 1]'.thermalConductor_a_1.port_b.T = RealVariables4[98];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 5, 1]'.thermalConductor_a_1.port_b.Q_flow = RealVariables4[99];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 5, 1]'.thermalConductor_a_1.T = RealVariables4[100];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 5, 1]'.thermalConductor_a_1.G = RealVariables5[1];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 5, 1]'.thermalConductor_a_1.k = RealVariables5[2];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 5, 1]'.thermalConductor_b_1.Q_flow = RealVariables5[3];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 5, 1]'.thermalConductor_b_1.dT = RealVariables5[4];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 5, 1]'.thermalConductor_b_1.port_a.T = RealVariables5[5];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 5, 1]'.thermalConductor_b_1.port_a.Q_flow = RealVariables5[6];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 5, 1]'.thermalConductor_b_1.port_b.T = RealVariables5[7];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 5, 1]'.thermalConductor_b_1.port_b.Q_flow = RealVariables5[8];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 5, 1]'.thermalConductor_b_1.T = RealVariables5[9];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 5, 1]'.thermalConductor_b_1.G = RealVariables5[10];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 5, 1]'.thermalConductor_b_1.k = RealVariables5[11];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 5, 1]'.thermalConductor_a_2.Q_flow = RealVariables5[12];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 5, 1]'.thermalConductor_a_2.dT = RealVariables5[13];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 5, 1]'.thermalConductor_a_2.port_a.T = RealVariables5[14];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 5, 1]'.thermalConductor_a_2.port_a.Q_flow = RealVariables5[15];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 5, 1]'.thermalConductor_a_2.port_b.T = RealVariables5[16];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 5, 1]'.thermalConductor_a_2.port_b.Q_flow = RealVariables5[17];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 5, 1]'.thermalConductor_a_2.T = RealVariables5[18];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 5, 1]'.thermalConductor_a_2.G = RealVariables5[19];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 5, 1]'.thermalConductor_a_2.k = RealVariables5[20];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 5, 1]'.thermalConductor_b_2.Q_flow = RealVariables5[21];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 5, 1]'.thermalConductor_b_2.dT = RealVariables5[22];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 5, 1]'.thermalConductor_b_2.port_a.T = RealVariables5[23];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 5, 1]'.thermalConductor_b_2.port_a.Q_flow = RealVariables5[24];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 5, 1]'.thermalConductor_b_2.port_b.T = RealVariables5[25];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 5, 1]'.thermalConductor_b_2.port_b.Q_flow = RealVariables5[26];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 5, 1]'.thermalConductor_b_2.T = RealVariables5[27];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 5, 1]'.thermalConductor_b_2.G = RealVariables5[28];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 5, 1]'.thermalConductor_b_2.k = RealVariables5[29];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 5, 1]'.thermalConductor_a_3.dT = RealVariables5[30];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 5, 1]'.thermalConductor_a_3.port_a.T = RealVariables5[31];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 5, 1]'.thermalConductor_a_3.port_b.T = RealVariables5[32];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 5, 1]'.thermalConductor_a_3.T = RealVariables5[33];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 5, 1]'.thermalConductor_a_3.G = RealVariables5[34];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 5, 1]'.thermalConductor_a_3.k = RealVariables5[35];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 5, 1]'.thermalConductor_b_3.dT = RealVariables5[36];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 5, 1]'.thermalConductor_b_3.port_a.T = RealVariables5[37];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 5, 1]'.thermalConductor_b_3.port_b.T = RealVariables5[38];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 5, 1]'.thermalConductor_b_3.T = RealVariables5[39];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 5, 1]'.thermalConductor_b_3.G = RealVariables5[40];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 5, 1]'.thermalConductor_b_3.k = RealVariables5[41];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 5, 1]'.heatCapacitor.T = RealVariables5[42];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 5, 1]'.heatCapacitor.T_der = RealVariables5[43];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 5, 1]'.heatCapacitor.Q_flow = RealVariables5[44];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 5, 1]'.heatCapacitor.port.T = RealVariables5[45];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 5, 1]'.heatCapacitor.port.Q_flow = RealVariables5[46];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 5, 1]'.heatCapacitor.der_T = RealVariables5[47];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 5, 1]'.heatCapacitor.C = RealVariables5[48];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 5, 1]'.port_int.T = RealVariables5[49];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 6, 1]'.port_a_1.T = RealVariables5[50];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 6, 1]'.port_a_1.Q_flow = RealVariables5[51];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 6, 1]'.port_b_1.T = RealVariables5[52];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 6, 1]'.port_b_1.Q_flow = RealVariables5[53];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 6, 1]'.port_a_2.T = RealVariables5[54];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 6, 1]'.port_a_2.Q_flow = RealVariables5[55];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 6, 1]'.port_b_2.T = RealVariables5[56];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 6, 1]'.port_b_2.Q_flow = RealVariables5[57];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 6, 1]'.thermalConductor_a_1.Q_flow = RealVariables5[58];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 6, 1]'.thermalConductor_a_1.dT = RealVariables5[59];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 6, 1]'.thermalConductor_a_1.port_a.T = RealVariables5[60];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 6, 1]'.thermalConductor_a_1.port_a.Q_flow = RealVariables5[61];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 6, 1]'.thermalConductor_a_1.port_b.T = RealVariables5[62];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 6, 1]'.thermalConductor_a_1.port_b.Q_flow = RealVariables5[63];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 6, 1]'.thermalConductor_a_1.T = RealVariables5[64];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 6, 1]'.thermalConductor_a_1.G = RealVariables5[65];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 6, 1]'.thermalConductor_a_1.k = RealVariables5[66];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 6, 1]'.thermalConductor_b_1.Q_flow = RealVariables5[67];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 6, 1]'.thermalConductor_b_1.dT = RealVariables5[68];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 6, 1]'.thermalConductor_b_1.port_a.T = RealVariables5[69];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 6, 1]'.thermalConductor_b_1.port_a.Q_flow = RealVariables5[70];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 6, 1]'.thermalConductor_b_1.port_b.T = RealVariables5[71];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 6, 1]'.thermalConductor_b_1.port_b.Q_flow = RealVariables5[72];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 6, 1]'.thermalConductor_b_1.T = RealVariables5[73];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 6, 1]'.thermalConductor_b_1.G = RealVariables5[74];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 6, 1]'.thermalConductor_b_1.k = RealVariables5[75];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 6, 1]'.thermalConductor_a_2.Q_flow = RealVariables5[76];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 6, 1]'.thermalConductor_a_2.dT = RealVariables5[77];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 6, 1]'.thermalConductor_a_2.port_a.T = RealVariables5[78];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 6, 1]'.thermalConductor_a_2.port_a.Q_flow = RealVariables5[79];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 6, 1]'.thermalConductor_a_2.port_b.T = RealVariables5[80];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 6, 1]'.thermalConductor_a_2.port_b.Q_flow = RealVariables5[81];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 6, 1]'.thermalConductor_a_2.T = RealVariables5[82];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 6, 1]'.thermalConductor_a_2.G = RealVariables5[83];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 6, 1]'.thermalConductor_a_2.k = RealVariables5[84];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 6, 1]'.thermalConductor_b_2.Q_flow = RealVariables5[85];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 6, 1]'.thermalConductor_b_2.dT = RealVariables5[86];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 6, 1]'.thermalConductor_b_2.port_a.T = RealVariables5[87];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 6, 1]'.thermalConductor_b_2.port_a.Q_flow = RealVariables5[88];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 6, 1]'.thermalConductor_b_2.port_b.T = RealVariables5[89];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 6, 1]'.thermalConductor_b_2.port_b.Q_flow = RealVariables5[90];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 6, 1]'.thermalConductor_b_2.T = RealVariables5[91];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 6, 1]'.thermalConductor_b_2.G = RealVariables5[92];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 6, 1]'.thermalConductor_b_2.k = RealVariables5[93];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 6, 1]'.thermalConductor_a_3.dT = RealVariables5[94];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 6, 1]'.thermalConductor_a_3.port_a.T = RealVariables5[95];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 6, 1]'.thermalConductor_a_3.port_b.T = RealVariables5[96];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 6, 1]'.thermalConductor_a_3.T = RealVariables5[97];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 6, 1]'.thermalConductor_a_3.G = RealVariables5[98];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 6, 1]'.thermalConductor_a_3.k = RealVariables5[99];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 6, 1]'.thermalConductor_b_3.dT = RealVariables5[100];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 6, 1]'.thermalConductor_b_3.port_a.T = RealVariables6[1];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 6, 1]'.thermalConductor_b_3.port_b.T = RealVariables6[2];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 6, 1]'.thermalConductor_b_3.T = RealVariables6[3];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 6, 1]'.thermalConductor_b_3.G = RealVariables6[4];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 6, 1]'.thermalConductor_b_3.k = RealVariables6[5];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 6, 1]'.heatCapacitor.T = RealVariables6[6];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 6, 1]'.heatCapacitor.T_der = RealVariables6[7];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 6, 1]'.heatCapacitor.Q_flow = RealVariables6[8];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 6, 1]'.heatCapacitor.port.T = RealVariables6[9];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 6, 1]'.heatCapacitor.port.Q_flow = RealVariables6[10];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 6, 1]'.heatCapacitor.der_T = RealVariables6[11];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 6, 1]'.heatCapacitor.C = RealVariables6[12];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 6, 1]'.port_int.T = RealVariables6[13];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 7, 1]'.port_a_1.T = RealVariables6[14];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 7, 1]'.port_a_1.Q_flow = RealVariables6[15];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 7, 1]'.port_b_1.T = RealVariables6[16];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 7, 1]'.port_b_1.Q_flow = RealVariables6[17];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 7, 1]'.port_a_2.T = RealVariables6[18];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 7, 1]'.port_a_2.Q_flow = RealVariables6[19];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 7, 1]'.port_b_2.T = RealVariables6[20];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 7, 1]'.port_b_2.Q_flow = RealVariables6[21];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 7, 1]'.thermalConductor_a_1.Q_flow = RealVariables6[22];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 7, 1]'.thermalConductor_a_1.dT = RealVariables6[23];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 7, 1]'.thermalConductor_a_1.port_a.T = RealVariables6[24];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 7, 1]'.thermalConductor_a_1.port_a.Q_flow = RealVariables6[25];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 7, 1]'.thermalConductor_a_1.port_b.T = RealVariables6[26];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 7, 1]'.thermalConductor_a_1.port_b.Q_flow = RealVariables6[27];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 7, 1]'.thermalConductor_a_1.T = RealVariables6[28];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 7, 1]'.thermalConductor_a_1.G = RealVariables6[29];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 7, 1]'.thermalConductor_a_1.k = RealVariables6[30];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 7, 1]'.thermalConductor_b_1.Q_flow = RealVariables6[31];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 7, 1]'.thermalConductor_b_1.dT = RealVariables6[32];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 7, 1]'.thermalConductor_b_1.port_a.T = RealVariables6[33];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 7, 1]'.thermalConductor_b_1.port_a.Q_flow = RealVariables6[34];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 7, 1]'.thermalConductor_b_1.port_b.T = RealVariables6[35];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 7, 1]'.thermalConductor_b_1.port_b.Q_flow = RealVariables6[36];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 7, 1]'.thermalConductor_b_1.T = RealVariables6[37];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 7, 1]'.thermalConductor_b_1.G = RealVariables6[38];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 7, 1]'.thermalConductor_b_1.k = RealVariables6[39];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 7, 1]'.thermalConductor_a_2.Q_flow = RealVariables6[40];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 7, 1]'.thermalConductor_a_2.dT = RealVariables6[41];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 7, 1]'.thermalConductor_a_2.port_a.T = RealVariables6[42];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 7, 1]'.thermalConductor_a_2.port_a.Q_flow = RealVariables6[43];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 7, 1]'.thermalConductor_a_2.port_b.T = RealVariables6[44];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 7, 1]'.thermalConductor_a_2.port_b.Q_flow = RealVariables6[45];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 7, 1]'.thermalConductor_a_2.T = RealVariables6[46];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 7, 1]'.thermalConductor_a_2.G = RealVariables6[47];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 7, 1]'.thermalConductor_a_2.k = RealVariables6[48];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 7, 1]'.thermalConductor_b_2.Q_flow = RealVariables6[49];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 7, 1]'.thermalConductor_b_2.dT = RealVariables6[50];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 7, 1]'.thermalConductor_b_2.port_a.T = RealVariables6[51];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 7, 1]'.thermalConductor_b_2.port_a.Q_flow = RealVariables6[52];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 7, 1]'.thermalConductor_b_2.port_b.T = RealVariables6[53];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 7, 1]'.thermalConductor_b_2.port_b.Q_flow = RealVariables6[54];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 7, 1]'.thermalConductor_b_2.T = RealVariables6[55];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 7, 1]'.thermalConductor_b_2.G = RealVariables6[56];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 7, 1]'.thermalConductor_b_2.k = RealVariables6[57];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 7, 1]'.thermalConductor_a_3.dT = RealVariables6[58];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 7, 1]'.thermalConductor_a_3.port_a.T = RealVariables6[59];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 7, 1]'.thermalConductor_a_3.port_b.T = RealVariables6[60];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 7, 1]'.thermalConductor_a_3.T = RealVariables6[61];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 7, 1]'.thermalConductor_a_3.G = RealVariables6[62];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 7, 1]'.thermalConductor_a_3.k = RealVariables6[63];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 7, 1]'.thermalConductor_b_3.dT = RealVariables6[64];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 7, 1]'.thermalConductor_b_3.port_a.T = RealVariables6[65];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 7, 1]'.thermalConductor_b_3.port_b.T = RealVariables6[66];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 7, 1]'.thermalConductor_b_3.T = RealVariables6[67];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 7, 1]'.thermalConductor_b_3.G = RealVariables6[68];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 7, 1]'.thermalConductor_b_3.k = RealVariables6[69];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 7, 1]'.heatCapacitor.T = RealVariables6[70];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 7, 1]'.heatCapacitor.T_der = RealVariables6[71];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 7, 1]'.heatCapacitor.Q_flow = RealVariables6[72];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 7, 1]'.heatCapacitor.port.T = RealVariables6[73];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 7, 1]'.heatCapacitor.port.Q_flow = RealVariables6[74];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 7, 1]'.heatCapacitor.der_T = RealVariables6[75];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 7, 1]'.heatCapacitor.C = RealVariables6[76];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 7, 1]'.port_int.T = RealVariables6[77];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 8, 1]'.port_a_1.T = RealVariables6[78];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 8, 1]'.port_a_1.Q_flow = RealVariables6[79];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 8, 1]'.port_b_1.T = RealVariables6[80];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 8, 1]'.port_b_1.Q_flow = RealVariables6[81];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 8, 1]'.port_a_2.T = RealVariables6[82];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 8, 1]'.port_a_2.Q_flow = RealVariables6[83];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 8, 1]'.port_b_2.T = RealVariables6[84];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 8, 1]'.port_b_2.Q_flow = RealVariables6[85];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 8, 1]'.thermalConductor_a_1.Q_flow = RealVariables6[86];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 8, 1]'.thermalConductor_a_1.dT = RealVariables6[87];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 8, 1]'.thermalConductor_a_1.port_a.T = RealVariables6[88];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 8, 1]'.thermalConductor_a_1.port_a.Q_flow = RealVariables6[89];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 8, 1]'.thermalConductor_a_1.port_b.T = RealVariables6[90];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 8, 1]'.thermalConductor_a_1.port_b.Q_flow = RealVariables6[91];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 8, 1]'.thermalConductor_a_1.T = RealVariables6[92];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 8, 1]'.thermalConductor_a_1.G = RealVariables6[93];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 8, 1]'.thermalConductor_a_1.k = RealVariables6[94];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 8, 1]'.thermalConductor_b_1.Q_flow = RealVariables6[95];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 8, 1]'.thermalConductor_b_1.dT = RealVariables6[96];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 8, 1]'.thermalConductor_b_1.port_a.T = RealVariables6[97];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 8, 1]'.thermalConductor_b_1.port_a.Q_flow = RealVariables6[98];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 8, 1]'.thermalConductor_b_1.port_b.T = RealVariables6[99];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 8, 1]'.thermalConductor_b_1.port_b.Q_flow = RealVariables6[100];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 8, 1]'.thermalConductor_b_1.T = RealVariables7[1];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 8, 1]'.thermalConductor_b_1.G = RealVariables7[2];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 8, 1]'.thermalConductor_b_1.k = RealVariables7[3];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 8, 1]'.thermalConductor_a_2.Q_flow = RealVariables7[4];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 8, 1]'.thermalConductor_a_2.dT = RealVariables7[5];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 8, 1]'.thermalConductor_a_2.port_a.T = RealVariables7[6];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 8, 1]'.thermalConductor_a_2.port_a.Q_flow = RealVariables7[7];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 8, 1]'.thermalConductor_a_2.port_b.T = RealVariables7[8];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 8, 1]'.thermalConductor_a_2.port_b.Q_flow = RealVariables7[9];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 8, 1]'.thermalConductor_a_2.T = RealVariables7[10];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 8, 1]'.thermalConductor_a_2.G = RealVariables7[11];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 8, 1]'.thermalConductor_a_2.k = RealVariables7[12];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 8, 1]'.thermalConductor_b_2.Q_flow = RealVariables7[13];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 8, 1]'.thermalConductor_b_2.dT = RealVariables7[14];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 8, 1]'.thermalConductor_b_2.port_a.T = RealVariables7[15];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 8, 1]'.thermalConductor_b_2.port_a.Q_flow = RealVariables7[16];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 8, 1]'.thermalConductor_b_2.port_b.T = RealVariables7[17];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 8, 1]'.thermalConductor_b_2.port_b.Q_flow = RealVariables7[18];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 8, 1]'.thermalConductor_b_2.T = RealVariables7[19];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 8, 1]'.thermalConductor_b_2.G = RealVariables7[20];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 8, 1]'.thermalConductor_b_2.k = RealVariables7[21];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 8, 1]'.thermalConductor_a_3.dT = RealVariables7[22];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 8, 1]'.thermalConductor_a_3.port_a.T = RealVariables7[23];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 8, 1]'.thermalConductor_a_3.port_b.T = RealVariables7[24];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 8, 1]'.thermalConductor_a_3.T = RealVariables7[25];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 8, 1]'.thermalConductor_a_3.G = RealVariables7[26];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 8, 1]'.thermalConductor_a_3.k = RealVariables7[27];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 8, 1]'.thermalConductor_b_3.dT = RealVariables7[28];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 8, 1]'.thermalConductor_b_3.port_a.T = RealVariables7[29];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 8, 1]'.thermalConductor_b_3.port_b.T = RealVariables7[30];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 8, 1]'.thermalConductor_b_3.T = RealVariables7[31];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 8, 1]'.thermalConductor_b_3.G = RealVariables7[32];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 8, 1]'.thermalConductor_b_3.k = RealVariables7[33];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 8, 1]'.heatCapacitor.T = RealVariables7[34];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 8, 1]'.heatCapacitor.T_der = RealVariables7[35];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 8, 1]'.heatCapacitor.Q_flow = RealVariables7[36];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 8, 1]'.heatCapacitor.port.T = RealVariables7[37];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 8, 1]'.heatCapacitor.port.Q_flow = RealVariables7[38];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 8, 1]'.heatCapacitor.der_T = RealVariables7[39];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 8, 1]'.heatCapacitor.C = RealVariables7[40];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 8, 1]'.port_int.T = RealVariables7[41];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 9, 1]'.port_a_1.T = RealVariables7[42];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 9, 1]'.port_a_1.Q_flow = RealVariables7[43];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 9, 1]'.port_b_1.T = RealVariables7[44];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 9, 1]'.port_b_1.Q_flow = RealVariables7[45];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 9, 1]'.port_a_2.T = RealVariables7[46];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 9, 1]'.port_a_2.Q_flow = RealVariables7[47];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 9, 1]'.port_b_2.T = RealVariables7[48];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 9, 1]'.port_b_2.Q_flow = RealVariables7[49];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 9, 1]'.thermalConductor_a_1.Q_flow = RealVariables7[50];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 9, 1]'.thermalConductor_a_1.dT = RealVariables7[51];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 9, 1]'.thermalConductor_a_1.port_a.T = RealVariables7[52];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 9, 1]'.thermalConductor_a_1.port_a.Q_flow = RealVariables7[53];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 9, 1]'.thermalConductor_a_1.port_b.T = RealVariables7[54];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 9, 1]'.thermalConductor_a_1.port_b.Q_flow = RealVariables7[55];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 9, 1]'.thermalConductor_a_1.T = RealVariables7[56];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 9, 1]'.thermalConductor_a_1.G = RealVariables7[57];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 9, 1]'.thermalConductor_a_1.k = RealVariables7[58];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 9, 1]'.thermalConductor_b_1.Q_flow = RealVariables7[59];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 9, 1]'.thermalConductor_b_1.dT = RealVariables7[60];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 9, 1]'.thermalConductor_b_1.port_a.T = RealVariables7[61];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 9, 1]'.thermalConductor_b_1.port_a.Q_flow = RealVariables7[62];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 9, 1]'.thermalConductor_b_1.port_b.T = RealVariables7[63];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 9, 1]'.thermalConductor_b_1.port_b.Q_flow = RealVariables7[64];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 9, 1]'.thermalConductor_b_1.T = RealVariables7[65];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 9, 1]'.thermalConductor_b_1.G = RealVariables7[66];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 9, 1]'.thermalConductor_b_1.k = RealVariables7[67];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 9, 1]'.thermalConductor_a_2.Q_flow = RealVariables7[68];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 9, 1]'.thermalConductor_a_2.dT = RealVariables7[69];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 9, 1]'.thermalConductor_a_2.port_a.T = RealVariables7[70];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 9, 1]'.thermalConductor_a_2.port_a.Q_flow = RealVariables7[71];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 9, 1]'.thermalConductor_a_2.port_b.T = RealVariables7[72];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 9, 1]'.thermalConductor_a_2.port_b.Q_flow = RealVariables7[73];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 9, 1]'.thermalConductor_a_2.T = RealVariables7[74];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 9, 1]'.thermalConductor_a_2.G = RealVariables7[75];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 9, 1]'.thermalConductor_a_2.k = RealVariables7[76];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 9, 1]'.thermalConductor_b_2.Q_flow = RealVariables7[77];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 9, 1]'.thermalConductor_b_2.dT = RealVariables7[78];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 9, 1]'.thermalConductor_b_2.port_a.T = RealVariables7[79];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 9, 1]'.thermalConductor_b_2.port_a.Q_flow = RealVariables7[80];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 9, 1]'.thermalConductor_b_2.port_b.T = RealVariables7[81];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 9, 1]'.thermalConductor_b_2.port_b.Q_flow = RealVariables7[82];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 9, 1]'.thermalConductor_b_2.T = RealVariables7[83];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 9, 1]'.thermalConductor_b_2.G = RealVariables7[84];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 9, 1]'.thermalConductor_b_2.k = RealVariables7[85];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 9, 1]'.thermalConductor_a_3.dT = RealVariables7[86];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 9, 1]'.thermalConductor_a_3.port_a.T = RealVariables7[87];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 9, 1]'.thermalConductor_a_3.port_b.T = RealVariables7[88];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 9, 1]'.thermalConductor_a_3.T = RealVariables7[89];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 9, 1]'.thermalConductor_a_3.G = RealVariables7[90];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 9, 1]'.thermalConductor_a_3.k = RealVariables7[91];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 9, 1]'.thermalConductor_b_3.dT = RealVariables7[92];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 9, 1]'.thermalConductor_b_3.port_a.T = RealVariables7[93];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 9, 1]'.thermalConductor_b_3.port_b.T = RealVariables7[94];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 9, 1]'.thermalConductor_b_3.T = RealVariables7[95];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 9, 1]'.thermalConductor_b_3.G = RealVariables7[96];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 9, 1]'.thermalConductor_b_3.k = RealVariables7[97];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 9, 1]'.heatCapacitor.T = RealVariables7[98];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 9, 1]'.heatCapacitor.T_der = RealVariables7[99];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 9, 1]'.heatCapacitor.Q_flow = RealVariables7[100];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 9, 1]'.heatCapacitor.port.T = RealVariables8[1];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 9, 1]'.heatCapacitor.port.Q_flow = RealVariables8[2];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 9, 1]'.heatCapacitor.der_T = RealVariables8[3];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 9, 1]'.heatCapacitor.C = RealVariables8[4];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 9, 1]'.port_int.T = RealVariables8[5];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 10, 1]'.port_a_1.T = RealVariables8[6];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 10, 1]'.port_a_1.Q_flow = RealVariables8[7];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 10, 1]'.port_b_1.T = RealVariables8[8];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 10, 1]'.port_b_1.Q_flow = RealVariables8[9];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 10, 1]'.port_a_2.T = RealVariables8[10];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 10, 1]'.port_a_2.Q_flow = RealVariables8[11];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 10, 1]'.port_b_2.T = RealVariables8[12];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 10, 1]'.thermalConductor_a_1.Q_flow = RealVariables8[13];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 10, 1]'.thermalConductor_a_1.dT = RealVariables8[14];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 10, 1]'.thermalConductor_a_1.port_a.T = RealVariables8[15];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 10, 1]'.thermalConductor_a_1.port_a.Q_flow = RealVariables8[16];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 10, 1]'.thermalConductor_a_1.port_b.T = RealVariables8[17];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 10, 1]'.thermalConductor_a_1.port_b.Q_flow = RealVariables8[18];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 10, 1]'.thermalConductor_a_1.T = RealVariables8[19];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 10, 1]'.thermalConductor_a_1.G = RealVariables8[20];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 10, 1]'.thermalConductor_a_1.k = RealVariables8[21];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 10, 1]'.thermalConductor_b_1.Q_flow = RealVariables8[22];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 10, 1]'.thermalConductor_b_1.dT = RealVariables8[23];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 10, 1]'.thermalConductor_b_1.port_a.T = RealVariables8[24];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 10, 1]'.thermalConductor_b_1.port_a.Q_flow = RealVariables8[25];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 10, 1]'.thermalConductor_b_1.port_b.T = RealVariables8[26];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 10, 1]'.thermalConductor_b_1.port_b.Q_flow = RealVariables8[27];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 10, 1]'.thermalConductor_b_1.T = RealVariables8[28];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 10, 1]'.thermalConductor_b_1.G = RealVariables8[29];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 10, 1]'.thermalConductor_b_1.k = RealVariables8[30];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 10, 1]'.thermalConductor_a_2.Q_flow = RealVariables8[31];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 10, 1]'.thermalConductor_a_2.dT = RealVariables8[32];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 10, 1]'.thermalConductor_a_2.port_a.T = RealVariables8[33];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 10, 1]'.thermalConductor_a_2.port_a.Q_flow = RealVariables8[34];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 10, 1]'.thermalConductor_a_2.port_b.T = RealVariables8[35];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 10, 1]'.thermalConductor_a_2.port_b.Q_flow = RealVariables8[36];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 10, 1]'.thermalConductor_a_2.T = RealVariables8[37];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 10, 1]'.thermalConductor_a_2.G = RealVariables8[38];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 10, 1]'.thermalConductor_a_2.k = RealVariables8[39];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 10, 1]'.thermalConductor_b_2.dT = RealVariables8[40];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 10, 1]'.thermalConductor_b_2.port_a.T = RealVariables8[41];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 10, 1]'.thermalConductor_b_2.port_b.T = RealVariables8[42];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 10, 1]'.thermalConductor_b_2.T = RealVariables8[43];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 10, 1]'.thermalConductor_b_2.G = RealVariables8[44];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 10, 1]'.thermalConductor_b_2.k = RealVariables8[45];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 10, 1]'.thermalConductor_a_3.dT = RealVariables8[46];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 10, 1]'.thermalConductor_a_3.port_a.T = RealVariables8[47];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 10, 1]'.thermalConductor_a_3.port_b.T = RealVariables8[48];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 10, 1]'.thermalConductor_a_3.T = RealVariables8[49];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 10, 1]'.thermalConductor_a_3.G = RealVariables8[50];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 10, 1]'.thermalConductor_a_3.k = RealVariables8[51];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 10, 1]'.thermalConductor_b_3.dT = RealVariables8[52];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 10, 1]'.thermalConductor_b_3.port_a.T = RealVariables8[53];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 10, 1]'.thermalConductor_b_3.port_b.T = RealVariables8[54];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 10, 1]'.thermalConductor_b_3.T = RealVariables8[55];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 10, 1]'.thermalConductor_b_3.G = RealVariables8[56];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 10, 1]'.thermalConductor_b_3.k = RealVariables8[57];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 10, 1]'.heatCapacitor.T = RealVariables8[58];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 10, 1]'.heatCapacitor.T_der = RealVariables8[59];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 10, 1]'.heatCapacitor.Q_flow = RealVariables8[60];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 10, 1]'.heatCapacitor.port.T = RealVariables8[61];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 10, 1]'.heatCapacitor.port.Q_flow = RealVariables8[62];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 10, 1]'.heatCapacitor.der_T = RealVariables8[63];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 10, 1]'.heatCapacitor.C = RealVariables8[64];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 10, 1]'.port_int.T = RealVariables8[65];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'port_int[1, 1, 1]'.T = RealVariables8[66];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'port_int[1, 2, 1]'.T = RealVariables8[67];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'port_int[1, 3, 1]'.T = RealVariables8[68];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'port_int[1, 4, 1]'.T = RealVariables8[69];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'port_int[1, 5, 1]'.T = RealVariables8[70];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'port_int[1, 6, 1]'.T = RealVariables8[71];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'port_int[1, 7, 1]'.T = RealVariables8[72];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'port_int[1, 8, 1]'.T = RealVariables8[73];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'port_int[1, 9, 1]'.T = RealVariables8[74];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'port_int[1, 10, 1]'.T = RealVariables8[75];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'port_a_1[1, 1]'.T = RealVariables8[76];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'port_a_1[1, 1]'.Q_flow = RealVariables8[77];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'port_a_1[1, 2]'.T = RealVariables8[78];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'port_a_1[1, 2]'.Q_flow = RealVariables8[79];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'port_a_1[1, 3]'.T = RealVariables8[80];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'port_a_1[1, 3]'.Q_flow = RealVariables8[81];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'port_a_1[1, 4]'.T = RealVariables8[82];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'port_a_1[1, 4]'.Q_flow = RealVariables8[83];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'port_a_1[1, 5]'.T = RealVariables8[84];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'port_a_1[1, 5]'.Q_flow = RealVariables8[85];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'port_a_1[1, 6]'.T = RealVariables8[86];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'port_a_1[1, 6]'.Q_flow = RealVariables8[87];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'port_a_1[1, 7]'.T = RealVariables8[88];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'port_a_1[1, 7]'.Q_flow = RealVariables8[89];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'port_a_1[1, 8]'.T = RealVariables8[90];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'port_a_1[1, 8]'.Q_flow = RealVariables8[91];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'port_a_1[1, 9]'.T = RealVariables8[92];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'port_a_1[1, 9]'.Q_flow = RealVariables8[93];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'port_a_1[1, 10]'.T = RealVariables8[94];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'port_a_1[1, 10]'.Q_flow = RealVariables8[95];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'port_b_1[1, 1]'.T = RealVariables8[96];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'port_b_1[1, 1]'.Q_flow = RealVariables8[97];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'port_b_1[1, 2]'.T = RealVariables8[98];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'port_b_1[1, 2]'.Q_flow = RealVariables8[99];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'port_b_1[1, 3]'.T = RealVariables8[100];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'port_b_1[1, 3]'.Q_flow = RealVariables9[1];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'port_b_1[1, 4]'.T = RealVariables9[2];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'port_b_1[1, 4]'.Q_flow = RealVariables9[3];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'port_b_1[1, 5]'.T = RealVariables9[4];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'port_b_1[1, 5]'.Q_flow = RealVariables9[5];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'port_b_1[1, 6]'.T = RealVariables9[6];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'port_b_1[1, 6]'.Q_flow = RealVariables9[7];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'port_b_1[1, 7]'.T = RealVariables9[8];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'port_b_1[1, 7]'.Q_flow = RealVariables9[9];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'port_b_1[1, 8]'.T = RealVariables9[10];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'port_b_1[1, 8]'.Q_flow = RealVariables9[11];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'port_b_1[1, 9]'.T = RealVariables9[12];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'port_b_1[1, 9]'.Q_flow = RealVariables9[13];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'port_b_1[1, 10]'.T = RealVariables9[14];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'port_b_1[1, 10]'.Q_flow = RealVariables9[15];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'port_a_2[1, 1]'.T = RealVariables9[16];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'port_b_2[1, 1]'.T = RealVariables9[17];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 1, 1]'.port_a_1.T = RealVariables9[18];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 1, 1]'.port_a_1.Q_flow = RealVariables9[19];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 1, 1]'.port_b_1.T = RealVariables9[20];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 1, 1]'.port_b_1.Q_flow = RealVariables9[21];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 1, 1]'.port_a_2.T = RealVariables9[22];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 1, 1]'.port_b_2.T = RealVariables9[23];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 1, 1]'.port_b_2.Q_flow = RealVariables9[24];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 1, 1]'.thermalConductor_a_1.Q_flow = RealVariables9[25];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 1, 1]'.thermalConductor_a_1.dT = RealVariables9[26];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 1, 1]'.thermalConductor_a_1.port_a.T = RealVariables9[27];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 1, 1]'.thermalConductor_a_1.port_a.Q_flow = RealVariables9[28];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 1, 1]'.thermalConductor_a_1.port_b.T = RealVariables9[29];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 1, 1]'.thermalConductor_a_1.port_b.Q_flow = RealVariables9[30];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 1, 1]'.thermalConductor_a_1.T = RealVariables9[31];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 1, 1]'.thermalConductor_a_1.G = RealVariables9[32];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 1, 1]'.thermalConductor_a_1.k = RealVariables9[33];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 1, 1]'.thermalConductor_b_1.Q_flow = RealVariables9[34];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 1, 1]'.thermalConductor_b_1.dT = RealVariables9[35];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 1, 1]'.thermalConductor_b_1.port_a.T = RealVariables9[36];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 1, 1]'.thermalConductor_b_1.port_a.Q_flow = RealVariables9[37];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 1, 1]'.thermalConductor_b_1.port_b.T = RealVariables9[38];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 1, 1]'.thermalConductor_b_1.port_b.Q_flow = RealVariables9[39];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 1, 1]'.thermalConductor_b_1.T = RealVariables9[40];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 1, 1]'.thermalConductor_b_1.G = RealVariables9[41];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 1, 1]'.thermalConductor_b_1.k = RealVariables9[42];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 1, 1]'.thermalConductor_a_2.dT = RealVariables9[43];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 1, 1]'.thermalConductor_a_2.port_a.T = RealVariables9[44];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 1, 1]'.thermalConductor_a_2.port_b.T = RealVariables9[45];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 1, 1]'.thermalConductor_a_2.T = RealVariables9[46];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 1, 1]'.thermalConductor_a_2.G = RealVariables9[47];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 1, 1]'.thermalConductor_a_2.k = RealVariables9[48];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 1, 1]'.thermalConductor_b_2.Q_flow = RealVariables9[49];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 1, 1]'.thermalConductor_b_2.dT = RealVariables9[50];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 1, 1]'.thermalConductor_b_2.port_a.T = RealVariables9[51];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 1, 1]'.thermalConductor_b_2.port_a.Q_flow = RealVariables9[52];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 1, 1]'.thermalConductor_b_2.port_b.T = RealVariables9[53];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 1, 1]'.thermalConductor_b_2.port_b.Q_flow = RealVariables9[54];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 1, 1]'.thermalConductor_b_2.T = RealVariables9[55];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 1, 1]'.thermalConductor_b_2.G = RealVariables9[56];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 1, 1]'.thermalConductor_b_2.k = RealVariables9[57];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 1, 1]'.thermalConductor_a_3.dT = RealVariables9[58];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 1, 1]'.thermalConductor_a_3.port_a.T = RealVariables9[59];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 1, 1]'.thermalConductor_a_3.port_b.T = RealVariables9[60];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 1, 1]'.thermalConductor_a_3.T = RealVariables9[61];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 1, 1]'.thermalConductor_a_3.G = RealVariables9[62];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 1, 1]'.thermalConductor_a_3.k = RealVariables9[63];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 1, 1]'.thermalConductor_b_3.dT = RealVariables9[64];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 1, 1]'.thermalConductor_b_3.port_a.T = RealVariables9[65];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 1, 1]'.thermalConductor_b_3.port_b.T = RealVariables9[66];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 1, 1]'.thermalConductor_b_3.T = RealVariables9[67];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 1, 1]'.thermalConductor_b_3.G = RealVariables9[68];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 1, 1]'.thermalConductor_b_3.k = RealVariables9[69];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 1, 1]'.heatCapacitor.T = RealVariables9[70];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 1, 1]'.heatCapacitor.T_der = RealVariables9[71];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 1, 1]'.heatCapacitor.Q_flow = RealVariables9[72];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 1, 1]'.heatCapacitor.port.T = RealVariables9[73];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 1, 1]'.heatCapacitor.port.Q_flow = RealVariables9[74];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 1, 1]'.heatCapacitor.der_T = RealVariables9[75];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 1, 1]'.heatCapacitor.C = RealVariables9[76];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 1, 1]'.port_int.T = RealVariables9[77];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 2, 1]'.port_a_1.T = RealVariables9[78];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 2, 1]'.port_a_1.Q_flow = RealVariables9[79];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 2, 1]'.port_b_1.T = RealVariables9[80];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 2, 1]'.port_b_1.Q_flow = RealVariables9[81];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 2, 1]'.port_a_2.T = RealVariables9[82];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 2, 1]'.port_a_2.Q_flow = RealVariables9[83];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 2, 1]'.port_b_2.T = RealVariables9[84];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 2, 1]'.port_b_2.Q_flow = RealVariables9[85];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 2, 1]'.thermalConductor_a_1.Q_flow = RealVariables9[86];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 2, 1]'.thermalConductor_a_1.dT = RealVariables9[87];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 2, 1]'.thermalConductor_a_1.port_a.T = RealVariables9[88];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 2, 1]'.thermalConductor_a_1.port_a.Q_flow = RealVariables9[89];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 2, 1]'.thermalConductor_a_1.port_b.T = RealVariables9[90];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 2, 1]'.thermalConductor_a_1.port_b.Q_flow = RealVariables9[91];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 2, 1]'.thermalConductor_a_1.T = RealVariables9[92];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 2, 1]'.thermalConductor_a_1.G = RealVariables9[93];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 2, 1]'.thermalConductor_a_1.k = RealVariables9[94];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 2, 1]'.thermalConductor_b_1.Q_flow = RealVariables9[95];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 2, 1]'.thermalConductor_b_1.dT = RealVariables9[96];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 2, 1]'.thermalConductor_b_1.port_a.T = RealVariables9[97];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 2, 1]'.thermalConductor_b_1.port_a.Q_flow = RealVariables9[98];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 2, 1]'.thermalConductor_b_1.port_b.T = RealVariables9[99];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 2, 1]'.thermalConductor_b_1.port_b.Q_flow = RealVariables9[100];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 2, 1]'.thermalConductor_b_1.T = RealVariables10[1];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 2, 1]'.thermalConductor_b_1.G = RealVariables10[2];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 2, 1]'.thermalConductor_b_1.k = RealVariables10[3];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 2, 1]'.thermalConductor_a_2.Q_flow = RealVariables10[4];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 2, 1]'.thermalConductor_a_2.dT = RealVariables10[5];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 2, 1]'.thermalConductor_a_2.port_a.T = RealVariables10[6];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 2, 1]'.thermalConductor_a_2.port_a.Q_flow = RealVariables10[7];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 2, 1]'.thermalConductor_a_2.port_b.T = RealVariables10[8];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 2, 1]'.thermalConductor_a_2.port_b.Q_flow = RealVariables10[9];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 2, 1]'.thermalConductor_a_2.T = RealVariables10[10];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 2, 1]'.thermalConductor_a_2.G = RealVariables10[11];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 2, 1]'.thermalConductor_a_2.k = RealVariables10[12];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 2, 1]'.thermalConductor_b_2.Q_flow = RealVariables10[13];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 2, 1]'.thermalConductor_b_2.dT = RealVariables10[14];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 2, 1]'.thermalConductor_b_2.port_a.T = RealVariables10[15];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 2, 1]'.thermalConductor_b_2.port_a.Q_flow = RealVariables10[16];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 2, 1]'.thermalConductor_b_2.port_b.T = RealVariables10[17];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 2, 1]'.thermalConductor_b_2.port_b.Q_flow = RealVariables10[18];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 2, 1]'.thermalConductor_b_2.T = RealVariables10[19];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 2, 1]'.thermalConductor_b_2.G = RealVariables10[20];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 2, 1]'.thermalConductor_b_2.k = RealVariables10[21];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 2, 1]'.thermalConductor_a_3.dT = RealVariables10[22];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 2, 1]'.thermalConductor_a_3.port_a.T = RealVariables10[23];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 2, 1]'.thermalConductor_a_3.port_b.T = RealVariables10[24];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 2, 1]'.thermalConductor_a_3.T = RealVariables10[25];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 2, 1]'.thermalConductor_a_3.G = RealVariables10[26];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 2, 1]'.thermalConductor_a_3.k = RealVariables10[27];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 2, 1]'.thermalConductor_b_3.dT = RealVariables10[28];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 2, 1]'.thermalConductor_b_3.port_a.T = RealVariables10[29];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 2, 1]'.thermalConductor_b_3.port_b.T = RealVariables10[30];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 2, 1]'.thermalConductor_b_3.T = RealVariables10[31];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 2, 1]'.thermalConductor_b_3.G = RealVariables10[32];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 2, 1]'.thermalConductor_b_3.k = RealVariables10[33];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 2, 1]'.heatCapacitor.T = RealVariables10[34];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 2, 1]'.heatCapacitor.T_der = RealVariables10[35];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 2, 1]'.heatCapacitor.Q_flow = RealVariables10[36];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 2, 1]'.heatCapacitor.port.T = RealVariables10[37];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 2, 1]'.heatCapacitor.port.Q_flow = RealVariables10[38];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 2, 1]'.heatCapacitor.der_T = RealVariables10[39];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 2, 1]'.heatCapacitor.C = RealVariables10[40];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 2, 1]'.port_int.T = RealVariables10[41];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 3, 1]'.port_a_1.T = RealVariables10[42];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 3, 1]'.port_a_1.Q_flow = RealVariables10[43];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 3, 1]'.port_b_1.T = RealVariables10[44];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 3, 1]'.port_b_1.Q_flow = RealVariables10[45];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 3, 1]'.port_a_2.T = RealVariables10[46];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 3, 1]'.port_a_2.Q_flow = RealVariables10[47];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 3, 1]'.port_b_2.T = RealVariables10[48];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 3, 1]'.port_b_2.Q_flow = RealVariables10[49];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 3, 1]'.thermalConductor_a_1.Q_flow = RealVariables10[50];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 3, 1]'.thermalConductor_a_1.dT = RealVariables10[51];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 3, 1]'.thermalConductor_a_1.port_a.T = RealVariables10[52];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 3, 1]'.thermalConductor_a_1.port_a.Q_flow = RealVariables10[53];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 3, 1]'.thermalConductor_a_1.port_b.T = RealVariables10[54];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 3, 1]'.thermalConductor_a_1.port_b.Q_flow = RealVariables10[55];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 3, 1]'.thermalConductor_a_1.T = RealVariables10[56];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 3, 1]'.thermalConductor_a_1.G = RealVariables10[57];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 3, 1]'.thermalConductor_a_1.k = RealVariables10[58];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 3, 1]'.thermalConductor_b_1.Q_flow = RealVariables10[59];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 3, 1]'.thermalConductor_b_1.dT = RealVariables10[60];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 3, 1]'.thermalConductor_b_1.port_a.T = RealVariables10[61];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 3, 1]'.thermalConductor_b_1.port_a.Q_flow = RealVariables10[62];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 3, 1]'.thermalConductor_b_1.port_b.T = RealVariables10[63];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 3, 1]'.thermalConductor_b_1.port_b.Q_flow = RealVariables10[64];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 3, 1]'.thermalConductor_b_1.T = RealVariables10[65];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 3, 1]'.thermalConductor_b_1.G = RealVariables10[66];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 3, 1]'.thermalConductor_b_1.k = RealVariables10[67];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 3, 1]'.thermalConductor_a_2.Q_flow = RealVariables10[68];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 3, 1]'.thermalConductor_a_2.dT = RealVariables10[69];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 3, 1]'.thermalConductor_a_2.port_a.T = RealVariables10[70];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 3, 1]'.thermalConductor_a_2.port_a.Q_flow = RealVariables10[71];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 3, 1]'.thermalConductor_a_2.port_b.T = RealVariables10[72];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 3, 1]'.thermalConductor_a_2.port_b.Q_flow = RealVariables10[73];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 3, 1]'.thermalConductor_a_2.T = RealVariables10[74];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 3, 1]'.thermalConductor_a_2.G = RealVariables10[75];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 3, 1]'.thermalConductor_a_2.k = RealVariables10[76];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 3, 1]'.thermalConductor_b_2.Q_flow = RealVariables10[77];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 3, 1]'.thermalConductor_b_2.dT = RealVariables10[78];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 3, 1]'.thermalConductor_b_2.port_a.T = RealVariables10[79];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 3, 1]'.thermalConductor_b_2.port_a.Q_flow = RealVariables10[80];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 3, 1]'.thermalConductor_b_2.port_b.T = RealVariables10[81];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 3, 1]'.thermalConductor_b_2.port_b.Q_flow = RealVariables10[82];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 3, 1]'.thermalConductor_b_2.T = RealVariables10[83];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 3, 1]'.thermalConductor_b_2.G = RealVariables10[84];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 3, 1]'.thermalConductor_b_2.k = RealVariables10[85];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 3, 1]'.thermalConductor_a_3.dT = RealVariables10[86];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 3, 1]'.thermalConductor_a_3.port_a.T = RealVariables10[87];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 3, 1]'.thermalConductor_a_3.port_b.T = RealVariables10[88];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 3, 1]'.thermalConductor_a_3.T = RealVariables10[89];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 3, 1]'.thermalConductor_a_3.G = RealVariables10[90];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 3, 1]'.thermalConductor_a_3.k = RealVariables10[91];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 3, 1]'.thermalConductor_b_3.dT = RealVariables10[92];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 3, 1]'.thermalConductor_b_3.port_a.T = RealVariables10[93];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 3, 1]'.thermalConductor_b_3.port_b.T = RealVariables10[94];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 3, 1]'.thermalConductor_b_3.T = RealVariables10[95];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 3, 1]'.thermalConductor_b_3.G = RealVariables10[96];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 3, 1]'.thermalConductor_b_3.k = RealVariables10[97];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 3, 1]'.heatCapacitor.T = RealVariables10[98];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 3, 1]'.heatCapacitor.T_der = RealVariables10[99];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 3, 1]'.heatCapacitor.Q_flow = RealVariables10[100];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 3, 1]'.heatCapacitor.port.T = RealVariables11[1];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 3, 1]'.heatCapacitor.port.Q_flow = RealVariables11[2];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 3, 1]'.heatCapacitor.der_T = RealVariables11[3];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 3, 1]'.heatCapacitor.C = RealVariables11[4];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 3, 1]'.port_int.T = RealVariables11[5];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 4, 1]'.port_a_1.T = RealVariables11[6];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 4, 1]'.port_a_1.Q_flow = RealVariables11[7];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 4, 1]'.port_b_1.T = RealVariables11[8];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 4, 1]'.port_b_1.Q_flow = RealVariables11[9];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 4, 1]'.port_a_2.T = RealVariables11[10];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 4, 1]'.port_a_2.Q_flow = RealVariables11[11];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 4, 1]'.port_b_2.T = RealVariables11[12];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 4, 1]'.port_b_2.Q_flow = RealVariables11[13];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 4, 1]'.thermalConductor_a_1.Q_flow = RealVariables11[14];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 4, 1]'.thermalConductor_a_1.dT = RealVariables11[15];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 4, 1]'.thermalConductor_a_1.port_a.T = RealVariables11[16];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 4, 1]'.thermalConductor_a_1.port_a.Q_flow = RealVariables11[17];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 4, 1]'.thermalConductor_a_1.port_b.T = RealVariables11[18];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 4, 1]'.thermalConductor_a_1.port_b.Q_flow = RealVariables11[19];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 4, 1]'.thermalConductor_a_1.T = RealVariables11[20];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 4, 1]'.thermalConductor_a_1.G = RealVariables11[21];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 4, 1]'.thermalConductor_a_1.k = RealVariables11[22];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 4, 1]'.thermalConductor_b_1.Q_flow = RealVariables11[23];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 4, 1]'.thermalConductor_b_1.dT = RealVariables11[24];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 4, 1]'.thermalConductor_b_1.port_a.T = RealVariables11[25];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 4, 1]'.thermalConductor_b_1.port_a.Q_flow = RealVariables11[26];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 4, 1]'.thermalConductor_b_1.port_b.T = RealVariables11[27];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 4, 1]'.thermalConductor_b_1.port_b.Q_flow = RealVariables11[28];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 4, 1]'.thermalConductor_b_1.T = RealVariables11[29];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 4, 1]'.thermalConductor_b_1.G = RealVariables11[30];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 4, 1]'.thermalConductor_b_1.k = RealVariables11[31];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 4, 1]'.thermalConductor_a_2.Q_flow = RealVariables11[32];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 4, 1]'.thermalConductor_a_2.dT = RealVariables11[33];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 4, 1]'.thermalConductor_a_2.port_a.T = RealVariables11[34];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 4, 1]'.thermalConductor_a_2.port_a.Q_flow = RealVariables11[35];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 4, 1]'.thermalConductor_a_2.port_b.T = RealVariables11[36];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 4, 1]'.thermalConductor_a_2.port_b.Q_flow = RealVariables11[37];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 4, 1]'.thermalConductor_a_2.T = RealVariables11[38];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 4, 1]'.thermalConductor_a_2.G = RealVariables11[39];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 4, 1]'.thermalConductor_a_2.k = RealVariables11[40];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 4, 1]'.thermalConductor_b_2.Q_flow = RealVariables11[41];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 4, 1]'.thermalConductor_b_2.dT = RealVariables11[42];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 4, 1]'.thermalConductor_b_2.port_a.T = RealVariables11[43];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 4, 1]'.thermalConductor_b_2.port_a.Q_flow = RealVariables11[44];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 4, 1]'.thermalConductor_b_2.port_b.T = RealVariables11[45];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 4, 1]'.thermalConductor_b_2.port_b.Q_flow = RealVariables11[46];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 4, 1]'.thermalConductor_b_2.T = RealVariables11[47];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 4, 1]'.thermalConductor_b_2.G = RealVariables11[48];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 4, 1]'.thermalConductor_b_2.k = RealVariables11[49];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 4, 1]'.thermalConductor_a_3.dT = RealVariables11[50];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 4, 1]'.thermalConductor_a_3.port_a.T = RealVariables11[51];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 4, 1]'.thermalConductor_a_3.port_b.T = RealVariables11[52];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 4, 1]'.thermalConductor_a_3.T = RealVariables11[53];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 4, 1]'.thermalConductor_a_3.G = RealVariables11[54];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 4, 1]'.thermalConductor_a_3.k = RealVariables11[55];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 4, 1]'.thermalConductor_b_3.dT = RealVariables11[56];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 4, 1]'.thermalConductor_b_3.port_a.T = RealVariables11[57];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 4, 1]'.thermalConductor_b_3.port_b.T = RealVariables11[58];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 4, 1]'.thermalConductor_b_3.T = RealVariables11[59];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 4, 1]'.thermalConductor_b_3.G = RealVariables11[60];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 4, 1]'.thermalConductor_b_3.k = RealVariables11[61];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 4, 1]'.heatCapacitor.T = RealVariables11[62];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 4, 1]'.heatCapacitor.T_der = RealVariables11[63];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 4, 1]'.heatCapacitor.Q_flow = RealVariables11[64];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 4, 1]'.heatCapacitor.port.T = RealVariables11[65];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 4, 1]'.heatCapacitor.port.Q_flow = RealVariables11[66];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 4, 1]'.heatCapacitor.der_T = RealVariables11[67];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 4, 1]'.heatCapacitor.C = RealVariables11[68];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 4, 1]'.port_int.T = RealVariables11[69];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 5, 1]'.port_a_1.T = RealVariables11[70];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 5, 1]'.port_a_1.Q_flow = RealVariables11[71];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 5, 1]'.port_b_1.T = RealVariables11[72];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 5, 1]'.port_b_1.Q_flow = RealVariables11[73];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 5, 1]'.port_a_2.T = RealVariables11[74];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 5, 1]'.port_a_2.Q_flow = RealVariables11[75];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 5, 1]'.port_b_2.T = RealVariables11[76];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 5, 1]'.port_b_2.Q_flow = RealVariables11[77];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 5, 1]'.thermalConductor_a_1.Q_flow = RealVariables11[78];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 5, 1]'.thermalConductor_a_1.dT = RealVariables11[79];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 5, 1]'.thermalConductor_a_1.port_a.T = RealVariables11[80];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 5, 1]'.thermalConductor_a_1.port_a.Q_flow = RealVariables11[81];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 5, 1]'.thermalConductor_a_1.port_b.T = RealVariables11[82];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 5, 1]'.thermalConductor_a_1.port_b.Q_flow = RealVariables11[83];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 5, 1]'.thermalConductor_a_1.T = RealVariables11[84];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 5, 1]'.thermalConductor_a_1.G = RealVariables11[85];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 5, 1]'.thermalConductor_a_1.k = RealVariables11[86];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 5, 1]'.thermalConductor_b_1.Q_flow = RealVariables11[87];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 5, 1]'.thermalConductor_b_1.dT = RealVariables11[88];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 5, 1]'.thermalConductor_b_1.port_a.T = RealVariables11[89];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 5, 1]'.thermalConductor_b_1.port_a.Q_flow = RealVariables11[90];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 5, 1]'.thermalConductor_b_1.port_b.T = RealVariables11[91];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 5, 1]'.thermalConductor_b_1.port_b.Q_flow = RealVariables11[92];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 5, 1]'.thermalConductor_b_1.T = RealVariables11[93];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 5, 1]'.thermalConductor_b_1.G = RealVariables11[94];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 5, 1]'.thermalConductor_b_1.k = RealVariables11[95];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 5, 1]'.thermalConductor_a_2.Q_flow = RealVariables11[96];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 5, 1]'.thermalConductor_a_2.dT = RealVariables11[97];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 5, 1]'.thermalConductor_a_2.port_a.T = RealVariables11[98];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 5, 1]'.thermalConductor_a_2.port_a.Q_flow = RealVariables11[99];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 5, 1]'.thermalConductor_a_2.port_b.T = RealVariables11[100];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 5, 1]'.thermalConductor_a_2.port_b.Q_flow = RealVariables12[1];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 5, 1]'.thermalConductor_a_2.T = RealVariables12[2];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 5, 1]'.thermalConductor_a_2.G = RealVariables12[3];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 5, 1]'.thermalConductor_a_2.k = RealVariables12[4];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 5, 1]'.thermalConductor_b_2.Q_flow = RealVariables12[5];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 5, 1]'.thermalConductor_b_2.dT = RealVariables12[6];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 5, 1]'.thermalConductor_b_2.port_a.T = RealVariables12[7];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 5, 1]'.thermalConductor_b_2.port_a.Q_flow = RealVariables12[8];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 5, 1]'.thermalConductor_b_2.port_b.T = RealVariables12[9];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 5, 1]'.thermalConductor_b_2.port_b.Q_flow = RealVariables12[10];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 5, 1]'.thermalConductor_b_2.T = RealVariables12[11];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 5, 1]'.thermalConductor_b_2.G = RealVariables12[12];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 5, 1]'.thermalConductor_b_2.k = RealVariables12[13];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 5, 1]'.thermalConductor_a_3.dT = RealVariables12[14];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 5, 1]'.thermalConductor_a_3.port_a.T = RealVariables12[15];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 5, 1]'.thermalConductor_a_3.port_b.T = RealVariables12[16];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 5, 1]'.thermalConductor_a_3.T = RealVariables12[17];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 5, 1]'.thermalConductor_a_3.G = RealVariables12[18];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 5, 1]'.thermalConductor_a_3.k = RealVariables12[19];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 5, 1]'.thermalConductor_b_3.dT = RealVariables12[20];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 5, 1]'.thermalConductor_b_3.port_a.T = RealVariables12[21];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 5, 1]'.thermalConductor_b_3.port_b.T = RealVariables12[22];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 5, 1]'.thermalConductor_b_3.T = RealVariables12[23];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 5, 1]'.thermalConductor_b_3.G = RealVariables12[24];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 5, 1]'.thermalConductor_b_3.k = RealVariables12[25];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 5, 1]'.heatCapacitor.T = RealVariables12[26];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 5, 1]'.heatCapacitor.T_der = RealVariables12[27];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 5, 1]'.heatCapacitor.Q_flow = RealVariables12[28];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 5, 1]'.heatCapacitor.port.T = RealVariables12[29];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 5, 1]'.heatCapacitor.port.Q_flow = RealVariables12[30];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 5, 1]'.heatCapacitor.der_T = RealVariables12[31];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 5, 1]'.heatCapacitor.C = RealVariables12[32];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 5, 1]'.port_int.T = RealVariables12[33];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 6, 1]'.port_a_1.T = RealVariables12[34];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 6, 1]'.port_a_1.Q_flow = RealVariables12[35];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 6, 1]'.port_b_1.T = RealVariables12[36];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 6, 1]'.port_b_1.Q_flow = RealVariables12[37];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 6, 1]'.port_a_2.T = RealVariables12[38];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 6, 1]'.port_a_2.Q_flow = RealVariables12[39];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 6, 1]'.port_b_2.T = RealVariables12[40];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 6, 1]'.port_b_2.Q_flow = RealVariables12[41];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 6, 1]'.thermalConductor_a_1.Q_flow = RealVariables12[42];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 6, 1]'.thermalConductor_a_1.dT = RealVariables12[43];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 6, 1]'.thermalConductor_a_1.port_a.T = RealVariables12[44];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 6, 1]'.thermalConductor_a_1.port_a.Q_flow = RealVariables12[45];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 6, 1]'.thermalConductor_a_1.port_b.T = RealVariables12[46];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 6, 1]'.thermalConductor_a_1.port_b.Q_flow = RealVariables12[47];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 6, 1]'.thermalConductor_a_1.T = RealVariables12[48];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 6, 1]'.thermalConductor_a_1.G = RealVariables12[49];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 6, 1]'.thermalConductor_a_1.k = RealVariables12[50];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 6, 1]'.thermalConductor_b_1.Q_flow = RealVariables12[51];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 6, 1]'.thermalConductor_b_1.dT = RealVariables12[52];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 6, 1]'.thermalConductor_b_1.port_a.T = RealVariables12[53];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 6, 1]'.thermalConductor_b_1.port_a.Q_flow = RealVariables12[54];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 6, 1]'.thermalConductor_b_1.port_b.T = RealVariables12[55];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 6, 1]'.thermalConductor_b_1.port_b.Q_flow = RealVariables12[56];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 6, 1]'.thermalConductor_b_1.T = RealVariables12[57];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 6, 1]'.thermalConductor_b_1.G = RealVariables12[58];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 6, 1]'.thermalConductor_b_1.k = RealVariables12[59];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 6, 1]'.thermalConductor_a_2.Q_flow = RealVariables12[60];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 6, 1]'.thermalConductor_a_2.dT = RealVariables12[61];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 6, 1]'.thermalConductor_a_2.port_a.T = RealVariables12[62];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 6, 1]'.thermalConductor_a_2.port_a.Q_flow = RealVariables12[63];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 6, 1]'.thermalConductor_a_2.port_b.T = RealVariables12[64];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 6, 1]'.thermalConductor_a_2.port_b.Q_flow = RealVariables12[65];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 6, 1]'.thermalConductor_a_2.T = RealVariables12[66];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 6, 1]'.thermalConductor_a_2.G = RealVariables12[67];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 6, 1]'.thermalConductor_a_2.k = RealVariables12[68];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 6, 1]'.thermalConductor_b_2.Q_flow = RealVariables12[69];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 6, 1]'.thermalConductor_b_2.dT = RealVariables12[70];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 6, 1]'.thermalConductor_b_2.port_a.T = RealVariables12[71];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 6, 1]'.thermalConductor_b_2.port_a.Q_flow = RealVariables12[72];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 6, 1]'.thermalConductor_b_2.port_b.T = RealVariables12[73];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 6, 1]'.thermalConductor_b_2.port_b.Q_flow = RealVariables12[74];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 6, 1]'.thermalConductor_b_2.T = RealVariables12[75];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 6, 1]'.thermalConductor_b_2.G = RealVariables12[76];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 6, 1]'.thermalConductor_b_2.k = RealVariables12[77];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 6, 1]'.thermalConductor_a_3.dT = RealVariables12[78];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 6, 1]'.thermalConductor_a_3.port_a.T = RealVariables12[79];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 6, 1]'.thermalConductor_a_3.port_b.T = RealVariables12[80];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 6, 1]'.thermalConductor_a_3.T = RealVariables12[81];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 6, 1]'.thermalConductor_a_3.G = RealVariables12[82];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 6, 1]'.thermalConductor_a_3.k = RealVariables12[83];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 6, 1]'.thermalConductor_b_3.dT = RealVariables12[84];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 6, 1]'.thermalConductor_b_3.port_a.T = RealVariables12[85];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 6, 1]'.thermalConductor_b_3.port_b.T = RealVariables12[86];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 6, 1]'.thermalConductor_b_3.T = RealVariables12[87];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 6, 1]'.thermalConductor_b_3.G = RealVariables12[88];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 6, 1]'.thermalConductor_b_3.k = RealVariables12[89];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 6, 1]'.heatCapacitor.T = RealVariables12[90];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 6, 1]'.heatCapacitor.T_der = RealVariables12[91];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 6, 1]'.heatCapacitor.Q_flow = RealVariables12[92];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 6, 1]'.heatCapacitor.port.T = RealVariables12[93];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 6, 1]'.heatCapacitor.port.Q_flow = RealVariables12[94];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 6, 1]'.heatCapacitor.der_T = RealVariables12[95];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 6, 1]'.heatCapacitor.C = RealVariables12[96];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 6, 1]'.port_int.T = RealVariables12[97];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 7, 1]'.port_a_1.T = RealVariables12[98];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 7, 1]'.port_a_1.Q_flow = RealVariables12[99];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 7, 1]'.port_b_1.T = RealVariables12[100];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 7, 1]'.port_b_1.Q_flow = RealVariables13[1];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 7, 1]'.port_a_2.T = RealVariables13[2];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 7, 1]'.port_a_2.Q_flow = RealVariables13[3];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 7, 1]'.port_b_2.T = RealVariables13[4];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 7, 1]'.port_b_2.Q_flow = RealVariables13[5];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 7, 1]'.thermalConductor_a_1.Q_flow = RealVariables13[6];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 7, 1]'.thermalConductor_a_1.dT = RealVariables13[7];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 7, 1]'.thermalConductor_a_1.port_a.T = RealVariables13[8];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 7, 1]'.thermalConductor_a_1.port_a.Q_flow = RealVariables13[9];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 7, 1]'.thermalConductor_a_1.port_b.T = RealVariables13[10];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 7, 1]'.thermalConductor_a_1.port_b.Q_flow = RealVariables13[11];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 7, 1]'.thermalConductor_a_1.T = RealVariables13[12];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 7, 1]'.thermalConductor_a_1.G = RealVariables13[13];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 7, 1]'.thermalConductor_a_1.k = RealVariables13[14];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 7, 1]'.thermalConductor_b_1.Q_flow = RealVariables13[15];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 7, 1]'.thermalConductor_b_1.dT = RealVariables13[16];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 7, 1]'.thermalConductor_b_1.port_a.T = RealVariables13[17];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 7, 1]'.thermalConductor_b_1.port_a.Q_flow = RealVariables13[18];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 7, 1]'.thermalConductor_b_1.port_b.T = RealVariables13[19];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 7, 1]'.thermalConductor_b_1.port_b.Q_flow = RealVariables13[20];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 7, 1]'.thermalConductor_b_1.T = RealVariables13[21];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 7, 1]'.thermalConductor_b_1.G = RealVariables13[22];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 7, 1]'.thermalConductor_b_1.k = RealVariables13[23];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 7, 1]'.thermalConductor_a_2.Q_flow = RealVariables13[24];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 7, 1]'.thermalConductor_a_2.dT = RealVariables13[25];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 7, 1]'.thermalConductor_a_2.port_a.T = RealVariables13[26];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 7, 1]'.thermalConductor_a_2.port_a.Q_flow = RealVariables13[27];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 7, 1]'.thermalConductor_a_2.port_b.T = RealVariables13[28];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 7, 1]'.thermalConductor_a_2.port_b.Q_flow = RealVariables13[29];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 7, 1]'.thermalConductor_a_2.T = RealVariables13[30];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 7, 1]'.thermalConductor_a_2.G = RealVariables13[31];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 7, 1]'.thermalConductor_a_2.k = RealVariables13[32];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 7, 1]'.thermalConductor_b_2.Q_flow = RealVariables13[33];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 7, 1]'.thermalConductor_b_2.dT = RealVariables13[34];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 7, 1]'.thermalConductor_b_2.port_a.T = RealVariables13[35];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 7, 1]'.thermalConductor_b_2.port_a.Q_flow = RealVariables13[36];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 7, 1]'.thermalConductor_b_2.port_b.T = RealVariables13[37];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 7, 1]'.thermalConductor_b_2.port_b.Q_flow = RealVariables13[38];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 7, 1]'.thermalConductor_b_2.T = RealVariables13[39];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 7, 1]'.thermalConductor_b_2.G = RealVariables13[40];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 7, 1]'.thermalConductor_b_2.k = RealVariables13[41];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 7, 1]'.thermalConductor_a_3.dT = RealVariables13[42];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 7, 1]'.thermalConductor_a_3.port_a.T = RealVariables13[43];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 7, 1]'.thermalConductor_a_3.port_b.T = RealVariables13[44];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 7, 1]'.thermalConductor_a_3.T = RealVariables13[45];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 7, 1]'.thermalConductor_a_3.G = RealVariables13[46];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 7, 1]'.thermalConductor_a_3.k = RealVariables13[47];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 7, 1]'.thermalConductor_b_3.dT = RealVariables13[48];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 7, 1]'.thermalConductor_b_3.port_a.T = RealVariables13[49];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 7, 1]'.thermalConductor_b_3.port_b.T = RealVariables13[50];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 7, 1]'.thermalConductor_b_3.T = RealVariables13[51];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 7, 1]'.thermalConductor_b_3.G = RealVariables13[52];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 7, 1]'.thermalConductor_b_3.k = RealVariables13[53];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 7, 1]'.heatCapacitor.T = RealVariables13[54];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 7, 1]'.heatCapacitor.T_der = RealVariables13[55];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 7, 1]'.heatCapacitor.Q_flow = RealVariables13[56];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 7, 1]'.heatCapacitor.port.T = RealVariables13[57];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 7, 1]'.heatCapacitor.port.Q_flow = RealVariables13[58];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 7, 1]'.heatCapacitor.der_T = RealVariables13[59];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 7, 1]'.heatCapacitor.C = RealVariables13[60];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 7, 1]'.port_int.T = RealVariables13[61];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 8, 1]'.port_a_1.T = RealVariables13[62];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 8, 1]'.port_a_1.Q_flow = RealVariables13[63];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 8, 1]'.port_b_1.T = RealVariables13[64];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 8, 1]'.port_b_1.Q_flow = RealVariables13[65];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 8, 1]'.port_a_2.T = RealVariables13[66];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 8, 1]'.port_a_2.Q_flow = RealVariables13[67];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 8, 1]'.port_b_2.T = RealVariables13[68];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 8, 1]'.port_b_2.Q_flow = RealVariables13[69];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 8, 1]'.thermalConductor_a_1.Q_flow = RealVariables13[70];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 8, 1]'.thermalConductor_a_1.dT = RealVariables13[71];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 8, 1]'.thermalConductor_a_1.port_a.T = RealVariables13[72];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 8, 1]'.thermalConductor_a_1.port_a.Q_flow = RealVariables13[73];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 8, 1]'.thermalConductor_a_1.port_b.T = RealVariables13[74];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 8, 1]'.thermalConductor_a_1.port_b.Q_flow = RealVariables13[75];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 8, 1]'.thermalConductor_a_1.T = RealVariables13[76];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 8, 1]'.thermalConductor_a_1.G = RealVariables13[77];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 8, 1]'.thermalConductor_a_1.k = RealVariables13[78];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 8, 1]'.thermalConductor_b_1.Q_flow = RealVariables13[79];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 8, 1]'.thermalConductor_b_1.dT = RealVariables13[80];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 8, 1]'.thermalConductor_b_1.port_a.T = RealVariables13[81];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 8, 1]'.thermalConductor_b_1.port_a.Q_flow = RealVariables13[82];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 8, 1]'.thermalConductor_b_1.port_b.T = RealVariables13[83];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 8, 1]'.thermalConductor_b_1.port_b.Q_flow = RealVariables13[84];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 8, 1]'.thermalConductor_b_1.T = RealVariables13[85];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 8, 1]'.thermalConductor_b_1.G = RealVariables13[86];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 8, 1]'.thermalConductor_b_1.k = RealVariables13[87];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 8, 1]'.thermalConductor_a_2.Q_flow = RealVariables13[88];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 8, 1]'.thermalConductor_a_2.dT = RealVariables13[89];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 8, 1]'.thermalConductor_a_2.port_a.T = RealVariables13[90];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 8, 1]'.thermalConductor_a_2.port_a.Q_flow = RealVariables13[91];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 8, 1]'.thermalConductor_a_2.port_b.T = RealVariables13[92];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 8, 1]'.thermalConductor_a_2.port_b.Q_flow = RealVariables13[93];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 8, 1]'.thermalConductor_a_2.T = RealVariables13[94];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 8, 1]'.thermalConductor_a_2.G = RealVariables13[95];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 8, 1]'.thermalConductor_a_2.k = RealVariables13[96];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 8, 1]'.thermalConductor_b_2.Q_flow = RealVariables13[97];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 8, 1]'.thermalConductor_b_2.dT = RealVariables13[98];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 8, 1]'.thermalConductor_b_2.port_a.T = RealVariables13[99];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 8, 1]'.thermalConductor_b_2.port_a.Q_flow = RealVariables13[100];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 8, 1]'.thermalConductor_b_2.port_b.T = RealVariables14[1];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 8, 1]'.thermalConductor_b_2.port_b.Q_flow = RealVariables14[2];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 8, 1]'.thermalConductor_b_2.T = RealVariables14[3];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 8, 1]'.thermalConductor_b_2.G = RealVariables14[4];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 8, 1]'.thermalConductor_b_2.k = RealVariables14[5];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 8, 1]'.thermalConductor_a_3.dT = RealVariables14[6];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 8, 1]'.thermalConductor_a_3.port_a.T = RealVariables14[7];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 8, 1]'.thermalConductor_a_3.port_b.T = RealVariables14[8];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 8, 1]'.thermalConductor_a_3.T = RealVariables14[9];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 8, 1]'.thermalConductor_a_3.G = RealVariables14[10];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 8, 1]'.thermalConductor_a_3.k = RealVariables14[11];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 8, 1]'.thermalConductor_b_3.dT = RealVariables14[12];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 8, 1]'.thermalConductor_b_3.port_a.T = RealVariables14[13];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 8, 1]'.thermalConductor_b_3.port_b.T = RealVariables14[14];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 8, 1]'.thermalConductor_b_3.T = RealVariables14[15];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 8, 1]'.thermalConductor_b_3.G = RealVariables14[16];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 8, 1]'.thermalConductor_b_3.k = RealVariables14[17];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 8, 1]'.heatCapacitor.T = RealVariables14[18];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 8, 1]'.heatCapacitor.T_der = RealVariables14[19];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 8, 1]'.heatCapacitor.Q_flow = RealVariables14[20];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 8, 1]'.heatCapacitor.port.T = RealVariables14[21];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 8, 1]'.heatCapacitor.port.Q_flow = RealVariables14[22];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 8, 1]'.heatCapacitor.der_T = RealVariables14[23];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 8, 1]'.heatCapacitor.C = RealVariables14[24];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 8, 1]'.port_int.T = RealVariables14[25];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 9, 1]'.port_a_1.T = RealVariables14[26];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 9, 1]'.port_a_1.Q_flow = RealVariables14[27];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 9, 1]'.port_b_1.T = RealVariables14[28];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 9, 1]'.port_b_1.Q_flow = RealVariables14[29];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 9, 1]'.port_a_2.T = RealVariables14[30];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 9, 1]'.port_a_2.Q_flow = RealVariables14[31];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 9, 1]'.port_b_2.T = RealVariables14[32];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 9, 1]'.port_b_2.Q_flow = RealVariables14[33];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 9, 1]'.thermalConductor_a_1.Q_flow = RealVariables14[34];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 9, 1]'.thermalConductor_a_1.dT = RealVariables14[35];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 9, 1]'.thermalConductor_a_1.port_a.T = RealVariables14[36];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 9, 1]'.thermalConductor_a_1.port_a.Q_flow = RealVariables14[37];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 9, 1]'.thermalConductor_a_1.port_b.T = RealVariables14[38];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 9, 1]'.thermalConductor_a_1.port_b.Q_flow = RealVariables14[39];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 9, 1]'.thermalConductor_a_1.T = RealVariables14[40];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 9, 1]'.thermalConductor_a_1.G = RealVariables14[41];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 9, 1]'.thermalConductor_a_1.k = RealVariables14[42];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 9, 1]'.thermalConductor_b_1.Q_flow = RealVariables14[43];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 9, 1]'.thermalConductor_b_1.dT = RealVariables14[44];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 9, 1]'.thermalConductor_b_1.port_a.T = RealVariables14[45];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 9, 1]'.thermalConductor_b_1.port_a.Q_flow = RealVariables14[46];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 9, 1]'.thermalConductor_b_1.port_b.T = RealVariables14[47];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 9, 1]'.thermalConductor_b_1.port_b.Q_flow = RealVariables14[48];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 9, 1]'.thermalConductor_b_1.T = RealVariables14[49];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 9, 1]'.thermalConductor_b_1.G = RealVariables14[50];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 9, 1]'.thermalConductor_b_1.k = RealVariables14[51];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 9, 1]'.thermalConductor_a_2.Q_flow = RealVariables14[52];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 9, 1]'.thermalConductor_a_2.dT = RealVariables14[53];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 9, 1]'.thermalConductor_a_2.port_a.T = RealVariables14[54];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 9, 1]'.thermalConductor_a_2.port_a.Q_flow = RealVariables14[55];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 9, 1]'.thermalConductor_a_2.port_b.T = RealVariables14[56];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 9, 1]'.thermalConductor_a_2.port_b.Q_flow = RealVariables14[57];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 9, 1]'.thermalConductor_a_2.T = RealVariables14[58];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 9, 1]'.thermalConductor_a_2.G = RealVariables14[59];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 9, 1]'.thermalConductor_a_2.k = RealVariables14[60];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 9, 1]'.thermalConductor_b_2.Q_flow = RealVariables14[61];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 9, 1]'.thermalConductor_b_2.dT = RealVariables14[62];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 9, 1]'.thermalConductor_b_2.port_a.T = RealVariables14[63];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 9, 1]'.thermalConductor_b_2.port_a.Q_flow = RealVariables14[64];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 9, 1]'.thermalConductor_b_2.port_b.T = RealVariables14[65];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 9, 1]'.thermalConductor_b_2.port_b.Q_flow = RealVariables14[66];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 9, 1]'.thermalConductor_b_2.T = RealVariables14[67];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 9, 1]'.thermalConductor_b_2.G = RealVariables14[68];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 9, 1]'.thermalConductor_b_2.k = RealVariables14[69];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 9, 1]'.thermalConductor_a_3.dT = RealVariables14[70];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 9, 1]'.thermalConductor_a_3.port_a.T = RealVariables14[71];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 9, 1]'.thermalConductor_a_3.port_b.T = RealVariables14[72];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 9, 1]'.thermalConductor_a_3.T = RealVariables14[73];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 9, 1]'.thermalConductor_a_3.G = RealVariables14[74];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 9, 1]'.thermalConductor_a_3.k = RealVariables14[75];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 9, 1]'.thermalConductor_b_3.dT = RealVariables14[76];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 9, 1]'.thermalConductor_b_3.port_a.T = RealVariables14[77];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 9, 1]'.thermalConductor_b_3.port_b.T = RealVariables14[78];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 9, 1]'.thermalConductor_b_3.T = RealVariables14[79];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 9, 1]'.thermalConductor_b_3.G = RealVariables14[80];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 9, 1]'.thermalConductor_b_3.k = RealVariables14[81];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 9, 1]'.heatCapacitor.T = RealVariables14[82];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 9, 1]'.heatCapacitor.T_der = RealVariables14[83];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 9, 1]'.heatCapacitor.Q_flow = RealVariables14[84];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 9, 1]'.heatCapacitor.port.T = RealVariables14[85];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 9, 1]'.heatCapacitor.port.Q_flow = RealVariables14[86];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 9, 1]'.heatCapacitor.der_T = RealVariables14[87];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 9, 1]'.heatCapacitor.C = RealVariables14[88];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 9, 1]'.port_int.T = RealVariables14[89];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 10, 1]'.port_a_1.T = RealVariables14[90];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 10, 1]'.port_a_1.Q_flow = RealVariables14[91];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 10, 1]'.port_b_1.T = RealVariables14[92];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 10, 1]'.port_b_1.Q_flow = RealVariables14[93];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 10, 1]'.port_a_2.T = RealVariables14[94];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 10, 1]'.port_a_2.Q_flow = RealVariables14[95];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 10, 1]'.port_b_2.T = RealVariables14[96];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 10, 1]'.thermalConductor_a_1.Q_flow = RealVariables14[97];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 10, 1]'.thermalConductor_a_1.dT = RealVariables14[98];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 10, 1]'.thermalConductor_a_1.port_a.T = RealVariables14[99];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 10, 1]'.thermalConductor_a_1.port_a.Q_flow = RealVariables14[100];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 10, 1]'.thermalConductor_a_1.port_b.T = RealVariables15[1];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 10, 1]'.thermalConductor_a_1.port_b.Q_flow = RealVariables15[2];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 10, 1]'.thermalConductor_a_1.T = RealVariables15[3];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 10, 1]'.thermalConductor_a_1.G = RealVariables15[4];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 10, 1]'.thermalConductor_a_1.k = RealVariables15[5];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 10, 1]'.thermalConductor_b_1.Q_flow = RealVariables15[6];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 10, 1]'.thermalConductor_b_1.dT = RealVariables15[7];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 10, 1]'.thermalConductor_b_1.port_a.T = RealVariables15[8];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 10, 1]'.thermalConductor_b_1.port_a.Q_flow = RealVariables15[9];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 10, 1]'.thermalConductor_b_1.port_b.T = RealVariables15[10];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 10, 1]'.thermalConductor_b_1.port_b.Q_flow = RealVariables15[11];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 10, 1]'.thermalConductor_b_1.T = RealVariables15[12];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 10, 1]'.thermalConductor_b_1.G = RealVariables15[13];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 10, 1]'.thermalConductor_b_1.k = RealVariables15[14];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 10, 1]'.thermalConductor_a_2.Q_flow = RealVariables15[15];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 10, 1]'.thermalConductor_a_2.dT = RealVariables15[16];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 10, 1]'.thermalConductor_a_2.port_a.T = RealVariables15[17];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 10, 1]'.thermalConductor_a_2.port_a.Q_flow = RealVariables15[18];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 10, 1]'.thermalConductor_a_2.port_b.T = RealVariables15[19];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 10, 1]'.thermalConductor_a_2.port_b.Q_flow = RealVariables15[20];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 10, 1]'.thermalConductor_a_2.T = RealVariables15[21];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 10, 1]'.thermalConductor_a_2.G = RealVariables15[22];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 10, 1]'.thermalConductor_a_2.k = RealVariables15[23];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 10, 1]'.thermalConductor_b_2.dT = RealVariables15[24];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 10, 1]'.thermalConductor_b_2.port_a.T = RealVariables15[25];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 10, 1]'.thermalConductor_b_2.port_b.T = RealVariables15[26];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 10, 1]'.thermalConductor_b_2.T = RealVariables15[27];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 10, 1]'.thermalConductor_b_2.G = RealVariables15[28];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 10, 1]'.thermalConductor_b_2.k = RealVariables15[29];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 10, 1]'.thermalConductor_a_3.dT = RealVariables15[30];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 10, 1]'.thermalConductor_a_3.port_a.T = RealVariables15[31];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 10, 1]'.thermalConductor_a_3.port_b.T = RealVariables15[32];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 10, 1]'.thermalConductor_a_3.T = RealVariables15[33];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 10, 1]'.thermalConductor_a_3.G = RealVariables15[34];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 10, 1]'.thermalConductor_a_3.k = RealVariables15[35];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 10, 1]'.thermalConductor_b_3.dT = RealVariables15[36];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 10, 1]'.thermalConductor_b_3.port_a.T = RealVariables15[37];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 10, 1]'.thermalConductor_b_3.port_b.T = RealVariables15[38];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 10, 1]'.thermalConductor_b_3.T = RealVariables15[39];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 10, 1]'.thermalConductor_b_3.G = RealVariables15[40];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 10, 1]'.thermalConductor_b_3.k = RealVariables15[41];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 10, 1]'.heatCapacitor.T = RealVariables15[42];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 10, 1]'.heatCapacitor.T_der = RealVariables15[43];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 10, 1]'.heatCapacitor.Q_flow = RealVariables15[44];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 10, 1]'.heatCapacitor.port.T = RealVariables15[45];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 10, 1]'.heatCapacitor.port.Q_flow = RealVariables15[46];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 10, 1]'.heatCapacitor.der_T = RealVariables15[47];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 10, 1]'.heatCapacitor.C = RealVariables15[48];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 10, 1]'.port_int.T = RealVariables15[49];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'port_int[1, 1, 1]'.T = RealVariables15[50];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'port_int[1, 2, 1]'.T = RealVariables15[51];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'port_int[1, 3, 1]'.T = RealVariables15[52];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'port_int[1, 4, 1]'.T = RealVariables15[53];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'port_int[1, 5, 1]'.T = RealVariables15[54];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'port_int[1, 6, 1]'.T = RealVariables15[55];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'port_int[1, 7, 1]'.T = RealVariables15[56];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'port_int[1, 8, 1]'.T = RealVariables15[57];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'port_int[1, 9, 1]'.T = RealVariables15[58];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'port_int[1, 10, 1]'.T = RealVariables15[59];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.port_a.m_flow = RealVariables15[60];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.port_a.p = RealVariables15[61];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.port_a.h_outflow = RealVariables15[62];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.port_b.p = RealVariables15[63];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.port_b.h_outflow = RealVariables15[64];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.'Us[1]' = RealVariables15[65];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.'Us[1]_der' = RealVariables15[66];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.'Us[2]' = RealVariables15[67];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.'Us[2]_der' = RealVariables15[68];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.'Us[3]' = RealVariables15[69];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.'Us[3]_der' = RealVariables15[70];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.'Us[4]' = RealVariables15[71];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.'Us[4]_der' = RealVariables15[72];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.'Us[5]' = RealVariables15[73];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.'Us[5]_der' = RealVariables15[74];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.'Us[6]' = RealVariables15[75];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.'Us[6]_der' = RealVariables15[76];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.'Us[7]' = RealVariables15[77];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.'Us[7]_der' = RealVariables15[78];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.'Us[8]' = RealVariables15[79];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.'Us[8]_der' = RealVariables15[80];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.'Us[9]' = RealVariables15[81];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.'Us[9]_der' = RealVariables15[82];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.'Us[10]' = RealVariables15[83];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.'Us[10]_der' = RealVariables15[84];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.'Hb_flows[1]' = RealVariables15[85];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.'Hb_flows[2]' = RealVariables15[86];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.'Hb_flows[3]' = RealVariables15[87];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.'Hb_flows[4]' = RealVariables15[88];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.'Hb_flows[5]' = RealVariables15[89];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.'Hb_flows[6]' = RealVariables15[90];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.'Hb_flows[7]' = RealVariables15[91];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.'Hb_flows[8]' = RealVariables15[92];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.'Hb_flows[9]' = RealVariables15[93];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.'Hb_flows[10]' = RealVariables15[94];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.'Qb_flows[1]' = RealVariables15[95];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.'Qb_flows[2]' = RealVariables15[96];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.'Qb_flows[3]' = RealVariables15[97];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.'Qb_flows[4]' = RealVariables15[98];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.'Qb_flows[5]' = RealVariables15[99];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.'Qb_flows[6]' = RealVariables15[100];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.'Qb_flows[7]' = RealVariables16[1];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.'Qb_flows[8]' = RealVariables16[2];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.'Qb_flows[9]' = RealVariables16[3];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.'Qb_flows[10]' = RealVariables16[4];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.'Wb_flows[1]' = RealVariables16[5];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.'Wb_flows[2]' = RealVariables16[6];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.'Wb_flows[3]' = RealVariables16[7];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.'Wb_flows[4]' = RealVariables16[8];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.'Wb_flows[5]' = RealVariables16[9];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.'Wb_flows[6]' = RealVariables16[10];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.'Wb_flows[7]' = RealVariables16[11];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.'Wb_flows[8]' = RealVariables16[12];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.'Wb_flows[9]' = RealVariables16[13];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.'Wb_flows[10]' = RealVariables16[14];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.state_a.p = RealVariables16[15];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.state_a.T = RealVariables16[16];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.state_b.p = RealVariables16[17];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.state_b.T = RealVariables16[18];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.'statesFM[1]'.p = RealVariables16[19];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.'statesFM[1]'.T = RealVariables16[20];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.'statesFM[2]'.p = RealVariables16[21];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.'statesFM[2]'.T = RealVariables16[22];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.'statesFM[3]'.p = RealVariables16[23];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.'statesFM[3]'.T = RealVariables16[24];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.'statesFM[4]'.p = RealVariables16[25];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.'statesFM[4]'.T = RealVariables16[26];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.'statesFM[5]'.p = RealVariables16[27];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.'statesFM[5]'.T = RealVariables16[28];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.'statesFM[6]'.p = RealVariables16[29];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.'statesFM[6]'.T = RealVariables16[30];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.'statesFM[7]'.p = RealVariables16[31];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.'statesFM[7]'.T = RealVariables16[32];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.'statesFM[8]'.p = RealVariables16[33];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.'statesFM[8]'.T = RealVariables16[34];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.'statesFM[9]'.p = RealVariables16[35];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.'statesFM[9]'.T = RealVariables16[36];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.'statesFM[10]'.p = RealVariables16[37];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.'statesFM[10]'.T = RealVariables16[38];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.flowModel.'states[1]'.p = RealVariables16[39];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.flowModel.'states[1]'.T = RealVariables16[40];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.flowModel.'states[2]'.p = RealVariables16[41];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.flowModel.'states[2]'.T = RealVariables16[42];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.flowModel.'states[3]'.p = RealVariables16[43];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.flowModel.'states[3]'.T = RealVariables16[44];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.flowModel.'states[4]'.p = RealVariables16[45];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.flowModel.'states[4]'.T = RealVariables16[46];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.flowModel.'states[5]'.p = RealVariables16[47];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.flowModel.'states[5]'.T = RealVariables16[48];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.flowModel.'states[6]'.p = RealVariables16[49];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.flowModel.'states[6]'.T = RealVariables16[50];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.flowModel.'states[7]'.p = RealVariables16[51];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.flowModel.'states[7]'.T = RealVariables16[52];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.flowModel.'states[8]'.p = RealVariables16[53];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.flowModel.'states[8]'.T = RealVariables16[54];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.flowModel.'states[9]'.p = RealVariables16[55];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.flowModel.'states[9]'.T = RealVariables16[56];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.flowModel.'states[10]'.p = RealVariables16[57];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.flowModel.'states[10]'.T = RealVariables16[58];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.flowModel.'vs[1]' = RealVariables16[59];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.flowModel.'vs[2]' = RealVariables16[60];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.flowModel.'vs[3]' = RealVariables16[61];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.flowModel.'vs[4]' = RealVariables16[62];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.flowModel.'vs[5]' = RealVariables16[63];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.flowModel.'vs[6]' = RealVariables16[64];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.flowModel.'vs[7]' = RealVariables16[65];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.flowModel.'vs[8]' = RealVariables16[66];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.flowModel.'vs[9]' = RealVariables16[67];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.flowModel.'vs[10]' = RealVariables16[68];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.flowModel.'crossAreas[1]' = RealVariables16[69];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.flowModel.'crossAreas[2]' = RealVariables16[70];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.flowModel.'crossAreas[3]' = RealVariables16[71];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.flowModel.'crossAreas[4]' = RealVariables16[72];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.flowModel.'crossAreas[5]' = RealVariables16[73];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.flowModel.'crossAreas[6]' = RealVariables16[74];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.flowModel.'crossAreas[7]' = RealVariables16[75];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.flowModel.'crossAreas[8]' = RealVariables16[76];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.flowModel.'crossAreas[9]' = RealVariables16[77];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.flowModel.'crossAreas[10]' = RealVariables16[78];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.flowModel.'dimensions[1]' = RealVariables16[79];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.flowModel.'dimensions[2]' = RealVariables16[80];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.flowModel.'dimensions[3]' = RealVariables16[81];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.flowModel.'dimensions[4]' = RealVariables16[82];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.flowModel.'dimensions[5]' = RealVariables16[83];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.flowModel.'dimensions[6]' = RealVariables16[84];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.flowModel.'dimensions[7]' = RealVariables16[85];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.flowModel.'dimensions[8]' = RealVariables16[86];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.flowModel.'dimensions[9]' = RealVariables16[87];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.flowModel.'dimensions[10]' = RealVariables16[88];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.flowModel.'roughnesses[1]' = RealVariables16[89];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.flowModel.'roughnesses[2]' = RealVariables16[90];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.flowModel.'roughnesses[3]' = RealVariables16[91];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.flowModel.'roughnesses[4]' = RealVariables16[92];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.flowModel.'roughnesses[5]' = RealVariables16[93];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.flowModel.'roughnesses[6]' = RealVariables16[94];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.flowModel.'roughnesses[7]' = RealVariables16[95];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.flowModel.'roughnesses[8]' = RealVariables16[96];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.flowModel.'roughnesses[9]' = RealVariables16[97];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.flowModel.'roughnesses[10]' = RealVariables16[98];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.flowModel.'m_flows[1]' = RealVariables16[99];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.flowModel.'m_flows[2]' = RealVariables16[100];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.flowModel.'m_flows[3]' = RealVariables17[1];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.flowModel.'m_flows[4]' = RealVariables17[2];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.flowModel.'m_flows[5]' = RealVariables17[3];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.flowModel.'m_flows[6]' = RealVariables17[4];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.flowModel.'m_flows[7]' = RealVariables17[5];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.flowModel.'m_flows[8]' = RealVariables17[6];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.flowModel.'m_flows[9]' = RealVariables17[7];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.flowModel.'Is[1]' = RealVariables17[8];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.flowModel.'Is[2]' = RealVariables17[9];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.flowModel.'Is[3]' = RealVariables17[10];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.flowModel.'Is[4]' = RealVariables17[11];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.flowModel.'Is[5]' = RealVariables17[12];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.flowModel.'Is[6]' = RealVariables17[13];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.flowModel.'Is[7]' = RealVariables17[14];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.flowModel.'Is[8]' = RealVariables17[15];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.flowModel.'Is[9]' = RealVariables17[16];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.flowModel.'Fs_p[1]' = RealVariables17[17];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.flowModel.'Fs_p[2]' = RealVariables17[18];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.flowModel.'Fs_p[3]' = RealVariables17[19];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.flowModel.'Fs_p[4]' = RealVariables17[20];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.flowModel.'Fs_p[5]' = RealVariables17[21];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.flowModel.'Fs_p[6]' = RealVariables17[22];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.flowModel.'Fs_p[7]' = RealVariables17[23];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.flowModel.'Fs_p[8]' = RealVariables17[24];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.flowModel.'Fs_p[9]' = RealVariables17[25];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.flowModel.'Fs_fg[1]' = RealVariables17[26];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.flowModel.'Fs_fg[2]' = RealVariables17[27];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.flowModel.'Fs_fg[3]' = RealVariables17[28];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.flowModel.'Fs_fg[4]' = RealVariables17[29];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.flowModel.'Fs_fg[5]' = RealVariables17[30];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.flowModel.'Fs_fg[6]' = RealVariables17[31];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.flowModel.'Fs_fg[7]' = RealVariables17[32];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.flowModel.'Fs_fg[8]' = RealVariables17[33];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.flowModel.'Fs_fg[9]' = RealVariables17[34];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.flowModel.'dps_fg[1]' = RealVariables17[35];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.flowModel.'dps_fg[2]' = RealVariables17[36];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.flowModel.'dps_fg[3]' = RealVariables17[37];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.flowModel.'dps_fg[4]' = RealVariables17[38];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.flowModel.'dps_fg[5]' = RealVariables17[39];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.flowModel.'dps_fg[6]' = RealVariables17[40];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.flowModel.'dps_fg[7]' = RealVariables17[41];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.flowModel.'dps_fg[8]' = RealVariables17[42];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.flowModel.'dps_fg[9]' = RealVariables17[43];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.'m_flows[1]' = RealVariables17[44];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.'m_flows[2]' = RealVariables17[45];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.'m_flows[3]' = RealVariables17[46];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.'m_flows[4]' = RealVariables17[47];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.'m_flows[5]' = RealVariables17[48];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.'m_flows[6]' = RealVariables17[49];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.'m_flows[7]' = RealVariables17[50];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.'m_flows[8]' = RealVariables17[51];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.'m_flows[9]' = RealVariables17[52];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.'m_flows[10]' = RealVariables17[53];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.'m_flows[11]' = RealVariables17[54];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.'H_flows[1]' = RealVariables17[55];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.'H_flows[2]' = RealVariables17[56];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.'H_flows[3]' = RealVariables17[57];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.'H_flows[4]' = RealVariables17[58];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.'H_flows[5]' = RealVariables17[59];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.'H_flows[6]' = RealVariables17[60];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.'H_flows[7]' = RealVariables17[61];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.'H_flows[8]' = RealVariables17[62];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.'H_flows[9]' = RealVariables17[63];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.'H_flows[10]' = RealVariables17[64];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.'H_flows[11]' = RealVariables17[65];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.'vs[1]' = RealVariables17[66];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.'vs[2]' = RealVariables17[67];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.'vs[3]' = RealVariables17[68];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.'vs[4]' = RealVariables17[69];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.'vs[5]' = RealVariables17[70];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.'vs[6]' = RealVariables17[71];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.'vs[7]' = RealVariables17[72];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.'vs[8]' = RealVariables17[73];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.'vs[9]' = RealVariables17[74];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.'vs[10]' = RealVariables17[75];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.'heatPorts[1]'.T = RealVariables17[76];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.'heatPorts[1]'.Q_flow = RealVariables17[77];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.'heatPorts[2]'.T = RealVariables17[78];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.'heatPorts[2]'.Q_flow = RealVariables17[79];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.'heatPorts[3]'.T = RealVariables17[80];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.'heatPorts[3]'.Q_flow = RealVariables17[81];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.'heatPorts[4]'.T = RealVariables17[82];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.'heatPorts[4]'.Q_flow = RealVariables17[83];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.'heatPorts[5]'.T = RealVariables17[84];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.'heatPorts[5]'.Q_flow = RealVariables17[85];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.'heatPorts[6]'.T = RealVariables17[86];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.'heatPorts[6]'.Q_flow = RealVariables17[87];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.'heatPorts[7]'.T = RealVariables17[88];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.'heatPorts[7]'.Q_flow = RealVariables17[89];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.'heatPorts[8]'.T = RealVariables17[90];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.'heatPorts[8]'.Q_flow = RealVariables17[91];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.'heatPorts[9]'.T = RealVariables17[92];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.'heatPorts[9]'.Q_flow = RealVariables17[93];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.'heatPorts[10]'.T = RealVariables17[94];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.'heatPorts[10]'.Q_flow = RealVariables17[95];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.heatTransfer.'states[1]'.p = RealVariables17[96];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.heatTransfer.'states[1]'.T = RealVariables17[97];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.heatTransfer.'states[2]'.p = RealVariables17[98];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.heatTransfer.'states[2]'.T = RealVariables17[99];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.heatTransfer.'states[3]'.p = RealVariables17[100];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.heatTransfer.'states[3]'.T = RealVariables18[1];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.heatTransfer.'states[4]'.p = RealVariables18[2];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.heatTransfer.'states[4]'.T = RealVariables18[3];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.heatTransfer.'states[5]'.p = RealVariables18[4];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.heatTransfer.'states[5]'.T = RealVariables18[5];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.heatTransfer.'states[6]'.p = RealVariables18[6];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.heatTransfer.'states[6]'.T = RealVariables18[7];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.heatTransfer.'states[7]'.p = RealVariables18[8];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.heatTransfer.'states[7]'.T = RealVariables18[9];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.heatTransfer.'states[8]'.p = RealVariables18[10];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.heatTransfer.'states[8]'.T = RealVariables18[11];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.heatTransfer.'states[9]'.p = RealVariables18[12];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.heatTransfer.'states[9]'.T = RealVariables18[13];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.heatTransfer.'states[10]'.p = RealVariables18[14];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.heatTransfer.'states[10]'.T = RealVariables18[15];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.heatTransfer.'Q_flows[1]' = RealVariables18[16];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.heatTransfer.'Q_flows[2]' = RealVariables18[17];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.heatTransfer.'Q_flows[3]' = RealVariables18[18];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.heatTransfer.'Q_flows[4]' = RealVariables18[19];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.heatTransfer.'Q_flows[5]' = RealVariables18[20];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.heatTransfer.'Q_flows[6]' = RealVariables18[21];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.heatTransfer.'Q_flows[7]' = RealVariables18[22];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.heatTransfer.'Q_flows[8]' = RealVariables18[23];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.heatTransfer.'Q_flows[9]' = RealVariables18[24];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.heatTransfer.'Q_flows[10]' = RealVariables18[25];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.heatTransfer.'heatPorts[1]'.T = RealVariables18[26];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.heatTransfer.'heatPorts[1]'.Q_flow = RealVariables18[27];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.heatTransfer.'heatPorts[2]'.T = RealVariables18[28];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.heatTransfer.'heatPorts[2]'.Q_flow = RealVariables18[29];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.heatTransfer.'heatPorts[3]'.T = RealVariables18[30];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.heatTransfer.'heatPorts[3]'.Q_flow = RealVariables18[31];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.heatTransfer.'heatPorts[4]'.T = RealVariables18[32];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.heatTransfer.'heatPorts[4]'.Q_flow = RealVariables18[33];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.heatTransfer.'heatPorts[5]'.T = RealVariables18[34];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.heatTransfer.'heatPorts[5]'.Q_flow = RealVariables18[35];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.heatTransfer.'heatPorts[6]'.T = RealVariables18[36];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.heatTransfer.'heatPorts[6]'.Q_flow = RealVariables18[37];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.heatTransfer.'heatPorts[7]'.T = RealVariables18[38];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.heatTransfer.'heatPorts[7]'.Q_flow = RealVariables18[39];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.heatTransfer.'heatPorts[8]'.T = RealVariables18[40];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.heatTransfer.'heatPorts[8]'.Q_flow = RealVariables18[41];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.heatTransfer.'heatPorts[9]'.T = RealVariables18[42];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.heatTransfer.'heatPorts[9]'.Q_flow = RealVariables18[43];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.heatTransfer.'heatPorts[10]'.T = RealVariables18[44];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.heatTransfer.'heatPorts[10]'.Q_flow = RealVariables18[45];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.heatTransfer.'Ts[1]' = RealVariables18[46];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.heatTransfer.'Ts[2]' = RealVariables18[47];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.heatTransfer.'Ts[3]' = RealVariables18[48];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.heatTransfer.'Ts[4]' = RealVariables18[49];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.heatTransfer.'Ts[5]' = RealVariables18[50];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.heatTransfer.'Ts[6]' = RealVariables18[51];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.heatTransfer.'Ts[7]' = RealVariables18[52];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.heatTransfer.'Ts[8]' = RealVariables18[53];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.heatTransfer.'Ts[9]' = RealVariables18[54];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.heatTransfer.'Ts[10]' = RealVariables18[55];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.heatTransfer.'vs[1]' = RealVariables18[56];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.heatTransfer.'vs[2]' = RealVariables18[57];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.heatTransfer.'vs[3]' = RealVariables18[58];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.heatTransfer.'vs[4]' = RealVariables18[59];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.heatTransfer.'vs[5]' = RealVariables18[60];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.heatTransfer.'vs[6]' = RealVariables18[61];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.heatTransfer.'vs[7]' = RealVariables18[62];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.heatTransfer.'vs[8]' = RealVariables18[63];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.heatTransfer.'vs[9]' = RealVariables18[64];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.heatTransfer.'vs[10]' = RealVariables18[65];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.heatTransfer.'dimensions[1]' = RealVariables18[66];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.heatTransfer.'dimensions[2]' = RealVariables18[67];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.heatTransfer.'dimensions[3]' = RealVariables18[68];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.heatTransfer.'dimensions[4]' = RealVariables18[69];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.heatTransfer.'dimensions[5]' = RealVariables18[70];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.heatTransfer.'dimensions[6]' = RealVariables18[71];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.heatTransfer.'dimensions[7]' = RealVariables18[72];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.heatTransfer.'dimensions[8]' = RealVariables18[73];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.heatTransfer.'dimensions[9]' = RealVariables18[74];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.heatTransfer.'dimensions[10]' = RealVariables18[75];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.heatTransfer.'roughnesses[1]' = RealVariables18[76];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.heatTransfer.'roughnesses[2]' = RealVariables18[77];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.heatTransfer.'roughnesses[3]' = RealVariables18[78];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.heatTransfer.'roughnesses[4]' = RealVariables18[79];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.heatTransfer.'roughnesses[5]' = RealVariables18[80];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.heatTransfer.'roughnesses[6]' = RealVariables18[81];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.heatTransfer.'roughnesses[7]' = RealVariables18[82];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.heatTransfer.'roughnesses[8]' = RealVariables18[83];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.heatTransfer.'roughnesses[9]' = RealVariables18[84];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.heatTransfer.'roughnesses[10]' = RealVariables18[85];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.'mediums[1]'.p = RealVariables18[86];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.'mediums[1]'.h = RealVariables18[87];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.'mediums[1]'.T = RealVariables18[88];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.'mediums[1]'.T_der = RealVariables18[89];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.'mediums[1]'.u = RealVariables18[90];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.'mediums[1]'.u_der = RealVariables18[91];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.'mediums[1]'.state.p = RealVariables18[92];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.'mediums[1]'.state.T = RealVariables18[93];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.'mediums[1]'.T_degC = RealVariables18[94];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.'mediums[1]'.p_bar = RealVariables18[95];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.'mediums[2]'.p = RealVariables18[96];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.'mediums[2]'.h = RealVariables18[97];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.'mediums[2]'.T = RealVariables18[98];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.'mediums[2]'.T_der = RealVariables18[99];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.'mediums[2]'.u = RealVariables18[100];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.'mediums[2]'.u_der = RealVariables19[1];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.'mediums[2]'.state.p = RealVariables19[2];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.'mediums[2]'.state.T = RealVariables19[3];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.'mediums[2]'.T_degC = RealVariables19[4];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.'mediums[2]'.p_bar = RealVariables19[5];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.'mediums[3]'.p = RealVariables19[6];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.'mediums[3]'.h = RealVariables19[7];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.'mediums[3]'.T = RealVariables19[8];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.'mediums[3]'.T_der = RealVariables19[9];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.'mediums[3]'.u = RealVariables19[10];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.'mediums[3]'.u_der = RealVariables19[11];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.'mediums[3]'.state.p = RealVariables19[12];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.'mediums[3]'.state.T = RealVariables19[13];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.'mediums[3]'.T_degC = RealVariables19[14];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.'mediums[3]'.p_bar = RealVariables19[15];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.'mediums[4]'.p = RealVariables19[16];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.'mediums[4]'.h = RealVariables19[17];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.'mediums[4]'.T = RealVariables19[18];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.'mediums[4]'.T_der = RealVariables19[19];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.'mediums[4]'.u = RealVariables19[20];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.'mediums[4]'.u_der = RealVariables19[21];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.'mediums[4]'.state.p = RealVariables19[22];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.'mediums[4]'.state.T = RealVariables19[23];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.'mediums[4]'.T_degC = RealVariables19[24];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.'mediums[4]'.p_bar = RealVariables19[25];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.'mediums[5]'.p = RealVariables19[26];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.'mediums[5]'.h = RealVariables19[27];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.'mediums[5]'.T = RealVariables19[28];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.'mediums[5]'.T_der = RealVariables19[29];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.'mediums[5]'.u = RealVariables19[30];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.'mediums[5]'.u_der = RealVariables19[31];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.'mediums[5]'.state.p = RealVariables19[32];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.'mediums[5]'.state.T = RealVariables19[33];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.'mediums[5]'.T_degC = RealVariables19[34];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.'mediums[5]'.p_bar = RealVariables19[35];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.'mediums[6]'.p = RealVariables19[36];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.'mediums[6]'.h = RealVariables19[37];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.'mediums[6]'.T = RealVariables19[38];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.'mediums[6]'.T_der = RealVariables19[39];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.'mediums[6]'.u = RealVariables19[40];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.'mediums[6]'.u_der = RealVariables19[41];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.'mediums[6]'.state.p = RealVariables19[42];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.'mediums[6]'.state.T = RealVariables19[43];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.'mediums[6]'.T_degC = RealVariables19[44];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.'mediums[6]'.p_bar = RealVariables19[45];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.'mediums[7]'.p = RealVariables19[46];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.'mediums[7]'.h = RealVariables19[47];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.'mediums[7]'.T = RealVariables19[48];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.'mediums[7]'.T_der = RealVariables19[49];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.'mediums[7]'.u = RealVariables19[50];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.'mediums[7]'.u_der = RealVariables19[51];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.'mediums[7]'.state.p = RealVariables19[52];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.'mediums[7]'.state.T = RealVariables19[53];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.'mediums[7]'.T_degC = RealVariables19[54];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.'mediums[7]'.p_bar = RealVariables19[55];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.'mediums[8]'.p = RealVariables19[56];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.'mediums[8]'.h = RealVariables19[57];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.'mediums[8]'.T = RealVariables19[58];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.'mediums[8]'.T_der = RealVariables19[59];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.'mediums[8]'.u = RealVariables19[60];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.'mediums[8]'.u_der = RealVariables19[61];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.'mediums[8]'.state.p = RealVariables19[62];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.'mediums[8]'.state.T = RealVariables19[63];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.'mediums[8]'.T_degC = RealVariables19[64];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.'mediums[8]'.p_bar = RealVariables19[65];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.'mediums[9]'.p = RealVariables19[66];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.'mediums[9]'.h = RealVariables19[67];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.'mediums[9]'.T = RealVariables19[68];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.'mediums[9]'.T_der = RealVariables19[69];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.'mediums[9]'.u = RealVariables19[70];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.'mediums[9]'.u_der = RealVariables19[71];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.'mediums[9]'.state.p = RealVariables19[72];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.'mediums[9]'.state.T = RealVariables19[73];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.'mediums[9]'.T_degC = RealVariables19[74];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.'mediums[9]'.p_bar = RealVariables19[75];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.'mediums[10]'.p = RealVariables19[76];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.'mediums[10]'.h = RealVariables19[77];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.'mediums[10]'.T = RealVariables19[78];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.'mediums[10]'.T_der = RealVariables19[79];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.'mediums[10]'.u = RealVariables19[80];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.'mediums[10]'.u_der = RealVariables19[81];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.'mediums[10]'.state.p = RealVariables19[82];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.'mediums[10]'.state.T = RealVariables19[83];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.'mediums[10]'.T_degC = RealVariables19[84];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.'mediums[10]'.p_bar = RealVariables19[85];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.port_a.m_flow = RealVariables19[86];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.port_a.p = RealVariables19[87];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.port_a.h_outflow = RealVariables19[88];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.port_b.p = RealVariables19[89];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.port_b.h_outflow = RealVariables19[90];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.'Us[1]' = RealVariables19[91];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.'Us[1]_der' = RealVariables19[92];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.'Us[2]' = RealVariables19[93];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.'Us[2]_der' = RealVariables19[94];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.'Us[3]' = RealVariables19[95];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.'Us[3]_der' = RealVariables19[96];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.'Us[4]' = RealVariables19[97];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.'Us[4]_der' = RealVariables19[98];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.'Us[5]' = RealVariables19[99];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.'Us[5]_der' = RealVariables19[100];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.'Us[6]' = RealVariables20[1];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.'Us[6]_der' = RealVariables20[2];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.'Us[7]' = RealVariables20[3];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.'Us[7]_der' = RealVariables20[4];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.'Us[8]' = RealVariables20[5];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.'Us[8]_der' = RealVariables20[6];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.'Us[9]' = RealVariables20[7];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.'Us[9]_der' = RealVariables20[8];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.'Us[10]' = RealVariables20[9];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.'Us[10]_der' = RealVariables20[10];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.'Hb_flows[1]' = RealVariables20[11];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.'Hb_flows[2]' = RealVariables20[12];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.'Hb_flows[3]' = RealVariables20[13];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.'Hb_flows[4]' = RealVariables20[14];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.'Hb_flows[5]' = RealVariables20[15];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.'Hb_flows[6]' = RealVariables20[16];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.'Hb_flows[7]' = RealVariables20[17];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.'Hb_flows[8]' = RealVariables20[18];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.'Hb_flows[9]' = RealVariables20[19];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.'Hb_flows[10]' = RealVariables20[20];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.'Qb_flows[1]' = RealVariables20[21];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.'Qb_flows[2]' = RealVariables20[22];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.'Qb_flows[3]' = RealVariables20[23];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.'Qb_flows[4]' = RealVariables20[24];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.'Qb_flows[5]' = RealVariables20[25];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.'Qb_flows[6]' = RealVariables20[26];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.'Qb_flows[7]' = RealVariables20[27];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.'Qb_flows[8]' = RealVariables20[28];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.'Qb_flows[9]' = RealVariables20[29];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.'Qb_flows[10]' = RealVariables20[30];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.'Wb_flows[1]' = RealVariables20[31];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.'Wb_flows[2]' = RealVariables20[32];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.'Wb_flows[3]' = RealVariables20[33];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.'Wb_flows[4]' = RealVariables20[34];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.'Wb_flows[5]' = RealVariables20[35];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.'Wb_flows[6]' = RealVariables20[36];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.'Wb_flows[7]' = RealVariables20[37];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.'Wb_flows[8]' = RealVariables20[38];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.'Wb_flows[9]' = RealVariables20[39];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.'Wb_flows[10]' = RealVariables20[40];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.state_a.p = RealVariables20[41];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.state_a.T = RealVariables20[42];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.state_b.p = RealVariables20[43];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.'statesFM[1]'.p = RealVariables20[44];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.'statesFM[1]'.T = RealVariables20[45];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.'statesFM[2]'.p = RealVariables20[46];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.'statesFM[2]'.T = RealVariables20[47];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.'statesFM[3]'.p = RealVariables20[48];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.'statesFM[3]'.T = RealVariables20[49];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.'statesFM[4]'.p = RealVariables20[50];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.'statesFM[4]'.T = RealVariables20[51];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.'statesFM[5]'.p = RealVariables20[52];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.'statesFM[5]'.T = RealVariables20[53];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.'statesFM[6]'.p = RealVariables20[54];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.'statesFM[6]'.T = RealVariables20[55];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.'statesFM[7]'.p = RealVariables20[56];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.'statesFM[7]'.T = RealVariables20[57];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.'statesFM[8]'.p = RealVariables20[58];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.'statesFM[8]'.T = RealVariables20[59];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.'statesFM[9]'.p = RealVariables20[60];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.'statesFM[9]'.T = RealVariables20[61];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.'statesFM[10]'.p = RealVariables20[62];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.'statesFM[10]'.T = RealVariables20[63];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.flowModel.'states[1]'.p = RealVariables20[64];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.flowModel.'states[1]'.T = RealVariables20[65];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.flowModel.'states[2]'.p = RealVariables20[66];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.flowModel.'states[2]'.T = RealVariables20[67];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.flowModel.'states[3]'.p = RealVariables20[68];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.flowModel.'states[3]'.T = RealVariables20[69];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.flowModel.'states[4]'.p = RealVariables20[70];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.flowModel.'states[4]'.T = RealVariables20[71];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.flowModel.'states[5]'.p = RealVariables20[72];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.flowModel.'states[5]'.T = RealVariables20[73];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.flowModel.'states[6]'.p = RealVariables20[74];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.flowModel.'states[6]'.T = RealVariables20[75];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.flowModel.'states[7]'.p = RealVariables20[76];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.flowModel.'states[7]'.T = RealVariables20[77];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.flowModel.'states[8]'.p = RealVariables20[78];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.flowModel.'states[8]'.T = RealVariables20[79];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.flowModel.'states[9]'.p = RealVariables20[80];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.flowModel.'states[9]'.T = RealVariables20[81];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.flowModel.'states[10]'.p = RealVariables20[82];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.flowModel.'states[10]'.T = RealVariables20[83];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.flowModel.'vs[1]' = RealVariables20[84];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.flowModel.'vs[2]' = RealVariables20[85];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.flowModel.'vs[3]' = RealVariables20[86];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.flowModel.'vs[4]' = RealVariables20[87];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.flowModel.'vs[5]' = RealVariables20[88];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.flowModel.'vs[6]' = RealVariables20[89];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.flowModel.'vs[7]' = RealVariables20[90];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.flowModel.'vs[8]' = RealVariables20[91];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.flowModel.'vs[9]' = RealVariables20[92];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.flowModel.'vs[10]' = RealVariables20[93];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.flowModel.'crossAreas[1]' = RealVariables20[94];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.flowModel.'crossAreas[2]' = RealVariables20[95];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.flowModel.'crossAreas[3]' = RealVariables20[96];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.flowModel.'crossAreas[4]' = RealVariables20[97];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.flowModel.'crossAreas[5]' = RealVariables20[98];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.flowModel.'crossAreas[6]' = RealVariables20[99];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.flowModel.'crossAreas[7]' = RealVariables20[100];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.flowModel.'crossAreas[8]' = RealVariables21[1];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.flowModel.'crossAreas[9]' = RealVariables21[2];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.flowModel.'crossAreas[10]' = RealVariables21[3];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.flowModel.'dimensions[1]' = RealVariables21[4];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.flowModel.'dimensions[2]' = RealVariables21[5];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.flowModel.'dimensions[3]' = RealVariables21[6];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.flowModel.'dimensions[4]' = RealVariables21[7];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.flowModel.'dimensions[5]' = RealVariables21[8];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.flowModel.'dimensions[6]' = RealVariables21[9];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.flowModel.'dimensions[7]' = RealVariables21[10];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.flowModel.'dimensions[8]' = RealVariables21[11];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.flowModel.'dimensions[9]' = RealVariables21[12];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.flowModel.'dimensions[10]' = RealVariables21[13];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.flowModel.'roughnesses[1]' = RealVariables21[14];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.flowModel.'roughnesses[2]' = RealVariables21[15];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.flowModel.'roughnesses[3]' = RealVariables21[16];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.flowModel.'roughnesses[4]' = RealVariables21[17];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.flowModel.'roughnesses[5]' = RealVariables21[18];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.flowModel.'roughnesses[6]' = RealVariables21[19];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.flowModel.'roughnesses[7]' = RealVariables21[20];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.flowModel.'roughnesses[8]' = RealVariables21[21];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.flowModel.'roughnesses[9]' = RealVariables21[22];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.flowModel.'roughnesses[10]' = RealVariables21[23];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.flowModel.'m_flows[1]' = RealVariables21[24];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.flowModel.'m_flows[2]' = RealVariables21[25];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.flowModel.'m_flows[3]' = RealVariables21[26];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.flowModel.'m_flows[4]' = RealVariables21[27];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.flowModel.'m_flows[5]' = RealVariables21[28];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.flowModel.'m_flows[6]' = RealVariables21[29];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.flowModel.'m_flows[7]' = RealVariables21[30];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.flowModel.'m_flows[8]' = RealVariables21[31];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.flowModel.'m_flows[9]' = RealVariables21[32];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.flowModel.'Is[1]' = RealVariables21[33];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.flowModel.'Is[2]' = RealVariables21[34];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.flowModel.'Is[3]' = RealVariables21[35];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.flowModel.'Is[4]' = RealVariables21[36];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.flowModel.'Is[5]' = RealVariables21[37];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.flowModel.'Is[6]' = RealVariables21[38];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.flowModel.'Is[7]' = RealVariables21[39];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.flowModel.'Is[8]' = RealVariables21[40];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.flowModel.'Is[9]' = RealVariables21[41];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.flowModel.'Fs_p[1]' = RealVariables21[42];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.flowModel.'Fs_p[2]' = RealVariables21[43];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.flowModel.'Fs_p[3]' = RealVariables21[44];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.flowModel.'Fs_p[4]' = RealVariables21[45];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.flowModel.'Fs_p[5]' = RealVariables21[46];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.flowModel.'Fs_p[6]' = RealVariables21[47];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.flowModel.'Fs_p[7]' = RealVariables21[48];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.flowModel.'Fs_p[8]' = RealVariables21[49];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.flowModel.'Fs_p[9]' = RealVariables21[50];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.flowModel.'Fs_fg[1]' = RealVariables21[51];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.flowModel.'Fs_fg[2]' = RealVariables21[52];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.flowModel.'Fs_fg[3]' = RealVariables21[53];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.flowModel.'Fs_fg[4]' = RealVariables21[54];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.flowModel.'Fs_fg[5]' = RealVariables21[55];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.flowModel.'Fs_fg[6]' = RealVariables21[56];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.flowModel.'Fs_fg[7]' = RealVariables21[57];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.flowModel.'Fs_fg[8]' = RealVariables21[58];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.flowModel.'Fs_fg[9]' = RealVariables21[59];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.flowModel.'dps_fg[1]' = RealVariables21[60];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.flowModel.'dps_fg[2]' = RealVariables21[61];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.flowModel.'dps_fg[3]' = RealVariables21[62];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.flowModel.'dps_fg[4]' = RealVariables21[63];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.flowModel.'dps_fg[5]' = RealVariables21[64];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.flowModel.'dps_fg[6]' = RealVariables21[65];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.flowModel.'dps_fg[7]' = RealVariables21[66];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.flowModel.'dps_fg[8]' = RealVariables21[67];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.flowModel.'dps_fg[9]' = RealVariables21[68];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.'m_flows[1]' = RealVariables21[69];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.'m_flows[2]' = RealVariables21[70];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.'m_flows[3]' = RealVariables21[71];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.'m_flows[4]' = RealVariables21[72];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.'m_flows[5]' = RealVariables21[73];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.'m_flows[6]' = RealVariables21[74];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.'m_flows[7]' = RealVariables21[75];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.'m_flows[8]' = RealVariables21[76];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.'m_flows[9]' = RealVariables21[77];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.'m_flows[10]' = RealVariables21[78];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.'m_flows[11]' = RealVariables21[79];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.'H_flows[1]' = RealVariables21[80];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.'H_flows[2]' = RealVariables21[81];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.'H_flows[3]' = RealVariables21[82];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.'H_flows[4]' = RealVariables21[83];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.'H_flows[5]' = RealVariables21[84];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.'H_flows[6]' = RealVariables21[85];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.'H_flows[7]' = RealVariables21[86];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.'H_flows[8]' = RealVariables21[87];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.'H_flows[9]' = RealVariables21[88];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.'H_flows[10]' = RealVariables21[89];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.'H_flows[11]' = RealVariables21[90];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.'vs[1]' = RealVariables21[91];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.'vs[2]' = RealVariables21[92];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.'vs[3]' = RealVariables21[93];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.'vs[4]' = RealVariables21[94];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.'vs[5]' = RealVariables21[95];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.'vs[6]' = RealVariables21[96];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.'vs[7]' = RealVariables21[97];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.'vs[8]' = RealVariables21[98];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.'vs[9]' = RealVariables21[99];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.'vs[10]' = RealVariables21[100];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.'heatPorts[1]'.T = RealVariables22[1];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.'heatPorts[1]'.Q_flow = RealVariables22[2];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.'heatPorts[2]'.T = RealVariables22[3];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.'heatPorts[2]'.Q_flow = RealVariables22[4];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.'heatPorts[3]'.T = RealVariables22[5];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.'heatPorts[3]'.Q_flow = RealVariables22[6];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.'heatPorts[4]'.T = RealVariables22[7];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.'heatPorts[4]'.Q_flow = RealVariables22[8];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.'heatPorts[5]'.T = RealVariables22[9];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.'heatPorts[5]'.Q_flow = RealVariables22[10];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.'heatPorts[6]'.T = RealVariables22[11];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.'heatPorts[6]'.Q_flow = RealVariables22[12];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.'heatPorts[7]'.T = RealVariables22[13];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.'heatPorts[7]'.Q_flow = RealVariables22[14];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.'heatPorts[8]'.T = RealVariables22[15];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.'heatPorts[8]'.Q_flow = RealVariables22[16];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.'heatPorts[9]'.T = RealVariables22[17];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.'heatPorts[9]'.Q_flow = RealVariables22[18];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.'heatPorts[10]'.T = RealVariables22[19];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.'heatPorts[10]'.Q_flow = RealVariables22[20];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.heatTransfer.'states[1]'.p = RealVariables22[21];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.heatTransfer.'states[1]'.T = RealVariables22[22];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.heatTransfer.'states[2]'.p = RealVariables22[23];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.heatTransfer.'states[2]'.T = RealVariables22[24];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.heatTransfer.'states[3]'.p = RealVariables22[25];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.heatTransfer.'states[3]'.T = RealVariables22[26];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.heatTransfer.'states[4]'.p = RealVariables22[27];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.heatTransfer.'states[4]'.T = RealVariables22[28];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.heatTransfer.'states[5]'.p = RealVariables22[29];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.heatTransfer.'states[5]'.T = RealVariables22[30];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.heatTransfer.'states[6]'.p = RealVariables22[31];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.heatTransfer.'states[6]'.T = RealVariables22[32];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.heatTransfer.'states[7]'.p = RealVariables22[33];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.heatTransfer.'states[7]'.T = RealVariables22[34];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.heatTransfer.'states[8]'.p = RealVariables22[35];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.heatTransfer.'states[8]'.T = RealVariables22[36];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.heatTransfer.'states[9]'.p = RealVariables22[37];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.heatTransfer.'states[9]'.T = RealVariables22[38];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.heatTransfer.'states[10]'.p = RealVariables22[39];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.heatTransfer.'states[10]'.T = RealVariables22[40];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.heatTransfer.'Q_flows[1]' = RealVariables22[41];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.heatTransfer.'Q_flows[2]' = RealVariables22[42];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.heatTransfer.'Q_flows[3]' = RealVariables22[43];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.heatTransfer.'Q_flows[4]' = RealVariables22[44];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.heatTransfer.'Q_flows[5]' = RealVariables22[45];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.heatTransfer.'Q_flows[6]' = RealVariables22[46];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.heatTransfer.'Q_flows[7]' = RealVariables22[47];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.heatTransfer.'Q_flows[8]' = RealVariables22[48];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.heatTransfer.'Q_flows[9]' = RealVariables22[49];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.heatTransfer.'Q_flows[10]' = RealVariables22[50];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.heatTransfer.'heatPorts[1]'.T = RealVariables22[51];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.heatTransfer.'heatPorts[1]'.Q_flow = RealVariables22[52];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.heatTransfer.'heatPorts[2]'.T = RealVariables22[53];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.heatTransfer.'heatPorts[2]'.Q_flow = RealVariables22[54];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.heatTransfer.'heatPorts[3]'.T = RealVariables22[55];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.heatTransfer.'heatPorts[3]'.Q_flow = RealVariables22[56];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.heatTransfer.'heatPorts[4]'.T = RealVariables22[57];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.heatTransfer.'heatPorts[4]'.Q_flow = RealVariables22[58];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.heatTransfer.'heatPorts[5]'.T = RealVariables22[59];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.heatTransfer.'heatPorts[5]'.Q_flow = RealVariables22[60];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.heatTransfer.'heatPorts[6]'.T = RealVariables22[61];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.heatTransfer.'heatPorts[6]'.Q_flow = RealVariables22[62];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.heatTransfer.'heatPorts[7]'.T = RealVariables22[63];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.heatTransfer.'heatPorts[7]'.Q_flow = RealVariables22[64];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.heatTransfer.'heatPorts[8]'.T = RealVariables22[65];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.heatTransfer.'heatPorts[8]'.Q_flow = RealVariables22[66];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.heatTransfer.'heatPorts[9]'.T = RealVariables22[67];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.heatTransfer.'heatPorts[9]'.Q_flow = RealVariables22[68];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.heatTransfer.'heatPorts[10]'.T = RealVariables22[69];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.heatTransfer.'heatPorts[10]'.Q_flow = RealVariables22[70];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.heatTransfer.'Ts[1]' = RealVariables22[71];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.heatTransfer.'Ts[2]' = RealVariables22[72];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.heatTransfer.'Ts[3]' = RealVariables22[73];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.heatTransfer.'Ts[4]' = RealVariables22[74];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.heatTransfer.'Ts[5]' = RealVariables22[75];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.heatTransfer.'Ts[6]' = RealVariables22[76];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.heatTransfer.'Ts[7]' = RealVariables22[77];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.heatTransfer.'Ts[8]' = RealVariables22[78];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.heatTransfer.'Ts[9]' = RealVariables22[79];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.heatTransfer.'Ts[10]' = RealVariables22[80];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.heatTransfer.'vs[1]' = RealVariables22[81];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.heatTransfer.'vs[2]' = RealVariables22[82];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.heatTransfer.'vs[3]' = RealVariables22[83];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.heatTransfer.'vs[4]' = RealVariables22[84];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.heatTransfer.'vs[5]' = RealVariables22[85];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.heatTransfer.'vs[6]' = RealVariables22[86];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.heatTransfer.'vs[7]' = RealVariables22[87];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.heatTransfer.'vs[8]' = RealVariables22[88];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.heatTransfer.'vs[9]' = RealVariables22[89];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.heatTransfer.'vs[10]' = RealVariables22[90];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.heatTransfer.'dimensions[1]' = RealVariables22[91];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.heatTransfer.'dimensions[2]' = RealVariables22[92];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.heatTransfer.'dimensions[3]' = RealVariables22[93];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.heatTransfer.'dimensions[4]' = RealVariables22[94];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.heatTransfer.'dimensions[5]' = RealVariables22[95];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.heatTransfer.'dimensions[6]' = RealVariables22[96];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.heatTransfer.'dimensions[7]' = RealVariables22[97];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.heatTransfer.'dimensions[8]' = RealVariables22[98];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.heatTransfer.'dimensions[9]' = RealVariables22[99];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.heatTransfer.'dimensions[10]' = RealVariables22[100];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.heatTransfer.'roughnesses[1]' = RealVariables23[1];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.heatTransfer.'roughnesses[2]' = RealVariables23[2];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.heatTransfer.'roughnesses[3]' = RealVariables23[3];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.heatTransfer.'roughnesses[4]' = RealVariables23[4];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.heatTransfer.'roughnesses[5]' = RealVariables23[5];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.heatTransfer.'roughnesses[6]' = RealVariables23[6];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.heatTransfer.'roughnesses[7]' = RealVariables23[7];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.heatTransfer.'roughnesses[8]' = RealVariables23[8];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.heatTransfer.'roughnesses[9]' = RealVariables23[9];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.heatTransfer.'roughnesses[10]' = RealVariables23[10];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.'mediums[1]'.p = RealVariables23[11];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.'mediums[1]'.h = RealVariables23[12];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.'mediums[1]'.T = RealVariables23[13];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.'mediums[1]'.T_der = RealVariables23[14];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.'mediums[1]'.u = RealVariables23[15];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.'mediums[1]'.u_der = RealVariables23[16];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.'mediums[1]'.state.p = RealVariables23[17];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.'mediums[1]'.state.T = RealVariables23[18];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.'mediums[1]'.T_degC = RealVariables23[19];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.'mediums[1]'.p_bar = RealVariables23[20];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.'mediums[2]'.p = RealVariables23[21];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.'mediums[2]'.h = RealVariables23[22];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.'mediums[2]'.T = RealVariables23[23];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.'mediums[2]'.T_der = RealVariables23[24];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.'mediums[2]'.u = RealVariables23[25];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.'mediums[2]'.u_der = RealVariables23[26];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.'mediums[2]'.state.p = RealVariables23[27];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.'mediums[2]'.state.T = RealVariables23[28];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.'mediums[2]'.T_degC = RealVariables23[29];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.'mediums[2]'.p_bar = RealVariables23[30];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.'mediums[3]'.p = RealVariables23[31];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.'mediums[3]'.h = RealVariables23[32];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.'mediums[3]'.T = RealVariables23[33];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.'mediums[3]'.T_der = RealVariables23[34];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.'mediums[3]'.u = RealVariables23[35];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.'mediums[3]'.u_der = RealVariables23[36];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.'mediums[3]'.state.p = RealVariables23[37];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.'mediums[3]'.state.T = RealVariables23[38];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.'mediums[3]'.T_degC = RealVariables23[39];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.'mediums[3]'.p_bar = RealVariables23[40];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.'mediums[4]'.p = RealVariables23[41];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.'mediums[4]'.h = RealVariables23[42];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.'mediums[4]'.T = RealVariables23[43];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.'mediums[4]'.T_der = RealVariables23[44];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.'mediums[4]'.u = RealVariables23[45];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.'mediums[4]'.u_der = RealVariables23[46];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.'mediums[4]'.state.p = RealVariables23[47];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.'mediums[4]'.state.T = RealVariables23[48];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.'mediums[4]'.T_degC = RealVariables23[49];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.'mediums[4]'.p_bar = RealVariables23[50];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.'mediums[5]'.p = RealVariables23[51];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.'mediums[5]'.h = RealVariables23[52];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.'mediums[5]'.T = RealVariables23[53];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.'mediums[5]'.T_der = RealVariables23[54];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.'mediums[5]'.u = RealVariables23[55];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.'mediums[5]'.u_der = RealVariables23[56];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.'mediums[5]'.state.p = RealVariables23[57];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.'mediums[5]'.state.T = RealVariables23[58];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.'mediums[5]'.T_degC = RealVariables23[59];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.'mediums[5]'.p_bar = RealVariables23[60];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.'mediums[6]'.p = RealVariables23[61];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.'mediums[6]'.h = RealVariables23[62];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.'mediums[6]'.T = RealVariables23[63];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.'mediums[6]'.T_der = RealVariables23[64];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.'mediums[6]'.u = RealVariables23[65];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.'mediums[6]'.u_der = RealVariables23[66];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.'mediums[6]'.state.p = RealVariables23[67];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.'mediums[6]'.state.T = RealVariables23[68];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.'mediums[6]'.T_degC = RealVariables23[69];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.'mediums[6]'.p_bar = RealVariables23[70];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.'mediums[7]'.p = RealVariables23[71];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.'mediums[7]'.h = RealVariables23[72];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.'mediums[7]'.T = RealVariables23[73];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.'mediums[7]'.T_der = RealVariables23[74];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.'mediums[7]'.u = RealVariables23[75];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.'mediums[7]'.u_der = RealVariables23[76];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.'mediums[7]'.state.p = RealVariables23[77];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.'mediums[7]'.state.T = RealVariables23[78];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.'mediums[7]'.T_degC = RealVariables23[79];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.'mediums[7]'.p_bar = RealVariables23[80];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.'mediums[8]'.p = RealVariables23[81];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.'mediums[8]'.h = RealVariables23[82];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.'mediums[8]'.T = RealVariables23[83];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.'mediums[8]'.T_der = RealVariables23[84];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.'mediums[8]'.u = RealVariables23[85];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.'mediums[8]'.u_der = RealVariables23[86];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.'mediums[8]'.state.p = RealVariables23[87];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.'mediums[8]'.state.T = RealVariables23[88];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.'mediums[8]'.T_degC = RealVariables23[89];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.'mediums[8]'.p_bar = RealVariables23[90];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.'mediums[9]'.p = RealVariables23[91];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.'mediums[9]'.h = RealVariables23[92];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.'mediums[9]'.T = RealVariables23[93];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.'mediums[9]'.T_der = RealVariables23[94];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.'mediums[9]'.u = RealVariables23[95];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.'mediums[9]'.u_der = RealVariables23[96];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.'mediums[9]'.state.p = RealVariables23[97];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.'mediums[9]'.state.T = RealVariables23[98];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.'mediums[9]'.T_degC = RealVariables23[99];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.'mediums[9]'.p_bar = RealVariables23[100];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.'mediums[10]'.p = RealVariables24[1];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.'mediums[10]'.h = RealVariables24[2];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.'mediums[10]'.T = RealVariables24[3];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.'mediums[10]'.T_der = RealVariables24[4];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.'mediums[10]'.u = RealVariables24[5];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.'mediums[10]'.u_der = RealVariables24[6];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.'mediums[10]'.state.p = RealVariables24[7];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.'mediums[10]'.state.T = RealVariables24[8];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.'mediums[10]'.T_degC = RealVariables24[9];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.'mediums[10]'.p_bar = RealVariables24[10];
  closedCTPressureDrop.heatExchangerThroughReal.volumeFlowRate.port_a.m_flow = RealVariables24[11];
  closedCTPressureDrop.heatExchangerThroughReal.volumeFlowRate.port_a.p = RealVariables24[12];
  closedCTPressureDrop.heatExchangerThroughReal.volumeFlowRate.port_a.h_outflow = RealVariables24[13];
  closedCTPressureDrop.heatExchangerThroughReal.volumeFlowRate.port_b.p = RealVariables24[14];
  closedCTPressureDrop.heatExchangerThroughReal.volumeFlowRate.port_b.h_outflow = RealVariables24[15];
  closedCTPressureDrop.heatExchangerThroughReal.volumeFlowRate.m_flow = RealVariables24[16];
  closedCTPressureDrop.heatExchangerThroughReal.volumeFlowRate.dp = RealVariables24[17];
  closedCTPressureDrop.heatExchangerThroughReal.volumeFlowRate.V_flow = RealVariables24[18];
  closedCTPressureDrop.heatExchangerThroughReal.volumeFlowRate.port_a_T = RealVariables24[19];
  closedCTPressureDrop.heatExchangerThroughReal.volumeFlowRate.port_b_T = RealVariables24[20];
  closedCTPressureDrop.port_a_air.m_flow = RealVariables24[21];
  closedCTPressureDrop.port_a_air.p = RealVariables24[22];
  closedCTPressureDrop.port_a_air.h_outflow = RealVariables24[23];
  closedCTPressureDrop.port_a_air.'Xi_outflow[1]' = RealVariables24[24];
  closedCTPressureDrop.port_b_air.m_flow = RealVariables24[25];
  closedCTPressureDrop.port_b_air.p = RealVariables24[26];
  closedCTPressureDrop.port_b_air.h_outflow = RealVariables24[27];
  closedCTPressureDrop.port_b_air.'Xi_outflow[1]' = RealVariables24[28];
  closedCTPressureDrop.waterBasin.level = RealVariables24[29];
  closedCTPressureDrop.waterBasin.level_der = RealVariables24[30];
  closedCTPressureDrop.waterBasin.V = RealVariables24[31];
  closedCTPressureDrop.waterBasin.V_der = RealVariables24[32];
  closedCTPressureDrop.waterBasin.fluidVolume = RealVariables24[33];
  closedCTPressureDrop.waterBasin.medium.h = RealVariables24[34];
  closedCTPressureDrop.waterBasin.medium.T = RealVariables24[35];
  closedCTPressureDrop.waterBasin.medium.T_der = RealVariables24[36];
  closedCTPressureDrop.waterBasin.medium.u = RealVariables24[37];
  closedCTPressureDrop.waterBasin.medium.u_der = RealVariables24[38];
  closedCTPressureDrop.waterBasin.medium.state.p = RealVariables24[39];
  closedCTPressureDrop.waterBasin.medium.state.T = RealVariables24[40];
  closedCTPressureDrop.waterBasin.medium.T_degC = RealVariables24[41];
  closedCTPressureDrop.waterBasin.U = RealVariables24[42];
  closedCTPressureDrop.waterBasin.U_der = RealVariables24[43];
  closedCTPressureDrop.waterBasin.m = RealVariables24[44];
  closedCTPressureDrop.waterBasin.m_der = RealVariables24[45];
  closedCTPressureDrop.waterBasin.mb_flow = RealVariables24[46];
  closedCTPressureDrop.waterBasin.Hb_flow = RealVariables24[47];
  closedCTPressureDrop.waterBasin.Qb_flow = RealVariables24[48];
  closedCTPressureDrop.waterBasin.'ports[1]'.m_flow = RealVariables24[49];
  closedCTPressureDrop.waterBasin.'ports[1]'.p = RealVariables24[50];
  closedCTPressureDrop.waterBasin.'ports[1]'.h_outflow = RealVariables24[51];
  closedCTPressureDrop.waterBasin.'ports[2]'.m_flow = RealVariables24[52];
  closedCTPressureDrop.waterBasin.'ports[2]'.p = RealVariables24[53];
  closedCTPressureDrop.waterBasin.'ports[2]'.h_outflow = RealVariables24[54];
  closedCTPressureDrop.waterBasin.'ports[3]'.m_flow = RealVariables24[55];
  closedCTPressureDrop.waterBasin.'ports[3]'.p = RealVariables24[56];
  closedCTPressureDrop.waterBasin.'ports[3]'.h_outflow = RealVariables24[57];
  closedCTPressureDrop.waterBasin.'ports_H_flow[1]' = RealVariables24[58];
  closedCTPressureDrop.waterBasin.'ports_H_flow[2]' = RealVariables24[59];
  closedCTPressureDrop.waterBasin.'ports_H_flow[3]' = RealVariables24[60];
  closedCTPressureDrop.waterBasin.heatTransfer.'states[1]'.p = RealVariables24[61];
  closedCTPressureDrop.waterBasin.heatTransfer.'states[1]'.T = RealVariables24[62];
  closedCTPressureDrop.waterBasin.heatTransfer.'surfaceAreas[1]' = RealVariables24[63];
  closedCTPressureDrop.waterBasin.heatTransfer.'Q_flows[1]' = RealVariables24[64];
  closedCTPressureDrop.waterBasin.heatTransfer.'heatPorts[1]'.T = RealVariables24[65];
  closedCTPressureDrop.waterBasin.heatTransfer.'heatPorts[1]'.Q_flow = RealVariables24[66];
  closedCTPressureDrop.waterBasin.heatTransfer.'Ts[1]' = RealVariables24[67];
  closedCTPressureDrop.waterBasin.heatPort.T = RealVariables24[68];
  closedCTPressureDrop.waterBasin.heatPort.Q_flow = RealVariables24[69];
  closedCTPressureDrop.waterBasin.'portVelocities[2]' = RealVariables24[70];
  closedCTPressureDrop.waterBasin.'portVelocities[3]' = RealVariables24[71];
  closedCTPressureDrop.waterBasin.'ports_E_flow[2]' = RealVariables24[72];
  closedCTPressureDrop.waterBasin.'ports_E_flow[3]' = RealVariables24[73];
  closedCTPressureDrop.waterBasin.'s[1]' = RealVariables24[74];
  closedCTPressureDrop.waterBasin.'s[2]' = RealVariables24[75];
  closedCTPressureDrop.waterBasin.'s[3]' = RealVariables24[76];
  closedCTPressureDrop.waterBasin.'ports_penetration[1]' = RealVariables24[77];
  closedCTPressureDrop.waterBasin.'ports_penetration[2]' = RealVariables24[78];
  closedCTPressureDrop.waterBasin.'ports_penetration[3]' = RealVariables24[79];
  closedCTPressureDrop.waterBasin.'vessel_ps_static[1]' = RealVariables24[80];
  closedCTPressureDrop.waterBasin.'vessel_ps_static[2]' = RealVariables24[81];
  closedCTPressureDrop.waterBasin.'vessel_ps_static[3]' = RealVariables24[82];
  closedCTPressureDrop.waterBasin.'m_flow_turbulent[1]' = RealVariables24[83];
  closedCTPressureDrop.waterBasin.'m_flow_turbulent[2]' = RealVariables24[84];
  closedCTPressureDrop.waterBasin.'m_flow_turbulent[3]' = RealVariables24[85];
  closedCTPressureDrop.naturalConvectionVerticalPlate.Q_flow = RealVariables24[86];
  closedCTPressureDrop.naturalConvectionVerticalPlate.dT = RealVariables24[87];
  closedCTPressureDrop.naturalConvectionVerticalPlate.solid.T = RealVariables24[88];
  closedCTPressureDrop.naturalConvectionVerticalPlate.solid.Q_flow = RealVariables24[89];
  closedCTPressureDrop.naturalConvectionVerticalPlate.fluid.T = RealVariables24[90];
  closedCTPressureDrop.naturalConvectionVerticalPlate.fluid.Q_flow = RealVariables24[91];
  closedCTPressureDrop.naturalConvectionVerticalPlate.Gc = RealVariables24[92];
  closedCTPressureDrop.naturalConvectionVerticalPlate.h = RealVariables24[93];
  closedCTPressureDrop.naturalConvectionVerticalPlate.A = RealVariables24[94];
  closedCTPressureDrop.naturalConvectionVerticalPlate.beta = RealVariables24[95];
  closedCTPressureDrop.naturalConvectionVerticalPlate.Gr = RealVariables24[96];
  closedCTPressureDrop.naturalConvectionVerticalPlate.Ra = RealVariables24[97];
  closedCTPressureDrop.naturalConvectionVerticalPlate.NuL = RealVariables24[98];
  closedCTPressureDrop.naturalConvectionVerticalPlate.NuL1 = RealVariables24[99];
  closedCTPressureDrop.naturalConvectionVerticalPlate.NuL2 = RealVariables24[100];
  closedCTPressureDrop.naturalConvectionVerticalPlate.Pr = RealVariables25[1];
  closedCTPressureDrop.naturalConvectionVerticalPlate.visco = RealVariables25[2];
  closedCTPressureDrop.naturalConvectionVerticalPlate.K = RealVariables25[3];
  closedCTPressureDrop.naturalConvectionVerticalPlate.Tc = RealVariables25[4];
  closedCTPressureDrop.port_a_floor.T = RealVariables25[5];
  closedCTPressureDrop.port_a_floor.Q_flow = RealVariables25[6];
  closedCTPressureDrop.port_a_Cwater.m_flow = RealVariables25[7];
  closedCTPressureDrop.port_a_Cwater.p = RealVariables25[8];
  closedCTPressureDrop.port_a_Cwater.h_outflow = RealVariables25[9];
  closedCTPressureDrop.port_b_Cwater.p = RealVariables25[10];
  closedCTPressureDrop.port_b_Cwater.h_outflow = RealVariables25[11];
  closedCTPressureDrop.port_a_Owater.m_flow = RealVariables25[12];
  closedCTPressureDrop.port_a_Owater.p = RealVariables25[13];
  closedCTPressureDrop.port_a_Owater.h_outflow = RealVariables25[14];
  closedCTPressureDrop.waterSpray.port_a.m_flow = RealVariables25[15];
  closedCTPressureDrop.waterSpray.port_a.p = RealVariables25[16];
  closedCTPressureDrop.waterSpray.port_a.h_outflow = RealVariables25[17];
  closedCTPressureDrop.waterSpray.port_b.m_flow = RealVariables25[18];
  closedCTPressureDrop.waterSpray.port_b.p = RealVariables25[19];
  closedCTPressureDrop.waterSpray.port_b.h_outflow = RealVariables25[20];
  closedCTPressureDrop.waterSpray.m_flow = RealVariables25[21];
  closedCTPressureDrop.waterSpray.port_a_T = RealVariables25[22];
  closedCTPressureDrop.waterSpray.port_b_T = RealVariables25[23];
  closedCTPressureDrop.pump.port_a.m_flow = RealVariables25[24];
  closedCTPressureDrop.pump.port_a.p = RealVariables25[25];
  closedCTPressureDrop.pump.port_a.h_outflow = RealVariables25[26];
  closedCTPressureDrop.pump.port_b.m_flow = RealVariables25[27];
  closedCTPressureDrop.pump.port_b.p = RealVariables25[28];
  closedCTPressureDrop.pump.port_b.h_outflow = RealVariables25[29];
  closedCTPressureDrop.pump.medium.p = RealVariables25[30];
  closedCTPressureDrop.pump.medium.h = RealVariables25[31];
  closedCTPressureDrop.pump.medium.T = RealVariables25[32];
  closedCTPressureDrop.pump.medium.u = RealVariables25[33];
  closedCTPressureDrop.pump.medium.state.p = RealVariables25[34];
  closedCTPressureDrop.pump.medium.state.T = RealVariables25[35];
  closedCTPressureDrop.pump.medium.T_degC = RealVariables25[36];
  closedCTPressureDrop.pump.medium.p_bar = RealVariables25[37];
  closedCTPressureDrop.pump.U = RealVariables25[38];
  closedCTPressureDrop.pump.Hb_flow = RealVariables25[39];
  closedCTPressureDrop.pump.Wb_flow = RealVariables25[40];
  closedCTPressureDrop.pump.heatTransfer.'states[1]'.p = RealVariables25[41];
  closedCTPressureDrop.pump.heatTransfer.'states[1]'.T = RealVariables25[42];
  closedCTPressureDrop.pump.heatTransfer.'heatPorts[1]'.T = RealVariables25[43];
  closedCTPressureDrop.pump.heatTransfer.'Ts[1]' = RealVariables25[44];
  closedCTPressureDrop.pump.dp_pump = RealVariables25[45];
  closedCTPressureDrop.pump.head = RealVariables25[46];
  closedCTPressureDrop.pump.m_flow = RealVariables25[47];
  closedCTPressureDrop.pump.N = RealVariables25[48];
  closedCTPressureDrop.pump.W_single = RealVariables25[49];
  closedCTPressureDrop.pump.W_total = RealVariables25[50];
  closedCTPressureDrop.pump.monitoring.state_in.p = RealVariables25[51];
  closedCTPressureDrop.pump.monitoring.state_in.T = RealVariables25[52];
  closedCTPressureDrop.pump.monitoring.state.p = RealVariables25[53];
  closedCTPressureDrop.pump.monitoring.state.T = RealVariables25[54];
  closedCTPressureDrop.pump.m_flow_set = RealVariables25[55];
  closedCTPressureDrop.realExpression.y = RealVariables25[56];
  closedCTPressureDrop.A.y = RealVariables25[57];
  closedCTPressureDrop.storageWall.'sideInertia[1]'.T = RealVariables25[58];
  closedCTPressureDrop.storageWall.'sideInertia[1]'.T_der = RealVariables25[59];
  closedCTPressureDrop.storageWall.'sideInertia[1]'.Q_flow = RealVariables25[60];
  closedCTPressureDrop.storageWall.'sideInertia[1]'.port.T = RealVariables25[61];
  closedCTPressureDrop.storageWall.'sideInertia[1]'.port.Q_flow = RealVariables25[62];
  closedCTPressureDrop.storageWall.'sideInertia[1]'.der_T = RealVariables25[63];
  closedCTPressureDrop.storageWall.'sideInertia[2]'.T = RealVariables25[64];
  closedCTPressureDrop.storageWall.'sideInertia[2]'.T_der = RealVariables25[65];
  closedCTPressureDrop.storageWall.'sideInertia[2]'.Q_flow = RealVariables25[66];
  closedCTPressureDrop.storageWall.'sideInertia[2]'.port.T = RealVariables25[67];
  closedCTPressureDrop.storageWall.'sideInertia[2]'.port.Q_flow = RealVariables25[68];
  closedCTPressureDrop.storageWall.'sideInertia[2]'.der_T = RealVariables25[69];
  closedCTPressureDrop.storageWall.topInertia.T = RealVariables25[70];
  closedCTPressureDrop.storageWall.topInertia.T_der = RealVariables25[71];
  closedCTPressureDrop.storageWall.topInertia.Q_flow = RealVariables25[72];
  closedCTPressureDrop.storageWall.topInertia.port.T = RealVariables25[73];
  closedCTPressureDrop.storageWall.topInertia.port.Q_flow = RealVariables25[74];
  closedCTPressureDrop.storageWall.topInertia.der_T = RealVariables25[75];
  closedCTPressureDrop.storageWall.'sideCond2[1]'.Q_flow = RealVariables25[76];
  closedCTPressureDrop.storageWall.'sideCond2[1]'.dT = RealVariables25[77];
  closedCTPressureDrop.storageWall.'sideCond2[1]'.port_a.T = RealVariables25[78];
  closedCTPressureDrop.storageWall.'sideCond2[1]'.port_a.Q_flow = RealVariables25[79];
  closedCTPressureDrop.storageWall.'sideCond2[1]'.port_b.T = RealVariables25[80];
  closedCTPressureDrop.storageWall.'sideCond2[1]'.port_b.Q_flow = RealVariables25[81];
  closedCTPressureDrop.storageWall.'sideCond2[1]'.T = RealVariables25[82];
  closedCTPressureDrop.storageWall.'sideCond2[2]'.Q_flow = RealVariables25[83];
  closedCTPressureDrop.storageWall.'sideCond2[2]'.dT = RealVariables25[84];
  closedCTPressureDrop.storageWall.'sideCond2[2]'.port_a.T = RealVariables25[85];
  closedCTPressureDrop.storageWall.'sideCond2[2]'.port_a.Q_flow = RealVariables25[86];
  closedCTPressureDrop.storageWall.'sideCond2[2]'.port_b.T = RealVariables25[87];
  closedCTPressureDrop.storageWall.'sideCond2[2]'.port_b.Q_flow = RealVariables25[88];
  closedCTPressureDrop.storageWall.'sideCond2[2]'.T = RealVariables25[89];
  closedCTPressureDrop.storageWall.'sideCond1[1]'.Q_flow = RealVariables25[90];
  closedCTPressureDrop.storageWall.'sideCond1[1]'.dT = RealVariables25[91];
  closedCTPressureDrop.storageWall.'sideCond1[1]'.port_a.T = RealVariables25[92];
  closedCTPressureDrop.storageWall.'sideCond1[1]'.port_a.Q_flow = RealVariables25[93];
  closedCTPressureDrop.storageWall.'sideCond1[1]'.port_b.T = RealVariables25[94];
  closedCTPressureDrop.storageWall.'sideCond1[1]'.port_b.Q_flow = RealVariables25[95];
  closedCTPressureDrop.storageWall.'sideCond1[1]'.T = RealVariables25[96];
  closedCTPressureDrop.storageWall.'sideCond1[2]'.Q_flow = RealVariables25[97];
  closedCTPressureDrop.storageWall.'sideCond1[2]'.dT = RealVariables25[98];
  closedCTPressureDrop.storageWall.'sideCond1[2]'.port_a.T = RealVariables25[99];
  closedCTPressureDrop.storageWall.'sideCond1[2]'.port_a.Q_flow = RealVariables25[100];
  closedCTPressureDrop.storageWall.'sideCond1[2]'.port_b.T = RealVariables26[1];
  closedCTPressureDrop.storageWall.'sideCond1[2]'.port_b.Q_flow = RealVariables26[2];
  closedCTPressureDrop.storageWall.'sideCond1[2]'.T = RealVariables26[3];
  closedCTPressureDrop.storageWall.topCond1.Q_flow = RealVariables26[4];
  closedCTPressureDrop.storageWall.topCond1.dT = RealVariables26[5];
  closedCTPressureDrop.storageWall.topCond1.port_a.T = RealVariables26[6];
  closedCTPressureDrop.storageWall.topCond1.port_a.Q_flow = RealVariables26[7];
  closedCTPressureDrop.storageWall.topCond1.port_b.T = RealVariables26[8];
  closedCTPressureDrop.storageWall.topCond1.port_b.Q_flow = RealVariables26[9];
  closedCTPressureDrop.storageWall.topCond1.T = RealVariables26[10];
  closedCTPressureDrop.storageWall.topCond2.Q_flow = RealVariables26[11];
  closedCTPressureDrop.storageWall.topCond2.dT = RealVariables26[12];
  closedCTPressureDrop.storageWall.topCond2.port_a.T = RealVariables26[13];
  closedCTPressureDrop.storageWall.topCond2.port_a.Q_flow = RealVariables26[14];
  closedCTPressureDrop.storageWall.topCond2.port_b.T = RealVariables26[15];
  closedCTPressureDrop.storageWall.topCond2.port_b.Q_flow = RealVariables26[16];
  closedCTPressureDrop.storageWall.topCond2.T = RealVariables26[17];
  closedCTPressureDrop.storageWall.T_water.T = RealVariables26[18];
  closedCTPressureDrop.storageWall.T_water.Q_flow = RealVariables26[19];
  closedCTPressureDrop.storageWall.ambient.T = RealVariables26[20];
  closedCTPressureDrop.storageWall.ambient.Q_flow = RealVariables26[21];
  closedCTPressureDrop.storageWall.'frontInertia[1]'.T = RealVariables26[22];
  closedCTPressureDrop.storageWall.'frontInertia[1]'.T_der = RealVariables26[23];
  closedCTPressureDrop.storageWall.'frontInertia[1]'.Q_flow = RealVariables26[24];
  closedCTPressureDrop.storageWall.'frontInertia[1]'.port.T = RealVariables26[25];
  closedCTPressureDrop.storageWall.'frontInertia[1]'.port.Q_flow = RealVariables26[26];
  closedCTPressureDrop.storageWall.'frontInertia[1]'.der_T = RealVariables26[27];
  closedCTPressureDrop.storageWall.'frontInertia[2]'.T = RealVariables26[28];
  closedCTPressureDrop.storageWall.'frontInertia[2]'.T_der = RealVariables26[29];
  closedCTPressureDrop.storageWall.'frontInertia[2]'.Q_flow = RealVariables26[30];
  closedCTPressureDrop.storageWall.'frontInertia[2]'.port.T = RealVariables26[31];
  closedCTPressureDrop.storageWall.'frontInertia[2]'.port.Q_flow = RealVariables26[32];
  closedCTPressureDrop.storageWall.'frontInertia[2]'.der_T = RealVariables26[33];
  closedCTPressureDrop.storageWall.'frontCond1[1]'.Q_flow = RealVariables26[34];
  closedCTPressureDrop.storageWall.'frontCond1[1]'.dT = RealVariables26[35];
  closedCTPressureDrop.storageWall.'frontCond1[1]'.port_a.T = RealVariables26[36];
  closedCTPressureDrop.storageWall.'frontCond1[1]'.port_a.Q_flow = RealVariables26[37];
  closedCTPressureDrop.storageWall.'frontCond1[1]'.port_b.T = RealVariables26[38];
  closedCTPressureDrop.storageWall.'frontCond1[1]'.port_b.Q_flow = RealVariables26[39];
  closedCTPressureDrop.storageWall.'frontCond1[1]'.T = RealVariables26[40];
  closedCTPressureDrop.storageWall.'frontCond1[2]'.port_a.T = RealVariables26[41];
  closedCTPressureDrop.storageWall.'frontCond1[2]'.port_b.T = RealVariables26[42];
  closedCTPressureDrop.storageWall.'frontCond1[2]'.T = RealVariables26[43];
  closedCTPressureDrop.storageWall.'frontCond2[1]'.Q_flow = RealVariables26[44];
  closedCTPressureDrop.storageWall.'frontCond2[1]'.dT = RealVariables26[45];
  closedCTPressureDrop.storageWall.'frontCond2[1]'.port_a.T = RealVariables26[46];
  closedCTPressureDrop.storageWall.'frontCond2[1]'.port_a.Q_flow = RealVariables26[47];
  closedCTPressureDrop.storageWall.'frontCond2[1]'.port_b.T = RealVariables26[48];
  closedCTPressureDrop.storageWall.'frontCond2[1]'.port_b.Q_flow = RealVariables26[49];
  closedCTPressureDrop.storageWall.'frontCond2[1]'.T = RealVariables26[50];
  closedCTPressureDrop.storageWall.'frontCond2[2]'.Q_flow = RealVariables26[51];
  closedCTPressureDrop.storageWall.'frontCond2[2]'.dT = RealVariables26[52];
  closedCTPressureDrop.storageWall.'frontCond2[2]'.port_a.T = RealVariables26[53];
  closedCTPressureDrop.storageWall.'frontCond2[2]'.port_a.Q_flow = RealVariables26[54];
  closedCTPressureDrop.storageWall.'frontCond2[2]'.port_b.T = RealVariables26[55];
  closedCTPressureDrop.storageWall.'frontCond2[2]'.port_b.Q_flow = RealVariables26[56];
  closedCTPressureDrop.storageWall.'frontCond2[2]'.T = RealVariables26[57];
  closedCTPressureDrop.storageWall.'floor'.T = RealVariables26[58];
  closedCTPressureDrop.storageWall.'floor'.Q_flow = RealVariables26[59];
  closedCTPressureDrop.port_a_ambient.T = RealVariables26[60];
  closedCTPressureDrop.port_a_ambient.Q_flow = RealVariables26[61];
  closedCTPressureDrop.level = RealVariables26[62];
  airIn.medium.p = RealVariables26[63];
  airIn.medium.'Xi[1]' = RealVariables26[64];
  airIn.medium.h = RealVariables26[65];
  airIn.medium.d = RealVariables26[66];
  airIn.medium.T = RealVariables26[67];
  airIn.medium.'X[1]' = RealVariables26[68];
  airIn.medium.'X[2]' = RealVariables26[69];
  airIn.medium.u = RealVariables26[70];
  airIn.medium.R = RealVariables26[71];
  airIn.medium.MM = RealVariables26[72];
  airIn.medium.state.p = RealVariables26[73];
  airIn.medium.state.T = RealVariables26[74];
  airIn.medium.state.'X[1]' = RealVariables26[75];
  airIn.medium.state.'X[2]' = RealVariables26[76];
  airIn.medium.T_degC = RealVariables26[77];
  airIn.medium.p_bar = RealVariables26[78];
  airIn.medium.x_water = RealVariables26[79];
  airIn.medium.phi = RealVariables26[80];
  airIn.'ports[1]'.m_flow = RealVariables26[81];
  airIn.'ports[1]'.p = RealVariables26[82];
  airIn.'ports[1]'.h_outflow = RealVariables26[83];
  airIn.'ports[1]'.'Xi_outflow[1]' = RealVariables26[84];
  airIn.m_flow_in = RealVariables26[85];
  airIn.T_in = RealVariables26[86];
  airIn.'X_in[1]' = RealVariables26[87];
  airIn.'X_in[2]' = RealVariables26[88];
  airOut.medium.p = RealVariables26[89];
  airOut.medium.'Xi[1]' = RealVariables26[90];
  airOut.medium.h = RealVariables26[91];
  airOut.medium.T = RealVariables26[92];
  airOut.medium.'X[1]' = RealVariables26[93];
  airOut.medium.state.p = RealVariables26[94];
  airOut.medium.state.T = RealVariables26[95];
  airOut.medium.state.'X[1]' = RealVariables26[96];
  airOut.medium.state.'X[2]' = RealVariables26[97];
  airOut.'ports[1]'.m_flow = RealVariables26[98];
  airOut.'ports[1]'.p = RealVariables26[99];
  airOut.'ports[1]'.'Xi_outflow[1]' = RealVariables26[100];
  cWaterIn.medium.p = RealVariables27[1];
  cWaterIn.medium.h = RealVariables27[2];
  cWaterIn.medium.T = RealVariables27[3];
  cWaterIn.medium.u = RealVariables27[4];
  cWaterIn.medium.state.p = RealVariables27[5];
  cWaterIn.medium.state.T = RealVariables27[6];
  cWaterIn.medium.T_degC = RealVariables27[7];
  cWaterIn.medium.p_bar = RealVariables27[8];
  cWaterIn.'ports[1]'.m_flow = RealVariables27[9];
  cWaterIn.'ports[1]'.p = RealVariables27[10];
  cWaterIn.'ports[1]'.h_outflow = RealVariables27[11];
  cWaterIn.m_flow_in = RealVariables27[12];
  cWaterIn.T_in = RealVariables27[13];
  cWaterOut.medium.p = RealVariables27[14];
  cWaterOut.medium.h = RealVariables27[15];
  cWaterOut.medium.T = RealVariables27[16];
  cWaterOut.medium.state.p = RealVariables27[17];
  cWaterOut.medium.state.T = RealVariables27[18];
  cWaterOut.'ports[1]'.m_flow = RealVariables27[19];
  cWaterOut.'ports[1]'.p = RealVariables27[20];
  T_airout.port.p = RealVariables27[21];
  T_airout.T = RealVariables27[22];
  T_CWaterout.port.p = RealVariables27[23];
  T_CWaterout.T = RealVariables27[24];
  T_floor.port.T = RealVariables27[25];
  T_floor.port.Q_flow = RealVariables27[26];
  T_ambient.port.T = RealVariables27[27];
  T_ambient.port.Q_flow = RealVariables27[28];
  T_ambient.T = RealVariables27[29];
  levelControl.level = RealVariables27[30];
  levelControl.m_outflow = RealVariables27[31];
  waterOverFlow1.medium.p = RealVariables27[32];
  waterOverFlow1.medium.state.p = RealVariables27[33];
  waterOverFlow1.medium.p_bar = RealVariables27[34];
  waterOverFlow1.'ports[1]'.m_flow = RealVariables27[35];
  waterOverFlow1.'ports[1]'.p = RealVariables27[36];
  waterOverFlow1.m_flow_in = RealVariables27[37];
  sampler.u = RealVariables27[38];
  sampler.y = RealVariables27[39];
  'system'.p_start = RealDependentParameters1[1];
  'system'.T_start = RealDependentParameters1[2];
  'system'.m_flow_nominal = RealDependentParameters1[3];
  pCWater2 = RealDependentParameters1[4];
  closedCTPressureDrop.hmax = RealDependentParameters1[5];
  closedCTPressureDrop.hmin = RealDependentParameters1[6];
  closedCTPressureDrop.L_basin = RealDependentParameters1[7];
  closedCTPressureDrop.L_char = RealDependentParameters1[8];
  closedCTPressureDrop.w = RealDependentParameters1[9];
  closedCTPressureDrop.e = RealDependentParameters1[10];
  closedCTPressureDrop.R_ext = RealDependentParameters1[11];
  closedCTPressureDrop.R_int = RealDependentParameters1[12];
  closedCTPressureDrop.mWaterIn = RealDependentParameters1[13];
  closedCTPressureDrop.pPumpedWater = RealDependentParameters1[14];
  closedCTPressureDrop.c = RealDependentParameters1[15];
  closedCTPressureDrop.n = RealDependentParameters1[16];
  closedCTPressureDrop.roughness = RealDependentParameters1[17];
  closedCTPressureDrop.a = RealDependentParameters1[18];
  closedCTPressureDrop.b = RealDependentParameters1[19];
  closedCTPressureDrop.d_a = RealDependentParameters1[20];
  closedCTPressureDrop.d_b = RealDependentParameters1[21];
  closedCTPressureDrop.C_iner = RealDependentParameters1[22];
  closedCTPressureDrop.Kfi = RealDependentParameters1[23];
  closedCTPressureDrop.hfi = RealDependentParameters1[24];
  closedCTPressureDrop.wfi = RealDependentParameters1[25];
  closedCTPressureDrop.lfi = RealDependentParameters1[26];
  closedCTPressureDrop.Afr = RealDependentParameters1[27];
  closedCTPressureDrop.TWater2_start = RealDependentParameters1[28];
  closedCTPressureDrop.TAir2_start = RealDependentParameters1[29];
  closedCTPressureDrop.H2_start = RealDependentParameters1[30];
  closedCTPressureDrop.TMaterial_start = RealDependentParameters1[31];
  closedCTPressureDrop.heatExchangerThroughReal.R_ext = RealDependentParameters1[32];
  closedCTPressureDrop.heatExchangerThroughReal.R_int = RealDependentParameters1[33];
  closedCTPressureDrop.heatExchangerThroughReal.c = RealDependentParameters1[34];
  closedCTPressureDrop.heatExchangerThroughReal.n = RealDependentParameters1[35];
  closedCTPressureDrop.heatExchangerThroughReal.roughness = RealDependentParameters1[36];
  closedCTPressureDrop.heatExchangerThroughReal.a = RealDependentParameters1[37];
  closedCTPressureDrop.heatExchangerThroughReal.b = RealDependentParameters1[38];
  closedCTPressureDrop.heatExchangerThroughReal.Kfi = RealDependentParameters1[39];
  closedCTPressureDrop.heatExchangerThroughReal.hfi = RealDependentParameters1[40];
  closedCTPressureDrop.heatExchangerThroughReal.wfi = RealDependentParameters1[41];
  closedCTPressureDrop.heatExchangerThroughReal.lfi = RealDependentParameters1[42];
  closedCTPressureDrop.heatExchangerThroughReal.Afr = RealDependentParameters1[43];
  closedCTPressureDrop.heatExchangerThroughReal.C_iner = RealDependentParameters1[44];
  closedCTPressureDrop.heatExchangerThroughReal.TWater2_start = RealDependentParameters1[45];
  closedCTPressureDrop.heatExchangerThroughReal.TAir2_start = RealDependentParameters1[46];
  closedCTPressureDrop.heatExchangerThroughReal.H2_start = RealDependentParameters1[47];
  closedCTPressureDrop.heatExchangerThroughReal.TMaterial_start = RealDependentParameters1[48];
  closedCTPressureDrop.heatExchangerThroughReal.port_a_water.m_flow = RealDependentParameters1[49];
  closedCTPressureDrop.heatExchangerThroughReal.closedHeatToAirPressureDrop.mWater1 = RealDependentParameters1[50];
  closedCTPressureDrop.heatExchangerThroughReal.closedHeatToAirPressureDrop.Kfi = RealDependentParameters1[51];
  closedCTPressureDrop.heatExchangerThroughReal.closedHeatToAirPressureDrop.hfi = RealDependentParameters1[52];
  closedCTPressureDrop.heatExchangerThroughReal.closedHeatToAirPressureDrop.wfi = RealDependentParameters1[53];
  closedCTPressureDrop.heatExchangerThroughReal.closedHeatToAirPressureDrop.lfi = RealDependentParameters1[54];
  closedCTPressureDrop.heatExchangerThroughReal.closedHeatToAirPressureDrop.Afr = RealDependentParameters1[55];
  closedCTPressureDrop.heatExchangerThroughReal.closedHeatToAirPressureDrop.c = RealDependentParameters1[56];
  closedCTPressureDrop.heatExchangerThroughReal.closedHeatToAirPressureDrop.n = RealDependentParameters1[57];
  closedCTPressureDrop.heatExchangerThroughReal.closedHeatToAirPressureDrop.pAmbient = RealDependentParameters1[58];
  closedCTPressureDrop.heatExchangerThroughReal.closedHeatToAirPressureDrop.TWater2_start = RealDependentParameters1[59];
  closedCTPressureDrop.heatExchangerThroughReal.closedHeatToAirPressureDrop.TAir2_start = RealDependentParameters1[60];
  closedCTPressureDrop.heatExchangerThroughReal.closedHeatToAirPressureDrop.H2_start = RealDependentParameters1[61];
  closedCTPressureDrop.heatExchangerThroughReal.closedHeatToAirPressureDrop.C_iner = RealDependentParameters1[62];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.nParallel = RealDependentParameters1[63];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.T_start = RealDependentParameters1[64];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.V = RealDependentParameters1[65];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.r_int = RealDependentParameters1[66];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.r_ext = RealDependentParameters1[67];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.A_annulus = RealDependentParameters1[68];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.alpha_node = RealDependentParameters1[69];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'rs[1]' = RealDependentParameters1[70];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'rs[2]' = RealDependentParameters1[71];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'rs_int[1,1,1]' = RealDependentParameters1[72];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'rs_int[1,2,1]' = RealDependentParameters1[73];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'rs_int[1,3,1]' = RealDependentParameters1[74];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'rs_int[1,4,1]' = RealDependentParameters1[75];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'rs_int[1,5,1]' = RealDependentParameters1[76];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'rs_int[1,6,1]' = RealDependentParameters1[77];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'rs_int[1,7,1]' = RealDependentParameters1[78];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'rs_int[1,8,1]' = RealDependentParameters1[79];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'rs_int[1,9,1]' = RealDependentParameters1[80];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'rs_int[1,10,1]' = RealDependentParameters1[81];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'rs_ext[1,1,1]' = RealDependentParameters1[82];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'rs_ext[1,2,1]' = RealDependentParameters1[83];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'rs_ext[1,3,1]' = RealDependentParameters1[84];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'rs_ext[1,4,1]' = RealDependentParameters1[85];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'rs_ext[1,5,1]' = RealDependentParameters1[86];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'rs_ext[1,6,1]' = RealDependentParameters1[87];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'rs_ext[1,7,1]' = RealDependentParameters1[88];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'rs_ext[1,8,1]' = RealDependentParameters1[89];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'rs_ext[1,9,1]' = RealDependentParameters1[90];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'rs_ext[1,10,1]' = RealDependentParameters1[91];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'rs_avg[1,1,1]' = RealDependentParameters1[92];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'rs_avg[1,2,1]' = RealDependentParameters1[93];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'rs_avg[1,3,1]' = RealDependentParameters1[94];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'rs_avg[1,4,1]' = RealDependentParameters1[95];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'rs_avg[1,5,1]' = RealDependentParameters1[96];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'rs_avg[1,6,1]' = RealDependentParameters1[97];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'rs_avg[1,7,1]' = RealDependentParameters1[98];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'rs_avg[1,8,1]' = RealDependentParameters1[99];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'rs_avg[1,9,1]' = RealDependentParameters1[100];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'rs_avg[1,10,1]' = RealDependentParameters2[1];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'arcs[1,1,1]' = RealDependentParameters2[2];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'arcs[1,2,1]' = RealDependentParameters2[3];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'arcs[1,3,1]' = RealDependentParameters2[4];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'arcs[1,4,1]' = RealDependentParameters2[5];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'arcs[1,5,1]' = RealDependentParameters2[6];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'arcs[1,6,1]' = RealDependentParameters2[7];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'arcs[1,7,1]' = RealDependentParameters2[8];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'arcs[1,8,1]' = RealDependentParameters2[9];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'arcs[1,9,1]' = RealDependentParameters2[10];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'arcs[1,10,1]' = RealDependentParameters2[11];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'As_annulus[1,1,1]' = RealDependentParameters2[12];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'As_annulus[1,2,1]' = RealDependentParameters2[13];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'As_annulus[1,3,1]' = RealDependentParameters2[14];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'As_annulus[1,4,1]' = RealDependentParameters2[15];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'As_annulus[1,5,1]' = RealDependentParameters2[16];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'As_annulus[1,6,1]' = RealDependentParameters2[17];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'As_annulus[1,7,1]' = RealDependentParameters2[18];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'As_annulus[1,8,1]' = RealDependentParameters2[19];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'As_annulus[1,9,1]' = RealDependentParameters2[20];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'As_annulus[1,10,1]' = RealDependentParameters2[21];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 1, 1]'.V = RealDependentParameters2[22];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 1, 1]'.thermalConductor_a_1.T_start = RealDependentParameters2[23];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 1, 1]'.thermalConductor_a_1.r_internal = RealDependentParameters2[24];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 1, 1]'.thermalConductor_a_1.r_external = RealDependentParameters2[25];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 1, 1]'.thermalConductor_a_1.L = RealDependentParameters2[26];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 1, 1]'.thermalConductor_a_1.alpha = RealDependentParameters2[27];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 1, 1]'.thermalConductor_b_1.T_start = RealDependentParameters2[28];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 1, 1]'.thermalConductor_b_1.r_internal = RealDependentParameters2[29];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 1, 1]'.thermalConductor_b_1.r_external = RealDependentParameters2[30];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 1, 1]'.thermalConductor_b_1.L = RealDependentParameters2[31];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 1, 1]'.thermalConductor_b_1.alpha = RealDependentParameters2[32];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 1, 1]'.thermalConductor_a_2.T_start = RealDependentParameters2[33];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 1, 1]'.thermalConductor_a_2.L = RealDependentParameters2[34];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 1, 1]'.thermalConductor_a_2.A = RealDependentParameters2[35];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 1, 1]'.thermalConductor_b_2.T_start = RealDependentParameters2[36];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 1, 1]'.thermalConductor_b_2.L = RealDependentParameters2[37];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 1, 1]'.thermalConductor_b_2.A = RealDependentParameters2[38];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 1, 1]'.thermalConductor_a_3.T_start = RealDependentParameters2[39];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 1, 1]'.thermalConductor_a_3.L = RealDependentParameters2[40];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 1, 1]'.thermalConductor_a_3.A = RealDependentParameters2[41];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 1, 1]'.thermalConductor_b_3.T_start = RealDependentParameters2[42];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 1, 1]'.thermalConductor_b_3.L = RealDependentParameters2[43];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 1, 1]'.thermalConductor_b_3.A = RealDependentParameters2[44];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 1, 1]'.heatCapacitor.T_start = RealDependentParameters2[45];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 1, 1]'.heatCapacitor.V = RealDependentParameters2[46];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 1, 1]'.heatCapacitor.m = RealDependentParameters2[47];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 1, 1]'.heatCapacitor.der_T_start = RealDependentParameters2[48];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 2, 1]'.V = RealDependentParameters2[49];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 2, 1]'.thermalConductor_a_1.T_start = RealDependentParameters2[50];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 2, 1]'.thermalConductor_a_1.r_internal = RealDependentParameters2[51];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 2, 1]'.thermalConductor_a_1.r_external = RealDependentParameters2[52];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 2, 1]'.thermalConductor_a_1.L = RealDependentParameters2[53];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 2, 1]'.thermalConductor_a_1.alpha = RealDependentParameters2[54];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 2, 1]'.thermalConductor_b_1.T_start = RealDependentParameters2[55];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 2, 1]'.thermalConductor_b_1.r_internal = RealDependentParameters2[56];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 2, 1]'.thermalConductor_b_1.r_external = RealDependentParameters2[57];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 2, 1]'.thermalConductor_b_1.L = RealDependentParameters2[58];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 2, 1]'.thermalConductor_b_1.alpha = RealDependentParameters2[59];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 2, 1]'.thermalConductor_a_2.T_start = RealDependentParameters2[60];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 2, 1]'.thermalConductor_a_2.L = RealDependentParameters2[61];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 2, 1]'.thermalConductor_a_2.A = RealDependentParameters2[62];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 2, 1]'.thermalConductor_b_2.T_start = RealDependentParameters2[63];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 2, 1]'.thermalConductor_b_2.L = RealDependentParameters2[64];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 2, 1]'.thermalConductor_b_2.A = RealDependentParameters2[65];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 2, 1]'.thermalConductor_a_3.T_start = RealDependentParameters2[66];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 2, 1]'.thermalConductor_a_3.L = RealDependentParameters2[67];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 2, 1]'.thermalConductor_a_3.A = RealDependentParameters2[68];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 2, 1]'.thermalConductor_b_3.T_start = RealDependentParameters2[69];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 2, 1]'.thermalConductor_b_3.L = RealDependentParameters2[70];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 2, 1]'.thermalConductor_b_3.A = RealDependentParameters2[71];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 2, 1]'.heatCapacitor.T_start = RealDependentParameters2[72];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 2, 1]'.heatCapacitor.V = RealDependentParameters2[73];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 2, 1]'.heatCapacitor.m = RealDependentParameters2[74];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 2, 1]'.heatCapacitor.der_T_start = RealDependentParameters2[75];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 3, 1]'.V = RealDependentParameters2[76];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 3, 1]'.thermalConductor_a_1.T_start = RealDependentParameters2[77];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 3, 1]'.thermalConductor_a_1.r_internal = RealDependentParameters2[78];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 3, 1]'.thermalConductor_a_1.r_external = RealDependentParameters2[79];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 3, 1]'.thermalConductor_a_1.L = RealDependentParameters2[80];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 3, 1]'.thermalConductor_a_1.alpha = RealDependentParameters2[81];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 3, 1]'.thermalConductor_b_1.T_start = RealDependentParameters2[82];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 3, 1]'.thermalConductor_b_1.r_internal = RealDependentParameters2[83];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 3, 1]'.thermalConductor_b_1.r_external = RealDependentParameters2[84];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 3, 1]'.thermalConductor_b_1.L = RealDependentParameters2[85];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 3, 1]'.thermalConductor_b_1.alpha = RealDependentParameters2[86];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 3, 1]'.thermalConductor_a_2.T_start = RealDependentParameters2[87];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 3, 1]'.thermalConductor_a_2.L = RealDependentParameters2[88];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 3, 1]'.thermalConductor_a_2.A = RealDependentParameters2[89];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 3, 1]'.thermalConductor_b_2.T_start = RealDependentParameters2[90];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 3, 1]'.thermalConductor_b_2.L = RealDependentParameters2[91];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 3, 1]'.thermalConductor_b_2.A = RealDependentParameters2[92];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 3, 1]'.thermalConductor_a_3.T_start = RealDependentParameters2[93];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 3, 1]'.thermalConductor_a_3.L = RealDependentParameters2[94];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 3, 1]'.thermalConductor_a_3.A = RealDependentParameters2[95];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 3, 1]'.thermalConductor_b_3.T_start = RealDependentParameters2[96];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 3, 1]'.thermalConductor_b_3.L = RealDependentParameters2[97];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 3, 1]'.thermalConductor_b_3.A = RealDependentParameters2[98];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 3, 1]'.heatCapacitor.T_start = RealDependentParameters2[99];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 3, 1]'.heatCapacitor.V = RealDependentParameters2[100];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 3, 1]'.heatCapacitor.m = RealDependentParameters3[1];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 3, 1]'.heatCapacitor.der_T_start = RealDependentParameters3[2];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 4, 1]'.V = RealDependentParameters3[3];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 4, 1]'.thermalConductor_a_1.T_start = RealDependentParameters3[4];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 4, 1]'.thermalConductor_a_1.r_internal = RealDependentParameters3[5];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 4, 1]'.thermalConductor_a_1.r_external = RealDependentParameters3[6];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 4, 1]'.thermalConductor_a_1.L = RealDependentParameters3[7];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 4, 1]'.thermalConductor_a_1.alpha = RealDependentParameters3[8];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 4, 1]'.thermalConductor_b_1.T_start = RealDependentParameters3[9];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 4, 1]'.thermalConductor_b_1.r_internal = RealDependentParameters3[10];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 4, 1]'.thermalConductor_b_1.r_external = RealDependentParameters3[11];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 4, 1]'.thermalConductor_b_1.L = RealDependentParameters3[12];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 4, 1]'.thermalConductor_b_1.alpha = RealDependentParameters3[13];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 4, 1]'.thermalConductor_a_2.T_start = RealDependentParameters3[14];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 4, 1]'.thermalConductor_a_2.L = RealDependentParameters3[15];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 4, 1]'.thermalConductor_a_2.A = RealDependentParameters3[16];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 4, 1]'.thermalConductor_b_2.T_start = RealDependentParameters3[17];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 4, 1]'.thermalConductor_b_2.L = RealDependentParameters3[18];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 4, 1]'.thermalConductor_b_2.A = RealDependentParameters3[19];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 4, 1]'.thermalConductor_a_3.T_start = RealDependentParameters3[20];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 4, 1]'.thermalConductor_a_3.L = RealDependentParameters3[21];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 4, 1]'.thermalConductor_a_3.A = RealDependentParameters3[22];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 4, 1]'.thermalConductor_b_3.T_start = RealDependentParameters3[23];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 4, 1]'.thermalConductor_b_3.L = RealDependentParameters3[24];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 4, 1]'.thermalConductor_b_3.A = RealDependentParameters3[25];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 4, 1]'.heatCapacitor.T_start = RealDependentParameters3[26];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 4, 1]'.heatCapacitor.V = RealDependentParameters3[27];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 4, 1]'.heatCapacitor.m = RealDependentParameters3[28];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 4, 1]'.heatCapacitor.der_T_start = RealDependentParameters3[29];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 5, 1]'.V = RealDependentParameters3[30];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 5, 1]'.thermalConductor_a_1.T_start = RealDependentParameters3[31];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 5, 1]'.thermalConductor_a_1.r_internal = RealDependentParameters3[32];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 5, 1]'.thermalConductor_a_1.r_external = RealDependentParameters3[33];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 5, 1]'.thermalConductor_a_1.L = RealDependentParameters3[34];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 5, 1]'.thermalConductor_a_1.alpha = RealDependentParameters3[35];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 5, 1]'.thermalConductor_b_1.T_start = RealDependentParameters3[36];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 5, 1]'.thermalConductor_b_1.r_internal = RealDependentParameters3[37];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 5, 1]'.thermalConductor_b_1.r_external = RealDependentParameters3[38];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 5, 1]'.thermalConductor_b_1.L = RealDependentParameters3[39];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 5, 1]'.thermalConductor_b_1.alpha = RealDependentParameters3[40];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 5, 1]'.thermalConductor_a_2.T_start = RealDependentParameters3[41];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 5, 1]'.thermalConductor_a_2.L = RealDependentParameters3[42];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 5, 1]'.thermalConductor_a_2.A = RealDependentParameters3[43];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 5, 1]'.thermalConductor_b_2.T_start = RealDependentParameters3[44];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 5, 1]'.thermalConductor_b_2.L = RealDependentParameters3[45];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 5, 1]'.thermalConductor_b_2.A = RealDependentParameters3[46];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 5, 1]'.thermalConductor_a_3.T_start = RealDependentParameters3[47];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 5, 1]'.thermalConductor_a_3.L = RealDependentParameters3[48];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 5, 1]'.thermalConductor_a_3.A = RealDependentParameters3[49];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 5, 1]'.thermalConductor_b_3.T_start = RealDependentParameters3[50];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 5, 1]'.thermalConductor_b_3.L = RealDependentParameters3[51];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 5, 1]'.thermalConductor_b_3.A = RealDependentParameters3[52];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 5, 1]'.heatCapacitor.T_start = RealDependentParameters3[53];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 5, 1]'.heatCapacitor.V = RealDependentParameters3[54];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 5, 1]'.heatCapacitor.m = RealDependentParameters3[55];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 5, 1]'.heatCapacitor.der_T_start = RealDependentParameters3[56];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 6, 1]'.V = RealDependentParameters3[57];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 6, 1]'.thermalConductor_a_1.T_start = RealDependentParameters3[58];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 6, 1]'.thermalConductor_a_1.r_internal = RealDependentParameters3[59];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 6, 1]'.thermalConductor_a_1.r_external = RealDependentParameters3[60];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 6, 1]'.thermalConductor_a_1.L = RealDependentParameters3[61];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 6, 1]'.thermalConductor_a_1.alpha = RealDependentParameters3[62];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 6, 1]'.thermalConductor_b_1.T_start = RealDependentParameters3[63];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 6, 1]'.thermalConductor_b_1.r_internal = RealDependentParameters3[64];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 6, 1]'.thermalConductor_b_1.r_external = RealDependentParameters3[65];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 6, 1]'.thermalConductor_b_1.L = RealDependentParameters3[66];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 6, 1]'.thermalConductor_b_1.alpha = RealDependentParameters3[67];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 6, 1]'.thermalConductor_a_2.T_start = RealDependentParameters3[68];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 6, 1]'.thermalConductor_a_2.L = RealDependentParameters3[69];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 6, 1]'.thermalConductor_a_2.A = RealDependentParameters3[70];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 6, 1]'.thermalConductor_b_2.T_start = RealDependentParameters3[71];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 6, 1]'.thermalConductor_b_2.L = RealDependentParameters3[72];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 6, 1]'.thermalConductor_b_2.A = RealDependentParameters3[73];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 6, 1]'.thermalConductor_a_3.T_start = RealDependentParameters3[74];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 6, 1]'.thermalConductor_a_3.L = RealDependentParameters3[75];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 6, 1]'.thermalConductor_a_3.A = RealDependentParameters3[76];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 6, 1]'.thermalConductor_b_3.T_start = RealDependentParameters3[77];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 6, 1]'.thermalConductor_b_3.L = RealDependentParameters3[78];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 6, 1]'.thermalConductor_b_3.A = RealDependentParameters3[79];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 6, 1]'.heatCapacitor.T_start = RealDependentParameters3[80];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 6, 1]'.heatCapacitor.V = RealDependentParameters3[81];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 6, 1]'.heatCapacitor.m = RealDependentParameters3[82];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 6, 1]'.heatCapacitor.der_T_start = RealDependentParameters3[83];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 7, 1]'.V = RealDependentParameters3[84];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 7, 1]'.thermalConductor_a_1.T_start = RealDependentParameters3[85];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 7, 1]'.thermalConductor_a_1.r_internal = RealDependentParameters3[86];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 7, 1]'.thermalConductor_a_1.r_external = RealDependentParameters3[87];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 7, 1]'.thermalConductor_a_1.L = RealDependentParameters3[88];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 7, 1]'.thermalConductor_a_1.alpha = RealDependentParameters3[89];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 7, 1]'.thermalConductor_b_1.T_start = RealDependentParameters3[90];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 7, 1]'.thermalConductor_b_1.r_internal = RealDependentParameters3[91];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 7, 1]'.thermalConductor_b_1.r_external = RealDependentParameters3[92];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 7, 1]'.thermalConductor_b_1.L = RealDependentParameters3[93];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 7, 1]'.thermalConductor_b_1.alpha = RealDependentParameters3[94];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 7, 1]'.thermalConductor_a_2.T_start = RealDependentParameters3[95];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 7, 1]'.thermalConductor_a_2.L = RealDependentParameters3[96];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 7, 1]'.thermalConductor_a_2.A = RealDependentParameters3[97];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 7, 1]'.thermalConductor_b_2.T_start = RealDependentParameters3[98];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 7, 1]'.thermalConductor_b_2.L = RealDependentParameters3[99];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 7, 1]'.thermalConductor_b_2.A = RealDependentParameters3[100];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 7, 1]'.thermalConductor_a_3.T_start = RealDependentParameters4[1];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 7, 1]'.thermalConductor_a_3.L = RealDependentParameters4[2];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 7, 1]'.thermalConductor_a_3.A = RealDependentParameters4[3];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 7, 1]'.thermalConductor_b_3.T_start = RealDependentParameters4[4];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 7, 1]'.thermalConductor_b_3.L = RealDependentParameters4[5];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 7, 1]'.thermalConductor_b_3.A = RealDependentParameters4[6];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 7, 1]'.heatCapacitor.T_start = RealDependentParameters4[7];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 7, 1]'.heatCapacitor.V = RealDependentParameters4[8];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 7, 1]'.heatCapacitor.m = RealDependentParameters4[9];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 7, 1]'.heatCapacitor.der_T_start = RealDependentParameters4[10];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 8, 1]'.V = RealDependentParameters4[11];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 8, 1]'.thermalConductor_a_1.T_start = RealDependentParameters4[12];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 8, 1]'.thermalConductor_a_1.r_internal = RealDependentParameters4[13];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 8, 1]'.thermalConductor_a_1.r_external = RealDependentParameters4[14];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 8, 1]'.thermalConductor_a_1.L = RealDependentParameters4[15];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 8, 1]'.thermalConductor_a_1.alpha = RealDependentParameters4[16];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 8, 1]'.thermalConductor_b_1.T_start = RealDependentParameters4[17];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 8, 1]'.thermalConductor_b_1.r_internal = RealDependentParameters4[18];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 8, 1]'.thermalConductor_b_1.r_external = RealDependentParameters4[19];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 8, 1]'.thermalConductor_b_1.L = RealDependentParameters4[20];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 8, 1]'.thermalConductor_b_1.alpha = RealDependentParameters4[21];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 8, 1]'.thermalConductor_a_2.T_start = RealDependentParameters4[22];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 8, 1]'.thermalConductor_a_2.L = RealDependentParameters4[23];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 8, 1]'.thermalConductor_a_2.A = RealDependentParameters4[24];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 8, 1]'.thermalConductor_b_2.T_start = RealDependentParameters4[25];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 8, 1]'.thermalConductor_b_2.L = RealDependentParameters4[26];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 8, 1]'.thermalConductor_b_2.A = RealDependentParameters4[27];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 8, 1]'.thermalConductor_a_3.T_start = RealDependentParameters4[28];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 8, 1]'.thermalConductor_a_3.L = RealDependentParameters4[29];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 8, 1]'.thermalConductor_a_3.A = RealDependentParameters4[30];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 8, 1]'.thermalConductor_b_3.T_start = RealDependentParameters4[31];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 8, 1]'.thermalConductor_b_3.L = RealDependentParameters4[32];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 8, 1]'.thermalConductor_b_3.A = RealDependentParameters4[33];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 8, 1]'.heatCapacitor.T_start = RealDependentParameters4[34];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 8, 1]'.heatCapacitor.V = RealDependentParameters4[35];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 8, 1]'.heatCapacitor.m = RealDependentParameters4[36];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 8, 1]'.heatCapacitor.der_T_start = RealDependentParameters4[37];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 9, 1]'.V = RealDependentParameters4[38];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 9, 1]'.thermalConductor_a_1.T_start = RealDependentParameters4[39];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 9, 1]'.thermalConductor_a_1.r_internal = RealDependentParameters4[40];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 9, 1]'.thermalConductor_a_1.r_external = RealDependentParameters4[41];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 9, 1]'.thermalConductor_a_1.L = RealDependentParameters4[42];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 9, 1]'.thermalConductor_a_1.alpha = RealDependentParameters4[43];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 9, 1]'.thermalConductor_b_1.T_start = RealDependentParameters4[44];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 9, 1]'.thermalConductor_b_1.r_internal = RealDependentParameters4[45];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 9, 1]'.thermalConductor_b_1.r_external = RealDependentParameters4[46];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 9, 1]'.thermalConductor_b_1.L = RealDependentParameters4[47];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 9, 1]'.thermalConductor_b_1.alpha = RealDependentParameters4[48];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 9, 1]'.thermalConductor_a_2.T_start = RealDependentParameters4[49];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 9, 1]'.thermalConductor_a_2.L = RealDependentParameters4[50];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 9, 1]'.thermalConductor_a_2.A = RealDependentParameters4[51];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 9, 1]'.thermalConductor_b_2.T_start = RealDependentParameters4[52];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 9, 1]'.thermalConductor_b_2.L = RealDependentParameters4[53];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 9, 1]'.thermalConductor_b_2.A = RealDependentParameters4[54];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 9, 1]'.thermalConductor_a_3.T_start = RealDependentParameters4[55];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 9, 1]'.thermalConductor_a_3.L = RealDependentParameters4[56];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 9, 1]'.thermalConductor_a_3.A = RealDependentParameters4[57];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 9, 1]'.thermalConductor_b_3.T_start = RealDependentParameters4[58];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 9, 1]'.thermalConductor_b_3.L = RealDependentParameters4[59];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 9, 1]'.thermalConductor_b_3.A = RealDependentParameters4[60];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 9, 1]'.heatCapacitor.T_start = RealDependentParameters4[61];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 9, 1]'.heatCapacitor.V = RealDependentParameters4[62];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 9, 1]'.heatCapacitor.m = RealDependentParameters4[63];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 9, 1]'.heatCapacitor.der_T_start = RealDependentParameters4[64];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 10, 1]'.V = RealDependentParameters4[65];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 10, 1]'.thermalConductor_a_1.T_start = RealDependentParameters4[66];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 10, 1]'.thermalConductor_a_1.r_internal = RealDependentParameters4[67];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 10, 1]'.thermalConductor_a_1.r_external = RealDependentParameters4[68];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 10, 1]'.thermalConductor_a_1.L = RealDependentParameters4[69];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 10, 1]'.thermalConductor_a_1.alpha = RealDependentParameters4[70];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 10, 1]'.thermalConductor_b_1.T_start = RealDependentParameters4[71];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 10, 1]'.thermalConductor_b_1.r_internal = RealDependentParameters4[72];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 10, 1]'.thermalConductor_b_1.r_external = RealDependentParameters4[73];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 10, 1]'.thermalConductor_b_1.L = RealDependentParameters4[74];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 10, 1]'.thermalConductor_b_1.alpha = RealDependentParameters4[75];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 10, 1]'.thermalConductor_a_2.T_start = RealDependentParameters4[76];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 10, 1]'.thermalConductor_a_2.L = RealDependentParameters4[77];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 10, 1]'.thermalConductor_a_2.A = RealDependentParameters4[78];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 10, 1]'.thermalConductor_b_2.T_start = RealDependentParameters4[79];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 10, 1]'.thermalConductor_b_2.L = RealDependentParameters4[80];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 10, 1]'.thermalConductor_b_2.A = RealDependentParameters4[81];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 10, 1]'.thermalConductor_a_3.T_start = RealDependentParameters4[82];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 10, 1]'.thermalConductor_a_3.L = RealDependentParameters4[83];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 10, 1]'.thermalConductor_a_3.A = RealDependentParameters4[84];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 10, 1]'.thermalConductor_b_3.T_start = RealDependentParameters4[85];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 10, 1]'.thermalConductor_b_3.L = RealDependentParameters4[86];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 10, 1]'.thermalConductor_b_3.A = RealDependentParameters4[87];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 10, 1]'.heatCapacitor.T_start = RealDependentParameters4[88];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 10, 1]'.heatCapacitor.V = RealDependentParameters4[89];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 10, 1]'.heatCapacitor.m = RealDependentParameters4[90];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[1]'.'thermalNode[1, 10, 1]'.heatCapacitor.der_T_start = RealDependentParameters4[91];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.nParallel = RealDependentParameters4[92];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.T_start = RealDependentParameters4[93];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.V = RealDependentParameters4[94];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.r_int = RealDependentParameters4[95];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.r_ext = RealDependentParameters4[96];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.A_annulus = RealDependentParameters4[97];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.alpha_node = RealDependentParameters4[98];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'rs[1]' = RealDependentParameters4[99];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'rs[2]' = RealDependentParameters4[100];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'rs_int[1,1,1]' = RealDependentParameters5[1];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'rs_int[1,2,1]' = RealDependentParameters5[2];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'rs_int[1,3,1]' = RealDependentParameters5[3];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'rs_int[1,4,1]' = RealDependentParameters5[4];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'rs_int[1,5,1]' = RealDependentParameters5[5];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'rs_int[1,6,1]' = RealDependentParameters5[6];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'rs_int[1,7,1]' = RealDependentParameters5[7];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'rs_int[1,8,1]' = RealDependentParameters5[8];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'rs_int[1,9,1]' = RealDependentParameters5[9];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'rs_int[1,10,1]' = RealDependentParameters5[10];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'rs_ext[1,1,1]' = RealDependentParameters5[11];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'rs_ext[1,2,1]' = RealDependentParameters5[12];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'rs_ext[1,3,1]' = RealDependentParameters5[13];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'rs_ext[1,4,1]' = RealDependentParameters5[14];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'rs_ext[1,5,1]' = RealDependentParameters5[15];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'rs_ext[1,6,1]' = RealDependentParameters5[16];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'rs_ext[1,7,1]' = RealDependentParameters5[17];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'rs_ext[1,8,1]' = RealDependentParameters5[18];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'rs_ext[1,9,1]' = RealDependentParameters5[19];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'rs_ext[1,10,1]' = RealDependentParameters5[20];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'rs_avg[1,1,1]' = RealDependentParameters5[21];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'rs_avg[1,2,1]' = RealDependentParameters5[22];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'rs_avg[1,3,1]' = RealDependentParameters5[23];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'rs_avg[1,4,1]' = RealDependentParameters5[24];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'rs_avg[1,5,1]' = RealDependentParameters5[25];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'rs_avg[1,6,1]' = RealDependentParameters5[26];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'rs_avg[1,7,1]' = RealDependentParameters5[27];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'rs_avg[1,8,1]' = RealDependentParameters5[28];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'rs_avg[1,9,1]' = RealDependentParameters5[29];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'rs_avg[1,10,1]' = RealDependentParameters5[30];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'arcs[1,1,1]' = RealDependentParameters5[31];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'arcs[1,2,1]' = RealDependentParameters5[32];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'arcs[1,3,1]' = RealDependentParameters5[33];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'arcs[1,4,1]' = RealDependentParameters5[34];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'arcs[1,5,1]' = RealDependentParameters5[35];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'arcs[1,6,1]' = RealDependentParameters5[36];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'arcs[1,7,1]' = RealDependentParameters5[37];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'arcs[1,8,1]' = RealDependentParameters5[38];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'arcs[1,9,1]' = RealDependentParameters5[39];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'arcs[1,10,1]' = RealDependentParameters5[40];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'As_annulus[1,1,1]' = RealDependentParameters5[41];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'As_annulus[1,2,1]' = RealDependentParameters5[42];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'As_annulus[1,3,1]' = RealDependentParameters5[43];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'As_annulus[1,4,1]' = RealDependentParameters5[44];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'As_annulus[1,5,1]' = RealDependentParameters5[45];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'As_annulus[1,6,1]' = RealDependentParameters5[46];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'As_annulus[1,7,1]' = RealDependentParameters5[47];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'As_annulus[1,8,1]' = RealDependentParameters5[48];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'As_annulus[1,9,1]' = RealDependentParameters5[49];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'As_annulus[1,10,1]' = RealDependentParameters5[50];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 1, 1]'.V = RealDependentParameters5[51];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 1, 1]'.thermalConductor_a_1.T_start = RealDependentParameters5[52];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 1, 1]'.thermalConductor_a_1.r_internal = RealDependentParameters5[53];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 1, 1]'.thermalConductor_a_1.r_external = RealDependentParameters5[54];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 1, 1]'.thermalConductor_a_1.L = RealDependentParameters5[55];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 1, 1]'.thermalConductor_a_1.alpha = RealDependentParameters5[56];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 1, 1]'.thermalConductor_b_1.T_start = RealDependentParameters5[57];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 1, 1]'.thermalConductor_b_1.r_internal = RealDependentParameters5[58];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 1, 1]'.thermalConductor_b_1.r_external = RealDependentParameters5[59];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 1, 1]'.thermalConductor_b_1.L = RealDependentParameters5[60];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 1, 1]'.thermalConductor_b_1.alpha = RealDependentParameters5[61];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 1, 1]'.thermalConductor_a_2.T_start = RealDependentParameters5[62];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 1, 1]'.thermalConductor_a_2.L = RealDependentParameters5[63];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 1, 1]'.thermalConductor_a_2.A = RealDependentParameters5[64];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 1, 1]'.thermalConductor_b_2.T_start = RealDependentParameters5[65];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 1, 1]'.thermalConductor_b_2.L = RealDependentParameters5[66];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 1, 1]'.thermalConductor_b_2.A = RealDependentParameters5[67];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 1, 1]'.thermalConductor_a_3.T_start = RealDependentParameters5[68];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 1, 1]'.thermalConductor_a_3.L = RealDependentParameters5[69];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 1, 1]'.thermalConductor_a_3.A = RealDependentParameters5[70];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 1, 1]'.thermalConductor_b_3.T_start = RealDependentParameters5[71];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 1, 1]'.thermalConductor_b_3.L = RealDependentParameters5[72];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 1, 1]'.thermalConductor_b_3.A = RealDependentParameters5[73];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 1, 1]'.heatCapacitor.T_start = RealDependentParameters5[74];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 1, 1]'.heatCapacitor.V = RealDependentParameters5[75];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 1, 1]'.heatCapacitor.m = RealDependentParameters5[76];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 1, 1]'.heatCapacitor.der_T_start = RealDependentParameters5[77];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 2, 1]'.V = RealDependentParameters5[78];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 2, 1]'.thermalConductor_a_1.T_start = RealDependentParameters5[79];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 2, 1]'.thermalConductor_a_1.r_internal = RealDependentParameters5[80];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 2, 1]'.thermalConductor_a_1.r_external = RealDependentParameters5[81];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 2, 1]'.thermalConductor_a_1.L = RealDependentParameters5[82];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 2, 1]'.thermalConductor_a_1.alpha = RealDependentParameters5[83];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 2, 1]'.thermalConductor_b_1.T_start = RealDependentParameters5[84];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 2, 1]'.thermalConductor_b_1.r_internal = RealDependentParameters5[85];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 2, 1]'.thermalConductor_b_1.r_external = RealDependentParameters5[86];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 2, 1]'.thermalConductor_b_1.L = RealDependentParameters5[87];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 2, 1]'.thermalConductor_b_1.alpha = RealDependentParameters5[88];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 2, 1]'.thermalConductor_a_2.T_start = RealDependentParameters5[89];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 2, 1]'.thermalConductor_a_2.L = RealDependentParameters5[90];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 2, 1]'.thermalConductor_a_2.A = RealDependentParameters5[91];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 2, 1]'.thermalConductor_b_2.T_start = RealDependentParameters5[92];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 2, 1]'.thermalConductor_b_2.L = RealDependentParameters5[93];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 2, 1]'.thermalConductor_b_2.A = RealDependentParameters5[94];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 2, 1]'.thermalConductor_a_3.T_start = RealDependentParameters5[95];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 2, 1]'.thermalConductor_a_3.L = RealDependentParameters5[96];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 2, 1]'.thermalConductor_a_3.A = RealDependentParameters5[97];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 2, 1]'.thermalConductor_b_3.T_start = RealDependentParameters5[98];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 2, 1]'.thermalConductor_b_3.L = RealDependentParameters5[99];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 2, 1]'.thermalConductor_b_3.A = RealDependentParameters5[100];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 2, 1]'.heatCapacitor.T_start = RealDependentParameters6[1];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 2, 1]'.heatCapacitor.V = RealDependentParameters6[2];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 2, 1]'.heatCapacitor.m = RealDependentParameters6[3];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 2, 1]'.heatCapacitor.der_T_start = RealDependentParameters6[4];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 3, 1]'.V = RealDependentParameters6[5];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 3, 1]'.thermalConductor_a_1.T_start = RealDependentParameters6[6];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 3, 1]'.thermalConductor_a_1.r_internal = RealDependentParameters6[7];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 3, 1]'.thermalConductor_a_1.r_external = RealDependentParameters6[8];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 3, 1]'.thermalConductor_a_1.L = RealDependentParameters6[9];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 3, 1]'.thermalConductor_a_1.alpha = RealDependentParameters6[10];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 3, 1]'.thermalConductor_b_1.T_start = RealDependentParameters6[11];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 3, 1]'.thermalConductor_b_1.r_internal = RealDependentParameters6[12];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 3, 1]'.thermalConductor_b_1.r_external = RealDependentParameters6[13];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 3, 1]'.thermalConductor_b_1.L = RealDependentParameters6[14];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 3, 1]'.thermalConductor_b_1.alpha = RealDependentParameters6[15];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 3, 1]'.thermalConductor_a_2.T_start = RealDependentParameters6[16];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 3, 1]'.thermalConductor_a_2.L = RealDependentParameters6[17];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 3, 1]'.thermalConductor_a_2.A = RealDependentParameters6[18];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 3, 1]'.thermalConductor_b_2.T_start = RealDependentParameters6[19];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 3, 1]'.thermalConductor_b_2.L = RealDependentParameters6[20];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 3, 1]'.thermalConductor_b_2.A = RealDependentParameters6[21];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 3, 1]'.thermalConductor_a_3.T_start = RealDependentParameters6[22];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 3, 1]'.thermalConductor_a_3.L = RealDependentParameters6[23];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 3, 1]'.thermalConductor_a_3.A = RealDependentParameters6[24];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 3, 1]'.thermalConductor_b_3.T_start = RealDependentParameters6[25];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 3, 1]'.thermalConductor_b_3.L = RealDependentParameters6[26];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 3, 1]'.thermalConductor_b_3.A = RealDependentParameters6[27];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 3, 1]'.heatCapacitor.T_start = RealDependentParameters6[28];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 3, 1]'.heatCapacitor.V = RealDependentParameters6[29];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 3, 1]'.heatCapacitor.m = RealDependentParameters6[30];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 3, 1]'.heatCapacitor.der_T_start = RealDependentParameters6[31];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 4, 1]'.V = RealDependentParameters6[32];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 4, 1]'.thermalConductor_a_1.T_start = RealDependentParameters6[33];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 4, 1]'.thermalConductor_a_1.r_internal = RealDependentParameters6[34];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 4, 1]'.thermalConductor_a_1.r_external = RealDependentParameters6[35];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 4, 1]'.thermalConductor_a_1.L = RealDependentParameters6[36];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 4, 1]'.thermalConductor_a_1.alpha = RealDependentParameters6[37];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 4, 1]'.thermalConductor_b_1.T_start = RealDependentParameters6[38];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 4, 1]'.thermalConductor_b_1.r_internal = RealDependentParameters6[39];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 4, 1]'.thermalConductor_b_1.r_external = RealDependentParameters6[40];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 4, 1]'.thermalConductor_b_1.L = RealDependentParameters6[41];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 4, 1]'.thermalConductor_b_1.alpha = RealDependentParameters6[42];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 4, 1]'.thermalConductor_a_2.T_start = RealDependentParameters6[43];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 4, 1]'.thermalConductor_a_2.L = RealDependentParameters6[44];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 4, 1]'.thermalConductor_a_2.A = RealDependentParameters6[45];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 4, 1]'.thermalConductor_b_2.T_start = RealDependentParameters6[46];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 4, 1]'.thermalConductor_b_2.L = RealDependentParameters6[47];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 4, 1]'.thermalConductor_b_2.A = RealDependentParameters6[48];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 4, 1]'.thermalConductor_a_3.T_start = RealDependentParameters6[49];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 4, 1]'.thermalConductor_a_3.L = RealDependentParameters6[50];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 4, 1]'.thermalConductor_a_3.A = RealDependentParameters6[51];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 4, 1]'.thermalConductor_b_3.T_start = RealDependentParameters6[52];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 4, 1]'.thermalConductor_b_3.L = RealDependentParameters6[53];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 4, 1]'.thermalConductor_b_3.A = RealDependentParameters6[54];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 4, 1]'.heatCapacitor.T_start = RealDependentParameters6[55];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 4, 1]'.heatCapacitor.V = RealDependentParameters6[56];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 4, 1]'.heatCapacitor.m = RealDependentParameters6[57];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 4, 1]'.heatCapacitor.der_T_start = RealDependentParameters6[58];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 5, 1]'.V = RealDependentParameters6[59];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 5, 1]'.thermalConductor_a_1.T_start = RealDependentParameters6[60];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 5, 1]'.thermalConductor_a_1.r_internal = RealDependentParameters6[61];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 5, 1]'.thermalConductor_a_1.r_external = RealDependentParameters6[62];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 5, 1]'.thermalConductor_a_1.L = RealDependentParameters6[63];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 5, 1]'.thermalConductor_a_1.alpha = RealDependentParameters6[64];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 5, 1]'.thermalConductor_b_1.T_start = RealDependentParameters6[65];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 5, 1]'.thermalConductor_b_1.r_internal = RealDependentParameters6[66];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 5, 1]'.thermalConductor_b_1.r_external = RealDependentParameters6[67];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 5, 1]'.thermalConductor_b_1.L = RealDependentParameters6[68];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 5, 1]'.thermalConductor_b_1.alpha = RealDependentParameters6[69];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 5, 1]'.thermalConductor_a_2.T_start = RealDependentParameters6[70];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 5, 1]'.thermalConductor_a_2.L = RealDependentParameters6[71];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 5, 1]'.thermalConductor_a_2.A = RealDependentParameters6[72];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 5, 1]'.thermalConductor_b_2.T_start = RealDependentParameters6[73];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 5, 1]'.thermalConductor_b_2.L = RealDependentParameters6[74];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 5, 1]'.thermalConductor_b_2.A = RealDependentParameters6[75];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 5, 1]'.thermalConductor_a_3.T_start = RealDependentParameters6[76];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 5, 1]'.thermalConductor_a_3.L = RealDependentParameters6[77];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 5, 1]'.thermalConductor_a_3.A = RealDependentParameters6[78];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 5, 1]'.thermalConductor_b_3.T_start = RealDependentParameters6[79];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 5, 1]'.thermalConductor_b_3.L = RealDependentParameters6[80];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 5, 1]'.thermalConductor_b_3.A = RealDependentParameters6[81];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 5, 1]'.heatCapacitor.T_start = RealDependentParameters6[82];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 5, 1]'.heatCapacitor.V = RealDependentParameters6[83];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 5, 1]'.heatCapacitor.m = RealDependentParameters6[84];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 5, 1]'.heatCapacitor.der_T_start = RealDependentParameters6[85];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 6, 1]'.V = RealDependentParameters6[86];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 6, 1]'.thermalConductor_a_1.T_start = RealDependentParameters6[87];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 6, 1]'.thermalConductor_a_1.r_internal = RealDependentParameters6[88];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 6, 1]'.thermalConductor_a_1.r_external = RealDependentParameters6[89];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 6, 1]'.thermalConductor_a_1.L = RealDependentParameters6[90];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 6, 1]'.thermalConductor_a_1.alpha = RealDependentParameters6[91];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 6, 1]'.thermalConductor_b_1.T_start = RealDependentParameters6[92];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 6, 1]'.thermalConductor_b_1.r_internal = RealDependentParameters6[93];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 6, 1]'.thermalConductor_b_1.r_external = RealDependentParameters6[94];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 6, 1]'.thermalConductor_b_1.L = RealDependentParameters6[95];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 6, 1]'.thermalConductor_b_1.alpha = RealDependentParameters6[96];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 6, 1]'.thermalConductor_a_2.T_start = RealDependentParameters6[97];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 6, 1]'.thermalConductor_a_2.L = RealDependentParameters6[98];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 6, 1]'.thermalConductor_a_2.A = RealDependentParameters6[99];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 6, 1]'.thermalConductor_b_2.T_start = RealDependentParameters6[100];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 6, 1]'.thermalConductor_b_2.L = RealDependentParameters7[1];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 6, 1]'.thermalConductor_b_2.A = RealDependentParameters7[2];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 6, 1]'.thermalConductor_a_3.T_start = RealDependentParameters7[3];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 6, 1]'.thermalConductor_a_3.L = RealDependentParameters7[4];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 6, 1]'.thermalConductor_a_3.A = RealDependentParameters7[5];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 6, 1]'.thermalConductor_b_3.T_start = RealDependentParameters7[6];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 6, 1]'.thermalConductor_b_3.L = RealDependentParameters7[7];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 6, 1]'.thermalConductor_b_3.A = RealDependentParameters7[8];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 6, 1]'.heatCapacitor.T_start = RealDependentParameters7[9];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 6, 1]'.heatCapacitor.V = RealDependentParameters7[10];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 6, 1]'.heatCapacitor.m = RealDependentParameters7[11];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 6, 1]'.heatCapacitor.der_T_start = RealDependentParameters7[12];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 7, 1]'.V = RealDependentParameters7[13];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 7, 1]'.thermalConductor_a_1.T_start = RealDependentParameters7[14];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 7, 1]'.thermalConductor_a_1.r_internal = RealDependentParameters7[15];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 7, 1]'.thermalConductor_a_1.r_external = RealDependentParameters7[16];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 7, 1]'.thermalConductor_a_1.L = RealDependentParameters7[17];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 7, 1]'.thermalConductor_a_1.alpha = RealDependentParameters7[18];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 7, 1]'.thermalConductor_b_1.T_start = RealDependentParameters7[19];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 7, 1]'.thermalConductor_b_1.r_internal = RealDependentParameters7[20];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 7, 1]'.thermalConductor_b_1.r_external = RealDependentParameters7[21];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 7, 1]'.thermalConductor_b_1.L = RealDependentParameters7[22];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 7, 1]'.thermalConductor_b_1.alpha = RealDependentParameters7[23];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 7, 1]'.thermalConductor_a_2.T_start = RealDependentParameters7[24];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 7, 1]'.thermalConductor_a_2.L = RealDependentParameters7[25];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 7, 1]'.thermalConductor_a_2.A = RealDependentParameters7[26];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 7, 1]'.thermalConductor_b_2.T_start = RealDependentParameters7[27];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 7, 1]'.thermalConductor_b_2.L = RealDependentParameters7[28];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 7, 1]'.thermalConductor_b_2.A = RealDependentParameters7[29];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 7, 1]'.thermalConductor_a_3.T_start = RealDependentParameters7[30];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 7, 1]'.thermalConductor_a_3.L = RealDependentParameters7[31];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 7, 1]'.thermalConductor_a_3.A = RealDependentParameters7[32];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 7, 1]'.thermalConductor_b_3.T_start = RealDependentParameters7[33];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 7, 1]'.thermalConductor_b_3.L = RealDependentParameters7[34];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 7, 1]'.thermalConductor_b_3.A = RealDependentParameters7[35];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 7, 1]'.heatCapacitor.T_start = RealDependentParameters7[36];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 7, 1]'.heatCapacitor.V = RealDependentParameters7[37];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 7, 1]'.heatCapacitor.m = RealDependentParameters7[38];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 7, 1]'.heatCapacitor.der_T_start = RealDependentParameters7[39];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 8, 1]'.V = RealDependentParameters7[40];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 8, 1]'.thermalConductor_a_1.T_start = RealDependentParameters7[41];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 8, 1]'.thermalConductor_a_1.r_internal = RealDependentParameters7[42];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 8, 1]'.thermalConductor_a_1.r_external = RealDependentParameters7[43];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 8, 1]'.thermalConductor_a_1.L = RealDependentParameters7[44];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 8, 1]'.thermalConductor_a_1.alpha = RealDependentParameters7[45];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 8, 1]'.thermalConductor_b_1.T_start = RealDependentParameters7[46];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 8, 1]'.thermalConductor_b_1.r_internal = RealDependentParameters7[47];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 8, 1]'.thermalConductor_b_1.r_external = RealDependentParameters7[48];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 8, 1]'.thermalConductor_b_1.L = RealDependentParameters7[49];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 8, 1]'.thermalConductor_b_1.alpha = RealDependentParameters7[50];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 8, 1]'.thermalConductor_a_2.T_start = RealDependentParameters7[51];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 8, 1]'.thermalConductor_a_2.L = RealDependentParameters7[52];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 8, 1]'.thermalConductor_a_2.A = RealDependentParameters7[53];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 8, 1]'.thermalConductor_b_2.T_start = RealDependentParameters7[54];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 8, 1]'.thermalConductor_b_2.L = RealDependentParameters7[55];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 8, 1]'.thermalConductor_b_2.A = RealDependentParameters7[56];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 8, 1]'.thermalConductor_a_3.T_start = RealDependentParameters7[57];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 8, 1]'.thermalConductor_a_3.L = RealDependentParameters7[58];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 8, 1]'.thermalConductor_a_3.A = RealDependentParameters7[59];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 8, 1]'.thermalConductor_b_3.T_start = RealDependentParameters7[60];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 8, 1]'.thermalConductor_b_3.L = RealDependentParameters7[61];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 8, 1]'.thermalConductor_b_3.A = RealDependentParameters7[62];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 8, 1]'.heatCapacitor.T_start = RealDependentParameters7[63];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 8, 1]'.heatCapacitor.V = RealDependentParameters7[64];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 8, 1]'.heatCapacitor.m = RealDependentParameters7[65];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 8, 1]'.heatCapacitor.der_T_start = RealDependentParameters7[66];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 9, 1]'.V = RealDependentParameters7[67];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 9, 1]'.thermalConductor_a_1.T_start = RealDependentParameters7[68];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 9, 1]'.thermalConductor_a_1.r_internal = RealDependentParameters7[69];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 9, 1]'.thermalConductor_a_1.r_external = RealDependentParameters7[70];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 9, 1]'.thermalConductor_a_1.L = RealDependentParameters7[71];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 9, 1]'.thermalConductor_a_1.alpha = RealDependentParameters7[72];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 9, 1]'.thermalConductor_b_1.T_start = RealDependentParameters7[73];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 9, 1]'.thermalConductor_b_1.r_internal = RealDependentParameters7[74];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 9, 1]'.thermalConductor_b_1.r_external = RealDependentParameters7[75];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 9, 1]'.thermalConductor_b_1.L = RealDependentParameters7[76];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 9, 1]'.thermalConductor_b_1.alpha = RealDependentParameters7[77];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 9, 1]'.thermalConductor_a_2.T_start = RealDependentParameters7[78];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 9, 1]'.thermalConductor_a_2.L = RealDependentParameters7[79];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 9, 1]'.thermalConductor_a_2.A = RealDependentParameters7[80];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 9, 1]'.thermalConductor_b_2.T_start = RealDependentParameters7[81];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 9, 1]'.thermalConductor_b_2.L = RealDependentParameters7[82];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 9, 1]'.thermalConductor_b_2.A = RealDependentParameters7[83];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 9, 1]'.thermalConductor_a_3.T_start = RealDependentParameters7[84];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 9, 1]'.thermalConductor_a_3.L = RealDependentParameters7[85];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 9, 1]'.thermalConductor_a_3.A = RealDependentParameters7[86];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 9, 1]'.thermalConductor_b_3.T_start = RealDependentParameters7[87];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 9, 1]'.thermalConductor_b_3.L = RealDependentParameters7[88];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 9, 1]'.thermalConductor_b_3.A = RealDependentParameters7[89];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 9, 1]'.heatCapacitor.T_start = RealDependentParameters7[90];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 9, 1]'.heatCapacitor.V = RealDependentParameters7[91];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 9, 1]'.heatCapacitor.m = RealDependentParameters7[92];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 9, 1]'.heatCapacitor.der_T_start = RealDependentParameters7[93];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 10, 1]'.V = RealDependentParameters7[94];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 10, 1]'.thermalConductor_a_1.T_start = RealDependentParameters7[95];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 10, 1]'.thermalConductor_a_1.r_internal = RealDependentParameters7[96];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 10, 1]'.thermalConductor_a_1.r_external = RealDependentParameters7[97];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 10, 1]'.thermalConductor_a_1.L = RealDependentParameters7[98];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 10, 1]'.thermalConductor_a_1.alpha = RealDependentParameters7[99];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 10, 1]'.thermalConductor_b_1.T_start = RealDependentParameters7[100];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 10, 1]'.thermalConductor_b_1.r_internal = RealDependentParameters8[1];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 10, 1]'.thermalConductor_b_1.r_external = RealDependentParameters8[2];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 10, 1]'.thermalConductor_b_1.L = RealDependentParameters8[3];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 10, 1]'.thermalConductor_b_1.alpha = RealDependentParameters8[4];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 10, 1]'.thermalConductor_a_2.T_start = RealDependentParameters8[5];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 10, 1]'.thermalConductor_a_2.L = RealDependentParameters8[6];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 10, 1]'.thermalConductor_a_2.A = RealDependentParameters8[7];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 10, 1]'.thermalConductor_b_2.T_start = RealDependentParameters8[8];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 10, 1]'.thermalConductor_b_2.L = RealDependentParameters8[9];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 10, 1]'.thermalConductor_b_2.A = RealDependentParameters8[10];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 10, 1]'.thermalConductor_a_3.T_start = RealDependentParameters8[11];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 10, 1]'.thermalConductor_a_3.L = RealDependentParameters8[12];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 10, 1]'.thermalConductor_a_3.A = RealDependentParameters8[13];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 10, 1]'.thermalConductor_b_3.T_start = RealDependentParameters8[14];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 10, 1]'.thermalConductor_b_3.L = RealDependentParameters8[15];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 10, 1]'.thermalConductor_b_3.A = RealDependentParameters8[16];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 10, 1]'.heatCapacitor.T_start = RealDependentParameters8[17];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 10, 1]'.heatCapacitor.V = RealDependentParameters8[18];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 10, 1]'.heatCapacitor.m = RealDependentParameters8[19];
  closedCTPressureDrop.heatExchangerThroughReal.'coilWall[2]'.'thermalNode[1, 10, 1]'.heatCapacitor.der_T_start = RealDependentParameters8[20];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.nParallel = RealDependentParameters8[21];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.diameter = RealDependentParameters8[22];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.crossArea = RealDependentParameters8[23];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.perimeter = RealDependentParameters8[24];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.roughness = RealDependentParameters8[25];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.V = RealDependentParameters8[26];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.'fluidVolumes[1]' = RealDependentParameters8[27];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.'fluidVolumes[2]' = RealDependentParameters8[28];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.'fluidVolumes[3]' = RealDependentParameters8[29];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.'fluidVolumes[4]' = RealDependentParameters8[30];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.'fluidVolumes[5]' = RealDependentParameters8[31];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.'fluidVolumes[6]' = RealDependentParameters8[32];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.'fluidVolumes[7]' = RealDependentParameters8[33];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.'fluidVolumes[8]' = RealDependentParameters8[34];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.'fluidVolumes[9]' = RealDependentParameters8[35];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.'fluidVolumes[10]' = RealDependentParameters8[36];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.p_a_start = RealDependentParameters8[37];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.p_b_start = RealDependentParameters8[38];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.'ps_start[1]' = RealDependentParameters8[39];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.'ps_start[2]' = RealDependentParameters8[40];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.'ps_start[3]' = RealDependentParameters8[41];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.'ps_start[4]' = RealDependentParameters8[42];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.'ps_start[5]' = RealDependentParameters8[43];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.'ps_start[6]' = RealDependentParameters8[44];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.'ps_start[7]' = RealDependentParameters8[45];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.'ps_start[8]' = RealDependentParameters8[46];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.'ps_start[9]' = RealDependentParameters8[47];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.'ps_start[10]' = RealDependentParameters8[48];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.'ms[1]' = RealDependentParameters8[49];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.'ms[2]' = RealDependentParameters8[50];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.'ms[3]' = RealDependentParameters8[51];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.'ms[4]' = RealDependentParameters8[52];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.'ms[5]' = RealDependentParameters8[53];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.'ms[6]' = RealDependentParameters8[54];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.'ms[7]' = RealDependentParameters8[55];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.'ms[8]' = RealDependentParameters8[56];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.'ms[9]' = RealDependentParameters8[57];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.'ms[10]' = RealDependentParameters8[58];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.'crossAreas[1]' = RealDependentParameters8[59];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.'crossAreas[2]' = RealDependentParameters8[60];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.'crossAreas[3]' = RealDependentParameters8[61];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.'crossAreas[4]' = RealDependentParameters8[62];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.'crossAreas[5]' = RealDependentParameters8[63];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.'crossAreas[6]' = RealDependentParameters8[64];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.'crossAreas[7]' = RealDependentParameters8[65];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.'crossAreas[8]' = RealDependentParameters8[66];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.'crossAreas[9]' = RealDependentParameters8[67];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.'crossAreas[10]' = RealDependentParameters8[68];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.'dimensions[1]' = RealDependentParameters8[69];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.'dimensions[2]' = RealDependentParameters8[70];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.'dimensions[3]' = RealDependentParameters8[71];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.'dimensions[4]' = RealDependentParameters8[72];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.'dimensions[5]' = RealDependentParameters8[73];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.'dimensions[6]' = RealDependentParameters8[74];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.'dimensions[7]' = RealDependentParameters8[75];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.'dimensions[8]' = RealDependentParameters8[76];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.'dimensions[9]' = RealDependentParameters8[77];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.'dimensions[10]' = RealDependentParameters8[78];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.'roughnesses[1]' = RealDependentParameters8[79];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.'roughnesses[2]' = RealDependentParameters8[80];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.'roughnesses[3]' = RealDependentParameters8[81];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.'roughnesses[4]' = RealDependentParameters8[82];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.'roughnesses[5]' = RealDependentParameters8[83];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.'roughnesses[6]' = RealDependentParameters8[84];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.'roughnesses[7]' = RealDependentParameters8[85];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.'roughnesses[8]' = RealDependentParameters8[86];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.'roughnesses[9]' = RealDependentParameters8[87];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.'roughnesses[10]' = RealDependentParameters8[88];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.flowModel.nParallel = RealDependentParameters8[89];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.flowModel.g = RealDependentParameters8[90];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.flowModel.p_a_start = RealDependentParameters8[91];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.flowModel.p_b_start = RealDependentParameters8[92];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.flowModel.dp_nominal = RealDependentParameters8[93];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.flowModel.m_flow_nominal = RealDependentParameters8[94];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.flowModel.m_flow_small = RealDependentParameters8[95];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.heatTransfer.'surfaceAreas[1]' = RealDependentParameters8[96];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.heatTransfer.'surfaceAreas[2]' = RealDependentParameters8[97];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.heatTransfer.'surfaceAreas[3]' = RealDependentParameters8[98];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.heatTransfer.'surfaceAreas[4]' = RealDependentParameters8[99];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.heatTransfer.'surfaceAreas[5]' = RealDependentParameters8[100];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.heatTransfer.'surfaceAreas[6]' = RealDependentParameters9[1];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.heatTransfer.'surfaceAreas[7]' = RealDependentParameters9[2];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.heatTransfer.'surfaceAreas[8]' = RealDependentParameters9[3];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.heatTransfer.'surfaceAreas[9]' = RealDependentParameters9[4];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.heatTransfer.'surfaceAreas[10]' = RealDependentParameters9[5];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.heatTransfer.T_ambient = RealDependentParameters9[6];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[1]'.heatTransfer.nParallel = RealDependentParameters9[7];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.nParallel = RealDependentParameters9[8];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.diameter = RealDependentParameters9[9];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.crossArea = RealDependentParameters9[10];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.perimeter = RealDependentParameters9[11];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.roughness = RealDependentParameters9[12];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.V = RealDependentParameters9[13];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.'fluidVolumes[1]' = RealDependentParameters9[14];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.'fluidVolumes[2]' = RealDependentParameters9[15];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.'fluidVolumes[3]' = RealDependentParameters9[16];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.'fluidVolumes[4]' = RealDependentParameters9[17];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.'fluidVolumes[5]' = RealDependentParameters9[18];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.'fluidVolumes[6]' = RealDependentParameters9[19];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.'fluidVolumes[7]' = RealDependentParameters9[20];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.'fluidVolumes[8]' = RealDependentParameters9[21];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.'fluidVolumes[9]' = RealDependentParameters9[22];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.'fluidVolumes[10]' = RealDependentParameters9[23];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.p_a_start = RealDependentParameters9[24];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.p_b_start = RealDependentParameters9[25];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.'ps_start[1]' = RealDependentParameters9[26];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.'ps_start[2]' = RealDependentParameters9[27];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.'ps_start[3]' = RealDependentParameters9[28];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.'ps_start[4]' = RealDependentParameters9[29];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.'ps_start[5]' = RealDependentParameters9[30];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.'ps_start[6]' = RealDependentParameters9[31];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.'ps_start[7]' = RealDependentParameters9[32];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.'ps_start[8]' = RealDependentParameters9[33];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.'ps_start[9]' = RealDependentParameters9[34];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.'ps_start[10]' = RealDependentParameters9[35];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.'ms[1]' = RealDependentParameters9[36];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.'ms[2]' = RealDependentParameters9[37];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.'ms[3]' = RealDependentParameters9[38];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.'ms[4]' = RealDependentParameters9[39];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.'ms[5]' = RealDependentParameters9[40];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.'ms[6]' = RealDependentParameters9[41];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.'ms[7]' = RealDependentParameters9[42];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.'ms[8]' = RealDependentParameters9[43];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.'ms[9]' = RealDependentParameters9[44];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.'ms[10]' = RealDependentParameters9[45];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.'crossAreas[1]' = RealDependentParameters9[46];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.'crossAreas[2]' = RealDependentParameters9[47];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.'crossAreas[3]' = RealDependentParameters9[48];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.'crossAreas[4]' = RealDependentParameters9[49];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.'crossAreas[5]' = RealDependentParameters9[50];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.'crossAreas[6]' = RealDependentParameters9[51];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.'crossAreas[7]' = RealDependentParameters9[52];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.'crossAreas[8]' = RealDependentParameters9[53];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.'crossAreas[9]' = RealDependentParameters9[54];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.'crossAreas[10]' = RealDependentParameters9[55];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.'dimensions[1]' = RealDependentParameters9[56];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.'dimensions[2]' = RealDependentParameters9[57];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.'dimensions[3]' = RealDependentParameters9[58];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.'dimensions[4]' = RealDependentParameters9[59];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.'dimensions[5]' = RealDependentParameters9[60];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.'dimensions[6]' = RealDependentParameters9[61];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.'dimensions[7]' = RealDependentParameters9[62];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.'dimensions[8]' = RealDependentParameters9[63];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.'dimensions[9]' = RealDependentParameters9[64];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.'dimensions[10]' = RealDependentParameters9[65];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.'roughnesses[1]' = RealDependentParameters9[66];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.'roughnesses[2]' = RealDependentParameters9[67];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.'roughnesses[3]' = RealDependentParameters9[68];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.'roughnesses[4]' = RealDependentParameters9[69];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.'roughnesses[5]' = RealDependentParameters9[70];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.'roughnesses[6]' = RealDependentParameters9[71];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.'roughnesses[7]' = RealDependentParameters9[72];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.'roughnesses[8]' = RealDependentParameters9[73];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.'roughnesses[9]' = RealDependentParameters9[74];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.'roughnesses[10]' = RealDependentParameters9[75];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.state_b.T = RealDependentParameters9[76];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.flowModel.nParallel = RealDependentParameters9[77];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.flowModel.g = RealDependentParameters9[78];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.flowModel.p_a_start = RealDependentParameters9[79];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.flowModel.p_b_start = RealDependentParameters9[80];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.flowModel.dp_nominal = RealDependentParameters9[81];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.flowModel.m_flow_nominal = RealDependentParameters9[82];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.flowModel.m_flow_small = RealDependentParameters9[83];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.heatTransfer.'surfaceAreas[1]' = RealDependentParameters9[84];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.heatTransfer.'surfaceAreas[2]' = RealDependentParameters9[85];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.heatTransfer.'surfaceAreas[3]' = RealDependentParameters9[86];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.heatTransfer.'surfaceAreas[4]' = RealDependentParameters9[87];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.heatTransfer.'surfaceAreas[5]' = RealDependentParameters9[88];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.heatTransfer.'surfaceAreas[6]' = RealDependentParameters9[89];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.heatTransfer.'surfaceAreas[7]' = RealDependentParameters9[90];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.heatTransfer.'surfaceAreas[8]' = RealDependentParameters9[91];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.heatTransfer.'surfaceAreas[9]' = RealDependentParameters9[92];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.heatTransfer.'surfaceAreas[10]' = RealDependentParameters9[93];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.heatTransfer.T_ambient = RealDependentParameters9[94];
  closedCTPressureDrop.heatExchangerThroughReal.'pipe[2]'.heatTransfer.nParallel = RealDependentParameters9[95];
  closedCTPressureDrop.heatExchangerThroughReal.volumeFlowRate.dp_start = RealDependentParameters9[96];
  closedCTPressureDrop.heatExchangerThroughReal.volumeFlowRate.m_flow_small = RealDependentParameters9[97];
  closedCTPressureDrop.heatExchangerThroughReal.volumeFlowRate.a = RealDependentParameters9[98];
  closedCTPressureDrop.heatExchangerThroughReal.volumeFlowRate.b = RealDependentParameters9[99];
  closedCTPressureDrop.waterBasin.height = RealDependentParameters9[100];
  closedCTPressureDrop.waterBasin.crossArea = RealDependentParameters10[1];
  closedCTPressureDrop.waterBasin.p_ambient = RealDependentParameters10[2];
  closedCTPressureDrop.waterBasin.T_ambient = RealDependentParameters10[3];
  closedCTPressureDrop.waterBasin.level_start = RealDependentParameters10[4];
  closedCTPressureDrop.waterBasin.p_start = RealDependentParameters10[5];
  closedCTPressureDrop.waterBasin.T_start = RealDependentParameters10[6];
  closedCTPressureDrop.waterBasin.h_start = RealDependentParameters10[7];
  closedCTPressureDrop.waterBasin.medium.p = RealDependentParameters10[8];
  closedCTPressureDrop.waterBasin.medium.p_bar = RealDependentParameters10[9];
  closedCTPressureDrop.waterBasin.'portsData[3]'.diameter = RealDependentParameters10[10];
  closedCTPressureDrop.waterBasin.'portsData[3]'.height = RealDependentParameters10[11];
  closedCTPressureDrop.waterBasin.m_flow_nominal = RealDependentParameters10[12];
  closedCTPressureDrop.waterBasin.m_flow_small = RealDependentParameters10[13];
  closedCTPressureDrop.waterBasin.heatTransfer.T_ambient = RealDependentParameters10[14];
  closedCTPressureDrop.waterBasin.'portVelocities[1]' = RealDependentParameters10[15];
  closedCTPressureDrop.waterBasin.'ports_E_flow[1]' = RealDependentParameters10[16];
  closedCTPressureDrop.waterBasin.'portAreas[1]' = RealDependentParameters10[17];
  closedCTPressureDrop.waterBasin.'portAreas[2]' = RealDependentParameters10[18];
  closedCTPressureDrop.waterBasin.'portAreas[3]' = RealDependentParameters10[19];
  closedCTPressureDrop.naturalConvectionVerticalPlate.L = RealDependentParameters10[20];
  closedCTPressureDrop.waterSpray.dp_start = RealDependentParameters10[21];
  closedCTPressureDrop.waterSpray.m_flow_small = RealDependentParameters10[22];
  closedCTPressureDrop.waterSpray.dp = RealDependentParameters10[23];
  closedCTPressureDrop.waterSpray.V_flow = RealDependentParameters10[24];
  closedCTPressureDrop.waterSpray.p_ambient = RealDependentParameters10[25];
  closedCTPressureDrop.waterSpray.d_a = RealDependentParameters10[26];
  closedCTPressureDrop.waterSpray.d_b = RealDependentParameters10[27];
  closedCTPressureDrop.waterSpray.A_a = RealDependentParameters10[28];
  closedCTPressureDrop.waterSpray.A_b = RealDependentParameters10[29];
  closedCTPressureDrop.waterSpray.V_a = RealDependentParameters10[30];
  closedCTPressureDrop.waterSpray.V_b = RealDependentParameters10[31];
  closedCTPressureDrop.pump.p_a_start = RealDependentParameters10[32];
  closedCTPressureDrop.pump.p_b_start = RealDependentParameters10[33];
  closedCTPressureDrop.pump.p_start = RealDependentParameters10[34];
  closedCTPressureDrop.pump.T_start = RealDependentParameters10[35];
  closedCTPressureDrop.pump.h_start = RealDependentParameters10[36];
  closedCTPressureDrop.pump.heatTransfer.T_ambient = RealDependentParameters10[37];
  closedCTPressureDrop.pump.g = RealDependentParameters10[38];
  closedCTPressureDrop.pump.m_flow_single = RealDependentParameters10[39];
  closedCTPressureDrop.pump.V_flow = RealDependentParameters10[40];
  closedCTPressureDrop.pump.V_flow_single = RealDependentParameters10[41];
  closedCTPressureDrop.pump.p_a_nominal = RealDependentParameters10[42];
  closedCTPressureDrop.pump.p_b_nominal = RealDependentParameters10[43];
  closedCTPressureDrop.pump.m_flow_nominal = RealDependentParameters10[44];
  closedCTPressureDrop.pump.V_flow_op = RealDependentParameters10[45];
  closedCTPressureDrop.pump.head_op = RealDependentParameters10[46];
  closedCTPressureDrop.storageWall.h = RealDependentParameters10[47];
  closedCTPressureDrop.storageWall.w = RealDependentParameters10[48];
  closedCTPressureDrop.storageWall.l = RealDependentParameters10[49];
  closedCTPressureDrop.storageWall.e = RealDependentParameters10[50];
  closedCTPressureDrop.storageWall.'sideInertia[1]'.V = RealDependentParameters10[51];
  closedCTPressureDrop.storageWall.'sideInertia[1]'.m = RealDependentParameters10[52];
  closedCTPressureDrop.storageWall.'sideInertia[1]'.C = RealDependentParameters10[53];
  closedCTPressureDrop.storageWall.'sideInertia[2]'.V = RealDependentParameters10[54];
  closedCTPressureDrop.storageWall.'sideInertia[2]'.m = RealDependentParameters10[55];
  closedCTPressureDrop.storageWall.'sideInertia[2]'.C = RealDependentParameters10[56];
  closedCTPressureDrop.storageWall.topInertia.V = RealDependentParameters10[57];
  closedCTPressureDrop.storageWall.topInertia.m = RealDependentParameters10[58];
  closedCTPressureDrop.storageWall.topInertia.C = RealDependentParameters10[59];
  closedCTPressureDrop.storageWall.'sideCond2[1]'.G = RealDependentParameters10[60];
  closedCTPressureDrop.storageWall.'sideCond2[1]'.L = RealDependentParameters10[61];
  closedCTPressureDrop.storageWall.'sideCond2[1]'.A = RealDependentParameters10[62];
  closedCTPressureDrop.storageWall.'sideCond2[2]'.G = RealDependentParameters10[63];
  closedCTPressureDrop.storageWall.'sideCond2[2]'.L = RealDependentParameters10[64];
  closedCTPressureDrop.storageWall.'sideCond2[2]'.A = RealDependentParameters10[65];
  closedCTPressureDrop.storageWall.'sideCond1[1]'.G = RealDependentParameters10[66];
  closedCTPressureDrop.storageWall.'sideCond1[1]'.L = RealDependentParameters10[67];
  closedCTPressureDrop.storageWall.'sideCond1[1]'.A = RealDependentParameters10[68];
  closedCTPressureDrop.storageWall.'sideCond1[2]'.G = RealDependentParameters10[69];
  closedCTPressureDrop.storageWall.'sideCond1[2]'.L = RealDependentParameters10[70];
  closedCTPressureDrop.storageWall.'sideCond1[2]'.A = RealDependentParameters10[71];
  closedCTPressureDrop.storageWall.topCond1.G = RealDependentParameters10[72];
  closedCTPressureDrop.storageWall.topCond1.L = RealDependentParameters10[73];
  closedCTPressureDrop.storageWall.topCond1.A = RealDependentParameters10[74];
  closedCTPressureDrop.storageWall.topCond2.G = RealDependentParameters10[75];
  closedCTPressureDrop.storageWall.topCond2.L = RealDependentParameters10[76];
  closedCTPressureDrop.storageWall.topCond2.A = RealDependentParameters10[77];
  closedCTPressureDrop.storageWall.'frontInertia[1]'.V = RealDependentParameters10[78];
  closedCTPressureDrop.storageWall.'frontInertia[1]'.m = RealDependentParameters10[79];
  closedCTPressureDrop.storageWall.'frontInertia[1]'.C = RealDependentParameters10[80];
  closedCTPressureDrop.storageWall.'frontInertia[2]'.V = RealDependentParameters10[81];
  closedCTPressureDrop.storageWall.'frontInertia[2]'.m = RealDependentParameters10[82];
  closedCTPressureDrop.storageWall.'frontInertia[2]'.C = RealDependentParameters10[83];
  closedCTPressureDrop.storageWall.'frontCond1[1]'.G = RealDependentParameters10[84];
  closedCTPressureDrop.storageWall.'frontCond1[1]'.L = RealDependentParameters10[85];
  closedCTPressureDrop.storageWall.'frontCond1[1]'.A = RealDependentParameters10[86];
  closedCTPressureDrop.storageWall.'frontCond1[2]'.dT = RealDependentParameters10[87];
  closedCTPressureDrop.storageWall.'frontCond1[2]'.G = RealDependentParameters10[88];
  closedCTPressureDrop.storageWall.'frontCond1[2]'.L = RealDependentParameters10[89];
  closedCTPressureDrop.storageWall.'frontCond1[2]'.A = RealDependentParameters10[90];
  closedCTPressureDrop.storageWall.'frontCond2[1]'.G = RealDependentParameters10[91];
  closedCTPressureDrop.storageWall.'frontCond2[1]'.L = RealDependentParameters10[92];
  closedCTPressureDrop.storageWall.'frontCond2[1]'.A = RealDependentParameters10[93];
  closedCTPressureDrop.storageWall.'frontCond2[2]'.G = RealDependentParameters10[94];
  closedCTPressureDrop.storageWall.'frontCond2[2]'.L = RealDependentParameters10[95];
  closedCTPressureDrop.storageWall.'frontCond2[2]'.A = RealDependentParameters10[96];
  airOut.medium.d = RealDependentParameters10[97];
  airOut.medium.'X[2]' = RealDependentParameters10[98];
  airOut.medium.u = RealDependentParameters10[99];
  airOut.medium.R = RealDependentParameters10[100];
  airOut.medium.MM = RealDependentParameters11[1];
  airOut.medium.T_degC = RealDependentParameters11[2];
  airOut.medium.p_bar = RealDependentParameters11[3];
  airOut.medium.x_water = RealDependentParameters11[4];
  airOut.medium.phi = RealDependentParameters11[5];
  airOut.'ports[1]'.h_outflow = RealDependentParameters11[6];
  airOut.p = RealDependentParameters11[7];
  cWaterOut.medium.u = RealDependentParameters11[8];
  cWaterOut.medium.T_degC = RealDependentParameters11[9];
  cWaterOut.medium.p_bar = RealDependentParameters11[10];
  cWaterOut.'ports[1]'.h_outflow = RealDependentParameters11[11];
  cWaterOut.p = RealDependentParameters11[12];
  levelControl.hmax = RealDependentParameters11[13];
  levelControl.hmin = RealDependentParameters11[14];
  levelControl.m_In = RealDependentParameters11[15];
  closedCTPressureDrop.nParallel = IntegerDependentParameters[1];
  closedCTPressureDrop.heatExchangerThroughReal.nParallel = IntegerDependentParameters[2];
  annotation (__Dymola_FMUImportVersion="Dymola 2017 FD01", experiment(StartTime=0.0, StopTime=15000.0, Tolerance=0.0001),
    Icon(graphics={
      Rectangle(
        extent={{-100,100},{100,-100}},
        lineColor={95,95,95},
        fillColor={255,255,255},
        fillPattern=FillPattern.Solid,
        lineThickness=0.5),
      Text(
        extent={{-70,20},{70,-20}},
        lineColor={0,0,255},
        textString="%name"),
      Text(
        extent={{-70,-72},{70,-94}},
        lineColor={95,95,95},
        textString="FMI 1.0 CS Import")}),
Documentation(info="<html>
<h4>ModelDescription Attributes</h4>
<ul>
<li>fmiVersion = 1.0</li>
<li>modelName = Modelica_IK4_TEKNIKER.DCOL.Generation.CoolingTowers.FMI.CompleteCCT_inertia_Dym</li>
<li>generationTool = Dymola Version 2017 FD01 (64-bit), 2016-10-11 (requires license to execute)</li>
<li>generationDateAndTime = 2017-06-02T10:23:00Z</li>
</ul>
<p><br><b>Co-Simulation Attributes</b></p>
<ul>
<li>canHandleVariableCommunicationStepSize = true</li>
<li>canHandleEvents = true</li>
<li>canRejectSteps = false</li>
<li>canInterpolateInputs = true</li>
<li>maxOutputDerivativeOrder = 1</li>
<li>canRunAsynchronuously = false</li>
<li>canSignalEvents = false</li>
<li>canBeInstantiatedOnlyOncePerProcess = false</li>
<li>canNotUseMemoryManagementFunctions = false</li>
</ul>
</html>",
      revisions="<html>
<p>2016-05-16 <a href=\"mailto: eduardo.ubieta@tekniker.es\">Eduardo Ubieta</a></a> (IK4-TEKNIKER): First implementation</p>
<p><b>Copyright &copy; <a href=\"http://www.tekniker.es/en\">IK4-TEKNIKER</a></b></p>
</html>"));
end CompleteCCT_inertia_FMI;
