within DCOL.Generation.CoolingTowers.FMI;
model CompleteOCT_inertia_FMI
// Model automatically generated by Dymola from FMI model description
public
  type Modelica_Blocks_Interfaces_BooleanInput = Boolean annotation (
      Documentation(revisions="<html>
</html>"));
  type Modelica_Blocks_Interfaces_RealInput = Real annotation (
      Documentation(revisions="<html>
</html>"));
  type Modelica_Blocks_Interfaces_RealOutput = Real annotation (
      Documentation(revisions="<html>
</html>"));
  type Modelica_IK4_TEKNIKER_DCOL_Generation_CoolingTowers_FMI_RealConnectors_RealMassFlowInput = Real (unit = "kg/s", quantity = "MassFlowRate")
    annotation (Documentation(revisions="<html>
</html>"));
  type Modelica_IK4_TEKNIKER_DCOL_Generation_CoolingTowers_FMI_RealConnectors_RealMassFractionInput = Real (unit = "1", quantity = "MassFraction", min = 0.0, max = 1.0)
    annotation (Documentation(revisions="<html>
</html>"));
  type Modelica_IK4_TEKNIKER_DCOL_Generation_CoolingTowers_FMI_RealConnectors_RealTemperatureInput = Real (unit = "K", displayUnit = "degC", nominal = 300.0, quantity = "ThermodynamicTemperature", min = 0.0)
    annotation (Documentation(revisions="<html>
</html>"));
  type Modelica_IK4_TEKNIKER_DCOL_Generation_CoolingTowers_FMI_RealConnectors_RealTemperatureOutput = Real (unit = "K", displayUnit = "degC", nominal = 300.0, quantity = "ThermodynamicTemperature", min = 0.0)
    annotation (Documentation(revisions="<html>
</html>"));
protected
  record 'system_rec'
    constant Modelica.SIunits.AbsolutePressure p_ambient = 101325
                                                                 "Default ambient pressure";
    parameter Modelica.SIunits.Temperature T_ambient = 293.15
                                                             "Default ambient temperature";
    parameter Modelica.SIunits.Acceleration g = 9.80665
                                                       "Constant gravity acceleration";
    constant Boolean allowFlowReversal = true
                                             "= false to restrict to design flow direction (port_a -> port_b)";
    constant Modelica.Fluid.Types.Dynamics energyDynamics = Modelica.Fluid.Types.Dynamics.DynamicFreeInitial
                                                                                                            "Default formulation of energy balances";
    constant Modelica.Fluid.Types.Dynamics massDynamics = Modelica.Fluid.Types.Dynamics.DynamicFreeInitial
                                                                                                          "Default formulation of mass balances";
    constant Modelica.Fluid.Types.Dynamics substanceDynamics = Modelica.Fluid.Types.Dynamics.DynamicFreeInitial
                                                                                                               "Default formulation of substance balances";
    constant Modelica.Fluid.Types.Dynamics traceDynamics = Modelica.Fluid.Types.Dynamics.DynamicFreeInitial
                                                                                                           "Default formulation of trace substance balances";
    constant Modelica.Fluid.Types.Dynamics momentumDynamics = Modelica.Fluid.Types.Dynamics.SteadyState
                                                                                                       "Default formulation of momentum balances, if options available";
    parameter Modelica.SIunits.MassFlowRate m_flow_start = 0
                                                            "Default start value for mass flow rates";
    constant Modelica.SIunits.AbsolutePressure p_start = 101325.0
                                                                 "Default start value for pressures";
    parameter Modelica.SIunits.Temperature T_start(fixed=false)
                                                               "Default start value for temperatures";
    constant Boolean use_eps_Re = false
                                       "= true to determine turbulent region automatically using Reynolds number";
    parameter Modelica.SIunits.MassFlowRate m_flow_nominal(fixed=false)
                                                                       "Default nominal mass flow rate";
    parameter Real eps_m_flow(unit = "1", min = 0.0) = 0.0001
                                                             "Regularization of zero flow for |m_flow| < eps_m_flow*m_flow_nominal";
    parameter Modelica.SIunits.AbsolutePressure dp_small = 1
                                                            "Default small pressure drop for regularization of laminar and zero flow";
    parameter Modelica.SIunits.MassFlowRate m_flow_small(min = 0.0) = 0.01
                                                                          "Default small mass flow rate for regularization of laminar and zero flow";
  end 'system_rec';
public
  'system_rec' 'system' annotation(Dialog);
  parameter Modelica.SIunits.Height hmax = 0.377825
                                                   "Maximum height of water that can the basin have";
  parameter Modelica.SIunits.Height hmin = 0.092075
                                                   "Minimum height of water that can the basin have";
  parameter Modelica.SIunits.Length L_basin = 2.60985
                                                     "Length of the basin";
  parameter Modelica.SIunits.Length w = 2.28346
                                               "Width of the basin";
  parameter Modelica.SIunits.Length e = 0.2
                                           "Thicknes of the storages wall";
  parameter Real c = 2.3
                        "Empirical constant specific to a particular tower design";
  parameter Real n = -0.72
                          "Empirical constant specific to a particular tower design";
  parameter Real Kfi(unit = "1/m") = 3.5
                                        "Loss coefficient in the fill";
  parameter Modelica.SIunits.Length hfi = 2.11455
                                                 "Height of the filter";
  parameter Modelica.SIunits.Length wfi = 2.28346
                                                 "Width of the filter";
  parameter Modelica.SIunits.Length lfi = 2.60985
                                                 "Length of the filter";
  parameter Real C_iner(unit = "J/K") = 10
                                          "Constant defining the thermal inertia of the filter";
  constant Modelica.SIunits.Temperature ToverflowWater = 298.15
                                                               "Start value for the outlet water";
  parameter Modelica.SIunits.Temperature TWater2_start = 302.15
                                                               "Start value for the outlet water";
  parameter Modelica.SIunits.Temperature TAir2_start = 307.15
                                                             "Start value for the outlet water";
  parameter Modelica.SIunits.MassFraction H2_start = 0.15
                                                         "Outlet Air absolute humidity";
  parameter Modelica.SIunits.MassFlowRate mAir1_start = 20
                                                          "Inlet air mass flow";
protected
  record openCT2_rec
    constant Boolean allowFlowReversal = false
                                              "true for allowing the reversal flow";
    constant Boolean homotopyInitialization = true
                                                  "true for allowing the reversal flow";
    parameter Modelica.SIunits.Height hmax(fixed=false)
                                                       "Maximum height of water that can the basin have";
    parameter Modelica.SIunits.Height hmin(fixed=false)
                                                       "Minimum height of water that can the basin have";
    parameter Modelica.SIunits.Length L_char(fixed=false)
                                                         "Characteristic length, length of the plate";
    parameter Modelica.SIunits.Length L_basin(fixed=false)
                                                          "Length of the basin";
    parameter Modelica.SIunits.Length w(fixed=false)
                                                    "Width of the basin";
    parameter Modelica.SIunits.Length e(fixed=false)
                                                    "Thicknes of the storages wall";
    parameter Real c(fixed=false)
                                 "Empirical constant specific to a particular tower design";
    parameter Real n(fixed=false)
                                 "Empirical constant specific to a particular tower design";
    parameter Real Kfi(unit = "1/m", fixed=false)
                                                 "Loss coefficient in the fill";
    parameter Modelica.SIunits.Length hfi(fixed=false)
                                                      "Height of the filter";
    parameter Modelica.SIunits.Length wfi(fixed=false)
                                                      "Width of the filter";
    parameter Modelica.SIunits.Length lfi(fixed=false)
                                                      "Length of the filter";
    parameter Modelica.SIunits.Area Afr(fixed=false)
                                                    "cross-sectional packing area";
    parameter Real C_iner(unit = "J/K", fixed=false)
                                                    "Constant defining the thermal inertia of the filter";
    parameter Modelica.SIunits.Temperature TWater2_start(fixed=false)
                                                                     "Start value for the outlet water";
    parameter Modelica.SIunits.Temperature TAir2_start(fixed=false)
                                                                   "Start value for the outlet water";
    parameter Modelica.SIunits.MassFraction H2_start(fixed=false)
                                                                 "Outlet Air absolute humidity";
    parameter Modelica.SIunits.MassFlowRate mAir1_start(fixed=false)
                                                                    "Inlet air mass flow";
  protected
    record openHTX_rec
      constant Boolean allowFlowReversal = false
                                                "= true to allow flow reversal, false restricts to design direction (port_a -> port_b)";
    protected
      record port_a_water_rec
        Modelica.Media.Interfaces.PartialMedium.MassFlowRate m_flow(quantity = "MassFlowRate.SimpleLiquidWater", min = 0.0)
                                                                                                                           "Mass flow rate from the connection point into the component";
        Modelica.Media.Interfaces.Types.AbsolutePressure p
                                                          "Thermodynamic pressure in the connection point";
        Modelica.Media.Interfaces.Types.SpecificEnthalpy h_outflow
                                                                  "Specific thermodynamic enthalpy close to the connection point if m_flow < 0";
      end port_a_water_rec;
    public
      port_a_water_rec port_a_water;
    protected
      record port_b_water_rec
        Modelica.Media.Interfaces.PartialMedium.MassFlowRate m_flow(quantity = "MassFlowRate.SimpleLiquidWater", max = 0.0)
                                                                                                                           "Mass flow rate from the connection point into the component";
        Modelica.Media.Interfaces.Types.AbsolutePressure p
                                                          "Thermodynamic pressure in the connection point";
        Modelica.Media.Interfaces.Types.SpecificEnthalpy h_outflow
                                                                  "Specific thermodynamic enthalpy close to the connection point if m_flow < 0";
      end port_b_water_rec;
    public
      port_b_water_rec port_b_water;
    protected
      record port_a_air_rec
        Modelica.Media.Interfaces.PartialMedium.MassFlowRate m_flow(quantity = "MassFlowRate.Moist air", min = 0.0)
                                                                                                                   "Mass flow rate from the connection point into the component";
        constant Modelica.Media.Interfaces.Types.AbsolutePressure p = 101325.0
                                                                              "Thermodynamic pressure in the connection point";
        Modelica.Media.Interfaces.Types.SpecificEnthalpy h_outflow
                                                                  "Specific thermodynamic enthalpy close to the connection point if m_flow < 0";
        Modelica.Media.Interfaces.Types.MassFraction 'Xi_outflow[1]'
                                                                    "Independent mixture mass fractions m_i/m close to the connection point if m_flow < 0";
      end port_a_air_rec;
    public
      port_a_air_rec port_a_air;
    protected
      record port_b_air_rec
        Modelica.Media.Interfaces.PartialMedium.MassFlowRate m_flow(quantity = "MassFlowRate.Moist air", max = 0.0)
                                                                                                                   "Mass flow rate from the connection point into the component";
        Modelica.Media.Interfaces.Types.AbsolutePressure p
                                                          "Thermodynamic pressure in the connection point";
        Modelica.Media.Interfaces.Types.SpecificEnthalpy h_outflow
                                                                  "Specific thermodynamic enthalpy close to the connection point if m_flow < 0";
        parameter Modelica.Media.Interfaces.Types.MassFraction '_Xi_outflow[1]_start' = 0.0;
        Modelica.Media.Interfaces.Types.MassFraction 'Xi_outflow[1]'(start = '_Xi_outflow[1]_start', fixed=false)
                                                                                                                 "Independent mixture mass fractions m_i/m close to the connection point if m_flow < 0";
      end port_b_air_rec;
    public
      port_b_air_rec port_b_air annotation(Dialog);
      Modelica.SIunits.Temperature TWater1
                                          "Inlet water temperature in K";
      Modelica.SIunits.SpecificEnthalpy hWater1
                                               "Specific enthalpy of the inlet water";
      Modelica.SIunits.MassFlowRate mWater1
                                           "Inlet water mass flow";
      Modelica.SIunits.Temp_C TWater1C
                                      "Inlet water temperature in C";
      Modelica.SIunits.Temperature TWater2
                                          "Outlet water temperature in K";
      Modelica.SIunits.SpecificEnthalpy hWater2
                                               "Specific enthalpy of the outlet water";
      Modelica.SIunits.MassFlowRate mWater2
                                           "Outlet water mass flow";
      Modelica.SIunits.Temp_C TWater2C
                                      "Outlet water temperature in C";
      Modelica.SIunits.Temperature TAir1
                                        "Inlet air temperature in K";
      Modelica.SIunits.SpecificEnthalpy hAir1
                                             "Specific enthalpy of the inlet air";
      Modelica.SIunits.MassFlowRate mAir1
                                         "Inlet air mass flow";
      Modelica.SIunits.MassFraction X1
                                      "Vapour mass fraction in the inlet air [kg_vapour/kg_moist_air]";
      Modelica.SIunits.Temp_C TAir1C
                                    "Inlet air temperature in C";
      Modelica.SIunits.MassFraction H1
                                      "Inlet air absolute humidity=0.0184560958649";
      Modelica.SIunits.MassFlowRate mDAir1
                                          "Inlet dry air mass flow";
      Modelica.SIunits.MassFlowRate mVap1
                                         "Inlet vapour mass flow";
      Modelica.SIunits.SpecificEnthalpy hsw1
                                            "Air saturation enthalpy at inlet water temperature";
      Modelica.SIunits.MassFraction Hsat1
                                         "Inlet air saturation absolute humidity";
      Modelica.SIunits.MassFraction Hsat1w
                                          "Inlet air saturation absolute humidity at inlet water temperature";
      Modelica.SIunits.Pressure pSat1
                                     "Air saturation pressure at TWater1";
      Modelica.SIunits.Density rho1
                                   "Density of air-water vapor mixture at the entrace";
      Modelica.SIunits.MolarMass N1
                                   "Inlet air molar mass";
      Modelica.SIunits.Temperature TAir2
                                        "Inlet air temperature in K";
      Modelica.SIunits.SpecificEnthalpy hAir2
                                             "specific enthalpy of the outlet Air";
      Modelica.SIunits.MassFlowRate mAir2
                                         "Outlet Air mass flow";
      Modelica.SIunits.MassFraction X2
                                      "Vapour mass fraction in the outlet air [kg_vapour/kg_moist_air]";
      Modelica.SIunits.MassFlowRate mDAir2
                                          "Outlet dry air mass flow";
      Modelica.SIunits.MassFlowRate mVap2
                                         "Outlet vapour mass flow";
      Modelica.SIunits.MassFraction H2
                                      "Outlet air absolute humidity";
      Modelica.SIunits.Temp_C TAir2C
                                    "Inlet air temperature in C";
      Modelica.SIunits.SpecificEnthalpy hsw2
                                            "Air saturation enthalpy at outlet water temperature";
      Modelica.SIunits.MassFraction Hsat2
                                         "Outlet air saturation absolute humidity";
      Modelica.SIunits.MassFraction Hsat2w
                                          "Outlet air saturation absolute humidity at water temperature";
      Modelica.SIunits.Pressure pSat2
                                     "Air saturation pressure at TAir2";
      Modelica.SIunits.Density rho2
                                   "Density of air-water vapor mixture at the exit";
      Modelica.SIunits.MolarMass N2
                                   "Outlet air molar mass";
      Real phi2
               "Realitive humidity at the exit of the tower";
      Modelica.SIunits.MassFlowRate mEvap
                                         "Evaported mass flow";
      Modelica.SIunits.SpecificEnthalpy hvap
                                            "Vapour specific enthalpy";
      Modelica.SIunits.Temperature Tvap
                                       "Vapour temperature in K";
      Modelica.SIunits.Temp_C TvapC
                                   "Vapour temperature in C";
      Modelica.SIunits.HeatFlowRate Qsen
                                        "Sensible heat transferred to the water";
      Modelica.SIunits.HeatFlowRate Qlat
                                        "Latent heat transferred to the water";
      Modelica.SIunits.HeatFlowRate Qfi
                                       "Total heat absorbed by the filter";
      Modelica.SIunits.HeatFlowRate Qtot
                                        "Total heat transferred to the water";
      parameter Real Kfi(unit = "1/m", fixed=false)
                                                   "Loss coefficient in the fill";
      Modelica.SIunits.MassFlowRate mMed
                                        "Mean air-vapor flow rate";
      Modelica.SIunits.Density rhoMed
                                     "harmonic mean density of air-water vapor mixtures";
      parameter Modelica.SIunits.Length hfi(fixed=false)
                                                        "Height of the filter";
      parameter Modelica.SIunits.Length wfi(fixed=false)
                                                        "Width of the filter";
      parameter Modelica.SIunits.Length lfi(fixed=false)
                                                        "Length of the filter";
      Modelica.SIunits.Pressure IncP
                                    "Air pressure chnge between the entrace and the exit";
      Real e_a(unit = "1");
      Real efficiency(unit = "1")
                                 "Efficiency of the tower";
      parameter Real c(fixed=false)
                                   "Empirical constant specific to a particular tower design";
      parameter Real n(fixed=false)
                                   "Empirical constant specific to a particular tower design";
      Real NTU
              "Number of Transfer Units of the tower";
      Real C_s(unit = "J/(kg.K)")
                                 "Derivative of saturated ha with respect to Tw";
      Real m_ratio(unit = "1")
                              "Ratio of air to water effective capacitance rate";
      constant Modelica.SIunits.Pressure pAmbient = 101325.0
                                                            "Ambient pressure";
      parameter Modelica.SIunits.Area Afr(fixed=false)
                                                      "cross-sectional packing area";
      parameter Modelica.SIunits.Volume Vfi(fixed=false)
                                                        "Volume of the filter";
      parameter Modelica.SIunits.MassFlowRate mAir1_start(fixed=false)
                                                                      "Inlet water mass flow";
      parameter Modelica.SIunits.Temperature TWater2_start(fixed=false)
                                                                       "Start value for the outlet water";
      parameter Modelica.SIunits.Temperature TAir2_start(fixed=false)
                                                                     "Start value for the outlet water";
      parameter Modelica.SIunits.MassFraction H2_start(fixed=false)
                                                                   "Outlet Air absolute humidity";
      parameter Modelica.SIunits.Temperature _Tfi_start = 288.15;
      Modelica.SIunits.Temperature Tfi(start = _Tfi_start);
      Real Tfi_der(unit = "K/s");
      parameter Real C_iner(unit = "J/K", fixed=false)
                                                      "Constant defining the thermal inertia of the filter";
    end openHTX_rec;
  public
    openHTX_rec openHTX annotation(Dialog);
  protected
    record port_a_air_rec
      Modelica.Media.Interfaces.PartialMedium.MassFlowRate m_flow(quantity = "MassFlowRate.Moist air", min = 0.0)
                                                                                                                 "Mass flow rate from the connection point into the component";
      constant Modelica.Media.Interfaces.Types.AbsolutePressure p = 101325.0
                                                                            "Thermodynamic pressure in the connection point";
      Modelica.Media.Interfaces.Types.SpecificEnthalpy h_outflow
                                                                "Specific thermodynamic enthalpy close to the connection point if m_flow < 0";
      Modelica.Media.Interfaces.Types.MassFraction 'Xi_outflow[1]'
                                                                  "Independent mixture mass fractions m_i/m close to the connection point if m_flow < 0";
    end port_a_air_rec;
  public
    port_a_air_rec port_a_air;
  protected
    record port_b_air_rec
      Modelica.Media.Interfaces.PartialMedium.MassFlowRate m_flow(quantity = "MassFlowRate.Moist air", max = 0.0)
                                                                                                                 "Mass flow rate from the connection point into the component";
      Modelica.Media.Interfaces.Types.AbsolutePressure p
                                                        "Thermodynamic pressure in the connection point";
      Modelica.Media.Interfaces.Types.SpecificEnthalpy h_outflow
                                                                "Specific thermodynamic enthalpy close to the connection point if m_flow < 0";
      Modelica.Media.Interfaces.Types.MassFraction 'Xi_outflow[1]'
                                                                  "Independent mixture mass fractions m_i/m close to the connection point if m_flow < 0";
    end port_b_air_rec;
  public
    port_b_air_rec port_b_air;
  protected
    record port_a_water_rec
      Modelica.Media.Interfaces.PartialMedium.MassFlowRate m_flow(quantity = "MassFlowRate.SimpleLiquidWater", min = 0.0)
                                                                                                                         "Mass flow rate from the connection point into the component";
      Modelica.Media.Interfaces.Types.AbsolutePressure p
                                                        "Thermodynamic pressure in the connection point";
      Modelica.Media.Interfaces.Types.SpecificEnthalpy h_outflow
                                                                "Specific thermodynamic enthalpy close to the connection point if m_flow < 0";
    end port_a_water_rec;
  public
    port_a_water_rec port_a_water;
  protected
    record port_b_water_rec
      Modelica.Media.Interfaces.PartialMedium.MassFlowRate m_flow(quantity = "MassFlowRate.SimpleLiquidWater", max = 0.0)
                                                                                                                         "Mass flow rate from the connection point into the component";
      Modelica.Media.Interfaces.Types.AbsolutePressure p
                                                        "Thermodynamic pressure in the connection point";
      Modelica.Media.Interfaces.Types.SpecificEnthalpy h_outflow
                                                                "Specific thermodynamic enthalpy close to the connection point if m_flow < 0";
    end port_b_water_rec;
  public
    port_b_water_rec port_b_water;
  protected
    record waterBasin_rec
      Modelica.SIunits.Height level
                                   "Level height of tank";
      Real level_der(unit = "m/s")
                                  "der(Level height of tank)";
      Modelica.SIunits.Volume V
                               "Actual tank volume";
      Real V_der(unit = "m3/s")
                               "der(Actual tank volume)";
      parameter Modelica.SIunits.Height height(fixed=false)
                                                           "Height of tank";
      parameter Modelica.SIunits.Area crossArea(fixed=false)
                                                            "Area of tank";
      constant Modelica.Media.Interfaces.Types.AbsolutePressure p_ambient = 101325.0
                                                                                    "Tank surface pressure";
      parameter Modelica.Media.Interfaces.Types.Temperature T_ambient(fixed=false)
                                                                                  "Tank surface Temperature";
      parameter Modelica.SIunits.Height level_start(fixed=false)
                                                                "Start value of tank level";
      Modelica.SIunits.Volume fluidVolume
                                         "Volume";
      constant Modelica.Fluid.Types.Dynamics energyDynamics = Modelica.Fluid.Types.Dynamics.DynamicFreeInitial
                                                                                                              "Formulation of energy balance";
      constant Modelica.Fluid.Types.Dynamics massDynamics = Modelica.Fluid.Types.Dynamics.DynamicFreeInitial
                                                                                                            "Formulation of mass balance";
      constant Modelica.Fluid.Types.Dynamics substanceDynamics = Modelica.Fluid.Types.Dynamics.DynamicFreeInitial
                                                                                                                 "Formulation of substance balance";
      constant Modelica.Fluid.Types.Dynamics traceDynamics = Modelica.Fluid.Types.Dynamics.DynamicFreeInitial
                                                                                                             "Formulation of trace substance balance";
      constant Modelica.Media.Interfaces.Types.AbsolutePressure p_start = 101325.0
                                                                                  "Start value of pressure";
      constant Boolean use_T_start = true
                                         "= true, use T_start, otherwise h_start";
      parameter Modelica.Media.Interfaces.Types.Temperature T_start(fixed=false)
                                                                                "Start value of temperature";
      parameter Modelica.Media.Interfaces.Types.SpecificEnthalpy h_start(fixed=false)
                                                                                     "Start value of specific enthalpy";
      parameter Modelica.Media.Interfaces.Types.MassFraction 'X_start[1]' = 1.0
                                                                               "Start value of mass fractions m_i/m";
    protected
      record medium_rec
        constant Real p(unit = "Pa", displayUnit = "bar", nominal = 100000.0, quantity = "Pressure", min = 0.0) = 101325.0
                                                                                                                          "Absolute pressure of medium";
        Real h(unit = "J/kg", quantity = "SpecificEnergy")
                                                          "Specific enthalpy of medium";
        constant Modelica.Media.Interfaces.Types.Density d = 995.586
                                                                    "Density of medium";
        Modelica.Media.Interfaces.Types.Temperature T
                                                     "Temperature of medium";
        Real T_der(unit = "K/s")
                                "der(Temperature of medium)";
        constant Modelica.Media.Interfaces.Types.MassFraction 'X[1]' = 1.0
                                                                          "Mass fractions (= (component mass)/total mass  m_i/m)";
        Modelica.Media.Interfaces.Types.SpecificInternalEnergy u
                                                                "Specific internal energy of medium";
        Real u_der(unit = "m2/s3")
                                  "der(Specific internal energy of medium)";
        constant Modelica.Media.Interfaces.Types.SpecificHeatCapacity R = 0
                                                                           "Gas constant (of mixture if applicable)";
        constant Modelica.Media.Interfaces.Types.MolarMass MM = 0.018015268
                                                                           "Molar mass (of mixture or single fluid)";
      protected
        record state_rec
          constant Modelica.Media.Interfaces.Types.AbsolutePressure p = 101325.0
                                                                                "Absolute pressure of medium";
          Modelica.Media.Interfaces.Types.Temperature T
                                                       "Temperature of medium";
        end state_rec;
      public
        state_rec state;
        constant Boolean preferredMediumStates = true
                                                     "= true if StateSelect.prefer shall be used for the independent property variables of the medium";
        constant Boolean standardOrderComponents = true
                                                       "If true, and reducedX = true, the last element of X will be computed from the other ones";
        Modelica.SIunits.Conversions.NonSIunits.Temperature_degC T_degC
                                                                       "Temperature of medium in [degC]";
        constant Modelica.SIunits.Conversions.NonSIunits.Pressure_bar p_bar = 1.01325
                                                                                     "Absolute pressure of medium in [bar]";
      end medium_rec;
    public
      medium_rec medium;
      Modelica.SIunits.Energy U
                               "Internal energy of fluid";
      Real U_der(unit = "W")
                            "der(Internal energy of fluid)";
      Modelica.SIunits.Mass m
                             "Mass of fluid";
      Real m_der(unit = "kg/s")
                               "der(Mass of fluid)";
      Modelica.SIunits.MassFlowRate mb_flow
                                           "Mass flows across boundaries";
      Modelica.SIunits.EnthalpyFlowRate Hb_flow
                                               "Enthalpy flow across boundaries or energy source/sink";
      Modelica.SIunits.HeatFlowRate Qb_flow
                                           "Heat flow across boundaries or energy source/sink";
      constant Modelica.SIunits.Power Wb_flow = 0
                                                 "Work flow across boundaries or source term";
      constant Integer nPorts = 3
                                 "Number of ports";
    protected
      record 'ports[1]_rec'
        Modelica.Media.Interfaces.PartialMedium.MassFlowRate m_flow(quantity = "MassFlowRate.SimpleLiquidWater")
                                                                                                                "Mass flow rate from the connection point into the component";
        Modelica.Media.Interfaces.Types.AbsolutePressure p
                                                          "Thermodynamic pressure in the connection point";
        Modelica.Media.Interfaces.Types.SpecificEnthalpy h_outflow
                                                                  "Specific thermodynamic enthalpy close to the connection point if m_flow < 0";
      end 'ports[1]_rec';
    public
      'ports[1]_rec' 'ports[1]';
    protected
      record 'ports[2]_rec'
        Modelica.Media.Interfaces.PartialMedium.MassFlowRate m_flow(quantity = "MassFlowRate.SimpleLiquidWater")
                                                                                                                "Mass flow rate from the connection point into the component";
        Modelica.Media.Interfaces.Types.AbsolutePressure p
                                                          "Thermodynamic pressure in the connection point";
        Modelica.Media.Interfaces.Types.SpecificEnthalpy h_outflow
                                                                  "Specific thermodynamic enthalpy close to the connection point if m_flow < 0";
      end 'ports[2]_rec';
    public
      'ports[2]_rec' 'ports[2]';
    protected
      record 'ports[3]_rec'
        Modelica.Media.Interfaces.PartialMedium.MassFlowRate m_flow(quantity = "MassFlowRate.SimpleLiquidWater")
                                                                                                                "Mass flow rate from the connection point into the component";
        Modelica.Media.Interfaces.Types.AbsolutePressure p
                                                          "Thermodynamic pressure in the connection point";
        Modelica.Media.Interfaces.Types.SpecificEnthalpy h_outflow
                                                                  "Specific thermodynamic enthalpy close to the connection point if m_flow < 0";
      end 'ports[3]_rec';
    public
      'ports[3]_rec' 'ports[3]';
      constant Boolean use_portsData = true
                                           "= false to neglect pressure loss and kinetic energy";
    protected
      record 'portsData[1]_rec'
        parameter Modelica.SIunits.Diameter diameter = 0.5
                                                          "Inner (hydraulic) diameter of inlet/outlet port";
        parameter Modelica.SIunits.Height height = 0.0
                                                      "Height over the bottom of the vessel";
        parameter Real zeta_out(min = 0.0) = 0.5
                                                "Hydraulic resistance out of vessel, default 0.5 for small diameter mounted flush with the wall";
        parameter Real zeta_in(min = 0.0) = 1.04
                                                "Hydraulic resistance into vessel, default 1.04 for small diameter mounted flush with the wall";
      end 'portsData[1]_rec';
    public
      'portsData[1]_rec' 'portsData[1]' annotation(Dialog);
    protected
      record 'portsData[2]_rec'
        parameter Modelica.SIunits.Diameter diameter = 0.5
                                                          "Inner (hydraulic) diameter of inlet/outlet port";
        parameter Modelica.SIunits.Height height = 0.0
                                                      "Height over the bottom of the vessel";
        parameter Real zeta_out(min = 0.0) = 0.5
                                                "Hydraulic resistance out of vessel, default 0.5 for small diameter mounted flush with the wall";
        parameter Real zeta_in(min = 0.0) = 1.04
                                                "Hydraulic resistance into vessel, default 1.04 for small diameter mounted flush with the wall";
      end 'portsData[2]_rec';
    public
      'portsData[2]_rec' 'portsData[2]' annotation(Dialog);
    protected
      record 'portsData[3]_rec'
        parameter Modelica.SIunits.Diameter diameter(fixed=false)
                                                                 "Inner (hydraulic) diameter of inlet/outlet port";
        parameter Modelica.SIunits.Height height(fixed=false)
                                                             "Height over the bottom of the vessel";
        parameter Real zeta_out(min = 0.0) = 0.5
                                                "Hydraulic resistance out of vessel, default 0.5 for small diameter mounted flush with the wall";
        parameter Real zeta_in(min = 0.0) = 1.04
                                                "Hydraulic resistance into vessel, default 1.04 for small diameter mounted flush with the wall";
      end 'portsData[3]_rec';
    public
      'portsData[3]_rec' 'portsData[3]' annotation(Dialog);
      parameter Modelica.Media.Interfaces.PartialMedium.MassFlowRate m_flow_nominal(quantity = "MassFlowRate.SimpleLiquidWater", fixed=false)
                                                                                                                                             "Nominal value for mass flow rates in ports";
      parameter Modelica.SIunits.MassFlowRate m_flow_small(min = 0.0, fixed=false)
                                                                                  "Regularization range at zero mass flow rate";
      constant Boolean use_Re = false
                                     "= true, if turbulent region is defined by Re, otherwise by m_flow_small";
      Modelica.Media.Interfaces.Types.EnthalpyFlowRate 'ports_H_flow[1]';
      Modelica.Media.Interfaces.Types.EnthalpyFlowRate 'ports_H_flow[2]';
      Modelica.Media.Interfaces.Types.EnthalpyFlowRate 'ports_H_flow[3]';
      constant Boolean use_HeatTransfer = true
                                              "= true to use the HeatTransfer model";
    protected
      record heatTransfer_rec
        constant Integer n = 1
                              "Number of heat transfer segments";
      protected
        record 'states[1]_rec'
          constant Modelica.Media.Interfaces.Types.AbsolutePressure p = 101325.0
                                                                                "Absolute pressure of medium";
          Modelica.Media.Interfaces.Types.Temperature T
                                                       "Temperature of medium";
        end 'states[1]_rec';
      public
        'states[1]_rec' 'states[1]';
        Modelica.SIunits.Area 'surfaceAreas[1]'
                                               "Heat transfer areas";
        Modelica.SIunits.HeatFlowRate 'Q_flows[1]'
                                                  "Heat flow rates";
        constant Boolean use_k = true
                                     "= true to use k value for thermal isolation";
        constant Modelica.SIunits.CoefficientOfHeatTransfer k = 0
                                                                 "Heat transfer coefficient to ambient";
        parameter Modelica.SIunits.Temperature T_ambient(fixed=false)
                                                                     "Ambient temperature";
      protected
        record 'heatPorts[1]_rec'
          Modelica.SIunits.Temperature T
                                        "Port temperature";
          Modelica.SIunits.HeatFlowRate Q_flow
                                              "Heat flow rate (positive if flowing from outside into the component)";
        end 'heatPorts[1]_rec';
      public
        'heatPorts[1]_rec' 'heatPorts[1]';
        Modelica.SIunits.Temperature 'Ts[1]'
                                            "Temperatures defined by fluid states";
      end heatTransfer_rec;
    public
      heatTransfer_rec heatTransfer;
    protected
      record heatPort_rec
        Modelica.SIunits.Temperature T
                                      "Port temperature";
        Modelica.SIunits.HeatFlowRate Q_flow
                                            "Heat flow rate (positive if flowing from outside into the component)";
      end heatPort_rec;
    public
      heatPort_rec heatPort;
      constant Modelica.Media.Interfaces.Types.Density 'portInDensities[1]' = 995.586
                                                                                     "densities of the fluid at the device boundary";
      constant Modelica.Media.Interfaces.Types.Density 'portInDensities[2]' = 995.586
                                                                                     "densities of the fluid at the device boundary";
      constant Modelica.Media.Interfaces.Types.Density 'portInDensities[3]' = 995.586
                                                                                     "densities of the fluid at the device boundary";
      Modelica.SIunits.Velocity 'portVelocities[1]'
                                                   "velocities of fluid flow at device boundary";
      Modelica.SIunits.Velocity 'portVelocities[2]'
                                                   "velocities of fluid flow at device boundary";
      Modelica.SIunits.Velocity 'portVelocities[3]'
                                                   "velocities of fluid flow at device boundary";
      Modelica.SIunits.EnergyFlowRate 'ports_E_flow[1]'
                                                       "flow of kinetic and potential energy at device boundary";
      Modelica.SIunits.EnergyFlowRate 'ports_E_flow[2]'
                                                       "flow of kinetic and potential energy at device boundary";
      Modelica.SIunits.EnergyFlowRate 'ports_E_flow[3]'
                                                       "flow of kinetic and potential energy at device boundary";
      Real 's[1]'(unit = "m")
                             "curve parameters for port flows vs. port pressures; for further details see, Modelica Tutorial: Ideal switching devices";
      Real 's[2]'(unit = "m")
                             "curve parameters for port flows vs. port pressures; for further details see, Modelica Tutorial: Ideal switching devices";
      Real 's[3]'(unit = "m")
                             "curve parameters for port flows vs. port pressures; for further details see, Modelica Tutorial: Ideal switching devices";
      Real 'ports_penetration[1]'
                                 "penetration of port with fluid, depending on fluid level and port diameter";
      Real 'ports_penetration[2]'
                                 "penetration of port with fluid, depending on fluid level and port diameter";
      Real 'ports_penetration[3]'
                                 "penetration of port with fluid, depending on fluid level and port diameter";
      parameter Modelica.SIunits.Area 'portAreas[1]'(fixed=false);
      parameter Modelica.SIunits.Area 'portAreas[2]'(fixed=false);
      parameter Modelica.SIunits.Area 'portAreas[3]'(fixed=false);
      Modelica.Media.Interfaces.Types.AbsolutePressure 'vessel_ps_static[1]'
                                                                            "static pressures inside the vessel at the height of the corresponding ports, zero flow velocity";
      Modelica.Media.Interfaces.Types.AbsolutePressure 'vessel_ps_static[2]'
                                                                            "static pressures inside the vessel at the height of the corresponding ports, zero flow velocity";
      Modelica.Media.Interfaces.Types.AbsolutePressure 'vessel_ps_static[3]'
                                                                            "static pressures inside the vessel at the height of the corresponding ports, zero flow velocity";
      constant Modelica.SIunits.ReynoldsNumber Re_turbulent = 100
                                                                 "cf. suddenExpansion";
      Modelica.SIunits.MassFlowRate 'm_flow_turbulent[1]';
      Modelica.SIunits.MassFlowRate 'm_flow_turbulent[2]';
      Modelica.SIunits.MassFlowRate 'm_flow_turbulent[3]';
    end waterBasin_rec;
  public
    waterBasin_rec waterBasin annotation(Dialog);
  protected
    record naturalConvectionVerticalPlate_rec
      Modelica.SIunits.HeatFlowRate Q_flow
                                          "Heat flow rate from solid -> fluid";
      Modelica.SIunits.TemperatureDifference dT
                                               "= solid.T - fluid.T";
    protected
      record solid_rec
        Modelica.SIunits.Temperature T
                                      "Port temperature";
        Modelica.SIunits.HeatFlowRate Q_flow
                                            "Heat flow rate (positive if flowing from outside into the component)";
      end solid_rec;
    public
      solid_rec solid;
    protected
      record fluid_rec
        Modelica.SIunits.Temperature T
                                      "Port temperature";
        Modelica.SIunits.HeatFlowRate Q_flow
                                            "Heat flow rate (positive if flowing from outside into the component)";
      end fluid_rec;
    public
      fluid_rec fluid;
      Real Gc(unit = "W/K")
                           "Convective thermal conductance in [W/K]";
      Modelica.SIunits.CoefficientOfHeatTransfer h
                                                  "Convection heat transfer coefficient";
      Modelica_Blocks_Interfaces_RealInput A(unit = "m2");
      Modelica.SIunits.CubicExpansionCoefficient beta;
      Modelica.SIunits.GrashofNumber Gr;
      Modelica.SIunits.RayleighNumber Ra;
      Modelica.SIunits.NusseltNumber NuL;
      Modelica.SIunits.NusseltNumber NuL1;
      Modelica.SIunits.NusseltNumber NuL2;
      Modelica.SIunits.PrandtlNumber Pr;
      Modelica.SIunits.KinematicViscosity visco;
      Modelica.SIunits.ThermalConductivity K;
      Modelica.SIunits.Temp_K Tc
                                "Average temperature solid-fluid, characteristic temperature for correlation";
      parameter Modelica.SIunits.Length L(fixed=false)
                                                      "Characteristic length, length of the plate";
    end naturalConvectionVerticalPlate_rec;
  public
    naturalConvectionVerticalPlate_rec naturalConvectionVerticalPlate;
  protected
    record port_a_floor_rec
      Modelica.SIunits.Temperature T
                                    "Port temperature";
      Modelica.SIunits.HeatFlowRate Q_flow
                                          "Heat flow rate (positive if flowing from outside into the component)";
    end port_a_floor_rec;
  public
    port_a_floor_rec port_a_floor;
  protected
    record port_a_Owater_rec
      Modelica.Media.Interfaces.PartialMedium.MassFlowRate m_flow(quantity = "MassFlowRate.SimpleLiquidWater", min = 0.0)
                                                                                                                         "Mass flow rate from the connection point into the component";
      Modelica.Media.Interfaces.Types.AbsolutePressure p
                                                        "Thermodynamic pressure in the connection point";
      Modelica.Media.Interfaces.Types.SpecificEnthalpy h_outflow
                                                                "Specific thermodynamic enthalpy close to the connection point if m_flow < 0";
    end port_a_Owater_rec;
  public
    port_a_Owater_rec port_a_Owater;
  protected
    record A_rec
      Modelica_Blocks_Interfaces_RealOutput y(unit = "m2")
                                                          "Value of Real output";
    end A_rec;
  public
    A_rec A;
    Modelica_Blocks_Interfaces_RealOutput level(unit = "m")
                                                           "Level of the water in the waterBasin";
  protected
    record storageWall_rec
      parameter Modelica.SIunits.Temperature T_Wall_start(fixed=false)
                                                                      "Start temperature of the storage walls";
      parameter Modelica.SIunits.Length h(fixed=false)
                                                      "Height of the storage";
      parameter Modelica.SIunits.Length w(fixed=false)
                                                      "Width of the storage";
      parameter Modelica.SIunits.Length l(fixed=false)
                                                      "Length of the storage";
      parameter Modelica.SIunits.Length e(fixed=false)
                                                      "Thicknes of the storages wall";
    protected
      record 'sideInertia[1]_rec'
        Modelica.SIunits.Temperature T
                                      "Temperature of element";
        Real T_der(unit = "K/s")
                                "der(Temperature of element)";
        Modelica.SIunits.HeatFlowRate Q_flow;
        parameter Modelica.SIunits.Temperature T_start = 293.15
                                                               "Start temperature for the average temperature of ellement";
      protected
        record port_rec
          Modelica.SIunits.Temperature T
                                        "Port temperature";
          Modelica.SIunits.HeatFlowRate Q_flow
                                              "Heat flow rate (positive if flowing from outside into the component)";
        end port_rec;
      public
        port_rec port;
        parameter Modelica.SIunits.Volume V(fixed=false)
                                                        "Volume of element";
        parameter Modelica.SIunits.Mass m(fixed=false)
                                                      "Mass of element";
        Modelica.SIunits.TemperatureSlope der_T
                                               "Time derivative of temperature (= der(T))";
        Modelica.SIunits.HeatCapacity C
                                       "Heat capacity of element (= cp*m)";
        parameter Modelica.SIunits.TemperatureSlope der_T_start = 0
                                                                   "Start value ofime derivative of temperature (= der(T))";
      end 'sideInertia[1]_rec';
    public
      'sideInertia[1]_rec' 'sideInertia[1]' annotation(Dialog);
    protected
      record 'sideInertia[2]_rec'
        Modelica.SIunits.Temperature T
                                      "Temperature of element";
        Real T_der(unit = "K/s")
                                "der(Temperature of element)";
        Modelica.SIunits.HeatFlowRate Q_flow;
        parameter Modelica.SIunits.Temperature T_start = 293.15
                                                               "Start temperature for the average temperature of ellement";
      protected
        record port_rec
          Modelica.SIunits.Temperature T
                                        "Port temperature";
          Modelica.SIunits.HeatFlowRate Q_flow
                                              "Heat flow rate (positive if flowing from outside into the component)";
        end port_rec;
      public
        port_rec port;
        parameter Modelica.SIunits.Volume V(fixed=false)
                                                        "Volume of element";
        parameter Modelica.SIunits.Mass m(fixed=false)
                                                      "Mass of element";
        Modelica.SIunits.TemperatureSlope der_T
                                               "Time derivative of temperature (= der(T))";
        Modelica.SIunits.HeatCapacity C
                                       "Heat capacity of element (= cp*m)";
        parameter Modelica.SIunits.TemperatureSlope der_T_start = 0
                                                                   "Start value ofime derivative of temperature (= der(T))";
      end 'sideInertia[2]_rec';
    public
      'sideInertia[2]_rec' 'sideInertia[2]' annotation(Dialog);
    protected
      record topInertia_rec
        Modelica.SIunits.Temperature T
                                      "Temperature of element";
        Real T_der(unit = "K/s")
                                "der(Temperature of element)";
        Modelica.SIunits.HeatFlowRate Q_flow;
        parameter Modelica.SIunits.Temperature T_start = 293.15
                                                               "Start temperature for the average temperature of ellement";
      protected
        record port_rec
          Modelica.SIunits.Temperature T
                                        "Port temperature";
          Modelica.SIunits.HeatFlowRate Q_flow
                                              "Heat flow rate (positive if flowing from outside into the component)";
        end port_rec;
      public
        port_rec port;
        parameter Modelica.SIunits.Volume V(fixed=false)
                                                        "Volume of element";
        parameter Modelica.SIunits.Mass m(fixed=false)
                                                      "Mass of element";
        Modelica.SIunits.TemperatureSlope der_T
                                               "Time derivative of temperature (= der(T))";
        Modelica.SIunits.HeatCapacity C
                                       "Heat capacity of element (= cp*m)";
        parameter Modelica.SIunits.TemperatureSlope der_T_start = 0
                                                                   "Start value ofime derivative of temperature (= der(T))";
      end topInertia_rec;
    public
      topInertia_rec topInertia annotation(Dialog);
    protected
      record 'sideCond2[1]_rec'
        Modelica.SIunits.HeatFlowRate Q_flow
                                            "Heat flow rate from port_a -> port_b";
        Modelica.SIunits.TemperatureDifference dT
                                                 "port_a.T - port_b.T";
      protected
        record port_a_rec
          Modelica.SIunits.Temperature T
                                        "Port temperature";
          Modelica.SIunits.HeatFlowRate Q_flow
                                              "Heat flow rate (positive if flowing from outside into the component)";
        end port_a_rec;
      public
        port_a_rec port_a;
      protected
        record port_b_rec
          Modelica.SIunits.Temperature T
                                        "Port temperature";
          Modelica.SIunits.HeatFlowRate Q_flow
                                              "Heat flow rate (positive if flowing from outside into the component)";
        end port_b_rec;
      public
        port_b_rec port_b;
        Modelica.SIunits.Temperature T
                                      "Average temperature of element";
        parameter Modelica.SIunits.Temperature T_start = 293.15
                                                               "Start temperature for the average temperature of element";
        Modelica.SIunits.ThermalConductance G
                                             "Thermal conductance of material";
        Modelica.SIunits.ThermalConductivity k
                                              "Thermal conductivity";
        parameter Modelica.SIunits.Length L(fixed=false)
                                                        "length of conduction";
        parameter Modelica.SIunits.Area A(fixed=false)
                                                      "Heat transfer area";
      end 'sideCond2[1]_rec';
    public
      'sideCond2[1]_rec' 'sideCond2[1]' annotation(Dialog);
    protected
      record 'sideCond2[2]_rec'
        Modelica.SIunits.HeatFlowRate Q_flow
                                            "Heat flow rate from port_a -> port_b";
        Modelica.SIunits.TemperatureDifference dT
                                                 "port_a.T - port_b.T";
      protected
        record port_a_rec
          Modelica.SIunits.Temperature T
                                        "Port temperature";
          Modelica.SIunits.HeatFlowRate Q_flow
                                              "Heat flow rate (positive if flowing from outside into the component)";
        end port_a_rec;
      public
        port_a_rec port_a;
      protected
        record port_b_rec
          Modelica.SIunits.Temperature T
                                        "Port temperature";
          Modelica.SIunits.HeatFlowRate Q_flow
                                              "Heat flow rate (positive if flowing from outside into the component)";
        end port_b_rec;
      public
        port_b_rec port_b;
        Modelica.SIunits.Temperature T
                                      "Average temperature of element";
        parameter Modelica.SIunits.Temperature T_start = 293.15
                                                               "Start temperature for the average temperature of element";
        Modelica.SIunits.ThermalConductance G
                                             "Thermal conductance of material";
        Modelica.SIunits.ThermalConductivity k
                                              "Thermal conductivity";
        parameter Modelica.SIunits.Length L(fixed=false)
                                                        "length of conduction";
        parameter Modelica.SIunits.Area A(fixed=false)
                                                      "Heat transfer area";
      end 'sideCond2[2]_rec';
    public
      'sideCond2[2]_rec' 'sideCond2[2]' annotation(Dialog);
    protected
      record 'sideCond1[1]_rec'
        Modelica.SIunits.HeatFlowRate Q_flow
                                            "Heat flow rate from port_a -> port_b";
        Modelica.SIunits.TemperatureDifference dT
                                                 "port_a.T - port_b.T";
      protected
        record port_a_rec
          Modelica.SIunits.Temperature T
                                        "Port temperature";
          Modelica.SIunits.HeatFlowRate Q_flow
                                              "Heat flow rate (positive if flowing from outside into the component)";
        end port_a_rec;
      public
        port_a_rec port_a;
      protected
        record port_b_rec
          Modelica.SIunits.Temperature T
                                        "Port temperature";
          Modelica.SIunits.HeatFlowRate Q_flow
                                              "Heat flow rate (positive if flowing from outside into the component)";
        end port_b_rec;
      public
        port_b_rec port_b;
        Modelica.SIunits.Temperature T
                                      "Average temperature of element";
        parameter Modelica.SIunits.Temperature T_start = 293.15
                                                               "Start temperature for the average temperature of element";
        Modelica.SIunits.ThermalConductance G
                                             "Thermal conductance of material";
        Modelica.SIunits.ThermalConductivity k
                                              "Thermal conductivity";
        parameter Modelica.SIunits.Length L(fixed=false)
                                                        "length of conduction";
        parameter Modelica.SIunits.Area A(fixed=false)
                                                      "Heat transfer area";
      end 'sideCond1[1]_rec';
    public
      'sideCond1[1]_rec' 'sideCond1[1]' annotation(Dialog);
    protected
      record 'sideCond1[2]_rec'
        Modelica.SIunits.HeatFlowRate Q_flow
                                            "Heat flow rate from port_a -> port_b";
        Modelica.SIunits.TemperatureDifference dT
                                                 "port_a.T - port_b.T";
      protected
        record port_a_rec
          Modelica.SIunits.Temperature T
                                        "Port temperature";
          Modelica.SIunits.HeatFlowRate Q_flow
                                              "Heat flow rate (positive if flowing from outside into the component)";
        end port_a_rec;
      public
        port_a_rec port_a;
      protected
        record port_b_rec
          Modelica.SIunits.Temperature T
                                        "Port temperature";
          Modelica.SIunits.HeatFlowRate Q_flow
                                              "Heat flow rate (positive if flowing from outside into the component)";
        end port_b_rec;
      public
        port_b_rec port_b;
        Modelica.SIunits.Temperature T
                                      "Average temperature of element";
        parameter Modelica.SIunits.Temperature T_start = 293.15
                                                               "Start temperature for the average temperature of element";
        Modelica.SIunits.ThermalConductance G
                                             "Thermal conductance of material";
        Modelica.SIunits.ThermalConductivity k
                                              "Thermal conductivity";
        parameter Modelica.SIunits.Length L(fixed=false)
                                                        "length of conduction";
        parameter Modelica.SIunits.Area A(fixed=false)
                                                      "Heat transfer area";
      end 'sideCond1[2]_rec';
    public
      'sideCond1[2]_rec' 'sideCond1[2]' annotation(Dialog);
    protected
      record topCond1_rec
        Modelica.SIunits.HeatFlowRate Q_flow
                                            "Heat flow rate from port_a -> port_b";
        Modelica.SIunits.TemperatureDifference dT
                                                 "port_a.T - port_b.T";
      protected
        record port_a_rec
          Modelica.SIunits.Temperature T
                                        "Port temperature";
          Modelica.SIunits.HeatFlowRate Q_flow
                                              "Heat flow rate (positive if flowing from outside into the component)";
        end port_a_rec;
      public
        port_a_rec port_a;
      protected
        record port_b_rec
          Modelica.SIunits.Temperature T
                                        "Port temperature";
          Modelica.SIunits.HeatFlowRate Q_flow
                                              "Heat flow rate (positive if flowing from outside into the component)";
        end port_b_rec;
      public
        port_b_rec port_b;
        Modelica.SIunits.Temperature T
                                      "Average temperature of element";
        parameter Modelica.SIunits.Temperature T_start = 293.15
                                                               "Start temperature for the average temperature of element";
        Modelica.SIunits.ThermalConductance G
                                             "Thermal conductance of material";
        Modelica.SIunits.ThermalConductivity k
                                              "Thermal conductivity";
        parameter Modelica.SIunits.Length L(fixed=false)
                                                        "length of conduction";
        parameter Modelica.SIunits.Area A(fixed=false)
                                                      "Heat transfer area";
      end topCond1_rec;
    public
      topCond1_rec topCond1 annotation(Dialog);
    protected
      record topCond2_rec
        Modelica.SIunits.HeatFlowRate Q_flow
                                            "Heat flow rate from port_a -> port_b";
        Modelica.SIunits.TemperatureDifference dT
                                                 "port_a.T - port_b.T";
      protected
        record port_a_rec
          Modelica.SIunits.Temperature T
                                        "Port temperature";
          Modelica.SIunits.HeatFlowRate Q_flow
                                              "Heat flow rate (positive if flowing from outside into the component)";
        end port_a_rec;
      public
        port_a_rec port_a;
      protected
        record port_b_rec
          Modelica.SIunits.Temperature T
                                        "Port temperature";
          Modelica.SIunits.HeatFlowRate Q_flow
                                              "Heat flow rate (positive if flowing from outside into the component)";
        end port_b_rec;
      public
        port_b_rec port_b;
        Modelica.SIunits.Temperature T
                                      "Average temperature of element";
        parameter Modelica.SIunits.Temperature T_start = 293.15
                                                               "Start temperature for the average temperature of element";
        Modelica.SIunits.ThermalConductance G
                                             "Thermal conductance of material";
        Modelica.SIunits.ThermalConductivity k
                                              "Thermal conductivity";
        parameter Modelica.SIunits.Length L(fixed=false)
                                                        "length of conduction";
        parameter Modelica.SIunits.Area A(fixed=false)
                                                      "Heat transfer area";
      end topCond2_rec;
    public
      topCond2_rec topCond2 annotation(Dialog);
    protected
      record T_water_rec
        Modelica.SIunits.Temperature T
                                      "Port temperature";
        Modelica.SIunits.HeatFlowRate Q_flow
                                            "Heat flow rate (positive if flowing from outside into the component)";
      end T_water_rec;
    public
      T_water_rec T_water;
    protected
      record ambient_rec
        Modelica.SIunits.Temperature T
                                      "Port temperature";
        Modelica.SIunits.HeatFlowRate Q_flow
                                            "Heat flow rate (positive if flowing from outside into the component)";
      end ambient_rec;
    public
      ambient_rec ambient;
    protected
      record 'frontInertia[1]_rec'
        Modelica.SIunits.Temperature T
                                      "Temperature of element";
        Real T_der(unit = "K/s")
                                "der(Temperature of element)";
        Modelica.SIunits.HeatFlowRate Q_flow;
        parameter Modelica.SIunits.Temperature T_start = 293.15
                                                               "Start temperature for the average temperature of ellement";
      protected
        record port_rec
          Modelica.SIunits.Temperature T
                                        "Port temperature";
          Modelica.SIunits.HeatFlowRate Q_flow
                                              "Heat flow rate (positive if flowing from outside into the component)";
        end port_rec;
      public
        port_rec port;
        parameter Modelica.SIunits.Volume V(fixed=false)
                                                        "Volume of element";
        parameter Modelica.SIunits.Mass m(fixed=false)
                                                      "Mass of element";
        Modelica.SIunits.TemperatureSlope der_T
                                               "Time derivative of temperature (= der(T))";
        Modelica.SIunits.HeatCapacity C
                                       "Heat capacity of element (= cp*m)";
        parameter Modelica.SIunits.TemperatureSlope der_T_start = 0
                                                                   "Start value ofime derivative of temperature (= der(T))";
      end 'frontInertia[1]_rec';
    public
      'frontInertia[1]_rec' 'frontInertia[1]' annotation(Dialog);
    protected
      record 'frontInertia[2]_rec'
        Modelica.SIunits.Temperature T
                                      "Temperature of element";
        Real T_der(unit = "K/s")
                                "der(Temperature of element)";
        Modelica.SIunits.HeatFlowRate Q_flow;
        parameter Modelica.SIunits.Temperature T_start = 293.15
                                                               "Start temperature for the average temperature of ellement";
      protected
        record port_rec
          Modelica.SIunits.Temperature T
                                        "Port temperature";
          Modelica.SIunits.HeatFlowRate Q_flow
                                              "Heat flow rate (positive if flowing from outside into the component)";
        end port_rec;
      public
        port_rec port;
        parameter Modelica.SIunits.Volume V(fixed=false)
                                                        "Volume of element";
        parameter Modelica.SIunits.Mass m(fixed=false)
                                                      "Mass of element";
        Modelica.SIunits.TemperatureSlope der_T
                                               "Time derivative of temperature (= der(T))";
        Modelica.SIunits.HeatCapacity C
                                       "Heat capacity of element (= cp*m)";
        parameter Modelica.SIunits.TemperatureSlope der_T_start = 0
                                                                   "Start value ofime derivative of temperature (= der(T))";
      end 'frontInertia[2]_rec';
    public
      'frontInertia[2]_rec' 'frontInertia[2]' annotation(Dialog);
    protected
      record 'frontCond1[1]_rec'
        Modelica.SIunits.HeatFlowRate Q_flow
                                            "Heat flow rate from port_a -> port_b";
        Modelica.SIunits.TemperatureDifference dT
                                                 "port_a.T - port_b.T";
      protected
        record port_a_rec
          Modelica.SIunits.Temperature T
                                        "Port temperature";
          Modelica.SIunits.HeatFlowRate Q_flow
                                              "Heat flow rate (positive if flowing from outside into the component)";
        end port_a_rec;
      public
        port_a_rec port_a;
      protected
        record port_b_rec
          Modelica.SIunits.Temperature T
                                        "Port temperature";
          Modelica.SIunits.HeatFlowRate Q_flow
                                              "Heat flow rate (positive if flowing from outside into the component)";
        end port_b_rec;
      public
        port_b_rec port_b;
        Modelica.SIunits.Temperature T
                                      "Average temperature of element";
        parameter Modelica.SIunits.Temperature T_start = 293.15
                                                               "Start temperature for the average temperature of element";
        Modelica.SIunits.ThermalConductance G
                                             "Thermal conductance of material";
        Modelica.SIunits.ThermalConductivity k
                                              "Thermal conductivity";
        parameter Modelica.SIunits.Length L(fixed=false)
                                                        "length of conduction";
        parameter Modelica.SIunits.Area A(fixed=false)
                                                      "Heat transfer area";
      end 'frontCond1[1]_rec';
    public
      'frontCond1[1]_rec' 'frontCond1[1]' annotation(Dialog);
    protected
      record 'frontCond1[2]_rec'
        constant Modelica.SIunits.HeatFlowRate Q_flow = 0.0
                                                           "Heat flow rate from port_a -> port_b";
        Modelica.SIunits.TemperatureDifference dT
                                                 "port_a.T - port_b.T";
      protected
        record port_a_rec
          Modelica.SIunits.Temperature T
                                        "Port temperature";
          constant Modelica.SIunits.HeatFlowRate Q_flow = 0.0
                                                             "Heat flow rate (positive if flowing from outside into the component)";
        end port_a_rec;
      public
        port_a_rec port_a;
      protected
        record port_b_rec
          Modelica.SIunits.Temperature T
                                        "Port temperature";
          constant Modelica.SIunits.HeatFlowRate Q_flow = 0.0
                                                             "Heat flow rate (positive if flowing from outside into the component)";
        end port_b_rec;
      public
        port_b_rec port_b;
        Modelica.SIunits.Temperature T
                                      "Average temperature of element";
        parameter Modelica.SIunits.Temperature T_start = 293.15
                                                               "Start temperature for the average temperature of element";
        Modelica.SIunits.ThermalConductance G
                                             "Thermal conductance of material";
        Modelica.SIunits.ThermalConductivity k
                                              "Thermal conductivity";
        parameter Modelica.SIunits.Length L(fixed=false)
                                                        "length of conduction";
        parameter Modelica.SIunits.Area A(fixed=false)
                                                      "Heat transfer area";
      end 'frontCond1[2]_rec';
    public
      'frontCond1[2]_rec' 'frontCond1[2]' annotation(Dialog);
    protected
      record 'frontCond2[1]_rec'
        Modelica.SIunits.HeatFlowRate Q_flow
                                            "Heat flow rate from port_a -> port_b";
        Modelica.SIunits.TemperatureDifference dT
                                                 "port_a.T - port_b.T";
      protected
        record port_a_rec
          Modelica.SIunits.Temperature T
                                        "Port temperature";
          Modelica.SIunits.HeatFlowRate Q_flow
                                              "Heat flow rate (positive if flowing from outside into the component)";
        end port_a_rec;
      public
        port_a_rec port_a;
      protected
        record port_b_rec
          Modelica.SIunits.Temperature T
                                        "Port temperature";
          Modelica.SIunits.HeatFlowRate Q_flow
                                              "Heat flow rate (positive if flowing from outside into the component)";
        end port_b_rec;
      public
        port_b_rec port_b;
        Modelica.SIunits.Temperature T
                                      "Average temperature of element";
        parameter Modelica.SIunits.Temperature T_start = 293.15
                                                               "Start temperature for the average temperature of element";
        Modelica.SIunits.ThermalConductance G
                                             "Thermal conductance of material";
        Modelica.SIunits.ThermalConductivity k
                                              "Thermal conductivity";
        parameter Modelica.SIunits.Length L(fixed=false)
                                                        "length of conduction";
        parameter Modelica.SIunits.Area A(fixed=false)
                                                      "Heat transfer area";
      end 'frontCond2[1]_rec';
    public
      'frontCond2[1]_rec' 'frontCond2[1]' annotation(Dialog);
    protected
      record 'frontCond2[2]_rec'
        Modelica.SIunits.HeatFlowRate Q_flow
                                            "Heat flow rate from port_a -> port_b";
        Modelica.SIunits.TemperatureDifference dT
                                                 "port_a.T - port_b.T";
      protected
        record port_a_rec
          Modelica.SIunits.Temperature T
                                        "Port temperature";
          Modelica.SIunits.HeatFlowRate Q_flow
                                              "Heat flow rate (positive if flowing from outside into the component)";
        end port_a_rec;
      public
        port_a_rec port_a;
      protected
        record port_b_rec
          Modelica.SIunits.Temperature T
                                        "Port temperature";
          Modelica.SIunits.HeatFlowRate Q_flow
                                              "Heat flow rate (positive if flowing from outside into the component)";
        end port_b_rec;
      public
        port_b_rec port_b;
        Modelica.SIunits.Temperature T
                                      "Average temperature of element";
        parameter Modelica.SIunits.Temperature T_start = 293.15
                                                               "Start temperature for the average temperature of element";
        Modelica.SIunits.ThermalConductance G
                                             "Thermal conductance of material";
        Modelica.SIunits.ThermalConductivity k
                                              "Thermal conductivity";
        parameter Modelica.SIunits.Length L(fixed=false)
                                                        "length of conduction";
        parameter Modelica.SIunits.Area A(fixed=false)
                                                      "Heat transfer area";
      end 'frontCond2[2]_rec';
    public
      'frontCond2[2]_rec' 'frontCond2[2]' annotation(Dialog);
    protected
      record 'floor_rec'
        Modelica.SIunits.Temperature T
                                      "Port temperature";
        Modelica.SIunits.HeatFlowRate Q_flow
                                            "Heat flow rate (positive if flowing from outside into the component)";
      end 'floor_rec';
    public
      'floor_rec' 'floor';
    end storageWall_rec;
  public
    storageWall_rec storageWall annotation(Dialog);
  protected
    record port_a_ambient_rec
      Modelica.SIunits.Temperature T
                                    "Port temperature";
      Modelica.SIunits.HeatFlowRate Q_flow
                                          "Heat flow rate (positive if flowing from outside into the component)";
    end port_a_ambient_rec;
  public
    port_a_ambient_rec port_a_ambient;
  end openCT2_rec;
public
  openCT2_rec openCT2 annotation(Dialog);
protected
  record inletWater_rec
    constant Integer nPorts = 1
                               "Number of ports";
  protected
    record medium_rec
      Real p(unit = "Pa", displayUnit = "bar", nominal = 100000.0, quantity = "Pressure", min = 0.0)
                                                                                                    "Absolute pressure of medium";
      Real h(unit = "J/kg", quantity = "SpecificEnergy")
                                                        "Specific enthalpy of medium";
      constant Modelica.Media.Interfaces.Types.Density d = 995.586
                                                                  "Density of medium";
      Modelica.Media.Interfaces.Types.Temperature T
                                                   "Temperature of medium";
      constant Modelica.Media.Interfaces.Types.MassFraction 'X[1]' = 1.0
                                                                        "Mass fractions (= (component mass)/total mass  m_i/m)";
      Modelica.Media.Interfaces.Types.SpecificInternalEnergy u
                                                              "Specific internal energy of medium";
      constant Modelica.Media.Interfaces.Types.SpecificHeatCapacity R = 0
                                                                         "Gas constant (of mixture if applicable)";
      constant Modelica.Media.Interfaces.Types.MolarMass MM = 0.018015268
                                                                         "Molar mass (of mixture or single fluid)";
    protected
      record state_rec
        Modelica.Media.Interfaces.Types.AbsolutePressure p
                                                          "Absolute pressure of medium";
        Modelica.Media.Interfaces.Types.Temperature T
                                                     "Temperature of medium";
      end state_rec;
    public
      state_rec state;
      constant Boolean preferredMediumStates = false
                                                    "= true if StateSelect.prefer shall be used for the independent property variables of the medium";
      constant Boolean standardOrderComponents = true
                                                     "If true, and reducedX = true, the last element of X will be computed from the other ones";
      Modelica.SIunits.Conversions.NonSIunits.Temperature_degC T_degC
                                                                     "Temperature of medium in [degC]";
      Modelica.SIunits.Conversions.NonSIunits.Pressure_bar p_bar
                                                                "Absolute pressure of medium in [bar]";
    end medium_rec;
  public
    medium_rec medium;
  protected
    record 'ports[1]_rec'
      Modelica.Media.Interfaces.PartialMedium.MassFlowRate m_flow(quantity = "MassFlowRate.SimpleLiquidWater", min = -1E+060, max = 1E+060)
                                                                                                                                           "Mass flow rate from the connection point into the component";
      Modelica.Media.Interfaces.Types.AbsolutePressure p
                                                        "Thermodynamic pressure in the connection point";
      Modelica.Media.Interfaces.Types.SpecificEnthalpy h_outflow
                                                                "Specific thermodynamic enthalpy close to the connection point if m_flow < 0";
    end 'ports[1]_rec';
  public
    'ports[1]_rec' 'ports[1]';
    constant Modelica.Media.Interfaces.PartialMedium.MassFlowRate m_flow(quantity = "MassFlowRate.SimpleLiquidWater") = 100
                                                                                                                           "Fixed mass flow rate going out of the fluid port";
    constant Modelica.Media.Interfaces.Types.Temperature T = 308.15
                                                                   "Fixed value of temperature";
    constant Modelica.Media.Interfaces.Types.MassFraction 'X[1]' = 1.0
                                                                      "Fixed value of composition";
    Modelica_Blocks_Interfaces_RealInput m_flow_in(unit = "kg/s")
                                                                 "Prescribed mass flow rate";
    Modelica_Blocks_Interfaces_RealInput T_in(unit = "K")
                                                         "Prescribed fluid temperature";
  end inletWater_rec;
public
  inletWater_rec inletWater;
protected
  record outletWater_rec
    constant Integer nPorts = 1
                               "Number of ports";
  protected
    record medium_rec
      Real p(unit = "Pa", displayUnit = "bar", nominal = 100000.0, quantity = "Pressure", min = 0.0)
                                                                                                    "Absolute pressure of medium";
      constant Real h(unit = "J/kg", quantity = "SpecificEnergy") = 83680.0
                                                                           "Specific enthalpy of medium";
      constant Modelica.Media.Interfaces.Types.Density d = 995.586
                                                                  "Density of medium";
      constant Modelica.Media.Interfaces.Types.Temperature T = 293.15
                                                                     "Temperature of medium";
      constant Modelica.Media.Interfaces.Types.MassFraction 'X[1]' = 1.0
                                                                        "Mass fractions (= (component mass)/total mass  m_i/m)";
      constant Modelica.Media.Interfaces.Types.SpecificInternalEnergy u = 83680.0
                                                                                 "Specific internal energy of medium";
      constant Modelica.Media.Interfaces.Types.SpecificHeatCapacity R = 0
                                                                         "Gas constant (of mixture if applicable)";
      constant Modelica.Media.Interfaces.Types.MolarMass MM = 0.018015268
                                                                         "Molar mass (of mixture or single fluid)";
    protected
      record state_rec
        Modelica.Media.Interfaces.Types.AbsolutePressure p
                                                          "Absolute pressure of medium";
        constant Modelica.Media.Interfaces.Types.Temperature T = 293.15
                                                                       "Temperature of medium";
      end state_rec;
    public
      state_rec state;
      constant Boolean preferredMediumStates = false
                                                    "= true if StateSelect.prefer shall be used for the independent property variables of the medium";
      constant Boolean standardOrderComponents = true
                                                     "If true, and reducedX = true, the last element of X will be computed from the other ones";
      constant Modelica.SIunits.Conversions.NonSIunits.Temperature_degC T_degC = 20.0
                                                                                     "Temperature of medium in [degC]";
      Modelica.SIunits.Conversions.NonSIunits.Pressure_bar p_bar
                                                                "Absolute pressure of medium in [bar]";
    end medium_rec;
  public
    medium_rec medium;
  protected
    record 'ports[1]_rec'
      Modelica.Media.Interfaces.PartialMedium.MassFlowRate m_flow(quantity = "MassFlowRate.SimpleLiquidWater", min = -0.0)
                                                                                                                          "Mass flow rate from the connection point into the component";
      Modelica.Media.Interfaces.Types.AbsolutePressure p
                                                        "Thermodynamic pressure in the connection point";
      constant Modelica.Media.Interfaces.Types.SpecificEnthalpy h_outflow = 83680.0
                                                                                   "Specific thermodynamic enthalpy close to the connection point if m_flow < 0";
    end 'ports[1]_rec';
  public
    'ports[1]_rec' 'ports[1]';
    constant Modelica.Media.Interfaces.PartialMedium.MassFlowRate m_flow(quantity = "MassFlowRate.SimpleLiquidWater") = -50
                                                                                                                           "Fixed mass flow rate going out of the fluid port";
    constant Modelica.Media.Interfaces.Types.Temperature T = 293.15
                                                                   "Fixed value of temperature";
    constant Modelica.Media.Interfaces.Types.MassFraction 'X[1]' = 1.0
                                                                      "Fixed value of composition";
    Modelica_Blocks_Interfaces_RealInput m_flow_in(unit = "kg/s")
                                                                 "Prescribed mass flow rate";
  end outletWater_rec;
public
  outletWater_rec outletWater;
protected
  record overflowWater_rec
    constant Integer nPorts = 1
                               "Number of ports";
  protected
    record medium_rec
      Real p(unit = "Pa", displayUnit = "bar", nominal = 100000.0, quantity = "Pressure", min = 0.0)
                                                                                                    "Absolute pressure of medium";
      constant Real h(unit = "J/kg", quantity = "SpecificEnergy") = 104600.0
                                                                            "Specific enthalpy of medium";
      constant Modelica.Media.Interfaces.Types.Density d = 995.586
                                                                  "Density of medium";
      constant Modelica.Media.Interfaces.Types.Temperature T = 298.15
                                                                     "Temperature of medium";
      constant Modelica.Media.Interfaces.Types.MassFraction 'X[1]' = 1.0
                                                                        "Mass fractions (= (component mass)/total mass  m_i/m)";
      constant Modelica.Media.Interfaces.Types.SpecificInternalEnergy u = 104600.0
                                                                                  "Specific internal energy of medium";
      constant Modelica.Media.Interfaces.Types.SpecificHeatCapacity R = 0
                                                                         "Gas constant (of mixture if applicable)";
      constant Modelica.Media.Interfaces.Types.MolarMass MM = 0.018015268
                                                                         "Molar mass (of mixture or single fluid)";
    protected
      record state_rec
        Modelica.Media.Interfaces.Types.AbsolutePressure p
                                                          "Absolute pressure of medium";
        constant Modelica.Media.Interfaces.Types.Temperature T = 298.15
                                                                       "Temperature of medium";
      end state_rec;
    public
      state_rec state;
      constant Boolean preferredMediumStates = false
                                                    "= true if StateSelect.prefer shall be used for the independent property variables of the medium";
      constant Boolean standardOrderComponents = true
                                                     "If true, and reducedX = true, the last element of X will be computed from the other ones";
      constant Modelica.SIunits.Conversions.NonSIunits.Temperature_degC T_degC = 25.0
                                                                                     "Temperature of medium in [degC]";
      Modelica.SIunits.Conversions.NonSIunits.Pressure_bar p_bar
                                                                "Absolute pressure of medium in [bar]";
    end medium_rec;
  public
    medium_rec medium;
  protected
    record 'ports[1]_rec'
      Modelica.Media.Interfaces.PartialMedium.MassFlowRate m_flow(quantity = "MassFlowRate.SimpleLiquidWater", max = -0.0)
                                                                                                                          "Mass flow rate from the connection point into the component";
      Modelica.Media.Interfaces.Types.AbsolutePressure p
                                                        "Thermodynamic pressure in the connection point";
      constant Modelica.Media.Interfaces.Types.SpecificEnthalpy h_outflow = 104600.0
                                                                                    "Specific thermodynamic enthalpy close to the connection point if m_flow < 0";
    end 'ports[1]_rec';
  public
    'ports[1]_rec' 'ports[1]';
    constant Modelica.Media.Interfaces.PartialMedium.MassFlowRate m_flow(quantity = "MassFlowRate.SimpleLiquidWater") = 10
                                                                                                                          "Fixed mass flow rate going out of the fluid port";
    constant Modelica.Media.Interfaces.Types.Temperature T = 298.15
                                                                   "Fixed value of temperature";
    constant Modelica.Media.Interfaces.Types.MassFraction 'X[1]' = 1.0
                                                                      "Fixed value of composition";
    Modelica_Blocks_Interfaces_RealInput m_flow_in(unit = "kg/s")
                                                                 "Prescribed mass flow rate";
  end overflowWater_rec;
public
  overflowWater_rec overflowWater;
protected
  record gain_rec
    parameter Real k(unit = "1") = -1
                                     "Gain value multiplied with input signal";
    Modelica_Blocks_Interfaces_RealInput u(unit = "kg/s")
                                                         "Input signal connector";
    Modelica_Blocks_Interfaces_RealOutput y(unit = "kg/s")
                                                          "Output signal connector";
  end gain_rec;
public
  gain_rec gain annotation(Dialog);
protected
  record ambientTemperature_rec
  protected
    record port_rec
      Modelica.SIunits.Temperature T
                                    "Port temperature";
      Modelica.SIunits.HeatFlowRate Q_flow
                                          "Heat flow rate (positive if flowing from outside into the component)";
    end port_rec;
  public
    port_rec port;
    Modelica_Blocks_Interfaces_RealInput T(unit = "K");
  end ambientTemperature_rec;
public
  ambientTemperature_rec ambientTemperature;
protected
  record floorTemperature_rec
    parameter Modelica.SIunits.Temperature T = 288.15
                                                     "Fixed temperature at port";
  protected
    record port_rec
      Modelica.SIunits.Temperature T
                                    "Port temperature";
      Modelica.SIunits.HeatFlowRate Q_flow
                                          "Heat flow rate (positive if flowing from outside into the component)";
    end port_rec;
  public
    port_rec port;
  end floorTemperature_rec;
public
  floorTemperature_rec floorTemperature annotation(Dialog);
protected
  record levelControl_rec
    parameter Modelica.SIunits.Height hmax = 0.377825
                                                     "Maximum height of water that can the basin have";
    parameter Modelica.SIunits.Height hmin = 0.092075
                                                     "Minimum height of water that can the basin have";
    parameter Modelica.SIunits.MassFlowRate m_In = 1.34381
                                                          "Inlet overflow";
    parameter Modelica.SIunits.MassFlowRate m_Out = 0
                                                     "Outlet overflow";
    Modelica_Blocks_Interfaces_RealInput level(unit = "m", min = 0.0);
    parameter Modelica_Blocks_Interfaces_RealOutput _m_outflow_start = 0.01;
    Modelica_Blocks_Interfaces_RealOutput m_outflow(unit = "kg/s", min = 0.0, max = 100000.0,start = _m_outflow_start);
  end levelControl_rec;
public
  levelControl_rec levelControl annotation(Dialog);
protected
  record outletAir_rec
    constant Integer nPorts = 1
                               "Number of ports";
  protected
    record medium_rec
      Real p(unit = "Pa", displayUnit = "bar", nominal = 100000.0, quantity = "Pressure", min = 0.0)
                                                                                                    "Absolute pressure of medium";
      constant Real 'Xi[1]'(unit = "1", quantity = "MassFraction", min = 0.0, max = 1.0) = 0.01
                                                                                               "Structurally independent mass fractions";
      Real h(unit = "J/kg", quantity = "SpecificEnergy")
                                                        "Specific enthalpy of medium";
      Modelica.Media.Interfaces.Types.Density d
                                               "Density of medium";
      constant Modelica.Media.Interfaces.Types.Temperature T(min = 190.0, max = 647.0) = 293.15
                                                                                               "Temperature of medium";
      constant Modelica.Media.Interfaces.Types.MassFraction 'X[1]' = 0.01
                                                                         "Mass fractions (= (component mass)/total mass  m_i/m)";
      constant Modelica.Media.Interfaces.Types.MassFraction 'X[2]' = 0.99
                                                                         "Mass fractions (= (component mass)/total mass  m_i/m)";
      Modelica.Media.Interfaces.Types.SpecificInternalEnergy u
                                                              "Specific internal energy of medium";
      Modelica.Media.Interfaces.Types.SpecificHeatCapacity R
                                                            "Gas constant (of mixture if applicable)";
      constant Modelica.Media.Interfaces.Types.MolarMass MM = 0.02879012713067693
                                                                                 "Molar mass (of mixture or single fluid)";
    protected
      record state_rec
        Modelica.Media.Interfaces.Types.AbsolutePressure p
                                                          "Absolute pressure of medium";
        constant Modelica.Media.Interfaces.Types.Temperature T(min = 190.0, max = 647.0) = 293.15
                                                                                                 "Temperature of medium";
        constant Modelica.Media.Interfaces.Types.MassFraction 'X[1]' = 0.01
                                                                           "Mass fractions (= (component mass)/total mass  m_i/m)";
        constant Modelica.Media.Interfaces.Types.MassFraction 'X[2]' = 0.99
                                                                           "Mass fractions (= (component mass)/total mass  m_i/m)";
      end state_rec;
    public
      state_rec state;
      constant Boolean preferredMediumStates = false
                                                    "= true if StateSelect.prefer shall be used for the independent property variables of the medium";
      constant Boolean standardOrderComponents = true
                                                     "If true, and reducedX = true, the last element of X will be computed from the other ones";
      constant Modelica.SIunits.Conversions.NonSIunits.Temperature_degC T_degC = 20.0
                                                                                     "Temperature of medium in [degC]";
      Modelica.SIunits.Conversions.NonSIunits.Pressure_bar p_bar
                                                                "Absolute pressure of medium in [bar]";
      constant Modelica.Media.Interfaces.Types.MassFraction x_water = 0.010101010101010102
                                                                                          "Mass of total water/mass of dry air";
      Real phi
              "Relative humidity";
    end medium_rec;
  public
    medium_rec medium;
  protected
    record 'ports[1]_rec'
      Modelica.Media.Interfaces.PartialMedium.MassFlowRate m_flow(quantity = "MassFlowRate.Moist air", min = -0.0)
                                                                                                                  "Mass flow rate from the connection point into the component";
      parameter Modelica.Media.Interfaces.Types.AbsolutePressure _p_start = 100000.0;
      Modelica.Media.Interfaces.Types.AbsolutePressure p(start = _p_start, fixed=false)
                                                                                       "Thermodynamic pressure in the connection point";
      Modelica.Media.Interfaces.Types.SpecificEnthalpy h_outflow
                                                                "Specific thermodynamic enthalpy close to the connection point if m_flow < 0";
      constant Modelica.Media.Interfaces.Types.MassFraction 'Xi_outflow[1]' = 0.01
                                                                                  "Independent mixture mass fractions m_i/m close to the connection point if m_flow < 0";
    end 'ports[1]_rec';
  public
    'ports[1]_rec' 'ports[1]' annotation(Dialog);
    constant Modelica.Media.Interfaces.PartialMedium.MassFlowRate m_flow(quantity = "MassFlowRate.Moist air") = -31.5258
                                                                                                                        "Fixed mass flow rate going out of the fluid port";
    constant Modelica.Media.Interfaces.Types.Temperature T(min = 190.0, max = 647.0) = 293.15
                                                                                             "Fixed value of temperature";
    constant Modelica.Media.Interfaces.Types.MassFraction 'X[1]' = 0.01
                                                                       "Fixed value of composition";
    constant Modelica.Media.Interfaces.Types.MassFraction 'X[2]' = 0.99
                                                                       "Fixed value of composition";
    Modelica_Blocks_Interfaces_RealInput m_flow_in(unit = "kg/s")
                                                                 "Prescribed mass flow rate";
  end outletAir_rec;
public
  outletAir_rec outletAir annotation(Dialog);
protected
  record inletAir_rec
    constant Integer nPorts = 1
                               "Number of ports";
  protected
    record medium_rec
      constant Real p(unit = "Pa", displayUnit = "bar", nominal = 100000.0, quantity = "Pressure", min = 0.0) = 101325.0
                                                                                                                        "Absolute pressure of medium";
      Real 'Xi[1]'(unit = "1", quantity = "MassFraction", min = 0.0, max = 1.0)
                                                                               "Structurally independent mass fractions";
      Real h(unit = "J/kg", quantity = "SpecificEnergy")
                                                        "Specific enthalpy of medium";
      Modelica.Media.Interfaces.Types.Density d
                                               "Density of medium";
      Modelica.Media.Interfaces.Types.Temperature T(min = 190.0, max = 647.0)
                                                                             "Temperature of medium";
      Modelica.Media.Interfaces.Types.MassFraction 'X[1]'
                                                         "Mass fractions (= (component mass)/total mass  m_i/m)";
      Modelica.Media.Interfaces.Types.MassFraction 'X[2]'
                                                         "Mass fractions (= (component mass)/total mass  m_i/m)";
      Modelica.Media.Interfaces.Types.SpecificInternalEnergy u
                                                              "Specific internal energy of medium";
      Modelica.Media.Interfaces.Types.SpecificHeatCapacity R
                                                            "Gas constant (of mixture if applicable)";
      Modelica.Media.Interfaces.Types.MolarMass MM
                                                  "Molar mass (of mixture or single fluid)";
    protected
      record state_rec
        constant Modelica.Media.Interfaces.Types.AbsolutePressure p = 101325.0
                                                                              "Absolute pressure of medium";
        Modelica.Media.Interfaces.Types.Temperature T(min = 190.0, max = 647.0)
                                                                               "Temperature of medium";
        Modelica.Media.Interfaces.Types.MassFraction 'X[1]'
                                                           "Mass fractions (= (component mass)/total mass  m_i/m)";
        Modelica.Media.Interfaces.Types.MassFraction 'X[2]'
                                                           "Mass fractions (= (component mass)/total mass  m_i/m)";
      end state_rec;
    public
      state_rec state;
      constant Boolean preferredMediumStates = false
                                                    "= true if StateSelect.prefer shall be used for the independent property variables of the medium";
      constant Boolean standardOrderComponents = true
                                                     "If true, and reducedX = true, the last element of X will be computed from the other ones";
      Modelica.SIunits.Conversions.NonSIunits.Temperature_degC T_degC
                                                                     "Temperature of medium in [degC]";
      constant Modelica.SIunits.Conversions.NonSIunits.Pressure_bar p_bar = 1.01325
                                                                                   "Absolute pressure of medium in [bar]";
      Modelica.Media.Interfaces.Types.MassFraction x_water
                                                          "Mass of total water/mass of dry air";
      Real phi
              "Relative humidity";
    end medium_rec;
  public
    medium_rec medium;
  protected
    record 'ports[1]_rec'
      Modelica.Media.Interfaces.PartialMedium.MassFlowRate m_flow(quantity = "MassFlowRate.Moist air", min = -1E+060, max = 1E+060)
                                                                                                                                   "Mass flow rate from the connection point into the component";
      constant Modelica.Media.Interfaces.Types.AbsolutePressure p = 101325.0
                                                                            "Thermodynamic pressure in the connection point";
      Modelica.Media.Interfaces.Types.SpecificEnthalpy h_outflow
                                                                "Specific thermodynamic enthalpy close to the connection point if m_flow < 0";
      Modelica.Media.Interfaces.Types.MassFraction 'Xi_outflow[1]'
                                                                  "Independent mixture mass fractions m_i/m close to the connection point if m_flow < 0";
    end 'ports[1]_rec';
  public
    'ports[1]_rec' 'ports[1]';
    constant Modelica.Media.Interfaces.Types.AbsolutePressure p = 101325.0
                                                                          "Fixed value of pressure";
    constant Modelica.Media.Interfaces.Types.Temperature T(min = 190.0, max = 647.0) = 293.15
                                                                                             "Fixed value of temperature";
    constant Modelica.Media.Interfaces.Types.MassFraction 'X[1]' = 0.017623194
                                                                              "Fixed value of composition";
    constant Modelica.Media.Interfaces.Types.MassFraction 'X[2]' = 0.982376806
                                                                              "Fixed value of composition";
    Modelica_Blocks_Interfaces_RealInput T_in(unit = "K")
                                                         "Prescribed boundary temperature";
    Modelica_Blocks_Interfaces_RealInput 'X_in[1]'(unit = "1")
                                                              "Prescribed boundary composition";
    Modelica_Blocks_Interfaces_RealInput 'X_in[2]'(unit = "1")
                                                              "Prescribed boundary composition";
  end inletAir_rec;
public
  inletAir_rec inletAir;
protected
  record gain1_rec
    parameter Real k(unit = "1") = -1
                                     "Gain value multiplied with input signal";
    Modelica_Blocks_Interfaces_RealInput u(unit = "kg/s")
                                                         "Input signal connector";
    Modelica_Blocks_Interfaces_RealOutput y(unit = "kg/s")
                                                          "Output signal connector";
  end gain1_rec;
public
  gain1_rec gain1 annotation(Dialog);
protected
  record T_waterOut_rec
  protected
    record port_rec
      constant Modelica.Media.Interfaces.PartialMedium.MassFlowRate m_flow(quantity = "MassFlowRate.SimpleLiquidWater", min = 0.0) = 0
                                                                                                                                      "Mass flow rate from the connection point into the component";
      Modelica.Media.Interfaces.Types.AbsolutePressure p
                                                        "Thermodynamic pressure in the connection point";
      constant Modelica.Media.Interfaces.Types.SpecificEnthalpy h_outflow = 83680.0
                                                                                   "Specific thermodynamic enthalpy close to the connection point if m_flow < 0";
    end port_rec;
  public
    port_rec port;
    Modelica_Blocks_Interfaces_RealOutput T(unit = "K", displayUnit = "degC", nominal = 300.0, quantity = "ThermodynamicTemperature", min = 0.0)
                                                                                                                                                "Temperature in port medium";
  end T_waterOut_rec;
public
  T_waterOut_rec T_waterOut;
protected
  record T_airOut_rec
  protected
    record port_rec
      constant Modelica.Media.Interfaces.PartialMedium.MassFlowRate m_flow(quantity = "MassFlowRate.Moist air", min = 0.0) = 0
                                                                                                                              "Mass flow rate from the connection point into the component";
      Modelica.Media.Interfaces.Types.AbsolutePressure p
                                                        "Thermodynamic pressure in the connection point";
      constant Modelica.Media.Interfaces.Types.SpecificEnthalpy h_outflow = 45263.238744693415
                                                                                              "Specific thermodynamic enthalpy close to the connection point if m_flow < 0";
      constant Modelica.Media.Interfaces.Types.MassFraction 'Xi_outflow[1]' = 0.01
                                                                                  "Independent mixture mass fractions m_i/m close to the connection point if m_flow < 0";
    end port_rec;
  public
    port_rec port;
    Modelica_Blocks_Interfaces_RealOutput T(unit = "K", displayUnit = "degC", nominal = 300.0, quantity = "ThermodynamicTemperature", min = 0.0)
                                                                                                                                                "Temperature in port medium";
  end T_airOut_rec;
public
  T_airOut_rec T_airOut;
protected
  record massFlow_Air1_rec
    constant Boolean allowFlowReversal = true
                                             "= true to allow flow reversal, false restricts to design direction (port_a -> port_b)";
  protected
    record port_a_rec
      Modelica.Media.Interfaces.PartialMedium.MassFlowRate m_flow(quantity = "MassFlowRate.Moist air", min = -1E+060)
                                                                                                                     "Mass flow rate from the connection point into the component";
      constant Modelica.Media.Interfaces.Types.AbsolutePressure p = 101325.0
                                                                            "Thermodynamic pressure in the connection point";
      Modelica.Media.Interfaces.Types.SpecificEnthalpy h_outflow
                                                                "Specific thermodynamic enthalpy close to the connection point if m_flow < 0";
      Modelica.Media.Interfaces.Types.MassFraction 'Xi_outflow[1]'
                                                                  "Independent mixture mass fractions m_i/m close to the connection point if m_flow < 0";
    end port_a_rec;
  public
    port_a_rec port_a;
  protected
    record port_b_rec
      Modelica.Media.Interfaces.PartialMedium.MassFlowRate m_flow(quantity = "MassFlowRate.Moist air", max = 1E+060)
                                                                                                                    "Mass flow rate from the connection point into the component";
      constant Modelica.Media.Interfaces.Types.AbsolutePressure p = 101325.0
                                                                            "Thermodynamic pressure in the connection point";
      Modelica.Media.Interfaces.Types.SpecificEnthalpy h_outflow
                                                                "Specific thermodynamic enthalpy close to the connection point if m_flow < 0";
      Modelica.Media.Interfaces.Types.MassFraction 'Xi_outflow[1]'
                                                                  "Independent mixture mass fractions m_i/m close to the connection point if m_flow < 0";
    end port_b_rec;
  public
    port_b_rec port_b;
    parameter Modelica.Media.Interfaces.PartialMedium.MassFlowRate m_flow_nominal(quantity = "MassFlowRate.Moist air", fixed=false)
                                                                                                                                   "Nominal value of m_flow = port_a.m_flow";
    parameter Modelica.Media.Interfaces.PartialMedium.MassFlowRate m_flow_small(quantity = "MassFlowRate.Moist air", min = 0.0, fixed=false)
                                                                                                                                            "Regularization for bi-directional flow in the region |m_flow| < m_flow_small (m_flow_small > 0 required)";
    Modelica_Blocks_Interfaces_RealOutput m_flow(unit = "kg/s", quantity = "MassFlowRate")
                                                                                          "Mass flow rate from port_a to port_b";
  end massFlow_Air1_rec;
public
  massFlow_Air1_rec massFlow_Air1;
protected
  record massFlow_Water1_rec
    constant Boolean allowFlowReversal = true
                                             "= true to allow flow reversal, false restricts to design direction (port_a -> port_b)";
  protected
    record port_a_rec
      Modelica.Media.Interfaces.PartialMedium.MassFlowRate m_flow(quantity = "MassFlowRate.SimpleLiquidWater", min = -1E+060)
                                                                                                                             "Mass flow rate from the connection point into the component";
      Modelica.Media.Interfaces.Types.AbsolutePressure p
                                                        "Thermodynamic pressure in the connection point";
      Modelica.Media.Interfaces.Types.SpecificEnthalpy h_outflow
                                                                "Specific thermodynamic enthalpy close to the connection point if m_flow < 0";
    end port_a_rec;
  public
    port_a_rec port_a;
  protected
    record port_b_rec
      Modelica.Media.Interfaces.Types.AbsolutePressure p
                                                        "Thermodynamic pressure in the connection point";
      Modelica.Media.Interfaces.Types.SpecificEnthalpy h_outflow
                                                                "Specific thermodynamic enthalpy close to the connection point if m_flow < 0";
    end port_b_rec;
  public
    port_b_rec port_b;
    parameter Modelica.Media.Interfaces.PartialMedium.MassFlowRate m_flow_nominal(quantity = "MassFlowRate.SimpleLiquidWater", fixed=false)
                                                                                                                                           "Nominal value of m_flow = port_a.m_flow";
    parameter Modelica.Media.Interfaces.PartialMedium.MassFlowRate m_flow_small(quantity = "MassFlowRate.SimpleLiquidWater", min = 0.0, fixed=false)
                                                                                                                                                    "Regularization for bi-directional flow in the region |m_flow| < m_flow_small (m_flow_small > 0 required)";
    Modelica_Blocks_Interfaces_RealOutput m_flow(unit = "kg/s", quantity = "MassFlowRate")
                                                                                          "Mass flow rate from port_a to port_b";
  end massFlow_Water1_rec;
public
  massFlow_Water1_rec massFlow_Water1;
  parameter Real _outletAir_m_flow_start = 0.0
  annotation (Dialog(tab="Input Start Values", group="Input Start Value before call to fmiInitialize"));
protected
  Real _outletAir_m_flow_old;
public
  Modelica.Blocks.Interfaces.RealInput outletAir_m_flow(unit = "kg/s", quantity = "MassFlowRate", start = 0.0)
                                                                                                              "Outlet air mass flow"
  annotation (Placement(transformation(extent={{-114,62},{-94,82}})));
  parameter Real _inletWater_m_flow_start = 0.0
  annotation (Dialog(tab="Input Start Values", group="Input Start Value before call to fmiInitialize"));
protected
  Real _inletWater_m_flow_old;
public
  Modelica.Blocks.Interfaces.RealInput inletWater_m_flow(unit = "kg/s", quantity = "MassFlowRate", min = 0.0, max = 100000.0, start = 0.0)
                                                                                                                                          "Inlet water mass flow"
  annotation (Placement(transformation(extent={{-114,33},{-94,53}})));
  parameter Real _inletWater_T_start = 288.15
  annotation (Dialog(tab="Input Start Values", group="Input Start Value before call to fmiInitialize"));
protected
  Real _inletWater_T_old;
public
  Modelica.Blocks.Interfaces.RealInput inletWater_T(unit = "K", displayUnit = "degC", nominal = 300.0, quantity = "ThermodynamicTemperature", min = 1.0, max = 10000.0, start = 288.15)
                                                                                                                                                                                       "Inlet water temperature"
  annotation (Placement(transformation(extent={{-114,5},{-94,25}})));
  parameter Real _ambient_T_start = 288.15
  annotation (Dialog(tab="Input Start Values", group="Input Start Value before call to fmiInitialize"));
protected
  Real _ambient_T_old;
public
  Modelica.Blocks.Interfaces.RealInput ambient_T(unit = "K", displayUnit = "degC", nominal = 300.0, quantity = "ThermodynamicTemperature", min = 190.0, max = 647.0, start = 288.15)
                                                                                                                                                                                    "Ambient temperature"
  annotation (Placement(transformation(extent={{-114,-24},{-94,-4}})));
  parameter Real _outletWater_m_flow_start = 0.0
  annotation (Dialog(tab="Input Start Values", group="Input Start Value before call to fmiInitialize"));
protected
  Real _outletWater_m_flow_old;
public
  Modelica.Blocks.Interfaces.RealInput outletWater_m_flow(unit = "kg/s", quantity = "MassFlowRate", start = 0.0)
                                                                                                                "Outlet water mass flow"
  annotation (Placement(transformation(extent={{-114,-52},{-94,-32}})));
  parameter Real _inletAir_X_start = 0.01
  annotation (Dialog(tab="Input Start Values", group="Input Start Value before call to fmiInitialize"));
protected
  Real _inletAir_X_old;
public
  Modelica.Blocks.Interfaces.RealInput inletAir_X(unit = "1", nominal = 0.1, quantity = "MassFraction", min = 0.0, max = 1.0, start = 0.01)
                                                                                                                                           "Vapour fraction in the air at the entrace (m_vapour/m_air)"
  annotation (Placement(transformation(extent={{-114,-81},{-94,-61}})));
  Modelica.Blocks.Interfaces.RealOutput outletWater_T(unit = "K", displayUnit = "degC", nominal = 300.0, quantity = "ThermodynamicTemperature", min = 0.0)
                                                                                                                                                          "Outlet water temperature"
  annotation (Placement(transformation(extent={{100,14},{140,54}})));
  Modelica.Blocks.Interfaces.RealOutput outletAir_T(unit = "K", displayUnit = "degC", nominal = 300.0, quantity = "ThermodynamicTemperature", min = 0.0)
                                                                                                                                                        "Outlet air temperature"
  annotation (Placement(transformation(extent={{100,-53},{140,-13}})));
public
  parameter String fmi_instanceName="CompleteOCT_inertia_FMU_fmu"
  annotation (Dialog(tab="FMI", group="Instance name"));
  parameter Boolean fmi_loggingOn=false
  annotation (Dialog(tab="FMI", group="Enable logging"));
  parameter Boolean fmi_pullInputsForInitialization=true
  "Set to false when using the FMU in feedback connections"
  annotation (Dialog(tab="FMI", group="Inputs for initialization"));
  parameter Boolean fmi_InputTime=false
  "Time point of input used when calling doStep."
  annotation (Evaluate=true,Dialog(tab="FMI", group="Input Handling"),choices(choice= false "StepEnd", choice= true "StepStart"));
  parameter Boolean fmi_UsePreOnInputSignals=true
  annotation (Evaluate=true,Dialog(tab="FMI", group="Input Handling"));
  parameter Real fmi_StartTime = 0.0
  annotation (Dialog(tab="FMI", group="Step time"));
  parameter Real fmi_StopTime = 3000.0
  annotation (Dialog(tab="FMI", group="Step time"));
  parameter Real fmi_NumberOfSteps = 500
  annotation (Dialog(tab="FMI", group="Step time"));
  parameter Real fmi_CommunicationStepSize=(fmi_StopTime-fmi_StartTime)/fmi_NumberOfSteps
  annotation (Dialog(tab="FMI", group="Step time"));
  parameter Integer stepSizeScaleFactor = 1 "Number of doSteps called between two CommunicationStepSize"
  annotation (Dialog(tab="FMI", group="Step time"));
  parameter Boolean fmi_forceShutDownAtStopTime=false
  annotation (Dialog(tab="FMI", group="Step time"));
  parameter String fmi_fmuLocation="file:///"+ModelicaServices.ExternalReferences.loadResource("modelica://CompleteOCT_inertia_FMU_fmu/Resources/Library/FMU/CompleteOCT_inertia_FMU")
  annotation (Dialog(tab="FMI", group="Instantiation"));
protected
fmi_Functions.fmiModel fmi;
Boolean fmi_StepOK;
parameter Real fmi_Initialized(fixed=false);
parameter Real fmi_AParamsAndStart(fixed=false);
parameter Real fmi_initInput0(start=0,fixed=false);
parameter Real fmi_initInput1(start=0,fixed=false);
parameter Real fmi_initInput2(start=0,fixed=false);
parameter Real fmi_initInput3(start=0,fixed=false);
parameter Real fmi_initInput4(start=0,fixed=false);
parameter Real fmi_initInput5(start=0,fixed=false);
Real RealVariables1[100];
Real RealVariables2[100];
Real RealVariables3[100];
Real RealVariables4[80];
Real RealDependentParameters[87];
package fmi_Functions
  class fmiModel
  extends ExternalObject;
    function constructor "Initialize FMI model"
      extends Modelica.Icons.Function;
      input String instanceName;
      input Boolean loggingOn;
        input String fmuLocation;
      output fmiModel fmi;
      external"C" fmi = Modelica_0IK4_0TEKNIKER_DCOL_Generation_CoolingTowers_FMI_CompleteOCT_0inertia_0Dym_fmiInstantiateModel2(instanceName, loggingOn, fmuLocation)
      annotation(Header="
#ifndef Modelica_0IK4_0TEKNIKER_DCOL_Generation_CoolingTowers_FMI_CompleteOCT_0inertia_0Dym_Instantiate_C
#define Modelica_0IK4_0TEKNIKER_DCOL_Generation_CoolingTowers_FMI_CompleteOCT_0inertia_0Dym_Instantiate_C 1
#include <stdlib.h>
#include \"FMI/fmiImport.h\"
#ifndef Modelica_0IK4_0TEKNIKER_DCOL_Generation_CoolingTowers_FMI_CompleteOCT_0inertia_0Dym_MYSTRCMP_C
#define Modelica_0IK4_0TEKNIKER_DCOL_Generation_CoolingTowers_FMI_CompleteOCT_0inertia_0Dym_MYSTRCMP_C 1
int Modelica_0IK4_0TEKNIKER_DCOL_Generation_CoolingTowers_FMI_CompleteOCT_0inertia_0Dymmystrcmp(const void *_a, const void *_b) {
  char *a = _a;
  char *const *b = _b;
  return strcmp(a, *b);
}
#endif
void Modelica_0IK4_0TEKNIKER_DCOL_Generation_CoolingTowers_FMI_CompleteOCT_0inertia_0DymLogger(fmiComponent c, fmiString instanceName, fmiStatus status,
         fmiString category, fmiString message, ...) {
  char msg[4096];
  char buf[4096];
  int len;
  va_list ap;
  va_start(ap,message);
#if defined(_MSC_VER) && _MSC_VER>=1200
  len = _snprintf(msg, sizeof(msg)/sizeof(*msg), \"%s: %s\", instanceName, message);
  if (len < 0) goto fail;
  len = _vsnprintf(buf, sizeof(buf)/sizeof(*buf) - 2, msg, ap);
  if (len < 0) goto fail;
#else
  len = snprintf(msg, sizeof(msg)/sizeof(*msg), \"%s: %s\", instanceName, message);
  if (len < 0) goto fail;
  len = vsnprintf(buf, sizeof(buf)/sizeof(*buf) - 2, msg, ap);
  if (len < 0) goto fail;
#endif
  if( len>0 && len <4096 && buf[len - 1]!='\\n'){
    buf[len] = '\\n';
    buf[len + 1] = 0;
  }
  va_end(ap);
  switch (status) {
    case fmiFatal:
      ModelicaMessage(\"[fmiFatal]: \");
      break;
    case fmiError:
      ModelicaMessage(\"[fmiError]: \");
      break;
    case fmiDiscard:
      ModelicaMessage(\"[fmiDiscard]: \");
      break;
    case fmiWarning:
      ModelicaMessage(\"[fmiWarning]: \");
      break;
    case fmiOK:
      ModelicaMessage(\"[fmiOK]: \");
      break;
  }
  ModelicaMessage(buf);
  return;
fail:
  ModelicaMessage(\"Logger failed, message too long?\");
}
void * Modelica_0IK4_0TEKNIKER_DCOL_Generation_CoolingTowers_FMI_CompleteOCT_0inertia_0Dym_fmiInstantiateModel2(const char*instanceName, fmiBoolean loggingOn, const char* fmuLocation) {
  static fmiCoSimCallbackFunctions funcs = {&Modelica_0IK4_0TEKNIKER_DCOL_Generation_CoolingTowers_FMI_CompleteOCT_0inertia_0DymLogger, &calloc, &free, NULL};
  struct dy_Extended* res;

  res = calloc(1, sizeof(struct dy_Extended));
  if (res!=0) {
    if (!(res->hInst=LoadLibraryW(L\"Modelica_0IK4_0TEKNIKER_DCOL_Generation_CoolingTowers_FMI_CompleteOCT_0inertia_0Dym.dll\"))) {
      ModelicaError(\"Loading of FMU dynamic link library (Modelica_0IK4_0TEKNIKER_DCOL_Generation_CoolingTowers_FMI_CompleteOCT_0inertia_0Dym.dll) failed!\");
      return 0;
    }
    if(!(res->dyFmiInstantiateSlave=(fmiInstantiateSlaveFunc)GetProcAddress(res->hInst,\"Modelica_0IK4_0TEKNIKER_DCOL_Generation_CoolingTowers_FMI_CompleteOCT_0inertia_0Dym_fmiInstantiateSlave\"))){
      ModelicaError(\"GetProcAddress failed for fmiInstantiateSlave!\\n The model was imported as a Co-Simulation FMU but could not load the CS specific function fmiInstantiateSlave\\n Verify that the FMU supports Co-Simulation\");
      return 0;
    }
    if(!(res->dyFmiFreeSlaveInstance=(fmiFreeSlaveInstanceFunc)GetProcAddress(res->hInst,\"Modelica_0IK4_0TEKNIKER_DCOL_Generation_CoolingTowers_FMI_CompleteOCT_0inertia_0Dym_fmiFreeSlaveInstance\"))){
      ModelicaError(\"GetProcAddress failed for fmiFreeSlaveInstance!\\n The model was imported as a Co-Simulation FMU but could not load the CS specific function fmiFreeSlaveInstance\\n Verify that the FMU supports Co-Simulation\");
      return 0;
    }
    if(!(res->dyFmiInitializeSlave=(fmiInitializeSlaveFunc)GetProcAddress(res->hInst,\"Modelica_0IK4_0TEKNIKER_DCOL_Generation_CoolingTowers_FMI_CompleteOCT_0inertia_0Dym_fmiInitializeSlave\"))){
      ModelicaError(\"GetProcAddress failed for fmiInitializeSlave!\\n The model was imported as a Co-Simulation FMU but could not load the CS specific function fmiInitializeSlave\\n Verify that the FMU supports Co-Simulation\");
      return 0;
    }
    if(!(res->dyFmiResetSlave=(fmiResetSlaveFunc)GetProcAddress(res->hInst,\"Modelica_0IK4_0TEKNIKER_DCOL_Generation_CoolingTowers_FMI_CompleteOCT_0inertia_0Dym_fmiResetSlave\"))){
      ModelicaError(\"GetProcAddress failed for fmiResetSlave!\\n The model was imported as a Co-Simulation FMU but could not load the CS specific function fmiResetSlave\\n Verify that the FMU supports Co-Simulation\");
      return 0;
    }
    if(!(res->dyFmiDoStep=(fmiDoStepFunc)GetProcAddress(res->hInst,\"Modelica_0IK4_0TEKNIKER_DCOL_Generation_CoolingTowers_FMI_CompleteOCT_0inertia_0Dym_fmiDoStep\"))){
      ModelicaError(\"GetProcAddress failed for fmiDoStep!\\n The model was imported as a Co-Simulation FMU but could not load the CS specific function fmiDoStep\\n Verify that the FMU supports Co-Simulation\");
      return 0;
    }
    if(!(res->dyFmiTerminateSlave=(fmiTerminateSlaveFunc)GetProcAddress(res->hInst,\"Modelica_0IK4_0TEKNIKER_DCOL_Generation_CoolingTowers_FMI_CompleteOCT_0inertia_0Dym_fmiTerminateSlave\"))){
      ModelicaError(\"GetProcAddress failed for fmiTerminateSlave!\\n The model was imported as a Co-Simulation FMU but could not load the CS specific function fmiTerminateSlave\\n Verify that the FMU supports Co-Simulation\");
      return 0;
    }
    if (!(res->dyFmiSetReal=(fmiSetRealFunc)GetProcAddress(res->hInst,\"Modelica_0IK4_0TEKNIKER_DCOL_Generation_CoolingTowers_FMI_CompleteOCT_0inertia_0Dym_fmiSetReal\"))) {
      ModelicaError(\"GetProcAddress failed for fmiSetReal!\");
      return 0;
    }
    if (!(res->dyFmiGetReal=(fmiGetRealFunc)GetProcAddress(res->hInst,\"Modelica_0IK4_0TEKNIKER_DCOL_Generation_CoolingTowers_FMI_CompleteOCT_0inertia_0Dym_fmiGetReal\"))) {
      ModelicaError(\"GetProcAddress failed for fmiGetReal!\");
      return 0;
    }
    if (!(res->dyFmiSetInteger=(fmiSetIntegerFunc)GetProcAddress(res->hInst,\"Modelica_0IK4_0TEKNIKER_DCOL_Generation_CoolingTowers_FMI_CompleteOCT_0inertia_0Dym_fmiSetInteger\"))) {
      ModelicaError(\"GetProcAddress failed for fmiSetInteger!\");
      return 0;
    }
    if (!(res->dyFmiGetInteger=(fmiGetIntegerFunc)GetProcAddress(res->hInst,\"Modelica_0IK4_0TEKNIKER_DCOL_Generation_CoolingTowers_FMI_CompleteOCT_0inertia_0Dym_fmiGetInteger\"))) {
      ModelicaError(\"GetProcAddress failed for fmiGetInteger!\");
      return 0;
    }
    if (!(res->dyFmiSetBoolean=(fmiSetBooleanFunc)GetProcAddress(res->hInst,\"Modelica_0IK4_0TEKNIKER_DCOL_Generation_CoolingTowers_FMI_CompleteOCT_0inertia_0Dym_fmiSetBoolean\"))) {
      ModelicaError(\"GetProcAddress failed for fmiSetBoolean!\");
      return 0;
    }
    if (!(res->dyFmiGetBoolean=(fmiGetBooleanFunc)GetProcAddress(res->hInst,\"Modelica_0IK4_0TEKNIKER_DCOL_Generation_CoolingTowers_FMI_CompleteOCT_0inertia_0Dym_fmiGetBoolean\"))) {
      ModelicaError(\"GetProcAddress failed for fmiGetBoolean!\");
      return 0;
    }
    if (!(res->dyFmiSetString=(fmiSetStringFunc)GetProcAddress(res->hInst,\"Modelica_0IK4_0TEKNIKER_DCOL_Generation_CoolingTowers_FMI_CompleteOCT_0inertia_0Dym_fmiSetString\"))) {
      ModelicaError(\"GetProcAddress failed for fmiSetString!\");
      return 0;
    }
    if (!(res->dyFmiGetString=(fmiGetStringFunc)GetProcAddress(res->hInst,\"Modelica_0IK4_0TEKNIKER_DCOL_Generation_CoolingTowers_FMI_CompleteOCT_0inertia_0Dym_fmiGetString\"))) {
      ModelicaError(\"GetProcAddress failed for fmiGetString!\");
      return 0;
    }
    res->m=res->dyFmiInstantiateSlave(instanceName, \"{0a44c32f-cb18-4817-8ee7-9cd740bfea91}\", fmuLocation, \"application/x-dymolakernel\", 0, fmiFalse, fmiFalse, funcs, loggingOn);
    if (0==res->m) {free(res);res=0;ModelicaError(\"InstantiateSlave failed\");}
    else {res->dyTriggered=0;res->dyTime=res->dyLastTime=-1e37;}
  }
  return res;
}
#endif", Library="Modelica_0IK4_0TEKNIKER_DCOL_Generation_CoolingTowers_FMI_CompleteOCT_0inertia_0Dym", LibraryDirectory="modelica://DCOL/Resources/Library/FMU/CompleteOCT_inertia_FMU/binaries",                        __Dymola_CriticalRegion="Modelica_0IK4_0TEKNIKER_DCOL_Generation_CoolingTowers_FMI_CompleteOCT_0inertia_0Dym");
    end constructor;

    function destructor "Release storage of FMI model"
      extends Modelica.Icons.Function;
      input fmiModel fmi;
      external"C"
                 Modelica_0IK4_0TEKNIKER_DCOL_Generation_CoolingTowers_FMI_CompleteOCT_0inertia_0Dym_fmiFreeModelInstance2(fmi);
      annotation (Header="
#ifndef Modelica_0IK4_0TEKNIKER_DCOL_Generation_CoolingTowers_FMI_CompleteOCT_0inertia_0Dym_Free_C
#define Modelica_0IK4_0TEKNIKER_DCOL_Generation_CoolingTowers_FMI_CompleteOCT_0inertia_0Dym_Free_C 1
#include <stdlib.h>
#include \"FMI/fmiImport.h\"
void Modelica_0IK4_0TEKNIKER_DCOL_Generation_CoolingTowers_FMI_CompleteOCT_0inertia_0Dym_fmiFreeModelInstance2(void*m) {
  struct dy_Extended*a=m;
  if (a) {
    a->dyFmiTerminateSlave(a->m);
    a->dyFmiFreeSlaveInstance(a->m);
    FreeLibrary(a->hInst);
    free(a);
  }
}
#endif", Library="Modelica_0IK4_0TEKNIKER_DCOL_Generation_CoolingTowers_FMI_CompleteOCT_0inertia_0Dym", LibraryDirectory="modelica://DCOL/Resources/Library/FMU/CompleteOCT_inertia_FMU/binaries",                        __Dymola_CriticalRegion="Modelica_0IK4_0TEKNIKER_DCOL_Generation_CoolingTowers_FMI_CompleteOCT_0inertia_0Dym");
    end destructor;
  end fmiModel;

    function fmiInitializeSlave
      input fmiModel fmi;
      input Real tStart;
      input Boolean forceShutDownAtTStop;
       input Real tStop;
      input Real preAvailable;
      output Real postAvailable=preAvailable;
      external"C" Modelica_0IK4_0TEKNIKER_DCOL_Generation_CoolingTowers_FMI_CompleteOCT_0inertia_0Dym_fmiInitializeSlave2(fmi, tStart, forceShutDownAtTStop, tStop);
      annotation (Header="
#ifndef Modelica_0IK4_0TEKNIKER_DCOL_Generation_CoolingTowers_FMI_CompleteOCT_0inertia_0Dym_InitializeSlave_C
#define Modelica_0IK4_0TEKNIKER_DCOL_Generation_CoolingTowers_FMI_CompleteOCT_0inertia_0Dym_InitializeSlave_C 1
#include <stdlib.h>
#include \"FMI/fmiImport.h\"
double Modelica_0IK4_0TEKNIKER_DCOL_Generation_CoolingTowers_FMI_CompleteOCT_0inertia_0Dym_fmiInitializeSlave2(void*m, fmiReal tStart, fmiBoolean forceShutDownAtTStop, fmiReal tStop) {
  struct dy_Extended*a=m;
  fmiStatus status=fmiFatal;
  if (a) {
    status=a->dyFmiInitializeSlave(a->m, tStart, forceShutDownAtTStop, tStop);
    a->dyTriggered=0;
    a->dyLastTime=a->dyTime;
  }
  if (status!=fmiOK && status!=fmiWarning) ModelicaError(\"InitializeSlave failed\");
  return 1e37;
}
#endif", Library="Modelica_0IK4_0TEKNIKER_DCOL_Generation_CoolingTowers_FMI_CompleteOCT_0inertia_0Dym", LibraryDirectory="modelica://DCOL/Resources/Library/FMU/CompleteOCT_inertia_FMU/binaries",                        __Dymola_CriticalRegion="Modelica_0IK4_0TEKNIKER_DCOL_Generation_CoolingTowers_FMI_CompleteOCT_0inertia_0Dym");
    end fmiInitializeSlave;

    function fmiDoStep
     input fmiModel fmi;
     input Real currentTime;
     input Real stepSize;
     output Boolean stepOK;
     external"C" stepOK= Modelica_0IK4_0TEKNIKER_DCOL_Generation_CoolingTowers_FMI_CompleteOCT_0inertia_0Dym_fmiDoStep2(fmi, currentTime, stepSize);
     annotation (Header="
#ifndef Modelica_0IK4_0TEKNIKER_DCOL_Generation_CoolingTowers_FMI_CompleteOCT_0inertia_0Dym_DoStep_C
#define Modelica_0IK4_0TEKNIKER_DCOL_Generation_CoolingTowers_FMI_CompleteOCT_0inertia_0Dym_DoStep_C 1
#include <stdlib.h>
#include \"FMI/fmiImport.h\"
double Modelica_0IK4_0TEKNIKER_DCOL_Generation_CoolingTowers_FMI_CompleteOCT_0inertia_0Dym_fmiDoStep2(void*m, double currentTime, double stepSize) {
  struct dy_Extended*a=m;
  fmiStatus status=fmiFatal;
  if (a) {
    status=a->dyFmiDoStep(a->m, currentTime, stepSize, fmiTrue);
  }
  if (status!=fmiOK && status!=fmiWarning) ModelicaError(\"DoStep failed\");
  return 1.0;
}
#endif", Library="Modelica_0IK4_0TEKNIKER_DCOL_Generation_CoolingTowers_FMI_CompleteOCT_0inertia_0Dym", LibraryDirectory="modelica://DCOL/Resources/Library/FMU/CompleteOCT_inertia_FMU/binaries",                        __Dymola_CriticalRegion="Modelica_0IK4_0TEKNIKER_DCOL_Generation_CoolingTowers_FMI_CompleteOCT_0inertia_0Dym");
    end fmiDoStep;

    function fmiResetSlave
      input fmiModel fmi;
      output Boolean resetOK;
      external"C" resetOK = Modelica_0IK4_0TEKNIKER_DCOL_Generation_CoolingTowers_FMI_CompleteOCT_0inertia_0Dym_fmiResetSlave2(fmi);
      annotation (Header="
#ifndef Modelica_0IK4_0TEKNIKER_DCOL_Generation_CoolingTowers_FMI_CompleteOCT_0inertia_0Dym_ResetSlave_C
#define Modelica_0IK4_0TEKNIKER_DCOL_Generation_CoolingTowers_FMI_CompleteOCT_0inertia_0Dym_ResetSlave_C 1
#include <stdlib.h>
#include \"FMI/fmiImport.h\"
double Modelica_0IK4_0TEKNIKER_DCOL_Generation_CoolingTowers_FMI_CompleteOCT_0inertia_0Dym_fmiResetSlave2(void*m) {
  struct dy_Extended*a=m;
  fmiStatus status=fmiFatal;
  if (a) {
    status=a->dyFmiResetSlave(a->m);
  }
  if (status!=fmiOK && status!=fmiWarning) ModelicaError(\"resetSlave failed\");
    return 1.0;
  }
#endif", Library="Modelica_0IK4_0TEKNIKER_DCOL_Generation_CoolingTowers_FMI_CompleteOCT_0inertia_0Dym", LibraryDirectory="modelica://DCOL/Resources/Library/FMU/CompleteOCT_inertia_FMU/binaries",                        __Dymola_CriticalRegion="Modelica_0IK4_0TEKNIKER_DCOL_Generation_CoolingTowers_FMI_CompleteOCT_0inertia_0Dym");
    end fmiResetSlave;

    function fmiSetReal
      input fmiModel fmi;
      input Integer refs[:];
      input Real vals[size(refs, 1)];
      output Real dummy= 1;
      external"C"
                 Modelica_0IK4_0TEKNIKER_DCOL_Generation_CoolingTowers_FMI_CompleteOCT_0inertia_0Dym_fmiSetReal2(
        fmi,
        refs,
        size(refs, 1),
        vals);
        annotation (Header="
#ifndef Modelica_0IK4_0TEKNIKER_DCOL_Generation_CoolingTowers_FMI_CompleteOCT_0inertia_0Dym_SetReal_C
#define Modelica_0IK4_0TEKNIKER_DCOL_Generation_CoolingTowers_FMI_CompleteOCT_0inertia_0Dym_SetReal_C 1
#include <stdlib.h>
#include \"FMI/fmiImport.h\"
void Modelica_0IK4_0TEKNIKER_DCOL_Generation_CoolingTowers_FMI_CompleteOCT_0inertia_0Dym_fmiSetReal2(void*m, const int*refs, size_t nrefs, const double*vals) {
  struct dy_Extended*a=m;
  fmiStatus status=fmiFatal;
  if(!nrefs){return;}
  if (a) {
    status=a->dyFmiSetReal(a->m, refs, nrefs, vals);
  }
  if (status!=fmiOK && status!=fmiWarning) ModelicaError(\"SetReal failed\");
}
#endif", Library="Modelica_0IK4_0TEKNIKER_DCOL_Generation_CoolingTowers_FMI_CompleteOCT_0inertia_0Dym", LibraryDirectory="modelica://DCOL/Resources/Library/FMU/CompleteOCT_inertia_FMU/binaries",                        __Dymola_CriticalRegion="Modelica_0IK4_0TEKNIKER_DCOL_Generation_CoolingTowers_FMI_CompleteOCT_0inertia_0Dym",__Dymola_IdemPotent=true, __Dymola_VectorizedExceptFirst=true);
    end fmiSetReal;

    function fmiSetRealParam
      input fmiModel fmi;
      input Integer refs[:];
      input Real vals[size(refs, 1)];
    protected
      Real oldVals[size(refs, 1)];
      external"C"
                 Modelica_0IK4_0TEKNIKER_DCOL_Generation_CoolingTowers_FMI_CompleteOCT_0inertia_0Dym_fmiSetRealParam2(
        fmi,
        refs,
        size(refs, 1),
        vals,
        oldVals);
        annotation (Header="
#ifndef Modelica_0IK4_0TEKNIKER_DCOL_Generation_CoolingTowers_FMI_CompleteOCT_0inertia_0Dym_SetRealParam_C
#define Modelica_0IK4_0TEKNIKER_DCOL_Generation_CoolingTowers_FMI_CompleteOCT_0inertia_0Dym_SetRealParam_C 1
#include <stdlib.h>
#include \"FMI/fmiImport.h\"
void Modelica_0IK4_0TEKNIKER_DCOL_Generation_CoolingTowers_FMI_CompleteOCT_0inertia_0Dym_fmiSetRealParam2(void*m, const int*refs, size_t nrefs, const double*vals, double*oldVals) {
  struct dy_Extended*a=m;
  fmiStatus status=fmiFatal;
  int i = 0;
  if(!nrefs){return;}
  if (a) {
    if(a->currentMode == dyInstantiationMode){
                status=a->dyFmiSetReal(a->m, refs, nrefs, vals);
    }else{
      status=a->dyFmiGetReal(a->m, refs, nrefs, oldVals);
      for(i=0; i<nrefs;++i){
        if( abs(vals[i]-oldVals[i])> 5e-16){
          ModelicaError(\"SetRealParameter: new parameters with diferent values are being set after initialization, this is not allowed\");
        }
      }
    }
  }
  if (status!=fmiOK && status!=fmiWarning) ModelicaError(\"SetReal failed\");
}
#endif", Library="Modelica_0IK4_0TEKNIKER_DCOL_Generation_CoolingTowers_FMI_CompleteOCT_0inertia_0Dym", LibraryDirectory="modelica://DCOL/Resources/Library/FMU/CompleteOCT_inertia_FMU/binaries",                        __Dymola_CriticalRegion="Modelica_0IK4_0TEKNIKER_DCOL_Generation_CoolingTowers_FMI_CompleteOCT_0inertia_0Dym",__Dymola_IdemPotent=true, __Dymola_VectorizedExceptFirst=true);
    end fmiSetRealParam;

    function fmiGetRealScalar
      input fmiModel fmi;
      input Integer ref;
      input Real dummy;
      output Real val;
    algorithm
        val := scalar(fmiGetReal(fmi, {ref}, dummy));
    end fmiGetRealScalar;

    function fmiGetReal
      input fmiModel fmi;
      input Integer refs[:];
      output Real vals[size(refs, 1)];
      input Real preAvailable;
      external"C" Modelica_0IK4_0TEKNIKER_DCOL_Generation_CoolingTowers_FMI_CompleteOCT_0inertia_0Dym_fmiGetReal2(
        fmi,
        refs,
        size(refs, 1),
        vals);
      annotation (Header="
#ifndef Modelica_0IK4_0TEKNIKER_DCOL_Generation_CoolingTowers_FMI_CompleteOCT_0inertia_0Dym_GetReal_C
#define Modelica_0IK4_0TEKNIKER_DCOL_Generation_CoolingTowers_FMI_CompleteOCT_0inertia_0Dym_GetReal_C 1
#include <stdlib.h>
#include \"FMI/fmiImport.h\"
void Modelica_0IK4_0TEKNIKER_DCOL_Generation_CoolingTowers_FMI_CompleteOCT_0inertia_0Dym_fmiGetReal2(void*m, const int*refs, size_t nrefs, double*vals) {
  struct dy_Extended*a=m;
  fmiStatus status=fmiFatal;
  if (a) {
    status=a->dyFmiGetReal(a->m, refs, nrefs, vals);
  }
  if (status!=fmiOK && status!=fmiWarning) ModelicaError(\"GetReal failed\");
}
#endif", Library="Modelica_0IK4_0TEKNIKER_DCOL_Generation_CoolingTowers_FMI_CompleteOCT_0inertia_0Dym", LibraryDirectory="modelica://DCOL/Resources/Library/FMU/CompleteOCT_inertia_FMU/binaries",                        __Dymola_CriticalRegion="Modelica_0IK4_0TEKNIKER_DCOL_Generation_CoolingTowers_FMI_CompleteOCT_0inertia_0Dym");
    end fmiGetReal;

    function fmiGetIntegerScalar
      input fmiModel fmi;
      input Integer ref;
      input Integer dummy;
      output Integer val;
    algorithm
        val := scalar(fmiGetInteger(fmi, {ref}, dummy));
    end fmiGetIntegerScalar;

    function fmiGetInteger
      input fmiModel fmi;
      input Integer refs[:];
      output Integer vals[size(refs, 1)];
      input Integer preAvailable;
      external"C" Modelica_0IK4_0TEKNIKER_DCOL_Generation_CoolingTowers_FMI_CompleteOCT_0inertia_0Dym_fmiGetInteger2(
        fmi,
        refs,
        size(refs, 1),
        vals);
      annotation (Header="
#ifndef Modelica_0IK4_0TEKNIKER_DCOL_Generation_CoolingTowers_FMI_CompleteOCT_0inertia_0Dym_GetInteger_C
#define Modelica_0IK4_0TEKNIKER_DCOL_Generation_CoolingTowers_FMI_CompleteOCT_0inertia_0Dym_GetInteger_C 1
#include <stdlib.h>
#include \"FMI/fmiImport.h\"
void Modelica_0IK4_0TEKNIKER_DCOL_Generation_CoolingTowers_FMI_CompleteOCT_0inertia_0Dym_fmiGetInteger2(void*m, const int*refs, size_t nrefs, int*vals) {
  struct dy_Extended*a=m;
  fmiStatus status=fmiFatal;
  if (a) {
    status=a->dyFmiGetInteger(a->m, refs, nrefs, vals);
  }
  if (status!=fmiOK && status!=fmiWarning) ModelicaError(\"GetInteger failed\");
}
#endif", Library="Modelica_0IK4_0TEKNIKER_DCOL_Generation_CoolingTowers_FMI_CompleteOCT_0inertia_0Dym", LibraryDirectory="modelica://DCOL/Resources/Library/FMU/CompleteOCT_inertia_FMU/binaries",                        __Dymola_CriticalRegion="Modelica_0IK4_0TEKNIKER_DCOL_Generation_CoolingTowers_FMI_CompleteOCT_0inertia_0Dym");
    end fmiGetInteger;

    function fmiSetInteger
    input fmiModel fmi;
      input Integer refs[:];
      input Integer vals[size(refs, 1)];
      output Real dummy= 1;
      external"C" Modelica_0IK4_0TEKNIKER_DCOL_Generation_CoolingTowers_FMI_CompleteOCT_0inertia_0Dym_fmiSetInteger2(
        fmi,
        refs,
        size(refs, 1),
        vals);
        annotation (Header="
#ifndef Modelica_0IK4_0TEKNIKER_DCOL_Generation_CoolingTowers_FMI_CompleteOCT_0inertia_0Dym_SetInteger_C
#define Modelica_0IK4_0TEKNIKER_DCOL_Generation_CoolingTowers_FMI_CompleteOCT_0inertia_0Dym_SetInteger_C 1
#include <stdlib.h>
#include \"FMI/fmiImport.h\"
void Modelica_0IK4_0TEKNIKER_DCOL_Generation_CoolingTowers_FMI_CompleteOCT_0inertia_0Dym_fmiSetInteger2(void*m, const int*refs, size_t nrefs, int*vals) {
  struct dy_Extended*a=m;
  fmiStatus status=fmiFatal;
  if(!nrefs){return;}
  if (a) {
    status=a->dyFmiSetInteger(a->m, refs, nrefs, vals);
  }
  if (status!=fmiOK && status!=fmiWarning) ModelicaError(\"SetInteger failed\");
}
#endif", Library="Modelica_0IK4_0TEKNIKER_DCOL_Generation_CoolingTowers_FMI_CompleteOCT_0inertia_0Dym", LibraryDirectory="modelica://DCOL/Resources/Library/FMU/CompleteOCT_inertia_FMU/binaries",                        __Dymola_CriticalRegion="Modelica_0IK4_0TEKNIKER_DCOL_Generation_CoolingTowers_FMI_CompleteOCT_0inertia_0Dym",__Dymola_IdemPotent=true, __Dymola_VectorizedExceptFirst=true);
    end fmiSetInteger;

    function fmiSetIntegerParam
    input fmiModel fmi;
      input Integer refs[:];
      input Integer vals[size(refs, 1)];
    protected
      Integer oldVals[size(refs, 1)];
      external"C" Modelica_0IK4_0TEKNIKER_DCOL_Generation_CoolingTowers_FMI_CompleteOCT_0inertia_0Dym_fmiSetIntegerParam2(
        fmi,
        refs,
        size(refs, 1),
        vals,
        oldVals);
        annotation (Header="
#ifndef Modelica_0IK4_0TEKNIKER_DCOL_Generation_CoolingTowers_FMI_CompleteOCT_0inertia_0Dym_SetIntegerParam_C
#define Modelica_0IK4_0TEKNIKER_DCOL_Generation_CoolingTowers_FMI_CompleteOCT_0inertia_0Dym_SetIntegerParam_C 1
#include <stdlib.h>
#include \"FMI/fmiImport.h\"
void Modelica_0IK4_0TEKNIKER_DCOL_Generation_CoolingTowers_FMI_CompleteOCT_0inertia_0Dym_fmiSetIntegerParam2(void*m, const int*refs, size_t nrefs, int*vals, int*oldVals) {
  struct dy_Extended*a=m;
  fmiStatus status=fmiFatal;
  int i=0;
  if(!nrefs){return;}
  if (a) {
    if(a->currentMode == dyInstantiationMode){
      status=a->dyFmiSetInteger(a->m, refs, nrefs, vals);
    }else{
      status=a->dyFmiGetInteger(a->m, refs, nrefs, oldVals);
      for(i = 0; i< nrefs; ++i){
        if(vals[i]!=oldVals[i]){
          ModelicaError(\"SetIntegerParameter: new parameters with diferent values are being set after initialization, this is not allowed\");
        }
      }
    }
  }
  if (status!=fmiOK && status!=fmiWarning) ModelicaError(\"SetInteger failed\");
}
#endif", Library="Modelica_0IK4_0TEKNIKER_DCOL_Generation_CoolingTowers_FMI_CompleteOCT_0inertia_0Dym", LibraryDirectory="modelica://DCOL/Resources/Library/FMU/CompleteOCT_inertia_FMU/binaries",                        __Dymola_CriticalRegion="Modelica_0IK4_0TEKNIKER_DCOL_Generation_CoolingTowers_FMI_CompleteOCT_0inertia_0Dym",__Dymola_IdemPotent=true, __Dymola_VectorizedExceptFirst=true);
    end fmiSetIntegerParam;

    function fmiGetBooleanScalar
      input fmiModel fmi;
      input Integer ref;
      input Integer dummy;
      output Boolean val;
    algorithm
        val := scalar(fmiGetBoolean(fmi, {ref}, dummy));
    end fmiGetBooleanScalar;

    function fmiGetBoolean
      input fmiModel fmi;
      input Integer refs[:];
      output Boolean vals[size(refs, 1)];
      input Integer preAvailable;
      external"C" Modelica_0IK4_0TEKNIKER_DCOL_Generation_CoolingTowers_FMI_CompleteOCT_0inertia_0Dym_fmiGetBoolean2(
        fmi,
        refs,
        size(refs, 1),
        vals);
        annotation (Header="
#ifndef Modelica_0IK4_0TEKNIKER_DCOL_Generation_CoolingTowers_FMI_CompleteOCT_0inertia_0Dym_GetBoolean_C
#define Modelica_0IK4_0TEKNIKER_DCOL_Generation_CoolingTowers_FMI_CompleteOCT_0inertia_0Dym_GetBoolean_C 1
#include \"FMI/fmiImport.h\"
void Modelica_0IK4_0TEKNIKER_DCOL_Generation_CoolingTowers_FMI_CompleteOCT_0inertia_0Dym_fmiGetBoolean2(void*m, const int* refs, size_t nr, int* vals) {
  int i;
  struct dy_Extended*a=m;
  fmiStatus status=fmiFatal;
  if (a) {
    status=a->dyFmiGetBoolean(a->m, refs, nr, (fmiBoolean*)(vals));
  }
  if (status!=fmiOK && status!=fmiWarning) ModelicaError(\"GetBoolean failed\");
  for(i=nr-1;i>=0;i--) vals[i]=((fmiBoolean*)(vals))[i];
}
#endif", Library="Modelica_0IK4_0TEKNIKER_DCOL_Generation_CoolingTowers_FMI_CompleteOCT_0inertia_0Dym", LibraryDirectory="modelica://DCOL/Resources/Library/FMU/CompleteOCT_inertia_FMU/binaries",                        __Dymola_CriticalRegion="Modelica_0IK4_0TEKNIKER_DCOL_Generation_CoolingTowers_FMI_CompleteOCT_0inertia_0Dym");
    end fmiGetBoolean;

    function fmiSetBoolean
      input fmiModel fmi;
      input Integer refs[:];
      input Boolean vals[size(refs, 1)];
      output Real dummy2= 1;
    protected
      Boolean dummy[size(refs, 1)];
      external"C" Modelica_0IK4_0TEKNIKER_DCOL_Generation_CoolingTowers_FMI_CompleteOCT_0inertia_0Dym_fmiSetBoolean2(
        fmi,
        refs,
        size(refs, 1),
        vals,
        dummy);
        annotation (Header="
#ifndef Modelica_0IK4_0TEKNIKER_DCOL_Generation_CoolingTowers_FMI_CompleteOCT_0inertia_0Dym_SetBoolean_C
#define Modelica_0IK4_0TEKNIKER_DCOL_Generation_CoolingTowers_FMI_CompleteOCT_0inertia_0Dym_SetBoolean_C 1
#include \"FMI/fmiImport.h\"
void Modelica_0IK4_0TEKNIKER_DCOL_Generation_CoolingTowers_FMI_CompleteOCT_0inertia_0Dym_fmiSetBoolean2(void*m, const int* refs, size_t nr, const int* vals,int*dummy) {
  int i;
  struct dy_Extended*a=m;
  fmiStatus status=fmiFatal;
  if(!nr){return;}
  for(i=0;i<nr;++i) ((fmiBoolean*)(dummy))[i]=vals[i];
  if (a) {
    status=a->dyFmiSetBoolean(a->m, refs, nr, (fmiBoolean*)(dummy));
  }
  if (status!=fmiOK && status!=fmiWarning) ModelicaError(\"SetBoolean failed\");
}
#endif", Library="Modelica_0IK4_0TEKNIKER_DCOL_Generation_CoolingTowers_FMI_CompleteOCT_0inertia_0Dym", LibraryDirectory="modelica://DCOL/Resources/Library/FMU/CompleteOCT_inertia_FMU/binaries",                        __Dymola_CriticalRegion="Modelica_0IK4_0TEKNIKER_DCOL_Generation_CoolingTowers_FMI_CompleteOCT_0inertia_0Dym",__Dymola_IdemPotent=true, __Dymola_VectorizedExceptFirst=true);
    end fmiSetBoolean;

    function fmiSetBooleanParam
      input fmiModel fmi;
      input Integer refs[:];
      input Boolean vals[size(refs, 1)];
    protected
      Boolean dummy[size(refs, 1)];
      Boolean oldVals[size(refs, 1)];
      external"C" Modelica_0IK4_0TEKNIKER_DCOL_Generation_CoolingTowers_FMI_CompleteOCT_0inertia_0Dym_fmiSetBooleanParam2(
      fmi,
        refs,
        size(refs, 1),
        vals,
        dummy,
        oldVals);
        annotation (Header="
#ifndef Modelica_0IK4_0TEKNIKER_DCOL_Generation_CoolingTowers_FMI_CompleteOCT_0inertia_0Dym_SetBooleanParam_C
#define Modelica_0IK4_0TEKNIKER_DCOL_Generation_CoolingTowers_FMI_CompleteOCT_0inertia_0Dym_SetBooleanParam_C 1
#include \"FMI/fmiImport.h\"
void Modelica_0IK4_0TEKNIKER_DCOL_Generation_CoolingTowers_FMI_CompleteOCT_0inertia_0Dym_fmiSetBooleanParam2(void*m, const int* refs, size_t nr, const int* vals,int*dummy,int*oldVals) {
  int i;
  struct dy_Extended*a=m;
  fmiStatus status=fmiFatal;
  if(!nr){return;}
  for(i=0;i<nr;++i) ((fmiBoolean*)(dummy))[i]=vals[i];
  if (a) {
    if(a->currentMode == dyInstantiationMode){
      status=a->dyFmiSetBoolean(a->m, refs, nr, (fmiBoolean*)(dummy));
    }else{
      status=a->dyFmiGetBoolean(a->m, refs, nr, (fmiBoolean*)(oldVals));
      for(i=nr-1;i>=0;i--){
        oldVals[i]=((fmiBoolean*)(oldVals))[i];
        if(oldVals[i]!=dummy[i]){
          ModelicaError(\"SetIntegerParameter: new parameters with diferent values are being set after initialization, this is not allowed\");
        }
      }
    }
  }
  if (status!=fmiOK && status!=fmiWarning) ModelicaError(\"SetBoolean failed\");
}
#endif", Library="Modelica_0IK4_0TEKNIKER_DCOL_Generation_CoolingTowers_FMI_CompleteOCT_0inertia_0Dym", LibraryDirectory="modelica://DCOL/Resources/Library/FMU/CompleteOCT_inertia_FMU/binaries",                        __Dymola_CriticalRegion="Modelica_0IK4_0TEKNIKER_DCOL_Generation_CoolingTowers_FMI_CompleteOCT_0inertia_0Dym",__Dymola_IdemPotent=true, __Dymola_VectorizedExceptFirst=true);
    end fmiSetBooleanParam;

    function fmiGetString
      input fmiModel fmi;
      input Integer refs[:];
      output String vals[size(refs, 1)];
      input Integer preAvailable;
      external"C" Modelica_0IK4_0TEKNIKER_DCOL_Generation_CoolingTowers_FMI_CompleteOCT_0inertia_0Dym_fmiGetString2(
        fmi,
        refs,
        size(refs, 1),
        vals);
      annotation (Header="
#ifndef Modelica_0IK4_0TEKNIKER_DCOL_Generation_CoolingTowers_FMI_CompleteOCT_0inertia_0Dym_GetString_C
#define Modelica_0IK4_0TEKNIKER_DCOL_Generation_CoolingTowers_FMI_CompleteOCT_0inertia_0Dym_GetString_C 1
#include <stdlib.h>
#include \"FMI/fmiImport.h\"
void Modelica_0IK4_0TEKNIKER_DCOL_Generation_CoolingTowers_FMI_CompleteOCT_0inertia_0Dym_fmiGetString2(void*m, const int*refs, size_t nrefs, fmiString* vals) {
  struct dy_Extended*a=m;
  fmiStatus status=fmiFatal;
  if (a) {
    status=a->dyFmiGetString(a->m, refs, nrefs, vals);
  }
  if (status!=fmiOK && status!=fmiWarning) ModelicaError(\"StringInteger failed\");
}
#endif", Library="Modelica_0IK4_0TEKNIKER_DCOL_Generation_CoolingTowers_FMI_CompleteOCT_0inertia_0Dym", LibraryDirectory="modelica://DCOL/Resources/Library/FMU/CompleteOCT_inertia_FMU/binaries",                        __Dymola_CriticalRegion="Modelica_0IK4_0TEKNIKER_DCOL_Generation_CoolingTowers_FMI_CompleteOCT_0inertia_0Dym");
    end fmiGetString;

    function fmiSetString
    input fmiModel fmi;
      input Integer refs[:];
      input String vals[size(refs, 1)];
      external"C" Modelica_0IK4_0TEKNIKER_DCOL_Generation_CoolingTowers_FMI_CompleteOCT_0inertia_0Dym_fmiSetString2(
        fmi,
        refs,
        size(refs, 1),
        vals);
        annotation (Header="
#ifndef Modelica_0IK4_0TEKNIKER_DCOL_Generation_CoolingTowers_FMI_CompleteOCT_0inertia_0Dym_SetString_C
#define Modelica_0IK4_0TEKNIKER_DCOL_Generation_CoolingTowers_FMI_CompleteOCT_0inertia_0Dym_SetString_C 1
#include \"FMI/fmiImport.h\"
#include <stdlib.h>
void Modelica_0IK4_0TEKNIKER_DCOL_Generation_CoolingTowers_FMI_CompleteOCT_0inertia_0Dym_fmiSetString2(void*m, const int*refs, size_t nrefs, const fmiString vals[]) {
  struct dy_Extended*a=m;
  fmiStatus status=fmiFatal;
  if(!nrefs){return;}
  if (a) {
    status=a->dyFmiSetString(a->m, refs, nrefs, vals);
  }
  if (status!=fmiOK && status!=fmiWarning) ModelicaError(\"SetString failed\");
}
#endif", Library="Modelica_0IK4_0TEKNIKER_DCOL_Generation_CoolingTowers_FMI_CompleteOCT_0inertia_0Dym", LibraryDirectory="modelica://DCOL/Resources/Library/FMU/CompleteOCT_inertia_FMU/binaries",                        __Dymola_CriticalRegion="Modelica_0IK4_0TEKNIKER_DCOL_Generation_CoolingTowers_FMI_CompleteOCT_0inertia_0Dym",__Dymola_IdemPotent=true, __Dymola_VectorizedExceptFirst=true);
    end fmiSetString;

    function fmiSetStringParam
    input fmiModel fmi;
      input Integer refs[:];
      input String vals[size(refs, 1)];
      external"C" Modelica_0IK4_0TEKNIKER_DCOL_Generation_CoolingTowers_FMI_CompleteOCT_0inertia_0Dym_fmiSetStringParam2(
        fmi,
        refs,
        size(refs, 1),
        vals);
        annotation (Header="
#ifndef Modelica_0IK4_0TEKNIKER_DCOL_Generation_CoolingTowers_FMI_CompleteOCT_0inertia_0Dym_SetStringParam_C
#define Modelica_0IK4_0TEKNIKER_DCOL_Generation_CoolingTowers_FMI_CompleteOCT_0inertia_0Dym_SetStringParam_C 1
#include \"FMI/fmiImport.h\"
#include <stdlib.h>
void Modelica_0IK4_0TEKNIKER_DCOL_Generation_CoolingTowers_FMI_CompleteOCT_0inertia_0Dym_fmiSetStringParam2(void*m, const int*refs, size_t nrefs, const fmiString vals[]) {
  struct dy_Extended*a=m;
  fmiStatus status=fmiFatal;
  if(!nrefs){return;}
  if (a) {
    if(a->currentMode == dyInstantiationMode){
                status=a->dyFmiSetString(a->m, refs, nrefs, vals);
    }else{
      status=fmiOK;
    }
  }
  if (status!=fmiOK && status!=fmiWarning) ModelicaError(\"SetString failed\");
}
#endif", Library="Modelica_0IK4_0TEKNIKER_DCOL_Generation_CoolingTowers_FMI_CompleteOCT_0inertia_0Dym", LibraryDirectory="modelica://DCOL/Resources/Library/FMU/CompleteOCT_inertia_FMU/binaries",                        __Dymola_CriticalRegion="Modelica_0IK4_0TEKNIKER_DCOL_Generation_CoolingTowers_FMI_CompleteOCT_0inertia_0Dym",__Dymola_IdemPotent=true, __Dymola_VectorizedExceptFirst=true);
    end fmiSetStringParam;

    function noHysteresis
      input Real x;
      output Real y;
    algorithm
      y:=x+(if (x < 0) then -1 else 1);
    end noHysteresis;
end fmi_Functions;
equation
  when initial() then
    fmi = fmi_Functions.fmiModel(fmi_instanceName, fmi_loggingOn, fmi_fmuLocation);
  end when;
algorithm
  when {initial(), sample(fmi_StartTime, fmi_CommunicationStepSize)} then
    if time>=fmi_CommunicationStepSize +fmi_StartTime then
    if fmi_InputTime then
      fmi_Functions.fmiSetReal(fmi, {352321536}, {_outletAir_m_flow_old});
    else
      if fmi_UsePreOnInputSignals then
        fmi_Functions.fmiSetReal(fmi, {352321536}, {pre(outletAir_m_flow)});
      else
        fmi_Functions.fmiSetReal(fmi, {352321536}, {outletAir_m_flow});
      end if;
    end if;
    if fmi_InputTime then
      fmi_Functions.fmiSetReal(fmi, {352321537}, {_inletWater_m_flow_old});
    else
      if fmi_UsePreOnInputSignals then
        fmi_Functions.fmiSetReal(fmi, {352321537}, {pre(inletWater_m_flow)});
      else
        fmi_Functions.fmiSetReal(fmi, {352321537}, {inletWater_m_flow});
      end if;
    end if;
    if fmi_InputTime then
      fmi_Functions.fmiSetReal(fmi, {352321538}, {_inletWater_T_old});
    else
      if fmi_UsePreOnInputSignals then
        fmi_Functions.fmiSetReal(fmi, {352321538}, {pre(inletWater_T)});
      else
        fmi_Functions.fmiSetReal(fmi, {352321538}, {inletWater_T});
      end if;
    end if;
    if fmi_InputTime then
      fmi_Functions.fmiSetReal(fmi, {352321539}, {_ambient_T_old});
    else
      if fmi_UsePreOnInputSignals then
        fmi_Functions.fmiSetReal(fmi, {352321539}, {pre(ambient_T)});
      else
        fmi_Functions.fmiSetReal(fmi, {352321539}, {ambient_T});
      end if;
    end if;
    if fmi_InputTime then
      fmi_Functions.fmiSetReal(fmi, {352321540}, {_outletWater_m_flow_old});
    else
      if fmi_UsePreOnInputSignals then
        fmi_Functions.fmiSetReal(fmi, {352321540}, {pre(outletWater_m_flow)});
      else
        fmi_Functions.fmiSetReal(fmi, {352321540}, {outletWater_m_flow});
      end if;
    end if;
    if fmi_InputTime then
      fmi_Functions.fmiSetReal(fmi, {352321541}, {_inletAir_X_old});
    else
      if fmi_UsePreOnInputSignals then
        fmi_Functions.fmiSetReal(fmi, {352321541}, {pre(inletAir_X)});
      else
        fmi_Functions.fmiSetReal(fmi, {352321541}, {inletAir_X});
      end if;
    end if;
      for stepSizeIndex in 1:stepSizeScaleFactor loop
        fmi_StepOK :=fmi_Functions.fmiDoStep(
          fmi,
          time + (stepSizeIndex - 1 - stepSizeScaleFactor)*
            fmi_CommunicationStepSize/stepSizeScaleFactor,
          fmi_CommunicationStepSize/stepSizeScaleFactor);
      end for;
    end if;
    _outletAir_m_flow_old := outletAir_m_flow;
    _inletWater_m_flow_old := inletWater_m_flow;
    _inletWater_T_old := inletWater_T;
    _ambient_T_old := ambient_T;
    _outletWater_m_flow_old := outletWater_m_flow;
    _inletAir_X_old := inletAir_X;
  outletWater_T :=fmi_Functions.fmiGetRealScalar(
      fmi,
      335544320,
      1);
  outletAir_T :=fmi_Functions.fmiGetRealScalar(
      fmi,
      335544321,
      1);
RealVariables1 :=fmi_Functions.fmiGetReal(
      fmi,
      {352321537,905969992,369099081,637534241,905969992,637534242,369098849,
        369098851,352321541,369099314,369099265,369098852,369098788,369098789,
        369099081,369098790,369098791,369098793,637534242,637534250,369098795,
        369098796,369098851,369098849,352321541,369098797,369098798,369098799,
        369098800,369098801,905969714,369098803,905969716,369098805,905969718,
        369098807,369098852,369098808,905969765,369098799,369098809,905969722,
        369098811,369098812,905969725,369098814,905969727,369098816,905969729,
        905969730,369098820,369098821,369098807,369098822,369098823,369098824,
        637534281,369098826,369098828,369098829,369098833,369098834,905969747,
        369098838,369098839,369098840,33554432,587202560,369098849,369098851,
        352321541,369099314,369099265,369098852,905969765,352321537,905969992,
        369099081,369099143,905970017,369098854,33554433,587202561,637534311,
        637534312,637534311,369098854,33554434,587202562,637534329,637534330,
        33554434,905969792,905969794,637534339,637534340,637534341,637534341,
        637534342,637534343},
      1);
RealVariables2 :=fmi_Functions.fmiGetReal(
      fmi,
      {369099143,905970017,369098854,637534603,905970043,369098854,637534250,
        905969992,369098854,637534353,637534354,637534355,33554434,905969815,
        637534343,33554434,637534343,33554434,33554434,637534343,637534366,
        637534367,637534368,637534369,637534370,637534371,905969828,905969829,
        905969830,905969831,905969832,905969833,905969837,905969838,905969839,
        100663439,100663439,100663439,637534600,637534394,637534395,637534600,
        352321539,637534524,637534396,637534397,637534398,637534399,637534400,
        637534401,637534402,637534403,637534404,637534405,637534406,637534407,
        637534408,16777277,637534410,637534603,905970043,369098854,637534398,
        637534602,33554435,587202563,637534419,33554435,637534419,587202563,
        637534422,33554436,587202564,637534424,33554436,637534424,587202564,
        637534427,33554437,587202565,637534429,33554437,637534429,587202565,
        637534432,637534434,637534435,637534395,637534434,33554435,637534436,
        637534437,637534438,637534439,637534442,637534443,637534395,637534442,
        33554436,637534444},
      1);
RealVariables3 :=fmi_Functions.fmiGetReal(
      fmi,
      {637534445,637534446,637534447,637534450,637534451,33554435,637534450,
        33554434,637534452,637534453,637534454,637534455,637534458,637534459,
        33554436,637534458,33554434,637534460,637534461,637534462,637534463,
        637534466,637534467,33554437,637534466,33554434,637534468,637534469,
        637534470,637534471,637534410,637534474,16777277,637534410,33554437,
        637534601,637534475,637534476,637534477,33554434,637534480,637534395,
        637534524,33554438,587202566,637534481,33554438,637534481,587202566,
        637534484,33554439,587202567,637534486,33554439,637534486,587202567,
        637534489,637534491,637534492,33554438,637534491,33554434,637534493,
        637534494,637534495,637534496,905969956,33554439,905969958,905969960,
        905969961,905969962,637534509,637534510,637534395,637534509,33554438,
        637534511,637534512,637534513,637534514,637534486,637534517,637534395,
        637534486,33554439,637534518,637534519,637534520,637534521,16777277,
        637534410,352321539,637534524,905969992,369099081,352321538,905969984,
        905969992,352321538},
      1);
RealVariables4 :=fmi_Functions.fmiGetReal(
      fmi,
      {905969989,905969990,905969991,905969992,369099081,352321537,352321538,
        905970017,905970017,905970015,369099104,905970017,369099143,905970043,
        905970043,905970041,905970042,905970043,637534603,352321540,369099143,
        352321539,637534600,352321539,16777277,637534601,637534602,637534603,
        369099265,369099266,905970062,905970066,905970067,369099265,905970075,
        905970077,369099264,369099265,369099266,369099314,352321541,369098851,
        905970194,352321539,352321541,905970195,905970196,905970197,905970198,
        352321539,352321541,905970195,905970202,905970204,905970205,369099300,
        369098851,352321541,352321539,352321541,905970225,352321536,369099314,
        905970017,335544320,369099265,335544321,369098849,369098851,352321541,
        369099300,369098851,352321541,369098849,352321537,905969992,369099081,
        905969992,369099081,352321537},
      1);
  end when;
initial algorithm
  fmi_AParamsAndStart:=1;
 // 60 Real parameters
  fmi_Functions.fmiSetRealParam(fmi, {16777216, 16777217, 16777218, 16777219, 16777220, 16777221, 16777222, 16777223, 16777224, 16777225, 16777226, 16777227, 16777228, 16777229, 16777230, 16777231, 16777232, 16777233, 16777234, 16777235, 16777236, 16777237, 16777245, 16777246, 16777247, 16777248, 16777249, 16777250, 16777251, 16777252, 16777253, 16777254, 16777255, 16777256, 16777257, 16777258, 16777259, 16777260, 16777261, 16777262, 16777263, 16777264, 16777265, 16777266, 16777267, 16777268, 16777269, 16777270, 16777271, 16777272, 16777273, 16777274, 16777275, 16777276, 16777277, 16777278, 16777279, 16777280, 16777281, 16777282}, {'system'.T_ambient, 'system'.g, 'system'.m_flow_start, 'system'.eps_m_flow, 'system'.dp_small, 'system'.m_flow_small, hmax, hmin, L_basin, w, e, c, n, Kfi, hfi, wfi, lfi, C_iner, TWater2_start, TAir2_start, H2_start, mAir1_start, openCT2.waterBasin.'X_start[1]', openCT2.waterBasin.'portsData[1]'.diameter, openCT2.waterBasin.'portsData[1]'.height, openCT2.waterBasin.'portsData[1]'.zeta_out, openCT2.waterBasin.'portsData[1]'.zeta_in, openCT2.waterBasin.'portsData[2]'.diameter, openCT2.waterBasin.'portsData[2]'.height, openCT2.waterBasin.'portsData[2]'.zeta_out, openCT2.waterBasin.'portsData[2]'.zeta_in, openCT2.waterBasin.'portsData[3]'.zeta_out, openCT2.waterBasin.'portsData[3]'.zeta_in, openCT2.storageWall.'sideInertia[1]'.T_start, openCT2.storageWall.'sideInertia[1]'.der_T_start, openCT2.storageWall.'sideInertia[2]'.T_start, openCT2.storageWall.'sideInertia[2]'.der_T_start, openCT2.storageWall.topInertia.T_start, openCT2.storageWall.topInertia.der_T_start, openCT2.storageWall.'sideCond2[1]'.T_start, openCT2.storageWall.'sideCond2[2]'.T_start, openCT2.storageWall.'sideCond1[1]'.T_start, openCT2.storageWall.'sideCond1[2]'.T_start, openCT2.storageWall.topCond1.T_start, openCT2.storageWall.topCond2.T_start, openCT2.storageWall.'frontInertia[1]'.T_start, openCT2.storageWall.'frontInertia[1]'.der_T_start, openCT2.storageWall.'frontInertia[2]'.T_start, openCT2.storageWall.'frontInertia[2]'.der_T_start, openCT2.storageWall.'frontCond1[1]'.T_start, openCT2.storageWall.'frontCond1[2]'.T_start, openCT2.storageWall.'frontCond2[1]'.T_start, openCT2.storageWall.'frontCond2[2]'.T_start, gain.k, floorTemperature.T, levelControl.hmax, levelControl.hmin, levelControl.m_In, levelControl.m_Out, gain1.k});
 // 2 Real start values
  fmi_Functions.fmiSetRealParam(fmi, {33554432, 637534603}, {openCT2.openHTX._Tfi_start, levelControl._m_outflow_start});
 // 0 Integer parameters
 // 0 Integer start values
 // 0 Boolean parameters
 // 0 Boolean start values
 // 0 Enumeration parameters
 // 0 Enumeration start values
 // 0 String parameters
initial equation
if fmi_pullInputsForInitialization then fmi_initInput0 = fmi_Functions.fmiSetReal(fmi, {352321536}, {pre(outletAir_m_flow)}); else fmi_initInput0 = fmi_Functions.fmiSetReal(fmi, {352321536}, {_outletAir_m_flow_start}); end if;
if fmi_pullInputsForInitialization then fmi_initInput1 = fmi_Functions.fmiSetReal(fmi, {352321537}, {pre(inletWater_m_flow)}); else fmi_initInput1 = fmi_Functions.fmiSetReal(fmi, {352321537}, {_inletWater_m_flow_start}); end if;
if fmi_pullInputsForInitialization then fmi_initInput2 = fmi_Functions.fmiSetReal(fmi, {352321538}, {pre(inletWater_T)}); else fmi_initInput2 = fmi_Functions.fmiSetReal(fmi, {352321538}, {_inletWater_T_start}); end if;
if fmi_pullInputsForInitialization then fmi_initInput3 = fmi_Functions.fmiSetReal(fmi, {352321539}, {pre(ambient_T)}); else fmi_initInput3 = fmi_Functions.fmiSetReal(fmi, {352321539}, {_ambient_T_start}); end if;
if fmi_pullInputsForInitialization then fmi_initInput4 = fmi_Functions.fmiSetReal(fmi, {352321540}, {pre(outletWater_m_flow)}); else fmi_initInput4 = fmi_Functions.fmiSetReal(fmi, {352321540}, {_outletWater_m_flow_start}); end if;
if fmi_pullInputsForInitialization then fmi_initInput5 = fmi_Functions.fmiSetReal(fmi, {352321541}, {pre(inletAir_X)}); else fmi_initInput5 = fmi_Functions.fmiSetReal(fmi, {352321541}, {_inletAir_X_start}); end if;
  fmi_Initialized = fmi_Functions.fmiInitializeSlave(fmi, fmi_StartTime, fmi_forceShutDownAtStopTime, fmi_StopTime,fmi_AParamsAndStart+ fmi_initInput0+ fmi_initInput1+ fmi_initInput2+ fmi_initInput3+ fmi_initInput4+ fmi_initInput5);
RealDependentParameters = fmi_Functions.fmiGetReal(fmi, {100663304, 100663306, 100663310, 100663311, 100663312, 100663313, 100663314, 100663315, 100663316, 100663317, 100663318, 100663319, 100663320, 100663321, 100663322, 100663323, 100663324, 100663325, 100663326, 100663327, 100663371, 100663374, 100663375, 100663376, 100663380, 100663381, 100663386, 100663387, 100663388, 100663389, 100663390, 100663391, 100663392, 100663401, 100663402, 100663404, 100663405, 100663412, 100663413, 100663436, 100663437, 100663438, 100663439, 100663450, 100663466, 100663467, 100663468, 100663497, 100663499, 100663500, 100663501, 100663502, 100663503, 100663508, 100663509, 100663513, 100663514, 100663518, 100663519, 100663528, 100663529, 100663536, 100663537, 100663544, 100663545, 100663552, 100663553, 100663560, 100663561, 100663566, 100663567, 100663570, 100663571, 100663575, 100663576, 100663585, 100663586, 100663595, 100663596, 100663603, 100663604, 100663610, 100663611, 100663870, 100663871, 100663873, 100663874},fmi_Initialized);
equation
  openCT2.openHTX.port_a_water.m_flow = RealVariables1[1];
  openCT2.openHTX.port_a_water.p = RealVariables1[2];
  openCT2.openHTX.port_a_water.h_outflow = RealVariables1[3];
  openCT2.openHTX.port_b_water.m_flow = RealVariables1[4];
  openCT2.openHTX.port_b_water.p = RealVariables1[5];
  openCT2.openHTX.port_b_water.h_outflow = RealVariables1[6];
  openCT2.openHTX.port_a_air.m_flow = RealVariables1[7];
  openCT2.openHTX.port_a_air.h_outflow = RealVariables1[8];
  openCT2.openHTX.port_a_air.'Xi_outflow[1]' = RealVariables1[9];
  openCT2.openHTX.port_b_air.m_flow = RealVariables1[10];
  openCT2.openHTX.port_b_air.p = RealVariables1[11];
  openCT2.openHTX.port_b_air.h_outflow = RealVariables1[12];
  openCT2.openHTX.port_b_air.'Xi_outflow[1]' = RealVariables1[13];
  openCT2.openHTX.TWater1 = RealVariables1[14];
  openCT2.openHTX.hWater1 = RealVariables1[15];
  openCT2.openHTX.mWater1 = RealVariables1[16];
  openCT2.openHTX.TWater1C = RealVariables1[17];
  openCT2.openHTX.TWater2 = RealVariables1[18];
  openCT2.openHTX.hWater2 = RealVariables1[19];
  openCT2.openHTX.mWater2 = RealVariables1[20];
  openCT2.openHTX.TWater2C = RealVariables1[21];
  openCT2.openHTX.TAir1 = RealVariables1[22];
  openCT2.openHTX.hAir1 = RealVariables1[23];
  openCT2.openHTX.mAir1 = RealVariables1[24];
  openCT2.openHTX.X1 = RealVariables1[25];
  openCT2.openHTX.TAir1C = RealVariables1[26];
  openCT2.openHTX.H1 = RealVariables1[27];
  openCT2.openHTX.mDAir1 = RealVariables1[28];
  openCT2.openHTX.mVap1 = RealVariables1[29];
  openCT2.openHTX.hsw1 = RealVariables1[30];
  openCT2.openHTX.Hsat1 = RealVariables1[31];
  openCT2.openHTX.Hsat1w = RealVariables1[32];
  openCT2.openHTX.pSat1 = RealVariables1[33];
  openCT2.openHTX.rho1 = RealVariables1[34];
  openCT2.openHTX.N1 = RealVariables1[35];
  openCT2.openHTX.TAir2 = RealVariables1[36];
  openCT2.openHTX.hAir2 = RealVariables1[37];
  openCT2.openHTX.mAir2 = RealVariables1[38];
  openCT2.openHTX.X2 = RealVariables1[39];
  openCT2.openHTX.mDAir2 = RealVariables1[40];
  openCT2.openHTX.mVap2 = RealVariables1[41];
  openCT2.openHTX.H2 = RealVariables1[42];
  openCT2.openHTX.TAir2C = RealVariables1[43];
  openCT2.openHTX.hsw2 = RealVariables1[44];
  openCT2.openHTX.Hsat2 = RealVariables1[45];
  openCT2.openHTX.Hsat2w = RealVariables1[46];
  openCT2.openHTX.pSat2 = RealVariables1[47];
  openCT2.openHTX.rho2 = RealVariables1[48];
  openCT2.openHTX.N2 = RealVariables1[49];
  openCT2.openHTX.phi2 = RealVariables1[50];
  openCT2.openHTX.mEvap = RealVariables1[51];
  openCT2.openHTX.hvap = RealVariables1[52];
  openCT2.openHTX.Tvap = RealVariables1[53];
  openCT2.openHTX.TvapC = RealVariables1[54];
  openCT2.openHTX.Qsen = RealVariables1[55];
  openCT2.openHTX.Qlat = RealVariables1[56];
  openCT2.openHTX.Qfi = RealVariables1[57];
  openCT2.openHTX.Qtot = RealVariables1[58];
  openCT2.openHTX.mMed = RealVariables1[59];
  openCT2.openHTX.rhoMed = RealVariables1[60];
  openCT2.openHTX.IncP = RealVariables1[61];
  openCT2.openHTX.e_a = RealVariables1[62];
  openCT2.openHTX.efficiency = RealVariables1[63];
  openCT2.openHTX.NTU = RealVariables1[64];
  openCT2.openHTX.C_s = RealVariables1[65];
  openCT2.openHTX.m_ratio = RealVariables1[66];
  openCT2.openHTX.Tfi = RealVariables1[67];
  openCT2.openHTX.Tfi_der = RealVariables1[68];
  openCT2.port_a_air.m_flow = RealVariables1[69];
  openCT2.port_a_air.h_outflow = RealVariables1[70];
  openCT2.port_a_air.'Xi_outflow[1]' = RealVariables1[71];
  openCT2.port_b_air.m_flow = RealVariables1[72];
  openCT2.port_b_air.p = RealVariables1[73];
  openCT2.port_b_air.h_outflow = RealVariables1[74];
  openCT2.port_b_air.'Xi_outflow[1]' = RealVariables1[75];
  openCT2.port_a_water.m_flow = RealVariables1[76];
  openCT2.port_a_water.p = RealVariables1[77];
  openCT2.port_a_water.h_outflow = RealVariables1[78];
  openCT2.port_b_water.m_flow = RealVariables1[79];
  openCT2.port_b_water.p = RealVariables1[80];
  openCT2.port_b_water.h_outflow = RealVariables1[81];
  openCT2.waterBasin.level = RealVariables1[82];
  openCT2.waterBasin.level_der = RealVariables1[83];
  openCT2.waterBasin.V = RealVariables1[84];
  openCT2.waterBasin.V_der = RealVariables1[85];
  openCT2.waterBasin.fluidVolume = RealVariables1[86];
  openCT2.waterBasin.medium.h = RealVariables1[87];
  openCT2.waterBasin.medium.T = RealVariables1[88];
  openCT2.waterBasin.medium.T_der = RealVariables1[89];
  openCT2.waterBasin.medium.u = RealVariables1[90];
  openCT2.waterBasin.medium.u_der = RealVariables1[91];
  openCT2.waterBasin.medium.state.T = RealVariables1[92];
  openCT2.waterBasin.medium.T_degC = RealVariables1[93];
  openCT2.waterBasin.U = RealVariables1[94];
  openCT2.waterBasin.U_der = RealVariables1[95];
  openCT2.waterBasin.m = RealVariables1[96];
  openCT2.waterBasin.m_der = RealVariables1[97];
  openCT2.waterBasin.mb_flow = RealVariables1[98];
  openCT2.waterBasin.Hb_flow = RealVariables1[99];
  openCT2.waterBasin.Qb_flow = RealVariables1[100];
  openCT2.waterBasin.'ports[1]'.m_flow = RealVariables2[1];
  openCT2.waterBasin.'ports[1]'.p = RealVariables2[2];
  openCT2.waterBasin.'ports[1]'.h_outflow = RealVariables2[3];
  openCT2.waterBasin.'ports[2]'.m_flow = RealVariables2[4];
  openCT2.waterBasin.'ports[2]'.p = RealVariables2[5];
  openCT2.waterBasin.'ports[2]'.h_outflow = RealVariables2[6];
  openCT2.waterBasin.'ports[3]'.m_flow = RealVariables2[7];
  openCT2.waterBasin.'ports[3]'.p = RealVariables2[8];
  openCT2.waterBasin.'ports[3]'.h_outflow = RealVariables2[9];
  openCT2.waterBasin.'ports_H_flow[1]' = RealVariables2[10];
  openCT2.waterBasin.'ports_H_flow[2]' = RealVariables2[11];
  openCT2.waterBasin.'ports_H_flow[3]' = RealVariables2[12];
  openCT2.waterBasin.heatTransfer.'states[1]'.T = RealVariables2[13];
  openCT2.waterBasin.heatTransfer.'surfaceAreas[1]' = RealVariables2[14];
  openCT2.waterBasin.heatTransfer.'Q_flows[1]' = RealVariables2[15];
  openCT2.waterBasin.heatTransfer.'heatPorts[1]'.T = RealVariables2[16];
  openCT2.waterBasin.heatTransfer.'heatPorts[1]'.Q_flow = RealVariables2[17];
  openCT2.waterBasin.heatTransfer.'Ts[1]' = RealVariables2[18];
  openCT2.waterBasin.heatPort.T = RealVariables2[19];
  openCT2.waterBasin.heatPort.Q_flow = RealVariables2[20];
  openCT2.waterBasin.'portVelocities[1]' = RealVariables2[21];
  openCT2.waterBasin.'portVelocities[2]' = RealVariables2[22];
  openCT2.waterBasin.'portVelocities[3]' = RealVariables2[23];
  openCT2.waterBasin.'ports_E_flow[1]' = RealVariables2[24];
  openCT2.waterBasin.'ports_E_flow[2]' = RealVariables2[25];
  openCT2.waterBasin.'ports_E_flow[3]' = RealVariables2[26];
  openCT2.waterBasin.'s[1]' = RealVariables2[27];
  openCT2.waterBasin.'s[2]' = RealVariables2[28];
  openCT2.waterBasin.'s[3]' = RealVariables2[29];
  openCT2.waterBasin.'ports_penetration[1]' = RealVariables2[30];
  openCT2.waterBasin.'ports_penetration[2]' = RealVariables2[31];
  openCT2.waterBasin.'ports_penetration[3]' = RealVariables2[32];
  openCT2.waterBasin.'vessel_ps_static[1]' = RealVariables2[33];
  openCT2.waterBasin.'vessel_ps_static[2]' = RealVariables2[34];
  openCT2.waterBasin.'vessel_ps_static[3]' = RealVariables2[35];
  openCT2.waterBasin.'m_flow_turbulent[1]' = RealVariables2[36];
  openCT2.waterBasin.'m_flow_turbulent[2]' = RealVariables2[37];
  openCT2.waterBasin.'m_flow_turbulent[3]' = RealVariables2[38];
  openCT2.naturalConvectionVerticalPlate.Q_flow = RealVariables2[39];
  openCT2.naturalConvectionVerticalPlate.dT = RealVariables2[40];
  openCT2.naturalConvectionVerticalPlate.solid.T = RealVariables2[41];
  openCT2.naturalConvectionVerticalPlate.solid.Q_flow = RealVariables2[42];
  openCT2.naturalConvectionVerticalPlate.fluid.T = RealVariables2[43];
  openCT2.naturalConvectionVerticalPlate.fluid.Q_flow = RealVariables2[44];
  openCT2.naturalConvectionVerticalPlate.Gc = RealVariables2[45];
  openCT2.naturalConvectionVerticalPlate.h = RealVariables2[46];
  openCT2.naturalConvectionVerticalPlate.A = RealVariables2[47];
  openCT2.naturalConvectionVerticalPlate.beta = RealVariables2[48];
  openCT2.naturalConvectionVerticalPlate.Gr = RealVariables2[49];
  openCT2.naturalConvectionVerticalPlate.Ra = RealVariables2[50];
  openCT2.naturalConvectionVerticalPlate.NuL = RealVariables2[51];
  openCT2.naturalConvectionVerticalPlate.NuL1 = RealVariables2[52];
  openCT2.naturalConvectionVerticalPlate.NuL2 = RealVariables2[53];
  openCT2.naturalConvectionVerticalPlate.Pr = RealVariables2[54];
  openCT2.naturalConvectionVerticalPlate.visco = RealVariables2[55];
  openCT2.naturalConvectionVerticalPlate.K = RealVariables2[56];
  openCT2.naturalConvectionVerticalPlate.Tc = RealVariables2[57];
  openCT2.port_a_floor.T = RealVariables2[58];
  openCT2.port_a_floor.Q_flow = RealVariables2[59];
  openCT2.port_a_Owater.m_flow = RealVariables2[60];
  openCT2.port_a_Owater.p = RealVariables2[61];
  openCT2.port_a_Owater.h_outflow = RealVariables2[62];
  openCT2.A.y = RealVariables2[63];
  openCT2.level = RealVariables2[64];
  openCT2.storageWall.'sideInertia[1]'.T = RealVariables2[65];
  openCT2.storageWall.'sideInertia[1]'.T_der = RealVariables2[66];
  openCT2.storageWall.'sideInertia[1]'.Q_flow = RealVariables2[67];
  openCT2.storageWall.'sideInertia[1]'.port.T = RealVariables2[68];
  openCT2.storageWall.'sideInertia[1]'.port.Q_flow = RealVariables2[69];
  openCT2.storageWall.'sideInertia[1]'.der_T = RealVariables2[70];
  openCT2.storageWall.'sideInertia[1]'.C = RealVariables2[71];
  openCT2.storageWall.'sideInertia[2]'.T = RealVariables2[72];
  openCT2.storageWall.'sideInertia[2]'.T_der = RealVariables2[73];
  openCT2.storageWall.'sideInertia[2]'.Q_flow = RealVariables2[74];
  openCT2.storageWall.'sideInertia[2]'.port.T = RealVariables2[75];
  openCT2.storageWall.'sideInertia[2]'.port.Q_flow = RealVariables2[76];
  openCT2.storageWall.'sideInertia[2]'.der_T = RealVariables2[77];
  openCT2.storageWall.'sideInertia[2]'.C = RealVariables2[78];
  openCT2.storageWall.topInertia.T = RealVariables2[79];
  openCT2.storageWall.topInertia.T_der = RealVariables2[80];
  openCT2.storageWall.topInertia.Q_flow = RealVariables2[81];
  openCT2.storageWall.topInertia.port.T = RealVariables2[82];
  openCT2.storageWall.topInertia.port.Q_flow = RealVariables2[83];
  openCT2.storageWall.topInertia.der_T = RealVariables2[84];
  openCT2.storageWall.topInertia.C = RealVariables2[85];
  openCT2.storageWall.'sideCond2[1]'.Q_flow = RealVariables2[86];
  openCT2.storageWall.'sideCond2[1]'.dT = RealVariables2[87];
  openCT2.storageWall.'sideCond2[1]'.port_a.T = RealVariables2[88];
  openCT2.storageWall.'sideCond2[1]'.port_a.Q_flow = RealVariables2[89];
  openCT2.storageWall.'sideCond2[1]'.port_b.T = RealVariables2[90];
  openCT2.storageWall.'sideCond2[1]'.port_b.Q_flow = RealVariables2[91];
  openCT2.storageWall.'sideCond2[1]'.T = RealVariables2[92];
  openCT2.storageWall.'sideCond2[1]'.G = RealVariables2[93];
  openCT2.storageWall.'sideCond2[1]'.k = RealVariables2[94];
  openCT2.storageWall.'sideCond2[2]'.Q_flow = RealVariables2[95];
  openCT2.storageWall.'sideCond2[2]'.dT = RealVariables2[96];
  openCT2.storageWall.'sideCond2[2]'.port_a.T = RealVariables2[97];
  openCT2.storageWall.'sideCond2[2]'.port_a.Q_flow = RealVariables2[98];
  openCT2.storageWall.'sideCond2[2]'.port_b.T = RealVariables2[99];
  openCT2.storageWall.'sideCond2[2]'.port_b.Q_flow = RealVariables2[100];
  openCT2.storageWall.'sideCond2[2]'.T = RealVariables3[1];
  openCT2.storageWall.'sideCond2[2]'.G = RealVariables3[2];
  openCT2.storageWall.'sideCond2[2]'.k = RealVariables3[3];
  openCT2.storageWall.'sideCond1[1]'.Q_flow = RealVariables3[4];
  openCT2.storageWall.'sideCond1[1]'.dT = RealVariables3[5];
  openCT2.storageWall.'sideCond1[1]'.port_a.T = RealVariables3[6];
  openCT2.storageWall.'sideCond1[1]'.port_a.Q_flow = RealVariables3[7];
  openCT2.storageWall.'sideCond1[1]'.port_b.T = RealVariables3[8];
  openCT2.storageWall.'sideCond1[1]'.port_b.Q_flow = RealVariables3[9];
  openCT2.storageWall.'sideCond1[1]'.T = RealVariables3[10];
  openCT2.storageWall.'sideCond1[1]'.G = RealVariables3[11];
  openCT2.storageWall.'sideCond1[1]'.k = RealVariables3[12];
  openCT2.storageWall.'sideCond1[2]'.Q_flow = RealVariables3[13];
  openCT2.storageWall.'sideCond1[2]'.dT = RealVariables3[14];
  openCT2.storageWall.'sideCond1[2]'.port_a.T = RealVariables3[15];
  openCT2.storageWall.'sideCond1[2]'.port_a.Q_flow = RealVariables3[16];
  openCT2.storageWall.'sideCond1[2]'.port_b.T = RealVariables3[17];
  openCT2.storageWall.'sideCond1[2]'.port_b.Q_flow = RealVariables3[18];
  openCT2.storageWall.'sideCond1[2]'.T = RealVariables3[19];
  openCT2.storageWall.'sideCond1[2]'.G = RealVariables3[20];
  openCT2.storageWall.'sideCond1[2]'.k = RealVariables3[21];
  openCT2.storageWall.topCond1.Q_flow = RealVariables3[22];
  openCT2.storageWall.topCond1.dT = RealVariables3[23];
  openCT2.storageWall.topCond1.port_a.T = RealVariables3[24];
  openCT2.storageWall.topCond1.port_a.Q_flow = RealVariables3[25];
  openCT2.storageWall.topCond1.port_b.T = RealVariables3[26];
  openCT2.storageWall.topCond1.port_b.Q_flow = RealVariables3[27];
  openCT2.storageWall.topCond1.T = RealVariables3[28];
  openCT2.storageWall.topCond1.G = RealVariables3[29];
  openCT2.storageWall.topCond1.k = RealVariables3[30];
  openCT2.storageWall.topCond2.Q_flow = RealVariables3[31];
  openCT2.storageWall.topCond2.dT = RealVariables3[32];
  openCT2.storageWall.topCond2.port_a.T = RealVariables3[33];
  openCT2.storageWall.topCond2.port_a.Q_flow = RealVariables3[34];
  openCT2.storageWall.topCond2.port_b.T = RealVariables3[35];
  openCT2.storageWall.topCond2.port_b.Q_flow = RealVariables3[36];
  openCT2.storageWall.topCond2.T = RealVariables3[37];
  openCT2.storageWall.topCond2.G = RealVariables3[38];
  openCT2.storageWall.topCond2.k = RealVariables3[39];
  openCT2.storageWall.T_water.T = RealVariables3[40];
  openCT2.storageWall.T_water.Q_flow = RealVariables3[41];
  openCT2.storageWall.ambient.T = RealVariables3[42];
  openCT2.storageWall.ambient.Q_flow = RealVariables3[43];
  openCT2.storageWall.'frontInertia[1]'.T = RealVariables3[44];
  openCT2.storageWall.'frontInertia[1]'.T_der = RealVariables3[45];
  openCT2.storageWall.'frontInertia[1]'.Q_flow = RealVariables3[46];
  openCT2.storageWall.'frontInertia[1]'.port.T = RealVariables3[47];
  openCT2.storageWall.'frontInertia[1]'.port.Q_flow = RealVariables3[48];
  openCT2.storageWall.'frontInertia[1]'.der_T = RealVariables3[49];
  openCT2.storageWall.'frontInertia[1]'.C = RealVariables3[50];
  openCT2.storageWall.'frontInertia[2]'.T = RealVariables3[51];
  openCT2.storageWall.'frontInertia[2]'.T_der = RealVariables3[52];
  openCT2.storageWall.'frontInertia[2]'.Q_flow = RealVariables3[53];
  openCT2.storageWall.'frontInertia[2]'.port.T = RealVariables3[54];
  openCT2.storageWall.'frontInertia[2]'.port.Q_flow = RealVariables3[55];
  openCT2.storageWall.'frontInertia[2]'.der_T = RealVariables3[56];
  openCT2.storageWall.'frontInertia[2]'.C = RealVariables3[57];
  openCT2.storageWall.'frontCond1[1]'.Q_flow = RealVariables3[58];
  openCT2.storageWall.'frontCond1[1]'.dT = RealVariables3[59];
  openCT2.storageWall.'frontCond1[1]'.port_a.T = RealVariables3[60];
  openCT2.storageWall.'frontCond1[1]'.port_a.Q_flow = RealVariables3[61];
  openCT2.storageWall.'frontCond1[1]'.port_b.T = RealVariables3[62];
  openCT2.storageWall.'frontCond1[1]'.port_b.Q_flow = RealVariables3[63];
  openCT2.storageWall.'frontCond1[1]'.T = RealVariables3[64];
  openCT2.storageWall.'frontCond1[1]'.G = RealVariables3[65];
  openCT2.storageWall.'frontCond1[1]'.k = RealVariables3[66];
  openCT2.storageWall.'frontCond1[2]'.dT = RealVariables3[67];
  openCT2.storageWall.'frontCond1[2]'.port_a.T = RealVariables3[68];
  openCT2.storageWall.'frontCond1[2]'.port_b.T = RealVariables3[69];
  openCT2.storageWall.'frontCond1[2]'.T = RealVariables3[70];
  openCT2.storageWall.'frontCond1[2]'.G = RealVariables3[71];
  openCT2.storageWall.'frontCond1[2]'.k = RealVariables3[72];
  openCT2.storageWall.'frontCond2[1]'.Q_flow = RealVariables3[73];
  openCT2.storageWall.'frontCond2[1]'.dT = RealVariables3[74];
  openCT2.storageWall.'frontCond2[1]'.port_a.T = RealVariables3[75];
  openCT2.storageWall.'frontCond2[1]'.port_a.Q_flow = RealVariables3[76];
  openCT2.storageWall.'frontCond2[1]'.port_b.T = RealVariables3[77];
  openCT2.storageWall.'frontCond2[1]'.port_b.Q_flow = RealVariables3[78];
  openCT2.storageWall.'frontCond2[1]'.T = RealVariables3[79];
  openCT2.storageWall.'frontCond2[1]'.G = RealVariables3[80];
  openCT2.storageWall.'frontCond2[1]'.k = RealVariables3[81];
  openCT2.storageWall.'frontCond2[2]'.Q_flow = RealVariables3[82];
  openCT2.storageWall.'frontCond2[2]'.dT = RealVariables3[83];
  openCT2.storageWall.'frontCond2[2]'.port_a.T = RealVariables3[84];
  openCT2.storageWall.'frontCond2[2]'.port_a.Q_flow = RealVariables3[85];
  openCT2.storageWall.'frontCond2[2]'.port_b.T = RealVariables3[86];
  openCT2.storageWall.'frontCond2[2]'.port_b.Q_flow = RealVariables3[87];
  openCT2.storageWall.'frontCond2[2]'.T = RealVariables3[88];
  openCT2.storageWall.'frontCond2[2]'.G = RealVariables3[89];
  openCT2.storageWall.'frontCond2[2]'.k = RealVariables3[90];
  openCT2.storageWall.'floor'.T = RealVariables3[91];
  openCT2.storageWall.'floor'.Q_flow = RealVariables3[92];
  openCT2.port_a_ambient.T = RealVariables3[93];
  openCT2.port_a_ambient.Q_flow = RealVariables3[94];
  inletWater.medium.p = RealVariables3[95];
  inletWater.medium.h = RealVariables3[96];
  inletWater.medium.T = RealVariables3[97];
  inletWater.medium.u = RealVariables3[98];
  inletWater.medium.state.p = RealVariables3[99];
  inletWater.medium.state.T = RealVariables3[100];
  inletWater.medium.T_degC = RealVariables4[1];
  inletWater.medium.p_bar = RealVariables4[2];
  inletWater.'ports[1]'.m_flow = RealVariables4[3];
  inletWater.'ports[1]'.p = RealVariables4[4];
  inletWater.'ports[1]'.h_outflow = RealVariables4[5];
  inletWater.m_flow_in = RealVariables4[6];
  inletWater.T_in = RealVariables4[7];
  outletWater.medium.p = RealVariables4[8];
  outletWater.medium.state.p = RealVariables4[9];
  outletWater.medium.p_bar = RealVariables4[10];
  outletWater.'ports[1]'.m_flow = RealVariables4[11];
  outletWater.'ports[1]'.p = RealVariables4[12];
  outletWater.m_flow_in = RealVariables4[13];
  overflowWater.medium.p = RealVariables4[14];
  overflowWater.medium.state.p = RealVariables4[15];
  overflowWater.medium.p_bar = RealVariables4[16];
  overflowWater.'ports[1]'.m_flow = RealVariables4[17];
  overflowWater.'ports[1]'.p = RealVariables4[18];
  overflowWater.m_flow_in = RealVariables4[19];
  gain.u = RealVariables4[20];
  gain.y = RealVariables4[21];
  ambientTemperature.port.T = RealVariables4[22];
  ambientTemperature.port.Q_flow = RealVariables4[23];
  ambientTemperature.T = RealVariables4[24];
  floorTemperature.port.T = RealVariables4[25];
  floorTemperature.port.Q_flow = RealVariables4[26];
  levelControl.level = RealVariables4[27];
  levelControl.m_outflow = RealVariables4[28];
  outletAir.medium.p = RealVariables4[29];
  outletAir.medium.h = RealVariables4[30];
  outletAir.medium.d = RealVariables4[31];
  outletAir.medium.u = RealVariables4[32];
  outletAir.medium.R = RealVariables4[33];
  outletAir.medium.state.p = RealVariables4[34];
  outletAir.medium.p_bar = RealVariables4[35];
  outletAir.medium.phi = RealVariables4[36];
  outletAir.'ports[1]'.m_flow = RealVariables4[37];
  outletAir.'ports[1]'.p = RealVariables4[38];
  outletAir.'ports[1]'.h_outflow = RealVariables4[39];
  outletAir.m_flow_in = RealVariables4[40];
  inletAir.medium.'Xi[1]' = RealVariables4[41];
  inletAir.medium.h = RealVariables4[42];
  inletAir.medium.d = RealVariables4[43];
  inletAir.medium.T = RealVariables4[44];
  inletAir.medium.'X[1]' = RealVariables4[45];
  inletAir.medium.'X[2]' = RealVariables4[46];
  inletAir.medium.u = RealVariables4[47];
  inletAir.medium.R = RealVariables4[48];
  inletAir.medium.MM = RealVariables4[49];
  inletAir.medium.state.T = RealVariables4[50];
  inletAir.medium.state.'X[1]' = RealVariables4[51];
  inletAir.medium.state.'X[2]' = RealVariables4[52];
  inletAir.medium.T_degC = RealVariables4[53];
  inletAir.medium.x_water = RealVariables4[54];
  inletAir.medium.phi = RealVariables4[55];
  inletAir.'ports[1]'.m_flow = RealVariables4[56];
  inletAir.'ports[1]'.h_outflow = RealVariables4[57];
  inletAir.'ports[1]'.'Xi_outflow[1]' = RealVariables4[58];
  inletAir.T_in = RealVariables4[59];
  inletAir.'X_in[1]' = RealVariables4[60];
  inletAir.'X_in[2]' = RealVariables4[61];
  gain1.u = RealVariables4[62];
  gain1.y = RealVariables4[63];
  T_waterOut.port.p = RealVariables4[64];
  T_waterOut.T = RealVariables4[65];
  T_airOut.port.p = RealVariables4[66];
  T_airOut.T = RealVariables4[67];
  massFlow_Air1.port_a.m_flow = RealVariables4[68];
  massFlow_Air1.port_a.h_outflow = RealVariables4[69];
  massFlow_Air1.port_a.'Xi_outflow[1]' = RealVariables4[70];
  massFlow_Air1.port_b.m_flow = RealVariables4[71];
  massFlow_Air1.port_b.h_outflow = RealVariables4[72];
  massFlow_Air1.port_b.'Xi_outflow[1]' = RealVariables4[73];
  massFlow_Air1.m_flow = RealVariables4[74];
  massFlow_Water1.port_a.m_flow = RealVariables4[75];
  massFlow_Water1.port_a.p = RealVariables4[76];
  massFlow_Water1.port_a.h_outflow = RealVariables4[77];
  massFlow_Water1.port_b.p = RealVariables4[78];
  massFlow_Water1.port_b.h_outflow = RealVariables4[79];
  massFlow_Water1.m_flow = RealVariables4[80];
  'system'.T_start = RealDependentParameters[1];
  'system'.m_flow_nominal = RealDependentParameters[2];
  openCT2.hmax = RealDependentParameters[3];
  openCT2.hmin = RealDependentParameters[4];
  openCT2.L_char = RealDependentParameters[5];
  openCT2.L_basin = RealDependentParameters[6];
  openCT2.w = RealDependentParameters[7];
  openCT2.e = RealDependentParameters[8];
  openCT2.c = RealDependentParameters[9];
  openCT2.n = RealDependentParameters[10];
  openCT2.Kfi = RealDependentParameters[11];
  openCT2.hfi = RealDependentParameters[12];
  openCT2.wfi = RealDependentParameters[13];
  openCT2.lfi = RealDependentParameters[14];
  openCT2.Afr = RealDependentParameters[15];
  openCT2.C_iner = RealDependentParameters[16];
  openCT2.TWater2_start = RealDependentParameters[17];
  openCT2.TAir2_start = RealDependentParameters[18];
  openCT2.H2_start = RealDependentParameters[19];
  openCT2.mAir1_start = RealDependentParameters[20];
  openCT2.openHTX.Kfi = RealDependentParameters[21];
  openCT2.openHTX.hfi = RealDependentParameters[22];
  openCT2.openHTX.wfi = RealDependentParameters[23];
  openCT2.openHTX.lfi = RealDependentParameters[24];
  openCT2.openHTX.c = RealDependentParameters[25];
  openCT2.openHTX.n = RealDependentParameters[26];
  openCT2.openHTX.Afr = RealDependentParameters[27];
  openCT2.openHTX.Vfi = RealDependentParameters[28];
  openCT2.openHTX.mAir1_start = RealDependentParameters[29];
  openCT2.openHTX.TWater2_start = RealDependentParameters[30];
  openCT2.openHTX.TAir2_start = RealDependentParameters[31];
  openCT2.openHTX.H2_start = RealDependentParameters[32];
  openCT2.openHTX.C_iner = RealDependentParameters[33];
  openCT2.waterBasin.height = RealDependentParameters[34];
  openCT2.waterBasin.crossArea = RealDependentParameters[35];
  openCT2.waterBasin.T_ambient = RealDependentParameters[36];
  openCT2.waterBasin.level_start = RealDependentParameters[37];
  openCT2.waterBasin.T_start = RealDependentParameters[38];
  openCT2.waterBasin.h_start = RealDependentParameters[39];
  openCT2.waterBasin.'portsData[3]'.diameter = RealDependentParameters[40];
  openCT2.waterBasin.'portsData[3]'.height = RealDependentParameters[41];
  openCT2.waterBasin.m_flow_nominal = RealDependentParameters[42];
  openCT2.waterBasin.m_flow_small = RealDependentParameters[43];
  openCT2.waterBasin.heatTransfer.T_ambient = RealDependentParameters[44];
  openCT2.waterBasin.'portAreas[1]' = RealDependentParameters[45];
  openCT2.waterBasin.'portAreas[2]' = RealDependentParameters[46];
  openCT2.waterBasin.'portAreas[3]' = RealDependentParameters[47];
  openCT2.naturalConvectionVerticalPlate.L = RealDependentParameters[48];
  openCT2.storageWall.T_Wall_start = RealDependentParameters[49];
  openCT2.storageWall.h = RealDependentParameters[50];
  openCT2.storageWall.w = RealDependentParameters[51];
  openCT2.storageWall.l = RealDependentParameters[52];
  openCT2.storageWall.e = RealDependentParameters[53];
  openCT2.storageWall.'sideInertia[1]'.V = RealDependentParameters[54];
  openCT2.storageWall.'sideInertia[1]'.m = RealDependentParameters[55];
  openCT2.storageWall.'sideInertia[2]'.V = RealDependentParameters[56];
  openCT2.storageWall.'sideInertia[2]'.m = RealDependentParameters[57];
  openCT2.storageWall.topInertia.V = RealDependentParameters[58];
  openCT2.storageWall.topInertia.m = RealDependentParameters[59];
  openCT2.storageWall.'sideCond2[1]'.L = RealDependentParameters[60];
  openCT2.storageWall.'sideCond2[1]'.A = RealDependentParameters[61];
  openCT2.storageWall.'sideCond2[2]'.L = RealDependentParameters[62];
  openCT2.storageWall.'sideCond2[2]'.A = RealDependentParameters[63];
  openCT2.storageWall.'sideCond1[1]'.L = RealDependentParameters[64];
  openCT2.storageWall.'sideCond1[1]'.A = RealDependentParameters[65];
  openCT2.storageWall.'sideCond1[2]'.L = RealDependentParameters[66];
  openCT2.storageWall.'sideCond1[2]'.A = RealDependentParameters[67];
  openCT2.storageWall.topCond1.L = RealDependentParameters[68];
  openCT2.storageWall.topCond1.A = RealDependentParameters[69];
  openCT2.storageWall.topCond2.L = RealDependentParameters[70];
  openCT2.storageWall.topCond2.A = RealDependentParameters[71];
  openCT2.storageWall.'frontInertia[1]'.V = RealDependentParameters[72];
  openCT2.storageWall.'frontInertia[1]'.m = RealDependentParameters[73];
  openCT2.storageWall.'frontInertia[2]'.V = RealDependentParameters[74];
  openCT2.storageWall.'frontInertia[2]'.m = RealDependentParameters[75];
  openCT2.storageWall.'frontCond1[1]'.L = RealDependentParameters[76];
  openCT2.storageWall.'frontCond1[1]'.A = RealDependentParameters[77];
  openCT2.storageWall.'frontCond1[2]'.L = RealDependentParameters[78];
  openCT2.storageWall.'frontCond1[2]'.A = RealDependentParameters[79];
  openCT2.storageWall.'frontCond2[1]'.L = RealDependentParameters[80];
  openCT2.storageWall.'frontCond2[1]'.A = RealDependentParameters[81];
  openCT2.storageWall.'frontCond2[2]'.L = RealDependentParameters[82];
  openCT2.storageWall.'frontCond2[2]'.A = RealDependentParameters[83];
  massFlow_Air1.m_flow_nominal = RealDependentParameters[84];
  massFlow_Air1.m_flow_small = RealDependentParameters[85];
  massFlow_Water1.m_flow_nominal = RealDependentParameters[86];
  massFlow_Water1.m_flow_small = RealDependentParameters[87];
  annotation (__Dymola_FMUImportVersion="Dymola 2017 FD01", experiment(StartTime=0.0, StopTime=3000.0, Tolerance=0.0001),
    Icon(graphics={
      Rectangle(
        extent={{-100,100},{100,-100}},
        lineColor={95,95,95},
        fillColor={255,255,255},
        fillPattern=FillPattern.Solid,
        lineThickness=0.5),
      Text(
        extent={{-70,20},{70,-20}},
        lineColor={0,0,255},
        textString="%name"),
      Text(
        extent={{-70,-72},{70,-94}},
        lineColor={95,95,95},
        textString="FMI 1.0 CS Import")}),
Documentation(info="<html>
<h4>ModelDescription Attributes</h4>
<ul>
<li>fmiVersion = 1.0</li>
<li>modelName = Modelica_IK4_TEKNIKER.DCOL.Generation.CoolingTowers.FMI.CompleteOCT_inertia_Dym</li>
<li>generationTool = Dymola Version 2017 FD01 (64-bit), 2016-10-11 (requires license to execute)</li>
<li>generationDateAndTime = 2017-06-02T10:19:33Z</li>
</ul>
<p><br><b>Co-Simulation Attributes</b></p>
<ul>
<li>canHandleVariableCommunicationStepSize = true</li>
<li>canHandleEvents = true</li>
<li>canRejectSteps = false</li>
<li>canInterpolateInputs = true</li>
<li>maxOutputDerivativeOrder = 1</li>
<li>canRunAsynchronuously = false</li>
<li>canSignalEvents = false</li>
<li>canBeInstantiatedOnlyOncePerProcess = false</li>
<li>canNotUseMemoryManagementFunctions = false</li>
</ul>
</html>",
      revisions="<html>
<p>2016-05-16 <a href=\"mailto: eduardo.ubieta@tekniker.es\">Eduardo Ubieta</a></a> (IK4-TEKNIKER): First implementation</p>
<p><b>Copyright &copy; <a href=\"http://www.tekniker.es/en\">IK4-TEKNIKER</a></b></p>
</html>"));
end CompleteOCT_inertia_FMI;
