within DCOL.ThermalStorage.LatentStorages.FMI;
model IceStorageExtMelt_FMU_fmu
// Model automatically generated by Dymola from FMI model description
public
  type Modelica_Blocks_Interfaces_RealInput = Real;
  type Modelica_Blocks_Interfaces_RealOutput = Real;
  type Modelica_Media_Interfaces_PartialMedium_MassFlowRate = Real (unit = "kg/s", quantity = "MassFlowRate.unusablePartialMedium", min = -100000.0, max = 100000.0);
  type Modelica_IK4_TEKNIKER_DCOL_ThermalStorage_LatentStorages_FMI_RealConectors_RealMassFlowInput = Real (unit = "kg/s", quantity = "MassFlowRate");
  type Modelica_IK4_TEKNIKER_DCOL_ThermalStorage_LatentStorages_FMI_RealConectors_RealMassFlowOutput = Real (unit = "kg/s", quantity = "MassFlowRate");
  type Modelica_IK4_TEKNIKER_DCOL_ThermalStorage_LatentStorages_FMI_RealConectors_RealTemperatureInput = Real (unit = "K", displayUnit = "degC", nominal = 300.0, quantity = "ThermodynamicTemperature", min = 0.0);
  type Modelica_IK4_TEKNIKER_DCOL_ThermalStorage_LatentStorages_FMI_RealConectors_RealTemperatureOutput = Real (unit = "K", displayUnit = "degC", nominal = 300.0, quantity = "ThermodynamicTemperature", min = 0.0);
protected
  record 'system_rec'
    parameter Modelica.SIunits.AbsolutePressure p_ambient = 101325
                                                                  "Default ambient pressure";
    parameter Modelica.SIunits.Temperature T_ambient = 293.15
                                                             "Default ambient temperature";
    parameter Modelica.SIunits.Acceleration g = 9.80665
                                                       "Constant gravity acceleration";
    constant Boolean allowFlowReversal = true
                                             "= false to restrict to design flow direction (port_a -> port_b)";
    constant Modelica.Fluid.Types.Dynamics energyDynamics = Modelica.Fluid.Types.Dynamics.DynamicFreeInitial
                                                                                                            "Default formulation of energy balances";
    constant Modelica.Fluid.Types.Dynamics massDynamics = Modelica.Fluid.Types.Dynamics.DynamicFreeInitial
                                                                                                          "Default formulation of mass balances";
    constant Modelica.Fluid.Types.Dynamics substanceDynamics = Modelica.Fluid.Types.Dynamics.DynamicFreeInitial
                                                                                                               "Default formulation of substance balances";
    constant Modelica.Fluid.Types.Dynamics traceDynamics = Modelica.Fluid.Types.Dynamics.DynamicFreeInitial
                                                                                                           "Default formulation of trace substance balances";
    constant Modelica.Fluid.Types.Dynamics momentumDynamics = Modelica.Fluid.Types.Dynamics.SteadyState
                                                                                                       "Default formulation of momentum balances, if options available";
    constant Modelica.SIunits.MassFlowRate m_flow_start = 0
                                                           "Default start value for mass flow rates";
    parameter Modelica.SIunits.AbsolutePressure p_start(fixed=false)
                                                                    "Default start value for pressures";
    parameter Modelica.SIunits.Temperature T_start(fixed=false)
                                                               "Default start value for temperatures";
    constant Boolean use_eps_Re = false
                                       "= true to determine turbulent region automatically using Reynolds number";
    parameter Modelica.SIunits.MassFlowRate m_flow_nominal(fixed=false)
                                                                       "Default nominal mass flow rate";
    parameter Real eps_m_flow(unit = "1", min = 0.0) = 0.0001
                                                             "Regularization of zero flow for |m_flow| < eps_m_flow*m_flow_nominal";
    parameter Modelica.SIunits.AbsolutePressure dp_small = 1
                                                            "Default small pressure drop for regularization of laminar and zero flow";
    parameter Modelica.SIunits.MassFlowRate m_flow_small(min = 0.0) = 0.01
                                                                          "Default small mass flow rate for regularization of laminar and zero flow";
  end 'system_rec';
public
  'system_rec' 'system' annotation(Dialog);
  constant Integer nSeg = 10
                            "Number of segments of each coil";
  parameter Integer nCoilp = 10
                               "number of horizontally parallel coils";
  parameter Modelica.SIunits.SpecificEnthalpy hfus = 333550.0
                                                             "Enthalpy of fusion of the PCM at ambient presure";
  parameter Modelica.SIunits.SpecificHeatCapacity Cp_PCMs = 2110
                                                                "Specific heat capacity of the solid PCM";
  parameter Modelica.SIunits.SpecificHeatCapacity Cp_PCMl = 4184
                                                                "Specific heat capacity of the liquid PCM";
  parameter Modelica.SIunits.Density rho_solid = 917.0
                                                      "Density of the solid PCM";
  parameter Modelica.SIunits.Density rho_liquid = 999.82
                                                        "Density of the liquid PCM";
  constant Modelica.SIunits.Temperature T_fus = 273.15
                                                      "fusion temperature of the PCM";
  parameter Modelica.SIunits.Diameter D_tube_in = 0.025
                                                       "Interior diameter of the coil";
  constant Modelica.SIunits.Length L_coil = 0.66673757545215
                                                            "Length of each coil";
  constant Modelica.SIunits.Diameter D_crit = 0.1
                                                 "Critical diameter (vertical/horizontal distance between 2 coils)";
  parameter Modelica.SIunits.Pressure p_PCM = 101325
                                                    "Pressure of the PCM";
  parameter Modelica.SIunits.Diameter D_tube_out = 0.03
                                                       "Exterior diameter of the coil";
  constant Real Charge_Percentage = 90
                                      "Percentage of ice at the end of the charge [%]";
  parameter Real a = 1000
                         "Coefficient for quadratic term  of the pressure drop";
  parameter Real b = 1000
                         "Coefficient for linear term of the pressure drop";
  parameter Modelica.SIunits.Length h = 1
                                         "Height of the storage";
  parameter Modelica.SIunits.Length w = 1
                                         "Width of the storage";
  parameter Modelica.SIunits.Length e = 0.2
                                           "Thicknes of the storages wall";
  parameter Modelica.SIunits.ThermalConductivity k_PCMs = 2.2
                                                             "Thermal conductivity of the solid PCM";
  parameter Modelica.SIunits.CoefficientOfHeatTransfer h_PCMl = 568.4
                                                                     "Convection heat transfer coefficient of the liquid PCM";
  parameter Modelica.SIunits.ThermalConductivity k_PCMl = 0.58
                                                              "Thermal conductivity of the liquid PCM";
  parameter Modelica.SIunits.CoefficientOfHeatTransfer h_HTF = 6000
                                                                   "Convection heat transfer coefficient of the HTF";
  parameter Modelica.SIunits.MassFraction x_liquid_start = 1
                                                            "Liquid mass fraction at the start";
  constant Modelica.SIunits.Temperature T_PCM_start = 283.15
                                                            "Start temperature of the PCM";
  constant Modelica.SIunits.Temperature T_Tube_start = 263.15
                                                             "Start temperature of the tube";
  parameter Boolean Charging_start = true
                                         "Initial state of the storage";
  parameter Boolean Charged_start = false
                                         "Initial state of the storage";
protected
  record outlet_water_rec
    constant Integer nPorts = 1
                               "Number of ports";
  protected
    record medium_rec
      Real p(unit = "Pa", displayUnit = "bar", nominal = 100000.0, quantity = "Pressure", min = 0.0)
                                                                                                    "Absolute pressure of medium";
      Real h(unit = "J/kg", quantity = "SpecificEnergy")
                                                        "Specific enthalpy of medium";
      constant Modelica.Media.Interfaces.Types.Density d = 995.586
                                                                  "Density of medium";
      Modelica.Media.Interfaces.Types.Temperature T
                                                   "Temperature of medium";
      constant Modelica.Media.Interfaces.Types.MassFraction 'X[1]' = 1.0
                                                                        "Mass fractions (= (component mass)/total mass  m_i/m)";
      parameter Modelica.Media.Interfaces.Types.SpecificInternalEnergy u(fixed=false)
                                                                                     "Specific internal energy of medium";
      constant Modelica.Media.Interfaces.Types.SpecificHeatCapacity R = 0
                                                                         "Gas constant (of mixture if applicable)";
      constant Modelica.Media.Interfaces.Types.MolarMass MM = 0.018015268
                                                                         "Molar mass (of mixture or single fluid)";
    protected
      record state_rec
        Modelica.Media.Interfaces.Types.AbsolutePressure p
                                                          "Absolute pressure of medium";
        Modelica.Media.Interfaces.Types.Temperature T
                                                     "Temperature of medium";
      end state_rec;
    public
      state_rec state;
      constant Boolean preferredMediumStates = false
                                                    "= true if StateSelect.prefer shall be used for the independent property variables of the medium";
      constant Boolean standardOrderComponents = true
                                                     "If true, and reducedX = true, the last element of X will be computed from the other ones";
      parameter Modelica.SIunits.Conversions.NonSIunits.Temperature_degC T_degC(fixed=false)
                                                                                            "Temperature of medium in [degC]";
      parameter Modelica.SIunits.Conversions.NonSIunits.Pressure_bar p_bar(fixed=false)
                                                                                       "Absolute pressure of medium in [bar]";
    end medium_rec;
  public
    medium_rec medium;
  protected
    record 'ports[1]_rec'
      Modelica_Media_Interfaces_PartialMedium_MassFlowRate m_flow(quantity = "MassFlowRate.SimpleLiquidWater")
                                                                                                              "Mass flow rate from the connection point into the component";
      Modelica.Media.Interfaces.Types.AbsolutePressure p
                                                        "Thermodynamic pressure in the connection point";
      parameter Modelica.Media.Interfaces.Types.SpecificEnthalpy h_outflow(fixed=false)
                                                                                       "Specific thermodynamic enthalpy close to the connection point if m_flow < 0";
    end 'ports[1]_rec';
  public
    'ports[1]_rec' 'ports[1]';
    constant Boolean use_p = true
                                 "select p or d";
    parameter Modelica.Media.Interfaces.Types.AbsolutePressure p = 101325
                                                                         "Boundary pressure";
    constant Modelica.Media.Interfaces.Types.Density d = 995.586
                                                                "Boundary density";
    constant Boolean use_T = true
                                 "select T or h";
    parameter Modelica.Media.Interfaces.Types.Temperature T = 293.15
                                                                    "Boundary temperature";
    parameter Modelica.Media.Interfaces.Types.SpecificEnthalpy h = 83680.0
                                                                          "Boundary specific enthalpy";
    parameter Modelica.Media.Interfaces.Types.MassFraction 'X[1]'(quantity = "SimpleLiquidWater") = 1.0
                                                                                                       "Boundary mass fractions m_i/m";
  end outlet_water_rec;
public
  outlet_water_rec outlet_water annotation(Dialog);
protected
  record iceStorageExternalMelt_nSegnCoilp_rec
    constant Boolean allowFlowReversal = true
                                             "= true to allow flow reversal, false restricts to design direction (port_a -> port_b)";
    constant Integer nSeg = 10
                              "Number of segments of each coil";
    parameter Integer nCoilp(fixed=false)
                                         "number of horizontally parallel coils";
    parameter Modelica.SIunits.SpecificEnthalpy hfus(fixed=false)
                                                                 "Enthalpy of fusion of the PCM at ambient presure";
    parameter Modelica.SIunits.SpecificHeatCapacity Cp_PCMs(fixed=false)
                                                                        "Specific heat capacity of the solid PCM";
    parameter Modelica.SIunits.SpecificHeatCapacity Cp_PCMl(fixed=false)
                                                                        "Specific heat capacity of the liquid PCM";
    parameter Modelica.SIunits.Density rho_solid(fixed=false)
                                                             "Density of the solid PCM";
    parameter Modelica.SIunits.Density rho_liquid(fixed=false)
                                                              "Density of the liquid PCM";
    constant Modelica.SIunits.Temperature T_fus = 273.15
                                                        "fusion temperature of the PCM";
    parameter Modelica.SIunits.Diameter D_tube_in(fixed=false)
                                                              "Interior diameter of the coil";
    constant Modelica.SIunits.Length L_coil = 0.66673757545215
                                                              "Length of each coil";
    constant Modelica.SIunits.Diameter D_crit = 0.1
                                                   "Critical diameter (vertical/horizontal distance between 2 coils)";
    parameter Modelica.SIunits.Pressure p_PCM(fixed=false)
                                                          "Pressure of the PCM";
    parameter Modelica.SIunits.Diameter D_tube_out(fixed=false)
                                                               "Exterior diameter of the coil";
    constant Real Charge_Percentage = 90
                                        "Percentage of ice at the end of the charge [%]";
    parameter Real a(fixed=false)
                                 "Coefficient for quadratic term  of the pressure drop";
    parameter Real b(fixed=false)
                                 "Coefficient for linear term of the pressure drop";
    parameter Modelica.SIunits.Length h(fixed=false)
                                                    "Height of the storage";
    parameter Modelica.SIunits.Length w(fixed=false)
                                                    "Width of the storage";
    parameter Modelica.SIunits.Length e(fixed=false)
                                                    "Thicknes of the storages wall";
    Boolean Charging
                    "=true during the charging of the storage";
    Boolean Charged
                   "=true when Charge_Percentage is reached";
    Modelica.SIunits.ThermalConductance 'G_HTFtoTube[1]'
                                                        "Thermal conductance of the tube";
    Modelica.SIunits.ThermalConductance 'G_HTFtoTube[2]'
                                                        "Thermal conductance of the tube";
    Modelica.SIunits.ThermalConductance 'G_HTFtoTube[3]'
                                                        "Thermal conductance of the tube";
    Modelica.SIunits.ThermalConductance 'G_HTFtoTube[4]'
                                                        "Thermal conductance of the tube";
    Modelica.SIunits.ThermalConductance 'G_HTFtoTube[5]'
                                                        "Thermal conductance of the tube";
    Modelica.SIunits.ThermalConductance 'G_HTFtoTube[6]'
                                                        "Thermal conductance of the tube";
    Modelica.SIunits.ThermalConductance 'G_HTFtoTube[7]'
                                                        "Thermal conductance of the tube";
    Modelica.SIunits.ThermalConductance 'G_HTFtoTube[8]'
                                                        "Thermal conductance of the tube";
    Modelica.SIunits.ThermalConductance 'G_HTFtoTube[9]'
                                                        "Thermal conductance of the tube";
    Modelica.SIunits.ThermalConductance 'G_HTFtoTube[10]'
                                                         "Thermal conductance of the tube";
    Modelica.SIunits.ThermalConductance 'G_TubetoPCM[1]'
                                                        "Thermal conductance of the tube";
    Modelica.SIunits.ThermalConductance 'G_TubetoPCM[2]'
                                                        "Thermal conductance of the tube";
    Modelica.SIunits.ThermalConductance 'G_TubetoPCM[3]'
                                                        "Thermal conductance of the tube";
    Modelica.SIunits.ThermalConductance 'G_TubetoPCM[4]'
                                                        "Thermal conductance of the tube";
    Modelica.SIunits.ThermalConductance 'G_TubetoPCM[5]'
                                                        "Thermal conductance of the tube";
    Modelica.SIunits.ThermalConductance 'G_TubetoPCM[6]'
                                                        "Thermal conductance of the tube";
    Modelica.SIunits.ThermalConductance 'G_TubetoPCM[7]'
                                                        "Thermal conductance of the tube";
    Modelica.SIunits.ThermalConductance 'G_TubetoPCM[8]'
                                                        "Thermal conductance of the tube";
    Modelica.SIunits.ThermalConductance 'G_TubetoPCM[9]'
                                                        "Thermal conductance of the tube";
    Modelica.SIunits.ThermalConductance 'G_TubetoPCM[10]'
                                                         "Thermal conductance of the tube";
    parameter Modelica.SIunits.MassFraction x_liquid_start(fixed=false)
                                                                       "Liquid mass fraction at the start";
    constant Modelica.SIunits.Temperature T_PCM_start = 283.15
                                                              "Start temperature of the PCM";
    constant Modelica.SIunits.Temperature T_Tube_start = 263.15
                                                               "Start temperature of the tube";
    parameter Boolean Charging_start(fixed=false)
                                                 "Initial state of the storage";
    parameter Boolean Charged_start(fixed=false)
                                                "Initial state of the storage";
  protected
    record externalMelt_rec
      constant Integer nSeg = 10
                                "Number of segments dividing the coil";
      parameter Integer nCoilp(fixed=false)
                                           "number of horizontally parallel coils";
    protected
      record 'port_a_heatToAmbient[1]_rec'
        Modelica.SIunits.Temperature T
                                      "Port temperature";
        Modelica.SIunits.HeatFlowRate Q_flow
                                            "Heat flow rate (positive if flowing from outside into the component)";
      end 'port_a_heatToAmbient[1]_rec';
    public
      'port_a_heatToAmbient[1]_rec' 'port_a_heatToAmbient[1]';
    protected
      record 'port_a_heatToAmbient[2]_rec'
        Modelica.SIunits.Temperature T
                                      "Port temperature";
        Modelica.SIunits.HeatFlowRate Q_flow
                                            "Heat flow rate (positive if flowing from outside into the component)";
      end 'port_a_heatToAmbient[2]_rec';
    public
      'port_a_heatToAmbient[2]_rec' 'port_a_heatToAmbient[2]';
    protected
      record 'port_a_heatToAmbient[3]_rec'
        Modelica.SIunits.Temperature T
                                      "Port temperature";
        Modelica.SIunits.HeatFlowRate Q_flow
                                            "Heat flow rate (positive if flowing from outside into the component)";
      end 'port_a_heatToAmbient[3]_rec';
    public
      'port_a_heatToAmbient[3]_rec' 'port_a_heatToAmbient[3]';
    protected
      record 'port_a_heatToAmbient[4]_rec'
        Modelica.SIunits.Temperature T
                                      "Port temperature";
        Modelica.SIunits.HeatFlowRate Q_flow
                                            "Heat flow rate (positive if flowing from outside into the component)";
      end 'port_a_heatToAmbient[4]_rec';
    public
      'port_a_heatToAmbient[4]_rec' 'port_a_heatToAmbient[4]';
    protected
      record 'port_a_heatToAmbient[5]_rec'
        Modelica.SIunits.Temperature T
                                      "Port temperature";
        Modelica.SIunits.HeatFlowRate Q_flow
                                            "Heat flow rate (positive if flowing from outside into the component)";
      end 'port_a_heatToAmbient[5]_rec';
    public
      'port_a_heatToAmbient[5]_rec' 'port_a_heatToAmbient[5]';
    protected
      record 'port_a_heatToAmbient[6]_rec'
        Modelica.SIunits.Temperature T
                                      "Port temperature";
        Modelica.SIunits.HeatFlowRate Q_flow
                                            "Heat flow rate (positive if flowing from outside into the component)";
      end 'port_a_heatToAmbient[6]_rec';
    public
      'port_a_heatToAmbient[6]_rec' 'port_a_heatToAmbient[6]';
    protected
      record 'port_a_heatToAmbient[7]_rec'
        Modelica.SIunits.Temperature T
                                      "Port temperature";
        Modelica.SIunits.HeatFlowRate Q_flow
                                            "Heat flow rate (positive if flowing from outside into the component)";
      end 'port_a_heatToAmbient[7]_rec';
    public
      'port_a_heatToAmbient[7]_rec' 'port_a_heatToAmbient[7]';
    protected
      record 'port_a_heatToAmbient[8]_rec'
        Modelica.SIunits.Temperature T
                                      "Port temperature";
        Modelica.SIunits.HeatFlowRate Q_flow
                                            "Heat flow rate (positive if flowing from outside into the component)";
      end 'port_a_heatToAmbient[8]_rec';
    public
      'port_a_heatToAmbient[8]_rec' 'port_a_heatToAmbient[8]';
    protected
      record 'port_a_heatToAmbient[9]_rec'
        Modelica.SIunits.Temperature T
                                      "Port temperature";
        Modelica.SIunits.HeatFlowRate Q_flow
                                            "Heat flow rate (positive if flowing from outside into the component)";
      end 'port_a_heatToAmbient[9]_rec';
    public
      'port_a_heatToAmbient[9]_rec' 'port_a_heatToAmbient[9]';
    protected
      record 'port_a_heatToAmbient[10]_rec'
        Modelica.SIunits.Temperature T
                                      "Port temperature";
        Modelica.SIunits.HeatFlowRate Q_flow
                                            "Heat flow rate (positive if flowing from outside into the component)";
      end 'port_a_heatToAmbient[10]_rec';
    public
      'port_a_heatToAmbient[10]_rec' 'port_a_heatToAmbient[10]';
    protected
      record 'port_a_heatToHTF[1]_rec'
        Modelica.SIunits.Temperature T
                                      "Port temperature";
        Modelica.SIunits.HeatFlowRate Q_flow
                                            "Heat flow rate (positive if flowing from outside into the component)";
      end 'port_a_heatToHTF[1]_rec';
    public
      'port_a_heatToHTF[1]_rec' 'port_a_heatToHTF[1]';
    protected
      record 'port_a_heatToHTF[2]_rec'
        Modelica.SIunits.Temperature T
                                      "Port temperature";
        Modelica.SIunits.HeatFlowRate Q_flow
                                            "Heat flow rate (positive if flowing from outside into the component)";
      end 'port_a_heatToHTF[2]_rec';
    public
      'port_a_heatToHTF[2]_rec' 'port_a_heatToHTF[2]';
    protected
      record 'port_a_heatToHTF[3]_rec'
        Modelica.SIunits.Temperature T
                                      "Port temperature";
        Modelica.SIunits.HeatFlowRate Q_flow
                                            "Heat flow rate (positive if flowing from outside into the component)";
      end 'port_a_heatToHTF[3]_rec';
    public
      'port_a_heatToHTF[3]_rec' 'port_a_heatToHTF[3]';
    protected
      record 'port_a_heatToHTF[4]_rec'
        Modelica.SIunits.Temperature T
                                      "Port temperature";
        Modelica.SIunits.HeatFlowRate Q_flow
                                            "Heat flow rate (positive if flowing from outside into the component)";
      end 'port_a_heatToHTF[4]_rec';
    public
      'port_a_heatToHTF[4]_rec' 'port_a_heatToHTF[4]';
    protected
      record 'port_a_heatToHTF[5]_rec'
        Modelica.SIunits.Temperature T
                                      "Port temperature";
        Modelica.SIunits.HeatFlowRate Q_flow
                                            "Heat flow rate (positive if flowing from outside into the component)";
      end 'port_a_heatToHTF[5]_rec';
    public
      'port_a_heatToHTF[5]_rec' 'port_a_heatToHTF[5]';
    protected
      record 'port_a_heatToHTF[6]_rec'
        Modelica.SIunits.Temperature T
                                      "Port temperature";
        Modelica.SIunits.HeatFlowRate Q_flow
                                            "Heat flow rate (positive if flowing from outside into the component)";
      end 'port_a_heatToHTF[6]_rec';
    public
      'port_a_heatToHTF[6]_rec' 'port_a_heatToHTF[6]';
    protected
      record 'port_a_heatToHTF[7]_rec'
        Modelica.SIunits.Temperature T
                                      "Port temperature";
        Modelica.SIunits.HeatFlowRate Q_flow
                                            "Heat flow rate (positive if flowing from outside into the component)";
      end 'port_a_heatToHTF[7]_rec';
    public
      'port_a_heatToHTF[7]_rec' 'port_a_heatToHTF[7]';
    protected
      record 'port_a_heatToHTF[8]_rec'
        Modelica.SIunits.Temperature T
                                      "Port temperature";
        Modelica.SIunits.HeatFlowRate Q_flow
                                            "Heat flow rate (positive if flowing from outside into the component)";
      end 'port_a_heatToHTF[8]_rec';
    public
      'port_a_heatToHTF[8]_rec' 'port_a_heatToHTF[8]';
    protected
      record 'port_a_heatToHTF[9]_rec'
        Modelica.SIunits.Temperature T
                                      "Port temperature";
        Modelica.SIunits.HeatFlowRate Q_flow
                                            "Heat flow rate (positive if flowing from outside into the component)";
      end 'port_a_heatToHTF[9]_rec';
    public
      'port_a_heatToHTF[9]_rec' 'port_a_heatToHTF[9]';
    protected
      record 'port_a_heatToHTF[10]_rec'
        Modelica.SIunits.Temperature T
                                      "Port temperature";
        Modelica.SIunits.HeatFlowRate Q_flow
                                            "Heat flow rate (positive if flowing from outside into the component)";
      end 'port_a_heatToHTF[10]_rec';
    public
      'port_a_heatToHTF[10]_rec' 'port_a_heatToHTF[10]';
    protected
      record port_a_water_rec
        Modelica_Media_Interfaces_PartialMedium_MassFlowRate m_flow(quantity = "MassFlowRate.SimpleLiquidWater")
                                                                                                                "Mass flow rate from the connection point into the component";
        Modelica.Media.Interfaces.Types.AbsolutePressure p
                                                          "Thermodynamic pressure in the connection point";
        Modelica.Media.Interfaces.Types.SpecificEnthalpy h_outflow
                                                                  "Specific thermodynamic enthalpy close to the connection point if m_flow < 0";
      end port_a_water_rec;
    public
      port_a_water_rec port_a_water;
    protected
      record port_b_water_rec
        Modelica_Media_Interfaces_PartialMedium_MassFlowRate m_flow(quantity = "MassFlowRate.SimpleLiquidWater")
                                                                                                                "Mass flow rate from the connection point into the component";
        Modelica.Media.Interfaces.Types.AbsolutePressure p
                                                          "Thermodynamic pressure in the connection point";
        Modelica.Media.Interfaces.Types.SpecificEnthalpy h_outflow
                                                                  "Specific thermodynamic enthalpy close to the connection point if m_flow < 0";
      end port_b_water_rec;
    public
      port_b_water_rec port_b_water;
      parameter Modelica.SIunits.SpecificEnthalpy hfus(fixed=false)
                                                                   "Enthalpy of fusion of the PCM at ambient presure";
      parameter Modelica.SIunits.SpecificHeatCapacity Cp_PCMs(fixed=false)
                                                                          "Specific heat capacity of the solid PCM";
      parameter Modelica.SIunits.SpecificHeatCapacity Cp_PCMl(fixed=false)
                                                                          "Specific heat capacity of the liquid PCM";
      parameter Modelica.SIunits.Density rho_solid(fixed=false)
                                                               "Density of the solid PCM";
      parameter Modelica.SIunits.Density rho_liquid(fixed=false)
                                                                "Density of the liquid PCM";
      constant Modelica.SIunits.Temperature T_fus = 273.15
                                                          "fusion temperature of the PCM";
      parameter Modelica.SIunits.Pressure p_PCM(fixed=false)
                                                            "Pressure of the PCM";
      parameter Modelica.SIunits.Mass m_PCM(fixed=false)
                                                        "Total mass of the PCM";
      Modelica.SIunits.Temperature T
                                    "Temperature of the PCM";
      Modelica.SIunits.MassFraction x_liquid
                                            "Liquid mass fraction";
      Real x_liquid_der(unit = "s-1")
                                     "der(Liquid mass fraction)";
      Modelica.SIunits.InternalEnergy U
                                       "Internal energy of the PCM";
      Real U_der(unit = "W")
                            "der(Internal energy of the PCM)";
      Modelica.SIunits.Volume V_PCM
                                   "Volume ocupied by the PCM";
      Real V_PCM_der(unit = "m3/s")
                                   "der(Volume ocupied by the PCM)";
      Modelica.SIunits.SpecificEnthalpy h_PCM
                                             "Specific enthalpy of the PCM";
      parameter Real _h_PCM_der_start = 0.0;
      Real h_PCM_der(unit = "m2/s3",start = _h_PCM_der_start, fixed=false)
                                                                          "der(Specific enthalpy of the PCM)";
      Modelica.SIunits.Density rho
                                  "Density of the PCM";
      Real rho_der(unit = "Pa.m-2.s")
                                     "der(Density of the PCM)";
      constant Modelica.SIunits.SpecificEnthalpy h_satS = 0.0
                                                             "solid saturation enthalpy";
      Modelica.SIunits.SpecificEnthalpy h_satL
                                              "liquid saturation enthalpy";
      parameter Modelica.SIunits.Diameter D_tube_out(fixed=false)
                                                                 "Exterior diameter of the coil";
      constant Modelica.SIunits.Diameter D_crit = 0.1
                                                     "Critical diameter (vertical/horizontal distance between 2 coils)";
      constant Modelica.SIunits.Diameter D_max = 0.14142135623730953
                                                                    "maximun diameter (vertical/horizontal maximun distance between 2 coils)";
      constant Modelica.SIunits.Length L_coil = 0.66673757545215
                                                                "Length of each tube segment";
      constant Real Charge_Percentage = 90
                                          "Percentage of ice at the end of the charge [%]";
      parameter Modelica.SIunits.MassFraction x_liquid_start(fixed=false)
                                                                         "Liquid mass fraction at the start";
      constant Modelica.SIunits.Temperature T_PCM_start = 283.15
                                                                "Start temperature of the PCM";
      Modelica.SIunits.Mass m_PCMs
                                  "Total mass of the solid fraction of the PCM";
      Real m_PCMs_der(unit = "kg/s")
                                    "der(Total mass of the solid fraction of the PCM)";
      Modelica.SIunits.Temperature T_s
                                      "Temperature of the solid fraction of the PCM";
      parameter Modelica.SIunits.Diameter _D_s_start = 0.0;
      Modelica.SIunits.Diameter D_s(max = 0.14142135623730953,start = _D_s_start, fixed=false)
                                                                                              "External diameter of the formed solid ring";
      parameter Real _D_s_der_start = 0.0;
      Real D_s_der(unit = "m/s",start = _D_s_der_start, fixed=false)
                                                                    "der(External diameter of the formed solid ring)";
      parameter Modelica.SIunits.Diameter D_smax(fixed=false)
                                                             "Maximum diameter of the formed solid ring";
      Modelica.SIunits.Mass m_PCMl
                                  "Total mass of the liquid fraction of the PCM";
      Real m_PCMl_der(unit = "kg/s")
                                    "der(Total mass of the liquid fraction of the PCM)";
      Modelica.SIunits.Temperature T_l
                                      "Temperature of the liquid fraction of the PCM";
      parameter Modelica.SIunits.Diameter _D_l_start = 0.0;
      Modelica.SIunits.Diameter D_l(start = _D_l_start, fixed=false)
                                                                    "Internal diameter of the formed liquid ring(during Discharge)";
      parameter Real _D_l_der_start = 0.0;
      Real D_l_der(unit = "m/s",start = _D_l_der_start, fixed=false)
                                                                    "der(Internal diameter of the formed liquid ring(during Discharge))";
      Modelica.SIunits.Diameter D_l_out
                                       "External diameter of the formed liquid ring(during Discharge)";
      parameter Modelica.SIunits.Diameter D_lmax(fixed=false)
                                                             "Maximum diameter of the formed liquid ring";
      Modelica.SIunits.Temperature T_w1;
      Modelica.SIunits.MassFlowRate m_w1;
      Modelica.SIunits.SpecificEnthalpy h_w1;
      Modelica.SIunits.Temperature T_w2;
      Modelica.SIunits.MassFlowRate m_w2;
      Modelica.SIunits.SpecificEnthalpy h_w2;
      Boolean Charging
                      "True during the charging of the storage";
    end externalMelt_rec;
  public
    externalMelt_rec externalMelt annotation(Dialog);
  protected
    record port_a_water_rec
      Modelica_Media_Interfaces_PartialMedium_MassFlowRate m_flow(quantity = "MassFlowRate.SimpleLiquidWater")
                                                                                                              "Mass flow rate from the connection point into the component";
      Modelica.Media.Interfaces.Types.AbsolutePressure p
                                                        "Thermodynamic pressure in the connection point";
      Modelica.Media.Interfaces.Types.SpecificEnthalpy h_outflow
                                                                "Specific thermodynamic enthalpy close to the connection point if m_flow < 0";
    end port_a_water_rec;
  public
    port_a_water_rec port_a_water;
  protected
    record port_b_water_rec
      Modelica_Media_Interfaces_PartialMedium_MassFlowRate m_flow(quantity = "MassFlowRate.SimpleLiquidWater")
                                                                                                              "Mass flow rate from the connection point into the component";
      Modelica.Media.Interfaces.Types.AbsolutePressure p
                                                        "Thermodynamic pressure in the connection point";
      Modelica.Media.Interfaces.Types.SpecificEnthalpy h_outflow
                                                                "Specific thermodynamic enthalpy close to the connection point if m_flow < 0";
    end port_b_water_rec;
  public
    port_b_water_rec port_b_water;
  protected
    record port_b_Tambient_rec
      Modelica.SIunits.Temperature T
                                    "Port temperature";
      Modelica.SIunits.HeatFlowRate Q_flow
                                          "Heat flow rate (positive if flowing from outside into the component)";
    end port_b_Tambient_rec;
  public
    port_b_Tambient_rec port_b_Tambient;
  protected
    record port_a_HTF_rec
      Modelica_Media_Interfaces_PartialMedium_MassFlowRate m_flow(quantity = "MassFlowRate.Ethylene glycol", min = -1E+060)
                                                                                                                           "Mass flow rate from the connection point into the component";
      Modelica.Media.Interfaces.Types.AbsolutePressure p
                                                        "Thermodynamic pressure in the connection point";
      Modelica.Media.Interfaces.Types.SpecificEnthalpy h_outflow
                                                                "Specific thermodynamic enthalpy close to the connection point if m_flow < 0";
      Real h_outflow_der(unit = "m2/s3")
                                        "der(Specific thermodynamic enthalpy close to the connection point if m_flow < 0)";
    end port_a_HTF_rec;
  public
    port_a_HTF_rec port_a_HTF;
  protected
    record por_b_HTF_rec
      Modelica_Media_Interfaces_PartialMedium_MassFlowRate m_flow(quantity = "MassFlowRate.Ethylene glycol", max = 1E+060)
                                                                                                                          "Mass flow rate from the connection point into the component";
      Modelica.Media.Interfaces.Types.AbsolutePressure p
                                                        "Thermodynamic pressure in the connection point";
      Modelica.Media.Interfaces.Types.SpecificEnthalpy h_outflow
                                                                "Specific thermodynamic enthalpy close to the connection point if m_flow < 0";
      Real h_outflow_der(unit = "m2/s3")
                                        "der(Specific thermodynamic enthalpy close to the connection point if m_flow < 0)";
    end por_b_HTF_rec;
  public
    por_b_HTF_rec por_b_HTF;
  protected
    record pipe_rec
      constant Boolean allowFlowReversal = true
                                               "= true to allow flow reversal, false restricts to design direction (port_a -> port_b)";
    protected
      record port_a_rec
        Modelica_Media_Interfaces_PartialMedium_MassFlowRate m_flow(quantity = "MassFlowRate.Ethylene glycol", min = -1E+060)
                                                                                                                             "Mass flow rate from the connection point into the component";
        Modelica.Media.Interfaces.Types.AbsolutePressure p
                                                          "Thermodynamic pressure in the connection point";
        Modelica.Media.Interfaces.Types.SpecificEnthalpy h_outflow
                                                                  "Specific thermodynamic enthalpy close to the connection point if m_flow < 0";
      end port_a_rec;
    public
      port_a_rec port_a;
    protected
      record port_b_rec
        Modelica_Media_Interfaces_PartialMedium_MassFlowRate m_flow(quantity = "MassFlowRate.Ethylene glycol", max = 1E+060)
                                                                                                                            "Mass flow rate from the connection point into the component";
        Modelica.Media.Interfaces.Types.AbsolutePressure p
                                                          "Thermodynamic pressure in the connection point";
        Modelica.Media.Interfaces.Types.SpecificEnthalpy h_outflow
                                                                  "Specific thermodynamic enthalpy close to the connection point if m_flow < 0";
      end port_b_rec;
    public
      port_b_rec port_b;
      parameter Real nParallel(unit = "1", min = 1.0, fixed=false)
                                                                  "Number of identical parallel pipes";
      constant Modelica.SIunits.Length length = 0.66673757545215
                                                                "Length";
      constant Boolean isCircular = true
                                        "= true if cross sectional area is circular";
      parameter Modelica.SIunits.Diameter diameter(fixed=false)
                                                               "Diameter of circular pipe";
      parameter Modelica.SIunits.Area crossArea(fixed=false)
                                                            "Inner cross section area";
      parameter Modelica.SIunits.Length perimeter(fixed=false)
                                                              "Inner perimeter";
      parameter Modelica.SIunits.Height roughness = 2.5E-005
                                                            "Average height of surface asperities (default: smooth steel pipe)";
      parameter Modelica.SIunits.Volume V(fixed=false)
                                                      "volume size";
      constant Modelica.SIunits.Length height_ab = 0
                                                    "Height(port_b) - Height(port_a)";
      constant Integer n = 10
                             "Number of discrete volumes";
      parameter Modelica.SIunits.Volume 'fluidVolumes[1]'(fixed=false)
                                                                      "Discretized volume, determine in inheriting class";
      parameter Modelica.SIunits.Volume 'fluidVolumes[2]'(fixed=false)
                                                                      "Discretized volume, determine in inheriting class";
      parameter Modelica.SIunits.Volume 'fluidVolumes[3]'(fixed=false)
                                                                      "Discretized volume, determine in inheriting class";
      parameter Modelica.SIunits.Volume 'fluidVolumes[4]'(fixed=false)
                                                                      "Discretized volume, determine in inheriting class";
      parameter Modelica.SIunits.Volume 'fluidVolumes[5]'(fixed=false)
                                                                      "Discretized volume, determine in inheriting class";
      parameter Modelica.SIunits.Volume 'fluidVolumes[6]'(fixed=false)
                                                                      "Discretized volume, determine in inheriting class";
      parameter Modelica.SIunits.Volume 'fluidVolumes[7]'(fixed=false)
                                                                      "Discretized volume, determine in inheriting class";
      parameter Modelica.SIunits.Volume 'fluidVolumes[8]'(fixed=false)
                                                                      "Discretized volume, determine in inheriting class";
      parameter Modelica.SIunits.Volume 'fluidVolumes[9]'(fixed=false)
                                                                      "Discretized volume, determine in inheriting class";
      parameter Modelica.SIunits.Volume 'fluidVolumes[10]'(fixed=false)
                                                                       "Discretized volume, determine in inheriting class";
      constant Modelica.Fluid.Types.Dynamics energyDynamics = Modelica.Fluid.Types.Dynamics.DynamicFreeInitial
                                                                                                              "Formulation of energy balances";
      constant Modelica.Fluid.Types.Dynamics massDynamics = Modelica.Fluid.Types.Dynamics.DynamicFreeInitial
                                                                                                            "Formulation of mass balances";
      constant Modelica.Fluid.Types.Dynamics substanceDynamics = Modelica.Fluid.Types.Dynamics.DynamicFreeInitial
                                                                                                                 "Formulation of substance balances";
      constant Modelica.Fluid.Types.Dynamics traceDynamics = Modelica.Fluid.Types.Dynamics.DynamicFreeInitial
                                                                                                             "Formulation of trace substance balances";
      parameter Modelica.Media.Interfaces.Types.AbsolutePressure p_a_start(fixed=false)
                                                                                       "Start value of pressure at port a";
      parameter Modelica.Media.Interfaces.Types.AbsolutePressure p_b_start(fixed=false)
                                                                                       "Start value of pressure at port b";
      parameter Modelica.Media.Interfaces.Types.AbsolutePressure 'ps_start[1]'(fixed=false)
                                                                                           "Start value of pressure";
      parameter Modelica.Media.Interfaces.Types.AbsolutePressure 'ps_start[2]'(fixed=false)
                                                                                           "Start value of pressure";
      parameter Modelica.Media.Interfaces.Types.AbsolutePressure 'ps_start[3]'(fixed=false)
                                                                                           "Start value of pressure";
      parameter Modelica.Media.Interfaces.Types.AbsolutePressure 'ps_start[4]'(fixed=false)
                                                                                           "Start value of pressure";
      parameter Modelica.Media.Interfaces.Types.AbsolutePressure 'ps_start[5]'(fixed=false)
                                                                                           "Start value of pressure";
      parameter Modelica.Media.Interfaces.Types.AbsolutePressure 'ps_start[6]'(fixed=false)
                                                                                           "Start value of pressure";
      parameter Modelica.Media.Interfaces.Types.AbsolutePressure 'ps_start[7]'(fixed=false)
                                                                                           "Start value of pressure";
      parameter Modelica.Media.Interfaces.Types.AbsolutePressure 'ps_start[8]'(fixed=false)
                                                                                           "Start value of pressure";
      parameter Modelica.Media.Interfaces.Types.AbsolutePressure 'ps_start[9]'(fixed=false)
                                                                                           "Start value of pressure";
      parameter Modelica.Media.Interfaces.Types.AbsolutePressure 'ps_start[10]'(fixed=false)
                                                                                            "Start value of pressure";
      constant Boolean use_T_start = true
                                         "Use T_start if true, otherwise h_start";
      constant Modelica.Media.Interfaces.Types.Temperature T_start(min = 263.15, max = 443.15) = 263.15
                                                                                                       "Start value of temperature";
      parameter Modelica.Media.Interfaces.Types.SpecificEnthalpy h_start(fixed=false)
                                                                                     "Start value of specific enthalpy";
      parameter Modelica.Media.Interfaces.Types.MassFraction 'X_start[1]' = 1.0
                                                                               "Start value of mass fractions m_i/m";
      Modelica.SIunits.Energy 'Us[1]'
                                     "Internal energy of fluid";
      Real 'Us[1]_der'(unit = "W")
                                  "der(Internal energy of fluid)";
      Modelica.SIunits.Energy 'Us[2]'
                                     "Internal energy of fluid";
      Real 'Us[2]_der'(unit = "W")
                                  "der(Internal energy of fluid)";
      Modelica.SIunits.Energy 'Us[3]'
                                     "Internal energy of fluid";
      Real 'Us[3]_der'(unit = "W")
                                  "der(Internal energy of fluid)";
      Modelica.SIunits.Energy 'Us[4]'
                                     "Internal energy of fluid";
      Real 'Us[4]_der'(unit = "W")
                                  "der(Internal energy of fluid)";
      Modelica.SIunits.Energy 'Us[5]'
                                     "Internal energy of fluid";
      Real 'Us[5]_der'(unit = "W")
                                  "der(Internal energy of fluid)";
      Modelica.SIunits.Energy 'Us[6]'
                                     "Internal energy of fluid";
      Real 'Us[6]_der'(unit = "W")
                                  "der(Internal energy of fluid)";
      Modelica.SIunits.Energy 'Us[7]'
                                     "Internal energy of fluid";
      Real 'Us[7]_der'(unit = "W")
                                  "der(Internal energy of fluid)";
      Modelica.SIunits.Energy 'Us[8]'
                                     "Internal energy of fluid";
      Real 'Us[8]_der'(unit = "W")
                                  "der(Internal energy of fluid)";
      Modelica.SIunits.Energy 'Us[9]'
                                     "Internal energy of fluid";
      Real 'Us[9]_der'(unit = "W")
                                  "der(Internal energy of fluid)";
      Modelica.SIunits.Energy 'Us[10]'
                                      "Internal energy of fluid";
      Real 'Us[10]_der'(unit = "W")
                                   "der(Internal energy of fluid)";
      Modelica.SIunits.Mass 'ms[1]'
                                   "Fluid mass";
      Real 'ms[1]_der'(unit = "kg/s")
                                     "der(Fluid mass)";
      Modelica.SIunits.Mass 'ms[2]'
                                   "Fluid mass";
      Real 'ms[2]_der'(unit = "kg/s")
                                     "der(Fluid mass)";
      Modelica.SIunits.Mass 'ms[3]'
                                   "Fluid mass";
      Real 'ms[3]_der'(unit = "kg/s")
                                     "der(Fluid mass)";
      Modelica.SIunits.Mass 'ms[4]'
                                   "Fluid mass";
      Real 'ms[4]_der'(unit = "kg/s")
                                     "der(Fluid mass)";
      Modelica.SIunits.Mass 'ms[5]'
                                   "Fluid mass";
      Real 'ms[5]_der'(unit = "kg/s")
                                     "der(Fluid mass)";
      Modelica.SIunits.Mass 'ms[6]'
                                   "Fluid mass";
      Real 'ms[6]_der'(unit = "kg/s")
                                     "der(Fluid mass)";
      Modelica.SIunits.Mass 'ms[7]'
                                   "Fluid mass";
      Real 'ms[7]_der'(unit = "kg/s")
                                     "der(Fluid mass)";
      Modelica.SIunits.Mass 'ms[8]'
                                   "Fluid mass";
      Real 'ms[8]_der'(unit = "kg/s")
                                     "der(Fluid mass)";
      Modelica.SIunits.Mass 'ms[9]'
                                   "Fluid mass";
      Real 'ms[9]_der'(unit = "kg/s")
                                     "der(Fluid mass)";
      Modelica.SIunits.Mass 'ms[10]'
                                    "Fluid mass";
      Real 'ms[10]_der'(unit = "kg/s")
                                      "der(Fluid mass)";
      Modelica_Media_Interfaces_PartialMedium_MassFlowRate 'mb_flows[1]'(quantity = "MassFlowRate.Ethylene glycol")
                                                                                                                   "Mass flow rate, source or sink";
      Modelica_Media_Interfaces_PartialMedium_MassFlowRate 'mb_flows[2]'(quantity = "MassFlowRate.Ethylene glycol")
                                                                                                                   "Mass flow rate, source or sink";
      Modelica_Media_Interfaces_PartialMedium_MassFlowRate 'mb_flows[3]'(quantity = "MassFlowRate.Ethylene glycol")
                                                                                                                   "Mass flow rate, source or sink";
      Modelica_Media_Interfaces_PartialMedium_MassFlowRate 'mb_flows[4]'(quantity = "MassFlowRate.Ethylene glycol")
                                                                                                                   "Mass flow rate, source or sink";
      Modelica_Media_Interfaces_PartialMedium_MassFlowRate 'mb_flows[5]'(quantity = "MassFlowRate.Ethylene glycol")
                                                                                                                   "Mass flow rate, source or sink";
      Modelica_Media_Interfaces_PartialMedium_MassFlowRate 'mb_flows[6]'(quantity = "MassFlowRate.Ethylene glycol")
                                                                                                                   "Mass flow rate, source or sink";
      Modelica_Media_Interfaces_PartialMedium_MassFlowRate 'mb_flows[7]'(quantity = "MassFlowRate.Ethylene glycol")
                                                                                                                   "Mass flow rate, source or sink";
      Modelica_Media_Interfaces_PartialMedium_MassFlowRate 'mb_flows[8]'(quantity = "MassFlowRate.Ethylene glycol")
                                                                                                                   "Mass flow rate, source or sink";
      Modelica_Media_Interfaces_PartialMedium_MassFlowRate 'mb_flows[9]'(quantity = "MassFlowRate.Ethylene glycol")
                                                                                                                   "Mass flow rate, source or sink";
      Modelica_Media_Interfaces_PartialMedium_MassFlowRate 'mb_flows[10]'(quantity = "MassFlowRate.Ethylene glycol")
                                                                                                                    "Mass flow rate, source or sink";
      Modelica.SIunits.EnthalpyFlowRate 'Hb_flows[1]'
                                                     "Enthalpy flow rate, source or sink";
      Modelica.SIunits.EnthalpyFlowRate 'Hb_flows[2]'
                                                     "Enthalpy flow rate, source or sink";
      Modelica.SIunits.EnthalpyFlowRate 'Hb_flows[3]'
                                                     "Enthalpy flow rate, source or sink";
      Modelica.SIunits.EnthalpyFlowRate 'Hb_flows[4]'
                                                     "Enthalpy flow rate, source or sink";
      Modelica.SIunits.EnthalpyFlowRate 'Hb_flows[5]'
                                                     "Enthalpy flow rate, source or sink";
      Modelica.SIunits.EnthalpyFlowRate 'Hb_flows[6]'
                                                     "Enthalpy flow rate, source or sink";
      Modelica.SIunits.EnthalpyFlowRate 'Hb_flows[7]'
                                                     "Enthalpy flow rate, source or sink";
      Modelica.SIunits.EnthalpyFlowRate 'Hb_flows[8]'
                                                     "Enthalpy flow rate, source or sink";
      Modelica.SIunits.EnthalpyFlowRate 'Hb_flows[9]'
                                                     "Enthalpy flow rate, source or sink";
      Modelica.SIunits.EnthalpyFlowRate 'Hb_flows[10]'
                                                      "Enthalpy flow rate, source or sink";
      Modelica.SIunits.HeatFlowRate 'Qb_flows[1]'
                                                 "Heat flow rate, source or sink";
      Modelica.SIunits.HeatFlowRate 'Qb_flows[2]'
                                                 "Heat flow rate, source or sink";
      Modelica.SIunits.HeatFlowRate 'Qb_flows[3]'
                                                 "Heat flow rate, source or sink";
      Modelica.SIunits.HeatFlowRate 'Qb_flows[4]'
                                                 "Heat flow rate, source or sink";
      Modelica.SIunits.HeatFlowRate 'Qb_flows[5]'
                                                 "Heat flow rate, source or sink";
      Modelica.SIunits.HeatFlowRate 'Qb_flows[6]'
                                                 "Heat flow rate, source or sink";
      Modelica.SIunits.HeatFlowRate 'Qb_flows[7]'
                                                 "Heat flow rate, source or sink";
      Modelica.SIunits.HeatFlowRate 'Qb_flows[8]'
                                                 "Heat flow rate, source or sink";
      Modelica.SIunits.HeatFlowRate 'Qb_flows[9]'
                                                 "Heat flow rate, source or sink";
      Modelica.SIunits.HeatFlowRate 'Qb_flows[10]'
                                                  "Heat flow rate, source or sink";
      Modelica.SIunits.Power 'Wb_flows[1]'
                                          "Mechanical power, p*der(V) etc.";
      Modelica.SIunits.Power 'Wb_flows[2]'
                                          "Mechanical power, p*der(V) etc.";
      Modelica.SIunits.Power 'Wb_flows[3]'
                                          "Mechanical power, p*der(V) etc.";
      Modelica.SIunits.Power 'Wb_flows[4]'
                                          "Mechanical power, p*der(V) etc.";
      Modelica.SIunits.Power 'Wb_flows[5]'
                                          "Mechanical power, p*der(V) etc.";
      Modelica.SIunits.Power 'Wb_flows[6]'
                                          "Mechanical power, p*der(V) etc.";
      Modelica.SIunits.Power 'Wb_flows[7]'
                                          "Mechanical power, p*der(V) etc.";
      Modelica.SIunits.Power 'Wb_flows[8]'
                                          "Mechanical power, p*der(V) etc.";
      Modelica.SIunits.Power 'Wb_flows[9]'
                                          "Mechanical power, p*der(V) etc.";
      Modelica.SIunits.Power 'Wb_flows[10]'
                                           "Mechanical power, p*der(V) etc.";
      constant Modelica.SIunits.Length 'lengths[1]' = 0.066673757545215
                                                                       "lengths of flow segments";
      constant Modelica.SIunits.Length 'lengths[2]' = 0.066673757545215
                                                                       "lengths of flow segments";
      constant Modelica.SIunits.Length 'lengths[3]' = 0.066673757545215
                                                                       "lengths of flow segments";
      constant Modelica.SIunits.Length 'lengths[4]' = 0.066673757545215
                                                                       "lengths of flow segments";
      constant Modelica.SIunits.Length 'lengths[5]' = 0.066673757545215
                                                                       "lengths of flow segments";
      constant Modelica.SIunits.Length 'lengths[6]' = 0.066673757545215
                                                                       "lengths of flow segments";
      constant Modelica.SIunits.Length 'lengths[7]' = 0.066673757545215
                                                                       "lengths of flow segments";
      constant Modelica.SIunits.Length 'lengths[8]' = 0.066673757545215
                                                                       "lengths of flow segments";
      constant Modelica.SIunits.Length 'lengths[9]' = 0.066673757545215
                                                                       "lengths of flow segments";
      constant Modelica.SIunits.Length 'lengths[10]' = 0.066673757545215
                                                                        "lengths of flow segments";
      parameter Modelica.SIunits.Area 'crossAreas[1]'(fixed=false)
                                                                  "cross flow areas of flow segments";
      parameter Modelica.SIunits.Area 'crossAreas[2]'(fixed=false)
                                                                  "cross flow areas of flow segments";
      parameter Modelica.SIunits.Area 'crossAreas[3]'(fixed=false)
                                                                  "cross flow areas of flow segments";
      parameter Modelica.SIunits.Area 'crossAreas[4]'(fixed=false)
                                                                  "cross flow areas of flow segments";
      parameter Modelica.SIunits.Area 'crossAreas[5]'(fixed=false)
                                                                  "cross flow areas of flow segments";
      parameter Modelica.SIunits.Area 'crossAreas[6]'(fixed=false)
                                                                  "cross flow areas of flow segments";
      parameter Modelica.SIunits.Area 'crossAreas[7]'(fixed=false)
                                                                  "cross flow areas of flow segments";
      parameter Modelica.SIunits.Area 'crossAreas[8]'(fixed=false)
                                                                  "cross flow areas of flow segments";
      parameter Modelica.SIunits.Area 'crossAreas[9]'(fixed=false)
                                                                  "cross flow areas of flow segments";
      parameter Modelica.SIunits.Area 'crossAreas[10]'(fixed=false)
                                                                   "cross flow areas of flow segments";
      parameter Modelica.SIunits.Length 'dimensions[1]'(fixed=false)
                                                                    "hydraulic diameters of flow segments";
      parameter Modelica.SIunits.Length 'dimensions[2]'(fixed=false)
                                                                    "hydraulic diameters of flow segments";
      parameter Modelica.SIunits.Length 'dimensions[3]'(fixed=false)
                                                                    "hydraulic diameters of flow segments";
      parameter Modelica.SIunits.Length 'dimensions[4]'(fixed=false)
                                                                    "hydraulic diameters of flow segments";
      parameter Modelica.SIunits.Length 'dimensions[5]'(fixed=false)
                                                                    "hydraulic diameters of flow segments";
      parameter Modelica.SIunits.Length 'dimensions[6]'(fixed=false)
                                                                    "hydraulic diameters of flow segments";
      parameter Modelica.SIunits.Length 'dimensions[7]'(fixed=false)
                                                                    "hydraulic diameters of flow segments";
      parameter Modelica.SIunits.Length 'dimensions[8]'(fixed=false)
                                                                    "hydraulic diameters of flow segments";
      parameter Modelica.SIunits.Length 'dimensions[9]'(fixed=false)
                                                                    "hydraulic diameters of flow segments";
      parameter Modelica.SIunits.Length 'dimensions[10]'(fixed=false)
                                                                     "hydraulic diameters of flow segments";
      parameter Modelica.SIunits.Height 'roughnesses[1]'(fixed=false)
                                                                     "Average heights of surface asperities";
      parameter Modelica.SIunits.Height 'roughnesses[2]'(fixed=false)
                                                                     "Average heights of surface asperities";
      parameter Modelica.SIunits.Height 'roughnesses[3]'(fixed=false)
                                                                     "Average heights of surface asperities";
      parameter Modelica.SIunits.Height 'roughnesses[4]'(fixed=false)
                                                                     "Average heights of surface asperities";
      parameter Modelica.SIunits.Height 'roughnesses[5]'(fixed=false)
                                                                     "Average heights of surface asperities";
      parameter Modelica.SIunits.Height 'roughnesses[6]'(fixed=false)
                                                                     "Average heights of surface asperities";
      parameter Modelica.SIunits.Height 'roughnesses[7]'(fixed=false)
                                                                     "Average heights of surface asperities";
      parameter Modelica.SIunits.Height 'roughnesses[8]'(fixed=false)
                                                                     "Average heights of surface asperities";
      parameter Modelica.SIunits.Height 'roughnesses[9]'(fixed=false)
                                                                     "Average heights of surface asperities";
      parameter Modelica.SIunits.Height 'roughnesses[10]'(fixed=false)
                                                                      "Average heights of surface asperities";
      constant Modelica.SIunits.Length 'dheights[1]' = 0.0
                                                          "Differences in heights of flow segments";
      constant Modelica.SIunits.Length 'dheights[2]' = 0.0
                                                          "Differences in heights of flow segments";
      constant Modelica.SIunits.Length 'dheights[3]' = 0.0
                                                          "Differences in heights of flow segments";
      constant Modelica.SIunits.Length 'dheights[4]' = 0.0
                                                          "Differences in heights of flow segments";
      constant Modelica.SIunits.Length 'dheights[5]' = 0.0
                                                          "Differences in heights of flow segments";
      constant Modelica.SIunits.Length 'dheights[6]' = 0.0
                                                          "Differences in heights of flow segments";
      constant Modelica.SIunits.Length 'dheights[7]' = 0.0
                                                          "Differences in heights of flow segments";
      constant Modelica.SIunits.Length 'dheights[8]' = 0.0
                                                          "Differences in heights of flow segments";
      constant Modelica.SIunits.Length 'dheights[9]' = 0.0
                                                          "Differences in heights of flow segments";
      constant Modelica.SIunits.Length 'dheights[10]' = 0.0
                                                           "Differences in heights of flow segments";
      constant Modelica.Fluid.Types.Dynamics momentumDynamics = Modelica.Fluid.Types.Dynamics.SteadyState
                                                                                                         "Formulation of momentum balances";
      constant Modelica_Media_Interfaces_PartialMedium_MassFlowRate m_flow_start(quantity = "MassFlowRate.Ethylene glycol") = 0.0
                                                                                                                                 "Start value for mass flow rate";
      constant Integer nNodes(min = 1) = 10
                                           "Number of discrete flow volumes";
      constant Modelica.Fluid.Types.ModelStructure modelStructure = Modelica.Fluid.Types.ModelStructure.av_vb
                                                                                                             "Determines whether flow or volume models are present at the ports";
      constant Boolean useLumpedPressure = false
                                                "=true to lump pressure states together";
      constant Integer nFM = 9
                              "number of flow models in flowModel";
      constant Integer nFMDistributed = 9;
      constant Integer nFMLumped = 1;
      constant Integer iLumped = 6
                                  "Index of control volume with representative state if useLumpedPressure";
      constant Boolean useInnerPortProperties = false
                                                     "=true to take port properties for flow models from internal control volumes";
    protected
      record state_a_rec
        Modelica.SIunits.Temperature T
                                      "Temperature";
        Modelica.SIunits.Pressure p
                                   "Pressure";
      end state_a_rec;
    public
      state_a_rec state_a;
    protected
      record state_b_rec
        parameter Modelica.SIunits.Temperature T(fixed=false)
                                                             "Temperature";
        Modelica.SIunits.Pressure p
                                   "Pressure";
      end state_b_rec;
    public
      state_b_rec state_b;
    protected
      record 'statesFM[1]_rec'
        Modelica.SIunits.Temperature T
                                      "Temperature";
        Modelica.SIunits.Pressure p
                                   "Pressure";
      end 'statesFM[1]_rec';
    public
      'statesFM[1]_rec' 'statesFM[1]';
    protected
      record 'statesFM[2]_rec'
        Modelica.SIunits.Temperature T
                                      "Temperature";
        Modelica.SIunits.Pressure p(nominal = 100000.0, min = 0.0)
                                                                  "Pressure";
      end 'statesFM[2]_rec';
    public
      'statesFM[2]_rec' 'statesFM[2]';
    protected
      record 'statesFM[3]_rec'
        Modelica.SIunits.Temperature T
                                      "Temperature";
        Modelica.SIunits.Pressure p(nominal = 100000.0, min = 0.0)
                                                                  "Pressure";
      end 'statesFM[3]_rec';
    public
      'statesFM[3]_rec' 'statesFM[3]';
    protected
      record 'statesFM[4]_rec'
        Modelica.SIunits.Temperature T
                                      "Temperature";
        Modelica.SIunits.Pressure p(nominal = 100000.0, min = 0.0)
                                                                  "Pressure";
      end 'statesFM[4]_rec';
    public
      'statesFM[4]_rec' 'statesFM[4]';
    protected
      record 'statesFM[5]_rec'
        Modelica.SIunits.Temperature T
                                      "Temperature";
        Modelica.SIunits.Pressure p(nominal = 100000.0, min = 0.0)
                                                                  "Pressure";
      end 'statesFM[5]_rec';
    public
      'statesFM[5]_rec' 'statesFM[5]';
    protected
      record 'statesFM[6]_rec'
        Modelica.SIunits.Temperature T
                                      "Temperature";
        Modelica.SIunits.Pressure p(nominal = 100000.0, min = 0.0)
                                                                  "Pressure";
      end 'statesFM[6]_rec';
    public
      'statesFM[6]_rec' 'statesFM[6]';
    protected
      record 'statesFM[7]_rec'
        Modelica.SIunits.Temperature T
                                      "Temperature";
        Modelica.SIunits.Pressure p(nominal = 100000.0, min = 0.0)
                                                                  "Pressure";
      end 'statesFM[7]_rec';
    public
      'statesFM[7]_rec' 'statesFM[7]';
    protected
      record 'statesFM[8]_rec'
        Modelica.SIunits.Temperature T
                                      "Temperature";
        Modelica.SIunits.Pressure p(nominal = 100000.0, min = 0.0)
                                                                  "Pressure";
      end 'statesFM[8]_rec';
    public
      'statesFM[8]_rec' 'statesFM[8]';
    protected
      record 'statesFM[9]_rec'
        Modelica.SIunits.Temperature T
                                      "Temperature";
        Modelica.SIunits.Pressure p(nominal = 100000.0, min = 0.0)
                                                                  "Pressure";
      end 'statesFM[9]_rec';
    public
      'statesFM[9]_rec' 'statesFM[9]';
    protected
      record 'statesFM[10]_rec'
        Modelica.SIunits.Temperature T
                                      "Temperature";
        Modelica.SIunits.Pressure p
                                   "Pressure";
      end 'statesFM[10]_rec';
    public
      'statesFM[10]_rec' 'statesFM[10]';
    protected
      record flowModel_rec
        constant Boolean from_dp = true
                                       "= true, use m_flow = f(dp), otherwise dp = f(m_flow)";
        constant Integer n = 10
                               "Number of discrete flow volumes";
      protected
        record 'states[1]_rec'
          Modelica.SIunits.Temperature T
                                        "Temperature";
          Modelica.SIunits.Pressure p
                                     "Pressure";
        end 'states[1]_rec';
      public
        'states[1]_rec' 'states[1]';
      protected
        record 'states[2]_rec'
          Modelica.SIunits.Temperature T
                                        "Temperature";
          Modelica.SIunits.Pressure p
                                     "Pressure";
        end 'states[2]_rec';
      public
        'states[2]_rec' 'states[2]';
      protected
        record 'states[3]_rec'
          Modelica.SIunits.Temperature T
                                        "Temperature";
          Modelica.SIunits.Pressure p
                                     "Pressure";
        end 'states[3]_rec';
      public
        'states[3]_rec' 'states[3]';
      protected
        record 'states[4]_rec'
          Modelica.SIunits.Temperature T
                                        "Temperature";
          Modelica.SIunits.Pressure p
                                     "Pressure";
        end 'states[4]_rec';
      public
        'states[4]_rec' 'states[4]';
      protected
        record 'states[5]_rec'
          Modelica.SIunits.Temperature T
                                        "Temperature";
          Modelica.SIunits.Pressure p
                                     "Pressure";
        end 'states[5]_rec';
      public
        'states[5]_rec' 'states[5]';
      protected
        record 'states[6]_rec'
          Modelica.SIunits.Temperature T
                                        "Temperature";
          Modelica.SIunits.Pressure p
                                     "Pressure";
        end 'states[6]_rec';
      public
        'states[6]_rec' 'states[6]';
      protected
        record 'states[7]_rec'
          Modelica.SIunits.Temperature T
                                        "Temperature";
          Modelica.SIunits.Pressure p
                                     "Pressure";
        end 'states[7]_rec';
      public
        'states[7]_rec' 'states[7]';
      protected
        record 'states[8]_rec'
          Modelica.SIunits.Temperature T
                                        "Temperature";
          Modelica.SIunits.Pressure p
                                     "Pressure";
        end 'states[8]_rec';
      public
        'states[8]_rec' 'states[8]';
      protected
        record 'states[9]_rec'
          Modelica.SIunits.Temperature T
                                        "Temperature";
          Modelica.SIunits.Pressure p
                                     "Pressure";
        end 'states[9]_rec';
      public
        'states[9]_rec' 'states[9]';
      protected
        record 'states[10]_rec'
          Modelica.SIunits.Temperature T
                                        "Temperature";
          Modelica.SIunits.Pressure p
                                     "Pressure";
        end 'states[10]_rec';
      public
        'states[10]_rec' 'states[10]';
        Modelica.SIunits.Velocity 'vs[1]'
                                         "Mean velocities of fluid flow";
        Modelica.SIunits.Velocity 'vs[2]'
                                         "Mean velocities of fluid flow";
        Modelica.SIunits.Velocity 'vs[3]'
                                         "Mean velocities of fluid flow";
        Modelica.SIunits.Velocity 'vs[4]'
                                         "Mean velocities of fluid flow";
        Modelica.SIunits.Velocity 'vs[5]'
                                         "Mean velocities of fluid flow";
        Modelica.SIunits.Velocity 'vs[6]'
                                         "Mean velocities of fluid flow";
        Modelica.SIunits.Velocity 'vs[7]'
                                         "Mean velocities of fluid flow";
        Modelica.SIunits.Velocity 'vs[8]'
                                         "Mean velocities of fluid flow";
        Modelica.SIunits.Velocity 'vs[9]'
                                         "Mean velocities of fluid flow";
        Modelica.SIunits.Velocity 'vs[10]'
                                          "Mean velocities of fluid flow";
        parameter Real nParallel(unit = "1", fixed=false)
                                                         "number of identical parallel flow devices";
        Modelica.SIunits.Area 'crossAreas[1]'
                                             "Cross flow areas at segment boundaries";
        Modelica.SIunits.Area 'crossAreas[2]'
                                             "Cross flow areas at segment boundaries";
        Modelica.SIunits.Area 'crossAreas[3]'
                                             "Cross flow areas at segment boundaries";
        Modelica.SIunits.Area 'crossAreas[4]'
                                             "Cross flow areas at segment boundaries";
        Modelica.SIunits.Area 'crossAreas[5]'
                                             "Cross flow areas at segment boundaries";
        Modelica.SIunits.Area 'crossAreas[6]'
                                             "Cross flow areas at segment boundaries";
        Modelica.SIunits.Area 'crossAreas[7]'
                                             "Cross flow areas at segment boundaries";
        Modelica.SIunits.Area 'crossAreas[8]'
                                             "Cross flow areas at segment boundaries";
        Modelica.SIunits.Area 'crossAreas[9]'
                                             "Cross flow areas at segment boundaries";
        Modelica.SIunits.Area 'crossAreas[10]'
                                              "Cross flow areas at segment boundaries";
        Modelica.SIunits.Length 'dimensions[1]'
                                               "Characteristic dimensions for fluid flow (diameters for pipe flow)";
        Modelica.SIunits.Length 'dimensions[2]'
                                               "Characteristic dimensions for fluid flow (diameters for pipe flow)";
        Modelica.SIunits.Length 'dimensions[3]'
                                               "Characteristic dimensions for fluid flow (diameters for pipe flow)";
        Modelica.SIunits.Length 'dimensions[4]'
                                               "Characteristic dimensions for fluid flow (diameters for pipe flow)";
        Modelica.SIunits.Length 'dimensions[5]'
                                               "Characteristic dimensions for fluid flow (diameters for pipe flow)";
        Modelica.SIunits.Length 'dimensions[6]'
                                               "Characteristic dimensions for fluid flow (diameters for pipe flow)";
        Modelica.SIunits.Length 'dimensions[7]'
                                               "Characteristic dimensions for fluid flow (diameters for pipe flow)";
        Modelica.SIunits.Length 'dimensions[8]'
                                               "Characteristic dimensions for fluid flow (diameters for pipe flow)";
        Modelica.SIunits.Length 'dimensions[9]'
                                               "Characteristic dimensions for fluid flow (diameters for pipe flow)";
        Modelica.SIunits.Length 'dimensions[10]'
                                                "Characteristic dimensions for fluid flow (diameters for pipe flow)";
        Modelica.SIunits.Height 'roughnesses[1]'
                                                "Average height of surface asperities";
        Modelica.SIunits.Height 'roughnesses[2]'
                                                "Average height of surface asperities";
        Modelica.SIunits.Height 'roughnesses[3]'
                                                "Average height of surface asperities";
        Modelica.SIunits.Height 'roughnesses[4]'
                                                "Average height of surface asperities";
        Modelica.SIunits.Height 'roughnesses[5]'
                                                "Average height of surface asperities";
        Modelica.SIunits.Height 'roughnesses[6]'
                                                "Average height of surface asperities";
        Modelica.SIunits.Height 'roughnesses[7]'
                                                "Average height of surface asperities";
        Modelica.SIunits.Height 'roughnesses[8]'
                                                "Average height of surface asperities";
        Modelica.SIunits.Height 'roughnesses[9]'
                                                "Average height of surface asperities";
        Modelica.SIunits.Height 'roughnesses[10]'
                                                 "Average height of surface asperities";
        constant Modelica.SIunits.Length 'dheights[1]' = 0.0
                                                            "Height(states[2:n]) - Height(states[1:n-1])";
        constant Modelica.SIunits.Length 'dheights[2]' = 0.0
                                                            "Height(states[2:n]) - Height(states[1:n-1])";
        constant Modelica.SIunits.Length 'dheights[3]' = 0.0
                                                            "Height(states[2:n]) - Height(states[1:n-1])";
        constant Modelica.SIunits.Length 'dheights[4]' = 0.0
                                                            "Height(states[2:n]) - Height(states[1:n-1])";
        constant Modelica.SIunits.Length 'dheights[5]' = 0.0
                                                            "Height(states[2:n]) - Height(states[1:n-1])";
        constant Modelica.SIunits.Length 'dheights[6]' = 0.0
                                                            "Height(states[2:n]) - Height(states[1:n-1])";
        constant Modelica.SIunits.Length 'dheights[7]' = 0.0
                                                            "Height(states[2:n]) - Height(states[1:n-1])";
        constant Modelica.SIunits.Length 'dheights[8]' = 0.0
                                                            "Height(states[2:n]) - Height(states[1:n-1])";
        constant Modelica.SIunits.Length 'dheights[9]' = 0.0
                                                            "Height(states[2:n]) - Height(states[1:n-1])";
        parameter Modelica.SIunits.Acceleration g(fixed=false)
                                                              "Constant gravity acceleration";
        constant Boolean allowFlowReversal = true
                                                 "= true to allow flow reversal, false restricts to design direction (states[1] -> states[n+1])";
        constant Modelica.Fluid.Types.Dynamics momentumDynamics = Modelica.Fluid.Types.Dynamics.SteadyState
                                                                                                           "Formulation of momentum balance";
        constant Modelica_Media_Interfaces_PartialMedium_MassFlowRate m_flow_start(quantity = "MassFlowRate.Ethylene glycol") = 0.0
                                                                                                                                   "Start value of mass flow rates";
        parameter Modelica.Media.Interfaces.Types.AbsolutePressure p_a_start(fixed=false)
                                                                                         "Start value for p[1] at design inflow";
        parameter Modelica.Media.Interfaces.Types.AbsolutePressure p_b_start(fixed=false)
                                                                                         "Start value for p[n+1] at design outflow";
        constant Integer m = 9
                              "Number of flow segments";
        constant Modelica.SIunits.Length 'pathLengths[1]' = 0.1000106363178225
                                                                              "Lengths along flow path";
        constant Modelica.SIunits.Length 'pathLengths[2]' = 0.066673757545215
                                                                             "Lengths along flow path";
        constant Modelica.SIunits.Length 'pathLengths[3]' = 0.066673757545215
                                                                             "Lengths along flow path";
        constant Modelica.SIunits.Length 'pathLengths[4]' = 0.066673757545215
                                                                             "Lengths along flow path";
        constant Modelica.SIunits.Length 'pathLengths[5]' = 0.066673757545215
                                                                             "Lengths along flow path";
        constant Modelica.SIunits.Length 'pathLengths[6]' = 0.066673757545215
                                                                             "Lengths along flow path";
        constant Modelica.SIunits.Length 'pathLengths[7]' = 0.066673757545215
                                                                             "Lengths along flow path";
        constant Modelica.SIunits.Length 'pathLengths[8]' = 0.066673757545215
                                                                             "Lengths along flow path";
        constant Modelica.SIunits.Length 'pathLengths[9]' = 0.1000106363178225
                                                                              "Lengths along flow path";
        Modelica_Media_Interfaces_PartialMedium_MassFlowRate 'm_flows[1]'(quantity = "MassFlowRate.Ethylene glycol", min = -1E+060)
                                                                                                                                   "mass flow rates between states";
        Modelica_Media_Interfaces_PartialMedium_MassFlowRate 'm_flows[2]'(quantity = "MassFlowRate.Ethylene glycol", min = -1E+060)
                                                                                                                                   "mass flow rates between states";
        Modelica_Media_Interfaces_PartialMedium_MassFlowRate 'm_flows[3]'(quantity = "MassFlowRate.Ethylene glycol", min = -1E+060)
                                                                                                                                   "mass flow rates between states";
        Modelica_Media_Interfaces_PartialMedium_MassFlowRate 'm_flows[4]'(quantity = "MassFlowRate.Ethylene glycol", min = -1E+060)
                                                                                                                                   "mass flow rates between states";
        Modelica_Media_Interfaces_PartialMedium_MassFlowRate 'm_flows[5]'(quantity = "MassFlowRate.Ethylene glycol", min = -1E+060)
                                                                                                                                   "mass flow rates between states";
        Modelica_Media_Interfaces_PartialMedium_MassFlowRate 'm_flows[6]'(quantity = "MassFlowRate.Ethylene glycol", min = -1E+060)
                                                                                                                                   "mass flow rates between states";
        Modelica_Media_Interfaces_PartialMedium_MassFlowRate 'm_flows[7]'(quantity = "MassFlowRate.Ethylene glycol", min = -1E+060)
                                                                                                                                   "mass flow rates between states";
        Modelica_Media_Interfaces_PartialMedium_MassFlowRate 'm_flows[8]'(quantity = "MassFlowRate.Ethylene glycol", min = -1E+060)
                                                                                                                                   "mass flow rates between states";
        Modelica_Media_Interfaces_PartialMedium_MassFlowRate 'm_flows[9]'(quantity = "MassFlowRate.Ethylene glycol", min = -1E+060)
                                                                                                                                   "mass flow rates between states";
        Modelica.SIunits.Momentum 'Is[1]'
                                         "Momenta of flow segments";
        Modelica.SIunits.Momentum 'Is[2]'
                                         "Momenta of flow segments";
        Modelica.SIunits.Momentum 'Is[3]'
                                         "Momenta of flow segments";
        Modelica.SIunits.Momentum 'Is[4]'
                                         "Momenta of flow segments";
        Modelica.SIunits.Momentum 'Is[5]'
                                         "Momenta of flow segments";
        Modelica.SIunits.Momentum 'Is[6]'
                                         "Momenta of flow segments";
        Modelica.SIunits.Momentum 'Is[7]'
                                         "Momenta of flow segments";
        Modelica.SIunits.Momentum 'Is[8]'
                                         "Momenta of flow segments";
        Modelica.SIunits.Momentum 'Is[9]'
                                         "Momenta of flow segments";
        constant Modelica.SIunits.Force 'Ib_flows[1]' = 0.0
                                                           "Flow of momentum across boundaries";
        constant Modelica.SIunits.Force 'Ib_flows[2]' = 0.0
                                                           "Flow of momentum across boundaries";
        constant Modelica.SIunits.Force 'Ib_flows[3]' = 0.0
                                                           "Flow of momentum across boundaries";
        constant Modelica.SIunits.Force 'Ib_flows[4]' = 0.0
                                                           "Flow of momentum across boundaries";
        constant Modelica.SIunits.Force 'Ib_flows[5]' = 0.0
                                                           "Flow of momentum across boundaries";
        constant Modelica.SIunits.Force 'Ib_flows[6]' = 0.0
                                                           "Flow of momentum across boundaries";
        constant Modelica.SIunits.Force 'Ib_flows[7]' = 0.0
                                                           "Flow of momentum across boundaries";
        constant Modelica.SIunits.Force 'Ib_flows[8]' = 0.0
                                                           "Flow of momentum across boundaries";
        constant Modelica.SIunits.Force 'Ib_flows[9]' = 0.0
                                                           "Flow of momentum across boundaries";
        Modelica.SIunits.Force 'Fs_p[1]'
                                        "Pressure forces";
        Modelica.SIunits.Force 'Fs_p[2]'
                                        "Pressure forces";
        Modelica.SIunits.Force 'Fs_p[3]'
                                        "Pressure forces";
        Modelica.SIunits.Force 'Fs_p[4]'
                                        "Pressure forces";
        Modelica.SIunits.Force 'Fs_p[5]'
                                        "Pressure forces";
        Modelica.SIunits.Force 'Fs_p[6]'
                                        "Pressure forces";
        Modelica.SIunits.Force 'Fs_p[7]'
                                        "Pressure forces";
        Modelica.SIunits.Force 'Fs_p[8]'
                                        "Pressure forces";
        Modelica.SIunits.Force 'Fs_p[9]'
                                        "Pressure forces";
        Modelica.SIunits.Force 'Fs_fg[1]'
                                         "Friction and gravity forces";
        Modelica.SIunits.Force 'Fs_fg[2]'
                                         "Friction and gravity forces";
        Modelica.SIunits.Force 'Fs_fg[3]'
                                         "Friction and gravity forces";
        Modelica.SIunits.Force 'Fs_fg[4]'
                                         "Friction and gravity forces";
        Modelica.SIunits.Force 'Fs_fg[5]'
                                         "Friction and gravity forces";
        Modelica.SIunits.Force 'Fs_fg[6]'
                                         "Friction and gravity forces";
        Modelica.SIunits.Force 'Fs_fg[7]'
                                         "Friction and gravity forces";
        Modelica.SIunits.Force 'Fs_fg[8]'
                                         "Friction and gravity forces";
        Modelica.SIunits.Force 'Fs_fg[9]'
                                         "Friction and gravity forces";
        constant Boolean useUpstreamScheme = true
                                                 "= false to average upstream and downstream properties across flow segments";
        constant Boolean use_Ib_flows = false
                                             "= true to consider differences in flow of momentum through boundaries";
        Modelica.Media.Interfaces.Types.Density 'rhos[1]';
        Modelica.Media.Interfaces.Types.Density 'rhos[2]';
        Modelica.Media.Interfaces.Types.Density 'rhos[3]';
        Modelica.Media.Interfaces.Types.Density 'rhos[4]';
        Modelica.Media.Interfaces.Types.Density 'rhos[5]';
        Modelica.Media.Interfaces.Types.Density 'rhos[6]';
        Modelica.Media.Interfaces.Types.Density 'rhos[7]';
        Modelica.Media.Interfaces.Types.Density 'rhos[8]';
        Modelica.Media.Interfaces.Types.Density 'rhos[9]';
        Modelica.Media.Interfaces.Types.Density 'rhos[10]';
        Modelica.Media.Interfaces.Types.Density 'rhos_act[1]'
                                                             "Actual density per segment";
        Modelica.Media.Interfaces.Types.Density 'rhos_act[2]'
                                                             "Actual density per segment";
        Modelica.Media.Interfaces.Types.Density 'rhos_act[3]'
                                                             "Actual density per segment";
        Modelica.Media.Interfaces.Types.Density 'rhos_act[4]'
                                                             "Actual density per segment";
        Modelica.Media.Interfaces.Types.Density 'rhos_act[5]'
                                                             "Actual density per segment";
        Modelica.Media.Interfaces.Types.Density 'rhos_act[6]'
                                                             "Actual density per segment";
        Modelica.Media.Interfaces.Types.Density 'rhos_act[7]'
                                                             "Actual density per segment";
        Modelica.Media.Interfaces.Types.Density 'rhos_act[8]'
                                                             "Actual density per segment";
        Modelica.Media.Interfaces.Types.Density 'rhos_act[9]'
                                                             "Actual density per segment";
        Modelica.Media.Interfaces.Types.DynamicViscosity 'mus[1]';
        Modelica.Media.Interfaces.Types.DynamicViscosity 'mus[2]';
        Modelica.Media.Interfaces.Types.DynamicViscosity 'mus[3]';
        Modelica.Media.Interfaces.Types.DynamicViscosity 'mus[4]';
        Modelica.Media.Interfaces.Types.DynamicViscosity 'mus[5]';
        Modelica.Media.Interfaces.Types.DynamicViscosity 'mus[6]';
        Modelica.Media.Interfaces.Types.DynamicViscosity 'mus[7]';
        Modelica.Media.Interfaces.Types.DynamicViscosity 'mus[8]';
        Modelica.Media.Interfaces.Types.DynamicViscosity 'mus[9]';
        Modelica.Media.Interfaces.Types.DynamicViscosity 'mus[10]';
        Modelica.Media.Interfaces.Types.DynamicViscosity 'mus_act[1]'
                                                                     "Actual viscosity per segment";
        Modelica.Media.Interfaces.Types.DynamicViscosity 'mus_act[2]'
                                                                     "Actual viscosity per segment";
        Modelica.Media.Interfaces.Types.DynamicViscosity 'mus_act[3]'
                                                                     "Actual viscosity per segment";
        Modelica.Media.Interfaces.Types.DynamicViscosity 'mus_act[4]'
                                                                     "Actual viscosity per segment";
        Modelica.Media.Interfaces.Types.DynamicViscosity 'mus_act[5]'
                                                                     "Actual viscosity per segment";
        Modelica.Media.Interfaces.Types.DynamicViscosity 'mus_act[6]'
                                                                     "Actual viscosity per segment";
        Modelica.Media.Interfaces.Types.DynamicViscosity 'mus_act[7]'
                                                                     "Actual viscosity per segment";
        Modelica.Media.Interfaces.Types.DynamicViscosity 'mus_act[8]'
                                                                     "Actual viscosity per segment";
        Modelica.Media.Interfaces.Types.DynamicViscosity 'mus_act[9]'
                                                                     "Actual viscosity per segment";
        Modelica.SIunits.Pressure 'dps_fg[1]'
                                             "pressure drop between states";
        Modelica.SIunits.Pressure 'dps_fg[2]'
                                             "pressure drop between states";
        Modelica.SIunits.Pressure 'dps_fg[3]'
                                             "pressure drop between states";
        Modelica.SIunits.Pressure 'dps_fg[4]'
                                             "pressure drop between states";
        Modelica.SIunits.Pressure 'dps_fg[5]'
                                             "pressure drop between states";
        Modelica.SIunits.Pressure 'dps_fg[6]'
                                             "pressure drop between states";
        Modelica.SIunits.Pressure 'dps_fg[7]'
                                             "pressure drop between states";
        Modelica.SIunits.Pressure 'dps_fg[8]'
                                             "pressure drop between states";
        Modelica.SIunits.Pressure 'dps_fg[9]'
                                             "pressure drop between states";
        constant Modelica.SIunits.ReynoldsNumber Re_turbulent = 4000
                                                                    "Start of turbulent regime, depending on type of flow device";
        constant Boolean show_Res = false
                                         "= true, if Reynolds numbers are included for plotting";
        constant Modelica.SIunits.Length 'pathLengths_internal[1]' = 0.1000106363178225
                                                                                       "pathLengths used internally; to be defined by extending class";
        constant Modelica.SIunits.Length 'pathLengths_internal[2]' = 0.066673757545215
                                                                                      "pathLengths used internally; to be defined by extending class";
        constant Modelica.SIunits.Length 'pathLengths_internal[3]' = 0.066673757545215
                                                                                      "pathLengths used internally; to be defined by extending class";
        constant Modelica.SIunits.Length 'pathLengths_internal[4]' = 0.066673757545215
                                                                                      "pathLengths used internally; to be defined by extending class";
        constant Modelica.SIunits.Length 'pathLengths_internal[5]' = 0.066673757545215
                                                                                      "pathLengths used internally; to be defined by extending class";
        constant Modelica.SIunits.Length 'pathLengths_internal[6]' = 0.066673757545215
                                                                                      "pathLengths used internally; to be defined by extending class";
        constant Modelica.SIunits.Length 'pathLengths_internal[7]' = 0.066673757545215
                                                                                      "pathLengths used internally; to be defined by extending class";
        constant Modelica.SIunits.Length 'pathLengths_internal[8]' = 0.066673757545215
                                                                                      "pathLengths used internally; to be defined by extending class";
        constant Modelica.SIunits.Length 'pathLengths_internal[9]' = 0.1000106363178225
                                                                                       "pathLengths used internally; to be defined by extending class";
        constant Modelica.SIunits.ReynoldsNumber 'Res_turbulent_internal[1]' = 4000
                                                                                   "Re_turbulent used internally; to be defined by extending class";
        constant Modelica.SIunits.ReynoldsNumber 'Res_turbulent_internal[2]' = 4000
                                                                                   "Re_turbulent used internally; to be defined by extending class";
        constant Modelica.SIunits.ReynoldsNumber 'Res_turbulent_internal[3]' = 4000
                                                                                   "Re_turbulent used internally; to be defined by extending class";
        constant Modelica.SIunits.ReynoldsNumber 'Res_turbulent_internal[4]' = 4000
                                                                                   "Re_turbulent used internally; to be defined by extending class";
        constant Modelica.SIunits.ReynoldsNumber 'Res_turbulent_internal[5]' = 4000
                                                                                   "Re_turbulent used internally; to be defined by extending class";
        constant Modelica.SIunits.ReynoldsNumber 'Res_turbulent_internal[6]' = 4000
                                                                                   "Re_turbulent used internally; to be defined by extending class";
        constant Modelica.SIunits.ReynoldsNumber 'Res_turbulent_internal[7]' = 4000
                                                                                   "Re_turbulent used internally; to be defined by extending class";
        constant Modelica.SIunits.ReynoldsNumber 'Res_turbulent_internal[8]' = 4000
                                                                                   "Re_turbulent used internally; to be defined by extending class";
        constant Modelica.SIunits.ReynoldsNumber 'Res_turbulent_internal[9]' = 4000
                                                                                   "Re_turbulent used internally; to be defined by extending class";
        parameter Modelica.SIunits.AbsolutePressure dp_nominal(fixed=false)
                                                                           "Nominal pressure loss (only for nominal models)";
        parameter Modelica.SIunits.MassFlowRate m_flow_nominal(fixed=false)
                                                                           "Nominal mass flow rate";
        parameter Modelica.SIunits.MassFlowRate m_flow_small(fixed=false)
                                                                         "Within regularization if |m_flows| < m_flow_small (may be wider for large discontinuities in static head)";
      end flowModel_rec;
    public
      flowModel_rec flowModel;
      Modelica_Media_Interfaces_PartialMedium_MassFlowRate 'm_flows[1]'(quantity = "MassFlowRate.Ethylene glycol", min = -1E+060)
                                                                                                                                 "Mass flow rates of fluid across segment boundaries";
      Modelica_Media_Interfaces_PartialMedium_MassFlowRate 'm_flows[2]'(quantity = "MassFlowRate.Ethylene glycol", min = -1E+060)
                                                                                                                                 "Mass flow rates of fluid across segment boundaries";
      Modelica_Media_Interfaces_PartialMedium_MassFlowRate 'm_flows[3]'(quantity = "MassFlowRate.Ethylene glycol", min = -1E+060)
                                                                                                                                 "Mass flow rates of fluid across segment boundaries";
      Modelica_Media_Interfaces_PartialMedium_MassFlowRate 'm_flows[4]'(quantity = "MassFlowRate.Ethylene glycol", min = -1E+060)
                                                                                                                                 "Mass flow rates of fluid across segment boundaries";
      Modelica_Media_Interfaces_PartialMedium_MassFlowRate 'm_flows[5]'(quantity = "MassFlowRate.Ethylene glycol", min = -1E+060)
                                                                                                                                 "Mass flow rates of fluid across segment boundaries";
      Modelica_Media_Interfaces_PartialMedium_MassFlowRate 'm_flows[6]'(quantity = "MassFlowRate.Ethylene glycol", min = -1E+060)
                                                                                                                                 "Mass flow rates of fluid across segment boundaries";
      Modelica_Media_Interfaces_PartialMedium_MassFlowRate 'm_flows[7]'(quantity = "MassFlowRate.Ethylene glycol", min = -1E+060)
                                                                                                                                 "Mass flow rates of fluid across segment boundaries";
      Modelica_Media_Interfaces_PartialMedium_MassFlowRate 'm_flows[8]'(quantity = "MassFlowRate.Ethylene glycol", min = -1E+060)
                                                                                                                                 "Mass flow rates of fluid across segment boundaries";
      Modelica_Media_Interfaces_PartialMedium_MassFlowRate 'm_flows[9]'(quantity = "MassFlowRate.Ethylene glycol", min = -1E+060)
                                                                                                                                 "Mass flow rates of fluid across segment boundaries";
      Modelica_Media_Interfaces_PartialMedium_MassFlowRate 'm_flows[10]'(quantity = "MassFlowRate.Ethylene glycol", min = -1E+060)
                                                                                                                                  "Mass flow rates of fluid across segment boundaries";
      Modelica_Media_Interfaces_PartialMedium_MassFlowRate 'm_flows[11]'(quantity = "MassFlowRate.Ethylene glycol", min = -1E+060)
                                                                                                                                  "Mass flow rates of fluid across segment boundaries";
      Modelica.Media.Interfaces.Types.EnthalpyFlowRate 'H_flows[1]'
                                                                   "Enthalpy flow rates of fluid across segment boundaries";
      Modelica.Media.Interfaces.Types.EnthalpyFlowRate 'H_flows[2]'
                                                                   "Enthalpy flow rates of fluid across segment boundaries";
      Modelica.Media.Interfaces.Types.EnthalpyFlowRate 'H_flows[3]'
                                                                   "Enthalpy flow rates of fluid across segment boundaries";
      Modelica.Media.Interfaces.Types.EnthalpyFlowRate 'H_flows[4]'
                                                                   "Enthalpy flow rates of fluid across segment boundaries";
      Modelica.Media.Interfaces.Types.EnthalpyFlowRate 'H_flows[5]'
                                                                   "Enthalpy flow rates of fluid across segment boundaries";
      Modelica.Media.Interfaces.Types.EnthalpyFlowRate 'H_flows[6]'
                                                                   "Enthalpy flow rates of fluid across segment boundaries";
      Modelica.Media.Interfaces.Types.EnthalpyFlowRate 'H_flows[7]'
                                                                   "Enthalpy flow rates of fluid across segment boundaries";
      Modelica.Media.Interfaces.Types.EnthalpyFlowRate 'H_flows[8]'
                                                                   "Enthalpy flow rates of fluid across segment boundaries";
      Modelica.Media.Interfaces.Types.EnthalpyFlowRate 'H_flows[9]'
                                                                   "Enthalpy flow rates of fluid across segment boundaries";
      Modelica.Media.Interfaces.Types.EnthalpyFlowRate 'H_flows[10]'
                                                                    "Enthalpy flow rates of fluid across segment boundaries";
      Modelica.Media.Interfaces.Types.EnthalpyFlowRate 'H_flows[11]'
                                                                    "Enthalpy flow rates of fluid across segment boundaries";
      Modelica.SIunits.Velocity 'vs[1]'
                                       "mean velocities in flow segments";
      Modelica.SIunits.Velocity 'vs[2]'
                                       "mean velocities in flow segments";
      Modelica.SIunits.Velocity 'vs[3]'
                                       "mean velocities in flow segments";
      Modelica.SIunits.Velocity 'vs[4]'
                                       "mean velocities in flow segments";
      Modelica.SIunits.Velocity 'vs[5]'
                                       "mean velocities in flow segments";
      Modelica.SIunits.Velocity 'vs[6]'
                                       "mean velocities in flow segments";
      Modelica.SIunits.Velocity 'vs[7]'
                                       "mean velocities in flow segments";
      Modelica.SIunits.Velocity 'vs[8]'
                                       "mean velocities in flow segments";
      Modelica.SIunits.Velocity 'vs[9]'
                                       "mean velocities in flow segments";
      Modelica.SIunits.Velocity 'vs[10]'
                                        "mean velocities in flow segments";
      constant Boolean use_HeatTransfer = true
                                              "= true to use the HeatTransfer model";
    protected
      record 'heatPorts[1]_rec'
        Modelica.SIunits.Temperature T
                                      "Port temperature";
        Modelica.SIunits.HeatFlowRate Q_flow
                                            "Heat flow rate (positive if flowing from outside into the component)";
      end 'heatPorts[1]_rec';
    public
      'heatPorts[1]_rec' 'heatPorts[1]';
    protected
      record 'heatPorts[2]_rec'
        Modelica.SIunits.Temperature T
                                      "Port temperature";
        Modelica.SIunits.HeatFlowRate Q_flow
                                            "Heat flow rate (positive if flowing from outside into the component)";
      end 'heatPorts[2]_rec';
    public
      'heatPorts[2]_rec' 'heatPorts[2]';
    protected
      record 'heatPorts[3]_rec'
        Modelica.SIunits.Temperature T
                                      "Port temperature";
        Modelica.SIunits.HeatFlowRate Q_flow
                                            "Heat flow rate (positive if flowing from outside into the component)";
      end 'heatPorts[3]_rec';
    public
      'heatPorts[3]_rec' 'heatPorts[3]';
    protected
      record 'heatPorts[4]_rec'
        Modelica.SIunits.Temperature T
                                      "Port temperature";
        Modelica.SIunits.HeatFlowRate Q_flow
                                            "Heat flow rate (positive if flowing from outside into the component)";
      end 'heatPorts[4]_rec';
    public
      'heatPorts[4]_rec' 'heatPorts[4]';
    protected
      record 'heatPorts[5]_rec'
        Modelica.SIunits.Temperature T
                                      "Port temperature";
        Modelica.SIunits.HeatFlowRate Q_flow
                                            "Heat flow rate (positive if flowing from outside into the component)";
      end 'heatPorts[5]_rec';
    public
      'heatPorts[5]_rec' 'heatPorts[5]';
    protected
      record 'heatPorts[6]_rec'
        Modelica.SIunits.Temperature T
                                      "Port temperature";
        Modelica.SIunits.HeatFlowRate Q_flow
                                            "Heat flow rate (positive if flowing from outside into the component)";
      end 'heatPorts[6]_rec';
    public
      'heatPorts[6]_rec' 'heatPorts[6]';
    protected
      record 'heatPorts[7]_rec'
        Modelica.SIunits.Temperature T
                                      "Port temperature";
        Modelica.SIunits.HeatFlowRate Q_flow
                                            "Heat flow rate (positive if flowing from outside into the component)";
      end 'heatPorts[7]_rec';
    public
      'heatPorts[7]_rec' 'heatPorts[7]';
    protected
      record 'heatPorts[8]_rec'
        Modelica.SIunits.Temperature T
                                      "Port temperature";
        Modelica.SIunits.HeatFlowRate Q_flow
                                            "Heat flow rate (positive if flowing from outside into the component)";
      end 'heatPorts[8]_rec';
    public
      'heatPorts[8]_rec' 'heatPorts[8]';
    protected
      record 'heatPorts[9]_rec'
        Modelica.SIunits.Temperature T
                                      "Port temperature";
        Modelica.SIunits.HeatFlowRate Q_flow
                                            "Heat flow rate (positive if flowing from outside into the component)";
      end 'heatPorts[9]_rec';
    public
      'heatPorts[9]_rec' 'heatPorts[9]';
    protected
      record 'heatPorts[10]_rec'
        Modelica.SIunits.Temperature T
                                      "Port temperature";
        Modelica.SIunits.HeatFlowRate Q_flow
                                            "Heat flow rate (positive if flowing from outside into the component)";
      end 'heatPorts[10]_rec';
    public
      'heatPorts[10]_rec' 'heatPorts[10]';
    protected
      record heatTransfer_rec
        constant Integer n = 10
                               "Number of heat transfer segments";
      protected
        record 'states[1]_rec'
          Modelica.SIunits.Temperature T
                                        "Temperature";
          Modelica.SIunits.Pressure p
                                     "Pressure";
        end 'states[1]_rec';
      public
        'states[1]_rec' 'states[1]';
      protected
        record 'states[2]_rec'
          Modelica.SIunits.Temperature T
                                        "Temperature";
          Modelica.SIunits.Pressure p
                                     "Pressure";
        end 'states[2]_rec';
      public
        'states[2]_rec' 'states[2]';
      protected
        record 'states[3]_rec'
          Modelica.SIunits.Temperature T
                                        "Temperature";
          Modelica.SIunits.Pressure p
                                     "Pressure";
        end 'states[3]_rec';
      public
        'states[3]_rec' 'states[3]';
      protected
        record 'states[4]_rec'
          Modelica.SIunits.Temperature T
                                        "Temperature";
          Modelica.SIunits.Pressure p
                                     "Pressure";
        end 'states[4]_rec';
      public
        'states[4]_rec' 'states[4]';
      protected
        record 'states[5]_rec'
          Modelica.SIunits.Temperature T
                                        "Temperature";
          Modelica.SIunits.Pressure p
                                     "Pressure";
        end 'states[5]_rec';
      public
        'states[5]_rec' 'states[5]';
      protected
        record 'states[6]_rec'
          Modelica.SIunits.Temperature T
                                        "Temperature";
          Modelica.SIunits.Pressure p
                                     "Pressure";
        end 'states[6]_rec';
      public
        'states[6]_rec' 'states[6]';
      protected
        record 'states[7]_rec'
          Modelica.SIunits.Temperature T
                                        "Temperature";
          Modelica.SIunits.Pressure p
                                     "Pressure";
        end 'states[7]_rec';
      public
        'states[7]_rec' 'states[7]';
      protected
        record 'states[8]_rec'
          Modelica.SIunits.Temperature T
                                        "Temperature";
          Modelica.SIunits.Pressure p
                                     "Pressure";
        end 'states[8]_rec';
      public
        'states[8]_rec' 'states[8]';
      protected
        record 'states[9]_rec'
          Modelica.SIunits.Temperature T
                                        "Temperature";
          Modelica.SIunits.Pressure p
                                     "Pressure";
        end 'states[9]_rec';
      public
        'states[9]_rec' 'states[9]';
      protected
        record 'states[10]_rec'
          Modelica.SIunits.Temperature T
                                        "Temperature";
          Modelica.SIunits.Pressure p
                                     "Pressure";
        end 'states[10]_rec';
      public
        'states[10]_rec' 'states[10]';
        parameter Modelica.SIunits.Area 'surfaceAreas[1]'(fixed=false)
                                                                      "Heat transfer areas";
        parameter Modelica.SIunits.Area 'surfaceAreas[2]'(fixed=false)
                                                                      "Heat transfer areas";
        parameter Modelica.SIunits.Area 'surfaceAreas[3]'(fixed=false)
                                                                      "Heat transfer areas";
        parameter Modelica.SIunits.Area 'surfaceAreas[4]'(fixed=false)
                                                                      "Heat transfer areas";
        parameter Modelica.SIunits.Area 'surfaceAreas[5]'(fixed=false)
                                                                      "Heat transfer areas";
        parameter Modelica.SIunits.Area 'surfaceAreas[6]'(fixed=false)
                                                                      "Heat transfer areas";
        parameter Modelica.SIunits.Area 'surfaceAreas[7]'(fixed=false)
                                                                      "Heat transfer areas";
        parameter Modelica.SIunits.Area 'surfaceAreas[8]'(fixed=false)
                                                                      "Heat transfer areas";
        parameter Modelica.SIunits.Area 'surfaceAreas[9]'(fixed=false)
                                                                      "Heat transfer areas";
        parameter Modelica.SIunits.Area 'surfaceAreas[10]'(fixed=false)
                                                                       "Heat transfer areas";
        Modelica.SIunits.HeatFlowRate 'Q_flows[1]'
                                                  "Heat flow rates";
        Modelica.SIunits.HeatFlowRate 'Q_flows[2]'
                                                  "Heat flow rates";
        Modelica.SIunits.HeatFlowRate 'Q_flows[3]'
                                                  "Heat flow rates";
        Modelica.SIunits.HeatFlowRate 'Q_flows[4]'
                                                  "Heat flow rates";
        Modelica.SIunits.HeatFlowRate 'Q_flows[5]'
                                                  "Heat flow rates";
        Modelica.SIunits.HeatFlowRate 'Q_flows[6]'
                                                  "Heat flow rates";
        Modelica.SIunits.HeatFlowRate 'Q_flows[7]'
                                                  "Heat flow rates";
        Modelica.SIunits.HeatFlowRate 'Q_flows[8]'
                                                  "Heat flow rates";
        Modelica.SIunits.HeatFlowRate 'Q_flows[9]'
                                                  "Heat flow rates";
        Modelica.SIunits.HeatFlowRate 'Q_flows[10]'
                                                   "Heat flow rates";
        constant Boolean use_k = true
                                     "= true to use k value for thermal isolation";
        constant Modelica.SIunits.CoefficientOfHeatTransfer k = 0
                                                                 "Heat transfer coefficient to ambient";
        parameter Modelica.SIunits.Temperature T_ambient(fixed=false)
                                                                     "Ambient temperature";
      protected
        record 'heatPorts[1]_rec'
          Modelica.SIunits.Temperature T
                                        "Port temperature";
          Modelica.SIunits.HeatFlowRate Q_flow
                                              "Heat flow rate (positive if flowing from outside into the component)";
        end 'heatPorts[1]_rec';
      public
        'heatPorts[1]_rec' 'heatPorts[1]';
      protected
        record 'heatPorts[2]_rec'
          Modelica.SIunits.Temperature T
                                        "Port temperature";
          Modelica.SIunits.HeatFlowRate Q_flow
                                              "Heat flow rate (positive if flowing from outside into the component)";
        end 'heatPorts[2]_rec';
      public
        'heatPorts[2]_rec' 'heatPorts[2]';
      protected
        record 'heatPorts[3]_rec'
          Modelica.SIunits.Temperature T
                                        "Port temperature";
          Modelica.SIunits.HeatFlowRate Q_flow
                                              "Heat flow rate (positive if flowing from outside into the component)";
        end 'heatPorts[3]_rec';
      public
        'heatPorts[3]_rec' 'heatPorts[3]';
      protected
        record 'heatPorts[4]_rec'
          Modelica.SIunits.Temperature T
                                        "Port temperature";
          Modelica.SIunits.HeatFlowRate Q_flow
                                              "Heat flow rate (positive if flowing from outside into the component)";
        end 'heatPorts[4]_rec';
      public
        'heatPorts[4]_rec' 'heatPorts[4]';
      protected
        record 'heatPorts[5]_rec'
          Modelica.SIunits.Temperature T
                                        "Port temperature";
          Modelica.SIunits.HeatFlowRate Q_flow
                                              "Heat flow rate (positive if flowing from outside into the component)";
        end 'heatPorts[5]_rec';
      public
        'heatPorts[5]_rec' 'heatPorts[5]';
      protected
        record 'heatPorts[6]_rec'
          Modelica.SIunits.Temperature T
                                        "Port temperature";
          Modelica.SIunits.HeatFlowRate Q_flow
                                              "Heat flow rate (positive if flowing from outside into the component)";
        end 'heatPorts[6]_rec';
      public
        'heatPorts[6]_rec' 'heatPorts[6]';
      protected
        record 'heatPorts[7]_rec'
          Modelica.SIunits.Temperature T
                                        "Port temperature";
          Modelica.SIunits.HeatFlowRate Q_flow
                                              "Heat flow rate (positive if flowing from outside into the component)";
        end 'heatPorts[7]_rec';
      public
        'heatPorts[7]_rec' 'heatPorts[7]';
      protected
        record 'heatPorts[8]_rec'
          Modelica.SIunits.Temperature T
                                        "Port temperature";
          Modelica.SIunits.HeatFlowRate Q_flow
                                              "Heat flow rate (positive if flowing from outside into the component)";
        end 'heatPorts[8]_rec';
      public
        'heatPorts[8]_rec' 'heatPorts[8]';
      protected
        record 'heatPorts[9]_rec'
          Modelica.SIunits.Temperature T
                                        "Port temperature";
          Modelica.SIunits.HeatFlowRate Q_flow
                                              "Heat flow rate (positive if flowing from outside into the component)";
        end 'heatPorts[9]_rec';
      public
        'heatPorts[9]_rec' 'heatPorts[9]';
      protected
        record 'heatPorts[10]_rec'
          Modelica.SIunits.Temperature T
                                        "Port temperature";
          Modelica.SIunits.HeatFlowRate Q_flow
                                              "Heat flow rate (positive if flowing from outside into the component)";
        end 'heatPorts[10]_rec';
      public
        'heatPorts[10]_rec' 'heatPorts[10]';
        Modelica.SIunits.Temperature 'Ts[1]'
                                            "Temperatures defined by fluid states";
        Modelica.SIunits.Temperature 'Ts[2]'
                                            "Temperatures defined by fluid states";
        Modelica.SIunits.Temperature 'Ts[3]'
                                            "Temperatures defined by fluid states";
        Modelica.SIunits.Temperature 'Ts[4]'
                                            "Temperatures defined by fluid states";
        Modelica.SIunits.Temperature 'Ts[5]'
                                            "Temperatures defined by fluid states";
        Modelica.SIunits.Temperature 'Ts[6]'
                                            "Temperatures defined by fluid states";
        Modelica.SIunits.Temperature 'Ts[7]'
                                            "Temperatures defined by fluid states";
        Modelica.SIunits.Temperature 'Ts[8]'
                                            "Temperatures defined by fluid states";
        Modelica.SIunits.Temperature 'Ts[9]'
                                            "Temperatures defined by fluid states";
        Modelica.SIunits.Temperature 'Ts[10]'
                                             "Temperatures defined by fluid states";
        Modelica.SIunits.Velocity 'vs[1]'
                                         "Mean velocities of fluid flow in segments";
        Modelica.SIunits.Velocity 'vs[2]'
                                         "Mean velocities of fluid flow in segments";
        Modelica.SIunits.Velocity 'vs[3]'
                                         "Mean velocities of fluid flow in segments";
        Modelica.SIunits.Velocity 'vs[4]'
                                         "Mean velocities of fluid flow in segments";
        Modelica.SIunits.Velocity 'vs[5]'
                                         "Mean velocities of fluid flow in segments";
        Modelica.SIunits.Velocity 'vs[6]'
                                         "Mean velocities of fluid flow in segments";
        Modelica.SIunits.Velocity 'vs[7]'
                                         "Mean velocities of fluid flow in segments";
        Modelica.SIunits.Velocity 'vs[8]'
                                         "Mean velocities of fluid flow in segments";
        Modelica.SIunits.Velocity 'vs[9]'
                                         "Mean velocities of fluid flow in segments";
        Modelica.SIunits.Velocity 'vs[10]'
                                          "Mean velocities of fluid flow in segments";
        parameter Real nParallel(unit = "1", fixed=false)
                                                         "number of identical parallel flow devices";
        constant Modelica.SIunits.Length 'lengths[1]' = 0.066673757545215
                                                                         "Lengths along flow path";
        constant Modelica.SIunits.Length 'lengths[2]' = 0.066673757545215
                                                                         "Lengths along flow path";
        constant Modelica.SIunits.Length 'lengths[3]' = 0.066673757545215
                                                                         "Lengths along flow path";
        constant Modelica.SIunits.Length 'lengths[4]' = 0.066673757545215
                                                                         "Lengths along flow path";
        constant Modelica.SIunits.Length 'lengths[5]' = 0.066673757545215
                                                                         "Lengths along flow path";
        constant Modelica.SIunits.Length 'lengths[6]' = 0.066673757545215
                                                                         "Lengths along flow path";
        constant Modelica.SIunits.Length 'lengths[7]' = 0.066673757545215
                                                                         "Lengths along flow path";
        constant Modelica.SIunits.Length 'lengths[8]' = 0.066673757545215
                                                                         "Lengths along flow path";
        constant Modelica.SIunits.Length 'lengths[9]' = 0.066673757545215
                                                                         "Lengths along flow path";
        constant Modelica.SIunits.Length 'lengths[10]' = 0.066673757545215
                                                                          "Lengths along flow path";
        Modelica.SIunits.Length 'dimensions[1]'
                                               "Characteristic dimensions for fluid flow (diameter for pipe flow)";
        Modelica.SIunits.Length 'dimensions[2]'
                                               "Characteristic dimensions for fluid flow (diameter for pipe flow)";
        Modelica.SIunits.Length 'dimensions[3]'
                                               "Characteristic dimensions for fluid flow (diameter for pipe flow)";
        Modelica.SIunits.Length 'dimensions[4]'
                                               "Characteristic dimensions for fluid flow (diameter for pipe flow)";
        Modelica.SIunits.Length 'dimensions[5]'
                                               "Characteristic dimensions for fluid flow (diameter for pipe flow)";
        Modelica.SIunits.Length 'dimensions[6]'
                                               "Characteristic dimensions for fluid flow (diameter for pipe flow)";
        Modelica.SIunits.Length 'dimensions[7]'
                                               "Characteristic dimensions for fluid flow (diameter for pipe flow)";
        Modelica.SIunits.Length 'dimensions[8]'
                                               "Characteristic dimensions for fluid flow (diameter for pipe flow)";
        Modelica.SIunits.Length 'dimensions[9]'
                                               "Characteristic dimensions for fluid flow (diameter for pipe flow)";
        Modelica.SIunits.Length 'dimensions[10]'
                                                "Characteristic dimensions for fluid flow (diameter for pipe flow)";
        Modelica.SIunits.Height 'roughnesses[1]'
                                                "Average heights of surface asperities";
        Modelica.SIunits.Height 'roughnesses[2]'
                                                "Average heights of surface asperities";
        Modelica.SIunits.Height 'roughnesses[3]'
                                                "Average heights of surface asperities";
        Modelica.SIunits.Height 'roughnesses[4]'
                                                "Average heights of surface asperities";
        Modelica.SIunits.Height 'roughnesses[5]'
                                                "Average heights of surface asperities";
        Modelica.SIunits.Height 'roughnesses[6]'
                                                "Average heights of surface asperities";
        Modelica.SIunits.Height 'roughnesses[7]'
                                                "Average heights of surface asperities";
        Modelica.SIunits.Height 'roughnesses[8]'
                                                "Average heights of surface asperities";
        Modelica.SIunits.Height 'roughnesses[9]'
                                                "Average heights of surface asperities";
        Modelica.SIunits.Height 'roughnesses[10]'
                                                 "Average heights of surface asperities";
      end heatTransfer_rec;
    public
      heatTransfer_rec heatTransfer;
      constant Real 'dxs[1]'(unit = "1") = 0.1;
      constant Real 'dxs[2]'(unit = "1") = 0.1;
      constant Real 'dxs[3]'(unit = "1") = 0.1;
      constant Real 'dxs[4]'(unit = "1") = 0.1;
      constant Real 'dxs[5]'(unit = "1") = 0.1;
      constant Real 'dxs[6]'(unit = "1") = 0.1;
      constant Real 'dxs[7]'(unit = "1") = 0.1;
      constant Real 'dxs[8]'(unit = "1") = 0.1;
      constant Real 'dxs[9]'(unit = "1") = 0.1;
      constant Real 'dxs[10]'(unit = "1") = 0.1;
    protected
      record 'mediums[1]_rec'
        Real p(unit = "Pa", displayUnit = "bar", nominal = 100000.0, quantity = "Pressure", min = 0.0)
                                                                                                      "Absolute pressure of medium";
        Real h(unit = "J/kg", quantity = "SpecificEnergy")
                                                          "Specific enthalpy of medium";
        Modelica.Media.Interfaces.Types.Density d
                                                 "Density of medium";
        Real d_der(unit = "Pa.m-2.s")
                                     "der(Density of medium)";
        parameter Modelica.Media.Interfaces.Types.Temperature _T_start = 263.15;
        Modelica.Media.Interfaces.Types.Temperature T(min = 263.15, max = 443.15,start = _T_start)
                                                                                                  "Temperature of medium";
        parameter Real _T_der_start = 0.0;
        Real T_der(unit = "K/s",start = _T_der_start, fixed=false)
                                                                  "der(Temperature of medium)";
        constant Modelica.Media.Interfaces.Types.MassFraction 'X[1]' = 1.0
                                                                          "Mass fractions (= (component mass)/total mass  m_i/m)";
        Modelica.Media.Interfaces.Types.SpecificInternalEnergy u
                                                                "Specific internal energy of medium";
        Real u_der(unit = "m2/s3")
                                  "der(Specific internal energy of medium)";
        constant Modelica.Media.Interfaces.Types.SpecificHeatCapacity R = 8.3144598
                                                                                   "Gas constant (of mixture if applicable)";
        constant Modelica.Media.Interfaces.Types.MolarMass MM = 0.1
                                                                   "Molar mass (of mixture or single fluid)";
      protected
        record state_rec
          Modelica.SIunits.Temperature T
                                        "Temperature";
          Modelica.SIunits.Pressure p
                                     "Pressure";
        end state_rec;
      public
        state_rec state;
        constant Boolean preferredMediumStates = true
                                                     "= true if StateSelect.prefer shall be used for the independent property variables of the medium";
        constant Boolean standardOrderComponents = true
                                                       "If true, and reducedX = true, the last element of X will be computed from the other ones";
        Modelica.SIunits.Conversions.NonSIunits.Temperature_degC T_degC
                                                                       "Temperature of medium in [degC]";
        Modelica.SIunits.Conversions.NonSIunits.Pressure_bar p_bar
                                                                  "Absolute pressure of medium in [bar]";
        Modelica.SIunits.SpecificHeatCapacity cp
                                                "Specific heat capacity";
        parameter Modelica.SIunits.Temperature T_start = 298.15
                                                               "Initial temperature";
      end 'mediums[1]_rec';
    public
      'mediums[1]_rec' 'mediums[1]' annotation(Dialog);
    protected
      record 'mediums[2]_rec'
        Real p(unit = "Pa", displayUnit = "bar", nominal = 100000.0, quantity = "Pressure", min = 0.0)
                                                                                                      "Absolute pressure of medium";
        Real h(unit = "J/kg", quantity = "SpecificEnergy")
                                                          "Specific enthalpy of medium";
        Real h_der(unit = "m2/s3")
                                  "der(Specific enthalpy of medium)";
        Modelica.Media.Interfaces.Types.Density d
                                                 "Density of medium";
        Real d_der(unit = "Pa.m-2.s")
                                     "der(Density of medium)";
        parameter Modelica.Media.Interfaces.Types.Temperature _T_start = 263.15;
        Modelica.Media.Interfaces.Types.Temperature T(min = 263.15, max = 443.15,start = _T_start)
                                                                                                  "Temperature of medium";
        parameter Real _T_der_start = 0.0;
        Real T_der(unit = "K/s",start = _T_der_start, fixed=false)
                                                                  "der(Temperature of medium)";
        constant Modelica.Media.Interfaces.Types.MassFraction 'X[1]' = 1.0
                                                                          "Mass fractions (= (component mass)/total mass  m_i/m)";
        Modelica.Media.Interfaces.Types.SpecificInternalEnergy u
                                                                "Specific internal energy of medium";
        Real u_der(unit = "m2/s3")
                                  "der(Specific internal energy of medium)";
        constant Modelica.Media.Interfaces.Types.SpecificHeatCapacity R = 8.3144598
                                                                                   "Gas constant (of mixture if applicable)";
        constant Modelica.Media.Interfaces.Types.MolarMass MM = 0.1
                                                                   "Molar mass (of mixture or single fluid)";
      protected
        record state_rec
          Modelica.SIunits.Temperature T
                                        "Temperature";
          Modelica.SIunits.Pressure p
                                     "Pressure";
        end state_rec;
      public
        state_rec state;
        constant Boolean preferredMediumStates = true
                                                     "= true if StateSelect.prefer shall be used for the independent property variables of the medium";
        constant Boolean standardOrderComponents = true
                                                       "If true, and reducedX = true, the last element of X will be computed from the other ones";
        Modelica.SIunits.Conversions.NonSIunits.Temperature_degC T_degC
                                                                       "Temperature of medium in [degC]";
        Modelica.SIunits.Conversions.NonSIunits.Pressure_bar p_bar
                                                                  "Absolute pressure of medium in [bar]";
        Modelica.SIunits.SpecificHeatCapacity cp
                                                "Specific heat capacity";
        parameter Modelica.SIunits.Temperature T_start = 298.15
                                                               "Initial temperature";
      end 'mediums[2]_rec';
    public
      'mediums[2]_rec' 'mediums[2]' annotation(Dialog);
    protected
      record 'mediums[3]_rec'
        Real p(unit = "Pa", displayUnit = "bar", nominal = 100000.0, quantity = "Pressure", min = 0.0)
                                                                                                      "Absolute pressure of medium";
        Real h(unit = "J/kg", quantity = "SpecificEnergy")
                                                          "Specific enthalpy of medium";
        Real h_der(unit = "m2/s3")
                                  "der(Specific enthalpy of medium)";
        Modelica.Media.Interfaces.Types.Density d
                                                 "Density of medium";
        Real d_der(unit = "Pa.m-2.s")
                                     "der(Density of medium)";
        parameter Modelica.Media.Interfaces.Types.Temperature _T_start = 263.15;
        Modelica.Media.Interfaces.Types.Temperature T(min = 263.15, max = 443.15,start = _T_start)
                                                                                                  "Temperature of medium";
        parameter Real _T_der_start = 0.0;
        Real T_der(unit = "K/s",start = _T_der_start, fixed=false)
                                                                  "der(Temperature of medium)";
        constant Modelica.Media.Interfaces.Types.MassFraction 'X[1]' = 1.0
                                                                          "Mass fractions (= (component mass)/total mass  m_i/m)";
        Modelica.Media.Interfaces.Types.SpecificInternalEnergy u
                                                                "Specific internal energy of medium";
        Real u_der(unit = "m2/s3")
                                  "der(Specific internal energy of medium)";
        constant Modelica.Media.Interfaces.Types.SpecificHeatCapacity R = 8.3144598
                                                                                   "Gas constant (of mixture if applicable)";
        constant Modelica.Media.Interfaces.Types.MolarMass MM = 0.1
                                                                   "Molar mass (of mixture or single fluid)";
      protected
        record state_rec
          Modelica.SIunits.Temperature T
                                        "Temperature";
          Modelica.SIunits.Pressure p
                                     "Pressure";
        end state_rec;
      public
        state_rec state;
        constant Boolean preferredMediumStates = true
                                                     "= true if StateSelect.prefer shall be used for the independent property variables of the medium";
        constant Boolean standardOrderComponents = true
                                                       "If true, and reducedX = true, the last element of X will be computed from the other ones";
        Modelica.SIunits.Conversions.NonSIunits.Temperature_degC T_degC
                                                                       "Temperature of medium in [degC]";
        Modelica.SIunits.Conversions.NonSIunits.Pressure_bar p_bar
                                                                  "Absolute pressure of medium in [bar]";
        Modelica.SIunits.SpecificHeatCapacity cp
                                                "Specific heat capacity";
        parameter Modelica.SIunits.Temperature T_start = 298.15
                                                               "Initial temperature";
      end 'mediums[3]_rec';
    public
      'mediums[3]_rec' 'mediums[3]' annotation(Dialog);
    protected
      record 'mediums[4]_rec'
        Real p(unit = "Pa", displayUnit = "bar", nominal = 100000.0, quantity = "Pressure", min = 0.0)
                                                                                                      "Absolute pressure of medium";
        Real h(unit = "J/kg", quantity = "SpecificEnergy")
                                                          "Specific enthalpy of medium";
        Real h_der(unit = "m2/s3")
                                  "der(Specific enthalpy of medium)";
        Modelica.Media.Interfaces.Types.Density d
                                                 "Density of medium";
        Real d_der(unit = "Pa.m-2.s")
                                     "der(Density of medium)";
        parameter Modelica.Media.Interfaces.Types.Temperature _T_start = 263.15;
        Modelica.Media.Interfaces.Types.Temperature T(min = 263.15, max = 443.15,start = _T_start)
                                                                                                  "Temperature of medium";
        parameter Real _T_der_start = 0.0;
        Real T_der(unit = "K/s",start = _T_der_start, fixed=false)
                                                                  "der(Temperature of medium)";
        constant Modelica.Media.Interfaces.Types.MassFraction 'X[1]' = 1.0
                                                                          "Mass fractions (= (component mass)/total mass  m_i/m)";
        Modelica.Media.Interfaces.Types.SpecificInternalEnergy u
                                                                "Specific internal energy of medium";
        Real u_der(unit = "m2/s3")
                                  "der(Specific internal energy of medium)";
        constant Modelica.Media.Interfaces.Types.SpecificHeatCapacity R = 8.3144598
                                                                                   "Gas constant (of mixture if applicable)";
        constant Modelica.Media.Interfaces.Types.MolarMass MM = 0.1
                                                                   "Molar mass (of mixture or single fluid)";
      protected
        record state_rec
          Modelica.SIunits.Temperature T
                                        "Temperature";
          Modelica.SIunits.Pressure p
                                     "Pressure";
        end state_rec;
      public
        state_rec state;
        constant Boolean preferredMediumStates = true
                                                     "= true if StateSelect.prefer shall be used for the independent property variables of the medium";
        constant Boolean standardOrderComponents = true
                                                       "If true, and reducedX = true, the last element of X will be computed from the other ones";
        Modelica.SIunits.Conversions.NonSIunits.Temperature_degC T_degC
                                                                       "Temperature of medium in [degC]";
        Modelica.SIunits.Conversions.NonSIunits.Pressure_bar p_bar
                                                                  "Absolute pressure of medium in [bar]";
        Modelica.SIunits.SpecificHeatCapacity cp
                                                "Specific heat capacity";
        parameter Modelica.SIunits.Temperature T_start = 298.15
                                                               "Initial temperature";
      end 'mediums[4]_rec';
    public
      'mediums[4]_rec' 'mediums[4]' annotation(Dialog);
    protected
      record 'mediums[5]_rec'
        Real p(unit = "Pa", displayUnit = "bar", nominal = 100000.0, quantity = "Pressure", min = 0.0)
                                                                                                      "Absolute pressure of medium";
        Real h(unit = "J/kg", quantity = "SpecificEnergy")
                                                          "Specific enthalpy of medium";
        Real h_der(unit = "m2/s3")
                                  "der(Specific enthalpy of medium)";
        Modelica.Media.Interfaces.Types.Density d
                                                 "Density of medium";
        Real d_der(unit = "Pa.m-2.s")
                                     "der(Density of medium)";
        parameter Modelica.Media.Interfaces.Types.Temperature _T_start = 263.15;
        Modelica.Media.Interfaces.Types.Temperature T(min = 263.15, max = 443.15,start = _T_start)
                                                                                                  "Temperature of medium";
        parameter Real _T_der_start = 0.0;
        Real T_der(unit = "K/s",start = _T_der_start, fixed=false)
                                                                  "der(Temperature of medium)";
        constant Modelica.Media.Interfaces.Types.MassFraction 'X[1]' = 1.0
                                                                          "Mass fractions (= (component mass)/total mass  m_i/m)";
        Modelica.Media.Interfaces.Types.SpecificInternalEnergy u
                                                                "Specific internal energy of medium";
        Real u_der(unit = "m2/s3")
                                  "der(Specific internal energy of medium)";
        constant Modelica.Media.Interfaces.Types.SpecificHeatCapacity R = 8.3144598
                                                                                   "Gas constant (of mixture if applicable)";
        constant Modelica.Media.Interfaces.Types.MolarMass MM = 0.1
                                                                   "Molar mass (of mixture or single fluid)";
      protected
        record state_rec
          Modelica.SIunits.Temperature T
                                        "Temperature";
          Modelica.SIunits.Pressure p
                                     "Pressure";
        end state_rec;
      public
        state_rec state;
        constant Boolean preferredMediumStates = true
                                                     "= true if StateSelect.prefer shall be used for the independent property variables of the medium";
        constant Boolean standardOrderComponents = true
                                                       "If true, and reducedX = true, the last element of X will be computed from the other ones";
        Modelica.SIunits.Conversions.NonSIunits.Temperature_degC T_degC
                                                                       "Temperature of medium in [degC]";
        Modelica.SIunits.Conversions.NonSIunits.Pressure_bar p_bar
                                                                  "Absolute pressure of medium in [bar]";
        Modelica.SIunits.SpecificHeatCapacity cp
                                                "Specific heat capacity";
        parameter Modelica.SIunits.Temperature T_start = 298.15
                                                               "Initial temperature";
      end 'mediums[5]_rec';
    public
      'mediums[5]_rec' 'mediums[5]' annotation(Dialog);
    protected
      record 'mediums[6]_rec'
        Real p(unit = "Pa", displayUnit = "bar", nominal = 100000.0, quantity = "Pressure", min = 0.0)
                                                                                                      "Absolute pressure of medium";
        Real h(unit = "J/kg", quantity = "SpecificEnergy")
                                                          "Specific enthalpy of medium";
        Real h_der(unit = "m2/s3")
                                  "der(Specific enthalpy of medium)";
        Modelica.Media.Interfaces.Types.Density d
                                                 "Density of medium";
        Real d_der(unit = "Pa.m-2.s")
                                     "der(Density of medium)";
        parameter Modelica.Media.Interfaces.Types.Temperature _T_start = 263.15;
        Modelica.Media.Interfaces.Types.Temperature T(min = 263.15, max = 443.15,start = _T_start)
                                                                                                  "Temperature of medium";
        parameter Real _T_der_start = 0.0;
        Real T_der(unit = "K/s",start = _T_der_start, fixed=false)
                                                                  "der(Temperature of medium)";
        constant Modelica.Media.Interfaces.Types.MassFraction 'X[1]' = 1.0
                                                                          "Mass fractions (= (component mass)/total mass  m_i/m)";
        Modelica.Media.Interfaces.Types.SpecificInternalEnergy u
                                                                "Specific internal energy of medium";
        Real u_der(unit = "m2/s3")
                                  "der(Specific internal energy of medium)";
        constant Modelica.Media.Interfaces.Types.SpecificHeatCapacity R = 8.3144598
                                                                                   "Gas constant (of mixture if applicable)";
        constant Modelica.Media.Interfaces.Types.MolarMass MM = 0.1
                                                                   "Molar mass (of mixture or single fluid)";
      protected
        record state_rec
          Modelica.SIunits.Temperature T
                                        "Temperature";
          Modelica.SIunits.Pressure p
                                     "Pressure";
        end state_rec;
      public
        state_rec state;
        constant Boolean preferredMediumStates = true
                                                     "= true if StateSelect.prefer shall be used for the independent property variables of the medium";
        constant Boolean standardOrderComponents = true
                                                       "If true, and reducedX = true, the last element of X will be computed from the other ones";
        Modelica.SIunits.Conversions.NonSIunits.Temperature_degC T_degC
                                                                       "Temperature of medium in [degC]";
        Modelica.SIunits.Conversions.NonSIunits.Pressure_bar p_bar
                                                                  "Absolute pressure of medium in [bar]";
        Modelica.SIunits.SpecificHeatCapacity cp
                                                "Specific heat capacity";
        parameter Modelica.SIunits.Temperature T_start = 298.15
                                                               "Initial temperature";
      end 'mediums[6]_rec';
    public
      'mediums[6]_rec' 'mediums[6]' annotation(Dialog);
    protected
      record 'mediums[7]_rec'
        Real p(unit = "Pa", displayUnit = "bar", nominal = 100000.0, quantity = "Pressure", min = 0.0)
                                                                                                      "Absolute pressure of medium";
        Real h(unit = "J/kg", quantity = "SpecificEnergy")
                                                          "Specific enthalpy of medium";
        Real h_der(unit = "m2/s3")
                                  "der(Specific enthalpy of medium)";
        Modelica.Media.Interfaces.Types.Density d
                                                 "Density of medium";
        Real d_der(unit = "Pa.m-2.s")
                                     "der(Density of medium)";
        parameter Modelica.Media.Interfaces.Types.Temperature _T_start = 263.15;
        Modelica.Media.Interfaces.Types.Temperature T(min = 263.15, max = 443.15,start = _T_start)
                                                                                                  "Temperature of medium";
        parameter Real _T_der_start = 0.0;
        Real T_der(unit = "K/s",start = _T_der_start, fixed=false)
                                                                  "der(Temperature of medium)";
        constant Modelica.Media.Interfaces.Types.MassFraction 'X[1]' = 1.0
                                                                          "Mass fractions (= (component mass)/total mass  m_i/m)";
        Modelica.Media.Interfaces.Types.SpecificInternalEnergy u
                                                                "Specific internal energy of medium";
        Real u_der(unit = "m2/s3")
                                  "der(Specific internal energy of medium)";
        constant Modelica.Media.Interfaces.Types.SpecificHeatCapacity R = 8.3144598
                                                                                   "Gas constant (of mixture if applicable)";
        constant Modelica.Media.Interfaces.Types.MolarMass MM = 0.1
                                                                   "Molar mass (of mixture or single fluid)";
      protected
        record state_rec
          Modelica.SIunits.Temperature T
                                        "Temperature";
          Modelica.SIunits.Pressure p
                                     "Pressure";
        end state_rec;
      public
        state_rec state;
        constant Boolean preferredMediumStates = true
                                                     "= true if StateSelect.prefer shall be used for the independent property variables of the medium";
        constant Boolean standardOrderComponents = true
                                                       "If true, and reducedX = true, the last element of X will be computed from the other ones";
        Modelica.SIunits.Conversions.NonSIunits.Temperature_degC T_degC
                                                                       "Temperature of medium in [degC]";
        Modelica.SIunits.Conversions.NonSIunits.Pressure_bar p_bar
                                                                  "Absolute pressure of medium in [bar]";
        Modelica.SIunits.SpecificHeatCapacity cp
                                                "Specific heat capacity";
        parameter Modelica.SIunits.Temperature T_start = 298.15
                                                               "Initial temperature";
      end 'mediums[7]_rec';
    public
      'mediums[7]_rec' 'mediums[7]' annotation(Dialog);
    protected
      record 'mediums[8]_rec'
        Real p(unit = "Pa", displayUnit = "bar", nominal = 100000.0, quantity = "Pressure", min = 0.0)
                                                                                                      "Absolute pressure of medium";
        Real h(unit = "J/kg", quantity = "SpecificEnergy")
                                                          "Specific enthalpy of medium";
        Real h_der(unit = "m2/s3")
                                  "der(Specific enthalpy of medium)";
        Modelica.Media.Interfaces.Types.Density d
                                                 "Density of medium";
        Real d_der(unit = "Pa.m-2.s")
                                     "der(Density of medium)";
        parameter Modelica.Media.Interfaces.Types.Temperature _T_start = 263.15;
        Modelica.Media.Interfaces.Types.Temperature T(min = 263.15, max = 443.15,start = _T_start)
                                                                                                  "Temperature of medium";
        parameter Real _T_der_start = 0.0;
        Real T_der(unit = "K/s",start = _T_der_start, fixed=false)
                                                                  "der(Temperature of medium)";
        constant Modelica.Media.Interfaces.Types.MassFraction 'X[1]' = 1.0
                                                                          "Mass fractions (= (component mass)/total mass  m_i/m)";
        Modelica.Media.Interfaces.Types.SpecificInternalEnergy u
                                                                "Specific internal energy of medium";
        Real u_der(unit = "m2/s3")
                                  "der(Specific internal energy of medium)";
        constant Modelica.Media.Interfaces.Types.SpecificHeatCapacity R = 8.3144598
                                                                                   "Gas constant (of mixture if applicable)";
        constant Modelica.Media.Interfaces.Types.MolarMass MM = 0.1
                                                                   "Molar mass (of mixture or single fluid)";
      protected
        record state_rec
          Modelica.SIunits.Temperature T
                                        "Temperature";
          Modelica.SIunits.Pressure p
                                     "Pressure";
        end state_rec;
      public
        state_rec state;
        constant Boolean preferredMediumStates = true
                                                     "= true if StateSelect.prefer shall be used for the independent property variables of the medium";
        constant Boolean standardOrderComponents = true
                                                       "If true, and reducedX = true, the last element of X will be computed from the other ones";
        Modelica.SIunits.Conversions.NonSIunits.Temperature_degC T_degC
                                                                       "Temperature of medium in [degC]";
        Modelica.SIunits.Conversions.NonSIunits.Pressure_bar p_bar
                                                                  "Absolute pressure of medium in [bar]";
        Modelica.SIunits.SpecificHeatCapacity cp
                                                "Specific heat capacity";
        parameter Modelica.SIunits.Temperature T_start = 298.15
                                                               "Initial temperature";
      end 'mediums[8]_rec';
    public
      'mediums[8]_rec' 'mediums[8]' annotation(Dialog);
    protected
      record 'mediums[9]_rec'
        Real p(unit = "Pa", displayUnit = "bar", nominal = 100000.0, quantity = "Pressure", min = 0.0)
                                                                                                      "Absolute pressure of medium";
        Real h(unit = "J/kg", quantity = "SpecificEnergy")
                                                          "Specific enthalpy of medium";
        Real h_der(unit = "m2/s3")
                                  "der(Specific enthalpy of medium)";
        Modelica.Media.Interfaces.Types.Density d
                                                 "Density of medium";
        Real d_der(unit = "Pa.m-2.s")
                                     "der(Density of medium)";
        parameter Modelica.Media.Interfaces.Types.Temperature _T_start = 263.15;
        Modelica.Media.Interfaces.Types.Temperature T(min = 263.15, max = 443.15,start = _T_start)
                                                                                                  "Temperature of medium";
        parameter Real _T_der_start = 0.0;
        Real T_der(unit = "K/s",start = _T_der_start, fixed=false)
                                                                  "der(Temperature of medium)";
        constant Modelica.Media.Interfaces.Types.MassFraction 'X[1]' = 1.0
                                                                          "Mass fractions (= (component mass)/total mass  m_i/m)";
        Modelica.Media.Interfaces.Types.SpecificInternalEnergy u
                                                                "Specific internal energy of medium";
        Real u_der(unit = "m2/s3")
                                  "der(Specific internal energy of medium)";
        constant Modelica.Media.Interfaces.Types.SpecificHeatCapacity R = 8.3144598
                                                                                   "Gas constant (of mixture if applicable)";
        constant Modelica.Media.Interfaces.Types.MolarMass MM = 0.1
                                                                   "Molar mass (of mixture or single fluid)";
      protected
        record state_rec
          Modelica.SIunits.Temperature T
                                        "Temperature";
          Modelica.SIunits.Pressure p
                                     "Pressure";
        end state_rec;
      public
        state_rec state;
        constant Boolean preferredMediumStates = true
                                                     "= true if StateSelect.prefer shall be used for the independent property variables of the medium";
        constant Boolean standardOrderComponents = true
                                                       "If true, and reducedX = true, the last element of X will be computed from the other ones";
        Modelica.SIunits.Conversions.NonSIunits.Temperature_degC T_degC
                                                                       "Temperature of medium in [degC]";
        Modelica.SIunits.Conversions.NonSIunits.Pressure_bar p_bar
                                                                  "Absolute pressure of medium in [bar]";
        Modelica.SIunits.SpecificHeatCapacity cp
                                                "Specific heat capacity";
        parameter Modelica.SIunits.Temperature T_start = 298.15
                                                               "Initial temperature";
      end 'mediums[9]_rec';
    public
      'mediums[9]_rec' 'mediums[9]' annotation(Dialog);
    protected
      record 'mediums[10]_rec'
        Real p(unit = "Pa", displayUnit = "bar", nominal = 100000.0, quantity = "Pressure", min = 0.0)
                                                                                                      "Absolute pressure of medium";
        Real h(unit = "J/kg", quantity = "SpecificEnergy")
                                                          "Specific enthalpy of medium";
        Modelica.Media.Interfaces.Types.Density d
                                                 "Density of medium";
        Real d_der(unit = "Pa.m-2.s")
                                     "der(Density of medium)";
        parameter Modelica.Media.Interfaces.Types.Temperature _T_start = 263.15;
        Modelica.Media.Interfaces.Types.Temperature T(min = 263.15, max = 443.15,start = _T_start)
                                                                                                  "Temperature of medium";
        parameter Real _T_der_start = 0.0;
        Real T_der(unit = "K/s",start = _T_der_start, fixed=false)
                                                                  "der(Temperature of medium)";
        constant Modelica.Media.Interfaces.Types.MassFraction 'X[1]' = 1.0
                                                                          "Mass fractions (= (component mass)/total mass  m_i/m)";
        Modelica.Media.Interfaces.Types.SpecificInternalEnergy u
                                                                "Specific internal energy of medium";
        Real u_der(unit = "m2/s3")
                                  "der(Specific internal energy of medium)";
        constant Modelica.Media.Interfaces.Types.SpecificHeatCapacity R = 8.3144598
                                                                                   "Gas constant (of mixture if applicable)";
        constant Modelica.Media.Interfaces.Types.MolarMass MM = 0.1
                                                                   "Molar mass (of mixture or single fluid)";
      protected
        record state_rec
          Modelica.SIunits.Temperature T
                                        "Temperature";
          Modelica.SIunits.Pressure p
                                     "Pressure";
        end state_rec;
      public
        state_rec state;
        constant Boolean preferredMediumStates = true
                                                     "= true if StateSelect.prefer shall be used for the independent property variables of the medium";
        constant Boolean standardOrderComponents = true
                                                       "If true, and reducedX = true, the last element of X will be computed from the other ones";
        Modelica.SIunits.Conversions.NonSIunits.Temperature_degC T_degC
                                                                       "Temperature of medium in [degC]";
        parameter Modelica.SIunits.Conversions.NonSIunits.Pressure_bar p_bar(fixed=false)
                                                                                         "Absolute pressure of medium in [bar]";
        Modelica.SIunits.SpecificHeatCapacity cp
                                                "Specific heat capacity";
        parameter Modelica.SIunits.Temperature T_start = 298.15
                                                               "Initial temperature";
      end 'mediums[10]_rec';
    public
      'mediums[10]_rec' 'mediums[10]' annotation(Dialog);
    end pipe_rec;
  public
    pipe_rec pipe annotation(Dialog);
  protected
    record 'hTFtoPCM[1]_rec'
      parameter Modelica.SIunits.Volume vol(fixed=false)
                                                        "Volume of element";
      parameter Integer nCoilp(fixed=false)
                                           "number of horizontally parallel coils";
      constant Modelica.SIunits.Temperature T_Tube_start = 263.15
                                                                 "Start temperature of the tube";
    protected
      record HTFtoTube_rec
        Modelica.SIunits.HeatFlowRate Q_flow
                                            "Heat flow rate from port_a -> port_b";
        Modelica.SIunits.TemperatureDifference dT
                                                 "port_a.T - port_b.T";
      protected
        record port_a_rec
          Modelica.SIunits.Temperature T
                                        "Port temperature";
          Modelica.SIunits.HeatFlowRate Q_flow
                                              "Heat flow rate (positive if flowing from outside into the component)";
        end port_a_rec;
      public
        port_a_rec port_a;
      protected
        record port_b_rec
          Modelica.SIunits.Temperature T
                                        "Port temperature";
          Modelica.SIunits.HeatFlowRate Q_flow
                                              "Heat flow rate (positive if flowing from outside into the component)";
        end port_b_rec;
      public
        port_b_rec port_b;
        Modelica_Blocks_Interfaces_RealInput G(unit = "W/K")
                                                            "Constant thermal conductance of material";
      end HTFtoTube_rec;
    public
      HTFtoTube_rec HTFtoTube;
    protected
      record TubetoPCM_rec
        Modelica.SIunits.HeatFlowRate Q_flow
                                            "Heat flow rate from port_a -> port_b";
        Modelica.SIunits.TemperatureDifference dT
                                                 "port_a.T - port_b.T";
      protected
        record port_a_rec
          Modelica.SIunits.Temperature T
                                        "Port temperature";
          Modelica.SIunits.HeatFlowRate Q_flow
                                              "Heat flow rate (positive if flowing from outside into the component)";
        end port_a_rec;
      public
        port_a_rec port_a;
      protected
        record port_b_rec
          Modelica.SIunits.Temperature T
                                        "Port temperature";
          Modelica.SIunits.HeatFlowRate Q_flow
                                              "Heat flow rate (positive if flowing from outside into the component)";
        end port_b_rec;
      public
        port_b_rec port_b;
        Modelica_Blocks_Interfaces_RealInput G(unit = "W/K")
                                                            "Constant thermal conductance of material";
      end TubetoPCM_rec;
    public
      TubetoPCM_rec TubetoPCM;
    protected
      record TubeInertia_rec
        parameter Modelica.SIunits.Temperature _T_start = 263.15;
        Modelica.SIunits.Temperature T(start = _T_start)
                                                        "Temperature of element";
        Real T_der(unit = "K/s")
                                "der(Temperature of element)";
        Modelica.SIunits.HeatFlowRate Q_flow;
        parameter Modelica.SIunits.Temperature T_start = 293.15
                                                               "Start temperature for the average temperature of ellement";
      protected
        record port_rec
          Modelica.SIunits.Temperature T
                                        "Port temperature";
          Modelica.SIunits.HeatFlowRate Q_flow
                                              "Heat flow rate (positive if flowing from outside into the component)";
        end port_rec;
      public
        port_rec port;
        parameter Modelica.SIunits.Volume V(fixed=false)
                                                        "Volume of element";
        parameter Modelica.SIunits.Mass m(fixed=false)
                                                      "Mass of element";
        Modelica.SIunits.TemperatureSlope der_T
                                               "Time derivative of temperature (= der(T))";
        Modelica.SIunits.HeatCapacity C
                                       "Heat capacity of element (= cp*m)";
        parameter Modelica.SIunits.TemperatureSlope der_T_start = 0
                                                                   "Start value ofime derivative of temperature (= der(T))";
      end TubeInertia_rec;
    public
      TubeInertia_rec TubeInertia annotation(Dialog);
    protected
      record port_b_rec
        Modelica.SIunits.Temperature T
                                      "Port temperature";
        Modelica.SIunits.HeatFlowRate Q_flow
                                            "Heat flow rate (positive if flowing from outside into the component)";
      end port_b_rec;
    public
      port_b_rec port_b;
    protected
      record port_a_rec
        Modelica.SIunits.Temperature T
                                      "Port temperature";
        Modelica.SIunits.HeatFlowRate Q_flow
                                            "Heat flow rate (positive if flowing from outside into the component)";
      end port_a_rec;
    public
      port_a_rec port_a;
      Modelica_Blocks_Interfaces_RealInput G_HTFtoTube;
      Modelica_Blocks_Interfaces_RealInput G_TubetoPCM;
    end 'hTFtoPCM[1]_rec';
  public
    'hTFtoPCM[1]_rec' 'hTFtoPCM[1]' annotation(Dialog);
  protected
    record 'hTFtoPCM[2]_rec'
      parameter Modelica.SIunits.Volume vol(fixed=false)
                                                        "Volume of element";
      parameter Integer nCoilp(fixed=false)
                                           "number of horizontally parallel coils";
      constant Modelica.SIunits.Temperature T_Tube_start = 263.15
                                                                 "Start temperature of the tube";
    protected
      record HTFtoTube_rec
        Modelica.SIunits.HeatFlowRate Q_flow
                                            "Heat flow rate from port_a -> port_b";
        Modelica.SIunits.TemperatureDifference dT
                                                 "port_a.T - port_b.T";
      protected
        record port_a_rec
          Modelica.SIunits.Temperature T
                                        "Port temperature";
          Modelica.SIunits.HeatFlowRate Q_flow
                                              "Heat flow rate (positive if flowing from outside into the component)";
        end port_a_rec;
      public
        port_a_rec port_a;
      protected
        record port_b_rec
          Modelica.SIunits.Temperature T
                                        "Port temperature";
          Modelica.SIunits.HeatFlowRate Q_flow
                                              "Heat flow rate (positive if flowing from outside into the component)";
        end port_b_rec;
      public
        port_b_rec port_b;
        Modelica_Blocks_Interfaces_RealInput G(unit = "W/K")
                                                            "Constant thermal conductance of material";
      end HTFtoTube_rec;
    public
      HTFtoTube_rec HTFtoTube;
    protected
      record TubetoPCM_rec
        Modelica.SIunits.HeatFlowRate Q_flow
                                            "Heat flow rate from port_a -> port_b";
        Modelica.SIunits.TemperatureDifference dT
                                                 "port_a.T - port_b.T";
      protected
        record port_a_rec
          Modelica.SIunits.Temperature T
                                        "Port temperature";
          Modelica.SIunits.HeatFlowRate Q_flow
                                              "Heat flow rate (positive if flowing from outside into the component)";
        end port_a_rec;
      public
        port_a_rec port_a;
      protected
        record port_b_rec
          Modelica.SIunits.Temperature T
                                        "Port temperature";
          Modelica.SIunits.HeatFlowRate Q_flow
                                              "Heat flow rate (positive if flowing from outside into the component)";
        end port_b_rec;
      public
        port_b_rec port_b;
        Modelica_Blocks_Interfaces_RealInput G(unit = "W/K")
                                                            "Constant thermal conductance of material";
      end TubetoPCM_rec;
    public
      TubetoPCM_rec TubetoPCM;
    protected
      record TubeInertia_rec
        parameter Modelica.SIunits.Temperature _T_start = 263.15;
        Modelica.SIunits.Temperature T(start = _T_start)
                                                        "Temperature of element";
        Real T_der(unit = "K/s")
                                "der(Temperature of element)";
        Modelica.SIunits.HeatFlowRate Q_flow;
        parameter Modelica.SIunits.Temperature T_start = 293.15
                                                               "Start temperature for the average temperature of ellement";
      protected
        record port_rec
          Modelica.SIunits.Temperature T
                                        "Port temperature";
          Modelica.SIunits.HeatFlowRate Q_flow
                                              "Heat flow rate (positive if flowing from outside into the component)";
        end port_rec;
      public
        port_rec port;
        parameter Modelica.SIunits.Volume V(fixed=false)
                                                        "Volume of element";
        parameter Modelica.SIunits.Mass m(fixed=false)
                                                      "Mass of element";
        Modelica.SIunits.TemperatureSlope der_T
                                               "Time derivative of temperature (= der(T))";
        Modelica.SIunits.HeatCapacity C
                                       "Heat capacity of element (= cp*m)";
        parameter Modelica.SIunits.TemperatureSlope der_T_start = 0
                                                                   "Start value ofime derivative of temperature (= der(T))";
      end TubeInertia_rec;
    public
      TubeInertia_rec TubeInertia annotation(Dialog);
    protected
      record port_b_rec
        Modelica.SIunits.Temperature T
                                      "Port temperature";
        Modelica.SIunits.HeatFlowRate Q_flow
                                            "Heat flow rate (positive if flowing from outside into the component)";
      end port_b_rec;
    public
      port_b_rec port_b;
    protected
      record port_a_rec
        Modelica.SIunits.Temperature T
                                      "Port temperature";
        Modelica.SIunits.HeatFlowRate Q_flow
                                            "Heat flow rate (positive if flowing from outside into the component)";
      end port_a_rec;
    public
      port_a_rec port_a;
      Modelica_Blocks_Interfaces_RealInput G_HTFtoTube;
      Modelica_Blocks_Interfaces_RealInput G_TubetoPCM;
    end 'hTFtoPCM[2]_rec';
  public
    'hTFtoPCM[2]_rec' 'hTFtoPCM[2]' annotation(Dialog);
  protected
    record 'hTFtoPCM[3]_rec'
      parameter Modelica.SIunits.Volume vol(fixed=false)
                                                        "Volume of element";
      parameter Integer nCoilp(fixed=false)
                                           "number of horizontally parallel coils";
      constant Modelica.SIunits.Temperature T_Tube_start = 263.15
                                                                 "Start temperature of the tube";
    protected
      record HTFtoTube_rec
        Modelica.SIunits.HeatFlowRate Q_flow
                                            "Heat flow rate from port_a -> port_b";
        Modelica.SIunits.TemperatureDifference dT
                                                 "port_a.T - port_b.T";
      protected
        record port_a_rec
          Modelica.SIunits.Temperature T
                                        "Port temperature";
          Modelica.SIunits.HeatFlowRate Q_flow
                                              "Heat flow rate (positive if flowing from outside into the component)";
        end port_a_rec;
      public
        port_a_rec port_a;
      protected
        record port_b_rec
          Modelica.SIunits.Temperature T
                                        "Port temperature";
          Modelica.SIunits.HeatFlowRate Q_flow
                                              "Heat flow rate (positive if flowing from outside into the component)";
        end port_b_rec;
      public
        port_b_rec port_b;
        Modelica_Blocks_Interfaces_RealInput G(unit = "W/K")
                                                            "Constant thermal conductance of material";
      end HTFtoTube_rec;
    public
      HTFtoTube_rec HTFtoTube;
    protected
      record TubetoPCM_rec
        Modelica.SIunits.HeatFlowRate Q_flow
                                            "Heat flow rate from port_a -> port_b";
        Modelica.SIunits.TemperatureDifference dT
                                                 "port_a.T - port_b.T";
      protected
        record port_a_rec
          Modelica.SIunits.Temperature T
                                        "Port temperature";
          Modelica.SIunits.HeatFlowRate Q_flow
                                              "Heat flow rate (positive if flowing from outside into the component)";
        end port_a_rec;
      public
        port_a_rec port_a;
      protected
        record port_b_rec
          Modelica.SIunits.Temperature T
                                        "Port temperature";
          Modelica.SIunits.HeatFlowRate Q_flow
                                              "Heat flow rate (positive if flowing from outside into the component)";
        end port_b_rec;
      public
        port_b_rec port_b;
        Modelica_Blocks_Interfaces_RealInput G(unit = "W/K")
                                                            "Constant thermal conductance of material";
      end TubetoPCM_rec;
    public
      TubetoPCM_rec TubetoPCM;
    protected
      record TubeInertia_rec
        parameter Modelica.SIunits.Temperature _T_start = 263.15;
        Modelica.SIunits.Temperature T(start = _T_start)
                                                        "Temperature of element";
        Real T_der(unit = "K/s")
                                "der(Temperature of element)";
        Modelica.SIunits.HeatFlowRate Q_flow;
        parameter Modelica.SIunits.Temperature T_start = 293.15
                                                               "Start temperature for the average temperature of ellement";
      protected
        record port_rec
          Modelica.SIunits.Temperature T
                                        "Port temperature";
          Modelica.SIunits.HeatFlowRate Q_flow
                                              "Heat flow rate (positive if flowing from outside into the component)";
        end port_rec;
      public
        port_rec port;
        parameter Modelica.SIunits.Volume V(fixed=false)
                                                        "Volume of element";
        parameter Modelica.SIunits.Mass m(fixed=false)
                                                      "Mass of element";
        Modelica.SIunits.TemperatureSlope der_T
                                               "Time derivative of temperature (= der(T))";
        Modelica.SIunits.HeatCapacity C
                                       "Heat capacity of element (= cp*m)";
        parameter Modelica.SIunits.TemperatureSlope der_T_start = 0
                                                                   "Start value ofime derivative of temperature (= der(T))";
      end TubeInertia_rec;
    public
      TubeInertia_rec TubeInertia annotation(Dialog);
    protected
      record port_b_rec
        Modelica.SIunits.Temperature T
                                      "Port temperature";
        Modelica.SIunits.HeatFlowRate Q_flow
                                            "Heat flow rate (positive if flowing from outside into the component)";
      end port_b_rec;
    public
      port_b_rec port_b;
    protected
      record port_a_rec
        Modelica.SIunits.Temperature T
                                      "Port temperature";
        Modelica.SIunits.HeatFlowRate Q_flow
                                            "Heat flow rate (positive if flowing from outside into the component)";
      end port_a_rec;
    public
      port_a_rec port_a;
      Modelica_Blocks_Interfaces_RealInput G_HTFtoTube;
      Modelica_Blocks_Interfaces_RealInput G_TubetoPCM;
    end 'hTFtoPCM[3]_rec';
  public
    'hTFtoPCM[3]_rec' 'hTFtoPCM[3]' annotation(Dialog);
  protected
    record 'hTFtoPCM[4]_rec'
      parameter Modelica.SIunits.Volume vol(fixed=false)
                                                        "Volume of element";
      parameter Integer nCoilp(fixed=false)
                                           "number of horizontally parallel coils";
      constant Modelica.SIunits.Temperature T_Tube_start = 263.15
                                                                 "Start temperature of the tube";
    protected
      record HTFtoTube_rec
        Modelica.SIunits.HeatFlowRate Q_flow
                                            "Heat flow rate from port_a -> port_b";
        Modelica.SIunits.TemperatureDifference dT
                                                 "port_a.T - port_b.T";
      protected
        record port_a_rec
          Modelica.SIunits.Temperature T
                                        "Port temperature";
          Modelica.SIunits.HeatFlowRate Q_flow
                                              "Heat flow rate (positive if flowing from outside into the component)";
        end port_a_rec;
      public
        port_a_rec port_a;
      protected
        record port_b_rec
          Modelica.SIunits.Temperature T
                                        "Port temperature";
          Modelica.SIunits.HeatFlowRate Q_flow
                                              "Heat flow rate (positive if flowing from outside into the component)";
        end port_b_rec;
      public
        port_b_rec port_b;
        Modelica_Blocks_Interfaces_RealInput G(unit = "W/K")
                                                            "Constant thermal conductance of material";
      end HTFtoTube_rec;
    public
      HTFtoTube_rec HTFtoTube;
    protected
      record TubetoPCM_rec
        Modelica.SIunits.HeatFlowRate Q_flow
                                            "Heat flow rate from port_a -> port_b";
        Modelica.SIunits.TemperatureDifference dT
                                                 "port_a.T - port_b.T";
      protected
        record port_a_rec
          Modelica.SIunits.Temperature T
                                        "Port temperature";
          Modelica.SIunits.HeatFlowRate Q_flow
                                              "Heat flow rate (positive if flowing from outside into the component)";
        end port_a_rec;
      public
        port_a_rec port_a;
      protected
        record port_b_rec
          Modelica.SIunits.Temperature T
                                        "Port temperature";
          Modelica.SIunits.HeatFlowRate Q_flow
                                              "Heat flow rate (positive if flowing from outside into the component)";
        end port_b_rec;
      public
        port_b_rec port_b;
        Modelica_Blocks_Interfaces_RealInput G(unit = "W/K")
                                                            "Constant thermal conductance of material";
      end TubetoPCM_rec;
    public
      TubetoPCM_rec TubetoPCM;
    protected
      record TubeInertia_rec
        parameter Modelica.SIunits.Temperature _T_start = 263.15;
        Modelica.SIunits.Temperature T(start = _T_start)
                                                        "Temperature of element";
        Real T_der(unit = "K/s")
                                "der(Temperature of element)";
        Modelica.SIunits.HeatFlowRate Q_flow;
        parameter Modelica.SIunits.Temperature T_start = 293.15
                                                               "Start temperature for the average temperature of ellement";
      protected
        record port_rec
          Modelica.SIunits.Temperature T
                                        "Port temperature";
          Modelica.SIunits.HeatFlowRate Q_flow
                                              "Heat flow rate (positive if flowing from outside into the component)";
        end port_rec;
      public
        port_rec port;
        parameter Modelica.SIunits.Volume V(fixed=false)
                                                        "Volume of element";
        parameter Modelica.SIunits.Mass m(fixed=false)
                                                      "Mass of element";
        Modelica.SIunits.TemperatureSlope der_T
                                               "Time derivative of temperature (= der(T))";
        Modelica.SIunits.HeatCapacity C
                                       "Heat capacity of element (= cp*m)";
        parameter Modelica.SIunits.TemperatureSlope der_T_start = 0
                                                                   "Start value ofime derivative of temperature (= der(T))";
      end TubeInertia_rec;
    public
      TubeInertia_rec TubeInertia annotation(Dialog);
    protected
      record port_b_rec
        Modelica.SIunits.Temperature T
                                      "Port temperature";
        Modelica.SIunits.HeatFlowRate Q_flow
                                            "Heat flow rate (positive if flowing from outside into the component)";
      end port_b_rec;
    public
      port_b_rec port_b;
    protected
      record port_a_rec
        Modelica.SIunits.Temperature T
                                      "Port temperature";
        Modelica.SIunits.HeatFlowRate Q_flow
                                            "Heat flow rate (positive if flowing from outside into the component)";
      end port_a_rec;
    public
      port_a_rec port_a;
      Modelica_Blocks_Interfaces_RealInput G_HTFtoTube;
      Modelica_Blocks_Interfaces_RealInput G_TubetoPCM;
    end 'hTFtoPCM[4]_rec';
  public
    'hTFtoPCM[4]_rec' 'hTFtoPCM[4]' annotation(Dialog);
  protected
    record 'hTFtoPCM[5]_rec'
      parameter Modelica.SIunits.Volume vol(fixed=false)
                                                        "Volume of element";
      parameter Integer nCoilp(fixed=false)
                                           "number of horizontally parallel coils";
      constant Modelica.SIunits.Temperature T_Tube_start = 263.15
                                                                 "Start temperature of the tube";
    protected
      record HTFtoTube_rec
        Modelica.SIunits.HeatFlowRate Q_flow
                                            "Heat flow rate from port_a -> port_b";
        Modelica.SIunits.TemperatureDifference dT
                                                 "port_a.T - port_b.T";
      protected
        record port_a_rec
          Modelica.SIunits.Temperature T
                                        "Port temperature";
          Modelica.SIunits.HeatFlowRate Q_flow
                                              "Heat flow rate (positive if flowing from outside into the component)";
        end port_a_rec;
      public
        port_a_rec port_a;
      protected
        record port_b_rec
          Modelica.SIunits.Temperature T
                                        "Port temperature";
          Modelica.SIunits.HeatFlowRate Q_flow
                                              "Heat flow rate (positive if flowing from outside into the component)";
        end port_b_rec;
      public
        port_b_rec port_b;
        Modelica_Blocks_Interfaces_RealInput G(unit = "W/K")
                                                            "Constant thermal conductance of material";
      end HTFtoTube_rec;
    public
      HTFtoTube_rec HTFtoTube;
    protected
      record TubetoPCM_rec
        Modelica.SIunits.HeatFlowRate Q_flow
                                            "Heat flow rate from port_a -> port_b";
        Modelica.SIunits.TemperatureDifference dT
                                                 "port_a.T - port_b.T";
      protected
        record port_a_rec
          Modelica.SIunits.Temperature T
                                        "Port temperature";
          Modelica.SIunits.HeatFlowRate Q_flow
                                              "Heat flow rate (positive if flowing from outside into the component)";
        end port_a_rec;
      public
        port_a_rec port_a;
      protected
        record port_b_rec
          Modelica.SIunits.Temperature T
                                        "Port temperature";
          Modelica.SIunits.HeatFlowRate Q_flow
                                              "Heat flow rate (positive if flowing from outside into the component)";
        end port_b_rec;
      public
        port_b_rec port_b;
        Modelica_Blocks_Interfaces_RealInput G(unit = "W/K")
                                                            "Constant thermal conductance of material";
      end TubetoPCM_rec;
    public
      TubetoPCM_rec TubetoPCM;
    protected
      record TubeInertia_rec
        parameter Modelica.SIunits.Temperature _T_start = 263.15;
        Modelica.SIunits.Temperature T(start = _T_start)
                                                        "Temperature of element";
        Real T_der(unit = "K/s")
                                "der(Temperature of element)";
        Modelica.SIunits.HeatFlowRate Q_flow;
        parameter Modelica.SIunits.Temperature T_start = 293.15
                                                               "Start temperature for the average temperature of ellement";
      protected
        record port_rec
          Modelica.SIunits.Temperature T
                                        "Port temperature";
          Modelica.SIunits.HeatFlowRate Q_flow
                                              "Heat flow rate (positive if flowing from outside into the component)";
        end port_rec;
      public
        port_rec port;
        parameter Modelica.SIunits.Volume V(fixed=false)
                                                        "Volume of element";
        parameter Modelica.SIunits.Mass m(fixed=false)
                                                      "Mass of element";
        Modelica.SIunits.TemperatureSlope der_T
                                               "Time derivative of temperature (= der(T))";
        Modelica.SIunits.HeatCapacity C
                                       "Heat capacity of element (= cp*m)";
        parameter Modelica.SIunits.TemperatureSlope der_T_start = 0
                                                                   "Start value ofime derivative of temperature (= der(T))";
      end TubeInertia_rec;
    public
      TubeInertia_rec TubeInertia annotation(Dialog);
    protected
      record port_b_rec
        Modelica.SIunits.Temperature T
                                      "Port temperature";
        Modelica.SIunits.HeatFlowRate Q_flow
                                            "Heat flow rate (positive if flowing from outside into the component)";
      end port_b_rec;
    public
      port_b_rec port_b;
    protected
      record port_a_rec
        Modelica.SIunits.Temperature T
                                      "Port temperature";
        Modelica.SIunits.HeatFlowRate Q_flow
                                            "Heat flow rate (positive if flowing from outside into the component)";
      end port_a_rec;
    public
      port_a_rec port_a;
      Modelica_Blocks_Interfaces_RealInput G_HTFtoTube;
      Modelica_Blocks_Interfaces_RealInput G_TubetoPCM;
    end 'hTFtoPCM[5]_rec';
  public
    'hTFtoPCM[5]_rec' 'hTFtoPCM[5]' annotation(Dialog);
  protected
    record 'hTFtoPCM[6]_rec'
      parameter Modelica.SIunits.Volume vol(fixed=false)
                                                        "Volume of element";
      parameter Integer nCoilp(fixed=false)
                                           "number of horizontally parallel coils";
      constant Modelica.SIunits.Temperature T_Tube_start = 263.15
                                                                 "Start temperature of the tube";
    protected
      record HTFtoTube_rec
        Modelica.SIunits.HeatFlowRate Q_flow
                                            "Heat flow rate from port_a -> port_b";
        Modelica.SIunits.TemperatureDifference dT
                                                 "port_a.T - port_b.T";
      protected
        record port_a_rec
          Modelica.SIunits.Temperature T
                                        "Port temperature";
          Modelica.SIunits.HeatFlowRate Q_flow
                                              "Heat flow rate (positive if flowing from outside into the component)";
        end port_a_rec;
      public
        port_a_rec port_a;
      protected
        record port_b_rec
          Modelica.SIunits.Temperature T
                                        "Port temperature";
          Modelica.SIunits.HeatFlowRate Q_flow
                                              "Heat flow rate (positive if flowing from outside into the component)";
        end port_b_rec;
      public
        port_b_rec port_b;
        Modelica_Blocks_Interfaces_RealInput G(unit = "W/K")
                                                            "Constant thermal conductance of material";
      end HTFtoTube_rec;
    public
      HTFtoTube_rec HTFtoTube;
    protected
      record TubetoPCM_rec
        Modelica.SIunits.HeatFlowRate Q_flow
                                            "Heat flow rate from port_a -> port_b";
        Modelica.SIunits.TemperatureDifference dT
                                                 "port_a.T - port_b.T";
      protected
        record port_a_rec
          Modelica.SIunits.Temperature T
                                        "Port temperature";
          Modelica.SIunits.HeatFlowRate Q_flow
                                              "Heat flow rate (positive if flowing from outside into the component)";
        end port_a_rec;
      public
        port_a_rec port_a;
      protected
        record port_b_rec
          Modelica.SIunits.Temperature T
                                        "Port temperature";
          Modelica.SIunits.HeatFlowRate Q_flow
                                              "Heat flow rate (positive if flowing from outside into the component)";
        end port_b_rec;
      public
        port_b_rec port_b;
        Modelica_Blocks_Interfaces_RealInput G(unit = "W/K")
                                                            "Constant thermal conductance of material";
      end TubetoPCM_rec;
    public
      TubetoPCM_rec TubetoPCM;
    protected
      record TubeInertia_rec
        parameter Modelica.SIunits.Temperature _T_start = 263.15;
        Modelica.SIunits.Temperature T(start = _T_start)
                                                        "Temperature of element";
        Real T_der(unit = "K/s")
                                "der(Temperature of element)";
        Modelica.SIunits.HeatFlowRate Q_flow;
        parameter Modelica.SIunits.Temperature T_start = 293.15
                                                               "Start temperature for the average temperature of ellement";
      protected
        record port_rec
          Modelica.SIunits.Temperature T
                                        "Port temperature";
          Modelica.SIunits.HeatFlowRate Q_flow
                                              "Heat flow rate (positive if flowing from outside into the component)";
        end port_rec;
      public
        port_rec port;
        parameter Modelica.SIunits.Volume V(fixed=false)
                                                        "Volume of element";
        parameter Modelica.SIunits.Mass m(fixed=false)
                                                      "Mass of element";
        Modelica.SIunits.TemperatureSlope der_T
                                               "Time derivative of temperature (= der(T))";
        Modelica.SIunits.HeatCapacity C
                                       "Heat capacity of element (= cp*m)";
        parameter Modelica.SIunits.TemperatureSlope der_T_start = 0
                                                                   "Start value ofime derivative of temperature (= der(T))";
      end TubeInertia_rec;
    public
      TubeInertia_rec TubeInertia annotation(Dialog);
    protected
      record port_b_rec
        Modelica.SIunits.Temperature T
                                      "Port temperature";
        Modelica.SIunits.HeatFlowRate Q_flow
                                            "Heat flow rate (positive if flowing from outside into the component)";
      end port_b_rec;
    public
      port_b_rec port_b;
    protected
      record port_a_rec
        Modelica.SIunits.Temperature T
                                      "Port temperature";
        Modelica.SIunits.HeatFlowRate Q_flow
                                            "Heat flow rate (positive if flowing from outside into the component)";
      end port_a_rec;
    public
      port_a_rec port_a;
      Modelica_Blocks_Interfaces_RealInput G_HTFtoTube;
      Modelica_Blocks_Interfaces_RealInput G_TubetoPCM;
    end 'hTFtoPCM[6]_rec';
  public
    'hTFtoPCM[6]_rec' 'hTFtoPCM[6]' annotation(Dialog);
  protected
    record 'hTFtoPCM[7]_rec'
      parameter Modelica.SIunits.Volume vol(fixed=false)
                                                        "Volume of element";
      parameter Integer nCoilp(fixed=false)
                                           "number of horizontally parallel coils";
      constant Modelica.SIunits.Temperature T_Tube_start = 263.15
                                                                 "Start temperature of the tube";
    protected
      record HTFtoTube_rec
        Modelica.SIunits.HeatFlowRate Q_flow
                                            "Heat flow rate from port_a -> port_b";
        Modelica.SIunits.TemperatureDifference dT
                                                 "port_a.T - port_b.T";
      protected
        record port_a_rec
          Modelica.SIunits.Temperature T
                                        "Port temperature";
          Modelica.SIunits.HeatFlowRate Q_flow
                                              "Heat flow rate (positive if flowing from outside into the component)";
        end port_a_rec;
      public
        port_a_rec port_a;
      protected
        record port_b_rec
          Modelica.SIunits.Temperature T
                                        "Port temperature";
          Modelica.SIunits.HeatFlowRate Q_flow
                                              "Heat flow rate (positive if flowing from outside into the component)";
        end port_b_rec;
      public
        port_b_rec port_b;
        Modelica_Blocks_Interfaces_RealInput G(unit = "W/K")
                                                            "Constant thermal conductance of material";
      end HTFtoTube_rec;
    public
      HTFtoTube_rec HTFtoTube;
    protected
      record TubetoPCM_rec
        Modelica.SIunits.HeatFlowRate Q_flow
                                            "Heat flow rate from port_a -> port_b";
        Modelica.SIunits.TemperatureDifference dT
                                                 "port_a.T - port_b.T";
      protected
        record port_a_rec
          Modelica.SIunits.Temperature T
                                        "Port temperature";
          Modelica.SIunits.HeatFlowRate Q_flow
                                              "Heat flow rate (positive if flowing from outside into the component)";
        end port_a_rec;
      public
        port_a_rec port_a;
      protected
        record port_b_rec
          Modelica.SIunits.Temperature T
                                        "Port temperature";
          Modelica.SIunits.HeatFlowRate Q_flow
                                              "Heat flow rate (positive if flowing from outside into the component)";
        end port_b_rec;
      public
        port_b_rec port_b;
        Modelica_Blocks_Interfaces_RealInput G(unit = "W/K")
                                                            "Constant thermal conductance of material";
      end TubetoPCM_rec;
    public
      TubetoPCM_rec TubetoPCM;
    protected
      record TubeInertia_rec
        parameter Modelica.SIunits.Temperature _T_start = 263.15;
        Modelica.SIunits.Temperature T(start = _T_start)
                                                        "Temperature of element";
        Real T_der(unit = "K/s")
                                "der(Temperature of element)";
        Modelica.SIunits.HeatFlowRate Q_flow;
        parameter Modelica.SIunits.Temperature T_start = 293.15
                                                               "Start temperature for the average temperature of ellement";
      protected
        record port_rec
          Modelica.SIunits.Temperature T
                                        "Port temperature";
          Modelica.SIunits.HeatFlowRate Q_flow
                                              "Heat flow rate (positive if flowing from outside into the component)";
        end port_rec;
      public
        port_rec port;
        parameter Modelica.SIunits.Volume V(fixed=false)
                                                        "Volume of element";
        parameter Modelica.SIunits.Mass m(fixed=false)
                                                      "Mass of element";
        Modelica.SIunits.TemperatureSlope der_T
                                               "Time derivative of temperature (= der(T))";
        Modelica.SIunits.HeatCapacity C
                                       "Heat capacity of element (= cp*m)";
        parameter Modelica.SIunits.TemperatureSlope der_T_start = 0
                                                                   "Start value ofime derivative of temperature (= der(T))";
      end TubeInertia_rec;
    public
      TubeInertia_rec TubeInertia annotation(Dialog);
    protected
      record port_b_rec
        Modelica.SIunits.Temperature T
                                      "Port temperature";
        Modelica.SIunits.HeatFlowRate Q_flow
                                            "Heat flow rate (positive if flowing from outside into the component)";
      end port_b_rec;
    public
      port_b_rec port_b;
    protected
      record port_a_rec
        Modelica.SIunits.Temperature T
                                      "Port temperature";
        Modelica.SIunits.HeatFlowRate Q_flow
                                            "Heat flow rate (positive if flowing from outside into the component)";
      end port_a_rec;
    public
      port_a_rec port_a;
      Modelica_Blocks_Interfaces_RealInput G_HTFtoTube;
      Modelica_Blocks_Interfaces_RealInput G_TubetoPCM;
    end 'hTFtoPCM[7]_rec';
  public
    'hTFtoPCM[7]_rec' 'hTFtoPCM[7]' annotation(Dialog);
  protected
    record 'hTFtoPCM[8]_rec'
      parameter Modelica.SIunits.Volume vol(fixed=false)
                                                        "Volume of element";
      parameter Integer nCoilp(fixed=false)
                                           "number of horizontally parallel coils";
      constant Modelica.SIunits.Temperature T_Tube_start = 263.15
                                                                 "Start temperature of the tube";
    protected
      record HTFtoTube_rec
        Modelica.SIunits.HeatFlowRate Q_flow
                                            "Heat flow rate from port_a -> port_b";
        Modelica.SIunits.TemperatureDifference dT
                                                 "port_a.T - port_b.T";
      protected
        record port_a_rec
          Modelica.SIunits.Temperature T
                                        "Port temperature";
          Modelica.SIunits.HeatFlowRate Q_flow
                                              "Heat flow rate (positive if flowing from outside into the component)";
        end port_a_rec;
      public
        port_a_rec port_a;
      protected
        record port_b_rec
          Modelica.SIunits.Temperature T
                                        "Port temperature";
          Modelica.SIunits.HeatFlowRate Q_flow
                                              "Heat flow rate (positive if flowing from outside into the component)";
        end port_b_rec;
      public
        port_b_rec port_b;
        Modelica_Blocks_Interfaces_RealInput G(unit = "W/K")
                                                            "Constant thermal conductance of material";
      end HTFtoTube_rec;
    public
      HTFtoTube_rec HTFtoTube;
    protected
      record TubetoPCM_rec
        Modelica.SIunits.HeatFlowRate Q_flow
                                            "Heat flow rate from port_a -> port_b";
        Modelica.SIunits.TemperatureDifference dT
                                                 "port_a.T - port_b.T";
      protected
        record port_a_rec
          Modelica.SIunits.Temperature T
                                        "Port temperature";
          Modelica.SIunits.HeatFlowRate Q_flow
                                              "Heat flow rate (positive if flowing from outside into the component)";
        end port_a_rec;
      public
        port_a_rec port_a;
      protected
        record port_b_rec
          Modelica.SIunits.Temperature T
                                        "Port temperature";
          Modelica.SIunits.HeatFlowRate Q_flow
                                              "Heat flow rate (positive if flowing from outside into the component)";
        end port_b_rec;
      public
        port_b_rec port_b;
        Modelica_Blocks_Interfaces_RealInput G(unit = "W/K")
                                                            "Constant thermal conductance of material";
      end TubetoPCM_rec;
    public
      TubetoPCM_rec TubetoPCM;
    protected
      record TubeInertia_rec
        parameter Modelica.SIunits.Temperature _T_start = 263.15;
        Modelica.SIunits.Temperature T(start = _T_start)
                                                        "Temperature of element";
        Real T_der(unit = "K/s")
                                "der(Temperature of element)";
        Modelica.SIunits.HeatFlowRate Q_flow;
        parameter Modelica.SIunits.Temperature T_start = 293.15
                                                               "Start temperature for the average temperature of ellement";
      protected
        record port_rec
          Modelica.SIunits.Temperature T
                                        "Port temperature";
          Modelica.SIunits.HeatFlowRate Q_flow
                                              "Heat flow rate (positive if flowing from outside into the component)";
        end port_rec;
      public
        port_rec port;
        parameter Modelica.SIunits.Volume V(fixed=false)
                                                        "Volume of element";
        parameter Modelica.SIunits.Mass m(fixed=false)
                                                      "Mass of element";
        Modelica.SIunits.TemperatureSlope der_T
                                               "Time derivative of temperature (= der(T))";
        Modelica.SIunits.HeatCapacity C
                                       "Heat capacity of element (= cp*m)";
        parameter Modelica.SIunits.TemperatureSlope der_T_start = 0
                                                                   "Start value ofime derivative of temperature (= der(T))";
      end TubeInertia_rec;
    public
      TubeInertia_rec TubeInertia annotation(Dialog);
    protected
      record port_b_rec
        Modelica.SIunits.Temperature T
                                      "Port temperature";
        Modelica.SIunits.HeatFlowRate Q_flow
                                            "Heat flow rate (positive if flowing from outside into the component)";
      end port_b_rec;
    public
      port_b_rec port_b;
    protected
      record port_a_rec
        Modelica.SIunits.Temperature T
                                      "Port temperature";
        Modelica.SIunits.HeatFlowRate Q_flow
                                            "Heat flow rate (positive if flowing from outside into the component)";
      end port_a_rec;
    public
      port_a_rec port_a;
      Modelica_Blocks_Interfaces_RealInput G_HTFtoTube;
      Modelica_Blocks_Interfaces_RealInput G_TubetoPCM;
    end 'hTFtoPCM[8]_rec';
  public
    'hTFtoPCM[8]_rec' 'hTFtoPCM[8]' annotation(Dialog);
  protected
    record 'hTFtoPCM[9]_rec'
      parameter Modelica.SIunits.Volume vol(fixed=false)
                                                        "Volume of element";
      parameter Integer nCoilp(fixed=false)
                                           "number of horizontally parallel coils";
      constant Modelica.SIunits.Temperature T_Tube_start = 263.15
                                                                 "Start temperature of the tube";
    protected
      record HTFtoTube_rec
        Modelica.SIunits.HeatFlowRate Q_flow
                                            "Heat flow rate from port_a -> port_b";
        Modelica.SIunits.TemperatureDifference dT
                                                 "port_a.T - port_b.T";
      protected
        record port_a_rec
          Modelica.SIunits.Temperature T
                                        "Port temperature";
          Modelica.SIunits.HeatFlowRate Q_flow
                                              "Heat flow rate (positive if flowing from outside into the component)";
        end port_a_rec;
      public
        port_a_rec port_a;
      protected
        record port_b_rec
          Modelica.SIunits.Temperature T
                                        "Port temperature";
          Modelica.SIunits.HeatFlowRate Q_flow
                                              "Heat flow rate (positive if flowing from outside into the component)";
        end port_b_rec;
      public
        port_b_rec port_b;
        Modelica_Blocks_Interfaces_RealInput G(unit = "W/K")
                                                            "Constant thermal conductance of material";
      end HTFtoTube_rec;
    public
      HTFtoTube_rec HTFtoTube;
    protected
      record TubetoPCM_rec
        Modelica.SIunits.HeatFlowRate Q_flow
                                            "Heat flow rate from port_a -> port_b";
        Modelica.SIunits.TemperatureDifference dT
                                                 "port_a.T - port_b.T";
      protected
        record port_a_rec
          Modelica.SIunits.Temperature T
                                        "Port temperature";
          Modelica.SIunits.HeatFlowRate Q_flow
                                              "Heat flow rate (positive if flowing from outside into the component)";
        end port_a_rec;
      public
        port_a_rec port_a;
      protected
        record port_b_rec
          Modelica.SIunits.Temperature T
                                        "Port temperature";
          Modelica.SIunits.HeatFlowRate Q_flow
                                              "Heat flow rate (positive if flowing from outside into the component)";
        end port_b_rec;
      public
        port_b_rec port_b;
        Modelica_Blocks_Interfaces_RealInput G(unit = "W/K")
                                                            "Constant thermal conductance of material";
      end TubetoPCM_rec;
    public
      TubetoPCM_rec TubetoPCM;
    protected
      record TubeInertia_rec
        parameter Modelica.SIunits.Temperature _T_start = 263.15;
        Modelica.SIunits.Temperature T(start = _T_start)
                                                        "Temperature of element";
        Real T_der(unit = "K/s")
                                "der(Temperature of element)";
        Modelica.SIunits.HeatFlowRate Q_flow;
        parameter Modelica.SIunits.Temperature T_start = 293.15
                                                               "Start temperature for the average temperature of ellement";
      protected
        record port_rec
          Modelica.SIunits.Temperature T
                                        "Port temperature";
          Modelica.SIunits.HeatFlowRate Q_flow
                                              "Heat flow rate (positive if flowing from outside into the component)";
        end port_rec;
      public
        port_rec port;
        parameter Modelica.SIunits.Volume V(fixed=false)
                                                        "Volume of element";
        parameter Modelica.SIunits.Mass m(fixed=false)
                                                      "Mass of element";
        Modelica.SIunits.TemperatureSlope der_T
                                               "Time derivative of temperature (= der(T))";
        Modelica.SIunits.HeatCapacity C
                                       "Heat capacity of element (= cp*m)";
        parameter Modelica.SIunits.TemperatureSlope der_T_start = 0
                                                                   "Start value ofime derivative of temperature (= der(T))";
      end TubeInertia_rec;
    public
      TubeInertia_rec TubeInertia annotation(Dialog);
    protected
      record port_b_rec
        Modelica.SIunits.Temperature T
                                      "Port temperature";
        Modelica.SIunits.HeatFlowRate Q_flow
                                            "Heat flow rate (positive if flowing from outside into the component)";
      end port_b_rec;
    public
      port_b_rec port_b;
    protected
      record port_a_rec
        Modelica.SIunits.Temperature T
                                      "Port temperature";
        Modelica.SIunits.HeatFlowRate Q_flow
                                            "Heat flow rate (positive if flowing from outside into the component)";
      end port_a_rec;
    public
      port_a_rec port_a;
      Modelica_Blocks_Interfaces_RealInput G_HTFtoTube;
      Modelica_Blocks_Interfaces_RealInput G_TubetoPCM;
    end 'hTFtoPCM[9]_rec';
  public
    'hTFtoPCM[9]_rec' 'hTFtoPCM[9]' annotation(Dialog);
  protected
    record 'hTFtoPCM[10]_rec'
      parameter Modelica.SIunits.Volume vol(fixed=false)
                                                        "Volume of element";
      parameter Integer nCoilp(fixed=false)
                                           "number of horizontally parallel coils";
      constant Modelica.SIunits.Temperature T_Tube_start = 263.15
                                                                 "Start temperature of the tube";
    protected
      record HTFtoTube_rec
        Modelica.SIunits.HeatFlowRate Q_flow
                                            "Heat flow rate from port_a -> port_b";
        Modelica.SIunits.TemperatureDifference dT
                                                 "port_a.T - port_b.T";
      protected
        record port_a_rec
          Modelica.SIunits.Temperature T
                                        "Port temperature";
          Modelica.SIunits.HeatFlowRate Q_flow
                                              "Heat flow rate (positive if flowing from outside into the component)";
        end port_a_rec;
      public
        port_a_rec port_a;
      protected
        record port_b_rec
          Modelica.SIunits.Temperature T
                                        "Port temperature";
          Modelica.SIunits.HeatFlowRate Q_flow
                                              "Heat flow rate (positive if flowing from outside into the component)";
        end port_b_rec;
      public
        port_b_rec port_b;
        Modelica_Blocks_Interfaces_RealInput G(unit = "W/K")
                                                            "Constant thermal conductance of material";
      end HTFtoTube_rec;
    public
      HTFtoTube_rec HTFtoTube;
    protected
      record TubetoPCM_rec
        Modelica.SIunits.HeatFlowRate Q_flow
                                            "Heat flow rate from port_a -> port_b";
        Modelica.SIunits.TemperatureDifference dT
                                                 "port_a.T - port_b.T";
      protected
        record port_a_rec
          Modelica.SIunits.Temperature T
                                        "Port temperature";
          Modelica.SIunits.HeatFlowRate Q_flow
                                              "Heat flow rate (positive if flowing from outside into the component)";
        end port_a_rec;
      public
        port_a_rec port_a;
      protected
        record port_b_rec
          Modelica.SIunits.Temperature T
                                        "Port temperature";
          Modelica.SIunits.HeatFlowRate Q_flow
                                              "Heat flow rate (positive if flowing from outside into the component)";
        end port_b_rec;
      public
        port_b_rec port_b;
        Modelica_Blocks_Interfaces_RealInput G(unit = "W/K")
                                                            "Constant thermal conductance of material";
      end TubetoPCM_rec;
    public
      TubetoPCM_rec TubetoPCM;
    protected
      record TubeInertia_rec
        parameter Modelica.SIunits.Temperature _T_start = 263.15;
        Modelica.SIunits.Temperature T(start = _T_start)
                                                        "Temperature of element";
        Real T_der(unit = "K/s")
                                "der(Temperature of element)";
        Modelica.SIunits.HeatFlowRate Q_flow;
        parameter Modelica.SIunits.Temperature T_start = 293.15
                                                               "Start temperature for the average temperature of ellement";
      protected
        record port_rec
          Modelica.SIunits.Temperature T
                                        "Port temperature";
          Modelica.SIunits.HeatFlowRate Q_flow
                                              "Heat flow rate (positive if flowing from outside into the component)";
        end port_rec;
      public
        port_rec port;
        parameter Modelica.SIunits.Volume V(fixed=false)
                                                        "Volume of element";
        parameter Modelica.SIunits.Mass m(fixed=false)
                                                      "Mass of element";
        Modelica.SIunits.TemperatureSlope der_T
                                               "Time derivative of temperature (= der(T))";
        Modelica.SIunits.HeatCapacity C
                                       "Heat capacity of element (= cp*m)";
        parameter Modelica.SIunits.TemperatureSlope der_T_start = 0
                                                                   "Start value ofime derivative of temperature (= der(T))";
      end TubeInertia_rec;
    public
      TubeInertia_rec TubeInertia annotation(Dialog);
    protected
      record port_b_rec
        Modelica.SIunits.Temperature T
                                      "Port temperature";
        Modelica.SIunits.HeatFlowRate Q_flow
                                            "Heat flow rate (positive if flowing from outside into the component)";
      end port_b_rec;
    public
      port_b_rec port_b;
    protected
      record port_a_rec
        Modelica.SIunits.Temperature T
                                      "Port temperature";
        Modelica.SIunits.HeatFlowRate Q_flow
                                            "Heat flow rate (positive if flowing from outside into the component)";
      end port_a_rec;
    public
      port_a_rec port_a;
      Modelica_Blocks_Interfaces_RealInput G_HTFtoTube;
      Modelica_Blocks_Interfaces_RealInput G_TubetoPCM;
    end 'hTFtoPCM[10]_rec';
  public
    'hTFtoPCM[10]_rec' 'hTFtoPCM[10]' annotation(Dialog);
  protected
    record 'tubeToPCM[1]_rec'
      Modelica_Blocks_Interfaces_RealOutput y
                                             "Value of Real output";
    end 'tubeToPCM[1]_rec';
  public
    'tubeToPCM[1]_rec' 'tubeToPCM[1]';
  protected
    record 'tubeToPCM[2]_rec'
      Modelica_Blocks_Interfaces_RealOutput y
                                             "Value of Real output";
    end 'tubeToPCM[2]_rec';
  public
    'tubeToPCM[2]_rec' 'tubeToPCM[2]';
  protected
    record 'tubeToPCM[3]_rec'
      Modelica_Blocks_Interfaces_RealOutput y
                                             "Value of Real output";
    end 'tubeToPCM[3]_rec';
  public
    'tubeToPCM[3]_rec' 'tubeToPCM[3]';
  protected
    record 'tubeToPCM[4]_rec'
      Modelica_Blocks_Interfaces_RealOutput y
                                             "Value of Real output";
    end 'tubeToPCM[4]_rec';
  public
    'tubeToPCM[4]_rec' 'tubeToPCM[4]';
  protected
    record 'tubeToPCM[5]_rec'
      Modelica_Blocks_Interfaces_RealOutput y
                                             "Value of Real output";
    end 'tubeToPCM[5]_rec';
  public
    'tubeToPCM[5]_rec' 'tubeToPCM[5]';
  protected
    record 'tubeToPCM[6]_rec'
      Modelica_Blocks_Interfaces_RealOutput y
                                             "Value of Real output";
    end 'tubeToPCM[6]_rec';
  public
    'tubeToPCM[6]_rec' 'tubeToPCM[6]';
  protected
    record 'tubeToPCM[7]_rec'
      Modelica_Blocks_Interfaces_RealOutput y
                                             "Value of Real output";
    end 'tubeToPCM[7]_rec';
  public
    'tubeToPCM[7]_rec' 'tubeToPCM[7]';
  protected
    record 'tubeToPCM[8]_rec'
      Modelica_Blocks_Interfaces_RealOutput y
                                             "Value of Real output";
    end 'tubeToPCM[8]_rec';
  public
    'tubeToPCM[8]_rec' 'tubeToPCM[8]';
  protected
    record 'tubeToPCM[9]_rec'
      Modelica_Blocks_Interfaces_RealOutput y
                                             "Value of Real output";
    end 'tubeToPCM[9]_rec';
  public
    'tubeToPCM[9]_rec' 'tubeToPCM[9]';
  protected
    record 'tubeToPCM[10]_rec'
      Modelica_Blocks_Interfaces_RealOutput y
                                             "Value of Real output";
    end 'tubeToPCM[10]_rec';
  public
    'tubeToPCM[10]_rec' 'tubeToPCM[10]';
  protected
    record 'HTFtoTube[1]_rec'
      Modelica_Blocks_Interfaces_RealOutput y
                                             "Value of Real output";
    end 'HTFtoTube[1]_rec';
  public
    'HTFtoTube[1]_rec' 'HTFtoTube[1]';
  protected
    record 'HTFtoTube[2]_rec'
      Modelica_Blocks_Interfaces_RealOutput y
                                             "Value of Real output";
    end 'HTFtoTube[2]_rec';
  public
    'HTFtoTube[2]_rec' 'HTFtoTube[2]';
  protected
    record 'HTFtoTube[3]_rec'
      Modelica_Blocks_Interfaces_RealOutput y
                                             "Value of Real output";
    end 'HTFtoTube[3]_rec';
  public
    'HTFtoTube[3]_rec' 'HTFtoTube[3]';
  protected
    record 'HTFtoTube[4]_rec'
      Modelica_Blocks_Interfaces_RealOutput y
                                             "Value of Real output";
    end 'HTFtoTube[4]_rec';
  public
    'HTFtoTube[4]_rec' 'HTFtoTube[4]';
  protected
    record 'HTFtoTube[5]_rec'
      Modelica_Blocks_Interfaces_RealOutput y
                                             "Value of Real output";
    end 'HTFtoTube[5]_rec';
  public
    'HTFtoTube[5]_rec' 'HTFtoTube[5]';
  protected
    record 'HTFtoTube[6]_rec'
      Modelica_Blocks_Interfaces_RealOutput y
                                             "Value of Real output";
    end 'HTFtoTube[6]_rec';
  public
    'HTFtoTube[6]_rec' 'HTFtoTube[6]';
  protected
    record 'HTFtoTube[7]_rec'
      Modelica_Blocks_Interfaces_RealOutput y
                                             "Value of Real output";
    end 'HTFtoTube[7]_rec';
  public
    'HTFtoTube[7]_rec' 'HTFtoTube[7]';
  protected
    record 'HTFtoTube[8]_rec'
      Modelica_Blocks_Interfaces_RealOutput y
                                             "Value of Real output";
    end 'HTFtoTube[8]_rec';
  public
    'HTFtoTube[8]_rec' 'HTFtoTube[8]';
  protected
    record 'HTFtoTube[9]_rec'
      Modelica_Blocks_Interfaces_RealOutput y
                                             "Value of Real output";
    end 'HTFtoTube[9]_rec';
  public
    'HTFtoTube[9]_rec' 'HTFtoTube[9]';
  protected
    record 'HTFtoTube[10]_rec'
      Modelica_Blocks_Interfaces_RealOutput y
                                             "Value of Real output";
    end 'HTFtoTube[10]_rec';
  public
    'HTFtoTube[10]_rec' 'HTFtoTube[10]';
  protected
    record 'thermalConductor[1]_rec'
      Modelica.SIunits.HeatFlowRate Q_flow
                                          "Heat flow rate from port_a -> port_b";
      Modelica.SIunits.TemperatureDifference dT
                                               "port_a.T - port_b.T";
    protected
      record port_a_rec
        Modelica.SIunits.Temperature T
                                      "Port temperature";
        Modelica.SIunits.HeatFlowRate Q_flow
                                            "Heat flow rate (positive if flowing from outside into the component)";
      end port_a_rec;
    public
      port_a_rec port_a;
    protected
      record port_b_rec
        Modelica.SIunits.Temperature T
                                      "Port temperature";
        Modelica.SIunits.HeatFlowRate Q_flow
                                            "Heat flow rate (positive if flowing from outside into the component)";
      end port_b_rec;
    public
      port_b_rec port_b;
      parameter Modelica.SIunits.ThermalConductance G = 2
                                                         "Constant thermal conductance of material";
    end 'thermalConductor[1]_rec';
  public
    'thermalConductor[1]_rec' 'thermalConductor[1]' annotation(Dialog);
  protected
    record 'thermalConductor[2]_rec'
      Modelica.SIunits.HeatFlowRate Q_flow
                                          "Heat flow rate from port_a -> port_b";
      Modelica.SIunits.TemperatureDifference dT
                                               "port_a.T - port_b.T";
    protected
      record port_a_rec
        Modelica.SIunits.Temperature T
                                      "Port temperature";
        Modelica.SIunits.HeatFlowRate Q_flow
                                            "Heat flow rate (positive if flowing from outside into the component)";
      end port_a_rec;
    public
      port_a_rec port_a;
    protected
      record port_b_rec
        Modelica.SIunits.Temperature T
                                      "Port temperature";
        Modelica.SIunits.HeatFlowRate Q_flow
                                            "Heat flow rate (positive if flowing from outside into the component)";
      end port_b_rec;
    public
      port_b_rec port_b;
      parameter Modelica.SIunits.ThermalConductance G = 2
                                                         "Constant thermal conductance of material";
    end 'thermalConductor[2]_rec';
  public
    'thermalConductor[2]_rec' 'thermalConductor[2]' annotation(Dialog);
  protected
    record 'thermalConductor[3]_rec'
      Modelica.SIunits.HeatFlowRate Q_flow
                                          "Heat flow rate from port_a -> port_b";
      Modelica.SIunits.TemperatureDifference dT
                                               "port_a.T - port_b.T";
    protected
      record port_a_rec
        Modelica.SIunits.Temperature T
                                      "Port temperature";
        Modelica.SIunits.HeatFlowRate Q_flow
                                            "Heat flow rate (positive if flowing from outside into the component)";
      end port_a_rec;
    public
      port_a_rec port_a;
    protected
      record port_b_rec
        Modelica.SIunits.Temperature T
                                      "Port temperature";
        Modelica.SIunits.HeatFlowRate Q_flow
                                            "Heat flow rate (positive if flowing from outside into the component)";
      end port_b_rec;
    public
      port_b_rec port_b;
      parameter Modelica.SIunits.ThermalConductance G = 2
                                                         "Constant thermal conductance of material";
    end 'thermalConductor[3]_rec';
  public
    'thermalConductor[3]_rec' 'thermalConductor[3]' annotation(Dialog);
  protected
    record 'thermalConductor[4]_rec'
      Modelica.SIunits.HeatFlowRate Q_flow
                                          "Heat flow rate from port_a -> port_b";
      Modelica.SIunits.TemperatureDifference dT
                                               "port_a.T - port_b.T";
    protected
      record port_a_rec
        Modelica.SIunits.Temperature T
                                      "Port temperature";
        Modelica.SIunits.HeatFlowRate Q_flow
                                            "Heat flow rate (positive if flowing from outside into the component)";
      end port_a_rec;
    public
      port_a_rec port_a;
    protected
      record port_b_rec
        Modelica.SIunits.Temperature T
                                      "Port temperature";
        Modelica.SIunits.HeatFlowRate Q_flow
                                            "Heat flow rate (positive if flowing from outside into the component)";
      end port_b_rec;
    public
      port_b_rec port_b;
      parameter Modelica.SIunits.ThermalConductance G = 2
                                                         "Constant thermal conductance of material";
    end 'thermalConductor[4]_rec';
  public
    'thermalConductor[4]_rec' 'thermalConductor[4]' annotation(Dialog);
  protected
    record 'thermalConductor[5]_rec'
      Modelica.SIunits.HeatFlowRate Q_flow
                                          "Heat flow rate from port_a -> port_b";
      Modelica.SIunits.TemperatureDifference dT
                                               "port_a.T - port_b.T";
    protected
      record port_a_rec
        Modelica.SIunits.Temperature T
                                      "Port temperature";
        Modelica.SIunits.HeatFlowRate Q_flow
                                            "Heat flow rate (positive if flowing from outside into the component)";
      end port_a_rec;
    public
      port_a_rec port_a;
    protected
      record port_b_rec
        Modelica.SIunits.Temperature T
                                      "Port temperature";
        Modelica.SIunits.HeatFlowRate Q_flow
                                            "Heat flow rate (positive if flowing from outside into the component)";
      end port_b_rec;
    public
      port_b_rec port_b;
      parameter Modelica.SIunits.ThermalConductance G = 2
                                                         "Constant thermal conductance of material";
    end 'thermalConductor[5]_rec';
  public
    'thermalConductor[5]_rec' 'thermalConductor[5]' annotation(Dialog);
  protected
    record 'thermalConductor[6]_rec'
      Modelica.SIunits.HeatFlowRate Q_flow
                                          "Heat flow rate from port_a -> port_b";
      Modelica.SIunits.TemperatureDifference dT
                                               "port_a.T - port_b.T";
    protected
      record port_a_rec
        Modelica.SIunits.Temperature T
                                      "Port temperature";
        Modelica.SIunits.HeatFlowRate Q_flow
                                            "Heat flow rate (positive if flowing from outside into the component)";
      end port_a_rec;
    public
      port_a_rec port_a;
    protected
      record port_b_rec
        Modelica.SIunits.Temperature T
                                      "Port temperature";
        Modelica.SIunits.HeatFlowRate Q_flow
                                            "Heat flow rate (positive if flowing from outside into the component)";
      end port_b_rec;
    public
      port_b_rec port_b;
      parameter Modelica.SIunits.ThermalConductance G = 2
                                                         "Constant thermal conductance of material";
    end 'thermalConductor[6]_rec';
  public
    'thermalConductor[6]_rec' 'thermalConductor[6]' annotation(Dialog);
  protected
    record 'thermalConductor[7]_rec'
      Modelica.SIunits.HeatFlowRate Q_flow
                                          "Heat flow rate from port_a -> port_b";
      Modelica.SIunits.TemperatureDifference dT
                                               "port_a.T - port_b.T";
    protected
      record port_a_rec
        Modelica.SIunits.Temperature T
                                      "Port temperature";
        Modelica.SIunits.HeatFlowRate Q_flow
                                            "Heat flow rate (positive if flowing from outside into the component)";
      end port_a_rec;
    public
      port_a_rec port_a;
    protected
      record port_b_rec
        Modelica.SIunits.Temperature T
                                      "Port temperature";
        Modelica.SIunits.HeatFlowRate Q_flow
                                            "Heat flow rate (positive if flowing from outside into the component)";
      end port_b_rec;
    public
      port_b_rec port_b;
      parameter Modelica.SIunits.ThermalConductance G = 2
                                                         "Constant thermal conductance of material";
    end 'thermalConductor[7]_rec';
  public
    'thermalConductor[7]_rec' 'thermalConductor[7]' annotation(Dialog);
  protected
    record 'thermalConductor[8]_rec'
      Modelica.SIunits.HeatFlowRate Q_flow
                                          "Heat flow rate from port_a -> port_b";
      Modelica.SIunits.TemperatureDifference dT
                                               "port_a.T - port_b.T";
    protected
      record port_a_rec
        Modelica.SIunits.Temperature T
                                      "Port temperature";
        Modelica.SIunits.HeatFlowRate Q_flow
                                            "Heat flow rate (positive if flowing from outside into the component)";
      end port_a_rec;
    public
      port_a_rec port_a;
    protected
      record port_b_rec
        Modelica.SIunits.Temperature T
                                      "Port temperature";
        Modelica.SIunits.HeatFlowRate Q_flow
                                            "Heat flow rate (positive if flowing from outside into the component)";
      end port_b_rec;
    public
      port_b_rec port_b;
      parameter Modelica.SIunits.ThermalConductance G = 2
                                                         "Constant thermal conductance of material";
    end 'thermalConductor[8]_rec';
  public
    'thermalConductor[8]_rec' 'thermalConductor[8]' annotation(Dialog);
  protected
    record 'thermalConductor[9]_rec'
      Modelica.SIunits.HeatFlowRate Q_flow
                                          "Heat flow rate from port_a -> port_b";
      Modelica.SIunits.TemperatureDifference dT
                                               "port_a.T - port_b.T";
    protected
      record port_a_rec
        Modelica.SIunits.Temperature T
                                      "Port temperature";
        Modelica.SIunits.HeatFlowRate Q_flow
                                            "Heat flow rate (positive if flowing from outside into the component)";
      end port_a_rec;
    public
      port_a_rec port_a;
    protected
      record port_b_rec
        Modelica.SIunits.Temperature T
                                      "Port temperature";
        Modelica.SIunits.HeatFlowRate Q_flow
                                            "Heat flow rate (positive if flowing from outside into the component)";
      end port_b_rec;
    public
      port_b_rec port_b;
      parameter Modelica.SIunits.ThermalConductance G = 2
                                                         "Constant thermal conductance of material";
    end 'thermalConductor[9]_rec';
  public
    'thermalConductor[9]_rec' 'thermalConductor[9]' annotation(Dialog);
  protected
    record 'thermalConductor[10]_rec'
      Modelica.SIunits.HeatFlowRate Q_flow
                                          "Heat flow rate from port_a -> port_b";
      Modelica.SIunits.TemperatureDifference dT
                                               "port_a.T - port_b.T";
    protected
      record port_a_rec
        Modelica.SIunits.Temperature T
                                      "Port temperature";
        Modelica.SIunits.HeatFlowRate Q_flow
                                            "Heat flow rate (positive if flowing from outside into the component)";
      end port_a_rec;
    public
      port_a_rec port_a;
    protected
      record port_b_rec
        Modelica.SIunits.Temperature T
                                      "Port temperature";
        Modelica.SIunits.HeatFlowRate Q_flow
                                            "Heat flow rate (positive if flowing from outside into the component)";
      end port_b_rec;
    public
      port_b_rec port_b;
      parameter Modelica.SIunits.ThermalConductance G = 2
                                                         "Constant thermal conductance of material";
    end 'thermalConductor[10]_rec';
  public
    'thermalConductor[10]_rec' 'thermalConductor[10]' annotation(Dialog);
    Modelica_IK4_TEKNIKER_DCOL_ThermalStorage_LatentStorages_FMI_RealConectors_RealTemperatureOutput PCM_T
                                                                                                          "Temperature of the PCM";
    Modelica.SIunits.ThermalConductivity 'k_tube[1]'
                                                    "Thermal conductivity of the tube";
    Modelica.SIunits.ThermalConductivity 'k_tube[2]'
                                                    "Thermal conductivity of the tube";
    Modelica.SIunits.ThermalConductivity 'k_tube[3]'
                                                    "Thermal conductivity of the tube";
    Modelica.SIunits.ThermalConductivity 'k_tube[4]'
                                                    "Thermal conductivity of the tube";
    Modelica.SIunits.ThermalConductivity 'k_tube[5]'
                                                    "Thermal conductivity of the tube";
    Modelica.SIunits.ThermalConductivity 'k_tube[6]'
                                                    "Thermal conductivity of the tube";
    Modelica.SIunits.ThermalConductivity 'k_tube[7]'
                                                    "Thermal conductivity of the tube";
    Modelica.SIunits.ThermalConductivity 'k_tube[8]'
                                                    "Thermal conductivity of the tube";
    Modelica.SIunits.ThermalConductivity 'k_tube[9]'
                                                    "Thermal conductivity of the tube";
    Modelica.SIunits.ThermalConductivity 'k_tube[10]'
                                                     "Thermal conductivity of the tube";
    Modelica.SIunits.MassFraction x_liquid_Total
                                                "Total liquid mass fraction";
    Modelica.SIunits.CoefficientOfHeatTransfer 'U_in[1]'
                                                        "Heat transfer coeficient";
    Modelica.SIunits.CoefficientOfHeatTransfer 'U_in[2]'
                                                        "Heat transfer coeficient";
    Modelica.SIunits.CoefficientOfHeatTransfer 'U_in[3]'
                                                        "Heat transfer coeficient";
    Modelica.SIunits.CoefficientOfHeatTransfer 'U_in[4]'
                                                        "Heat transfer coeficient";
    Modelica.SIunits.CoefficientOfHeatTransfer 'U_in[5]'
                                                        "Heat transfer coeficient";
    Modelica.SIunits.CoefficientOfHeatTransfer 'U_in[6]'
                                                        "Heat transfer coeficient";
    Modelica.SIunits.CoefficientOfHeatTransfer 'U_in[7]'
                                                        "Heat transfer coeficient";
    Modelica.SIunits.CoefficientOfHeatTransfer 'U_in[8]'
                                                        "Heat transfer coeficient";
    Modelica.SIunits.CoefficientOfHeatTransfer 'U_in[9]'
                                                        "Heat transfer coeficient";
    Modelica.SIunits.CoefficientOfHeatTransfer 'U_in[10]'
                                                         "Heat transfer coeficient";
    Modelica.SIunits.CoefficientOfHeatTransfer 'U_out[1]'
                                                         "Heat transfer coeficient";
    Modelica.SIunits.CoefficientOfHeatTransfer 'U_out[2]'
                                                         "Heat transfer coeficient";
    Modelica.SIunits.CoefficientOfHeatTransfer 'U_out[3]'
                                                         "Heat transfer coeficient";
    Modelica.SIunits.CoefficientOfHeatTransfer 'U_out[4]'
                                                         "Heat transfer coeficient";
    Modelica.SIunits.CoefficientOfHeatTransfer 'U_out[5]'
                                                         "Heat transfer coeficient";
    Modelica.SIunits.CoefficientOfHeatTransfer 'U_out[6]'
                                                         "Heat transfer coeficient";
    Modelica.SIunits.CoefficientOfHeatTransfer 'U_out[7]'
                                                         "Heat transfer coeficient";
    Modelica.SIunits.CoefficientOfHeatTransfer 'U_out[8]'
                                                         "Heat transfer coeficient";
    Modelica.SIunits.CoefficientOfHeatTransfer 'U_out[9]'
                                                         "Heat transfer coeficient";
    Modelica.SIunits.CoefficientOfHeatTransfer 'U_out[10]'
                                                          "Heat transfer coeficient";
    Modelica.SIunits.Area A_in
                              "Heat transfer area";
    Modelica.SIunits.Area A_out
                               "Heat transfer area";
    parameter Modelica.SIunits.ThermalConductivity k_PCMs(fixed=false)
                                                                      "Thermal conductivity of the solid PCM";
    Modelica.SIunits.Area A_PCMs_out
                                    "Area of the exterior of the ice";
    parameter Modelica.SIunits.CoefficientOfHeatTransfer h_PCMl(fixed=false)
                                                                            "Convection heat transfer coefficient of the liquid PCM";
    parameter Modelica.SIunits.ThermalConductivity k_PCMl(fixed=false)
                                                                      "Thermal conductivity of the liquid PCM";
    Modelica.SIunits.Area A_PCMl_out
                                    "Area of the exterior of the liquid PCM";
    Modelica.SIunits.Temperature T_HTFo
                                       "Outlet HTF temperature";
    Modelica.SIunits.Temperature T_HTFi
                                       "Inlet HTF temperature";
    parameter Modelica.SIunits.CoefficientOfHeatTransfer h_HTF(fixed=false)
                                                                           "Convection heat transfer coefficient of the HTF";
    Real 'f[1]'
               "Correction factor";
    Real 'f[2]'
               "Correction factor";
    Real 'f[3]'
               "Correction factor";
    Real 'f[4]'
               "Correction factor";
    Real 'f[5]'
               "Correction factor";
    Real 'f[6]'
               "Correction factor";
    Real 'f[7]'
               "Correction factor";
    Real 'f[8]'
               "Correction factor";
    Real 'f[9]'
               "Correction factor";
    Real 'f[10]'
                "Correction factor";
    Real 'AR[1]'
                "Area ratio";
    Real 'AR[2]'
                "Area ratio";
    Real 'AR[3]'
                "Area ratio";
    Real 'AR[4]'
                "Area ratio";
    Real 'AR[5]'
                "Area ratio";
    Real 'AR[6]'
                "Area ratio";
    Real 'AR[7]'
                "Area ratio";
    Real 'AR[8]'
                "Area ratio";
    Real 'AR[9]'
                "Area ratio";
    Real 'AR[10]'
                 "Area ratio";
  end iceStorageExternalMelt_nSegnCoilp_rec;
public
  iceStorageExternalMelt_nSegnCoilp_rec iceStorageExternalMelt_nSegnCoilp annotation(Dialog);
protected
  record inlet_HTF_rec
    constant Integer nPorts = 1
                               "Number of ports";
  protected
    record medium_rec
      Real p(unit = "Pa", displayUnit = "bar", nominal = 100000.0, quantity = "Pressure", min = 0.0)
                                                                                                    "Absolute pressure of medium";
      Real h(unit = "J/kg", quantity = "SpecificEnergy")
                                                        "Specific enthalpy of medium";
      Modelica.Media.Interfaces.Types.Density d
                                               "Density of medium";
      Modelica.Media.Interfaces.Types.Temperature T(min = 263.15, max = 443.15)
                                                                               "Temperature of medium";
      constant Modelica.Media.Interfaces.Types.MassFraction 'X[1]' = 1.0
                                                                        "Mass fractions (= (component mass)/total mass  m_i/m)";
      Modelica.Media.Interfaces.Types.SpecificInternalEnergy u
                                                              "Specific internal energy of medium";
      constant Modelica.Media.Interfaces.Types.SpecificHeatCapacity R = 8.3144598
                                                                                 "Gas constant (of mixture if applicable)";
      constant Modelica.Media.Interfaces.Types.MolarMass MM = 0.1
                                                                 "Molar mass (of mixture or single fluid)";
    protected
      record state_rec
        Modelica.SIunits.Temperature T
                                      "Temperature";
        Modelica.SIunits.Pressure p
                                   "Pressure";
      end state_rec;
    public
      state_rec state;
      constant Boolean preferredMediumStates = false
                                                    "= true if StateSelect.prefer shall be used for the independent property variables of the medium";
      constant Boolean standardOrderComponents = true
                                                     "If true, and reducedX = true, the last element of X will be computed from the other ones";
      Modelica.SIunits.Conversions.NonSIunits.Temperature_degC T_degC
                                                                     "Temperature of medium in [degC]";
      Modelica.SIunits.Conversions.NonSIunits.Pressure_bar p_bar
                                                                "Absolute pressure of medium in [bar]";
      Modelica.SIunits.SpecificHeatCapacity cp
                                              "Specific heat capacity";
      parameter Modelica.SIunits.Temperature T_start = 298.15
                                                             "Initial temperature";
    end medium_rec;
  public
    medium_rec medium annotation(Dialog);
  protected
    record 'ports[1]_rec'
      Modelica_Media_Interfaces_PartialMedium_MassFlowRate m_flow(quantity = "MassFlowRate.Ethylene glycol", min = -1E+060, max = 1E+060)
                                                                                                                                         "Mass flow rate from the connection point into the component";
      Modelica.Media.Interfaces.Types.AbsolutePressure p
                                                        "Thermodynamic pressure in the connection point";
      Modelica.Media.Interfaces.Types.SpecificEnthalpy h_outflow
                                                                "Specific thermodynamic enthalpy close to the connection point if m_flow < 0";
    end 'ports[1]_rec';
  public
    'ports[1]_rec' 'ports[1]';
    constant Modelica_Media_Interfaces_PartialMedium_MassFlowRate m_flow(quantity = "MassFlowRate.Ethylene glycol") = 30
                                                                                                                        "Fixed mass flow rate going out of the fluid port";
    constant Modelica.Media.Interfaces.Types.Temperature T(min = 263.15, max = 443.15) = 263.15
                                                                                               "Fixed value of temperature";
    constant Modelica.Media.Interfaces.Types.MassFraction 'X[1]' = 1.0
                                                                      "Fixed value of composition";
    Modelica_Blocks_Interfaces_RealInput m_flow_in(unit = "kg/s")
                                                                 "Prescribed mass flow rate";
    Modelica_Blocks_Interfaces_RealInput T_in(unit = "K")
                                                         "Prescribed fluid temperature";
  end inlet_HTF_rec;
public
  inlet_HTF_rec inlet_HTF annotation(Dialog);
protected
  record inlet_water_rec
    constant Integer nPorts = 1
                               "Number of ports";
  protected
    record medium_rec
      Real p(unit = "Pa", displayUnit = "bar", nominal = 100000.0, quantity = "Pressure", min = 0.0)
                                                                                                    "Absolute pressure of medium";
      Real h(unit = "J/kg", quantity = "SpecificEnergy")
                                                        "Specific enthalpy of medium";
      constant Modelica.Media.Interfaces.Types.Density d = 995.586
                                                                  "Density of medium";
      Modelica.Media.Interfaces.Types.Temperature T
                                                   "Temperature of medium";
      constant Modelica.Media.Interfaces.Types.MassFraction 'X[1]' = 1.0
                                                                        "Mass fractions (= (component mass)/total mass  m_i/m)";
      Modelica.Media.Interfaces.Types.SpecificInternalEnergy u
                                                              "Specific internal energy of medium";
      constant Modelica.Media.Interfaces.Types.SpecificHeatCapacity R = 0
                                                                         "Gas constant (of mixture if applicable)";
      constant Modelica.Media.Interfaces.Types.MolarMass MM = 0.018015268
                                                                         "Molar mass (of mixture or single fluid)";
    protected
      record state_rec
        Modelica.Media.Interfaces.Types.AbsolutePressure p
                                                          "Absolute pressure of medium";
        Modelica.Media.Interfaces.Types.Temperature T
                                                     "Temperature of medium";
      end state_rec;
    public
      state_rec state;
      constant Boolean preferredMediumStates = false
                                                    "= true if StateSelect.prefer shall be used for the independent property variables of the medium";
      constant Boolean standardOrderComponents = true
                                                     "If true, and reducedX = true, the last element of X will be computed from the other ones";
      Modelica.SIunits.Conversions.NonSIunits.Temperature_degC T_degC
                                                                     "Temperature of medium in [degC]";
      parameter Modelica.SIunits.Conversions.NonSIunits.Pressure_bar p_bar(fixed=false)
                                                                                       "Absolute pressure of medium in [bar]";
    end medium_rec;
  public
    medium_rec medium;
  protected
    record 'ports[1]_rec'
      Modelica_Media_Interfaces_PartialMedium_MassFlowRate m_flow(quantity = "MassFlowRate.SimpleLiquidWater", min = -1E+060, max = 1E+060)
                                                                                                                                           "Mass flow rate from the connection point into the component";
      parameter Modelica.Media.Interfaces.Types.AbsolutePressure p(fixed=false)
                                                                               "Thermodynamic pressure in the connection point";
      Modelica.Media.Interfaces.Types.SpecificEnthalpy h_outflow
                                                                "Specific thermodynamic enthalpy close to the connection point if m_flow < 0";
    end 'ports[1]_rec';
  public
    'ports[1]_rec' 'ports[1]';
    constant Modelica_Media_Interfaces_PartialMedium_MassFlowRate m_flow(quantity = "MassFlowRate.SimpleLiquidWater") = 10
                                                                                                                          "Fixed mass flow rate going out of the fluid port";
    constant Modelica.Media.Interfaces.Types.Temperature T = 283.15
                                                                   "Fixed value of temperature";
    constant Modelica.Media.Interfaces.Types.MassFraction 'X[1]' = 1.0
                                                                      "Fixed value of composition";
    Modelica_Blocks_Interfaces_RealInput m_flow_in(unit = "kg/s")
                                                                 "Prescribed mass flow rate";
    Modelica_Blocks_Interfaces_RealInput T_in(unit = "K")
                                                         "Prescribed fluid temperature";
  end inlet_water_rec;
public
  inlet_water_rec inlet_water;
protected
  record outlet_HTF_rec
    constant Integer nPorts = 1
                               "Number of ports";
  protected
    record medium_rec
      Real p(unit = "Pa", displayUnit = "bar", nominal = 100000.0, quantity = "Pressure", min = 0.0)
                                                                                                    "Absolute pressure of medium";
      Real h(unit = "J/kg", quantity = "SpecificEnergy")
                                                        "Specific enthalpy of medium";
      parameter Modelica.Media.Interfaces.Types.Density d(fixed=false)
                                                                      "Density of medium";
      Modelica.Media.Interfaces.Types.Temperature T(min = 263.15, max = 443.15)
                                                                               "Temperature of medium";
      constant Modelica.Media.Interfaces.Types.MassFraction 'X[1]' = 1.0
                                                                        "Mass fractions (= (component mass)/total mass  m_i/m)";
      parameter Modelica.Media.Interfaces.Types.SpecificInternalEnergy u(fixed=false)
                                                                                     "Specific internal energy of medium";
      constant Modelica.Media.Interfaces.Types.SpecificHeatCapacity R = 8.3144598
                                                                                 "Gas constant (of mixture if applicable)";
      constant Modelica.Media.Interfaces.Types.MolarMass MM = 0.1
                                                                 "Molar mass (of mixture or single fluid)";
    protected
      record state_rec
        Modelica.SIunits.Temperature T
                                      "Temperature";
        Modelica.SIunits.Pressure p
                                   "Pressure";
      end state_rec;
    public
      state_rec state;
      constant Boolean preferredMediumStates = false
                                                    "= true if StateSelect.prefer shall be used for the independent property variables of the medium";
      constant Boolean standardOrderComponents = true
                                                     "If true, and reducedX = true, the last element of X will be computed from the other ones";
      parameter Modelica.SIunits.Conversions.NonSIunits.Temperature_degC T_degC(fixed=false)
                                                                                            "Temperature of medium in [degC]";
      parameter Modelica.SIunits.Conversions.NonSIunits.Pressure_bar p_bar(fixed=false)
                                                                                       "Absolute pressure of medium in [bar]";
      parameter Modelica.SIunits.SpecificHeatCapacity cp(fixed=false)
                                                                     "Specific heat capacity";
      parameter Modelica.SIunits.Temperature T_start = 298.15
                                                             "Initial temperature";
    end medium_rec;
  public
    medium_rec medium annotation(Dialog);
  protected
    record 'ports[1]_rec'
      Modelica_Media_Interfaces_PartialMedium_MassFlowRate m_flow(quantity = "MassFlowRate.Ethylene glycol", min = -1E+060, max = 1E+060)
                                                                                                                                         "Mass flow rate from the connection point into the component";
      Modelica.Media.Interfaces.Types.AbsolutePressure p
                                                        "Thermodynamic pressure in the connection point";
      parameter Modelica.Media.Interfaces.Types.SpecificEnthalpy h_outflow(fixed=false)
                                                                                       "Specific thermodynamic enthalpy close to the connection point if m_flow < 0";
    end 'ports[1]_rec';
  public
    'ports[1]_rec' 'ports[1]';
    constant Boolean use_p = true
                                 "select p or d";
    parameter Modelica.Media.Interfaces.Types.AbsolutePressure p = 101325
                                                                         "Boundary pressure";
    parameter Modelica.Media.Interfaces.Types.Density d(fixed=false)
                                                                    "Boundary density";
    constant Boolean use_T = true
                                 "select T or h";
    parameter Modelica.Media.Interfaces.Types.Temperature T(min = 263.15, max = 443.15) = 293.15
                                                                                                "Boundary temperature";
    parameter Modelica.Media.Interfaces.Types.SpecificEnthalpy h(fixed=false)
                                                                             "Boundary specific enthalpy";
    parameter Modelica.Media.Interfaces.Types.MassFraction 'X[1]'(quantity = "Ethylene glycol") = 1.0
                                                                                                     "Boundary mass fractions m_i/m";
  end outlet_HTF_rec;
public
  outlet_HTF_rec outlet_HTF annotation(Dialog);
protected
  record fixedTemperature_rec
  protected
    record port_rec
      Modelica.SIunits.Temperature T
                                    "Port temperature";
      Modelica.SIunits.HeatFlowRate Q_flow
                                          "Heat flow rate (positive if flowing from outside into the component)";
    end port_rec;
  public
    port_rec port;
    Modelica_Blocks_Interfaces_RealInput T(unit = "K");
  end fixedTemperature_rec;
public
  fixedTemperature_rec fixedTemperature;
protected
  record outlet_water_temperature_rec
  protected
    record port_rec
      constant Modelica_Media_Interfaces_PartialMedium_MassFlowRate m_flow(quantity = "MassFlowRate.SimpleLiquidWater", min = 0.0) = 0
                                                                                                                                      "Mass flow rate from the connection point into the component";
      Modelica.Media.Interfaces.Types.AbsolutePressure p
                                                        "Thermodynamic pressure in the connection point";
      constant Modelica.Media.Interfaces.Types.SpecificEnthalpy h_outflow = 83680.0
                                                                                   "Specific thermodynamic enthalpy close to the connection point if m_flow < 0";
    end port_rec;
  public
    port_rec port;
    Modelica_Blocks_Interfaces_RealOutput T(unit = "K", displayUnit = "degC", nominal = 300.0, quantity = "ThermodynamicTemperature", min = 0.0)
                                                                                                                                                "Temperature in port medium";
  end outlet_water_temperature_rec;
public
  outlet_water_temperature_rec outlet_water_temperature;
protected
  record outlet_HTF_temperature_rec
  protected
    record port_rec
      constant Modelica_Media_Interfaces_PartialMedium_MassFlowRate m_flow(quantity = "MassFlowRate.Ethylene glycol", min = 0.0) = 0
                                                                                                                                    "Mass flow rate from the connection point into the component";
      Modelica.Media.Interfaces.Types.AbsolutePressure p
                                                        "Thermodynamic pressure in the connection point";
      parameter Modelica.Media.Interfaces.Types.SpecificEnthalpy h_outflow(fixed=false)
                                                                                       "Specific thermodynamic enthalpy close to the connection point if m_flow < 0";
    end port_rec;
  public
    port_rec port;
    Modelica_Blocks_Interfaces_RealOutput T(unit = "K", displayUnit = "degC", nominal = 300.0, quantity = "ThermodynamicTemperature", min = 0.0)
                                                                                                                                                "Temperature in port medium";
  end outlet_HTF_temperature_rec;
public
  outlet_HTF_temperature_rec outlet_HTF_temperature;
protected
  record massFlowRate_rec
    constant Boolean allowFlowReversal = true
                                             "= true to allow flow reversal, false restricts to design direction (port_a -> port_b)";
  protected
    record port_a_rec
      Modelica_Media_Interfaces_PartialMedium_MassFlowRate m_flow(quantity = "MassFlowRate.SimpleLiquidWater", min = -1E+060)
                                                                                                                             "Mass flow rate from the connection point into the component";
      Modelica.Media.Interfaces.Types.AbsolutePressure p
                                                        "Thermodynamic pressure in the connection point";
      Modelica.Media.Interfaces.Types.SpecificEnthalpy h_outflow
                                                                "Specific thermodynamic enthalpy close to the connection point if m_flow < 0";
    end port_a_rec;
  public
    port_a_rec port_a;
  protected
    record port_b_rec
      Modelica_Media_Interfaces_PartialMedium_MassFlowRate m_flow(quantity = "MassFlowRate.SimpleLiquidWater", max = 1E+060)
                                                                                                                            "Mass flow rate from the connection point into the component";
      Modelica.Media.Interfaces.Types.AbsolutePressure p
                                                        "Thermodynamic pressure in the connection point";
      Modelica.Media.Interfaces.Types.SpecificEnthalpy h_outflow
                                                                "Specific thermodynamic enthalpy close to the connection point if m_flow < 0";
    end port_b_rec;
  public
    port_b_rec port_b;
    parameter Modelica_Media_Interfaces_PartialMedium_MassFlowRate m_flow_nominal(quantity = "MassFlowRate.SimpleLiquidWater", fixed=false)
                                                                                                                                           "Nominal value of m_flow = port_a.m_flow";
    parameter Modelica_Media_Interfaces_PartialMedium_MassFlowRate m_flow_small(quantity = "MassFlowRate.SimpleLiquidWater", min = 0.0, fixed=false)
                                                                                                                                                    "Regularization for bi-directional flow in the region |m_flow| < m_flow_small (m_flow_small > 0 required)";
    Modelica_Blocks_Interfaces_RealOutput m_flow(unit = "kg/s", quantity = "MassFlowRate")
                                                                                          "Mass flow rate from port_a to port_b";
  end massFlowRate_rec;
public
  massFlowRate_rec massFlowRate;
  parameter Real _ambient_T_start = 288.15
  annotation (Dialog( group="Start values for inputs "));
protected
  Real _ambient_T_old;
public
  Modelica.Blocks.Interfaces.RealInput ambient_T(unit = "K", displayUnit = "degC", nominal = 300.0, quantity = "ThermodynamicTemperature", min = 0.0, start = _ambient_T_start)
  annotation (Placement(transformation(extent={{-124,47},{-84,87}})));
  parameter Real _water_in_m_flow_start = 0.0
  annotation (Dialog( group="Start values for inputs "));
protected
  Real _water_in_m_flow_old;
public
  Modelica.Blocks.Interfaces.RealInput water_in_m_flow(unit = "kg/s", quantity = "MassFlowRate", min = -100000.0, max = 100000.0, start = _water_in_m_flow_start)
  annotation (Placement(transformation(extent={{-124,14},{-84,54}})));
  parameter Real _water_inlet_T_start = 288.15
  annotation (Dialog( group="Start values for inputs "));
protected
  Real _water_inlet_T_old;
public
  Modelica.Blocks.Interfaces.RealInput water_inlet_T(unit = "K", displayUnit = "degC", nominal = 300.0, quantity = "ThermodynamicTemperature", min = 1.0, max = 10000.0, start = _water_inlet_T_start)
  annotation (Placement(transformation(extent={{-124,-20},{-84,20}})));
  parameter Real _HTF_m_flow_start = 0.0
  annotation (Dialog( group="Start values for inputs "));
protected
  Real _HTF_m_flow_old;
public
  Modelica.Blocks.Interfaces.RealInput HTF_m_flow(unit = "kg/s", quantity = "MassFlowRate", min = -1E+060, max = 100000.0, start = _HTF_m_flow_start)
  annotation (Placement(transformation(extent={{-124,-53},{-84,-13}})));
  parameter Real _HTF_inlet_T_start = 0.0
  annotation (Dialog( group="Start values for inputs "));
protected
  Real _HTF_inlet_T_old;
public
  Modelica.Blocks.Interfaces.RealInput HTF_inlet_T(unit = "K", displayUnit = "degC", nominal = 300.0, quantity = "ThermodynamicTemperature", min = 263.15, max = 443.15, start = _HTF_inlet_T_start)
  annotation (Placement(transformation(extent={{-124,-86},{-84,-46}})));
  Modelica.Blocks.Interfaces.RealOutput HTF_outlet_T(unit = "K", displayUnit = "degC", nominal = 300.0, quantity = "ThermodynamicTemperature", min = 0.0)
  annotation (Placement(transformation(extent={{100,40},{140,80}})));
  Modelica.Blocks.Interfaces.RealOutput PCM_T(unit = "K", displayUnit = "degC", nominal = 300.0, quantity = "ThermodynamicTemperature", min = 0.0)
  annotation (Placement(transformation(extent={{100,0},{140,40}})));
  Modelica.Blocks.Interfaces.RealOutput water_outlet_T(unit = "K", displayUnit = "degC", nominal = 300.0, quantity = "ThermodynamicTemperature", min = 0.0)
  annotation (Placement(transformation(extent={{100,-40},{140,0}})));
  Modelica.Blocks.Interfaces.RealOutput water_out_m_flow(unit = "kg/s", quantity = "MassFlowRate", min = -100000.0, max = 100000.0)
  annotation (Placement(transformation(extent={{100,-80},{140,-40}})));
public
  parameter String fmi_instanceName="IceStorageExtMelt_FMU_fmu"
  annotation (Dialog(tab="FMI", group="Instance name"));
  parameter Boolean fmi_loggingOn=false
  annotation (Dialog(tab="FMI", group="Enable logging"));
  parameter Boolean fmi_pullInputsForInitialization=true
  "Set to false when using the FMU in feedback connections"
  annotation (Dialog(tab="FMI", group="Inputs for initialization"));
  parameter Boolean fmi_InputTime=false
  "Time point of input used when calling doStep."
  annotation (Evaluate=true,Dialog(tab="FMI", group="Input Handling"),choices(choice= false "StepEnd", choice= true "StepStart"));
  parameter Boolean fmi_UsePreOnInputSignals=true
  annotation (Evaluate=true,Dialog(tab="FMI", group="Input Handling"));
  parameter Real fmi_StartTime = 0.0
  annotation (Dialog(tab="FMI", group="Step time"));
  parameter Real fmi_StopTime = 100.0
  annotation (Dialog(tab="FMI", group="Step time"));
  parameter Real fmi_NumberOfSteps = 500
  annotation (Dialog(tab="FMI", group="Step time"));
  parameter Real fmi_CommunicationStepSize=(fmi_StopTime-fmi_StartTime)/fmi_NumberOfSteps
  annotation (Dialog(tab="FMI", group="Step time"));
  parameter Integer stepSizeScaleFactor = 1 "Number of doSteps called between two CommunicationStepSize"
  annotation (Dialog(tab="FMI", group="Step time"));
  parameter Boolean fmi_forceShutDownAtStopTime=false
  annotation (Dialog(tab="FMI", group="Step time"));
  parameter String fmi_fmuLocation="file:///"+ModelicaServices.ExternalReferences.loadResource("modelica://IceStorageExtMelt_FMU_fmu/Resources/Library/FMU/IceStorageExtMelt_FMU")
  annotation (Dialog(tab="FMI", group="Instantiation"));
protected
fmi_Functions.fmiModel fmi;
Boolean fmi_StepOK;
parameter Real fmi_Initialized(fixed=false);
parameter Real fmi_AParamsAndStart(fixed=false);
parameter Real fmi_initInput0(start=0,fixed=false);
parameter Real fmi_initInput1(start=0,fixed=false);
parameter Real fmi_initInput2(start=0,fixed=false);
parameter Real fmi_initInput3(start=0,fixed=false);
parameter Real fmi_initInput4(start=0,fixed=false);
Real RealVariables1[100];
Real RealVariables2[100];
Real RealVariables3[100];
Real RealVariables4[100];
Real RealVariables5[100];
Real RealVariables6[100];
Real RealVariables7[100];
Real RealVariables8[100];
Real RealVariables9[100];
Real RealVariables10[100];
Real RealVariables11[100];
Real RealVariables12[4];
Real RealDependentParameters1[100];
Real RealDependentParameters2[58];
Integer IntegerDependentParameters[12];
Boolean BooleanVariables[3];
Boolean BooleanDependentParameters[2];
package fmi_Functions
  class fmiModel
  extends ExternalObject;
    function constructor "Initialize FMI model"
      extends Modelica.Icons.Function;
      input String instanceName;
      input Boolean loggingOn;
        input String fmuLocation;
      output fmiModel fmi;
      external"C" fmi = Modelica_0IK4_0TEKNIKER_DCOL_ThermalStorage_LatentStorages_FMI_IceStorageExternalMelting_0Dym_fmiInstantiateModel2(instanceName, loggingOn, fmuLocation)
      annotation(Header="
#ifndef Modelica_0IK4_0TEKNIKER_DCOL_ThermalStorage_LatentStorages_FMI_IceStorageExternalMelting_0Dym_Instantiate_C
#define Modelica_0IK4_0TEKNIKER_DCOL_ThermalStorage_LatentStorages_FMI_IceStorageExternalMelting_0Dym_Instantiate_C 1
#include <stdlib.h>
#include \"FMI/fmiImport.h\"
#ifndef Modelica_0IK4_0TEKNIKER_DCOL_ThermalStorage_LatentStorages_FMI_IceStorageExternalMelting_0Dym_MYSTRCMP_C
#define Modelica_0IK4_0TEKNIKER_DCOL_ThermalStorage_LatentStorages_FMI_IceStorageExternalMelting_0Dym_MYSTRCMP_C 1
int Modelica_0IK4_0TEKNIKER_DCOL_ThermalStorage_LatentStorages_FMI_IceStorageExternalMelting_0Dymmystrcmp(const void *_a, const void *_b) {
  char *a = _a;
  char *const *b = _b;
  return strcmp(a, *b);
}
#endif
void Modelica_0IK4_0TEKNIKER_DCOL_ThermalStorage_LatentStorages_FMI_IceStorageExternalMelting_0DymLogger(fmiComponent c, fmiString instanceName, fmiStatus status,
	 fmiString category, fmiString message, ...) {
  char msg[4096];
  char buf[4096];
  int len;
  va_list ap;
  va_start(ap,message);
#if defined(_MSC_VER) && _MSC_VER>=1200
  len = _snprintf(msg, sizeof(msg)/sizeof(*msg), \"%s: %s\", instanceName, message);
  if (len < 0) goto fail;
  len = _vsnprintf(buf, sizeof(buf)/sizeof(*buf) - 2, msg, ap);
  if (len < 0) goto fail;
#else
  len = snprintf(msg, sizeof(msg)/sizeof(*msg), \"%s: %s\", instanceName, message);
  if (len < 0) goto fail;
  len = vsnprintf(buf, sizeof(buf)/sizeof(*buf) - 2, msg, ap);
  if (len < 0) goto fail;
#endif
  if( len>0 && len <4096 && buf[len - 1]!='\\n'){
    buf[len] = '\\n';
    buf[len + 1] = 0;
  }
  va_end(ap);
  switch (status) {
    case fmiFatal:
      ModelicaMessage(\"[fmiFatal]: \");
      break;
    case fmiError:
      ModelicaMessage(\"[fmiError]: \");
      break;
    case fmiDiscard:
      ModelicaMessage(\"[fmiDiscard]: \");
      break;
    case fmiWarning:
      ModelicaMessage(\"[fmiWarning]: \");
      break;
    case fmiOK:
      ModelicaMessage(\"[fmiOK]: \");
      break;
  }
  ModelicaMessage(buf);
  return;
fail:
  ModelicaMessage(\"Logger failed, message too long?\");
}
void * Modelica_0IK4_0TEKNIKER_DCOL_ThermalStorage_LatentStorages_FMI_IceStorageExternalMelting_0Dym_fmiInstantiateModel2(const char*instanceName, fmiBoolean loggingOn, const char* fmuLocation) {
  static fmiCoSimCallbackFunctions funcs = {&Modelica_0IK4_0TEKNIKER_DCOL_ThermalStorage_LatentStorages_FMI_IceStorageExternalMelting_0DymLogger, &calloc, &free, NULL};
  struct dy_Extended* res;

  res = calloc(1, sizeof(struct dy_Extended));
  if (res!=0) {
    if (!(res->hInst=LoadLibraryW(L\"Modelica_0IK4_0TEKNIKER_DCOL_ThermalStorage_LatentStorages_FMI_IceStorageExternalMelting_0Dym.dll\"))) {
      ModelicaError(\"Loading of FMU dynamic link library (Modelica_0IK4_0TEKNIKER_DCOL_ThermalStorage_LatentStorages_FMI_IceStorageExternalMelting_0Dym.dll) failed!\");
      return 0;
    }
    if(!(res->dyFmiInstantiateSlave=(fmiInstantiateSlaveFunc)GetProcAddress(res->hInst,\"Modelica_0IK4_0TEKNIKER_DCOL_ThermalStorage_LatentStorages_FMI_IceStorageExternalMelting_0Dym_fmiInstantiateSlave\"))){
      ModelicaError(\"GetProcAddress failed for fmiInstantiateSlave!\\n The model was imported as a Co-Simulation FMU but could not load the CS specific function fmiInstantiateSlave\\n Verify that the FMU supports Co-Simulation\");
      return 0;
    }
    if(!(res->dyFmiFreeSlaveInstance=(fmiFreeSlaveInstanceFunc)GetProcAddress(res->hInst,\"Modelica_0IK4_0TEKNIKER_DCOL_ThermalStorage_LatentStorages_FMI_IceStorageExternalMelting_0Dym_fmiFreeSlaveInstance\"))){
      ModelicaError(\"GetProcAddress failed for fmiFreeSlaveInstance!\\n The model was imported as a Co-Simulation FMU but could not load the CS specific function fmiFreeSlaveInstance\\n Verify that the FMU supports Co-Simulation\");
      return 0;
    }
    if(!(res->dyFmiInitializeSlave=(fmiInitializeSlaveFunc)GetProcAddress(res->hInst,\"Modelica_0IK4_0TEKNIKER_DCOL_ThermalStorage_LatentStorages_FMI_IceStorageExternalMelting_0Dym_fmiInitializeSlave\"))){
      ModelicaError(\"GetProcAddress failed for fmiInitializeSlave!\\n The model was imported as a Co-Simulation FMU but could not load the CS specific function fmiInitializeSlave\\n Verify that the FMU supports Co-Simulation\");
      return 0;
    }
    if(!(res->dyFmiResetSlave=(fmiResetSlaveFunc)GetProcAddress(res->hInst,\"Modelica_0IK4_0TEKNIKER_DCOL_ThermalStorage_LatentStorages_FMI_IceStorageExternalMelting_0Dym_fmiResetSlave\"))){
      ModelicaError(\"GetProcAddress failed for fmiResetSlave!\\n The model was imported as a Co-Simulation FMU but could not load the CS specific function fmiResetSlave\\n Verify that the FMU supports Co-Simulation\");
      return 0;
    }
    if(!(res->dyFmiDoStep=(fmiDoStepFunc)GetProcAddress(res->hInst,\"Modelica_0IK4_0TEKNIKER_DCOL_ThermalStorage_LatentStorages_FMI_IceStorageExternalMelting_0Dym_fmiDoStep\"))){
      ModelicaError(\"GetProcAddress failed for fmiDoStep!\\n The model was imported as a Co-Simulation FMU but could not load the CS specific function fmiDoStep\\n Verify that the FMU supports Co-Simulation\");
      return 0;
    }
    if(!(res->dyFmiTerminateSlave=(fmiTerminateSlaveFunc)GetProcAddress(res->hInst,\"Modelica_0IK4_0TEKNIKER_DCOL_ThermalStorage_LatentStorages_FMI_IceStorageExternalMelting_0Dym_fmiTerminateSlave\"))){
      ModelicaError(\"GetProcAddress failed for fmiTerminateSlave!\\n The model was imported as a Co-Simulation FMU but could not load the CS specific function fmiTerminateSlave\\n Verify that the FMU supports Co-Simulation\");
      return 0;
    }
    if (!(res->dyFmiSetReal=(fmiSetRealFunc)GetProcAddress(res->hInst,\"Modelica_0IK4_0TEKNIKER_DCOL_ThermalStorage_LatentStorages_FMI_IceStorageExternalMelting_0Dym_fmiSetReal\"))) {
      ModelicaError(\"GetProcAddress failed for fmiSetReal!\");
      return 0;
    }
    if (!(res->dyFmiGetReal=(fmiGetRealFunc)GetProcAddress(res->hInst,\"Modelica_0IK4_0TEKNIKER_DCOL_ThermalStorage_LatentStorages_FMI_IceStorageExternalMelting_0Dym_fmiGetReal\"))) {
      ModelicaError(\"GetProcAddress failed for fmiGetReal!\");
      return 0;
    }
    if (!(res->dyFmiSetInteger=(fmiSetIntegerFunc)GetProcAddress(res->hInst,\"Modelica_0IK4_0TEKNIKER_DCOL_ThermalStorage_LatentStorages_FMI_IceStorageExternalMelting_0Dym_fmiSetInteger\"))) {
      ModelicaError(\"GetProcAddress failed for fmiSetInteger!\");
      return 0;
    }
    if (!(res->dyFmiGetInteger=(fmiGetIntegerFunc)GetProcAddress(res->hInst,\"Modelica_0IK4_0TEKNIKER_DCOL_ThermalStorage_LatentStorages_FMI_IceStorageExternalMelting_0Dym_fmiGetInteger\"))) {
      ModelicaError(\"GetProcAddress failed for fmiGetInteger!\");
      return 0;
    }
    if (!(res->dyFmiSetBoolean=(fmiSetBooleanFunc)GetProcAddress(res->hInst,\"Modelica_0IK4_0TEKNIKER_DCOL_ThermalStorage_LatentStorages_FMI_IceStorageExternalMelting_0Dym_fmiSetBoolean\"))) {
      ModelicaError(\"GetProcAddress failed for fmiSetBoolean!\");
      return 0;
    }
    if (!(res->dyFmiGetBoolean=(fmiGetBooleanFunc)GetProcAddress(res->hInst,\"Modelica_0IK4_0TEKNIKER_DCOL_ThermalStorage_LatentStorages_FMI_IceStorageExternalMelting_0Dym_fmiGetBoolean\"))) {
      ModelicaError(\"GetProcAddress failed for fmiGetBoolean!\");
      return 0;
    }
    if (!(res->dyFmiSetString=(fmiSetStringFunc)GetProcAddress(res->hInst,\"Modelica_0IK4_0TEKNIKER_DCOL_ThermalStorage_LatentStorages_FMI_IceStorageExternalMelting_0Dym_fmiSetString\"))) {
      ModelicaError(\"GetProcAddress failed for fmiSetString!\");
      return 0;
    }
    if (!(res->dyFmiGetString=(fmiGetStringFunc)GetProcAddress(res->hInst,\"Modelica_0IK4_0TEKNIKER_DCOL_ThermalStorage_LatentStorages_FMI_IceStorageExternalMelting_0Dym_fmiGetString\"))) {
      ModelicaError(\"GetProcAddress failed for fmiGetString!\");
      return 0;
    }
    res->m=res->dyFmiInstantiateSlave(instanceName, \"{80292877-2a20-4248-9920-ec6250c4b11e}\", fmuLocation, \"application/x-dymolakernel\", 0, fmiFalse, fmiFalse, funcs, loggingOn);
    if (0==res->m) {free(res);res=0;ModelicaError(\"InstantiateSlave failed\");}
    else {res->dyTriggered=0;res->dyTime=res->dyLastTime=-1e37;}
  }
  return res;
}
#endif", Library="Modelica_0IK4_0TEKNIKER_DCOL_ThermalStorage_LatentStorages_FMI_IceStorageExternalMelting_0Dym", LibraryDirectory="modelica://DCOL/Resources/Library/FMU/IceStorageExtMelt_FMU/binaries",                      __Dymola_CriticalRegion="Modelica_0IK4_0TEKNIKER_DCOL_ThermalStorage_LatentStorages_FMI_IceStorageExternalMelting_0Dym");
    end constructor;

    function destructor "Release storage of FMI model"
      extends Modelica.Icons.Function;
      input fmiModel fmi;
      external"C"
                 Modelica_0IK4_0TEKNIKER_DCOL_ThermalStorage_LatentStorages_FMI_IceStorageExternalMelting_0Dym_fmiFreeModelInstance2(fmi);
      annotation (Header="
#ifndef Modelica_0IK4_0TEKNIKER_DCOL_ThermalStorage_LatentStorages_FMI_IceStorageExternalMelting_0Dym_Free_C
#define Modelica_0IK4_0TEKNIKER_DCOL_ThermalStorage_LatentStorages_FMI_IceStorageExternalMelting_0Dym_Free_C 1
#include <stdlib.h>
#include \"FMI/fmiImport.h\"
void Modelica_0IK4_0TEKNIKER_DCOL_ThermalStorage_LatentStorages_FMI_IceStorageExternalMelting_0Dym_fmiFreeModelInstance2(void*m) {
  struct dy_Extended*a=m;
  if (a) {
    a->dyFmiTerminateSlave(a->m);
    a->dyFmiFreeSlaveInstance(a->m);
    FreeLibrary(a->hInst);
    free(a);
  }
}
#endif", Library="Modelica_0IK4_0TEKNIKER_DCOL_ThermalStorage_LatentStorages_FMI_IceStorageExternalMelting_0Dym", LibraryDirectory="modelica://DCOL/Resources/Library/FMU/IceStorageExtMelt_FMU/binaries",                      __Dymola_CriticalRegion="Modelica_0IK4_0TEKNIKER_DCOL_ThermalStorage_LatentStorages_FMI_IceStorageExternalMelting_0Dym");
    end destructor;
  end fmiModel;

    function fmiInitializeSlave
      input fmiModel fmi;
      input Real tStart;
      input Boolean forceShutDownAtTStop;
       input Real tStop;
      input Real preAvailable;
      output Real postAvailable=preAvailable;
      external"C" Modelica_0IK4_0TEKNIKER_DCOL_ThermalStorage_LatentStorages_FMI_IceStorageExternalMelting_0Dym_fmiInitializeSlave2(fmi, tStart, forceShutDownAtTStop, tStop);
      annotation (Header="
#ifndef Modelica_0IK4_0TEKNIKER_DCOL_ThermalStorage_LatentStorages_FMI_IceStorageExternalMelting_0Dym_InitializeSlave_C
#define Modelica_0IK4_0TEKNIKER_DCOL_ThermalStorage_LatentStorages_FMI_IceStorageExternalMelting_0Dym_InitializeSlave_C 1
#include <stdlib.h>
#include \"FMI/fmiImport.h\"
double Modelica_0IK4_0TEKNIKER_DCOL_ThermalStorage_LatentStorages_FMI_IceStorageExternalMelting_0Dym_fmiInitializeSlave2(void*m, fmiReal tStart, fmiBoolean forceShutDownAtTStop, fmiReal tStop) {
  struct dy_Extended*a=m;
  fmiStatus status=fmiFatal;
  if (a) {
    status=a->dyFmiInitializeSlave(a->m, tStart, forceShutDownAtTStop, tStop);
    a->dyTriggered=0;
    a->dyLastTime=a->dyTime;
  }
  if (status!=fmiOK && status!=fmiWarning) ModelicaError(\"InitializeSlave failed\");
  return 1e37;
}
#endif", Library="Modelica_0IK4_0TEKNIKER_DCOL_ThermalStorage_LatentStorages_FMI_IceStorageExternalMelting_0Dym", LibraryDirectory="modelica://DCOL/Resources/Library/FMU/IceStorageExtMelt_FMU/binaries",                      __Dymola_CriticalRegion="Modelica_0IK4_0TEKNIKER_DCOL_ThermalStorage_LatentStorages_FMI_IceStorageExternalMelting_0Dym");
    end fmiInitializeSlave;

    function fmiDoStep
     input fmiModel fmi;
     input Real currentTime;
     input Real stepSize;
     output Boolean stepOK;
     external"C" stepOK= Modelica_0IK4_0TEKNIKER_DCOL_ThermalStorage_LatentStorages_FMI_IceStorageExternalMelting_0Dym_fmiDoStep2(fmi, currentTime, stepSize);
     annotation (Header="
#ifndef Modelica_0IK4_0TEKNIKER_DCOL_ThermalStorage_LatentStorages_FMI_IceStorageExternalMelting_0Dym_DoStep_C
#define Modelica_0IK4_0TEKNIKER_DCOL_ThermalStorage_LatentStorages_FMI_IceStorageExternalMelting_0Dym_DoStep_C 1
#include <stdlib.h>
#include \"FMI/fmiImport.h\"
double Modelica_0IK4_0TEKNIKER_DCOL_ThermalStorage_LatentStorages_FMI_IceStorageExternalMelting_0Dym_fmiDoStep2(void*m, double currentTime, double stepSize) {
  struct dy_Extended*a=m;
  fmiStatus status=fmiFatal;
  if (a) {
    status=a->dyFmiDoStep(a->m, currentTime, stepSize, fmiTrue);
  }
  if (status!=fmiOK && status!=fmiWarning) ModelicaError(\"DoStep failed\");
  return 1.0;
}
#endif", Library="Modelica_0IK4_0TEKNIKER_DCOL_ThermalStorage_LatentStorages_FMI_IceStorageExternalMelting_0Dym", LibraryDirectory="modelica://DCOL/Resources/Library/FMU/IceStorageExtMelt_FMU/binaries",                      __Dymola_CriticalRegion="Modelica_0IK4_0TEKNIKER_DCOL_ThermalStorage_LatentStorages_FMI_IceStorageExternalMelting_0Dym");
    end fmiDoStep;

    function fmiResetSlave
      input fmiModel fmi;
      output Boolean resetOK;
      external"C" resetOK = Modelica_0IK4_0TEKNIKER_DCOL_ThermalStorage_LatentStorages_FMI_IceStorageExternalMelting_0Dym_fmiResetSlave2(fmi);
      annotation (Header="
#ifndef Modelica_0IK4_0TEKNIKER_DCOL_ThermalStorage_LatentStorages_FMI_IceStorageExternalMelting_0Dym_ResetSlave_C
#define Modelica_0IK4_0TEKNIKER_DCOL_ThermalStorage_LatentStorages_FMI_IceStorageExternalMelting_0Dym_ResetSlave_C 1
#include <stdlib.h>
#include \"FMI/fmiImport.h\"
double Modelica_0IK4_0TEKNIKER_DCOL_ThermalStorage_LatentStorages_FMI_IceStorageExternalMelting_0Dym_fmiResetSlave2(void*m) {
  struct dy_Extended*a=m;
  fmiStatus status=fmiFatal;
  if (a) {
    status=a->dyFmiResetSlave(a->m);
  }
  if (status!=fmiOK && status!=fmiWarning) ModelicaError(\"resetSlave failed\");
    return 1.0;
  }
#endif", Library="Modelica_0IK4_0TEKNIKER_DCOL_ThermalStorage_LatentStorages_FMI_IceStorageExternalMelting_0Dym", LibraryDirectory="modelica://DCOL/Resources/Library/FMU/IceStorageExtMelt_FMU/binaries",                      __Dymola_CriticalRegion="Modelica_0IK4_0TEKNIKER_DCOL_ThermalStorage_LatentStorages_FMI_IceStorageExternalMelting_0Dym");
    end fmiResetSlave;

    function fmiSetReal
      input fmiModel fmi;
      input Integer refs[:];
      input Real vals[size(refs, 1)];
      output Real dummy= 1;
      external"C"
                 Modelica_0IK4_0TEKNIKER_DCOL_ThermalStorage_LatentStorages_FMI_IceStorageExternalMelting_0Dym_fmiSetReal2(
        fmi,
        refs,
        size(refs, 1),
        vals);
        annotation (Header="
#ifndef Modelica_0IK4_0TEKNIKER_DCOL_ThermalStorage_LatentStorages_FMI_IceStorageExternalMelting_0Dym_SetReal_C
#define Modelica_0IK4_0TEKNIKER_DCOL_ThermalStorage_LatentStorages_FMI_IceStorageExternalMelting_0Dym_SetReal_C 1
#include <stdlib.h>
#include \"FMI/fmiImport.h\"
void Modelica_0IK4_0TEKNIKER_DCOL_ThermalStorage_LatentStorages_FMI_IceStorageExternalMelting_0Dym_fmiSetReal2(void*m, const int*refs, size_t nrefs, const double*vals) {
  struct dy_Extended*a=m;
  fmiStatus status=fmiFatal;
  if(!nrefs){return;}
  if (a) {
    status=a->dyFmiSetReal(a->m, refs, nrefs, vals);
  }
  if (status!=fmiOK && status!=fmiWarning) ModelicaError(\"SetReal failed\");
}
#endif", Library="Modelica_0IK4_0TEKNIKER_DCOL_ThermalStorage_LatentStorages_FMI_IceStorageExternalMelting_0Dym", LibraryDirectory="modelica://DCOL/Resources/Library/FMU/IceStorageExtMelt_FMU/binaries",                      __Dymola_CriticalRegion="Modelica_0IK4_0TEKNIKER_DCOL_ThermalStorage_LatentStorages_FMI_IceStorageExternalMelting_0Dym",__Dymola_IdemPotent=true, __Dymola_VectorizedExceptFirst=true);
    end fmiSetReal;

    function fmiSetRealParam
      input fmiModel fmi;
      input Integer refs[:];
      input Real vals[size(refs, 1)];
    protected
      Real oldVals[size(refs, 1)];
      external"C"
                 Modelica_0IK4_0TEKNIKER_DCOL_ThermalStorage_LatentStorages_FMI_IceStorageExternalMelting_0Dym_fmiSetRealParam2(
        fmi,
        refs,
        size(refs, 1),
        vals,
        oldVals);
        annotation (Header="
#ifndef Modelica_0IK4_0TEKNIKER_DCOL_ThermalStorage_LatentStorages_FMI_IceStorageExternalMelting_0Dym_SetRealParam_C
#define Modelica_0IK4_0TEKNIKER_DCOL_ThermalStorage_LatentStorages_FMI_IceStorageExternalMelting_0Dym_SetRealParam_C 1
#include <stdlib.h>
#include \"FMI/fmiImport.h\"
void Modelica_0IK4_0TEKNIKER_DCOL_ThermalStorage_LatentStorages_FMI_IceStorageExternalMelting_0Dym_fmiSetRealParam2(void*m, const int*refs, size_t nrefs, const double*vals, double*oldVals) {
  struct dy_Extended*a=m;
  fmiStatus status=fmiFatal;
  int i = 0;
  if(!nrefs){return;}
  if (a) {
    if(a->currentMode == dyInstantiationMode){
		status=a->dyFmiSetReal(a->m, refs, nrefs, vals);
    }else{
      status=a->dyFmiGetReal(a->m, refs, nrefs, oldVals);
      for(i=0; i<nrefs;++i){
        if( abs(vals[i]-oldVals[i])> 5e-16){
          ModelicaError(\"SetRealParameter: new parameters with diferent values are being set after initialization, this is not allowed\");
        }
      }
    }
  }
  if (status!=fmiOK && status!=fmiWarning) ModelicaError(\"SetReal failed\");
}
#endif", Library="Modelica_0IK4_0TEKNIKER_DCOL_ThermalStorage_LatentStorages_FMI_IceStorageExternalMelting_0Dym", LibraryDirectory="modelica://DCOL/Resources/Library/FMU/IceStorageExtMelt_FMU/binaries",                      __Dymola_CriticalRegion="Modelica_0IK4_0TEKNIKER_DCOL_ThermalStorage_LatentStorages_FMI_IceStorageExternalMelting_0Dym",__Dymola_IdemPotent=true, __Dymola_VectorizedExceptFirst=true);
    end fmiSetRealParam;

    function fmiGetRealScalar
      input fmiModel fmi;
      input Integer ref;
      input Real dummy;
      output Real val;
    algorithm
        val := scalar(fmiGetReal(fmi, {ref}, dummy));
    end fmiGetRealScalar;

    function fmiGetReal
      input fmiModel fmi;
      input Integer refs[:];
      output Real vals[size(refs, 1)];
      input Real preAvailable;
      external"C" Modelica_0IK4_0TEKNIKER_DCOL_ThermalStorage_LatentStorages_FMI_IceStorageExternalMelting_0Dym_fmiGetReal2(
        fmi,
        refs,
        size(refs, 1),
        vals);
      annotation (Header="
#ifndef Modelica_0IK4_0TEKNIKER_DCOL_ThermalStorage_LatentStorages_FMI_IceStorageExternalMelting_0Dym_GetReal_C
#define Modelica_0IK4_0TEKNIKER_DCOL_ThermalStorage_LatentStorages_FMI_IceStorageExternalMelting_0Dym_GetReal_C 1
#include <stdlib.h>
#include \"FMI/fmiImport.h\"
void Modelica_0IK4_0TEKNIKER_DCOL_ThermalStorage_LatentStorages_FMI_IceStorageExternalMelting_0Dym_fmiGetReal2(void*m, const int*refs, size_t nrefs, double*vals) {
  struct dy_Extended*a=m;
  fmiStatus status=fmiFatal;
  if (a) {
    status=a->dyFmiGetReal(a->m, refs, nrefs, vals);
  }
  if (status!=fmiOK && status!=fmiWarning) ModelicaError(\"GetReal failed\");
}
#endif", Library="Modelica_0IK4_0TEKNIKER_DCOL_ThermalStorage_LatentStorages_FMI_IceStorageExternalMelting_0Dym", LibraryDirectory="modelica://DCOL/Resources/Library/FMU/IceStorageExtMelt_FMU/binaries",                      __Dymola_CriticalRegion="Modelica_0IK4_0TEKNIKER_DCOL_ThermalStorage_LatentStorages_FMI_IceStorageExternalMelting_0Dym");
    end fmiGetReal;

    function fmiGetIntegerScalar
      input fmiModel fmi;
      input Integer ref;
      input Integer dummy;
      output Integer val;
    algorithm
        val := scalar(fmiGetInteger(fmi, {ref}, dummy));
    end fmiGetIntegerScalar;

    function fmiGetInteger
      input fmiModel fmi;
      input Integer refs[:];
      output Integer vals[size(refs, 1)];
      input Integer preAvailable;
      external"C" Modelica_0IK4_0TEKNIKER_DCOL_ThermalStorage_LatentStorages_FMI_IceStorageExternalMelting_0Dym_fmiGetInteger2(
        fmi,
        refs,
        size(refs, 1),
        vals);
      annotation (Header="
#ifndef Modelica_0IK4_0TEKNIKER_DCOL_ThermalStorage_LatentStorages_FMI_IceStorageExternalMelting_0Dym_GetInteger_C
#define Modelica_0IK4_0TEKNIKER_DCOL_ThermalStorage_LatentStorages_FMI_IceStorageExternalMelting_0Dym_GetInteger_C 1
#include <stdlib.h>
#include \"FMI/fmiImport.h\"
void Modelica_0IK4_0TEKNIKER_DCOL_ThermalStorage_LatentStorages_FMI_IceStorageExternalMelting_0Dym_fmiGetInteger2(void*m, const int*refs, size_t nrefs, int*vals) {
  struct dy_Extended*a=m;
  fmiStatus status=fmiFatal;
  if (a) {
    status=a->dyFmiGetInteger(a->m, refs, nrefs, vals);
  }
  if (status!=fmiOK && status!=fmiWarning) ModelicaError(\"GetInteger failed\");
}
#endif", Library="Modelica_0IK4_0TEKNIKER_DCOL_ThermalStorage_LatentStorages_FMI_IceStorageExternalMelting_0Dym", LibraryDirectory="modelica://DCOL/Resources/Library/FMU/IceStorageExtMelt_FMU/binaries",                      __Dymola_CriticalRegion="Modelica_0IK4_0TEKNIKER_DCOL_ThermalStorage_LatentStorages_FMI_IceStorageExternalMelting_0Dym");
    end fmiGetInteger;

    function fmiSetInteger
    input fmiModel fmi;
      input Integer refs[:];
      input Integer vals[size(refs, 1)];
      output Real dummy= 1;
      external"C" Modelica_0IK4_0TEKNIKER_DCOL_ThermalStorage_LatentStorages_FMI_IceStorageExternalMelting_0Dym_fmiSetInteger2(
        fmi,
        refs,
        size(refs, 1),
        vals);
        annotation (Header="
#ifndef Modelica_0IK4_0TEKNIKER_DCOL_ThermalStorage_LatentStorages_FMI_IceStorageExternalMelting_0Dym_SetInteger_C
#define Modelica_0IK4_0TEKNIKER_DCOL_ThermalStorage_LatentStorages_FMI_IceStorageExternalMelting_0Dym_SetInteger_C 1
#include <stdlib.h>
#include \"FMI/fmiImport.h\"
void Modelica_0IK4_0TEKNIKER_DCOL_ThermalStorage_LatentStorages_FMI_IceStorageExternalMelting_0Dym_fmiSetInteger2(void*m, const int*refs, size_t nrefs, int*vals) {
  struct dy_Extended*a=m;
  fmiStatus status=fmiFatal;
  if(!nrefs){return;}
  if (a) {
    status=a->dyFmiSetInteger(a->m, refs, nrefs, vals);
  }
  if (status!=fmiOK && status!=fmiWarning) ModelicaError(\"SetInteger failed\");
}
#endif", Library="Modelica_0IK4_0TEKNIKER_DCOL_ThermalStorage_LatentStorages_FMI_IceStorageExternalMelting_0Dym", LibraryDirectory="modelica://DCOL/Resources/Library/FMU/IceStorageExtMelt_FMU/binaries",                      __Dymola_CriticalRegion="Modelica_0IK4_0TEKNIKER_DCOL_ThermalStorage_LatentStorages_FMI_IceStorageExternalMelting_0Dym",__Dymola_IdemPotent=true, __Dymola_VectorizedExceptFirst=true);
    end fmiSetInteger;

    function fmiSetIntegerParam
    input fmiModel fmi;
      input Integer refs[:];
      input Integer vals[size(refs, 1)];
    protected
      Integer oldVals[size(refs, 1)];
      external"C" Modelica_0IK4_0TEKNIKER_DCOL_ThermalStorage_LatentStorages_FMI_IceStorageExternalMelting_0Dym_fmiSetIntegerParam2(
        fmi,
        refs,
        size(refs, 1),
        vals,
        oldVals);
        annotation (Header="
#ifndef Modelica_0IK4_0TEKNIKER_DCOL_ThermalStorage_LatentStorages_FMI_IceStorageExternalMelting_0Dym_SetIntegerParam_C
#define Modelica_0IK4_0TEKNIKER_DCOL_ThermalStorage_LatentStorages_FMI_IceStorageExternalMelting_0Dym_SetIntegerParam_C 1
#include <stdlib.h>
#include \"FMI/fmiImport.h\"
void Modelica_0IK4_0TEKNIKER_DCOL_ThermalStorage_LatentStorages_FMI_IceStorageExternalMelting_0Dym_fmiSetIntegerParam2(void*m, const int*refs, size_t nrefs, int*vals, int*oldVals) {
  struct dy_Extended*a=m;
  fmiStatus status=fmiFatal;
  int i=0;
  if(!nrefs){return;}
  if (a) {
    if(a->currentMode == dyInstantiationMode){
      status=a->dyFmiSetInteger(a->m, refs, nrefs, vals);
    }else{
      status=a->dyFmiGetInteger(a->m, refs, nrefs, oldVals);
      for(i = 0; i< nrefs; ++i){
        if(vals[i]!=oldVals[i]){
          ModelicaError(\"SetIntegerParameter: new parameters with diferent values are being set after initialization, this is not allowed\");
        }
      }
    }
  }
  if (status!=fmiOK && status!=fmiWarning) ModelicaError(\"SetInteger failed\");
}
#endif", Library="Modelica_0IK4_0TEKNIKER_DCOL_ThermalStorage_LatentStorages_FMI_IceStorageExternalMelting_0Dym", LibraryDirectory="modelica://DCOL/Resources/Library/FMU/IceStorageExtMelt_FMU/binaries",                      __Dymola_CriticalRegion="Modelica_0IK4_0TEKNIKER_DCOL_ThermalStorage_LatentStorages_FMI_IceStorageExternalMelting_0Dym",__Dymola_IdemPotent=true, __Dymola_VectorizedExceptFirst=true);
    end fmiSetIntegerParam;

    function fmiGetBooleanScalar
      input fmiModel fmi;
      input Integer ref;
      input Integer dummy;
      output Boolean val;
    algorithm
        val := scalar(fmiGetBoolean(fmi, {ref}, dummy));
    end fmiGetBooleanScalar;

    function fmiGetBoolean
      input fmiModel fmi;
      input Integer refs[:];
      output Boolean vals[size(refs, 1)];
      input Integer preAvailable;
      external"C" Modelica_0IK4_0TEKNIKER_DCOL_ThermalStorage_LatentStorages_FMI_IceStorageExternalMelting_0Dym_fmiGetBoolean2(
        fmi,
        refs,
        size(refs, 1),
        vals);
        annotation (Header="
#ifndef Modelica_0IK4_0TEKNIKER_DCOL_ThermalStorage_LatentStorages_FMI_IceStorageExternalMelting_0Dym_GetBoolean_C
#define Modelica_0IK4_0TEKNIKER_DCOL_ThermalStorage_LatentStorages_FMI_IceStorageExternalMelting_0Dym_GetBoolean_C 1
#include \"FMI/fmiImport.h\"
void Modelica_0IK4_0TEKNIKER_DCOL_ThermalStorage_LatentStorages_FMI_IceStorageExternalMelting_0Dym_fmiGetBoolean2(void*m, const int* refs, size_t nr, int* vals) {
  int i;
  struct dy_Extended*a=m;
  fmiStatus status=fmiFatal;
  if (a) {
    status=a->dyFmiGetBoolean(a->m, refs, nr, (fmiBoolean*)(vals));
  }
  if (status!=fmiOK && status!=fmiWarning) ModelicaError(\"GetBoolean failed\");
  for(i=nr-1;i>=0;i--) vals[i]=((fmiBoolean*)(vals))[i];
}
#endif", Library="Modelica_0IK4_0TEKNIKER_DCOL_ThermalStorage_LatentStorages_FMI_IceStorageExternalMelting_0Dym", LibraryDirectory="modelica://DCOL/Resources/Library/FMU/IceStorageExtMelt_FMU/binaries",                      __Dymola_CriticalRegion="Modelica_0IK4_0TEKNIKER_DCOL_ThermalStorage_LatentStorages_FMI_IceStorageExternalMelting_0Dym");
    end fmiGetBoolean;

    function fmiSetBoolean
      input fmiModel fmi;
      input Integer refs[:];
      input Boolean vals[size(refs, 1)];
      output Real dummy2= 1;
    protected
      Boolean dummy[size(refs, 1)];
      external"C" Modelica_0IK4_0TEKNIKER_DCOL_ThermalStorage_LatentStorages_FMI_IceStorageExternalMelting_0Dym_fmiSetBoolean2(
        fmi,
        refs,
        size(refs, 1),
        vals,
        dummy);
        annotation (Header="
#ifndef Modelica_0IK4_0TEKNIKER_DCOL_ThermalStorage_LatentStorages_FMI_IceStorageExternalMelting_0Dym_SetBoolean_C
#define Modelica_0IK4_0TEKNIKER_DCOL_ThermalStorage_LatentStorages_FMI_IceStorageExternalMelting_0Dym_SetBoolean_C 1
#include \"FMI/fmiImport.h\"
void Modelica_0IK4_0TEKNIKER_DCOL_ThermalStorage_LatentStorages_FMI_IceStorageExternalMelting_0Dym_fmiSetBoolean2(void*m, const int* refs, size_t nr, const int* vals,int*dummy) {
  int i;
  struct dy_Extended*a=m;
  fmiStatus status=fmiFatal;
  if(!nr){return;}
  for(i=0;i<nr;++i) ((fmiBoolean*)(dummy))[i]=vals[i];
  if (a) {
    status=a->dyFmiSetBoolean(a->m, refs, nr, (fmiBoolean*)(dummy));
  }
  if (status!=fmiOK && status!=fmiWarning) ModelicaError(\"SetBoolean failed\");
}
#endif", Library="Modelica_0IK4_0TEKNIKER_DCOL_ThermalStorage_LatentStorages_FMI_IceStorageExternalMelting_0Dym", LibraryDirectory="modelica://DCOL/Resources/Library/FMU/IceStorageExtMelt_FMU/binaries",                      __Dymola_CriticalRegion="Modelica_0IK4_0TEKNIKER_DCOL_ThermalStorage_LatentStorages_FMI_IceStorageExternalMelting_0Dym",__Dymola_IdemPotent=true, __Dymola_VectorizedExceptFirst=true);
    end fmiSetBoolean;

    function fmiSetBooleanParam
      input fmiModel fmi;
      input Integer refs[:];
      input Boolean vals[size(refs, 1)];
    protected
      Boolean dummy[size(refs, 1)];
      Boolean oldVals[size(refs, 1)];
      external"C" Modelica_0IK4_0TEKNIKER_DCOL_ThermalStorage_LatentStorages_FMI_IceStorageExternalMelting_0Dym_fmiSetBooleanParam2(
      fmi,
        refs,
        size(refs, 1),
        vals,
        dummy,
        oldVals);
        annotation (Header="
#ifndef Modelica_0IK4_0TEKNIKER_DCOL_ThermalStorage_LatentStorages_FMI_IceStorageExternalMelting_0Dym_SetBooleanParam_C
#define Modelica_0IK4_0TEKNIKER_DCOL_ThermalStorage_LatentStorages_FMI_IceStorageExternalMelting_0Dym_SetBooleanParam_C 1
#include \"FMI/fmiImport.h\"
void Modelica_0IK4_0TEKNIKER_DCOL_ThermalStorage_LatentStorages_FMI_IceStorageExternalMelting_0Dym_fmiSetBooleanParam2(void*m, const int* refs, size_t nr, const int* vals,int*dummy,int*oldVals) {
  int i;
  struct dy_Extended*a=m;
  fmiStatus status=fmiFatal;
  if(!nr){return;}
  for(i=0;i<nr;++i) ((fmiBoolean*)(dummy))[i]=vals[i];
  if (a) {
    if(a->currentMode == dyInstantiationMode){
      status=a->dyFmiSetBoolean(a->m, refs, nr, (fmiBoolean*)(dummy));
    }else{
      status=a->dyFmiGetBoolean(a->m, refs, nr, (fmiBoolean*)(oldVals));
      for(i=nr-1;i>=0;i--){
        oldVals[i]=((fmiBoolean*)(oldVals))[i];
        if(oldVals[i]!=dummy[i]){
          ModelicaError(\"SetIntegerParameter: new parameters with diferent values are being set after initialization, this is not allowed\");
        }
      }
    }
  }
  if (status!=fmiOK && status!=fmiWarning) ModelicaError(\"SetBoolean failed\");
}
#endif", Library="Modelica_0IK4_0TEKNIKER_DCOL_ThermalStorage_LatentStorages_FMI_IceStorageExternalMelting_0Dym", LibraryDirectory="modelica://DCOL/Resources/Library/FMU/IceStorageExtMelt_FMU/binaries",                      __Dymola_CriticalRegion="Modelica_0IK4_0TEKNIKER_DCOL_ThermalStorage_LatentStorages_FMI_IceStorageExternalMelting_0Dym",__Dymola_IdemPotent=true, __Dymola_VectorizedExceptFirst=true);
    end fmiSetBooleanParam;

    function fmiGetString
      input fmiModel fmi;
      input Integer refs[:];
      output String vals[size(refs, 1)];
      input Integer preAvailable;
      external"C" Modelica_0IK4_0TEKNIKER_DCOL_ThermalStorage_LatentStorages_FMI_IceStorageExternalMelting_0Dym_fmiGetString2(
        fmi,
        refs,
        size(refs, 1),
        vals);
      annotation (Header="
#ifndef Modelica_0IK4_0TEKNIKER_DCOL_ThermalStorage_LatentStorages_FMI_IceStorageExternalMelting_0Dym_GetString_C
#define Modelica_0IK4_0TEKNIKER_DCOL_ThermalStorage_LatentStorages_FMI_IceStorageExternalMelting_0Dym_GetString_C 1
#include <stdlib.h>
#include \"FMI/fmiImport.h\"
void Modelica_0IK4_0TEKNIKER_DCOL_ThermalStorage_LatentStorages_FMI_IceStorageExternalMelting_0Dym_fmiGetString2(void*m, const int*refs, size_t nrefs, fmiString* vals) {
  struct dy_Extended*a=m;
  fmiStatus status=fmiFatal;
  if (a) {
    status=a->dyFmiGetString(a->m, refs, nrefs, vals);
  }
  if (status!=fmiOK && status!=fmiWarning) ModelicaError(\"StringInteger failed\");
}
#endif", Library="Modelica_0IK4_0TEKNIKER_DCOL_ThermalStorage_LatentStorages_FMI_IceStorageExternalMelting_0Dym", LibraryDirectory="modelica://DCOL/Resources/Library/FMU/IceStorageExtMelt_FMU/binaries",                      __Dymola_CriticalRegion="Modelica_0IK4_0TEKNIKER_DCOL_ThermalStorage_LatentStorages_FMI_IceStorageExternalMelting_0Dym");
    end fmiGetString;

    function fmiSetString
    input fmiModel fmi;
      input Integer refs[:];
      input String vals[size(refs, 1)];
      external"C" Modelica_0IK4_0TEKNIKER_DCOL_ThermalStorage_LatentStorages_FMI_IceStorageExternalMelting_0Dym_fmiSetString2(
        fmi,
        refs,
        size(refs, 1),
        vals);
        annotation (Header="
#ifndef Modelica_0IK4_0TEKNIKER_DCOL_ThermalStorage_LatentStorages_FMI_IceStorageExternalMelting_0Dym_SetString_C
#define Modelica_0IK4_0TEKNIKER_DCOL_ThermalStorage_LatentStorages_FMI_IceStorageExternalMelting_0Dym_SetString_C 1
#include \"FMI/fmiImport.h\"
#include <stdlib.h>
void Modelica_0IK4_0TEKNIKER_DCOL_ThermalStorage_LatentStorages_FMI_IceStorageExternalMelting_0Dym_fmiSetString2(void*m, const int*refs, size_t nrefs, const fmiString vals[]) {
  struct dy_Extended*a=m;
  fmiStatus status=fmiFatal;
  if(!nrefs){return;}
  if (a) {
    status=a->dyFmiSetString(a->m, refs, nrefs, vals);
  }
  if (status!=fmiOK && status!=fmiWarning) ModelicaError(\"SetString failed\");
}
#endif", Library="Modelica_0IK4_0TEKNIKER_DCOL_ThermalStorage_LatentStorages_FMI_IceStorageExternalMelting_0Dym", LibraryDirectory="modelica://DCOL/Resources/Library/FMU/IceStorageExtMelt_FMU/binaries",                      __Dymola_CriticalRegion="Modelica_0IK4_0TEKNIKER_DCOL_ThermalStorage_LatentStorages_FMI_IceStorageExternalMelting_0Dym",__Dymola_IdemPotent=true, __Dymola_VectorizedExceptFirst=true);
    end fmiSetString;

    function fmiSetStringParam
    input fmiModel fmi;
      input Integer refs[:];
      input String vals[size(refs, 1)];
      external"C" Modelica_0IK4_0TEKNIKER_DCOL_ThermalStorage_LatentStorages_FMI_IceStorageExternalMelting_0Dym_fmiSetStringParam2(
        fmi,
        refs,
        size(refs, 1),
        vals);
        annotation (Header="
#ifndef Modelica_0IK4_0TEKNIKER_DCOL_ThermalStorage_LatentStorages_FMI_IceStorageExternalMelting_0Dym_SetStringParam_C
#define Modelica_0IK4_0TEKNIKER_DCOL_ThermalStorage_LatentStorages_FMI_IceStorageExternalMelting_0Dym_SetStringParam_C 1
#include \"FMI/fmiImport.h\"
#include <stdlib.h>
void Modelica_0IK4_0TEKNIKER_DCOL_ThermalStorage_LatentStorages_FMI_IceStorageExternalMelting_0Dym_fmiSetStringParam2(void*m, const int*refs, size_t nrefs, const fmiString vals[]) {
  struct dy_Extended*a=m;
  fmiStatus status=fmiFatal;
  if(!nrefs){return;}
  if (a) {
    if(a->currentMode == dyInstantiationMode){
		status=a->dyFmiSetString(a->m, refs, nrefs, vals);
    }else{
      status=fmiOK;
    }
  }
  if (status!=fmiOK && status!=fmiWarning) ModelicaError(\"SetString failed\");
}
#endif", Library="Modelica_0IK4_0TEKNIKER_DCOL_ThermalStorage_LatentStorages_FMI_IceStorageExternalMelting_0Dym", LibraryDirectory="modelica://DCOL/Resources/Library/FMU/IceStorageExtMelt_FMU/binaries",                      __Dymola_CriticalRegion="Modelica_0IK4_0TEKNIKER_DCOL_ThermalStorage_LatentStorages_FMI_IceStorageExternalMelting_0Dym",__Dymola_IdemPotent=true, __Dymola_VectorizedExceptFirst=true);
    end fmiSetStringParam;

    function noHysteresis
      input Real x;
      output Real y;
    algorithm
      y:=x+(if (x < 0) then -1 else 1);
    end noHysteresis;
end fmi_Functions;
equation
  when initial() then
    fmi = fmi_Functions.fmiModel(fmi_instanceName, fmi_loggingOn, fmi_fmuLocation);
  end when;
algorithm
  when {initial(), sample(fmi_StartTime, fmi_CommunicationStepSize)} then
    if time>=fmi_CommunicationStepSize +fmi_StartTime then
    if fmi_InputTime then
      fmi_Functions.fmiSetReal(fmi, {352321536}, {_ambient_T_old});
    else
      if fmi_UsePreOnInputSignals then
        fmi_Functions.fmiSetReal(fmi, {352321536}, {pre(ambient_T)});
      else
        fmi_Functions.fmiSetReal(fmi, {352321536}, {ambient_T});
      end if;
    end if;
    if fmi_InputTime then
      fmi_Functions.fmiSetReal(fmi, {352321537}, {_water_in_m_flow_old});
    else
      if fmi_UsePreOnInputSignals then
        fmi_Functions.fmiSetReal(fmi, {352321537}, {pre(water_in_m_flow)});
      else
        fmi_Functions.fmiSetReal(fmi, {352321537}, {water_in_m_flow});
      end if;
    end if;
    if fmi_InputTime then
      fmi_Functions.fmiSetReal(fmi, {352321538}, {_water_inlet_T_old});
    else
      if fmi_UsePreOnInputSignals then
        fmi_Functions.fmiSetReal(fmi, {352321538}, {pre(water_inlet_T)});
      else
        fmi_Functions.fmiSetReal(fmi, {352321538}, {water_inlet_T});
      end if;
    end if;
    if fmi_InputTime then
      fmi_Functions.fmiSetReal(fmi, {352321539}, {_HTF_m_flow_old});
    else
      if fmi_UsePreOnInputSignals then
        fmi_Functions.fmiSetReal(fmi, {352321539}, {pre(HTF_m_flow)});
      else
        fmi_Functions.fmiSetReal(fmi, {352321539}, {HTF_m_flow});
      end if;
    end if;
    if fmi_InputTime then
      fmi_Functions.fmiSetReal(fmi, {352321540}, {_HTF_inlet_T_old});
    else
      if fmi_UsePreOnInputSignals then
        fmi_Functions.fmiSetReal(fmi, {352321540}, {pre(HTF_inlet_T)});
      else
        fmi_Functions.fmiSetReal(fmi, {352321540}, {HTF_inlet_T});
      end if;
    end if;
      for stepSizeIndex in 1:stepSizeScaleFactor loop
        fmi_StepOK :=fmi_Functions.fmiDoStep(
          fmi,
          time + (stepSizeIndex - 1 - stepSizeScaleFactor)*
            fmi_CommunicationStepSize/stepSizeScaleFactor,
          fmi_CommunicationStepSize/stepSizeScaleFactor);
      end for;
    end if;
    _ambient_T_old := ambient_T;
    _water_in_m_flow_old := water_in_m_flow;
    _water_inlet_T_old := water_inlet_T;
    _HTF_m_flow_old := HTF_m_flow;
    _HTF_inlet_T_old := HTF_inlet_T;
  HTF_outlet_T :=fmi_Functions.fmiGetRealScalar(
      fmi,
      335544320,
      1);
  PCM_T :=fmi_Functions.fmiGetRealScalar(
      fmi,
      335544321,
      1);
  water_outlet_T :=fmi_Functions.fmiGetRealScalar(
      fmi,
      335544322,
      1);
  water_out_m_flow :=fmi_Functions.fmiGetRealScalar(
      fmi,
      335544323,
      1);
RealVariables1 :=fmi_Functions.fmiGetReal(
      fmi,
      {16777243,100663324,16777244,16777243,16777244,335544323,16777243,
        369098807,369098808,369098809,369098810,369098811,369098812,369098813,
        369098814,369098815,369098816,369098817,369098818,369098819,369098820,
        369098821,369098822,369098823,369098824,369098825,369098826,335544321,
        369098837,335544321,369098838,335544321,369098839,335544321,369098840,
        335544321,369098841,335544321,369098842,335544321,369098843,335544321,
        369098844,335544321,369098845,335544321,369098846,335544321,369098847,
        335544321,369098848,335544321,369098849,335544321,369098850,335544321,
        369098851,335544321,369098852,335544321,369098853,335544321,369098854,
        335544321,369098855,335544321,369098856,352321537,16777243,369099583,
        369098857,16777243,369098898,335544321,369098866,369098867,369098868,
        369098869,369098870,369098871,369098872,369098873,369098874,369098875,
        100663402,369098884,369098885,905969798,369098887,369098888,369098890,
        369098891,905969804,369098893,369098894,905969807,905969809,352321537,
        369099583,335544321},
      1);
RealVariables2 :=fmi_Functions.fmiGetReal(
      fmi,
      {335544323,369098898,352321537,16777243,369099583,369098857,16777243,
        369098898,352321536,905969811,352321539,369099560,369098900,369098901,
        369098902,16777283,369098903,369098904,352321539,369099560,369098900,
        369098902,16777283,369098903,905969858,369098956,905969859,369098957,
        905969860,369098958,905969861,369098959,905969862,369098960,905969863,
        369098961,905969864,369098962,905969865,369098963,905969866,369098964,
        905969867,369098965,369098966,369098976,369098967,369098977,369098968,
        369098978,369098969,369098979,369098970,369098980,369098971,369098981,
        369098972,369098982,369098973,369098983,369098974,369098984,369098975,
        369098985,369098976,369098977,369098978,369098979,369098980,369098981,
        369098982,369098983,369098984,369098985,369098986,369098987,369098988,
        369098989,369098990,369098991,369098992,369098993,369098994,369098995,
        369098996,369098997,369098998,369098999,369099000,369099001,369099002,
        369099003,369099004,369099005,369099006,369099007,369099008,369099009,
        369099010,369099011},
      1);
RealVariables3 :=fmi_Functions.fmiGetReal(
      fmi,
      {369099012,369099013,369099014,369099015,905969988,369099560,16777283,
        33554442,369099560,33554443,369099078,33554444,369099079,33554445,
        369099080,33554446,369099081,33554447,369099082,33554448,369099083,
        33554449,369099084,33554450,369099085,33554451,16777283,33554442,
        369099560,33554443,369099078,33554444,369099079,33554445,369099080,
        33554446,369099081,33554447,369099082,33554448,369099083,33554449,
        369099084,33554450,369099085,33554451,16777283,369099260,369099261,
        369099262,369099263,369099264,369099265,369099266,369099267,369099268,
        369099269,100663570,100663571,100663572,100663573,100663574,100663575,
        100663576,100663577,100663578,100663579,100663580,100663581,100663582,
        100663583,100663584,100663585,100663586,100663587,100663588,100663589,
        100663590,100663591,100663592,100663593,100663594,100663595,100663596,
        100663597,100663598,100663599,369099239,369099240,369099241,369099242,
        369099243,369099244,369099245,369099246,369099247,905970026,905970027,
        905970028,905970029},
      1);
RealVariables4 :=fmi_Functions.fmiGetReal(
      fmi,
      {905970030,905970031,905970032,905970033,905970034,369099132,369099133,
        369099134,369099135,369099136,369099137,369099138,369099139,369099140,
        369099141,369099142,369099143,369099144,369099145,369099146,369099147,
        369099148,369099149,369099152,369099153,369099154,369099155,369099156,
        369099157,369099158,369099159,369099160,369099161,905970074,905970075,
        905970076,905970077,905970078,905970079,905970080,905970081,905970082,
        369099171,369099172,369099173,369099174,369099175,369099176,369099177,
        369099178,369099179,369099180,905970093,905970094,905970095,905970096,
        905970097,905970098,905970099,905970100,905970101,369099190,369099191,
        369099192,369099193,369099194,369099195,369099196,369099197,369099198,
        352321539,369099239,369099240,369099241,369099242,369099243,369099244,
        369099245,369099246,369099247,369099248,369099249,369099250,369099251,
        369099252,369099253,369099254,369099255,369099256,369099257,369099258,
        369099259,369099260,369099261,369099262,369099263,369099264,369099265,
        369099266,369099267},
      1);
RealVariables5 :=fmi_Functions.fmiGetReal(
      fmi,
      {369099268,369099269,33554442,369098996,33554443,369098997,33554444,
        369098998,33554445,369098999,33554446,369099000,33554447,369099001,
        33554448,369099002,33554449,369099003,33554450,369099004,33554451,
        369099005,33554442,369099560,33554443,369099078,33554444,369099079,
        33554445,369099080,33554446,369099081,33554447,369099082,33554448,
        369099083,33554449,369099084,33554450,369099085,33554451,16777283,
        369098996,369098997,369098998,369098999,369099000,369099001,369099002,
        369099003,369099004,369099005,33554442,369098996,33554443,369098997,
        33554444,369098998,33554445,369098999,33554446,369099000,33554447,
        369099001,33554448,369099002,33554449,369099003,33554450,369099004,
        33554451,369099005,33554442,33554443,33554444,33554445,33554446,
        33554447,33554448,33554449,33554450,33554451,369099260,369099261,
        369099262,369099263,369099264,369099265,369099266,369099267,369099268,
        369099269,100663580,100663581,100663582,100663583,100663584,100663585,
        100663586,100663587},
      1);
RealVariables6 :=fmi_Functions.fmiGetReal(
      fmi,
      {100663588,100663589,100663590,100663591,100663592,100663593,100663594,
        100663595,100663596,100663597,100663598,100663599,369099560,369098900,
        369099620,369099621,33554442,318767114,369099623,369099624,33554442,
        369099560,369099629,905970542,905970543,369099078,369099632,369099633,
        369099634,369099635,33554443,318767115,369099637,369099638,33554443,
        369099078,369099643,905970556,905970557,369099079,369099646,369099647,
        369099648,369099649,33554444,318767116,369099651,369099652,33554444,
        369099079,369099657,905970570,905970571,369099080,369099660,369099661,
        369099662,369099663,33554445,318767117,369099665,369099666,33554445,
        369099080,369099671,905970584,905970585,369099081,369099674,369099675,
        369099676,369099677,33554446,318767118,369099679,369099680,33554446,
        369099081,369099685,905970598,905970599,369099082,369099688,369099689,
        369099690,369099691,33554447,318767119,369099693,369099694,33554447,
        369099082,369099699,905970612,905970613,369099083,369099702,369099703,
        369099704,369099705},
      1);
RealVariables7 :=fmi_Functions.fmiGetReal(
      fmi,
      {33554448,318767120,369099707,369099708,33554448,369099083,369099713,
        905970626,905970627,369099084,369099716,369099717,369099718,369099719,
        33554449,318767121,369099721,369099722,33554449,369099084,369099727,
        905970640,905970641,369099085,369099730,369099731,369099732,369099733,
        33554450,318767122,369099735,369099736,33554450,369099085,369099741,
        905970654,905970655,16777283,369098903,369099744,369099745,33554451,
        318767123,369099747,369099748,33554451,16777283,369099753,905970667,
        369099327,369099328,33554442,369099327,33554432,369098996,369099329,
        369098847,369099330,33554432,369098847,335544321,369099331,369099332,
        33554432,587202560,637534789,33554432,637534789,587202560,637534792,
        33554442,369099327,335544321,369099331,369098807,369098817,369099341,
        369099342,33554443,369099341,33554433,369098997,369099343,369098848,
        369099344,33554433,369098848,335544321,369099345,369099346,33554433,
        587202561,637534803,33554433,637534803,587202561,637534806,33554443,
        369099341,335544321},
      1);
RealVariables8 :=fmi_Functions.fmiGetReal(
      fmi,
      {369099345,369098808,369098818,369099355,369099356,33554444,369099355,
        33554434,369098998,369099357,369098849,369099358,33554434,369098849,
        335544321,369099359,369099360,33554434,587202562,637534817,33554434,
        637534817,587202562,637534820,33554444,369099355,335544321,369099359,
        369098809,369098819,369099369,369099370,33554445,369099369,33554435,
        369098999,369099371,369098850,369099372,33554435,369098850,335544321,
        369099373,369099374,33554435,587202563,637534831,33554435,637534831,
        587202563,637534834,33554445,369099369,335544321,369099373,369098810,
        369098820,369099383,369099384,33554446,369099383,33554436,369099000,
        369099385,369098851,369099386,33554436,369098851,335544321,369099387,
        369099388,33554436,587202564,637534845,33554436,637534845,587202564,
        637534848,33554446,369099383,335544321,369099387,369098811,369098821,
        369099397,369099398,33554447,369099397,33554437,369099001,369099399,
        369098852,369099400,33554437,369098852,335544321,369099401,369099402,
        33554437,587202565},
      1);
RealVariables9 :=fmi_Functions.fmiGetReal(
      fmi,
      {637534859,33554437,637534859,587202565,637534862,33554447,369099397,
        335544321,369099401,369098812,369098822,369099411,369099412,33554448,
        369099411,33554438,369099002,369099413,369098853,369099414,33554438,
        369098853,335544321,369099415,369099416,33554438,587202566,637534873,
        33554438,637534873,587202566,637534876,33554448,369099411,335544321,
        369099415,369098813,369098823,369099425,369099426,33554449,369099425,
        33554439,369099003,369099427,369098854,369099428,33554439,369098854,
        335544321,369099429,369099430,33554439,587202567,637534887,33554439,
        637534887,587202567,637534890,33554449,369099425,335544321,369099429,
        369098814,369098824,369099439,369099440,33554450,369099439,33554440,
        369099004,369099441,369098855,369099442,33554440,369098855,335544321,
        369099443,369099444,33554440,587202568,637534901,33554440,637534901,
        587202568,637534904,33554450,369099439,335544321,369099443,369098815,
        369098825,369099453,369099454,33554451,369099453,33554441,369099005,
        369099455,369098856},
      1);
RealVariables10 :=fmi_Functions.fmiGetReal(
      fmi,
      {369099456,33554441,369098856,335544321,369099457,369099458,33554441,
        587202569,637534915,33554441,637534915,587202569,637534918,33554451,
        369099453,335544321,369099457,369098816,369098826,369098817,369098818,
        369098819,369098820,369098821,369098822,369098823,369098824,369098825,
        369098826,369098807,369098808,369098809,369098810,369098811,369098812,
        369098813,369098814,369098815,369098816,369099464,369099465,335544321,
        369099464,352321536,369098837,369099466,369099467,335544321,369099466,
        352321536,369098838,369099468,369099469,335544321,369099468,352321536,
        369098839,369099470,369099471,335544321,369099470,352321536,369098840,
        369099472,369099473,335544321,369099472,352321536,369098841,369099474,
        369099475,335544321,369099474,352321536,369098842,369099476,369099477,
        335544321,369099476,352321536,369098843,369099478,369099479,335544321,
        369099478,352321536,369098844,369099480,369099481,335544321,369099480,
        352321536,369098845,369099482,369099483,335544321,369099482,352321536,
        369098846,335544321},
      1);
RealVariables11 :=fmi_Functions.fmiGetReal(
      fmi,
      {369099484,369099485,369099486,369099487,369099488,369099489,369099490,
        369099491,369099492,369099493,369099494,369099495,369099496,369099497,
        369099498,369099499,369099500,369099501,369099502,369099503,369099504,
        369099505,369099506,369099507,369099508,369099509,369099510,369099511,
        369099512,369099513,369099514,100664091,369099515,369099517,905970432,
        905970433,369099522,369099524,369099525,369099526,369099527,369099528,
        369099529,369099530,369099531,369099532,369099533,369099534,369099535,
        369099536,369099537,369099538,369099539,369099540,369099541,369099542,
        369099543,369099560,369099561,905970461,352321540,905970463,352321540,
        369099560,905970468,905970469,905970470,905970471,369099560,369099561,
        352321539,352321540,16777243,369099583,352321538,905970486,16777243,
        352321538,905970491,905970493,369099583,352321537,352321538,16777283,
        100664148,16777284,16777284,16777283,369099248,16777283,352321536,
        905970522,352321536,16777243,335544322,16777283,335544320,335544323,
        16777243,100663324},
      1);
RealVariables12 :=fmi_Functions.fmiGetReal(
      fmi,
      {369098857,16777243,369098898,335544323},
      1);
BooleanVariables :=fmi_Functions.fmiGetBoolean(
      fmi,
      {369098805,369098806,369098805},
      1);
  end when;
initial algorithm
  fmi_AParamsAndStart:=1;
 // 75 Real parameters
  fmi_Functions.fmiSetRealParam(fmi, {16777216, 16777217, 16777218, 16777219, 16777220, 16777221, 16777223, 16777224, 16777225, 16777226, 16777227, 16777228, 16777229, 16777230, 16777231, 16777232, 16777233, 16777234, 16777235, 16777236, 16777237, 16777238, 16777239, 16777240, 16777243, 16777244, 16777245, 16777246, 16777248, 16777249, 16777289, 16777290, 16777291, 16777292, 16777293, 16777294, 16777295, 16777296, 16777297, 16777298, 16777251, 16777252, 16777253, 16777254, 16777255, 16777256, 16777257, 16777258, 16777259, 16777260, 16777261, 16777262, 16777263, 16777264, 16777265, 16777266, 16777267, 16777268, 16777269, 16777270, 16777271, 16777272, 16777273, 16777274, 16777275, 16777276, 16777277, 16777278, 16777279, 16777280, 16777281, 16777282, 16777283, 16777284, 16777285}, {'system'.p_ambient, 'system'.T_ambient, 'system'.g, 'system'.eps_m_flow, 'system'.dp_small, 'system'.m_flow_small, hfus, Cp_PCMs, Cp_PCMl, rho_solid, rho_liquid, D_tube_in, p_PCM, D_tube_out, a, b, h, w, e, k_PCMs, h_PCMl, k_PCMl, h_HTF, x_liquid_start, outlet_water.p, outlet_water.T, outlet_water.h, outlet_water.'X[1]', iceStorageExternalMelt_nSegnCoilp.pipe.roughness, iceStorageExternalMelt_nSegnCoilp.pipe.'X_start[1]', iceStorageExternalMelt_nSegnCoilp.pipe.'mediums[1]'.T_start, iceStorageExternalMelt_nSegnCoilp.pipe.'mediums[2]'.T_start, iceStorageExternalMelt_nSegnCoilp.pipe.'mediums[3]'.T_start, iceStorageExternalMelt_nSegnCoilp.pipe.'mediums[4]'.T_start, iceStorageExternalMelt_nSegnCoilp.pipe.'mediums[5]'.T_start, iceStorageExternalMelt_nSegnCoilp.pipe.'mediums[6]'.T_start, iceStorageExternalMelt_nSegnCoilp.pipe.'mediums[7]'.T_start, iceStorageExternalMelt_nSegnCoilp.pipe.'mediums[8]'.T_start, iceStorageExternalMelt_nSegnCoilp.pipe.'mediums[9]'.T_start, iceStorageExternalMelt_nSegnCoilp.pipe.'mediums[10]'.T_start, iceStorageExternalMelt_nSegnCoilp.'hTFtoPCM[1]'.TubeInertia.T_start, iceStorageExternalMelt_nSegnCoilp.'hTFtoPCM[1]'.TubeInertia.der_T_start, iceStorageExternalMelt_nSegnCoilp.'hTFtoPCM[2]'.TubeInertia.T_start, iceStorageExternalMelt_nSegnCoilp.'hTFtoPCM[2]'.TubeInertia.der_T_start, iceStorageExternalMelt_nSegnCoilp.'hTFtoPCM[3]'.TubeInertia.T_start, iceStorageExternalMelt_nSegnCoilp.'hTFtoPCM[3]'.TubeInertia.der_T_start, iceStorageExternalMelt_nSegnCoilp.'hTFtoPCM[4]'.TubeInertia.T_start, iceStorageExternalMelt_nSegnCoilp.'hTFtoPCM[4]'.TubeInertia.der_T_start, iceStorageExternalMelt_nSegnCoilp.'hTFtoPCM[5]'.TubeInertia.T_start, iceStorageExternalMelt_nSegnCoilp.'hTFtoPCM[5]'.TubeInertia.der_T_start, iceStorageExternalMelt_nSegnCoilp.'hTFtoPCM[6]'.TubeInertia.T_start, iceStorageExternalMelt_nSegnCoilp.'hTFtoPCM[6]'.TubeInertia.der_T_start, iceStorageExternalMelt_nSegnCoilp.'hTFtoPCM[7]'.TubeInertia.T_start, iceStorageExternalMelt_nSegnCoilp.'hTFtoPCM[7]'.TubeInertia.der_T_start, iceStorageExternalMelt_nSegnCoilp.'hTFtoPCM[8]'.TubeInertia.T_start, iceStorageExternalMelt_nSegnCoilp.'hTFtoPCM[8]'.TubeInertia.der_T_start, iceStorageExternalMelt_nSegnCoilp.'hTFtoPCM[9]'.TubeInertia.T_start, iceStorageExternalMelt_nSegnCoilp.'hTFtoPCM[9]'.TubeInertia.der_T_start, iceStorageExternalMelt_nSegnCoilp.'hTFtoPCM[10]'.TubeInertia.T_start, iceStorageExternalMelt_nSegnCoilp.'hTFtoPCM[10]'.TubeInertia.der_T_start, iceStorageExternalMelt_nSegnCoilp.'thermalConductor[1]'.G, iceStorageExternalMelt_nSegnCoilp.'thermalConductor[2]'.G, iceStorageExternalMelt_nSegnCoilp.'thermalConductor[3]'.G, iceStorageExternalMelt_nSegnCoilp.'thermalConductor[4]'.G, iceStorageExternalMelt_nSegnCoilp.'thermalConductor[5]'.G, iceStorageExternalMelt_nSegnCoilp.'thermalConductor[6]'.G, iceStorageExternalMelt_nSegnCoilp.'thermalConductor[7]'.G, iceStorageExternalMelt_nSegnCoilp.'thermalConductor[8]'.G, iceStorageExternalMelt_nSegnCoilp.'thermalConductor[9]'.G, iceStorageExternalMelt_nSegnCoilp.'thermalConductor[10]'.G, inlet_HTF.medium.T_start, outlet_HTF.medium.T_start, outlet_HTF.p, outlet_HTF.T, outlet_HTF.'X[1]'});
 // 20 Real start values
  fmi_Functions.fmiSetRealParam(fmi, {33554442, 33554443, 33554444, 33554445, 33554446, 33554447, 33554448, 33554449, 33554450, 33554451, 33554432, 33554433, 33554434, 33554435, 33554436, 33554437, 33554438, 33554439, 33554440, 33554441}, {iceStorageExternalMelt_nSegnCoilp.pipe.'mediums[1]'._T_start, iceStorageExternalMelt_nSegnCoilp.pipe.'mediums[2]'._T_start, iceStorageExternalMelt_nSegnCoilp.pipe.'mediums[3]'._T_start, iceStorageExternalMelt_nSegnCoilp.pipe.'mediums[4]'._T_start, iceStorageExternalMelt_nSegnCoilp.pipe.'mediums[5]'._T_start, iceStorageExternalMelt_nSegnCoilp.pipe.'mediums[6]'._T_start, iceStorageExternalMelt_nSegnCoilp.pipe.'mediums[7]'._T_start, iceStorageExternalMelt_nSegnCoilp.pipe.'mediums[8]'._T_start, iceStorageExternalMelt_nSegnCoilp.pipe.'mediums[9]'._T_start, iceStorageExternalMelt_nSegnCoilp.pipe.'mediums[10]'._T_start, iceStorageExternalMelt_nSegnCoilp.'hTFtoPCM[1]'.TubeInertia._T_start, iceStorageExternalMelt_nSegnCoilp.'hTFtoPCM[2]'.TubeInertia._T_start, iceStorageExternalMelt_nSegnCoilp.'hTFtoPCM[3]'.TubeInertia._T_start, iceStorageExternalMelt_nSegnCoilp.'hTFtoPCM[4]'.TubeInertia._T_start, iceStorageExternalMelt_nSegnCoilp.'hTFtoPCM[5]'.TubeInertia._T_start, iceStorageExternalMelt_nSegnCoilp.'hTFtoPCM[6]'.TubeInertia._T_start, iceStorageExternalMelt_nSegnCoilp.'hTFtoPCM[7]'.TubeInertia._T_start, iceStorageExternalMelt_nSegnCoilp.'hTFtoPCM[8]'.TubeInertia._T_start, iceStorageExternalMelt_nSegnCoilp.'hTFtoPCM[9]'.TubeInertia._T_start, iceStorageExternalMelt_nSegnCoilp.'hTFtoPCM[10]'.TubeInertia._T_start});
 // 1 Integer parameters
  fmi_Functions.fmiSetIntegerParam(fmi, {16777222}, {nCoilp});
 // 0 Integer start values
 // 2 Boolean parameters
  fmi_Functions.fmiSetBooleanParam(fmi, {16777241, 16777242}, {Charging_start, Charged_start});
 // 0 Boolean start values
 // 0 Enumeration parameters
 // 0 Enumeration start values
 // 0 String parameters
initial equation
if fmi_pullInputsForInitialization then fmi_initInput0 = fmi_Functions.fmiSetReal(fmi, {352321536}, {pre(ambient_T)}); else fmi_initInput0 = fmi_Functions.fmiSetReal(fmi, {352321536}, {_ambient_T_start}); end if;
if fmi_pullInputsForInitialization then fmi_initInput1 = fmi_Functions.fmiSetReal(fmi, {352321537}, {pre(water_in_m_flow)}); else fmi_initInput1 = fmi_Functions.fmiSetReal(fmi, {352321537}, {_water_in_m_flow_start}); end if;
if fmi_pullInputsForInitialization then fmi_initInput2 = fmi_Functions.fmiSetReal(fmi, {352321538}, {pre(water_inlet_T)}); else fmi_initInput2 = fmi_Functions.fmiSetReal(fmi, {352321538}, {_water_inlet_T_start}); end if;
if fmi_pullInputsForInitialization then fmi_initInput3 = fmi_Functions.fmiSetReal(fmi, {352321539}, {pre(HTF_m_flow)}); else fmi_initInput3 = fmi_Functions.fmiSetReal(fmi, {352321539}, {_HTF_m_flow_start}); end if;
if fmi_pullInputsForInitialization then fmi_initInput4 = fmi_Functions.fmiSetReal(fmi, {352321540}, {pre(HTF_inlet_T)}); else fmi_initInput4 = fmi_Functions.fmiSetReal(fmi, {352321540}, {_HTF_inlet_T_start}); end if;
  fmi_Initialized = fmi_Functions.fmiInitializeSlave(fmi, fmi_StartTime, fmi_forceShutDownAtStopTime, fmi_StopTime,fmi_AParamsAndStart+ fmi_initInput0+ fmi_initInput1+ fmi_initInput2+ fmi_initInput3+ fmi_initInput4);
RealDependentParameters1 = fmi_Functions.fmiGetReal(fmi, {100663303, 100663304, 100663306, 100663317, 100663322, 100663323, 100663324, 100663332, 100663333, 100663334, 100663335, 100663336, 100663338, 100663341, 100663342, 100663344, 100663345, 100663346, 100663347, 100663348, 100663374, 100663402, 100663403, 100663404, 100663405, 100663406, 100663408, 100663409, 100663421, 100663426, 100663433, 100663440, 100663452, 100663455, 100663456, 100663457, 100663458, 100663461, 100663462, 100663463, 100663464, 100663465, 100663466, 100663467, 100663468, 100663469, 100663470, 100663475, 100663476, 100663477, 100663478, 100663479, 100663480, 100663481, 100663482, 100663483, 100663484, 100663485, 100663486, 100663489, 100663570, 100663571, 100663572, 100663573, 100663574, 100663575, 100663576, 100663577, 100663578, 100663579, 100663580, 100663581, 100663582, 100663583, 100663584, 100663585, 100663586, 100663587, 100663588, 100663589, 100663590, 100663591, 100663592, 100663593, 100663594, 100663595, 100663596, 100663597, 100663598, 100663599, 100663621, 100663632, 100663642, 100663646, 100663647, 100663767, 100663768, 100663769, 100663834, 100663835},fmi_Initialized);
RealDependentParameters2 = fmi_Functions.fmiGetReal(fmi, {100663836, 100663837, 100663838, 100663839, 100663840, 100663841, 100663842, 100663843, 100663846, 100663847, 100664298, 100663868, 100663878, 100663879, 100663882, 100663892, 100663893, 100663896, 100663906, 100663907, 100663910, 100663920, 100663921, 100663924, 100663934, 100663935, 100663938, 100663948, 100663949, 100663952, 100663962, 100663963, 100663966, 100663976, 100663977, 100663980, 100663990, 100663991, 100663994, 100664004, 100664005, 100664060, 100664062, 100664063, 100664067, 100664124, 100664126, 100664138, 100664140, 100664145, 100664146, 100664147, 100664148, 100664151, 100664153, 100664159, 100664162, 100664163},fmi_Initialized);
IntegerDependentParameters = fmi_Functions.fmiGetInteger(fmi, {100663331, 100663380, 100663869, 100663883, 100663897, 100663911, 100663925, 100663939, 100663953, 100663967, 100663981, 100663995},integer(fmi_Initialized));
BooleanDependentParameters = fmi_Functions.fmiGetBoolean(fmi, {100663377, 100663378},integer(fmi_Initialized));
equation
  outlet_water.medium.p = RealVariables1[1];
  outlet_water.medium.h = RealVariables1[2];
  outlet_water.medium.T = RealVariables1[3];
  outlet_water.medium.state.p = RealVariables1[4];
  outlet_water.medium.state.T = RealVariables1[5];
  outlet_water.'ports[1]'.m_flow = RealVariables1[6];
  outlet_water.'ports[1]'.p = RealVariables1[7];
  iceStorageExternalMelt_nSegnCoilp.'G_HTFtoTube[1]' = RealVariables1[8];
  iceStorageExternalMelt_nSegnCoilp.'G_HTFtoTube[2]' = RealVariables1[9];
  iceStorageExternalMelt_nSegnCoilp.'G_HTFtoTube[3]' = RealVariables1[10];
  iceStorageExternalMelt_nSegnCoilp.'G_HTFtoTube[4]' = RealVariables1[11];
  iceStorageExternalMelt_nSegnCoilp.'G_HTFtoTube[5]' = RealVariables1[12];
  iceStorageExternalMelt_nSegnCoilp.'G_HTFtoTube[6]' = RealVariables1[13];
  iceStorageExternalMelt_nSegnCoilp.'G_HTFtoTube[7]' = RealVariables1[14];
  iceStorageExternalMelt_nSegnCoilp.'G_HTFtoTube[8]' = RealVariables1[15];
  iceStorageExternalMelt_nSegnCoilp.'G_HTFtoTube[9]' = RealVariables1[16];
  iceStorageExternalMelt_nSegnCoilp.'G_HTFtoTube[10]' = RealVariables1[17];
  iceStorageExternalMelt_nSegnCoilp.'G_TubetoPCM[1]' = RealVariables1[18];
  iceStorageExternalMelt_nSegnCoilp.'G_TubetoPCM[2]' = RealVariables1[19];
  iceStorageExternalMelt_nSegnCoilp.'G_TubetoPCM[3]' = RealVariables1[20];
  iceStorageExternalMelt_nSegnCoilp.'G_TubetoPCM[4]' = RealVariables1[21];
  iceStorageExternalMelt_nSegnCoilp.'G_TubetoPCM[5]' = RealVariables1[22];
  iceStorageExternalMelt_nSegnCoilp.'G_TubetoPCM[6]' = RealVariables1[23];
  iceStorageExternalMelt_nSegnCoilp.'G_TubetoPCM[7]' = RealVariables1[24];
  iceStorageExternalMelt_nSegnCoilp.'G_TubetoPCM[8]' = RealVariables1[25];
  iceStorageExternalMelt_nSegnCoilp.'G_TubetoPCM[9]' = RealVariables1[26];
  iceStorageExternalMelt_nSegnCoilp.'G_TubetoPCM[10]' = RealVariables1[27];
  iceStorageExternalMelt_nSegnCoilp.externalMelt.'port_a_heatToAmbient[1]'.T = RealVariables1[28];
  iceStorageExternalMelt_nSegnCoilp.externalMelt.'port_a_heatToAmbient[1]'.Q_flow = RealVariables1[29];
  iceStorageExternalMelt_nSegnCoilp.externalMelt.'port_a_heatToAmbient[2]'.T = RealVariables1[30];
  iceStorageExternalMelt_nSegnCoilp.externalMelt.'port_a_heatToAmbient[2]'.Q_flow = RealVariables1[31];
  iceStorageExternalMelt_nSegnCoilp.externalMelt.'port_a_heatToAmbient[3]'.T = RealVariables1[32];
  iceStorageExternalMelt_nSegnCoilp.externalMelt.'port_a_heatToAmbient[3]'.Q_flow = RealVariables1[33];
  iceStorageExternalMelt_nSegnCoilp.externalMelt.'port_a_heatToAmbient[4]'.T = RealVariables1[34];
  iceStorageExternalMelt_nSegnCoilp.externalMelt.'port_a_heatToAmbient[4]'.Q_flow = RealVariables1[35];
  iceStorageExternalMelt_nSegnCoilp.externalMelt.'port_a_heatToAmbient[5]'.T = RealVariables1[36];
  iceStorageExternalMelt_nSegnCoilp.externalMelt.'port_a_heatToAmbient[5]'.Q_flow = RealVariables1[37];
  iceStorageExternalMelt_nSegnCoilp.externalMelt.'port_a_heatToAmbient[6]'.T = RealVariables1[38];
  iceStorageExternalMelt_nSegnCoilp.externalMelt.'port_a_heatToAmbient[6]'.Q_flow = RealVariables1[39];
  iceStorageExternalMelt_nSegnCoilp.externalMelt.'port_a_heatToAmbient[7]'.T = RealVariables1[40];
  iceStorageExternalMelt_nSegnCoilp.externalMelt.'port_a_heatToAmbient[7]'.Q_flow = RealVariables1[41];
  iceStorageExternalMelt_nSegnCoilp.externalMelt.'port_a_heatToAmbient[8]'.T = RealVariables1[42];
  iceStorageExternalMelt_nSegnCoilp.externalMelt.'port_a_heatToAmbient[8]'.Q_flow = RealVariables1[43];
  iceStorageExternalMelt_nSegnCoilp.externalMelt.'port_a_heatToAmbient[9]'.T = RealVariables1[44];
  iceStorageExternalMelt_nSegnCoilp.externalMelt.'port_a_heatToAmbient[9]'.Q_flow = RealVariables1[45];
  iceStorageExternalMelt_nSegnCoilp.externalMelt.'port_a_heatToAmbient[10]'.T = RealVariables1[46];
  iceStorageExternalMelt_nSegnCoilp.externalMelt.'port_a_heatToAmbient[10]'.Q_flow = RealVariables1[47];
  iceStorageExternalMelt_nSegnCoilp.externalMelt.'port_a_heatToHTF[1]'.T = RealVariables1[48];
  iceStorageExternalMelt_nSegnCoilp.externalMelt.'port_a_heatToHTF[1]'.Q_flow = RealVariables1[49];
  iceStorageExternalMelt_nSegnCoilp.externalMelt.'port_a_heatToHTF[2]'.T = RealVariables1[50];
  iceStorageExternalMelt_nSegnCoilp.externalMelt.'port_a_heatToHTF[2]'.Q_flow = RealVariables1[51];
  iceStorageExternalMelt_nSegnCoilp.externalMelt.'port_a_heatToHTF[3]'.T = RealVariables1[52];
  iceStorageExternalMelt_nSegnCoilp.externalMelt.'port_a_heatToHTF[3]'.Q_flow = RealVariables1[53];
  iceStorageExternalMelt_nSegnCoilp.externalMelt.'port_a_heatToHTF[4]'.T = RealVariables1[54];
  iceStorageExternalMelt_nSegnCoilp.externalMelt.'port_a_heatToHTF[4]'.Q_flow = RealVariables1[55];
  iceStorageExternalMelt_nSegnCoilp.externalMelt.'port_a_heatToHTF[5]'.T = RealVariables1[56];
  iceStorageExternalMelt_nSegnCoilp.externalMelt.'port_a_heatToHTF[5]'.Q_flow = RealVariables1[57];
  iceStorageExternalMelt_nSegnCoilp.externalMelt.'port_a_heatToHTF[6]'.T = RealVariables1[58];
  iceStorageExternalMelt_nSegnCoilp.externalMelt.'port_a_heatToHTF[6]'.Q_flow = RealVariables1[59];
  iceStorageExternalMelt_nSegnCoilp.externalMelt.'port_a_heatToHTF[7]'.T = RealVariables1[60];
  iceStorageExternalMelt_nSegnCoilp.externalMelt.'port_a_heatToHTF[7]'.Q_flow = RealVariables1[61];
  iceStorageExternalMelt_nSegnCoilp.externalMelt.'port_a_heatToHTF[8]'.T = RealVariables1[62];
  iceStorageExternalMelt_nSegnCoilp.externalMelt.'port_a_heatToHTF[8]'.Q_flow = RealVariables1[63];
  iceStorageExternalMelt_nSegnCoilp.externalMelt.'port_a_heatToHTF[9]'.T = RealVariables1[64];
  iceStorageExternalMelt_nSegnCoilp.externalMelt.'port_a_heatToHTF[9]'.Q_flow = RealVariables1[65];
  iceStorageExternalMelt_nSegnCoilp.externalMelt.'port_a_heatToHTF[10]'.T = RealVariables1[66];
  iceStorageExternalMelt_nSegnCoilp.externalMelt.'port_a_heatToHTF[10]'.Q_flow = RealVariables1[67];
  iceStorageExternalMelt_nSegnCoilp.externalMelt.port_a_water.m_flow = RealVariables1[68];
  iceStorageExternalMelt_nSegnCoilp.externalMelt.port_a_water.p = RealVariables1[69];
  iceStorageExternalMelt_nSegnCoilp.externalMelt.port_a_water.h_outflow = RealVariables1[70];
  iceStorageExternalMelt_nSegnCoilp.externalMelt.port_b_water.m_flow = RealVariables1[71];
  iceStorageExternalMelt_nSegnCoilp.externalMelt.port_b_water.p = RealVariables1[72];
  iceStorageExternalMelt_nSegnCoilp.externalMelt.port_b_water.h_outflow = RealVariables1[73];
  iceStorageExternalMelt_nSegnCoilp.externalMelt.T = RealVariables1[74];
  iceStorageExternalMelt_nSegnCoilp.externalMelt.x_liquid = RealVariables1[75];
  iceStorageExternalMelt_nSegnCoilp.externalMelt.x_liquid_der = RealVariables1[76];
  iceStorageExternalMelt_nSegnCoilp.externalMelt.U = RealVariables1[77];
  iceStorageExternalMelt_nSegnCoilp.externalMelt.U_der = RealVariables1[78];
  iceStorageExternalMelt_nSegnCoilp.externalMelt.V_PCM = RealVariables1[79];
  iceStorageExternalMelt_nSegnCoilp.externalMelt.V_PCM_der = RealVariables1[80];
  iceStorageExternalMelt_nSegnCoilp.externalMelt.h_PCM = RealVariables1[81];
  iceStorageExternalMelt_nSegnCoilp.externalMelt.h_PCM_der = RealVariables1[82];
  iceStorageExternalMelt_nSegnCoilp.externalMelt.rho = RealVariables1[83];
  iceStorageExternalMelt_nSegnCoilp.externalMelt.rho_der = RealVariables1[84];
  iceStorageExternalMelt_nSegnCoilp.externalMelt.h_satL = RealVariables1[85];
  iceStorageExternalMelt_nSegnCoilp.externalMelt.m_PCMs = RealVariables1[86];
  iceStorageExternalMelt_nSegnCoilp.externalMelt.m_PCMs_der = RealVariables1[87];
  iceStorageExternalMelt_nSegnCoilp.externalMelt.T_s = RealVariables1[88];
  iceStorageExternalMelt_nSegnCoilp.externalMelt.D_s = RealVariables1[89];
  iceStorageExternalMelt_nSegnCoilp.externalMelt.D_s_der = RealVariables1[90];
  iceStorageExternalMelt_nSegnCoilp.externalMelt.m_PCMl = RealVariables1[91];
  iceStorageExternalMelt_nSegnCoilp.externalMelt.m_PCMl_der = RealVariables1[92];
  iceStorageExternalMelt_nSegnCoilp.externalMelt.T_l = RealVariables1[93];
  iceStorageExternalMelt_nSegnCoilp.externalMelt.D_l = RealVariables1[94];
  iceStorageExternalMelt_nSegnCoilp.externalMelt.D_l_der = RealVariables1[95];
  iceStorageExternalMelt_nSegnCoilp.externalMelt.D_l_out = RealVariables1[96];
  iceStorageExternalMelt_nSegnCoilp.externalMelt.T_w1 = RealVariables1[97];
  iceStorageExternalMelt_nSegnCoilp.externalMelt.m_w1 = RealVariables1[98];
  iceStorageExternalMelt_nSegnCoilp.externalMelt.h_w1 = RealVariables1[99];
  iceStorageExternalMelt_nSegnCoilp.externalMelt.T_w2 = RealVariables1[100];
  iceStorageExternalMelt_nSegnCoilp.externalMelt.m_w2 = RealVariables2[1];
  iceStorageExternalMelt_nSegnCoilp.externalMelt.h_w2 = RealVariables2[2];
  iceStorageExternalMelt_nSegnCoilp.port_a_water.m_flow = RealVariables2[3];
  iceStorageExternalMelt_nSegnCoilp.port_a_water.p = RealVariables2[4];
  iceStorageExternalMelt_nSegnCoilp.port_a_water.h_outflow = RealVariables2[5];
  iceStorageExternalMelt_nSegnCoilp.port_b_water.m_flow = RealVariables2[6];
  iceStorageExternalMelt_nSegnCoilp.port_b_water.p = RealVariables2[7];
  iceStorageExternalMelt_nSegnCoilp.port_b_water.h_outflow = RealVariables2[8];
  iceStorageExternalMelt_nSegnCoilp.port_b_Tambient.T = RealVariables2[9];
  iceStorageExternalMelt_nSegnCoilp.port_b_Tambient.Q_flow = RealVariables2[10];
  iceStorageExternalMelt_nSegnCoilp.port_a_HTF.m_flow = RealVariables2[11];
  iceStorageExternalMelt_nSegnCoilp.port_a_HTF.p = RealVariables2[12];
  iceStorageExternalMelt_nSegnCoilp.port_a_HTF.h_outflow = RealVariables2[13];
  iceStorageExternalMelt_nSegnCoilp.port_a_HTF.h_outflow_der = RealVariables2[14];
  iceStorageExternalMelt_nSegnCoilp.por_b_HTF.m_flow = RealVariables2[15];
  iceStorageExternalMelt_nSegnCoilp.por_b_HTF.p = RealVariables2[16];
  iceStorageExternalMelt_nSegnCoilp.por_b_HTF.h_outflow = RealVariables2[17];
  iceStorageExternalMelt_nSegnCoilp.por_b_HTF.h_outflow_der = RealVariables2[18];
  iceStorageExternalMelt_nSegnCoilp.pipe.port_a.m_flow = RealVariables2[19];
  iceStorageExternalMelt_nSegnCoilp.pipe.port_a.p = RealVariables2[20];
  iceStorageExternalMelt_nSegnCoilp.pipe.port_a.h_outflow = RealVariables2[21];
  iceStorageExternalMelt_nSegnCoilp.pipe.port_b.m_flow = RealVariables2[22];
  iceStorageExternalMelt_nSegnCoilp.pipe.port_b.p = RealVariables2[23];
  iceStorageExternalMelt_nSegnCoilp.pipe.port_b.h_outflow = RealVariables2[24];
  iceStorageExternalMelt_nSegnCoilp.pipe.'Us[1]' = RealVariables2[25];
  iceStorageExternalMelt_nSegnCoilp.pipe.'Us[1]_der' = RealVariables2[26];
  iceStorageExternalMelt_nSegnCoilp.pipe.'Us[2]' = RealVariables2[27];
  iceStorageExternalMelt_nSegnCoilp.pipe.'Us[2]_der' = RealVariables2[28];
  iceStorageExternalMelt_nSegnCoilp.pipe.'Us[3]' = RealVariables2[29];
  iceStorageExternalMelt_nSegnCoilp.pipe.'Us[3]_der' = RealVariables2[30];
  iceStorageExternalMelt_nSegnCoilp.pipe.'Us[4]' = RealVariables2[31];
  iceStorageExternalMelt_nSegnCoilp.pipe.'Us[4]_der' = RealVariables2[32];
  iceStorageExternalMelt_nSegnCoilp.pipe.'Us[5]' = RealVariables2[33];
  iceStorageExternalMelt_nSegnCoilp.pipe.'Us[5]_der' = RealVariables2[34];
  iceStorageExternalMelt_nSegnCoilp.pipe.'Us[6]' = RealVariables2[35];
  iceStorageExternalMelt_nSegnCoilp.pipe.'Us[6]_der' = RealVariables2[36];
  iceStorageExternalMelt_nSegnCoilp.pipe.'Us[7]' = RealVariables2[37];
  iceStorageExternalMelt_nSegnCoilp.pipe.'Us[7]_der' = RealVariables2[38];
  iceStorageExternalMelt_nSegnCoilp.pipe.'Us[8]' = RealVariables2[39];
  iceStorageExternalMelt_nSegnCoilp.pipe.'Us[8]_der' = RealVariables2[40];
  iceStorageExternalMelt_nSegnCoilp.pipe.'Us[9]' = RealVariables2[41];
  iceStorageExternalMelt_nSegnCoilp.pipe.'Us[9]_der' = RealVariables2[42];
  iceStorageExternalMelt_nSegnCoilp.pipe.'Us[10]' = RealVariables2[43];
  iceStorageExternalMelt_nSegnCoilp.pipe.'Us[10]_der' = RealVariables2[44];
  iceStorageExternalMelt_nSegnCoilp.pipe.'ms[1]' = RealVariables2[45];
  iceStorageExternalMelt_nSegnCoilp.pipe.'ms[1]_der' = RealVariables2[46];
  iceStorageExternalMelt_nSegnCoilp.pipe.'ms[2]' = RealVariables2[47];
  iceStorageExternalMelt_nSegnCoilp.pipe.'ms[2]_der' = RealVariables2[48];
  iceStorageExternalMelt_nSegnCoilp.pipe.'ms[3]' = RealVariables2[49];
  iceStorageExternalMelt_nSegnCoilp.pipe.'ms[3]_der' = RealVariables2[50];
  iceStorageExternalMelt_nSegnCoilp.pipe.'ms[4]' = RealVariables2[51];
  iceStorageExternalMelt_nSegnCoilp.pipe.'ms[4]_der' = RealVariables2[52];
  iceStorageExternalMelt_nSegnCoilp.pipe.'ms[5]' = RealVariables2[53];
  iceStorageExternalMelt_nSegnCoilp.pipe.'ms[5]_der' = RealVariables2[54];
  iceStorageExternalMelt_nSegnCoilp.pipe.'ms[6]' = RealVariables2[55];
  iceStorageExternalMelt_nSegnCoilp.pipe.'ms[6]_der' = RealVariables2[56];
  iceStorageExternalMelt_nSegnCoilp.pipe.'ms[7]' = RealVariables2[57];
  iceStorageExternalMelt_nSegnCoilp.pipe.'ms[7]_der' = RealVariables2[58];
  iceStorageExternalMelt_nSegnCoilp.pipe.'ms[8]' = RealVariables2[59];
  iceStorageExternalMelt_nSegnCoilp.pipe.'ms[8]_der' = RealVariables2[60];
  iceStorageExternalMelt_nSegnCoilp.pipe.'ms[9]' = RealVariables2[61];
  iceStorageExternalMelt_nSegnCoilp.pipe.'ms[9]_der' = RealVariables2[62];
  iceStorageExternalMelt_nSegnCoilp.pipe.'ms[10]' = RealVariables2[63];
  iceStorageExternalMelt_nSegnCoilp.pipe.'ms[10]_der' = RealVariables2[64];
  iceStorageExternalMelt_nSegnCoilp.pipe.'mb_flows[1]' = RealVariables2[65];
  iceStorageExternalMelt_nSegnCoilp.pipe.'mb_flows[2]' = RealVariables2[66];
  iceStorageExternalMelt_nSegnCoilp.pipe.'mb_flows[3]' = RealVariables2[67];
  iceStorageExternalMelt_nSegnCoilp.pipe.'mb_flows[4]' = RealVariables2[68];
  iceStorageExternalMelt_nSegnCoilp.pipe.'mb_flows[5]' = RealVariables2[69];
  iceStorageExternalMelt_nSegnCoilp.pipe.'mb_flows[6]' = RealVariables2[70];
  iceStorageExternalMelt_nSegnCoilp.pipe.'mb_flows[7]' = RealVariables2[71];
  iceStorageExternalMelt_nSegnCoilp.pipe.'mb_flows[8]' = RealVariables2[72];
  iceStorageExternalMelt_nSegnCoilp.pipe.'mb_flows[9]' = RealVariables2[73];
  iceStorageExternalMelt_nSegnCoilp.pipe.'mb_flows[10]' = RealVariables2[74];
  iceStorageExternalMelt_nSegnCoilp.pipe.'Hb_flows[1]' = RealVariables2[75];
  iceStorageExternalMelt_nSegnCoilp.pipe.'Hb_flows[2]' = RealVariables2[76];
  iceStorageExternalMelt_nSegnCoilp.pipe.'Hb_flows[3]' = RealVariables2[77];
  iceStorageExternalMelt_nSegnCoilp.pipe.'Hb_flows[4]' = RealVariables2[78];
  iceStorageExternalMelt_nSegnCoilp.pipe.'Hb_flows[5]' = RealVariables2[79];
  iceStorageExternalMelt_nSegnCoilp.pipe.'Hb_flows[6]' = RealVariables2[80];
  iceStorageExternalMelt_nSegnCoilp.pipe.'Hb_flows[7]' = RealVariables2[81];
  iceStorageExternalMelt_nSegnCoilp.pipe.'Hb_flows[8]' = RealVariables2[82];
  iceStorageExternalMelt_nSegnCoilp.pipe.'Hb_flows[9]' = RealVariables2[83];
  iceStorageExternalMelt_nSegnCoilp.pipe.'Hb_flows[10]' = RealVariables2[84];
  iceStorageExternalMelt_nSegnCoilp.pipe.'Qb_flows[1]' = RealVariables2[85];
  iceStorageExternalMelt_nSegnCoilp.pipe.'Qb_flows[2]' = RealVariables2[86];
  iceStorageExternalMelt_nSegnCoilp.pipe.'Qb_flows[3]' = RealVariables2[87];
  iceStorageExternalMelt_nSegnCoilp.pipe.'Qb_flows[4]' = RealVariables2[88];
  iceStorageExternalMelt_nSegnCoilp.pipe.'Qb_flows[5]' = RealVariables2[89];
  iceStorageExternalMelt_nSegnCoilp.pipe.'Qb_flows[6]' = RealVariables2[90];
  iceStorageExternalMelt_nSegnCoilp.pipe.'Qb_flows[7]' = RealVariables2[91];
  iceStorageExternalMelt_nSegnCoilp.pipe.'Qb_flows[8]' = RealVariables2[92];
  iceStorageExternalMelt_nSegnCoilp.pipe.'Qb_flows[9]' = RealVariables2[93];
  iceStorageExternalMelt_nSegnCoilp.pipe.'Qb_flows[10]' = RealVariables2[94];
  iceStorageExternalMelt_nSegnCoilp.pipe.'Wb_flows[1]' = RealVariables2[95];
  iceStorageExternalMelt_nSegnCoilp.pipe.'Wb_flows[2]' = RealVariables2[96];
  iceStorageExternalMelt_nSegnCoilp.pipe.'Wb_flows[3]' = RealVariables2[97];
  iceStorageExternalMelt_nSegnCoilp.pipe.'Wb_flows[4]' = RealVariables2[98];
  iceStorageExternalMelt_nSegnCoilp.pipe.'Wb_flows[5]' = RealVariables2[99];
  iceStorageExternalMelt_nSegnCoilp.pipe.'Wb_flows[6]' = RealVariables2[100];
  iceStorageExternalMelt_nSegnCoilp.pipe.'Wb_flows[7]' = RealVariables3[1];
  iceStorageExternalMelt_nSegnCoilp.pipe.'Wb_flows[8]' = RealVariables3[2];
  iceStorageExternalMelt_nSegnCoilp.pipe.'Wb_flows[9]' = RealVariables3[3];
  iceStorageExternalMelt_nSegnCoilp.pipe.'Wb_flows[10]' = RealVariables3[4];
  iceStorageExternalMelt_nSegnCoilp.pipe.state_a.T = RealVariables3[5];
  iceStorageExternalMelt_nSegnCoilp.pipe.state_a.p = RealVariables3[6];
  iceStorageExternalMelt_nSegnCoilp.pipe.state_b.p = RealVariables3[7];
  iceStorageExternalMelt_nSegnCoilp.pipe.'statesFM[1]'.T = RealVariables3[8];
  iceStorageExternalMelt_nSegnCoilp.pipe.'statesFM[1]'.p = RealVariables3[9];
  iceStorageExternalMelt_nSegnCoilp.pipe.'statesFM[2]'.T = RealVariables3[10];
  iceStorageExternalMelt_nSegnCoilp.pipe.'statesFM[2]'.p = RealVariables3[11];
  iceStorageExternalMelt_nSegnCoilp.pipe.'statesFM[3]'.T = RealVariables3[12];
  iceStorageExternalMelt_nSegnCoilp.pipe.'statesFM[3]'.p = RealVariables3[13];
  iceStorageExternalMelt_nSegnCoilp.pipe.'statesFM[4]'.T = RealVariables3[14];
  iceStorageExternalMelt_nSegnCoilp.pipe.'statesFM[4]'.p = RealVariables3[15];
  iceStorageExternalMelt_nSegnCoilp.pipe.'statesFM[5]'.T = RealVariables3[16];
  iceStorageExternalMelt_nSegnCoilp.pipe.'statesFM[5]'.p = RealVariables3[17];
  iceStorageExternalMelt_nSegnCoilp.pipe.'statesFM[6]'.T = RealVariables3[18];
  iceStorageExternalMelt_nSegnCoilp.pipe.'statesFM[6]'.p = RealVariables3[19];
  iceStorageExternalMelt_nSegnCoilp.pipe.'statesFM[7]'.T = RealVariables3[20];
  iceStorageExternalMelt_nSegnCoilp.pipe.'statesFM[7]'.p = RealVariables3[21];
  iceStorageExternalMelt_nSegnCoilp.pipe.'statesFM[8]'.T = RealVariables3[22];
  iceStorageExternalMelt_nSegnCoilp.pipe.'statesFM[8]'.p = RealVariables3[23];
  iceStorageExternalMelt_nSegnCoilp.pipe.'statesFM[9]'.T = RealVariables3[24];
  iceStorageExternalMelt_nSegnCoilp.pipe.'statesFM[9]'.p = RealVariables3[25];
  iceStorageExternalMelt_nSegnCoilp.pipe.'statesFM[10]'.T = RealVariables3[26];
  iceStorageExternalMelt_nSegnCoilp.pipe.'statesFM[10]'.p = RealVariables3[27];
  iceStorageExternalMelt_nSegnCoilp.pipe.flowModel.'states[1]'.T = RealVariables3[28];
  iceStorageExternalMelt_nSegnCoilp.pipe.flowModel.'states[1]'.p = RealVariables3[29];
  iceStorageExternalMelt_nSegnCoilp.pipe.flowModel.'states[2]'.T = RealVariables3[30];
  iceStorageExternalMelt_nSegnCoilp.pipe.flowModel.'states[2]'.p = RealVariables3[31];
  iceStorageExternalMelt_nSegnCoilp.pipe.flowModel.'states[3]'.T = RealVariables3[32];
  iceStorageExternalMelt_nSegnCoilp.pipe.flowModel.'states[3]'.p = RealVariables3[33];
  iceStorageExternalMelt_nSegnCoilp.pipe.flowModel.'states[4]'.T = RealVariables3[34];
  iceStorageExternalMelt_nSegnCoilp.pipe.flowModel.'states[4]'.p = RealVariables3[35];
  iceStorageExternalMelt_nSegnCoilp.pipe.flowModel.'states[5]'.T = RealVariables3[36];
  iceStorageExternalMelt_nSegnCoilp.pipe.flowModel.'states[5]'.p = RealVariables3[37];
  iceStorageExternalMelt_nSegnCoilp.pipe.flowModel.'states[6]'.T = RealVariables3[38];
  iceStorageExternalMelt_nSegnCoilp.pipe.flowModel.'states[6]'.p = RealVariables3[39];
  iceStorageExternalMelt_nSegnCoilp.pipe.flowModel.'states[7]'.T = RealVariables3[40];
  iceStorageExternalMelt_nSegnCoilp.pipe.flowModel.'states[7]'.p = RealVariables3[41];
  iceStorageExternalMelt_nSegnCoilp.pipe.flowModel.'states[8]'.T = RealVariables3[42];
  iceStorageExternalMelt_nSegnCoilp.pipe.flowModel.'states[8]'.p = RealVariables3[43];
  iceStorageExternalMelt_nSegnCoilp.pipe.flowModel.'states[9]'.T = RealVariables3[44];
  iceStorageExternalMelt_nSegnCoilp.pipe.flowModel.'states[9]'.p = RealVariables3[45];
  iceStorageExternalMelt_nSegnCoilp.pipe.flowModel.'states[10]'.T = RealVariables3[46];
  iceStorageExternalMelt_nSegnCoilp.pipe.flowModel.'states[10]'.p = RealVariables3[47];
  iceStorageExternalMelt_nSegnCoilp.pipe.flowModel.'vs[1]' = RealVariables3[48];
  iceStorageExternalMelt_nSegnCoilp.pipe.flowModel.'vs[2]' = RealVariables3[49];
  iceStorageExternalMelt_nSegnCoilp.pipe.flowModel.'vs[3]' = RealVariables3[50];
  iceStorageExternalMelt_nSegnCoilp.pipe.flowModel.'vs[4]' = RealVariables3[51];
  iceStorageExternalMelt_nSegnCoilp.pipe.flowModel.'vs[5]' = RealVariables3[52];
  iceStorageExternalMelt_nSegnCoilp.pipe.flowModel.'vs[6]' = RealVariables3[53];
  iceStorageExternalMelt_nSegnCoilp.pipe.flowModel.'vs[7]' = RealVariables3[54];
  iceStorageExternalMelt_nSegnCoilp.pipe.flowModel.'vs[8]' = RealVariables3[55];
  iceStorageExternalMelt_nSegnCoilp.pipe.flowModel.'vs[9]' = RealVariables3[56];
  iceStorageExternalMelt_nSegnCoilp.pipe.flowModel.'vs[10]' = RealVariables3[57];
  iceStorageExternalMelt_nSegnCoilp.pipe.flowModel.'crossAreas[1]' = RealVariables3[58];
  iceStorageExternalMelt_nSegnCoilp.pipe.flowModel.'crossAreas[2]' = RealVariables3[59];
  iceStorageExternalMelt_nSegnCoilp.pipe.flowModel.'crossAreas[3]' = RealVariables3[60];
  iceStorageExternalMelt_nSegnCoilp.pipe.flowModel.'crossAreas[4]' = RealVariables3[61];
  iceStorageExternalMelt_nSegnCoilp.pipe.flowModel.'crossAreas[5]' = RealVariables3[62];
  iceStorageExternalMelt_nSegnCoilp.pipe.flowModel.'crossAreas[6]' = RealVariables3[63];
  iceStorageExternalMelt_nSegnCoilp.pipe.flowModel.'crossAreas[7]' = RealVariables3[64];
  iceStorageExternalMelt_nSegnCoilp.pipe.flowModel.'crossAreas[8]' = RealVariables3[65];
  iceStorageExternalMelt_nSegnCoilp.pipe.flowModel.'crossAreas[9]' = RealVariables3[66];
  iceStorageExternalMelt_nSegnCoilp.pipe.flowModel.'crossAreas[10]' = RealVariables3[67];
  iceStorageExternalMelt_nSegnCoilp.pipe.flowModel.'dimensions[1]' = RealVariables3[68];
  iceStorageExternalMelt_nSegnCoilp.pipe.flowModel.'dimensions[2]' = RealVariables3[69];
  iceStorageExternalMelt_nSegnCoilp.pipe.flowModel.'dimensions[3]' = RealVariables3[70];
  iceStorageExternalMelt_nSegnCoilp.pipe.flowModel.'dimensions[4]' = RealVariables3[71];
  iceStorageExternalMelt_nSegnCoilp.pipe.flowModel.'dimensions[5]' = RealVariables3[72];
  iceStorageExternalMelt_nSegnCoilp.pipe.flowModel.'dimensions[6]' = RealVariables3[73];
  iceStorageExternalMelt_nSegnCoilp.pipe.flowModel.'dimensions[7]' = RealVariables3[74];
  iceStorageExternalMelt_nSegnCoilp.pipe.flowModel.'dimensions[8]' = RealVariables3[75];
  iceStorageExternalMelt_nSegnCoilp.pipe.flowModel.'dimensions[9]' = RealVariables3[76];
  iceStorageExternalMelt_nSegnCoilp.pipe.flowModel.'dimensions[10]' = RealVariables3[77];
  iceStorageExternalMelt_nSegnCoilp.pipe.flowModel.'roughnesses[1]' = RealVariables3[78];
  iceStorageExternalMelt_nSegnCoilp.pipe.flowModel.'roughnesses[2]' = RealVariables3[79];
  iceStorageExternalMelt_nSegnCoilp.pipe.flowModel.'roughnesses[3]' = RealVariables3[80];
  iceStorageExternalMelt_nSegnCoilp.pipe.flowModel.'roughnesses[4]' = RealVariables3[81];
  iceStorageExternalMelt_nSegnCoilp.pipe.flowModel.'roughnesses[5]' = RealVariables3[82];
  iceStorageExternalMelt_nSegnCoilp.pipe.flowModel.'roughnesses[6]' = RealVariables3[83];
  iceStorageExternalMelt_nSegnCoilp.pipe.flowModel.'roughnesses[7]' = RealVariables3[84];
  iceStorageExternalMelt_nSegnCoilp.pipe.flowModel.'roughnesses[8]' = RealVariables3[85];
  iceStorageExternalMelt_nSegnCoilp.pipe.flowModel.'roughnesses[9]' = RealVariables3[86];
  iceStorageExternalMelt_nSegnCoilp.pipe.flowModel.'roughnesses[10]' = RealVariables3[87];
  iceStorageExternalMelt_nSegnCoilp.pipe.flowModel.'m_flows[1]' = RealVariables3[88];
  iceStorageExternalMelt_nSegnCoilp.pipe.flowModel.'m_flows[2]' = RealVariables3[89];
  iceStorageExternalMelt_nSegnCoilp.pipe.flowModel.'m_flows[3]' = RealVariables3[90];
  iceStorageExternalMelt_nSegnCoilp.pipe.flowModel.'m_flows[4]' = RealVariables3[91];
  iceStorageExternalMelt_nSegnCoilp.pipe.flowModel.'m_flows[5]' = RealVariables3[92];
  iceStorageExternalMelt_nSegnCoilp.pipe.flowModel.'m_flows[6]' = RealVariables3[93];
  iceStorageExternalMelt_nSegnCoilp.pipe.flowModel.'m_flows[7]' = RealVariables3[94];
  iceStorageExternalMelt_nSegnCoilp.pipe.flowModel.'m_flows[8]' = RealVariables3[95];
  iceStorageExternalMelt_nSegnCoilp.pipe.flowModel.'m_flows[9]' = RealVariables3[96];
  iceStorageExternalMelt_nSegnCoilp.pipe.flowModel.'Is[1]' = RealVariables3[97];
  iceStorageExternalMelt_nSegnCoilp.pipe.flowModel.'Is[2]' = RealVariables3[98];
  iceStorageExternalMelt_nSegnCoilp.pipe.flowModel.'Is[3]' = RealVariables3[99];
  iceStorageExternalMelt_nSegnCoilp.pipe.flowModel.'Is[4]' = RealVariables3[100];
  iceStorageExternalMelt_nSegnCoilp.pipe.flowModel.'Is[5]' = RealVariables4[1];
  iceStorageExternalMelt_nSegnCoilp.pipe.flowModel.'Is[6]' = RealVariables4[2];
  iceStorageExternalMelt_nSegnCoilp.pipe.flowModel.'Is[7]' = RealVariables4[3];
  iceStorageExternalMelt_nSegnCoilp.pipe.flowModel.'Is[8]' = RealVariables4[4];
  iceStorageExternalMelt_nSegnCoilp.pipe.flowModel.'Is[9]' = RealVariables4[5];
  iceStorageExternalMelt_nSegnCoilp.pipe.flowModel.'Fs_p[1]' = RealVariables4[6];
  iceStorageExternalMelt_nSegnCoilp.pipe.flowModel.'Fs_p[2]' = RealVariables4[7];
  iceStorageExternalMelt_nSegnCoilp.pipe.flowModel.'Fs_p[3]' = RealVariables4[8];
  iceStorageExternalMelt_nSegnCoilp.pipe.flowModel.'Fs_p[4]' = RealVariables4[9];
  iceStorageExternalMelt_nSegnCoilp.pipe.flowModel.'Fs_p[5]' = RealVariables4[10];
  iceStorageExternalMelt_nSegnCoilp.pipe.flowModel.'Fs_p[6]' = RealVariables4[11];
  iceStorageExternalMelt_nSegnCoilp.pipe.flowModel.'Fs_p[7]' = RealVariables4[12];
  iceStorageExternalMelt_nSegnCoilp.pipe.flowModel.'Fs_p[8]' = RealVariables4[13];
  iceStorageExternalMelt_nSegnCoilp.pipe.flowModel.'Fs_p[9]' = RealVariables4[14];
  iceStorageExternalMelt_nSegnCoilp.pipe.flowModel.'Fs_fg[1]' = RealVariables4[15];
  iceStorageExternalMelt_nSegnCoilp.pipe.flowModel.'Fs_fg[2]' = RealVariables4[16];
  iceStorageExternalMelt_nSegnCoilp.pipe.flowModel.'Fs_fg[3]' = RealVariables4[17];
  iceStorageExternalMelt_nSegnCoilp.pipe.flowModel.'Fs_fg[4]' = RealVariables4[18];
  iceStorageExternalMelt_nSegnCoilp.pipe.flowModel.'Fs_fg[5]' = RealVariables4[19];
  iceStorageExternalMelt_nSegnCoilp.pipe.flowModel.'Fs_fg[6]' = RealVariables4[20];
  iceStorageExternalMelt_nSegnCoilp.pipe.flowModel.'Fs_fg[7]' = RealVariables4[21];
  iceStorageExternalMelt_nSegnCoilp.pipe.flowModel.'Fs_fg[8]' = RealVariables4[22];
  iceStorageExternalMelt_nSegnCoilp.pipe.flowModel.'Fs_fg[9]' = RealVariables4[23];
  iceStorageExternalMelt_nSegnCoilp.pipe.flowModel.'rhos[1]' = RealVariables4[24];
  iceStorageExternalMelt_nSegnCoilp.pipe.flowModel.'rhos[2]' = RealVariables4[25];
  iceStorageExternalMelt_nSegnCoilp.pipe.flowModel.'rhos[3]' = RealVariables4[26];
  iceStorageExternalMelt_nSegnCoilp.pipe.flowModel.'rhos[4]' = RealVariables4[27];
  iceStorageExternalMelt_nSegnCoilp.pipe.flowModel.'rhos[5]' = RealVariables4[28];
  iceStorageExternalMelt_nSegnCoilp.pipe.flowModel.'rhos[6]' = RealVariables4[29];
  iceStorageExternalMelt_nSegnCoilp.pipe.flowModel.'rhos[7]' = RealVariables4[30];
  iceStorageExternalMelt_nSegnCoilp.pipe.flowModel.'rhos[8]' = RealVariables4[31];
  iceStorageExternalMelt_nSegnCoilp.pipe.flowModel.'rhos[9]' = RealVariables4[32];
  iceStorageExternalMelt_nSegnCoilp.pipe.flowModel.'rhos[10]' = RealVariables4[33];
  iceStorageExternalMelt_nSegnCoilp.pipe.flowModel.'rhos_act[1]' = RealVariables4[34];
  iceStorageExternalMelt_nSegnCoilp.pipe.flowModel.'rhos_act[2]' = RealVariables4[35];
  iceStorageExternalMelt_nSegnCoilp.pipe.flowModel.'rhos_act[3]' = RealVariables4[36];
  iceStorageExternalMelt_nSegnCoilp.pipe.flowModel.'rhos_act[4]' = RealVariables4[37];
  iceStorageExternalMelt_nSegnCoilp.pipe.flowModel.'rhos_act[5]' = RealVariables4[38];
  iceStorageExternalMelt_nSegnCoilp.pipe.flowModel.'rhos_act[6]' = RealVariables4[39];
  iceStorageExternalMelt_nSegnCoilp.pipe.flowModel.'rhos_act[7]' = RealVariables4[40];
  iceStorageExternalMelt_nSegnCoilp.pipe.flowModel.'rhos_act[8]' = RealVariables4[41];
  iceStorageExternalMelt_nSegnCoilp.pipe.flowModel.'rhos_act[9]' = RealVariables4[42];
  iceStorageExternalMelt_nSegnCoilp.pipe.flowModel.'mus[1]' = RealVariables4[43];
  iceStorageExternalMelt_nSegnCoilp.pipe.flowModel.'mus[2]' = RealVariables4[44];
  iceStorageExternalMelt_nSegnCoilp.pipe.flowModel.'mus[3]' = RealVariables4[45];
  iceStorageExternalMelt_nSegnCoilp.pipe.flowModel.'mus[4]' = RealVariables4[46];
  iceStorageExternalMelt_nSegnCoilp.pipe.flowModel.'mus[5]' = RealVariables4[47];
  iceStorageExternalMelt_nSegnCoilp.pipe.flowModel.'mus[6]' = RealVariables4[48];
  iceStorageExternalMelt_nSegnCoilp.pipe.flowModel.'mus[7]' = RealVariables4[49];
  iceStorageExternalMelt_nSegnCoilp.pipe.flowModel.'mus[8]' = RealVariables4[50];
  iceStorageExternalMelt_nSegnCoilp.pipe.flowModel.'mus[9]' = RealVariables4[51];
  iceStorageExternalMelt_nSegnCoilp.pipe.flowModel.'mus[10]' = RealVariables4[52];
  iceStorageExternalMelt_nSegnCoilp.pipe.flowModel.'mus_act[1]' = RealVariables4[53];
  iceStorageExternalMelt_nSegnCoilp.pipe.flowModel.'mus_act[2]' = RealVariables4[54];
  iceStorageExternalMelt_nSegnCoilp.pipe.flowModel.'mus_act[3]' = RealVariables4[55];
  iceStorageExternalMelt_nSegnCoilp.pipe.flowModel.'mus_act[4]' = RealVariables4[56];
  iceStorageExternalMelt_nSegnCoilp.pipe.flowModel.'mus_act[5]' = RealVariables4[57];
  iceStorageExternalMelt_nSegnCoilp.pipe.flowModel.'mus_act[6]' = RealVariables4[58];
  iceStorageExternalMelt_nSegnCoilp.pipe.flowModel.'mus_act[7]' = RealVariables4[59];
  iceStorageExternalMelt_nSegnCoilp.pipe.flowModel.'mus_act[8]' = RealVariables4[60];
  iceStorageExternalMelt_nSegnCoilp.pipe.flowModel.'mus_act[9]' = RealVariables4[61];
  iceStorageExternalMelt_nSegnCoilp.pipe.flowModel.'dps_fg[1]' = RealVariables4[62];
  iceStorageExternalMelt_nSegnCoilp.pipe.flowModel.'dps_fg[2]' = RealVariables4[63];
  iceStorageExternalMelt_nSegnCoilp.pipe.flowModel.'dps_fg[3]' = RealVariables4[64];
  iceStorageExternalMelt_nSegnCoilp.pipe.flowModel.'dps_fg[4]' = RealVariables4[65];
  iceStorageExternalMelt_nSegnCoilp.pipe.flowModel.'dps_fg[5]' = RealVariables4[66];
  iceStorageExternalMelt_nSegnCoilp.pipe.flowModel.'dps_fg[6]' = RealVariables4[67];
  iceStorageExternalMelt_nSegnCoilp.pipe.flowModel.'dps_fg[7]' = RealVariables4[68];
  iceStorageExternalMelt_nSegnCoilp.pipe.flowModel.'dps_fg[8]' = RealVariables4[69];
  iceStorageExternalMelt_nSegnCoilp.pipe.flowModel.'dps_fg[9]' = RealVariables4[70];
  iceStorageExternalMelt_nSegnCoilp.pipe.'m_flows[1]' = RealVariables4[71];
  iceStorageExternalMelt_nSegnCoilp.pipe.'m_flows[2]' = RealVariables4[72];
  iceStorageExternalMelt_nSegnCoilp.pipe.'m_flows[3]' = RealVariables4[73];
  iceStorageExternalMelt_nSegnCoilp.pipe.'m_flows[4]' = RealVariables4[74];
  iceStorageExternalMelt_nSegnCoilp.pipe.'m_flows[5]' = RealVariables4[75];
  iceStorageExternalMelt_nSegnCoilp.pipe.'m_flows[6]' = RealVariables4[76];
  iceStorageExternalMelt_nSegnCoilp.pipe.'m_flows[7]' = RealVariables4[77];
  iceStorageExternalMelt_nSegnCoilp.pipe.'m_flows[8]' = RealVariables4[78];
  iceStorageExternalMelt_nSegnCoilp.pipe.'m_flows[9]' = RealVariables4[79];
  iceStorageExternalMelt_nSegnCoilp.pipe.'m_flows[10]' = RealVariables4[80];
  iceStorageExternalMelt_nSegnCoilp.pipe.'m_flows[11]' = RealVariables4[81];
  iceStorageExternalMelt_nSegnCoilp.pipe.'H_flows[1]' = RealVariables4[82];
  iceStorageExternalMelt_nSegnCoilp.pipe.'H_flows[2]' = RealVariables4[83];
  iceStorageExternalMelt_nSegnCoilp.pipe.'H_flows[3]' = RealVariables4[84];
  iceStorageExternalMelt_nSegnCoilp.pipe.'H_flows[4]' = RealVariables4[85];
  iceStorageExternalMelt_nSegnCoilp.pipe.'H_flows[5]' = RealVariables4[86];
  iceStorageExternalMelt_nSegnCoilp.pipe.'H_flows[6]' = RealVariables4[87];
  iceStorageExternalMelt_nSegnCoilp.pipe.'H_flows[7]' = RealVariables4[88];
  iceStorageExternalMelt_nSegnCoilp.pipe.'H_flows[8]' = RealVariables4[89];
  iceStorageExternalMelt_nSegnCoilp.pipe.'H_flows[9]' = RealVariables4[90];
  iceStorageExternalMelt_nSegnCoilp.pipe.'H_flows[10]' = RealVariables4[91];
  iceStorageExternalMelt_nSegnCoilp.pipe.'H_flows[11]' = RealVariables4[92];
  iceStorageExternalMelt_nSegnCoilp.pipe.'vs[1]' = RealVariables4[93];
  iceStorageExternalMelt_nSegnCoilp.pipe.'vs[2]' = RealVariables4[94];
  iceStorageExternalMelt_nSegnCoilp.pipe.'vs[3]' = RealVariables4[95];
  iceStorageExternalMelt_nSegnCoilp.pipe.'vs[4]' = RealVariables4[96];
  iceStorageExternalMelt_nSegnCoilp.pipe.'vs[5]' = RealVariables4[97];
  iceStorageExternalMelt_nSegnCoilp.pipe.'vs[6]' = RealVariables4[98];
  iceStorageExternalMelt_nSegnCoilp.pipe.'vs[7]' = RealVariables4[99];
  iceStorageExternalMelt_nSegnCoilp.pipe.'vs[8]' = RealVariables4[100];
  iceStorageExternalMelt_nSegnCoilp.pipe.'vs[9]' = RealVariables5[1];
  iceStorageExternalMelt_nSegnCoilp.pipe.'vs[10]' = RealVariables5[2];
  iceStorageExternalMelt_nSegnCoilp.pipe.'heatPorts[1]'.T = RealVariables5[3];
  iceStorageExternalMelt_nSegnCoilp.pipe.'heatPorts[1]'.Q_flow = RealVariables5[4];
  iceStorageExternalMelt_nSegnCoilp.pipe.'heatPorts[2]'.T = RealVariables5[5];
  iceStorageExternalMelt_nSegnCoilp.pipe.'heatPorts[2]'.Q_flow = RealVariables5[6];
  iceStorageExternalMelt_nSegnCoilp.pipe.'heatPorts[3]'.T = RealVariables5[7];
  iceStorageExternalMelt_nSegnCoilp.pipe.'heatPorts[3]'.Q_flow = RealVariables5[8];
  iceStorageExternalMelt_nSegnCoilp.pipe.'heatPorts[4]'.T = RealVariables5[9];
  iceStorageExternalMelt_nSegnCoilp.pipe.'heatPorts[4]'.Q_flow = RealVariables5[10];
  iceStorageExternalMelt_nSegnCoilp.pipe.'heatPorts[5]'.T = RealVariables5[11];
  iceStorageExternalMelt_nSegnCoilp.pipe.'heatPorts[5]'.Q_flow = RealVariables5[12];
  iceStorageExternalMelt_nSegnCoilp.pipe.'heatPorts[6]'.T = RealVariables5[13];
  iceStorageExternalMelt_nSegnCoilp.pipe.'heatPorts[6]'.Q_flow = RealVariables5[14];
  iceStorageExternalMelt_nSegnCoilp.pipe.'heatPorts[7]'.T = RealVariables5[15];
  iceStorageExternalMelt_nSegnCoilp.pipe.'heatPorts[7]'.Q_flow = RealVariables5[16];
  iceStorageExternalMelt_nSegnCoilp.pipe.'heatPorts[8]'.T = RealVariables5[17];
  iceStorageExternalMelt_nSegnCoilp.pipe.'heatPorts[8]'.Q_flow = RealVariables5[18];
  iceStorageExternalMelt_nSegnCoilp.pipe.'heatPorts[9]'.T = RealVariables5[19];
  iceStorageExternalMelt_nSegnCoilp.pipe.'heatPorts[9]'.Q_flow = RealVariables5[20];
  iceStorageExternalMelt_nSegnCoilp.pipe.'heatPorts[10]'.T = RealVariables5[21];
  iceStorageExternalMelt_nSegnCoilp.pipe.'heatPorts[10]'.Q_flow = RealVariables5[22];
  iceStorageExternalMelt_nSegnCoilp.pipe.heatTransfer.'states[1]'.T = RealVariables5[23];
  iceStorageExternalMelt_nSegnCoilp.pipe.heatTransfer.'states[1]'.p = RealVariables5[24];
  iceStorageExternalMelt_nSegnCoilp.pipe.heatTransfer.'states[2]'.T = RealVariables5[25];
  iceStorageExternalMelt_nSegnCoilp.pipe.heatTransfer.'states[2]'.p = RealVariables5[26];
  iceStorageExternalMelt_nSegnCoilp.pipe.heatTransfer.'states[3]'.T = RealVariables5[27];
  iceStorageExternalMelt_nSegnCoilp.pipe.heatTransfer.'states[3]'.p = RealVariables5[28];
  iceStorageExternalMelt_nSegnCoilp.pipe.heatTransfer.'states[4]'.T = RealVariables5[29];
  iceStorageExternalMelt_nSegnCoilp.pipe.heatTransfer.'states[4]'.p = RealVariables5[30];
  iceStorageExternalMelt_nSegnCoilp.pipe.heatTransfer.'states[5]'.T = RealVariables5[31];
  iceStorageExternalMelt_nSegnCoilp.pipe.heatTransfer.'states[5]'.p = RealVariables5[32];
  iceStorageExternalMelt_nSegnCoilp.pipe.heatTransfer.'states[6]'.T = RealVariables5[33];
  iceStorageExternalMelt_nSegnCoilp.pipe.heatTransfer.'states[6]'.p = RealVariables5[34];
  iceStorageExternalMelt_nSegnCoilp.pipe.heatTransfer.'states[7]'.T = RealVariables5[35];
  iceStorageExternalMelt_nSegnCoilp.pipe.heatTransfer.'states[7]'.p = RealVariables5[36];
  iceStorageExternalMelt_nSegnCoilp.pipe.heatTransfer.'states[8]'.T = RealVariables5[37];
  iceStorageExternalMelt_nSegnCoilp.pipe.heatTransfer.'states[8]'.p = RealVariables5[38];
  iceStorageExternalMelt_nSegnCoilp.pipe.heatTransfer.'states[9]'.T = RealVariables5[39];
  iceStorageExternalMelt_nSegnCoilp.pipe.heatTransfer.'states[9]'.p = RealVariables5[40];
  iceStorageExternalMelt_nSegnCoilp.pipe.heatTransfer.'states[10]'.T = RealVariables5[41];
  iceStorageExternalMelt_nSegnCoilp.pipe.heatTransfer.'states[10]'.p = RealVariables5[42];
  iceStorageExternalMelt_nSegnCoilp.pipe.heatTransfer.'Q_flows[1]' = RealVariables5[43];
  iceStorageExternalMelt_nSegnCoilp.pipe.heatTransfer.'Q_flows[2]' = RealVariables5[44];
  iceStorageExternalMelt_nSegnCoilp.pipe.heatTransfer.'Q_flows[3]' = RealVariables5[45];
  iceStorageExternalMelt_nSegnCoilp.pipe.heatTransfer.'Q_flows[4]' = RealVariables5[46];
  iceStorageExternalMelt_nSegnCoilp.pipe.heatTransfer.'Q_flows[5]' = RealVariables5[47];
  iceStorageExternalMelt_nSegnCoilp.pipe.heatTransfer.'Q_flows[6]' = RealVariables5[48];
  iceStorageExternalMelt_nSegnCoilp.pipe.heatTransfer.'Q_flows[7]' = RealVariables5[49];
  iceStorageExternalMelt_nSegnCoilp.pipe.heatTransfer.'Q_flows[8]' = RealVariables5[50];
  iceStorageExternalMelt_nSegnCoilp.pipe.heatTransfer.'Q_flows[9]' = RealVariables5[51];
  iceStorageExternalMelt_nSegnCoilp.pipe.heatTransfer.'Q_flows[10]' = RealVariables5[52];
  iceStorageExternalMelt_nSegnCoilp.pipe.heatTransfer.'heatPorts[1]'.T = RealVariables5[53];
  iceStorageExternalMelt_nSegnCoilp.pipe.heatTransfer.'heatPorts[1]'.Q_flow = RealVariables5[54];
  iceStorageExternalMelt_nSegnCoilp.pipe.heatTransfer.'heatPorts[2]'.T = RealVariables5[55];
  iceStorageExternalMelt_nSegnCoilp.pipe.heatTransfer.'heatPorts[2]'.Q_flow = RealVariables5[56];
  iceStorageExternalMelt_nSegnCoilp.pipe.heatTransfer.'heatPorts[3]'.T = RealVariables5[57];
  iceStorageExternalMelt_nSegnCoilp.pipe.heatTransfer.'heatPorts[3]'.Q_flow = RealVariables5[58];
  iceStorageExternalMelt_nSegnCoilp.pipe.heatTransfer.'heatPorts[4]'.T = RealVariables5[59];
  iceStorageExternalMelt_nSegnCoilp.pipe.heatTransfer.'heatPorts[4]'.Q_flow = RealVariables5[60];
  iceStorageExternalMelt_nSegnCoilp.pipe.heatTransfer.'heatPorts[5]'.T = RealVariables5[61];
  iceStorageExternalMelt_nSegnCoilp.pipe.heatTransfer.'heatPorts[5]'.Q_flow = RealVariables5[62];
  iceStorageExternalMelt_nSegnCoilp.pipe.heatTransfer.'heatPorts[6]'.T = RealVariables5[63];
  iceStorageExternalMelt_nSegnCoilp.pipe.heatTransfer.'heatPorts[6]'.Q_flow = RealVariables5[64];
  iceStorageExternalMelt_nSegnCoilp.pipe.heatTransfer.'heatPorts[7]'.T = RealVariables5[65];
  iceStorageExternalMelt_nSegnCoilp.pipe.heatTransfer.'heatPorts[7]'.Q_flow = RealVariables5[66];
  iceStorageExternalMelt_nSegnCoilp.pipe.heatTransfer.'heatPorts[8]'.T = RealVariables5[67];
  iceStorageExternalMelt_nSegnCoilp.pipe.heatTransfer.'heatPorts[8]'.Q_flow = RealVariables5[68];
  iceStorageExternalMelt_nSegnCoilp.pipe.heatTransfer.'heatPorts[9]'.T = RealVariables5[69];
  iceStorageExternalMelt_nSegnCoilp.pipe.heatTransfer.'heatPorts[9]'.Q_flow = RealVariables5[70];
  iceStorageExternalMelt_nSegnCoilp.pipe.heatTransfer.'heatPorts[10]'.T = RealVariables5[71];
  iceStorageExternalMelt_nSegnCoilp.pipe.heatTransfer.'heatPorts[10]'.Q_flow = RealVariables5[72];
  iceStorageExternalMelt_nSegnCoilp.pipe.heatTransfer.'Ts[1]' = RealVariables5[73];
  iceStorageExternalMelt_nSegnCoilp.pipe.heatTransfer.'Ts[2]' = RealVariables5[74];
  iceStorageExternalMelt_nSegnCoilp.pipe.heatTransfer.'Ts[3]' = RealVariables5[75];
  iceStorageExternalMelt_nSegnCoilp.pipe.heatTransfer.'Ts[4]' = RealVariables5[76];
  iceStorageExternalMelt_nSegnCoilp.pipe.heatTransfer.'Ts[5]' = RealVariables5[77];
  iceStorageExternalMelt_nSegnCoilp.pipe.heatTransfer.'Ts[6]' = RealVariables5[78];
  iceStorageExternalMelt_nSegnCoilp.pipe.heatTransfer.'Ts[7]' = RealVariables5[79];
  iceStorageExternalMelt_nSegnCoilp.pipe.heatTransfer.'Ts[8]' = RealVariables5[80];
  iceStorageExternalMelt_nSegnCoilp.pipe.heatTransfer.'Ts[9]' = RealVariables5[81];
  iceStorageExternalMelt_nSegnCoilp.pipe.heatTransfer.'Ts[10]' = RealVariables5[82];
  iceStorageExternalMelt_nSegnCoilp.pipe.heatTransfer.'vs[1]' = RealVariables5[83];
  iceStorageExternalMelt_nSegnCoilp.pipe.heatTransfer.'vs[2]' = RealVariables5[84];
  iceStorageExternalMelt_nSegnCoilp.pipe.heatTransfer.'vs[3]' = RealVariables5[85];
  iceStorageExternalMelt_nSegnCoilp.pipe.heatTransfer.'vs[4]' = RealVariables5[86];
  iceStorageExternalMelt_nSegnCoilp.pipe.heatTransfer.'vs[5]' = RealVariables5[87];
  iceStorageExternalMelt_nSegnCoilp.pipe.heatTransfer.'vs[6]' = RealVariables5[88];
  iceStorageExternalMelt_nSegnCoilp.pipe.heatTransfer.'vs[7]' = RealVariables5[89];
  iceStorageExternalMelt_nSegnCoilp.pipe.heatTransfer.'vs[8]' = RealVariables5[90];
  iceStorageExternalMelt_nSegnCoilp.pipe.heatTransfer.'vs[9]' = RealVariables5[91];
  iceStorageExternalMelt_nSegnCoilp.pipe.heatTransfer.'vs[10]' = RealVariables5[92];
  iceStorageExternalMelt_nSegnCoilp.pipe.heatTransfer.'dimensions[1]' = RealVariables5[93];
  iceStorageExternalMelt_nSegnCoilp.pipe.heatTransfer.'dimensions[2]' = RealVariables5[94];
  iceStorageExternalMelt_nSegnCoilp.pipe.heatTransfer.'dimensions[3]' = RealVariables5[95];
  iceStorageExternalMelt_nSegnCoilp.pipe.heatTransfer.'dimensions[4]' = RealVariables5[96];
  iceStorageExternalMelt_nSegnCoilp.pipe.heatTransfer.'dimensions[5]' = RealVariables5[97];
  iceStorageExternalMelt_nSegnCoilp.pipe.heatTransfer.'dimensions[6]' = RealVariables5[98];
  iceStorageExternalMelt_nSegnCoilp.pipe.heatTransfer.'dimensions[7]' = RealVariables5[99];
  iceStorageExternalMelt_nSegnCoilp.pipe.heatTransfer.'dimensions[8]' = RealVariables5[100];
  iceStorageExternalMelt_nSegnCoilp.pipe.heatTransfer.'dimensions[9]' = RealVariables6[1];
  iceStorageExternalMelt_nSegnCoilp.pipe.heatTransfer.'dimensions[10]' = RealVariables6[2];
  iceStorageExternalMelt_nSegnCoilp.pipe.heatTransfer.'roughnesses[1]' = RealVariables6[3];
  iceStorageExternalMelt_nSegnCoilp.pipe.heatTransfer.'roughnesses[2]' = RealVariables6[4];
  iceStorageExternalMelt_nSegnCoilp.pipe.heatTransfer.'roughnesses[3]' = RealVariables6[5];
  iceStorageExternalMelt_nSegnCoilp.pipe.heatTransfer.'roughnesses[4]' = RealVariables6[6];
  iceStorageExternalMelt_nSegnCoilp.pipe.heatTransfer.'roughnesses[5]' = RealVariables6[7];
  iceStorageExternalMelt_nSegnCoilp.pipe.heatTransfer.'roughnesses[6]' = RealVariables6[8];
  iceStorageExternalMelt_nSegnCoilp.pipe.heatTransfer.'roughnesses[7]' = RealVariables6[9];
  iceStorageExternalMelt_nSegnCoilp.pipe.heatTransfer.'roughnesses[8]' = RealVariables6[10];
  iceStorageExternalMelt_nSegnCoilp.pipe.heatTransfer.'roughnesses[9]' = RealVariables6[11];
  iceStorageExternalMelt_nSegnCoilp.pipe.heatTransfer.'roughnesses[10]' = RealVariables6[12];
  iceStorageExternalMelt_nSegnCoilp.pipe.'mediums[1]'.p = RealVariables6[13];
  iceStorageExternalMelt_nSegnCoilp.pipe.'mediums[1]'.h = RealVariables6[14];
  iceStorageExternalMelt_nSegnCoilp.pipe.'mediums[1]'.d = RealVariables6[15];
  iceStorageExternalMelt_nSegnCoilp.pipe.'mediums[1]'.d_der = RealVariables6[16];
  iceStorageExternalMelt_nSegnCoilp.pipe.'mediums[1]'.T = RealVariables6[17];
  iceStorageExternalMelt_nSegnCoilp.pipe.'mediums[1]'.T_der = RealVariables6[18];
  iceStorageExternalMelt_nSegnCoilp.pipe.'mediums[1]'.u = RealVariables6[19];
  iceStorageExternalMelt_nSegnCoilp.pipe.'mediums[1]'.u_der = RealVariables6[20];
  iceStorageExternalMelt_nSegnCoilp.pipe.'mediums[1]'.state.T = RealVariables6[21];
  iceStorageExternalMelt_nSegnCoilp.pipe.'mediums[1]'.state.p = RealVariables6[22];
  iceStorageExternalMelt_nSegnCoilp.pipe.'mediums[1]'.T_degC = RealVariables6[23];
  iceStorageExternalMelt_nSegnCoilp.pipe.'mediums[1]'.p_bar = RealVariables6[24];
  iceStorageExternalMelt_nSegnCoilp.pipe.'mediums[1]'.cp = RealVariables6[25];
  iceStorageExternalMelt_nSegnCoilp.pipe.'mediums[2]'.p = RealVariables6[26];
  iceStorageExternalMelt_nSegnCoilp.pipe.'mediums[2]'.h = RealVariables6[27];
  iceStorageExternalMelt_nSegnCoilp.pipe.'mediums[2]'.h_der = RealVariables6[28];
  iceStorageExternalMelt_nSegnCoilp.pipe.'mediums[2]'.d = RealVariables6[29];
  iceStorageExternalMelt_nSegnCoilp.pipe.'mediums[2]'.d_der = RealVariables6[30];
  iceStorageExternalMelt_nSegnCoilp.pipe.'mediums[2]'.T = RealVariables6[31];
  iceStorageExternalMelt_nSegnCoilp.pipe.'mediums[2]'.T_der = RealVariables6[32];
  iceStorageExternalMelt_nSegnCoilp.pipe.'mediums[2]'.u = RealVariables6[33];
  iceStorageExternalMelt_nSegnCoilp.pipe.'mediums[2]'.u_der = RealVariables6[34];
  iceStorageExternalMelt_nSegnCoilp.pipe.'mediums[2]'.state.T = RealVariables6[35];
  iceStorageExternalMelt_nSegnCoilp.pipe.'mediums[2]'.state.p = RealVariables6[36];
  iceStorageExternalMelt_nSegnCoilp.pipe.'mediums[2]'.T_degC = RealVariables6[37];
  iceStorageExternalMelt_nSegnCoilp.pipe.'mediums[2]'.p_bar = RealVariables6[38];
  iceStorageExternalMelt_nSegnCoilp.pipe.'mediums[2]'.cp = RealVariables6[39];
  iceStorageExternalMelt_nSegnCoilp.pipe.'mediums[3]'.p = RealVariables6[40];
  iceStorageExternalMelt_nSegnCoilp.pipe.'mediums[3]'.h = RealVariables6[41];
  iceStorageExternalMelt_nSegnCoilp.pipe.'mediums[3]'.h_der = RealVariables6[42];
  iceStorageExternalMelt_nSegnCoilp.pipe.'mediums[3]'.d = RealVariables6[43];
  iceStorageExternalMelt_nSegnCoilp.pipe.'mediums[3]'.d_der = RealVariables6[44];
  iceStorageExternalMelt_nSegnCoilp.pipe.'mediums[3]'.T = RealVariables6[45];
  iceStorageExternalMelt_nSegnCoilp.pipe.'mediums[3]'.T_der = RealVariables6[46];
  iceStorageExternalMelt_nSegnCoilp.pipe.'mediums[3]'.u = RealVariables6[47];
  iceStorageExternalMelt_nSegnCoilp.pipe.'mediums[3]'.u_der = RealVariables6[48];
  iceStorageExternalMelt_nSegnCoilp.pipe.'mediums[3]'.state.T = RealVariables6[49];
  iceStorageExternalMelt_nSegnCoilp.pipe.'mediums[3]'.state.p = RealVariables6[50];
  iceStorageExternalMelt_nSegnCoilp.pipe.'mediums[3]'.T_degC = RealVariables6[51];
  iceStorageExternalMelt_nSegnCoilp.pipe.'mediums[3]'.p_bar = RealVariables6[52];
  iceStorageExternalMelt_nSegnCoilp.pipe.'mediums[3]'.cp = RealVariables6[53];
  iceStorageExternalMelt_nSegnCoilp.pipe.'mediums[4]'.p = RealVariables6[54];
  iceStorageExternalMelt_nSegnCoilp.pipe.'mediums[4]'.h = RealVariables6[55];
  iceStorageExternalMelt_nSegnCoilp.pipe.'mediums[4]'.h_der = RealVariables6[56];
  iceStorageExternalMelt_nSegnCoilp.pipe.'mediums[4]'.d = RealVariables6[57];
  iceStorageExternalMelt_nSegnCoilp.pipe.'mediums[4]'.d_der = RealVariables6[58];
  iceStorageExternalMelt_nSegnCoilp.pipe.'mediums[4]'.T = RealVariables6[59];
  iceStorageExternalMelt_nSegnCoilp.pipe.'mediums[4]'.T_der = RealVariables6[60];
  iceStorageExternalMelt_nSegnCoilp.pipe.'mediums[4]'.u = RealVariables6[61];
  iceStorageExternalMelt_nSegnCoilp.pipe.'mediums[4]'.u_der = RealVariables6[62];
  iceStorageExternalMelt_nSegnCoilp.pipe.'mediums[4]'.state.T = RealVariables6[63];
  iceStorageExternalMelt_nSegnCoilp.pipe.'mediums[4]'.state.p = RealVariables6[64];
  iceStorageExternalMelt_nSegnCoilp.pipe.'mediums[4]'.T_degC = RealVariables6[65];
  iceStorageExternalMelt_nSegnCoilp.pipe.'mediums[4]'.p_bar = RealVariables6[66];
  iceStorageExternalMelt_nSegnCoilp.pipe.'mediums[4]'.cp = RealVariables6[67];
  iceStorageExternalMelt_nSegnCoilp.pipe.'mediums[5]'.p = RealVariables6[68];
  iceStorageExternalMelt_nSegnCoilp.pipe.'mediums[5]'.h = RealVariables6[69];
  iceStorageExternalMelt_nSegnCoilp.pipe.'mediums[5]'.h_der = RealVariables6[70];
  iceStorageExternalMelt_nSegnCoilp.pipe.'mediums[5]'.d = RealVariables6[71];
  iceStorageExternalMelt_nSegnCoilp.pipe.'mediums[5]'.d_der = RealVariables6[72];
  iceStorageExternalMelt_nSegnCoilp.pipe.'mediums[5]'.T = RealVariables6[73];
  iceStorageExternalMelt_nSegnCoilp.pipe.'mediums[5]'.T_der = RealVariables6[74];
  iceStorageExternalMelt_nSegnCoilp.pipe.'mediums[5]'.u = RealVariables6[75];
  iceStorageExternalMelt_nSegnCoilp.pipe.'mediums[5]'.u_der = RealVariables6[76];
  iceStorageExternalMelt_nSegnCoilp.pipe.'mediums[5]'.state.T = RealVariables6[77];
  iceStorageExternalMelt_nSegnCoilp.pipe.'mediums[5]'.state.p = RealVariables6[78];
  iceStorageExternalMelt_nSegnCoilp.pipe.'mediums[5]'.T_degC = RealVariables6[79];
  iceStorageExternalMelt_nSegnCoilp.pipe.'mediums[5]'.p_bar = RealVariables6[80];
  iceStorageExternalMelt_nSegnCoilp.pipe.'mediums[5]'.cp = RealVariables6[81];
  iceStorageExternalMelt_nSegnCoilp.pipe.'mediums[6]'.p = RealVariables6[82];
  iceStorageExternalMelt_nSegnCoilp.pipe.'mediums[6]'.h = RealVariables6[83];
  iceStorageExternalMelt_nSegnCoilp.pipe.'mediums[6]'.h_der = RealVariables6[84];
  iceStorageExternalMelt_nSegnCoilp.pipe.'mediums[6]'.d = RealVariables6[85];
  iceStorageExternalMelt_nSegnCoilp.pipe.'mediums[6]'.d_der = RealVariables6[86];
  iceStorageExternalMelt_nSegnCoilp.pipe.'mediums[6]'.T = RealVariables6[87];
  iceStorageExternalMelt_nSegnCoilp.pipe.'mediums[6]'.T_der = RealVariables6[88];
  iceStorageExternalMelt_nSegnCoilp.pipe.'mediums[6]'.u = RealVariables6[89];
  iceStorageExternalMelt_nSegnCoilp.pipe.'mediums[6]'.u_der = RealVariables6[90];
  iceStorageExternalMelt_nSegnCoilp.pipe.'mediums[6]'.state.T = RealVariables6[91];
  iceStorageExternalMelt_nSegnCoilp.pipe.'mediums[6]'.state.p = RealVariables6[92];
  iceStorageExternalMelt_nSegnCoilp.pipe.'mediums[6]'.T_degC = RealVariables6[93];
  iceStorageExternalMelt_nSegnCoilp.pipe.'mediums[6]'.p_bar = RealVariables6[94];
  iceStorageExternalMelt_nSegnCoilp.pipe.'mediums[6]'.cp = RealVariables6[95];
  iceStorageExternalMelt_nSegnCoilp.pipe.'mediums[7]'.p = RealVariables6[96];
  iceStorageExternalMelt_nSegnCoilp.pipe.'mediums[7]'.h = RealVariables6[97];
  iceStorageExternalMelt_nSegnCoilp.pipe.'mediums[7]'.h_der = RealVariables6[98];
  iceStorageExternalMelt_nSegnCoilp.pipe.'mediums[7]'.d = RealVariables6[99];
  iceStorageExternalMelt_nSegnCoilp.pipe.'mediums[7]'.d_der = RealVariables6[100];
  iceStorageExternalMelt_nSegnCoilp.pipe.'mediums[7]'.T = RealVariables7[1];
  iceStorageExternalMelt_nSegnCoilp.pipe.'mediums[7]'.T_der = RealVariables7[2];
  iceStorageExternalMelt_nSegnCoilp.pipe.'mediums[7]'.u = RealVariables7[3];
  iceStorageExternalMelt_nSegnCoilp.pipe.'mediums[7]'.u_der = RealVariables7[4];
  iceStorageExternalMelt_nSegnCoilp.pipe.'mediums[7]'.state.T = RealVariables7[5];
  iceStorageExternalMelt_nSegnCoilp.pipe.'mediums[7]'.state.p = RealVariables7[6];
  iceStorageExternalMelt_nSegnCoilp.pipe.'mediums[7]'.T_degC = RealVariables7[7];
  iceStorageExternalMelt_nSegnCoilp.pipe.'mediums[7]'.p_bar = RealVariables7[8];
  iceStorageExternalMelt_nSegnCoilp.pipe.'mediums[7]'.cp = RealVariables7[9];
  iceStorageExternalMelt_nSegnCoilp.pipe.'mediums[8]'.p = RealVariables7[10];
  iceStorageExternalMelt_nSegnCoilp.pipe.'mediums[8]'.h = RealVariables7[11];
  iceStorageExternalMelt_nSegnCoilp.pipe.'mediums[8]'.h_der = RealVariables7[12];
  iceStorageExternalMelt_nSegnCoilp.pipe.'mediums[8]'.d = RealVariables7[13];
  iceStorageExternalMelt_nSegnCoilp.pipe.'mediums[8]'.d_der = RealVariables7[14];
  iceStorageExternalMelt_nSegnCoilp.pipe.'mediums[8]'.T = RealVariables7[15];
  iceStorageExternalMelt_nSegnCoilp.pipe.'mediums[8]'.T_der = RealVariables7[16];
  iceStorageExternalMelt_nSegnCoilp.pipe.'mediums[8]'.u = RealVariables7[17];
  iceStorageExternalMelt_nSegnCoilp.pipe.'mediums[8]'.u_der = RealVariables7[18];
  iceStorageExternalMelt_nSegnCoilp.pipe.'mediums[8]'.state.T = RealVariables7[19];
  iceStorageExternalMelt_nSegnCoilp.pipe.'mediums[8]'.state.p = RealVariables7[20];
  iceStorageExternalMelt_nSegnCoilp.pipe.'mediums[8]'.T_degC = RealVariables7[21];
  iceStorageExternalMelt_nSegnCoilp.pipe.'mediums[8]'.p_bar = RealVariables7[22];
  iceStorageExternalMelt_nSegnCoilp.pipe.'mediums[8]'.cp = RealVariables7[23];
  iceStorageExternalMelt_nSegnCoilp.pipe.'mediums[9]'.p = RealVariables7[24];
  iceStorageExternalMelt_nSegnCoilp.pipe.'mediums[9]'.h = RealVariables7[25];
  iceStorageExternalMelt_nSegnCoilp.pipe.'mediums[9]'.h_der = RealVariables7[26];
  iceStorageExternalMelt_nSegnCoilp.pipe.'mediums[9]'.d = RealVariables7[27];
  iceStorageExternalMelt_nSegnCoilp.pipe.'mediums[9]'.d_der = RealVariables7[28];
  iceStorageExternalMelt_nSegnCoilp.pipe.'mediums[9]'.T = RealVariables7[29];
  iceStorageExternalMelt_nSegnCoilp.pipe.'mediums[9]'.T_der = RealVariables7[30];
  iceStorageExternalMelt_nSegnCoilp.pipe.'mediums[9]'.u = RealVariables7[31];
  iceStorageExternalMelt_nSegnCoilp.pipe.'mediums[9]'.u_der = RealVariables7[32];
  iceStorageExternalMelt_nSegnCoilp.pipe.'mediums[9]'.state.T = RealVariables7[33];
  iceStorageExternalMelt_nSegnCoilp.pipe.'mediums[9]'.state.p = RealVariables7[34];
  iceStorageExternalMelt_nSegnCoilp.pipe.'mediums[9]'.T_degC = RealVariables7[35];
  iceStorageExternalMelt_nSegnCoilp.pipe.'mediums[9]'.p_bar = RealVariables7[36];
  iceStorageExternalMelt_nSegnCoilp.pipe.'mediums[9]'.cp = RealVariables7[37];
  iceStorageExternalMelt_nSegnCoilp.pipe.'mediums[10]'.p = RealVariables7[38];
  iceStorageExternalMelt_nSegnCoilp.pipe.'mediums[10]'.h = RealVariables7[39];
  iceStorageExternalMelt_nSegnCoilp.pipe.'mediums[10]'.d = RealVariables7[40];
  iceStorageExternalMelt_nSegnCoilp.pipe.'mediums[10]'.d_der = RealVariables7[41];
  iceStorageExternalMelt_nSegnCoilp.pipe.'mediums[10]'.T = RealVariables7[42];
  iceStorageExternalMelt_nSegnCoilp.pipe.'mediums[10]'.T_der = RealVariables7[43];
  iceStorageExternalMelt_nSegnCoilp.pipe.'mediums[10]'.u = RealVariables7[44];
  iceStorageExternalMelt_nSegnCoilp.pipe.'mediums[10]'.u_der = RealVariables7[45];
  iceStorageExternalMelt_nSegnCoilp.pipe.'mediums[10]'.state.T = RealVariables7[46];
  iceStorageExternalMelt_nSegnCoilp.pipe.'mediums[10]'.state.p = RealVariables7[47];
  iceStorageExternalMelt_nSegnCoilp.pipe.'mediums[10]'.T_degC = RealVariables7[48];
  iceStorageExternalMelt_nSegnCoilp.pipe.'mediums[10]'.cp = RealVariables7[49];
  iceStorageExternalMelt_nSegnCoilp.'hTFtoPCM[1]'.HTFtoTube.Q_flow = RealVariables7[50];
  iceStorageExternalMelt_nSegnCoilp.'hTFtoPCM[1]'.HTFtoTube.dT = RealVariables7[51];
  iceStorageExternalMelt_nSegnCoilp.'hTFtoPCM[1]'.HTFtoTube.port_a.T = RealVariables7[52];
  iceStorageExternalMelt_nSegnCoilp.'hTFtoPCM[1]'.HTFtoTube.port_a.Q_flow = RealVariables7[53];
  iceStorageExternalMelt_nSegnCoilp.'hTFtoPCM[1]'.HTFtoTube.port_b.T = RealVariables7[54];
  iceStorageExternalMelt_nSegnCoilp.'hTFtoPCM[1]'.HTFtoTube.port_b.Q_flow = RealVariables7[55];
  iceStorageExternalMelt_nSegnCoilp.'hTFtoPCM[1]'.HTFtoTube.G = RealVariables7[56];
  iceStorageExternalMelt_nSegnCoilp.'hTFtoPCM[1]'.TubetoPCM.Q_flow = RealVariables7[57];
  iceStorageExternalMelt_nSegnCoilp.'hTFtoPCM[1]'.TubetoPCM.dT = RealVariables7[58];
  iceStorageExternalMelt_nSegnCoilp.'hTFtoPCM[1]'.TubetoPCM.port_a.T = RealVariables7[59];
  iceStorageExternalMelt_nSegnCoilp.'hTFtoPCM[1]'.TubetoPCM.port_a.Q_flow = RealVariables7[60];
  iceStorageExternalMelt_nSegnCoilp.'hTFtoPCM[1]'.TubetoPCM.port_b.T = RealVariables7[61];
  iceStorageExternalMelt_nSegnCoilp.'hTFtoPCM[1]'.TubetoPCM.port_b.Q_flow = RealVariables7[62];
  iceStorageExternalMelt_nSegnCoilp.'hTFtoPCM[1]'.TubetoPCM.G = RealVariables7[63];
  iceStorageExternalMelt_nSegnCoilp.'hTFtoPCM[1]'.TubeInertia.T = RealVariables7[64];
  iceStorageExternalMelt_nSegnCoilp.'hTFtoPCM[1]'.TubeInertia.T_der = RealVariables7[65];
  iceStorageExternalMelt_nSegnCoilp.'hTFtoPCM[1]'.TubeInertia.Q_flow = RealVariables7[66];
  iceStorageExternalMelt_nSegnCoilp.'hTFtoPCM[1]'.TubeInertia.port.T = RealVariables7[67];
  iceStorageExternalMelt_nSegnCoilp.'hTFtoPCM[1]'.TubeInertia.port.Q_flow = RealVariables7[68];
  iceStorageExternalMelt_nSegnCoilp.'hTFtoPCM[1]'.TubeInertia.der_T = RealVariables7[69];
  iceStorageExternalMelt_nSegnCoilp.'hTFtoPCM[1]'.TubeInertia.C = RealVariables7[70];
  iceStorageExternalMelt_nSegnCoilp.'hTFtoPCM[1]'.port_b.T = RealVariables7[71];
  iceStorageExternalMelt_nSegnCoilp.'hTFtoPCM[1]'.port_b.Q_flow = RealVariables7[72];
  iceStorageExternalMelt_nSegnCoilp.'hTFtoPCM[1]'.port_a.T = RealVariables7[73];
  iceStorageExternalMelt_nSegnCoilp.'hTFtoPCM[1]'.port_a.Q_flow = RealVariables7[74];
  iceStorageExternalMelt_nSegnCoilp.'hTFtoPCM[1]'.G_HTFtoTube = RealVariables7[75];
  iceStorageExternalMelt_nSegnCoilp.'hTFtoPCM[1]'.G_TubetoPCM = RealVariables7[76];
  iceStorageExternalMelt_nSegnCoilp.'hTFtoPCM[2]'.HTFtoTube.Q_flow = RealVariables7[77];
  iceStorageExternalMelt_nSegnCoilp.'hTFtoPCM[2]'.HTFtoTube.dT = RealVariables7[78];
  iceStorageExternalMelt_nSegnCoilp.'hTFtoPCM[2]'.HTFtoTube.port_a.T = RealVariables7[79];
  iceStorageExternalMelt_nSegnCoilp.'hTFtoPCM[2]'.HTFtoTube.port_a.Q_flow = RealVariables7[80];
  iceStorageExternalMelt_nSegnCoilp.'hTFtoPCM[2]'.HTFtoTube.port_b.T = RealVariables7[81];
  iceStorageExternalMelt_nSegnCoilp.'hTFtoPCM[2]'.HTFtoTube.port_b.Q_flow = RealVariables7[82];
  iceStorageExternalMelt_nSegnCoilp.'hTFtoPCM[2]'.HTFtoTube.G = RealVariables7[83];
  iceStorageExternalMelt_nSegnCoilp.'hTFtoPCM[2]'.TubetoPCM.Q_flow = RealVariables7[84];
  iceStorageExternalMelt_nSegnCoilp.'hTFtoPCM[2]'.TubetoPCM.dT = RealVariables7[85];
  iceStorageExternalMelt_nSegnCoilp.'hTFtoPCM[2]'.TubetoPCM.port_a.T = RealVariables7[86];
  iceStorageExternalMelt_nSegnCoilp.'hTFtoPCM[2]'.TubetoPCM.port_a.Q_flow = RealVariables7[87];
  iceStorageExternalMelt_nSegnCoilp.'hTFtoPCM[2]'.TubetoPCM.port_b.T = RealVariables7[88];
  iceStorageExternalMelt_nSegnCoilp.'hTFtoPCM[2]'.TubetoPCM.port_b.Q_flow = RealVariables7[89];
  iceStorageExternalMelt_nSegnCoilp.'hTFtoPCM[2]'.TubetoPCM.G = RealVariables7[90];
  iceStorageExternalMelt_nSegnCoilp.'hTFtoPCM[2]'.TubeInertia.T = RealVariables7[91];
  iceStorageExternalMelt_nSegnCoilp.'hTFtoPCM[2]'.TubeInertia.T_der = RealVariables7[92];
  iceStorageExternalMelt_nSegnCoilp.'hTFtoPCM[2]'.TubeInertia.Q_flow = RealVariables7[93];
  iceStorageExternalMelt_nSegnCoilp.'hTFtoPCM[2]'.TubeInertia.port.T = RealVariables7[94];
  iceStorageExternalMelt_nSegnCoilp.'hTFtoPCM[2]'.TubeInertia.port.Q_flow = RealVariables7[95];
  iceStorageExternalMelt_nSegnCoilp.'hTFtoPCM[2]'.TubeInertia.der_T = RealVariables7[96];
  iceStorageExternalMelt_nSegnCoilp.'hTFtoPCM[2]'.TubeInertia.C = RealVariables7[97];
  iceStorageExternalMelt_nSegnCoilp.'hTFtoPCM[2]'.port_b.T = RealVariables7[98];
  iceStorageExternalMelt_nSegnCoilp.'hTFtoPCM[2]'.port_b.Q_flow = RealVariables7[99];
  iceStorageExternalMelt_nSegnCoilp.'hTFtoPCM[2]'.port_a.T = RealVariables7[100];
  iceStorageExternalMelt_nSegnCoilp.'hTFtoPCM[2]'.port_a.Q_flow = RealVariables8[1];
  iceStorageExternalMelt_nSegnCoilp.'hTFtoPCM[2]'.G_HTFtoTube = RealVariables8[2];
  iceStorageExternalMelt_nSegnCoilp.'hTFtoPCM[2]'.G_TubetoPCM = RealVariables8[3];
  iceStorageExternalMelt_nSegnCoilp.'hTFtoPCM[3]'.HTFtoTube.Q_flow = RealVariables8[4];
  iceStorageExternalMelt_nSegnCoilp.'hTFtoPCM[3]'.HTFtoTube.dT = RealVariables8[5];
  iceStorageExternalMelt_nSegnCoilp.'hTFtoPCM[3]'.HTFtoTube.port_a.T = RealVariables8[6];
  iceStorageExternalMelt_nSegnCoilp.'hTFtoPCM[3]'.HTFtoTube.port_a.Q_flow = RealVariables8[7];
  iceStorageExternalMelt_nSegnCoilp.'hTFtoPCM[3]'.HTFtoTube.port_b.T = RealVariables8[8];
  iceStorageExternalMelt_nSegnCoilp.'hTFtoPCM[3]'.HTFtoTube.port_b.Q_flow = RealVariables8[9];
  iceStorageExternalMelt_nSegnCoilp.'hTFtoPCM[3]'.HTFtoTube.G = RealVariables8[10];
  iceStorageExternalMelt_nSegnCoilp.'hTFtoPCM[3]'.TubetoPCM.Q_flow = RealVariables8[11];
  iceStorageExternalMelt_nSegnCoilp.'hTFtoPCM[3]'.TubetoPCM.dT = RealVariables8[12];
  iceStorageExternalMelt_nSegnCoilp.'hTFtoPCM[3]'.TubetoPCM.port_a.T = RealVariables8[13];
  iceStorageExternalMelt_nSegnCoilp.'hTFtoPCM[3]'.TubetoPCM.port_a.Q_flow = RealVariables8[14];
  iceStorageExternalMelt_nSegnCoilp.'hTFtoPCM[3]'.TubetoPCM.port_b.T = RealVariables8[15];
  iceStorageExternalMelt_nSegnCoilp.'hTFtoPCM[3]'.TubetoPCM.port_b.Q_flow = RealVariables8[16];
  iceStorageExternalMelt_nSegnCoilp.'hTFtoPCM[3]'.TubetoPCM.G = RealVariables8[17];
  iceStorageExternalMelt_nSegnCoilp.'hTFtoPCM[3]'.TubeInertia.T = RealVariables8[18];
  iceStorageExternalMelt_nSegnCoilp.'hTFtoPCM[3]'.TubeInertia.T_der = RealVariables8[19];
  iceStorageExternalMelt_nSegnCoilp.'hTFtoPCM[3]'.TubeInertia.Q_flow = RealVariables8[20];
  iceStorageExternalMelt_nSegnCoilp.'hTFtoPCM[3]'.TubeInertia.port.T = RealVariables8[21];
  iceStorageExternalMelt_nSegnCoilp.'hTFtoPCM[3]'.TubeInertia.port.Q_flow = RealVariables8[22];
  iceStorageExternalMelt_nSegnCoilp.'hTFtoPCM[3]'.TubeInertia.der_T = RealVariables8[23];
  iceStorageExternalMelt_nSegnCoilp.'hTFtoPCM[3]'.TubeInertia.C = RealVariables8[24];
  iceStorageExternalMelt_nSegnCoilp.'hTFtoPCM[3]'.port_b.T = RealVariables8[25];
  iceStorageExternalMelt_nSegnCoilp.'hTFtoPCM[3]'.port_b.Q_flow = RealVariables8[26];
  iceStorageExternalMelt_nSegnCoilp.'hTFtoPCM[3]'.port_a.T = RealVariables8[27];
  iceStorageExternalMelt_nSegnCoilp.'hTFtoPCM[3]'.port_a.Q_flow = RealVariables8[28];
  iceStorageExternalMelt_nSegnCoilp.'hTFtoPCM[3]'.G_HTFtoTube = RealVariables8[29];
  iceStorageExternalMelt_nSegnCoilp.'hTFtoPCM[3]'.G_TubetoPCM = RealVariables8[30];
  iceStorageExternalMelt_nSegnCoilp.'hTFtoPCM[4]'.HTFtoTube.Q_flow = RealVariables8[31];
  iceStorageExternalMelt_nSegnCoilp.'hTFtoPCM[4]'.HTFtoTube.dT = RealVariables8[32];
  iceStorageExternalMelt_nSegnCoilp.'hTFtoPCM[4]'.HTFtoTube.port_a.T = RealVariables8[33];
  iceStorageExternalMelt_nSegnCoilp.'hTFtoPCM[4]'.HTFtoTube.port_a.Q_flow = RealVariables8[34];
  iceStorageExternalMelt_nSegnCoilp.'hTFtoPCM[4]'.HTFtoTube.port_b.T = RealVariables8[35];
  iceStorageExternalMelt_nSegnCoilp.'hTFtoPCM[4]'.HTFtoTube.port_b.Q_flow = RealVariables8[36];
  iceStorageExternalMelt_nSegnCoilp.'hTFtoPCM[4]'.HTFtoTube.G = RealVariables8[37];
  iceStorageExternalMelt_nSegnCoilp.'hTFtoPCM[4]'.TubetoPCM.Q_flow = RealVariables8[38];
  iceStorageExternalMelt_nSegnCoilp.'hTFtoPCM[4]'.TubetoPCM.dT = RealVariables8[39];
  iceStorageExternalMelt_nSegnCoilp.'hTFtoPCM[4]'.TubetoPCM.port_a.T = RealVariables8[40];
  iceStorageExternalMelt_nSegnCoilp.'hTFtoPCM[4]'.TubetoPCM.port_a.Q_flow = RealVariables8[41];
  iceStorageExternalMelt_nSegnCoilp.'hTFtoPCM[4]'.TubetoPCM.port_b.T = RealVariables8[42];
  iceStorageExternalMelt_nSegnCoilp.'hTFtoPCM[4]'.TubetoPCM.port_b.Q_flow = RealVariables8[43];
  iceStorageExternalMelt_nSegnCoilp.'hTFtoPCM[4]'.TubetoPCM.G = RealVariables8[44];
  iceStorageExternalMelt_nSegnCoilp.'hTFtoPCM[4]'.TubeInertia.T = RealVariables8[45];
  iceStorageExternalMelt_nSegnCoilp.'hTFtoPCM[4]'.TubeInertia.T_der = RealVariables8[46];
  iceStorageExternalMelt_nSegnCoilp.'hTFtoPCM[4]'.TubeInertia.Q_flow = RealVariables8[47];
  iceStorageExternalMelt_nSegnCoilp.'hTFtoPCM[4]'.TubeInertia.port.T = RealVariables8[48];
  iceStorageExternalMelt_nSegnCoilp.'hTFtoPCM[4]'.TubeInertia.port.Q_flow = RealVariables8[49];
  iceStorageExternalMelt_nSegnCoilp.'hTFtoPCM[4]'.TubeInertia.der_T = RealVariables8[50];
  iceStorageExternalMelt_nSegnCoilp.'hTFtoPCM[4]'.TubeInertia.C = RealVariables8[51];
  iceStorageExternalMelt_nSegnCoilp.'hTFtoPCM[4]'.port_b.T = RealVariables8[52];
  iceStorageExternalMelt_nSegnCoilp.'hTFtoPCM[4]'.port_b.Q_flow = RealVariables8[53];
  iceStorageExternalMelt_nSegnCoilp.'hTFtoPCM[4]'.port_a.T = RealVariables8[54];
  iceStorageExternalMelt_nSegnCoilp.'hTFtoPCM[4]'.port_a.Q_flow = RealVariables8[55];
  iceStorageExternalMelt_nSegnCoilp.'hTFtoPCM[4]'.G_HTFtoTube = RealVariables8[56];
  iceStorageExternalMelt_nSegnCoilp.'hTFtoPCM[4]'.G_TubetoPCM = RealVariables8[57];
  iceStorageExternalMelt_nSegnCoilp.'hTFtoPCM[5]'.HTFtoTube.Q_flow = RealVariables8[58];
  iceStorageExternalMelt_nSegnCoilp.'hTFtoPCM[5]'.HTFtoTube.dT = RealVariables8[59];
  iceStorageExternalMelt_nSegnCoilp.'hTFtoPCM[5]'.HTFtoTube.port_a.T = RealVariables8[60];
  iceStorageExternalMelt_nSegnCoilp.'hTFtoPCM[5]'.HTFtoTube.port_a.Q_flow = RealVariables8[61];
  iceStorageExternalMelt_nSegnCoilp.'hTFtoPCM[5]'.HTFtoTube.port_b.T = RealVariables8[62];
  iceStorageExternalMelt_nSegnCoilp.'hTFtoPCM[5]'.HTFtoTube.port_b.Q_flow = RealVariables8[63];
  iceStorageExternalMelt_nSegnCoilp.'hTFtoPCM[5]'.HTFtoTube.G = RealVariables8[64];
  iceStorageExternalMelt_nSegnCoilp.'hTFtoPCM[5]'.TubetoPCM.Q_flow = RealVariables8[65];
  iceStorageExternalMelt_nSegnCoilp.'hTFtoPCM[5]'.TubetoPCM.dT = RealVariables8[66];
  iceStorageExternalMelt_nSegnCoilp.'hTFtoPCM[5]'.TubetoPCM.port_a.T = RealVariables8[67];
  iceStorageExternalMelt_nSegnCoilp.'hTFtoPCM[5]'.TubetoPCM.port_a.Q_flow = RealVariables8[68];
  iceStorageExternalMelt_nSegnCoilp.'hTFtoPCM[5]'.TubetoPCM.port_b.T = RealVariables8[69];
  iceStorageExternalMelt_nSegnCoilp.'hTFtoPCM[5]'.TubetoPCM.port_b.Q_flow = RealVariables8[70];
  iceStorageExternalMelt_nSegnCoilp.'hTFtoPCM[5]'.TubetoPCM.G = RealVariables8[71];
  iceStorageExternalMelt_nSegnCoilp.'hTFtoPCM[5]'.TubeInertia.T = RealVariables8[72];
  iceStorageExternalMelt_nSegnCoilp.'hTFtoPCM[5]'.TubeInertia.T_der = RealVariables8[73];
  iceStorageExternalMelt_nSegnCoilp.'hTFtoPCM[5]'.TubeInertia.Q_flow = RealVariables8[74];
  iceStorageExternalMelt_nSegnCoilp.'hTFtoPCM[5]'.TubeInertia.port.T = RealVariables8[75];
  iceStorageExternalMelt_nSegnCoilp.'hTFtoPCM[5]'.TubeInertia.port.Q_flow = RealVariables8[76];
  iceStorageExternalMelt_nSegnCoilp.'hTFtoPCM[5]'.TubeInertia.der_T = RealVariables8[77];
  iceStorageExternalMelt_nSegnCoilp.'hTFtoPCM[5]'.TubeInertia.C = RealVariables8[78];
  iceStorageExternalMelt_nSegnCoilp.'hTFtoPCM[5]'.port_b.T = RealVariables8[79];
  iceStorageExternalMelt_nSegnCoilp.'hTFtoPCM[5]'.port_b.Q_flow = RealVariables8[80];
  iceStorageExternalMelt_nSegnCoilp.'hTFtoPCM[5]'.port_a.T = RealVariables8[81];
  iceStorageExternalMelt_nSegnCoilp.'hTFtoPCM[5]'.port_a.Q_flow = RealVariables8[82];
  iceStorageExternalMelt_nSegnCoilp.'hTFtoPCM[5]'.G_HTFtoTube = RealVariables8[83];
  iceStorageExternalMelt_nSegnCoilp.'hTFtoPCM[5]'.G_TubetoPCM = RealVariables8[84];
  iceStorageExternalMelt_nSegnCoilp.'hTFtoPCM[6]'.HTFtoTube.Q_flow = RealVariables8[85];
  iceStorageExternalMelt_nSegnCoilp.'hTFtoPCM[6]'.HTFtoTube.dT = RealVariables8[86];
  iceStorageExternalMelt_nSegnCoilp.'hTFtoPCM[6]'.HTFtoTube.port_a.T = RealVariables8[87];
  iceStorageExternalMelt_nSegnCoilp.'hTFtoPCM[6]'.HTFtoTube.port_a.Q_flow = RealVariables8[88];
  iceStorageExternalMelt_nSegnCoilp.'hTFtoPCM[6]'.HTFtoTube.port_b.T = RealVariables8[89];
  iceStorageExternalMelt_nSegnCoilp.'hTFtoPCM[6]'.HTFtoTube.port_b.Q_flow = RealVariables8[90];
  iceStorageExternalMelt_nSegnCoilp.'hTFtoPCM[6]'.HTFtoTube.G = RealVariables8[91];
  iceStorageExternalMelt_nSegnCoilp.'hTFtoPCM[6]'.TubetoPCM.Q_flow = RealVariables8[92];
  iceStorageExternalMelt_nSegnCoilp.'hTFtoPCM[6]'.TubetoPCM.dT = RealVariables8[93];
  iceStorageExternalMelt_nSegnCoilp.'hTFtoPCM[6]'.TubetoPCM.port_a.T = RealVariables8[94];
  iceStorageExternalMelt_nSegnCoilp.'hTFtoPCM[6]'.TubetoPCM.port_a.Q_flow = RealVariables8[95];
  iceStorageExternalMelt_nSegnCoilp.'hTFtoPCM[6]'.TubetoPCM.port_b.T = RealVariables8[96];
  iceStorageExternalMelt_nSegnCoilp.'hTFtoPCM[6]'.TubetoPCM.port_b.Q_flow = RealVariables8[97];
  iceStorageExternalMelt_nSegnCoilp.'hTFtoPCM[6]'.TubetoPCM.G = RealVariables8[98];
  iceStorageExternalMelt_nSegnCoilp.'hTFtoPCM[6]'.TubeInertia.T = RealVariables8[99];
  iceStorageExternalMelt_nSegnCoilp.'hTFtoPCM[6]'.TubeInertia.T_der = RealVariables8[100];
  iceStorageExternalMelt_nSegnCoilp.'hTFtoPCM[6]'.TubeInertia.Q_flow = RealVariables9[1];
  iceStorageExternalMelt_nSegnCoilp.'hTFtoPCM[6]'.TubeInertia.port.T = RealVariables9[2];
  iceStorageExternalMelt_nSegnCoilp.'hTFtoPCM[6]'.TubeInertia.port.Q_flow = RealVariables9[3];
  iceStorageExternalMelt_nSegnCoilp.'hTFtoPCM[6]'.TubeInertia.der_T = RealVariables9[4];
  iceStorageExternalMelt_nSegnCoilp.'hTFtoPCM[6]'.TubeInertia.C = RealVariables9[5];
  iceStorageExternalMelt_nSegnCoilp.'hTFtoPCM[6]'.port_b.T = RealVariables9[6];
  iceStorageExternalMelt_nSegnCoilp.'hTFtoPCM[6]'.port_b.Q_flow = RealVariables9[7];
  iceStorageExternalMelt_nSegnCoilp.'hTFtoPCM[6]'.port_a.T = RealVariables9[8];
  iceStorageExternalMelt_nSegnCoilp.'hTFtoPCM[6]'.port_a.Q_flow = RealVariables9[9];
  iceStorageExternalMelt_nSegnCoilp.'hTFtoPCM[6]'.G_HTFtoTube = RealVariables9[10];
  iceStorageExternalMelt_nSegnCoilp.'hTFtoPCM[6]'.G_TubetoPCM = RealVariables9[11];
  iceStorageExternalMelt_nSegnCoilp.'hTFtoPCM[7]'.HTFtoTube.Q_flow = RealVariables9[12];
  iceStorageExternalMelt_nSegnCoilp.'hTFtoPCM[7]'.HTFtoTube.dT = RealVariables9[13];
  iceStorageExternalMelt_nSegnCoilp.'hTFtoPCM[7]'.HTFtoTube.port_a.T = RealVariables9[14];
  iceStorageExternalMelt_nSegnCoilp.'hTFtoPCM[7]'.HTFtoTube.port_a.Q_flow = RealVariables9[15];
  iceStorageExternalMelt_nSegnCoilp.'hTFtoPCM[7]'.HTFtoTube.port_b.T = RealVariables9[16];
  iceStorageExternalMelt_nSegnCoilp.'hTFtoPCM[7]'.HTFtoTube.port_b.Q_flow = RealVariables9[17];
  iceStorageExternalMelt_nSegnCoilp.'hTFtoPCM[7]'.HTFtoTube.G = RealVariables9[18];
  iceStorageExternalMelt_nSegnCoilp.'hTFtoPCM[7]'.TubetoPCM.Q_flow = RealVariables9[19];
  iceStorageExternalMelt_nSegnCoilp.'hTFtoPCM[7]'.TubetoPCM.dT = RealVariables9[20];
  iceStorageExternalMelt_nSegnCoilp.'hTFtoPCM[7]'.TubetoPCM.port_a.T = RealVariables9[21];
  iceStorageExternalMelt_nSegnCoilp.'hTFtoPCM[7]'.TubetoPCM.port_a.Q_flow = RealVariables9[22];
  iceStorageExternalMelt_nSegnCoilp.'hTFtoPCM[7]'.TubetoPCM.port_b.T = RealVariables9[23];
  iceStorageExternalMelt_nSegnCoilp.'hTFtoPCM[7]'.TubetoPCM.port_b.Q_flow = RealVariables9[24];
  iceStorageExternalMelt_nSegnCoilp.'hTFtoPCM[7]'.TubetoPCM.G = RealVariables9[25];
  iceStorageExternalMelt_nSegnCoilp.'hTFtoPCM[7]'.TubeInertia.T = RealVariables9[26];
  iceStorageExternalMelt_nSegnCoilp.'hTFtoPCM[7]'.TubeInertia.T_der = RealVariables9[27];
  iceStorageExternalMelt_nSegnCoilp.'hTFtoPCM[7]'.TubeInertia.Q_flow = RealVariables9[28];
  iceStorageExternalMelt_nSegnCoilp.'hTFtoPCM[7]'.TubeInertia.port.T = RealVariables9[29];
  iceStorageExternalMelt_nSegnCoilp.'hTFtoPCM[7]'.TubeInertia.port.Q_flow = RealVariables9[30];
  iceStorageExternalMelt_nSegnCoilp.'hTFtoPCM[7]'.TubeInertia.der_T = RealVariables9[31];
  iceStorageExternalMelt_nSegnCoilp.'hTFtoPCM[7]'.TubeInertia.C = RealVariables9[32];
  iceStorageExternalMelt_nSegnCoilp.'hTFtoPCM[7]'.port_b.T = RealVariables9[33];
  iceStorageExternalMelt_nSegnCoilp.'hTFtoPCM[7]'.port_b.Q_flow = RealVariables9[34];
  iceStorageExternalMelt_nSegnCoilp.'hTFtoPCM[7]'.port_a.T = RealVariables9[35];
  iceStorageExternalMelt_nSegnCoilp.'hTFtoPCM[7]'.port_a.Q_flow = RealVariables9[36];
  iceStorageExternalMelt_nSegnCoilp.'hTFtoPCM[7]'.G_HTFtoTube = RealVariables9[37];
  iceStorageExternalMelt_nSegnCoilp.'hTFtoPCM[7]'.G_TubetoPCM = RealVariables9[38];
  iceStorageExternalMelt_nSegnCoilp.'hTFtoPCM[8]'.HTFtoTube.Q_flow = RealVariables9[39];
  iceStorageExternalMelt_nSegnCoilp.'hTFtoPCM[8]'.HTFtoTube.dT = RealVariables9[40];
  iceStorageExternalMelt_nSegnCoilp.'hTFtoPCM[8]'.HTFtoTube.port_a.T = RealVariables9[41];
  iceStorageExternalMelt_nSegnCoilp.'hTFtoPCM[8]'.HTFtoTube.port_a.Q_flow = RealVariables9[42];
  iceStorageExternalMelt_nSegnCoilp.'hTFtoPCM[8]'.HTFtoTube.port_b.T = RealVariables9[43];
  iceStorageExternalMelt_nSegnCoilp.'hTFtoPCM[8]'.HTFtoTube.port_b.Q_flow = RealVariables9[44];
  iceStorageExternalMelt_nSegnCoilp.'hTFtoPCM[8]'.HTFtoTube.G = RealVariables9[45];
  iceStorageExternalMelt_nSegnCoilp.'hTFtoPCM[8]'.TubetoPCM.Q_flow = RealVariables9[46];
  iceStorageExternalMelt_nSegnCoilp.'hTFtoPCM[8]'.TubetoPCM.dT = RealVariables9[47];
  iceStorageExternalMelt_nSegnCoilp.'hTFtoPCM[8]'.TubetoPCM.port_a.T = RealVariables9[48];
  iceStorageExternalMelt_nSegnCoilp.'hTFtoPCM[8]'.TubetoPCM.port_a.Q_flow = RealVariables9[49];
  iceStorageExternalMelt_nSegnCoilp.'hTFtoPCM[8]'.TubetoPCM.port_b.T = RealVariables9[50];
  iceStorageExternalMelt_nSegnCoilp.'hTFtoPCM[8]'.TubetoPCM.port_b.Q_flow = RealVariables9[51];
  iceStorageExternalMelt_nSegnCoilp.'hTFtoPCM[8]'.TubetoPCM.G = RealVariables9[52];
  iceStorageExternalMelt_nSegnCoilp.'hTFtoPCM[8]'.TubeInertia.T = RealVariables9[53];
  iceStorageExternalMelt_nSegnCoilp.'hTFtoPCM[8]'.TubeInertia.T_der = RealVariables9[54];
  iceStorageExternalMelt_nSegnCoilp.'hTFtoPCM[8]'.TubeInertia.Q_flow = RealVariables9[55];
  iceStorageExternalMelt_nSegnCoilp.'hTFtoPCM[8]'.TubeInertia.port.T = RealVariables9[56];
  iceStorageExternalMelt_nSegnCoilp.'hTFtoPCM[8]'.TubeInertia.port.Q_flow = RealVariables9[57];
  iceStorageExternalMelt_nSegnCoilp.'hTFtoPCM[8]'.TubeInertia.der_T = RealVariables9[58];
  iceStorageExternalMelt_nSegnCoilp.'hTFtoPCM[8]'.TubeInertia.C = RealVariables9[59];
  iceStorageExternalMelt_nSegnCoilp.'hTFtoPCM[8]'.port_b.T = RealVariables9[60];
  iceStorageExternalMelt_nSegnCoilp.'hTFtoPCM[8]'.port_b.Q_flow = RealVariables9[61];
  iceStorageExternalMelt_nSegnCoilp.'hTFtoPCM[8]'.port_a.T = RealVariables9[62];
  iceStorageExternalMelt_nSegnCoilp.'hTFtoPCM[8]'.port_a.Q_flow = RealVariables9[63];
  iceStorageExternalMelt_nSegnCoilp.'hTFtoPCM[8]'.G_HTFtoTube = RealVariables9[64];
  iceStorageExternalMelt_nSegnCoilp.'hTFtoPCM[8]'.G_TubetoPCM = RealVariables9[65];
  iceStorageExternalMelt_nSegnCoilp.'hTFtoPCM[9]'.HTFtoTube.Q_flow = RealVariables9[66];
  iceStorageExternalMelt_nSegnCoilp.'hTFtoPCM[9]'.HTFtoTube.dT = RealVariables9[67];
  iceStorageExternalMelt_nSegnCoilp.'hTFtoPCM[9]'.HTFtoTube.port_a.T = RealVariables9[68];
  iceStorageExternalMelt_nSegnCoilp.'hTFtoPCM[9]'.HTFtoTube.port_a.Q_flow = RealVariables9[69];
  iceStorageExternalMelt_nSegnCoilp.'hTFtoPCM[9]'.HTFtoTube.port_b.T = RealVariables9[70];
  iceStorageExternalMelt_nSegnCoilp.'hTFtoPCM[9]'.HTFtoTube.port_b.Q_flow = RealVariables9[71];
  iceStorageExternalMelt_nSegnCoilp.'hTFtoPCM[9]'.HTFtoTube.G = RealVariables9[72];
  iceStorageExternalMelt_nSegnCoilp.'hTFtoPCM[9]'.TubetoPCM.Q_flow = RealVariables9[73];
  iceStorageExternalMelt_nSegnCoilp.'hTFtoPCM[9]'.TubetoPCM.dT = RealVariables9[74];
  iceStorageExternalMelt_nSegnCoilp.'hTFtoPCM[9]'.TubetoPCM.port_a.T = RealVariables9[75];
  iceStorageExternalMelt_nSegnCoilp.'hTFtoPCM[9]'.TubetoPCM.port_a.Q_flow = RealVariables9[76];
  iceStorageExternalMelt_nSegnCoilp.'hTFtoPCM[9]'.TubetoPCM.port_b.T = RealVariables9[77];
  iceStorageExternalMelt_nSegnCoilp.'hTFtoPCM[9]'.TubetoPCM.port_b.Q_flow = RealVariables9[78];
  iceStorageExternalMelt_nSegnCoilp.'hTFtoPCM[9]'.TubetoPCM.G = RealVariables9[79];
  iceStorageExternalMelt_nSegnCoilp.'hTFtoPCM[9]'.TubeInertia.T = RealVariables9[80];
  iceStorageExternalMelt_nSegnCoilp.'hTFtoPCM[9]'.TubeInertia.T_der = RealVariables9[81];
  iceStorageExternalMelt_nSegnCoilp.'hTFtoPCM[9]'.TubeInertia.Q_flow = RealVariables9[82];
  iceStorageExternalMelt_nSegnCoilp.'hTFtoPCM[9]'.TubeInertia.port.T = RealVariables9[83];
  iceStorageExternalMelt_nSegnCoilp.'hTFtoPCM[9]'.TubeInertia.port.Q_flow = RealVariables9[84];
  iceStorageExternalMelt_nSegnCoilp.'hTFtoPCM[9]'.TubeInertia.der_T = RealVariables9[85];
  iceStorageExternalMelt_nSegnCoilp.'hTFtoPCM[9]'.TubeInertia.C = RealVariables9[86];
  iceStorageExternalMelt_nSegnCoilp.'hTFtoPCM[9]'.port_b.T = RealVariables9[87];
  iceStorageExternalMelt_nSegnCoilp.'hTFtoPCM[9]'.port_b.Q_flow = RealVariables9[88];
  iceStorageExternalMelt_nSegnCoilp.'hTFtoPCM[9]'.port_a.T = RealVariables9[89];
  iceStorageExternalMelt_nSegnCoilp.'hTFtoPCM[9]'.port_a.Q_flow = RealVariables9[90];
  iceStorageExternalMelt_nSegnCoilp.'hTFtoPCM[9]'.G_HTFtoTube = RealVariables9[91];
  iceStorageExternalMelt_nSegnCoilp.'hTFtoPCM[9]'.G_TubetoPCM = RealVariables9[92];
  iceStorageExternalMelt_nSegnCoilp.'hTFtoPCM[10]'.HTFtoTube.Q_flow = RealVariables9[93];
  iceStorageExternalMelt_nSegnCoilp.'hTFtoPCM[10]'.HTFtoTube.dT = RealVariables9[94];
  iceStorageExternalMelt_nSegnCoilp.'hTFtoPCM[10]'.HTFtoTube.port_a.T = RealVariables9[95];
  iceStorageExternalMelt_nSegnCoilp.'hTFtoPCM[10]'.HTFtoTube.port_a.Q_flow = RealVariables9[96];
  iceStorageExternalMelt_nSegnCoilp.'hTFtoPCM[10]'.HTFtoTube.port_b.T = RealVariables9[97];
  iceStorageExternalMelt_nSegnCoilp.'hTFtoPCM[10]'.HTFtoTube.port_b.Q_flow = RealVariables9[98];
  iceStorageExternalMelt_nSegnCoilp.'hTFtoPCM[10]'.HTFtoTube.G = RealVariables9[99];
  iceStorageExternalMelt_nSegnCoilp.'hTFtoPCM[10]'.TubetoPCM.Q_flow = RealVariables9[100];
  iceStorageExternalMelt_nSegnCoilp.'hTFtoPCM[10]'.TubetoPCM.dT = RealVariables10[1];
  iceStorageExternalMelt_nSegnCoilp.'hTFtoPCM[10]'.TubetoPCM.port_a.T = RealVariables10[2];
  iceStorageExternalMelt_nSegnCoilp.'hTFtoPCM[10]'.TubetoPCM.port_a.Q_flow = RealVariables10[3];
  iceStorageExternalMelt_nSegnCoilp.'hTFtoPCM[10]'.TubetoPCM.port_b.T = RealVariables10[4];
  iceStorageExternalMelt_nSegnCoilp.'hTFtoPCM[10]'.TubetoPCM.port_b.Q_flow = RealVariables10[5];
  iceStorageExternalMelt_nSegnCoilp.'hTFtoPCM[10]'.TubetoPCM.G = RealVariables10[6];
  iceStorageExternalMelt_nSegnCoilp.'hTFtoPCM[10]'.TubeInertia.T = RealVariables10[7];
  iceStorageExternalMelt_nSegnCoilp.'hTFtoPCM[10]'.TubeInertia.T_der = RealVariables10[8];
  iceStorageExternalMelt_nSegnCoilp.'hTFtoPCM[10]'.TubeInertia.Q_flow = RealVariables10[9];
  iceStorageExternalMelt_nSegnCoilp.'hTFtoPCM[10]'.TubeInertia.port.T = RealVariables10[10];
  iceStorageExternalMelt_nSegnCoilp.'hTFtoPCM[10]'.TubeInertia.port.Q_flow = RealVariables10[11];
  iceStorageExternalMelt_nSegnCoilp.'hTFtoPCM[10]'.TubeInertia.der_T = RealVariables10[12];
  iceStorageExternalMelt_nSegnCoilp.'hTFtoPCM[10]'.TubeInertia.C = RealVariables10[13];
  iceStorageExternalMelt_nSegnCoilp.'hTFtoPCM[10]'.port_b.T = RealVariables10[14];
  iceStorageExternalMelt_nSegnCoilp.'hTFtoPCM[10]'.port_b.Q_flow = RealVariables10[15];
  iceStorageExternalMelt_nSegnCoilp.'hTFtoPCM[10]'.port_a.T = RealVariables10[16];
  iceStorageExternalMelt_nSegnCoilp.'hTFtoPCM[10]'.port_a.Q_flow = RealVariables10[17];
  iceStorageExternalMelt_nSegnCoilp.'hTFtoPCM[10]'.G_HTFtoTube = RealVariables10[18];
  iceStorageExternalMelt_nSegnCoilp.'hTFtoPCM[10]'.G_TubetoPCM = RealVariables10[19];
  iceStorageExternalMelt_nSegnCoilp.'tubeToPCM[1]'.y = RealVariables10[20];
  iceStorageExternalMelt_nSegnCoilp.'tubeToPCM[2]'.y = RealVariables10[21];
  iceStorageExternalMelt_nSegnCoilp.'tubeToPCM[3]'.y = RealVariables10[22];
  iceStorageExternalMelt_nSegnCoilp.'tubeToPCM[4]'.y = RealVariables10[23];
  iceStorageExternalMelt_nSegnCoilp.'tubeToPCM[5]'.y = RealVariables10[24];
  iceStorageExternalMelt_nSegnCoilp.'tubeToPCM[6]'.y = RealVariables10[25];
  iceStorageExternalMelt_nSegnCoilp.'tubeToPCM[7]'.y = RealVariables10[26];
  iceStorageExternalMelt_nSegnCoilp.'tubeToPCM[8]'.y = RealVariables10[27];
  iceStorageExternalMelt_nSegnCoilp.'tubeToPCM[9]'.y = RealVariables10[28];
  iceStorageExternalMelt_nSegnCoilp.'tubeToPCM[10]'.y = RealVariables10[29];
  iceStorageExternalMelt_nSegnCoilp.'HTFtoTube[1]'.y = RealVariables10[30];
  iceStorageExternalMelt_nSegnCoilp.'HTFtoTube[2]'.y = RealVariables10[31];
  iceStorageExternalMelt_nSegnCoilp.'HTFtoTube[3]'.y = RealVariables10[32];
  iceStorageExternalMelt_nSegnCoilp.'HTFtoTube[4]'.y = RealVariables10[33];
  iceStorageExternalMelt_nSegnCoilp.'HTFtoTube[5]'.y = RealVariables10[34];
  iceStorageExternalMelt_nSegnCoilp.'HTFtoTube[6]'.y = RealVariables10[35];
  iceStorageExternalMelt_nSegnCoilp.'HTFtoTube[7]'.y = RealVariables10[36];
  iceStorageExternalMelt_nSegnCoilp.'HTFtoTube[8]'.y = RealVariables10[37];
  iceStorageExternalMelt_nSegnCoilp.'HTFtoTube[9]'.y = RealVariables10[38];
  iceStorageExternalMelt_nSegnCoilp.'HTFtoTube[10]'.y = RealVariables10[39];
  iceStorageExternalMelt_nSegnCoilp.'thermalConductor[1]'.Q_flow = RealVariables10[40];
  iceStorageExternalMelt_nSegnCoilp.'thermalConductor[1]'.dT = RealVariables10[41];
  iceStorageExternalMelt_nSegnCoilp.'thermalConductor[1]'.port_a.T = RealVariables10[42];
  iceStorageExternalMelt_nSegnCoilp.'thermalConductor[1]'.port_a.Q_flow = RealVariables10[43];
  iceStorageExternalMelt_nSegnCoilp.'thermalConductor[1]'.port_b.T = RealVariables10[44];
  iceStorageExternalMelt_nSegnCoilp.'thermalConductor[1]'.port_b.Q_flow = RealVariables10[45];
  iceStorageExternalMelt_nSegnCoilp.'thermalConductor[2]'.Q_flow = RealVariables10[46];
  iceStorageExternalMelt_nSegnCoilp.'thermalConductor[2]'.dT = RealVariables10[47];
  iceStorageExternalMelt_nSegnCoilp.'thermalConductor[2]'.port_a.T = RealVariables10[48];
  iceStorageExternalMelt_nSegnCoilp.'thermalConductor[2]'.port_a.Q_flow = RealVariables10[49];
  iceStorageExternalMelt_nSegnCoilp.'thermalConductor[2]'.port_b.T = RealVariables10[50];
  iceStorageExternalMelt_nSegnCoilp.'thermalConductor[2]'.port_b.Q_flow = RealVariables10[51];
  iceStorageExternalMelt_nSegnCoilp.'thermalConductor[3]'.Q_flow = RealVariables10[52];
  iceStorageExternalMelt_nSegnCoilp.'thermalConductor[3]'.dT = RealVariables10[53];
  iceStorageExternalMelt_nSegnCoilp.'thermalConductor[3]'.port_a.T = RealVariables10[54];
  iceStorageExternalMelt_nSegnCoilp.'thermalConductor[3]'.port_a.Q_flow = RealVariables10[55];
  iceStorageExternalMelt_nSegnCoilp.'thermalConductor[3]'.port_b.T = RealVariables10[56];
  iceStorageExternalMelt_nSegnCoilp.'thermalConductor[3]'.port_b.Q_flow = RealVariables10[57];
  iceStorageExternalMelt_nSegnCoilp.'thermalConductor[4]'.Q_flow = RealVariables10[58];
  iceStorageExternalMelt_nSegnCoilp.'thermalConductor[4]'.dT = RealVariables10[59];
  iceStorageExternalMelt_nSegnCoilp.'thermalConductor[4]'.port_a.T = RealVariables10[60];
  iceStorageExternalMelt_nSegnCoilp.'thermalConductor[4]'.port_a.Q_flow = RealVariables10[61];
  iceStorageExternalMelt_nSegnCoilp.'thermalConductor[4]'.port_b.T = RealVariables10[62];
  iceStorageExternalMelt_nSegnCoilp.'thermalConductor[4]'.port_b.Q_flow = RealVariables10[63];
  iceStorageExternalMelt_nSegnCoilp.'thermalConductor[5]'.Q_flow = RealVariables10[64];
  iceStorageExternalMelt_nSegnCoilp.'thermalConductor[5]'.dT = RealVariables10[65];
  iceStorageExternalMelt_nSegnCoilp.'thermalConductor[5]'.port_a.T = RealVariables10[66];
  iceStorageExternalMelt_nSegnCoilp.'thermalConductor[5]'.port_a.Q_flow = RealVariables10[67];
  iceStorageExternalMelt_nSegnCoilp.'thermalConductor[5]'.port_b.T = RealVariables10[68];
  iceStorageExternalMelt_nSegnCoilp.'thermalConductor[5]'.port_b.Q_flow = RealVariables10[69];
  iceStorageExternalMelt_nSegnCoilp.'thermalConductor[6]'.Q_flow = RealVariables10[70];
  iceStorageExternalMelt_nSegnCoilp.'thermalConductor[6]'.dT = RealVariables10[71];
  iceStorageExternalMelt_nSegnCoilp.'thermalConductor[6]'.port_a.T = RealVariables10[72];
  iceStorageExternalMelt_nSegnCoilp.'thermalConductor[6]'.port_a.Q_flow = RealVariables10[73];
  iceStorageExternalMelt_nSegnCoilp.'thermalConductor[6]'.port_b.T = RealVariables10[74];
  iceStorageExternalMelt_nSegnCoilp.'thermalConductor[6]'.port_b.Q_flow = RealVariables10[75];
  iceStorageExternalMelt_nSegnCoilp.'thermalConductor[7]'.Q_flow = RealVariables10[76];
  iceStorageExternalMelt_nSegnCoilp.'thermalConductor[7]'.dT = RealVariables10[77];
  iceStorageExternalMelt_nSegnCoilp.'thermalConductor[7]'.port_a.T = RealVariables10[78];
  iceStorageExternalMelt_nSegnCoilp.'thermalConductor[7]'.port_a.Q_flow = RealVariables10[79];
  iceStorageExternalMelt_nSegnCoilp.'thermalConductor[7]'.port_b.T = RealVariables10[80];
  iceStorageExternalMelt_nSegnCoilp.'thermalConductor[7]'.port_b.Q_flow = RealVariables10[81];
  iceStorageExternalMelt_nSegnCoilp.'thermalConductor[8]'.Q_flow = RealVariables10[82];
  iceStorageExternalMelt_nSegnCoilp.'thermalConductor[8]'.dT = RealVariables10[83];
  iceStorageExternalMelt_nSegnCoilp.'thermalConductor[8]'.port_a.T = RealVariables10[84];
  iceStorageExternalMelt_nSegnCoilp.'thermalConductor[8]'.port_a.Q_flow = RealVariables10[85];
  iceStorageExternalMelt_nSegnCoilp.'thermalConductor[8]'.port_b.T = RealVariables10[86];
  iceStorageExternalMelt_nSegnCoilp.'thermalConductor[8]'.port_b.Q_flow = RealVariables10[87];
  iceStorageExternalMelt_nSegnCoilp.'thermalConductor[9]'.Q_flow = RealVariables10[88];
  iceStorageExternalMelt_nSegnCoilp.'thermalConductor[9]'.dT = RealVariables10[89];
  iceStorageExternalMelt_nSegnCoilp.'thermalConductor[9]'.port_a.T = RealVariables10[90];
  iceStorageExternalMelt_nSegnCoilp.'thermalConductor[9]'.port_a.Q_flow = RealVariables10[91];
  iceStorageExternalMelt_nSegnCoilp.'thermalConductor[9]'.port_b.T = RealVariables10[92];
  iceStorageExternalMelt_nSegnCoilp.'thermalConductor[9]'.port_b.Q_flow = RealVariables10[93];
  iceStorageExternalMelt_nSegnCoilp.'thermalConductor[10]'.Q_flow = RealVariables10[94];
  iceStorageExternalMelt_nSegnCoilp.'thermalConductor[10]'.dT = RealVariables10[95];
  iceStorageExternalMelt_nSegnCoilp.'thermalConductor[10]'.port_a.T = RealVariables10[96];
  iceStorageExternalMelt_nSegnCoilp.'thermalConductor[10]'.port_a.Q_flow = RealVariables10[97];
  iceStorageExternalMelt_nSegnCoilp.'thermalConductor[10]'.port_b.T = RealVariables10[98];
  iceStorageExternalMelt_nSegnCoilp.'thermalConductor[10]'.port_b.Q_flow = RealVariables10[99];
  iceStorageExternalMelt_nSegnCoilp.PCM_T = RealVariables10[100];
  iceStorageExternalMelt_nSegnCoilp.'k_tube[1]' = RealVariables11[1];
  iceStorageExternalMelt_nSegnCoilp.'k_tube[2]' = RealVariables11[2];
  iceStorageExternalMelt_nSegnCoilp.'k_tube[3]' = RealVariables11[3];
  iceStorageExternalMelt_nSegnCoilp.'k_tube[4]' = RealVariables11[4];
  iceStorageExternalMelt_nSegnCoilp.'k_tube[5]' = RealVariables11[5];
  iceStorageExternalMelt_nSegnCoilp.'k_tube[6]' = RealVariables11[6];
  iceStorageExternalMelt_nSegnCoilp.'k_tube[7]' = RealVariables11[7];
  iceStorageExternalMelt_nSegnCoilp.'k_tube[8]' = RealVariables11[8];
  iceStorageExternalMelt_nSegnCoilp.'k_tube[9]' = RealVariables11[9];
  iceStorageExternalMelt_nSegnCoilp.'k_tube[10]' = RealVariables11[10];
  iceStorageExternalMelt_nSegnCoilp.x_liquid_Total = RealVariables11[11];
  iceStorageExternalMelt_nSegnCoilp.'U_in[1]' = RealVariables11[12];
  iceStorageExternalMelt_nSegnCoilp.'U_in[2]' = RealVariables11[13];
  iceStorageExternalMelt_nSegnCoilp.'U_in[3]' = RealVariables11[14];
  iceStorageExternalMelt_nSegnCoilp.'U_in[4]' = RealVariables11[15];
  iceStorageExternalMelt_nSegnCoilp.'U_in[5]' = RealVariables11[16];
  iceStorageExternalMelt_nSegnCoilp.'U_in[6]' = RealVariables11[17];
  iceStorageExternalMelt_nSegnCoilp.'U_in[7]' = RealVariables11[18];
  iceStorageExternalMelt_nSegnCoilp.'U_in[8]' = RealVariables11[19];
  iceStorageExternalMelt_nSegnCoilp.'U_in[9]' = RealVariables11[20];
  iceStorageExternalMelt_nSegnCoilp.'U_in[10]' = RealVariables11[21];
  iceStorageExternalMelt_nSegnCoilp.'U_out[1]' = RealVariables11[22];
  iceStorageExternalMelt_nSegnCoilp.'U_out[2]' = RealVariables11[23];
  iceStorageExternalMelt_nSegnCoilp.'U_out[3]' = RealVariables11[24];
  iceStorageExternalMelt_nSegnCoilp.'U_out[4]' = RealVariables11[25];
  iceStorageExternalMelt_nSegnCoilp.'U_out[5]' = RealVariables11[26];
  iceStorageExternalMelt_nSegnCoilp.'U_out[6]' = RealVariables11[27];
  iceStorageExternalMelt_nSegnCoilp.'U_out[7]' = RealVariables11[28];
  iceStorageExternalMelt_nSegnCoilp.'U_out[8]' = RealVariables11[29];
  iceStorageExternalMelt_nSegnCoilp.'U_out[9]' = RealVariables11[30];
  iceStorageExternalMelt_nSegnCoilp.'U_out[10]' = RealVariables11[31];
  iceStorageExternalMelt_nSegnCoilp.A_in = RealVariables11[32];
  iceStorageExternalMelt_nSegnCoilp.A_out = RealVariables11[33];
  iceStorageExternalMelt_nSegnCoilp.A_PCMs_out = RealVariables11[34];
  iceStorageExternalMelt_nSegnCoilp.A_PCMl_out = RealVariables11[35];
  iceStorageExternalMelt_nSegnCoilp.T_HTFo = RealVariables11[36];
  iceStorageExternalMelt_nSegnCoilp.T_HTFi = RealVariables11[37];
  iceStorageExternalMelt_nSegnCoilp.'f[1]' = RealVariables11[38];
  iceStorageExternalMelt_nSegnCoilp.'f[2]' = RealVariables11[39];
  iceStorageExternalMelt_nSegnCoilp.'f[3]' = RealVariables11[40];
  iceStorageExternalMelt_nSegnCoilp.'f[4]' = RealVariables11[41];
  iceStorageExternalMelt_nSegnCoilp.'f[5]' = RealVariables11[42];
  iceStorageExternalMelt_nSegnCoilp.'f[6]' = RealVariables11[43];
  iceStorageExternalMelt_nSegnCoilp.'f[7]' = RealVariables11[44];
  iceStorageExternalMelt_nSegnCoilp.'f[8]' = RealVariables11[45];
  iceStorageExternalMelt_nSegnCoilp.'f[9]' = RealVariables11[46];
  iceStorageExternalMelt_nSegnCoilp.'f[10]' = RealVariables11[47];
  iceStorageExternalMelt_nSegnCoilp.'AR[1]' = RealVariables11[48];
  iceStorageExternalMelt_nSegnCoilp.'AR[2]' = RealVariables11[49];
  iceStorageExternalMelt_nSegnCoilp.'AR[3]' = RealVariables11[50];
  iceStorageExternalMelt_nSegnCoilp.'AR[4]' = RealVariables11[51];
  iceStorageExternalMelt_nSegnCoilp.'AR[5]' = RealVariables11[52];
  iceStorageExternalMelt_nSegnCoilp.'AR[6]' = RealVariables11[53];
  iceStorageExternalMelt_nSegnCoilp.'AR[7]' = RealVariables11[54];
  iceStorageExternalMelt_nSegnCoilp.'AR[8]' = RealVariables11[55];
  iceStorageExternalMelt_nSegnCoilp.'AR[9]' = RealVariables11[56];
  iceStorageExternalMelt_nSegnCoilp.'AR[10]' = RealVariables11[57];
  inlet_HTF.medium.p = RealVariables11[58];
  inlet_HTF.medium.h = RealVariables11[59];
  inlet_HTF.medium.d = RealVariables11[60];
  inlet_HTF.medium.T = RealVariables11[61];
  inlet_HTF.medium.u = RealVariables11[62];
  inlet_HTF.medium.state.T = RealVariables11[63];
  inlet_HTF.medium.state.p = RealVariables11[64];
  inlet_HTF.medium.T_degC = RealVariables11[65];
  inlet_HTF.medium.p_bar = RealVariables11[66];
  inlet_HTF.medium.cp = RealVariables11[67];
  inlet_HTF.'ports[1]'.m_flow = RealVariables11[68];
  inlet_HTF.'ports[1]'.p = RealVariables11[69];
  inlet_HTF.'ports[1]'.h_outflow = RealVariables11[70];
  inlet_HTF.m_flow_in = RealVariables11[71];
  inlet_HTF.T_in = RealVariables11[72];
  inlet_water.medium.p = RealVariables11[73];
  inlet_water.medium.h = RealVariables11[74];
  inlet_water.medium.T = RealVariables11[75];
  inlet_water.medium.u = RealVariables11[76];
  inlet_water.medium.state.p = RealVariables11[77];
  inlet_water.medium.state.T = RealVariables11[78];
  inlet_water.medium.T_degC = RealVariables11[79];
  inlet_water.'ports[1]'.m_flow = RealVariables11[80];
  inlet_water.'ports[1]'.h_outflow = RealVariables11[81];
  inlet_water.m_flow_in = RealVariables11[82];
  inlet_water.T_in = RealVariables11[83];
  outlet_HTF.medium.p = RealVariables11[84];
  outlet_HTF.medium.h = RealVariables11[85];
  outlet_HTF.medium.T = RealVariables11[86];
  outlet_HTF.medium.state.T = RealVariables11[87];
  outlet_HTF.medium.state.p = RealVariables11[88];
  outlet_HTF.'ports[1]'.m_flow = RealVariables11[89];
  outlet_HTF.'ports[1]'.p = RealVariables11[90];
  fixedTemperature.port.T = RealVariables11[91];
  fixedTemperature.port.Q_flow = RealVariables11[92];
  fixedTemperature.T = RealVariables11[93];
  outlet_water_temperature.port.p = RealVariables11[94];
  outlet_water_temperature.T = RealVariables11[95];
  outlet_HTF_temperature.port.p = RealVariables11[96];
  outlet_HTF_temperature.T = RealVariables11[97];
  massFlowRate.port_a.m_flow = RealVariables11[98];
  massFlowRate.port_a.p = RealVariables11[99];
  massFlowRate.port_a.h_outflow = RealVariables11[100];
  massFlowRate.port_b.m_flow = RealVariables12[1];
  massFlowRate.port_b.p = RealVariables12[2];
  massFlowRate.port_b.h_outflow = RealVariables12[3];
  massFlowRate.m_flow = RealVariables12[4];
  'system'.p_start = RealDependentParameters1[1];
  'system'.T_start = RealDependentParameters1[2];
  'system'.m_flow_nominal = RealDependentParameters1[3];
  outlet_water.medium.u = RealDependentParameters1[4];
  outlet_water.medium.T_degC = RealDependentParameters1[5];
  outlet_water.medium.p_bar = RealDependentParameters1[6];
  outlet_water.'ports[1]'.h_outflow = RealDependentParameters1[7];
  iceStorageExternalMelt_nSegnCoilp.hfus = RealDependentParameters1[8];
  iceStorageExternalMelt_nSegnCoilp.Cp_PCMs = RealDependentParameters1[9];
  iceStorageExternalMelt_nSegnCoilp.Cp_PCMl = RealDependentParameters1[10];
  iceStorageExternalMelt_nSegnCoilp.rho_solid = RealDependentParameters1[11];
  iceStorageExternalMelt_nSegnCoilp.rho_liquid = RealDependentParameters1[12];
  iceStorageExternalMelt_nSegnCoilp.D_tube_in = RealDependentParameters1[13];
  iceStorageExternalMelt_nSegnCoilp.p_PCM = RealDependentParameters1[14];
  iceStorageExternalMelt_nSegnCoilp.D_tube_out = RealDependentParameters1[15];
  iceStorageExternalMelt_nSegnCoilp.a = RealDependentParameters1[16];
  iceStorageExternalMelt_nSegnCoilp.b = RealDependentParameters1[17];
  iceStorageExternalMelt_nSegnCoilp.h = RealDependentParameters1[18];
  iceStorageExternalMelt_nSegnCoilp.w = RealDependentParameters1[19];
  iceStorageExternalMelt_nSegnCoilp.e = RealDependentParameters1[20];
  iceStorageExternalMelt_nSegnCoilp.x_liquid_start = RealDependentParameters1[21];
  iceStorageExternalMelt_nSegnCoilp.externalMelt.hfus = RealDependentParameters1[22];
  iceStorageExternalMelt_nSegnCoilp.externalMelt.Cp_PCMs = RealDependentParameters1[23];
  iceStorageExternalMelt_nSegnCoilp.externalMelt.Cp_PCMl = RealDependentParameters1[24];
  iceStorageExternalMelt_nSegnCoilp.externalMelt.rho_solid = RealDependentParameters1[25];
  iceStorageExternalMelt_nSegnCoilp.externalMelt.rho_liquid = RealDependentParameters1[26];
  iceStorageExternalMelt_nSegnCoilp.externalMelt.p_PCM = RealDependentParameters1[27];
  iceStorageExternalMelt_nSegnCoilp.externalMelt.m_PCM = RealDependentParameters1[28];
  iceStorageExternalMelt_nSegnCoilp.externalMelt.D_tube_out = RealDependentParameters1[29];
  iceStorageExternalMelt_nSegnCoilp.externalMelt.x_liquid_start = RealDependentParameters1[30];
  iceStorageExternalMelt_nSegnCoilp.externalMelt.D_smax = RealDependentParameters1[31];
  iceStorageExternalMelt_nSegnCoilp.externalMelt.D_lmax = RealDependentParameters1[32];
  iceStorageExternalMelt_nSegnCoilp.pipe.nParallel = RealDependentParameters1[33];
  iceStorageExternalMelt_nSegnCoilp.pipe.diameter = RealDependentParameters1[34];
  iceStorageExternalMelt_nSegnCoilp.pipe.crossArea = RealDependentParameters1[35];
  iceStorageExternalMelt_nSegnCoilp.pipe.perimeter = RealDependentParameters1[36];
  iceStorageExternalMelt_nSegnCoilp.pipe.V = RealDependentParameters1[37];
  iceStorageExternalMelt_nSegnCoilp.pipe.'fluidVolumes[1]' = RealDependentParameters1[38];
  iceStorageExternalMelt_nSegnCoilp.pipe.'fluidVolumes[2]' = RealDependentParameters1[39];
  iceStorageExternalMelt_nSegnCoilp.pipe.'fluidVolumes[3]' = RealDependentParameters1[40];
  iceStorageExternalMelt_nSegnCoilp.pipe.'fluidVolumes[4]' = RealDependentParameters1[41];
  iceStorageExternalMelt_nSegnCoilp.pipe.'fluidVolumes[5]' = RealDependentParameters1[42];
  iceStorageExternalMelt_nSegnCoilp.pipe.'fluidVolumes[6]' = RealDependentParameters1[43];
  iceStorageExternalMelt_nSegnCoilp.pipe.'fluidVolumes[7]' = RealDependentParameters1[44];
  iceStorageExternalMelt_nSegnCoilp.pipe.'fluidVolumes[8]' = RealDependentParameters1[45];
  iceStorageExternalMelt_nSegnCoilp.pipe.'fluidVolumes[9]' = RealDependentParameters1[46];
  iceStorageExternalMelt_nSegnCoilp.pipe.'fluidVolumes[10]' = RealDependentParameters1[47];
  iceStorageExternalMelt_nSegnCoilp.pipe.p_a_start = RealDependentParameters1[48];
  iceStorageExternalMelt_nSegnCoilp.pipe.p_b_start = RealDependentParameters1[49];
  iceStorageExternalMelt_nSegnCoilp.pipe.'ps_start[1]' = RealDependentParameters1[50];
  iceStorageExternalMelt_nSegnCoilp.pipe.'ps_start[2]' = RealDependentParameters1[51];
  iceStorageExternalMelt_nSegnCoilp.pipe.'ps_start[3]' = RealDependentParameters1[52];
  iceStorageExternalMelt_nSegnCoilp.pipe.'ps_start[4]' = RealDependentParameters1[53];
  iceStorageExternalMelt_nSegnCoilp.pipe.'ps_start[5]' = RealDependentParameters1[54];
  iceStorageExternalMelt_nSegnCoilp.pipe.'ps_start[6]' = RealDependentParameters1[55];
  iceStorageExternalMelt_nSegnCoilp.pipe.'ps_start[7]' = RealDependentParameters1[56];
  iceStorageExternalMelt_nSegnCoilp.pipe.'ps_start[8]' = RealDependentParameters1[57];
  iceStorageExternalMelt_nSegnCoilp.pipe.'ps_start[9]' = RealDependentParameters1[58];
  iceStorageExternalMelt_nSegnCoilp.pipe.'ps_start[10]' = RealDependentParameters1[59];
  iceStorageExternalMelt_nSegnCoilp.pipe.h_start = RealDependentParameters1[60];
  iceStorageExternalMelt_nSegnCoilp.pipe.'crossAreas[1]' = RealDependentParameters1[61];
  iceStorageExternalMelt_nSegnCoilp.pipe.'crossAreas[2]' = RealDependentParameters1[62];
  iceStorageExternalMelt_nSegnCoilp.pipe.'crossAreas[3]' = RealDependentParameters1[63];
  iceStorageExternalMelt_nSegnCoilp.pipe.'crossAreas[4]' = RealDependentParameters1[64];
  iceStorageExternalMelt_nSegnCoilp.pipe.'crossAreas[5]' = RealDependentParameters1[65];
  iceStorageExternalMelt_nSegnCoilp.pipe.'crossAreas[6]' = RealDependentParameters1[66];
  iceStorageExternalMelt_nSegnCoilp.pipe.'crossAreas[7]' = RealDependentParameters1[67];
  iceStorageExternalMelt_nSegnCoilp.pipe.'crossAreas[8]' = RealDependentParameters1[68];
  iceStorageExternalMelt_nSegnCoilp.pipe.'crossAreas[9]' = RealDependentParameters1[69];
  iceStorageExternalMelt_nSegnCoilp.pipe.'crossAreas[10]' = RealDependentParameters1[70];
  iceStorageExternalMelt_nSegnCoilp.pipe.'dimensions[1]' = RealDependentParameters1[71];
  iceStorageExternalMelt_nSegnCoilp.pipe.'dimensions[2]' = RealDependentParameters1[72];
  iceStorageExternalMelt_nSegnCoilp.pipe.'dimensions[3]' = RealDependentParameters1[73];
  iceStorageExternalMelt_nSegnCoilp.pipe.'dimensions[4]' = RealDependentParameters1[74];
  iceStorageExternalMelt_nSegnCoilp.pipe.'dimensions[5]' = RealDependentParameters1[75];
  iceStorageExternalMelt_nSegnCoilp.pipe.'dimensions[6]' = RealDependentParameters1[76];
  iceStorageExternalMelt_nSegnCoilp.pipe.'dimensions[7]' = RealDependentParameters1[77];
  iceStorageExternalMelt_nSegnCoilp.pipe.'dimensions[8]' = RealDependentParameters1[78];
  iceStorageExternalMelt_nSegnCoilp.pipe.'dimensions[9]' = RealDependentParameters1[79];
  iceStorageExternalMelt_nSegnCoilp.pipe.'dimensions[10]' = RealDependentParameters1[80];
  iceStorageExternalMelt_nSegnCoilp.pipe.'roughnesses[1]' = RealDependentParameters1[81];
  iceStorageExternalMelt_nSegnCoilp.pipe.'roughnesses[2]' = RealDependentParameters1[82];
  iceStorageExternalMelt_nSegnCoilp.pipe.'roughnesses[3]' = RealDependentParameters1[83];
  iceStorageExternalMelt_nSegnCoilp.pipe.'roughnesses[4]' = RealDependentParameters1[84];
  iceStorageExternalMelt_nSegnCoilp.pipe.'roughnesses[5]' = RealDependentParameters1[85];
  iceStorageExternalMelt_nSegnCoilp.pipe.'roughnesses[6]' = RealDependentParameters1[86];
  iceStorageExternalMelt_nSegnCoilp.pipe.'roughnesses[7]' = RealDependentParameters1[87];
  iceStorageExternalMelt_nSegnCoilp.pipe.'roughnesses[8]' = RealDependentParameters1[88];
  iceStorageExternalMelt_nSegnCoilp.pipe.'roughnesses[9]' = RealDependentParameters1[89];
  iceStorageExternalMelt_nSegnCoilp.pipe.'roughnesses[10]' = RealDependentParameters1[90];
  iceStorageExternalMelt_nSegnCoilp.pipe.state_b.T = RealDependentParameters1[91];
  iceStorageExternalMelt_nSegnCoilp.pipe.flowModel.nParallel = RealDependentParameters1[92];
  iceStorageExternalMelt_nSegnCoilp.pipe.flowModel.g = RealDependentParameters1[93];
  iceStorageExternalMelt_nSegnCoilp.pipe.flowModel.p_a_start = RealDependentParameters1[94];
  iceStorageExternalMelt_nSegnCoilp.pipe.flowModel.p_b_start = RealDependentParameters1[95];
  iceStorageExternalMelt_nSegnCoilp.pipe.flowModel.dp_nominal = RealDependentParameters1[96];
  iceStorageExternalMelt_nSegnCoilp.pipe.flowModel.m_flow_nominal = RealDependentParameters1[97];
  iceStorageExternalMelt_nSegnCoilp.pipe.flowModel.m_flow_small = RealDependentParameters1[98];
  iceStorageExternalMelt_nSegnCoilp.pipe.heatTransfer.'surfaceAreas[1]' = RealDependentParameters1[99];
  iceStorageExternalMelt_nSegnCoilp.pipe.heatTransfer.'surfaceAreas[2]' = RealDependentParameters1[100];
  iceStorageExternalMelt_nSegnCoilp.pipe.heatTransfer.'surfaceAreas[3]' = RealDependentParameters2[1];
  iceStorageExternalMelt_nSegnCoilp.pipe.heatTransfer.'surfaceAreas[4]' = RealDependentParameters2[2];
  iceStorageExternalMelt_nSegnCoilp.pipe.heatTransfer.'surfaceAreas[5]' = RealDependentParameters2[3];
  iceStorageExternalMelt_nSegnCoilp.pipe.heatTransfer.'surfaceAreas[6]' = RealDependentParameters2[4];
  iceStorageExternalMelt_nSegnCoilp.pipe.heatTransfer.'surfaceAreas[7]' = RealDependentParameters2[5];
  iceStorageExternalMelt_nSegnCoilp.pipe.heatTransfer.'surfaceAreas[8]' = RealDependentParameters2[6];
  iceStorageExternalMelt_nSegnCoilp.pipe.heatTransfer.'surfaceAreas[9]' = RealDependentParameters2[7];
  iceStorageExternalMelt_nSegnCoilp.pipe.heatTransfer.'surfaceAreas[10]' = RealDependentParameters2[8];
  iceStorageExternalMelt_nSegnCoilp.pipe.heatTransfer.T_ambient = RealDependentParameters2[9];
  iceStorageExternalMelt_nSegnCoilp.pipe.heatTransfer.nParallel = RealDependentParameters2[10];
  iceStorageExternalMelt_nSegnCoilp.pipe.'mediums[10]'.p_bar = RealDependentParameters2[11];
  iceStorageExternalMelt_nSegnCoilp.'hTFtoPCM[1]'.vol = RealDependentParameters2[12];
  iceStorageExternalMelt_nSegnCoilp.'hTFtoPCM[1]'.TubeInertia.V = RealDependentParameters2[13];
  iceStorageExternalMelt_nSegnCoilp.'hTFtoPCM[1]'.TubeInertia.m = RealDependentParameters2[14];
  iceStorageExternalMelt_nSegnCoilp.'hTFtoPCM[2]'.vol = RealDependentParameters2[15];
  iceStorageExternalMelt_nSegnCoilp.'hTFtoPCM[2]'.TubeInertia.V = RealDependentParameters2[16];
  iceStorageExternalMelt_nSegnCoilp.'hTFtoPCM[2]'.TubeInertia.m = RealDependentParameters2[17];
  iceStorageExternalMelt_nSegnCoilp.'hTFtoPCM[3]'.vol = RealDependentParameters2[18];
  iceStorageExternalMelt_nSegnCoilp.'hTFtoPCM[3]'.TubeInertia.V = RealDependentParameters2[19];
  iceStorageExternalMelt_nSegnCoilp.'hTFtoPCM[3]'.TubeInertia.m = RealDependentParameters2[20];
  iceStorageExternalMelt_nSegnCoilp.'hTFtoPCM[4]'.vol = RealDependentParameters2[21];
  iceStorageExternalMelt_nSegnCoilp.'hTFtoPCM[4]'.TubeInertia.V = RealDependentParameters2[22];
  iceStorageExternalMelt_nSegnCoilp.'hTFtoPCM[4]'.TubeInertia.m = RealDependentParameters2[23];
  iceStorageExternalMelt_nSegnCoilp.'hTFtoPCM[5]'.vol = RealDependentParameters2[24];
  iceStorageExternalMelt_nSegnCoilp.'hTFtoPCM[5]'.TubeInertia.V = RealDependentParameters2[25];
  iceStorageExternalMelt_nSegnCoilp.'hTFtoPCM[5]'.TubeInertia.m = RealDependentParameters2[26];
  iceStorageExternalMelt_nSegnCoilp.'hTFtoPCM[6]'.vol = RealDependentParameters2[27];
  iceStorageExternalMelt_nSegnCoilp.'hTFtoPCM[6]'.TubeInertia.V = RealDependentParameters2[28];
  iceStorageExternalMelt_nSegnCoilp.'hTFtoPCM[6]'.TubeInertia.m = RealDependentParameters2[29];
  iceStorageExternalMelt_nSegnCoilp.'hTFtoPCM[7]'.vol = RealDependentParameters2[30];
  iceStorageExternalMelt_nSegnCoilp.'hTFtoPCM[7]'.TubeInertia.V = RealDependentParameters2[31];
  iceStorageExternalMelt_nSegnCoilp.'hTFtoPCM[7]'.TubeInertia.m = RealDependentParameters2[32];
  iceStorageExternalMelt_nSegnCoilp.'hTFtoPCM[8]'.vol = RealDependentParameters2[33];
  iceStorageExternalMelt_nSegnCoilp.'hTFtoPCM[8]'.TubeInertia.V = RealDependentParameters2[34];
  iceStorageExternalMelt_nSegnCoilp.'hTFtoPCM[8]'.TubeInertia.m = RealDependentParameters2[35];
  iceStorageExternalMelt_nSegnCoilp.'hTFtoPCM[9]'.vol = RealDependentParameters2[36];
  iceStorageExternalMelt_nSegnCoilp.'hTFtoPCM[9]'.TubeInertia.V = RealDependentParameters2[37];
  iceStorageExternalMelt_nSegnCoilp.'hTFtoPCM[9]'.TubeInertia.m = RealDependentParameters2[38];
  iceStorageExternalMelt_nSegnCoilp.'hTFtoPCM[10]'.vol = RealDependentParameters2[39];
  iceStorageExternalMelt_nSegnCoilp.'hTFtoPCM[10]'.TubeInertia.V = RealDependentParameters2[40];
  iceStorageExternalMelt_nSegnCoilp.'hTFtoPCM[10]'.TubeInertia.m = RealDependentParameters2[41];
  iceStorageExternalMelt_nSegnCoilp.k_PCMs = RealDependentParameters2[42];
  iceStorageExternalMelt_nSegnCoilp.h_PCMl = RealDependentParameters2[43];
  iceStorageExternalMelt_nSegnCoilp.k_PCMl = RealDependentParameters2[44];
  iceStorageExternalMelt_nSegnCoilp.h_HTF = RealDependentParameters2[45];
  inlet_water.medium.p_bar = RealDependentParameters2[46];
  inlet_water.'ports[1]'.p = RealDependentParameters2[47];
  outlet_HTF.medium.d = RealDependentParameters2[48];
  outlet_HTF.medium.u = RealDependentParameters2[49];
  outlet_HTF.medium.T_degC = RealDependentParameters2[50];
  outlet_HTF.medium.p_bar = RealDependentParameters2[51];
  outlet_HTF.medium.cp = RealDependentParameters2[52];
  outlet_HTF.'ports[1]'.h_outflow = RealDependentParameters2[53];
  outlet_HTF.d = RealDependentParameters2[54];
  outlet_HTF.h = RealDependentParameters2[55];
  outlet_HTF_temperature.port.h_outflow = RealDependentParameters2[56];
  massFlowRate.m_flow_nominal = RealDependentParameters2[57];
  massFlowRate.m_flow_small = RealDependentParameters2[58];
  iceStorageExternalMelt_nSegnCoilp.nCoilp = IntegerDependentParameters[1];
  iceStorageExternalMelt_nSegnCoilp.externalMelt.nCoilp = IntegerDependentParameters[2];
  iceStorageExternalMelt_nSegnCoilp.'hTFtoPCM[1]'.nCoilp = IntegerDependentParameters[3];
  iceStorageExternalMelt_nSegnCoilp.'hTFtoPCM[2]'.nCoilp = IntegerDependentParameters[4];
  iceStorageExternalMelt_nSegnCoilp.'hTFtoPCM[3]'.nCoilp = IntegerDependentParameters[5];
  iceStorageExternalMelt_nSegnCoilp.'hTFtoPCM[4]'.nCoilp = IntegerDependentParameters[6];
  iceStorageExternalMelt_nSegnCoilp.'hTFtoPCM[5]'.nCoilp = IntegerDependentParameters[7];
  iceStorageExternalMelt_nSegnCoilp.'hTFtoPCM[6]'.nCoilp = IntegerDependentParameters[8];
  iceStorageExternalMelt_nSegnCoilp.'hTFtoPCM[7]'.nCoilp = IntegerDependentParameters[9];
  iceStorageExternalMelt_nSegnCoilp.'hTFtoPCM[8]'.nCoilp = IntegerDependentParameters[10];
  iceStorageExternalMelt_nSegnCoilp.'hTFtoPCM[9]'.nCoilp = IntegerDependentParameters[11];
  iceStorageExternalMelt_nSegnCoilp.'hTFtoPCM[10]'.nCoilp = IntegerDependentParameters[12];
  iceStorageExternalMelt_nSegnCoilp.Charging = BooleanVariables[1];
  iceStorageExternalMelt_nSegnCoilp.Charged = BooleanVariables[2];
  iceStorageExternalMelt_nSegnCoilp.externalMelt.Charging = BooleanVariables[3];
  iceStorageExternalMelt_nSegnCoilp.Charging_start = BooleanDependentParameters[1];
  iceStorageExternalMelt_nSegnCoilp.Charged_start = BooleanDependentParameters[2];
  annotation (__Dymola_FMUImportVersion="Dymola 2018", experiment(StartTime=0.0, StopTime=100.0, Tolerance=0.0001),
    Icon(graphics={
      Rectangle(
        extent={{-100,100},{100,-100}},
        lineColor={95,95,95},
        fillColor={255,255,255},
        fillPattern=FillPattern.Solid,
        lineThickness=0.5),
      Text(
        extent={{-70,20},{70,-20}},
        lineColor={0,0,255},
        textString="%name"),
      Text(
        extent={{-70,-72},{70,-94}},
        lineColor={95,95,95},
        textString="FMI 1.0 CS Import")}),
Documentation(info="<html>
<h4>ModelDescription Attributes</h4>
<ul>
<li>fmiVersion = 1.0</li>
<li>modelName = Modelica_IK4_TEKNIKER.DCOL.ThermalStorage.LatentStorages.FMI.IceStorageExternalMelting_Dym</li>
<li>generationTool = Dymola Version 2018 (64-bit), 2017-04-10 (requires license to execute)</li>
<li>generationDateAndTime = 2017-09-27T13:29:20Z</li>
</ul>
<p><br><b>Co-Simulation Attributes</b></p>
<ul>
<li>canHandleVariableCommunicationStepSize = true</li>
<li>canHandleEvents = true</li>
<li>canRejectSteps = false</li>
<li>canInterpolateInputs = true</li>
<li>maxOutputDerivativeOrder = 1</li>
<li>canRunAsynchronuously = false</li>
<li>canSignalEvents = false</li>
<li>canBeInstantiatedOnlyOncePerProcess = false</li>
<li>canNotUseMemoryManagementFunctions = false</li>
</ul>
</html>"));
end IceStorageExtMelt_FMU_fmu;
