within DCOL.ThermalStorage.SensibleStorages.FMI;
model Buffer_FMI
// Model automatically generated by Dymola from FMI model description
public
  type Modelica_Blocks_Interfaces_BooleanInput = Boolean;
  type Modelica_Blocks_Interfaces_BooleanOutput = Boolean;
  type Modelica_Blocks_Interfaces_RealInput = Real;
  type Modelica_Blocks_Interfaces_RealOutput = Real;
  type Modelica_IK4_TEKNIKER_DCOL_Generation_SensibleStorages_FMI_RealConectors_RealHeatFlowOutput = Real (unit = "W", quantity = "Power");
  type Modelica_IK4_TEKNIKER_DCOL_Generation_SensibleStorages_FMI_RealConectors_RealMassFlowInput = Real (unit = "kg/s", quantity = "MassFlowRate");
  type Modelica_IK4_TEKNIKER_DCOL_Generation_SensibleStorages_FMI_RealConectors_RealTemperatureInput = Real (unit = "K", displayUnit = "degC", nominal = 300.0, quantity = "ThermodynamicTemperature", min = 0.0);
  type Modelica_IK4_TEKNIKER_DCOL_Generation_SensibleStorages_FMI_RealConectors_RealTemperatureOutput = Real (unit = "K", displayUnit = "degC", nominal = 300.0, quantity = "ThermodynamicTemperature", min = 0.0);
protected
  record 'system_rec'
    parameter Modelica.SIunits.AbsolutePressure p_ambient = 101325
                                                                  "Default ambient pressure";
    parameter Modelica.SIunits.Temperature T_ambient = 293.15
                                                             "Default ambient temperature";
    parameter Modelica.SIunits.Acceleration g = 9.80665
                                                       "Constant gravity acceleration";
    constant Boolean allowFlowReversal = true
                                             "= false to restrict to design flow direction (port_a -> port_b)";
    constant Modelica.Fluid.Types.Dynamics energyDynamics = Modelica.Fluid.Types.Dynamics.DynamicFreeInitial
                                                                                                            "Default formulation of energy balances";
    constant Modelica.Fluid.Types.Dynamics massDynamics = Modelica.Fluid.Types.Dynamics.DynamicFreeInitial
                                                                                                          "Default formulation of mass balances";
    constant Modelica.Fluid.Types.Dynamics substanceDynamics = Modelica.Fluid.Types.Dynamics.DynamicFreeInitial
                                                                                                               "Default formulation of substance balances";
    constant Modelica.Fluid.Types.Dynamics traceDynamics = Modelica.Fluid.Types.Dynamics.DynamicFreeInitial
                                                                                                           "Default formulation of trace substance balances";
    constant Modelica.Fluid.Types.Dynamics momentumDynamics = Modelica.Fluid.Types.Dynamics.SteadyState
                                                                                                       "Default formulation of momentum balances, if options available";
    parameter Modelica.SIunits.MassFlowRate m_flow_start = 0
                                                            "Default start value for mass flow rates";
    parameter Modelica.SIunits.AbsolutePressure p_start(fixed=false)
                                                                    "Default start value for pressures";
    parameter Modelica.SIunits.Temperature T_start(fixed=false)
                                                               "Default start value for temperatures";
    constant Boolean use_eps_Re = false
                                       "= true to determine turbulent region automatically using Reynolds number";
    parameter Modelica.SIunits.MassFlowRate m_flow_nominal(fixed=false)
                                                                       "Default nominal mass flow rate";
    parameter Real eps_m_flow(unit = "1", min = 0.0) = 0.0001
                                                             "Regularization of zero flow for |m_flow| < eps_m_flow*m_flow_nominal";
    parameter Modelica.SIunits.AbsolutePressure dp_small = 1
                                                            "Default small pressure drop for regularization of laminar and zero flow";
    parameter Modelica.SIunits.MassFlowRate m_flow_small(min = 0.0) = 0.01
                                                                          "Default small mass flow rate for regularization of laminar and zero flow";
  end 'system_rec';
public
  'system_rec' 'system' annotation(Dialog);
  constant Integer nSeg = 4
                           "number of segments the volume is divided";
  parameter Modelica.SIunits.Diameter d = 1.128379167
                                                     "diameter of the cylindrical tank";
  parameter Modelica.SIunits.Height h_max = 10
                                              "Maximun height occupied by the water";
  constant Modelica.SIunits.Height h = 5
                                        "height of the cylindrical tank";
  parameter Modelica.SIunits.Length eTank = 0.03
                                                "Thickness of insulation";
  constant Modelica.SIunits.Height h_portIn = 7.5
                                                 "Height of the inlet port";
  constant Modelica.SIunits.Height h_portOut = 0.5
                                                  "Height of the outlet port";
  parameter Modelica.SIunits.Diameter d_Inlet = 0.05
                                                    "Diameter of the inlet port";
  parameter Modelica.SIunits.Diameter d_Outlet = 0.05
                                                     "Diameter of the outlet port";
  parameter Modelica.SIunits.Height h_heater = 7.5
                                                  "Height of the heater";
  parameter Modelica.SIunits.Temperature T_start = 283.15
                                                         "Default start value for temperatures";
  parameter Modelica.SIunits.AbsolutePressure p_start(fixed=false)
                                                                  "Default start value for pressures";
  parameter Modelica.SIunits.Time tau = 1
                                         "Time constant for mixing";
protected
  record closedCylindricalTank_rec
    constant Boolean allowFlowReversal = true
                                             "true for allowing the reversal flow";
    constant Boolean homotopyInitialization = true
                                                  "true for allowing the reversal flow";
    constant Boolean useHeater = false
                                      "Inlet port at the top of the tank";
    constant Integer nSeg = 4
                             "number of segments the volume is divided";
    parameter Modelica.SIunits.Diameter d(fixed=false)
                                                      "diameter of the cylindrical tank";
    parameter Modelica.SIunits.Height h_max(fixed=false)
                                                        "Maximun height occupied by the water";
    constant Modelica.SIunits.Height h = 5
                                          "height of the cylindrical tank";
    parameter Modelica.SIunits.Length eTank(fixed=false)
                                                        "Thickness of insulation";
    constant Modelica.SIunits.Height h_portIn = 7.5
                                                   "Height of the inlet port";
    constant Modelica.SIunits.Height h_portOut = 0.5
                                                    "Height of the outlet port";
    parameter Modelica.SIunits.Diameter d_Inlet(fixed=false)
                                                            "Diameter of the inlet port";
    parameter Modelica.SIunits.Diameter d_Outlet(fixed=false)
                                                             "Diameter of the outlet port";
    constant Modelica.SIunits.Height h_heater = 7.5
                                                   "Height of the heater";
    parameter Modelica.SIunits.Temperature T_start(fixed=false)
                                                               "Default start value for temperatures";
    parameter Modelica.SIunits.AbsolutePressure p_start(fixed=false)
                                                                    "Default start value for pressures";
    parameter Modelica.SIunits.Time tau(fixed=false)
                                                    "Time constant for mixing";
    constant Boolean faceUpTop = true
                                     "True when the top of the storage is facing up";
    parameter Boolean faceUpBottom = true
                                         "True when the bottom of the storage is facing up";
    parameter Modelica.SIunits.Length D(fixed=false)
                                                    "External diameter of the clinder";
  protected
    record port_a_rec
      Modelica.Media.Interfaces.PartialMedium.MassFlowRate m_flow(quantity = "MassFlowRate.SimpleLiquidWater")
                                                                                                              "Mass flow rate from the connection point into the component";
      constant Modelica.Media.Interfaces.Types.AbsolutePressure p = 101325.0
                                                                            "Thermodynamic pressure in the connection point";
      Modelica.Media.Interfaces.Types.SpecificEnthalpy h_outflow
                                                                "Specific thermodynamic enthalpy close to the connection point if m_flow < 0";
    end port_a_rec;
  public
    port_a_rec port_a;
  protected
    record port_b_rec
      constant Modelica.Media.Interfaces.Types.AbsolutePressure p = 101325
                                                                          "Thermodynamic pressure in the connection point";
      Modelica.Media.Interfaces.Types.SpecificEnthalpy h_outflow
                                                                "Specific thermodynamic enthalpy close to the connection point if m_flow < 0";
    end port_b_rec;
  public
    port_b_rec port_b;
  protected
    record volumeTop_rec
      Modelica.SIunits.Volume fluidVolume
                                         "Volume";
      constant Modelica.Fluid.Types.Dynamics energyDynamics = Modelica.Fluid.Types.Dynamics.DynamicFreeInitial
                                                                                                              "Formulation of energy balance";
      constant Modelica.Fluid.Types.Dynamics massDynamics = Modelica.Fluid.Types.Dynamics.DynamicFreeInitial
                                                                                                            "Formulation of mass balance";
      constant Modelica.Fluid.Types.Dynamics substanceDynamics = Modelica.Fluid.Types.Dynamics.DynamicFreeInitial
                                                                                                                 "Formulation of substance balance";
      constant Modelica.Fluid.Types.Dynamics traceDynamics = Modelica.Fluid.Types.Dynamics.DynamicFreeInitial
                                                                                                             "Formulation of trace substance balance";
      parameter Modelica.Media.Interfaces.Types.AbsolutePressure p_start(fixed=false)
                                                                                     "Start value of pressure";
      constant Boolean use_T_start = true
                                         "= true, use T_start, otherwise h_start";
      parameter Modelica.Media.Interfaces.Types.Temperature T_start(fixed=false)
                                                                                "Start value of temperature";
      parameter Modelica.Media.Interfaces.Types.SpecificEnthalpy h_start(fixed=false)
                                                                                     "Start value of specific enthalpy";
      parameter Modelica.Media.Interfaces.Types.MassFraction 'X_start[1]' = 1.0
                                                                               "Start value of mass fractions m_i/m";
    protected
      record medium_rec
        constant Real p(unit = "Pa", displayUnit = "bar", nominal = 100000.0, quantity = "Pressure", min = 0.0, max = 100000000.0) = 101325.0
                                                                                                                                             "Absolute pressure of medium";
        Real h(unit = "J/kg", quantity = "SpecificEnergy")
                                                          "Specific enthalpy of medium";
        constant Modelica.Media.Interfaces.Types.Density d = 995.586
                                                                    "Density of medium";
        Modelica.Media.Interfaces.Types.Temperature T
                                                     "Temperature of medium";
        Real T_der(unit = "K/s")
                                "der(Temperature of medium)";
        constant Modelica.Media.Interfaces.Types.MassFraction 'X[1]' = 1.0
                                                                          "Mass fractions (= (component mass)/total mass  m_i/m)";
        Modelica.Media.Interfaces.Types.SpecificInternalEnergy u
                                                                "Specific internal energy of medium";
        Real u_der(unit = "m2/s3")
                                  "der(Specific internal energy of medium)";
        constant Modelica.Media.Interfaces.Types.SpecificHeatCapacity R = 0
                                                                           "Gas constant (of mixture if applicable)";
        constant Modelica.Media.Interfaces.Types.MolarMass MM = 0.018015268
                                                                           "Molar mass (of mixture or single fluid)";
      protected
        record state_rec
          constant Modelica.Media.Interfaces.Types.AbsolutePressure p = 101325.0
                                                                                "Absolute pressure of medium";
          Modelica.Media.Interfaces.Types.Temperature T
                                                       "Temperature of medium";
        end state_rec;
      public
        state_rec state;
        constant Boolean preferredMediumStates = true
                                                     "= true if StateSelect.prefer shall be used for the independent property variables of the medium";
        constant Boolean standardOrderComponents = true
                                                       "If true, and reducedX = true, the last element of X will be computed from the other ones";
        Modelica.SIunits.Conversions.NonSIunits.Temperature_degC T_degC
                                                                       "Temperature of medium in [degC]";
        constant Modelica.SIunits.Conversions.NonSIunits.Pressure_bar p_bar = 1.01325
                                                                                     "Absolute pressure of medium in [bar]";
      end medium_rec;
    public
      medium_rec medium;
      Modelica.SIunits.Energy U
                               "Internal energy of fluid";
      Real U_der(unit = "W")
                            "der(Internal energy of fluid)";
      parameter Modelica.SIunits.Mass m(fixed=false)
                                                    "Mass of fluid";
      constant Real m_der(unit = "kg/s") = 0.0
                                              "der(Mass of fluid)";
      constant Modelica.SIunits.MassFlowRate mb_flow = 0.0
                                                          "Mass flows across boundaries";
      Modelica.SIunits.EnthalpyFlowRate Hb_flow
                                               "Enthalpy flow across boundaries or energy source/sink";
      Modelica.SIunits.HeatFlowRate Qb_flow
                                           "Heat flow across boundaries or energy source/sink";
      constant Modelica.SIunits.Power Wb_flow = 0
                                                 "Work flow across boundaries or source term";
      constant Integer nPorts = 3
                                 "Number of ports";
    protected
      record 'ports[1]_rec'
        Modelica.Media.Interfaces.PartialMedium.MassFlowRate m_flow(quantity = "MassFlowRate.SimpleLiquidWater")
                                                                                                                "Mass flow rate from the connection point into the component";
        constant Modelica.Media.Interfaces.Types.AbsolutePressure p = 101325.0
                                                                              "Thermodynamic pressure in the connection point";
        Modelica.Media.Interfaces.Types.SpecificEnthalpy h_outflow
                                                                  "Specific thermodynamic enthalpy close to the connection point if m_flow < 0";
      end 'ports[1]_rec';
    public
      'ports[1]_rec' 'ports[1]';
    protected
      record 'ports[2]_rec'
        constant Modelica.Media.Interfaces.PartialMedium.MassFlowRate m_flow(quantity = "MassFlowRate.SimpleLiquidWater") = 0.0
                                                                                                                               "Mass flow rate from the connection point into the component";
        constant Modelica.Media.Interfaces.Types.AbsolutePressure p = 101325.0
                                                                              "Thermodynamic pressure in the connection point";
        Modelica.Media.Interfaces.Types.SpecificEnthalpy h_outflow
                                                                  "Specific thermodynamic enthalpy close to the connection point if m_flow < 0";
      end 'ports[2]_rec';
    public
      'ports[2]_rec' 'ports[2]';
    protected
      record 'ports[3]_rec'
        constant Modelica.Media.Interfaces.Types.AbsolutePressure p = 101325.0
                                                                              "Thermodynamic pressure in the connection point";
        Modelica.Media.Interfaces.Types.SpecificEnthalpy h_outflow
                                                                  "Specific thermodynamic enthalpy close to the connection point if m_flow < 0";
      end 'ports[3]_rec';
    public
      'ports[3]_rec' 'ports[3]';
      constant Boolean use_portsData = false
                                            "= false to neglect pressure loss and kinetic energy";
      parameter Modelica.Media.Interfaces.PartialMedium.MassFlowRate m_flow_nominal(quantity = "MassFlowRate.SimpleLiquidWater", fixed=false)
                                                                                                                                             "Nominal value for mass flow rates in ports";
      parameter Modelica.SIunits.MassFlowRate m_flow_small(min = 0.0, fixed=false)
                                                                                  "Regularization range at zero mass flow rate";
      constant Boolean use_Re = false
                                     "= true, if turbulent region is defined by Re, otherwise by m_flow_small";
      Modelica.Media.Interfaces.Types.EnthalpyFlowRate 'ports_H_flow[1]';
      constant Modelica.Media.Interfaces.Types.EnthalpyFlowRate 'ports_H_flow[2]' = 0.0;
      Modelica.Media.Interfaces.Types.EnthalpyFlowRate 'ports_H_flow[3]';
      constant Boolean use_HeatTransfer = true
                                              "= true to use the HeatTransfer model";
    protected
      record heatTransfer_rec
        constant Integer n = 1
                              "Number of heat transfer segments";
      protected
        record 'states[1]_rec'
          constant Modelica.Media.Interfaces.Types.AbsolutePressure p = 101325.0
                                                                                "Absolute pressure of medium";
          Modelica.Media.Interfaces.Types.Temperature T
                                                       "Temperature of medium";
        end 'states[1]_rec';
      public
        'states[1]_rec' 'states[1]';
        parameter Modelica.SIunits.Area 'surfaceAreas[1]'(fixed=false)
                                                                      "Heat transfer areas";
        Modelica.SIunits.HeatFlowRate 'Q_flows[1]'
                                                  "Heat flow rates";
        constant Boolean use_k = true
                                     "= true to use k value for thermal isolation";
        constant Modelica.SIunits.CoefficientOfHeatTransfer k = 0
                                                                 "Heat transfer coefficient to ambient";
        parameter Modelica.SIunits.Temperature T_ambient(fixed=false)
                                                                     "Ambient temperature";
      protected
        record 'heatPorts[1]_rec'
          Modelica.SIunits.Temperature T
                                        "Port temperature";
          Modelica.SIunits.HeatFlowRate Q_flow
                                              "Heat flow rate (positive if flowing from outside into the component)";
        end 'heatPorts[1]_rec';
      public
        'heatPorts[1]_rec' 'heatPorts[1]';
        Modelica.SIunits.Temperature 'Ts[1]'
                                            "Temperatures defined by fluid states";
      end heatTransfer_rec;
    public
      heatTransfer_rec heatTransfer;
    protected
      record heatPort_rec
        Modelica.SIunits.Temperature T
                                      "Port temperature";
        Modelica.SIunits.HeatFlowRate Q_flow
                                            "Heat flow rate (positive if flowing from outside into the component)";
      end heatPort_rec;
    public
      heatPort_rec heatPort;
      constant Modelica.Media.Interfaces.Types.Density 'portInDensities[1]' = 995.586
                                                                                     "densities of the fluid at the device boundary";
      constant Modelica.Media.Interfaces.Types.Density 'portInDensities[2]' = 995.586
                                                                                     "densities of the fluid at the device boundary";
      constant Modelica.Media.Interfaces.Types.Density 'portInDensities[3]' = 995.586
                                                                                     "densities of the fluid at the device boundary";
      constant Modelica.SIunits.Velocity 'portVelocities[1]' = 0.0
                                                                  "velocities of fluid flow at device boundary";
      constant Modelica.SIunits.Velocity 'portVelocities[2]' = 0.0
                                                                  "velocities of fluid flow at device boundary";
      constant Modelica.SIunits.Velocity 'portVelocities[3]' = 0.0
                                                                  "velocities of fluid flow at device boundary";
      constant Modelica.SIunits.EnergyFlowRate 'ports_E_flow[1]' = 0.0
                                                                      "flow of kinetic and potential energy at device boundary";
      constant Modelica.SIunits.EnergyFlowRate 'ports_E_flow[2]' = 0.0
                                                                      "flow of kinetic and potential energy at device boundary";
      constant Modelica.SIunits.EnergyFlowRate 'ports_E_flow[3]' = 0.0
                                                                      "flow of kinetic and potential energy at device boundary";
      constant Real 's[1]'(unit = "m") = 1.25
                                             "curve parameters for port flows vs. port pressures; for further details see, Modelica Tutorial: Ideal switching devices";
      constant Real 's[2]'(unit = "m") = 1.25
                                             "curve parameters for port flows vs. port pressures; for further details see, Modelica Tutorial: Ideal switching devices";
      constant Real 's[3]'(unit = "m") = 1.25
                                             "curve parameters for port flows vs. port pressures; for further details see, Modelica Tutorial: Ideal switching devices";
      constant Real 'ports_penetration[1]' = 1.0
                                                "penetration of port with fluid, depending on fluid level and port diameter";
      constant Real 'ports_penetration[2]' = 1.0
                                                "penetration of port with fluid, depending on fluid level and port diameter";
      constant Real 'ports_penetration[3]' = 1.0
                                                "penetration of port with fluid, depending on fluid level and port diameter";
      constant Modelica.SIunits.Area 'portAreas[1]' = 0.0;
      constant Modelica.SIunits.Area 'portAreas[2]' = 0.0;
      constant Modelica.SIunits.Area 'portAreas[3]' = 0.0;
      constant Modelica.Media.Interfaces.Types.AbsolutePressure 'vessel_ps_static[1]' = 101325.0
                                                                                                "static pressures inside the vessel at the height of the corresponding ports, zero flow velocity";
      constant Modelica.Media.Interfaces.Types.AbsolutePressure 'vessel_ps_static[2]' = 101325.0
                                                                                                "static pressures inside the vessel at the height of the corresponding ports, zero flow velocity";
      constant Modelica.Media.Interfaces.Types.AbsolutePressure 'vessel_ps_static[3]' = 101325.0
                                                                                                "static pressures inside the vessel at the height of the corresponding ports, zero flow velocity";
      constant Modelica.SIunits.ReynoldsNumber Re_turbulent = 100
                                                                 "cf. suddenExpansion";
      constant Modelica.SIunits.MassFlowRate 'm_flow_turbulent[1]' = 1E+060;
      constant Modelica.SIunits.MassFlowRate 'm_flow_turbulent[2]' = 1E+060;
      constant Modelica.SIunits.MassFlowRate 'm_flow_turbulent[3]' = 1E+060;
      parameter Modelica.SIunits.Volume V(fixed=false)
                                                      "Volume";
      parameter Modelica.SIunits.Diameter d(fixed=false)
                                                        "diameter of the cylindrical tank";
      constant Modelica.SIunits.Height h = 1.25
                                               "Height of the cylindrical tank";
      parameter Modelica.SIunits.Height h_max(fixed=false)
                                                          "Maximun height occupied by the water";
    end volumeTop_rec;
  public
    volumeTop_rec volumeTop annotation(Dialog);
  protected
    record 'volumeMiddle[1]_rec'
      Modelica.SIunits.Volume fluidVolume
                                         "Volume";
      constant Modelica.Fluid.Types.Dynamics energyDynamics = Modelica.Fluid.Types.Dynamics.DynamicFreeInitial
                                                                                                              "Formulation of energy balance";
      constant Modelica.Fluid.Types.Dynamics massDynamics = Modelica.Fluid.Types.Dynamics.DynamicFreeInitial
                                                                                                            "Formulation of mass balance";
      constant Modelica.Fluid.Types.Dynamics substanceDynamics = Modelica.Fluid.Types.Dynamics.DynamicFreeInitial
                                                                                                                 "Formulation of substance balance";
      constant Modelica.Fluid.Types.Dynamics traceDynamics = Modelica.Fluid.Types.Dynamics.DynamicFreeInitial
                                                                                                             "Formulation of trace substance balance";
      parameter Modelica.Media.Interfaces.Types.AbsolutePressure p_start(fixed=false)
                                                                                     "Start value of pressure";
      constant Boolean use_T_start = true
                                         "= true, use T_start, otherwise h_start";
      parameter Modelica.Media.Interfaces.Types.Temperature T_start(fixed=false)
                                                                                "Start value of temperature";
      parameter Modelica.Media.Interfaces.Types.SpecificEnthalpy h_start(fixed=false)
                                                                                     "Start value of specific enthalpy";
      parameter Modelica.Media.Interfaces.Types.MassFraction 'X_start[1]' = 1.0
                                                                               "Start value of mass fractions m_i/m";
    protected
      record medium_rec
        constant Real p(unit = "Pa", displayUnit = "bar", nominal = 100000.0, quantity = "Pressure", min = 0.0, max = 100000000.0) = 101325.0
                                                                                                                                             "Absolute pressure of medium";
        Real h(unit = "J/kg", quantity = "SpecificEnergy")
                                                          "Specific enthalpy of medium";
        constant Modelica.Media.Interfaces.Types.Density d = 995.586
                                                                    "Density of medium";
        Modelica.Media.Interfaces.Types.Temperature T
                                                     "Temperature of medium";
        Real T_der(unit = "K/s")
                                "der(Temperature of medium)";
        constant Modelica.Media.Interfaces.Types.MassFraction 'X[1]' = 1.0
                                                                          "Mass fractions (= (component mass)/total mass  m_i/m)";
        Modelica.Media.Interfaces.Types.SpecificInternalEnergy u
                                                                "Specific internal energy of medium";
        Real u_der(unit = "m2/s3")
                                  "der(Specific internal energy of medium)";
        constant Modelica.Media.Interfaces.Types.SpecificHeatCapacity R = 0
                                                                           "Gas constant (of mixture if applicable)";
        constant Modelica.Media.Interfaces.Types.MolarMass MM = 0.018015268
                                                                           "Molar mass (of mixture or single fluid)";
      protected
        record state_rec
          constant Modelica.Media.Interfaces.Types.AbsolutePressure p = 101325.0
                                                                                "Absolute pressure of medium";
          Modelica.Media.Interfaces.Types.Temperature T
                                                       "Temperature of medium";
        end state_rec;
      public
        state_rec state;
        constant Boolean preferredMediumStates = true
                                                     "= true if StateSelect.prefer shall be used for the independent property variables of the medium";
        constant Boolean standardOrderComponents = true
                                                       "If true, and reducedX = true, the last element of X will be computed from the other ones";
        Modelica.SIunits.Conversions.NonSIunits.Temperature_degC T_degC
                                                                       "Temperature of medium in [degC]";
        constant Modelica.SIunits.Conversions.NonSIunits.Pressure_bar p_bar = 1.01325
                                                                                     "Absolute pressure of medium in [bar]";
      end medium_rec;
    public
      medium_rec medium;
      Modelica.SIunits.Energy U
                               "Internal energy of fluid";
      Real U_der(unit = "W")
                            "der(Internal energy of fluid)";
      parameter Modelica.SIunits.Mass m(fixed=false)
                                                    "Mass of fluid";
      constant Real m_der(unit = "kg/s") = 0.0
                                              "der(Mass of fluid)";
      constant Modelica.SIunits.MassFlowRate mb_flow = 0.0
                                                          "Mass flows across boundaries";
      Modelica.SIunits.EnthalpyFlowRate Hb_flow
                                               "Enthalpy flow across boundaries or energy source/sink";
      Modelica.SIunits.HeatFlowRate Qb_flow
                                           "Heat flow across boundaries or energy source/sink";
      constant Modelica.SIunits.Power Wb_flow = 0
                                                 "Work flow across boundaries or source term";
      constant Integer nPorts = 4
                                 "Number of ports";
    protected
      record 'ports[1]_rec'
        constant Modelica.Media.Interfaces.PartialMedium.MassFlowRate m_flow(quantity = "MassFlowRate.SimpleLiquidWater") = 0.0
                                                                                                                               "Mass flow rate from the connection point into the component";
        constant Modelica.Media.Interfaces.Types.AbsolutePressure p = 101325.0
                                                                              "Thermodynamic pressure in the connection point";
        Modelica.Media.Interfaces.Types.SpecificEnthalpy h_outflow
                                                                  "Specific thermodynamic enthalpy close to the connection point if m_flow < 0";
      end 'ports[1]_rec';
    public
      'ports[1]_rec' 'ports[1]';
    protected
      record 'ports[2]_rec'
        Modelica.Media.Interfaces.PartialMedium.MassFlowRate m_flow(quantity = "MassFlowRate.SimpleLiquidWater")
                                                                                                                "Mass flow rate from the connection point into the component";
        constant Modelica.Media.Interfaces.Types.AbsolutePressure p = 101325.0
                                                                              "Thermodynamic pressure in the connection point";
        Modelica.Media.Interfaces.Types.SpecificEnthalpy h_outflow
                                                                  "Specific thermodynamic enthalpy close to the connection point if m_flow < 0";
      end 'ports[2]_rec';
    public
      'ports[2]_rec' 'ports[2]';
    protected
      record 'ports[3]_rec'
        constant Modelica.Media.Interfaces.Types.AbsolutePressure p = 101325.0
                                                                              "Thermodynamic pressure in the connection point";
        Modelica.Media.Interfaces.Types.SpecificEnthalpy h_outflow
                                                                  "Specific thermodynamic enthalpy close to the connection point if m_flow < 0";
      end 'ports[3]_rec';
    public
      'ports[3]_rec' 'ports[3]';
    protected
      record 'ports[4]_rec'
        constant Modelica.Media.Interfaces.PartialMedium.MassFlowRate m_flow(quantity = "MassFlowRate.SimpleLiquidWater") = 0.0
                                                                                                                               "Mass flow rate from the connection point into the component";
        constant Modelica.Media.Interfaces.Types.AbsolutePressure p = 101325.0
                                                                              "Thermodynamic pressure in the connection point";
        Modelica.Media.Interfaces.Types.SpecificEnthalpy h_outflow
                                                                  "Specific thermodynamic enthalpy close to the connection point if m_flow < 0";
      end 'ports[4]_rec';
    public
      'ports[4]_rec' 'ports[4]';
      constant Boolean use_portsData = false
                                            "= false to neglect pressure loss and kinetic energy";
      parameter Modelica.Media.Interfaces.PartialMedium.MassFlowRate m_flow_nominal(quantity = "MassFlowRate.SimpleLiquidWater", fixed=false)
                                                                                                                                             "Nominal value for mass flow rates in ports";
      parameter Modelica.SIunits.MassFlowRate m_flow_small(min = 0.0, fixed=false)
                                                                                  "Regularization range at zero mass flow rate";
      constant Boolean use_Re = false
                                     "= true, if turbulent region is defined by Re, otherwise by m_flow_small";
      constant Modelica.Media.Interfaces.Types.EnthalpyFlowRate 'ports_H_flow[1]' = 0.0;
      Modelica.Media.Interfaces.Types.EnthalpyFlowRate 'ports_H_flow[2]';
      Modelica.Media.Interfaces.Types.EnthalpyFlowRate 'ports_H_flow[3]';
      constant Modelica.Media.Interfaces.Types.EnthalpyFlowRate 'ports_H_flow[4]' = 0.0;
      constant Boolean use_HeatTransfer = true
                                              "= true to use the HeatTransfer model";
    protected
      record heatTransfer_rec
        constant Integer n = 1
                              "Number of heat transfer segments";
      protected
        record 'states[1]_rec'
          constant Modelica.Media.Interfaces.Types.AbsolutePressure p = 101325.0
                                                                                "Absolute pressure of medium";
          Modelica.Media.Interfaces.Types.Temperature T
                                                       "Temperature of medium";
        end 'states[1]_rec';
      public
        'states[1]_rec' 'states[1]';
        parameter Modelica.SIunits.Area 'surfaceAreas[1]'(fixed=false)
                                                                      "Heat transfer areas";
        Modelica.SIunits.HeatFlowRate 'Q_flows[1]'
                                                  "Heat flow rates";
        constant Boolean use_k = true
                                     "= true to use k value for thermal isolation";
        constant Modelica.SIunits.CoefficientOfHeatTransfer k = 0
                                                                 "Heat transfer coefficient to ambient";
        parameter Modelica.SIunits.Temperature T_ambient(fixed=false)
                                                                     "Ambient temperature";
      protected
        record 'heatPorts[1]_rec'
          Modelica.SIunits.Temperature T
                                        "Port temperature";
          Modelica.SIunits.HeatFlowRate Q_flow
                                              "Heat flow rate (positive if flowing from outside into the component)";
        end 'heatPorts[1]_rec';
      public
        'heatPorts[1]_rec' 'heatPorts[1]';
        Modelica.SIunits.Temperature 'Ts[1]'
                                            "Temperatures defined by fluid states";
      end heatTransfer_rec;
    public
      heatTransfer_rec heatTransfer;
    protected
      record heatPort_rec
        Modelica.SIunits.Temperature T
                                      "Port temperature";
        Modelica.SIunits.HeatFlowRate Q_flow
                                            "Heat flow rate (positive if flowing from outside into the component)";
      end heatPort_rec;
    public
      heatPort_rec heatPort;
      constant Modelica.Media.Interfaces.Types.Density 'portInDensities[1]' = 995.586
                                                                                     "densities of the fluid at the device boundary";
      constant Modelica.Media.Interfaces.Types.Density 'portInDensities[2]' = 995.586
                                                                                     "densities of the fluid at the device boundary";
      constant Modelica.Media.Interfaces.Types.Density 'portInDensities[3]' = 995.586
                                                                                     "densities of the fluid at the device boundary";
      constant Modelica.Media.Interfaces.Types.Density 'portInDensities[4]' = 995.586
                                                                                     "densities of the fluid at the device boundary";
      constant Modelica.SIunits.Velocity 'portVelocities[1]' = 0.0
                                                                  "velocities of fluid flow at device boundary";
      constant Modelica.SIunits.Velocity 'portVelocities[2]' = 0.0
                                                                  "velocities of fluid flow at device boundary";
      constant Modelica.SIunits.Velocity 'portVelocities[3]' = 0.0
                                                                  "velocities of fluid flow at device boundary";
      constant Modelica.SIunits.Velocity 'portVelocities[4]' = 0.0
                                                                  "velocities of fluid flow at device boundary";
      constant Modelica.SIunits.EnergyFlowRate 'ports_E_flow[1]' = 0.0
                                                                      "flow of kinetic and potential energy at device boundary";
      constant Modelica.SIunits.EnergyFlowRate 'ports_E_flow[2]' = 0.0
                                                                      "flow of kinetic and potential energy at device boundary";
      constant Modelica.SIunits.EnergyFlowRate 'ports_E_flow[3]' = 0.0
                                                                      "flow of kinetic and potential energy at device boundary";
      constant Modelica.SIunits.EnergyFlowRate 'ports_E_flow[4]' = 0.0
                                                                      "flow of kinetic and potential energy at device boundary";
      constant Real 's[1]'(unit = "m") = 1.25
                                             "curve parameters for port flows vs. port pressures; for further details see, Modelica Tutorial: Ideal switching devices";
      constant Real 's[2]'(unit = "m") = 1.25
                                             "curve parameters for port flows vs. port pressures; for further details see, Modelica Tutorial: Ideal switching devices";
      constant Real 's[3]'(unit = "m") = 1.25
                                             "curve parameters for port flows vs. port pressures; for further details see, Modelica Tutorial: Ideal switching devices";
      constant Real 's[4]'(unit = "m") = 1.25
                                             "curve parameters for port flows vs. port pressures; for further details see, Modelica Tutorial: Ideal switching devices";
      constant Real 'ports_penetration[1]' = 1.0
                                                "penetration of port with fluid, depending on fluid level and port diameter";
      constant Real 'ports_penetration[2]' = 1.0
                                                "penetration of port with fluid, depending on fluid level and port diameter";
      constant Real 'ports_penetration[3]' = 1.0
                                                "penetration of port with fluid, depending on fluid level and port diameter";
      constant Real 'ports_penetration[4]' = 1.0
                                                "penetration of port with fluid, depending on fluid level and port diameter";
      constant Modelica.SIunits.Area 'portAreas[1]' = 0.0;
      constant Modelica.SIunits.Area 'portAreas[2]' = 0.0;
      constant Modelica.SIunits.Area 'portAreas[3]' = 0.0;
      constant Modelica.SIunits.Area 'portAreas[4]' = 0.0;
      constant Modelica.Media.Interfaces.Types.AbsolutePressure 'vessel_ps_static[1]' = 101325.0
                                                                                                "static pressures inside the vessel at the height of the corresponding ports, zero flow velocity";
      constant Modelica.Media.Interfaces.Types.AbsolutePressure 'vessel_ps_static[2]' = 101325.0
                                                                                                "static pressures inside the vessel at the height of the corresponding ports, zero flow velocity";
      constant Modelica.Media.Interfaces.Types.AbsolutePressure 'vessel_ps_static[3]' = 101325.0
                                                                                                "static pressures inside the vessel at the height of the corresponding ports, zero flow velocity";
      constant Modelica.Media.Interfaces.Types.AbsolutePressure 'vessel_ps_static[4]' = 101325.0
                                                                                                "static pressures inside the vessel at the height of the corresponding ports, zero flow velocity";
      constant Modelica.SIunits.ReynoldsNumber Re_turbulent = 100
                                                                 "cf. suddenExpansion";
      constant Modelica.SIunits.MassFlowRate 'm_flow_turbulent[1]' = 1E+060;
      constant Modelica.SIunits.MassFlowRate 'm_flow_turbulent[2]' = 1E+060;
      constant Modelica.SIunits.MassFlowRate 'm_flow_turbulent[3]' = 1E+060;
      constant Modelica.SIunits.MassFlowRate 'm_flow_turbulent[4]' = 1E+060;
      parameter Modelica.SIunits.Volume V(fixed=false)
                                                      "Volume";
      parameter Modelica.SIunits.Diameter d(fixed=false)
                                                        "diameter of the cylindrical tank";
      constant Modelica.SIunits.Height h = 1.25
                                               "Height of the cylindrical tank";
      parameter Modelica.SIunits.Height h_max(fixed=false)
                                                          "Maximun height occupied by the water";
    end 'volumeMiddle[1]_rec';
  public
    'volumeMiddle[1]_rec' 'volumeMiddle[1]' annotation(Dialog);
  protected
    record 'volumeMiddle[2]_rec'
      Modelica.SIunits.Volume fluidVolume
                                         "Volume";
      constant Modelica.Fluid.Types.Dynamics energyDynamics = Modelica.Fluid.Types.Dynamics.DynamicFreeInitial
                                                                                                              "Formulation of energy balance";
      constant Modelica.Fluid.Types.Dynamics massDynamics = Modelica.Fluid.Types.Dynamics.DynamicFreeInitial
                                                                                                            "Formulation of mass balance";
      constant Modelica.Fluid.Types.Dynamics substanceDynamics = Modelica.Fluid.Types.Dynamics.DynamicFreeInitial
                                                                                                                 "Formulation of substance balance";
      constant Modelica.Fluid.Types.Dynamics traceDynamics = Modelica.Fluid.Types.Dynamics.DynamicFreeInitial
                                                                                                             "Formulation of trace substance balance";
      parameter Modelica.Media.Interfaces.Types.AbsolutePressure p_start(fixed=false)
                                                                                     "Start value of pressure";
      constant Boolean use_T_start = true
                                         "= true, use T_start, otherwise h_start";
      parameter Modelica.Media.Interfaces.Types.Temperature T_start(fixed=false)
                                                                                "Start value of temperature";
      parameter Modelica.Media.Interfaces.Types.SpecificEnthalpy h_start(fixed=false)
                                                                                     "Start value of specific enthalpy";
      parameter Modelica.Media.Interfaces.Types.MassFraction 'X_start[1]' = 1.0
                                                                               "Start value of mass fractions m_i/m";
    protected
      record medium_rec
        constant Real p(unit = "Pa", displayUnit = "bar", nominal = 100000.0, quantity = "Pressure", min = 0.0, max = 100000000.0) = 101325.0
                                                                                                                                             "Absolute pressure of medium";
        Real h(unit = "J/kg", quantity = "SpecificEnergy")
                                                          "Specific enthalpy of medium";
        constant Modelica.Media.Interfaces.Types.Density d = 995.586
                                                                    "Density of medium";
        Modelica.Media.Interfaces.Types.Temperature T
                                                     "Temperature of medium";
        Real T_der(unit = "K/s")
                                "der(Temperature of medium)";
        constant Modelica.Media.Interfaces.Types.MassFraction 'X[1]' = 1.0
                                                                          "Mass fractions (= (component mass)/total mass  m_i/m)";
        Modelica.Media.Interfaces.Types.SpecificInternalEnergy u
                                                                "Specific internal energy of medium";
        Real u_der(unit = "m2/s3")
                                  "der(Specific internal energy of medium)";
        constant Modelica.Media.Interfaces.Types.SpecificHeatCapacity R = 0
                                                                           "Gas constant (of mixture if applicable)";
        constant Modelica.Media.Interfaces.Types.MolarMass MM = 0.018015268
                                                                           "Molar mass (of mixture or single fluid)";
      protected
        record state_rec
          constant Modelica.Media.Interfaces.Types.AbsolutePressure p = 101325.0
                                                                                "Absolute pressure of medium";
          Modelica.Media.Interfaces.Types.Temperature T
                                                       "Temperature of medium";
        end state_rec;
      public
        state_rec state;
        constant Boolean preferredMediumStates = true
                                                     "= true if StateSelect.prefer shall be used for the independent property variables of the medium";
        constant Boolean standardOrderComponents = true
                                                       "If true, and reducedX = true, the last element of X will be computed from the other ones";
        Modelica.SIunits.Conversions.NonSIunits.Temperature_degC T_degC
                                                                       "Temperature of medium in [degC]";
        constant Modelica.SIunits.Conversions.NonSIunits.Pressure_bar p_bar = 1.01325
                                                                                     "Absolute pressure of medium in [bar]";
      end medium_rec;
    public
      medium_rec medium;
      Modelica.SIunits.Energy U
                               "Internal energy of fluid";
      Real U_der(unit = "W")
                            "der(Internal energy of fluid)";
      parameter Modelica.SIunits.Mass m(fixed=false)
                                                    "Mass of fluid";
      constant Real m_der(unit = "kg/s") = 0.0
                                              "der(Mass of fluid)";
      constant Modelica.SIunits.MassFlowRate mb_flow = 0.0
                                                          "Mass flows across boundaries";
      Modelica.SIunits.EnthalpyFlowRate Hb_flow
                                               "Enthalpy flow across boundaries or energy source/sink";
      Modelica.SIunits.HeatFlowRate Qb_flow
                                           "Heat flow across boundaries or energy source/sink";
      constant Modelica.SIunits.Power Wb_flow = 0
                                                 "Work flow across boundaries or source term";
      constant Integer nPorts = 4
                                 "Number of ports";
    protected
      record 'ports[1]_rec'
        constant Modelica.Media.Interfaces.PartialMedium.MassFlowRate m_flow(quantity = "MassFlowRate.SimpleLiquidWater") = 0.0
                                                                                                                               "Mass flow rate from the connection point into the component";
        constant Modelica.Media.Interfaces.Types.AbsolutePressure p = 101325.0
                                                                              "Thermodynamic pressure in the connection point";
        Modelica.Media.Interfaces.Types.SpecificEnthalpy h_outflow
                                                                  "Specific thermodynamic enthalpy close to the connection point if m_flow < 0";
      end 'ports[1]_rec';
    public
      'ports[1]_rec' 'ports[1]';
    protected
      record 'ports[2]_rec'
        Modelica.Media.Interfaces.PartialMedium.MassFlowRate m_flow(quantity = "MassFlowRate.SimpleLiquidWater")
                                                                                                                "Mass flow rate from the connection point into the component";
        constant Modelica.Media.Interfaces.Types.AbsolutePressure p = 101325.0
                                                                              "Thermodynamic pressure in the connection point";
        Modelica.Media.Interfaces.Types.SpecificEnthalpy h_outflow
                                                                  "Specific thermodynamic enthalpy close to the connection point if m_flow < 0";
      end 'ports[2]_rec';
    public
      'ports[2]_rec' 'ports[2]';
    protected
      record 'ports[3]_rec'
        constant Modelica.Media.Interfaces.Types.AbsolutePressure p = 101325.0
                                                                              "Thermodynamic pressure in the connection point";
        Modelica.Media.Interfaces.Types.SpecificEnthalpy h_outflow
                                                                  "Specific thermodynamic enthalpy close to the connection point if m_flow < 0";
      end 'ports[3]_rec';
    public
      'ports[3]_rec' 'ports[3]';
    protected
      record 'ports[4]_rec'
        constant Modelica.Media.Interfaces.PartialMedium.MassFlowRate m_flow(quantity = "MassFlowRate.SimpleLiquidWater") = 0.0
                                                                                                                               "Mass flow rate from the connection point into the component";
        constant Modelica.Media.Interfaces.Types.AbsolutePressure p = 101325.0
                                                                              "Thermodynamic pressure in the connection point";
        Modelica.Media.Interfaces.Types.SpecificEnthalpy h_outflow
                                                                  "Specific thermodynamic enthalpy close to the connection point if m_flow < 0";
      end 'ports[4]_rec';
    public
      'ports[4]_rec' 'ports[4]';
      constant Boolean use_portsData = false
                                            "= false to neglect pressure loss and kinetic energy";
      parameter Modelica.Media.Interfaces.PartialMedium.MassFlowRate m_flow_nominal(quantity = "MassFlowRate.SimpleLiquidWater", fixed=false)
                                                                                                                                             "Nominal value for mass flow rates in ports";
      parameter Modelica.SIunits.MassFlowRate m_flow_small(min = 0.0, fixed=false)
                                                                                  "Regularization range at zero mass flow rate";
      constant Boolean use_Re = false
                                     "= true, if turbulent region is defined by Re, otherwise by m_flow_small";
      constant Modelica.Media.Interfaces.Types.EnthalpyFlowRate 'ports_H_flow[1]' = 0.0;
      Modelica.Media.Interfaces.Types.EnthalpyFlowRate 'ports_H_flow[2]';
      Modelica.Media.Interfaces.Types.EnthalpyFlowRate 'ports_H_flow[3]';
      constant Modelica.Media.Interfaces.Types.EnthalpyFlowRate 'ports_H_flow[4]' = 0.0;
      constant Boolean use_HeatTransfer = true
                                              "= true to use the HeatTransfer model";
    protected
      record heatTransfer_rec
        constant Integer n = 1
                              "Number of heat transfer segments";
      protected
        record 'states[1]_rec'
          constant Modelica.Media.Interfaces.Types.AbsolutePressure p = 101325.0
                                                                                "Absolute pressure of medium";
          Modelica.Media.Interfaces.Types.Temperature T
                                                       "Temperature of medium";
        end 'states[1]_rec';
      public
        'states[1]_rec' 'states[1]';
        parameter Modelica.SIunits.Area 'surfaceAreas[1]'(fixed=false)
                                                                      "Heat transfer areas";
        Modelica.SIunits.HeatFlowRate 'Q_flows[1]'
                                                  "Heat flow rates";
        constant Boolean use_k = true
                                     "= true to use k value for thermal isolation";
        constant Modelica.SIunits.CoefficientOfHeatTransfer k = 0
                                                                 "Heat transfer coefficient to ambient";
        parameter Modelica.SIunits.Temperature T_ambient(fixed=false)
                                                                     "Ambient temperature";
      protected
        record 'heatPorts[1]_rec'
          Modelica.SIunits.Temperature T
                                        "Port temperature";
          Modelica.SIunits.HeatFlowRate Q_flow
                                              "Heat flow rate (positive if flowing from outside into the component)";
        end 'heatPorts[1]_rec';
      public
        'heatPorts[1]_rec' 'heatPorts[1]';
        Modelica.SIunits.Temperature 'Ts[1]'
                                            "Temperatures defined by fluid states";
      end heatTransfer_rec;
    public
      heatTransfer_rec heatTransfer;
    protected
      record heatPort_rec
        Modelica.SIunits.Temperature T
                                      "Port temperature";
        Modelica.SIunits.HeatFlowRate Q_flow
                                            "Heat flow rate (positive if flowing from outside into the component)";
      end heatPort_rec;
    public
      heatPort_rec heatPort;
      constant Modelica.Media.Interfaces.Types.Density 'portInDensities[1]' = 995.586
                                                                                     "densities of the fluid at the device boundary";
      constant Modelica.Media.Interfaces.Types.Density 'portInDensities[2]' = 995.586
                                                                                     "densities of the fluid at the device boundary";
      constant Modelica.Media.Interfaces.Types.Density 'portInDensities[3]' = 995.586
                                                                                     "densities of the fluid at the device boundary";
      constant Modelica.Media.Interfaces.Types.Density 'portInDensities[4]' = 995.586
                                                                                     "densities of the fluid at the device boundary";
      constant Modelica.SIunits.Velocity 'portVelocities[1]' = 0.0
                                                                  "velocities of fluid flow at device boundary";
      constant Modelica.SIunits.Velocity 'portVelocities[2]' = 0.0
                                                                  "velocities of fluid flow at device boundary";
      constant Modelica.SIunits.Velocity 'portVelocities[3]' = 0.0
                                                                  "velocities of fluid flow at device boundary";
      constant Modelica.SIunits.Velocity 'portVelocities[4]' = 0.0
                                                                  "velocities of fluid flow at device boundary";
      constant Modelica.SIunits.EnergyFlowRate 'ports_E_flow[1]' = 0.0
                                                                      "flow of kinetic and potential energy at device boundary";
      constant Modelica.SIunits.EnergyFlowRate 'ports_E_flow[2]' = 0.0
                                                                      "flow of kinetic and potential energy at device boundary";
      constant Modelica.SIunits.EnergyFlowRate 'ports_E_flow[3]' = 0.0
                                                                      "flow of kinetic and potential energy at device boundary";
      constant Modelica.SIunits.EnergyFlowRate 'ports_E_flow[4]' = 0.0
                                                                      "flow of kinetic and potential energy at device boundary";
      constant Real 's[1]'(unit = "m") = 1.25
                                             "curve parameters for port flows vs. port pressures; for further details see, Modelica Tutorial: Ideal switching devices";
      constant Real 's[2]'(unit = "m") = 1.25
                                             "curve parameters for port flows vs. port pressures; for further details see, Modelica Tutorial: Ideal switching devices";
      constant Real 's[3]'(unit = "m") = 1.25
                                             "curve parameters for port flows vs. port pressures; for further details see, Modelica Tutorial: Ideal switching devices";
      constant Real 's[4]'(unit = "m") = 1.25
                                             "curve parameters for port flows vs. port pressures; for further details see, Modelica Tutorial: Ideal switching devices";
      constant Real 'ports_penetration[1]' = 1.0
                                                "penetration of port with fluid, depending on fluid level and port diameter";
      constant Real 'ports_penetration[2]' = 1.0
                                                "penetration of port with fluid, depending on fluid level and port diameter";
      constant Real 'ports_penetration[3]' = 1.0
                                                "penetration of port with fluid, depending on fluid level and port diameter";
      constant Real 'ports_penetration[4]' = 1.0
                                                "penetration of port with fluid, depending on fluid level and port diameter";
      constant Modelica.SIunits.Area 'portAreas[1]' = 0.0;
      constant Modelica.SIunits.Area 'portAreas[2]' = 0.0;
      constant Modelica.SIunits.Area 'portAreas[3]' = 0.0;
      constant Modelica.SIunits.Area 'portAreas[4]' = 0.0;
      constant Modelica.Media.Interfaces.Types.AbsolutePressure 'vessel_ps_static[1]' = 101325.0
                                                                                                "static pressures inside the vessel at the height of the corresponding ports, zero flow velocity";
      constant Modelica.Media.Interfaces.Types.AbsolutePressure 'vessel_ps_static[2]' = 101325.0
                                                                                                "static pressures inside the vessel at the height of the corresponding ports, zero flow velocity";
      constant Modelica.Media.Interfaces.Types.AbsolutePressure 'vessel_ps_static[3]' = 101325.0
                                                                                                "static pressures inside the vessel at the height of the corresponding ports, zero flow velocity";
      constant Modelica.Media.Interfaces.Types.AbsolutePressure 'vessel_ps_static[4]' = 101325.0
                                                                                                "static pressures inside the vessel at the height of the corresponding ports, zero flow velocity";
      constant Modelica.SIunits.ReynoldsNumber Re_turbulent = 100
                                                                 "cf. suddenExpansion";
      constant Modelica.SIunits.MassFlowRate 'm_flow_turbulent[1]' = 1E+060;
      constant Modelica.SIunits.MassFlowRate 'm_flow_turbulent[2]' = 1E+060;
      constant Modelica.SIunits.MassFlowRate 'm_flow_turbulent[3]' = 1E+060;
      constant Modelica.SIunits.MassFlowRate 'm_flow_turbulent[4]' = 1E+060;
      parameter Modelica.SIunits.Volume V(fixed=false)
                                                      "Volume";
      parameter Modelica.SIunits.Diameter d(fixed=false)
                                                        "diameter of the cylindrical tank";
      constant Modelica.SIunits.Height h = 1.25
                                               "Height of the cylindrical tank";
      parameter Modelica.SIunits.Height h_max(fixed=false)
                                                          "Maximun height occupied by the water";
    end 'volumeMiddle[2]_rec';
  public
    'volumeMiddle[2]_rec' 'volumeMiddle[2]' annotation(Dialog);
  protected
    record volumeBottom_rec
      Modelica.SIunits.Volume fluidVolume
                                         "Volume";
      constant Modelica.Fluid.Types.Dynamics energyDynamics = Modelica.Fluid.Types.Dynamics.DynamicFreeInitial
                                                                                                              "Formulation of energy balance";
      constant Modelica.Fluid.Types.Dynamics massDynamics = Modelica.Fluid.Types.Dynamics.DynamicFreeInitial
                                                                                                            "Formulation of mass balance";
      constant Modelica.Fluid.Types.Dynamics substanceDynamics = Modelica.Fluid.Types.Dynamics.DynamicFreeInitial
                                                                                                                 "Formulation of substance balance";
      constant Modelica.Fluid.Types.Dynamics traceDynamics = Modelica.Fluid.Types.Dynamics.DynamicFreeInitial
                                                                                                             "Formulation of trace substance balance";
      parameter Modelica.Media.Interfaces.Types.AbsolutePressure p_start(fixed=false)
                                                                                     "Start value of pressure";
      constant Boolean use_T_start = true
                                         "= true, use T_start, otherwise h_start";
      parameter Modelica.Media.Interfaces.Types.Temperature T_start(fixed=false)
                                                                                "Start value of temperature";
      parameter Modelica.Media.Interfaces.Types.SpecificEnthalpy h_start(fixed=false)
                                                                                     "Start value of specific enthalpy";
      parameter Modelica.Media.Interfaces.Types.MassFraction 'X_start[1]' = 1.0
                                                                               "Start value of mass fractions m_i/m";
    protected
      record medium_rec
        constant Real p(unit = "Pa", displayUnit = "bar", nominal = 100000.0, quantity = "Pressure", min = 0.0, max = 100000000.0) = 101325.0
                                                                                                                                             "Absolute pressure of medium";
        Real h(unit = "J/kg", quantity = "SpecificEnergy")
                                                          "Specific enthalpy of medium";
        constant Modelica.Media.Interfaces.Types.Density d = 995.586
                                                                    "Density of medium";
        Modelica.Media.Interfaces.Types.Temperature T
                                                     "Temperature of medium";
        Real T_der(unit = "K/s")
                                "der(Temperature of medium)";
        constant Modelica.Media.Interfaces.Types.MassFraction 'X[1]' = 1.0
                                                                          "Mass fractions (= (component mass)/total mass  m_i/m)";
        Modelica.Media.Interfaces.Types.SpecificInternalEnergy u
                                                                "Specific internal energy of medium";
        Real u_der(unit = "m2/s3")
                                  "der(Specific internal energy of medium)";
        constant Modelica.Media.Interfaces.Types.SpecificHeatCapacity R = 0
                                                                           "Gas constant (of mixture if applicable)";
        constant Modelica.Media.Interfaces.Types.MolarMass MM = 0.018015268
                                                                           "Molar mass (of mixture or single fluid)";
      protected
        record state_rec
          constant Modelica.Media.Interfaces.Types.AbsolutePressure p = 101325.0
                                                                                "Absolute pressure of medium";
          Modelica.Media.Interfaces.Types.Temperature T
                                                       "Temperature of medium";
        end state_rec;
      public
        state_rec state;
        constant Boolean preferredMediumStates = true
                                                     "= true if StateSelect.prefer shall be used for the independent property variables of the medium";
        constant Boolean standardOrderComponents = true
                                                       "If true, and reducedX = true, the last element of X will be computed from the other ones";
        Modelica.SIunits.Conversions.NonSIunits.Temperature_degC T_degC
                                                                       "Temperature of medium in [degC]";
        constant Modelica.SIunits.Conversions.NonSIunits.Pressure_bar p_bar = 1.01325
                                                                                     "Absolute pressure of medium in [bar]";
      end medium_rec;
    public
      medium_rec medium;
      Modelica.SIunits.Energy U
                               "Internal energy of fluid";
      Real U_der(unit = "W")
                            "der(Internal energy of fluid)";
      parameter Modelica.SIunits.Mass m(fixed=false)
                                                    "Mass of fluid";
      constant Real m_der(unit = "kg/s") = 0.0
                                              "der(Mass of fluid)";
      constant Modelica.SIunits.MassFlowRate mb_flow = 0.0
                                                          "Mass flows across boundaries";
      Modelica.SIunits.EnthalpyFlowRate Hb_flow
                                               "Enthalpy flow across boundaries or energy source/sink";
      Modelica.SIunits.HeatFlowRate Qb_flow
                                           "Heat flow across boundaries or energy source/sink";
      constant Modelica.SIunits.Power Wb_flow = 0
                                                 "Work flow across boundaries or source term";
      constant Integer nPorts = 3
                                 "Number of ports";
    protected
      record 'ports[1]_rec'
        constant Modelica.Media.Interfaces.PartialMedium.MassFlowRate m_flow(quantity = "MassFlowRate.SimpleLiquidWater") = 0.0
                                                                                                                               "Mass flow rate from the connection point into the component";
        constant Modelica.Media.Interfaces.Types.AbsolutePressure p = 101325.0
                                                                              "Thermodynamic pressure in the connection point";
        Modelica.Media.Interfaces.Types.SpecificEnthalpy h_outflow
                                                                  "Specific thermodynamic enthalpy close to the connection point if m_flow < 0";
      end 'ports[1]_rec';
    public
      'ports[1]_rec' 'ports[1]';
    protected
      record 'ports[2]_rec'
        constant Modelica.Media.Interfaces.Types.AbsolutePressure p = 101325.0
                                                                              "Thermodynamic pressure in the connection point";
        Modelica.Media.Interfaces.Types.SpecificEnthalpy h_outflow
                                                                  "Specific thermodynamic enthalpy close to the connection point if m_flow < 0";
      end 'ports[2]_rec';
    public
      'ports[2]_rec' 'ports[2]';
    protected
      record 'ports[3]_rec'
        Modelica.Media.Interfaces.PartialMedium.MassFlowRate m_flow(quantity = "MassFlowRate.SimpleLiquidWater")
                                                                                                                "Mass flow rate from the connection point into the component";
        constant Modelica.Media.Interfaces.Types.AbsolutePressure p = 101325.0
                                                                              "Thermodynamic pressure in the connection point";
        Modelica.Media.Interfaces.Types.SpecificEnthalpy h_outflow
                                                                  "Specific thermodynamic enthalpy close to the connection point if m_flow < 0";
      end 'ports[3]_rec';
    public
      'ports[3]_rec' 'ports[3]';
      constant Boolean use_portsData = false
                                            "= false to neglect pressure loss and kinetic energy";
      parameter Modelica.Media.Interfaces.PartialMedium.MassFlowRate m_flow_nominal(quantity = "MassFlowRate.SimpleLiquidWater", fixed=false)
                                                                                                                                             "Nominal value for mass flow rates in ports";
      parameter Modelica.SIunits.MassFlowRate m_flow_small(min = 0.0, fixed=false)
                                                                                  "Regularization range at zero mass flow rate";
      constant Boolean use_Re = false
                                     "= true, if turbulent region is defined by Re, otherwise by m_flow_small";
      constant Modelica.Media.Interfaces.Types.EnthalpyFlowRate 'ports_H_flow[1]' = 0.0;
      Modelica.Media.Interfaces.Types.EnthalpyFlowRate 'ports_H_flow[2]';
      Modelica.Media.Interfaces.Types.EnthalpyFlowRate 'ports_H_flow[3]';
      constant Boolean use_HeatTransfer = true
                                              "= true to use the HeatTransfer model";
    protected
      record heatTransfer_rec
        constant Integer n = 1
                              "Number of heat transfer segments";
      protected
        record 'states[1]_rec'
          constant Modelica.Media.Interfaces.Types.AbsolutePressure p = 101325.0
                                                                                "Absolute pressure of medium";
          Modelica.Media.Interfaces.Types.Temperature T
                                                       "Temperature of medium";
        end 'states[1]_rec';
      public
        'states[1]_rec' 'states[1]';
        parameter Modelica.SIunits.Area 'surfaceAreas[1]'(fixed=false)
                                                                      "Heat transfer areas";
        Modelica.SIunits.HeatFlowRate 'Q_flows[1]'
                                                  "Heat flow rates";
        constant Boolean use_k = true
                                     "= true to use k value for thermal isolation";
        constant Modelica.SIunits.CoefficientOfHeatTransfer k = 0
                                                                 "Heat transfer coefficient to ambient";
        parameter Modelica.SIunits.Temperature T_ambient(fixed=false)
                                                                     "Ambient temperature";
      protected
        record 'heatPorts[1]_rec'
          Modelica.SIunits.Temperature T
                                        "Port temperature";
          Modelica.SIunits.HeatFlowRate Q_flow
                                              "Heat flow rate (positive if flowing from outside into the component)";
        end 'heatPorts[1]_rec';
      public
        'heatPorts[1]_rec' 'heatPorts[1]';
        Modelica.SIunits.Temperature 'Ts[1]'
                                            "Temperatures defined by fluid states";
      end heatTransfer_rec;
    public
      heatTransfer_rec heatTransfer;
    protected
      record heatPort_rec
        Modelica.SIunits.Temperature T
                                      "Port temperature";
        Modelica.SIunits.HeatFlowRate Q_flow
                                            "Heat flow rate (positive if flowing from outside into the component)";
      end heatPort_rec;
    public
      heatPort_rec heatPort;
      constant Modelica.Media.Interfaces.Types.Density 'portInDensities[1]' = 995.586
                                                                                     "densities of the fluid at the device boundary";
      constant Modelica.Media.Interfaces.Types.Density 'portInDensities[2]' = 995.586
                                                                                     "densities of the fluid at the device boundary";
      constant Modelica.Media.Interfaces.Types.Density 'portInDensities[3]' = 995.586
                                                                                     "densities of the fluid at the device boundary";
      constant Modelica.SIunits.Velocity 'portVelocities[1]' = 0.0
                                                                  "velocities of fluid flow at device boundary";
      constant Modelica.SIunits.Velocity 'portVelocities[2]' = 0.0
                                                                  "velocities of fluid flow at device boundary";
      constant Modelica.SIunits.Velocity 'portVelocities[3]' = 0.0
                                                                  "velocities of fluid flow at device boundary";
      constant Modelica.SIunits.EnergyFlowRate 'ports_E_flow[1]' = 0.0
                                                                      "flow of kinetic and potential energy at device boundary";
      constant Modelica.SIunits.EnergyFlowRate 'ports_E_flow[2]' = 0.0
                                                                      "flow of kinetic and potential energy at device boundary";
      constant Modelica.SIunits.EnergyFlowRate 'ports_E_flow[3]' = 0.0
                                                                      "flow of kinetic and potential energy at device boundary";
      constant Real 's[1]'(unit = "m") = 1.25
                                             "curve parameters for port flows vs. port pressures; for further details see, Modelica Tutorial: Ideal switching devices";
      constant Real 's[2]'(unit = "m") = 1.25
                                             "curve parameters for port flows vs. port pressures; for further details see, Modelica Tutorial: Ideal switching devices";
      constant Real 's[3]'(unit = "m") = 1.25
                                             "curve parameters for port flows vs. port pressures; for further details see, Modelica Tutorial: Ideal switching devices";
      constant Real 'ports_penetration[1]' = 1.0
                                                "penetration of port with fluid, depending on fluid level and port diameter";
      constant Real 'ports_penetration[2]' = 1.0
                                                "penetration of port with fluid, depending on fluid level and port diameter";
      constant Real 'ports_penetration[3]' = 1.0
                                                "penetration of port with fluid, depending on fluid level and port diameter";
      constant Modelica.SIunits.Area 'portAreas[1]' = 0.0;
      constant Modelica.SIunits.Area 'portAreas[2]' = 0.0;
      constant Modelica.SIunits.Area 'portAreas[3]' = 0.0;
      constant Modelica.Media.Interfaces.Types.AbsolutePressure 'vessel_ps_static[1]' = 101325.0
                                                                                                "static pressures inside the vessel at the height of the corresponding ports, zero flow velocity";
      constant Modelica.Media.Interfaces.Types.AbsolutePressure 'vessel_ps_static[2]' = 101325.0
                                                                                                "static pressures inside the vessel at the height of the corresponding ports, zero flow velocity";
      constant Modelica.Media.Interfaces.Types.AbsolutePressure 'vessel_ps_static[3]' = 101325.0
                                                                                                "static pressures inside the vessel at the height of the corresponding ports, zero flow velocity";
      constant Modelica.SIunits.ReynoldsNumber Re_turbulent = 100
                                                                 "cf. suddenExpansion";
      constant Modelica.SIunits.MassFlowRate 'm_flow_turbulent[1]' = 1E+060;
      constant Modelica.SIunits.MassFlowRate 'm_flow_turbulent[2]' = 1E+060;
      constant Modelica.SIunits.MassFlowRate 'm_flow_turbulent[3]' = 1E+060;
      parameter Modelica.SIunits.Volume V(fixed=false)
                                                      "Volume";
      parameter Modelica.SIunits.Diameter d(fixed=false)
                                                        "diameter of the cylindrical tank";
      constant Modelica.SIunits.Height h = 1.25
                                               "Height of the cylindrical tank";
      parameter Modelica.SIunits.Height h_max(fixed=false)
                                                          "Maximun height occupied by the water";
    end volumeBottom_rec;
  public
    volumeBottom_rec volumeBottom annotation(Dialog);
  protected
    record topCond_rec
      Modelica.SIunits.HeatFlowRate Q_flow
                                          "Heat flow rate from port_a -> port_b";
      Modelica.SIunits.TemperatureDifference dT
                                               "port_a.T - port_b.T";
    protected
      record port_a_rec
        Modelica.SIunits.Temperature T
                                      "Port temperature";
        Modelica.SIunits.HeatFlowRate Q_flow
                                            "Heat flow rate (positive if flowing from outside into the component)";
      end port_a_rec;
    public
      port_a_rec port_a;
    protected
      record port_b_rec
        Modelica.SIunits.Temperature T
                                      "Port temperature";
        Modelica.SIunits.HeatFlowRate Q_flow
                                            "Heat flow rate (positive if flowing from outside into the component)";
      end port_b_rec;
    public
      port_b_rec port_b;
      Modelica.SIunits.Temperature T
                                    "Average temperature of element";
      parameter Modelica.SIunits.Temperature T_start = 293.15
                                                             "Start temperature for the average temperature of element";
      Modelica.SIunits.ThermalConductance G
                                           "Thermal conductance of material";
      Modelica.SIunits.ThermalConductivity k
                                            "Thermal conductivity";
      parameter Modelica.SIunits.Length L(fixed=false)
                                                      "length of conduction";
      parameter Modelica.SIunits.Area A(fixed=false)
                                                    "Heat transfer area";
    end topCond_rec;
  public
    topCond_rec topCond annotation(Dialog);
  protected
    record 'middleCond[1]_rec'
      Modelica.SIunits.HeatFlowRate Q_flow
                                          "Heat flow rate from port_a -> port_b";
      Modelica.SIunits.TemperatureDifference dT
                                               "port_a.T - port_b.T";
    protected
      record port_a_rec
        Modelica.SIunits.Temperature T
                                      "Port temperature";
        Modelica.SIunits.HeatFlowRate Q_flow
                                            "Heat flow rate (positive if flowing from outside into the component)";
      end port_a_rec;
    public
      port_a_rec port_a;
    protected
      record port_b_rec
        Modelica.SIunits.Temperature T
                                      "Port temperature";
        Modelica.SIunits.HeatFlowRate Q_flow
                                            "Heat flow rate (positive if flowing from outside into the component)";
      end port_b_rec;
    public
      port_b_rec port_b;
      Modelica.SIunits.Temperature T
                                    "Average temperature of element";
      parameter Modelica.SIunits.Temperature T_start = 293.15
                                                             "Start temperature for the average temperature of element";
      Modelica.SIunits.ThermalConductance G
                                           "Thermal conductance of material";
      Modelica.SIunits.ThermalConductivity k
                                            "Thermal conductivity";
      parameter Modelica.SIunits.Length L(fixed=false)
                                                      "length of conduction";
      parameter Modelica.SIunits.Area A(fixed=false)
                                                    "Heat transfer area";
    end 'middleCond[1]_rec';
  public
    'middleCond[1]_rec' 'middleCond[1]' annotation(Dialog);
  protected
    record 'middleCond[2]_rec'
      Modelica.SIunits.HeatFlowRate Q_flow
                                          "Heat flow rate from port_a -> port_b";
      Modelica.SIunits.TemperatureDifference dT
                                               "port_a.T - port_b.T";
    protected
      record port_a_rec
        Modelica.SIunits.Temperature T
                                      "Port temperature";
        Modelica.SIunits.HeatFlowRate Q_flow
                                            "Heat flow rate (positive if flowing from outside into the component)";
      end port_a_rec;
    public
      port_a_rec port_a;
    protected
      record port_b_rec
        Modelica.SIunits.Temperature T
                                      "Port temperature";
        Modelica.SIunits.HeatFlowRate Q_flow
                                            "Heat flow rate (positive if flowing from outside into the component)";
      end port_b_rec;
    public
      port_b_rec port_b;
      Modelica.SIunits.Temperature T
                                    "Average temperature of element";
      parameter Modelica.SIunits.Temperature T_start = 293.15
                                                             "Start temperature for the average temperature of element";
      Modelica.SIunits.ThermalConductance G
                                           "Thermal conductance of material";
      Modelica.SIunits.ThermalConductivity k
                                            "Thermal conductivity";
      parameter Modelica.SIunits.Length L(fixed=false)
                                                      "length of conduction";
      parameter Modelica.SIunits.Area A(fixed=false)
                                                    "Heat transfer area";
    end 'middleCond[2]_rec';
  public
    'middleCond[2]_rec' 'middleCond[2]' annotation(Dialog);
  protected
    record 'middleCond[3]_rec'
      Modelica.SIunits.HeatFlowRate Q_flow
                                          "Heat flow rate from port_a -> port_b";
      Modelica.SIunits.TemperatureDifference dT
                                               "port_a.T - port_b.T";
    protected
      record port_a_rec
        Modelica.SIunits.Temperature T
                                      "Port temperature";
        Modelica.SIunits.HeatFlowRate Q_flow
                                            "Heat flow rate (positive if flowing from outside into the component)";
      end port_a_rec;
    public
      port_a_rec port_a;
    protected
      record port_b_rec
        Modelica.SIunits.Temperature T
                                      "Port temperature";
        Modelica.SIunits.HeatFlowRate Q_flow
                                            "Heat flow rate (positive if flowing from outside into the component)";
      end port_b_rec;
    public
      port_b_rec port_b;
      Modelica.SIunits.Temperature T
                                    "Average temperature of element";
      parameter Modelica.SIunits.Temperature T_start = 293.15
                                                             "Start temperature for the average temperature of element";
      Modelica.SIunits.ThermalConductance G
                                           "Thermal conductance of material";
      Modelica.SIunits.ThermalConductivity k
                                            "Thermal conductivity";
      parameter Modelica.SIunits.Length L(fixed=false)
                                                      "length of conduction";
      parameter Modelica.SIunits.Area A(fixed=false)
                                                    "Heat transfer area";
    end 'middleCond[3]_rec';
  public
    'middleCond[3]_rec' 'middleCond[3]' annotation(Dialog);
  protected
    record 'middleCond[4]_rec'
      Modelica.SIunits.HeatFlowRate Q_flow
                                          "Heat flow rate from port_a -> port_b";
      Modelica.SIunits.TemperatureDifference dT
                                               "port_a.T - port_b.T";
    protected
      record port_a_rec
        Modelica.SIunits.Temperature T
                                      "Port temperature";
        Modelica.SIunits.HeatFlowRate Q_flow
                                            "Heat flow rate (positive if flowing from outside into the component)";
      end port_a_rec;
    public
      port_a_rec port_a;
    protected
      record port_b_rec
        Modelica.SIunits.Temperature T
                                      "Port temperature";
        Modelica.SIunits.HeatFlowRate Q_flow
                                            "Heat flow rate (positive if flowing from outside into the component)";
      end port_b_rec;
    public
      port_b_rec port_b;
      Modelica.SIunits.Temperature T
                                    "Average temperature of element";
      parameter Modelica.SIunits.Temperature T_start = 293.15
                                                             "Start temperature for the average temperature of element";
      Modelica.SIunits.ThermalConductance G
                                           "Thermal conductance of material";
      Modelica.SIunits.ThermalConductivity k
                                            "Thermal conductivity";
      parameter Modelica.SIunits.Length L(fixed=false)
                                                      "length of conduction";
      parameter Modelica.SIunits.Area A(fixed=false)
                                                    "Heat transfer area";
    end 'middleCond[4]_rec';
  public
    'middleCond[4]_rec' 'middleCond[4]' annotation(Dialog);
  protected
    record bottomCond_rec
      Modelica.SIunits.HeatFlowRate Q_flow
                                          "Heat flow rate from port_a -> port_b";
      Modelica.SIunits.TemperatureDifference dT
                                               "port_a.T - port_b.T";
    protected
      record port_a_rec
        Modelica.SIunits.Temperature T
                                      "Port temperature";
        Modelica.SIunits.HeatFlowRate Q_flow
                                            "Heat flow rate (positive if flowing from outside into the component)";
      end port_a_rec;
    public
      port_a_rec port_a;
    protected
      record port_b_rec
        Modelica.SIunits.Temperature T
                                      "Port temperature";
        Modelica.SIunits.HeatFlowRate Q_flow
                                            "Heat flow rate (positive if flowing from outside into the component)";
      end port_b_rec;
    public
      port_b_rec port_b;
      Modelica.SIunits.Temperature T
                                    "Average temperature of element";
      parameter Modelica.SIunits.Temperature T_start = 293.15
                                                             "Start temperature for the average temperature of element";
      Modelica.SIunits.ThermalConductance G
                                           "Thermal conductance of material";
      Modelica.SIunits.ThermalConductivity k
                                            "Thermal conductivity";
      parameter Modelica.SIunits.Length L(fixed=false)
                                                      "length of conduction";
      parameter Modelica.SIunits.Area A(fixed=false)
                                                    "Heat transfer area";
    end bottomCond_rec;
  public
    bottomCond_rec bottomCond annotation(Dialog);
  protected
    record topConv_rec
      Modelica.SIunits.HeatFlowRate Q_flow
                                          "Heat flow rate from solid -> fluid";
      Modelica.SIunits.TemperatureDifference dT
                                               "= solid.T - fluid.T";
    protected
      record solid_rec
        Modelica.SIunits.Temperature T
                                      "Port temperature";
        Modelica.SIunits.HeatFlowRate Q_flow
                                            "Heat flow rate (positive if flowing from outside into the component)";
      end solid_rec;
    public
      solid_rec solid;
    protected
      record fluid_rec
        Modelica.SIunits.Temperature T
                                      "Port temperature";
        Modelica.SIunits.HeatFlowRate Q_flow
                                            "Heat flow rate (positive if flowing from outside into the component)";
      end fluid_rec;
    public
      fluid_rec fluid;
      parameter Modelica.SIunits.Area A(fixed=false)
                                                    "Convection area";
      Real Gc(unit = "W/K")
                           "Convective thermal conductance in [W/K]";
      Modelica.SIunits.CoefficientOfHeatTransfer h
                                                  "Convection heat transfer coefficient";
      Modelica.SIunits.CubicExpansionCoefficient beta;
      Modelica.SIunits.GrashofNumber Gr;
      Modelica.SIunits.RayleighNumber Ra;
      Modelica.SIunits.NusseltNumber NuL;
      Modelica.SIunits.NusseltNumber NuLa;
      Modelica.SIunits.NusseltNumber NuLb;
      constant Modelica.SIunits.PrandtlNumber Pr = 0.7038150000000001;
      Modelica.SIunits.KinematicViscosity visco;
      constant Modelica.SIunits.ThermalConductivity K = 0.026;
      parameter Modelica.SIunits.Temp_K _Tc_start = 293.15;
      Modelica.SIunits.Temp_K Tc(start = _Tc_start, fixed=false)
                                                                "Average temperature solid-fluid, characteristic temperature for correlation";
      parameter Modelica.SIunits.Length B(fixed=false)
                                                      "Perimeter of the plate";
      parameter Modelica.SIunits.Length L(fixed=false)
                                                      "Characteristic length, surface of the plate/perimeter";
      constant Boolean faceUp = true
                                    "true, if the heated plate is up";
      parameter Modelica.SIunits.Pressure P(fixed=false)
                                                        "pressure of the medium where the plate is immersed";
    end topConv_rec;
  public
    topConv_rec topConv annotation(Dialog);
  protected
    record 'middleConv[1]_rec'
      Modelica.SIunits.HeatFlowRate Q_flow
                                          "Heat flow rate from solid -> fluid";
      Modelica.SIunits.TemperatureDifference dT
                                               "= solid.T - fluid.T";
    protected
      record solid_rec
        Modelica.SIunits.Temperature T
                                      "Port temperature";
        Modelica.SIunits.HeatFlowRate Q_flow
                                            "Heat flow rate (positive if flowing from outside into the component)";
      end solid_rec;
    public
      solid_rec solid;
    protected
      record fluid_rec
        Modelica.SIunits.Temperature T
                                      "Port temperature";
        Modelica.SIunits.HeatFlowRate Q_flow
                                            "Heat flow rate (positive if flowing from outside into the component)";
      end fluid_rec;
    public
      fluid_rec fluid;
      parameter Modelica.SIunits.Area A(fixed=false)
                                                    "Convection area";
      Real Gc(unit = "W/K")
                           "Convective thermal conductance in [W/K]";
      Modelica.SIunits.CoefficientOfHeatTransfer h
                                                  "Convection heat transfer coefficient";
      parameter Modelica.SIunits.Length D(fixed=false)
                                                      "External diameter of the clinder";
      constant Modelica.SIunits.Length H = 1.25
                                               "Height of the cylinder";
      Modelica.SIunits.Temp_K Tm
                                "Mean temperature solid-fluid";
      Modelica.SIunits.KinematicViscosity visco
                                               "Kinematic viscosity of air at Tm";
      Modelica.SIunits.ThermalConductivity K
                                            "Conductivity of air at Tm";
      Modelica.SIunits.PrandtlNumber Pr
                                       "Prandtl number at Tm";
      Modelica.SIunits.RayleighNumber Ra;
      Modelica.SIunits.GrashofNumber Gr;
      Modelica.SIunits.CubicExpansionCoefficient beta;
      Modelica.SIunits.NusseltNumber Nu_nat;
      Modelica.SIunits.NusseltNumber Nu_nat1;
      Modelica.SIunits.NusseltNumber Nu_nat2;
    end 'middleConv[1]_rec';
  public
    'middleConv[1]_rec' 'middleConv[1]';
  protected
    record 'middleConv[2]_rec'
      Modelica.SIunits.HeatFlowRate Q_flow
                                          "Heat flow rate from solid -> fluid";
      Modelica.SIunits.TemperatureDifference dT
                                               "= solid.T - fluid.T";
    protected
      record solid_rec
        Modelica.SIunits.Temperature T
                                      "Port temperature";
        Modelica.SIunits.HeatFlowRate Q_flow
                                            "Heat flow rate (positive if flowing from outside into the component)";
      end solid_rec;
    public
      solid_rec solid;
    protected
      record fluid_rec
        Modelica.SIunits.Temperature T
                                      "Port temperature";
        Modelica.SIunits.HeatFlowRate Q_flow
                                            "Heat flow rate (positive if flowing from outside into the component)";
      end fluid_rec;
    public
      fluid_rec fluid;
      parameter Modelica.SIunits.Area A(fixed=false)
                                                    "Convection area";
      Real Gc(unit = "W/K")
                           "Convective thermal conductance in [W/K]";
      Modelica.SIunits.CoefficientOfHeatTransfer h
                                                  "Convection heat transfer coefficient";
      parameter Modelica.SIunits.Length D(fixed=false)
                                                      "External diameter of the clinder";
      constant Modelica.SIunits.Length H = 1.25
                                               "Height of the cylinder";
      Modelica.SIunits.Temp_K Tm
                                "Mean temperature solid-fluid";
      Modelica.SIunits.KinematicViscosity visco
                                               "Kinematic viscosity of air at Tm";
      Modelica.SIunits.ThermalConductivity K
                                            "Conductivity of air at Tm";
      Modelica.SIunits.PrandtlNumber Pr
                                       "Prandtl number at Tm";
      Modelica.SIunits.RayleighNumber Ra;
      Modelica.SIunits.GrashofNumber Gr;
      Modelica.SIunits.CubicExpansionCoefficient beta;
      Modelica.SIunits.NusseltNumber Nu_nat;
      Modelica.SIunits.NusseltNumber Nu_nat1;
      Modelica.SIunits.NusseltNumber Nu_nat2;
    end 'middleConv[2]_rec';
  public
    'middleConv[2]_rec' 'middleConv[2]';
  protected
    record 'middleConv[3]_rec'
      Modelica.SIunits.HeatFlowRate Q_flow
                                          "Heat flow rate from solid -> fluid";
      Modelica.SIunits.TemperatureDifference dT
                                               "= solid.T - fluid.T";
    protected
      record solid_rec
        Modelica.SIunits.Temperature T
                                      "Port temperature";
        Modelica.SIunits.HeatFlowRate Q_flow
                                            "Heat flow rate (positive if flowing from outside into the component)";
      end solid_rec;
    public
      solid_rec solid;
    protected
      record fluid_rec
        Modelica.SIunits.Temperature T
                                      "Port temperature";
        Modelica.SIunits.HeatFlowRate Q_flow
                                            "Heat flow rate (positive if flowing from outside into the component)";
      end fluid_rec;
    public
      fluid_rec fluid;
      parameter Modelica.SIunits.Area A(fixed=false)
                                                    "Convection area";
      Real Gc(unit = "W/K")
                           "Convective thermal conductance in [W/K]";
      Modelica.SIunits.CoefficientOfHeatTransfer h
                                                  "Convection heat transfer coefficient";
      parameter Modelica.SIunits.Length D(fixed=false)
                                                      "External diameter of the clinder";
      constant Modelica.SIunits.Length H = 1.25
                                               "Height of the cylinder";
      Modelica.SIunits.Temp_K Tm
                                "Mean temperature solid-fluid";
      Modelica.SIunits.KinematicViscosity visco
                                               "Kinematic viscosity of air at Tm";
      Modelica.SIunits.ThermalConductivity K
                                            "Conductivity of air at Tm";
      Modelica.SIunits.PrandtlNumber Pr
                                       "Prandtl number at Tm";
      Modelica.SIunits.RayleighNumber Ra;
      Modelica.SIunits.GrashofNumber Gr;
      Modelica.SIunits.CubicExpansionCoefficient beta;
      Modelica.SIunits.NusseltNumber Nu_nat;
      Modelica.SIunits.NusseltNumber Nu_nat1;
      Modelica.SIunits.NusseltNumber Nu_nat2;
    end 'middleConv[3]_rec';
  public
    'middleConv[3]_rec' 'middleConv[3]';
  protected
    record 'middleConv[4]_rec'
      Modelica.SIunits.HeatFlowRate Q_flow
                                          "Heat flow rate from solid -> fluid";
      Modelica.SIunits.TemperatureDifference dT
                                               "= solid.T - fluid.T";
    protected
      record solid_rec
        Modelica.SIunits.Temperature T
                                      "Port temperature";
        Modelica.SIunits.HeatFlowRate Q_flow
                                            "Heat flow rate (positive if flowing from outside into the component)";
      end solid_rec;
    public
      solid_rec solid;
    protected
      record fluid_rec
        Modelica.SIunits.Temperature T
                                      "Port temperature";
        Modelica.SIunits.HeatFlowRate Q_flow
                                            "Heat flow rate (positive if flowing from outside into the component)";
      end fluid_rec;
    public
      fluid_rec fluid;
      parameter Modelica.SIunits.Area A(fixed=false)
                                                    "Convection area";
      Real Gc(unit = "W/K")
                           "Convective thermal conductance in [W/K]";
      Modelica.SIunits.CoefficientOfHeatTransfer h
                                                  "Convection heat transfer coefficient";
      parameter Modelica.SIunits.Length D(fixed=false)
                                                      "External diameter of the clinder";
      constant Modelica.SIunits.Length H = 1.25
                                               "Height of the cylinder";
      Modelica.SIunits.Temp_K Tm
                                "Mean temperature solid-fluid";
      Modelica.SIunits.KinematicViscosity visco
                                               "Kinematic viscosity of air at Tm";
      Modelica.SIunits.ThermalConductivity K
                                            "Conductivity of air at Tm";
      Modelica.SIunits.PrandtlNumber Pr
                                       "Prandtl number at Tm";
      Modelica.SIunits.RayleighNumber Ra;
      Modelica.SIunits.GrashofNumber Gr;
      Modelica.SIunits.CubicExpansionCoefficient beta;
      Modelica.SIunits.NusseltNumber Nu_nat;
      Modelica.SIunits.NusseltNumber Nu_nat1;
      Modelica.SIunits.NusseltNumber Nu_nat2;
    end 'middleConv[4]_rec';
  public
    'middleConv[4]_rec' 'middleConv[4]';
  protected
    record bottomConv_rec
      Modelica.SIunits.HeatFlowRate Q_flow
                                          "Heat flow rate from solid -> fluid";
      Modelica.SIunits.TemperatureDifference dT
                                               "= solid.T - fluid.T";
    protected
      record solid_rec
        Modelica.SIunits.Temperature T
                                      "Port temperature";
        Modelica.SIunits.HeatFlowRate Q_flow
                                            "Heat flow rate (positive if flowing from outside into the component)";
      end solid_rec;
    public
      solid_rec solid;
    protected
      record fluid_rec
        Modelica.SIunits.Temperature T
                                      "Port temperature";
        Modelica.SIunits.HeatFlowRate Q_flow
                                            "Heat flow rate (positive if flowing from outside into the component)";
      end fluid_rec;
    public
      fluid_rec fluid;
      parameter Modelica.SIunits.Area A(fixed=false)
                                                    "Convection area";
      Real Gc(unit = "W/K")
                           "Convective thermal conductance in [W/K]";
      Modelica.SIunits.CoefficientOfHeatTransfer h
                                                  "Convection heat transfer coefficient";
      Modelica.SIunits.CubicExpansionCoefficient beta;
      Modelica.SIunits.GrashofNumber Gr;
      Modelica.SIunits.RayleighNumber Ra;
      Modelica.SIunits.NusseltNumber NuL;
      Modelica.SIunits.NusseltNumber NuL1;
      Modelica.SIunits.NusseltNumber NuL2;
      Modelica.SIunits.PrandtlNumber Pr;
      Modelica.SIunits.KinematicViscosity visco;
      Modelica.SIunits.ThermalConductivity K;
      Modelica.SIunits.Temp_K Tc
                                "Average temperature solid-fluid, characteristic temperature for correlation";
      parameter Modelica.SIunits.Length L(fixed=false)
                                                      "Characteristic length, length of the plate";
    end bottomConv_rec;
  public
    bottomConv_rec bottomConv;
  protected
    record 'condFluid[1]_rec'
      Modelica.SIunits.HeatFlowRate Q_flow
                                          "Heat flow rate from port_a -> port_b";
      Modelica.SIunits.TemperatureDifference dT
                                               "port_a.T - port_b.T";
    protected
      record port_a_rec
        Modelica.SIunits.Temperature T
                                      "Port temperature";
        Modelica.SIunits.HeatFlowRate Q_flow
                                            "Heat flow rate (positive if flowing from outside into the component)";
      end port_a_rec;
    public
      port_a_rec port_a;
    protected
      record port_b_rec
        Modelica.SIunits.Temperature T
                                      "Port temperature";
        Modelica.SIunits.HeatFlowRate Q_flow
                                            "Heat flow rate (positive if flowing from outside into the component)";
      end port_b_rec;
    public
      port_b_rec port_b;
      Modelica_Blocks_Interfaces_RealInput G(unit = "W/K")
                                                          "Constant thermal conductance of material";
    end 'condFluid[1]_rec';
  public
    'condFluid[1]_rec' 'condFluid[1]';
  protected
    record 'condFluid[2]_rec'
      Modelica.SIunits.HeatFlowRate Q_flow
                                          "Heat flow rate from port_a -> port_b";
      Modelica.SIunits.TemperatureDifference dT
                                               "port_a.T - port_b.T";
    protected
      record port_a_rec
        Modelica.SIunits.Temperature T
                                      "Port temperature";
        Modelica.SIunits.HeatFlowRate Q_flow
                                            "Heat flow rate (positive if flowing from outside into the component)";
      end port_a_rec;
    public
      port_a_rec port_a;
    protected
      record port_b_rec
        Modelica.SIunits.Temperature T
                                      "Port temperature";
        Modelica.SIunits.HeatFlowRate Q_flow
                                            "Heat flow rate (positive if flowing from outside into the component)";
      end port_b_rec;
    public
      port_b_rec port_b;
      Modelica_Blocks_Interfaces_RealInput G(unit = "W/K")
                                                          "Constant thermal conductance of material";
    end 'condFluid[2]_rec';
  public
    'condFluid[2]_rec' 'condFluid[2]';
  protected
    record 'condFluid[3]_rec'
      Modelica.SIunits.HeatFlowRate Q_flow
                                          "Heat flow rate from port_a -> port_b";
      Modelica.SIunits.TemperatureDifference dT
                                               "port_a.T - port_b.T";
    protected
      record port_a_rec
        Modelica.SIunits.Temperature T
                                      "Port temperature";
        Modelica.SIunits.HeatFlowRate Q_flow
                                            "Heat flow rate (positive if flowing from outside into the component)";
      end port_a_rec;
    public
      port_a_rec port_a;
    protected
      record port_b_rec
        Modelica.SIunits.Temperature T
                                      "Port temperature";
        Modelica.SIunits.HeatFlowRate Q_flow
                                            "Heat flow rate (positive if flowing from outside into the component)";
      end port_b_rec;
    public
      port_b_rec port_b;
      Modelica_Blocks_Interfaces_RealInput G(unit = "W/K")
                                                          "Constant thermal conductance of material";
    end 'condFluid[3]_rec';
  public
    'condFluid[3]_rec' 'condFluid[3]';
  protected
    record heatFlowTop_rec
      Modelica_Blocks_Interfaces_RealOutput Q_flow(unit = "W")
                                                              "Heat flow from port_a to port_b as output signal";
    protected
      record port_a_rec
        Modelica.SIunits.Temperature T
                                      "Port temperature";
        Modelica.SIunits.HeatFlowRate Q_flow
                                            "Heat flow rate (positive if flowing from outside into the component)";
      end port_a_rec;
    public
      port_a_rec port_a;
    protected
      record port_b_rec
        Modelica.SIunits.Temperature T
                                      "Port temperature";
        Modelica.SIunits.HeatFlowRate Q_flow
                                            "Heat flow rate (positive if flowing from outside into the component)";
      end port_b_rec;
    public
      port_b_rec port_b;
    end heatFlowTop_rec;
  public
    heatFlowTop_rec heatFlowTop;
  protected
    record 'heatFlowMiddle[1]_rec'
      Modelica_Blocks_Interfaces_RealOutput Q_flow(unit = "W")
                                                              "Heat flow from port_a to port_b as output signal";
    protected
      record port_a_rec
        Modelica.SIunits.Temperature T
                                      "Port temperature";
        Modelica.SIunits.HeatFlowRate Q_flow
                                            "Heat flow rate (positive if flowing from outside into the component)";
      end port_a_rec;
    public
      port_a_rec port_a;
    protected
      record port_b_rec
        Modelica.SIunits.Temperature T
                                      "Port temperature";
        Modelica.SIunits.HeatFlowRate Q_flow
                                            "Heat flow rate (positive if flowing from outside into the component)";
      end port_b_rec;
    public
      port_b_rec port_b;
    end 'heatFlowMiddle[1]_rec';
  public
    'heatFlowMiddle[1]_rec' 'heatFlowMiddle[1]';
  protected
    record 'heatFlowMiddle[2]_rec'
      Modelica_Blocks_Interfaces_RealOutput Q_flow(unit = "W")
                                                              "Heat flow from port_a to port_b as output signal";
    protected
      record port_a_rec
        Modelica.SIunits.Temperature T
                                      "Port temperature";
        Modelica.SIunits.HeatFlowRate Q_flow
                                            "Heat flow rate (positive if flowing from outside into the component)";
      end port_a_rec;
    public
      port_a_rec port_a;
    protected
      record port_b_rec
        Modelica.SIunits.Temperature T
                                      "Port temperature";
        Modelica.SIunits.HeatFlowRate Q_flow
                                            "Heat flow rate (positive if flowing from outside into the component)";
      end port_b_rec;
    public
      port_b_rec port_b;
    end 'heatFlowMiddle[2]_rec';
  public
    'heatFlowMiddle[2]_rec' 'heatFlowMiddle[2]';
  protected
    record 'heatFlowMiddle[3]_rec'
      Modelica_Blocks_Interfaces_RealOutput Q_flow(unit = "W")
                                                              "Heat flow from port_a to port_b as output signal";
    protected
      record port_a_rec
        Modelica.SIunits.Temperature T
                                      "Port temperature";
        Modelica.SIunits.HeatFlowRate Q_flow
                                            "Heat flow rate (positive if flowing from outside into the component)";
      end port_a_rec;
    public
      port_a_rec port_a;
    protected
      record port_b_rec
        Modelica.SIunits.Temperature T
                                      "Port temperature";
        Modelica.SIunits.HeatFlowRate Q_flow
                                            "Heat flow rate (positive if flowing from outside into the component)";
      end port_b_rec;
    public
      port_b_rec port_b;
    end 'heatFlowMiddle[3]_rec';
  public
    'heatFlowMiddle[3]_rec' 'heatFlowMiddle[3]';
  protected
    record 'heatFlowMiddle[4]_rec'
      Modelica_Blocks_Interfaces_RealOutput Q_flow(unit = "W")
                                                              "Heat flow from port_a to port_b as output signal";
    protected
      record port_a_rec
        Modelica.SIunits.Temperature T
                                      "Port temperature";
        Modelica.SIunits.HeatFlowRate Q_flow
                                            "Heat flow rate (positive if flowing from outside into the component)";
      end port_a_rec;
    public
      port_a_rec port_a;
    protected
      record port_b_rec
        Modelica.SIunits.Temperature T
                                      "Port temperature";
        Modelica.SIunits.HeatFlowRate Q_flow
                                            "Heat flow rate (positive if flowing from outside into the component)";
      end port_b_rec;
    public
      port_b_rec port_b;
    end 'heatFlowMiddle[4]_rec';
  public
    'heatFlowMiddle[4]_rec' 'heatFlowMiddle[4]';
  protected
    record heatFlowBottom_rec
      Modelica_Blocks_Interfaces_RealOutput Q_flow(unit = "W")
                                                              "Heat flow from port_a to port_b as output signal";
    protected
      record port_a_rec
        Modelica.SIunits.Temperature T
                                      "Port temperature";
        Modelica.SIunits.HeatFlowRate Q_flow
                                            "Heat flow rate (positive if flowing from outside into the component)";
      end port_a_rec;
    public
      port_a_rec port_a;
    protected
      record port_b_rec
        Modelica.SIunits.Temperature T
                                      "Port temperature";
        Modelica.SIunits.HeatFlowRate Q_flow
                                            "Heat flow rate (positive if flowing from outside into the component)";
      end port_b_rec;
    public
      port_b_rec port_b;
    end heatFlowBottom_rec;
  public
    heatFlowBottom_rec heatFlowBottom;
    Modelica_Blocks_Interfaces_RealOutput Ql_flow(unit = "W")
                                                             "Heat loss of tank (positive if heat flows from tank to ambient)";
  protected
    record port_a_Tambient_rec
      Modelica.SIunits.Temperature T
                                    "Port temperature";
      Modelica.SIunits.HeatFlowRate Q_flow
                                          "Heat flow rate (positive if flowing from outside into the component)";
    end port_a_Tambient_rec;
  public
    port_a_Tambient_rec port_a_Tambient;
  protected
    record buoyancy_rec
      parameter Modelica.SIunits.Volume V(fixed=false)
                                                      "Volume";
      constant Integer nSeg(min = 2) = 4
                                        "Number of volume segments";
      parameter Modelica.SIunits.Time tau(min = 0.0, fixed=false)
                                                                 "Time constant for mixing";
    protected
      record sta_default_rec
        parameter Modelica.Media.Interfaces.Types.AbsolutePressure p = 101325.0
                                                                               "Absolute pressure of medium";
        parameter Modelica.Media.Interfaces.Types.Temperature T = 293.15
                                                                        "Temperature of medium";
      end sta_default_rec;
    public
      sta_default_rec sta_default annotation(Dialog);
      constant Modelica.SIunits.Density rho_default = 995.586
                                                             "Density, used to compute fluid mass";
      constant Modelica.SIunits.SpecificHeatCapacity cp_default = 4184
                                                                      "Specific heat capacity";
      parameter Real k(unit = "W/K", fixed=false)
                                                 "Proportionality constant, since we use dT instead of dH";
      Modelica.SIunits.TemperatureDifference 'dT[1]'
                                                    "Temperature difference between adjoining volumes";
      Modelica.SIunits.TemperatureDifference 'dT[2]'
                                                    "Temperature difference between adjoining volumes";
      Modelica.SIunits.TemperatureDifference 'dT[3]'
                                                    "Temperature difference between adjoining volumes";
      Modelica.SIunits.HeatFlowRate 'Q_flow[1]'
                                               "Heat flow rate from segment i+1 to i";
      Modelica.SIunits.HeatFlowRate 'Q_flow[2]'
                                               "Heat flow rate from segment i+1 to i";
      Modelica.SIunits.HeatFlowRate 'Q_flow[3]'
                                               "Heat flow rate from segment i+1 to i";
    protected
      record 'port_a_heat[1]_rec'
        Modelica.SIunits.Temperature T
                                      "Port temperature";
        Modelica.SIunits.HeatFlowRate Q_flow
                                            "Heat flow rate (positive if flowing from outside into the component)";
      end 'port_a_heat[1]_rec';
    public
      'port_a_heat[1]_rec' 'port_a_heat[1]';
    protected
      record 'port_a_heat[2]_rec'
        Modelica.SIunits.Temperature T
                                      "Port temperature";
        Modelica.SIunits.HeatFlowRate Q_flow
                                            "Heat flow rate (positive if flowing from outside into the component)";
      end 'port_a_heat[2]_rec';
    public
      'port_a_heat[2]_rec' 'port_a_heat[2]';
    protected
      record 'port_a_heat[3]_rec'
        Modelica.SIunits.Temperature T
                                      "Port temperature";
        Modelica.SIunits.HeatFlowRate Q_flow
                                            "Heat flow rate (positive if flowing from outside into the component)";
      end 'port_a_heat[3]_rec';
    public
      'port_a_heat[3]_rec' 'port_a_heat[3]';
    protected
      record 'port_a_heat[4]_rec'
        Modelica.SIunits.Temperature T
                                      "Port temperature";
        Modelica.SIunits.HeatFlowRate Q_flow
                                            "Heat flow rate (positive if flowing from outside into the component)";
      end 'port_a_heat[4]_rec';
    public
      'port_a_heat[4]_rec' 'port_a_heat[4]';
    end buoyancy_rec;
  public
    buoyancy_rec buoyancy annotation(Dialog);
  end closedCylindricalTank_rec;
public
  closedCylindricalTank_rec closedCylindricalTank annotation(Dialog);
protected
  record ambientTemperature_rec
  protected
    record port_rec
      Modelica.SIunits.Temperature T
                                    "Port temperature";
      Modelica.SIunits.HeatFlowRate Q_flow
                                          "Heat flow rate (positive if flowing from outside into the component)";
    end port_rec;
  public
    port_rec port;
    Modelica_Blocks_Interfaces_RealInput T(unit = "K");
  end ambientTemperature_rec;
public
  ambientTemperature_rec ambientTemperature;
protected
  record Retorno_rec
    constant Integer nPorts = 1
                               "Number of ports";
  protected
    record medium_rec
      constant Real p(unit = "Pa", displayUnit = "bar", nominal = 100000.0, quantity = "Pressure", min = 0.0) = 101325.0
                                                                                                                        "Absolute pressure of medium";
      Real h(unit = "J/kg", quantity = "SpecificEnergy")
                                                        "Specific enthalpy of medium";
      constant Modelica.Media.Interfaces.Types.Density d = 995.586
                                                                  "Density of medium";
      Modelica.Media.Interfaces.Types.Temperature T
                                                   "Temperature of medium";
      constant Modelica.Media.Interfaces.Types.MassFraction 'X[1]' = 1.0
                                                                        "Mass fractions (= (component mass)/total mass  m_i/m)";
      Modelica.Media.Interfaces.Types.SpecificInternalEnergy u
                                                              "Specific internal energy of medium";
      constant Modelica.Media.Interfaces.Types.SpecificHeatCapacity R = 0
                                                                         "Gas constant (of mixture if applicable)";
      constant Modelica.Media.Interfaces.Types.MolarMass MM = 0.018015268
                                                                         "Molar mass (of mixture or single fluid)";
    protected
      record state_rec
        constant Modelica.Media.Interfaces.Types.AbsolutePressure p = 101325.0
                                                                              "Absolute pressure of medium";
        Modelica.Media.Interfaces.Types.Temperature T
                                                     "Temperature of medium";
      end state_rec;
    public
      state_rec state;
      constant Boolean preferredMediumStates = false
                                                    "= true if StateSelect.prefer shall be used for the independent property variables of the medium";
      constant Boolean standardOrderComponents = true
                                                     "If true, and reducedX = true, the last element of X will be computed from the other ones";
      Modelica.SIunits.Conversions.NonSIunits.Temperature_degC T_degC
                                                                     "Temperature of medium in [degC]";
      constant Modelica.SIunits.Conversions.NonSIunits.Pressure_bar p_bar = 1.01325
                                                                                   "Absolute pressure of medium in [bar]";
    end medium_rec;
  public
    medium_rec medium;
  protected
    record 'ports[1]_rec'
      Modelica.Media.Interfaces.PartialMedium.MassFlowRate m_flow(quantity = "MassFlowRate.SimpleLiquidWater", min = -1E+060)
                                                                                                                             "Mass flow rate from the connection point into the component";
      constant Modelica.Media.Interfaces.Types.AbsolutePressure p = 101325.0
                                                                            "Thermodynamic pressure in the connection point";
      Modelica.Media.Interfaces.Types.SpecificEnthalpy h_outflow
                                                                "Specific thermodynamic enthalpy close to the connection point if m_flow < 0";
    end 'ports[1]_rec';
  public
    'ports[1]_rec' 'ports[1]';
    constant Modelica.Media.Interfaces.Types.AbsolutePressure p = 101325
                                                                        "Fixed value of pressure";
    constant Modelica.Media.Interfaces.Types.Temperature T = 293.15
                                                                   "Fixed value of temperature";
    constant Modelica.Media.Interfaces.Types.MassFraction 'X[1]' = 1.0
                                                                      "Fixed value of composition";
    Modelica_Blocks_Interfaces_RealInput T_in(unit = "K")
                                                         "Prescribed boundary temperature";
  end Retorno_rec;
public
  Retorno_rec Retorno;
protected
  record Impulsion_rec
    constant Integer nPorts = 1
                               "Number of ports";
  protected
    record medium_rec
      constant Real p(unit = "Pa", displayUnit = "bar", nominal = 100000.0, quantity = "Pressure", min = 0.0) = 101325.0
                                                                                                                        "Absolute pressure of medium";
      Real h(unit = "J/kg", quantity = "SpecificEnergy")
                                                        "Specific enthalpy of medium";
      constant Modelica.Media.Interfaces.Types.Density d = 995.586
                                                                  "Density of medium";
      Modelica.Media.Interfaces.Types.Temperature T
                                                   "Temperature of medium";
      constant Modelica.Media.Interfaces.Types.MassFraction 'X[1]' = 1.0
                                                                        "Mass fractions (= (component mass)/total mass  m_i/m)";
      Modelica.Media.Interfaces.Types.SpecificInternalEnergy u
                                                              "Specific internal energy of medium";
      constant Modelica.Media.Interfaces.Types.SpecificHeatCapacity R = 0
                                                                         "Gas constant (of mixture if applicable)";
      constant Modelica.Media.Interfaces.Types.MolarMass MM = 0.018015268
                                                                         "Molar mass (of mixture or single fluid)";
    protected
      record state_rec
        constant Modelica.Media.Interfaces.Types.AbsolutePressure p = 101325.0
                                                                              "Absolute pressure of medium";
        Modelica.Media.Interfaces.Types.Temperature T
                                                     "Temperature of medium";
      end state_rec;
    public
      state_rec state;
      constant Boolean preferredMediumStates = false
                                                    "= true if StateSelect.prefer shall be used for the independent property variables of the medium";
      constant Boolean standardOrderComponents = true
                                                     "If true, and reducedX = true, the last element of X will be computed from the other ones";
      Modelica.SIunits.Conversions.NonSIunits.Temperature_degC T_degC
                                                                     "Temperature of medium in [degC]";
      constant Modelica.SIunits.Conversions.NonSIunits.Pressure_bar p_bar = 1.01325
                                                                                   "Absolute pressure of medium in [bar]";
    end medium_rec;
  public
    medium_rec medium;
  protected
    record 'ports[1]_rec'
      Modelica.Media.Interfaces.PartialMedium.MassFlowRate m_flow(quantity = "MassFlowRate.SimpleLiquidWater", min = -1E+060, max = 1E+060)
                                                                                                                                           "Mass flow rate from the connection point into the component";
      constant Modelica.Media.Interfaces.Types.AbsolutePressure p = 101325.0
                                                                            "Thermodynamic pressure in the connection point";
      Modelica.Media.Interfaces.Types.SpecificEnthalpy h_outflow
                                                                "Specific thermodynamic enthalpy close to the connection point if m_flow < 0";
    end 'ports[1]_rec';
  public
    'ports[1]_rec' 'ports[1]';
    constant Modelica.Media.Interfaces.PartialMedium.MassFlowRate m_flow(quantity = "MassFlowRate.SimpleLiquidWater") = 0
                                                                                                                         "Fixed mass flow rate going out of the fluid port";
    constant Modelica.Media.Interfaces.Types.Temperature T = 293.15
                                                                   "Fixed value of temperature";
    constant Modelica.Media.Interfaces.Types.MassFraction 'X[1]' = 1.0
                                                                      "Fixed value of composition";
    Modelica_Blocks_Interfaces_RealInput m_flow_in(unit = "kg/s")
                                                                 "Prescribed mass flow rate";
    Modelica_Blocks_Interfaces_RealInput T_in(unit = "K")
                                                         "Prescribed fluid temperature";
  end Impulsion_rec;
public
  Impulsion_rec Impulsion;
protected
  record T_Impulsion_rec
  protected
    record port_rec
      constant Modelica.Media.Interfaces.PartialMedium.MassFlowRate m_flow(quantity = "MassFlowRate.SimpleLiquidWater", min = 0.0) = 0
                                                                                                                                      "Mass flow rate from the connection point into the component";
      constant Modelica.Media.Interfaces.Types.AbsolutePressure p = 101325.0
                                                                            "Thermodynamic pressure in the connection point";
      constant Modelica.Media.Interfaces.Types.SpecificEnthalpy h_outflow = 83680.0
                                                                                   "Specific thermodynamic enthalpy close to the connection point if m_flow < 0";
    end port_rec;
  public
    port_rec port;
    Modelica_Blocks_Interfaces_RealOutput T(unit = "K", displayUnit = "degC", nominal = 300.0, quantity = "ThermodynamicTemperature", min = 0.0)
                                                                                                                                                "Temperature in port medium";
  end T_Impulsion_rec;
public
  T_Impulsion_rec T_Impulsion;
protected
  record T_Retorno_rec
  protected
    record port_rec
      constant Modelica.Media.Interfaces.PartialMedium.MassFlowRate m_flow(quantity = "MassFlowRate.SimpleLiquidWater", min = 0.0) = 0
                                                                                                                                      "Mass flow rate from the connection point into the component";
      constant Modelica.Media.Interfaces.Types.AbsolutePressure p = 101325.0
                                                                            "Thermodynamic pressure in the connection point";
      constant Modelica.Media.Interfaces.Types.SpecificEnthalpy h_outflow = 83680.0
                                                                                   "Specific thermodynamic enthalpy close to the connection point if m_flow < 0";
    end port_rec;
  public
    port_rec port;
    Modelica_Blocks_Interfaces_RealOutput T(unit = "K", displayUnit = "degC", nominal = 300.0, quantity = "ThermodynamicTemperature", min = 0.0)
                                                                                                                                                "Temperature in port medium";
  end T_Retorno_rec;
public
  T_Retorno_rec T_Retorno;
protected
  record massFlowRate_rec
    constant Boolean allowFlowReversal = true
                                             "= true to allow flow reversal, false restricts to design direction (port_a -> port_b)";
  protected
    record port_a_rec
      Modelica.Media.Interfaces.PartialMedium.MassFlowRate m_flow(quantity = "MassFlowRate.SimpleLiquidWater", min = -1E+060)
                                                                                                                             "Mass flow rate from the connection point into the component";
      constant Modelica.Media.Interfaces.Types.AbsolutePressure p = 101325.0
                                                                            "Thermodynamic pressure in the connection point";
      Modelica.Media.Interfaces.Types.SpecificEnthalpy h_outflow
                                                                "Specific thermodynamic enthalpy close to the connection point if m_flow < 0";
    end port_a_rec;
  public
    port_a_rec port_a;
  protected
    record port_b_rec
      constant Modelica.Media.Interfaces.Types.AbsolutePressure p = 101325.0
                                                                            "Thermodynamic pressure in the connection point";
      Modelica.Media.Interfaces.Types.SpecificEnthalpy h_outflow
                                                                "Specific thermodynamic enthalpy close to the connection point if m_flow < 0";
    end port_b_rec;
  public
    port_b_rec port_b;
    parameter Modelica.Media.Interfaces.PartialMedium.MassFlowRate m_flow_nominal(quantity = "MassFlowRate.SimpleLiquidWater", fixed=false)
                                                                                                                                           "Nominal value of m_flow = port_a.m_flow";
    parameter Modelica.Media.Interfaces.PartialMedium.MassFlowRate m_flow_small(quantity = "MassFlowRate.SimpleLiquidWater", min = 0.0, fixed=false)
                                                                                                                                                    "Regularization for bi-directional flow in the region |m_flow| < m_flow_small (m_flow_small > 0 required)";
    Modelica_Blocks_Interfaces_RealOutput m_flow(unit = "kg/s", quantity = "MassFlowRate")
                                                                                          "Mass flow rate from port_a to port_b";
  end massFlowRate_rec;
public
  massFlowRate_rec massFlowRate;
protected
  record triggeredSampler_rec
    parameter Real y_start(unit = "K") = 280.15
                                               "initial value of output signal";
    Modelica_Blocks_Interfaces_RealInput u(unit = "K")
                                                      "Connector with a Real input signal";
    Modelica_Blocks_Interfaces_RealOutput y(unit = "K", nominal = 300.0, min = 1.0, max = 10000.0)
                                                                                                  "Connector with a Real output signal";
    Modelica_Blocks_Interfaces_BooleanInput trigger;
  end triggeredSampler_rec;
public
  triggeredSampler_rec triggeredSampler annotation(Dialog);
protected
  record triggeredSampler1_rec
    parameter Real y_start(unit = "K") = 280.15
                                               "initial value of output signal";
    Modelica_Blocks_Interfaces_RealInput u(unit = "K")
                                                      "Connector with a Real input signal";
    Modelica_Blocks_Interfaces_RealOutput y(unit = "K", nominal = 300.0, min = 1.0, max = 10000.0)
                                                                                                  "Connector with a Real output signal";
    Modelica_Blocks_Interfaces_BooleanInput trigger;
  end triggeredSampler1_rec;
public
  triggeredSampler1_rec triggeredSampler1 annotation(Dialog);
protected
  record not1_rec
    Modelica_Blocks_Interfaces_BooleanInput u
                                             "Connector of Boolean input signal";
    Modelica_Blocks_Interfaces_BooleanOutput y
                                              "Connector of Boolean output signal";
  end not1_rec;
public
  not1_rec not1;
protected
  record booleanExpression_rec
    Modelica_Blocks_Interfaces_BooleanOutput y
                                              "Value of Boolean output";
  end booleanExpression_rec;
public
  booleanExpression_rec booleanExpression;
  parameter Real _massFlow_start = 0.0
  annotation (Dialog(tab="Input Start Values", group="Input Start Value before call to fmiInitialize"));
protected
  Real _massFlow_old;
public
  Modelica.Blocks.Interfaces.RealInput massFlow(unit = "kg/s", quantity = "MassFlowRate", min = -100000.0, max = 100000.0, start = 0.0)
                                                                                                                                       "Inlet fluid mass flow"
  annotation (Placement(transformation(extent={{-124,40},{-84,80}})));
  parameter Real _impulsion_T_start = 288.15
  annotation (Dialog(tab="Input Start Values", group="Input Start Value before call to fmiInitialize"));
protected
  Real _impulsion_T_old;
public
  Modelica.Blocks.Interfaces.RealInput impulsion_T(unit = "K", displayUnit = "degC", nominal = 300.0, quantity = "ThermodynamicTemperature", min = 0.0, start = 288.15)
                                                                                                                                                                       "Temperature of the fluid to the \"Impulsion\""
  annotation (Placement(transformation(extent={{-124,0},{-84,40}})));
  parameter Real _return_T_start = 288.15
  annotation (Dialog(tab="Input Start Values", group="Input Start Value before call to fmiInitialize"));
protected
  Real _return_T_old;
public
  Modelica.Blocks.Interfaces.RealInput return_T(unit = "K", displayUnit = "degC", nominal = 300.0, quantity = "ThermodynamicTemperature", min = 0.0, start = 288.15)
                                                                                                                                                                    "Temperature of the fluid to the \"Return\""
  annotation (Placement(transformation(extent={{-124,-40},{-84,0}})));
  parameter Real _ambient_T_start = 288.15
  annotation (Dialog(tab="Input Start Values", group="Input Start Value before call to fmiInitialize"));
protected
  Real _ambient_T_old;
public
  Modelica.Blocks.Interfaces.RealInput ambient_T(unit = "K", displayUnit = "degC", nominal = 300.0, quantity = "ThermodynamicTemperature", min = 0.0, start = 288.15)
                                                                                                                                                                     "Ambient temperautre"
  annotation (Placement(transformation(extent={{-124,-80},{-84,-40}})));
  Modelica.Blocks.Interfaces.RealOutput m_impulsion_T(unit = "K", displayUnit = "degC", nominal = 300.0, quantity = "ThermodynamicTemperature", min = 0.0)
                                                                                                                                                          "Temperature of the fluid to the \"Impulsion\""
  annotation (Placement(transformation(extent={{100,30},{140,70}})));
  Modelica.Blocks.Interfaces.RealOutput m_return_T(unit = "K", displayUnit = "degC", nominal = 300.0, quantity = "ThermodynamicTemperature", min = 0.0)
                                                                                                                                                       "Temperature of the fluid to the \"Return\""
  annotation (Placement(transformation(extent={{100,-20},{140,20}})));
  Modelica.Blocks.Interfaces.RealOutput heatLosses(unit = "W", quantity = "Power")
                                                                                  "Heat losses of the storage"
  annotation (Placement(transformation(extent={{100,-70},{140,-30}})));
public
  parameter String fmi_instanceName="Buffer_FMU_fmu"
  annotation (Dialog(tab="FMI", group="Instance name"));
  parameter Boolean fmi_loggingOn=false
  annotation (Dialog(tab="FMI", group="Enable logging"));
  parameter Boolean fmi_pullInputsForInitialization=true
  "Set to false when using the FMU in feedback connections"
  annotation (Dialog(tab="FMI", group="Inputs for initialization"));
  parameter Boolean fmi_InputTime=false
  "Time point of input used when calling doStep."
  annotation (Evaluate=true,Dialog(tab="FMI", group="Input Handling"),choices(choice= false "StepEnd", choice= true "StepStart"));
  parameter Boolean fmi_UsePreOnInputSignals=true
  annotation (Evaluate=true,Dialog(tab="FMI", group="Input Handling"));
  parameter Real fmi_StartTime = 0.0
  annotation (Dialog(tab="FMI", group="Step time"));
  parameter Real fmi_StopTime = 60000.0
  annotation (Dialog(tab="FMI", group="Step time"));
  parameter Real fmi_NumberOfSteps = 500
  annotation (Dialog(tab="FMI", group="Step time"));
  parameter Real fmi_CommunicationStepSize=(fmi_StopTime-fmi_StartTime)/fmi_NumberOfSteps
  annotation (Dialog(tab="FMI", group="Step time"));
  parameter Integer stepSizeScaleFactor = 1 "Number of doSteps called between two CommunicationStepSize"
  annotation (Dialog(tab="FMI", group="Step time"));
  parameter Boolean fmi_forceShutDownAtStopTime=false
  annotation (Dialog(tab="FMI", group="Step time"));
  parameter String fmi_fmuLocation="file:///"+ModelicaServices.ExternalReferences.loadResource("modelica://Buffer_FMU_fmu/Resources/Library/FMU/Buffer_FMU")
  annotation (Dialog(tab="FMI", group="Instantiation"));
protected
fmi_Functions.fmiModel fmi;
Boolean fmi_StepOK;
parameter Real fmi_Initialized(fixed=false);
parameter Real fmi_AParamsAndStart(fixed=false);
parameter Real fmi_initInput0(start=0,fixed=false);
parameter Real fmi_initInput1(start=0,fixed=false);
parameter Real fmi_initInput2(start=0,fixed=false);
parameter Real fmi_initInput3(start=0,fixed=false);
Real RealVariables1[100];
Real RealVariables2[100];
Real RealVariables3[100];
Real RealVariables4[63];
Real RealDependentParameters[88];
Boolean BooleanVariables[5];
package fmi_Functions
  class fmiModel
  extends ExternalObject;
    function constructor "Initialize FMI model"
      extends Modelica.Icons.Function;
      input String instanceName;
      input Boolean loggingOn;
        input String fmuLocation;
      output fmiModel fmi;
      external"C" fmi = Modelica_0IK4_0TEKNIKER_DCOL_Generation_SensibleStorages_FMI_Buffer_0Dym_fmiInstantiateModel2(instanceName, loggingOn, fmuLocation)
      annotation(Header="
#ifndef Modelica_0IK4_0TEKNIKER_DCOL_Generation_SensibleStorages_FMI_Buffer_0Dym_Instantiate_C
#define Modelica_0IK4_0TEKNIKER_DCOL_Generation_SensibleStorages_FMI_Buffer_0Dym_Instantiate_C 1
#include <stdlib.h>
#include \"FMI/fmiImport.h\"
#ifndef Modelica_0IK4_0TEKNIKER_DCOL_Generation_SensibleStorages_FMI_Buffer_0Dym_MYSTRCMP_C
#define Modelica_0IK4_0TEKNIKER_DCOL_Generation_SensibleStorages_FMI_Buffer_0Dym_MYSTRCMP_C 1
int Modelica_0IK4_0TEKNIKER_DCOL_Generation_SensibleStorages_FMI_Buffer_0Dymmystrcmp(const void *_a, const void *_b) {
  char *a = _a;
  char *const *b = _b;
  return strcmp(a, *b);
}
#endif
void Modelica_0IK4_0TEKNIKER_DCOL_Generation_SensibleStorages_FMI_Buffer_0DymLogger(fmiComponent c, fmiString instanceName, fmiStatus status,
         fmiString category, fmiString message, ...) {
  char msg[4096];
  char buf[4096];
  int len;
  va_list ap;
  va_start(ap,message);
#if defined(_MSC_VER) && _MSC_VER>=1200
  len = _snprintf(msg, sizeof(msg)/sizeof(*msg), \"%s: %s\", instanceName, message);
  if (len < 0) goto fail;
  len = _vsnprintf(buf, sizeof(buf)/sizeof(*buf) - 2, msg, ap);
  if (len < 0) goto fail;
#else
  len = snprintf(msg, sizeof(msg)/sizeof(*msg), \"%s: %s\", instanceName, message);
  if (len < 0) goto fail;
  len = vsnprintf(buf, sizeof(buf)/sizeof(*buf) - 2, msg, ap);
  if (len < 0) goto fail;
#endif
  if( len>0 && len <4096 && buf[len - 1]!='\\n'){
    buf[len] = '\\n';
    buf[len + 1] = 0;
  }
  va_end(ap);
  switch (status) {
    case fmiFatal:
      ModelicaMessage(\"[fmiFatal]: \");
      break;
    case fmiError:
      ModelicaMessage(\"[fmiError]: \");
      break;
    case fmiDiscard:
      ModelicaMessage(\"[fmiDiscard]: \");
      break;
    case fmiWarning:
      ModelicaMessage(\"[fmiWarning]: \");
      break;
    case fmiOK:
      ModelicaMessage(\"[fmiOK]: \");
      break;
  }
  ModelicaMessage(buf);
  return;
fail:
  ModelicaMessage(\"Logger failed, message too long?\");
}
void * Modelica_0IK4_0TEKNIKER_DCOL_Generation_SensibleStorages_FMI_Buffer_0Dym_fmiInstantiateModel2(const char*instanceName, fmiBoolean loggingOn, const char* fmuLocation) {
  static fmiCoSimCallbackFunctions funcs = {&Modelica_0IK4_0TEKNIKER_DCOL_Generation_SensibleStorages_FMI_Buffer_0DymLogger, &calloc, &free, NULL};
  struct dy_Extended* res;

  res = calloc(1, sizeof(struct dy_Extended));
  if (res!=0) {
    if (!(res->hInst=LoadLibraryW(L\"Modelica_0IK4_0TEKNIKER_DCOL_Generation_SensibleStorages_FMI_Buffer_0Dym.dll\"))) {
      ModelicaError(\"Loading of FMU dynamic link library (Modelica_0IK4_0TEKNIKER_DCOL_Generation_SensibleStorages_FMI_Buffer_0Dym.dll) failed!\");
      return 0;
    }
    if(!(res->dyFmiInstantiateSlave=(fmiInstantiateSlaveFunc)GetProcAddress(res->hInst,\"Modelica_0IK4_0TEKNIKER_DCOL_Generation_SensibleStorages_FMI_Buffer_0Dym_fmiInstantiateSlave\"))){
      ModelicaError(\"GetProcAddress failed for fmiInstantiateSlave!\\n The model was imported as a Co-Simulation FMU but could not load the CS specific function fmiInstantiateSlave\\n Verify that the FMU supports Co-Simulation\");
      return 0;
    }
    if(!(res->dyFmiFreeSlaveInstance=(fmiFreeSlaveInstanceFunc)GetProcAddress(res->hInst,\"Modelica_0IK4_0TEKNIKER_DCOL_Generation_SensibleStorages_FMI_Buffer_0Dym_fmiFreeSlaveInstance\"))){
      ModelicaError(\"GetProcAddress failed for fmiFreeSlaveInstance!\\n The model was imported as a Co-Simulation FMU but could not load the CS specific function fmiFreeSlaveInstance\\n Verify that the FMU supports Co-Simulation\");
      return 0;
    }
    if(!(res->dyFmiInitializeSlave=(fmiInitializeSlaveFunc)GetProcAddress(res->hInst,\"Modelica_0IK4_0TEKNIKER_DCOL_Generation_SensibleStorages_FMI_Buffer_0Dym_fmiInitializeSlave\"))){
      ModelicaError(\"GetProcAddress failed for fmiInitializeSlave!\\n The model was imported as a Co-Simulation FMU but could not load the CS specific function fmiInitializeSlave\\n Verify that the FMU supports Co-Simulation\");
      return 0;
    }
    if(!(res->dyFmiResetSlave=(fmiResetSlaveFunc)GetProcAddress(res->hInst,\"Modelica_0IK4_0TEKNIKER_DCOL_Generation_SensibleStorages_FMI_Buffer_0Dym_fmiResetSlave\"))){
      ModelicaError(\"GetProcAddress failed for fmiResetSlave!\\n The model was imported as a Co-Simulation FMU but could not load the CS specific function fmiResetSlave\\n Verify that the FMU supports Co-Simulation\");
      return 0;
    }
    if(!(res->dyFmiDoStep=(fmiDoStepFunc)GetProcAddress(res->hInst,\"Modelica_0IK4_0TEKNIKER_DCOL_Generation_SensibleStorages_FMI_Buffer_0Dym_fmiDoStep\"))){
      ModelicaError(\"GetProcAddress failed for fmiDoStep!\\n The model was imported as a Co-Simulation FMU but could not load the CS specific function fmiDoStep\\n Verify that the FMU supports Co-Simulation\");
      return 0;
    }
    if(!(res->dyFmiTerminateSlave=(fmiTerminateSlaveFunc)GetProcAddress(res->hInst,\"Modelica_0IK4_0TEKNIKER_DCOL_Generation_SensibleStorages_FMI_Buffer_0Dym_fmiTerminateSlave\"))){
      ModelicaError(\"GetProcAddress failed for fmiTerminateSlave!\\n The model was imported as a Co-Simulation FMU but could not load the CS specific function fmiTerminateSlave\\n Verify that the FMU supports Co-Simulation\");
      return 0;
    }
    if (!(res->dyFmiSetReal=(fmiSetRealFunc)GetProcAddress(res->hInst,\"Modelica_0IK4_0TEKNIKER_DCOL_Generation_SensibleStorages_FMI_Buffer_0Dym_fmiSetReal\"))) {
      ModelicaError(\"GetProcAddress failed for fmiSetReal!\");
      return 0;
    }
    if (!(res->dyFmiGetReal=(fmiGetRealFunc)GetProcAddress(res->hInst,\"Modelica_0IK4_0TEKNIKER_DCOL_Generation_SensibleStorages_FMI_Buffer_0Dym_fmiGetReal\"))) {
      ModelicaError(\"GetProcAddress failed for fmiGetReal!\");
      return 0;
    }
    if (!(res->dyFmiSetInteger=(fmiSetIntegerFunc)GetProcAddress(res->hInst,\"Modelica_0IK4_0TEKNIKER_DCOL_Generation_SensibleStorages_FMI_Buffer_0Dym_fmiSetInteger\"))) {
      ModelicaError(\"GetProcAddress failed for fmiSetInteger!\");
      return 0;
    }
    if (!(res->dyFmiGetInteger=(fmiGetIntegerFunc)GetProcAddress(res->hInst,\"Modelica_0IK4_0TEKNIKER_DCOL_Generation_SensibleStorages_FMI_Buffer_0Dym_fmiGetInteger\"))) {
      ModelicaError(\"GetProcAddress failed for fmiGetInteger!\");
      return 0;
    }
    if (!(res->dyFmiSetBoolean=(fmiSetBooleanFunc)GetProcAddress(res->hInst,\"Modelica_0IK4_0TEKNIKER_DCOL_Generation_SensibleStorages_FMI_Buffer_0Dym_fmiSetBoolean\"))) {
      ModelicaError(\"GetProcAddress failed for fmiSetBoolean!\");
      return 0;
    }
    if (!(res->dyFmiGetBoolean=(fmiGetBooleanFunc)GetProcAddress(res->hInst,\"Modelica_0IK4_0TEKNIKER_DCOL_Generation_SensibleStorages_FMI_Buffer_0Dym_fmiGetBoolean\"))) {
      ModelicaError(\"GetProcAddress failed for fmiGetBoolean!\");
      return 0;
    }
    if (!(res->dyFmiSetString=(fmiSetStringFunc)GetProcAddress(res->hInst,\"Modelica_0IK4_0TEKNIKER_DCOL_Generation_SensibleStorages_FMI_Buffer_0Dym_fmiSetString\"))) {
      ModelicaError(\"GetProcAddress failed for fmiSetString!\");
      return 0;
    }
    if (!(res->dyFmiGetString=(fmiGetStringFunc)GetProcAddress(res->hInst,\"Modelica_0IK4_0TEKNIKER_DCOL_Generation_SensibleStorages_FMI_Buffer_0Dym_fmiGetString\"))) {
      ModelicaError(\"GetProcAddress failed for fmiGetString!\");
      return 0;
    }
    res->m=res->dyFmiInstantiateSlave(instanceName, \"{fea30f15-c015-4d0d-872d-28deb2bc2103}\", fmuLocation, \"application/x-dymolakernel\", 0, fmiFalse, fmiFalse, funcs, loggingOn);
    if (0==res->m) {free(res);res=0;ModelicaError(\"InstantiateSlave failed\");}
    else {res->dyTriggered=0;res->dyTime=res->dyLastTime=-1e37;}
  }
  return res;
}
#endif", Library="Modelica_0IK4_0TEKNIKER_DCOL_Generation_SensibleStorages_FMI_Buffer_0Dym", LibraryDirectory="modelica://DCOL/Resources/Library/FMU/Buffer_FMU/binaries",           __Dymola_CriticalRegion="Modelica_0IK4_0TEKNIKER_DCOL_Generation_SensibleStorages_FMI_Buffer_0Dym");
    end constructor;

    function destructor "Release storage of FMI model"
      extends Modelica.Icons.Function;
      input fmiModel fmi;
      external"C"
                 Modelica_0IK4_0TEKNIKER_DCOL_Generation_SensibleStorages_FMI_Buffer_0Dym_fmiFreeModelInstance2(fmi);
      annotation (Header="
#ifndef Modelica_0IK4_0TEKNIKER_DCOL_Generation_SensibleStorages_FMI_Buffer_0Dym_Free_C
#define Modelica_0IK4_0TEKNIKER_DCOL_Generation_SensibleStorages_FMI_Buffer_0Dym_Free_C 1
#include <stdlib.h>
#include \"FMI/fmiImport.h\"
void Modelica_0IK4_0TEKNIKER_DCOL_Generation_SensibleStorages_FMI_Buffer_0Dym_fmiFreeModelInstance2(void*m) {
  struct dy_Extended*a=m;
  if (a) {
    a->dyFmiTerminateSlave(a->m);
    a->dyFmiFreeSlaveInstance(a->m);
    FreeLibrary(a->hInst);
    free(a);
  }
}
#endif", Library="Modelica_0IK4_0TEKNIKER_DCOL_Generation_SensibleStorages_FMI_Buffer_0Dym", LibraryDirectory="modelica://DCOL/Resources/Library/FMU/Buffer_FMU/binaries",           __Dymola_CriticalRegion="Modelica_0IK4_0TEKNIKER_DCOL_Generation_SensibleStorages_FMI_Buffer_0Dym");
    end destructor;
  end fmiModel;

    function fmiInitializeSlave
      input fmiModel fmi;
      input Real tStart;
      input Boolean forceShutDownAtTStop;
       input Real tStop;
      input Real preAvailable;
      output Real postAvailable=preAvailable;
      external"C" Modelica_0IK4_0TEKNIKER_DCOL_Generation_SensibleStorages_FMI_Buffer_0Dym_fmiInitializeSlave2(fmi, tStart, forceShutDownAtTStop, tStop);
      annotation (Header="
#ifndef Modelica_0IK4_0TEKNIKER_DCOL_Generation_SensibleStorages_FMI_Buffer_0Dym_InitializeSlave_C
#define Modelica_0IK4_0TEKNIKER_DCOL_Generation_SensibleStorages_FMI_Buffer_0Dym_InitializeSlave_C 1
#include <stdlib.h>
#include \"FMI/fmiImport.h\"
double Modelica_0IK4_0TEKNIKER_DCOL_Generation_SensibleStorages_FMI_Buffer_0Dym_fmiInitializeSlave2(void*m, fmiReal tStart, fmiBoolean forceShutDownAtTStop, fmiReal tStop) {
  struct dy_Extended*a=m;
  fmiStatus status=fmiFatal;
  if (a) {
    status=a->dyFmiInitializeSlave(a->m, tStart, forceShutDownAtTStop, tStop);
    a->dyTriggered=0;
    a->dyLastTime=a->dyTime;
  }
  if (status!=fmiOK && status!=fmiWarning) ModelicaError(\"InitializeSlave failed\");
  return 1e37;
}
#endif", Library="Modelica_0IK4_0TEKNIKER_DCOL_Generation_SensibleStorages_FMI_Buffer_0Dym", LibraryDirectory="modelica://DCOL/Resources/Library/FMU/Buffer_FMU/binaries",           __Dymola_CriticalRegion="Modelica_0IK4_0TEKNIKER_DCOL_Generation_SensibleStorages_FMI_Buffer_0Dym");
    end fmiInitializeSlave;

    function fmiDoStep
     input fmiModel fmi;
     input Real currentTime;
     input Real stepSize;
     output Boolean stepOK;
     external"C" stepOK= Modelica_0IK4_0TEKNIKER_DCOL_Generation_SensibleStorages_FMI_Buffer_0Dym_fmiDoStep2(fmi, currentTime, stepSize);
     annotation (Header="
#ifndef Modelica_0IK4_0TEKNIKER_DCOL_Generation_SensibleStorages_FMI_Buffer_0Dym_DoStep_C
#define Modelica_0IK4_0TEKNIKER_DCOL_Generation_SensibleStorages_FMI_Buffer_0Dym_DoStep_C 1
#include <stdlib.h>
#include \"FMI/fmiImport.h\"
double Modelica_0IK4_0TEKNIKER_DCOL_Generation_SensibleStorages_FMI_Buffer_0Dym_fmiDoStep2(void*m, double currentTime, double stepSize) {
  struct dy_Extended*a=m;
  fmiStatus status=fmiFatal;
  if (a) {
    status=a->dyFmiDoStep(a->m, currentTime, stepSize, fmiTrue);
  }
  if (status!=fmiOK && status!=fmiWarning) ModelicaError(\"DoStep failed\");
  return 1.0;
}
#endif", Library="Modelica_0IK4_0TEKNIKER_DCOL_Generation_SensibleStorages_FMI_Buffer_0Dym", LibraryDirectory="modelica://DCOL/Resources/Library/FMU/Buffer_FMU/binaries",           __Dymola_CriticalRegion="Modelica_0IK4_0TEKNIKER_DCOL_Generation_SensibleStorages_FMI_Buffer_0Dym");
    end fmiDoStep;

    function fmiResetSlave
      input fmiModel fmi;
      output Boolean resetOK;
      external"C" resetOK = Modelica_0IK4_0TEKNIKER_DCOL_Generation_SensibleStorages_FMI_Buffer_0Dym_fmiResetSlave2(fmi);
      annotation (Header="
#ifndef Modelica_0IK4_0TEKNIKER_DCOL_Generation_SensibleStorages_FMI_Buffer_0Dym_ResetSlave_C
#define Modelica_0IK4_0TEKNIKER_DCOL_Generation_SensibleStorages_FMI_Buffer_0Dym_ResetSlave_C 1
#include <stdlib.h>
#include \"FMI/fmiImport.h\"
double Modelica_0IK4_0TEKNIKER_DCOL_Generation_SensibleStorages_FMI_Buffer_0Dym_fmiResetSlave2(void*m) {
  struct dy_Extended*a=m;
  fmiStatus status=fmiFatal;
  if (a) {
    status=a->dyFmiResetSlave(a->m);
  }
  if (status!=fmiOK && status!=fmiWarning) ModelicaError(\"resetSlave failed\");
    return 1.0;
  }
#endif", Library="Modelica_0IK4_0TEKNIKER_DCOL_Generation_SensibleStorages_FMI_Buffer_0Dym", LibraryDirectory="modelica://DCOL/Resources/Library/FMU/Buffer_FMU/binaries",           __Dymola_CriticalRegion="Modelica_0IK4_0TEKNIKER_DCOL_Generation_SensibleStorages_FMI_Buffer_0Dym");
    end fmiResetSlave;

    function fmiSetReal
      input fmiModel fmi;
      input Integer refs[:];
      input Real vals[size(refs, 1)];
      output Real dummy= 1;
      external"C"
                 Modelica_0IK4_0TEKNIKER_DCOL_Generation_SensibleStorages_FMI_Buffer_0Dym_fmiSetReal2(
        fmi,
        refs,
        size(refs, 1),
        vals);
        annotation (Header="
#ifndef Modelica_0IK4_0TEKNIKER_DCOL_Generation_SensibleStorages_FMI_Buffer_0Dym_SetReal_C
#define Modelica_0IK4_0TEKNIKER_DCOL_Generation_SensibleStorages_FMI_Buffer_0Dym_SetReal_C 1
#include <stdlib.h>
#include \"FMI/fmiImport.h\"
void Modelica_0IK4_0TEKNIKER_DCOL_Generation_SensibleStorages_FMI_Buffer_0Dym_fmiSetReal2(void*m, const int*refs, size_t nrefs, const double*vals) {
  struct dy_Extended*a=m;
  fmiStatus status=fmiFatal;
  if(!nrefs){return;}
  if (a) {
    status=a->dyFmiSetReal(a->m, refs, nrefs, vals);
  }
  if (status!=fmiOK && status!=fmiWarning) ModelicaError(\"SetReal failed\");
}
#endif", Library="Modelica_0IK4_0TEKNIKER_DCOL_Generation_SensibleStorages_FMI_Buffer_0Dym", LibraryDirectory="modelica://DCOL/Resources/Library/FMU/Buffer_FMU/binaries",           __Dymola_CriticalRegion="Modelica_0IK4_0TEKNIKER_DCOL_Generation_SensibleStorages_FMI_Buffer_0Dym",__Dymola_IdemPotent=true, __Dymola_VectorizedExceptFirst=true);
    end fmiSetReal;

    function fmiSetRealParam
      input fmiModel fmi;
      input Integer refs[:];
      input Real vals[size(refs, 1)];
    protected
      Real oldVals[size(refs, 1)];
      external"C"
                 Modelica_0IK4_0TEKNIKER_DCOL_Generation_SensibleStorages_FMI_Buffer_0Dym_fmiSetRealParam2(
        fmi,
        refs,
        size(refs, 1),
        vals,
        oldVals);
        annotation (Header="
#ifndef Modelica_0IK4_0TEKNIKER_DCOL_Generation_SensibleStorages_FMI_Buffer_0Dym_SetRealParam_C
#define Modelica_0IK4_0TEKNIKER_DCOL_Generation_SensibleStorages_FMI_Buffer_0Dym_SetRealParam_C 1
#include <stdlib.h>
#include \"FMI/fmiImport.h\"
void Modelica_0IK4_0TEKNIKER_DCOL_Generation_SensibleStorages_FMI_Buffer_0Dym_fmiSetRealParam2(void*m, const int*refs, size_t nrefs, const double*vals, double*oldVals) {
  struct dy_Extended*a=m;
  fmiStatus status=fmiFatal;
  int i = 0;
  if(!nrefs){return;}
  if (a) {
    if(a->currentMode == dyInstantiationMode){
                status=a->dyFmiSetReal(a->m, refs, nrefs, vals);
    }else{
      status=a->dyFmiGetReal(a->m, refs, nrefs, oldVals);
      for(i=0; i<nrefs;++i){
        if( abs(vals[i]-oldVals[i])> 5e-16){
          ModelicaError(\"SetRealParameter: new parameters with diferent values are being set after initialization, this is not allowed\");
        }
      }
    }
  }
  if (status!=fmiOK && status!=fmiWarning) ModelicaError(\"SetReal failed\");
}
#endif", Library="Modelica_0IK4_0TEKNIKER_DCOL_Generation_SensibleStorages_FMI_Buffer_0Dym", LibraryDirectory="modelica://DCOL/Resources/Library/FMU/Buffer_FMU/binaries",           __Dymola_CriticalRegion="Modelica_0IK4_0TEKNIKER_DCOL_Generation_SensibleStorages_FMI_Buffer_0Dym",__Dymola_IdemPotent=true, __Dymola_VectorizedExceptFirst=true);
    end fmiSetRealParam;

    function fmiGetRealScalar
      input fmiModel fmi;
      input Integer ref;
      input Real dummy;
      output Real val;
    algorithm
        val := scalar(fmiGetReal(fmi, {ref}, dummy));
    end fmiGetRealScalar;

    function fmiGetReal
      input fmiModel fmi;
      input Integer refs[:];
      output Real vals[size(refs, 1)];
      input Real preAvailable;
      external"C" Modelica_0IK4_0TEKNIKER_DCOL_Generation_SensibleStorages_FMI_Buffer_0Dym_fmiGetReal2(
        fmi,
        refs,
        size(refs, 1),
        vals);
      annotation (Header="
#ifndef Modelica_0IK4_0TEKNIKER_DCOL_Generation_SensibleStorages_FMI_Buffer_0Dym_GetReal_C
#define Modelica_0IK4_0TEKNIKER_DCOL_Generation_SensibleStorages_FMI_Buffer_0Dym_GetReal_C 1
#include <stdlib.h>
#include \"FMI/fmiImport.h\"
void Modelica_0IK4_0TEKNIKER_DCOL_Generation_SensibleStorages_FMI_Buffer_0Dym_fmiGetReal2(void*m, const int*refs, size_t nrefs, double*vals) {
  struct dy_Extended*a=m;
  fmiStatus status=fmiFatal;
  if (a) {
    status=a->dyFmiGetReal(a->m, refs, nrefs, vals);
  }
  if (status!=fmiOK && status!=fmiWarning) ModelicaError(\"GetReal failed\");
}
#endif", Library="Modelica_0IK4_0TEKNIKER_DCOL_Generation_SensibleStorages_FMI_Buffer_0Dym", LibraryDirectory="modelica://DCOL/Resources/Library/FMU/Buffer_FMU/binaries",           __Dymola_CriticalRegion="Modelica_0IK4_0TEKNIKER_DCOL_Generation_SensibleStorages_FMI_Buffer_0Dym");
    end fmiGetReal;

    function fmiGetIntegerScalar
      input fmiModel fmi;
      input Integer ref;
      input Integer dummy;
      output Integer val;
    algorithm
        val := scalar(fmiGetInteger(fmi, {ref}, dummy));
    end fmiGetIntegerScalar;

    function fmiGetInteger
      input fmiModel fmi;
      input Integer refs[:];
      output Integer vals[size(refs, 1)];
      input Integer preAvailable;
      external"C" Modelica_0IK4_0TEKNIKER_DCOL_Generation_SensibleStorages_FMI_Buffer_0Dym_fmiGetInteger2(
        fmi,
        refs,
        size(refs, 1),
        vals);
      annotation (Header="
#ifndef Modelica_0IK4_0TEKNIKER_DCOL_Generation_SensibleStorages_FMI_Buffer_0Dym_GetInteger_C
#define Modelica_0IK4_0TEKNIKER_DCOL_Generation_SensibleStorages_FMI_Buffer_0Dym_GetInteger_C 1
#include <stdlib.h>
#include \"FMI/fmiImport.h\"
void Modelica_0IK4_0TEKNIKER_DCOL_Generation_SensibleStorages_FMI_Buffer_0Dym_fmiGetInteger2(void*m, const int*refs, size_t nrefs, int*vals) {
  struct dy_Extended*a=m;
  fmiStatus status=fmiFatal;
  if (a) {
    status=a->dyFmiGetInteger(a->m, refs, nrefs, vals);
  }
  if (status!=fmiOK && status!=fmiWarning) ModelicaError(\"GetInteger failed\");
}
#endif", Library="Modelica_0IK4_0TEKNIKER_DCOL_Generation_SensibleStorages_FMI_Buffer_0Dym", LibraryDirectory="modelica://DCOL/Resources/Library/FMU/Buffer_FMU/binaries",           __Dymola_CriticalRegion="Modelica_0IK4_0TEKNIKER_DCOL_Generation_SensibleStorages_FMI_Buffer_0Dym");
    end fmiGetInteger;

    function fmiSetInteger
    input fmiModel fmi;
      input Integer refs[:];
      input Integer vals[size(refs, 1)];
      output Real dummy= 1;
      external"C" Modelica_0IK4_0TEKNIKER_DCOL_Generation_SensibleStorages_FMI_Buffer_0Dym_fmiSetInteger2(
        fmi,
        refs,
        size(refs, 1),
        vals);
        annotation (Header="
#ifndef Modelica_0IK4_0TEKNIKER_DCOL_Generation_SensibleStorages_FMI_Buffer_0Dym_SetInteger_C
#define Modelica_0IK4_0TEKNIKER_DCOL_Generation_SensibleStorages_FMI_Buffer_0Dym_SetInteger_C 1
#include <stdlib.h>
#include \"FMI/fmiImport.h\"
void Modelica_0IK4_0TEKNIKER_DCOL_Generation_SensibleStorages_FMI_Buffer_0Dym_fmiSetInteger2(void*m, const int*refs, size_t nrefs, int*vals) {
  struct dy_Extended*a=m;
  fmiStatus status=fmiFatal;
  if(!nrefs){return;}
  if (a) {
    status=a->dyFmiSetInteger(a->m, refs, nrefs, vals);
  }
  if (status!=fmiOK && status!=fmiWarning) ModelicaError(\"SetInteger failed\");
}
#endif", Library="Modelica_0IK4_0TEKNIKER_DCOL_Generation_SensibleStorages_FMI_Buffer_0Dym", LibraryDirectory="modelica://DCOL/Resources/Library/FMU/Buffer_FMU/binaries",           __Dymola_CriticalRegion="Modelica_0IK4_0TEKNIKER_DCOL_Generation_SensibleStorages_FMI_Buffer_0Dym",__Dymola_IdemPotent=true, __Dymola_VectorizedExceptFirst=true);
    end fmiSetInteger;

    function fmiSetIntegerParam
    input fmiModel fmi;
      input Integer refs[:];
      input Integer vals[size(refs, 1)];
    protected
      Integer oldVals[size(refs, 1)];
      external"C" Modelica_0IK4_0TEKNIKER_DCOL_Generation_SensibleStorages_FMI_Buffer_0Dym_fmiSetIntegerParam2(
        fmi,
        refs,
        size(refs, 1),
        vals,
        oldVals);
        annotation (Header="
#ifndef Modelica_0IK4_0TEKNIKER_DCOL_Generation_SensibleStorages_FMI_Buffer_0Dym_SetIntegerParam_C
#define Modelica_0IK4_0TEKNIKER_DCOL_Generation_SensibleStorages_FMI_Buffer_0Dym_SetIntegerParam_C 1
#include <stdlib.h>
#include \"FMI/fmiImport.h\"
void Modelica_0IK4_0TEKNIKER_DCOL_Generation_SensibleStorages_FMI_Buffer_0Dym_fmiSetIntegerParam2(void*m, const int*refs, size_t nrefs, int*vals, int*oldVals) {
  struct dy_Extended*a=m;
  fmiStatus status=fmiFatal;
  int i=0;
  if(!nrefs){return;}
  if (a) {
    if(a->currentMode == dyInstantiationMode){
      status=a->dyFmiSetInteger(a->m, refs, nrefs, vals);
    }else{
      status=a->dyFmiGetInteger(a->m, refs, nrefs, oldVals);
      for(i = 0; i< nrefs; ++i){
        if(vals[i]!=oldVals[i]){
          ModelicaError(\"SetIntegerParameter: new parameters with diferent values are being set after initialization, this is not allowed\");
        }
      }
    }
  }
  if (status!=fmiOK && status!=fmiWarning) ModelicaError(\"SetInteger failed\");
}
#endif", Library="Modelica_0IK4_0TEKNIKER_DCOL_Generation_SensibleStorages_FMI_Buffer_0Dym", LibraryDirectory="modelica://DCOL/Resources/Library/FMU/Buffer_FMU/binaries",           __Dymola_CriticalRegion="Modelica_0IK4_0TEKNIKER_DCOL_Generation_SensibleStorages_FMI_Buffer_0Dym",__Dymola_IdemPotent=true, __Dymola_VectorizedExceptFirst=true);
    end fmiSetIntegerParam;

    function fmiGetBooleanScalar
      input fmiModel fmi;
      input Integer ref;
      input Integer dummy;
      output Boolean val;
    algorithm
        val := scalar(fmiGetBoolean(fmi, {ref}, dummy));
    end fmiGetBooleanScalar;

    function fmiGetBoolean
      input fmiModel fmi;
      input Integer refs[:];
      output Boolean vals[size(refs, 1)];
      input Integer preAvailable;
      external"C" Modelica_0IK4_0TEKNIKER_DCOL_Generation_SensibleStorages_FMI_Buffer_0Dym_fmiGetBoolean2(
        fmi,
        refs,
        size(refs, 1),
        vals);
        annotation (Header="
#ifndef Modelica_0IK4_0TEKNIKER_DCOL_Generation_SensibleStorages_FMI_Buffer_0Dym_GetBoolean_C
#define Modelica_0IK4_0TEKNIKER_DCOL_Generation_SensibleStorages_FMI_Buffer_0Dym_GetBoolean_C 1
#include \"FMI/fmiImport.h\"
void Modelica_0IK4_0TEKNIKER_DCOL_Generation_SensibleStorages_FMI_Buffer_0Dym_fmiGetBoolean2(void*m, const int* refs, size_t nr, int* vals) {
  int i;
  struct dy_Extended*a=m;
  fmiStatus status=fmiFatal;
  if (a) {
    status=a->dyFmiGetBoolean(a->m, refs, nr, (fmiBoolean*)(vals));
  }
  if (status!=fmiOK && status!=fmiWarning) ModelicaError(\"GetBoolean failed\");
  for(i=nr-1;i>=0;i--) vals[i]=((fmiBoolean*)(vals))[i];
}
#endif", Library="Modelica_0IK4_0TEKNIKER_DCOL_Generation_SensibleStorages_FMI_Buffer_0Dym", LibraryDirectory="modelica://DCOL/Resources/Library/FMU/Buffer_FMU/binaries",           __Dymola_CriticalRegion="Modelica_0IK4_0TEKNIKER_DCOL_Generation_SensibleStorages_FMI_Buffer_0Dym");
    end fmiGetBoolean;

    function fmiSetBoolean
      input fmiModel fmi;
      input Integer refs[:];
      input Boolean vals[size(refs, 1)];
      output Real dummy2= 1;
    protected
      Boolean dummy[size(refs, 1)];
      external"C" Modelica_0IK4_0TEKNIKER_DCOL_Generation_SensibleStorages_FMI_Buffer_0Dym_fmiSetBoolean2(
        fmi,
        refs,
        size(refs, 1),
        vals,
        dummy);
        annotation (Header="
#ifndef Modelica_0IK4_0TEKNIKER_DCOL_Generation_SensibleStorages_FMI_Buffer_0Dym_SetBoolean_C
#define Modelica_0IK4_0TEKNIKER_DCOL_Generation_SensibleStorages_FMI_Buffer_0Dym_SetBoolean_C 1
#include \"FMI/fmiImport.h\"
void Modelica_0IK4_0TEKNIKER_DCOL_Generation_SensibleStorages_FMI_Buffer_0Dym_fmiSetBoolean2(void*m, const int* refs, size_t nr, const int* vals,int*dummy) {
  int i;
  struct dy_Extended*a=m;
  fmiStatus status=fmiFatal;
  if(!nr){return;}
  for(i=0;i<nr;++i) ((fmiBoolean*)(dummy))[i]=vals[i];
  if (a) {
    status=a->dyFmiSetBoolean(a->m, refs, nr, (fmiBoolean*)(dummy));
  }
  if (status!=fmiOK && status!=fmiWarning) ModelicaError(\"SetBoolean failed\");
}
#endif", Library="Modelica_0IK4_0TEKNIKER_DCOL_Generation_SensibleStorages_FMI_Buffer_0Dym", LibraryDirectory="modelica://DCOL/Resources/Library/FMU/Buffer_FMU/binaries",           __Dymola_CriticalRegion="Modelica_0IK4_0TEKNIKER_DCOL_Generation_SensibleStorages_FMI_Buffer_0Dym",__Dymola_IdemPotent=true, __Dymola_VectorizedExceptFirst=true);
    end fmiSetBoolean;

    function fmiSetBooleanParam
      input fmiModel fmi;
      input Integer refs[:];
      input Boolean vals[size(refs, 1)];
    protected
      Boolean dummy[size(refs, 1)];
      Boolean oldVals[size(refs, 1)];
      external"C" Modelica_0IK4_0TEKNIKER_DCOL_Generation_SensibleStorages_FMI_Buffer_0Dym_fmiSetBooleanParam2(
      fmi,
        refs,
        size(refs, 1),
        vals,
        dummy,
        oldVals);
        annotation (Header="
#ifndef Modelica_0IK4_0TEKNIKER_DCOL_Generation_SensibleStorages_FMI_Buffer_0Dym_SetBooleanParam_C
#define Modelica_0IK4_0TEKNIKER_DCOL_Generation_SensibleStorages_FMI_Buffer_0Dym_SetBooleanParam_C 1
#include \"FMI/fmiImport.h\"
void Modelica_0IK4_0TEKNIKER_DCOL_Generation_SensibleStorages_FMI_Buffer_0Dym_fmiSetBooleanParam2(void*m, const int* refs, size_t nr, const int* vals,int*dummy,int*oldVals) {
  int i;
  struct dy_Extended*a=m;
  fmiStatus status=fmiFatal;
  if(!nr){return;}
  for(i=0;i<nr;++i) ((fmiBoolean*)(dummy))[i]=vals[i];
  if (a) {
    if(a->currentMode == dyInstantiationMode){
      status=a->dyFmiSetBoolean(a->m, refs, nr, (fmiBoolean*)(dummy));
    }else{
      status=a->dyFmiGetBoolean(a->m, refs, nr, (fmiBoolean*)(oldVals));
      for(i=nr-1;i>=0;i--){
        oldVals[i]=((fmiBoolean*)(oldVals))[i];
        if(oldVals[i]!=dummy[i]){
          ModelicaError(\"SetIntegerParameter: new parameters with diferent values are being set after initialization, this is not allowed\");
        }
      }
    }
  }
  if (status!=fmiOK && status!=fmiWarning) ModelicaError(\"SetBoolean failed\");
}
#endif", Library="Modelica_0IK4_0TEKNIKER_DCOL_Generation_SensibleStorages_FMI_Buffer_0Dym", LibraryDirectory="modelica://DCOL/Resources/Library/FMU/Buffer_FMU/binaries",           __Dymola_CriticalRegion="Modelica_0IK4_0TEKNIKER_DCOL_Generation_SensibleStorages_FMI_Buffer_0Dym",__Dymola_IdemPotent=true, __Dymola_VectorizedExceptFirst=true);
    end fmiSetBooleanParam;

    function fmiGetString
      input fmiModel fmi;
      input Integer refs[:];
      output String vals[size(refs, 1)];
      input Integer preAvailable;
      external"C" Modelica_0IK4_0TEKNIKER_DCOL_Generation_SensibleStorages_FMI_Buffer_0Dym_fmiGetString2(
        fmi,
        refs,
        size(refs, 1),
        vals);
      annotation (Header="
#ifndef Modelica_0IK4_0TEKNIKER_DCOL_Generation_SensibleStorages_FMI_Buffer_0Dym_GetString_C
#define Modelica_0IK4_0TEKNIKER_DCOL_Generation_SensibleStorages_FMI_Buffer_0Dym_GetString_C 1
#include <stdlib.h>
#include \"FMI/fmiImport.h\"
void Modelica_0IK4_0TEKNIKER_DCOL_Generation_SensibleStorages_FMI_Buffer_0Dym_fmiGetString2(void*m, const int*refs, size_t nrefs, fmiString* vals) {
  struct dy_Extended*a=m;
  fmiStatus status=fmiFatal;
  if (a) {
    status=a->dyFmiGetString(a->m, refs, nrefs, vals);
  }
  if (status!=fmiOK && status!=fmiWarning) ModelicaError(\"StringInteger failed\");
}
#endif", Library="Modelica_0IK4_0TEKNIKER_DCOL_Generation_SensibleStorages_FMI_Buffer_0Dym", LibraryDirectory="modelica://DCOL/Resources/Library/FMU/Buffer_FMU/binaries",           __Dymola_CriticalRegion="Modelica_0IK4_0TEKNIKER_DCOL_Generation_SensibleStorages_FMI_Buffer_0Dym");
    end fmiGetString;

    function fmiSetString
    input fmiModel fmi;
      input Integer refs[:];
      input String vals[size(refs, 1)];
      external"C" Modelica_0IK4_0TEKNIKER_DCOL_Generation_SensibleStorages_FMI_Buffer_0Dym_fmiSetString2(
        fmi,
        refs,
        size(refs, 1),
        vals);
        annotation (Header="
#ifndef Modelica_0IK4_0TEKNIKER_DCOL_Generation_SensibleStorages_FMI_Buffer_0Dym_SetString_C
#define Modelica_0IK4_0TEKNIKER_DCOL_Generation_SensibleStorages_FMI_Buffer_0Dym_SetString_C 1
#include \"FMI/fmiImport.h\"
#include <stdlib.h>
void Modelica_0IK4_0TEKNIKER_DCOL_Generation_SensibleStorages_FMI_Buffer_0Dym_fmiSetString2(void*m, const int*refs, size_t nrefs, const fmiString vals[]) {
  struct dy_Extended*a=m;
  fmiStatus status=fmiFatal;
  if(!nrefs){return;}
  if (a) {
    status=a->dyFmiSetString(a->m, refs, nrefs, vals);
  }
  if (status!=fmiOK && status!=fmiWarning) ModelicaError(\"SetString failed\");
}
#endif", Library="Modelica_0IK4_0TEKNIKER_DCOL_Generation_SensibleStorages_FMI_Buffer_0Dym", LibraryDirectory="modelica://DCOL/Resources/Library/FMU/Buffer_FMU/binaries",           __Dymola_CriticalRegion="Modelica_0IK4_0TEKNIKER_DCOL_Generation_SensibleStorages_FMI_Buffer_0Dym",__Dymola_IdemPotent=true, __Dymola_VectorizedExceptFirst=true);
    end fmiSetString;

    function fmiSetStringParam
    input fmiModel fmi;
      input Integer refs[:];
      input String vals[size(refs, 1)];
      external"C" Modelica_0IK4_0TEKNIKER_DCOL_Generation_SensibleStorages_FMI_Buffer_0Dym_fmiSetStringParam2(
        fmi,
        refs,
        size(refs, 1),
        vals);
        annotation (Header="
#ifndef Modelica_0IK4_0TEKNIKER_DCOL_Generation_SensibleStorages_FMI_Buffer_0Dym_SetStringParam_C
#define Modelica_0IK4_0TEKNIKER_DCOL_Generation_SensibleStorages_FMI_Buffer_0Dym_SetStringParam_C 1
#include \"FMI/fmiImport.h\"
#include <stdlib.h>
void Modelica_0IK4_0TEKNIKER_DCOL_Generation_SensibleStorages_FMI_Buffer_0Dym_fmiSetStringParam2(void*m, const int*refs, size_t nrefs, const fmiString vals[]) {
  struct dy_Extended*a=m;
  fmiStatus status=fmiFatal;
  if(!nrefs){return;}
  if (a) {
    if(a->currentMode == dyInstantiationMode){
                status=a->dyFmiSetString(a->m, refs, nrefs, vals);
    }else{
      status=fmiOK;
    }
  }
  if (status!=fmiOK && status!=fmiWarning) ModelicaError(\"SetString failed\");
}
#endif", Library="Modelica_0IK4_0TEKNIKER_DCOL_Generation_SensibleStorages_FMI_Buffer_0Dym", LibraryDirectory="modelica://DCOL/Resources/Library/FMU/Buffer_FMU/binaries",           __Dymola_CriticalRegion="Modelica_0IK4_0TEKNIKER_DCOL_Generation_SensibleStorages_FMI_Buffer_0Dym",__Dymola_IdemPotent=true, __Dymola_VectorizedExceptFirst=true);
    end fmiSetStringParam;

    function noHysteresis
      input Real x;
      output Real y;
    algorithm
      y:=x+(if (x < 0) then -1 else 1);
    end noHysteresis;
end fmi_Functions;
equation
  when initial() then
    fmi = fmi_Functions.fmiModel(fmi_instanceName, fmi_loggingOn, fmi_fmuLocation);
  end when;
algorithm
  when {initial(), sample(fmi_StartTime, fmi_CommunicationStepSize)} then
    if time>=fmi_CommunicationStepSize +fmi_StartTime then
    if fmi_InputTime then
      fmi_Functions.fmiSetReal(fmi, {352321536}, {_massFlow_old});
    else
      if fmi_UsePreOnInputSignals then
        fmi_Functions.fmiSetReal(fmi, {352321536}, {pre(massFlow)});
      else
        fmi_Functions.fmiSetReal(fmi, {352321536}, {massFlow});
      end if;
    end if;
    if fmi_InputTime then
      fmi_Functions.fmiSetReal(fmi, {352321537}, {_impulsion_T_old});
    else
      if fmi_UsePreOnInputSignals then
        fmi_Functions.fmiSetReal(fmi, {352321537}, {pre(impulsion_T)});
      else
        fmi_Functions.fmiSetReal(fmi, {352321537}, {impulsion_T});
      end if;
    end if;
    if fmi_InputTime then
      fmi_Functions.fmiSetReal(fmi, {352321538}, {_return_T_old});
    else
      if fmi_UsePreOnInputSignals then
        fmi_Functions.fmiSetReal(fmi, {352321538}, {pre(return_T)});
      else
        fmi_Functions.fmiSetReal(fmi, {352321538}, {return_T});
      end if;
    end if;
    if fmi_InputTime then
      fmi_Functions.fmiSetReal(fmi, {352321539}, {_ambient_T_old});
    else
      if fmi_UsePreOnInputSignals then
        fmi_Functions.fmiSetReal(fmi, {352321539}, {pre(ambient_T)});
      else
        fmi_Functions.fmiSetReal(fmi, {352321539}, {ambient_T});
      end if;
    end if;
      for stepSizeIndex in 1:stepSizeScaleFactor loop
        fmi_StepOK :=fmi_Functions.fmiDoStep(
          fmi,
          time + (stepSizeIndex - 1 - stepSizeScaleFactor)*
            fmi_CommunicationStepSize/stepSizeScaleFactor,
          fmi_CommunicationStepSize/stepSizeScaleFactor);
      end for;
    end if;
    _massFlow_old := massFlow;
    _impulsion_T_old := impulsion_T;
    _return_T_old := return_T;
    _ambient_T_old := ambient_T;
  m_impulsion_T :=fmi_Functions.fmiGetRealScalar(
      fmi,
      335544320,
      1);
  m_return_T :=fmi_Functions.fmiGetRealScalar(
      fmi,
      335544321,
      1);
  heatLosses :=fmi_Functions.fmiGetRealScalar(
      fmi,
      335544322,
      1);
RealVariables1 :=fmi_Functions.fmiGetReal(
      fmi,
      {352321536,369098837,369098839,100663477,369098837,33554432,587202560,
        905969763,637534308,33554432,905969770,905969772,637534317,637534321,
        637534322,352321536,369098837,369098837,369098837,637534333,637534335,
        33554432,637534322,33554432,637534322,33554432,33554432,637534322,
        100663592,637534424,33554433,587202561,905969860,637534405,33554433,
        905969867,905969869,637534414,637534418,637534419,637534424,352321536,
        637534424,637534424,637534424,637534434,637534435,33554433,637534419,
        33554433,637534419,33554433,33554433,637534419,100663707,637534539,
        33554434,587202562,905969975,637534520,33554434,905969982,905969984,
        637534529,637534533,637534534,637534539,352321536,637534539,637534539,
        637534539,637534549,637534550,33554434,637534534,33554434,637534534,
        33554434,33554434,637534534,100663804,369098839,33554435,587202563,
        905970090,637534635,33554435,905970097,905970099,637534644,637534648,
        637534649,369098839,369098839,352321536,369098839,637534661,637534662,
        33554435,637534649},
      1);
RealVariables2 :=fmi_Functions.fmiGetReal(
      fmi,
      {33554435,637534649,33554435,33554435,637534649,369099264,369099265,
        33554432,369099264,369099266,369099415,369099267,369099268,369099269,
        369099440,369099272,33554435,369099440,369099273,369099416,369099274,
        369099275,369099276,369099441,369099279,33554433,369099441,369099280,
        369099417,369099281,369099282,369099283,369099442,369099286,33554434,
        369099442,369099287,369099418,369099288,369099289,369099290,369099443,
        369099293,33554432,369099443,369099294,369099419,369099295,369099296,
        369099297,369099300,369099301,33554435,369099300,369099302,369099303,
        369099304,369099305,369099306,369099264,369099309,369099266,369099264,
        352321539,369099415,369099311,369099312,369099313,369099314,369099315,
        369099316,369099317,369099318,369099320,369099322,369099440,369099327,
        369099273,369099440,352321539,369099416,369099329,369099330,369099333,
        369099334,369099335,369099336,369099337,369099338,369099339,369099340,
        369099341,369099342,369099441,369099343,369099280,369099441,352321539,
        369099417,369099345},
      1);
RealVariables3 :=fmi_Functions.fmiGetReal(
      fmi,
      {369099346,369099349,369099350,369099351,369099352,369099353,369099354,
        369099355,369099356,369099357,369099358,369099442,369099359,369099287,
        369099442,352321539,369099418,369099361,369099362,369099365,369099366,
        369099367,369099368,369099369,369099370,369099371,369099372,369099373,
        369099374,369099443,369099375,369099294,369099443,352321539,369099419,
        369099377,369099378,369099381,369099382,369099383,369099384,369099385,
        369099386,369099387,369099388,369099389,369099390,369099300,369099391,
        369099302,369099300,352321539,369099303,369099393,369099394,369099395,
        369099396,369099397,369099398,369099399,369099400,369099401,369099402,
        369099403,369099404,637534862,637534863,33554435,637534862,33554433,
        637534864,100663361,637534865,637534866,33554433,637534865,33554434,
        637534867,100663362,637534868,637534869,33554434,637534868,33554432,
        637534870,100663363,369099264,352321539,369099264,352321539,369099415,
        369099440,352321539,369099440,352321539,369099416,369099441,352321539,
        369099441,352321539},
      1);
RealVariables4 :=fmi_Functions.fmiGetReal(
      fmi,
      {369099417,369099442,352321539,369099442,352321539,369099418,369099443,
        352321539,369099443,352321539,369099419,369099300,352321539,369099300,
        352321539,369099303,335544322,352321539,905970332,637534884,637534885,
        637534886,637534887,637534888,637534889,33554435,637534890,33554433,
        637534891,33554434,637534892,33554432,637534889,352321539,905970357,
        352321539,369099459,369099508,905970362,369099508,905970368,352321536,
        369099459,369099508,369099484,369099506,905970386,369099506,905970392,
        905970394,369099484,352321536,369099506,335544320,335544321,352321536,
        369099459,369098839,352321536,352321537,369099506,352321538,369099508},
      1);
BooleanVariables :=fmi_Functions.fmiGetBoolean(
      fmi,
      {369099507,369099509,369099507,369099509,369099507},
      1);
  end when;
initial algorithm
  fmi_AParamsAndStart:=1;
 // 29 Real parameters
  fmi_Functions.fmiSetRealParam(fmi, {16777216, 16777217, 16777218, 16777219, 16777220, 16777221, 16777222, 16777223, 16777224, 16777225, 16777226, 16777227, 16777228, 16777229, 16777230, 16777232, 16777234, 16777236, 16777238, 16777240, 16777241, 16777242, 16777243, 16777244, 16777245, 16777246, 16777247, 16777257, 16777258}, {'system'.p_ambient, 'system'.T_ambient, 'system'.g, 'system'.m_flow_start, 'system'.eps_m_flow, 'system'.dp_small, 'system'.m_flow_small, d, h_max, eTank, d_Inlet, d_Outlet, h_heater, T_start, tau, closedCylindricalTank.volumeTop.'X_start[1]', closedCylindricalTank.'volumeMiddle[1]'.'X_start[1]', closedCylindricalTank.'volumeMiddle[2]'.'X_start[1]', closedCylindricalTank.volumeBottom.'X_start[1]', closedCylindricalTank.topCond.T_start, closedCylindricalTank.'middleCond[1]'.T_start, closedCylindricalTank.'middleCond[2]'.T_start, closedCylindricalTank.'middleCond[3]'.T_start, closedCylindricalTank.'middleCond[4]'.T_start, closedCylindricalTank.bottomCond.T_start, closedCylindricalTank.buoyancy.sta_default.p, closedCylindricalTank.buoyancy.sta_default.T, triggeredSampler.y_start, triggeredSampler1.y_start});
 // 0 Real start values
 // 0 Integer parameters
 // 0 Integer start values
 // 1 Boolean parameters
  fmi_Functions.fmiSetBooleanParam(fmi, {16777231}, {closedCylindricalTank.faceUpBottom});
 // 0 Boolean start values
 // 0 Enumeration parameters
 // 0 Enumeration start values
 // 0 String parameters
initial equation
if fmi_pullInputsForInitialization then fmi_initInput0 = fmi_Functions.fmiSetReal(fmi, {352321536}, {pre(massFlow)}); else fmi_initInput0 = fmi_Functions.fmiSetReal(fmi, {352321536}, {_massFlow_start}); end if;
if fmi_pullInputsForInitialization then fmi_initInput1 = fmi_Functions.fmiSetReal(fmi, {352321537}, {pre(impulsion_T)}); else fmi_initInput1 = fmi_Functions.fmiSetReal(fmi, {352321537}, {_impulsion_T_start}); end if;
if fmi_pullInputsForInitialization then fmi_initInput2 = fmi_Functions.fmiSetReal(fmi, {352321538}, {pre(return_T)}); else fmi_initInput2 = fmi_Functions.fmiSetReal(fmi, {352321538}, {_return_T_start}); end if;
if fmi_pullInputsForInitialization then fmi_initInput3 = fmi_Functions.fmiSetReal(fmi, {352321539}, {pre(ambient_T)}); else fmi_initInput3 = fmi_Functions.fmiSetReal(fmi, {352321539}, {_ambient_T_start}); end if;
  fmi_Initialized = fmi_Functions.fmiInitializeSlave(fmi, fmi_StartTime, fmi_forceShutDownAtStopTime, fmi_StopTime,fmi_AParamsAndStart+ fmi_initInput0+ fmi_initInput1+ fmi_initInput2+ fmi_initInput3);
RealDependentParameters = fmi_Functions.fmiGetReal(fmi, {100663302, 100663303, 100663305, 100663310, 100663315, 100663316, 100663331, 100663334, 100663335, 100663364, 100663365, 100663366, 100663368, 100663388, 100663390, 100663391, 100663406, 100663418, 100663419, 100663427, 100663430, 100663477, 100663478, 100663480, 100663485, 100663487, 100663488, 100663503, 100663518, 100663519, 100663528, 100663531, 100663592, 100663593, 100663595, 100663600, 100663602, 100663603, 100663618, 100663633, 100663634, 100663643, 100663646, 100663707, 100663708, 100663710, 100663715, 100663717, 100663718, 100663733, 100663745, 100663746, 100663754, 100663757, 100663804, 100663805, 100663807, 100663814, 100663815, 100663821, 100663822, 100663828, 100663829, 100663835, 100663836, 100663842, 100663843, 100663851, 100663852, 100663854, 100663867, 100663868, 100663870, 100663872, 100663875, 100663888, 100663891, 100663904, 100663907, 100663920, 100663923, 100663936, 100663949, 100663965, 100663967, 100663971, 100664048, 100664049},fmi_Initialized);
equation
  closedCylindricalTank.port_a.m_flow = RealVariables1[1];
  closedCylindricalTank.port_a.h_outflow = RealVariables1[2];
  closedCylindricalTank.port_b.h_outflow = RealVariables1[3];
  closedCylindricalTank.volumeTop.fluidVolume = RealVariables1[4];
  closedCylindricalTank.volumeTop.medium.h = RealVariables1[5];
  closedCylindricalTank.volumeTop.medium.T = RealVariables1[6];
  closedCylindricalTank.volumeTop.medium.T_der = RealVariables1[7];
  closedCylindricalTank.volumeTop.medium.u = RealVariables1[8];
  closedCylindricalTank.volumeTop.medium.u_der = RealVariables1[9];
  closedCylindricalTank.volumeTop.medium.state.T = RealVariables1[10];
  closedCylindricalTank.volumeTop.medium.T_degC = RealVariables1[11];
  closedCylindricalTank.volumeTop.U = RealVariables1[12];
  closedCylindricalTank.volumeTop.U_der = RealVariables1[13];
  closedCylindricalTank.volumeTop.Hb_flow = RealVariables1[14];
  closedCylindricalTank.volumeTop.Qb_flow = RealVariables1[15];
  closedCylindricalTank.volumeTop.'ports[1]'.m_flow = RealVariables1[16];
  closedCylindricalTank.volumeTop.'ports[1]'.h_outflow = RealVariables1[17];
  closedCylindricalTank.volumeTop.'ports[2]'.h_outflow = RealVariables1[18];
  closedCylindricalTank.volumeTop.'ports[3]'.h_outflow = RealVariables1[19];
  closedCylindricalTank.volumeTop.'ports_H_flow[1]' = RealVariables1[20];
  closedCylindricalTank.volumeTop.'ports_H_flow[3]' = RealVariables1[21];
  closedCylindricalTank.volumeTop.heatTransfer.'states[1]'.T = RealVariables1[22];
  closedCylindricalTank.volumeTop.heatTransfer.'Q_flows[1]' = RealVariables1[23];
  closedCylindricalTank.volumeTop.heatTransfer.'heatPorts[1]'.T = RealVariables1[24];
  closedCylindricalTank.volumeTop.heatTransfer.'heatPorts[1]'.Q_flow = RealVariables1[25];
  closedCylindricalTank.volumeTop.heatTransfer.'Ts[1]' = RealVariables1[26];
  closedCylindricalTank.volumeTop.heatPort.T = RealVariables1[27];
  closedCylindricalTank.volumeTop.heatPort.Q_flow = RealVariables1[28];
  closedCylindricalTank.'volumeMiddle[1]'.fluidVolume = RealVariables1[29];
  closedCylindricalTank.'volumeMiddle[1]'.medium.h = RealVariables1[30];
  closedCylindricalTank.'volumeMiddle[1]'.medium.T = RealVariables1[31];
  closedCylindricalTank.'volumeMiddle[1]'.medium.T_der = RealVariables1[32];
  closedCylindricalTank.'volumeMiddle[1]'.medium.u = RealVariables1[33];
  closedCylindricalTank.'volumeMiddle[1]'.medium.u_der = RealVariables1[34];
  closedCylindricalTank.'volumeMiddle[1]'.medium.state.T = RealVariables1[35];
  closedCylindricalTank.'volumeMiddle[1]'.medium.T_degC = RealVariables1[36];
  closedCylindricalTank.'volumeMiddle[1]'.U = RealVariables1[37];
  closedCylindricalTank.'volumeMiddle[1]'.U_der = RealVariables1[38];
  closedCylindricalTank.'volumeMiddle[1]'.Hb_flow = RealVariables1[39];
  closedCylindricalTank.'volumeMiddle[1]'.Qb_flow = RealVariables1[40];
  closedCylindricalTank.'volumeMiddle[1]'.'ports[1]'.h_outflow = RealVariables1[41];
  closedCylindricalTank.'volumeMiddle[1]'.'ports[2]'.m_flow = RealVariables1[42];
  closedCylindricalTank.'volumeMiddle[1]'.'ports[2]'.h_outflow = RealVariables1[43];
  closedCylindricalTank.'volumeMiddle[1]'.'ports[3]'.h_outflow = RealVariables1[44];
  closedCylindricalTank.'volumeMiddle[1]'.'ports[4]'.h_outflow = RealVariables1[45];
  closedCylindricalTank.'volumeMiddle[1]'.'ports_H_flow[2]' = RealVariables1[46];
  closedCylindricalTank.'volumeMiddle[1]'.'ports_H_flow[3]' = RealVariables1[47];
  closedCylindricalTank.'volumeMiddle[1]'.heatTransfer.'states[1]'.T = RealVariables1[48];
  closedCylindricalTank.'volumeMiddle[1]'.heatTransfer.'Q_flows[1]' = RealVariables1[49];
  closedCylindricalTank.'volumeMiddle[1]'.heatTransfer.'heatPorts[1]'.T = RealVariables1[50];
  closedCylindricalTank.'volumeMiddle[1]'.heatTransfer.'heatPorts[1]'.Q_flow = RealVariables1[51];
  closedCylindricalTank.'volumeMiddle[1]'.heatTransfer.'Ts[1]' = RealVariables1[52];
  closedCylindricalTank.'volumeMiddle[1]'.heatPort.T = RealVariables1[53];
  closedCylindricalTank.'volumeMiddle[1]'.heatPort.Q_flow = RealVariables1[54];
  closedCylindricalTank.'volumeMiddle[2]'.fluidVolume = RealVariables1[55];
  closedCylindricalTank.'volumeMiddle[2]'.medium.h = RealVariables1[56];
  closedCylindricalTank.'volumeMiddle[2]'.medium.T = RealVariables1[57];
  closedCylindricalTank.'volumeMiddle[2]'.medium.T_der = RealVariables1[58];
  closedCylindricalTank.'volumeMiddle[2]'.medium.u = RealVariables1[59];
  closedCylindricalTank.'volumeMiddle[2]'.medium.u_der = RealVariables1[60];
  closedCylindricalTank.'volumeMiddle[2]'.medium.state.T = RealVariables1[61];
  closedCylindricalTank.'volumeMiddle[2]'.medium.T_degC = RealVariables1[62];
  closedCylindricalTank.'volumeMiddle[2]'.U = RealVariables1[63];
  closedCylindricalTank.'volumeMiddle[2]'.U_der = RealVariables1[64];
  closedCylindricalTank.'volumeMiddle[2]'.Hb_flow = RealVariables1[65];
  closedCylindricalTank.'volumeMiddle[2]'.Qb_flow = RealVariables1[66];
  closedCylindricalTank.'volumeMiddle[2]'.'ports[1]'.h_outflow = RealVariables1[67];
  closedCylindricalTank.'volumeMiddle[2]'.'ports[2]'.m_flow = RealVariables1[68];
  closedCylindricalTank.'volumeMiddle[2]'.'ports[2]'.h_outflow = RealVariables1[69];
  closedCylindricalTank.'volumeMiddle[2]'.'ports[3]'.h_outflow = RealVariables1[70];
  closedCylindricalTank.'volumeMiddle[2]'.'ports[4]'.h_outflow = RealVariables1[71];
  closedCylindricalTank.'volumeMiddle[2]'.'ports_H_flow[2]' = RealVariables1[72];
  closedCylindricalTank.'volumeMiddle[2]'.'ports_H_flow[3]' = RealVariables1[73];
  closedCylindricalTank.'volumeMiddle[2]'.heatTransfer.'states[1]'.T = RealVariables1[74];
  closedCylindricalTank.'volumeMiddle[2]'.heatTransfer.'Q_flows[1]' = RealVariables1[75];
  closedCylindricalTank.'volumeMiddle[2]'.heatTransfer.'heatPorts[1]'.T = RealVariables1[76];
  closedCylindricalTank.'volumeMiddle[2]'.heatTransfer.'heatPorts[1]'.Q_flow = RealVariables1[77];
  closedCylindricalTank.'volumeMiddle[2]'.heatTransfer.'Ts[1]' = RealVariables1[78];
  closedCylindricalTank.'volumeMiddle[2]'.heatPort.T = RealVariables1[79];
  closedCylindricalTank.'volumeMiddle[2]'.heatPort.Q_flow = RealVariables1[80];
  closedCylindricalTank.volumeBottom.fluidVolume = RealVariables1[81];
  closedCylindricalTank.volumeBottom.medium.h = RealVariables1[82];
  closedCylindricalTank.volumeBottom.medium.T = RealVariables1[83];
  closedCylindricalTank.volumeBottom.medium.T_der = RealVariables1[84];
  closedCylindricalTank.volumeBottom.medium.u = RealVariables1[85];
  closedCylindricalTank.volumeBottom.medium.u_der = RealVariables1[86];
  closedCylindricalTank.volumeBottom.medium.state.T = RealVariables1[87];
  closedCylindricalTank.volumeBottom.medium.T_degC = RealVariables1[88];
  closedCylindricalTank.volumeBottom.U = RealVariables1[89];
  closedCylindricalTank.volumeBottom.U_der = RealVariables1[90];
  closedCylindricalTank.volumeBottom.Hb_flow = RealVariables1[91];
  closedCylindricalTank.volumeBottom.Qb_flow = RealVariables1[92];
  closedCylindricalTank.volumeBottom.'ports[1]'.h_outflow = RealVariables1[93];
  closedCylindricalTank.volumeBottom.'ports[2]'.h_outflow = RealVariables1[94];
  closedCylindricalTank.volumeBottom.'ports[3]'.m_flow = RealVariables1[95];
  closedCylindricalTank.volumeBottom.'ports[3]'.h_outflow = RealVariables1[96];
  closedCylindricalTank.volumeBottom.'ports_H_flow[2]' = RealVariables1[97];
  closedCylindricalTank.volumeBottom.'ports_H_flow[3]' = RealVariables1[98];
  closedCylindricalTank.volumeBottom.heatTransfer.'states[1]'.T = RealVariables1[99];
  closedCylindricalTank.volumeBottom.heatTransfer.'Q_flows[1]' = RealVariables1[100];
  closedCylindricalTank.volumeBottom.heatTransfer.'heatPorts[1]'.T = RealVariables2[1];
  closedCylindricalTank.volumeBottom.heatTransfer.'heatPorts[1]'.Q_flow = RealVariables2[2];
  closedCylindricalTank.volumeBottom.heatTransfer.'Ts[1]' = RealVariables2[3];
  closedCylindricalTank.volumeBottom.heatPort.T = RealVariables2[4];
  closedCylindricalTank.volumeBottom.heatPort.Q_flow = RealVariables2[5];
  closedCylindricalTank.topCond.Q_flow = RealVariables2[6];
  closedCylindricalTank.topCond.dT = RealVariables2[7];
  closedCylindricalTank.topCond.port_a.T = RealVariables2[8];
  closedCylindricalTank.topCond.port_a.Q_flow = RealVariables2[9];
  closedCylindricalTank.topCond.port_b.T = RealVariables2[10];
  closedCylindricalTank.topCond.port_b.Q_flow = RealVariables2[11];
  closedCylindricalTank.topCond.T = RealVariables2[12];
  closedCylindricalTank.topCond.G = RealVariables2[13];
  closedCylindricalTank.topCond.k = RealVariables2[14];
  closedCylindricalTank.'middleCond[1]'.Q_flow = RealVariables2[15];
  closedCylindricalTank.'middleCond[1]'.dT = RealVariables2[16];
  closedCylindricalTank.'middleCond[1]'.port_a.T = RealVariables2[17];
  closedCylindricalTank.'middleCond[1]'.port_a.Q_flow = RealVariables2[18];
  closedCylindricalTank.'middleCond[1]'.port_b.T = RealVariables2[19];
  closedCylindricalTank.'middleCond[1]'.port_b.Q_flow = RealVariables2[20];
  closedCylindricalTank.'middleCond[1]'.T = RealVariables2[21];
  closedCylindricalTank.'middleCond[1]'.G = RealVariables2[22];
  closedCylindricalTank.'middleCond[1]'.k = RealVariables2[23];
  closedCylindricalTank.'middleCond[2]'.Q_flow = RealVariables2[24];
  closedCylindricalTank.'middleCond[2]'.dT = RealVariables2[25];
  closedCylindricalTank.'middleCond[2]'.port_a.T = RealVariables2[26];
  closedCylindricalTank.'middleCond[2]'.port_a.Q_flow = RealVariables2[27];
  closedCylindricalTank.'middleCond[2]'.port_b.T = RealVariables2[28];
  closedCylindricalTank.'middleCond[2]'.port_b.Q_flow = RealVariables2[29];
  closedCylindricalTank.'middleCond[2]'.T = RealVariables2[30];
  closedCylindricalTank.'middleCond[2]'.G = RealVariables2[31];
  closedCylindricalTank.'middleCond[2]'.k = RealVariables2[32];
  closedCylindricalTank.'middleCond[3]'.Q_flow = RealVariables2[33];
  closedCylindricalTank.'middleCond[3]'.dT = RealVariables2[34];
  closedCylindricalTank.'middleCond[3]'.port_a.T = RealVariables2[35];
  closedCylindricalTank.'middleCond[3]'.port_a.Q_flow = RealVariables2[36];
  closedCylindricalTank.'middleCond[3]'.port_b.T = RealVariables2[37];
  closedCylindricalTank.'middleCond[3]'.port_b.Q_flow = RealVariables2[38];
  closedCylindricalTank.'middleCond[3]'.T = RealVariables2[39];
  closedCylindricalTank.'middleCond[3]'.G = RealVariables2[40];
  closedCylindricalTank.'middleCond[3]'.k = RealVariables2[41];
  closedCylindricalTank.'middleCond[4]'.Q_flow = RealVariables2[42];
  closedCylindricalTank.'middleCond[4]'.dT = RealVariables2[43];
  closedCylindricalTank.'middleCond[4]'.port_a.T = RealVariables2[44];
  closedCylindricalTank.'middleCond[4]'.port_a.Q_flow = RealVariables2[45];
  closedCylindricalTank.'middleCond[4]'.port_b.T = RealVariables2[46];
  closedCylindricalTank.'middleCond[4]'.port_b.Q_flow = RealVariables2[47];
  closedCylindricalTank.'middleCond[4]'.T = RealVariables2[48];
  closedCylindricalTank.'middleCond[4]'.G = RealVariables2[49];
  closedCylindricalTank.'middleCond[4]'.k = RealVariables2[50];
  closedCylindricalTank.bottomCond.Q_flow = RealVariables2[51];
  closedCylindricalTank.bottomCond.dT = RealVariables2[52];
  closedCylindricalTank.bottomCond.port_a.T = RealVariables2[53];
  closedCylindricalTank.bottomCond.port_a.Q_flow = RealVariables2[54];
  closedCylindricalTank.bottomCond.port_b.T = RealVariables2[55];
  closedCylindricalTank.bottomCond.port_b.Q_flow = RealVariables2[56];
  closedCylindricalTank.bottomCond.T = RealVariables2[57];
  closedCylindricalTank.bottomCond.G = RealVariables2[58];
  closedCylindricalTank.bottomCond.k = RealVariables2[59];
  closedCylindricalTank.topConv.Q_flow = RealVariables2[60];
  closedCylindricalTank.topConv.dT = RealVariables2[61];
  closedCylindricalTank.topConv.solid.T = RealVariables2[62];
  closedCylindricalTank.topConv.solid.Q_flow = RealVariables2[63];
  closedCylindricalTank.topConv.fluid.T = RealVariables2[64];
  closedCylindricalTank.topConv.fluid.Q_flow = RealVariables2[65];
  closedCylindricalTank.topConv.Gc = RealVariables2[66];
  closedCylindricalTank.topConv.h = RealVariables2[67];
  closedCylindricalTank.topConv.beta = RealVariables2[68];
  closedCylindricalTank.topConv.Gr = RealVariables2[69];
  closedCylindricalTank.topConv.Ra = RealVariables2[70];
  closedCylindricalTank.topConv.NuL = RealVariables2[71];
  closedCylindricalTank.topConv.NuLa = RealVariables2[72];
  closedCylindricalTank.topConv.NuLb = RealVariables2[73];
  closedCylindricalTank.topConv.visco = RealVariables2[74];
  closedCylindricalTank.topConv.Tc = RealVariables2[75];
  closedCylindricalTank.'middleConv[1]'.Q_flow = RealVariables2[76];
  closedCylindricalTank.'middleConv[1]'.dT = RealVariables2[77];
  closedCylindricalTank.'middleConv[1]'.solid.T = RealVariables2[78];
  closedCylindricalTank.'middleConv[1]'.solid.Q_flow = RealVariables2[79];
  closedCylindricalTank.'middleConv[1]'.fluid.T = RealVariables2[80];
  closedCylindricalTank.'middleConv[1]'.fluid.Q_flow = RealVariables2[81];
  closedCylindricalTank.'middleConv[1]'.Gc = RealVariables2[82];
  closedCylindricalTank.'middleConv[1]'.h = RealVariables2[83];
  closedCylindricalTank.'middleConv[1]'.Tm = RealVariables2[84];
  closedCylindricalTank.'middleConv[1]'.visco = RealVariables2[85];
  closedCylindricalTank.'middleConv[1]'.K = RealVariables2[86];
  closedCylindricalTank.'middleConv[1]'.Pr = RealVariables2[87];
  closedCylindricalTank.'middleConv[1]'.Ra = RealVariables2[88];
  closedCylindricalTank.'middleConv[1]'.Gr = RealVariables2[89];
  closedCylindricalTank.'middleConv[1]'.beta = RealVariables2[90];
  closedCylindricalTank.'middleConv[1]'.Nu_nat = RealVariables2[91];
  closedCylindricalTank.'middleConv[1]'.Nu_nat1 = RealVariables2[92];
  closedCylindricalTank.'middleConv[1]'.Nu_nat2 = RealVariables2[93];
  closedCylindricalTank.'middleConv[2]'.Q_flow = RealVariables2[94];
  closedCylindricalTank.'middleConv[2]'.dT = RealVariables2[95];
  closedCylindricalTank.'middleConv[2]'.solid.T = RealVariables2[96];
  closedCylindricalTank.'middleConv[2]'.solid.Q_flow = RealVariables2[97];
  closedCylindricalTank.'middleConv[2]'.fluid.T = RealVariables2[98];
  closedCylindricalTank.'middleConv[2]'.fluid.Q_flow = RealVariables2[99];
  closedCylindricalTank.'middleConv[2]'.Gc = RealVariables2[100];
  closedCylindricalTank.'middleConv[2]'.h = RealVariables3[1];
  closedCylindricalTank.'middleConv[2]'.Tm = RealVariables3[2];
  closedCylindricalTank.'middleConv[2]'.visco = RealVariables3[3];
  closedCylindricalTank.'middleConv[2]'.K = RealVariables3[4];
  closedCylindricalTank.'middleConv[2]'.Pr = RealVariables3[5];
  closedCylindricalTank.'middleConv[2]'.Ra = RealVariables3[6];
  closedCylindricalTank.'middleConv[2]'.Gr = RealVariables3[7];
  closedCylindricalTank.'middleConv[2]'.beta = RealVariables3[8];
  closedCylindricalTank.'middleConv[2]'.Nu_nat = RealVariables3[9];
  closedCylindricalTank.'middleConv[2]'.Nu_nat1 = RealVariables3[10];
  closedCylindricalTank.'middleConv[2]'.Nu_nat2 = RealVariables3[11];
  closedCylindricalTank.'middleConv[3]'.Q_flow = RealVariables3[12];
  closedCylindricalTank.'middleConv[3]'.dT = RealVariables3[13];
  closedCylindricalTank.'middleConv[3]'.solid.T = RealVariables3[14];
  closedCylindricalTank.'middleConv[3]'.solid.Q_flow = RealVariables3[15];
  closedCylindricalTank.'middleConv[3]'.fluid.T = RealVariables3[16];
  closedCylindricalTank.'middleConv[3]'.fluid.Q_flow = RealVariables3[17];
  closedCylindricalTank.'middleConv[3]'.Gc = RealVariables3[18];
  closedCylindricalTank.'middleConv[3]'.h = RealVariables3[19];
  closedCylindricalTank.'middleConv[3]'.Tm = RealVariables3[20];
  closedCylindricalTank.'middleConv[3]'.visco = RealVariables3[21];
  closedCylindricalTank.'middleConv[3]'.K = RealVariables3[22];
  closedCylindricalTank.'middleConv[3]'.Pr = RealVariables3[23];
  closedCylindricalTank.'middleConv[3]'.Ra = RealVariables3[24];
  closedCylindricalTank.'middleConv[3]'.Gr = RealVariables3[25];
  closedCylindricalTank.'middleConv[3]'.beta = RealVariables3[26];
  closedCylindricalTank.'middleConv[3]'.Nu_nat = RealVariables3[27];
  closedCylindricalTank.'middleConv[3]'.Nu_nat1 = RealVariables3[28];
  closedCylindricalTank.'middleConv[3]'.Nu_nat2 = RealVariables3[29];
  closedCylindricalTank.'middleConv[4]'.Q_flow = RealVariables3[30];
  closedCylindricalTank.'middleConv[4]'.dT = RealVariables3[31];
  closedCylindricalTank.'middleConv[4]'.solid.T = RealVariables3[32];
  closedCylindricalTank.'middleConv[4]'.solid.Q_flow = RealVariables3[33];
  closedCylindricalTank.'middleConv[4]'.fluid.T = RealVariables3[34];
  closedCylindricalTank.'middleConv[4]'.fluid.Q_flow = RealVariables3[35];
  closedCylindricalTank.'middleConv[4]'.Gc = RealVariables3[36];
  closedCylindricalTank.'middleConv[4]'.h = RealVariables3[37];
  closedCylindricalTank.'middleConv[4]'.Tm = RealVariables3[38];
  closedCylindricalTank.'middleConv[4]'.visco = RealVariables3[39];
  closedCylindricalTank.'middleConv[4]'.K = RealVariables3[40];
  closedCylindricalTank.'middleConv[4]'.Pr = RealVariables3[41];
  closedCylindricalTank.'middleConv[4]'.Ra = RealVariables3[42];
  closedCylindricalTank.'middleConv[4]'.Gr = RealVariables3[43];
  closedCylindricalTank.'middleConv[4]'.beta = RealVariables3[44];
  closedCylindricalTank.'middleConv[4]'.Nu_nat = RealVariables3[45];
  closedCylindricalTank.'middleConv[4]'.Nu_nat1 = RealVariables3[46];
  closedCylindricalTank.'middleConv[4]'.Nu_nat2 = RealVariables3[47];
  closedCylindricalTank.bottomConv.Q_flow = RealVariables3[48];
  closedCylindricalTank.bottomConv.dT = RealVariables3[49];
  closedCylindricalTank.bottomConv.solid.T = RealVariables3[50];
  closedCylindricalTank.bottomConv.solid.Q_flow = RealVariables3[51];
  closedCylindricalTank.bottomConv.fluid.T = RealVariables3[52];
  closedCylindricalTank.bottomConv.fluid.Q_flow = RealVariables3[53];
  closedCylindricalTank.bottomConv.Gc = RealVariables3[54];
  closedCylindricalTank.bottomConv.h = RealVariables3[55];
  closedCylindricalTank.bottomConv.beta = RealVariables3[56];
  closedCylindricalTank.bottomConv.Gr = RealVariables3[57];
  closedCylindricalTank.bottomConv.Ra = RealVariables3[58];
  closedCylindricalTank.bottomConv.NuL = RealVariables3[59];
  closedCylindricalTank.bottomConv.NuL1 = RealVariables3[60];
  closedCylindricalTank.bottomConv.NuL2 = RealVariables3[61];
  closedCylindricalTank.bottomConv.Pr = RealVariables3[62];
  closedCylindricalTank.bottomConv.visco = RealVariables3[63];
  closedCylindricalTank.bottomConv.K = RealVariables3[64];
  closedCylindricalTank.bottomConv.Tc = RealVariables3[65];
  closedCylindricalTank.'condFluid[1]'.Q_flow = RealVariables3[66];
  closedCylindricalTank.'condFluid[1]'.dT = RealVariables3[67];
  closedCylindricalTank.'condFluid[1]'.port_a.T = RealVariables3[68];
  closedCylindricalTank.'condFluid[1]'.port_a.Q_flow = RealVariables3[69];
  closedCylindricalTank.'condFluid[1]'.port_b.T = RealVariables3[70];
  closedCylindricalTank.'condFluid[1]'.port_b.Q_flow = RealVariables3[71];
  closedCylindricalTank.'condFluid[1]'.G = RealVariables3[72];
  closedCylindricalTank.'condFluid[2]'.Q_flow = RealVariables3[73];
  closedCylindricalTank.'condFluid[2]'.dT = RealVariables3[74];
  closedCylindricalTank.'condFluid[2]'.port_a.T = RealVariables3[75];
  closedCylindricalTank.'condFluid[2]'.port_a.Q_flow = RealVariables3[76];
  closedCylindricalTank.'condFluid[2]'.port_b.T = RealVariables3[77];
  closedCylindricalTank.'condFluid[2]'.port_b.Q_flow = RealVariables3[78];
  closedCylindricalTank.'condFluid[2]'.G = RealVariables3[79];
  closedCylindricalTank.'condFluid[3]'.Q_flow = RealVariables3[80];
  closedCylindricalTank.'condFluid[3]'.dT = RealVariables3[81];
  closedCylindricalTank.'condFluid[3]'.port_a.T = RealVariables3[82];
  closedCylindricalTank.'condFluid[3]'.port_a.Q_flow = RealVariables3[83];
  closedCylindricalTank.'condFluid[3]'.port_b.T = RealVariables3[84];
  closedCylindricalTank.'condFluid[3]'.port_b.Q_flow = RealVariables3[85];
  closedCylindricalTank.'condFluid[3]'.G = RealVariables3[86];
  closedCylindricalTank.heatFlowTop.Q_flow = RealVariables3[87];
  closedCylindricalTank.heatFlowTop.port_a.T = RealVariables3[88];
  closedCylindricalTank.heatFlowTop.port_a.Q_flow = RealVariables3[89];
  closedCylindricalTank.heatFlowTop.port_b.T = RealVariables3[90];
  closedCylindricalTank.heatFlowTop.port_b.Q_flow = RealVariables3[91];
  closedCylindricalTank.'heatFlowMiddle[1]'.Q_flow = RealVariables3[92];
  closedCylindricalTank.'heatFlowMiddle[1]'.port_a.T = RealVariables3[93];
  closedCylindricalTank.'heatFlowMiddle[1]'.port_a.Q_flow = RealVariables3[94];
  closedCylindricalTank.'heatFlowMiddle[1]'.port_b.T = RealVariables3[95];
  closedCylindricalTank.'heatFlowMiddle[1]'.port_b.Q_flow = RealVariables3[96];
  closedCylindricalTank.'heatFlowMiddle[2]'.Q_flow = RealVariables3[97];
  closedCylindricalTank.'heatFlowMiddle[2]'.port_a.T = RealVariables3[98];
  closedCylindricalTank.'heatFlowMiddle[2]'.port_a.Q_flow = RealVariables3[99];
  closedCylindricalTank.'heatFlowMiddle[2]'.port_b.T = RealVariables3[100];
  closedCylindricalTank.'heatFlowMiddle[2]'.port_b.Q_flow = RealVariables4[1];
  closedCylindricalTank.'heatFlowMiddle[3]'.Q_flow = RealVariables4[2];
  closedCylindricalTank.'heatFlowMiddle[3]'.port_a.T = RealVariables4[3];
  closedCylindricalTank.'heatFlowMiddle[3]'.port_a.Q_flow = RealVariables4[4];
  closedCylindricalTank.'heatFlowMiddle[3]'.port_b.T = RealVariables4[5];
  closedCylindricalTank.'heatFlowMiddle[3]'.port_b.Q_flow = RealVariables4[6];
  closedCylindricalTank.'heatFlowMiddle[4]'.Q_flow = RealVariables4[7];
  closedCylindricalTank.'heatFlowMiddle[4]'.port_a.T = RealVariables4[8];
  closedCylindricalTank.'heatFlowMiddle[4]'.port_a.Q_flow = RealVariables4[9];
  closedCylindricalTank.'heatFlowMiddle[4]'.port_b.T = RealVariables4[10];
  closedCylindricalTank.'heatFlowMiddle[4]'.port_b.Q_flow = RealVariables4[11];
  closedCylindricalTank.heatFlowBottom.Q_flow = RealVariables4[12];
  closedCylindricalTank.heatFlowBottom.port_a.T = RealVariables4[13];
  closedCylindricalTank.heatFlowBottom.port_a.Q_flow = RealVariables4[14];
  closedCylindricalTank.heatFlowBottom.port_b.T = RealVariables4[15];
  closedCylindricalTank.heatFlowBottom.port_b.Q_flow = RealVariables4[16];
  closedCylindricalTank.Ql_flow = RealVariables4[17];
  closedCylindricalTank.port_a_Tambient.T = RealVariables4[18];
  closedCylindricalTank.port_a_Tambient.Q_flow = RealVariables4[19];
  closedCylindricalTank.buoyancy.'dT[1]' = RealVariables4[20];
  closedCylindricalTank.buoyancy.'dT[2]' = RealVariables4[21];
  closedCylindricalTank.buoyancy.'dT[3]' = RealVariables4[22];
  closedCylindricalTank.buoyancy.'Q_flow[1]' = RealVariables4[23];
  closedCylindricalTank.buoyancy.'Q_flow[2]' = RealVariables4[24];
  closedCylindricalTank.buoyancy.'Q_flow[3]' = RealVariables4[25];
  closedCylindricalTank.buoyancy.'port_a_heat[1]'.T = RealVariables4[26];
  closedCylindricalTank.buoyancy.'port_a_heat[1]'.Q_flow = RealVariables4[27];
  closedCylindricalTank.buoyancy.'port_a_heat[2]'.T = RealVariables4[28];
  closedCylindricalTank.buoyancy.'port_a_heat[2]'.Q_flow = RealVariables4[29];
  closedCylindricalTank.buoyancy.'port_a_heat[3]'.T = RealVariables4[30];
  closedCylindricalTank.buoyancy.'port_a_heat[3]'.Q_flow = RealVariables4[31];
  closedCylindricalTank.buoyancy.'port_a_heat[4]'.T = RealVariables4[32];
  closedCylindricalTank.buoyancy.'port_a_heat[4]'.Q_flow = RealVariables4[33];
  ambientTemperature.port.T = RealVariables4[34];
  ambientTemperature.port.Q_flow = RealVariables4[35];
  ambientTemperature.T = RealVariables4[36];
  Retorno.medium.h = RealVariables4[37];
  Retorno.medium.T = RealVariables4[38];
  Retorno.medium.u = RealVariables4[39];
  Retorno.medium.state.T = RealVariables4[40];
  Retorno.medium.T_degC = RealVariables4[41];
  Retorno.'ports[1]'.m_flow = RealVariables4[42];
  Retorno.'ports[1]'.h_outflow = RealVariables4[43];
  Retorno.T_in = RealVariables4[44];
  Impulsion.medium.h = RealVariables4[45];
  Impulsion.medium.T = RealVariables4[46];
  Impulsion.medium.u = RealVariables4[47];
  Impulsion.medium.state.T = RealVariables4[48];
  Impulsion.medium.T_degC = RealVariables4[49];
  Impulsion.'ports[1]'.m_flow = RealVariables4[50];
  Impulsion.'ports[1]'.h_outflow = RealVariables4[51];
  Impulsion.m_flow_in = RealVariables4[52];
  Impulsion.T_in = RealVariables4[53];
  T_Impulsion.T = RealVariables4[54];
  T_Retorno.T = RealVariables4[55];
  massFlowRate.port_a.m_flow = RealVariables4[56];
  massFlowRate.port_a.h_outflow = RealVariables4[57];
  massFlowRate.port_b.h_outflow = RealVariables4[58];
  massFlowRate.m_flow = RealVariables4[59];
  triggeredSampler.u = RealVariables4[60];
  triggeredSampler.y = RealVariables4[61];
  triggeredSampler1.u = RealVariables4[62];
  triggeredSampler1.y = RealVariables4[63];
  'system'.p_start = RealDependentParameters[1];
  'system'.T_start = RealDependentParameters[2];
  'system'.m_flow_nominal = RealDependentParameters[3];
  p_start = RealDependentParameters[4];
  closedCylindricalTank.d = RealDependentParameters[5];
  closedCylindricalTank.h_max = RealDependentParameters[6];
  closedCylindricalTank.eTank = RealDependentParameters[7];
  closedCylindricalTank.d_Inlet = RealDependentParameters[8];
  closedCylindricalTank.d_Outlet = RealDependentParameters[9];
  closedCylindricalTank.T_start = RealDependentParameters[10];
  closedCylindricalTank.p_start = RealDependentParameters[11];
  closedCylindricalTank.tau = RealDependentParameters[12];
  closedCylindricalTank.D = RealDependentParameters[13];
  closedCylindricalTank.volumeTop.p_start = RealDependentParameters[14];
  closedCylindricalTank.volumeTop.T_start = RealDependentParameters[15];
  closedCylindricalTank.volumeTop.h_start = RealDependentParameters[16];
  closedCylindricalTank.volumeTop.m = RealDependentParameters[17];
  closedCylindricalTank.volumeTop.m_flow_nominal = RealDependentParameters[18];
  closedCylindricalTank.volumeTop.m_flow_small = RealDependentParameters[19];
  closedCylindricalTank.volumeTop.heatTransfer.'surfaceAreas[1]' = RealDependentParameters[20];
  closedCylindricalTank.volumeTop.heatTransfer.T_ambient = RealDependentParameters[21];
  closedCylindricalTank.volumeTop.V = RealDependentParameters[22];
  closedCylindricalTank.volumeTop.d = RealDependentParameters[23];
  closedCylindricalTank.volumeTop.h_max = RealDependentParameters[24];
  closedCylindricalTank.'volumeMiddle[1]'.p_start = RealDependentParameters[25];
  closedCylindricalTank.'volumeMiddle[1]'.T_start = RealDependentParameters[26];
  closedCylindricalTank.'volumeMiddle[1]'.h_start = RealDependentParameters[27];
  closedCylindricalTank.'volumeMiddle[1]'.m = RealDependentParameters[28];
  closedCylindricalTank.'volumeMiddle[1]'.m_flow_nominal = RealDependentParameters[29];
  closedCylindricalTank.'volumeMiddle[1]'.m_flow_small = RealDependentParameters[30];
  closedCylindricalTank.'volumeMiddle[1]'.heatTransfer.'surfaceAreas[1]' = RealDependentParameters[31];
  closedCylindricalTank.'volumeMiddle[1]'.heatTransfer.T_ambient = RealDependentParameters[32];
  closedCylindricalTank.'volumeMiddle[1]'.V = RealDependentParameters[33];
  closedCylindricalTank.'volumeMiddle[1]'.d = RealDependentParameters[34];
  closedCylindricalTank.'volumeMiddle[1]'.h_max = RealDependentParameters[35];
  closedCylindricalTank.'volumeMiddle[2]'.p_start = RealDependentParameters[36];
  closedCylindricalTank.'volumeMiddle[2]'.T_start = RealDependentParameters[37];
  closedCylindricalTank.'volumeMiddle[2]'.h_start = RealDependentParameters[38];
  closedCylindricalTank.'volumeMiddle[2]'.m = RealDependentParameters[39];
  closedCylindricalTank.'volumeMiddle[2]'.m_flow_nominal = RealDependentParameters[40];
  closedCylindricalTank.'volumeMiddle[2]'.m_flow_small = RealDependentParameters[41];
  closedCylindricalTank.'volumeMiddle[2]'.heatTransfer.'surfaceAreas[1]' = RealDependentParameters[42];
  closedCylindricalTank.'volumeMiddle[2]'.heatTransfer.T_ambient = RealDependentParameters[43];
  closedCylindricalTank.'volumeMiddle[2]'.V = RealDependentParameters[44];
  closedCylindricalTank.'volumeMiddle[2]'.d = RealDependentParameters[45];
  closedCylindricalTank.'volumeMiddle[2]'.h_max = RealDependentParameters[46];
  closedCylindricalTank.volumeBottom.p_start = RealDependentParameters[47];
  closedCylindricalTank.volumeBottom.T_start = RealDependentParameters[48];
  closedCylindricalTank.volumeBottom.h_start = RealDependentParameters[49];
  closedCylindricalTank.volumeBottom.m = RealDependentParameters[50];
  closedCylindricalTank.volumeBottom.m_flow_nominal = RealDependentParameters[51];
  closedCylindricalTank.volumeBottom.m_flow_small = RealDependentParameters[52];
  closedCylindricalTank.volumeBottom.heatTransfer.'surfaceAreas[1]' = RealDependentParameters[53];
  closedCylindricalTank.volumeBottom.heatTransfer.T_ambient = RealDependentParameters[54];
  closedCylindricalTank.volumeBottom.V = RealDependentParameters[55];
  closedCylindricalTank.volumeBottom.d = RealDependentParameters[56];
  closedCylindricalTank.volumeBottom.h_max = RealDependentParameters[57];
  closedCylindricalTank.topCond.L = RealDependentParameters[58];
  closedCylindricalTank.topCond.A = RealDependentParameters[59];
  closedCylindricalTank.'middleCond[1]'.L = RealDependentParameters[60];
  closedCylindricalTank.'middleCond[1]'.A = RealDependentParameters[61];
  closedCylindricalTank.'middleCond[2]'.L = RealDependentParameters[62];
  closedCylindricalTank.'middleCond[2]'.A = RealDependentParameters[63];
  closedCylindricalTank.'middleCond[3]'.L = RealDependentParameters[64];
  closedCylindricalTank.'middleCond[3]'.A = RealDependentParameters[65];
  closedCylindricalTank.'middleCond[4]'.L = RealDependentParameters[66];
  closedCylindricalTank.'middleCond[4]'.A = RealDependentParameters[67];
  closedCylindricalTank.bottomCond.L = RealDependentParameters[68];
  closedCylindricalTank.bottomCond.A = RealDependentParameters[69];
  closedCylindricalTank.topConv.A = RealDependentParameters[70];
  closedCylindricalTank.topConv.B = RealDependentParameters[71];
  closedCylindricalTank.topConv.L = RealDependentParameters[72];
  closedCylindricalTank.topConv.P = RealDependentParameters[73];
  closedCylindricalTank.'middleConv[1]'.A = RealDependentParameters[74];
  closedCylindricalTank.'middleConv[1]'.D = RealDependentParameters[75];
  closedCylindricalTank.'middleConv[2]'.A = RealDependentParameters[76];
  closedCylindricalTank.'middleConv[2]'.D = RealDependentParameters[77];
  closedCylindricalTank.'middleConv[3]'.A = RealDependentParameters[78];
  closedCylindricalTank.'middleConv[3]'.D = RealDependentParameters[79];
  closedCylindricalTank.'middleConv[4]'.A = RealDependentParameters[80];
  closedCylindricalTank.'middleConv[4]'.D = RealDependentParameters[81];
  closedCylindricalTank.bottomConv.A = RealDependentParameters[82];
  closedCylindricalTank.bottomConv.L = RealDependentParameters[83];
  closedCylindricalTank.buoyancy.V = RealDependentParameters[84];
  closedCylindricalTank.buoyancy.tau = RealDependentParameters[85];
  closedCylindricalTank.buoyancy.k = RealDependentParameters[86];
  massFlowRate.m_flow_nominal = RealDependentParameters[87];
  massFlowRate.m_flow_small = RealDependentParameters[88];
  triggeredSampler.trigger = BooleanVariables[1];
  triggeredSampler1.trigger = BooleanVariables[2];
  not1.u = BooleanVariables[3];
  not1.y = BooleanVariables[4];
  booleanExpression.y = BooleanVariables[5];
  annotation (__Dymola_FMUImportVersion="Dymola 2017 FD01", experiment(StartTime=0.0, StopTime=60000.0, Tolerance=0.0001),
    Icon(graphics={
      Rectangle(
        extent={{-100,100},{100,-100}},
        lineColor={95,95,95},
        fillColor={255,255,255},
        fillPattern=FillPattern.Solid,
        lineThickness=0.5),
      Text(
        extent={{-70,20},{70,-20}},
        lineColor={0,0,255},
        textString="%name"),
      Text(
        extent={{-70,-72},{70,-94}},
        lineColor={95,95,95},
        textString="FMI 1.0 CS Import")}),
Documentation(info="<html>
<h4>ModelDescription Attributes</h4>
<ul>
<li>fmiVersion = 1.0</li>
<li>modelName = Modelica_IK4_TEKNIKER.DCOL.Generation.SensibleStorages.FMI.Buffer_Dym</li>
<li>generationTool = Dymola Version 2017 FD01 (64-bit), 2016-10-11 (requires license to execute)</li>
<li>generationDateAndTime = 2017-06-02T10:04:48Z</li>
</ul>
<p><br><b>Co-Simulation Attributes</b></p>
<ul>
<li>canHandleVariableCommunicationStepSize = true</li>
<li>canHandleEvents = true</li>
<li>canRejectSteps = false</li>
<li>canInterpolateInputs = true</li>
<li>maxOutputDerivativeOrder = 1</li>
<li>canRunAsynchronuously = false</li>
<li>canSignalEvents = false</li>
<li>canBeInstantiatedOnlyOncePerProcess = false</li>
<li>canNotUseMemoryManagementFunctions = false</li>
</ul>
</html>",
      revisions="<html>
<p>2016-05-16 <a href=\"mailto: eduardo.ubieta@tekniker.es\">Eduardo Ubieta</a></a> (IK4-TEKNIKER): First implementation</p>
<p><b>Copyright &copy; <a href=\"http://www.tekniker.es/en\">IK4-TEKNIKER</a></b></p>
</html>"));
end Buffer_FMI;
