within DCOL.ThermalStorage.SensibleStorages.FMI;
model Buffer_FMI_temperature
// Model automatically generated by Dymola from FMI model description
public
  type Modelica_Blocks_Interfaces_BooleanInput = Boolean;
  type Modelica_Blocks_Interfaces_RealInput = Real;
  type Modelica_Blocks_Interfaces_RealOutput = Real;
  type Modelica_IK4_TEKNIKER_DCOL_Generation_SensibleStorages_FMI_RealConectors_RealHeatFlowOutput = Real (unit = "W", quantity = "Power");
  type Modelica_IK4_TEKNIKER_DCOL_Generation_SensibleStorages_FMI_RealConectors_RealMassFlowInput = Real (unit = "kg/s", quantity = "MassFlowRate");
  type Modelica_IK4_TEKNIKER_DCOL_Generation_SensibleStorages_FMI_RealConectors_RealTemperatureInput = Real (unit = "K", displayUnit = "degC", nominal = 300.0, quantity = "ThermodynamicTemperature", min = 0.0);
  type Modelica_IK4_TEKNIKER_DCOL_Generation_SensibleStorages_FMI_RealConectors_RealTemperatureOutput = Real (unit = "K", displayUnit = "degC", nominal = 300.0, quantity = "ThermodynamicTemperature", min = 0.0);
protected
  record 'system_rec'
    parameter Modelica.SIunits.AbsolutePressure p_ambient = 101325
                                                                  "Default ambient pressure";
    parameter Modelica.SIunits.Temperature T_ambient = 293.15
                                                             "Default ambient temperature";
    parameter Modelica.SIunits.Acceleration g = 9.80665
                                                       "Constant gravity acceleration";
    constant Boolean allowFlowReversal = true
                                             "= false to restrict to design flow direction (port_a -> port_b)";
    constant Modelica.Fluid.Types.Dynamics energyDynamics = Modelica.Fluid.Types.Dynamics.DynamicFreeInitial
                                                                                                            "Default formulation of energy balances";
    constant Modelica.Fluid.Types.Dynamics massDynamics = Modelica.Fluid.Types.Dynamics.DynamicFreeInitial
                                                                                                          "Default formulation of mass balances";
    constant Modelica.Fluid.Types.Dynamics substanceDynamics = Modelica.Fluid.Types.Dynamics.DynamicFreeInitial
                                                                                                               "Default formulation of substance balances";
    constant Modelica.Fluid.Types.Dynamics traceDynamics = Modelica.Fluid.Types.Dynamics.DynamicFreeInitial
                                                                                                           "Default formulation of trace substance balances";
    constant Modelica.Fluid.Types.Dynamics momentumDynamics = Modelica.Fluid.Types.Dynamics.SteadyState
                                                                                                       "Default formulation of momentum balances, if options available";
    parameter Modelica.SIunits.MassFlowRate m_flow_start = 0
                                                            "Default start value for mass flow rates";
    parameter Modelica.SIunits.AbsolutePressure p_start(fixed=false)
                                                                    "Default start value for pressures";
    parameter Modelica.SIunits.Temperature T_start(fixed=false)
                                                               "Default start value for temperatures";
    constant Boolean use_eps_Re = false
                                       "= true to determine turbulent region automatically using Reynolds number";
    parameter Modelica.SIunits.MassFlowRate m_flow_nominal(fixed=false)
                                                                       "Default nominal mass flow rate";
    parameter Real eps_m_flow(unit = "1", min = 0.0) = 0.0001
                                                             "Regularization of zero flow for |m_flow| < eps_m_flow*m_flow_nominal";
    parameter Modelica.SIunits.AbsolutePressure dp_small = 1
                                                            "Default small pressure drop for regularization of laminar and zero flow";
    parameter Modelica.SIunits.MassFlowRate m_flow_small(min = 0.0) = 0.01
                                                                          "Default small mass flow rate for regularization of laminar and zero flow";
  end 'system_rec';
public
  'system_rec' 'system' annotation(Dialog);
  constant Integer nSeg = 4
                           "number of segments the volume is divided";
  parameter Modelica.SIunits.Diameter d = 1.128379167
                                                     "diameter of the cylindrical tank";
  parameter Modelica.SIunits.Height h_max = 10
                                              "Maximun height occupied by the water";
  constant Modelica.SIunits.Height h = 5
                                        "height of the cylindrical tank";
  parameter Modelica.SIunits.Length eTank = 0.03
                                                "Thickness of insulation";
  constant Modelica.SIunits.Height h_portIn = 7.5
                                                 "Height of the inlet port";
  constant Modelica.SIunits.Height h_portOut = 0.5
                                                  "Height of the outlet port";
  parameter Modelica.SIunits.Diameter d_Inlet = 0.05
                                                    "Diameter of the inlet port";
  parameter Modelica.SIunits.Diameter d_Outlet = 0.05
                                                     "Diameter of the outlet port";
  parameter Modelica.SIunits.Height h_heater = 7.5
                                                  "Height of the heater";
  parameter Modelica.SIunits.Temperature T_start = 283.15
                                                         "Default start value for temperatures";
  parameter Modelica.SIunits.AbsolutePressure p_start(fixed=false)
                                                                  "Default start value for pressures";
  parameter Modelica.SIunits.Time tau = 1
                                         "Time constant for mixing";
protected
  record closedCylindricalTank_rec
    constant Boolean allowFlowReversal = true
                                             "true for allowing the reversal flow";
    constant Boolean homotopyInitialization = true
                                                  "true for allowing the reversal flow";
    constant Boolean useHeater = false
                                      "Inlet port at the top of the tank";
    constant Integer nSeg = 4
                             "number of segments the volume is divided";
    parameter Modelica.SIunits.Diameter d(fixed=false)
                                                      "diameter of the cylindrical tank";
    parameter Modelica.SIunits.Height h_max(fixed=false)
                                                        "Maximun height occupied by the water";
    constant Modelica.SIunits.Height h = 5
                                          "height of the cylindrical tank";
    parameter Modelica.SIunits.Length eTank(fixed=false)
                                                        "Thickness of insulation";
    constant Modelica.SIunits.Height h_portIn = 7.5
                                                   "Height of the inlet port";
    constant Modelica.SIunits.Height h_portOut = 0.5
                                                    "Height of the outlet port";
    parameter Modelica.SIunits.Diameter d_Inlet(fixed=false)
                                                            "Diameter of the inlet port";
    parameter Modelica.SIunits.Diameter d_Outlet(fixed=false)
                                                             "Diameter of the outlet port";
    constant Modelica.SIunits.Height h_heater = 7.5
                                                   "Height of the heater";
    parameter Modelica.SIunits.Temperature T_start(fixed=false)
                                                               "Default start value for temperatures";
    parameter Modelica.SIunits.AbsolutePressure p_start(fixed=false)
                                                                    "Default start value for pressures";
    parameter Modelica.SIunits.Time tau(fixed=false)
                                                    "Time constant for mixing";
    constant Boolean faceUpTop = true
                                     "True when the top of the storage is facing up";
    parameter Boolean faceUpBottom = false
                                          "True when the bottom of the storage is facing up";
    parameter Modelica.SIunits.Length D(fixed=false)
                                                    "External diameter of the clinder";
  protected
    record port_a_rec
      Modelica.Media.Interfaces.PartialMedium.MassFlowRate m_flow(quantity = "MassFlowRate.SimpleLiquidWater")
                                                                                                              "Mass flow rate from the connection point into the component";
      Modelica.Media.Interfaces.Types.AbsolutePressure p
                                                        "Thermodynamic pressure in the connection point";
      Modelica.Media.Interfaces.Types.SpecificEnthalpy h_outflow
                                                                "Specific thermodynamic enthalpy close to the connection point if m_flow < 0";
    end port_a_rec;
  public
    port_a_rec port_a;
  protected
    record port_b_rec
      Modelica.Media.Interfaces.Types.AbsolutePressure p
                                                        "Thermodynamic pressure in the connection point";
      Modelica.Media.Interfaces.Types.SpecificEnthalpy h_outflow
                                                                "Specific thermodynamic enthalpy close to the connection point if m_flow < 0";
    end port_b_rec;
  public
    port_b_rec port_b;
  protected
    record volumeTop_rec
      Modelica.SIunits.Volume fluidVolume
                                         "Volume";
      constant Modelica.Fluid.Types.Dynamics energyDynamics = Modelica.Fluid.Types.Dynamics.DynamicFreeInitial
                                                                                                              "Formulation of energy balance";
      constant Modelica.Fluid.Types.Dynamics massDynamics = Modelica.Fluid.Types.Dynamics.DynamicFreeInitial
                                                                                                            "Formulation of mass balance";
      constant Modelica.Fluid.Types.Dynamics substanceDynamics = Modelica.Fluid.Types.Dynamics.DynamicFreeInitial
                                                                                                                 "Formulation of substance balance";
      constant Modelica.Fluid.Types.Dynamics traceDynamics = Modelica.Fluid.Types.Dynamics.DynamicFreeInitial
                                                                                                             "Formulation of trace substance balance";
      parameter Modelica.Media.Interfaces.Types.AbsolutePressure p_start(fixed=false)
                                                                                     "Start value of pressure";
      constant Boolean use_T_start = true
                                         "= true, use T_start, otherwise h_start";
      parameter Modelica.Media.Interfaces.Types.Temperature T_start(fixed=false)
                                                                                "Start value of temperature";
      parameter Modelica.Media.Interfaces.Types.SpecificEnthalpy h_start(fixed=false)
                                                                                     "Start value of specific enthalpy";
      parameter Modelica.Media.Interfaces.Types.MassFraction 'X_start[1]' = 1.0
                                                                               "Start value of mass fractions m_i/m";
    protected
      record medium_rec
        parameter Real p(unit = "Pa", displayUnit = "bar", nominal = 100000.0, quantity = "Pressure", min = 0.0, max = 100000000.0, fixed=false)
                                                                                                                                                "Absolute pressure of medium";
        Real h(unit = "J/kg", quantity = "SpecificEnergy")
                                                          "Specific enthalpy of medium";
        constant Modelica.Media.Interfaces.Types.Density d = 995.586
                                                                    "Density of medium";
        Modelica.Media.Interfaces.Types.Temperature T
                                                     "Temperature of medium";
        Real T_der(unit = "K/s")
                                "der(Temperature of medium)";
        constant Modelica.Media.Interfaces.Types.MassFraction 'X[1]' = 1.0
                                                                          "Mass fractions (= (component mass)/total mass  m_i/m)";
        Modelica.Media.Interfaces.Types.SpecificInternalEnergy u
                                                                "Specific internal energy of medium";
        Real u_der(unit = "m2/s3")
                                  "der(Specific internal energy of medium)";
        constant Modelica.Media.Interfaces.Types.SpecificHeatCapacity R = 0
                                                                           "Gas constant (of mixture if applicable)";
        constant Modelica.Media.Interfaces.Types.MolarMass MM = 0.018015268
                                                                           "Molar mass (of mixture or single fluid)";
      protected
        record state_rec
          Modelica.Media.Interfaces.Types.AbsolutePressure p
                                                            "Absolute pressure of medium";
          Modelica.Media.Interfaces.Types.Temperature T
                                                       "Temperature of medium";
        end state_rec;
      public
        state_rec state;
        constant Boolean preferredMediumStates = true
                                                     "= true if StateSelect.prefer shall be used for the independent property variables of the medium";
        constant Boolean standardOrderComponents = true
                                                       "If true, and reducedX = true, the last element of X will be computed from the other ones";
        Modelica.SIunits.Conversions.NonSIunits.Temperature_degC T_degC
                                                                       "Temperature of medium in [degC]";
        parameter Modelica.SIunits.Conversions.NonSIunits.Pressure_bar p_bar(fixed=false)
                                                                                         "Absolute pressure of medium in [bar]";
      end medium_rec;
    public
      medium_rec medium;
      Modelica.SIunits.Energy U
                               "Internal energy of fluid";
      Real U_der(unit = "W")
                            "der(Internal energy of fluid)";
      parameter Modelica.SIunits.Mass m(fixed=false)
                                                    "Mass of fluid";
      constant Real m_der(unit = "kg/s") = 0.0
                                              "der(Mass of fluid)";
      constant Modelica.SIunits.MassFlowRate mb_flow = 0.0
                                                          "Mass flows across boundaries";
      Modelica.SIunits.EnthalpyFlowRate Hb_flow
                                               "Enthalpy flow across boundaries or energy source/sink";
      Modelica.SIunits.HeatFlowRate Qb_flow
                                           "Heat flow across boundaries or energy source/sink";
      constant Modelica.SIunits.Power Wb_flow = 0
                                                 "Work flow across boundaries or source term";
      constant Integer nPorts = 3
                                 "Number of ports";
    protected
      record 'ports[1]_rec'
        Modelica.Media.Interfaces.PartialMedium.MassFlowRate m_flow(quantity = "MassFlowRate.SimpleLiquidWater")
                                                                                                                "Mass flow rate from the connection point into the component";
        Modelica.Media.Interfaces.Types.AbsolutePressure p
                                                          "Thermodynamic pressure in the connection point";
        Modelica.Media.Interfaces.Types.SpecificEnthalpy h_outflow
                                                                  "Specific thermodynamic enthalpy close to the connection point if m_flow < 0";
      end 'ports[1]_rec';
    public
      'ports[1]_rec' 'ports[1]';
    protected
      record 'ports[2]_rec'
        constant Modelica.Media.Interfaces.PartialMedium.MassFlowRate m_flow(quantity = "MassFlowRate.SimpleLiquidWater") = 0.0
                                                                                                                               "Mass flow rate from the connection point into the component";
        parameter Modelica.Media.Interfaces.Types.AbsolutePressure p(fixed=false)
                                                                                 "Thermodynamic pressure in the connection point";
        Modelica.Media.Interfaces.Types.SpecificEnthalpy h_outflow
                                                                  "Specific thermodynamic enthalpy close to the connection point if m_flow < 0";
      end 'ports[2]_rec';
    public
      'ports[2]_rec' 'ports[2]';
    protected
      record 'ports[3]_rec'
        parameter Modelica.Media.Interfaces.Types.AbsolutePressure p(fixed=false)
                                                                                 "Thermodynamic pressure in the connection point";
        Modelica.Media.Interfaces.Types.SpecificEnthalpy h_outflow
                                                                  "Specific thermodynamic enthalpy close to the connection point if m_flow < 0";
      end 'ports[3]_rec';
    public
      'ports[3]_rec' 'ports[3]';
      constant Boolean use_portsData = false
                                            "= false to neglect pressure loss and kinetic energy";
      parameter Modelica.Media.Interfaces.PartialMedium.MassFlowRate m_flow_nominal(quantity = "MassFlowRate.SimpleLiquidWater", fixed=false)
                                                                                                                                             "Nominal value for mass flow rates in ports";
      parameter Modelica.SIunits.MassFlowRate m_flow_small(min = 0.0, fixed=false)
                                                                                  "Regularization range at zero mass flow rate";
      constant Boolean use_Re = false
                                     "= true, if turbulent region is defined by Re, otherwise by m_flow_small";
      Modelica.Media.Interfaces.Types.EnthalpyFlowRate 'ports_H_flow[1]';
      constant Modelica.Media.Interfaces.Types.EnthalpyFlowRate 'ports_H_flow[2]' = 0.0;
      Modelica.Media.Interfaces.Types.EnthalpyFlowRate 'ports_H_flow[3]';
      constant Boolean use_HeatTransfer = true
                                              "= true to use the HeatTransfer model";
    protected
      record heatTransfer_rec
        constant Integer n = 1
                              "Number of heat transfer segments";
      protected
        record 'states[1]_rec'
          Modelica.Media.Interfaces.Types.AbsolutePressure p
                                                            "Absolute pressure of medium";
          Modelica.Media.Interfaces.Types.Temperature T
                                                       "Temperature of medium";
        end 'states[1]_rec';
      public
        'states[1]_rec' 'states[1]';
        parameter Modelica.SIunits.Area 'surfaceAreas[1]'(fixed=false)
                                                                      "Heat transfer areas";
        Modelica.SIunits.HeatFlowRate 'Q_flows[1]'
                                                  "Heat flow rates";
        constant Boolean use_k = true
                                     "= true to use k value for thermal isolation";
        constant Modelica.SIunits.CoefficientOfHeatTransfer k = 0
                                                                 "Heat transfer coefficient to ambient";
        parameter Modelica.SIunits.Temperature T_ambient(fixed=false)
                                                                     "Ambient temperature";
      protected
        record 'heatPorts[1]_rec'
          Modelica.SIunits.Temperature T
                                        "Port temperature";
          Modelica.SIunits.HeatFlowRate Q_flow
                                              "Heat flow rate (positive if flowing from outside into the component)";
        end 'heatPorts[1]_rec';
      public
        'heatPorts[1]_rec' 'heatPorts[1]';
        Modelica.SIunits.Temperature 'Ts[1]'
                                            "Temperatures defined by fluid states";
      end heatTransfer_rec;
    public
      heatTransfer_rec heatTransfer;
    protected
      record heatPort_rec
        Modelica.SIunits.Temperature T
                                      "Port temperature";
        Modelica.SIunits.HeatFlowRate Q_flow
                                            "Heat flow rate (positive if flowing from outside into the component)";
      end heatPort_rec;
    public
      heatPort_rec heatPort;
      constant Modelica.Media.Interfaces.Types.Density 'portInDensities[1]' = 995.586
                                                                                     "densities of the fluid at the device boundary";
      constant Modelica.Media.Interfaces.Types.Density 'portInDensities[2]' = 995.586
                                                                                     "densities of the fluid at the device boundary";
      constant Modelica.Media.Interfaces.Types.Density 'portInDensities[3]' = 995.586
                                                                                     "densities of the fluid at the device boundary";
      constant Modelica.SIunits.Velocity 'portVelocities[1]' = 0.0
                                                                  "velocities of fluid flow at device boundary";
      constant Modelica.SIunits.Velocity 'portVelocities[2]' = 0.0
                                                                  "velocities of fluid flow at device boundary";
      constant Modelica.SIunits.Velocity 'portVelocities[3]' = 0.0
                                                                  "velocities of fluid flow at device boundary";
      constant Modelica.SIunits.EnergyFlowRate 'ports_E_flow[1]' = 0.0
                                                                      "flow of kinetic and potential energy at device boundary";
      constant Modelica.SIunits.EnergyFlowRate 'ports_E_flow[2]' = 0.0
                                                                      "flow of kinetic and potential energy at device boundary";
      constant Modelica.SIunits.EnergyFlowRate 'ports_E_flow[3]' = 0.0
                                                                      "flow of kinetic and potential energy at device boundary";
      constant Real 's[1]'(unit = "m") = 1.25
                                             "curve parameters for port flows vs. port pressures; for further details see, Modelica Tutorial: Ideal switching devices";
      constant Real 's[2]'(unit = "m") = 1.25
                                             "curve parameters for port flows vs. port pressures; for further details see, Modelica Tutorial: Ideal switching devices";
      constant Real 's[3]'(unit = "m") = 1.25
                                             "curve parameters for port flows vs. port pressures; for further details see, Modelica Tutorial: Ideal switching devices";
      constant Real 'ports_penetration[1]' = 1.0
                                                "penetration of port with fluid, depending on fluid level and port diameter";
      constant Real 'ports_penetration[2]' = 1.0
                                                "penetration of port with fluid, depending on fluid level and port diameter";
      constant Real 'ports_penetration[3]' = 1.0
                                                "penetration of port with fluid, depending on fluid level and port diameter";
      constant Modelica.SIunits.Area 'portAreas[1]' = 0.0;
      constant Modelica.SIunits.Area 'portAreas[2]' = 0.0;
      constant Modelica.SIunits.Area 'portAreas[3]' = 0.0;
      Modelica.Media.Interfaces.Types.AbsolutePressure 'vessel_ps_static[1]'
                                                                            "static pressures inside the vessel at the height of the corresponding ports, zero flow velocity";
      Modelica.Media.Interfaces.Types.AbsolutePressure 'vessel_ps_static[2]'
                                                                            "static pressures inside the vessel at the height of the corresponding ports, zero flow velocity";
      Modelica.Media.Interfaces.Types.AbsolutePressure 'vessel_ps_static[3]'
                                                                            "static pressures inside the vessel at the height of the corresponding ports, zero flow velocity";
      constant Modelica.SIunits.ReynoldsNumber Re_turbulent = 100
                                                                 "cf. suddenExpansion";
      constant Modelica.SIunits.MassFlowRate 'm_flow_turbulent[1]' = 1E+060;
      constant Modelica.SIunits.MassFlowRate 'm_flow_turbulent[2]' = 1E+060;
      constant Modelica.SIunits.MassFlowRate 'm_flow_turbulent[3]' = 1E+060;
      parameter Modelica.SIunits.Volume V(fixed=false)
                                                      "Volume";
      parameter Modelica.SIunits.Diameter d(fixed=false)
                                                        "diameter of the cylindrical tank";
      constant Modelica.SIunits.Height h = 1.25
                                               "Height of the cylindrical tank";
      parameter Modelica.SIunits.Height h_max(fixed=false)
                                                          "Maximun height occupied by the water";
    end volumeTop_rec;
  public
    volumeTop_rec volumeTop annotation(Dialog);
  protected
    record 'volumeMiddle[1]_rec'
      Modelica.SIunits.Volume fluidVolume
                                         "Volume";
      constant Modelica.Fluid.Types.Dynamics energyDynamics = Modelica.Fluid.Types.Dynamics.DynamicFreeInitial
                                                                                                              "Formulation of energy balance";
      constant Modelica.Fluid.Types.Dynamics massDynamics = Modelica.Fluid.Types.Dynamics.DynamicFreeInitial
                                                                                                            "Formulation of mass balance";
      constant Modelica.Fluid.Types.Dynamics substanceDynamics = Modelica.Fluid.Types.Dynamics.DynamicFreeInitial
                                                                                                                 "Formulation of substance balance";
      constant Modelica.Fluid.Types.Dynamics traceDynamics = Modelica.Fluid.Types.Dynamics.DynamicFreeInitial
                                                                                                             "Formulation of trace substance balance";
      parameter Modelica.Media.Interfaces.Types.AbsolutePressure p_start(fixed=false)
                                                                                     "Start value of pressure";
      constant Boolean use_T_start = true
                                         "= true, use T_start, otherwise h_start";
      parameter Modelica.Media.Interfaces.Types.Temperature T_start(fixed=false)
                                                                                "Start value of temperature";
      parameter Modelica.Media.Interfaces.Types.SpecificEnthalpy h_start(fixed=false)
                                                                                     "Start value of specific enthalpy";
      parameter Modelica.Media.Interfaces.Types.MassFraction 'X_start[1]' = 1.0
                                                                               "Start value of mass fractions m_i/m";
    protected
      record medium_rec
        parameter Real p(unit = "Pa", displayUnit = "bar", nominal = 100000.0, quantity = "Pressure", min = 0.0, max = 100000000.0, fixed=false)
                                                                                                                                                "Absolute pressure of medium";
        Real h(unit = "J/kg", quantity = "SpecificEnergy")
                                                          "Specific enthalpy of medium";
        constant Modelica.Media.Interfaces.Types.Density d = 995.586
                                                                    "Density of medium";
        Modelica.Media.Interfaces.Types.Temperature T
                                                     "Temperature of medium";
        Real T_der(unit = "K/s")
                                "der(Temperature of medium)";
        constant Modelica.Media.Interfaces.Types.MassFraction 'X[1]' = 1.0
                                                                          "Mass fractions (= (component mass)/total mass  m_i/m)";
        Modelica.Media.Interfaces.Types.SpecificInternalEnergy u
                                                                "Specific internal energy of medium";
        Real u_der(unit = "m2/s3")
                                  "der(Specific internal energy of medium)";
        constant Modelica.Media.Interfaces.Types.SpecificHeatCapacity R = 0
                                                                           "Gas constant (of mixture if applicable)";
        constant Modelica.Media.Interfaces.Types.MolarMass MM = 0.018015268
                                                                           "Molar mass (of mixture or single fluid)";
      protected
        record state_rec
          Modelica.Media.Interfaces.Types.AbsolutePressure p
                                                            "Absolute pressure of medium";
          Modelica.Media.Interfaces.Types.Temperature T
                                                       "Temperature of medium";
        end state_rec;
      public
        state_rec state;
        constant Boolean preferredMediumStates = true
                                                     "= true if StateSelect.prefer shall be used for the independent property variables of the medium";
        constant Boolean standardOrderComponents = true
                                                       "If true, and reducedX = true, the last element of X will be computed from the other ones";
        Modelica.SIunits.Conversions.NonSIunits.Temperature_degC T_degC
                                                                       "Temperature of medium in [degC]";
        parameter Modelica.SIunits.Conversions.NonSIunits.Pressure_bar p_bar(fixed=false)
                                                                                         "Absolute pressure of medium in [bar]";
      end medium_rec;
    public
      medium_rec medium;
      Modelica.SIunits.Energy U
                               "Internal energy of fluid";
      Real U_der(unit = "W")
                            "der(Internal energy of fluid)";
      parameter Modelica.SIunits.Mass m(fixed=false)
                                                    "Mass of fluid";
      constant Real m_der(unit = "kg/s") = 0.0
                                              "der(Mass of fluid)";
      constant Modelica.SIunits.MassFlowRate mb_flow = 0.0
                                                          "Mass flows across boundaries";
      Modelica.SIunits.EnthalpyFlowRate Hb_flow
                                               "Enthalpy flow across boundaries or energy source/sink";
      Modelica.SIunits.HeatFlowRate Qb_flow
                                           "Heat flow across boundaries or energy source/sink";
      constant Modelica.SIunits.Power Wb_flow = 0
                                                 "Work flow across boundaries or source term";
      constant Integer nPorts = 4
                                 "Number of ports";
    protected
      record 'ports[1]_rec'
        constant Modelica.Media.Interfaces.PartialMedium.MassFlowRate m_flow(quantity = "MassFlowRate.SimpleLiquidWater") = 0.0
                                                                                                                               "Mass flow rate from the connection point into the component";
        parameter Modelica.Media.Interfaces.Types.AbsolutePressure p(fixed=false)
                                                                                 "Thermodynamic pressure in the connection point";
        Modelica.Media.Interfaces.Types.SpecificEnthalpy h_outflow
                                                                  "Specific thermodynamic enthalpy close to the connection point if m_flow < 0";
      end 'ports[1]_rec';
    public
      'ports[1]_rec' 'ports[1]';
    protected
      record 'ports[2]_rec'
        Modelica.Media.Interfaces.PartialMedium.MassFlowRate m_flow(quantity = "MassFlowRate.SimpleLiquidWater")
                                                                                                                "Mass flow rate from the connection point into the component";
        parameter Modelica.Media.Interfaces.Types.AbsolutePressure p(fixed=false)
                                                                                 "Thermodynamic pressure in the connection point";
        Modelica.Media.Interfaces.Types.SpecificEnthalpy h_outflow
                                                                  "Specific thermodynamic enthalpy close to the connection point if m_flow < 0";
      end 'ports[2]_rec';
    public
      'ports[2]_rec' 'ports[2]';
    protected
      record 'ports[3]_rec'
        Modelica.Media.Interfaces.Types.AbsolutePressure p
                                                          "Thermodynamic pressure in the connection point";
        Modelica.Media.Interfaces.Types.SpecificEnthalpy h_outflow
                                                                  "Specific thermodynamic enthalpy close to the connection point if m_flow < 0";
      end 'ports[3]_rec';
    public
      'ports[3]_rec' 'ports[3]';
    protected
      record 'ports[4]_rec'
        constant Modelica.Media.Interfaces.PartialMedium.MassFlowRate m_flow(quantity = "MassFlowRate.SimpleLiquidWater") = 0.0
                                                                                                                               "Mass flow rate from the connection point into the component";
        parameter Modelica.Media.Interfaces.Types.AbsolutePressure p(fixed=false)
                                                                                 "Thermodynamic pressure in the connection point";
        Modelica.Media.Interfaces.Types.SpecificEnthalpy h_outflow
                                                                  "Specific thermodynamic enthalpy close to the connection point if m_flow < 0";
      end 'ports[4]_rec';
    public
      'ports[4]_rec' 'ports[4]';
      constant Boolean use_portsData = false
                                            "= false to neglect pressure loss and kinetic energy";
      parameter Modelica.Media.Interfaces.PartialMedium.MassFlowRate m_flow_nominal(quantity = "MassFlowRate.SimpleLiquidWater", fixed=false)
                                                                                                                                             "Nominal value for mass flow rates in ports";
      parameter Modelica.SIunits.MassFlowRate m_flow_small(min = 0.0, fixed=false)
                                                                                  "Regularization range at zero mass flow rate";
      constant Boolean use_Re = false
                                     "= true, if turbulent region is defined by Re, otherwise by m_flow_small";
      constant Modelica.Media.Interfaces.Types.EnthalpyFlowRate 'ports_H_flow[1]' = 0.0;
      Modelica.Media.Interfaces.Types.EnthalpyFlowRate 'ports_H_flow[2]';
      Modelica.Media.Interfaces.Types.EnthalpyFlowRate 'ports_H_flow[3]';
      constant Modelica.Media.Interfaces.Types.EnthalpyFlowRate 'ports_H_flow[4]' = 0.0;
      constant Boolean use_HeatTransfer = true
                                              "= true to use the HeatTransfer model";
    protected
      record heatTransfer_rec
        constant Integer n = 1
                              "Number of heat transfer segments";
      protected
        record 'states[1]_rec'
          Modelica.Media.Interfaces.Types.AbsolutePressure p
                                                            "Absolute pressure of medium";
          Modelica.Media.Interfaces.Types.Temperature T
                                                       "Temperature of medium";
        end 'states[1]_rec';
      public
        'states[1]_rec' 'states[1]';
        parameter Modelica.SIunits.Area 'surfaceAreas[1]'(fixed=false)
                                                                      "Heat transfer areas";
        Modelica.SIunits.HeatFlowRate 'Q_flows[1]'
                                                  "Heat flow rates";
        constant Boolean use_k = true
                                     "= true to use k value for thermal isolation";
        constant Modelica.SIunits.CoefficientOfHeatTransfer k = 0
                                                                 "Heat transfer coefficient to ambient";
        parameter Modelica.SIunits.Temperature T_ambient(fixed=false)
                                                                     "Ambient temperature";
      protected
        record 'heatPorts[1]_rec'
          Modelica.SIunits.Temperature T
                                        "Port temperature";
          Modelica.SIunits.HeatFlowRate Q_flow
                                              "Heat flow rate (positive if flowing from outside into the component)";
        end 'heatPorts[1]_rec';
      public
        'heatPorts[1]_rec' 'heatPorts[1]';
        Modelica.SIunits.Temperature 'Ts[1]'
                                            "Temperatures defined by fluid states";
      end heatTransfer_rec;
    public
      heatTransfer_rec heatTransfer;
    protected
      record heatPort_rec
        Modelica.SIunits.Temperature T
                                      "Port temperature";
        Modelica.SIunits.HeatFlowRate Q_flow
                                            "Heat flow rate (positive if flowing from outside into the component)";
      end heatPort_rec;
    public
      heatPort_rec heatPort;
      constant Modelica.Media.Interfaces.Types.Density 'portInDensities[1]' = 995.586
                                                                                     "densities of the fluid at the device boundary";
      constant Modelica.Media.Interfaces.Types.Density 'portInDensities[2]' = 995.586
                                                                                     "densities of the fluid at the device boundary";
      constant Modelica.Media.Interfaces.Types.Density 'portInDensities[3]' = 995.586
                                                                                     "densities of the fluid at the device boundary";
      constant Modelica.Media.Interfaces.Types.Density 'portInDensities[4]' = 995.586
                                                                                     "densities of the fluid at the device boundary";
      constant Modelica.SIunits.Velocity 'portVelocities[1]' = 0.0
                                                                  "velocities of fluid flow at device boundary";
      constant Modelica.SIunits.Velocity 'portVelocities[2]' = 0.0
                                                                  "velocities of fluid flow at device boundary";
      constant Modelica.SIunits.Velocity 'portVelocities[3]' = 0.0
                                                                  "velocities of fluid flow at device boundary";
      constant Modelica.SIunits.Velocity 'portVelocities[4]' = 0.0
                                                                  "velocities of fluid flow at device boundary";
      constant Modelica.SIunits.EnergyFlowRate 'ports_E_flow[1]' = 0.0
                                                                      "flow of kinetic and potential energy at device boundary";
      constant Modelica.SIunits.EnergyFlowRate 'ports_E_flow[2]' = 0.0
                                                                      "flow of kinetic and potential energy at device boundary";
      constant Modelica.SIunits.EnergyFlowRate 'ports_E_flow[3]' = 0.0
                                                                      "flow of kinetic and potential energy at device boundary";
      constant Modelica.SIunits.EnergyFlowRate 'ports_E_flow[4]' = 0.0
                                                                      "flow of kinetic and potential energy at device boundary";
      constant Real 's[1]'(unit = "m") = 1.25
                                             "curve parameters for port flows vs. port pressures; for further details see, Modelica Tutorial: Ideal switching devices";
      constant Real 's[2]'(unit = "m") = 1.25
                                             "curve parameters for port flows vs. port pressures; for further details see, Modelica Tutorial: Ideal switching devices";
      constant Real 's[3]'(unit = "m") = 1.25
                                             "curve parameters for port flows vs. port pressures; for further details see, Modelica Tutorial: Ideal switching devices";
      constant Real 's[4]'(unit = "m") = 1.25
                                             "curve parameters for port flows vs. port pressures; for further details see, Modelica Tutorial: Ideal switching devices";
      constant Real 'ports_penetration[1]' = 1.0
                                                "penetration of port with fluid, depending on fluid level and port diameter";
      constant Real 'ports_penetration[2]' = 1.0
                                                "penetration of port with fluid, depending on fluid level and port diameter";
      constant Real 'ports_penetration[3]' = 1.0
                                                "penetration of port with fluid, depending on fluid level and port diameter";
      constant Real 'ports_penetration[4]' = 1.0
                                                "penetration of port with fluid, depending on fluid level and port diameter";
      constant Modelica.SIunits.Area 'portAreas[1]' = 0.0;
      constant Modelica.SIunits.Area 'portAreas[2]' = 0.0;
      constant Modelica.SIunits.Area 'portAreas[3]' = 0.0;
      constant Modelica.SIunits.Area 'portAreas[4]' = 0.0;
      Modelica.Media.Interfaces.Types.AbsolutePressure 'vessel_ps_static[1]'
                                                                            "static pressures inside the vessel at the height of the corresponding ports, zero flow velocity";
      Modelica.Media.Interfaces.Types.AbsolutePressure 'vessel_ps_static[2]'
                                                                            "static pressures inside the vessel at the height of the corresponding ports, zero flow velocity";
      Modelica.Media.Interfaces.Types.AbsolutePressure 'vessel_ps_static[3]'
                                                                            "static pressures inside the vessel at the height of the corresponding ports, zero flow velocity";
      Modelica.Media.Interfaces.Types.AbsolutePressure 'vessel_ps_static[4]'
                                                                            "static pressures inside the vessel at the height of the corresponding ports, zero flow velocity";
      constant Modelica.SIunits.ReynoldsNumber Re_turbulent = 100
                                                                 "cf. suddenExpansion";
      constant Modelica.SIunits.MassFlowRate 'm_flow_turbulent[1]' = 1E+060;
      constant Modelica.SIunits.MassFlowRate 'm_flow_turbulent[2]' = 1E+060;
      constant Modelica.SIunits.MassFlowRate 'm_flow_turbulent[3]' = 1E+060;
      constant Modelica.SIunits.MassFlowRate 'm_flow_turbulent[4]' = 1E+060;
      parameter Modelica.SIunits.Volume V(fixed=false)
                                                      "Volume";
      parameter Modelica.SIunits.Diameter d(fixed=false)
                                                        "diameter of the cylindrical tank";
      constant Modelica.SIunits.Height h = 1.25
                                               "Height of the cylindrical tank";
      parameter Modelica.SIunits.Height h_max(fixed=false)
                                                          "Maximun height occupied by the water";
    end 'volumeMiddle[1]_rec';
  public
    'volumeMiddle[1]_rec' 'volumeMiddle[1]' annotation(Dialog);
  protected
    record 'volumeMiddle[2]_rec'
      Modelica.SIunits.Volume fluidVolume
                                         "Volume";
      constant Modelica.Fluid.Types.Dynamics energyDynamics = Modelica.Fluid.Types.Dynamics.DynamicFreeInitial
                                                                                                              "Formulation of energy balance";
      constant Modelica.Fluid.Types.Dynamics massDynamics = Modelica.Fluid.Types.Dynamics.DynamicFreeInitial
                                                                                                            "Formulation of mass balance";
      constant Modelica.Fluid.Types.Dynamics substanceDynamics = Modelica.Fluid.Types.Dynamics.DynamicFreeInitial
                                                                                                                 "Formulation of substance balance";
      constant Modelica.Fluid.Types.Dynamics traceDynamics = Modelica.Fluid.Types.Dynamics.DynamicFreeInitial
                                                                                                             "Formulation of trace substance balance";
      parameter Modelica.Media.Interfaces.Types.AbsolutePressure p_start(fixed=false)
                                                                                     "Start value of pressure";
      constant Boolean use_T_start = true
                                         "= true, use T_start, otherwise h_start";
      parameter Modelica.Media.Interfaces.Types.Temperature T_start(fixed=false)
                                                                                "Start value of temperature";
      parameter Modelica.Media.Interfaces.Types.SpecificEnthalpy h_start(fixed=false)
                                                                                     "Start value of specific enthalpy";
      parameter Modelica.Media.Interfaces.Types.MassFraction 'X_start[1]' = 1.0
                                                                               "Start value of mass fractions m_i/m";
    protected
      record medium_rec
        parameter Real p(unit = "Pa", displayUnit = "bar", nominal = 100000.0, quantity = "Pressure", min = 0.0, max = 100000000.0, fixed=false)
                                                                                                                                                "Absolute pressure of medium";
        Real h(unit = "J/kg", quantity = "SpecificEnergy")
                                                          "Specific enthalpy of medium";
        constant Modelica.Media.Interfaces.Types.Density d = 995.586
                                                                    "Density of medium";
        Modelica.Media.Interfaces.Types.Temperature T
                                                     "Temperature of medium";
        Real T_der(unit = "K/s")
                                "der(Temperature of medium)";
        constant Modelica.Media.Interfaces.Types.MassFraction 'X[1]' = 1.0
                                                                          "Mass fractions (= (component mass)/total mass  m_i/m)";
        Modelica.Media.Interfaces.Types.SpecificInternalEnergy u
                                                                "Specific internal energy of medium";
        Real u_der(unit = "m2/s3")
                                  "der(Specific internal energy of medium)";
        constant Modelica.Media.Interfaces.Types.SpecificHeatCapacity R = 0
                                                                           "Gas constant (of mixture if applicable)";
        constant Modelica.Media.Interfaces.Types.MolarMass MM = 0.018015268
                                                                           "Molar mass (of mixture or single fluid)";
      protected
        record state_rec
          Modelica.Media.Interfaces.Types.AbsolutePressure p
                                                            "Absolute pressure of medium";
          Modelica.Media.Interfaces.Types.Temperature T
                                                       "Temperature of medium";
        end state_rec;
      public
        state_rec state;
        constant Boolean preferredMediumStates = true
                                                     "= true if StateSelect.prefer shall be used for the independent property variables of the medium";
        constant Boolean standardOrderComponents = true
                                                       "If true, and reducedX = true, the last element of X will be computed from the other ones";
        Modelica.SIunits.Conversions.NonSIunits.Temperature_degC T_degC
                                                                       "Temperature of medium in [degC]";
        parameter Modelica.SIunits.Conversions.NonSIunits.Pressure_bar p_bar(fixed=false)
                                                                                         "Absolute pressure of medium in [bar]";
      end medium_rec;
    public
      medium_rec medium;
      Modelica.SIunits.Energy U
                               "Internal energy of fluid";
      Real U_der(unit = "W")
                            "der(Internal energy of fluid)";
      parameter Modelica.SIunits.Mass m(fixed=false)
                                                    "Mass of fluid";
      constant Real m_der(unit = "kg/s") = 0.0
                                              "der(Mass of fluid)";
      constant Modelica.SIunits.MassFlowRate mb_flow = 0.0
                                                          "Mass flows across boundaries";
      Modelica.SIunits.EnthalpyFlowRate Hb_flow
                                               "Enthalpy flow across boundaries or energy source/sink";
      Modelica.SIunits.HeatFlowRate Qb_flow
                                           "Heat flow across boundaries or energy source/sink";
      constant Modelica.SIunits.Power Wb_flow = 0
                                                 "Work flow across boundaries or source term";
      constant Integer nPorts = 4
                                 "Number of ports";
    protected
      record 'ports[1]_rec'
        constant Modelica.Media.Interfaces.PartialMedium.MassFlowRate m_flow(quantity = "MassFlowRate.SimpleLiquidWater") = 0.0
                                                                                                                               "Mass flow rate from the connection point into the component";
        parameter Modelica.Media.Interfaces.Types.AbsolutePressure p(fixed=false)
                                                                                 "Thermodynamic pressure in the connection point";
        Modelica.Media.Interfaces.Types.SpecificEnthalpy h_outflow
                                                                  "Specific thermodynamic enthalpy close to the connection point if m_flow < 0";
      end 'ports[1]_rec';
    public
      'ports[1]_rec' 'ports[1]';
    protected
      record 'ports[2]_rec'
        Modelica.Media.Interfaces.PartialMedium.MassFlowRate m_flow(quantity = "MassFlowRate.SimpleLiquidWater")
                                                                                                                "Mass flow rate from the connection point into the component";
        Modelica.Media.Interfaces.Types.AbsolutePressure p
                                                          "Thermodynamic pressure in the connection point";
        Modelica.Media.Interfaces.Types.SpecificEnthalpy h_outflow
                                                                  "Specific thermodynamic enthalpy close to the connection point if m_flow < 0";
      end 'ports[2]_rec';
    public
      'ports[2]_rec' 'ports[2]';
    protected
      record 'ports[3]_rec'
        Modelica.Media.Interfaces.Types.AbsolutePressure p
                                                          "Thermodynamic pressure in the connection point";
        Modelica.Media.Interfaces.Types.SpecificEnthalpy h_outflow
                                                                  "Specific thermodynamic enthalpy close to the connection point if m_flow < 0";
      end 'ports[3]_rec';
    public
      'ports[3]_rec' 'ports[3]';
    protected
      record 'ports[4]_rec'
        constant Modelica.Media.Interfaces.PartialMedium.MassFlowRate m_flow(quantity = "MassFlowRate.SimpleLiquidWater") = 0.0
                                                                                                                               "Mass flow rate from the connection point into the component";
        parameter Modelica.Media.Interfaces.Types.AbsolutePressure p(fixed=false)
                                                                                 "Thermodynamic pressure in the connection point";
        Modelica.Media.Interfaces.Types.SpecificEnthalpy h_outflow
                                                                  "Specific thermodynamic enthalpy close to the connection point if m_flow < 0";
      end 'ports[4]_rec';
    public
      'ports[4]_rec' 'ports[4]';
      constant Boolean use_portsData = false
                                            "= false to neglect pressure loss and kinetic energy";
      parameter Modelica.Media.Interfaces.PartialMedium.MassFlowRate m_flow_nominal(quantity = "MassFlowRate.SimpleLiquidWater", fixed=false)
                                                                                                                                             "Nominal value for mass flow rates in ports";
      parameter Modelica.SIunits.MassFlowRate m_flow_small(min = 0.0, fixed=false)
                                                                                  "Regularization range at zero mass flow rate";
      constant Boolean use_Re = false
                                     "= true, if turbulent region is defined by Re, otherwise by m_flow_small";
      constant Modelica.Media.Interfaces.Types.EnthalpyFlowRate 'ports_H_flow[1]' = 0.0;
      Modelica.Media.Interfaces.Types.EnthalpyFlowRate 'ports_H_flow[2]';
      Modelica.Media.Interfaces.Types.EnthalpyFlowRate 'ports_H_flow[3]';
      constant Modelica.Media.Interfaces.Types.EnthalpyFlowRate 'ports_H_flow[4]' = 0.0;
      constant Boolean use_HeatTransfer = true
                                              "= true to use the HeatTransfer model";
    protected
      record heatTransfer_rec
        constant Integer n = 1
                              "Number of heat transfer segments";
      protected
        record 'states[1]_rec'
          Modelica.Media.Interfaces.Types.AbsolutePressure p
                                                            "Absolute pressure of medium";
          Modelica.Media.Interfaces.Types.Temperature T
                                                       "Temperature of medium";
        end 'states[1]_rec';
      public
        'states[1]_rec' 'states[1]';
        parameter Modelica.SIunits.Area 'surfaceAreas[1]'(fixed=false)
                                                                      "Heat transfer areas";
        Modelica.SIunits.HeatFlowRate 'Q_flows[1]'
                                                  "Heat flow rates";
        constant Boolean use_k = true
                                     "= true to use k value for thermal isolation";
        constant Modelica.SIunits.CoefficientOfHeatTransfer k = 0
                                                                 "Heat transfer coefficient to ambient";
        parameter Modelica.SIunits.Temperature T_ambient(fixed=false)
                                                                     "Ambient temperature";
      protected
        record 'heatPorts[1]_rec'
          Modelica.SIunits.Temperature T
                                        "Port temperature";
          Modelica.SIunits.HeatFlowRate Q_flow
                                              "Heat flow rate (positive if flowing from outside into the component)";
        end 'heatPorts[1]_rec';
      public
        'heatPorts[1]_rec' 'heatPorts[1]';
        Modelica.SIunits.Temperature 'Ts[1]'
                                            "Temperatures defined by fluid states";
      end heatTransfer_rec;
    public
      heatTransfer_rec heatTransfer;
    protected
      record heatPort_rec
        Modelica.SIunits.Temperature T
                                      "Port temperature";
        Modelica.SIunits.HeatFlowRate Q_flow
                                            "Heat flow rate (positive if flowing from outside into the component)";
      end heatPort_rec;
    public
      heatPort_rec heatPort;
      constant Modelica.Media.Interfaces.Types.Density 'portInDensities[1]' = 995.586
                                                                                     "densities of the fluid at the device boundary";
      constant Modelica.Media.Interfaces.Types.Density 'portInDensities[2]' = 995.586
                                                                                     "densities of the fluid at the device boundary";
      constant Modelica.Media.Interfaces.Types.Density 'portInDensities[3]' = 995.586
                                                                                     "densities of the fluid at the device boundary";
      constant Modelica.Media.Interfaces.Types.Density 'portInDensities[4]' = 995.586
                                                                                     "densities of the fluid at the device boundary";
      constant Modelica.SIunits.Velocity 'portVelocities[1]' = 0.0
                                                                  "velocities of fluid flow at device boundary";
      constant Modelica.SIunits.Velocity 'portVelocities[2]' = 0.0
                                                                  "velocities of fluid flow at device boundary";
      constant Modelica.SIunits.Velocity 'portVelocities[3]' = 0.0
                                                                  "velocities of fluid flow at device boundary";
      constant Modelica.SIunits.Velocity 'portVelocities[4]' = 0.0
                                                                  "velocities of fluid flow at device boundary";
      constant Modelica.SIunits.EnergyFlowRate 'ports_E_flow[1]' = 0.0
                                                                      "flow of kinetic and potential energy at device boundary";
      constant Modelica.SIunits.EnergyFlowRate 'ports_E_flow[2]' = 0.0
                                                                      "flow of kinetic and potential energy at device boundary";
      constant Modelica.SIunits.EnergyFlowRate 'ports_E_flow[3]' = 0.0
                                                                      "flow of kinetic and potential energy at device boundary";
      constant Modelica.SIunits.EnergyFlowRate 'ports_E_flow[4]' = 0.0
                                                                      "flow of kinetic and potential energy at device boundary";
      constant Real 's[1]'(unit = "m") = 1.25
                                             "curve parameters for port flows vs. port pressures; for further details see, Modelica Tutorial: Ideal switching devices";
      constant Real 's[2]'(unit = "m") = 1.25
                                             "curve parameters for port flows vs. port pressures; for further details see, Modelica Tutorial: Ideal switching devices";
      constant Real 's[3]'(unit = "m") = 1.25
                                             "curve parameters for port flows vs. port pressures; for further details see, Modelica Tutorial: Ideal switching devices";
      constant Real 's[4]'(unit = "m") = 1.25
                                             "curve parameters for port flows vs. port pressures; for further details see, Modelica Tutorial: Ideal switching devices";
      constant Real 'ports_penetration[1]' = 1.0
                                                "penetration of port with fluid, depending on fluid level and port diameter";
      constant Real 'ports_penetration[2]' = 1.0
                                                "penetration of port with fluid, depending on fluid level and port diameter";
      constant Real 'ports_penetration[3]' = 1.0
                                                "penetration of port with fluid, depending on fluid level and port diameter";
      constant Real 'ports_penetration[4]' = 1.0
                                                "penetration of port with fluid, depending on fluid level and port diameter";
      constant Modelica.SIunits.Area 'portAreas[1]' = 0.0;
      constant Modelica.SIunits.Area 'portAreas[2]' = 0.0;
      constant Modelica.SIunits.Area 'portAreas[3]' = 0.0;
      constant Modelica.SIunits.Area 'portAreas[4]' = 0.0;
      Modelica.Media.Interfaces.Types.AbsolutePressure 'vessel_ps_static[1]'
                                                                            "static pressures inside the vessel at the height of the corresponding ports, zero flow velocity";
      Modelica.Media.Interfaces.Types.AbsolutePressure 'vessel_ps_static[2]'
                                                                            "static pressures inside the vessel at the height of the corresponding ports, zero flow velocity";
      Modelica.Media.Interfaces.Types.AbsolutePressure 'vessel_ps_static[3]'
                                                                            "static pressures inside the vessel at the height of the corresponding ports, zero flow velocity";
      Modelica.Media.Interfaces.Types.AbsolutePressure 'vessel_ps_static[4]'
                                                                            "static pressures inside the vessel at the height of the corresponding ports, zero flow velocity";
      constant Modelica.SIunits.ReynoldsNumber Re_turbulent = 100
                                                                 "cf. suddenExpansion";
      constant Modelica.SIunits.MassFlowRate 'm_flow_turbulent[1]' = 1E+060;
      constant Modelica.SIunits.MassFlowRate 'm_flow_turbulent[2]' = 1E+060;
      constant Modelica.SIunits.MassFlowRate 'm_flow_turbulent[3]' = 1E+060;
      constant Modelica.SIunits.MassFlowRate 'm_flow_turbulent[4]' = 1E+060;
      parameter Modelica.SIunits.Volume V(fixed=false)
                                                      "Volume";
      parameter Modelica.SIunits.Diameter d(fixed=false)
                                                        "diameter of the cylindrical tank";
      constant Modelica.SIunits.Height h = 1.25
                                               "Height of the cylindrical tank";
      parameter Modelica.SIunits.Height h_max(fixed=false)
                                                          "Maximun height occupied by the water";
    end 'volumeMiddle[2]_rec';
  public
    'volumeMiddle[2]_rec' 'volumeMiddle[2]' annotation(Dialog);
  protected
    record volumeBottom_rec
      Modelica.SIunits.Volume fluidVolume
                                         "Volume";
      constant Modelica.Fluid.Types.Dynamics energyDynamics = Modelica.Fluid.Types.Dynamics.DynamicFreeInitial
                                                                                                              "Formulation of energy balance";
      constant Modelica.Fluid.Types.Dynamics massDynamics = Modelica.Fluid.Types.Dynamics.DynamicFreeInitial
                                                                                                            "Formulation of mass balance";
      constant Modelica.Fluid.Types.Dynamics substanceDynamics = Modelica.Fluid.Types.Dynamics.DynamicFreeInitial
                                                                                                                 "Formulation of substance balance";
      constant Modelica.Fluid.Types.Dynamics traceDynamics = Modelica.Fluid.Types.Dynamics.DynamicFreeInitial
                                                                                                             "Formulation of trace substance balance";
      parameter Modelica.Media.Interfaces.Types.AbsolutePressure p_start(fixed=false)
                                                                                     "Start value of pressure";
      constant Boolean use_T_start = true
                                         "= true, use T_start, otherwise h_start";
      parameter Modelica.Media.Interfaces.Types.Temperature T_start(fixed=false)
                                                                                "Start value of temperature";
      parameter Modelica.Media.Interfaces.Types.SpecificEnthalpy h_start(fixed=false)
                                                                                     "Start value of specific enthalpy";
      parameter Modelica.Media.Interfaces.Types.MassFraction 'X_start[1]' = 1.0
                                                                               "Start value of mass fractions m_i/m";
    protected
      record medium_rec
        parameter Real p(unit = "Pa", displayUnit = "bar", nominal = 100000.0, quantity = "Pressure", min = 0.0, max = 100000000.0, fixed=false)
                                                                                                                                                "Absolute pressure of medium";
        Real h(unit = "J/kg", quantity = "SpecificEnergy")
                                                          "Specific enthalpy of medium";
        constant Modelica.Media.Interfaces.Types.Density d = 995.586
                                                                    "Density of medium";
        Modelica.Media.Interfaces.Types.Temperature T
                                                     "Temperature of medium";
        Real T_der(unit = "K/s")
                                "der(Temperature of medium)";
        constant Modelica.Media.Interfaces.Types.MassFraction 'X[1]' = 1.0
                                                                          "Mass fractions (= (component mass)/total mass  m_i/m)";
        Modelica.Media.Interfaces.Types.SpecificInternalEnergy u
                                                                "Specific internal energy of medium";
        Real u_der(unit = "m2/s3")
                                  "der(Specific internal energy of medium)";
        constant Modelica.Media.Interfaces.Types.SpecificHeatCapacity R = 0
                                                                           "Gas constant (of mixture if applicable)";
        constant Modelica.Media.Interfaces.Types.MolarMass MM = 0.018015268
                                                                           "Molar mass (of mixture or single fluid)";
      protected
        record state_rec
          Modelica.Media.Interfaces.Types.AbsolutePressure p
                                                            "Absolute pressure of medium";
          Modelica.Media.Interfaces.Types.Temperature T
                                                       "Temperature of medium";
        end state_rec;
      public
        state_rec state;
        constant Boolean preferredMediumStates = true
                                                     "= true if StateSelect.prefer shall be used for the independent property variables of the medium";
        constant Boolean standardOrderComponents = true
                                                       "If true, and reducedX = true, the last element of X will be computed from the other ones";
        Modelica.SIunits.Conversions.NonSIunits.Temperature_degC T_degC
                                                                       "Temperature of medium in [degC]";
        parameter Modelica.SIunits.Conversions.NonSIunits.Pressure_bar p_bar(fixed=false)
                                                                                         "Absolute pressure of medium in [bar]";
      end medium_rec;
    public
      medium_rec medium;
      Modelica.SIunits.Energy U
                               "Internal energy of fluid";
      Real U_der(unit = "W")
                            "der(Internal energy of fluid)";
      parameter Modelica.SIunits.Mass m(fixed=false)
                                                    "Mass of fluid";
      constant Real m_der(unit = "kg/s") = 0.0
                                              "der(Mass of fluid)";
      constant Modelica.SIunits.MassFlowRate mb_flow = 0.0
                                                          "Mass flows across boundaries";
      Modelica.SIunits.EnthalpyFlowRate Hb_flow
                                               "Enthalpy flow across boundaries or energy source/sink";
      Modelica.SIunits.HeatFlowRate Qb_flow
                                           "Heat flow across boundaries or energy source/sink";
      constant Modelica.SIunits.Power Wb_flow = 0
                                                 "Work flow across boundaries or source term";
      constant Integer nPorts = 3
                                 "Number of ports";
    protected
      record 'ports[1]_rec'
        constant Modelica.Media.Interfaces.PartialMedium.MassFlowRate m_flow(quantity = "MassFlowRate.SimpleLiquidWater") = 0.0
                                                                                                                               "Mass flow rate from the connection point into the component";
        parameter Modelica.Media.Interfaces.Types.AbsolutePressure p(fixed=false)
                                                                                 "Thermodynamic pressure in the connection point";
        Modelica.Media.Interfaces.Types.SpecificEnthalpy h_outflow
                                                                  "Specific thermodynamic enthalpy close to the connection point if m_flow < 0";
      end 'ports[1]_rec';
    public
      'ports[1]_rec' 'ports[1]';
    protected
      record 'ports[2]_rec'
        Modelica.Media.Interfaces.Types.AbsolutePressure p
                                                          "Thermodynamic pressure in the connection point";
        Modelica.Media.Interfaces.Types.SpecificEnthalpy h_outflow
                                                                  "Specific thermodynamic enthalpy close to the connection point if m_flow < 0";
      end 'ports[2]_rec';
    public
      'ports[2]_rec' 'ports[2]';
    protected
      record 'ports[3]_rec'
        Modelica.Media.Interfaces.PartialMedium.MassFlowRate m_flow(quantity = "MassFlowRate.SimpleLiquidWater")
                                                                                                                "Mass flow rate from the connection point into the component";
        parameter Modelica.Media.Interfaces.Types.AbsolutePressure p(fixed=false)
                                                                                 "Thermodynamic pressure in the connection point";
        Modelica.Media.Interfaces.Types.SpecificEnthalpy h_outflow
                                                                  "Specific thermodynamic enthalpy close to the connection point if m_flow < 0";
      end 'ports[3]_rec';
    public
      'ports[3]_rec' 'ports[3]';
      constant Boolean use_portsData = false
                                            "= false to neglect pressure loss and kinetic energy";
      parameter Modelica.Media.Interfaces.PartialMedium.MassFlowRate m_flow_nominal(quantity = "MassFlowRate.SimpleLiquidWater", fixed=false)
                                                                                                                                             "Nominal value for mass flow rates in ports";
      parameter Modelica.SIunits.MassFlowRate m_flow_small(min = 0.0, fixed=false)
                                                                                  "Regularization range at zero mass flow rate";
      constant Boolean use_Re = false
                                     "= true, if turbulent region is defined by Re, otherwise by m_flow_small";
      constant Modelica.Media.Interfaces.Types.EnthalpyFlowRate 'ports_H_flow[1]' = 0.0;
      Modelica.Media.Interfaces.Types.EnthalpyFlowRate 'ports_H_flow[2]';
      Modelica.Media.Interfaces.Types.EnthalpyFlowRate 'ports_H_flow[3]';
      constant Boolean use_HeatTransfer = true
                                              "= true to use the HeatTransfer model";
    protected
      record heatTransfer_rec
        constant Integer n = 1
                              "Number of heat transfer segments";
      protected
        record 'states[1]_rec'
          Modelica.Media.Interfaces.Types.AbsolutePressure p
                                                            "Absolute pressure of medium";
          Modelica.Media.Interfaces.Types.Temperature T
                                                       "Temperature of medium";
        end 'states[1]_rec';
      public
        'states[1]_rec' 'states[1]';
        parameter Modelica.SIunits.Area 'surfaceAreas[1]'(fixed=false)
                                                                      "Heat transfer areas";
        Modelica.SIunits.HeatFlowRate 'Q_flows[1]'
                                                  "Heat flow rates";
        constant Boolean use_k = true
                                     "= true to use k value for thermal isolation";
        constant Modelica.SIunits.CoefficientOfHeatTransfer k = 0
                                                                 "Heat transfer coefficient to ambient";
        parameter Modelica.SIunits.Temperature T_ambient(fixed=false)
                                                                     "Ambient temperature";
      protected
        record 'heatPorts[1]_rec'
          Modelica.SIunits.Temperature T
                                        "Port temperature";
          Modelica.SIunits.HeatFlowRate Q_flow
                                              "Heat flow rate (positive if flowing from outside into the component)";
        end 'heatPorts[1]_rec';
      public
        'heatPorts[1]_rec' 'heatPorts[1]';
        Modelica.SIunits.Temperature 'Ts[1]'
                                            "Temperatures defined by fluid states";
      end heatTransfer_rec;
    public
      heatTransfer_rec heatTransfer;
    protected
      record heatPort_rec
        Modelica.SIunits.Temperature T
                                      "Port temperature";
        Modelica.SIunits.HeatFlowRate Q_flow
                                            "Heat flow rate (positive if flowing from outside into the component)";
      end heatPort_rec;
    public
      heatPort_rec heatPort;
      constant Modelica.Media.Interfaces.Types.Density 'portInDensities[1]' = 995.586
                                                                                     "densities of the fluid at the device boundary";
      constant Modelica.Media.Interfaces.Types.Density 'portInDensities[2]' = 995.586
                                                                                     "densities of the fluid at the device boundary";
      constant Modelica.Media.Interfaces.Types.Density 'portInDensities[3]' = 995.586
                                                                                     "densities of the fluid at the device boundary";
      constant Modelica.SIunits.Velocity 'portVelocities[1]' = 0.0
                                                                  "velocities of fluid flow at device boundary";
      constant Modelica.SIunits.Velocity 'portVelocities[2]' = 0.0
                                                                  "velocities of fluid flow at device boundary";
      constant Modelica.SIunits.Velocity 'portVelocities[3]' = 0.0
                                                                  "velocities of fluid flow at device boundary";
      constant Modelica.SIunits.EnergyFlowRate 'ports_E_flow[1]' = 0.0
                                                                      "flow of kinetic and potential energy at device boundary";
      constant Modelica.SIunits.EnergyFlowRate 'ports_E_flow[2]' = 0.0
                                                                      "flow of kinetic and potential energy at device boundary";
      constant Modelica.SIunits.EnergyFlowRate 'ports_E_flow[3]' = 0.0
                                                                      "flow of kinetic and potential energy at device boundary";
      constant Real 's[1]'(unit = "m") = 1.25
                                             "curve parameters for port flows vs. port pressures; for further details see, Modelica Tutorial: Ideal switching devices";
      constant Real 's[2]'(unit = "m") = 1.25
                                             "curve parameters for port flows vs. port pressures; for further details see, Modelica Tutorial: Ideal switching devices";
      constant Real 's[3]'(unit = "m") = 1.25
                                             "curve parameters for port flows vs. port pressures; for further details see, Modelica Tutorial: Ideal switching devices";
      constant Real 'ports_penetration[1]' = 1.0
                                                "penetration of port with fluid, depending on fluid level and port diameter";
      constant Real 'ports_penetration[2]' = 1.0
                                                "penetration of port with fluid, depending on fluid level and port diameter";
      constant Real 'ports_penetration[3]' = 1.0
                                                "penetration of port with fluid, depending on fluid level and port diameter";
      constant Modelica.SIunits.Area 'portAreas[1]' = 0.0;
      constant Modelica.SIunits.Area 'portAreas[2]' = 0.0;
      constant Modelica.SIunits.Area 'portAreas[3]' = 0.0;
      Modelica.Media.Interfaces.Types.AbsolutePressure 'vessel_ps_static[1]'
                                                                            "static pressures inside the vessel at the height of the corresponding ports, zero flow velocity";
      Modelica.Media.Interfaces.Types.AbsolutePressure 'vessel_ps_static[2]'
                                                                            "static pressures inside the vessel at the height of the corresponding ports, zero flow velocity";
      Modelica.Media.Interfaces.Types.AbsolutePressure 'vessel_ps_static[3]'
                                                                            "static pressures inside the vessel at the height of the corresponding ports, zero flow velocity";
      constant Modelica.SIunits.ReynoldsNumber Re_turbulent = 100
                                                                 "cf. suddenExpansion";
      constant Modelica.SIunits.MassFlowRate 'm_flow_turbulent[1]' = 1E+060;
      constant Modelica.SIunits.MassFlowRate 'm_flow_turbulent[2]' = 1E+060;
      constant Modelica.SIunits.MassFlowRate 'm_flow_turbulent[3]' = 1E+060;
      parameter Modelica.SIunits.Volume V(fixed=false)
                                                      "Volume";
      parameter Modelica.SIunits.Diameter d(fixed=false)
                                                        "diameter of the cylindrical tank";
      constant Modelica.SIunits.Height h = 1.25
                                               "Height of the cylindrical tank";
      parameter Modelica.SIunits.Height h_max(fixed=false)
                                                          "Maximun height occupied by the water";
    end volumeBottom_rec;
  public
    volumeBottom_rec volumeBottom annotation(Dialog);
  protected
    record topCond_rec
      Modelica.SIunits.HeatFlowRate Q_flow
                                          "Heat flow rate from port_a -> port_b";
      Modelica.SIunits.TemperatureDifference dT
                                               "port_a.T - port_b.T";
    protected
      record port_a_rec
        Modelica.SIunits.Temperature T
                                      "Port temperature";
        Modelica.SIunits.HeatFlowRate Q_flow
                                            "Heat flow rate (positive if flowing from outside into the component)";
      end port_a_rec;
    public
      port_a_rec port_a;
    protected
      record port_b_rec
        Modelica.SIunits.Temperature T
                                      "Port temperature";
        Modelica.SIunits.HeatFlowRate Q_flow
                                            "Heat flow rate (positive if flowing from outside into the component)";
      end port_b_rec;
    public
      port_b_rec port_b;
      Modelica.SIunits.Temperature T
                                    "Average temperature of element";
      parameter Modelica.SIunits.Temperature T_start = 293.15
                                                             "Start temperature for the average temperature of element";
      Modelica.SIunits.ThermalConductance G
                                           "Thermal conductance of material";
      Modelica.SIunits.ThermalConductivity k
                                            "Thermal conductivity";
      parameter Modelica.SIunits.Length L(fixed=false)
                                                      "length of conduction";
      parameter Modelica.SIunits.Area A(fixed=false)
                                                    "Heat transfer area";
    end topCond_rec;
  public
    topCond_rec topCond annotation(Dialog);
  protected
    record 'middleCond[1]_rec'
      Modelica.SIunits.HeatFlowRate Q_flow
                                          "Heat flow rate from port_a -> port_b";
      Modelica.SIunits.TemperatureDifference dT
                                               "port_a.T - port_b.T";
    protected
      record port_a_rec
        Modelica.SIunits.Temperature T
                                      "Port temperature";
        Modelica.SIunits.HeatFlowRate Q_flow
                                            "Heat flow rate (positive if flowing from outside into the component)";
      end port_a_rec;
    public
      port_a_rec port_a;
    protected
      record port_b_rec
        Modelica.SIunits.Temperature T
                                      "Port temperature";
        Modelica.SIunits.HeatFlowRate Q_flow
                                            "Heat flow rate (positive if flowing from outside into the component)";
      end port_b_rec;
    public
      port_b_rec port_b;
      Modelica.SIunits.Temperature T
                                    "Average temperature of element";
      parameter Modelica.SIunits.Temperature T_start = 293.15
                                                             "Start temperature for the average temperature of element";
      Modelica.SIunits.ThermalConductance G
                                           "Thermal conductance of material";
      Modelica.SIunits.ThermalConductivity k
                                            "Thermal conductivity";
      parameter Modelica.SIunits.Length L(fixed=false)
                                                      "length of conduction";
      parameter Modelica.SIunits.Area A(fixed=false)
                                                    "Heat transfer area";
    end 'middleCond[1]_rec';
  public
    'middleCond[1]_rec' 'middleCond[1]' annotation(Dialog);
  protected
    record 'middleCond[2]_rec'
      Modelica.SIunits.HeatFlowRate Q_flow
                                          "Heat flow rate from port_a -> port_b";
      Modelica.SIunits.TemperatureDifference dT
                                               "port_a.T - port_b.T";
    protected
      record port_a_rec
        Modelica.SIunits.Temperature T
                                      "Port temperature";
        Modelica.SIunits.HeatFlowRate Q_flow
                                            "Heat flow rate (positive if flowing from outside into the component)";
      end port_a_rec;
    public
      port_a_rec port_a;
    protected
      record port_b_rec
        Modelica.SIunits.Temperature T
                                      "Port temperature";
        Modelica.SIunits.HeatFlowRate Q_flow
                                            "Heat flow rate (positive if flowing from outside into the component)";
      end port_b_rec;
    public
      port_b_rec port_b;
      Modelica.SIunits.Temperature T
                                    "Average temperature of element";
      parameter Modelica.SIunits.Temperature T_start = 293.15
                                                             "Start temperature for the average temperature of element";
      Modelica.SIunits.ThermalConductance G
                                           "Thermal conductance of material";
      Modelica.SIunits.ThermalConductivity k
                                            "Thermal conductivity";
      parameter Modelica.SIunits.Length L(fixed=false)
                                                      "length of conduction";
      parameter Modelica.SIunits.Area A(fixed=false)
                                                    "Heat transfer area";
    end 'middleCond[2]_rec';
  public
    'middleCond[2]_rec' 'middleCond[2]' annotation(Dialog);
  protected
    record 'middleCond[3]_rec'
      Modelica.SIunits.HeatFlowRate Q_flow
                                          "Heat flow rate from port_a -> port_b";
      Modelica.SIunits.TemperatureDifference dT
                                               "port_a.T - port_b.T";
    protected
      record port_a_rec
        Modelica.SIunits.Temperature T
                                      "Port temperature";
        Modelica.SIunits.HeatFlowRate Q_flow
                                            "Heat flow rate (positive if flowing from outside into the component)";
      end port_a_rec;
    public
      port_a_rec port_a;
    protected
      record port_b_rec
        Modelica.SIunits.Temperature T
                                      "Port temperature";
        Modelica.SIunits.HeatFlowRate Q_flow
                                            "Heat flow rate (positive if flowing from outside into the component)";
      end port_b_rec;
    public
      port_b_rec port_b;
      Modelica.SIunits.Temperature T
                                    "Average temperature of element";
      parameter Modelica.SIunits.Temperature T_start = 293.15
                                                             "Start temperature for the average temperature of element";
      Modelica.SIunits.ThermalConductance G
                                           "Thermal conductance of material";
      Modelica.SIunits.ThermalConductivity k
                                            "Thermal conductivity";
      parameter Modelica.SIunits.Length L(fixed=false)
                                                      "length of conduction";
      parameter Modelica.SIunits.Area A(fixed=false)
                                                    "Heat transfer area";
    end 'middleCond[3]_rec';
  public
    'middleCond[3]_rec' 'middleCond[3]' annotation(Dialog);
  protected
    record 'middleCond[4]_rec'
      Modelica.SIunits.HeatFlowRate Q_flow
                                          "Heat flow rate from port_a -> port_b";
      Modelica.SIunits.TemperatureDifference dT
                                               "port_a.T - port_b.T";
    protected
      record port_a_rec
        Modelica.SIunits.Temperature T
                                      "Port temperature";
        Modelica.SIunits.HeatFlowRate Q_flow
                                            "Heat flow rate (positive if flowing from outside into the component)";
      end port_a_rec;
    public
      port_a_rec port_a;
    protected
      record port_b_rec
        Modelica.SIunits.Temperature T
                                      "Port temperature";
        Modelica.SIunits.HeatFlowRate Q_flow
                                            "Heat flow rate (positive if flowing from outside into the component)";
      end port_b_rec;
    public
      port_b_rec port_b;
      Modelica.SIunits.Temperature T
                                    "Average temperature of element";
      parameter Modelica.SIunits.Temperature T_start = 293.15
                                                             "Start temperature for the average temperature of element";
      Modelica.SIunits.ThermalConductance G
                                           "Thermal conductance of material";
      Modelica.SIunits.ThermalConductivity k
                                            "Thermal conductivity";
      parameter Modelica.SIunits.Length L(fixed=false)
                                                      "length of conduction";
      parameter Modelica.SIunits.Area A(fixed=false)
                                                    "Heat transfer area";
    end 'middleCond[4]_rec';
  public
    'middleCond[4]_rec' 'middleCond[4]' annotation(Dialog);
  protected
    record bottomCond_rec
      Modelica.SIunits.HeatFlowRate Q_flow
                                          "Heat flow rate from port_a -> port_b";
      Modelica.SIunits.TemperatureDifference dT
                                               "port_a.T - port_b.T";
    protected
      record port_a_rec
        Modelica.SIunits.Temperature T
                                      "Port temperature";
        Modelica.SIunits.HeatFlowRate Q_flow
                                            "Heat flow rate (positive if flowing from outside into the component)";
      end port_a_rec;
    public
      port_a_rec port_a;
    protected
      record port_b_rec
        Modelica.SIunits.Temperature T
                                      "Port temperature";
        Modelica.SIunits.HeatFlowRate Q_flow
                                            "Heat flow rate (positive if flowing from outside into the component)";
      end port_b_rec;
    public
      port_b_rec port_b;
      Modelica.SIunits.Temperature T
                                    "Average temperature of element";
      parameter Modelica.SIunits.Temperature T_start = 293.15
                                                             "Start temperature for the average temperature of element";
      Modelica.SIunits.ThermalConductance G
                                           "Thermal conductance of material";
      Modelica.SIunits.ThermalConductivity k
                                            "Thermal conductivity";
      parameter Modelica.SIunits.Length L(fixed=false)
                                                      "length of conduction";
      parameter Modelica.SIunits.Area A(fixed=false)
                                                    "Heat transfer area";
    end bottomCond_rec;
  public
    bottomCond_rec bottomCond annotation(Dialog);
  protected
    record topConv_rec
      Modelica.SIunits.HeatFlowRate Q_flow
                                          "Heat flow rate from solid -> fluid";
      Modelica.SIunits.TemperatureDifference dT
                                               "= solid.T - fluid.T";
    protected
      record solid_rec
        Modelica.SIunits.Temperature T
                                      "Port temperature";
        Modelica.SIunits.HeatFlowRate Q_flow
                                            "Heat flow rate (positive if flowing from outside into the component)";
      end solid_rec;
    public
      solid_rec solid;
    protected
      record fluid_rec
        Modelica.SIunits.Temperature T
                                      "Port temperature";
        Modelica.SIunits.HeatFlowRate Q_flow
                                            "Heat flow rate (positive if flowing from outside into the component)";
      end fluid_rec;
    public
      fluid_rec fluid;
      parameter Modelica.SIunits.Area A(fixed=false)
                                                    "Convection area";
      Real Gc(unit = "W/K")
                           "Convective thermal conductance in [W/K]";
      Modelica.SIunits.CoefficientOfHeatTransfer h
                                                  "Convection heat transfer coefficient";
      Modelica.SIunits.CubicExpansionCoefficient beta;
      Modelica.SIunits.GrashofNumber Gr;
      Modelica.SIunits.RayleighNumber Ra;
      Modelica.SIunits.NusseltNumber NuL;
      Modelica.SIunits.NusseltNumber NuLa;
      Modelica.SIunits.NusseltNumber NuLb;
      constant Modelica.SIunits.PrandtlNumber Pr = 0.7038150000000001;
      Modelica.SIunits.KinematicViscosity visco;
      constant Modelica.SIunits.ThermalConductivity K = 0.026;
      parameter Modelica.SIunits.Temp_K _Tc_start = 293.15;
      Modelica.SIunits.Temp_K Tc(start = _Tc_start, fixed=false)
                                                                "Average temperature solid-fluid, characteristic temperature for correlation";
      parameter Modelica.SIunits.Length B(fixed=false)
                                                      "Perimeter of the plate";
      parameter Modelica.SIunits.Length L(fixed=false)
                                                      "Characteristic length, surface of the plate/perimeter";
      constant Boolean faceUp = true
                                    "true, if the heated plate is up";
      parameter Modelica.SIunits.Pressure P(fixed=false)
                                                        "pressure of the medium where the plate is immersed";
    end topConv_rec;
  public
    topConv_rec topConv annotation(Dialog);
  protected
    record 'middleConv[1]_rec'
      Modelica.SIunits.HeatFlowRate Q_flow
                                          "Heat flow rate from solid -> fluid";
      Modelica.SIunits.TemperatureDifference dT
                                               "= solid.T - fluid.T";
    protected
      record solid_rec
        Modelica.SIunits.Temperature T
                                      "Port temperature";
        Modelica.SIunits.HeatFlowRate Q_flow
                                            "Heat flow rate (positive if flowing from outside into the component)";
      end solid_rec;
    public
      solid_rec solid;
    protected
      record fluid_rec
        Modelica.SIunits.Temperature T
                                      "Port temperature";
        Modelica.SIunits.HeatFlowRate Q_flow
                                            "Heat flow rate (positive if flowing from outside into the component)";
      end fluid_rec;
    public
      fluid_rec fluid;
      parameter Modelica.SIunits.Area A(fixed=false)
                                                    "Convection area";
      Real Gc(unit = "W/K")
                           "Convective thermal conductance in [W/K]";
      Modelica.SIunits.CoefficientOfHeatTransfer h
                                                  "Convection heat transfer coefficient";
      parameter Modelica.SIunits.Length D(fixed=false)
                                                      "External diameter of the clinder";
      constant Modelica.SIunits.Length H = 1.25
                                               "Height of the cylinder";
      Modelica.SIunits.Temp_K Tm
                                "Mean temperature solid-fluid";
      Modelica.SIunits.KinematicViscosity visco
                                               "Kinematic viscosity of air at Tm";
      Modelica.SIunits.ThermalConductivity K
                                            "Conductivity of air at Tm";
      Modelica.SIunits.PrandtlNumber Pr
                                       "Prandtl number at Tm";
      Modelica.SIunits.RayleighNumber Ra;
      Modelica.SIunits.GrashofNumber Gr;
      Modelica.SIunits.CubicExpansionCoefficient beta;
      Modelica.SIunits.NusseltNumber Nu_nat;
      Modelica.SIunits.NusseltNumber Nu_nat1;
      Modelica.SIunits.NusseltNumber Nu_nat2;
    end 'middleConv[1]_rec';
  public
    'middleConv[1]_rec' 'middleConv[1]';
  protected
    record 'middleConv[2]_rec'
      Modelica.SIunits.HeatFlowRate Q_flow
                                          "Heat flow rate from solid -> fluid";
      Modelica.SIunits.TemperatureDifference dT
                                               "= solid.T - fluid.T";
    protected
      record solid_rec
        Modelica.SIunits.Temperature T
                                      "Port temperature";
        Modelica.SIunits.HeatFlowRate Q_flow
                                            "Heat flow rate (positive if flowing from outside into the component)";
      end solid_rec;
    public
      solid_rec solid;
    protected
      record fluid_rec
        Modelica.SIunits.Temperature T
                                      "Port temperature";
        Modelica.SIunits.HeatFlowRate Q_flow
                                            "Heat flow rate (positive if flowing from outside into the component)";
      end fluid_rec;
    public
      fluid_rec fluid;
      parameter Modelica.SIunits.Area A(fixed=false)
                                                    "Convection area";
      Real Gc(unit = "W/K")
                           "Convective thermal conductance in [W/K]";
      Modelica.SIunits.CoefficientOfHeatTransfer h
                                                  "Convection heat transfer coefficient";
      parameter Modelica.SIunits.Length D(fixed=false)
                                                      "External diameter of the clinder";
      constant Modelica.SIunits.Length H = 1.25
                                               "Height of the cylinder";
      Modelica.SIunits.Temp_K Tm
                                "Mean temperature solid-fluid";
      Modelica.SIunits.KinematicViscosity visco
                                               "Kinematic viscosity of air at Tm";
      Modelica.SIunits.ThermalConductivity K
                                            "Conductivity of air at Tm";
      Modelica.SIunits.PrandtlNumber Pr
                                       "Prandtl number at Tm";
      Modelica.SIunits.RayleighNumber Ra;
      Modelica.SIunits.GrashofNumber Gr;
      Modelica.SIunits.CubicExpansionCoefficient beta;
      Modelica.SIunits.NusseltNumber Nu_nat;
      Modelica.SIunits.NusseltNumber Nu_nat1;
      Modelica.SIunits.NusseltNumber Nu_nat2;
    end 'middleConv[2]_rec';
  public
    'middleConv[2]_rec' 'middleConv[2]';
  protected
    record 'middleConv[3]_rec'
      Modelica.SIunits.HeatFlowRate Q_flow
                                          "Heat flow rate from solid -> fluid";
      Modelica.SIunits.TemperatureDifference dT
                                               "= solid.T - fluid.T";
    protected
      record solid_rec
        Modelica.SIunits.Temperature T
                                      "Port temperature";
        Modelica.SIunits.HeatFlowRate Q_flow
                                            "Heat flow rate (positive if flowing from outside into the component)";
      end solid_rec;
    public
      solid_rec solid;
    protected
      record fluid_rec
        Modelica.SIunits.Temperature T
                                      "Port temperature";
        Modelica.SIunits.HeatFlowRate Q_flow
                                            "Heat flow rate (positive if flowing from outside into the component)";
      end fluid_rec;
    public
      fluid_rec fluid;
      parameter Modelica.SIunits.Area A(fixed=false)
                                                    "Convection area";
      Real Gc(unit = "W/K")
                           "Convective thermal conductance in [W/K]";
      Modelica.SIunits.CoefficientOfHeatTransfer h
                                                  "Convection heat transfer coefficient";
      parameter Modelica.SIunits.Length D(fixed=false)
                                                      "External diameter of the clinder";
      constant Modelica.SIunits.Length H = 1.25
                                               "Height of the cylinder";
      Modelica.SIunits.Temp_K Tm
                                "Mean temperature solid-fluid";
      Modelica.SIunits.KinematicViscosity visco
                                               "Kinematic viscosity of air at Tm";
      Modelica.SIunits.ThermalConductivity K
                                            "Conductivity of air at Tm";
      Modelica.SIunits.PrandtlNumber Pr
                                       "Prandtl number at Tm";
      Modelica.SIunits.RayleighNumber Ra;
      Modelica.SIunits.GrashofNumber Gr;
      Modelica.SIunits.CubicExpansionCoefficient beta;
      Modelica.SIunits.NusseltNumber Nu_nat;
      Modelica.SIunits.NusseltNumber Nu_nat1;
      Modelica.SIunits.NusseltNumber Nu_nat2;
    end 'middleConv[3]_rec';
  public
    'middleConv[3]_rec' 'middleConv[3]';
  protected
    record 'middleConv[4]_rec'
      Modelica.SIunits.HeatFlowRate Q_flow
                                          "Heat flow rate from solid -> fluid";
      Modelica.SIunits.TemperatureDifference dT
                                               "= solid.T - fluid.T";
    protected
      record solid_rec
        Modelica.SIunits.Temperature T
                                      "Port temperature";
        Modelica.SIunits.HeatFlowRate Q_flow
                                            "Heat flow rate (positive if flowing from outside into the component)";
      end solid_rec;
    public
      solid_rec solid;
    protected
      record fluid_rec
        Modelica.SIunits.Temperature T
                                      "Port temperature";
        Modelica.SIunits.HeatFlowRate Q_flow
                                            "Heat flow rate (positive if flowing from outside into the component)";
      end fluid_rec;
    public
      fluid_rec fluid;
      parameter Modelica.SIunits.Area A(fixed=false)
                                                    "Convection area";
      Real Gc(unit = "W/K")
                           "Convective thermal conductance in [W/K]";
      Modelica.SIunits.CoefficientOfHeatTransfer h
                                                  "Convection heat transfer coefficient";
      parameter Modelica.SIunits.Length D(fixed=false)
                                                      "External diameter of the clinder";
      constant Modelica.SIunits.Length H = 1.25
                                               "Height of the cylinder";
      Modelica.SIunits.Temp_K Tm
                                "Mean temperature solid-fluid";
      Modelica.SIunits.KinematicViscosity visco
                                               "Kinematic viscosity of air at Tm";
      Modelica.SIunits.ThermalConductivity K
                                            "Conductivity of air at Tm";
      Modelica.SIunits.PrandtlNumber Pr
                                       "Prandtl number at Tm";
      Modelica.SIunits.RayleighNumber Ra;
      Modelica.SIunits.GrashofNumber Gr;
      Modelica.SIunits.CubicExpansionCoefficient beta;
      Modelica.SIunits.NusseltNumber Nu_nat;
      Modelica.SIunits.NusseltNumber Nu_nat1;
      Modelica.SIunits.NusseltNumber Nu_nat2;
    end 'middleConv[4]_rec';
  public
    'middleConv[4]_rec' 'middleConv[4]';
  protected
    record bottomConv_rec
      Modelica.SIunits.HeatFlowRate Q_flow
                                          "Heat flow rate from solid -> fluid";
      Modelica.SIunits.TemperatureDifference dT
                                               "= solid.T - fluid.T";
    protected
      record solid_rec
        Modelica.SIunits.Temperature T
                                      "Port temperature";
        Modelica.SIunits.HeatFlowRate Q_flow
                                            "Heat flow rate (positive if flowing from outside into the component)";
      end solid_rec;
    public
      solid_rec solid;
    protected
      record fluid_rec
        Modelica.SIunits.Temperature T
                                      "Port temperature";
        Modelica.SIunits.HeatFlowRate Q_flow
                                            "Heat flow rate (positive if flowing from outside into the component)";
      end fluid_rec;
    public
      fluid_rec fluid;
      parameter Modelica.SIunits.Area A(fixed=false)
                                                    "Convection area";
      Real Gc(unit = "W/K")
                           "Convective thermal conductance in [W/K]";
      Modelica.SIunits.CoefficientOfHeatTransfer h
                                                  "Convection heat transfer coefficient";
      Modelica.SIunits.CubicExpansionCoefficient beta;
      Modelica.SIunits.GrashofNumber Gr;
      Modelica.SIunits.RayleighNumber Ra;
      Modelica.SIunits.NusseltNumber NuL;
      Modelica.SIunits.NusseltNumber NuL1;
      Modelica.SIunits.NusseltNumber NuL2;
      Modelica.SIunits.PrandtlNumber Pr;
      Modelica.SIunits.KinematicViscosity visco;
      Modelica.SIunits.ThermalConductivity K;
      Modelica.SIunits.Temp_K Tc
                                "Average temperature solid-fluid, characteristic temperature for correlation";
      parameter Modelica.SIunits.Length L(fixed=false)
                                                      "Characteristic length, length of the plate";
    end bottomConv_rec;
  public
    bottomConv_rec bottomConv;
  protected
    record 'condFluid[1]_rec'
      Modelica.SIunits.HeatFlowRate Q_flow
                                          "Heat flow rate from port_a -> port_b";
      Modelica.SIunits.TemperatureDifference dT
                                               "port_a.T - port_b.T";
    protected
      record port_a_rec
        Modelica.SIunits.Temperature T
                                      "Port temperature";
        Modelica.SIunits.HeatFlowRate Q_flow
                                            "Heat flow rate (positive if flowing from outside into the component)";
      end port_a_rec;
    public
      port_a_rec port_a;
    protected
      record port_b_rec
        Modelica.SIunits.Temperature T
                                      "Port temperature";
        Modelica.SIunits.HeatFlowRate Q_flow
                                            "Heat flow rate (positive if flowing from outside into the component)";
      end port_b_rec;
    public
      port_b_rec port_b;
      Modelica_Blocks_Interfaces_RealInput G(unit = "W/K")
                                                          "Constant thermal conductance of material";
    end 'condFluid[1]_rec';
  public
    'condFluid[1]_rec' 'condFluid[1]';
  protected
    record 'condFluid[2]_rec'
      Modelica.SIunits.HeatFlowRate Q_flow
                                          "Heat flow rate from port_a -> port_b";
      Modelica.SIunits.TemperatureDifference dT
                                               "port_a.T - port_b.T";
    protected
      record port_a_rec
        Modelica.SIunits.Temperature T
                                      "Port temperature";
        Modelica.SIunits.HeatFlowRate Q_flow
                                            "Heat flow rate (positive if flowing from outside into the component)";
      end port_a_rec;
    public
      port_a_rec port_a;
    protected
      record port_b_rec
        Modelica.SIunits.Temperature T
                                      "Port temperature";
        Modelica.SIunits.HeatFlowRate Q_flow
                                            "Heat flow rate (positive if flowing from outside into the component)";
      end port_b_rec;
    public
      port_b_rec port_b;
      Modelica_Blocks_Interfaces_RealInput G(unit = "W/K")
                                                          "Constant thermal conductance of material";
    end 'condFluid[2]_rec';
  public
    'condFluid[2]_rec' 'condFluid[2]';
  protected
    record 'condFluid[3]_rec'
      Modelica.SIunits.HeatFlowRate Q_flow
                                          "Heat flow rate from port_a -> port_b";
      Modelica.SIunits.TemperatureDifference dT
                                               "port_a.T - port_b.T";
    protected
      record port_a_rec
        Modelica.SIunits.Temperature T
                                      "Port temperature";
        Modelica.SIunits.HeatFlowRate Q_flow
                                            "Heat flow rate (positive if flowing from outside into the component)";
      end port_a_rec;
    public
      port_a_rec port_a;
    protected
      record port_b_rec
        Modelica.SIunits.Temperature T
                                      "Port temperature";
        Modelica.SIunits.HeatFlowRate Q_flow
                                            "Heat flow rate (positive if flowing from outside into the component)";
      end port_b_rec;
    public
      port_b_rec port_b;
      Modelica_Blocks_Interfaces_RealInput G(unit = "W/K")
                                                          "Constant thermal conductance of material";
    end 'condFluid[3]_rec';
  public
    'condFluid[3]_rec' 'condFluid[3]';
  protected
    record heatFlowTop_rec
      Modelica_Blocks_Interfaces_RealOutput Q_flow(unit = "W")
                                                              "Heat flow from port_a to port_b as output signal";
    protected
      record port_a_rec
        Modelica.SIunits.Temperature T
                                      "Port temperature";
        Modelica.SIunits.HeatFlowRate Q_flow
                                            "Heat flow rate (positive if flowing from outside into the component)";
      end port_a_rec;
    public
      port_a_rec port_a;
    protected
      record port_b_rec
        Modelica.SIunits.Temperature T
                                      "Port temperature";
        Modelica.SIunits.HeatFlowRate Q_flow
                                            "Heat flow rate (positive if flowing from outside into the component)";
      end port_b_rec;
    public
      port_b_rec port_b;
    end heatFlowTop_rec;
  public
    heatFlowTop_rec heatFlowTop;
  protected
    record 'heatFlowMiddle[1]_rec'
      Modelica_Blocks_Interfaces_RealOutput Q_flow(unit = "W")
                                                              "Heat flow from port_a to port_b as output signal";
    protected
      record port_a_rec
        Modelica.SIunits.Temperature T
                                      "Port temperature";
        Modelica.SIunits.HeatFlowRate Q_flow
                                            "Heat flow rate (positive if flowing from outside into the component)";
      end port_a_rec;
    public
      port_a_rec port_a;
    protected
      record port_b_rec
        Modelica.SIunits.Temperature T
                                      "Port temperature";
        Modelica.SIunits.HeatFlowRate Q_flow
                                            "Heat flow rate (positive if flowing from outside into the component)";
      end port_b_rec;
    public
      port_b_rec port_b;
    end 'heatFlowMiddle[1]_rec';
  public
    'heatFlowMiddle[1]_rec' 'heatFlowMiddle[1]';
  protected
    record 'heatFlowMiddle[2]_rec'
      Modelica_Blocks_Interfaces_RealOutput Q_flow(unit = "W")
                                                              "Heat flow from port_a to port_b as output signal";
    protected
      record port_a_rec
        Modelica.SIunits.Temperature T
                                      "Port temperature";
        Modelica.SIunits.HeatFlowRate Q_flow
                                            "Heat flow rate (positive if flowing from outside into the component)";
      end port_a_rec;
    public
      port_a_rec port_a;
    protected
      record port_b_rec
        Modelica.SIunits.Temperature T
                                      "Port temperature";
        Modelica.SIunits.HeatFlowRate Q_flow
                                            "Heat flow rate (positive if flowing from outside into the component)";
      end port_b_rec;
    public
      port_b_rec port_b;
    end 'heatFlowMiddle[2]_rec';
  public
    'heatFlowMiddle[2]_rec' 'heatFlowMiddle[2]';
  protected
    record 'heatFlowMiddle[3]_rec'
      Modelica_Blocks_Interfaces_RealOutput Q_flow(unit = "W")
                                                              "Heat flow from port_a to port_b as output signal";
    protected
      record port_a_rec
        Modelica.SIunits.Temperature T
                                      "Port temperature";
        Modelica.SIunits.HeatFlowRate Q_flow
                                            "Heat flow rate (positive if flowing from outside into the component)";
      end port_a_rec;
    public
      port_a_rec port_a;
    protected
      record port_b_rec
        Modelica.SIunits.Temperature T
                                      "Port temperature";
        Modelica.SIunits.HeatFlowRate Q_flow
                                            "Heat flow rate (positive if flowing from outside into the component)";
      end port_b_rec;
    public
      port_b_rec port_b;
    end 'heatFlowMiddle[3]_rec';
  public
    'heatFlowMiddle[3]_rec' 'heatFlowMiddle[3]';
  protected
    record 'heatFlowMiddle[4]_rec'
      Modelica_Blocks_Interfaces_RealOutput Q_flow(unit = "W")
                                                              "Heat flow from port_a to port_b as output signal";
    protected
      record port_a_rec
        Modelica.SIunits.Temperature T
                                      "Port temperature";
        Modelica.SIunits.HeatFlowRate Q_flow
                                            "Heat flow rate (positive if flowing from outside into the component)";
      end port_a_rec;
    public
      port_a_rec port_a;
    protected
      record port_b_rec
        Modelica.SIunits.Temperature T
                                      "Port temperature";
        Modelica.SIunits.HeatFlowRate Q_flow
                                            "Heat flow rate (positive if flowing from outside into the component)";
      end port_b_rec;
    public
      port_b_rec port_b;
    end 'heatFlowMiddle[4]_rec';
  public
    'heatFlowMiddle[4]_rec' 'heatFlowMiddle[4]';
  protected
    record heatFlowBottom_rec
      Modelica_Blocks_Interfaces_RealOutput Q_flow(unit = "W")
                                                              "Heat flow from port_a to port_b as output signal";
    protected
      record port_a_rec
        Modelica.SIunits.Temperature T
                                      "Port temperature";
        Modelica.SIunits.HeatFlowRate Q_flow
                                            "Heat flow rate (positive if flowing from outside into the component)";
      end port_a_rec;
    public
      port_a_rec port_a;
    protected
      record port_b_rec
        Modelica.SIunits.Temperature T
                                      "Port temperature";
        Modelica.SIunits.HeatFlowRate Q_flow
                                            "Heat flow rate (positive if flowing from outside into the component)";
      end port_b_rec;
    public
      port_b_rec port_b;
    end heatFlowBottom_rec;
  public
    heatFlowBottom_rec heatFlowBottom;
    Modelica_Blocks_Interfaces_RealOutput Ql_flow(unit = "W")
                                                             "Heat loss of tank (positive if heat flows from tank to ambient)";
  protected
    record port_a_Tambient_rec
      Modelica.SIunits.Temperature T
                                    "Port temperature";
      Modelica.SIunits.HeatFlowRate Q_flow
                                          "Heat flow rate (positive if flowing from outside into the component)";
    end port_a_Tambient_rec;
  public
    port_a_Tambient_rec port_a_Tambient;
  protected
    record buoyancy_rec
      parameter Modelica.SIunits.Volume V(fixed=false)
                                                      "Volume";
      constant Integer nSeg(min = 2) = 4
                                        "Number of volume segments";
      parameter Modelica.SIunits.Time tau(min = 0.0, fixed=false)
                                                                 "Time constant for mixing";
    protected
      record sta_default_rec
        parameter Modelica.Media.Interfaces.Types.AbsolutePressure p = 101325.0
                                                                               "Absolute pressure of medium";
        parameter Modelica.Media.Interfaces.Types.Temperature T = 293.15
                                                                        "Temperature of medium";
      end sta_default_rec;
    public
      sta_default_rec sta_default annotation(Dialog);
      constant Modelica.SIunits.Density rho_default = 995.586
                                                             "Density, used to compute fluid mass";
      constant Modelica.SIunits.SpecificHeatCapacity cp_default = 4184
                                                                      "Specific heat capacity";
      parameter Real k(unit = "W/K", fixed=false)
                                                 "Proportionality constant, since we use dT instead of dH";
      Modelica.SIunits.TemperatureDifference 'dT[1]'
                                                    "Temperature difference between adjoining volumes";
      Modelica.SIunits.TemperatureDifference 'dT[2]'
                                                    "Temperature difference between adjoining volumes";
      Modelica.SIunits.TemperatureDifference 'dT[3]'
                                                    "Temperature difference between adjoining volumes";
      Modelica.SIunits.HeatFlowRate 'Q_flow[1]'
                                               "Heat flow rate from segment i+1 to i";
      Modelica.SIunits.HeatFlowRate 'Q_flow[2]'
                                               "Heat flow rate from segment i+1 to i";
      Modelica.SIunits.HeatFlowRate 'Q_flow[3]'
                                               "Heat flow rate from segment i+1 to i";
    protected
      record 'port_a_heat[1]_rec'
        Modelica.SIunits.Temperature T
                                      "Port temperature";
        Modelica.SIunits.HeatFlowRate Q_flow
                                            "Heat flow rate (positive if flowing from outside into the component)";
      end 'port_a_heat[1]_rec';
    public
      'port_a_heat[1]_rec' 'port_a_heat[1]';
    protected
      record 'port_a_heat[2]_rec'
        Modelica.SIunits.Temperature T
                                      "Port temperature";
        Modelica.SIunits.HeatFlowRate Q_flow
                                            "Heat flow rate (positive if flowing from outside into the component)";
      end 'port_a_heat[2]_rec';
    public
      'port_a_heat[2]_rec' 'port_a_heat[2]';
    protected
      record 'port_a_heat[3]_rec'
        Modelica.SIunits.Temperature T
                                      "Port temperature";
        Modelica.SIunits.HeatFlowRate Q_flow
                                            "Heat flow rate (positive if flowing from outside into the component)";
      end 'port_a_heat[3]_rec';
    public
      'port_a_heat[3]_rec' 'port_a_heat[3]';
    protected
      record 'port_a_heat[4]_rec'
        Modelica.SIunits.Temperature T
                                      "Port temperature";
        Modelica.SIunits.HeatFlowRate Q_flow
                                            "Heat flow rate (positive if flowing from outside into the component)";
      end 'port_a_heat[4]_rec';
    public
      'port_a_heat[4]_rec' 'port_a_heat[4]';
    end buoyancy_rec;
  public
    buoyancy_rec buoyancy annotation(Dialog);
  end closedCylindricalTank_rec;
public
  closedCylindricalTank_rec closedCylindricalTank annotation(Dialog);
protected
  record ambientTemperature_rec
  protected
    record port_rec
      Modelica.SIunits.Temperature T
                                    "Port temperature";
      Modelica.SIunits.HeatFlowRate Q_flow
                                          "Heat flow rate (positive if flowing from outside into the component)";
    end port_rec;
  public
    port_rec port;
    Modelica_Blocks_Interfaces_RealInput T(unit = "K");
  end ambientTemperature_rec;
public
  ambientTemperature_rec ambientTemperature;
protected
  record Retorno_rec
    constant Integer nPorts = 1
                               "Number of ports";
  protected
    record medium_rec
      Real p(unit = "Pa", displayUnit = "bar", nominal = 100000.0, quantity = "Pressure", min = 0.0)
                                                                                                    "Absolute pressure of medium";
      Real h(unit = "J/kg", quantity = "SpecificEnergy")
                                                        "Specific enthalpy of medium";
      constant Modelica.Media.Interfaces.Types.Density d = 995.586
                                                                  "Density of medium";
      Modelica.Media.Interfaces.Types.Temperature T
                                                   "Temperature of medium";
      constant Modelica.Media.Interfaces.Types.MassFraction 'X[1]' = 1.0
                                                                        "Mass fractions (= (component mass)/total mass  m_i/m)";
      parameter Modelica.Media.Interfaces.Types.SpecificInternalEnergy u(fixed=false)
                                                                                     "Specific internal energy of medium";
      constant Modelica.Media.Interfaces.Types.SpecificHeatCapacity R = 0
                                                                         "Gas constant (of mixture if applicable)";
      constant Modelica.Media.Interfaces.Types.MolarMass MM = 0.018015268
                                                                         "Molar mass (of mixture or single fluid)";
    protected
      record state_rec
        Modelica.Media.Interfaces.Types.AbsolutePressure p
                                                          "Absolute pressure of medium";
        Modelica.Media.Interfaces.Types.Temperature T
                                                     "Temperature of medium";
      end state_rec;
    public
      state_rec state;
      constant Boolean preferredMediumStates = false
                                                    "= true if StateSelect.prefer shall be used for the independent property variables of the medium";
      constant Boolean standardOrderComponents = true
                                                     "If true, and reducedX = true, the last element of X will be computed from the other ones";
      parameter Modelica.SIunits.Conversions.NonSIunits.Temperature_degC T_degC(fixed=false)
                                                                                            "Temperature of medium in [degC]";
      parameter Modelica.SIunits.Conversions.NonSIunits.Pressure_bar p_bar(fixed=false)
                                                                                       "Absolute pressure of medium in [bar]";
    end medium_rec;
  public
    medium_rec medium;
  protected
    record 'ports[1]_rec'
      Modelica.Media.Interfaces.PartialMedium.MassFlowRate m_flow(quantity = "MassFlowRate.SimpleLiquidWater", min = -1E+060)
                                                                                                                             "Mass flow rate from the connection point into the component";
      Modelica.Media.Interfaces.Types.AbsolutePressure p
                                                        "Thermodynamic pressure in the connection point";
      parameter Modelica.Media.Interfaces.Types.SpecificEnthalpy h_outflow(fixed=false)
                                                                                       "Specific thermodynamic enthalpy close to the connection point if m_flow < 0";
    end 'ports[1]_rec';
  public
    'ports[1]_rec' 'ports[1]';
    constant Boolean use_p = true
                                 "select p or d";
    parameter Modelica.Media.Interfaces.Types.AbsolutePressure p = 101325
                                                                         "Boundary pressure";
    constant Modelica.Media.Interfaces.Types.Density d = 995.586
                                                                "Boundary density";
    constant Boolean use_T = true
                                 "select T or h";
    parameter Modelica.Media.Interfaces.Types.Temperature T = 293.15
                                                                    "Boundary temperature";
    parameter Modelica.Media.Interfaces.Types.SpecificEnthalpy h = 83680.0
                                                                          "Boundary specific enthalpy";
    parameter Modelica.Media.Interfaces.Types.MassFraction 'X[1]'(quantity = "SimpleLiquidWater") = 1.0
                                                                                                       "Boundary mass fractions m_i/m";
  end Retorno_rec;
public
  Retorno_rec Retorno annotation(Dialog);
protected
  record Impulsion_rec
    constant Integer nPorts = 1
                               "Number of ports";
  protected
    record medium_rec
      Real p(unit = "Pa", displayUnit = "bar", nominal = 100000.0, quantity = "Pressure", min = 0.0)
                                                                                                    "Absolute pressure of medium";
      Real h(unit = "J/kg", quantity = "SpecificEnergy")
                                                        "Specific enthalpy of medium";
      constant Modelica.Media.Interfaces.Types.Density d = 995.586
                                                                  "Density of medium";
      Modelica.Media.Interfaces.Types.Temperature T
                                                   "Temperature of medium";
      constant Modelica.Media.Interfaces.Types.MassFraction 'X[1]' = 1.0
                                                                        "Mass fractions (= (component mass)/total mass  m_i/m)";
      Modelica.Media.Interfaces.Types.SpecificInternalEnergy u
                                                              "Specific internal energy of medium";
      constant Modelica.Media.Interfaces.Types.SpecificHeatCapacity R = 0
                                                                         "Gas constant (of mixture if applicable)";
      constant Modelica.Media.Interfaces.Types.MolarMass MM = 0.018015268
                                                                         "Molar mass (of mixture or single fluid)";
    protected
      record state_rec
        Modelica.Media.Interfaces.Types.AbsolutePressure p
                                                          "Absolute pressure of medium";
        Modelica.Media.Interfaces.Types.Temperature T
                                                     "Temperature of medium";
      end state_rec;
    public
      state_rec state;
      constant Boolean preferredMediumStates = false
                                                    "= true if StateSelect.prefer shall be used for the independent property variables of the medium";
      constant Boolean standardOrderComponents = true
                                                     "If true, and reducedX = true, the last element of X will be computed from the other ones";
      Modelica.SIunits.Conversions.NonSIunits.Temperature_degC T_degC
                                                                     "Temperature of medium in [degC]";
      parameter Modelica.SIunits.Conversions.NonSIunits.Pressure_bar p_bar(fixed=false)
                                                                                       "Absolute pressure of medium in [bar]";
    end medium_rec;
  public
    medium_rec medium;
  protected
    record 'ports[1]_rec'
      Modelica.Media.Interfaces.PartialMedium.MassFlowRate m_flow(quantity = "MassFlowRate.SimpleLiquidWater", min = -1E+060, max = 1E+060)
                                                                                                                                           "Mass flow rate from the connection point into the component";
      parameter Modelica.Media.Interfaces.Types.AbsolutePressure p(fixed=false)
                                                                               "Thermodynamic pressure in the connection point";
      Modelica.Media.Interfaces.Types.SpecificEnthalpy h_outflow
                                                                "Specific thermodynamic enthalpy close to the connection point if m_flow < 0";
    end 'ports[1]_rec';
  public
    'ports[1]_rec' 'ports[1]';
    constant Modelica.Media.Interfaces.PartialMedium.MassFlowRate m_flow(quantity = "MassFlowRate.SimpleLiquidWater") = 0
                                                                                                                         "Fixed mass flow rate going out of the fluid port";
    constant Modelica.Media.Interfaces.Types.Temperature T = 293.15
                                                                   "Fixed value of temperature";
    constant Modelica.Media.Interfaces.Types.MassFraction 'X[1]' = 1.0
                                                                      "Fixed value of composition";
    Modelica_Blocks_Interfaces_RealInput m_flow_in(unit = "kg/s")
                                                                 "Prescribed mass flow rate";
    Modelica_Blocks_Interfaces_RealInput T_in(unit = "K")
                                                         "Prescribed fluid temperature";
  end Impulsion_rec;
public
  Impulsion_rec Impulsion;
protected
  record T_Impulsion_rec
  protected
    record port_rec
      constant Modelica.Media.Interfaces.PartialMedium.MassFlowRate m_flow(quantity = "MassFlowRate.SimpleLiquidWater", min = 0.0) = 0
                                                                                                                                      "Mass flow rate from the connection point into the component";
      Modelica.Media.Interfaces.Types.AbsolutePressure p
                                                        "Thermodynamic pressure in the connection point";
      constant Modelica.Media.Interfaces.Types.SpecificEnthalpy h_outflow = 83680.0
                                                                                   "Specific thermodynamic enthalpy close to the connection point if m_flow < 0";
    end port_rec;
  public
    port_rec port;
    Modelica_Blocks_Interfaces_RealOutput T(unit = "K", displayUnit = "degC", nominal = 300.0, quantity = "ThermodynamicTemperature", min = 0.0)
                                                                                                                                                "Temperature in port medium";
  end T_Impulsion_rec;
public
  T_Impulsion_rec T_Impulsion;
protected
  record T_Retorno_rec
  protected
    record port_rec
      constant Modelica.Media.Interfaces.PartialMedium.MassFlowRate m_flow(quantity = "MassFlowRate.SimpleLiquidWater", min = 0.0) = 0
                                                                                                                                      "Mass flow rate from the connection point into the component";
      Modelica.Media.Interfaces.Types.AbsolutePressure p
                                                        "Thermodynamic pressure in the connection point";
      constant Modelica.Media.Interfaces.Types.SpecificEnthalpy h_outflow = 83680.0
                                                                                   "Specific thermodynamic enthalpy close to the connection point if m_flow < 0";
    end port_rec;
  public
    port_rec port;
    Modelica_Blocks_Interfaces_RealOutput T(unit = "K", displayUnit = "degC", nominal = 300.0, quantity = "ThermodynamicTemperature", min = 0.0)
                                                                                                                                                "Temperature in port medium";
  end T_Retorno_rec;
public
  T_Retorno_rec T_Retorno;
protected
  record massFlowRate_rec
    constant Boolean allowFlowReversal = true
                                             "= true to allow flow reversal, false restricts to design direction (port_a -> port_b)";
  protected
    record port_a_rec
      Modelica.Media.Interfaces.PartialMedium.MassFlowRate m_flow(quantity = "MassFlowRate.SimpleLiquidWater", min = -1E+060)
                                                                                                                             "Mass flow rate from the connection point into the component";
      Modelica.Media.Interfaces.Types.AbsolutePressure p
                                                        "Thermodynamic pressure in the connection point";
      Modelica.Media.Interfaces.Types.SpecificEnthalpy h_outflow
                                                                "Specific thermodynamic enthalpy close to the connection point if m_flow < 0";
    end port_a_rec;
  public
    port_a_rec port_a;
  protected
    record port_b_rec
      Modelica.Media.Interfaces.Types.AbsolutePressure p
                                                        "Thermodynamic pressure in the connection point";
      Modelica.Media.Interfaces.Types.SpecificEnthalpy h_outflow
                                                                "Specific thermodynamic enthalpy close to the connection point if m_flow < 0";
    end port_b_rec;
  public
    port_b_rec port_b;
    parameter Modelica.Media.Interfaces.PartialMedium.MassFlowRate m_flow_nominal(quantity = "MassFlowRate.SimpleLiquidWater", fixed=false)
                                                                                                                                           "Nominal value of m_flow = port_a.m_flow";
    parameter Modelica.Media.Interfaces.PartialMedium.MassFlowRate m_flow_small(quantity = "MassFlowRate.SimpleLiquidWater", min = 0.0, fixed=false)
                                                                                                                                                    "Regularization for bi-directional flow in the region |m_flow| < m_flow_small (m_flow_small > 0 required)";
    Modelica_Blocks_Interfaces_RealOutput m_flow(unit = "kg/s", quantity = "MassFlowRate")
                                                                                          "Mass flow rate from port_a to port_b";
  end massFlowRate_rec;
public
  massFlowRate_rec massFlowRate;
  parameter Real _massFlow_start = 0.0
  annotation (Dialog(tab="Input Start Values", group="Input Start Value before call to fmiInitialize"));
protected
  Real _massFlow_old;
public
  Modelica.Blocks.Interfaces.RealInput massFlow(unit = "kg/s", quantity = "MassFlowRate", min = -100000.0, max = 100000.0, start = 0.0)
                                                                                                                                       "Inlet fluid mass flow"
  annotation (Placement(transformation(extent={{-124,30},{-84,70}})));
  parameter Real _impulsion_T_start = 288.15
  annotation (Dialog(tab="Input Start Values", group="Input Start Value before call to fmiInitialize"));
protected
  Real _impulsion_T_old;
public
  Modelica.Blocks.Interfaces.RealInput impulsion_T(unit = "K", displayUnit = "degC", nominal = 300.0, quantity = "ThermodynamicTemperature", min = 1.0, max = 10000.0, start = 288.15)
                                                                                                                                                                                      "Temperature of the fluid to \"Impulsion\""
  annotation (Placement(transformation(extent={{-124,-20},{-84,20}})));
  parameter Real _ambient_T_start = 288.15
  annotation (Dialog(tab="Input Start Values", group="Input Start Value before call to fmiInitialize"));
protected
  Real _ambient_T_old;
public
  Modelica.Blocks.Interfaces.RealInput ambient_T(unit = "K", displayUnit = "degC", nominal = 300.0, quantity = "ThermodynamicTemperature", min = 0.0, start = 288.15)
                                                                                                                                                                     "Ambient temperature"
  annotation (Placement(transformation(extent={{-124,-70},{-84,-30}})));
  Modelica.Blocks.Interfaces.RealOutput m_impulsion_T(unit = "K", displayUnit = "degC", nominal = 300.0, quantity = "ThermodynamicTemperature", min = 0.0)
  annotation (Placement(transformation(extent={{100,30},{140,70}})));
  Modelica.Blocks.Interfaces.RealOutput m_retorno_T(unit = "K", displayUnit = "degC", nominal = 300.0, quantity = "ThermodynamicTemperature", min = 0.0)
  annotation (Placement(transformation(extent={{100,-20},{140,20}})));
  Modelica.Blocks.Interfaces.RealOutput heatLosses(unit = "W", quantity = "Power")
  annotation (Placement(transformation(extent={{100,-70},{140,-30}})));
public
  parameter String fmi_instanceName="Buffer_FMU_temperature_fmu"
  annotation (Dialog(tab="FMI", group="Instance name"));
  parameter Boolean fmi_loggingOn=false
  annotation (Dialog(tab="FMI", group="Enable logging"));
  parameter Boolean fmi_pullInputsForInitialization=true
  "Set to false when using the FMU in feedback connections"
  annotation (Dialog(tab="FMI", group="Inputs for initialization"));
  parameter Boolean fmi_InputTime=false
  "Time point of input used when calling doStep."
  annotation (Evaluate=true,Dialog(tab="FMI", group="Input Handling"),choices(choice= false "StepEnd", choice= true "StepStart"));
  parameter Boolean fmi_UsePreOnInputSignals=true
  annotation (Evaluate=true,Dialog(tab="FMI", group="Input Handling"));
  parameter Real fmi_StartTime = 0.0
  annotation (Dialog(tab="FMI", group="Step time"));
  parameter Real fmi_StopTime = 60000.0
  annotation (Dialog(tab="FMI", group="Step time"));
  parameter Real fmi_NumberOfSteps = 500
  annotation (Dialog(tab="FMI", group="Step time"));
  parameter Real fmi_CommunicationStepSize=(fmi_StopTime-fmi_StartTime)/fmi_NumberOfSteps
  annotation (Dialog(tab="FMI", group="Step time"));
  parameter Integer stepSizeScaleFactor = 1 "Number of doSteps called between two CommunicationStepSize"
  annotation (Dialog(tab="FMI", group="Step time"));
  parameter Boolean fmi_forceShutDownAtStopTime=false
  annotation (Dialog(tab="FMI", group="Step time"));
  parameter String fmi_fmuLocation="file:///"+ModelicaServices.ExternalReferences.loadResource("modelica://Buffer_FMU_temperature_fmu/Resources/Library/FMU/Buffer_FMU_temperature")
  annotation (Dialog(tab="FMI", group="Instantiation"));
protected
fmi_Functions.fmiModel fmi;
Boolean fmi_StepOK;
parameter Real fmi_Initialized(fixed=false);
parameter Real fmi_AParamsAndStart(fixed=false);
parameter Real fmi_initInput0(start=0,fixed=false);
parameter Real fmi_initInput1(start=0,fixed=false);
parameter Real fmi_initInput2(start=0,fixed=false);
Real RealVariables1[100];
Real RealVariables2[100];
Real RealVariables3[100];
Real RealVariables4[93];
Real RealDependentParameters1[100];
Real RealDependentParameters2[11];
package fmi_Functions
  class fmiModel
  extends ExternalObject;
    function constructor "Initialize FMI model"
      extends Modelica.Icons.Function;
      input String instanceName;
      input Boolean loggingOn;
        input String fmuLocation;
      output fmiModel fmi;
      external"C" fmi = Modelica_0IK4_0TEKNIKER_DCOL_Generation_SensibleStorages_FMI_Buffer_0Dym_0temperature_fmiInstantiateModel2(instanceName, loggingOn, fmuLocation)
      annotation(Header="
#ifndef Modelica_0IK4_0TEKNIKER_DCOL_Generation_SensibleStorages_FMI_Buffer_0Dym_0temperature_Instantiate_C
#define Modelica_0IK4_0TEKNIKER_DCOL_Generation_SensibleStorages_FMI_Buffer_0Dym_0temperature_Instantiate_C 1
#include <stdlib.h>
#include \"FMI/fmiImport.h\"
#ifndef Modelica_0IK4_0TEKNIKER_DCOL_Generation_SensibleStorages_FMI_Buffer_0Dym_0temperature_MYSTRCMP_C
#define Modelica_0IK4_0TEKNIKER_DCOL_Generation_SensibleStorages_FMI_Buffer_0Dym_0temperature_MYSTRCMP_C 1
int Modelica_0IK4_0TEKNIKER_DCOL_Generation_SensibleStorages_FMI_Buffer_0Dym_0temperaturemystrcmp(const void *_a, const void *_b) {
  char *a = _a;
  char *const *b = _b;
  return strcmp(a, *b);
}
#endif
void Modelica_0IK4_0TEKNIKER_DCOL_Generation_SensibleStorages_FMI_Buffer_0Dym_0temperatureLogger(fmiComponent c, fmiString instanceName, fmiStatus status,
         fmiString category, fmiString message, ...) {
  char msg[4096];
  char buf[4096];
  int len;
  va_list ap;
  va_start(ap,message);
#if defined(_MSC_VER) && _MSC_VER>=1200
  len = _snprintf(msg, sizeof(msg)/sizeof(*msg), \"%s: %s\", instanceName, message);
  if (len < 0) goto fail;
  len = _vsnprintf(buf, sizeof(buf)/sizeof(*buf) - 2, msg, ap);
  if (len < 0) goto fail;
#else
  len = snprintf(msg, sizeof(msg)/sizeof(*msg), \"%s: %s\", instanceName, message);
  if (len < 0) goto fail;
  len = vsnprintf(buf, sizeof(buf)/sizeof(*buf) - 2, msg, ap);
  if (len < 0) goto fail;
#endif
  if( len>0 && len <4096 && buf[len - 1]!='\\n'){
    buf[len] = '\\n';
    buf[len + 1] = 0;
  }
  va_end(ap);
  switch (status) {
    case fmiFatal:
      ModelicaMessage(\"[fmiFatal]: \");
      break;
    case fmiError:
      ModelicaMessage(\"[fmiError]: \");
      break;
    case fmiDiscard:
      ModelicaMessage(\"[fmiDiscard]: \");
      break;
    case fmiWarning:
      ModelicaMessage(\"[fmiWarning]: \");
      break;
    case fmiOK:
      ModelicaMessage(\"[fmiOK]: \");
      break;
  }
  ModelicaMessage(buf);
  return;
fail:
  ModelicaMessage(\"Logger failed, message too long?\");
}
void * Modelica_0IK4_0TEKNIKER_DCOL_Generation_SensibleStorages_FMI_Buffer_0Dym_0temperature_fmiInstantiateModel2(const char*instanceName, fmiBoolean loggingOn, const char* fmuLocation) {
  static fmiCoSimCallbackFunctions funcs = {&Modelica_0IK4_0TEKNIKER_DCOL_Generation_SensibleStorages_FMI_Buffer_0Dym_0temperatureLogger, &calloc, &free, NULL};
  struct dy_Extended* res;

  res = calloc(1, sizeof(struct dy_Extended));
  if (res!=0) {
    if (!(res->hInst=LoadLibraryW(L\"Modelica_0IK4_0TEKNIKER_DCOL_Generation_SensibleStorages_FMI_Buffer_0Dym_0temperature.dll\"))) {
      ModelicaError(\"Loading of FMU dynamic link library (Modelica_0IK4_0TEKNIKER_DCOL_Generation_SensibleStorages_FMI_Buffer_0Dym_0temperature.dll) failed!\");
      return 0;
    }
    if(!(res->dyFmiInstantiateSlave=(fmiInstantiateSlaveFunc)GetProcAddress(res->hInst,\"Modelica_0IK4_0TEKNIKER_DCOL_Generation_SensibleStorages_FMI_Buffer_0Dym_0temperature_fmiInstantiateSlave\"))){
      ModelicaError(\"GetProcAddress failed for fmiInstantiateSlave!\\n The model was imported as a Co-Simulation FMU but could not load the CS specific function fmiInstantiateSlave\\n Verify that the FMU supports Co-Simulation\");
      return 0;
    }
    if(!(res->dyFmiFreeSlaveInstance=(fmiFreeSlaveInstanceFunc)GetProcAddress(res->hInst,\"Modelica_0IK4_0TEKNIKER_DCOL_Generation_SensibleStorages_FMI_Buffer_0Dym_0temperature_fmiFreeSlaveInstance\"))){
      ModelicaError(\"GetProcAddress failed for fmiFreeSlaveInstance!\\n The model was imported as a Co-Simulation FMU but could not load the CS specific function fmiFreeSlaveInstance\\n Verify that the FMU supports Co-Simulation\");
      return 0;
    }
    if(!(res->dyFmiInitializeSlave=(fmiInitializeSlaveFunc)GetProcAddress(res->hInst,\"Modelica_0IK4_0TEKNIKER_DCOL_Generation_SensibleStorages_FMI_Buffer_0Dym_0temperature_fmiInitializeSlave\"))){
      ModelicaError(\"GetProcAddress failed for fmiInitializeSlave!\\n The model was imported as a Co-Simulation FMU but could not load the CS specific function fmiInitializeSlave\\n Verify that the FMU supports Co-Simulation\");
      return 0;
    }
    if(!(res->dyFmiResetSlave=(fmiResetSlaveFunc)GetProcAddress(res->hInst,\"Modelica_0IK4_0TEKNIKER_DCOL_Generation_SensibleStorages_FMI_Buffer_0Dym_0temperature_fmiResetSlave\"))){
      ModelicaError(\"GetProcAddress failed for fmiResetSlave!\\n The model was imported as a Co-Simulation FMU but could not load the CS specific function fmiResetSlave\\n Verify that the FMU supports Co-Simulation\");
      return 0;
    }
    if(!(res->dyFmiDoStep=(fmiDoStepFunc)GetProcAddress(res->hInst,\"Modelica_0IK4_0TEKNIKER_DCOL_Generation_SensibleStorages_FMI_Buffer_0Dym_0temperature_fmiDoStep\"))){
      ModelicaError(\"GetProcAddress failed for fmiDoStep!\\n The model was imported as a Co-Simulation FMU but could not load the CS specific function fmiDoStep\\n Verify that the FMU supports Co-Simulation\");
      return 0;
    }
    if(!(res->dyFmiTerminateSlave=(fmiTerminateSlaveFunc)GetProcAddress(res->hInst,\"Modelica_0IK4_0TEKNIKER_DCOL_Generation_SensibleStorages_FMI_Buffer_0Dym_0temperature_fmiTerminateSlave\"))){
      ModelicaError(\"GetProcAddress failed for fmiTerminateSlave!\\n The model was imported as a Co-Simulation FMU but could not load the CS specific function fmiTerminateSlave\\n Verify that the FMU supports Co-Simulation\");
      return 0;
    }
    if (!(res->dyFmiSetReal=(fmiSetRealFunc)GetProcAddress(res->hInst,\"Modelica_0IK4_0TEKNIKER_DCOL_Generation_SensibleStorages_FMI_Buffer_0Dym_0temperature_fmiSetReal\"))) {
      ModelicaError(\"GetProcAddress failed for fmiSetReal!\");
      return 0;
    }
    if (!(res->dyFmiGetReal=(fmiGetRealFunc)GetProcAddress(res->hInst,\"Modelica_0IK4_0TEKNIKER_DCOL_Generation_SensibleStorages_FMI_Buffer_0Dym_0temperature_fmiGetReal\"))) {
      ModelicaError(\"GetProcAddress failed for fmiGetReal!\");
      return 0;
    }
    if (!(res->dyFmiSetInteger=(fmiSetIntegerFunc)GetProcAddress(res->hInst,\"Modelica_0IK4_0TEKNIKER_DCOL_Generation_SensibleStorages_FMI_Buffer_0Dym_0temperature_fmiSetInteger\"))) {
      ModelicaError(\"GetProcAddress failed for fmiSetInteger!\");
      return 0;
    }
    if (!(res->dyFmiGetInteger=(fmiGetIntegerFunc)GetProcAddress(res->hInst,\"Modelica_0IK4_0TEKNIKER_DCOL_Generation_SensibleStorages_FMI_Buffer_0Dym_0temperature_fmiGetInteger\"))) {
      ModelicaError(\"GetProcAddress failed for fmiGetInteger!\");
      return 0;
    }
    if (!(res->dyFmiSetBoolean=(fmiSetBooleanFunc)GetProcAddress(res->hInst,\"Modelica_0IK4_0TEKNIKER_DCOL_Generation_SensibleStorages_FMI_Buffer_0Dym_0temperature_fmiSetBoolean\"))) {
      ModelicaError(\"GetProcAddress failed for fmiSetBoolean!\");
      return 0;
    }
    if (!(res->dyFmiGetBoolean=(fmiGetBooleanFunc)GetProcAddress(res->hInst,\"Modelica_0IK4_0TEKNIKER_DCOL_Generation_SensibleStorages_FMI_Buffer_0Dym_0temperature_fmiGetBoolean\"))) {
      ModelicaError(\"GetProcAddress failed for fmiGetBoolean!\");
      return 0;
    }
    if (!(res->dyFmiSetString=(fmiSetStringFunc)GetProcAddress(res->hInst,\"Modelica_0IK4_0TEKNIKER_DCOL_Generation_SensibleStorages_FMI_Buffer_0Dym_0temperature_fmiSetString\"))) {
      ModelicaError(\"GetProcAddress failed for fmiSetString!\");
      return 0;
    }
    if (!(res->dyFmiGetString=(fmiGetStringFunc)GetProcAddress(res->hInst,\"Modelica_0IK4_0TEKNIKER_DCOL_Generation_SensibleStorages_FMI_Buffer_0Dym_0temperature_fmiGetString\"))) {
      ModelicaError(\"GetProcAddress failed for fmiGetString!\");
      return 0;
    }
    res->m=res->dyFmiInstantiateSlave(instanceName, \"{321f979a-63ba-42f0-bf55-952b718db157}\", fmuLocation, \"application/x-dymolakernel\", 0, fmiFalse, fmiFalse, funcs, loggingOn);
    if (0==res->m) {free(res);res=0;ModelicaError(\"InstantiateSlave failed\");}
    else {res->dyTriggered=0;res->dyTime=res->dyLastTime=-1e37;}
  }
  return res;
}
#endif", Library="Modelica_0IK4_0TEKNIKER_DCOL_Generation_SensibleStorages_FMI_Buffer_0Dym_0temperature", LibraryDirectory="modelica://DCOL/Resources/Library/FMU/Buffer_FMU_temperature/binaries",                       __Dymola_CriticalRegion="Modelica_0IK4_0TEKNIKER_DCOL_Generation_SensibleStorages_FMI_Buffer_0Dym_0temperature");
    end constructor;

    function destructor "Release storage of FMI model"
      extends Modelica.Icons.Function;
      input fmiModel fmi;
      external"C"
                 Modelica_0IK4_0TEKNIKER_DCOL_Generation_SensibleStorages_FMI_Buffer_0Dym_0temperature_fmiFreeModelInstance2(fmi);
      annotation (Header="
#ifndef Modelica_0IK4_0TEKNIKER_DCOL_Generation_SensibleStorages_FMI_Buffer_0Dym_0temperature_Free_C
#define Modelica_0IK4_0TEKNIKER_DCOL_Generation_SensibleStorages_FMI_Buffer_0Dym_0temperature_Free_C 1
#include <stdlib.h>
#include \"FMI/fmiImport.h\"
void Modelica_0IK4_0TEKNIKER_DCOL_Generation_SensibleStorages_FMI_Buffer_0Dym_0temperature_fmiFreeModelInstance2(void*m) {
  struct dy_Extended*a=m;
  if (a) {
    a->dyFmiTerminateSlave(a->m);
    a->dyFmiFreeSlaveInstance(a->m);
    FreeLibrary(a->hInst);
    free(a);
  }
}
#endif", Library="Modelica_0IK4_0TEKNIKER_DCOL_Generation_SensibleStorages_FMI_Buffer_0Dym_0temperature", LibraryDirectory="modelica://DCOL/Resources/Library/FMU/Buffer_FMU_temperature/binaries",                       __Dymola_CriticalRegion="Modelica_0IK4_0TEKNIKER_DCOL_Generation_SensibleStorages_FMI_Buffer_0Dym_0temperature");
    end destructor;
  end fmiModel;

    function fmiInitializeSlave
      input fmiModel fmi;
      input Real tStart;
      input Boolean forceShutDownAtTStop;
       input Real tStop;
      input Real preAvailable;
      output Real postAvailable=preAvailable;
      external"C" Modelica_0IK4_0TEKNIKER_DCOL_Generation_SensibleStorages_FMI_Buffer_0Dym_0temperature_fmiInitializeSlave2(fmi, tStart, forceShutDownAtTStop, tStop);
      annotation (Header="
#ifndef Modelica_0IK4_0TEKNIKER_DCOL_Generation_SensibleStorages_FMI_Buffer_0Dym_0temperature_InitializeSlave_C
#define Modelica_0IK4_0TEKNIKER_DCOL_Generation_SensibleStorages_FMI_Buffer_0Dym_0temperature_InitializeSlave_C 1
#include <stdlib.h>
#include \"FMI/fmiImport.h\"
double Modelica_0IK4_0TEKNIKER_DCOL_Generation_SensibleStorages_FMI_Buffer_0Dym_0temperature_fmiInitializeSlave2(void*m, fmiReal tStart, fmiBoolean forceShutDownAtTStop, fmiReal tStop) {
  struct dy_Extended*a=m;
  fmiStatus status=fmiFatal;
  if (a) {
    status=a->dyFmiInitializeSlave(a->m, tStart, forceShutDownAtTStop, tStop);
    a->dyTriggered=0;
    a->dyLastTime=a->dyTime;
  }
  if (status!=fmiOK && status!=fmiWarning) ModelicaError(\"InitializeSlave failed\");
  return 1e37;
}
#endif", Library="Modelica_0IK4_0TEKNIKER_DCOL_Generation_SensibleStorages_FMI_Buffer_0Dym_0temperature", LibraryDirectory="modelica://DCOL/Resources/Library/FMU/Buffer_FMU_temperature/binaries",                       __Dymola_CriticalRegion="Modelica_0IK4_0TEKNIKER_DCOL_Generation_SensibleStorages_FMI_Buffer_0Dym_0temperature");
    end fmiInitializeSlave;

    function fmiDoStep
     input fmiModel fmi;
     input Real currentTime;
     input Real stepSize;
     output Boolean stepOK;
     external"C" stepOK= Modelica_0IK4_0TEKNIKER_DCOL_Generation_SensibleStorages_FMI_Buffer_0Dym_0temperature_fmiDoStep2(fmi, currentTime, stepSize);
     annotation (Header="
#ifndef Modelica_0IK4_0TEKNIKER_DCOL_Generation_SensibleStorages_FMI_Buffer_0Dym_0temperature_DoStep_C
#define Modelica_0IK4_0TEKNIKER_DCOL_Generation_SensibleStorages_FMI_Buffer_0Dym_0temperature_DoStep_C 1
#include <stdlib.h>
#include \"FMI/fmiImport.h\"
double Modelica_0IK4_0TEKNIKER_DCOL_Generation_SensibleStorages_FMI_Buffer_0Dym_0temperature_fmiDoStep2(void*m, double currentTime, double stepSize) {
  struct dy_Extended*a=m;
  fmiStatus status=fmiFatal;
  if (a) {
    status=a->dyFmiDoStep(a->m, currentTime, stepSize, fmiTrue);
  }
  if (status!=fmiOK && status!=fmiWarning) ModelicaError(\"DoStep failed\");
  return 1.0;
}
#endif", Library="Modelica_0IK4_0TEKNIKER_DCOL_Generation_SensibleStorages_FMI_Buffer_0Dym_0temperature", LibraryDirectory="modelica://DCOL/Resources/Library/FMU/Buffer_FMU_temperature/binaries",                       __Dymola_CriticalRegion="Modelica_0IK4_0TEKNIKER_DCOL_Generation_SensibleStorages_FMI_Buffer_0Dym_0temperature");
    end fmiDoStep;

    function fmiResetSlave
      input fmiModel fmi;
      output Boolean resetOK;
      external"C" resetOK = Modelica_0IK4_0TEKNIKER_DCOL_Generation_SensibleStorages_FMI_Buffer_0Dym_0temperature_fmiResetSlave2(fmi);
      annotation (Header="
#ifndef Modelica_0IK4_0TEKNIKER_DCOL_Generation_SensibleStorages_FMI_Buffer_0Dym_0temperature_ResetSlave_C
#define Modelica_0IK4_0TEKNIKER_DCOL_Generation_SensibleStorages_FMI_Buffer_0Dym_0temperature_ResetSlave_C 1
#include <stdlib.h>
#include \"FMI/fmiImport.h\"
double Modelica_0IK4_0TEKNIKER_DCOL_Generation_SensibleStorages_FMI_Buffer_0Dym_0temperature_fmiResetSlave2(void*m) {
  struct dy_Extended*a=m;
  fmiStatus status=fmiFatal;
  if (a) {
    status=a->dyFmiResetSlave(a->m);
  }
  if (status!=fmiOK && status!=fmiWarning) ModelicaError(\"resetSlave failed\");
    return 1.0;
  }
#endif", Library="Modelica_0IK4_0TEKNIKER_DCOL_Generation_SensibleStorages_FMI_Buffer_0Dym_0temperature", LibraryDirectory="modelica://DCOL/Resources/Library/FMU/Buffer_FMU_temperature/binaries",                       __Dymola_CriticalRegion="Modelica_0IK4_0TEKNIKER_DCOL_Generation_SensibleStorages_FMI_Buffer_0Dym_0temperature");
    end fmiResetSlave;

    function fmiSetReal
      input fmiModel fmi;
      input Integer refs[:];
      input Real vals[size(refs, 1)];
      output Real dummy= 1;
      external"C"
                 Modelica_0IK4_0TEKNIKER_DCOL_Generation_SensibleStorages_FMI_Buffer_0Dym_0temperature_fmiSetReal2(
        fmi,
        refs,
        size(refs, 1),
        vals);
        annotation (Header="
#ifndef Modelica_0IK4_0TEKNIKER_DCOL_Generation_SensibleStorages_FMI_Buffer_0Dym_0temperature_SetReal_C
#define Modelica_0IK4_0TEKNIKER_DCOL_Generation_SensibleStorages_FMI_Buffer_0Dym_0temperature_SetReal_C 1
#include <stdlib.h>
#include \"FMI/fmiImport.h\"
void Modelica_0IK4_0TEKNIKER_DCOL_Generation_SensibleStorages_FMI_Buffer_0Dym_0temperature_fmiSetReal2(void*m, const int*refs, size_t nrefs, const double*vals) {
  struct dy_Extended*a=m;
  fmiStatus status=fmiFatal;
  if(!nrefs){return;}
  if (a) {
    status=a->dyFmiSetReal(a->m, refs, nrefs, vals);
  }
  if (status!=fmiOK && status!=fmiWarning) ModelicaError(\"SetReal failed\");
}
#endif", Library="Modelica_0IK4_0TEKNIKER_DCOL_Generation_SensibleStorages_FMI_Buffer_0Dym_0temperature", LibraryDirectory="modelica://DCOL/Resources/Library/FMU/Buffer_FMU_temperature/binaries",                       __Dymola_CriticalRegion="Modelica_0IK4_0TEKNIKER_DCOL_Generation_SensibleStorages_FMI_Buffer_0Dym_0temperature",__Dymola_IdemPotent=true, __Dymola_VectorizedExceptFirst=true);
    end fmiSetReal;

    function fmiSetRealParam
      input fmiModel fmi;
      input Integer refs[:];
      input Real vals[size(refs, 1)];
    protected
      Real oldVals[size(refs, 1)];
      external"C"
                 Modelica_0IK4_0TEKNIKER_DCOL_Generation_SensibleStorages_FMI_Buffer_0Dym_0temperature_fmiSetRealParam2(
        fmi,
        refs,
        size(refs, 1),
        vals,
        oldVals);
        annotation (Header="
#ifndef Modelica_0IK4_0TEKNIKER_DCOL_Generation_SensibleStorages_FMI_Buffer_0Dym_0temperature_SetRealParam_C
#define Modelica_0IK4_0TEKNIKER_DCOL_Generation_SensibleStorages_FMI_Buffer_0Dym_0temperature_SetRealParam_C 1
#include <stdlib.h>
#include \"FMI/fmiImport.h\"
void Modelica_0IK4_0TEKNIKER_DCOL_Generation_SensibleStorages_FMI_Buffer_0Dym_0temperature_fmiSetRealParam2(void*m, const int*refs, size_t nrefs, const double*vals, double*oldVals) {
  struct dy_Extended*a=m;
  fmiStatus status=fmiFatal;
  int i = 0;
  if(!nrefs){return;}
  if (a) {
    if(a->currentMode == dyInstantiationMode){
                status=a->dyFmiSetReal(a->m, refs, nrefs, vals);
    }else{
      status=a->dyFmiGetReal(a->m, refs, nrefs, oldVals);
      for(i=0; i<nrefs;++i){
        if( abs(vals[i]-oldVals[i])> 5e-16){
          ModelicaError(\"SetRealParameter: new parameters with diferent values are being set after initialization, this is not allowed\");
        }
      }
    }
  }
  if (status!=fmiOK && status!=fmiWarning) ModelicaError(\"SetReal failed\");
}
#endif", Library="Modelica_0IK4_0TEKNIKER_DCOL_Generation_SensibleStorages_FMI_Buffer_0Dym_0temperature", LibraryDirectory="modelica://DCOL/Resources/Library/FMU/Buffer_FMU_temperature/binaries",                       __Dymola_CriticalRegion="Modelica_0IK4_0TEKNIKER_DCOL_Generation_SensibleStorages_FMI_Buffer_0Dym_0temperature",__Dymola_IdemPotent=true, __Dymola_VectorizedExceptFirst=true);
    end fmiSetRealParam;

    function fmiGetRealScalar
      input fmiModel fmi;
      input Integer ref;
      input Real dummy;
      output Real val;
    algorithm
        val := scalar(fmiGetReal(fmi, {ref}, dummy));
    end fmiGetRealScalar;

    function fmiGetReal
      input fmiModel fmi;
      input Integer refs[:];
      output Real vals[size(refs, 1)];
      input Real preAvailable;
      external"C" Modelica_0IK4_0TEKNIKER_DCOL_Generation_SensibleStorages_FMI_Buffer_0Dym_0temperature_fmiGetReal2(
        fmi,
        refs,
        size(refs, 1),
        vals);
      annotation (Header="
#ifndef Modelica_0IK4_0TEKNIKER_DCOL_Generation_SensibleStorages_FMI_Buffer_0Dym_0temperature_GetReal_C
#define Modelica_0IK4_0TEKNIKER_DCOL_Generation_SensibleStorages_FMI_Buffer_0Dym_0temperature_GetReal_C 1
#include <stdlib.h>
#include \"FMI/fmiImport.h\"
void Modelica_0IK4_0TEKNIKER_DCOL_Generation_SensibleStorages_FMI_Buffer_0Dym_0temperature_fmiGetReal2(void*m, const int*refs, size_t nrefs, double*vals) {
  struct dy_Extended*a=m;
  fmiStatus status=fmiFatal;
  if (a) {
    status=a->dyFmiGetReal(a->m, refs, nrefs, vals);
  }
  if (status!=fmiOK && status!=fmiWarning) ModelicaError(\"GetReal failed\");
}
#endif", Library="Modelica_0IK4_0TEKNIKER_DCOL_Generation_SensibleStorages_FMI_Buffer_0Dym_0temperature", LibraryDirectory="modelica://DCOL/Resources/Library/FMU/Buffer_FMU_temperature/binaries",                       __Dymola_CriticalRegion="Modelica_0IK4_0TEKNIKER_DCOL_Generation_SensibleStorages_FMI_Buffer_0Dym_0temperature");
    end fmiGetReal;

    function fmiGetIntegerScalar
      input fmiModel fmi;
      input Integer ref;
      input Integer dummy;
      output Integer val;
    algorithm
        val := scalar(fmiGetInteger(fmi, {ref}, dummy));
    end fmiGetIntegerScalar;

    function fmiGetInteger
      input fmiModel fmi;
      input Integer refs[:];
      output Integer vals[size(refs, 1)];
      input Integer preAvailable;
      external"C" Modelica_0IK4_0TEKNIKER_DCOL_Generation_SensibleStorages_FMI_Buffer_0Dym_0temperature_fmiGetInteger2(
        fmi,
        refs,
        size(refs, 1),
        vals);
      annotation (Header="
#ifndef Modelica_0IK4_0TEKNIKER_DCOL_Generation_SensibleStorages_FMI_Buffer_0Dym_0temperature_GetInteger_C
#define Modelica_0IK4_0TEKNIKER_DCOL_Generation_SensibleStorages_FMI_Buffer_0Dym_0temperature_GetInteger_C 1
#include <stdlib.h>
#include \"FMI/fmiImport.h\"
void Modelica_0IK4_0TEKNIKER_DCOL_Generation_SensibleStorages_FMI_Buffer_0Dym_0temperature_fmiGetInteger2(void*m, const int*refs, size_t nrefs, int*vals) {
  struct dy_Extended*a=m;
  fmiStatus status=fmiFatal;
  if (a) {
    status=a->dyFmiGetInteger(a->m, refs, nrefs, vals);
  }
  if (status!=fmiOK && status!=fmiWarning) ModelicaError(\"GetInteger failed\");
}
#endif", Library="Modelica_0IK4_0TEKNIKER_DCOL_Generation_SensibleStorages_FMI_Buffer_0Dym_0temperature", LibraryDirectory="modelica://DCOL/Resources/Library/FMU/Buffer_FMU_temperature/binaries",                       __Dymola_CriticalRegion="Modelica_0IK4_0TEKNIKER_DCOL_Generation_SensibleStorages_FMI_Buffer_0Dym_0temperature");
    end fmiGetInteger;

    function fmiSetInteger
    input fmiModel fmi;
      input Integer refs[:];
      input Integer vals[size(refs, 1)];
      output Real dummy= 1;
      external"C" Modelica_0IK4_0TEKNIKER_DCOL_Generation_SensibleStorages_FMI_Buffer_0Dym_0temperature_fmiSetInteger2(
        fmi,
        refs,
        size(refs, 1),
        vals);
        annotation (Header="
#ifndef Modelica_0IK4_0TEKNIKER_DCOL_Generation_SensibleStorages_FMI_Buffer_0Dym_0temperature_SetInteger_C
#define Modelica_0IK4_0TEKNIKER_DCOL_Generation_SensibleStorages_FMI_Buffer_0Dym_0temperature_SetInteger_C 1
#include <stdlib.h>
#include \"FMI/fmiImport.h\"
void Modelica_0IK4_0TEKNIKER_DCOL_Generation_SensibleStorages_FMI_Buffer_0Dym_0temperature_fmiSetInteger2(void*m, const int*refs, size_t nrefs, int*vals) {
  struct dy_Extended*a=m;
  fmiStatus status=fmiFatal;
  if(!nrefs){return;}
  if (a) {
    status=a->dyFmiSetInteger(a->m, refs, nrefs, vals);
  }
  if (status!=fmiOK && status!=fmiWarning) ModelicaError(\"SetInteger failed\");
}
#endif", Library="Modelica_0IK4_0TEKNIKER_DCOL_Generation_SensibleStorages_FMI_Buffer_0Dym_0temperature", LibraryDirectory="modelica://DCOL/Resources/Library/FMU/Buffer_FMU_temperature/binaries",                       __Dymola_CriticalRegion="Modelica_0IK4_0TEKNIKER_DCOL_Generation_SensibleStorages_FMI_Buffer_0Dym_0temperature",__Dymola_IdemPotent=true, __Dymola_VectorizedExceptFirst=true);
    end fmiSetInteger;

    function fmiSetIntegerParam
    input fmiModel fmi;
      input Integer refs[:];
      input Integer vals[size(refs, 1)];
    protected
      Integer oldVals[size(refs, 1)];
      external"C" Modelica_0IK4_0TEKNIKER_DCOL_Generation_SensibleStorages_FMI_Buffer_0Dym_0temperature_fmiSetIntegerParam2(
        fmi,
        refs,
        size(refs, 1),
        vals,
        oldVals);
        annotation (Header="
#ifndef Modelica_0IK4_0TEKNIKER_DCOL_Generation_SensibleStorages_FMI_Buffer_0Dym_0temperature_SetIntegerParam_C
#define Modelica_0IK4_0TEKNIKER_DCOL_Generation_SensibleStorages_FMI_Buffer_0Dym_0temperature_SetIntegerParam_C 1
#include <stdlib.h>
#include \"FMI/fmiImport.h\"
void Modelica_0IK4_0TEKNIKER_DCOL_Generation_SensibleStorages_FMI_Buffer_0Dym_0temperature_fmiSetIntegerParam2(void*m, const int*refs, size_t nrefs, int*vals, int*oldVals) {
  struct dy_Extended*a=m;
  fmiStatus status=fmiFatal;
  int i=0;
  if(!nrefs){return;}
  if (a) {
    if(a->currentMode == dyInstantiationMode){
      status=a->dyFmiSetInteger(a->m, refs, nrefs, vals);
    }else{
      status=a->dyFmiGetInteger(a->m, refs, nrefs, oldVals);
      for(i = 0; i< nrefs; ++i){
        if(vals[i]!=oldVals[i]){
          ModelicaError(\"SetIntegerParameter: new parameters with diferent values are being set after initialization, this is not allowed\");
        }
      }
    }
  }
  if (status!=fmiOK && status!=fmiWarning) ModelicaError(\"SetInteger failed\");
}
#endif", Library="Modelica_0IK4_0TEKNIKER_DCOL_Generation_SensibleStorages_FMI_Buffer_0Dym_0temperature", LibraryDirectory="modelica://DCOL/Resources/Library/FMU/Buffer_FMU_temperature/binaries",                       __Dymola_CriticalRegion="Modelica_0IK4_0TEKNIKER_DCOL_Generation_SensibleStorages_FMI_Buffer_0Dym_0temperature",__Dymola_IdemPotent=true, __Dymola_VectorizedExceptFirst=true);
    end fmiSetIntegerParam;

    function fmiGetBooleanScalar
      input fmiModel fmi;
      input Integer ref;
      input Integer dummy;
      output Boolean val;
    algorithm
        val := scalar(fmiGetBoolean(fmi, {ref}, dummy));
    end fmiGetBooleanScalar;

    function fmiGetBoolean
      input fmiModel fmi;
      input Integer refs[:];
      output Boolean vals[size(refs, 1)];
      input Integer preAvailable;
      external"C" Modelica_0IK4_0TEKNIKER_DCOL_Generation_SensibleStorages_FMI_Buffer_0Dym_0temperature_fmiGetBoolean2(
        fmi,
        refs,
        size(refs, 1),
        vals);
        annotation (Header="
#ifndef Modelica_0IK4_0TEKNIKER_DCOL_Generation_SensibleStorages_FMI_Buffer_0Dym_0temperature_GetBoolean_C
#define Modelica_0IK4_0TEKNIKER_DCOL_Generation_SensibleStorages_FMI_Buffer_0Dym_0temperature_GetBoolean_C 1
#include \"FMI/fmiImport.h\"
void Modelica_0IK4_0TEKNIKER_DCOL_Generation_SensibleStorages_FMI_Buffer_0Dym_0temperature_fmiGetBoolean2(void*m, const int* refs, size_t nr, int* vals) {
  int i;
  struct dy_Extended*a=m;
  fmiStatus status=fmiFatal;
  if (a) {
    status=a->dyFmiGetBoolean(a->m, refs, nr, (fmiBoolean*)(vals));
  }
  if (status!=fmiOK && status!=fmiWarning) ModelicaError(\"GetBoolean failed\");
  for(i=nr-1;i>=0;i--) vals[i]=((fmiBoolean*)(vals))[i];
}
#endif", Library="Modelica_0IK4_0TEKNIKER_DCOL_Generation_SensibleStorages_FMI_Buffer_0Dym_0temperature", LibraryDirectory="modelica://DCOL/Resources/Library/FMU/Buffer_FMU_temperature/binaries",                       __Dymola_CriticalRegion="Modelica_0IK4_0TEKNIKER_DCOL_Generation_SensibleStorages_FMI_Buffer_0Dym_0temperature");
    end fmiGetBoolean;

    function fmiSetBoolean
      input fmiModel fmi;
      input Integer refs[:];
      input Boolean vals[size(refs, 1)];
      output Real dummy2= 1;
    protected
      Boolean dummy[size(refs, 1)];
      external"C" Modelica_0IK4_0TEKNIKER_DCOL_Generation_SensibleStorages_FMI_Buffer_0Dym_0temperature_fmiSetBoolean2(
        fmi,
        refs,
        size(refs, 1),
        vals,
        dummy);
        annotation (Header="
#ifndef Modelica_0IK4_0TEKNIKER_DCOL_Generation_SensibleStorages_FMI_Buffer_0Dym_0temperature_SetBoolean_C
#define Modelica_0IK4_0TEKNIKER_DCOL_Generation_SensibleStorages_FMI_Buffer_0Dym_0temperature_SetBoolean_C 1
#include \"FMI/fmiImport.h\"
void Modelica_0IK4_0TEKNIKER_DCOL_Generation_SensibleStorages_FMI_Buffer_0Dym_0temperature_fmiSetBoolean2(void*m, const int* refs, size_t nr, const int* vals,int*dummy) {
  int i;
  struct dy_Extended*a=m;
  fmiStatus status=fmiFatal;
  if(!nr){return;}
  for(i=0;i<nr;++i) ((fmiBoolean*)(dummy))[i]=vals[i];
  if (a) {
    status=a->dyFmiSetBoolean(a->m, refs, nr, (fmiBoolean*)(dummy));
  }
  if (status!=fmiOK && status!=fmiWarning) ModelicaError(\"SetBoolean failed\");
}
#endif", Library="Modelica_0IK4_0TEKNIKER_DCOL_Generation_SensibleStorages_FMI_Buffer_0Dym_0temperature", LibraryDirectory="modelica://DCOL/Resources/Library/FMU/Buffer_FMU_temperature/binaries",                       __Dymola_CriticalRegion="Modelica_0IK4_0TEKNIKER_DCOL_Generation_SensibleStorages_FMI_Buffer_0Dym_0temperature",__Dymola_IdemPotent=true, __Dymola_VectorizedExceptFirst=true);
    end fmiSetBoolean;

    function fmiSetBooleanParam
      input fmiModel fmi;
      input Integer refs[:];
      input Boolean vals[size(refs, 1)];
    protected
      Boolean dummy[size(refs, 1)];
      Boolean oldVals[size(refs, 1)];
      external"C" Modelica_0IK4_0TEKNIKER_DCOL_Generation_SensibleStorages_FMI_Buffer_0Dym_0temperature_fmiSetBooleanParam2(
      fmi,
        refs,
        size(refs, 1),
        vals,
        dummy,
        oldVals);
        annotation (Header="
#ifndef Modelica_0IK4_0TEKNIKER_DCOL_Generation_SensibleStorages_FMI_Buffer_0Dym_0temperature_SetBooleanParam_C
#define Modelica_0IK4_0TEKNIKER_DCOL_Generation_SensibleStorages_FMI_Buffer_0Dym_0temperature_SetBooleanParam_C 1
#include \"FMI/fmiImport.h\"
void Modelica_0IK4_0TEKNIKER_DCOL_Generation_SensibleStorages_FMI_Buffer_0Dym_0temperature_fmiSetBooleanParam2(void*m, const int* refs, size_t nr, const int* vals,int*dummy,int*oldVals) {
  int i;
  struct dy_Extended*a=m;
  fmiStatus status=fmiFatal;
  if(!nr){return;}
  for(i=0;i<nr;++i) ((fmiBoolean*)(dummy))[i]=vals[i];
  if (a) {
    if(a->currentMode == dyInstantiationMode){
      status=a->dyFmiSetBoolean(a->m, refs, nr, (fmiBoolean*)(dummy));
    }else{
      status=a->dyFmiGetBoolean(a->m, refs, nr, (fmiBoolean*)(oldVals));
      for(i=nr-1;i>=0;i--){
        oldVals[i]=((fmiBoolean*)(oldVals))[i];
        if(oldVals[i]!=dummy[i]){
          ModelicaError(\"SetIntegerParameter: new parameters with diferent values are being set after initialization, this is not allowed\");
        }
      }
    }
  }
  if (status!=fmiOK && status!=fmiWarning) ModelicaError(\"SetBoolean failed\");
}
#endif", Library="Modelica_0IK4_0TEKNIKER_DCOL_Generation_SensibleStorages_FMI_Buffer_0Dym_0temperature", LibraryDirectory="modelica://DCOL/Resources/Library/FMU/Buffer_FMU_temperature/binaries",                       __Dymola_CriticalRegion="Modelica_0IK4_0TEKNIKER_DCOL_Generation_SensibleStorages_FMI_Buffer_0Dym_0temperature",__Dymola_IdemPotent=true, __Dymola_VectorizedExceptFirst=true);
    end fmiSetBooleanParam;

    function fmiGetString
      input fmiModel fmi;
      input Integer refs[:];
      output String vals[size(refs, 1)];
      input Integer preAvailable;
      external"C" Modelica_0IK4_0TEKNIKER_DCOL_Generation_SensibleStorages_FMI_Buffer_0Dym_0temperature_fmiGetString2(
        fmi,
        refs,
        size(refs, 1),
        vals);
      annotation (Header="
#ifndef Modelica_0IK4_0TEKNIKER_DCOL_Generation_SensibleStorages_FMI_Buffer_0Dym_0temperature_GetString_C
#define Modelica_0IK4_0TEKNIKER_DCOL_Generation_SensibleStorages_FMI_Buffer_0Dym_0temperature_GetString_C 1
#include <stdlib.h>
#include \"FMI/fmiImport.h\"
void Modelica_0IK4_0TEKNIKER_DCOL_Generation_SensibleStorages_FMI_Buffer_0Dym_0temperature_fmiGetString2(void*m, const int*refs, size_t nrefs, fmiString* vals) {
  struct dy_Extended*a=m;
  fmiStatus status=fmiFatal;
  if (a) {
    status=a->dyFmiGetString(a->m, refs, nrefs, vals);
  }
  if (status!=fmiOK && status!=fmiWarning) ModelicaError(\"StringInteger failed\");
}
#endif", Library="Modelica_0IK4_0TEKNIKER_DCOL_Generation_SensibleStorages_FMI_Buffer_0Dym_0temperature", LibraryDirectory="modelica://DCOL/Resources/Library/FMU/Buffer_FMU_temperature/binaries",                       __Dymola_CriticalRegion="Modelica_0IK4_0TEKNIKER_DCOL_Generation_SensibleStorages_FMI_Buffer_0Dym_0temperature");
    end fmiGetString;

    function fmiSetString
    input fmiModel fmi;
      input Integer refs[:];
      input String vals[size(refs, 1)];
      external"C" Modelica_0IK4_0TEKNIKER_DCOL_Generation_SensibleStorages_FMI_Buffer_0Dym_0temperature_fmiSetString2(
        fmi,
        refs,
        size(refs, 1),
        vals);
        annotation (Header="
#ifndef Modelica_0IK4_0TEKNIKER_DCOL_Generation_SensibleStorages_FMI_Buffer_0Dym_0temperature_SetString_C
#define Modelica_0IK4_0TEKNIKER_DCOL_Generation_SensibleStorages_FMI_Buffer_0Dym_0temperature_SetString_C 1
#include \"FMI/fmiImport.h\"
#include <stdlib.h>
void Modelica_0IK4_0TEKNIKER_DCOL_Generation_SensibleStorages_FMI_Buffer_0Dym_0temperature_fmiSetString2(void*m, const int*refs, size_t nrefs, const fmiString vals[]) {
  struct dy_Extended*a=m;
  fmiStatus status=fmiFatal;
  if(!nrefs){return;}
  if (a) {
    status=a->dyFmiSetString(a->m, refs, nrefs, vals);
  }
  if (status!=fmiOK && status!=fmiWarning) ModelicaError(\"SetString failed\");
}
#endif", Library="Modelica_0IK4_0TEKNIKER_DCOL_Generation_SensibleStorages_FMI_Buffer_0Dym_0temperature", LibraryDirectory="modelica://DCOL/Resources/Library/FMU/Buffer_FMU_temperature/binaries",                       __Dymola_CriticalRegion="Modelica_0IK4_0TEKNIKER_DCOL_Generation_SensibleStorages_FMI_Buffer_0Dym_0temperature",__Dymola_IdemPotent=true, __Dymola_VectorizedExceptFirst=true);
    end fmiSetString;

    function fmiSetStringParam
    input fmiModel fmi;
      input Integer refs[:];
      input String vals[size(refs, 1)];
      external"C" Modelica_0IK4_0TEKNIKER_DCOL_Generation_SensibleStorages_FMI_Buffer_0Dym_0temperature_fmiSetStringParam2(
        fmi,
        refs,
        size(refs, 1),
        vals);
        annotation (Header="
#ifndef Modelica_0IK4_0TEKNIKER_DCOL_Generation_SensibleStorages_FMI_Buffer_0Dym_0temperature_SetStringParam_C
#define Modelica_0IK4_0TEKNIKER_DCOL_Generation_SensibleStorages_FMI_Buffer_0Dym_0temperature_SetStringParam_C 1
#include \"FMI/fmiImport.h\"
#include <stdlib.h>
void Modelica_0IK4_0TEKNIKER_DCOL_Generation_SensibleStorages_FMI_Buffer_0Dym_0temperature_fmiSetStringParam2(void*m, const int*refs, size_t nrefs, const fmiString vals[]) {
  struct dy_Extended*a=m;
  fmiStatus status=fmiFatal;
  if(!nrefs){return;}
  if (a) {
    if(a->currentMode == dyInstantiationMode){
                status=a->dyFmiSetString(a->m, refs, nrefs, vals);
    }else{
      status=fmiOK;
    }
  }
  if (status!=fmiOK && status!=fmiWarning) ModelicaError(\"SetString failed\");
}
#endif", Library="Modelica_0IK4_0TEKNIKER_DCOL_Generation_SensibleStorages_FMI_Buffer_0Dym_0temperature", LibraryDirectory="modelica://DCOL/Resources/Library/FMU/Buffer_FMU_temperature/binaries",                       __Dymola_CriticalRegion="Modelica_0IK4_0TEKNIKER_DCOL_Generation_SensibleStorages_FMI_Buffer_0Dym_0temperature",__Dymola_IdemPotent=true, __Dymola_VectorizedExceptFirst=true);
    end fmiSetStringParam;

    function noHysteresis
      input Real x;
      output Real y;
    algorithm
      y:=x+(if (x < 0) then -1 else 1);
    end noHysteresis;
end fmi_Functions;
equation
  when initial() then
    fmi = fmi_Functions.fmiModel(fmi_instanceName, fmi_loggingOn, fmi_fmuLocation);
  end when;
algorithm
  when {initial(), sample(fmi_StartTime, fmi_CommunicationStepSize)} then
    if time>=fmi_CommunicationStepSize +fmi_StartTime then
    if fmi_InputTime then
      fmi_Functions.fmiSetReal(fmi, {352321536}, {_massFlow_old});
    else
      if fmi_UsePreOnInputSignals then
        fmi_Functions.fmiSetReal(fmi, {352321536}, {pre(massFlow)});
      else
        fmi_Functions.fmiSetReal(fmi, {352321536}, {massFlow});
      end if;
    end if;
    if fmi_InputTime then
      fmi_Functions.fmiSetReal(fmi, {352321537}, {_impulsion_T_old});
    else
      if fmi_UsePreOnInputSignals then
        fmi_Functions.fmiSetReal(fmi, {352321537}, {pre(impulsion_T)});
      else
        fmi_Functions.fmiSetReal(fmi, {352321537}, {impulsion_T});
      end if;
    end if;
    if fmi_InputTime then
      fmi_Functions.fmiSetReal(fmi, {352321538}, {_ambient_T_old});
    else
      if fmi_UsePreOnInputSignals then
        fmi_Functions.fmiSetReal(fmi, {352321538}, {pre(ambient_T)});
      else
        fmi_Functions.fmiSetReal(fmi, {352321538}, {ambient_T});
      end if;
    end if;
      for stepSizeIndex in 1:stepSizeScaleFactor loop
        fmi_StepOK :=fmi_Functions.fmiDoStep(
          fmi,
          time + (stepSizeIndex - 1 - stepSizeScaleFactor)*
            fmi_CommunicationStepSize/stepSizeScaleFactor,
          fmi_CommunicationStepSize/stepSizeScaleFactor);
      end for;
    end if;
    _massFlow_old := massFlow;
    _impulsion_T_old := impulsion_T;
    _ambient_T_old := ambient_T;
  m_impulsion_T :=fmi_Functions.fmiGetRealScalar(
      fmi,
      335544320,
      1);
  m_retorno_T :=fmi_Functions.fmiGetRealScalar(
      fmi,
      335544321,
      1);
  heatLosses :=fmi_Functions.fmiGetRealScalar(
      fmi,
      335544322,
      1);
RealVariables1 :=fmi_Functions.fmiGetReal(
      fmi,
      {352321536,100663972,369098830,16777254,369098831,100663461,369098830,
        33554432,587202560,905969755,637534300,100663384,33554432,905969761,
        905969763,637534308,637534312,637534313,352321536,100663972,369098830,
        369098830,369098830,637534321,637534323,100663384,33554432,637534313,
        33554432,637534313,33554432,33554432,637534313,100663384,100663384,
        100663384,100663566,637534406,33554433,587202561,905969844,637534389,
        100663473,33554433,905969850,905969852,637534397,637534401,637534402,
        637534406,352321536,637534406,16777254,637534406,637534406,637534413,
        637534414,100663473,33554433,637534402,33554433,637534402,33554433,
        33554433,637534402,100663473,100663473,100663473,100663473,100663671,
        637534511,33554434,587202562,905969949,637534494,100663578,33554434,
        905969955,905969957,637534502,637534506,637534507,637534511,352321536,
        16777254,637534511,16777254,637534511,637534511,637534518,637534519,
        100663578,33554434,637534507,33554434,637534507,33554434,33554434,
        637534507,100663578},
      1);
RealVariables2 :=fmi_Functions.fmiGetReal(
      fmi,
      {100663578,100663578,100663578,100663760,369098831,33554435,587202563,
        905970054,637534599,100663683,33554435,905970060,905970062,637534607,
        637534611,637534612,369098831,16777254,369098831,352321536,369098831,
        637534621,637534622,100663683,33554435,637534612,33554435,637534612,
        33554435,33554435,637534612,100663683,100663683,100663683,369099220,
        369099221,33554432,369099220,369099222,369099371,369099223,369099224,
        369099225,369099396,369099228,33554435,369099396,369099229,369099372,
        369099230,369099231,369099232,369099397,369099235,33554433,369099397,
        369099236,369099373,369099237,369099238,369099239,369099398,369099242,
        33554434,369099398,369099243,369099374,369099244,369099245,369099246,
        369099399,369099249,33554432,369099399,369099250,369099375,369099251,
        369099252,369099253,369099256,369099257,33554435,369099256,369099258,
        369099259,369099260,369099261,369099262,369099220,369099265,369099222,
        369099220,352321538,369099371,369099267,369099268,369099269,369099270,
        369099271,369099272},
      1);
RealVariables3 :=fmi_Functions.fmiGetReal(
      fmi,
      {369099273,369099274,369099276,369099278,369099396,369099283,369099229,
        369099396,352321538,369099372,369099285,369099286,369099289,369099290,
        369099291,369099292,369099293,369099294,369099295,369099296,369099297,
        369099298,369099397,369099299,369099236,369099397,352321538,369099373,
        369099301,369099302,369099305,369099306,369099307,369099308,369099309,
        369099310,369099311,369099312,369099313,369099314,369099398,369099315,
        369099243,369099398,352321538,369099374,369099317,369099318,369099321,
        369099322,369099323,369099324,369099325,369099326,369099327,369099328,
        369099329,369099330,369099399,369099331,369099250,369099399,352321538,
        369099375,369099333,369099334,369099337,369099338,369099339,369099340,
        369099341,369099342,369099343,369099344,369099345,369099346,369099256,
        369099347,369099258,369099256,352321538,369099259,369099349,369099350,
        369099351,369099352,369099353,369099354,369099355,369099356,369099357,
        369099358,369099359,369099360,637534818,637534819,33554435,637534818,
        33554433,637534820},
      1);
RealVariables4 :=fmi_Functions.fmiGetReal(
      fmi,
      {100663355,637534821,637534822,33554433,637534821,33554434,637534823,
        100663356,637534824,637534825,33554434,637534824,33554432,637534826,
        100663357,369099220,352321538,369099220,352321538,369099371,369099396,
        352321538,369099396,352321538,369099372,369099397,352321538,369099397,
        352321538,369099373,369099398,352321538,369099398,352321538,369099374,
        369099399,352321538,369099399,352321538,369099375,369099256,352321538,
        369099256,352321538,369099259,335544322,352321538,905970288,637534840,
        637534841,637534842,637534843,637534844,637534845,33554435,637534846,
        33554433,637534847,33554434,637534848,33554432,637534845,352321538,
        905970313,352321538,16777254,100663956,16777255,16777254,16777255,
        352321536,16777254,100663972,369099429,352321537,905970332,100663972,
        352321537,905970337,905970339,369099429,352321536,352321537,100663972,
        335544320,16777254,335544321,352321536,16777254,100663956,16777254,
        369098831,352321536},
      1);
  end when;
initial algorithm
  fmi_AParamsAndStart:=1;
 // 31 Real parameters
  fmi_Functions.fmiSetRealParam(fmi, {16777216, 16777217, 16777218, 16777219, 16777220, 16777221, 16777222, 16777223, 16777224, 16777225, 16777226, 16777227, 16777228, 16777229, 16777230, 16777232, 16777234, 16777236, 16777238, 16777240, 16777241, 16777242, 16777243, 16777244, 16777245, 16777246, 16777247, 16777254, 16777255, 16777256, 16777257}, {'system'.p_ambient, 'system'.T_ambient, 'system'.g, 'system'.m_flow_start, 'system'.eps_m_flow, 'system'.dp_small, 'system'.m_flow_small, d, h_max, eTank, d_Inlet, d_Outlet, h_heater, T_start, tau, closedCylindricalTank.volumeTop.'X_start[1]', closedCylindricalTank.'volumeMiddle[1]'.'X_start[1]', closedCylindricalTank.'volumeMiddle[2]'.'X_start[1]', closedCylindricalTank.volumeBottom.'X_start[1]', closedCylindricalTank.topCond.T_start, closedCylindricalTank.'middleCond[1]'.T_start, closedCylindricalTank.'middleCond[2]'.T_start, closedCylindricalTank.'middleCond[3]'.T_start, closedCylindricalTank.'middleCond[4]'.T_start, closedCylindricalTank.bottomCond.T_start, closedCylindricalTank.buoyancy.sta_default.p, closedCylindricalTank.buoyancy.sta_default.T, Retorno.p, Retorno.T, Retorno.h, Retorno.'X[1]'});
 // 0 Real start values
 // 0 Integer parameters
 // 0 Integer start values
 // 1 Boolean parameters
  fmi_Functions.fmiSetBooleanParam(fmi, {16777231}, {closedCylindricalTank.faceUpBottom});
 // 0 Boolean start values
 // 0 Enumeration parameters
 // 0 Enumeration start values
 // 0 String parameters
initial equation
if fmi_pullInputsForInitialization then fmi_initInput0 = fmi_Functions.fmiSetReal(fmi, {352321536}, {pre(massFlow)}); else fmi_initInput0 = fmi_Functions.fmiSetReal(fmi, {352321536}, {_massFlow_start}); end if;
if fmi_pullInputsForInitialization then fmi_initInput1 = fmi_Functions.fmiSetReal(fmi, {352321537}, {pre(impulsion_T)}); else fmi_initInput1 = fmi_Functions.fmiSetReal(fmi, {352321537}, {_impulsion_T_start}); end if;
if fmi_pullInputsForInitialization then fmi_initInput2 = fmi_Functions.fmiSetReal(fmi, {352321538}, {pre(ambient_T)}); else fmi_initInput2 = fmi_Functions.fmiSetReal(fmi, {352321538}, {_ambient_T_start}); end if;
  fmi_Initialized = fmi_Functions.fmiInitializeSlave(fmi, fmi_StartTime, fmi_forceShutDownAtStopTime, fmi_StopTime,fmi_AParamsAndStart+ fmi_initInput0+ fmi_initInput1+ fmi_initInput2);
RealDependentParameters1 = fmi_Functions.fmiGetReal(fmi, {100663302, 100663303, 100663305, 100663310, 100663315, 100663316, 100663331, 100663334, 100663335, 100663358, 100663359, 100663360, 100663362, 100663380, 100663382, 100663383, 100663384, 100663394, 100663397, 16777254, 16777254, 100663406, 100663407, 100663414, 100663417, 100663461, 100663462, 100663464, 100663469, 100663471, 100663472, 100663473, 100663483, 100663486, 16777254, 16777254, 16777254, 100663497, 100663498, 100663506, 100663509, 100663566, 100663567, 100663569, 100663574, 100663576, 100663577, 100663578, 100663588, 100663591, 16777254, 16777254, 100663602, 100663603, 100663611, 100663614, 100663671, 100663672, 100663674, 100663679, 100663681, 100663682, 100663683, 100663693, 100663696, 16777254, 16777254, 100663705, 100663706, 100663713, 100663716, 100663760, 100663761, 100663763, 100663770, 100663771, 100663777, 100663778, 100663784, 100663785, 100663791, 100663792, 100663798, 100663799, 100663807, 100663808, 100663810, 100663823, 100663824, 100663826, 100663828, 100663831, 100663844, 100663847, 100663860, 100663863, 100663876, 100663879, 100663892, 100663905},fmi_Initialized);
RealDependentParameters2 = fmi_Functions.fmiGetReal(fmi, {100663921, 100663923, 100663927, 100663949, 100663954, 100663955, 100663956, 100663970, 100663972, 100663989, 100663990},fmi_Initialized);
equation
  closedCylindricalTank.port_a.m_flow = RealVariables1[1];
  closedCylindricalTank.port_a.p = RealVariables1[2];
  closedCylindricalTank.port_a.h_outflow = RealVariables1[3];
  closedCylindricalTank.port_b.p = RealVariables1[4];
  closedCylindricalTank.port_b.h_outflow = RealVariables1[5];
  closedCylindricalTank.volumeTop.fluidVolume = RealVariables1[6];
  closedCylindricalTank.volumeTop.medium.h = RealVariables1[7];
  closedCylindricalTank.volumeTop.medium.T = RealVariables1[8];
  closedCylindricalTank.volumeTop.medium.T_der = RealVariables1[9];
  closedCylindricalTank.volumeTop.medium.u = RealVariables1[10];
  closedCylindricalTank.volumeTop.medium.u_der = RealVariables1[11];
  closedCylindricalTank.volumeTop.medium.state.p = RealVariables1[12];
  closedCylindricalTank.volumeTop.medium.state.T = RealVariables1[13];
  closedCylindricalTank.volumeTop.medium.T_degC = RealVariables1[14];
  closedCylindricalTank.volumeTop.U = RealVariables1[15];
  closedCylindricalTank.volumeTop.U_der = RealVariables1[16];
  closedCylindricalTank.volumeTop.Hb_flow = RealVariables1[17];
  closedCylindricalTank.volumeTop.Qb_flow = RealVariables1[18];
  closedCylindricalTank.volumeTop.'ports[1]'.m_flow = RealVariables1[19];
  closedCylindricalTank.volumeTop.'ports[1]'.p = RealVariables1[20];
  closedCylindricalTank.volumeTop.'ports[1]'.h_outflow = RealVariables1[21];
  closedCylindricalTank.volumeTop.'ports[2]'.h_outflow = RealVariables1[22];
  closedCylindricalTank.volumeTop.'ports[3]'.h_outflow = RealVariables1[23];
  closedCylindricalTank.volumeTop.'ports_H_flow[1]' = RealVariables1[24];
  closedCylindricalTank.volumeTop.'ports_H_flow[3]' = RealVariables1[25];
  closedCylindricalTank.volumeTop.heatTransfer.'states[1]'.p = RealVariables1[26];
  closedCylindricalTank.volumeTop.heatTransfer.'states[1]'.T = RealVariables1[27];
  closedCylindricalTank.volumeTop.heatTransfer.'Q_flows[1]' = RealVariables1[28];
  closedCylindricalTank.volumeTop.heatTransfer.'heatPorts[1]'.T = RealVariables1[29];
  closedCylindricalTank.volumeTop.heatTransfer.'heatPorts[1]'.Q_flow = RealVariables1[30];
  closedCylindricalTank.volumeTop.heatTransfer.'Ts[1]' = RealVariables1[31];
  closedCylindricalTank.volumeTop.heatPort.T = RealVariables1[32];
  closedCylindricalTank.volumeTop.heatPort.Q_flow = RealVariables1[33];
  closedCylindricalTank.volumeTop.'vessel_ps_static[1]' = RealVariables1[34];
  closedCylindricalTank.volumeTop.'vessel_ps_static[2]' = RealVariables1[35];
  closedCylindricalTank.volumeTop.'vessel_ps_static[3]' = RealVariables1[36];
  closedCylindricalTank.'volumeMiddle[1]'.fluidVolume = RealVariables1[37];
  closedCylindricalTank.'volumeMiddle[1]'.medium.h = RealVariables1[38];
  closedCylindricalTank.'volumeMiddle[1]'.medium.T = RealVariables1[39];
  closedCylindricalTank.'volumeMiddle[1]'.medium.T_der = RealVariables1[40];
  closedCylindricalTank.'volumeMiddle[1]'.medium.u = RealVariables1[41];
  closedCylindricalTank.'volumeMiddle[1]'.medium.u_der = RealVariables1[42];
  closedCylindricalTank.'volumeMiddle[1]'.medium.state.p = RealVariables1[43];
  closedCylindricalTank.'volumeMiddle[1]'.medium.state.T = RealVariables1[44];
  closedCylindricalTank.'volumeMiddle[1]'.medium.T_degC = RealVariables1[45];
  closedCylindricalTank.'volumeMiddle[1]'.U = RealVariables1[46];
  closedCylindricalTank.'volumeMiddle[1]'.U_der = RealVariables1[47];
  closedCylindricalTank.'volumeMiddle[1]'.Hb_flow = RealVariables1[48];
  closedCylindricalTank.'volumeMiddle[1]'.Qb_flow = RealVariables1[49];
  closedCylindricalTank.'volumeMiddle[1]'.'ports[1]'.h_outflow = RealVariables1[50];
  closedCylindricalTank.'volumeMiddle[1]'.'ports[2]'.m_flow = RealVariables1[51];
  closedCylindricalTank.'volumeMiddle[1]'.'ports[2]'.h_outflow = RealVariables1[52];
  closedCylindricalTank.'volumeMiddle[1]'.'ports[3]'.p = RealVariables1[53];
  closedCylindricalTank.'volumeMiddle[1]'.'ports[3]'.h_outflow = RealVariables1[54];
  closedCylindricalTank.'volumeMiddle[1]'.'ports[4]'.h_outflow = RealVariables1[55];
  closedCylindricalTank.'volumeMiddle[1]'.'ports_H_flow[2]' = RealVariables1[56];
  closedCylindricalTank.'volumeMiddle[1]'.'ports_H_flow[3]' = RealVariables1[57];
  closedCylindricalTank.'volumeMiddle[1]'.heatTransfer.'states[1]'.p = RealVariables1[58];
  closedCylindricalTank.'volumeMiddle[1]'.heatTransfer.'states[1]'.T = RealVariables1[59];
  closedCylindricalTank.'volumeMiddle[1]'.heatTransfer.'Q_flows[1]' = RealVariables1[60];
  closedCylindricalTank.'volumeMiddle[1]'.heatTransfer.'heatPorts[1]'.T = RealVariables1[61];
  closedCylindricalTank.'volumeMiddle[1]'.heatTransfer.'heatPorts[1]'.Q_flow = RealVariables1[62];
  closedCylindricalTank.'volumeMiddle[1]'.heatTransfer.'Ts[1]' = RealVariables1[63];
  closedCylindricalTank.'volumeMiddle[1]'.heatPort.T = RealVariables1[64];
  closedCylindricalTank.'volumeMiddle[1]'.heatPort.Q_flow = RealVariables1[65];
  closedCylindricalTank.'volumeMiddle[1]'.'vessel_ps_static[1]' = RealVariables1[66];
  closedCylindricalTank.'volumeMiddle[1]'.'vessel_ps_static[2]' = RealVariables1[67];
  closedCylindricalTank.'volumeMiddle[1]'.'vessel_ps_static[3]' = RealVariables1[68];
  closedCylindricalTank.'volumeMiddle[1]'.'vessel_ps_static[4]' = RealVariables1[69];
  closedCylindricalTank.'volumeMiddle[2]'.fluidVolume = RealVariables1[70];
  closedCylindricalTank.'volumeMiddle[2]'.medium.h = RealVariables1[71];
  closedCylindricalTank.'volumeMiddle[2]'.medium.T = RealVariables1[72];
  closedCylindricalTank.'volumeMiddle[2]'.medium.T_der = RealVariables1[73];
  closedCylindricalTank.'volumeMiddle[2]'.medium.u = RealVariables1[74];
  closedCylindricalTank.'volumeMiddle[2]'.medium.u_der = RealVariables1[75];
  closedCylindricalTank.'volumeMiddle[2]'.medium.state.p = RealVariables1[76];
  closedCylindricalTank.'volumeMiddle[2]'.medium.state.T = RealVariables1[77];
  closedCylindricalTank.'volumeMiddle[2]'.medium.T_degC = RealVariables1[78];
  closedCylindricalTank.'volumeMiddle[2]'.U = RealVariables1[79];
  closedCylindricalTank.'volumeMiddle[2]'.U_der = RealVariables1[80];
  closedCylindricalTank.'volumeMiddle[2]'.Hb_flow = RealVariables1[81];
  closedCylindricalTank.'volumeMiddle[2]'.Qb_flow = RealVariables1[82];
  closedCylindricalTank.'volumeMiddle[2]'.'ports[1]'.h_outflow = RealVariables1[83];
  closedCylindricalTank.'volumeMiddle[2]'.'ports[2]'.m_flow = RealVariables1[84];
  closedCylindricalTank.'volumeMiddle[2]'.'ports[2]'.p = RealVariables1[85];
  closedCylindricalTank.'volumeMiddle[2]'.'ports[2]'.h_outflow = RealVariables1[86];
  closedCylindricalTank.'volumeMiddle[2]'.'ports[3]'.p = RealVariables1[87];
  closedCylindricalTank.'volumeMiddle[2]'.'ports[3]'.h_outflow = RealVariables1[88];
  closedCylindricalTank.'volumeMiddle[2]'.'ports[4]'.h_outflow = RealVariables1[89];
  closedCylindricalTank.'volumeMiddle[2]'.'ports_H_flow[2]' = RealVariables1[90];
  closedCylindricalTank.'volumeMiddle[2]'.'ports_H_flow[3]' = RealVariables1[91];
  closedCylindricalTank.'volumeMiddle[2]'.heatTransfer.'states[1]'.p = RealVariables1[92];
  closedCylindricalTank.'volumeMiddle[2]'.heatTransfer.'states[1]'.T = RealVariables1[93];
  closedCylindricalTank.'volumeMiddle[2]'.heatTransfer.'Q_flows[1]' = RealVariables1[94];
  closedCylindricalTank.'volumeMiddle[2]'.heatTransfer.'heatPorts[1]'.T = RealVariables1[95];
  closedCylindricalTank.'volumeMiddle[2]'.heatTransfer.'heatPorts[1]'.Q_flow = RealVariables1[96];
  closedCylindricalTank.'volumeMiddle[2]'.heatTransfer.'Ts[1]' = RealVariables1[97];
  closedCylindricalTank.'volumeMiddle[2]'.heatPort.T = RealVariables1[98];
  closedCylindricalTank.'volumeMiddle[2]'.heatPort.Q_flow = RealVariables1[99];
  closedCylindricalTank.'volumeMiddle[2]'.'vessel_ps_static[1]' = RealVariables1[100];
  closedCylindricalTank.'volumeMiddle[2]'.'vessel_ps_static[2]' = RealVariables2[1];
  closedCylindricalTank.'volumeMiddle[2]'.'vessel_ps_static[3]' = RealVariables2[2];
  closedCylindricalTank.'volumeMiddle[2]'.'vessel_ps_static[4]' = RealVariables2[3];
  closedCylindricalTank.volumeBottom.fluidVolume = RealVariables2[4];
  closedCylindricalTank.volumeBottom.medium.h = RealVariables2[5];
  closedCylindricalTank.volumeBottom.medium.T = RealVariables2[6];
  closedCylindricalTank.volumeBottom.medium.T_der = RealVariables2[7];
  closedCylindricalTank.volumeBottom.medium.u = RealVariables2[8];
  closedCylindricalTank.volumeBottom.medium.u_der = RealVariables2[9];
  closedCylindricalTank.volumeBottom.medium.state.p = RealVariables2[10];
  closedCylindricalTank.volumeBottom.medium.state.T = RealVariables2[11];
  closedCylindricalTank.volumeBottom.medium.T_degC = RealVariables2[12];
  closedCylindricalTank.volumeBottom.U = RealVariables2[13];
  closedCylindricalTank.volumeBottom.U_der = RealVariables2[14];
  closedCylindricalTank.volumeBottom.Hb_flow = RealVariables2[15];
  closedCylindricalTank.volumeBottom.Qb_flow = RealVariables2[16];
  closedCylindricalTank.volumeBottom.'ports[1]'.h_outflow = RealVariables2[17];
  closedCylindricalTank.volumeBottom.'ports[2]'.p = RealVariables2[18];
  closedCylindricalTank.volumeBottom.'ports[2]'.h_outflow = RealVariables2[19];
  closedCylindricalTank.volumeBottom.'ports[3]'.m_flow = RealVariables2[20];
  closedCylindricalTank.volumeBottom.'ports[3]'.h_outflow = RealVariables2[21];
  closedCylindricalTank.volumeBottom.'ports_H_flow[2]' = RealVariables2[22];
  closedCylindricalTank.volumeBottom.'ports_H_flow[3]' = RealVariables2[23];
  closedCylindricalTank.volumeBottom.heatTransfer.'states[1]'.p = RealVariables2[24];
  closedCylindricalTank.volumeBottom.heatTransfer.'states[1]'.T = RealVariables2[25];
  closedCylindricalTank.volumeBottom.heatTransfer.'Q_flows[1]' = RealVariables2[26];
  closedCylindricalTank.volumeBottom.heatTransfer.'heatPorts[1]'.T = RealVariables2[27];
  closedCylindricalTank.volumeBottom.heatTransfer.'heatPorts[1]'.Q_flow = RealVariables2[28];
  closedCylindricalTank.volumeBottom.heatTransfer.'Ts[1]' = RealVariables2[29];
  closedCylindricalTank.volumeBottom.heatPort.T = RealVariables2[30];
  closedCylindricalTank.volumeBottom.heatPort.Q_flow = RealVariables2[31];
  closedCylindricalTank.volumeBottom.'vessel_ps_static[1]' = RealVariables2[32];
  closedCylindricalTank.volumeBottom.'vessel_ps_static[2]' = RealVariables2[33];
  closedCylindricalTank.volumeBottom.'vessel_ps_static[3]' = RealVariables2[34];
  closedCylindricalTank.topCond.Q_flow = RealVariables2[35];
  closedCylindricalTank.topCond.dT = RealVariables2[36];
  closedCylindricalTank.topCond.port_a.T = RealVariables2[37];
  closedCylindricalTank.topCond.port_a.Q_flow = RealVariables2[38];
  closedCylindricalTank.topCond.port_b.T = RealVariables2[39];
  closedCylindricalTank.topCond.port_b.Q_flow = RealVariables2[40];
  closedCylindricalTank.topCond.T = RealVariables2[41];
  closedCylindricalTank.topCond.G = RealVariables2[42];
  closedCylindricalTank.topCond.k = RealVariables2[43];
  closedCylindricalTank.'middleCond[1]'.Q_flow = RealVariables2[44];
  closedCylindricalTank.'middleCond[1]'.dT = RealVariables2[45];
  closedCylindricalTank.'middleCond[1]'.port_a.T = RealVariables2[46];
  closedCylindricalTank.'middleCond[1]'.port_a.Q_flow = RealVariables2[47];
  closedCylindricalTank.'middleCond[1]'.port_b.T = RealVariables2[48];
  closedCylindricalTank.'middleCond[1]'.port_b.Q_flow = RealVariables2[49];
  closedCylindricalTank.'middleCond[1]'.T = RealVariables2[50];
  closedCylindricalTank.'middleCond[1]'.G = RealVariables2[51];
  closedCylindricalTank.'middleCond[1]'.k = RealVariables2[52];
  closedCylindricalTank.'middleCond[2]'.Q_flow = RealVariables2[53];
  closedCylindricalTank.'middleCond[2]'.dT = RealVariables2[54];
  closedCylindricalTank.'middleCond[2]'.port_a.T = RealVariables2[55];
  closedCylindricalTank.'middleCond[2]'.port_a.Q_flow = RealVariables2[56];
  closedCylindricalTank.'middleCond[2]'.port_b.T = RealVariables2[57];
  closedCylindricalTank.'middleCond[2]'.port_b.Q_flow = RealVariables2[58];
  closedCylindricalTank.'middleCond[2]'.T = RealVariables2[59];
  closedCylindricalTank.'middleCond[2]'.G = RealVariables2[60];
  closedCylindricalTank.'middleCond[2]'.k = RealVariables2[61];
  closedCylindricalTank.'middleCond[3]'.Q_flow = RealVariables2[62];
  closedCylindricalTank.'middleCond[3]'.dT = RealVariables2[63];
  closedCylindricalTank.'middleCond[3]'.port_a.T = RealVariables2[64];
  closedCylindricalTank.'middleCond[3]'.port_a.Q_flow = RealVariables2[65];
  closedCylindricalTank.'middleCond[3]'.port_b.T = RealVariables2[66];
  closedCylindricalTank.'middleCond[3]'.port_b.Q_flow = RealVariables2[67];
  closedCylindricalTank.'middleCond[3]'.T = RealVariables2[68];
  closedCylindricalTank.'middleCond[3]'.G = RealVariables2[69];
  closedCylindricalTank.'middleCond[3]'.k = RealVariables2[70];
  closedCylindricalTank.'middleCond[4]'.Q_flow = RealVariables2[71];
  closedCylindricalTank.'middleCond[4]'.dT = RealVariables2[72];
  closedCylindricalTank.'middleCond[4]'.port_a.T = RealVariables2[73];
  closedCylindricalTank.'middleCond[4]'.port_a.Q_flow = RealVariables2[74];
  closedCylindricalTank.'middleCond[4]'.port_b.T = RealVariables2[75];
  closedCylindricalTank.'middleCond[4]'.port_b.Q_flow = RealVariables2[76];
  closedCylindricalTank.'middleCond[4]'.T = RealVariables2[77];
  closedCylindricalTank.'middleCond[4]'.G = RealVariables2[78];
  closedCylindricalTank.'middleCond[4]'.k = RealVariables2[79];
  closedCylindricalTank.bottomCond.Q_flow = RealVariables2[80];
  closedCylindricalTank.bottomCond.dT = RealVariables2[81];
  closedCylindricalTank.bottomCond.port_a.T = RealVariables2[82];
  closedCylindricalTank.bottomCond.port_a.Q_flow = RealVariables2[83];
  closedCylindricalTank.bottomCond.port_b.T = RealVariables2[84];
  closedCylindricalTank.bottomCond.port_b.Q_flow = RealVariables2[85];
  closedCylindricalTank.bottomCond.T = RealVariables2[86];
  closedCylindricalTank.bottomCond.G = RealVariables2[87];
  closedCylindricalTank.bottomCond.k = RealVariables2[88];
  closedCylindricalTank.topConv.Q_flow = RealVariables2[89];
  closedCylindricalTank.topConv.dT = RealVariables2[90];
  closedCylindricalTank.topConv.solid.T = RealVariables2[91];
  closedCylindricalTank.topConv.solid.Q_flow = RealVariables2[92];
  closedCylindricalTank.topConv.fluid.T = RealVariables2[93];
  closedCylindricalTank.topConv.fluid.Q_flow = RealVariables2[94];
  closedCylindricalTank.topConv.Gc = RealVariables2[95];
  closedCylindricalTank.topConv.h = RealVariables2[96];
  closedCylindricalTank.topConv.beta = RealVariables2[97];
  closedCylindricalTank.topConv.Gr = RealVariables2[98];
  closedCylindricalTank.topConv.Ra = RealVariables2[99];
  closedCylindricalTank.topConv.NuL = RealVariables2[100];
  closedCylindricalTank.topConv.NuLa = RealVariables3[1];
  closedCylindricalTank.topConv.NuLb = RealVariables3[2];
  closedCylindricalTank.topConv.visco = RealVariables3[3];
  closedCylindricalTank.topConv.Tc = RealVariables3[4];
  closedCylindricalTank.'middleConv[1]'.Q_flow = RealVariables3[5];
  closedCylindricalTank.'middleConv[1]'.dT = RealVariables3[6];
  closedCylindricalTank.'middleConv[1]'.solid.T = RealVariables3[7];
  closedCylindricalTank.'middleConv[1]'.solid.Q_flow = RealVariables3[8];
  closedCylindricalTank.'middleConv[1]'.fluid.T = RealVariables3[9];
  closedCylindricalTank.'middleConv[1]'.fluid.Q_flow = RealVariables3[10];
  closedCylindricalTank.'middleConv[1]'.Gc = RealVariables3[11];
  closedCylindricalTank.'middleConv[1]'.h = RealVariables3[12];
  closedCylindricalTank.'middleConv[1]'.Tm = RealVariables3[13];
  closedCylindricalTank.'middleConv[1]'.visco = RealVariables3[14];
  closedCylindricalTank.'middleConv[1]'.K = RealVariables3[15];
  closedCylindricalTank.'middleConv[1]'.Pr = RealVariables3[16];
  closedCylindricalTank.'middleConv[1]'.Ra = RealVariables3[17];
  closedCylindricalTank.'middleConv[1]'.Gr = RealVariables3[18];
  closedCylindricalTank.'middleConv[1]'.beta = RealVariables3[19];
  closedCylindricalTank.'middleConv[1]'.Nu_nat = RealVariables3[20];
  closedCylindricalTank.'middleConv[1]'.Nu_nat1 = RealVariables3[21];
  closedCylindricalTank.'middleConv[1]'.Nu_nat2 = RealVariables3[22];
  closedCylindricalTank.'middleConv[2]'.Q_flow = RealVariables3[23];
  closedCylindricalTank.'middleConv[2]'.dT = RealVariables3[24];
  closedCylindricalTank.'middleConv[2]'.solid.T = RealVariables3[25];
  closedCylindricalTank.'middleConv[2]'.solid.Q_flow = RealVariables3[26];
  closedCylindricalTank.'middleConv[2]'.fluid.T = RealVariables3[27];
  closedCylindricalTank.'middleConv[2]'.fluid.Q_flow = RealVariables3[28];
  closedCylindricalTank.'middleConv[2]'.Gc = RealVariables3[29];
  closedCylindricalTank.'middleConv[2]'.h = RealVariables3[30];
  closedCylindricalTank.'middleConv[2]'.Tm = RealVariables3[31];
  closedCylindricalTank.'middleConv[2]'.visco = RealVariables3[32];
  closedCylindricalTank.'middleConv[2]'.K = RealVariables3[33];
  closedCylindricalTank.'middleConv[2]'.Pr = RealVariables3[34];
  closedCylindricalTank.'middleConv[2]'.Ra = RealVariables3[35];
  closedCylindricalTank.'middleConv[2]'.Gr = RealVariables3[36];
  closedCylindricalTank.'middleConv[2]'.beta = RealVariables3[37];
  closedCylindricalTank.'middleConv[2]'.Nu_nat = RealVariables3[38];
  closedCylindricalTank.'middleConv[2]'.Nu_nat1 = RealVariables3[39];
  closedCylindricalTank.'middleConv[2]'.Nu_nat2 = RealVariables3[40];
  closedCylindricalTank.'middleConv[3]'.Q_flow = RealVariables3[41];
  closedCylindricalTank.'middleConv[3]'.dT = RealVariables3[42];
  closedCylindricalTank.'middleConv[3]'.solid.T = RealVariables3[43];
  closedCylindricalTank.'middleConv[3]'.solid.Q_flow = RealVariables3[44];
  closedCylindricalTank.'middleConv[3]'.fluid.T = RealVariables3[45];
  closedCylindricalTank.'middleConv[3]'.fluid.Q_flow = RealVariables3[46];
  closedCylindricalTank.'middleConv[3]'.Gc = RealVariables3[47];
  closedCylindricalTank.'middleConv[3]'.h = RealVariables3[48];
  closedCylindricalTank.'middleConv[3]'.Tm = RealVariables3[49];
  closedCylindricalTank.'middleConv[3]'.visco = RealVariables3[50];
  closedCylindricalTank.'middleConv[3]'.K = RealVariables3[51];
  closedCylindricalTank.'middleConv[3]'.Pr = RealVariables3[52];
  closedCylindricalTank.'middleConv[3]'.Ra = RealVariables3[53];
  closedCylindricalTank.'middleConv[3]'.Gr = RealVariables3[54];
  closedCylindricalTank.'middleConv[3]'.beta = RealVariables3[55];
  closedCylindricalTank.'middleConv[3]'.Nu_nat = RealVariables3[56];
  closedCylindricalTank.'middleConv[3]'.Nu_nat1 = RealVariables3[57];
  closedCylindricalTank.'middleConv[3]'.Nu_nat2 = RealVariables3[58];
  closedCylindricalTank.'middleConv[4]'.Q_flow = RealVariables3[59];
  closedCylindricalTank.'middleConv[4]'.dT = RealVariables3[60];
  closedCylindricalTank.'middleConv[4]'.solid.T = RealVariables3[61];
  closedCylindricalTank.'middleConv[4]'.solid.Q_flow = RealVariables3[62];
  closedCylindricalTank.'middleConv[4]'.fluid.T = RealVariables3[63];
  closedCylindricalTank.'middleConv[4]'.fluid.Q_flow = RealVariables3[64];
  closedCylindricalTank.'middleConv[4]'.Gc = RealVariables3[65];
  closedCylindricalTank.'middleConv[4]'.h = RealVariables3[66];
  closedCylindricalTank.'middleConv[4]'.Tm = RealVariables3[67];
  closedCylindricalTank.'middleConv[4]'.visco = RealVariables3[68];
  closedCylindricalTank.'middleConv[4]'.K = RealVariables3[69];
  closedCylindricalTank.'middleConv[4]'.Pr = RealVariables3[70];
  closedCylindricalTank.'middleConv[4]'.Ra = RealVariables3[71];
  closedCylindricalTank.'middleConv[4]'.Gr = RealVariables3[72];
  closedCylindricalTank.'middleConv[4]'.beta = RealVariables3[73];
  closedCylindricalTank.'middleConv[4]'.Nu_nat = RealVariables3[74];
  closedCylindricalTank.'middleConv[4]'.Nu_nat1 = RealVariables3[75];
  closedCylindricalTank.'middleConv[4]'.Nu_nat2 = RealVariables3[76];
  closedCylindricalTank.bottomConv.Q_flow = RealVariables3[77];
  closedCylindricalTank.bottomConv.dT = RealVariables3[78];
  closedCylindricalTank.bottomConv.solid.T = RealVariables3[79];
  closedCylindricalTank.bottomConv.solid.Q_flow = RealVariables3[80];
  closedCylindricalTank.bottomConv.fluid.T = RealVariables3[81];
  closedCylindricalTank.bottomConv.fluid.Q_flow = RealVariables3[82];
  closedCylindricalTank.bottomConv.Gc = RealVariables3[83];
  closedCylindricalTank.bottomConv.h = RealVariables3[84];
  closedCylindricalTank.bottomConv.beta = RealVariables3[85];
  closedCylindricalTank.bottomConv.Gr = RealVariables3[86];
  closedCylindricalTank.bottomConv.Ra = RealVariables3[87];
  closedCylindricalTank.bottomConv.NuL = RealVariables3[88];
  closedCylindricalTank.bottomConv.NuL1 = RealVariables3[89];
  closedCylindricalTank.bottomConv.NuL2 = RealVariables3[90];
  closedCylindricalTank.bottomConv.Pr = RealVariables3[91];
  closedCylindricalTank.bottomConv.visco = RealVariables3[92];
  closedCylindricalTank.bottomConv.K = RealVariables3[93];
  closedCylindricalTank.bottomConv.Tc = RealVariables3[94];
  closedCylindricalTank.'condFluid[1]'.Q_flow = RealVariables3[95];
  closedCylindricalTank.'condFluid[1]'.dT = RealVariables3[96];
  closedCylindricalTank.'condFluid[1]'.port_a.T = RealVariables3[97];
  closedCylindricalTank.'condFluid[1]'.port_a.Q_flow = RealVariables3[98];
  closedCylindricalTank.'condFluid[1]'.port_b.T = RealVariables3[99];
  closedCylindricalTank.'condFluid[1]'.port_b.Q_flow = RealVariables3[100];
  closedCylindricalTank.'condFluid[1]'.G = RealVariables4[1];
  closedCylindricalTank.'condFluid[2]'.Q_flow = RealVariables4[2];
  closedCylindricalTank.'condFluid[2]'.dT = RealVariables4[3];
  closedCylindricalTank.'condFluid[2]'.port_a.T = RealVariables4[4];
  closedCylindricalTank.'condFluid[2]'.port_a.Q_flow = RealVariables4[5];
  closedCylindricalTank.'condFluid[2]'.port_b.T = RealVariables4[6];
  closedCylindricalTank.'condFluid[2]'.port_b.Q_flow = RealVariables4[7];
  closedCylindricalTank.'condFluid[2]'.G = RealVariables4[8];
  closedCylindricalTank.'condFluid[3]'.Q_flow = RealVariables4[9];
  closedCylindricalTank.'condFluid[3]'.dT = RealVariables4[10];
  closedCylindricalTank.'condFluid[3]'.port_a.T = RealVariables4[11];
  closedCylindricalTank.'condFluid[3]'.port_a.Q_flow = RealVariables4[12];
  closedCylindricalTank.'condFluid[3]'.port_b.T = RealVariables4[13];
  closedCylindricalTank.'condFluid[3]'.port_b.Q_flow = RealVariables4[14];
  closedCylindricalTank.'condFluid[3]'.G = RealVariables4[15];
  closedCylindricalTank.heatFlowTop.Q_flow = RealVariables4[16];
  closedCylindricalTank.heatFlowTop.port_a.T = RealVariables4[17];
  closedCylindricalTank.heatFlowTop.port_a.Q_flow = RealVariables4[18];
  closedCylindricalTank.heatFlowTop.port_b.T = RealVariables4[19];
  closedCylindricalTank.heatFlowTop.port_b.Q_flow = RealVariables4[20];
  closedCylindricalTank.'heatFlowMiddle[1]'.Q_flow = RealVariables4[21];
  closedCylindricalTank.'heatFlowMiddle[1]'.port_a.T = RealVariables4[22];
  closedCylindricalTank.'heatFlowMiddle[1]'.port_a.Q_flow = RealVariables4[23];
  closedCylindricalTank.'heatFlowMiddle[1]'.port_b.T = RealVariables4[24];
  closedCylindricalTank.'heatFlowMiddle[1]'.port_b.Q_flow = RealVariables4[25];
  closedCylindricalTank.'heatFlowMiddle[2]'.Q_flow = RealVariables4[26];
  closedCylindricalTank.'heatFlowMiddle[2]'.port_a.T = RealVariables4[27];
  closedCylindricalTank.'heatFlowMiddle[2]'.port_a.Q_flow = RealVariables4[28];
  closedCylindricalTank.'heatFlowMiddle[2]'.port_b.T = RealVariables4[29];
  closedCylindricalTank.'heatFlowMiddle[2]'.port_b.Q_flow = RealVariables4[30];
  closedCylindricalTank.'heatFlowMiddle[3]'.Q_flow = RealVariables4[31];
  closedCylindricalTank.'heatFlowMiddle[3]'.port_a.T = RealVariables4[32];
  closedCylindricalTank.'heatFlowMiddle[3]'.port_a.Q_flow = RealVariables4[33];
  closedCylindricalTank.'heatFlowMiddle[3]'.port_b.T = RealVariables4[34];
  closedCylindricalTank.'heatFlowMiddle[3]'.port_b.Q_flow = RealVariables4[35];
  closedCylindricalTank.'heatFlowMiddle[4]'.Q_flow = RealVariables4[36];
  closedCylindricalTank.'heatFlowMiddle[4]'.port_a.T = RealVariables4[37];
  closedCylindricalTank.'heatFlowMiddle[4]'.port_a.Q_flow = RealVariables4[38];
  closedCylindricalTank.'heatFlowMiddle[4]'.port_b.T = RealVariables4[39];
  closedCylindricalTank.'heatFlowMiddle[4]'.port_b.Q_flow = RealVariables4[40];
  closedCylindricalTank.heatFlowBottom.Q_flow = RealVariables4[41];
  closedCylindricalTank.heatFlowBottom.port_a.T = RealVariables4[42];
  closedCylindricalTank.heatFlowBottom.port_a.Q_flow = RealVariables4[43];
  closedCylindricalTank.heatFlowBottom.port_b.T = RealVariables4[44];
  closedCylindricalTank.heatFlowBottom.port_b.Q_flow = RealVariables4[45];
  closedCylindricalTank.Ql_flow = RealVariables4[46];
  closedCylindricalTank.port_a_Tambient.T = RealVariables4[47];
  closedCylindricalTank.port_a_Tambient.Q_flow = RealVariables4[48];
  closedCylindricalTank.buoyancy.'dT[1]' = RealVariables4[49];
  closedCylindricalTank.buoyancy.'dT[2]' = RealVariables4[50];
  closedCylindricalTank.buoyancy.'dT[3]' = RealVariables4[51];
  closedCylindricalTank.buoyancy.'Q_flow[1]' = RealVariables4[52];
  closedCylindricalTank.buoyancy.'Q_flow[2]' = RealVariables4[53];
  closedCylindricalTank.buoyancy.'Q_flow[3]' = RealVariables4[54];
  closedCylindricalTank.buoyancy.'port_a_heat[1]'.T = RealVariables4[55];
  closedCylindricalTank.buoyancy.'port_a_heat[1]'.Q_flow = RealVariables4[56];
  closedCylindricalTank.buoyancy.'port_a_heat[2]'.T = RealVariables4[57];
  closedCylindricalTank.buoyancy.'port_a_heat[2]'.Q_flow = RealVariables4[58];
  closedCylindricalTank.buoyancy.'port_a_heat[3]'.T = RealVariables4[59];
  closedCylindricalTank.buoyancy.'port_a_heat[3]'.Q_flow = RealVariables4[60];
  closedCylindricalTank.buoyancy.'port_a_heat[4]'.T = RealVariables4[61];
  closedCylindricalTank.buoyancy.'port_a_heat[4]'.Q_flow = RealVariables4[62];
  ambientTemperature.port.T = RealVariables4[63];
  ambientTemperature.port.Q_flow = RealVariables4[64];
  ambientTemperature.T = RealVariables4[65];
  Retorno.medium.p = RealVariables4[66];
  Retorno.medium.h = RealVariables4[67];
  Retorno.medium.T = RealVariables4[68];
  Retorno.medium.state.p = RealVariables4[69];
  Retorno.medium.state.T = RealVariables4[70];
  Retorno.'ports[1]'.m_flow = RealVariables4[71];
  Retorno.'ports[1]'.p = RealVariables4[72];
  Impulsion.medium.p = RealVariables4[73];
  Impulsion.medium.h = RealVariables4[74];
  Impulsion.medium.T = RealVariables4[75];
  Impulsion.medium.u = RealVariables4[76];
  Impulsion.medium.state.p = RealVariables4[77];
  Impulsion.medium.state.T = RealVariables4[78];
  Impulsion.medium.T_degC = RealVariables4[79];
  Impulsion.'ports[1]'.m_flow = RealVariables4[80];
  Impulsion.'ports[1]'.h_outflow = RealVariables4[81];
  Impulsion.m_flow_in = RealVariables4[82];
  Impulsion.T_in = RealVariables4[83];
  T_Impulsion.port.p = RealVariables4[84];
  T_Impulsion.T = RealVariables4[85];
  T_Retorno.port.p = RealVariables4[86];
  T_Retorno.T = RealVariables4[87];
  massFlowRate.port_a.m_flow = RealVariables4[88];
  massFlowRate.port_a.p = RealVariables4[89];
  massFlowRate.port_a.h_outflow = RealVariables4[90];
  massFlowRate.port_b.p = RealVariables4[91];
  massFlowRate.port_b.h_outflow = RealVariables4[92];
  massFlowRate.m_flow = RealVariables4[93];
  'system'.p_start = RealDependentParameters1[1];
  'system'.T_start = RealDependentParameters1[2];
  'system'.m_flow_nominal = RealDependentParameters1[3];
  p_start = RealDependentParameters1[4];
  closedCylindricalTank.d = RealDependentParameters1[5];
  closedCylindricalTank.h_max = RealDependentParameters1[6];
  closedCylindricalTank.eTank = RealDependentParameters1[7];
  closedCylindricalTank.d_Inlet = RealDependentParameters1[8];
  closedCylindricalTank.d_Outlet = RealDependentParameters1[9];
  closedCylindricalTank.T_start = RealDependentParameters1[10];
  closedCylindricalTank.p_start = RealDependentParameters1[11];
  closedCylindricalTank.tau = RealDependentParameters1[12];
  closedCylindricalTank.D = RealDependentParameters1[13];
  closedCylindricalTank.volumeTop.p_start = RealDependentParameters1[14];
  closedCylindricalTank.volumeTop.T_start = RealDependentParameters1[15];
  closedCylindricalTank.volumeTop.h_start = RealDependentParameters1[16];
  closedCylindricalTank.volumeTop.medium.p = RealDependentParameters1[17];
  closedCylindricalTank.volumeTop.medium.p_bar = RealDependentParameters1[18];
  closedCylindricalTank.volumeTop.m = RealDependentParameters1[19];
  closedCylindricalTank.volumeTop.'ports[2]'.p = RealDependentParameters1[20];
  closedCylindricalTank.volumeTop.'ports[3]'.p = RealDependentParameters1[21];
  closedCylindricalTank.volumeTop.m_flow_nominal = RealDependentParameters1[22];
  closedCylindricalTank.volumeTop.m_flow_small = RealDependentParameters1[23];
  closedCylindricalTank.volumeTop.heatTransfer.'surfaceAreas[1]' = RealDependentParameters1[24];
  closedCylindricalTank.volumeTop.heatTransfer.T_ambient = RealDependentParameters1[25];
  closedCylindricalTank.volumeTop.V = RealDependentParameters1[26];
  closedCylindricalTank.volumeTop.d = RealDependentParameters1[27];
  closedCylindricalTank.volumeTop.h_max = RealDependentParameters1[28];
  closedCylindricalTank.'volumeMiddle[1]'.p_start = RealDependentParameters1[29];
  closedCylindricalTank.'volumeMiddle[1]'.T_start = RealDependentParameters1[30];
  closedCylindricalTank.'volumeMiddle[1]'.h_start = RealDependentParameters1[31];
  closedCylindricalTank.'volumeMiddle[1]'.medium.p = RealDependentParameters1[32];
  closedCylindricalTank.'volumeMiddle[1]'.medium.p_bar = RealDependentParameters1[33];
  closedCylindricalTank.'volumeMiddle[1]'.m = RealDependentParameters1[34];
  closedCylindricalTank.'volumeMiddle[1]'.'ports[1]'.p = RealDependentParameters1[35];
  closedCylindricalTank.'volumeMiddle[1]'.'ports[2]'.p = RealDependentParameters1[36];
  closedCylindricalTank.'volumeMiddle[1]'.'ports[4]'.p = RealDependentParameters1[37];
  closedCylindricalTank.'volumeMiddle[1]'.m_flow_nominal = RealDependentParameters1[38];
  closedCylindricalTank.'volumeMiddle[1]'.m_flow_small = RealDependentParameters1[39];
  closedCylindricalTank.'volumeMiddle[1]'.heatTransfer.'surfaceAreas[1]' = RealDependentParameters1[40];
  closedCylindricalTank.'volumeMiddle[1]'.heatTransfer.T_ambient = RealDependentParameters1[41];
  closedCylindricalTank.'volumeMiddle[1]'.V = RealDependentParameters1[42];
  closedCylindricalTank.'volumeMiddle[1]'.d = RealDependentParameters1[43];
  closedCylindricalTank.'volumeMiddle[1]'.h_max = RealDependentParameters1[44];
  closedCylindricalTank.'volumeMiddle[2]'.p_start = RealDependentParameters1[45];
  closedCylindricalTank.'volumeMiddle[2]'.T_start = RealDependentParameters1[46];
  closedCylindricalTank.'volumeMiddle[2]'.h_start = RealDependentParameters1[47];
  closedCylindricalTank.'volumeMiddle[2]'.medium.p = RealDependentParameters1[48];
  closedCylindricalTank.'volumeMiddle[2]'.medium.p_bar = RealDependentParameters1[49];
  closedCylindricalTank.'volumeMiddle[2]'.m = RealDependentParameters1[50];
  closedCylindricalTank.'volumeMiddle[2]'.'ports[1]'.p = RealDependentParameters1[51];
  closedCylindricalTank.'volumeMiddle[2]'.'ports[4]'.p = RealDependentParameters1[52];
  closedCylindricalTank.'volumeMiddle[2]'.m_flow_nominal = RealDependentParameters1[53];
  closedCylindricalTank.'volumeMiddle[2]'.m_flow_small = RealDependentParameters1[54];
  closedCylindricalTank.'volumeMiddle[2]'.heatTransfer.'surfaceAreas[1]' = RealDependentParameters1[55];
  closedCylindricalTank.'volumeMiddle[2]'.heatTransfer.T_ambient = RealDependentParameters1[56];
  closedCylindricalTank.'volumeMiddle[2]'.V = RealDependentParameters1[57];
  closedCylindricalTank.'volumeMiddle[2]'.d = RealDependentParameters1[58];
  closedCylindricalTank.'volumeMiddle[2]'.h_max = RealDependentParameters1[59];
  closedCylindricalTank.volumeBottom.p_start = RealDependentParameters1[60];
  closedCylindricalTank.volumeBottom.T_start = RealDependentParameters1[61];
  closedCylindricalTank.volumeBottom.h_start = RealDependentParameters1[62];
  closedCylindricalTank.volumeBottom.medium.p = RealDependentParameters1[63];
  closedCylindricalTank.volumeBottom.medium.p_bar = RealDependentParameters1[64];
  closedCylindricalTank.volumeBottom.m = RealDependentParameters1[65];
  closedCylindricalTank.volumeBottom.'ports[1]'.p = RealDependentParameters1[66];
  closedCylindricalTank.volumeBottom.'ports[3]'.p = RealDependentParameters1[67];
  closedCylindricalTank.volumeBottom.m_flow_nominal = RealDependentParameters1[68];
  closedCylindricalTank.volumeBottom.m_flow_small = RealDependentParameters1[69];
  closedCylindricalTank.volumeBottom.heatTransfer.'surfaceAreas[1]' = RealDependentParameters1[70];
  closedCylindricalTank.volumeBottom.heatTransfer.T_ambient = RealDependentParameters1[71];
  closedCylindricalTank.volumeBottom.V = RealDependentParameters1[72];
  closedCylindricalTank.volumeBottom.d = RealDependentParameters1[73];
  closedCylindricalTank.volumeBottom.h_max = RealDependentParameters1[74];
  closedCylindricalTank.topCond.L = RealDependentParameters1[75];
  closedCylindricalTank.topCond.A = RealDependentParameters1[76];
  closedCylindricalTank.'middleCond[1]'.L = RealDependentParameters1[77];
  closedCylindricalTank.'middleCond[1]'.A = RealDependentParameters1[78];
  closedCylindricalTank.'middleCond[2]'.L = RealDependentParameters1[79];
  closedCylindricalTank.'middleCond[2]'.A = RealDependentParameters1[80];
  closedCylindricalTank.'middleCond[3]'.L = RealDependentParameters1[81];
  closedCylindricalTank.'middleCond[3]'.A = RealDependentParameters1[82];
  closedCylindricalTank.'middleCond[4]'.L = RealDependentParameters1[83];
  closedCylindricalTank.'middleCond[4]'.A = RealDependentParameters1[84];
  closedCylindricalTank.bottomCond.L = RealDependentParameters1[85];
  closedCylindricalTank.bottomCond.A = RealDependentParameters1[86];
  closedCylindricalTank.topConv.A = RealDependentParameters1[87];
  closedCylindricalTank.topConv.B = RealDependentParameters1[88];
  closedCylindricalTank.topConv.L = RealDependentParameters1[89];
  closedCylindricalTank.topConv.P = RealDependentParameters1[90];
  closedCylindricalTank.'middleConv[1]'.A = RealDependentParameters1[91];
  closedCylindricalTank.'middleConv[1]'.D = RealDependentParameters1[92];
  closedCylindricalTank.'middleConv[2]'.A = RealDependentParameters1[93];
  closedCylindricalTank.'middleConv[2]'.D = RealDependentParameters1[94];
  closedCylindricalTank.'middleConv[3]'.A = RealDependentParameters1[95];
  closedCylindricalTank.'middleConv[3]'.D = RealDependentParameters1[96];
  closedCylindricalTank.'middleConv[4]'.A = RealDependentParameters1[97];
  closedCylindricalTank.'middleConv[4]'.D = RealDependentParameters1[98];
  closedCylindricalTank.bottomConv.A = RealDependentParameters1[99];
  closedCylindricalTank.bottomConv.L = RealDependentParameters1[100];
  closedCylindricalTank.buoyancy.V = RealDependentParameters2[1];
  closedCylindricalTank.buoyancy.tau = RealDependentParameters2[2];
  closedCylindricalTank.buoyancy.k = RealDependentParameters2[3];
  Retorno.medium.u = RealDependentParameters2[4];
  Retorno.medium.T_degC = RealDependentParameters2[5];
  Retorno.medium.p_bar = RealDependentParameters2[6];
  Retorno.'ports[1]'.h_outflow = RealDependentParameters2[7];
  Impulsion.medium.p_bar = RealDependentParameters2[8];
  Impulsion.'ports[1]'.p = RealDependentParameters2[9];
  massFlowRate.m_flow_nominal = RealDependentParameters2[10];
  massFlowRate.m_flow_small = RealDependentParameters2[11];
  annotation (__Dymola_FMUImportVersion="Dymola 2017 FD01", experiment(StartTime=0.0, StopTime=60000.0, Tolerance=0.0001),
    Icon(graphics={
      Rectangle(
        extent={{-100,100},{100,-100}},
        lineColor={95,95,95},
        fillColor={255,255,255},
        fillPattern=FillPattern.Solid,
        lineThickness=0.5),
      Text(
        extent={{-70,20},{70,-20}},
        lineColor={0,0,255},
        textString="%name"),
      Text(
        extent={{-70,-72},{70,-94}},
        lineColor={95,95,95},
        textString="FMI 1.0 CS Import")}),
Documentation(info="<html>
<h4>ModelDescription Attributes</h4>
<ul>
<li>fmiVersion = 1.0</li>
<li>modelName = Modelica_IK4_TEKNIKER.DCOL.Generation.SensibleStorages.FMI.Buffer_Dym_temperature</li>
<li>generationTool = Dymola Version 2017 FD01 (64-bit), 2016-10-11 (requires license to execute)</li>
<li>generationDateAndTime = 2017-06-02T10:09:05Z</li>
</ul>
<p><br><b>Co-Simulation Attributes</b></p>
<ul>
<li>canHandleVariableCommunicationStepSize = true</li>
<li>canHandleEvents = true</li>
<li>canRejectSteps = false</li>
<li>canInterpolateInputs = true</li>
<li>maxOutputDerivativeOrder = 1</li>
<li>canRunAsynchronuously = false</li>
<li>canSignalEvents = false</li>
<li>canBeInstantiatedOnlyOncePerProcess = false</li>
<li>canNotUseMemoryManagementFunctions = false</li>
</ul>
</html>",
      revisions="<html>
<p>2016-05-16 <a href=\"mailto: eduardo.ubieta@tekniker.es\">Eduardo Ubieta</a></a> (IK4-TEKNIKER): First implementation</p>
<p><b>Copyright &copy; <a href=\"http://www.tekniker.es/en\">IK4-TEKNIKER</a></b></p>
</html>"));
end Buffer_FMI_temperature;
